! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
! GET_RANGE =========================================================
!
!
! ==================================================================
      subroutine get_range1( nr_s,nr_e,ns_s,ns_e,nao,myrank,nproc )
      
      implicit real(8)(a-h,o-z)

! rs version      
      nr_s = 0
      nr_e = 0
      ns_s = 0
      ns_e = 0

      if ( nproc <= nao ) then
         nproc_r = 1
         nproc_s = nproc
         myrank_r = 0
         myrank_s = myrank
      else
         nproc_r = int(dsqrt(dble(nproc)))
         nproc_s = nproc/nproc_r
         myrank_r = mod(myrank,nproc_r)
         myrank_s = myrank/nproc_r
         if ( myrank_s >= nproc_s ) nproc_s = 0
      endif
      
c$$$      write(6,'(''myrank='',i3,''  nproc_r='',i3,'' nproc_s='',i3,
c$$$     $''  myrank_r='',i3,'' myrank_s='',i3)')
c$$$     $     myrank,nproc_r,nproc_s,myrank_r,myrank_s

      if ( nproc_r > 0 ) then
         ix = nao/nproc_r
         if (mod(nao,nproc_r).eq.0) then
            nr_s = ix*(myrank_r) + 1
            nr_e = ix*(myrank_r+1)
         else   
            iy = ix + 1
            iyy = nao -nproc_r*ix
            ixx = nproc_r - iyy
            
            if ((myrank_r.ge.0).and.(myrank_r.le.ixx-1)) then
               nr_s = (myrank_r)*ix + 1
               nr_e = (myrank_r+1)*ix
            else
               nr_s = ixx*ix + (myrank_r-ixx)*iy +1
               nr_e = ixx*ix + (myrank_r-ixx+1)*iy
            endif
         endif
      endif

      if ( nproc_s > 0 ) then
         ix = nao/nproc_s
         if (mod(nao,nproc_s).eq.0) then
            ns_s = ix*(myrank_s) + 1
            ns_e = ix*(myrank_s+1)
         else   
            iy = ix + 1
            iyy = nao -nproc_s*ix
            ixx = nproc_s - iyy
            
            if ((myrank_s.ge.0).and.(myrank_s.le.ixx-1)) then
               ns_s = (myrank_s)*ix + 1
               ns_e = (myrank_s+1)*ix
            else
               ns_s = ixx*ix + (myrank_s-ixx)*iy +1
               ns_e = ixx*ix + (myrank_s-ixx+1)*iy
            endif
         endif
      endif

c$$$      write(6,*) myrank,nr_s,nr_e,ns_s,ns_e
c$$$      write(6,'(''myrank='',i3,''  rs=('',2i3,'')  ss=('',2i3,'')'')')
c$$$     $     myrank,nr_s,nr_e,ns_s,ns_e

c$$$      stop


! r version
c$$$c$$$      iran = 0
c$$$c$$$      ix = nao/nproc
c$$$c$$$      if (mod(nao,nproc).eq.0) then
c$$$c$$$         nr_s = ix*(myrank) + 1
c$$$c$$$         nr_e = ix*(myrank+1)
c$$$c$$$      else   
c$$$c$$$         iy = ix + 1
c$$$c$$$         iyy = nao -nproc*ix
c$$$c$$$         ixx = nproc - iyy
c$$$c$$$         
c$$$c$$$         if ((myrank.ge.0).and.(myrank.le.ixx-1)) then
c$$$c$$$            nr_s = (myrank)*ix + 1
c$$$c$$$            nr_e = (myrank+1)*ix
c$$$c$$$         else
c$$$c$$$            nr_s = ixx*ix + (myrank-ixx)*iy +1
c$$$c$$$            nr_e = ixx*ix + (myrank-ixx+1)*iy
c$$$c$$$         endif
c$$$c$$$      endif
c$$$c$$$      
c$$$c$$$      ns_s = 1
c$$$c$$$      ns_e = nao

! s version
c$$$      ix = nao/nproc
c$$$      if (mod(nao,nproc).eq.0) then
c$$$         ns_s = ix*(myrank) + 1
c$$$         ns_e = ix*(myrank+1)
c$$$      else   
c$$$         iy = ix + 1
c$$$         iyy = nao -nproc*ix
c$$$         ixx = nproc - iyy
c$$$         
c$$$         if ((myrank.ge.0).and.(myrank.le.ixx-1)) then
c$$$            ns_s = (myrank)*ix + 1
c$$$            ns_e = (myrank+1)*ix
c$$$         else
c$$$            ns_s = ixx*ix + (myrank-ixx)*iy +1
c$$$            ns_e = ixx*ix + (myrank-ixx+1)*iy
c$$$         endif
c$$$      endif
c$$$      
c$$$      nr_s = 1
c$$$      nr_e = nao
c$$$
c$$$      write(6,'(''myrank='',i3,''  r=('',2i3,'')  s=('',2i3,'')'')')
c$$$     $     myrank,nr_s,nr_e,ns_s,ns_e
c$$$

! test
!     select case(iran)
!     case(0)

!     nr_s = 1  ;   nr_e = nao
!     ns_s = 1  ;   ns_e = nao
!
!     case(1)
!
!     nr_s = 31   ;   nr_e = 44
!     ns_s = 42   ;   ns_e = 43

!     case(2)
!
!     nr_s = 175 ;   nr_e = 175
!     ns_s = 174 ;   ns_e = 174
!     case(3)
!
!     nr_s = 130;   nr_e = 175
!     ns_s = 80;   ns_e = 110
! 
!     end select

      end
! GET_RANGE =========================================================
!
!
! ==================================================================
      subroutine get_range(
     &           nr_s,nr_e,ns_s,ns_e,
     &           nt_s,nt_e,nu_s,nu_e,nao )
      implicit real(8)(a-h,o-z)

      iran = 0

      select case(iran)
      case(0)

      nr_s = 1  ;   nr_e = nao
      ns_s = 1  ;   ns_e = nao
      nt_s = 1  ;   nt_e = nao
      nu_s = 1  ;   nu_e = nao
 
      case(1)
 
      nr_s = 23 ;   nr_e = 25
      ns_s = 1 ;   ns_e = 1 
      nt_s = 11 ;   nt_e =  11
      nu_s = 6  ;   nu_e = 10 

      case(2)
 
      nr_s = 175 ;   nr_e = 175
      ns_s = 174 ;   ns_e = 174
      nt_s =  1 ;   nt_e =  173
      nu_s =  1 ;   nu_e =  173
      case(3)
 
      nr_s = 130;   nr_e = 175
      ns_s = 80;   ns_e = 110
      nt_s = 40;   nt_e = 70
      nu_s = 1;   nu_e = 20
  
      end select
      end
