! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!JERIOUS=============================================================
! DERIVATIVE ERI 
! caluclate with recurring formula of Obara
! ==================================================================
      subroutine jerios(
     o     ec    ,
     o     index_jtei,val_jtei,njtei1cut,njtei2cut,
     &     fdat  ,  edat ,
     &     zz    ,  cc   ,  xyz  , zetpq,
     &     pp    ,  qq   ,  uup  ,  uuq ,
     &     nfsz  ,  nesz ,
     &     ian   ,  jan  , kan   , lan ,
     &     i     ,  j    , k     , l   , mao3  ,
     &     mxprm ,  nasp , natom , mxsa, nshell,
     &     nangty,         erithr,
     &     ntprm ,  nsh2atm,nsh2ssh, natm2asp,nsh2shty,
     &     iaoslix,iaosljx,iaoslkx,iaosllx,
     &     ir_s,ir_e,is_s,is_e,
     &     it_s,it_e,iu_s,iu_e,
     &     ierr      )
 
      implicit real(8)(a-h,o-z)
      dimension fdat(nfsz,nesz),edat(nesz)
      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension ntprm(mxsa,nasp)
      dimension nsh2atm(nshell),nsh2ssh(nshell),natm2asp(natom)
      dimension nsh2shty(nshell)
      dimension zz(mxprm,mxsa,nasp),cc(mxprm,mxsa,nasp)
      dimension pp(3,mxprm,mxprm),qq(3,mxprm,mxprm)
      dimension uup(mxprm,mxprm),uuq(mxprm,mxprm)
  
      dimension iaoslix(ir_s:ir_e,3),iaosljx(is_s:is_e)
      dimension iaoslkx(it_s:it_e,3),iaosllx(iu_s:iu_e)
  
      integer(8) njtei1cut,njtei2cut
c$$$      dimension index_jtei(6,njtei1cut),val_jtei(njtei1cut)
      dimension val_jtei(njtei1cut)
      integer(2) index_jtei(6,njtei1cut)
      dimension ec(mao3,4)

      jab=0
      jcd=0
      jal=0

      kangi = ian
      kangj = jan
      kangk = kan
      kangl = lan

      iangp = ian + jan
      iangq = kan + lan
      ianga = iangp + iangq

      i0 = i
      j0 = j
      k0 = k
      l0 = l

      if (ian.lt.jan) then
         call iswap(i0,j0)
         jab = 1
      endif
      
      if (kan.lt.lan) then
         call iswap(k0,l0)
         jcd = 1
      endif

      kangi = nsh2shty(i0)
      kangk = nsh2shty(k0)

      if (iangp.le.iangq) then
         if ((iangp.eq.iangq).and.(kangi.ge.kangk)) then
         else
            call iswap(i0,k0)
            call iswap(j0,l0)
            jal = 1
         endif
      endif


      ishel = nsh2ssh(i0)  ; jshel = nsh2ssh(j0)
      kshel = nsh2ssh(k0)  ; lshel = nsh2ssh(l0)

      iatom = nsh2atm(i0)  ; jatom = nsh2atm(j0)
      katom = nsh2atm(k0)  ; latom = nsh2atm(l0)

      iasp  = natm2asp(iatom) ; jasp = natm2asp(jatom)
      kasp  = natm2asp(katom) ; lasp = natm2asp(latom)
     
      do i4=1,4
         do i3=1,mao3
            ec(i3,i4) = 0.d0
         enddo
      enddo

!!!   CALC PARAMETER       
      call ipara_ioup( 
     &     pp   ,  qq   , 
     &     uup  ,  uuq  , 
     &     zz   ,  cc   ,  zetpq,  xyz  ,
     &     ntprm,
     &     iasp ,  jasp ,  kasp ,  lasp ,
     &     iatom,  jatom,  katom,  latom,
     &     ishel,  jshel,  kshel,  lshel,
     &     natom,  nasp ,  mxprm,  mxsa ,
     &     ierr   )

      jpq = jcd + jab

      call jerid (
     &     ec   ,
     &     fdat ,  edat ,
     &     zz   ,  xyz  ,  zetpq,
     &     pp   ,  qq   ,  uup  ,  uuq  ,
     &     ntprm,
     &     nfsz ,  nesz ,
     &     nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &     jal  ,  jpq  ,  nangty,
     &     ishel,  jshel,  kshel,  lshel,
     &     iatom,  jatom,  katom,  latom,
     &     iasp ,  jasp ,  kasp ,  lasp        )

!     if (labcd.eq.0) then
      call jtoutos(
     &     index_jtei,  val_jtei,  njtei1cut,  njtei2cut,
     &     ec        ,
     &     iaoslix   ,  !iaosljx ,  iaoslkx  ,  iaosllx  ,
     &     i         ,  j       ,  k        ,  l        ,
     &     iatom     ,  jatom   ,  katom    ,  latom    ,
     &     ian       ,  jan     ,  kan      ,  lan      ,
     &     ir_s      ,  ir_e    ,  !is_s     ,  is_e     ,
!     &     it_s      ,  it_e    ,  iu_s     ,  iu_e     ,
     &     mao3      ,  erithr  ,
     &     ierr       )

!     endif

      end
CC JERID ============================================================
C     CALCULATION OF DERIVATIVE TWO ELECTRON INTEGRALS 
C====================================================================
      
      subroutine jerid (
     &     ec   ,
     &     fdat ,  edat ,
     &     z    ,  xyz  ,  zetpq,
     &     pp   ,  qq   ,  uup  ,  uuq  ,
     &     ntprm,
     &     nfsz ,  nesz ,
     &     nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &     jal  ,  jpq  ,  nangty,
     &     ishel,  jshel,  kshel,  lshel,
     &     iatom,  jatom,  katom,  latom,
     &     iasp ,  jasp ,  kasp ,  lasp        )
      
      implicit real(8) (a-h,o-z)

      dimension fdat(nfsz,nesz),edat(nesz)
      dimension xyz(3,natom)
      dimension ntprm(mxsa,nasp)
      dimension zetp(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension z(mxprm,mxsa,nasp)
      dimension pp(3,mxprm,mxprm),qq(3,mxprm,mxprm)
      dimension uup(mxprm,mxprm),uuq(mxprm,mxprm)
      
      dimension ec(mao3,4)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)!20100129
 
      select case(nangty)
      
      case(1)
         call jossss (
     &        ec   ,
     &        fdat ,  edat ,
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )

      case(2)
         call jopsss (
     &        ec   ,
     &        fdat ,  edat ,
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )

      case(3)
         call jopsps (
     &        ec   ,
     &        fdat ,  edat ,
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )
         
      case (4)
         call joppss (
     &        ec   ,
     &        fdat ,  edat ,
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )

      case(5)
         call joppps (
     &        ec   ,
     &        fdat ,  edat ,
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz ,  jal  ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )
         
      case(6)
         call jopppp (
     &        ec   ,
     &        fdat ,  edat ,
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz ,  jal  ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )
         
      case (7)
         call jodsss (
     &        ec   ,
     &        fdat ,  edat ,
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )
         
      case(8)
         call jodsps (
     &        ec   ,
     &        fdat ,  edat ,
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz ,  jal  ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )

      case(11)
         call jodpss (
     &        ec   ,
     &        fdat ,  edat , 
     &        z    ,  xyz  ,  zetpq,
     &        pp   ,  qq   ,  uup  ,  uuq  ,
     &        ntprm,
     &        nfsz ,  nesz , jpq  ,
     &        nasp ,  mxsa ,  mxprm,  natom,  mao3,
     &        ishel,  jshel,  kshel,  lshel,
     &        iatom,  jatom,  katom,  latom,
     &        iasp ,  jasp ,  kasp ,  lasp        )

      end select
      
      end
