! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
! JGET_BUFSIZE =======================================================
! GET MAX_ARRAY-SIZE
! d :: real =  18088 + fdfd(3600)    int =  275687
! f :: real = 332458 + gfgf(22500)   int = 3492736
! g :: real =1757964 + hghg(99225)   int =28944886

! d :: real,int =   11399,   337795
! f :: real,int =  147781, 10574119
! g :: real,int = 1231852,135732796
!====================================================================

      subroutine jget_bufsize(mrk,mik,mxxang,ikey)
      implicit none
      
      integer mxxang,mrk,mik,ikey
      
      if (ikey.eq.1) then
         
         select case (mxxang)
         case(1)
            mrk = 1
            mik = 1
         case(2)
            mrk = 1
            mik = 1
         case(3)
            mrk =  25000
            mik = 300000
         case(4)
            mrk =  250000
            mik = 4000000
         case(5)
            mrk =  2000000
            mik =  30000000
         end select
         
      else
         
         select case (mxxang)
         case(1)
            mrk = 1 * 3* 4
            mik = 1
         case(2)
            mrk =  81*3*4
            mik = 1
         case(3)
            mrk =     12000 + 1296*3*4
            mik =    400000
         case(4)
            mrk =    200000 + 10000*3*4
            mik =  12000000
         case(5)
            mrk =   1500000 + 50625*3*4
            mik = 140000000
         end select
         
      endif
      
      end
!! JSHROOP ==========================================================
!  precalc integral shell roop
! ===================================================================

      subroutine jshroop (
     &     iplset  ,  iqlset  ,
     &     kphky   ,
     &     swzij   ,  swzdij  ,
     &     ips     ,  iqs     ,
     &     cutthrp ,  cutthrq , cutthdp, cutthdq,
     &     ir_s    ,  ir_e    ,    is_s,    is_e,
     &     it_s    ,  it_e    ,    iu_s,    iu_e,
     &     nshell  ,
     &     ierr       )

      implicit real(8)(a-h,o-z)

      dimension iplset(3,ips),iqlset(2,iqs)
      dimension swzij(nshell,nshell)
      dimension swzdij(nshell,nshell)


      i0 = 0 ; j0 = 0
      kphky = 0 ; kqhky = 0

      do i = ir_s,ir_e
         do j = is_s,is_e
             kqhky = 1
!            ip = i + j
!            if (i.lt.j) cycle

             aaa = swzdij(i,j)
             bbb = swzdij(j,i)
             swzd = max(aaa,bbb)

             if ((swzij(i,j).lt.cutthdq).and. (swzd.lt.cutthrq) ) cycle

             kphky = kphky + 1
             iplset(1,kphky) = i
             iplset(2,kphky) = j

             do k = it_s,it_e
                do l = iu_s,iu_e

!                  if (k.lt.l) cycle
!                  if (i.lt.k) cycle
!                  iq = k + l
!                  if ((i.eq.k).and.(ip.lt.iq)) cycle

                   ccc = swzdij(k,l)
                   ddd = swzdij(l,k)
                   swzd = max(ccc,ddd)

                   if ((swzij(k,l).lt.cutthdp).and.
     &                 (swzd.lt.cutthrp)) cycle


                   if ((i0.eq.i).and.(j0.eq.j)) kqhky = kqhky + 1
                   i0 = i
                   j0 = j
                   iqlset(1,kqhky) = k
                   iqlset(2,kqhky) = l

                enddo
             enddo
             iplset(3,kphky) = kqhky
         enddo
      enddo
        
      end


!! JSHROOP18 ==========================================================
!  precalc integral shell roop
! ===================================================================

      subroutine jshroop18 (
     &     iplset  ,  iqlset  ,
     &     kphky   ,
     &     swzij   ,  swzdij  ,
     &     ips     ,  iqs     ,
     &     cutthrp ,  cutthrq , cutthdp, cutthdq,
     &     ir_s    ,  ir_e    ,    is_s,    is_e,
     &     it_s    ,  it_e    ,    iu_s,    iu_e,
     &     nshell  ,
     &     ierr       )

      implicit real(8)(a-h,o-z)

      dimension iplset(3,ips),iqlset(2,iqs)
      dimension swzij(nshell,nshell)
      dimension swzdij(nshell,nshell)


      i0 = 0 ; j0 = 0
      kphky = 0 ; kqhky = 0


      do i = ir_s,ir_e
         do j  = 1,i
             kqhky = 1
            aaa = swzdij(i,j)
            bbb = swzdij(j,i)
            swzd = max(aaa,bbb)
             if ((swzij(i,j).lt.cutthdq).and. (swzd.lt.cutthrq) ) cycle
             kphky = kphky + 1
             iplset(1,kphky) = i
             iplset(2,kphky) = j
         enddo
         enddo


      return
      do i = ir_s,ir_e
         do j = is_s,is_e
             kqhky = 1
             ip = i + j
             if (i.lt.j) cycle

             aaa = swzdij(i,j)
             bbb = swzdij(j,i)
             swzd = max(aaa,bbb)

             if ((swzij(i,j).lt.cutthdq).and. (swzd.lt.cutthrq) ) cycle

             kphky = kphky + 1
             iplset(1,kphky) = i
             iplset(2,kphky) = j

             do k = it_s,it_e
                do l = iu_s,iu_e

                   if (k.lt.l) cycle
                   if (i.lt.k) cycle
                   iq = k + l
                   if ((i.eq.k).and.(ip.lt.iq)) cycle

                   ccc = swzdij(k,l)
                   ddd = swzdij(l,k)
                   swzd = max(ccc,ddd)

                   if ((swzij(k,l).lt.cutthdp).and.
     &                 (swzd.lt.cutthrp)) cycle


                   if ((i0.eq.i).and.(j0.eq.j)) kqhky = kqhky + 1
                   i0 = i
                   j0 = j
                   iqlset(1,kqhky) = k
                   iqlset(2,kqhky) = l

                enddo
             enddo
             iplset(3,kphky) = kqhky
         enddo
      enddo
        
      end

CC /NCLAS   =========================================================
C  IDENTIFY 14 TYPES OF N-CLASS COMBINATION
C
C  (ab|bb),(ba|bb),(bb|ab),(bb|ba)
C  (aa|bb)
C  (ab|cc),(cc|ab)
C  (ab|ab),(ab|ba)
C  (ab|cb),(ab|bc),(ba|cb),(ba|bc)
C  (ab|cd)
C
C  =OUT=
C  NHK : NUMBER OF ATOM FOR DIFFERENTIATION
C    1 :
C  NTT : ANGULAR MOMETUM-SET
C
C ===================================================================
      
      subroutine jnclas (
     &     nhk     , ntt     ,
     &     icod    , ncod    , idatom,
     &     i       , j       , k     , l    , 
     &     nsh2atm , nsh2shty, nsh2ssh,nshell          )
      
      implicit real(8)(a-h,o-z)
      
      dimension nhk(4,3),ntt(4,2,3)
      dimension nsh2atm(nshell),nsh2shty(nshell),nsh2ssh(nshell)

      iatom = nsh2atm(i)
      jatom = nsh2atm(j)
      katom = nsh2atm(k)
      latom = nsh2atm(l)

      ishel = nsh2ssh(i)
      jshel = nsh2ssh(j)
      kshel = nsh2ssh(k)
      lshel = nsh2ssh(l)

      icod = 0
      iac = 1

      kij = 0 ; kik = 0 ; kil = 0
      kjk = 0 ; kjl = 0 ; kkl = 0

      if (iatom.eq.jatom) kij = 1
      if (iatom.eq.katom) kik = 1
      if (iatom.eq.latom) kil = 1
      if (jatom.eq.katom) kjk = 1
      if (jatom.eq.latom) kjl = 1
      if (katom.eq.latom) kkl = 1

      key = kij + 2*kik + 4*kil + 8*kjk + 16*kjl + 32*kkl + 1

      select case(key)

      case(1)!ABCD
         ncod  = 3
         nhk(1,1) = 1
         nhk(1,2) = 2
         nhk(1,3) = 3
         idatom = latom
      case(2)!CCAB
         ncod  = 2
         nhk(1,1) = 3
         nhk(1,2) = 4
         idatom = iatom
      case(3)!CACB
         ncod  = 2
         nhk(1,1) = 2
         nhk(1,2) = 4
         idatom = iatom
      case(5)!CABC
         ncod = 2
         nhk(1,1) = 2
         nhk(1,2) = 3
         idatom = iatom
      case(9)!ACCB
         ncod = 2
         nhk(1,1) = 1
         nhk(1,2) = 4
         idatom = jatom
      case(12)!BBBA
         ncod = 1
         nhk(1,1) = 4
         idatom = iatom
      case(13)!ABBA
         icod = 1
         ncod = 2
         nhk(1,1) = 1
         nhk(1,2) = 4
         idatom = jatom
      case(17)!ACBC
         ncod = 2
         nhk(1,1) = 1
         nhk(1,2) = 3
         idatom = jatom
      case(19)!ABAB
         natomd = 8
         icod = 1
         ncod = 2
         nhk(1,1) = 1
         nhk(1,2) = 3
         idatom = jatom
      case(22)!BBAB
         ncod = 1
         nhk(1,1) = 3
         idatom = iatom
      case(33)!ABCC
         ncod = 2
         nhk(1,1) = 1
         nhk(1,2) = 2
         idatom = katom
      case(34)!AABB
         icod = 1
         ncod = 2
         nhk(1,1) = 1
         nhk(1,2) = 2
         idatom = katom
      case(39)!BABB
         ncod = 1
         nhk(1,1) = 2
         idatom = iatom
      case(57)!ABBB
         ncod = 1
         nhk(1,1) = 1
         idatom = jatom
      case(64)!AAAA
         ncod  = 0
        goto 1000
      end select
      
!!!!!!!!===== ORDER ANGULAR MOMENTUM-SET ===== 
      ian = nsh2shty(i)
      jan = nsh2shty(j)
      kan = nsh2shty(k)
      lan = nsh2shty(l)

      do icc = 1,ncod
         iac = 1
         
         key = nhk(1,icc)
         
      select case (key)
         
      case(1)
         ntt(1,1,icc) = ian + 1
         ntt(2,1,icc) = jan
         ntt(3,1,icc) = kan
         ntt(4,1,icc) = lan
         jangl = ntt(1,1,icc)
         nhk(2,icc) = iatom
         nhk(3,icc) = ishel
         
      case(2)
         ntt(1,1,icc) = ian
         ntt(2,1,icc) = jan + 1
         ntt(3,1,icc) = kan
         ntt(4,1,icc) = lan
         jangl = ntt(2,1,icc)
         nhk(2,icc) = jatom
         nhk(3,icc) = jshel
         
      case(3)
         ntt(1,1,icc) = ian
         ntt(2,1,icc) = jan
         ntt(3,1,icc) = kan + 1
         ntt(4,1,icc) = lan 
         jangl = ntt(3,1,icc)
         nhk(2,icc) = katom
         nhk(3,icc) = kshel
 
       case(4)
         ntt(1,1,icc) = ian
         ntt(2,1,icc) = jan
         ntt(3,1,icc) = kan
         ntt(4,1,icc) = lan + 1 
         jangl = ntt(4,1,icc)
         nhk(2,icc) = latom
         nhk(3,icc) = lshel
         
      endselect
      
       if (jangl.ge.3) then
          iac = 2
          select case  (key)
          
       case(1)
          ntt(1,2,icc) = ntt(1,1,icc) - 2
          ntt(2,2,icc) = ntt(2,1,icc)
          ntt(3,2,icc) = ntt(3,1,icc)
          ntt(4,2,icc) = ntt(4,1,icc)
          
       case(2)
          ntt(1,2,icc) = ntt(1,1,icc)
          ntt(2,2,icc) = ntt(2,1,icc) - 2
          ntt(3,2,icc) = ntt(3,1,icc)
          ntt(4,2,icc) = ntt(4,1,icc)
          
       case(3)
          ntt(1,2,icc) = ntt(1,1,icc)
          ntt(2,2,icc) = ntt(2,1,icc)
          ntt(3,2,icc) = ntt(3,1,icc) - 2 
          ntt(4,2,icc) = ntt(4,1,icc)

       case(4)
          ntt(1,2,icc) = ntt(1,1,icc)
          ntt(2,2,icc) = ntt(2,1,icc)
          ntt(3,2,icc) = ntt(3,1,icc) 
          ntt(4,2,icc) = ntt(4,1,icc) - 2
          
       endselect
       
      endif

        nhk(4,icc) = key
        nhk(1,icc) = iac
      enddo
      
1000  end
CC JDEX =============================================================
C  SET INDEX-TABLE  JDET
C  JDET( IDA,JKOUT )
C  IDA  :NUMBER OF ATOM FOR DERIVATIVE
C  JKOUT:NUMBER OF TRANSLATION ANGLUAR-TYPE
!
C ===================================================================        

      subroutine jdex ( jdet )
      
      dimension jdet(4,8)
      
      jdet(1,1)  =  1           !1 ab|cd
      jdet(1,2)  =  2           !2 ba|cd
      jdet(1,3)  =  1           !3 ab|dc
      jdet(1,4)  =  2           !4 ba|dc
      jdet(1,5)  =  3           !5 cd|ab
      jdet(1,6)  =  4           !6 cd|ba
      jdet(1,7)  =  3           !7 dc|ab
      jdet(1,8)  =  4           !8 dc|ba
                    
      jdet(2,1)  =  2
      jdet(2,2)  =  1
      jdet(2,3)  =  2
      jdet(2,4)  =  1
      jdet(2,5)  =  4
      jdet(2,6)  =  3
      jdet(2,7)  =  4
      jdet(2,8)  =  3
                    
      jdet(3,1)  =  3
      jdet(3,2)  =  3
      jdet(3,3)  =  4
      jdet(3,4)  =  4
      jdet(3,5)  =  1
      jdet(3,6)  =  1
      jdet(3,7)  =  2
      jdet(3,8)  =  2
                    
      jdet(4,1)  =  4
      jdet(4,2)  =  4
      jdet(4,3)  =  3
      jdet(4,4)  =  3
      jdet(4,5)  =  2
      jdet(4,6)  =  2
      jdet(4,7)  =  1
      jdet(4,8)  =  1

      end
! J2ZETA ============================================================
! PUT ZETA DIFFERNTIAL-COEFFICIENT IN SEED_OBARA
! ===================================================================

      subroutine j2zeta(
     &     uup  ,    uuq  ,  
     &     uzp  ,    uzq  ,  
     &     zz   ,    ntprm,  
     &     mshel,    iflg ,
     &     ishel,    jshel,    kshel,    lshel,
     &     iasp ,    jasp ,    kasp ,    lasp ,
     &     mxsa ,    mxprm,    nasp ,    masp )
 
      implicit real(8)(a-h,o-z)

      dimension uup(mxprm,mxprm),uuq(mxprm,mxprm)
      dimension uzp(mxprm,mxprm),uzq(mxprm,mxprm)

      dimension zz(mxprm,mxsa,nasp)
      dimension ntprm(mxsa,nasp)

      select case(iflg)
      case(1)
         do ic = 1,ntprm(ishel,iasp)
            do jc = 1,ntprm(jshel,jasp)
               uup(jc,ic) = zz(ic,mshel,masp) * uup(jc,ic)
               uzp(jc,ic) = zz(ic,mshel,masp) * uzp(jc,ic)
            enddo
         enddo

      case(2)
         do ic = 1,ntprm(ishel,iasp)
            do jc = 1,ntprm(jshel,jasp)
               uup(jc,ic) = zz(jc,mshel,masp) * uup(jc,ic)
               uzp(jc,ic) = zz(jc,mshel,masp) * uzp(jc,ic)
            enddo
         enddo

      case(3)
         do ic = 1,ntprm(kshel,kasp)
            do jc = 1,ntprm(lshel,lasp)
               uuq(jc,ic) = zz(ic,mshel,masp) * uuq(jc,ic)
               uzq(jc,ic) = zz(ic,mshel,masp) * uzq(jc,ic)
            enddo
         enddo

      case(4)
         do ic = 1,ntprm(kshel,kasp)
            do jc = 1,ntprm(lshel,lasp)
               uuq(jc,ic) = zz(jc,mshel,masp) * uuq(jc,ic)
               uzq(jc,ic) = zz(jc,mshel,masp) * uzq(jc,ic)
            enddo
         enddo

      end select

      end
! JHRNMD ============================================================
! MULTIPLY NORMALIZATION COFFICIENTS
! 
!      ==============================================================

      subroutine jhrnmd (e,iangi,iangj,iangk,iangl,mao3,idn)

      implicit real(8)(a-h,o-z)
      dimension e(mao3)
      dimension mm(10)
      
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55/

      if (iangi.ge.3) then
         n0 = mm(iangj)*mm(iangk)*mm(iangl)*idn
         jkl= 1
         ni = 1
         call jdfg (e, mao3, iangi, n0, jkl, ni)
      endif
      
      if (iangj.ge.3) then
         n0 = mm(iangk)*mm(iangl)*idn
         jkl= mm(iangj)*mm(iangk)*mm(iangl)*idn
         ni = mm(iangi)
         call jdfg (e, mao3, iangj, n0, jkl, ni)
      endif
      
      if (iangk.ge.3) then
         n0 = mm(iangl)*idn
         jkl= mm(iangk)*mm(iangl)*idn
         ni = mm(iangi)*mm(iangj)
         call jdfg (e, mao3, iangk, n0, jkl, ni)
      endif
      
      if (iangl.ge.3) then
         n0 = idn
         jkl= mm(iangl)*idn
         ni = mm(iangi)*mm(iangj)*mm(iangk)
         call jdfg (e, mao3, iangl, n0, jkl, ni)
      endif
      
      end
      
! JDFG   ============================================================
! MULTIPLY NORMALIZATION COFFICIENTS
! D : ROOT3 (4:6)
! F : ROOT5 (4:9), ROOT15 (10)
! G : ROOT7 (4:9), ROOT105/3 (10:12), ROOT35 (13:15)
! 
!      ==============================================================

      subroutine  jdfg(e,mao3,iang,n0,jkl,ni)

      implicit real(8)(a-h,o-z)
      dimension e(mao3)

      data      root3 / 1.73205080756887729353d+00 /
      data      root5 / 2.23606797749978980505d+00 /
      data      root7 / 2.64575131106459071617d+00 /

      select case(iang)
      
      case(3)
         nd0 = 3 * n0
         nd1 = 6 * n0
         
         do i = 1,ni
            do j = nd0+1,nd1
               now = (i-1)*jkl + j
               e(now) = root3 * e(now)
            enddo
         enddo
         
      case(4)
         nf0 = 3 * n0
         nf1 = 9 * n0
         nf2 =10 * n0
         
         do i = 1,ni
            
            do j = nf0+1,nf2
               now = (i-1)*jkl + j
               e(now) = root5*e(now)
            enddo
            
            do j = nf1+1,nf2
               now = (i-1)*jkl + j
               e(now) = root3*e(now)
            enddo
            
         enddo
         
      case(5)
         ng0 = 3 * n0
         ng1 = 9 * n0
         ng2 =12 * n0
         ng3 =15 * n0
         
         do i = 1,ni
            
            do j=ng0+1,ng3
               now = (i-1)*jkl + j
               e(now) = root7*e(now)
            enddo
            
            do j=ng2+1,ng3
               now = (i-1)*jkl + j
               e(now) = root5*e(now)
            enddo
            
            do j=ng1+1,ng2
               now = (i-1)*jkl + j
               e(now) = root3*e(now) /3.0d0
            enddo
            
         enddo
         
      endselect
      
      end

