! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
C## IPASIZE   ===   ====================================================
C     set cutthr , buffersize and ao-shell index after setting range
C
C   === OUTPUT ===
!     cutthr  ::    threshhold value
!     iaoslix ::    index table of shell & ao numbers on I shell
!     iaosljx ::    index table of shell & ao numbers on J shell
!     iaoslkx ::    index table of shell & ao numbers on K shell
!     iaosllx ::    index table of shell & ao numbers on L shell
!     mwki    ::    work buffer  for int  type
!     mwkr    ::    work buffer  for real type
!     mxxang  ::    max of angularmomentum 
!
C======================================================================*
      subroutine jpasize(
     o     jdet    ,
     o     iaoslix , iaosljx , iaoslkx, iaosllx ,
     o     mwki    , mwkr    , mxxang , kphky   , 
     o     cutthrp,  cutthrq,  cutthdp,  cutthdq,
     &     nsh2ssh ,  nsh2asp, nsh2shty,nao2sh  ,
     &     ntshty  , 
!    &     e_rrrr  , d_rrrr  ,
     &     swzij   , swzdij  ,
     &     iplset  , iqlset  ,
     &     ips     , iqs     ,
     &     nr_s    , nr_e    , ns_s   , ns_e    ,
     &     nt_s    , nt_e    , nu_s   , nu_e    ,
     &     ir_s    , ir_e    , is_s   , is_e    ,
     &     it_s    , it_e    , iu_s   , iu_e    ,
     &     mxsa    ,  nao    , nshell, nasp,
     &     erithr  ,
     &     lprint,ldebug,ierr           )

      implicit real(8) (a-h,o-z)
      
      dimension jdet(4,8)
      dimension ntshty(mxsa,nasp)
     
      dimension nsh2ssh(nshell),nsh2asp(nshell)
      dimension nao2sh(nao),nsh2shty(nshell)
!     dimension e_rrrr(nshell),d_rrrr(nshell)
 
      dimension iaoslix(ir_s:ir_e,3),iaosljx(is_s:is_e,3)
      dimension iaoslkx(it_s:it_e,3),iaosllx(iu_s:iu_e,3)

      dimension swzij(nshell,nshell),swzdij(nshell,nshell)

      dimension iplset(3,ips)
      dimension iqlset(2,iqs)
      character shty(5)
      data (shty(i),i=1,5) /"s","p","d","f","g"/

      call iget_mxshty(
     &     mxxang  ,
     &     ir_s    , ir_e    , is_s, is_e,
     &     it_s    , it_e    , iu_s, iu_e,
     &     nsh2shty,
     &     nshell  , nao     , mxsa       )

      if ((mxxang.gt.5).or.(mxxang.lt.1) )then
          write(*,*)"ERROR INPUTDATA"
      endif

      call jget_bufsize(mwkr,mwki,mxxang,2)
      call jshroop18 (
     &     iplset  ,  iqlset  ,
     &     kphky   ,
     &     swzij   ,  swzdij  , 
     &     ips     ,  iqs     ,
     &     cutthrp ,  cutthrq ,   cutthdp,  cutthdq,
     &     ir_s    ,  ir_e    ,   is_s   ,  is_e   ,
     &     it_s    ,  it_e    ,   iu_s   ,  iu_e   ,
     &     nshell  ,
     &     ierr       )

      call iset_iaoslx (
     &     nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &     nao    ,  mxsa   ,  nasp   ,  nshell,
     &     ir_s,ir_e,iaoslix,
     &     nr_s     ,  nr_e      )

      call iset_iaoslx (
     &     nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &     nao    ,  mxsa   ,  nasp   ,  nshell,
     &     is_s,is_e,iaosljx,
     &     ns_s     ,  ns_e      )

      call iset_iaoslx (
     &     nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &     nao    ,  mxsa   ,  nasp   ,  nshell,
     &     it_s,it_e,iaoslkx,
     &     nt_s     ,  nt_e      )

      call iset_iaoslx (
     &     nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &     nao    ,  mxsa   ,  nasp   ,  nshell,
     &     iu_s,iu_e,iaosllx,
     &     nu_s     ,  nu_e      )

      call jdex(jdet)

      if (ldebug.ge.1) then
         write(6,*)" "
         write(6,*)"CUTOFF THRESHOLD "
         write(6,*)'cutthrp = ',cutthrp
         write(6,*)'cutthrq = ',cutthrq
         write(6,*)'cutthdp = ',cutthdp
         write(6,*)'cutthdp = ',cutthdp
      endif

      if (ldebug.ge.2) then
         write(6,*)"max shell type (jtei) ",shty(mxxang)
         write(6,*)"max buffersize for jtei (real,int) = ",mwki,mwkr
      endif
      END
