! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
! == PPRPARA ========================================================
! set parameter for tei calc before assignment range
! == OUTPUT ==
!    zetpq,zz2,nagn2n,e_rrrr,d_rrrr
!
! ISET_MM      : set mm
! IPARA_ZET    : set zetpq (1/za+zb)
! IPARA_ZZ2    : 2*z
! ISET_NANG2N  : set shell type number
! SWZ_RRRR     : calc (rrrr)integrals
! SWZ_DRRRR    : calc (r'r'r'r')integrals
! IGET_MXSHTYA : get max shell type all range
! IGET_BUFSIZE : get size of buffer for calc eri
!
! ===================================================================

      subroutine jprepara(
     o           zetpq   ,  zz2     ,  nang2n ,
     &           zz      ,
     &           mxsa    ,  nasp  ,  mxprm ,
     &           lprint  ,  ldebug  ,  ierr  )

      implicit real(8)(a-h,o-z)

      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension nang2n(5,5,5,5)

      dimension zz(mxprm,mxsa,nasp)
      dimension zz2(mxprm,mxsa,nasp)!20100129

      call ipara_zet(mxsa,nasp,mxprm,zz,zetpq)
      call ipara_zz2(zz2,zz,mxsa,nasp,mxprm)

      call iset_nang2n(nang2n,5)

      end
