! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
CC JTSOS1 ===========================================================
C     SET COEFFICIENT TABLE AND CALCULATE ERI WITH OPERATION TABLE
C     FOR CUTOFF-SCHWARTZ
C===================================================================
      
      subroutine jstos1(
     &     fdat ,   edat ,
     &     za   ,   zb   ,
     &     ca   ,   cb   ,
     &     a    ,   b    ,
     &     ncnta,   ncntb,
     &     nvtbl,   nv   ,   iv  ,   nv2,  iang,
     &     nssss,   ninto,   mvtl,
     &     ea   ,   eb   )

      implicit real(8)(a-h,o-z)
      dimension fdat(31,2001),edat(2001)
      dimension rminv(20),tf(25)
      
      dimension za(ncnta),zb(ncntb)
      dimension ca(ncnta),cb(ncntb)
      dimension  a(3), b(3)
      
      dimension nvtbl(3,nv)
      dimension ea(ninto), eb(mvtl), ocoef(50)
      
      data  (rminv(i),i=1,20) /
     &     1.0d0 ,0.333333333333333333d0,0.2d0 ,
     &     0.14285714285714286d0,    0.11111111111111111d0,
     &     0.90909090909090909d-01,  0.76923076923076923d-01,
     &     0.66666666666666666d-01,  0.58823529411764705d-01,
     &     0.52631578947368421d-01,  0.47619047619047619d-01,
     &     0.43478260869565217d-01,  0.4d-01,
     &     0.37037037037037037d-01,  0.34482758620689656d-01,
     &     0.32258064516129032d-01,  0.30303030303030303d-01,
     &     0.28571428571428571d-01,  0.27027027027027027d-01,
     &     0.25641025641025641d-01                          /
      
      data      pi / 3.14159265358979323846d+00 /
      data      (tf(i),i=1,25) /
     &     33.0,37.0,41.0,43.0,46.0,49.0,
     &     51.0,54.0,56.0,58.0,61.0,63.0,
     &     66.0,68.0,70.0,72.0,74.0,80.0,
     &     85.0,90.0,95.0,95.0,98.0,99.0,
     &     99.0                           /
      
      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /


      do kk= 1,ninto
         ea(kk) = 0.0d0
      enddo

      do kk= 1,mvtl
         eb(kk) = 0.0d0
      enddo


      issss = iang  + 1
 
      pi2 = 2.0d0*pi
      piup = dsqrt(2.0d0/pi)
      pi3 = pi**3
      pivq = 8.0d0 * pi3 * piup
      abx = a(1) - b(1)
      aby = a(2) - b(2)
      abz = a(3) - b(3)
      ab2 = abx*abx + aby*aby + abz*abz
      
      DO I = 1, ncnta
         DO J = 1, ncntb
            zet = 1.0d0 / ( za(i) + zb(j) )
            zet5= 0.5d0 * zet

            px = zet * ( za(i)*a(1) +zb(j)*b(1) )
            py = zet * ( za(i)*a(2) +zb(j)*b(2) )
            pz = zet * ( za(i)*a(3) +zb(j)*b(3) )
            
            pax = px - a(1)
            pay = py - a(2)
            paz = pz - a(3)
            pbx = px - b(1)
            pby = py - b(2)
            pbz = pz - b(3)

            ocoef( 1) = pax   
            ocoef( 2) = pay   
            ocoef( 3) = paz   
            ocoef( 4) = pbx   
            ocoef( 5) = pby   
            ocoef( 6) = pbz   

            up = dsqrt(zet5) * zet5 * dexp( -za(i)*zb(j) * zet *ab2)

            up = up * ca(i) * cb(j) *za(i)*2.d0
            DO K = 1,ncnta 
               DO L = 1,ncntb 
                  eta = 1.0d0/(za(k)+zb(l))
                  eta5= 0.5d0*eta

                  qx = eta * ( za(k)*a(1) +zb(l)*b(1) )
                  qy = eta * ( za(k)*a(2) +zb(l)*b(2) )
                  qz = eta * ( za(k)*a(3) +zb(l)*b(3) )
                  qpx = qx - px
                  qpy = qy - py
                  qpz = qz - pz

                  qcx = qx - a(1)
                  qcy = qy - a(2)
                  qcz = qz - a(3)
                  qdx = qx - b(1)
                  qdy = qy - b(2)
                  qdz = qz - b(3)

                  ocoef(10) = qcx
                  ocoef(11) = qcy
                  ocoef(12) = qcz
                  ocoef(13) = qdx
                  ocoef(14) = qdy
                  ocoef(15) = qdz

            vq = dsqrt(eta5) * eta5 * dexp( -za(k)*zb(l) * eta * ab2)
            vq = vq * ca(k) * cb(l) * pivq *za(k)*2.d0

                  ROO2 = 1.0d0 / (ZET5+ ETA5)
                  QP2  = QPX*QPX + QPY*QPY + QPZ*QPZ
                  T    = 0.5d0* ROO2*QP2

                  rooz = roo2 * zet5
                  rozz = rooz * zet5
                  zeta = eta / zet
                  
                  rooe = roo2 * eta5
                  roee = rooe * eta5
                  
                  wpx  = qpx * rooz
                  wpy  = qpy * rooz
                  wpz  = qpz * rooz

                  wqx  = wpx - qpx
                  wqy  = wpy - qpy
                  wqz  = wpz - qpz

                  ocoef( 7) = wpx
                  ocoef( 8) = wpy
                  ocoef( 9) = wpz
                  ocoef(16) = wqx
                  ocoef(17) = wqy
                  ocoef(18) = wqz
                  
                  IF (T. LE .TF(issss)) THEN
                     
                     IT = IDINT((T+0.025D+00)*20.0D+00)
                     DT = 0.05D+00*IT - T
                     IT = IT + 1
                     DT4 = DT*0.25D+00
                     DT5 = DT*0.2D+00
                     DT6 = DT*0.166666666666666667D+00
                     DT2 = DT4 + DT4
                     DT3 = DT6 + DT6
                     ea(issss)  = (((((FDAT(issss+6,IT) *DT6
     &                    + FDAT(issss+5,IT))*DT5
     &                    + FDAT(issss+4,IT))*DT4
     &                    + FDAT(issss+3,IT))*DT3
     &                    + FDAT(issss+2,IT))*DT2
     &                    + FDAT(issss+1,IT))*DT
     &                    + FDAT(issss  ,IT)
                     
                     EED  = (((((GA6*DT + GA5)*DT + GA4)*DT
     &                    + GA3)*DT + GA2)*DT + GA1)*DT + GA0
                     EE   = EDAT(IT)*EED
                     
                     T2   = T*2.0d0
                     
                     do m = issss-1 ,1 ,-1
                        ea(m) = (t2*ea(m+1) +ee)*rminv(m)
                     enddo
                     
                  ELSE
                     tinv = 1.0d0/t
                     ea(1) = dsqrt(pi*tinv)*0.5d0
                     
                     do m = 2,issss
                        ea(m) = (0.5d0 +m-2) * ea(m-1)*tinv
                     enddo
                     
                  END IF

                  fpp =  up * vq * dsqrt(roo2)
                  do m = 1,issss
                     ea(m) = fpp * ea(m)
                  enddo

                  do ii=1,issss
                     ea(nssss+ii-1)  = ea(ii)
                  enddo
                  
                  do izc = issss,1,-1
                     ea(izc) = 0.0d0
                  enddo
                  
                  do izc = 1,nssss-1
                     ea(izc) = 0.0d0
                  enddo

                  do i0=1,6
                     ocoef(18+i0) =  i0 * zet5
                     ocoef(24+i0) = -i0 * rozz
                     ocoef(30+i0) =  i0 * eta5
                     ocoef(36+i0) = -i0 * roee
                     ocoef(42+i0) =  i0 * rooz * eta5
                  enddo

                  do jj = 1,nv2
                     jst = nvtbl(1,jj)
                     jcf = nvtbl(2,jj)
                     jim = nvtbl(3,jj)

                     ea(jst) = ea(jst) + ocoef(jcf)*ea(jim)
                  enddo

                  do jj = nv2+1,nv
                     jst = nvtbl(1,jj)
                     jcf = nvtbl(2,jj)
                     jim = nvtbl(3,jj)

                     eb(jst) = eb(jst) + ocoef(jcf)*ea(jim)
                  enddo

               enddo
            enddo
         enddo
      enddo

      end
CC JTSOS2 ===========================================================
C     SET COEFFICIENT TABLE AND CALCULATE ERI WITH OPERATION TABLE
C     FOR CUTOFF-SCHWARTZ
C===================================================================
      
      subroutine jstos2(
     &     fdat , edat  ,
     &     za   , zb,
     &     ca   , cb,
     &     a    ,  b,
     &     ncnta,ncntb,
     &     nvtbl,nv,iv,nv2,iang,
     &     nssss,ninto,mvtl,ea, eb )

      implicit real(8)(a-h,o-z)
      dimension fdat(31,2001),edat(2001)
      dimension rminv(20),tf(25)
      
      dimension za(ncnta),zb(ncntb)
      dimension ca(ncnta),cb(ncntb)
      dimension  a(3), b(3)
      
      dimension nvtbl(3,nv)
      dimension ea(ninto),eb(mvtl),ocoef(50)
      
      data  (rminv(i),i=1,20) /
     &     1.0d0 ,0.333333333333333333d0,0.2d0 ,
     &     0.14285714285714286d0,    0.11111111111111111d0,
     &     0.90909090909090909d-01,  0.76923076923076923d-01,
     &     0.66666666666666666d-01,  0.58823529411764705d-01,
     &     0.52631578947368421d-01,  0.47619047619047619d-01,
     &     0.43478260869565217d-01,  0.4d-01,
     &     0.37037037037037037d-01,  0.34482758620689656d-01,
     &     0.32258064516129032d-01,  0.30303030303030303d-01,
     &     0.28571428571428571d-01,  0.27027027027027027d-01,
     &     0.25641025641025641d-01                          /
      
      data      pi / 3.14159265358979323846d+00 /
      data      (tf(i),i=1,25) /
     &     33.0,37.0,41.0,43.0,46.0,49.0,
     &     51.0,54.0,56.0,58.0,61.0,63.0,
     &     66.0,68.0,70.0,72.0,74.0,80.0,
     &     85.0,90.0,95.0,95.0,98.0,99.0,
     &     99.0                           /
      
      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /


      do kk= 1,ninto
         ea(kk) = 0.0d0
      enddo
       do kk= 1,mvtl
         eb(kk) = 0.0d0
      enddo
      issss = iang  + 1
 
      pi2 = 2.0d0*pi
      piup = dsqrt(2.0d0/pi)
      pi3 = pi**3
      pivq = 8.0d0 * pi3 * piup
      abx = a(1) - b(1)
      aby = a(2) - b(2)
      abz = a(3) - b(3)
      ab2 = abx*abx + aby*aby + abz*abz
      
      DO I = 1, ncnta
         DO J = 1, ncntb
            zet = 1.0d0 / ( za(i) + zb(j) )
            zet5= 0.5d0 * zet

            px = zet * ( za(i)*a(1) +zb(j)*b(1) )
            py = zet * ( za(i)*a(2) +zb(j)*b(2) )
            pz = zet * ( za(i)*a(3) +zb(j)*b(3) )
            
            pax = px - a(1)
            pay = py - a(2)
            paz = pz - a(3)
            pbx = px - b(1)
            pby = py - b(2)
            pbz = pz - b(3)

            ocoef( 1) = pax   
            ocoef( 2) = pay   
            ocoef( 3) = paz   
            ocoef( 4) = pbx   
            ocoef( 5) = pby   
            ocoef( 6) = pbz   

            up = dsqrt(zet5) * zet5 * dexp( -za(i)*zb(j) * zet *ab2)

            up = up * ca(i) * cb(j) *za(i)*2.d0
            DO K = 1,ncnta 
               DO L = 1,ncntb 
                  eta = 1.0d0/(za(k)+zb(l))
                  eta5= 0.5d0*eta

                  qx = eta * ( za(k)*a(1) +zb(l)*b(1) )
                  qy = eta * ( za(k)*a(2) +zb(l)*b(2) )
                  qz = eta * ( za(k)*a(3) +zb(l)*b(3) )
                  qpx = qx - px
                  qpy = qy - py
                  qpz = qz - pz

                  qcx = qx - a(1)
                  qcy = qy - a(2)
                  qcz = qz - a(3)
                  qdx = qx - b(1)
                  qdy = qy - b(2)
                  qdz = qz - b(3)

                  ocoef(10) = qcx
                  ocoef(11) = qcy
                  ocoef(12) = qcz
                  ocoef(13) = qdx
                  ocoef(14) = qdy
                  ocoef(15) = qdz

            vq = dsqrt(eta5) * eta5 * dexp( -za(k)*zb(l) * eta * ab2)
            vq = vq * ca(k) * cb(l) * pivq

                  ROO2 = 1.0d0 / (ZET5+ ETA5)
                  QP2  = QPX*QPX + QPY*QPY + QPZ*QPZ
                  T    = 0.5d0* ROO2*QP2

                  rooz = roo2 * zet5
                  rozz = rooz * zet5
                  zeta = eta / zet
                  
                  rooe = roo2 * eta5
                  roee = rooe * eta5
                  
                  wpx  = qpx * rooz
                  wpy  = qpy * rooz
                  wpz  = qpz * rooz

                  wqx  = wpx - qpx
                  wqy  = wpy - qpy
                  wqz  = wpz - qpz

                  ocoef( 7) = wpx
                  ocoef( 8) = wpy
                  ocoef( 9) = wpz
                  ocoef(16) = wqx
                  ocoef(17) = wqy
                  ocoef(18) = wqz
                  
                  IF (T. LE .TF(issss)) THEN
                     
                     IT = IDINT((T+0.025D+00)*20.0D+00)
                     DT = 0.05D+00*IT - T
                     IT = IT + 1
                     DT4 = DT*0.25D+00
                     DT5 = DT*0.2D+00
                     DT6 = DT*0.166666666666666667D+00
                     DT2 = DT4 + DT4
                     DT3 = DT6 + DT6
                     ea(issss)  = (((((FDAT(issss+6,IT) *DT6
     &                    + FDAT(issss+5,IT))*DT5
     &                    + FDAT(issss+4,IT))*DT4
     &                    + FDAT(issss+3,IT))*DT3
     &                    + FDAT(issss+2,IT))*DT2
     &                    + FDAT(issss+1,IT))*DT
     &                    + FDAT(issss  ,IT)
                     
                     EED  = (((((GA6*DT + GA5)*DT + GA4)*DT
     &                    + GA3)*DT + GA2)*DT + GA1)*DT + GA0
                     EE   = EDAT(IT)*EED
                     
                     T2   = T*2.0d0
                     
                     do m = issss-1 ,1 ,-1
                        ea(m) = (t2*ea(m+1) +ee)*rminv(m)
                     enddo
                     
                  ELSE
                     tinv = 1.0d0/t
                     ea(1) = dsqrt(pi*tinv)*0.5d0
                     
                     do m = 2,issss
                        ea(m) = (0.5d0 +m-2) * ea(m-1)*tinv
                     enddo
                     
                  END IF

                  fpp =  up * vq * dsqrt(roo2)

                  do m = 1,issss
                     ea(m) = fpp * ea(m)
                  enddo

                  do ii=1,issss
                     ea(nssss+ii-1)  = ea(ii)
                  enddo
                  
                  do izc = issss,1,-1
                     ea(izc) = 0.0d0
                  enddo
                  
                  do izc = 1,nssss-1
                     ea(izc) = 0.0d0
                  enddo

                  do i0=1,6
                     ocoef(18+i0) =  i0 * zet5
                     ocoef(24+i0) = -i0 * rozz
                     ocoef(30+i0) =  i0 * eta5
                     ocoef(36+i0) = -i0 * roee
                     ocoef(42+i0) =  i0 * rooz * eta5
                  enddo

                  do jj = 1,nv2
                     jst = nvtbl(1,jj)
                     jcf = nvtbl(2,jj)
                     jim = nvtbl(3,jj)

                     ea(jst) = ea(jst) + ocoef(jcf)*ea(jim)
                  enddo

                  do jj = nv2+1,nv
                     jst = nvtbl(1,jj)
                     jcf = nvtbl(2,jj)
                     jim = nvtbl(3,jj)

                     eb(jst) = eb(jst) + ocoef(jcf)*ea(jim)
                  enddo

               enddo
            enddo
         enddo
      enddo

      end
CC JTSOS3 ===========================================================
C     SET COEFFICIENT TABLE AND CALCULATE ERI WITH OPERATION TABLE
C     FOR CUTOFF-SCHWARTZ
C===================================================================
      
      subroutine jstos3(
     &     fdat , edat  ,
     &     za   , zb,
     &     ca   , cb,
     &     a    ,  b,
     &     ncnta,ncntb,
     &     nvtbl,nv,iv,nv2,iang,
     &     nssss,ninto,mvtl,ea, eb)

      implicit real(8)(a-h,o-z)
      dimension fdat(31,2001),edat(2001)
      dimension rminv(20),tf(25)
      
      dimension za(ncnta),zb(ncntb)
      dimension ca(ncnta),cb(ncntb)
      dimension  a(3), b(3)
      
      dimension nvtbl(3,nv)
      dimension ea(ninto),eb(mvtl),ocoef(50)
      
      data  (rminv(i),i=1,20) /
     &     1.0d0 ,0.333333333333333333d0,0.2d0 ,
     &     0.14285714285714286d0,    0.11111111111111111d0,
     &     0.90909090909090909d-01,  0.76923076923076923d-01,
     &     0.66666666666666666d-01,  0.58823529411764705d-01,
     &     0.52631578947368421d-01,  0.47619047619047619d-01,
     &     0.43478260869565217d-01,  0.4d-01,
     &     0.37037037037037037d-01,  0.34482758620689656d-01,
     &     0.32258064516129032d-01,  0.30303030303030303d-01,
     &     0.28571428571428571d-01,  0.27027027027027027d-01,
     &     0.25641025641025641d-01                          /
      
      data      pi / 3.14159265358979323846d+00 /
      data      (tf(i),i=1,25) /
     &     33.0,37.0,41.0,43.0,46.0,49.0,
     &     51.0,54.0,56.0,58.0,61.0,63.0,
     &     66.0,68.0,70.0,72.0,74.0,80.0,
     &     85.0,90.0,95.0,95.0,98.0,99.0,
     &     99.0                           /
      
      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /


      do kk= 1,ninto
         ea(kk) = 0.0d0
      enddo
       do kk= 1,mvtl
         eb(kk) = 0.0d0
      enddo
      issss = iang  + 1
 
      pi2 = 2.0d0*pi
      piup = dsqrt(2.0d0/pi)
      pi3 = pi**3
      pivq = 8.0d0 * pi3 * piup
      abx = a(1) - b(1)
      aby = a(2) - b(2)
      abz = a(3) - b(3)
      ab2 = abx*abx + aby*aby + abz*abz
      
      DO I = 1, ncnta
         DO J = 1, ncntb
            zet = 1.0d0 / ( za(i) + zb(j) )
            zet5= 0.5d0 * zet

            px = zet * ( za(i)*a(1) +zb(j)*b(1) )
            py = zet * ( za(i)*a(2) +zb(j)*b(2) )
            pz = zet * ( za(i)*a(3) +zb(j)*b(3) )
            
            pax = px - a(1)
            pay = py - a(2)
            paz = pz - a(3)
            pbx = px - b(1)
            pby = py - b(2)
            pbz = pz - b(3)

            ocoef( 1) = pax   
            ocoef( 2) = pay   
            ocoef( 3) = paz   
            ocoef( 4) = pbx   
            ocoef( 5) = pby   
            ocoef( 6) = pbz   

            up = dsqrt(zet5) * zet5 * dexp( -za(i)*zb(j) * zet *ab2)

            up = up * ca(i) * cb(j)
            DO K = 1,ncnta 
               DO L = 1,ncntb 
                  eta = 1.0d0/(za(k)+zb(l))
                  eta5= 0.5d0*eta

                  qx = eta * ( za(k)*a(1) +zb(l)*b(1) )
                  qy = eta * ( za(k)*a(2) +zb(l)*b(2) )
                  qz = eta * ( za(k)*a(3) +zb(l)*b(3) )
                  qpx = qx - px
                  qpy = qy - py
                  qpz = qz - pz

                  qcx = qx - a(1)
                  qcy = qy - a(2)
                  qcz = qz - a(3)
                  qdx = qx - b(1)
                  qdy = qy - b(2)
                  qdz = qz - b(3)

                  ocoef(10) = qcx
                  ocoef(11) = qcy
                  ocoef(12) = qcz
                  ocoef(13) = qdx
                  ocoef(14) = qdy
                  ocoef(15) = qdz

            vq = dsqrt(eta5) * eta5 * dexp( -za(k)*zb(l) * eta * ab2)
            vq = vq * ca(k) * cb(l) * pivq *za(k)*2.d0

                  ROO2 = 1.0d0 / (ZET5+ ETA5)
                  QP2  = QPX*QPX + QPY*QPY + QPZ*QPZ
                  T    = 0.5d0* ROO2*QP2

                  rooz = roo2 * zet5
                  rozz = rooz * zet5
                  zeta = eta / zet
                  
                  rooe = roo2 * eta5
                  roee = rooe * eta5
                  
                  wpx  = qpx * rooz
                  wpy  = qpy * rooz
                  wpz  = qpz * rooz

                  wqx  = wpx - qpx
                  wqy  = wpy - qpy
                  wqz  = wpz - qpz

                  ocoef( 7) = wpx
                  ocoef( 8) = wpy
                  ocoef( 9) = wpz
                  ocoef(16) = wqx
                  ocoef(17) = wqy
                  ocoef(18) = wqz
                  
                  IF (T. LE .TF(issss)) THEN
                     
                     IT = IDINT((T+0.025D+00)*20.0D+00)
                     DT = 0.05D+00*IT - T
                     IT = IT + 1
                     DT4 = DT*0.25D+00
                     DT5 = DT*0.2D+00
                     DT6 = DT*0.166666666666666667D+00
                     DT2 = DT4 + DT4
                     DT3 = DT6 + DT6
                     ea(issss)  = (((((FDAT(issss+6,IT) *DT6
     &                    + FDAT(issss+5,IT))*DT5
     &                    + FDAT(issss+4,IT))*DT4
     &                    + FDAT(issss+3,IT))*DT3
     &                    + FDAT(issss+2,IT))*DT2
     &                    + FDAT(issss+1,IT))*DT
     &                    + FDAT(issss  ,IT)
                     
                     EED  = (((((GA6*DT + GA5)*DT + GA4)*DT
     &                    + GA3)*DT + GA2)*DT + GA1)*DT + GA0
                     EE   = EDAT(IT)*EED
                     
                     T2   = T*2.0d0
                     
                     do m = issss-1 ,1 ,-1
                        ea(m) = (t2*ea(m+1) +ee)*rminv(m)
                     enddo
                     
                  ELSE
                     tinv = 1.0d0/t
                     ea(1) = dsqrt(pi*tinv)*0.5d0
                     
                     do m = 2,issss
                        ea(m) = (0.5d0 +m-2) * ea(m-1)*tinv
                     enddo
                     
                  END IF

                  fpp =  up * vq * dsqrt(roo2)

                  do m = 1,issss
                     ea(m) = fpp * ea(m)
                  enddo

                  do ii=1,issss
                     ea(nssss+ii-1)  = ea(ii)
                  enddo
                  
                  do izc = issss,1,-1
                     ea(izc) = 0.0d0
                  enddo
                  
                  do izc = 1,nssss-1
                     ea(izc) = 0.0d0
                  enddo

                  do i0=1,6
                     ocoef(18+i0) =  i0 * zet5
                     ocoef(24+i0) = -i0 * rozz
                     ocoef(30+i0) =  i0 * eta5
                     ocoef(36+i0) = -i0 * roee
                     ocoef(42+i0) =  i0 * rooz * eta5
                  enddo

                  do jj = 1,nv2
                     jst = nvtbl(1,jj)
                     jcf = nvtbl(2,jj)
                     jim = nvtbl(3,jj)

                     ea(jst) = ea(jst) + ocoef(jcf)*ea(jim)
                  enddo

                  do jj = nv2+1,nv
                     jst = nvtbl(1,jj)
                     jcf = nvtbl(2,jj)
                     jim = nvtbl(3,jj)

                     eb(jst) = eb(jst) + ocoef(jcf)*ea(jim)
                  enddo

               enddo
            enddo
         enddo
      enddo

      end
