! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
CC JTRANSA ==========================================================
C  TRANSFORMATION ORDER OF ANGULAR MOMENTUM
C  ORIGINAL OUTPUT
C ===================================================================

      subroutine jtransa (
     &     ec   ,
     &     ee   ,
     &     iangi,  iangj,  iangk,  iangl,
     &     ikout,  mvhgp        )

      implicit real(8)(a-h,o-z)

      dimension ec(mvhgp),ee(mvhgp)
      dimension mm(10)
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55/

      mi = mm(iangi)
      mj = mm(iangj)
      mk = mm(iangk)
      ml = mm(iangl)
      
      key = 1

      select case(ikout)
      case(1)
         
         m4 = mj * mk * ml
         m3 =      mk * ml
         m2 =           ml
         
         do io = 1,mm(iangi)
            do jo = 1,mm(iangj)
               do ko = 1,mm(iangk)
                  do lo = 1,mm(iangl)
                     
                     iky = m4 * (io-1) + m3 * (jo-1) + m2 * (ko-1) + lo
                     ec(key) = ee(iky)
                     key = key + 1
                  enddo
               enddo
            enddo
         enddo
         
      case(3)
         
         call iswap(mk,ml)
         
         m4 = mj * mk * ml
         m3 =      mk * ml
         m2 =           ml
         
         do io = 1,mm(iangi)
            do jo = 1,mm(iangj)
               do ko = 1,mm(iangk)
                  do lo = 1,mm(iangl)
                     
                     iky = m4 * (io-1) + m3 * (jo-1) + m2 * (lo-1) + ko
                     ec(key) = ee(iky)
                     key = key + 1
                     
                  enddo
               enddo
            enddo
         enddo
         
      case(2)
         
         call iswap(mi,mj)
         m4 = mj * mk * ml
         m3 =      mk * ml
         m2 =           ml
         
         do io = 1,mm(iangi)
            do jo = 1,mm(iangj)
               do ko = 1,mm(iangk)
                  do lo = 1,mm(iangl)
                     
                     iky = m4 * (jo-1) + m3 * (io-1) + m2 * (ko-1) + lo
                     ec(key) = ee(iky)
                     key = key + 1
                     
                  enddo
               enddo
            enddo
         enddo
         
      case(4)
         
         call iswap(mi,mj)
         call iswap(mk,ml)
         
         m4 = mj * mk * ml
         m3 =      mk * ml
         m2 =           ml
         
         do io = 1,mm(iangi)
            do jo = 1,mm(iangj)
               do ko = 1,mm(iangk)
                  do lo = 1,mm(iangl)
                     
                     iky = m4 * (jo-1) + m3 * (io-1) + m2 * (lo-1) + ko
                     ec(key) = ee(iky)
                     key = key + 1
                     
                  enddo
               enddo
            enddo
         enddo
         
      case(5)
         
         call iswap(mi,mk)
         call iswap(mj,ml)
         m4 = mj * mk * ml
         m3 =      mk * ml
         m2 =           ml
         
         do io = 1,mm(iangi)
            do jo = 1,mm(iangj)
               do ko = 1,mm(iangk)
                  do lo = 1,mm(iangl)
                     
                     iky = m4 * (ko-1) + m3 * (lo-1) + m2 * (io-1) + jo
                     ec(key) = ee(iky)
                     key = key + 1
                     
                  enddo
               enddo
            enddo
         enddo
         
      case(7)
         
         call iswap(mk,ml)
         call iswap(mi,mk)
         call iswap(mj,ml)
         m4 = mj * mk * ml
         m3 =      mk * ml
         m2 =           ml
         
         do io = 1,mm(iangi)
            do jo = 1,mm(iangj)
               do ko = 1,mm(iangk)
                  do lo = 1,mm(iangl)
                     
                     iky = m4 * (lo-1) + m3 * (ko-1) + m2 * (io-1) + jo
                     ec(key) = ee(iky)
                     key = key + 1
                     
                  enddo
               enddo
            enddo
         enddo
         
      case(6)
         
         call iswap(mi,mj)
         call iswap(mi,mk)
         call iswap(mj,ml)
         m4 = mj * mk * ml
         m3 =      mk * ml
         m2 =           ml
         
         do io = 1,mm(iangi)
            do jo = 1,mm(iangj)
               do ko = 1,mm(iangk)
                  do lo = 1,mm(iangl)
                     
                     iky = m4 * (ko-1) + m3 * (lo-1) + m2 * (jo-1) + io
                     ec(key) = ee(iky)
                     key = key + 1
                     
                  enddo
               enddo
            enddo
         enddo
         
      case(8)
         
         call iswap(mi,mj)
         call iswap(mk,ml)
         call iswap(mi,mk)
         call iswap(mj,ml)
         
         m4 = mj * mk * ml
         m3 =      mk * ml
         m2 =           ml
         
         do io = 1,mm(iangi)
            do jo = 1,mm(iangj)
               do ko = 1,mm(iangk)
                  do lo = 1,mm(iangl)
                     
                     iky = m4 * (lo-1) + m3 * (ko-1) + m2 * (jo-1) + io
                     ec(key) = ee(iky)
                     key = key + 1
                     
                  enddo
               enddo
            enddo
         enddo
         
      end select
      
      return
      end
      
! JTRANSB ===========================================================
C  TRANSFORMATION ORDER OF DIFFERENTIATE ATOM
! 
! ===================================================================

      subroutine jtransb(
     &     e,
     &     ec,
     &     jangi,jangj,jangk,jangl,
     &     ian,jan,kan,lan,
     &     ida,           mvhgp ,mao3                     )

      implicit real(8)(a-h,o-z)
      dimension e(mao3),ec(mvhgp)
      dimension jtrad(30,3)

      dimension mm(10)
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55/

      iii = mm(ian)
      jjj = mm(jan)
      kkk = mm(kan)
      lll = mm(lan)
!     write(*,*)ian,jan,kan,lan
      select case (ida)
         
      case(1)
         ii0 = 1
         idd = iii
         mset= mm(jangi)
         jkl = jjj*kkk*lll
      case(2) 
         ii0 = iii
         idd = jjj
         mset= mm(jangj)*mm(jangk)*mm(jangl)
         jkl = kkk*lll
      case(3) 
         ii0 = iii*jjj
         idd = kkk
         mset= mm(jangk) * mm(jangl)
         jkl = lll
      case(4) 
         ii0 = iii*jjj*kkk
         idd = lll
         mset= mm(jangl)
         jkl = 1
      endselect
      
      call jtrade ( jtrad,idd )

      kiss = 1
      do i0 = 1,ii0
         do i1 = 1,idd
            do i2 = 1,jkl
               do i3=1,3
                  
                  now = jtrad(i1,i3)
                  ipoint = mset*(i0-1) + (now-1) * jkl + i2
                  e(kiss) = ec(ipoint)
                  kiss = kiss + 1
               enddo
            enddo
         enddo
      enddo

      end
! JTRANSC ===========================================================
C  ( (a+1)b|cd ) - ( (a-1)b|cd ) 
! 
! ===================================================================

      subroutine jtransc(
     &           e,
     &           eb,
     &           ian,jan,kan,lan,
     &           ida,mvhgp ,mao3         )

      implicit real(8)(a-h,o-z)
      dimension e(mao3),eb(mvhgp)
      dimension jebx(15,3,2)

      dimension mm(10)
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55/

      iii = mm(ian)
      jjj = mm(jan)
      kkk = mm(kan)
      lll = mm(lan)

      ikey = 0
      select case(ida)

      case(1)
         n1   = 1
         n2   = iii
         n3   = jjj*kkk*lll
         m2   = mm(ian-1)
      case(2)
         n1   = iii
         n2   = jjj
         n3   = kkk*lll
         m2   = mm(jan-1)
      case(3)
         n1   = iii*jjj
         n2   = kkk
         n3   = lll
         m2   = mm(kan-1)
      case(4)
         n1   = iii*jjj*kkk
         n2   = lll
         n3   = 1
         m2   = mm(lan-1)

      endselect

      call jebdex(jebx,n2)

      do i1 = 1,n1
         do i2 = 1,n2
            do i3 = 1,n3
               do i4 = 1,3

                  ikey = ikey + 1
                  now = jebx(i2,i4,1)
                  if (now.eq.0) goto 3333

                  cof = jebx(i2,i4,2)
                  nowb = m2*n3*(i1-1) + n3*(now-1) + i3
                  e(ikey) = e(ikey) - cof * eb(nowb)
 3333          enddo
            enddo
         enddo
      enddo

      end
CC  JTRANS ==========================================================
C   SET INDEX FOR TRANS-B
C   SORT ORDER INDICATED
C====================================================================
      
      subroutine jtrade ( jtrad,idd )
      
      implicit real(8)(a-h,o-z)
      dimension jtrad(30,3)
      
      select case(idd)
! S --> P
          case(1)
          jtrad(1,1) = 1
          jtrad(1,2) = 2
          jtrad(1,3) = 3

          case(3)
          jtrad(1,1) = 1
          jtrad(1,2) = 4
          jtrad(1,3) = 5
          jtrad(2,1) = 4
          jtrad(2,2) = 2
          jtrad(2,3) = 6
          jtrad(3,1) = 5
          jtrad(3,2) = 6
          jtrad(3,3) = 3
          
          case(6)
          jtrad(1,1) = 1
          jtrad(1,2) = 4
          jtrad(1,3) = 5
          jtrad(2,1) = 6
          jtrad(2,2) = 2
          jtrad(2,3) = 7
          jtrad(3,1) = 8
          jtrad(3,2) = 9
          jtrad(3,3) = 3
          jtrad(4,1) = 4
          jtrad(4,2) = 6
          jtrad(4,3) = 10
          jtrad(5,1) = 5
          jtrad(5,2) = 10
          jtrad(5,3) = 8
          jtrad(6,1) = 10
          jtrad(6,2) = 7
          jtrad(6,3) = 9

         case(10)
         jtrad( 1,1)  =  1
         jtrad( 1,2)  =  4
         jtrad( 1,3)  =  5
         jtrad( 2,1)  =  6
         jtrad( 2,2)  =  2
         jtrad( 2,3)  =  7
         jtrad( 3,1)  =  8
         jtrad( 3,2)  =  9
         jtrad( 3,3)  =  3
         jtrad( 4,1)  =  4
         jtrad( 4,2)  =  10
         jtrad( 4,3)  =  13
         jtrad( 5,1)  =  5
         jtrad( 5,2)  =  13
         jtrad( 5,3)  =  11
         jtrad( 6,1)  =  10
         jtrad( 6,2)  =  6
         jtrad( 6,3)  =  14
         jtrad( 7,1)  =  14
         jtrad( 7,2)  =  7
         jtrad( 7,3)  =  12
         jtrad( 8,1)  =  11
         jtrad( 8,2)  =  15
         jtrad( 8,3)  =  8
         jtrad( 9,1)  =  15
         jtrad( 9,2)  =  12
         jtrad( 9,3)  =  9
         jtrad(10,1)  =  13
         jtrad(10,2)  =  14
         jtrad(10,3)  =  15
      case(15)
         jtrad( 1,1)  =  1
         jtrad( 1,2)  =  4
         jtrad( 1,3)  =  5
         jtrad( 2,1)  =  6
         jtrad( 2,2)  =  2
         jtrad( 2,3)  =  7
         jtrad( 3,1)  =  8
         jtrad( 3,2)  =  9
         jtrad( 3,3)  =  3
         jtrad( 4,1)  =  4
         jtrad( 4,2)  =  10
         jtrad( 4,3)  =  16
         jtrad( 5,1)  =  5
         jtrad( 5,2)  =  16
         jtrad( 5,3)  =  11
         jtrad( 6,1)  =  12
         jtrad( 6,2)  =  6
         jtrad( 6,3)  =  17
         jtrad( 7,1)  =  17
         jtrad( 7,2)  =  7
         jtrad( 7,3)  =  13
         jtrad( 8,1)  =  14
         jtrad( 8,2)  =  18
         jtrad( 8,3)  =  8
         jtrad( 9,1)  =  18
         jtrad( 9,2)  =  15
         jtrad( 9,3)  =  9
         jtrad(10,1)  =  10
         jtrad(10,2)  =  12
         jtrad(10,3)  =  19
         jtrad(11,1)  =  11
         jtrad(11,2)  =  20
         jtrad(11,3)  =  14
         jtrad(12,1)  =  21
         jtrad(12,2)  =  13
         jtrad(12,3)  =  15
         jtrad(13,1)  =  16
         jtrad(13,2)  =  19
         jtrad(13,3)  =  20
         jtrad(14,1)  =  19
         jtrad(14,2)  =  17
         jtrad(14,3)  =  21
         jtrad(15,1)  =  20
         jtrad(15,2)  =  21
         jtrad(15,3)  =  18
 
      endselect

      end
CC JEBDEX ============================================================
C   SET INDEX FOR TRANS-B
C   SORT ORDER INDICATED
C   
C ====================================================================
      
      subroutine jebdex( jtrad,idd )
      
      implicit real(8)(a-h,o-z)
      dimension jtrad(15,3,2)
      
      select case(idd)

          case(3)
          jtrad(1,1,1) = 1
          jtrad(1,2,1) = 0
          jtrad(1,3,1) = 0
          jtrad(2,1,1) = 0
          jtrad(2,2,1) = 1
          jtrad(2,3,1) = 0
          jtrad(3,1,1) = 0
          jtrad(3,2,1) = 0
          jtrad(3,3,1) = 1
          
          jtrad(1,1,2) = 1
          jtrad(2,2,2) = 1
          jtrad(3,3,2) = 1

          case(6)
          jtrad(1,1,1) = 1
          jtrad(1,2,1) = 0
          jtrad(1,3,1) = 0
          jtrad(2,1,1) = 0
          jtrad(2,2,1) = 2
          jtrad(2,3,1) = 0
          jtrad(3,1,1) = 0
          jtrad(3,2,1) = 0
          jtrad(3,3,1) = 3
          jtrad(4,1,1) = 2
          jtrad(4,2,1) = 1
          jtrad(4,3,1) = 0
          jtrad(5,1,1) = 3
          jtrad(5,2,1) = 0
          jtrad(5,3,1) = 1
          jtrad(6,1,1) = 0
          jtrad(6,2,1) = 3
          jtrad(6,3,1) = 2

          jtrad(1,1,2) = 2
          jtrad(2,2,2) = 2
          jtrad(3,3,2) = 2
          jtrad(4,1,2) = 1
          jtrad(4,2,2) = 1
          jtrad(5,1,2) = 1
          jtrad(5,3,2) = 1
          jtrad(6,2,2) = 1
          jtrad(6,3,2) = 1

      case(10)
         jtrad( 1,1,1)  =1
         jtrad( 1,2,1)  =0
         jtrad( 1,3,1)  =0
         jtrad( 2,1,1)  =0
         jtrad( 2,2,1)  =2
         jtrad( 2,3,1)  =0
         jtrad( 3,1,1)  =0
         jtrad( 3,2,1)  =0
         jtrad( 3,3,1)  =3
         jtrad( 4,1,1)  =4
         jtrad( 4,2,1)  =1
         jtrad( 4,3,1)  =0
         jtrad( 5,1,1)  =5
         jtrad( 5,2,1)  =0
         jtrad( 5,3,1)  =1
         jtrad( 6,1,1)  =2
         jtrad( 6,2,1)  =4
         jtrad( 6,3,1)  =0
         jtrad( 7,1,1)  =0
         jtrad( 7,2,1)  =6
         jtrad( 7,3,1)  =2
         jtrad( 8,1,1)  =3
         jtrad( 8,2,1)  =0
         jtrad( 8,3,1)  =5
         jtrad( 9,1,1)  =0
         jtrad( 9,2,1)  =3
         jtrad( 9,3,1)  =6
         jtrad(10,1,1)  =6
         jtrad(10,2,1)  =5
         jtrad(10,3,1)  =4

         jtrad( 1,1,2)  =3
         jtrad( 2,2,2)  =3
         jtrad( 3,3,2)  =3
         jtrad( 4,1,2)  =2
         jtrad( 4,2,2)  =1
         jtrad( 5,1,2)  =2
         jtrad( 5,3,2)  =1
         jtrad( 6,1,2)  =1
         jtrad( 6,2,2)  =2
         jtrad( 7,2,2)  =2
         jtrad( 7,3,2)  =1
         jtrad( 8,1,2)  =1
         jtrad( 8,3,2)  =2
         jtrad( 9,2,2)  =1
         jtrad( 9,3,2)  =2
         jtrad(10,1,2)  =1
         jtrad(10,2,2)  =1
         jtrad(10,3,2)  =1

      case(15)
         jtrad( 1,1,1)  =  1
         jtrad( 1,2,1)  =  0
         jtrad( 1,3,1)  =  0
         jtrad( 2,1,1)  =  0
         jtrad( 2,2,1)  =  2
         jtrad( 2,3,1)  =  0
         jtrad( 3,1,1)  =  0
         jtrad( 3,2,1)  =  0
         jtrad( 3,3,1)  =  3
         jtrad( 4,1,1)  =  4
         jtrad( 4,2,1)  =  1
         jtrad( 4,3,1)  =  0
         jtrad( 5,1,1)  =  5
         jtrad( 5,2,1)  =  0
         jtrad( 5,3,1)  =  1
         jtrad( 6,1,1)  =  2
         jtrad( 6,2,1)  =  6
         jtrad( 6,3,1)  =  0
         jtrad( 7,1,1)  =  0
         jtrad( 7,2,1)  =  7
         jtrad( 7,3,1)  =  2
         jtrad( 8,1,1)  =  3
         jtrad( 8,2,1)  =  0
         jtrad( 8,3,1)  =  8
         jtrad( 9,1,1)  =  0
         jtrad( 9,2,1)  =  3
         jtrad( 9,3,1)  =  9
         jtrad(10,1,1)  =  6
         jtrad(10,2,1)  =  4
         jtrad(10,3,1)  =  0
         jtrad(11,1,1)  =  8
         jtrad(11,2,1)  =  0
         jtrad(11,3,1)  =  5
         jtrad(12,1,1)  =  0
         jtrad(12,2,1)  =  9
         jtrad(12,3,1)  =  7
         jtrad(13,1,1)  =  10
         jtrad(13,2,1)  =  5
         jtrad(13,3,1)  =  4
         jtrad(14,1,1)  =  7
         jtrad(14,2,1)  =  10
         jtrad(14,3,1)  =  6
         jtrad(15,1,1)  =  9
         jtrad(15,2,1) =  8
         jtrad(15,3,1) =  10

         jtrad( 1,1,2)  = 4
         jtrad( 2,2,2)  = 4
         jtrad( 3,3,2)  = 4
         jtrad( 4,1,2)  = 3
         jtrad( 4,2,2)  = 1
         jtrad( 5,1,2)  = 3
         jtrad( 5,3,2)  = 1
         jtrad( 6,1,2)  = 1
         jtrad( 6,2,2)  = 3
         jtrad( 7,2,2)  = 3
         jtrad( 7,3,2)  = 1
         jtrad( 8,1,2)  = 1
         jtrad( 8,3,2)  = 3
         jtrad( 9,2,2)  = 1
         jtrad( 9,3,2)  = 3
         jtrad(10,1,2)  = 2
         jtrad(10,2,2)  = 2
         jtrad(11,1,2)  = 2
         jtrad(11,3,2)  = 2
         jtrad(12,2,2)  = 2
         jtrad(12,3,2)  = 2
         jtrad(13,1,2)  = 2
         jtrad(13,2,2)  = 1
         jtrad(13,3,2)  = 1
         jtrad(14,1,2)  = 1
         jtrad(14,2,2)  = 2
         jtrad(14,3,2)  = 1
         jtrad(15,1,2)  = 1
         jtrad(15,2,2)  = 1
         jtrad(15,3,2)  = 2
 
      endselect

      end

