! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
subroutine grad_output_core(ex,indexg,gval,mxang3,i4,m4,iam0,ncount,erithr) 

  integer :: i4(4),m4(4)
  integer(2) :: indexg(6,mxang3*12)
  real(8) :: ex(mxang3),gval(mxang3*12),erithr
  integer :: ncount

  ir = i4(1)
  is = i4(2)
  it = i4(3)
  iu = i4(4)

  mi = m4(1)
  mj = m4(2)
  mk = m4(3)
  ml = m4(4)

  icount = 0 

  do ii=ir,ir+mi-1
    do jj=is,is+mj-1
      do kk=it,it+mk-1
        do ll=iu,iu+ml-1
          do ixyz=1,3
            icount = icount + 1
            val = ex(icount)
            if (dabs(ex(icount)) < erithr ) cycle
            ncount = ncount + 1
            indexg(1,ncount) = ii
            indexg(2,ncount) = jj
            indexg(3,ncount) = kk
            indexg(4,ncount) = ll
            indexg(5,ncount) = iam0
            indexg(6,ncount) = ixyz
            gval(ncount) = val
!           write(80,"(6i4,e26.15)")ii,jj,kk,ll,iam0,ixyz,val
          enddo
        enddo
      enddo
    enddo
  enddo

end subroutine grad_output_core

subroutine grad_output_core1(ex,indexg,gval,mxang3,i4,m4,iam0,ncount,erithr) 

  integer ::i4(4),m4(4)
  integer(2) :: indexg(6,mxang3*12)
  real(8) :: ex(mxang3),gval(mxang3*12),erithr

  integer :: ncount

  ir = i4(1)
  is = i4(2)
  it = i4(3)
  iu = i4(4)

  mi = m4(1)
  mj = m4(2)
  mk = m4(3)
  ml = m4(4)

  icount = 0 
  do ii=ir,ir+mi-1
    do jj=is,is+mj-1
      do kk=it,it+mk-1
        do ll=iu,iu+ml-1
          do ixyz=1,3
            icount = icount + 1
!           if ( (ii == kk).and.(jj < ll ) )  cycle
            if (ii < jj)  cycle

            val = ex(icount)
            if (dabs(ex(icount)) < erithr ) cycle

            ncount = ncount + 1
            indexg(1,ncount) = ii
            indexg(2,ncount) = jj
            indexg(3,ncount) = kk
            indexg(4,ncount) = ll
            indexg(5,ncount) = iam0
            indexg(6,ncount) = ixyz
            gval(ncount) = val

!           write(80,"(6i4,e26.15)")ii,jj,kk,ll,iam0,ixyz,val
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine grad_output_core1

subroutine grad_output_core4(ex,indexg,gval,mxang3,i4,m4,iam0,ncount,erithr)
! use cutoff_option,only:erithr

  integer :: i4(4),m4(4)
  integer(2) :: indexg(6,mxang3*12)
  real(8) :: ex(mxang3),gval(mxang3*12),erithr

  integer :: ncount

  ir = i4(1)
  is = i4(2)
  it = i4(3)
  iu = i4(4)

  mi = m4(1)
  mj = m4(2)
  mk = m4(3)
  ml = m4(4)


  icount = 0 
  do ii=ir,ir+mi-1
    do jj=is,is+mj-1
      do kk=it,it+mk-1
        do ll=iu,iu+ml-1
          do ixyz=1,3
            icount = icount + 1
            if ( (ii == kk).and.(jj < ll ) )  cycle
            if (ii < kk)  cycle

            val = ex(icount)
            if (dabs(ex(icount)) < erithr ) cycle

            ncount = ncount + 1
            indexg(1,ncount) = ii
            indexg(2,ncount) = jj
            indexg(3,ncount) = kk
            indexg(4,ncount) = ll
            indexg(5,ncount) = iam0
            indexg(6,ncount) = ixyz
            gval(ncount) = val

!           write(80,"(6i4,e26.15)")ii,jj,kk,ll,iam0,ixyz,val
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine grad_output_core4

subroutine grad_output_core2(ex,indexg,gval,mxang3,i4,m4,iam0,ncount,erithr)
! use cutoff_option,only:erithr

  integer :: i4(4),m4(4)
  integer(2) :: indexg(6,mxang3*12)
  real(8) :: ex(mxang3),gval(mxang3*12),erithr

  integer :: ncount

  ir = i4(1)
  is = i4(2)
  it = i4(3)
  iu = i4(4)

  mi = m4(1)
  mj = m4(2)
  mk = m4(3)
  ml = m4(4)

  icount = 0 
  do ii=ir,ir+mi-1
    do jj=is,is+mj-1
      do kk=it,it+mk-1
        do ll=iu,iu+ml-1
          do ixyz=1,3
            icount = icount + 1
!           if ( (ii == kk).and.(jj < ll ) )  cycle
            if (kk < ll)  cycle

            val = ex(icount)
            if (dabs(ex(icount)) < erithr ) cycle

            ncount = ncount + 1
            indexg(1,ncount) = ii
            indexg(2,ncount) = jj
            indexg(3,ncount) = kk
            indexg(4,ncount) = ll
            indexg(5,ncount) = iam0
            indexg(6,ncount) = ixyz
            gval(ncount) = val

!           write(80,"(6i4,e26.15)")ii,jj,kk,ll,iam0,ixyz,val
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine grad_output_core2

subroutine grad_output_core3(ex,indexg,gval,mxang3,i4,m4,iam0,ncount,erithr) 
! use cutoff_option,only:erithr

  integer :: i4(4),m4(4)
  integer(2) :: indexg(6,mxang3*12)
  real(8) :: ex(mxang3),gval(mxang3*12),erithr

  integer :: ncount

  ir = i4(1)
  is = i4(2)
  it = i4(3)
  iu = i4(4)

  mi = m4(1)
  mj = m4(2)
  mk = m4(3)
  ml = m4(4)

  icount = 0 
  do ii=ir,ir+mi-1
    do jj=is,is+mj-1
      do kk=it,it+mk-1
        do ll=iu,iu+ml-1
          do ixyz=1,3
            icount = icount + 1
!           if ( (ii == kk).and.(jj < ll ) )  cycle
            if (ii < jj)  cycle
            if (kk < ll)  cycle

            val = ex(icount)
            if (dabs(ex(icount)) < erithr ) cycle

            ncount = ncount + 1
            indexg(1,ncount) = ii
            indexg(2,ncount) = jj
            indexg(3,ncount) = kk
            indexg(4,ncount) = ll
            indexg(5,ncount) = iam0
            indexg(6,ncount) = ixyz
            gval(ncount) = val

!           write(80,"(6i4,e26.15)")ii,jj,kk,ll,iam0,ixyz,val
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine grad_output_core3
