! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!#swzj_cutthr == =======================================================
!     Calculating for Max Value of |(rr|rr)|,|(r'r'|r'r')|
!     set cutthr  (erithr^2/|max(rr|rr)|)
! 
!     (rs|tu)^2  < |(rs|rs)||(tu|tu)|
!                < |(rs|rs)||max(rr|rr)| < erithr^2
!
!     |(rs|rs)| < erithr^2/|max(rr|rr)|
!======================================================================*
      subroutine swzj_cutthr(
     &     cutthrp, cutthrq,cutthdp,cutthdq,
     &     e_rrrr, d_rrrr,
     &     ir_s  ,  ir_e,  is_s,  is_e,
     &     it_s  ,  it_e,  iu_s,  iu_e,
     &     nshell,  erithr              )
      implicit real(8)(a-h,o-z)

      dimension e_rrrr(nshell),d_rrrr(nshell)

       qqmax = 0.d0
      dqqmax = 0.d0
       ppmax = 0.d0
      dppmax = 0.d0

      do i = ir_s ,ir_e
          qmax = e_rrrr(i)
         dqmax = d_rrrr(i)

         if ( qmax.gt. qqmax)  qqmax =  qmax
         if (dqmax.gt.dqqmax) dqqmax = dqmax
      enddo
        
      do i = is_s ,is_e
          qmax = e_rrrr(i)
         dqmax = d_rrrr(i)

         if ( qmax.gt.qqmax)   qqmax =  qmax
         if (dqmax.gt.dqqmax) dqqmax = dqmax
      enddo
        
      do i = it_s ,it_e
        pmax = e_rrrr(i)
       dpmax = d_rrrr(i)

       if ( pmax.gt. ppmax)  ppmax =  pmax
       if (dpmax.gt.dppmax) dppmax = dpmax
      enddo
        
      do i = iu_s ,iu_e
        pmax = e_rrrr(i)
       dpmax = d_rrrr(i)

       if ( pmax.gt. ppmax)  ppmax =  pmax
       if (dpmax.gt.dppmax) dppmax = dpmax
      enddo
       
      cutthrp =  erithr**2 / qqmax
      cutthrq =  erithr**2 / ppmax

      cutthdp =  erithr**2 / dsqrt(qqmax * dqqmax)
      cutthdq =  erithr**2 / dsqrt(ppmax * dppmax)
!     write(*,*)cutthrp,cutthrq
      end
