! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
C## Estimation Schwarz ================================================
C     Estimation for number of AO Value in Schwarz Inequality
C
C======================================================================*
      subroutine swz_dest(
     &     njtei0cut,  njtei1cut,
     &     iplset   ,  iqlset   , kphky, 
     &     ips      ,  iqs      ,
     &     nsh2shty ,  nsh2atm  ,
     &     ir_s     ,  ir_e     ,  is_s,  is_e,
     &     it_s     ,  it_e     ,  iu_s,  iu_e,
     &     nshell   ,
     &     ierr      )

      implicit real(8) (a-h,o-z)
      
      integer(8) njtei0cut, njtei1cut

      dimension iplset(3,ips),iqlset(2,iqs)
      dimension nsh2shty(nshell)
      dimension nsh2atm(nshell)

      dimension mm(10)
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55 /
      njtei1cut = 0

      do ip = 1,kphky
         iiq = iplset(3,ip)

         i = iplset(1,ip)
         j = iplset(2,ip)
         iatom = nsh2atm(i)
         jatom = nsh2atm(j)
         ian = nsh2shty(i)
         jan = nsh2shty(j)

         do iq = 1,iiq
            kij = 0 ; kik = 0 ; kil = 0
            kjk = 0 ; kjl = 0 ; kkl = 0
           
            k = iqlset(1,iq)
            l = iqlset(2,iq)
           
            kij = 0 ; kik = 0 ; kil = 0
            kjk = 0 ; kjl = 0 ; kkl = 0
            
            katom = nsh2atm(k)
            latom = nsh2atm(l)
            kan = nsh2shty(k)
            lan = nsh2shty(l)
           
            if (iatom.eq.jatom) kij = 1
            if (iatom.eq.katom) kik = 1
            if (iatom.eq.latom) kil = 1
            if (jatom.eq.katom) kjk = 1
            if (jatom.eq.latom) kjl = 1
            if (katom.eq.latom) kkl = 1
           
            key = kij + 2*kik + 4* kil + 8 * kjk + 16*kjl + 32 * kkl + 1
           
            select case(key)
            case(1)
               ncod = 4
            case(2)
               ncod = 3
            case(3)
               ncod = 3
            case(5)
               ncod = 3
            case(9)
               ncod = 3
            case(12)
               ncod = 2
            case(13)
               ncod = 2
            case(17)
               ncod = 3
            case(19)
               ncod = 2
            case(22)
               ncod = 2
            case(33)
               ncod = 3
            case(34)
               ncod = 2
            case(39)
               ncod = 2
            case(57)
               ncod = 2
            case(64)
               ncod = 0
            end select

            njtei1cut = njtei1cut + 
     &      3 * mm(ian)*mm(jan)*mm(kan)*mm(lan) * ncod

           
         enddo
      enddo

!!!! NJTEI0CUT =======================================
      njtei0cut = 0
      do i = ir_s,ir_e
         do j = is_s,is_e

!           if (i.lt.j) cycle

            iatom = nsh2atm(i)
            jatom = nsh2atm(j)
            ian = nsh2shty(i)
            jan = nsh2shty(j)

            do k = it_s,it_e
               do l = iu_s,iu_e

                  kij = 0 ; kik = 0 ; kil = 0
                  kjk = 0 ; kjl = 0 ; kkl = 0
           
                  kij = 0 ; kik = 0 ; kil = 0
                  kjk = 0 ; kjl = 0 ; kkl = 0
               
!                 ip = i + j
!                 iq = k + l
!                 if (k.lt.l) cycle
!                 if (i.lt.k) cycle
!                 if ((i.eq.k).and.(ip.lt.iq))cycle
               
                  katom = nsh2atm(k)
                  latom = nsh2atm(l)
                  kan = nsh2shty(k)
                  lan = nsh2shty(l)
           
                  if (iatom.eq.jatom) kij = 1
                  if (iatom.eq.katom) kik = 1
                  if (iatom.eq.latom) kil = 1
                  if (jatom.eq.katom) kjk = 1
                  if (jatom.eq.latom) kjl = 1
                  if (katom.eq.latom) kkl = 1
           
                  key = kij + 2*kik + 4* kil + 8 * kjk + 
     &                       16*kjl + 32*kkl + 1
           
                  select case(key)
                  case(1)
                     ncod = 4
                  case(2)
                     ncod = 3
                  case(3)
                     ncod = 3
                  case(5)
                     ncod = 3
                  case(9)
                     ncod = 3
                  case(12)
                     ncod = 2
                  case(13)
                     ncod = 2
                  case(17)
                     ncod = 3
                  case(19)
                     ncod = 2
                  case(22)
                     ncod = 2
                  case(33)
                     ncod = 3
                  case(34)
                     ncod = 2
                  case(39)
                     ncod = 2
                  case(57)
                     ncod = 2
                  case(64)
                     ncod = 0
                  end select
      
                  njtei0cut = njtei0cut + 
     &            3 * mm(ian)*mm(jan)*mm(kan)*mm(lan) * ncod
           
               enddo
            enddo
         enddo
      enddo


      end
C## Estimation Schwarz 1/8================================================
C     Estimation for number of AO Value in Schwarz Inequality
C
C======================================================================*
      subroutine swz_dest18x(
     &     njtei0cut,  njtei1cut,
     &     nsh2shty ,  nsh2atm  ,
     &     swzij    ,  swzdij   ,
     &     nr_s     ,  nr_e     ,  ns_s,  ns_e,
     &     nt_s     ,  nt_e     ,  nu_s,  nu_e, nao2sh,nao,
     &     cutthrp,cutthrq,cutthdp,cutthdq,
     &     nshell   ,
     &     myrank   ,  nproc, limit,
     &     lprint,ierr      )
c$$$      use mpi

      implicit real(8) (a-h,o-z)
      include 'mpif.h'

      integer(8) njtei0cut, njtei1cut

      dimension nsh2shty(nshell)
      dimension nsh2atm(nshell)
! ====
      dimension nao2sh(nao)
      dimension swzij(nshell,nshell),swzdij(nshell,nshell)
! ====
      logical ipart
      dimension mm(10)
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55 /

! --- for parallel ---
      icount = -1
! --- for parallel ---

      njtei1cut = 0
      njtei0cut = 0
      iff = 0 
        
      do i = nr_s,nr_e
         do j = ns_s,ns_e
            if (i.lt.j) cycle
            ii = nao2sh(i)
            jj = nao2sh(j)

            aaa = swzdij(ii,jj)
            bbb = swzdij(jj,ii)
            swzd = max(aaa,bbb)

            if ((swzij(ii,jj).lt.cutthdq).and.(swzd.lt.cutthrq) ) cycle
            do k = nt_s,nt_e
               do l = nu_s,nu_e

                  ip = i + j
                  iq = k + l
              
                  if (k.lt.l) cycle
                  if (i.lt.k) cycle
                  if ((i.eq.k).and.(ip.lt.iq))cycle

                  kk = nao2sh(k)
                  ll = nao2sh(l)

                  ccc = swzdij(kk,ll)
                  ddd = swzdij(ll,kk)
                  swzd = max(ccc,ddd)

                  if ( (swzij(kk,ll).lt.cutthdp ).and.
     &                ( swzd.lt.cutthrp) ) cycle

!             --- for parallel ---
                  icount = icount + 1
                  ipart  = icount.ne.myrank
                  if(icount.eq.nproc-1) icount = -1
                  if ( ipart ) cycle
!             --- for parallel ---

                  iatom = nsh2atm(ii)
                  jatom = nsh2atm(jj)
                  katom = nsh2atm(kk)
                  latom = nsh2atm(ll)
                  kij = 0 ; kik = 0 ; kil = 0
                  kjk = 0 ; kjl = 0 ; kkl = 0
       
                  if (iatom.eq.jatom) kij = 1
                  if (iatom.eq.katom) kik = 1
                  if (iatom.eq.latom) kil = 1
                  if (jatom.eq.katom) kjk = 1
                  if (jatom.eq.latom) kjl = 1
                  if (katom.eq.latom) kkl = 1
                  key = kij + 2*kik + 4* kil + 8 * kjk 
     &                              + 16*kjl + 32 * kkl + 1
                  select case(key)
                  case(1)
                     ncod = 12!4
                  case(2)
                     ncod = 9!3
                  case(3)
                     ncod = 9!3
                  case(5)
                     ncod = 9!3
                  case(9)
                     ncod = 9!3
                  case(12)
                     ncod = 6!2
                  case(13)
                     ncod = 6!2
                  case(17)
                     ncod = 9!3
                  case(19)
                     ncod = 6!2
                  case(22)
                     ncod = 6!2
                  case(33)
                     ncod = 9!3
                  case(34)
                     ncod = 6!2
                  case(39)
                     ncod = 6!2
                  case(57)
                     ncod = 6!2
                  case(64)
                     ncod = 0
                  end select

                  njtei1cut = njtei1cut + ncod!*3
               enddo
            enddo
         enddo
         if (njtei1cut.ge.limit) then
            i0 = i
            iff = 1
            goto 3333
         endif
      enddo

3333  if (iff.eq.1) then
         nr_e = i0
      endif


      if (lprint.le.1) goto 3334

!====== CALC TOTAL ERI NUMBER ===

! --- for parallel ---
      icount = -1
! --- for parallel ---

      do i = nr_s,nr_e
         do j = ns_s,ns_e
            if (i.lt.j) cycle
            ii = nao2sh(i)
            jj = nao2sh(j)

            aaa = swzdij(i,j)
            bbb = swzdij(j,i)
            swzd = max(aaa,bbb)

!           if ((swzij(ii,jj).lt.cutthdq).and.(swzd.lt.cutthrq) ) cycle
            do k = nt_s,nt_e
               do l = nu_s,nu_e
                  kk = nao2sh(k)
                  ll = nao2sh(l)

                  ip = i + j
                  iq = k + l
              
                  if (k.lt.l) cycle
                  if (i.lt.k) cycle
                  if ((i.eq.k).and.(ip.lt.iq))cycle
!             --- for parallel ---
                  icount = icount + 1
                  ipart  = icount.ne.myrank
                  if(icount.eq.nproc -1) icount = -1
                  if(ipart) cycle
!             --- for parallel ---
                    ccc = swzdij(k,l)
                    ddd = swzdij(l,k)
                    swzd = max(ccc,ddd)
!           if ((swzij(kk,ll).lt.cutthdp).and.(swzd.lt.cutthrp) ) cycle

                  iatom = nsh2atm(ii)
                  jatom = nsh2atm(jj)
                  katom = nsh2atm(kk)
                  latom = nsh2atm(ll)
                  kij = 0 ; kik = 0 ; kil = 0
                  kjk = 0 ; kjl = 0 ; kkl = 0
        
       
                  if (iatom.eq.jatom) kij = 1
                  if (iatom.eq.katom) kik = 1
                  if (iatom.eq.latom) kil = 1
                  if (jatom.eq.katom) kjk = 1
                  if (jatom.eq.latom) kjl = 1
                  if (katom.eq.latom) kkl = 1
                  key = kij + 2*kik + 4* kil + 8 * kjk 
     &                              + 16*kjl + 32 * kkl + 1

                  select case(key)
                  case(1)
                     ncod = 4
                  case(2)
                     ncod = 3
                  case(3)
                     ncod = 3
                  case(5)
                     ncod = 3
                  case(9)
                     ncod = 3
                  case(12)
                     ncod = 2
                  case(13)
                     ncod = 2
                  case(17)
                     ncod = 3
                  case(19)
                     ncod = 2
                  case(22)
                     ncod = 2
                  case(33)
                     ncod = 3
                  case(34)
                     ncod = 2
                  case(39)
                     ncod = 2
                  case(57)
                     ncod = 2
                  case(64)
                     ncod = 0
                  end select

                  njtei0cut = njtei0cut + ncod*3
               enddo
            enddo
         enddo
      enddo

3334  end
C## Estimation Schwarz 1/8================================================
C     Estimation for number of AO Value in Schwarz Inequality
C
C======================================================================*
      subroutine swz_dest18y(
     &     njtei0cut,  njtei1cut,
     &     nsh2shty ,  nsh2atm  ,
     &     swzij    ,  swzdij   ,
     &     nr_s     ,  nr_e     ,  ns_s,  ns_e,
     &     nt_s     ,  nt_e     ,  nu_s,  nu_e, nao2sh,nao,
     &     cutthrp,cutthrq,cutthdp,cutthdq,
     &     nshell   ,
c$$$     &     myrank   ,  nproc, limit,
     &     icomm, myrank, nproc, limit,
     &     lprint,ierr      )
c$$$      use mpi

      implicit real(8) (a-h,o-z)
      include 'mpif.h'

      integer(8) njtei0cut, njtei1cut

      dimension nsh2shty(nshell)
      dimension nsh2atm(nshell)
! ====
      dimension nao2sh(nao)
      dimension swzij(nshell,nshell),swzdij(nshell,nshell)
! ====
      logical ipart
      dimension mm(10)
      data (mm(i),i=1,10) /1,3,6,10,15,21,28,36,45,55 /

      integer,allocatable :: nsh2ao(:)

c$$$      mcw = MPI_COMM_WORLD
      allocate(nsh2ao(nshell+1))

! --- for parallel ---
      icount = -1
! --- for parallel ---

      njtei1cut = 0
      njtei0cut = 0
      iff = 0 
        
      ir_s = nao2sh(nr_s);  ir_e = nao2sh(nr_e)
      is_s = nao2sh(ns_s);  is_e = nao2sh(ns_e)
      it_s = nao2sh(nt_s);  it_e = nao2sh(nt_e)
      iu_s = nao2sh(nu_s);  iu_e = nao2sh(nu_e)

      ishelo = 0
      do i=1,nao
         isheln = nao2sh(i)
         if(isheln.ne.ishelo) then
           nsh2ao(isheln) = i
           ishelo = isheln
         endif
      enddo

      nsh2ao(nshell+1) = nao+1  
        
      nj1 = 0
      do i = ir_s,ir_e
         do j = is_s,is_e
            if (i.lt.j) cycle

            aaa = swzdij(i,j)
            bbb = swzdij(j,i)
            swzd = max(aaa,bbb)

            if ((swzij(i,j).lt.cutthdq).and.(swzd.lt.cutthrq) ) cycle
            do k = it_s,it_e
               do l = iu_s,iu_e

                  ip = i + j
                  iq = k + l
              
                  if (k.lt.l) cycle
                  if (i.lt.k) cycle
                  if ((i.eq.k).and.(ip.lt.iq))cycle
                  ccc = swzdij(k,l)
                  ddd = swzdij(l,k)
                  swzd = max(ccc,ddd)

                  if ( (swzij(k,l).lt.cutthdp ).and.
     &                ( swzd.lt.cutthrp) ) cycle

!             --- for parallel ---
                  icount = icount + 1
                  ipart  = icount.ne.myrank
                  if(icount.eq.nproc-1) icount = -1
                  if ( ipart ) cycle
!             --- for parallel ---

                  iatom = nsh2atm(i)
                  jatom = nsh2atm(j)
                  katom = nsh2atm(k)
                  latom = nsh2atm(l)

                  iang = nsh2shty(i)
                  jang = nsh2shty(j)
                  kang = nsh2shty(k)
                  lang = nsh2shty(l)

                  kij = 0 ; kik = 0 ; kil = 0
                  kjk = 0 ; kjl = 0 ; kkl = 0
       
                  if (iatom.eq.jatom) kij = 1
                  if (iatom.eq.katom) kik = 1
                  if (iatom.eq.latom) kil = 1
                  if (jatom.eq.katom) kjk = 1
                  if (jatom.eq.latom) kjl = 1
                  if (katom.eq.latom) kkl = 1
                  key = kij + 2*kik + 4* kil + 8 * kjk 
     &                              + 16*kjl + 32 * kkl + 1
                  select case(key)
                  case(1)
                     ncod = 12!4
                  case(2)
                     ncod = 9!3
                  case(3)
                     ncod = 9!3
                  case(5)
                     ncod = 9!3
                  case(9)
                     ncod = 9!3
                  case(12)
                     ncod = 6!2
                  case(13)
                     ncod = 6!2
                  case(17)
                     ncod = 9!3
                  case(19)
                     ncod = 6!2
                  case(22)
                     ncod = 6!2
                  case(33)
                     ncod = 9!3
                  case(34)
                     ncod = 6!2
                  case(39)
                     ncod = 6!2
                  case(57)
                     ncod = 6!2
                  case(64)
                     ncod = 0
                  end select

                  njtei1cut = njtei1cut + 
     &                        mm(iang)*mm(jang)*mm(kang)*mm(lang)*ncod!*3
               enddo
            enddo



         enddo

         if (njtei1cut.ge.limit) then
            write(6,*) 'njtei1cut=',njtei1cut
            i0 = i - 1
            iff = 1
            njtei1cut = nj1
            goto 3333
         endif
         nj1 = njtei1cut

      enddo

3333  if (iff.eq.1) then
!        nr_e = i0
         ir_e = i0
         nr_e = nsh2ao(i0+1) - 1
      endif

c$$$      call mpi_allreduce(ir_e,ir_ei,1,mpi_integer,mpi_min,mcw,ierr)
c$$$      call mpi_allreduce(ir_e,ir_ex,1,mpi_integer,mpi_max,mcw,ierr)
      call mpi_allreduce(ir_e,ir_ei,1,mpi_integer,mpi_min,icomm,ierr)
      call mpi_allreduce(ir_e,ir_ex,1,mpi_integer,mpi_max,icomm,ierr)
           
      if(ir_ei.ne.ir_ex)  then
        ir_e = ir_ei
        nr_e = nsh2ao(ir_e+1)-1
        njtei1cut = 0
        icount = -1
      do i = ir_s,ir_e
         do j = is_s,is_e
            if (i.lt.j) cycle

            aaa = swzdij(i,j)
            bbb = swzdij(j,i)
            swzd = max(aaa,bbb)

            if ((swzij(i,j).lt.cutthdq).and.(swzd.lt.cutthrq) ) cycle
               do k = it_s,it_e
                  do l = iu_s,iu_e
   
                     ip = i + j
                     iq = k + l
                 
                     if (k.lt.l) cycle
                     if (i.lt.k) cycle
                     if ((i.eq.k).and.(ip.lt.iq))cycle
   
                     ccc = swzdij(k,l)
                     ddd = swzdij(l,k)
                     swzd = max(ccc,ddd)
   
                     if ( (swzij(k,l).lt.cutthdp ).and.
     &                   ( swzd.lt.cutthrp) ) cycle

!                --- for parallel ---
                     icount = icount + 1
                     ipart  = icount.ne.myrank
                     if(icount.eq.nproc-1) icount = -1
                     if ( ipart ) cycle
!                --- for parallel ---
           
                     iatom = nsh2atm(i)
                     jatom = nsh2atm(j)
                     katom = nsh2atm(k)
                     latom = nsh2atm(l)
           
                     iang = nsh2shty(i)
                     jang = nsh2shty(j)
                     kang = nsh2shty(k)
                     lang = nsh2shty(l)
           
                     kij = 0 ; kik = 0 ; kil = 0
                     kjk = 0 ; kjl = 0 ; kkl = 0
          
                     if (iatom.eq.jatom) kij = 1
                     if (iatom.eq.katom) kik = 1
                     if (iatom.eq.latom) kil = 1
                     if (jatom.eq.katom) kjk = 1
                     if (jatom.eq.latom) kjl = 1
                     if (katom.eq.latom) kkl = 1
                     key = kij + 2*kik + 4* kil + 8 * kjk 
     &                                 + 16*kjl + 32 * kkl + 1
                     select case(key)
                     case(1)
                        ncod = 12!4
                     case(2)
                        ncod = 9!3
                     case(3)
                        ncod = 9!3
                     case(5)
                        ncod = 9!3
                     case(9)
                        ncod = 9!3
                     case(12)
                        ncod = 6!2
                     case(13)
                        ncod = 6!2
                     case(17)
                        ncod = 9!3
                     case(19)
                        ncod = 6!2
                     case(22)
                        ncod = 6!2
                     case(33)
                        ncod = 9!3
                     case(34)
                        ncod = 6!2
                     case(39)
                        ncod = 6!2
                     case(57)
                        ncod = 6!2
                     case(64)
                        ncod = 0
                     end select
           
                     njtei1cut = njtei1cut + 
     &               mm(iang)*mm(jang)*mm(kang)*mm(lang)*ncod!*3
                  enddo
               enddo
            enddo
         enddo

      endif

      if (lprint.le.1) goto 3334

!====== CALC TOTAL ERI NUMBER ===

! --- for parallel ---
      icount = -1
! --- for parallel ---

      do i = ir_s,ir_e
         do j = is_s,is_e
            if (i.lt.j) cycle
!           ii = nao2sh(i)
!           jj = nao2sh(j)

            aaa = swzdij(i,j)
            bbb = swzdij(j,i)
            swzd = max(aaa,bbb)

!           if ((swzij(ii,jj).lt.cutthdq).and.(swzd.lt.cutthrq) ) cycle
            do k = it_s,it_e
               do l = iu_s,iu_e
!                 kk = nao2sh(k)
!                 ll = nao2sh(l)

                  ip = i + j
                  iq = k + l
              
                  if (k.lt.l) cycle
                  if (i.lt.k) cycle
                  if ((i.eq.k).and.(ip.lt.iq))cycle
!             --- for parallel ---
                  icount = icount + 1
                  ipart  = icount.ne.myrank
                  if(icount.eq.nproc -1) icount = -1
                  if(ipart) cycle
!             --- for parallel ---
                  ccc = swzdij(k,l)
                  ddd = swzdij(l,k)
                  swzd = max(ccc,ddd)
!           if ((swzij(kk,ll).lt.cutthdp).and.(swzd.lt.cutthrp) ) cycle

                  iatom = nsh2atm(i)
                  jatom = nsh2atm(j)
                  katom = nsh2atm(k)
                  latom = nsh2atm(l)

                  iang = nsh2shty(i)
                  jang = nsh2shty(j)
                  kang = nsh2shty(k)
                  lang = nsh2shty(l)

                  kij = 0 ; kik = 0 ; kil = 0
                  kjk = 0 ; kjl = 0 ; kkl = 0
       
                  if (iatom.eq.jatom) kij = 1
                  if (iatom.eq.katom) kik = 1
                  if (iatom.eq.latom) kil = 1
                  if (jatom.eq.katom) kjk = 1
                  if (jatom.eq.latom) kjl = 1
                  if (katom.eq.latom) kkl = 1
                  key = kij + 2*kik + 4* kil + 8 * kjk 
     &                              + 16*kjl + 32 * kkl + 1

                  select case(key)
                  case(1)
                     ncod = 4
                  case(2)
                     ncod = 3
                  case(3)
                     ncod = 3
                  case(5)
                     ncod = 3
                  case(9)
                     ncod = 3
                  case(12)
                     ncod = 2
                  case(13)
                     ncod = 2
                  case(17)
                     ncod = 3
                  case(19)
                     ncod = 2
                  case(22)
                     ncod = 2
                  case(33)
                     ncod = 3
                  case(34)
                     ncod = 2
                  case(39)
                     ncod = 2
                  case(57)
                     ncod = 2
                  case(64)
                     ncod = 0
                  end select

                  njtei0cut = njtei0cut + 
     &                        mm(iang)*mm(jang)*mm(kang)*mm(lang)*ncod*3
               enddo
            enddo
         enddo
      enddo

3334  deallocate(nsh2ao)
      end

