! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
! SWZ_RRRR ==========================================================
C     Calculating for Max|(rr|rr)|
! ===================================================================
      subroutine swz_rrrr(
     &     e_rrrr ,
     &     nsh2ssh, nsh2asp, ntprm, ntshty,
     &     zz     , cc     ,
     &     nshell , mxsa   , nasp , mxprm , 
     &     ierr    )

      implicit real(8)(a-h,o-z)

      dimension e_rrrr(nshell)
      dimension zz(mxprm,mxsa,nasp),cc(mxprm,mxsa,nasp)
      dimension nsh2ssh(nshell),nsh2asp(nshell)
      dimension ntprm(mxsa,nasp),ntshty(mxsa,nasp)
      iao = 0
      do i = 1,nshell

         issh = nsh2ssh(i)
         iasp = nsh2asp(i)
         ipri = ntprm(issh,iasp)
         iang = ntshty(issh,iasp)

         select case (iang)
         case(1)
         call swz_ssss(zz(1,issh,iasp),cc(1,issh,iasp),ipri,rmax)
         case(2)
         call swz_pppp(zz(1,issh,iasp),cc(1,issh,iasp),ipri,rmax)
         case(3)
         call swz_dddd(zz(1,issh,iasp),cc(1,issh,iasp),ipri,rmax)
c$$$         case(4)
c$$$         call swz_ffff(zz(1,issh,iasp),cc(1,issh,iasp),ipri,rmax)
c$$$         case(5)
c$$$         call swz_gggg(zz(1,issh,iasp),cc(1,issh,iasp),ipri,rmax)
         end select

         e_rrrr(i) = rmax

!        do imv = 1,iang*(iang+1)/2
!           iao = iao + 1 
!           e_rrrr(iao) =  rmax
!        enddo

      enddo

      end
C## SSSS Schwarz ======================================================
C     Calculating for Max|(ss|ss)|
C
C   === INPUT ===
C  ZIJ     : Orbital exponent every shell
C  CIJ     : Contract coefficient every shell
C  NCNT    : Number of developed term every shell
C
C   === OUTPUT ===
C  RMAX    :  Max value of (ii|ii)
C
C======================================================================*
      subroutine swz_ssss(ZIJ,CIJ,NCNT,SSSSMAX)
      
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)

      DOUBLE PRECISION  LAMBDA0,LAMBDAQ,LAMBDAPQ
      parameter (pi52 = 17.4934183276248628462d0)

      DIMENSION ZIJ(NCNT),CIJ(NCNT)

      F0 = 1.0D+00

      RMAX = 0.0D+00
      SSSSMAX = 0.0D+00

      LAMBDA0 = 2.0D+00*PI52

      DO 1004 L = 1,NCNT
         DO 1003 K = 1,NCNT
            ZETQ = ZIJ(K) + ZIJ(L)
            LAMBDAQ = CIJ(K)*CIJ(L)*LAMBDA0/ZETQ
            DO 1002 J = 1,NCNT
               DO 1001 I = 1,NCNT
                  ZETP = ZIJ(I) + ZIJ(J)
                  ZPQ  = ZETP   + ZETQ
                  LAMBDAPQ = LAMBDAQ/(ZETP*SQRT(ZPQ))
                  
                  RMAX = CIJ(I)*CIJ(J)*LAMBDAPQ*F0

                  SSSSMAX = SSSSMAX + RMAX
 1001          CONTINUE
 1002       CONTINUE
 1003    CONTINUE
 1004 CONTINUE

      ssssmax = dabs(ssssmax)
      RETURN
      END
C## PPPP Schwarz ======================================================
C     Calculating for Max|(pp|pp)|
C
C   === INPUT ===
C  ZIJ     : Orbital exponent every shell
C  CIJ     : Contract coefficient every shell
C  NCNT    : Number of developed term every shell
C
C   === OUTPUT ===
C  RMAX    :  Max value of (ii|ii)
C
C======================================================================*
      subroutine swz_pppp(ZIJ,CIJ,NCNT,PPPPMAX)
      
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)
      parameter (pi52 = 17.4934183276248628462d0)

      DOUBLE PRECISION  LAMBDA,LAMBDA0,LAMBDAQ
      DOUBLE PRECISION  KET00,KET02,KET20

      DIMENSION ZIJ(NCNT),CIJ(NCNT)
      
CCC   Setting FMT
 
      F1 = 1.0D+00/3.0D+00
      F2 = 1.0D+00/5.0D+00

      R0001 = (-2.0D+00)**1*F1
      R0002 = (-2.0D+00)**2*F2
      R2000 = R0001
      R2001 = R0002
      R4000 = 3.0D+00*R2001

      RMAX = 0.0D+00
      PPPPMAX = 0.0D+00

      LAMBDA0 = 2.0D+00*PI52

      DO 1004 L = 1,NCNT
         DO 1003 K = 1,NCNT
            ZETQ = ZIJ(K) + ZIJ(L)

            LAMBDAQ = LAMBDA0/ZETQ
            CONTQ    = CIJ(K)*CIJ(L)
            
            DO 1002 J = 1,NCNT
               DO 1001 I = 1,NCNT
                  ZETP = ZIJ(I) + ZIJ(J)
                  ZPQ  = ZETP   + ZETQ
                  ROO  = ZETP*ZETQ/ZPQ
                  
                  
                  LAMBDA  = LAMBDAQ/(ZETP*SQRT(ZPQ))
                  CONTPQ  = CONTQ*CIJ(I)*CIJ(J)

                  RRMAX = CONTPQ*LAMBDA*R4000*ROO**2
                  
                  BRA02 = RRMAX/(2.0D+00*ZETP)
                  BRA00 = CONTPQ*LAMBDA*R2000*ROO
                  BRA20 = (BRA00 + BRA02)/(2.0D+00*ZETP)
                  
                  KET02 = BRA20/(2.0D+00*ZETQ)
C                  KET00 = (CONTPQ*LAMBDA - BRA00)/(2.0D+00*ZETP)
                  KET00 = CONTPQ*LAMBDA/(2.0D+00*ZETP)
     &                 *(1.0D+00 - ROO/ZETP*F1)
                  KET20 = (KET00 + KET02)/(2.0D+00*ZETQ)
                  
                  PPPPMAX = PPPPMAX + KET20
 1001          CONTINUE
 1002       CONTINUE
 1003    CONTINUE
 1004 CONTINUE
      
      ppppmax = dabs(ppppmax)
      
      
      RETURN
      END
C## DDDD Schwarz ======================================================
C     Calculating for Max|(dd|dd)|
C
C   === INPUT ===
C  ZIJ     : Orbital exponent every shell
C  CIJ     : Contract coefficient every shell
C  NCNT    : Number of developed term every shell
C
C   === OUTPUT ===
C  RMAX    :  Max value of (ii|ii)
C
C======================================================================*
      subroutine swz_dddd(ZIJ,CIJ,NCNT,DDDDMAX)
      
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)

      DOUBLE PRECISION  LAMBDA,LAMBDA0,LAMBDAQ
      parameter (pi52 = 17.4934183276248628462d0)

      DIMENSION ZIJ(NCNT),CIJ(NCNT)
c      DIMENSION R(9,5)

      F0 = 1.0D+00
      F1 = 1.0D+00/3.0D+00
      F2 = 1.0D+00/5.0D+00
      F3 = 1.0D+00/7.0D+00
      F4 = 1.0D+00/9.0D+00

      R0000 = F0
      R0001 = (-2.0D+00)**1*F1
      R0002 = (-2.0D+00)**2*F2
      R0003 = (-2.0D+00)**3*F3
      R0004 = (-2.0D+00)**4*F4

      R2000 = R0001
      R2001 = R0002
      R2002 = R0003
      R2003 = R0004

      R4000 = 3.0D+00*R2001
      R4001 = 3.0D+00*R2002
      R4002 = 3.0D+00*R2003

      R6000 = 5.0D+00*R4001
      R6001 = 5.0D+00*R4002

      R8000 = 7.0D+00*R6001

      R2200 = R2001

      R4200 = R4001
      R4201 = R4002

      R4400 = 3.0D+00*R4201

      RMAX = 0.0D+00
      DDDDMAX1 = 0.0D+00
      DDDDMAX2 = 0.0D+00
      DDDDMAX  = 0.0D+00

      LAMBDA0 = 2.0D+00*PI52

      DO 1004 L = 1,NCNT
         DO 1003 K = 1,NCNT
            ZETQ = ZIJ(K) + ZIJ(L)
            
            LAMBDAQ = LAMBDA0/ZETQ
            CONTQ    = CIJ(K)*CIJ(L)
            
            DO 1002 J = 1,NCNT
               DO 1001 I = 1,NCNT
                  ZETP = ZIJ(I) + ZIJ(J)
                  ZPQ  = ZETP   + ZETQ
                  ROO  = ZETP*ZETQ/ZPQ
                  
                  LAMBDA  = LAMBDAQ/(ZETP*SQRT(ZPQ))
                  CONTPQ  = CONTQ*CIJ(I)*CIJ(J)
                  
                  R0MAX    = CONTPQ*LAMBDA*R0000
                  R2MAX    = CONTPQ*LAMBDA*R2000*ROO**1
                  R4MAX    = CONTPQ*LAMBDA*R4000*ROO**2
                  R6MAX    = CONTPQ*LAMBDA*R6000*ROO**3
Ccc   XX Type Calculation  ---------------------------------------------
                  R8MAX1   = CONTPQ*LAMBDA*R8000*ROO**4
                  
                  CGTO0000 = R0MAX
                  CGTO0200 = R2MAX
                  CGTO1100 =         CGTO0000 + CGTO0200/(2.0D+00*ZETP)
                  CGTO2000 =                    CGTO1100/(2.0D+00*ZETP)
                  
                  CGTO0002 = R2MAX
                  CGTO0202 = R4MAX
                  CGTO1102 =         CGTO0002 + CGTO0202/(2.0D+00*ZETP)
                  CGTO2002 =                    CGTO1102/(2.0D+00*ZETP)
                  
                  CGTO0004 = R4MAX
                  CGTO0204 = R6MAX
                  CGTO1104 =         CGTO0004 + CGTO0204/(2.0D+00*ZETP)
                  CGTO2004 =                    CGTO1104/(2.0D+00*ZETP)
                  
                  CGTO0400 = R4MAX
                  CGTO1300 = 3.0D+00*CGTO0200 + CGTO0400/(2.0D+00*ZETP)
                  CGTO2200 = 2.0D+00*CGTO1100 + CGTO1300/(2.0D+00*ZETP)
                  CGTO3100 =         CGTO2000 + CGTO2200/(2.0D+00*ZETP)
                  CGTO4000 =                    CGTO3100/(2.0D+00*ZETP)
                  
                  CGTO0402 = R6MAX
                  CGTO1302 = 3.0D+00*CGTO0202 + CGTO0402/(2.0D+00*ZETP)
                  CGTO2202 = 2.0D+00*CGTO1102 + CGTO1302/(2.0D+00*ZETP)
                  CGTO3102 =         CGTO2002 + CGTO2202/(2.0D+00*ZETP)
                  CGTO4002 =                    CGTO3102/(2.0D+00*ZETP)
                  
                  CGTO0404 = R8MAX1
                  CGTO1304 = 3.0D+00*CGTO0204 + CGTO0404/(2.0D+00*ZETP)
                  CGTO2204 = 2.0D+00*CGTO1104 + CGTO1304/(2.0D+00*ZETP)
                  CGTO3104 =         CGTO2004 + CGTO2204/(2.0D+00*ZETP)
                  CGTO4004 =                    CGTO3104/(2.0D+00*ZETP)


                  CGTO4011 =         CGTO4000 + CGTO4002/(2.0D+00*ZETQ)
                  CGTO4020 =                    CGTO4011/(2.0D+00*ZETQ)
                  
                  CGTO4013 = 3.0D+00*CGTO4002 + CGTO4004/(2.0D+00*ZETQ)
                  CGTO4022 = 2.0D+00*CGTO4011 + CGTO4013/(2.0D+00*ZETQ)
                  CGTO4031 =         CGTO4020 + CGTO4022/(2.0D+00*ZETQ)
                  CGTO4040 =                    CGTO4031/(2.0D+00*ZETQ)
                  
                  DDDDMAX1 = DDDDMAX1 + CGTO4040
Ccc   XY Type Calculation ----------------------------------------------
                  R4MAX2   = CONTPQ*LAMBDA*R2200*ROO**2
                  R6MAX2   = CONTPQ*LAMBDA*R4200*ROO**3
                  R8MAX2   = CONTPQ*LAMBDA*R4400*ROO**4
                  

                  CGTO0000 = R0MAX
                  CGTO0200 = R2MAX
                  CGTO1100 = CGTO0000 + CGTO0200/(2.0D+00*ZETP)
                  CGTO2000 =            CGTO1100/(2.0D+00*ZETP)

                  CGTO0002 = R2MAX
                  CGTO0202 = R4MAX2
                  CGTO1102 = CGTO0002 + CGTO0202/(2.0D+00*ZETP)
                  CGTO2002 =            CGTO1102/(2.0D+00*ZETP)
                  
                  CGTO0004 = R4MAX2
                  CGTO0204 = R6MAX2
                  CGTO1104 = CGTO0004 + CGTO0204/(2.0D+00*ZETP)
                  CGTO2004 =            CGTO1104/(2.0D+00*ZETP)

                  CGTO0400 = R4MAX2
                  CGTO1300 = CGTO0200 + CGTO0400/(2.0D+00*ZETP)
                  CGTO2200 =            CGTO1300/(2.0D+00*ZETP)
                  CGTO3100 = CGTO2000 + CGTO2200/(2.0D+00*ZETP)
                  CGTO4000 =            CGTO3100/(2.0D+00*ZETP)
                  
                  CGTO0202 = R4MAX
                  CGTO0402 = R6MAX2
                  CGTO1302 = CGTO0202 + CGTO0402/(2.0D+00*ZETP)
                  CGTO2202 =            CGTO1302/(2.0D+00*ZETP)
                  CGTO3102 = CGTO2002 + CGTO2202/(2.0D+00*ZETP)
                  CGTO4002 =            CGTO3102/(2.0D+00*ZETP)
                  
                  CGTO0404 = R8MAX2
                  CGTO1304 = CGTO0204 + CGTO0404/(2.0D+00*ZETP)
                  CGTO2204 =            CGTO1304/(2.0D+00*ZETP)
                  CGTO3104 = CGTO2004 + CGTO2204/(2.0D+00*ZETP)
                  CGTO4004 =            CGTO3104/(2.0D+00*ZETP)
                  

                  CGTO4011 = CGTO4000 + CGTO4002/(2.0D+00*ZETQ)
                  CGTO4020 =            CGTO4011/(2.0D+00*ZETQ)
                  
                  CGTO4013 = CGTO4002 + CGTO4004/(2.0D+00*ZETQ)
                  CGTO4022 =            CGTO4013/(2.0D+00*ZETQ)
                  CGTO4031 = CGTO4020 + CGTO4022/(2.0D+00*ZETQ)
                  CGTO4040 =            CGTO4031/(2.0D+00*ZETQ)
                  
                  DDDDMAX2 = DDDDMAX2 + CGTO4040
Ccc   ------------------------------------------------------------------
 1001          CONTINUE
 1002       CONTINUE
 1003    CONTINUE
 1004 CONTINUE
      
      IF(dabs(DDDDMAX1) .GE. dabs(DDDDMAX2))THEN
         DDDDMAX = dabs(DDDDMAX1)
      ELSE
         DDDDMAX = dabs(DDDDMAX2)
      ENDIF
      
      
      END
C## S1S2S1S2 Schwarz ===================================================
C     Calculating for Max|(s(1)s(2)|s(1)s(2))|
C
C   === INPUT ===
C  ZIJ     : Orbital exponent every shell
C  CIJ     : Contract coefficient every shell
C  NCNT    : Number of developed term every shell
C
C   === OUTPUT ===
C  RMAX    :  Max value of (ii|ii)
C
C======================================================================*
      subroutine swz_s1s2s1s2(A , B , 
     &     NFSZ ,NESZ ,FDAT ,
     &     ZA , ZB ,
     &     CA , CB ,
     &     NCNTA , NCNTB , S1S2S1S2MAX )
      
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)

      parameter (pi52 = 17.4934183276248628462d0)
      DOUBLE PRECISION  LAMBDA0,LAMBDAQ,LAMBDA

      DIMENSION ZA(NCNTA),ZB(NCNTB)
      DIMENSION CA(NCNTA),CB(NCNTB)

      DIMENSION A(3),B(3)

      DIMENSION FDAT(NFSZ,NESZ)
      DIMENSION TF(25)
      DATA      PAI / 3.14159265358979323846D+00 /
      DATA      (TF(I),I=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /
C
      AX  = A(1)
      AY  = A(2)
      AZ  = A(3)
      BX  = B(1)
      BY  = B(2)
      BZ  = B(3)
      BAX = BX - AX
      BAY = BY - AY
      BAZ = BZ - AZ
      
      ABXYZ = BAX*BAX + BAY*BAY + BAZ*BAZ
      S1S2S1S2MAX = 0.0D+00
      
      LAMBDA0 = 2.0D+00*PI52
      
      DO 1004 L = 1,NCNTB
         DO 1003 K = 1,NCNTA
            ZETQ = ZA(K) + ZB(L)
            ROOQ = ZA(K)*ZB(L)/ZETQ
            QEXP = DEXP(-ROOQ*ABXYZ)
            LAMBDAQ = LAMBDA0/ZETQ
            CONTQ   = CA(K)*CB(L)

            QX = (ZA(K)*AX + ZB(L)*BX)/ZETQ
            QY = (ZA(K)*AY + ZB(L)*BY)/ZETQ
            QZ = (ZA(K)*AZ + ZB(L)*BZ)/ZETQ
            DO 1002 J = 1,NCNTB
               DO 1001 I = 1,NCNTA
                  ZETP = ZA(I) + ZB(J)
                  ZPQ  = ZETP  + ZETQ
                  ROOP = ZA(I)*ZB(J)/ZETP
                  PEXP = DEXP(-ROOP*ABXYZ)
                  LAMBDA = LAMBDAQ/(ZETP*DSQRT(ZETP+ZETQ))
                  CONTPQ = CONTQ*CA(I)*CB(J)

                  PX = (ZA(I)*AX + ZB(J)*BX)/ZETP
                  PY = (ZA(I)*AY + ZB(J)*BY)/ZETP
                  PZ = (ZA(I)*AZ + ZB(J)*BZ)/ZETP

                  ROO  = ZETP*ZETQ/ZPQ
                  T    = ROO*((PX-QX)**2+(PY-QY)**2+(PZ-QZ)**2)

                  IF (T. LE .TF(1)) THEN
C     
                     IT = IDINT((T+0.0251D+00)*20.0D+00)
                     DT = 0.05D+00*IT - T
                     IT = IT + 1
                     DT4 = DT*0.25D+00
                     DT5 = DT*0.2D+00
                     DT6 = DT*0.166666666666666667D+00
                     DT2 = DT4 + DT4
                     DT3 = DT6 + DT6
                     F0  = (((((FDAT(7,IT)*DT6   + FDAT(6,IT))*DT5
     &                        + FDAT(5,IT))*DT4  + FDAT(4,IT))*DT3
     &                        + FDAT(3,IT))*DT2  + FDAT(2,IT))*DT
     &                        + FDAT(1,IT)
C     
                  ELSE
                     TINV = 1.0D+00/T
                     F0   = DSQRT(PAI*TINV)*0.5D+00
                  END IF

                  SSSS0 = CONTPQ*PEXP*QEXP*LAMBDA*F0

                  S1S2S1S2MAX = S1S2S1S2MAX + SSSS0
 1001          CONTINUE
 1002       CONTINUE
 1003    CONTINUE
 1004 CONTINUE

      s1s2s1s2max = dabs(s1s2s1s2max)

      END

C## PSPS Schwarz ======================================================
C     Calculating for Max|(p(1)s(2)|p(1)s(2))| type for Obara-Saika Method
C
C   === INPUT ===
C  ZIJ     : Orbital exponent every shell
C  CIJ     : Contract coefficient every shell
C  NCNT    : Number of developed term every shell
C
C   === OUTPUT ===
C  RMAX    :  Max value of (ij|ij)
C
C======================================================================*
      subroutine swz_psps_obara(A , B , 
     &     NFSZ  ,NESZ ,FDAT , EDAT ,
     &     ZA    , ZB  ,
     &     CA    , CB  ,
     &     NCNTA , NCNTB , PSPSMAX )
      
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)

      parameter (pi52 = 17.4934183276248628462d0)
      DOUBLE PRECISION  LAMBDA0,LAMBDAQ,LAMBDA

      DIMENSION ZA(NCNTA),ZB(NCNTB)
      DIMENSION CA(NCNTA),CB(NCNTB)

      DIMENSION A(3),B(3)

      DIMENSION FDAT(NFSZ,NESZ)
      DIMENSION EDAT(NESZ)
      DIMENSION TF(25),RMINV(10)
      DATA      PAI / 3.14159265358979323846D+00 /
      DATA      (TF(I),I=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /
C
      DATA      (RMINV(I),I=1,10) /
     &   1.0D+00,  0.333333333333333333D+00,  0.20D+00,
     &   0.14285714285714286D+00,  0.11111111111111111D+00 ,
     &   0.90909090909090909D-01,  0.76923076923076923D-01 ,
     &   0.66666666666666666D-01,  0.58823529411764705D-01 ,
     &   0.52631578947368421D-01 /
C     
      DATA  GA0   / 1.0D+00 /
      DATA  GA1   / 1.000 000 000 000 005 298D+00 /
      DATA  GA2   / 0.5D+00 /
      DATA  GA3   / 0.166 666 666 598 849 826D+00 /
      DATA  GA4   / 0.416 666 666 666 666 667D-01 /
      DATA  GA5   / 0.833 355 034 722 222 222D-02 /
      DATA  GA6   / 0.138 888 888 888 888 889D-02 /
      
      PSPSMAX = 0.0D+00
      
      LAMBDA0 = 2.0D+00*PI52
      
      AX  = A(1)
      AY  = A(2)
      AZ  = A(3)
      BX  = B(1)
      BY  = B(2)
      BZ  = B(3)
      BAX = BX - AX
      BAY = BY - AY
      BAZ = BZ - AZ
      
      ABXYZ = BAX*BAX + BAY*BAY + BAZ*BAZ

      do 8001 MAOPQ = 1,3
         
         PSPSMAX1 = 0.0D+00
         
      DO 1004 L = 1,NCNTB
         DO 1003 K = 1,NCNTA
            ZETQ = ZA(K) + ZB(L)
            ROOQ = ZA(K)*ZB(L)/ZETQ
            QEXP = DEXP(-ROOQ*ABXYZ)
            LAMBDAQ = LAMBDA0/ZETQ
            CONTQ   = CA(K)*CB(L)

            QX = (ZA(K)*AX + ZB(L)*BX)/ZETQ
            QY = (ZA(K)*AY + ZB(L)*BY)/ZETQ
            QZ = (ZA(K)*AZ + ZB(L)*BZ)/ZETQ
            DO 1002 J = 1,NCNTB
               DO 1001 I = 1,NCNTA
                  ZETP = ZA(I) + ZB(J)
                  ZPQ  = ZETP  + ZETQ
                  ROOP = ZA(I)*ZB(J)/ZETP
                  PEXP = DEXP(-ROOP*ABXYZ)
                  LAMBDA = LAMBDAQ/(ZETP*DSQRT(ZPQ))
                  CONTPQ = CONTQ*CA(I)*CB(J)

                  PX = (ZA(I)*AX + ZB(J)*BX)/ZETP
                  PY = (ZA(I)*AY + ZB(J)*BY)/ZETP
                  PZ = (ZA(I)*AZ + ZB(J)*BZ)/ZETP
                  
                  WX = (ZETP*PX + ZETQ*QX)/ZPQ
                  WY = (ZETP*PY + ZETQ*QY)/ZPQ
                  WZ = (ZETP*PZ + ZETQ*QZ)/ZPQ

                  ROO  = ZETP*ZETQ/ZPQ
                  T    = ROO*((PX-QX)**2+(PY-QY)**2+(PZ-QZ)**2)
                  
                  IF (T. LE .TF(3)) THEN
C     
                     IT = IDINT((T+0.0251D+00)*20.0D+00)
                     DT = 0.05D+00*IT - T
                     IT = IT + 1
                     DT4 = DT*0.25D+00
                     DT5 = DT*0.2D+00
                     DT6 = DT*0.166666666666666667D+00
                     DT2 = DT4 + DT4
                     DT3 = DT6 + DT6
                     F2  = (((((FDAT(9,IT)*DT6   + FDAT(8,IT))*DT5
     &                    + FDAT(7,IT))*DT4  + FDAT(6,IT))*DT3
     &                    + FDAT(5,IT))*DT2  + FDAT(4,IT))*DT
     &                    + FDAT(3,IT)
C     
                     EED  = (((((GA6*DT + GA5)*DT + GA4)*DT
     &                    + GA3)*DT + GA2)*DT + GA1)*DT + GA0
                     EE   = EDAT(IT)*EED
                     T2   = 2.0D+00*T

                     F1   = (T2*F2 + EE)*RMINV(2)
                     F0   = T2*F1 + EE
                  ELSE
                     TINV = 1.0D+00/T
                     F0   = DSQRT(PAI*TINV)*0.5D+00
                     F1   = 0.5D+00*F0*TINV
                     F2   = 1.5D+00*F1*TINV
                  END IF
C     
                  IF(    MAOPQ .EQ. 1)THEN
                     PA = PX - AX
                     QC = QX - AX
                     WP = WX - PX
                     WQ = WX - QX
                  ELSEIF(MAOPQ .EQ. 2)THEN
                     PA = PY - AY
                     QC = QY - AY
                     WP = WY - PY
                     WQ = WY - QY
                  ELSEIF(MAOPQ .EQ. 3)THEN
                     PA = PZ - AZ
                     QC = QZ - AZ
                     WP = WZ - PZ
                     WQ = WZ - QZ
                  ELSE
                     write(*,*)MAOPQ
                     write(*,*)"Input Error !!"
                     STOP
                  ENDIF
                  
                  SSSS0 = CONTPQ*PEXP*QEXP*LAMBDA*F0
                  SSSS1 = CONTPQ*PEXP*QEXP*LAMBDA*F1
                  SSSS2 = CONTPQ*PEXP*QEXP*LAMBDA*F2

                  PSSS0 = PA*SSSS0 + WP*SSSS1
                  PSSS1 = PA*SSSS1 + WP*SSSS2

                  PSPS0 = QC*PSSS0 + WQ*PSSS1
     &                 + SSSS1/(2.0D+00*ZPQ)

                  PSPSMAX1 = PSPSMAX1 + PSPS0
 1001          CONTINUE
 1002       CONTINUE
 1003    CONTINUE
 1004 CONTINUE

      IF(PSPSMAX .LE. dabs(PSPSMAX1))THEN
         PSPSMAX = dabs(PSPSMAX1)
      ENDIF

 8001 continue

      END

C## P1P2P1P2 Schwarz ======================================================
C     Calculating for Max|(p(1)p(2)|p(1)p(2))| for Obara-Saika theory
C
C   === INPUT ===
C  ZIJ     : Orbital exponent every shell
C  CIJ     : Contract coefficient every shell
C  NCNT    : Number of developed term every shell
C
C   === OUTPUT ===
C  RMAX    :  Max value of (ii|jj)
C
C======================================================================*
      subroutine swz_p1p2p1p2_obara(A , B , 
     &     NFSZ ,NESZ  ,FDAT , EDAT ,
     &     ZA   , ZB   ,
     &     CA   , CB   ,
     &     NCNTA , NCNTB , P1P2P1P2MAX )
      
      IMPLICIT DOUBLE PRECISION  (A-H,O-Z)

      parameter (pi52 = 17.4934183276248628462d0)

      DOUBLE PRECISION  LAMBDA,LAMBDA0,LAMBDAQ

      DIMENSION ZA(NCNTA),ZB(NCNTB)
      DIMENSION CA(NCNTA),CB(NCNTB)

      DIMENSION A(3),B(3)

      DIMENSION FDAT(NFSZ,NESZ)
      DIMENSION EDAT(NESZ)
      DIMENSION TF(25),RMINV(10)
      DATA      PAI / 3.14159265358979323846D+00 /
      DATA      (TF(I),I=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /
C
      DATA      (RMINV(I),I=1,10) /
     &   1.0D+00,  0.333333333333333333D+00,  0.20D+00,
     &   0.14285714285714286D+00,  0.11111111111111111D+00 ,
     &   0.90909090909090909D-01,  0.76923076923076923D-01 ,
     &   0.66666666666666666D-01,  0.58823529411764705D-01 ,
     &   0.52631578947368421D-01 /
C
      DATA  GA0   / 1.0D+00 /
      DATA  GA1   / 1.000 000 000 000 005 298D+00 /
      DATA  GA2   / 0.5D+00 /
      DATA  GA3   / 0.166 666 666 598 849 826D+00 /
      DATA  GA4   / 0.416 666 666 666 666 667D-01 /
      DATA  GA5   / 0.833 355 034 722 222 222D-02 /
      DATA  GA6   / 0.138 888 888 888 888 889D-02 /

      AX  = A(1)
      AY  = A(2)
      AZ  = A(3)
      BX  = B(1)
      BY  = B(2)
      BZ  = B(3)
      BAX = BX - AX
      BAY = BY - AY
      BAZ = BZ - AZ

      ABXYZ = BAX*BAX + BAY*BAY + BAZ*BAZ

      P1P2P1P2MAX = 0.0D+00

      LAMBDA0 = 2.0D+00*PI52

      do 8002 MAOB = 1,3
         do 8001 MAOA = 1,3
            P1P2P1P2MAX0 = 0.0D+00

      IF(    MAOA .EQ. MAOB)THEN
      P1P2P1P2MAX0 = 0.0D+00
      DO 1004 L = 1,NCNTB
         DO 1003 K = 1,NCNTA
            ZETQ = ZA(K) + ZB(L)
            ROOQ = ZA(K)*ZB(L)/ZETQ
            QEXP = DEXP(-ROOQ*ABXYZ)
            LAMBDAQ = LAMBDA0/ZETQ
            CONTQ   = CA(K)*CB(L)

            QX = (ZA(K)*AX + ZB(L)*BX)/ZETQ
            QY = (ZA(K)*AY + ZB(L)*BY)/ZETQ
            QZ = (ZA(K)*AZ + ZB(L)*BZ)/ZETQ
            DO 1002 J = 1,NCNTB
               DO 1001 I = 1,NCNTA
                  ZETP = ZA(I) + ZB(J)
                  ZPQ  = ZETP  + ZETQ
                  ROOP = ZA(I)*ZB(J)/ZETP
                  PEXP = DEXP(-ROOP*ABXYZ)
                  LAMBDA = LAMBDAQ/(ZETP*DSQRT(ZPQ))
                  CONTPQ = CONTQ*CA(I)*CB(J)

                  PX = (ZA(I)*AX + ZB(J)*BX)/ZETP
                  PY = (ZA(I)*AY + ZB(J)*BY)/ZETP
                  PZ = (ZA(I)*AZ + ZB(J)*BZ)/ZETP
                  
                  WX = (ZETP*PX + ZETQ*QX)/ZPQ
                  WY = (ZETP*PY + ZETQ*QY)/ZPQ
                  WZ = (ZETP*PZ + ZETQ*QZ)/ZPQ

                  ROO  = ZETP*ZETQ/ZPQ
                  T    = ROO*((PX-QX)**2+(PY-QY)**2+(PZ-QZ)**2)

                  IF (T. LE .TF(5)) THEN
C     
                     IT = IDINT((T+0.025D+00)*20.0D+00)
                     DT = 0.05D+00*IT - T
                     IT = IT + 1
                     DT4 = DT*0.25D+00
                     DT5 = DT*0.2D+00
                     DT6 = DT*0.166666666666666667D+00
                     DT2 = DT4 + DT4
                     DT3 = DT6 + DT6
                     F4  = (((((FDAT(11,IT)*DT6   + FDAT(10,IT))*DT5
     &                    + FDAT(9,IT))*DT4  + FDAT(8,IT))*DT3
     &                    + FDAT(7,IT))*DT2  + FDAT(6,IT))*DT
     &                    + FDAT(5,IT)
C     
                     EED  = (((((GA6*DT + GA5)*DT + GA4)*DT
     &                    + GA3)*DT + GA2)*DT + GA1)*DT + GA0
                     EE   = EDAT(IT)*EED
                     T2   = 2.0D+00*T

                     F3   = (T2*F4 + EE)*RMINV(4)
                     F2   = (T2*F3 + EE)*RMINV(3)
                     F1   = (T2*F2 + EE)*RMINV(2)
                     F0   = T2*F1 + EE
                  ELSE
                     TINV = 1.0D+00/T
                     F0   = DSQRT(PAI*TINV)*0.5D+00
                     F1   = 0.5D+00*F0*TINV
                     F2   = 1.5D+00*F1*TINV
                     F3   = 2.5D+00*F2*TINV
                     F4   = 3.5D+00*F3*TINV
                  END IF
C     

                  IF(    MAOA .EQ. 1)THEN
                     PA = PX - AX
                     PB = PX - BX
                     QC = QX - AX
                     QD = QX - BX
                     WP = WX - PX
                     WQ = WX - QX
                  ELSEIF(MAOA .EQ. 2)THEN
                     PA = PY - AY
                     PB = PY - BY
                     QC = QY - AY
                     QD = QY - BY
                     WP = WY - PY
                     WQ = WY - QY
                  ELSEIF(MAOA .EQ. 3)THEN
                     PA = PZ - AZ
                     PB = PZ - BZ
                     QC = QZ - AZ
                     QD = QZ - BZ
                     WP = WZ - PZ
                     WQ = WZ - QZ
                  ELSE
                     write(*,*)MAOA
                     write(*,*)"Input Error !!"
                     STOP
                  ENDIF

                  SSSS0 = CONTPQ*PEXP*QEXP*LAMBDA*F0
                  SSSS1 = CONTPQ*PEXP*QEXP*LAMBDA*F1
                  SSSS2 = CONTPQ*PEXP*QEXP*LAMBDA*F2
                  SSSS3 = CONTPQ*PEXP*QEXP*LAMBDA*F3
                  SSSS4 = CONTPQ*PEXP*QEXP*LAMBDA*F4

                  PSSS0 = PA*SSSS0 + WP*SSSS1
                  PSSS1 = PA*SSSS1 + WP*SSSS2
                  PSSS2 = PA*SSSS2 + WP*SSSS3
                  PSSS3 = PA*SSSS3 + WP*SSSS2

                  SPSS1 = PB*SSSS1 + WP*SSSS2
                  SPSS2 = PB*SSSS2 + WP*SSSS3

                  PPSS0 = PB*PSSS0 + WP*PSSS1
     &                 + (SSSS0 - ROO/ZETP*SSSS1)/(2.0D+00*ZETP)
                  PPSS1 = PB*PSSS1 + WP*PSSS2
     &                 + (SSSS1 - ROO/ZETP*SSSS2)/(2.0D+00*ZETP)
                  PPSS2 = PB*PSSS2 + WP*PSSS3
     &                 + (SSSS2 - ROO/ZETP*SSSS3)/(2.0D+00*ZETP)

                  PSPS1 = QC*PSSS1 + WQ*PSSS2 
     &                 + SSSS2/(2.0D+00*ZPQ)

                  SPPS1 = PSPS1

                  PPPS0 = QC*PPSS0 + WQ*PPSS1
     &                 + (SPSS1 + PSSS1)/(2.0D+00*ZPQ)
                  PPPS1 = QC*PPSS1 + WQ*PPSS2
     &                 + (SPSS2 + PSSS2)/(2.0D+00*ZPQ)

                  PPPP0 = QD*PPPS0 + WQ*PPPS1
     &                 + (SPPS1 + PSPS1)/(2.0D+00*ZPQ)
     &                 + (PPSS0 - ROO/ZETQ*PPSS1)/(2.0D+00*ZETQ)
                  
                  P1P2P1P2MAX0 = P1P2P1P2MAX0 + PPPP0
 1001          CONTINUE
 1002       CONTINUE
 1003    CONTINUE
 1004 CONTINUE

      ELSE
         
      P1P2P1P2MAX0 = 0.0D+00
      DO 2004 L = 1,NCNTB
         DO 2003 K = 1,NCNTA
            ZETQ = ZA(K) + ZB(L)
            ROOQ = ZA(K)*ZB(L)/ZETQ
            QEXP = DEXP(-ROOQ*ABXYZ)
            LAMBDAQ = LAMBDA0/ZETQ
            CONTQ   = CA(K)*CB(L)

            QX = (ZA(K)*AX + ZB(L)*BX)/ZETQ
            QY = (ZA(K)*AY + ZB(L)*BY)/ZETQ
            QZ = (ZA(K)*AZ + ZB(L)*BZ)/ZETQ
            DO 2002 J = 1,NCNTB
               DO 2001 I = 1,NCNTA
                  ZETP = ZA(I) + ZB(J)
                  ZPQ  = ZETP  + ZETQ
                  ROOP = ZA(I)*ZB(J)/ZETP
                  PEXP = DEXP(-ROOP*ABXYZ)
                  LAMBDA = LAMBDAQ/(ZETP*DSQRT(ZPQ))
                  CONTPQ = CONTQ*CA(I)*CB(J)

                  PX = (ZA(I)*AX + ZB(J)*BX)/ZETP
                  PY = (ZA(I)*AY + ZB(J)*BY)/ZETP
                  PZ = (ZA(I)*AZ + ZB(J)*BZ)/ZETP
                  
                  WX = (ZETP*PX + ZETQ*QX)/ZPQ
                  WY = (ZETP*PY + ZETQ*QY)/ZPQ
                  WZ = (ZETP*PZ + ZETQ*QZ)/ZPQ

                  ROO  = ZETP*ZETQ/ZPQ
                  T    = ROO*((PX-QX)**2+(PY-QY)**2+(PZ-QZ)**2)
                  IF (T. LE .TF(4)) THEN
C     
                     IT = IDINT((T+0.025D+00)*20.0D+00)
                     DT = 0.05D+00*IT - T
                     IT = IT + 1
                     DT4 = DT*0.25D+00
                     DT5 = DT*0.2D+00
                     DT6 = DT*0.166666666666666667D+00
                     DT2 = DT4 + DT4
                     DT3 = DT6 + DT6
                     F4  = (((((FDAT(11,IT)*DT6   + FDAT(10,IT))*DT5
     &                    + FDAT(9,IT))*DT4  + FDAT(8,IT))*DT3
     &                    + FDAT(7,IT))*DT2  + FDAT(6,IT))*DT
     &                    + FDAT(5,IT)
C     
                     EED  = (((((GA6*DT + GA5)*DT + GA4)*DT
     &                    + GA3)*DT + GA2)*DT + GA1)*DT + GA0
                     EE   = EDAT(IT)*EED
                     T2   = 2.0D+00*T

                     F3   = (T2*F4 + EE)*RMINV(4)
                     F2   = (T2*F3 + EE)*RMINV(3)
                     F1   = (T2*F2 + EE)*RMINV(2)
                     F0   = T2*F1 + EE
                  ELSE
                     TINV = 1.0D+00/T
                     F0   = DSQRT(PAI*TINV)*0.5D+00
                     F1   = 0.5D+00*F0*TINV
                     F2   = 1.5D+00*F1*TINV
                     F3   = 2.5D+00*F2*TINV
                     F4   = 3.5D+00*F3*TINV
                  END IF
C     
                  IF(    MAOA .EQ. 1)THEN
                     PA  = PX - AX
                     QC  = QX - AX
                     WPN = WX - PX
                     WQN = WX - QX
                     IF(MAOB .EQ. 2)THEN
                        PB  = PY - BY
                        QD  = QY - BY
                        WPM = WY - PY
                        WQM = WY - QY
                     ELSE
                        PB  = PZ - BZ
                        QD  = QZ - BZ
                        WPM = WZ - PZ
                        WQM = WZ - QZ
                     ENDIF
                  ELSEIF(MAOA .EQ. 2)THEN
                     PA  = PY - AY
                     QC  = QY - AY
                     WPN = WY - PY
                     WQN = WY - QY
                     IF(MAOB .EQ. 1)THEN
                        PB  = PX - BX
                        QD  = QX - BX
                        WPM = WX - PX
                        WQM = WX - QX
                     ELSE
                        PB  = PZ - BZ
                        QD  = QZ - BZ
                        WPM = WZ - PZ
                        WQM = WZ - QZ
                     ENDIF
                  ELSEIF(MAOA .EQ. 3)THEN
                     PA  = PZ - AZ
                     QC  = QZ - AZ
                     WPN = WZ - PZ
                     WQN = WZ - QZ
                     IF(MAOB .EQ. 1)THEN
                        PB  = PX - BX
                        QD  = QX - BX
                        WPM = WX - PX
                        WQM = WX - QX
                     ELSE
                        PB  = PY - BY
                        QD  = QY - BY
                        WPM = WY - PY
                        WQM = WY - QY
                     ENDIF
                  ELSE
                     WRITE(*,*)"Input Error in SCHWARZ_P1P2"
                     STOP
                  ENDIF

                  SSSS0 = CONTPQ*PEXP*QEXP*LAMBDA*F0
                  SSSS1 = CONTPQ*PEXP*QEXP*LAMBDA*F1
                  SSSS2 = CONTPQ*PEXP*QEXP*LAMBDA*F2
                  SSSS3 = CONTPQ*PEXP*QEXP*LAMBDA*F3
                  SSSS4 = CONTPQ*PEXP*QEXP*LAMBDA*F4

                  PSSS0 = PA*SSSS0 + WPN*SSSS1
                  PSSS1 = PA*SSSS1 + WPN*SSSS2
                  PSSS2 = PA*SSSS2 + WPN*SSSS3
                  PSSS3 = PA*SSSS3 + WPN*SSSS4

                  SPSS1 = PB*SSSS1 + WPM*SSSS2
                  SPSS2 = PB*SSSS2 + WPM*SSSS3

                  PPSS0 = PB*PSSS0 + WPM*PSSS1
                  PPSS1 = PB*PSSS1 + WPM*PSSS2
                  PPSS2 = PB*PSSS2 + WPM*PSSS3

                  PSPS1 = QC*PSSS1 + WQN*PSSS2
     &                 + SSSS2/(2.0D+00*ZPQ)

                  PPPS0 = QC*PPSS0 + WQN*PPSS1
     &                 + SPSS1/(2.0D+00*ZPQ)
                  PPPS1 = QC*PPSS1 + WQN*PPSS2
     &                 + SPSS2/(2.0D+00*ZPQ)

                  PPPP0 = QD*PPPS0 + WQM*PPPS1
     &                 + PSPS1/(2.0D+00*ZPQ)

                  P1P2P1P2MAX0 = P1P2P1P2MAX0 + PPPP0
 2001          CONTINUE
 2002       CONTINUE
 2003    CONTINUE
 2004 CONTINUE
      ENDIF
      
      IF(P1P2P1P2MAX .LE. dabs(P1P2P1P2MAX0))THEN
         P1P2P1P2MAX = dabs(P1P2P1P2MAX0)
      ENDIF

 8001 continue
 8002 continue

      
      RETURN
      END
!## swz_rsrs ========================================================
!   calculate (rs|rs)shell type eri for schwarz's inequality
! 
!======================================================================*
      subroutine swz_rsrs(
     &           swzrs  ,
     &           zz     , cc     , 
     &           xyz    ,
     &           fdat   , edat   ,
     &           ntprm  , ntshty ,
     &           nsh2ssh, nsh2asp, nsh2atm,
     &           mik    ,
     &           nfsz   , nesz   ,
     &           ir_s   , ir_e   , is_s   , is_e,
     &           natom  , mxsa   , mxprm  , nao , nasp, nshell,
     &           ierr      )

      implicit double precision  (a-h,o-z)

      dimension ntshty(mxsa,nasp),ntprm(mxsa,nasp)
      dimension zz(mxprm,mxsa,nasp),cc(mxprm,mxsa,nasp)
      dimension fdat(nfsz,nesz),edat(nesz)
      dimension nsh2ssh(nshell),nsh2asp(nshell)
      dimension nsh2atm(nshell)

      dimension xyz(3,natom)

      dimension swzrs(ir_s:ir_e,is_s:is_e)

      real(8),allocatable :: ea(:),eb(:)
      integer,allocatable :: iswz(:)

      allocate (iswz(mik))

      iswz = 0
      do i = ir_s,ir_e
         do j = is_s,is_e
!           if (i.lt.j) cycle
            xyxymax = 0.0d+00

            swzrs(i,j) = 0.0d+00

      ish  = nsh2ssh(i)
      jsh  = nsh2ssh(j)
      iasp = nsh2asp(i)
      jasp = nsh2asp(j)

      ipri = ntprm(ish,iasp)
      jpri = ntprm(jsh,jasp)
  
      ian = ntshty(ish,iasp)
      jan = ntshty(jsh,jasp)
      iatom = nsh2atm(i)
      jatom = nsh2atm(j)


      if((ian.eq.1).and.(jan.eq.1)) then

         call swz_s1s2s1s2(
     &        xyz(1,iatom) , xyz(1,jatom) ,
     &        nfsz , nesz , fdat ,
     &        zz(1,ish,iasp)       , zz(1,jsh,jasp)         ,
     &        cc(1,ish,iasp) , cc(1,jsh,jasp) ,
     &        ipri , jpri , s1s2max               )

         swzrs(i,j) = s1s2max
         cycle
         
      elseif ((ian.eq.1).and.(jan.eq.2)) then

         call swz_psps_obara(
     &        xyz(1,jatom) , xyz(1,iatom) ,
     &        nfsz , nesz , fdat , edat ,
     &        zz(1,jsh,jasp)         , zz(1,ish,iasp)         ,
     &        cc(1,jsh,jasp) , cc(1,ish,iasp) ,
     &        jpri , ipri , pspsmax )

         swzrs(i,j) = pspsmax
         cycle

         
      elseif ((ian.eq.2).and.(jan.eq.1)) then

         call swz_psps_obara(
     &        xyz(1,iatom) , xyz(1,jatom) ,
     &        nfsz , nesz , fdat , edat ,
     &        zz(1,ish,iasp)         , zz(1,jsh,jasp)         ,
     &        cc(1,ish,iasp) , cc(1,jsh,jasp) ,
     &        ipri , jpri , pspsmax )

         swzrs(i,j) = pspsmax
         cycle

         
      elseif ((ian.eq.2).and.(jan.eq.2)) then

         call swz_p1p2p1p2_obara(
     &        xyz(1,iatom) , xyz(1,jatom) ,
     &        nfsz , nesz , fdat , edat ,
     &        zz(1,ish,iasp)         , zz(1,jsh,jasp)         ,
     &        cc(1,ish,iasp) , cc(1,jsh,jasp) ,
     &        ipri , jpri , p1p2p1p2max )

         swzrs(i,j) = p1p2p1p2max
         cycle

      else
      endif

      ijan = ian*(ian+1) * jan*(jan+1)  / 4
      mvhgp =  ijan **2

      kflag = 0
      if (ian.lt.jan) then
         kflag = 1
         call iswap(ian,jan)
      endif

      maxcod = max(ian,jan)
      na = maxcod**4

      lflag1 = 0
      lflag2 = 0

      call ivrrgr (ian    , jan, ian, jan,
     &             iswz(1), na , nv ,
     &             ir     , lflag1  , lflag2     )
 
      nbfsz = 2*na + 4 * maxcod * (maxcod+1)*maxcod/2
      i01 = 1
      i02 = i01 + 10*na
      i03 = i02 + nbfsz
      i04 = i03 + 3*nv

      call ivrrgt (iswz(i01), na    , iswz(i03), nv   , iswz(i02),nbfsz,
     &             ir      , maxcod, issss   , ninto, nv2       )

      iv  = nv
      j01 =  1
      j02 =  ninto + 1
      j03 =  j02 + mvhgp
      iang = 2*(ian +jan) - 4

      allocate(ea(ninto),eb(mvhgp))

      if (kflag.eq.0) then
      call istos (
     &          fdat, edat ,
     &          zz(1,ish,iasp)         , zz(1,jsh,jasp)       ,
     &          cc(1,ish,iasp) , cc(1,jsh,jasp) ,
     &          xyz(1,iatom) , xyz(1,jatom) ,
     &          ipri, jpri,
     &          iswz(i03),nv,iv,nv2,iang,
     &          issss,ninto,mvhgp,ea,eb     )

      else
      call istos (
     &          fdat, edat ,
     &          zz(1,jsh,jasp)         ,zz(1,ish,iasp)         , 
     &          cc(1,jsh,jasp) ,cc(1,ish,iasp)   ,
     &          xyz(1,jatom)             ,xyz(1,iatom)         , 
     &          jpri                     ,ipri                 , 
     &          iswz(i03),nv,iv,nv2,iang,
     &          issss,ninto,mvhgp,ea,eb          )

      endif

      call itsortao (ian,jan,ian,jan,mvhgp,eb )
 
!     call iset_ijij ( eb,mvhgp,xijij )

      xijij = 0.d0
      do im = 1,mvhgp
         xxxx = eb(im)
         if (dabs(xxxx).gt.xijij) xijij = dabs(xxxx)
      enddo

         swzrs(i,j) = xijij

         deallocate(ea,eb)

         enddo
      enddo

      deallocate(iswz)

      return
      end
!## swz_rsrs12 ========================================================
!   calculate (rs|rs)shell type eri for schwarz's inequality
! 
!======================================================================*
      subroutine swz_rsrs12(
     &           swzrs  ,
     &           zz     , cc     , 
     &           xyz    ,
     &           fdat   , edat   ,
     &           ntprm  , ntshty ,
     &           nsh2ssh, nsh2asp, nsh2atm,
     &           mik    ,
     &           nfsz   , nesz   ,
     &           ir_s   , ir_e   , is_s   , is_e,
     &           natom  , mxsa   , mxprm  , nao , nasp, nshell,
     &           myrank  , nproc , 
     &           ierr      )

      implicit double precision  (a-h,o-z)

      dimension ntshty(mxsa,nasp),ntprm(mxsa,nasp)
      dimension zz(mxprm,mxsa,nasp),cc(mxprm,mxsa,nasp)
      dimension fdat(nfsz,nesz),edat(nesz)
      dimension nsh2ssh(nshell),nsh2asp(nshell)
      dimension nsh2atm(nshell)

      dimension xyz(3,natom)

      dimension swzrs(ir_s:ir_e,is_s:is_e)

      real(8),allocatable :: ea(:),eb(:)
      integer,allocatable :: iswz(:)

      logical ipart
      icount  = -1

      allocate (iswz(mik))

c$$$      write(6,*) 'ir_s:ir_e,is_s:is_e=',ir_s,ir_e,is_s,is_e
c$$$      write(6,*) zz
c$$$      write(6,*) cc
c$$$      write(6,*) xyz
c$$$      write(6,*) ntprm
c$$$      write(6,*) ntshty
c$$$      write(6,*) nsh2ssh
c$$$      write(6,*) nsh2asp
c$$$      write(6,*) nsh2atm
c$$$      write(6,*) mik
c$$$      write(6,*) natom  , mxsa   , mxprm  , nao , nasp, nshell

      iswz = 0
      do i = ir_s,ir_e
         do j = is_s,is_e
            if (i.lt.j) cycle
            icount = icount + 1
            ipart = icount.ne.myrank
            if (icount == nproc - 1 ) icount = -1
            if (ipart) cycle
            xyxymax = 0.0d+00

            swzrs(i,j) = 0.0d+00

      ish  = nsh2ssh(i)
      jsh  = nsh2ssh(j)
      iasp = nsh2asp(i)
      jasp = nsh2asp(j)

      ipri = ntprm(ish,iasp)
      jpri = ntprm(jsh,jasp)
  
      ian = ntshty(ish,iasp)
      jan = ntshty(jsh,jasp)
      iatom = nsh2atm(i)
      jatom = nsh2atm(j)


      if((ian.eq.1).and.(jan.eq.1)) then

         call swz_s1s2s1s2(
     &        xyz(1,iatom) , xyz(1,jatom) ,
     &        nfsz , nesz , fdat ,
     &        zz(1,ish,iasp)       , zz(1,jsh,jasp)         ,
     &        cc(1,ish,iasp) , cc(1,jsh,jasp) ,
     &        ipri , jpri , s1s2max               )

         swzrs(i,j) = s1s2max
         cycle
         
      elseif ((ian.eq.1).and.(jan.eq.2)) then

         call swz_psps_obara(
     &        xyz(1,jatom) , xyz(1,iatom) ,
     &        nfsz , nesz , fdat , edat ,
     &        zz(1,jsh,jasp)         , zz(1,ish,iasp)         ,
     &        cc(1,jsh,jasp) , cc(1,ish,iasp) ,
     &        jpri , ipri , pspsmax )

         swzrs(i,j) = pspsmax
         cycle

         
      elseif ((ian.eq.2).and.(jan.eq.1)) then

         call swz_psps_obara(
     &        xyz(1,iatom) , xyz(1,jatom) ,
     &        nfsz , nesz , fdat , edat ,
     &        zz(1,ish,iasp)         , zz(1,jsh,jasp)         ,
     &        cc(1,ish,iasp) , cc(1,jsh,jasp) ,
     &        ipri , jpri , pspsmax )

         swzrs(i,j) = pspsmax
         cycle

         
      elseif ((ian.eq.2).and.(jan.eq.2)) then

         call swz_p1p2p1p2_obara(
     &        xyz(1,iatom) , xyz(1,jatom) ,
     &        nfsz , nesz , fdat , edat ,
     &        zz(1,ish,iasp)         , zz(1,jsh,jasp)         ,
     &        cc(1,ish,iasp) , cc(1,jsh,jasp) ,
     &        ipri , jpri , p1p2p1p2max )

         swzrs(i,j) = p1p2p1p2max
         cycle

      else
      endif

      ijan = ian*(ian+1) * jan*(jan+1)  / 4
      mvhgp =  ijan **2

      kflag = 0
      if (ian.lt.jan) then
         kflag = 1
         call iswap(ian,jan)
      endif

      maxcod = max(ian,jan)
      na = maxcod**4

      lflag1 = 0
      lflag2 = 0

      call ivrrgr (ian    , jan, ian, jan,
     &             iswz(1), na , nv ,
     &             ir     , lflag1  , lflag2     )
 
      nbfsz = 2*na + 4 * maxcod * (maxcod+1)*maxcod/2
      i01 = 1
      i02 = i01 + 10*na
      i03 = i02 + nbfsz
      i04 = i03 + 3*nv

      call ivrrgt (iswz(i01), na    , iswz(i03), nv   , iswz(i02),nbfsz,
     &             ir      , maxcod, issss   , ninto, nv2       )

      iv  = nv
      j01 =  1
      j02 =  ninto + 1
      j03 =  j02 + mvhgp
      iang = 2*(ian +jan) - 4

      allocate(ea(ninto),eb(mvhgp))

      if (kflag.eq.0) then
      call istos (
     &          fdat, edat ,
     &          zz(1,ish,iasp)         , zz(1,jsh,jasp)       ,
     &          cc(1,ish,iasp) , cc(1,jsh,jasp) ,
     &          xyz(1,iatom) , xyz(1,jatom) ,
     &          ipri, jpri,
     &          iswz(i03),nv,iv,nv2,iang,
     &          issss,ninto,mvhgp,ea,eb          )

      else
      call istos (
     &          fdat, edat ,
     &          zz(1,jsh,jasp)         ,zz(1,ish,iasp)         , 
     &          cc(1,jsh,jasp) ,cc(1,ish,iasp)   ,
     &          xyz(1,jatom)             ,xyz(1,iatom)         , 
     &          jpri                     ,ipri                 , 
     &          iswz(i03),nv,iv,nv2,iang,
     &          issss,ninto,mvhgp,ea,eb          )

      endif

      call itsortao (ian,jan,ian,jan,mvhgp,eb )
 
!     call iset_ijij ( eb,mvhgp,xijij )

      xijij = 0.d0
      do im = 1,mvhgp
         xxxx = eb(im)
         if (dabs(xxxx).gt.xijij) xijij = dabs(xxxx)
      enddo

         swzrs(i,j) = xijij

         deallocate(ea,eb)

         enddo
      enddo

      deallocate(iswz)

      return
      end
CC ISIJIJ =====================================================================
C  max|(ij|ij)|
C =============================================================================
      subroutine isijij ( ea , mvhgp, xijij)
    
      implicit double precision (a-h,o-z)
      dimension ea(mvhgp)
      double precision  xijij

      xijij  = 0.d0

      do i = 1,mvhgp
         xxxx = ea(i)
         if (xxxx.gt.xijij) xijij = xxxx
      enddo


      end
