! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
CC IERIFG ===========================================================
C     CALCULATION OF TWO ELECTRON INTEGRALS 
C     FOR D-ORBITAL
C====================================================================
      
      subroutine ierifg(
     &     ec    ,
     &     fdat  ,  edat  ,
     &     zz    ,  zetpq ,  xyz  ,
     &     p     ,  q     ,
     &     up    ,  uq    ,
     &     ntprm ,
     &     iasp  ,  jasp  ,  kasp ,  lasp ,
     &     ishel ,  jshel ,  kshel,  lshel,
     &     iatom ,  jatom ,  katom,  latom,
     &     nasp  ,  mxsa  ,  mxprm,  natom,
     &     mvhgp ,
     &     ierisw,  nangty )
      
      implicit double precision  (a-h,o-z)
      
      dimension fdat(31,2001),edat(2001)
      dimension xyz(3,natom)
      dimension ntprm(mxsa,nasp)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension z(mxprm,mxsa,nasp)
      dimension p(3,mxprm,mxprm),q(3,mxprm,mxprm)
      dimension up(mxprm,mxprm),uq(mxprm,mxprm)
      
      dimension ec(mvhgp)

      dimension zz(mxprm,mxsa,nasp)

      select case(nangty)
      case (22)
         call iofsss(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
      case (29)
         call iofpss(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
         
      case(56)
         call iogsss(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
      case(37)
         call iofdss(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )


      case(67)
         call iogpss(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )

         
      case(23)
         call iofsps(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )

    
      case(30)
         call iofpps(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
      case(57)
         call iogsps(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )


      case(24) 
         call iofspp(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
      case(25)
         call iofsds(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
         
      end select
      
      end
