! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
CC IERIPD ============================================================
C     CALCULATION OF TWO ELECTRON INTEGRALS 
C     FOR s,p,d-ORBITALS
C====================================================================
      
      subroutine ieripd (
     &     ec    ,
     &     fdat  ,  edat  , 
     &     zz    ,  zetpq ,  xyz   ,
     &     p     ,  q     ,
     &     up    ,  uq    ,  
     &     uep   ,  ueq   ,
     &     ntprm ,
     &     iasp  ,  jasp  ,  kasp  ,  lasp ,
     &     ishel ,  jshel ,  kshel ,  lshel,
     &     iatom ,  jatom ,  katom ,  latom,
     &     nasp  ,  mxsa  ,  mxprm ,  natom,
     &     mvhgp ,  
     &     ierisw,  nangty )
      
      implicit double precision  (a-h,o-z)
      
      dimension fdat(31,2001),edat(2001)
      dimension xyz(3,natom)
      dimension ntprm(mxsa,nasp)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension zz(mxprm,mxsa,nasp)
      dimension p(3,mxprm,mxprm),q(3,mxprm,mxprm)
      dimension up(mxprm,mxprm),uq(mxprm,mxprm)
      dimension uep(mxprm,mxprm),ueq(mxprm,mxprm)
        
      dimension psss(4)  
      dimension psps(14),ppss(15)
      dimension ppps(47)
      dimension pppp(148)
      dimension dsss(12)
      dimension dsps(39) ,dpss(38)
      dimension dspp(121),dsds(99) ,dpps(112),ddss(88)
      dimension dppp(336),dpds(284),ddps(245)

      dimension ec(mvhgp)

      select case(nangty)
      
      case(1)
         dm0 = 0
         call ikssss(
     &        dm0  , 
     &        fdat ,
     &        p    ,  q    ,
     &        up   ,  uq   ,
     &        zetpq, 
     &        nasp ,  mxsa ,  mxprm,   ntprm, 
     &        iasp ,  jasp ,  kasp ,  lasp ,
     &        ishel,  jshel,  kshel,  lshel        )

         ec(1) = dm0
      case(2)
         call ikpsss(
     &        psss ,                            
     &        fdat ,  edat , 
     &        p    ,  q    ,
     &        uep  ,  uq   ,
     &        zz   ,  zetpq,
     &        nasp ,  mxsa ,  mxprm,  ntprm,
     &        iasp ,  jasp ,  kasp , lasp ,  
     &        ishel,  jshel,  kshel, lshel               )
         
         call impsss(  
     &        ec,
     &        xyz    ,  psss  ,
     &        mvhgp  ,  natom ,
     &        iatom  ,  jatom ,  katom,  latom  )
         
      case(3)
         
         call ikpsps(
     &        psps ,
     &        fdat ,  edat , 
     &        p    ,  q    ,
     &        uep  ,  ueq  ,
     &        zz   ,  zetpq,
     &        nasp ,  mxsa ,  mxprm,   ntprm, 
     &        iasp ,  jasp ,  kasp ,  lasp ,
     &        ishel,  jshel,  kshel,  lshel        )

         call impsps(  
     &        ec,
     &        xyz    ,  psps  ,
     &        mvhgp  ,  natom ,
     &        iatom  ,  jatom ,  katom,  latom  )
         
      case(4)
         
         call ikppss(
     &        ppss ,  
     &        fdat , edat ,
     &        p    , q    ,
     &        uep  , uq   ,
     &        zz   , zetpq,
     &        nasp , mxsa , mxprm ,   ntprm, 
     &        iasp , jasp , kasp  ,  lasp ,
     &        ishel, jshel, kshel ,  lshel         )
         
         
         call imppss(  
     &        ec,
     &        xyz    ,  ppss  ,
     &        mvhgp  ,  natom ,
     &        iatom  ,  jatom ,  katom,  latom )
         
         
      case(5)
         
         call ikppps(
     &        ppps ,
     &        fdat , edat , 
     &        p    , q    ,
     &        uep  , ueq  ,
     &        zz   , zetpq, 
     &        nasp , mxsa , mxprm ,  ntprm, 
     &        iasp , jasp , kasp  , lasp ,
     &        ishel, jshel, kshel , lshel      )
         
         call imppps(  
     &        ec,
     &        xyz    ,  ppps  ,
     &        mvhgp  ,  natom ,
     &        iatom  ,  jatom ,  katom,  latom )
         
         
      case(6)
         call ikpppp(
     &        pppp ,
     &        fdat ,  edat  , 
     &        p    ,  q     ,
     &        uep  ,  ueq   ,
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,  mxprm,   ntprm,
     &        iasp ,  jasp  ,  kasp ,  lasp ,
     &        ishel,  jshel ,  kshel,  lshel           )
         
         call impppp(  
     &        ec,
     &        xyz    ,  pppp  ,
     &        mvhgp  ,  natom ,
     &        iatom  ,  jatom ,  katom,  latom )
      case (7)
         
         call ikdsss(
     &        dsss ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  uq    ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imdsss (
     &        ec   ,  
     &        xyz  ,  dsss ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
         
      case (8)
         call ikdsps(
     &        dsps ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  ueq   ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imdsps (
     &        ec   ,  
     &        xyz  ,  dsps ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
         
      case (9)
         call ikdspp(
     &        dspp ,
     &        fdat ,  edat  ,
     &        p    ,  q     ,
     &        uep  ,  ueq   ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imdspp (
     &        ec   ,  
     &        xyz  ,  dspp ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
         
      case(10)
         call ikdsds(
     &        dsds ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  ueq   ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm, 
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imdsds (
     &        ec   ,  
     &        xyz  ,  dsds ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
         
      case(11)
         call ikdpss(
     &        dpss ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  uq    ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imdpss (
     &        ec   ,  
     &        xyz  ,  dpss ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
         
      case(12)
         call ikdpps(
     &        dpps ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  ueq   ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imdpps (
     &        ec   ,  
     &        xyz  ,  dpps ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
      case(13)
         call ikdppp(
     &        dppp ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  ueq   ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imdppp (
     &        ec   ,  
     &        xyz  ,  dppp ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
         
      case(14)
         call ikdpds(
     &        dpds ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  ueq   ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imdpds (
     &        ec   ,  
     &        xyz  ,  dpds ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
         
      case(15)
         
         call iodpdp(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )

      case(16)
         call ikddss(
     &        ddss ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  uq    ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imddss (
     &        ec   ,  
     &        xyz  ,  ddss ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
         
      case(17)
         call ikddps(
     &        ddps ,
     &        fdat ,  edat  ,  
     &        p    ,  q     ,            
     &        uep  ,  ueq   ,  
     &        zz   ,  zetpq ,
     &        nasp ,  mxsa  ,   mxprm ,  ntprm,  
     &        iasp ,  jasp  ,   kasp  ,  lasp ,
     &        ishel,  jshel ,   kshel ,  lshel )
         
         call imddps (
     &        ec   ,  
     &        xyz  ,  ddps ,    
     &        mvhgp,  natom,  ierisw,
     &        iatom,  jatom,  katom ,  latom )
 
      case(18)
         call ioddpp(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
       case(19)
         call ioddds(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
      case(20)
         call iodddp(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
      case(21)
         call iodddd(
     &        ec   ,
     &        fdat ,   edat , 
     &        p    ,   q    , 
     &        up   ,   uq   , 
     &        zz   ,   zetpq,   xyz  ,
     &        nasp ,   mxsa ,   mxprm,   ntprm,   natom,
     &        iasp ,   jasp ,   kasp ,   lasp , 
     &        ishel,   jshel,   kshel,   lshel, 
     &        iatom,   jatom,   katom,   latom,
     &        ierisw     )
         
      endselect
      end
