! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
C**   ISWAP ===========================================================
C     SWAP PARAMETER    A <--> B
C====================================================================
      
      subroutine iswap(iatom,jatom)
      
      implicit none
      
      integer :: iii,iatom,jatom
      iii=iatom ; iatom = jatom ; jatom = iii
      
      END

CC ISET_IAOSLX ======================================================
C     SET INDEX NUMBER OF TOTAL-SHELL ==> NUMBER OF AO
C     
C     1:SET 0 BUT WHEN AO=IS X=0,Y=1,Z=2  
C     2:SET FIRST NUMBER
C     3:SET 0 BUT WHEN AO=IE X=2,Y=1,Z=0
C====================================================================

      subroutine iset_iaoslx (
     &           nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &           nao    ,  mxsa   ,  nasp   ,  nshell,
     &           is_s,is_e,iaoslix,
     &           is     ,  ie     )
      
      implicit real(8) (a-h,o-z)

      dimension nao2sh(nao)
      dimension nsh2ssh(nshell),nsh2asp(nshell),ntshty(mxsa,nasp)

      dimension iaoslix(is_s:is_e,3)

      integer,allocatable :: nao2shty(:)

c$$$      write(6,*) 'nao=',nao
c$$$      write(6,*) 'mxsa=',mxsa
      allocate(nao2shty(nao))

      nnn = 0
      do i = 1,nshell
         issh = nsh2ssh(i)
         iasp = nsh2asp(i)
         iang = ntshty(issh,iasp)
         jang = iang*(iang+1)/2

         do j = 1,jang
            nnn = nnn + 1
            nao2shty(nnn) = j
         enddo
      enddo

      ishelo = 0

      do i = is_s,is_e
         iaoslix(i,1) = 0
         iaoslix(i,3) = 0
      enddo

      iaoslix(is_s,1) = nao2shty(is) - 1
      
!j!============================================= 
      i = nao2sh(ie)
      iasp = nsh2asp(i)
      ishel = nsh2ssh(i)
      iangi = ntshty(ishel,iasp)
!j!============================================= 
      
      iii = nao2shty(ie)
      
      if (iangi.ge.5) then
         select case (iii)
         case (1)
                     iaoslix(is_e,3) = 14
         case (2)
                     iaoslix(is_e,3) = 13
         case (3)
                     iaoslix(is_e,3) = 12
         case (4)
                     iaoslix(is_e,3) = 11
         case (5)
                     iaoslix(is_e,3) = 10
         case (6)
                     iaoslix(is_e,3) = 9
         case (7)
                     iaoslix(is_e,3) = 8
         case (8)
                     iaoslix(is_e,3) = 7
         case (9)
                     iaoslix(is_e,3) = 6
         case (10)
                     iaoslix(is_e,3) = 5
         case (11)
                     iaoslix(is_e,3) = 4
         case (12)
                     iaoslix(is_e,3) = 3
         case (13)
                     iaoslix(is_e,3) = 2
         case (14)
                     iaoslix(is_e,3) = 1
         case (15)
                     iaoslix(is_e,3) = 0
         end select
         
      else
         if (iangi.ge.4) then
            
            select case (iii)
            case (1)
                     iaoslix(is_e,3) = 9
            case (2)
                     iaoslix(is_e,3) = 8
            case (3)
                     iaoslix(is_e,3) = 7
            case (4)
                     iaoslix(is_e,3) = 6
            case (5)
                     iaoslix(is_e,3) = 5
            case (6)
                     iaoslix(is_e,3) = 4
            case (7)
                     iaoslix(is_e,3) = 3
            case (8)
                     iaoslix(is_e,3) = 2
            case (9)
                     iaoslix(is_e,3) = 1
            case (10)
                     iaoslix(is_e,3) = 0
            end select
            
         else
            if (iangi.ge.3) then
               
               select case (iii)
               case (1)
                  iaoslix(is_e,3) = 5
               case (2)
                  iaoslix(is_e,3) = 4
               case (3)
                  iaoslix(is_e,3) = 3
               case (4)
                  iaoslix(is_e,3) = 2
               case (5)
                  iaoslix(is_e,3) = 1
               case (6)
                  iaoslix(is_e,3) = 0
               end select
               
            else
               if (iangi.ge.2) then
                  
                  select case (iii)
                  case (1)
                     iaoslix(is_e,3) = 2
                  case (2)
                     iaoslix(is_e,3) = 1
                  case (3)
                     iaoslix(is_e,3) = 0
                  end select
                  
               else
                  iaoslix(is_e,3) = 0
               endif
               
            endif
         endif
      endif
      
      ishelo = 0
      do i = is,ie
         
         isheln = nao2sh(i)
         
         if (isheln.ne.ishelo) then
            iaoslix(isheln,2) = i
            ishelo = isheln
         endif
         
      enddo

      iaoslix(is_s,2) = is - nao2shty(is) + 1
      
      deallocate(nao2shty)
      end

! ISETSLAO ==========================================================
! SET SHELL-AO INDEX TABLE
! RETURN FIRST NUMBER OF AO IN SHELL
!
!===================================================================
      SUBROUTINE isetslao(islao,nao2sh,nao,nshell)

      implicit none
      integer ishel0,ishel1,i,nshell,nao
      integer nao2sh(nao),islao(nshell)

      ishel0 = 0
      do i = 1,nao
         ishel1 = nao2sh(i)
         if (ishel1.ne.ishel0) then
            islao(ishel1) = i
            ishel0 = ishel1
         endif
      enddo 

      END

! IPARA_UP ==========================================================
! parameter set for calc eri
! ==output==
! pp,qq
! uup,uuq
! uzp,uzq
!====================================================================

      subroutine ipara_up(
     &     pp    ,  qq     ,
     &     uup   ,  uuq    ,
     &     uzp   ,  uzq    ,
     &     zz    ,  cc     ,  zetpq   ,  xyz    ,
     &     nsh2atm,  natm2asp,  nsh2ssh,
     &     ntshty,  ntprm  ,
     &     iss   ,  ise    ,  jss     ,  jse    ,
     &     kss   ,  kse    ,  lss     ,  lse    ,
     &     natom ,  nshell ,  nasp    ,  mxprm  ,  mxsa,  nao,
     &     ierr   )
      
      implicit real(8)(a-h,o-z)
      
      parameter (wpi52 = 197.915435609545184401d0)
      dimension pp(3,mxprm,mxprm,jss:jse,iss:ise)
      dimension qq(3,mxprm,mxprm,lss:lse,kss:kse)
      dimension uup( mxprm,mxprm,jss:jse,iss:ise)
      dimension uuq( mxprm,mxprm,lss:lse,kss:kse)
      dimension uzp( mxprm,mxprm,jss:jse,iss:ise)
      dimension uzq( mxprm,mxprm,lss:lse,kss:kse)

      dimension zz(mxprm,mxsa,nasp),cc(mxprm,mxsa,nasp)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension xyz(3,natom)

      dimension nsh2atm(nshell)
      dimension natm2asp(natom),nsh2ssh(nshell)

      dimension ntshty(mxsa,nasp),ntprm(mxsa,nasp)

      do i = iss,ise
         iatom = nsh2atm(i)
         ishel = nsh2ssh(i)
         iasp  = natm2asp(iatom)
         
         igp = ntprm(ishel,iasp)
         iang = ntshty(ishel,iasp)
         do j = jss,jse
            
            jatom = nsh2atm(j)
            jshel = nsh2ssh(j)
            jasp  = natm2asp(jatom)
            jang = ntshty(jshel,jasp)
!           if (iang.lt.jang) cycle
            jgp = ntprm(jshel,jasp)
            
            abx = xyz(1,iatom) - xyz(1,jatom)
            aby = xyz(2,iatom) - xyz(2,jatom)
            abz = xyz(3,iatom) - xyz(3,jatom)
            
            ab2 = 0.5d0*(abx*abx + aby*aby + abz*abz)
            do ic = 1,igp
               xyz1 = zz(ic,ishel,iasp) * xyz(1,iatom)
               xyz2 = zz(ic,ishel,iasp) * xyz(2,iatom)
               xyz3 = zz(ic,ishel,iasp) * xyz(3,iatom)
               zaab2 = -ab2 * zz(ic,ishel,iasp)
               do jc = 1,jgp

                  uup(jc,ic,j,i) = 
     &                 dsqrt( zetpq(jc,ic,jshel,jasp,ishel,iasp) )  *
     &                 zetpq(jc,ic,jshel,jasp,ishel,iasp)           *
     &                 dexp( zz(jc,jshel,jasp)                      *
     &                 zetpq(jc,ic,jshel,jasp,ishel,iasp) * zaab2   )
                  
                  uup(jc,ic,j,i) = uup(jc,ic,j,i) *
     &                 cc(ic,ishel,iasp) * cc(jc,jshel,jasp)
                  
                  uzp(jc,ic,j,i) = uup(jc,ic,j,i) *
     &                 zetpq(jc,ic,jshel,jasp,ishel,iasp)

                  pp(1,jc,ic,j,i)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &                 ( xyz1 + zz(jc,jshel,jasp) * xyz(1,jatom) )
                  pp(2,jc,ic,j,i)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &                 ( xyz2 + zz(jc,jshel,jasp) * xyz(2,jatom) )
                  pp(3,jc,ic,j,i)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &                 ( xyz3 + zz(jc,jshel,jasp) * xyz(3,jatom) )
                  
               enddo
            enddo
            
         enddo
      enddo
      
      do i = kss,kse
         iatom = nsh2atm(i)
         ishel = nsh2ssh(i)
         iasp  = natm2asp(iatom)
         iang  = ntshty(ishel,iasp)
         
         igp = ntprm(ishel,iasp)
         do j = lss,lse
            
            jatom = nsh2atm(j)
            jshel = nsh2ssh(j)
            jasp  = natm2asp(jatom)
            jang  = ntshty(jshel,jasp)
!           if (iang.lt.jang) cycle
            jgp = ntprm(jshel,jasp)
            abx = xyz(1,iatom) - xyz(1,jatom)
            aby = xyz(2,iatom) - xyz(2,jatom)
            abz = xyz(3,iatom) - xyz(3,jatom)
            
            ab2 = 0.5d0*(abx*abx + aby*aby + abz*abz)
            do ic = 1,igp
               xyz1 = zz(ic,ishel,iasp) * xyz(1,iatom)
               xyz2 = zz(ic,ishel,iasp) * xyz(2,iatom)
               xyz3 = zz(ic,ishel,iasp) * xyz(3,iatom)
               zaab2 = -ab2 * zz(ic,ishel,iasp)
               do jc = 1,jgp
                  
                  uuq(jc,ic,j,i) = 
     &                 dsqrt( zetpq(jc,ic,jshel,jasp,ishel,iasp) )  *
     &                 zetpq(jc,ic,jshel,jasp,ishel,iasp) * wpi52 *
     &                 dexp( zz(jc,jshel,jasp)                   * 
     &                 zetpq(jc,ic,jshel,jasp,ishel,iasp) * zaab2   )
                  
                  uuq(jc,ic,j,i) = uuq(jc,ic,j,i) *
     &                 cc(ic,ishel,iasp) * cc(jc,jshel,jasp)
                  uzq(jc,ic,j,i) = uuq(jc,ic,j,i) *
     &                 zetpq(jc,ic,jshel,jasp,ishel,iasp)
                  
                  qq(1,jc,ic,j,i)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &                 ( xyz1 + zz(jc,jshel,jasp) * xyz(1,jatom) )
                  qq(2,jc,ic,j,i)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &                 ( xyz2 + zz(jc,jshel,jasp) * xyz(2,jatom) )
                  qq(3,jc,ic,j,i)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &                 ( xyz3 + zz(jc,jshel,jasp) * xyz(3,jatom) )

               enddo
            enddo
            
         enddo
      enddo

      end
! IPARA_IUP ==========================================================
! parameter set for calc eri
! ==output==
! pp,qq
! uup,uuq
! uzp,uzq
!====================================================================

      subroutine ipara_iup(
     &     pp    ,  qq     ,
     &     uup   ,  uuq    ,
     &     uzp   ,  uzq    ,
     &     zz    ,  cc     ,  zetpq,  xyz    , !zetpq23,zetpqze,
     &     ntprm ,
     &     iasp  ,  jasp   ,  kasp ,  lasp   ,
     &     iatom ,  jatom  ,  katom,  latom  ,
     &     ishel ,  jshel  ,  kshel,  lshel  ,
     &     natom ,  nasp   ,  mxprm,  mxsa   ,
     &     ierr   )

      implicit real(8)(a-h,o-z)
      
      parameter (wpi52 = 197.915435609545184401d0)
                         
      dimension pp(3,mxprm,mxprm)
      dimension qq(3,mxprm,mxprm)
      dimension uup( mxprm,mxprm)
      dimension uuq( mxprm,mxprm)
      dimension uzp( mxprm,mxprm)
      dimension uzq( mxprm,mxprm)

      dimension zz(mxprm,mxsa,nasp),cc(mxprm,mxsa,nasp)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
!     dimension zetpq23(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
!     dimension zetpqze(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension xyz(3,natom)

      dimension ntprm(mxsa,nasp)
      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)
            
      abx = xyz(1,iatom) - xyz(1,jatom)
      aby = xyz(2,iatom) - xyz(2,jatom)
      abz = xyz(3,iatom) - xyz(3,jatom)
      cdx = xyz(1,katom) - xyz(1,latom)
      cdy = xyz(2,katom) - xyz(2,latom)
      cdz = xyz(3,katom) - xyz(3,latom)
            
      ab2 = 0.5d0*(abx*abx + aby*aby + abz*abz)
      cd2 = 0.5d0*(cdx*cdx + cdy*cdy + cdz*cdz)
      
      do ic = 1,igp
         xyz1 = zz(ic,ishel,iasp) * xyz(1,iatom)
         xyz2 = zz(ic,ishel,iasp) * xyz(2,iatom)
         xyz3 = zz(ic,ishel,iasp) * xyz(3,iatom)
         zaab2 = - ab2 * zz(ic,ishel,iasp)
         ezaab2 = dexp(zaab2)
         do jc = 1,jgp

            uup(jc,ic) = 
     &           dsqrt( zetpq(jc,ic,jshel,jasp,ishel,iasp) )  *
     &           zetpq(jc,ic,jshel,jasp,ishel,iasp)           *
!    &           zetpq23(jc,ic,jshel,jasp,ishel,iasp)         *
!    &           zetpqze(jc,ic,jshel,jasp,ishel,iasp) * ezaab2
     &           dexp( zz(jc,jshel,jasp)                      *
     &           zetpq(jc,ic,jshel,jasp,ishel,iasp) * zaab2   )
!    &           dexp( zz(jc,jshel,jasp)                      *
!    &           zetpq(jc,ic,jshel,jasp,ishel,iasp) ) * 
!    &           dexp( zaab2 )
            
            uup(jc,ic) = uup(jc,ic) *
     &           cc(ic,ishel,iasp) * cc(jc,jshel,jasp)
            
            uzp(jc,ic) = uup(jc,ic) *
     &           zetpq(jc,ic,jshel,jasp,ishel,iasp)
            
            pp(1,jc,ic)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &           ( xyz1 + zz(jc,jshel,jasp) * xyz(1,jatom) )
            pp(2,jc,ic)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &           ( xyz2 + zz(jc,jshel,jasp) * xyz(2,jatom) )
            pp(3,jc,ic)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &           ( xyz3 + zz(jc,jshel,jasp) * xyz(3,jatom) )
            
         enddo
      enddo
      
      
      do kc = 1,kgp
         xyz1 = zz(kc,kshel,kasp) * xyz(1,katom)
         xyz2 = zz(kc,kshel,kasp) * xyz(2,katom)
         xyz3 = zz(kc,kshel,kasp) * xyz(3,katom)
         zccd2 = -cd2 * zz(kc,kshel,kasp)
         do lc = 1,lgp
            
            uuq(lc,kc) = 
     &           dsqrt( zetpq(lc,kc,lshel,lasp,kshel,kasp) )  *
     &           zetpq(lc,kc,lshel,lasp,kshel,kasp) * wpi52 *
!    &           zetpq23(lc,kc,lshel,lasp,kshel,kasp) * wpi52 *
     &           dexp( zz(lc,lshel,lasp)                   * 
     &           zetpq(lc,kc,lshel,lasp,kshel,kasp) * zccd2   )
            
            uuq(lc,kc) = uuq(lc,kc) *
     &           cc(kc,kshel,kasp) * cc(lc,lshel,lasp)
            
            uzq(lc,kc) = uuq(lc,kc) *
     &           zetpq(lc,kc,lshel,lasp,kshel,kasp)
            
            qq(1,lc,kc)=zetpq(lc,kc,lshel,lasp,kshel,kasp) *
     &           ( xyz1 + zz(lc,lshel,lasp) * xyz(1,latom) )
            qq(2,lc,kc)=zetpq(lc,kc,lshel,lasp,kshel,kasp) *
     &           ( xyz2 + zz(lc,lshel,lasp) * xyz(2,latom) )
            qq(3,lc,kc)=zetpq(lc,kc,lshel,lasp,kshel,kasp) *
     &           ( xyz3 + zz(lc,lshel,lasp) * xyz(3,latom) )
            
         enddo
      enddo
      
      
      end
C** IPARA_zet23 ======================================================
C     SET PARAMETER FOR FMT 
C              SET ZET AND ETA    1/(ALP+BET) ,1/(RAM+DEL)
C ===================================================================

      subroutine ipara_zet23(mxsa,nasp,mxprm,zetpq,zetpq23)
      
      implicit real(8)(a-h,o-z)
      
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension zetpq23(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      
      do n = 1,nasp
         do l = 1,mxsa
            
            do m = 1,nasp
               do k = 1,mxsa
                  
                  do j = 1,mxprm
                     do i = 1,mxprm
                      
                        zetpq23(i,j,k,m,l,n) = 
     &                  zetpq(i,j,k,m,l,n) * dsqrt(zetpq(i,j,k,m,l,n))

                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
      
      end

C** IPARA_zetze ======================================================
C     SET PARAMETER FOR FMT 
C              SET ZET AND ETA    1/(ALP+BET) ,1/(RAM+DEL)
C ===================================================================

      subroutine ipara_zetze(mxsa,nasp,mxprm,zz,zetpq,zetpqze)
      
      implicit real(8)(a-h,o-z)
      
      dimension zz(mxprm,mxsa,nasp)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension zetpqze(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      
      do n = 1,nasp
         do l = 1,mxsa
            
            do m = 1,nasp
               do k = 1,mxsa
                  
                  do j = 1,mxprm
                     do i = 1,mxprm
                      
                        zetpqze(i,j,k,m,l,n) = 
     &                  dexp(zz(i,k,m) * zetpq(i,j,k,m,l,n))

                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
      
      end

!IGET_MXSHTY   =====================================================
!  GET MAXVALUE OF ANGULAR MOMENTUM IN AO-RANGE
! ===================================================================
      SUBROUTINE iget_mxshty (
     &     mxxang  ,
     &     is      ,  ie ,  js  ,  je,
     &     ks      ,  ke ,  ls  ,  le,
     &     nsh2shty,
     &     nshell  ,  nao,  mxsa    )
      
      implicit real(8)(a-h,o-z)
      
!     dimension nsh2ssh(nshell),nsh2atm(nshell),nsh2asp(nshell)
!     dimension nao2sh(nao)
!     dimension ntshty(mxsa,nasp)
      dimension nsh2shty(nshell)
      
      iang0 = 0
      iang1 = 0
      jang1 = 0
      kang1 = 0
      lang1 = 0

!     is = nao2sh(nr_s)
!     ie = nao2sh(nr_e)
!     js = nao2sh(ns_s)
!     je = nao2sh(ns_e)
!     ks = nao2sh(nt_s)
!     ke = nao2sh(nt_e)
!     ls = nao2sh(nu_s)
!     le = nao2sh(nu_e)
!     
!     i0 = nao2sh(  1)
!     i1 = nao2sh(nao)

!     do i= i0,i1
!        iasp  = nsh2asp(i)
!        ishel = nsh2ssh(i)

!        iang  = ntshty(ishel,iasp)

!        if (iang.gt.iang0) iang0 = iang
!     enddo

      do i = is,ie
!        iasp  = nsh2asp(i)
!        ishel = nsh2ssh(i)
!        iang  = ntshty(ishel,iasp)
         iang  = nsh2shty(i)
         if (iang.gt.iang1) iang1 = iang
      enddo
      
      do j = js,je
!        jasp  = nsh2asp(j)
!        jshel = nsh2ssh(j)

!        jang  = ntshty(jshel,jasp)
         jang  = nsh2shty(j)

         if (jang.gt.jang1) jang1 = jang
      enddo

      do k = ks,ke
!        kasp  = nsh2asp(k)
!        kshel = nsh2ssh(k)

!        kang  = ntshty(kshel,kasp)
         kang  = nsh2shty(k)

         if (kang.gt.kang1) kang1 = kang
      enddo
      
      do l = ls,le
!        lasp  = nsh2asp(l)
!        lshel = nsh2ssh(l)

!        lang  = ntshty(lshel,lasp)
         lang  = nsh2shty(l)

         if (lang.gt.lang1) lang1 = lang
      enddo
      
      mxxang = max(iang1,jang1,kang1,lang1)
      mxxang0= iang0

      end
      
!!IGARR =============================================================
! GET ARRAY-SIZE FOR TABLE OF CALC ERI
!     d :: real=  6518 +  6^4  int=    77581
!     f :: real= 94720 + 10^4  int=  1305013
!     g :: real=850955 + 15^4  int= 12959881, sum:45993628

!     ikey=1 : for schwarz
!     ikey=2 : for tei calc
!===================================================================      
      
      subroutine iget_bufsize(mrk,mik,mxxang,ikey)
      implicit none
      
      integer mxxang,mrk,mik,ikey
      
      if (ikey.eq.1) then
         
         select case (mxxang)
         case(1)
            mrk =   1
            mik =   0
         case(2)
            mrk =  81
            mik =   0
         case(3)
            mrk =  10000   + 1296
            mik = 100000
         case(4)
            mrk =   100000 + 10000
            mik =  1400000
         case(5)
            mrk =  1000000 + 50625
            mik = 14000000
         end select
      endif
      
      if (ikey.eq.2) then
         select case (mxxang)
         case(1)
            mrk =   1
            mik =   0
         case(2)
            mrk =  81
            mik =   0
         case(3)
            mrk =  10000   + 1296
            mik = 100000
         case(4)
            mrk =   100000 + 10000
            mik =  3500000
         case(5)
            mrk =  1000000 + 50625
            mik = 48000000
         end select
         
      endif
      
      end      
! IPARA_IUP ==========================================================
! parameter set for calc eri with os-method
! ==output==
! pp,qq
! uup,uuq
! uzp,uzq
!====================================================================

      subroutine ipara_ioup(
     &     pp    ,  qq     ,
     &     uup   ,  uuq    ,
     &     zz    ,  cc     ,  zetpq,  xyz    , !zetpq23,zetpqze,
     &     ntprm ,
     &     iasp  ,  jasp   ,  kasp ,  lasp   ,
     &     iatom ,  jatom  ,  katom,  latom  ,
     &     ishel ,  jshel  ,  kshel,  lshel  ,
     &     natom ,  nasp   ,  mxprm,  mxsa   ,
     &     ierr   )

      implicit real(8)(a-h,o-z)
      
      parameter (wpi52 = 197.915435609545184401d0)
                         
      dimension pp(3,mxprm,mxprm)
      dimension qq(3,mxprm,mxprm)
      dimension uup( mxprm,mxprm)
      dimension uuq( mxprm,mxprm)

      dimension zz(mxprm,mxsa,nasp),cc(mxprm,mxsa,nasp)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension xyz(3,natom)

      dimension ntprm(mxsa,nasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)
            
      abx = xyz(1,iatom) - xyz(1,jatom)
      aby = xyz(2,iatom) - xyz(2,jatom)
      abz = xyz(3,iatom) - xyz(3,jatom)
      cdx = xyz(1,katom) - xyz(1,latom)
      cdy = xyz(2,katom) - xyz(2,latom)
      cdz = xyz(3,katom) - xyz(3,latom)
            
      ab2 = 0.5d0*(abx*abx + aby*aby + abz*abz)
      cd2 = 0.5d0*(cdx*cdx + cdy*cdy + cdz*cdz)

      do ic = 1,igp
         xyz1 = zz(ic,ishel,iasp) * xyz(1,iatom)
         xyz2 = zz(ic,ishel,iasp) * xyz(2,iatom)
         xyz3 = zz(ic,ishel,iasp) * xyz(3,iatom)
         zaab2 = - ab2 * zz(ic,ishel,iasp)
         ezaab2 = dexp(zaab2)
         do jc = 1,jgp
            
            uup(jc,ic) = 
     &           dsqrt( zetpq(jc,ic,jshel,jasp,ishel,iasp) )  *
     &           zetpq(jc,ic,jshel,jasp,ishel,iasp)           *
     &           dexp( zz(jc,jshel,jasp)                      *
     &           zetpq(jc,ic,jshel,jasp,ishel,iasp) * zaab2   )
            
            uup(jc,ic) = uup(jc,ic) *
     &           cc(ic,ishel,iasp) * cc(jc,jshel,jasp)
            
            pp(1,jc,ic)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &           ( xyz1 + zz(jc,jshel,jasp) * xyz(1,jatom) )
            pp(2,jc,ic)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &           ( xyz2 + zz(jc,jshel,jasp) * xyz(2,jatom) )
            pp(3,jc,ic)=zetpq(jc,ic,jshel,jasp,ishel,iasp) *
     &           ( xyz3 + zz(jc,jshel,jasp) * xyz(3,jatom) )
            
         enddo
      enddo
      
      
      do kc = 1,kgp
         xyz1 = zz(kc,kshel,kasp) * xyz(1,katom)
         xyz2 = zz(kc,kshel,kasp) * xyz(2,katom)
         xyz3 = zz(kc,kshel,kasp) * xyz(3,katom)
         zccd2 = -cd2 * zz(kc,kshel,kasp)
         do lc = 1,lgp
            
            uuq(lc,kc) = 
     &           dsqrt( zetpq(lc,kc,lshel,lasp,kshel,kasp) )  *
     &           zetpq(lc,kc,lshel,lasp,kshel,kasp) * wpi52 *
     &           dexp( zz(lc,lshel,lasp)                   * 
     &           zetpq(lc,kc,lshel,lasp,kshel,kasp) * zccd2   )
            
            uuq(lc,kc) = uuq(lc,kc) *
     &           cc(kc,kshel,kasp) * cc(lc,lshel,lasp)
            
            qq(1,lc,kc)=zetpq(lc,kc,lshel,lasp,kshel,kasp) *
     &           ( xyz1 + zz(lc,lshel,lasp) * xyz(1,latom) )
            qq(2,lc,kc)=zetpq(lc,kc,lshel,lasp,kshel,kasp) *
     &           ( xyz2 + zz(lc,lshel,lasp) * xyz(2,latom) )
            qq(3,lc,kc)=zetpq(lc,kc,lshel,lasp,kshel,kasp) *
     &           ( xyz3 + zz(lc,lshel,lasp) * xyz(3,latom) )
            
         enddo
      enddo
      
      
      end
! == IGET_MXSHTYA======================================================
!    get maxvalue of angular momentum on all range
! ==================================================================
      subroutine iget_mxshtya(mxxang0,nshell,nsh2shty)
      implicit real(8)(a-h,o-z)

      dimension nsh2shty(nshell)

      mxxang0 = 0
      do i = 1,nshell
         iang1 = nsh2shty(i)
         if (iang1.gt.mxxang0) mxxang0 = iang1
      enddo
 
      if (mxxang0.gt.6)write(*,*)"ERROR : IGET_MXSHTYA" 
      
      end

C**   ISETMM ========================================================
C     SET MM 
C     NUMBER OF ORBIT ANGULAR MOMENTUM
C     s:1 p:3 d:6 f:10 g:15 h:21
C====================================================================

      subroutine iset_mm(mm)
      
      IMPLICIT NONE
      integer mm(20),i,ival
      
      ival = 0
      do i = 1,20
         ival = ival + i
         mm(i) = ival
      enddo

      END
C** IPARAZI ==========================================================
C     SET PARAMETER FOR FMT 
C              SET ZET AND ETA    1/(ALP+BET) ,1/(RAM+DEL)
C ===================================================================

      subroutine ipara_zet(mxsa,nasp,mxprm,zz,zetpq)
      
      implicit real(8)(a-h,o-z)
      
      dimension zz(mxprm,mxsa,nasp)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      
      do n = 1,nasp
         do l = 1,mxsa
            
            do m = 1,nasp
               do k = 1,mxsa
                  
                  do j = 1,mxprm
                     do i = 1,mxprm
                      
c$$$                        zetpq(i,j,k,m,l,n) = 0.5d0/(zz(i,k,m)+zz(j,l,n))
                        if (zz(i,k,m)+zz(j,l,n) .gt. 0.0d0) then
                        zetpq(i,j,k,m,l,n) = 0.5d0/(zz(i,k,m)+zz(j,l,n))
                        else
                        zetpq(i,j,k,m,l,n) = 0.0d0
                        endif

                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
      
      end
C** IPARAZ2 ==========================================================
C     SET PARAMETER FOR ERI_PRISM
C              Z = 2 * Z
C ===================================================================

      subroutine ipara_zz2(zz2,zz,mxprm,mxsa,nasp)
      
      implicit real(8)(a-h,o-z)
      
      dimension zz(mxprm,mxsa,nasp)
      dimension zz2(mxprm,mxsa,nasp)

      do k=1,nasp
         do j=1,mxsa
            do i=1,mxprm
               
               zz2(i,j,k) = 2.0d0 * zz(i,j,k)
               
            enddo
         enddo
      enddo

      END
! INANG2N ===========================================================
! SET NUMBERING OF ANGULARMOMENTUM TYPE 
!
!      ssss : 1                      * cannot compile with
!      psss : 2                        intel_8.1 -O3
!      psps : 3
!      ppss : 4
!          |
!      gggg : 120
! ==================================================================

      subroutine iset_nang2n(nang2n,mxxang)
      implicit real(8)(a-h,o-z) 
 
      dimension nang2n(mxxang,mxxang,mxxang,mxxang)

      ict = 0

      do i=1,mxxang
         do j=1,i!mxxang
!           if (i.lt.j) cycle
            ip = i + j

            do k=1,mxxang
                 do l=1,k!mxxang
!                   if (k.lt.l) cycle
                    if (i.lt.k) cycle
                    iq = k + l
                    if ((i.eq.k).and.(ip.lt.iq)) cycle
                       ict = ict + 1
                       nang2n(i,j,k,l) = ict 

                       nang2n(j,i,k,l) = ict
                       nang2n(i,j,l,k) = ict
                       nang2n(j,i,l,k) = ict

                       nang2n(k,l,i,j) = ict
                       nang2n(l,k,i,j) = ict
                       nang2n(k,l,j,i) = ict
                       nang2n(l,k,j,i) = ict

               enddo
            enddo
         enddo
      enddo
 
      end
