! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
C## IPASIZE   ===   ====================================================
C     set cutthr , buffersize and ao-shell index after setting range
C
C   === OUTPUT ===
!     cutthr  ::    threshhold value
!     iaoslix ::    index table of shell & ao numbers on I shell
!     iaosljx ::    index table of shell & ao numbers on J shell
!     iaoslkx ::    index table of shell & ao numbers on K shell
!     iaosllx ::    index table of shell & ao numbers on L shell
!     mwki    ::    work buffer  for int  type
!     mwkr    ::    work buffer  for real type
!     mxxang  ::    max of angularmomentum 
!
C======================================================================*
      subroutine ipasize(
     o     iaoslix , iaosljx , iaoslkx, iaosllx ,
     o     mwki    , mwkr    , mxxang , cutthr,
     &     nsh2ssh ,  nsh2asp, nsh2shty,nao2sh  ,
     &     ntshty  , 
     &     e_rrrr  , 
     &     nr_s    , nr_e    , ns_s   , ns_e    ,
     &     nt_s    , nt_e    , nu_s   , nu_e    ,
     &     ir_s    , ir_e    , is_s   , is_e    ,
     &     it_s    , it_e    , iu_s   , iu_e    ,
     &     mxsa    ,  nao    , nshell, nasp,
     &     erithr  ,
     &     ierr        )

      IMPLICIT REAL(8) (a-h,o-z)
      
      DIMENSION ntshty(mxsa,nasp)
     
      dimension nsh2ssh(nshell),nsh2asp(nshell)
      dimension nao2sh(nao),nsh2shty(nshell)
      dimension e_rrrr(nshell)
   
      dimension iaoslix(ir_s:ir_e,3),iaosljx(is_s:is_e,3)
      dimension iaoslkx(it_s:it_e,3),iaosllx(iu_s:iu_e,3)

      call swz_cutthr(
     &     cutthr,
     &     e_rrrr,
     &     ir_s  ,  ir_e  ,  is_s,  is_e,
     &     it_s  ,  it_e  ,  iu_s,  iu_e,
     &     nshell,  erithr             )

      call iget_mxshty(
     &     mxxang  ,
     &     ir_s    , ir_e    , is_s, is_e,
     &     it_s    , it_e    , iu_s, iu_e,
     &     nsh2shty,
     &     nshell  , nao     , mxsa       )

      call iget_bufsize(mwkr,mwki,mxxang,2)
      
      call iset_iaoslx (
     &     nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &     nao    ,  mxsa   ,  nasp   ,  nshell,
     &     ir_s,ir_e,iaoslix,
     &     nr_s     ,  nr_e      )

      call iset_iaoslx (
     &     nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &     nao    ,  mxsa   ,  nasp   ,  nshell,
     &     is_s,is_e,iaosljx,
     &     ns_s     ,  ns_e      )

      call iset_iaoslx (
     &     nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &     nao    ,  mxsa   ,  nasp   ,  nshell,
     &     it_s,it_e,iaoslkx,
     &     nt_s     ,  nt_e      )

      call iset_iaoslx (
     &     nao2sh ,  nsh2ssh,  nsh2asp,  ntshty,
     &     nao    ,  mxsa   ,  nasp   ,  nshell,
     &     iu_s,iu_e,iaosllx,
     &     nu_s     ,  nu_e      )

      END
