! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
C** BEGIN PRISM PSSS L2 STEP =========================================
C                    PSSS WITH BLAS
C=====================================================================

      SUBROUTINE impsss(
     &           ec     ,
     &           xyz    ,  psss   , 
     &           mvhgp  ,  natom  , 
     &           iatom  ,  jatom  ,  katom  , latom  )

      IMPLICIT REAL(8)(a-h,o-z)
      DIMENSION xyz(3,natom)
      DIMENSION psss(4)
      DIMENSION tiu(9),o1(3)
      DIMENSION ec(mvhgp)

      tiu(1) = xyz(1,jatom)-xyz(1,iatom)
      tiu(4) = xyz(2,jatom)-xyz(2,iatom)
      tiu(7) = xyz(3,jatom)-xyz(3,iatom)
      tiu(2) = xyz(1,katom)-xyz(1,latom)
      tiu(5) = xyz(2,katom)-xyz(2,latom)
      tiu(8) = xyz(3,katom)-xyz(3,latom)
      tiu(3) = xyz(1,latom)-xyz(1,jatom)
      tiu(6) = xyz(2,latom)-xyz(2,jatom)
      tiu(9) = xyz(3,latom)-xyz(3,jatom)

      z011000 = psss(1)
      u001000 = psss(2)
      u001101 = psss(3)
      u102000 = psss(4)

      o1(1) = psss(4) + psss(1)
      o1(2) = psss(3)
      o1(3) = psss(2)
      
      do i=1,3
         ec(i) = 0
!        do l = 1,3

            kyt1 = 3*i - 2!1+(i-1)*3
            kyt2 = 3*i - 1!2+(i-1)*3
            kyt3 = 3*i    !3+(i-1)*3

            ec(i) = ec(i) + tiu(kyt1)*o1(1)
            ec(i) = ec(i) + tiu(kyt2)*o1(2)
            ec(i) = ec(i) + tiu(kyt3)*o1(3)

!        enddo
      enddo
      
      END
C**   BEGIN PRISM PSPS L2 STEP =========================================
C                PSPS WITH BLAS
C=====================================================================
      SUBROUTINE impsps(
     &           ec     ,
     &           xyz    ,  psps   , 
     &           mvhgp  ,  natom  , 
     &           iatom  ,  jatom  ,  katom  , latom  )

      IMPLICIT REAL(8)(a-h,o-z)
      DIMENSION xyz(3,natom)
      DIMENSION psps(14)
      DIMENSION tiu(9),tkw(9),o1(9),p1(9)
      DIMENSION ec(mvhgp)

      tiu(1)= xyz(1,jatom)-xyz(1,iatom)
      tiu(4)= xyz(2,jatom)-xyz(2,iatom)
      tiu(7)= xyz(3,jatom)-xyz(3,iatom)
      tiu(2)= xyz(1,katom)-xyz(1,latom)
      tiu(5)= xyz(2,katom)-xyz(2,latom)
      tiu(8)= xyz(3,katom)-xyz(3,latom)
      tiu(3)= xyz(1,latom)-xyz(1,jatom)
      tiu(6)= xyz(2,latom)-xyz(2,jatom)
      tiu(9)= xyz(3,latom)-xyz(3,jatom)
      tkw(1)=-tiu(1)
      tkw(4)=-tiu(4)
      tkw(7)=-tiu(7)
      tkw(2)=-tiu(2)
      tkw(5)=-tiu(5)
      tkw(8)=-tiu(8)
      tkw(3)=-tiu(3)
      tkw(6)=-tiu(6)
      tkw(9)=-tiu(9)

      z011011 = psps( 1)
      u112001 = psps( 2)
      u102011 = psps( 3)
      u011102 = psps( 4)
      u001112 = psps( 5)
      u001001 = psps( 6)
      u001011 = psps( 7)
      u011001 = psps( 8)
      d203001 = psps( 9)
      d102102 = psps(10)
      d102001 = psps(11)
      d001203 = psps(12)
      d001102 = psps(13)
      d001001 = psps(14)

      o1(1) = d203001 + u112001
      o1(2) = d102102
      o1(3) = d102001
      o1(4) = d102102 + u102011 + u011102 + z011011
      o1(5) = d001203 + u001112
      o1(6) = d001102 + u001011
      o1(7) = d102001 + u011001
      o1(8) = d001102
      o1(9) = d001001
      
c     call ipgemm (3,p1,o1,tkw)
c     call ipgemmt(3,o1,p1,tiu)
      
!     do i=1,3
!        do j=1,3
!           ky = i + (j-1)*3
!           p1(ky) = 0
!           do l = 1,3
!              kyo = i +(l-1)*3
!              kyt = l +(j-1)*3
!              p1(ky) = p1(ky) + o1(kyo)*tkw(kyt)
!           enddo
!        enddo
!     enddo

!     do i=1,3
!        do j=1,3
!           ky = i + (j-1)*3
!           ec(ky) = 0
!           do l = 1,3
!              kyo = l +(i-1)*3
!              kyt = l +(j-1)*3
!              ec(ky) = ec(ky) + p1(kyo)*tiu(kyt)
!           enddo
!        enddo
!     enddo

      do i=1,3
         kyo1 = i         
         kyo2 = i + 3
         kyo3 = i + 6
         do j=1,3
            ky = i + (j-1)*3
            p1(ky) = 0
!           do l = 1,3

               kyt1 = 3*j - 2
               kyt2 = 3*j - 1
               kyt3 = 3*j

               p1(ky) = p1(ky) + o1(kyo1)*tkw(kyt1)
               p1(ky) = p1(ky) + o1(kyo2)*tkw(kyt2)
               p1(ky) = p1(ky) + o1(kyo3)*tkw(kyt3)
!           enddo
         enddo
      enddo

      do i=1,3
         kyo1 = 3 * i - 2
         kyo2 = 3 * i - 1
         kyo3 = 3 * i 
         do j=1,3
            ky = i + (j-1)*3
            ec(ky) = 0
!           do l = 1,3
 
               kyt1 = 3*j - 2!1 +(j-1)*3
               kyt2 = 3*j - 1!2 +(j-1)*3
               kyt3 = 3*j    !3 +(j-1)*3

               ec(ky) = ec(ky) + p1(kyo1)*tiu(kyt1)
               ec(ky) = ec(ky) + p1(kyo2)*tiu(kyt2)
               ec(ky) = ec(ky) + p1(kyo3)*tiu(kyt3)
!           enddo
         enddo
      enddo

      ec(1) = ec(1) + u001001
      ec(5) = ec(5) + u001001
      ec(9) = ec(9) + u001001

      END
C** BEGIN PRISM PPSS L2 STEP =========================================
C                    PPSS WITH BLAS
C=====================================================================
      SUBROUTINE imppss(
     &           ec     ,
     &           xyz    ,  ppss   , 
     &           mvhgp  ,  natom  , 
     &           iatom  ,  jatom  ,  katom  , latom  )

      IMPLICIT REAL(8)(a-h,o-z)
      DIMENSION xyz(3,natom)
      DIMENSION ppss(15)
      DIMENSION tiu(9),o1(9),p1(9)
      DIMENSION ec(mvhgp)
      
      tiu(1)= xyz(1,jatom)-xyz(1,iatom)
      tiu(4)= xyz(2,jatom)-xyz(2,iatom)
      tiu(7)= xyz(3,jatom)-xyz(3,iatom)
      tiu(2)= xyz(1,katom)-xyz(1,latom)
      tiu(5)= xyz(2,katom)-xyz(2,latom)
      tiu(8)= xyz(3,katom)-xyz(3,latom)
      tiu(3)= xyz(1,latom)-xyz(1,jatom)
      tiu(6)= xyz(2,latom)-xyz(2,jatom)
      tiu(9)= xyz(3,latom)-xyz(3,jatom)
      
      z112000= ppss( 1)
      z001000= ppss( 2)
      u203000= ppss( 3)
      u113000= ppss( 4)
      u012101= ppss( 5)
      u102101= ppss( 6)
      u002000= ppss( 7)
      u102000= ppss( 8)
      u012000= ppss( 9)
      d204000= ppss(10)
      d103101= ppss(11)
      d002202= ppss(12)
      d103000= ppss(13)
      d002101= ppss(14)
      d002000= ppss(15)
      
      o1(1)  = d204000 - u203000 + u113000 - z112000
      o1(2)  = d103101 - u102101
      o1(3)  = d103000 - u102000
      o1(4)  = d103101 + u012101
      o1(5)  = d002202
      o1(6)  = d002101
      o1(7)  = d103000 + u012000
      o1(8)  = d002101
      o1(9)  = d002000
      
      do2 = z001000 - u002000
      
      do jij=1,9
         p1(jij) = 0.0d0
      enddo

      do i=1,3
         kyo1 = i 
         kyo2 = i + 3
         kyo3 = i + 6

         do j=1,3
            ky = i + (j-1)*3
            p1(ky) = 0
!           do l = 1,3

            kyt1 = 3*j - 2
            kyt2 = 3*j - 1
            kyt3 = 3*j

            p1(ky) = p1(ky) + o1(kyo1)*tiu(kyt1)
            p1(ky) = p1(ky) + o1(kyo2)*tiu(kyt2)
            p1(ky) = p1(ky) + o1(kyo3)*tiu(kyt3)
!           enddo
         enddo
      enddo

      do i=1,3
               kyo1 = 1 +(i-1)*3
               kyo2 = 2 +(i-1)*3
               kyo3 = 3 +(i-1)*3
         do j=1,3
            ky = i + (j-1)*3
            ec(ky) = 0
!           do l = 1,3

               kyt1 = 3*j - 2
               kyt2 = 3*j - 1
               kyt3 = 3*j

               ec(ky) = ec(ky) + p1(kyo1)*tiu(kyt1)
               ec(ky) = ec(ky) + p1(kyo2)*tiu(kyt2)
               ec(ky) = ec(ky) + p1(kyo3)*tiu(kyt3)

!           enddo
         enddo
      enddo
      
      ec(1) = ec(1) + do2
      ec(5) = ec(5) + do2
      ec(9) = ec(9) + do2
      
      END
C** BEGIN PRISM PPPS L2 STEP =========================================
C                    PPPS WITH BLAS
C=====================================================================
      SUBROUTINE imppps(
     &           ec     ,
     &           xyz    ,  ppps   , 
     &           mvhgp  ,  natom  , 
     &           iatom  ,  jatom  ,  katom  , latom  )

      implicit real(8)(a-h,o-z)
      dimension xyz(3,natom)
      dimension ppps(47)
      dimension tiu(9),tkw(9)
      dimension o1(9),o2(9),o3(9),o4(3),o5(3),o6(3)
      dimension pps(27),p2(9),p3(9),b2(3),b3(3),p1(9)
      dimension ec(mvhgp)

      tiu(1)= xyz(1,jatom)-xyz(1,iatom)
      tiu(4)= xyz(2,jatom)-xyz(2,iatom)
      tiu(7)= xyz(3,jatom)-xyz(3,iatom)
      tiu(2)= xyz(1,katom)-xyz(1,latom)
      tiu(5)= xyz(2,katom)-xyz(2,latom)
      tiu(8)= xyz(3,katom)-xyz(3,latom)
      tiu(3)= xyz(1,latom)-xyz(1,jatom)
      tiu(6)= xyz(2,latom)-xyz(2,jatom)
      tiu(9)= xyz(3,latom)-xyz(3,jatom)
      tkw(1)=-tiu(1)
      tkw(4)=-tiu(4)
      tkw(7)=-tiu(7)
      tkw(2)=-tiu(2)
      tkw(5)=-tiu(5)
      tkw(8)=-tiu(8)
      tkw(3)=-tiu(3)
      tkw(6)=-tiu(6)
      tkw(9)=-tiu(9)

      d002001 =ppps( 1)
      d002011 =ppps( 2)
      d002102 =ppps( 3)
      d002112 =ppps( 4)
      d002213 =ppps( 5)
      d012001 =ppps( 6)
      d012102 =ppps( 7)
      d012203 =ppps( 8)
      d102001 =ppps( 9)
      d102102 =ppps(10)
      d102203 =ppps(11)
      d103001 =ppps(12)
      d103011 =ppps(13)
      d103112 =ppps(14)
      d113001 =ppps(15)
      d113102 =ppps(16)
      d203001 =ppps(17)
      d203102 =ppps(18)
      d204011 =ppps(19)
      d214001 =ppps(20)
      d304001 =ppps(21)
      t002001 =ppps(22)
      t002102 =ppps(23)
      t002203 =ppps(24)
      t002304 =ppps(25)
      t103001 =ppps(26)
      t103102 =ppps(27)
      t103203 =ppps(28)
      t204001 =ppps(29)
      t204102 =ppps(30)
      t305001 =ppps(31)
      u001001 =ppps(32)
      u001102 =ppps(33)
      u002011 =ppps(34)
      u012001 =ppps(35)
      u012011 =ppps(36)
      u012112 =ppps(37)
      u102001 =ppps(38)
      u102011 =ppps(39)
      u102112 =ppps(40)
      u112001 =ppps(41)
      u112102 =ppps(42)
      u113011 =ppps(43)
      u203011 =ppps(44)
      u213001 =ppps(45)
      z001011 =ppps(46)
      z112011 =ppps(47)
      
      o1(1)=+d214001+t305001-d304001-u213001
      o1(4)=+d113102+d204011+t204102+u113011
     &      -d203102-u112102-u203011-z112011
      o1(7)=+d113001+t204001-d203001-u112001
      o1(2)=+d113102+t204102
      o1(5)=+d012203+d103112+t103203+u012112
      o1(8)=+d012102+t103102
      o1(3)=+d113001+t204001
      o1(6)=+o1(8)  +d103011+u012011
      o1(9)=+d012001+t103001
      
      o2(1)=+t204102-d203102
      o2(4)=+d103112+t103203-d102203-u102112
      o2(7)=+t103102-d102102
      o2(2)=+t103203
      o2(5)=+d002213+t002304
      o2(8)=+t002203
      o2(3)=+t103102
      o2(6)=+d002112+t002203
      o2(9)=+t002102
      
      o3(1)=+t204001-d203001
      o3(4)=+d103011+o2(7)  -u102011
      o3(7)=+t103001-d102001
      o3(2)=+t103102
      o3(5)=+o2(6)
      o3(8)=+t002102
      o3(3)=+t103001
      o3(6)=+d002011+t002102
      o3(9)=+t002001               
      
      o4(1)=+u012001+d103001
      o4(2)=+d002102
      o4(3)=+d002001
      
      o5(1)=-u102001+d103001
      o5(2)=+d002102
      o5(3)=+d002001
      o6(1)=-o5(1)
      o6(2)=+z001011+u001102-u002011-d002102
      o6(3)=+u001001-d002001
      
      do i=1,3
         b2(i) = 0
         b3(i) = 0
         kyt1 = 3*i - 2 !1+(i-1)*3
         kyt2 = 3*i - 1 !2+(i-1)*3
         kyt3 = 3*i     !3+(i-1)*3

!        do l = 1,3

            b2(i) = b2(i) + tiu(kyt1)*o5(1)
            b3(i) = b3(i) + tkw(kyt1)*o6(1)
            b2(i) = b2(i) + tiu(kyt2)*o5(2)
            b3(i) = b3(i) + tkw(kyt2)*o6(2)
            b2(i) = b2(i) + tiu(kyt3)*o5(3)
            b3(i) = b3(i) + tkw(kyt3)*o6(3)
!        enddo
      enddo
      
c     call ipgemm (3,p1,o1,tkw)
c     call ipgemmt(3,o1,p1,tiu)
c     
c     call ipgemm (3,p1,o2,tkw)
c     call ipgemmt(3,o2,p1,tiu)
c     
c     call ipgemm (3,p1,o3,tkw)
c     call ipgemmt(3,o3,p1,tiu)
      
      
      do i=1,3
         kyo1 = i
         kyo2 = i + 3
         kyo3 = i + 6
         do j=1,3
            ky = i + (j-1) * 3
            p1(ky) = 0
            p2(ky) = 0
            p3(ky) = 0

            kyt1 = 3*j - 2
            kyt2 = 3*j - 1
            kyt3 = 3*j

!           do l = 1,3

               p1(ky) = p1(ky) + o1(kyo1) * tkw(kyt1)
               p1(ky) = p1(ky) + o1(kyo2) * tkw(kyt2)
               p1(ky) = p1(ky) + o1(kyo3) * tkw(kyt3)

               p2(ky) = p2(ky) + o2(kyo1) * tkw(kyt1)
               p2(ky) = p2(ky) + o2(kyo2) * tkw(kyt2)
               p2(ky) = p2(ky) + o2(kyo3) * tkw(kyt3)

               p3(ky) = p3(ky) + o3(kyo1) * tkw(kyt1)
               p3(ky) = p3(ky) + o3(kyo2) * tkw(kyt2)
               p3(ky) = p3(ky) + o3(kyo3) * tkw(kyt3)

!           enddo
         enddo
      enddo

      do i=1,3
         kyo1 = 3*i - 2
         kyo2 = 3*i - 1
         kyo3 = 3*i
         do j=1,3
            ky = i + (j-1) * 3
            o1(ky) = 0
            o2(ky) = 0
            o3(ky) = 0

            kyt1 = 3*j - 2
            kyt2 = 3*j - 1
            kyt3 = 3*j

            o1(ky) = o1(ky) + p1(kyo1) * tiu(kyt1)
            o1(ky) = o1(ky) + p1(kyo2) * tiu(kyt2)
            o1(ky) = o1(ky) + p1(kyo3) * tiu(kyt3)

            o2(ky) = o2(ky) + p2(kyo1) * tiu(kyt1)
            o2(ky) = o2(ky) + p2(kyo2) * tiu(kyt2)
            o2(ky) = o2(ky) + p2(kyo3) * tiu(kyt3)

            o3(ky) = o3(ky) + p3(kyo1) * tiu(kyt1)
            o3(ky) = o3(ky) + p3(kyo2) * tiu(kyt2)
            o3(ky) = o3(ky) + p3(kyo3) * tiu(kyt3)
!           enddo
         enddo
      enddo
      
      
      
!     call dgemm ('n','n',3,3,3,alpha,o1,3,tkw,3,beta,p1,3)
!     call dgemm ('t','n',3,3,3,alpha,p1,3,tiu,3,beta,o1,3)
!     
!     call dgemm ('n','n',3,3,3,alpha,o2,3,tkw,3,beta,p1,3)
!     call dgemm ('t','n',3,3,3,alpha,p1,3,tiu,3,beta,o2,3)
!     
!     call dgemm ('n','n',3,3,3,alpha,o3,3,tkw,3,beta,p1,3)
!     call dgemm ('t','n',3,3,3,alpha,p1,3,tiu,3,beta,o3,3)
      
      ec( 1) = o1(1)+o4(1)
      ec( 2) = o1(2)
      ec( 3) = o1(3)
      ec(10) = o2(1)+o4(2)
      ec(11) = o2(2)
      ec(12) = o2(3)
      ec(19) = o3(1)+o4(3)
      ec(20) = o3(2)
      ec(21) = o3(3)
      
      ec( 4) = o1(4)
      ec( 5) = o1(5)+o4(1)
      ec( 6) = o1(6)
      ec(13) = o2(4)
      ec(14) = o2(5)+o4(2)
      ec(15) = o2(6)
      ec(22) = o3(4)
      ec(23) = o3(5)+o4(3)
      ec(24) = o3(6)
      
      ec( 7) = o1(7)
      ec( 8) = o1(8)
      ec( 9) = o1(9)+o4(1)
      ec(16) = o2(7)
      ec(17) = o2(8)
      ec(18) = o2(9)+o4(2)
      ec(25) = o3(7)
      ec(26) = o3(8)
      ec(27) = o3(9)+o4(3)
      
      call ipgemm(9,pps,ec,tiu)
c     call dgemm ('n','n',9,3,3,alpha,ps,9,tiu,3,beta,pps,9)
      
      ec( 1) = pps( 1)      +b2(1)+b3(1)
      ec( 2) = pps( 2)+b3(2)
      ec( 3) = pps( 3)+b3(3)
      ec( 4) = pps( 4)+b2(2)
      ec( 5) = pps( 5)
      ec( 6) = pps( 6)
      ec( 7) = pps( 7)+b2(3)
      ec( 8) = pps( 8)
      ec( 9) = pps( 9)
      ec(10) = pps(10)
      ec(11) = pps(11)+b2(1)
      ec(12) = pps(12)
      ec(13) = pps(13)+b3(1)
      ec(14) = pps(14)+b2(2)+b3(2)
      ec(15) = pps(15)+b3(3)
      ec(16) = pps(16)
      ec(17) = pps(17)+b2(3)
      ec(18) = pps(18)
      ec(19) = pps(19)
      ec(20) = pps(20)
      ec(21) = pps(21)+b2(1)
      ec(22) = pps(22)
      ec(23) = pps(23)
      ec(24) = pps(24)+b2(2)
      ec(25) = pps(25)+b3(1)
      ec(26) = pps(26)+b3(2)
      ec(27) = pps(27)+b2(3)+b3(3)

      END
C** BEGIN PRISM PPPP L2 STEP =========================================
C                    PPPP WITH BLAS
C ====================================================================
      SUBROUTINE impppp(
     &           ec     ,
     &           xyz    ,  pppp   , 
     &           mvhgp  ,  natom  , 
     &           iatom  ,  jatom  ,  katom  , latom  )

      IMPLICIT REAL(8)(a-h,o-z)
      DIMENSION xyz(3,natom)
      DIMENSION pppp(148)
      DIMENSION tiu(9),tkw(9)
      DIMENSION o1(9),o2(9),o3(9),o4(9),o5(9),o6(9),o7(9),o8(9),o9(9)
      DIMENSION d1(9),d2(9),d3(9),d4(9),d5(9),d6(9)
      DIMENSION b2(9),b3(9),p1(9)
      DIMENSION ppp(81)
      DIMENSION ec(mvhgp)

      tiu(1)= xyz(1,jatom)-xyz(1,iatom)
      tiu(4)= xyz(2,jatom)-xyz(2,iatom)
      tiu(7)= xyz(3,jatom)-xyz(3,iatom)
      tiu(2)= xyz(1,katom)-xyz(1,latom)
      tiu(5)= xyz(2,katom)-xyz(2,latom)
      tiu(8)= xyz(3,katom)-xyz(3,latom)
      tiu(3)= xyz(1,latom)-xyz(1,jatom)
      tiu(6)= xyz(2,latom)-xyz(2,jatom)
      tiu(9)= xyz(3,latom)-xyz(3,jatom)
      tkw(1)=-tiu(1)
      tkw(4)=-tiu(4)
      tkw(7)=-tiu(7)
      tkw(2)=-tiu(2)
      tkw(5)=-tiu(5)
      tkw(8)=-tiu(8)
      tkw(3)=-tiu(3)
      tkw(6)=-tiu(6)
      tkw(9)=-tiu(9)

      d001002 =pppp(  1)
      d001103 =pppp(  2)
      d001204 =pppp(  3)
      d002001 =pppp(  4)
      d002002 =pppp(  5)
      d002012 =pppp(  6)
      d002102 =pppp(  7)
      d002112 =pppp(  8)
      d002113 =pppp(  9)
      d002203 =pppp( 10)
      d002213 =pppp( 11)
      d002314 =pppp( 12)
      d012002 =pppp( 13)
      d012012 =pppp( 14)
      d012102 =pppp( 15)
      d012103 =pppp( 16)
      d012113 =pppp( 17)
      d012203 =pppp( 18)
      d012214 =pppp( 19)
      d012304 =pppp( 20)
      d102002 =pppp( 21)
      d102012 =pppp( 22)
      d102102 =pppp( 23)
      d102103 =pppp( 24)
      d102113 =pppp( 25)
      d102203 =pppp( 26)
      d102214 =pppp( 27)
      d102304 =pppp( 28)
      d103001 =pppp( 29)
      d103012 =pppp( 30)
      d103102 =pppp( 31)
      d103112 =pppp( 32)
      d103213 =pppp( 33)
      d112002 =pppp( 34)
      d112103 =pppp( 35)
      d112204 =pppp( 36)
      d113002 =pppp( 37)
      d113012 =pppp( 38)
      d113102 =pppp( 39)
      d113113 =pppp( 40)
      d113203 =pppp( 41)
      d203002 =pppp( 42)
      d203012 =pppp( 43)
      d203102 =pppp( 44)
      d203113 =pppp( 45)
      d203203 =pppp( 46)
      d204001 =pppp( 47)
      d204112 =pppp( 48)
      d213002 =pppp( 49)
      d213103 =pppp( 50)
      d214012 =pppp( 51)
      d214102 =pppp( 52)
      d304012 =pppp( 53)
      d304102 =pppp( 54)
      d314002 =pppp( 55)
      f002002 =pppp( 56)
      f002103 =pppp( 57)
      f002204 =pppp( 58)
      f002305 =pppp( 59)
      f002406 =pppp( 60)
      f103002 =pppp( 61)
      f103103 =pppp( 62)
      f103204 =pppp( 63)
      f103305 =pppp( 64)
      f204002 =pppp( 65)
      f204103 =pppp( 66)
      f204204 =pppp( 67)
      f305002 =pppp( 68)
      f305103 =pppp( 69)
      f406002 =pppp( 70)
      t002002 =pppp( 71)
      t002012 =pppp( 72)
      t002102 =pppp( 73)
      t002103 =pppp( 74)
      t002113 =pppp( 75)
      t002203 =pppp( 76)
      t002204 =pppp( 77)
      t002214 =pppp( 78)
      t002304 =pppp( 79)
      t002315 =pppp( 80)
      t002405 =pppp( 81)
      t012002 =pppp( 82)
      t012103 =pppp( 83)
      t012204 =pppp( 84)
      t012305 =pppp( 85)
      t102002 =pppp( 86)
      t102103 =pppp( 87)
      t102204 =pppp( 88)
      t102305 =pppp( 89)
      t103002 =pppp( 90)
      t103012 =pppp( 91)
      t103102 =pppp( 92)
      t103103 =pppp( 93)
      t103113 =pppp( 94)
      t103203 =pppp( 95)
      t103214 =pppp( 96)
      t103304 =pppp( 97)
      t113002 =pppp( 98)
      t113103 =pppp( 99)
      t113204 =pppp(100)
      t203002 =pppp(101)
      t203103 =pppp(102)
      t203204 =pppp(103)
      t204002 =pppp(104)
      t204012 =pppp(105)
      t204102 =pppp(106)
      t204113 =pppp(107)
      t204203 =pppp(108)
      t214002 =pppp(109)
      t214103 =pppp(110)
      t304002 =pppp(111)
      t304103 =pppp(112)
      t305012 =pppp(113)
      t305102 =pppp(114)
      t315002 =pppp(115)
      t405002 =pppp(116)
      u001002 =pppp(117)
      u001012 =pppp(118)
      u001102 =pppp(119)
      u001113 =pppp(120)
      u001203 =pppp(121)
      u002001 =pppp(122)
      u002112 =pppp(123)
      u012001 =pppp(124)
      u012012 =pppp(125)
      u012102 =pppp(126)
      u012112 =pppp(127)
      u012213 =pppp(128)
      u102001 =pppp(129)
      u102012 =pppp(130)
      u102102 =pppp(131)
      u102112 =pppp(132)
      u102213 =pppp(133)
      u112002 =pppp(134)
      u112012 =pppp(135)
      u112102 =pppp(136)
      u112113 =pppp(137)
      u112203 =pppp(138)
      u113001 =pppp(139)
      u113112 =pppp(140)
      u203001 =pppp(141)
      u203112 =pppp(142)
      u213012 =pppp(143)
      u213102 =pppp(144)
      z001001 =pppp(145)
      z001112 =pppp(146)
      z112001 =pppp(147)
      z112112 =pppp(148)

      o1(1)= +f406002+t315002-d314002-t405002
      o1(4)= +d304102+f305103+t214103+u213102
     &       -d213103-d214102-t304103-t305102
      o1(7)= +f305002+t214002-d213002-t304002
      o1(2)= +d214012+f305103+t214103+t305012
     &       -d213103-d304012-t304103-u213012
      o1(5)= +d113113+d203203+f204204+t113204
     &       +t204113+u112203+u203112+z112112
     &       -d112204-d113203-d203113-d204112
     &       -t203204-t204203-u112113-u113112
      o1(8)= +d113012+f204103+t113103+t204012
     &       -d112103-d203012-t203103-u112012
      o1(3)= +o1(7)
      o1(6)= +d203102+f204103+t113103+u112102
     &       -d112103-d113102-t203103-t204102
      o1(9)= +f204002+t113002-d112002-t203002
 
      o2(1)= +f305103+t214103
      o2(4)= +f204204+t113204-d113203-t204203
      o2(7)= +f204103+t113103
      o2(2)= +d113113+f204204+t113204+t204113
      o2(5)= +d012214+f103305+t012305+t103214
     &       -d012304-d103213-t103304-u012213
      o2(8)= +d012113+f103204+t012204+t103113
      o2(3)= +o2(7)
      o2(6)= +f103204+t012204-d012203-t103203
      o2(9)= +f103103+t012103
 
      o3(1)= +f305002+t214002
      o3(4)= +o2(7)-d113102-t204102
      o3(7)= +f204002+t113002
      o3(2)= +d113012+o2(7)+t204012
      o3(5)= +o2(8)
     &       -d012203-d103112-t103203-u012112
      o3(8)= +d012012+o2(9)+t103012
      o3(3)= +o3(7)
      o3(6)= +o2(9)-d012102-t103102
      o3(9)= +f103002+t012002
 
      o4(1)= +f305103-t304103
      o4(4)= +d203203+f204204-t203204-t204203
      o4(7)= +f204103-t203103
      o4(2)= +f204204+t204113-d203113-t203204
      o4(5)= +d102304+f103305+t103214+u102213
     &       -d102214-d103213-t102305-t103304
      o4(8)= +f103204+t103113-d102113-t102204
      o4(3)= +o4(7)
      o4(6)= +d102203+f103204-t102204-t103203
      o4(9)= +f103103-t102103
 
      o5(1)= +f204204
      o5(4)= +f103305-t103304
      o5(7)= +f103204
      o5(2)= +f103305+t103214
      o5(5)= +f002406+t002315-d002314-t002405
      o5(8)= +f002305+t002214
      o5(3)= +f103204
      o5(6)= +f002305-t002304
      o5(9)= +f002204
 
      o6(1)= +f204103
      o6(4)= +f103204-t103203
      o6(7)= +f103103
      o6(2)= +f103204+t103113
      o6(5)= +o5(8)  -d002213-t002304
      o6(8)= +f002204+t002113
      o6(3)= +f103103
      o6(6)= +f002204-t002203
      o6(9)= +f002103
 
      o7(1)= +f305002-t304002
      o7(4)= +d203102+o4(7)  -t204102
      o7(7)= +f204002-t203002
      o7(2)= +o4(7)  +t204012-d203012
      o7(5)= +d102203+u102112+o4(8)
     &       -d103112-t103203
      o7(8)= +o4(9)  +t103012-d102012
      o7(3)= +o7(7)
      o7(6)= +d102102+o4(9)  -t103102
      o7(9)= +f103002-t102002
 
      o8(1)= +o6(1)
      o8(4)= +o6(4)
      o8(7)= +o6(7)
      o8(2)= +o6(2)
      o8(5)= +o6(5)
      o8(8)= +o6(8)
      o8(3)= +o6(3)
      o8(6)= +o6(6)
      o8(9)= +o6(9)
 
      o9(1)= +f204002
      o9(4)= +f103103-t103102
      o9(7)= +f103002
      o9(2)= +f103103+t103012
      o9(5)= +o6(6)  +t002113-d002112
      o9(8)= +f002103+t002012
      o9(3)= +f103002
      o9(6)= +f002103-t002102
      o9(9)= +f002002
c  delta1 d_kl          
      d1(1)=-z112001+u112002+u113001-d113002
     &      -u203001+d203002+d204001-t204002
      d1(2)=-u102102+d102103+d103102-t103103
      d1(3)=-u102001+d102002+d103001-t103002
      d1(4)=+u012102-d012103+d103102-t103103
      d1(5)=+d002203-t002204
      d1(6)=+d002102-t002103
      d1(7)=+u012001-d012002+d103001-t103002
      d1(8)=+d1(6)
      d1(9)=+d002001-t002002
c  delta2 d_jl          
      d2(1)=+d113002+t204002
      d2(2)=+t103103
      d2(3)=+t103002
      d2(4)=+u012012+d012103+d103012+t103103
      d2(5)=+d002113+t002204
      d2(6)=+d002012+t002103
      d2(7)=+d012002+t103002
      d2(8)=+t002103
      d2(9)=+t002002          
c  delta3 d_jk          
      d3(1)=+d2(1)
      d3(2)=+t103103
      d3(3)=+t103002
      d3(4)=-d1(4)
      d3(5)=-d1(5)
      d3(6)=-d1(6)
      d3(7)=+d2(7)
      d3(8)=+t002103
      d3(9)=+t002002          
c  delta4 d_il
      d4(1)=+t204002-d203002
      d4(4)=+d103012+t103103-d102103-u102012
      d4(7)=+t103002-d102002
      d4(2)=+t103103
      d4(5)=+d2(5)
      d4(8)=+t002103
      d4(3)=+t103002
      d4(6)=+d2(6)
      d4(9)=+t002002 
c  delta5 d_ik
      d5(1)=+d4(1)
      d5(4)=-d1(2)
      d5(7)=+d4(7)
      d5(2)=+t103103
      d5(5)=+d3(5)
      d5(8)=+t002103
      d5(3)=+t103002
      d5(6)=+d3(6)
      d5(9)=+t002002
c  delta6 d_ij        
      d6(1)=-d4(1)
      d6(4)=+d1(2)
      d6(7)=-d4(7)
      d6(2)=-d4(4)
      d6(5)=+d001204+u001113-u001203-z001112
     &      -d2(5)  +d002203+u002112
      d6(8)=+d001103+u001012-d2(6)
      d6(3)=-d4(7)
      d6(6)=+d001103-u001102-d3(6)
      d6(9)=+d001002-t002002
 
c  delta7 d_il and d_jk
      d7 = d002002
c  delta8 d_ik and d_jl
      d8 = d002002
c  delta9 d_ij and d_kl
      d9 = z001001-u001002-u002001+d002002
 
c delta ssss-->ppss in blas 
      
      call ipgemm (3,p1,d4,tkw)
      call ipgemmt(3,d4,p1,tiu)
      call ipgemm (3,p1,d5,tkw)
      call ipgemmt(3,d5,p1,tiu)
      call ipgemm (3,p1,d6,tkw)
      call ipgemmt(3,d6,p1,tkw)
!     call dgemm ('n','n',3,3,3,alpha,d4,3,tkw,3,beta,p1,3)
!     call dgemm ('t','n',3,3,3,alpha,p1,3,tiu,3,beta,d4,3)
!     
!     call dgemm ('n','n',3,3,3,alpha,d5,3,tkw,3,beta,p1,3)
!     call dgemm ('t','n',3,3,3,alpha,p1,3,tiu,3,beta,d5,3)
!     
!     call dgemm ('n','n',3,3,3,alpha,d6,3,tkw,3,beta,p1,3)
!     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,d6,3)
              
c ssss-->ppss in blas 
      call ipgemm (3,p1,o1,tkw)
      call ipgemmt(3,o1,p1,tkw)

      call ipgemm (3,p1,o2,tkw)
      call ipgemmt(3,o2,p1,tkw)

      call ipgemm (3,p1,o3,tkw)
      call ipgemmt(3,o3,p1,tkw)

      call ipgemm (3,p1,o4,tkw)
      call ipgemmt(3,o4,p1,tkw)

      call ipgemm (3,p1,o5,tkw)
      call ipgemmt(3,o5,p1,tkw)

      call ipgemm (3,p1,o6,tkw)
      call ipgemmt(3,o6,p1,tkw)

      call ipgemm (3,p1,o7,tkw)
      call ipgemmt(3,o7,p1,tkw)

      call ipgemm (3,p1,o8,tkw)
      call ipgemmt(3,o8,p1,tkw)

      call ipgemm (3,p1,o9,tkw)
      call ipgemmt(3,o9,p1,tkw)

c     call dgemm ('n','n',3,3,3,alpha,o1,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o1,3)

c     call dgemm ('n','n',3,3,3,alpha,o2,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o2,3)
c
c     call dgemm ('n','n',3,3,3,alpha,o3,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o3,3)
c     
c     call dgemm ('n','n',3,3,3,alpha,o4,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o4,3)

c     call dgemm ('n','n',3,3,3,alpha,o5,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o5,3)
c
c     call dgemm ('n','n',3,3,3,alpha,o6,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o6,3)
c     
c     call dgemm ('n','n',3,3,3,alpha,o7,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o7,3)

c     call dgemm ('n','n',3,3,3,alpha,o8,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o8,3)
c
c     call dgemm ('n','n',3,3,3,alpha,o9,3,tkw,3,beta,p1,3)
c     call dgemm ('t','n',3,3,3,alpha,p1,3,tkw,3,beta,o9,3)

c   blased o1 change suitable form for ppss-->ppps
      ec( 1) = o1(1)+d1(1)
      ec( 2) = o1(2)
      ec( 3) = o1(3)
      ec(28) = o2(1)+d1(4)
      ec(29) = o2(2)
      ec(30) = o2(3)
      ec(55) = o3(1)+d1(7)
      ec(56) = o3(2)
      ec(57) = o3(3)
            
      ec( 4) = o1(4)
      ec( 5) = o1(5)+d1(1)
      ec( 6) = o1(6)     
      ec(31) = o2(4)     
      ec(32) = o2(5)+d1(4)
      ec(33) = o2(6)     
      ec(58) = o3(4)     
      ec(59) = o3(5)+d1(7)
      ec(60) = o3(6)
          
      ec( 7) = o1(7)
      ec( 8) = o1(8)
      ec( 9) = o1(9)+d1(1)
      ec(34) = o2(7)     
      ec(35) = o2(8)     
      ec(36) = o2(9)+d1(4)
      ec(61) = o3(7)     
      ec(62) = o3(8)     
      ec(63) = o3(9)+d1(7)
          
      ec(10) = o4(1)+d1(2)
      ec(11) = o4(2)
      ec(12) = o4(3)
      ec(37) = o5(1)+d1(5)
      ec(38) = o5(2)
      ec(39) = o5(3)
      ec(64) = o6(1)+d1(8)
      ec(65) = o6(2)
      ec(66) = o6(3)
          
      ec(13) = o4(4)
      ec(14) = o4(5)+d1(2)
      ec(15) = o4(6)
      ec(40) = o5(4)
      ec(41) = o5(5)+d1(5)
      ec(42) = o5(6)
      ec(67) = o6(4)
      ec(68) = o6(5)+d1(8)
      ec(69) = o6(6)
          
      ec(16) = o4(7)
      ec(17) = o4(8)
      ec(18) = o4(9)+d1(2)
      ec(43) = o5(7)
      ec(44) = o5(8)
      ec(45) = o5(9)+d1(5)
      ec(70) = o6(7)
      ec(71) = o6(8)
      ec(72) = o6(9)+d1(8)               
          
      ec(19) = o7(1)+d1(3)
      ec(20) = o7(2)
      ec(21) = o7(3)
      ec(46) = o8(1)+d1(6)
      ec(47) = o8(2)
      ec(48) = o8(3)
      ec(73) = o9(1)+d1(9)
      ec(74) = o9(2)
      ec(75) = o9(3)
          
      ec(22) = o7(4)
      ec(23) = o7(5)+d1(3)
      ec(24) = o7(6)
      ec(49) = o8(4)
      ec(50) = o8(5)+d1(6)
      ec(51) = o8(6)
      ec(76) = o9(4)
      ec(77) = o9(5)+d1(9)
      ec(78) = o9(6)
          
      ec(25) = o7(7)
      ec(26) = o7(8)
      ec(27) = o7(9)+d1(3)
      ec(52) = o8(7)
      ec(53) = o8(8)
      ec(54) = o8(9)+d1(6)
      ec(79) = o9(7)
      ec(80) = o9(8)
      ec(81) = o9(9)+d1(9)                

c ppss-->ppps in blas 

      call ipgemm (27,ppp,ec,tiu)
c          call dgemm ('n','n',27,3,3,alpha,pp,27,tiu,3,beta,ppp,27)

c  blased o1 change suitable form for ppps-->pppp
      call ipgemm (3,b2,d2,tkw)
      call ipgemm (3,b3,d3,tkw)
c              call dgemm ('n','n',3,3,3,alpha,d2,3,tkw,3,beta,b2,3)
c              call dgemm ('n','n',3,3,3,alpha,d3,3,tkw,3,beta,b3,3)


      ec( 1) = ppp( 1)+b2(1)+b3(1)
      ec( 2) = ppp( 2)      +b3(4)
      ec( 3) = ppp( 3)      +b3(7)
      ec(28) = ppp(10)+b2(2)+b3(2)
      ec(29) = ppp(11)      +b3(5)
      ec(30) = ppp(12)      +b3(8)
      ec(55) = ppp(19)+b2(3)+b3(3)
      ec(56) = ppp(20)      +b3(6)
      ec(57) = ppp(21)      +b3(9)
      ec( 4) = ppp(28)
      ec( 5) = ppp(29)+b2(1)
      ec( 6) = ppp(30)
      ec(31) = ppp(37)
      ec(32) = ppp(38)+b2(2)
      ec(33) = ppp(39)
      ec(58) = ppp(46)
      ec(59) = ppp(47)+b2(3)
      ec(60) = ppp(48)
          
      ec( 7) = ppp(55)
      ec( 8) = ppp(56)
      ec( 9) = ppp(57)+b2(1)
      ec(34) = ppp(64)
      ec(35) = ppp(65)
      ec(36) = ppp(66)+b2(2)
      ec(61) = ppp(73)
      ec(62) = ppp(74)
      ec(63) = ppp(75)+b2(3)
                  
      ec(10) = ppp( 4)+b2(4)
      ec(11) = ppp( 5)
      ec(12) = ppp( 6)
      ec(37) = ppp(13)+b2(5)
      ec(38) = ppp(14)
      ec(39) = ppp(15)
      ec(64) = ppp(22)+b2(6)
      ec(65) = ppp(23)
      ec(66) = ppp(24)
                  
      ec(13) = ppp(31)      +b3(1)
      ec(14) = ppp(32)+b2(4)+b3(4)
      ec(15) = ppp(33)      +b3(7)
      ec(40) = ppp(40)      +b3(2)
      ec(41) = ppp(41)+b2(5)+b3(5)
      ec(42) = ppp(42)      +b3(8)
      ec(67) = ppp(49)      +b3(3)
      ec(68) = ppp(50)+b2(6)+b3(6)
      ec(69) = ppp(51)      +b3(9)
                  
      ec(16) = ppp(58)
      ec(17) = ppp(59)
      ec(18) = ppp(60)+b2(4)
      ec(43) = ppp(67)
      ec(44) = ppp(68)
      ec(45) = ppp(69)+b2(5)
      ec(70) = ppp(76)
      ec(71) = ppp(77)
      ec(72) = ppp(78)+b2(6)               
                  
      ec(19) = ppp( 7)+b2(7)
      ec(20) = ppp( 8)
      ec(21) = ppp( 9)
      ec(46) = ppp(16)+b2(8)
      ec(47) = ppp(17)
      ec(48) = ppp(18)
      ec(73) = ppp(25)+b2(9)
      ec(74) = ppp(26)
      ec(75) = ppp(27)
                  
      ec(22) = ppp(34)
      ec(23) = ppp(35)+b2(7)
      ec(24) = ppp(36)
      ec(49) = ppp(43)
      ec(50) = ppp(44)+b2(8)
      ec(51) = ppp(45)
      ec(76) = ppp(52)
      ec(77) = ppp(53)+b2(9)
      ec(78) = ppp(54)
                  
      ec(25) = ppp(61)      +b3(1)
      ec(26) = ppp(62)      +b3(4)
      ec(27) = ppp(63)+b2(7)+b3(7)
      ec(52) = ppp(70)      +b3(2)
      ec(53) = ppp(71)      +b3(5)
      ec(54) = ppp(72)+b2(8)+b3(8)
      ec(79) = ppp(79)      +b3(3)
      ec(80) = ppp(80)      +b3(6)
      ec(81) = ppp(81)+b2(9)+b3(9)

c ppps-->pppp in blas 
      call ipgemm (27,ppp,ec,tiu)
c             call dgemm ('n','n',27,3,3,alpha,pp,27,tiu,3,beta,ppp,27)

      ec( 1) =ppp( 1)+d4(1)+d5(1)+d6(1)+d7+d8+d9
      ec( 2) =ppp( 2)      +d5(2)+d6(2)
      ec( 3) =ppp( 3)      +d5(3)+d6(3)
      ec( 4) =ppp(10)+d4(2)      +d6(4)
      ec( 5) =ppp(11)            +d6(5)      +d9
      ec( 6) =ppp(12)            +d6(6)
      ec( 7) =ppp(19)+d4(3)      +d6(7)
      ec( 8) =ppp(20)            +d6(8)
      ec( 9) =ppp(21)            +d6(9)      +d9
      ec(10) =ppp( 4)+d4(4)+d5(4)
      ec(11) =ppp( 5)      +d5(5)         +d8
      ec(12) =ppp( 6)      +d5(6)
      ec(13) =ppp(13)+d4(5)            +d7
      ec(14) =ppp(14)      
      ec(15) =ppp(15)      
      ec(16) =ppp(22)+d4(6)
      ec(17) =ppp(23)
      ec(18) =ppp(24)
      ec(19) =ppp( 7)+d4(7)+d5(7) 
      ec(20) =ppp( 8)      +d5(8)
      ec(21) =ppp( 9)      +d5(9)         +d8
      ec(22) =ppp(16)+d4(8)      
      ec(23) =ppp(17)      
      ec(24) =ppp(18)      
      ec(25) =ppp(25)+d4(9)            +d7
      ec(26) =ppp(26)
      ec(27) =ppp(27)
      ec(28) =ppp(28)
      ec(29) =ppp(29)+d4(1)            +d7
      ec(30) =ppp(30)
      ec(31) =ppp(37)      +d5(1)         +d8
      ec(32) =ppp(38)+d4(2)+d5(2)
      ec(33) =ppp(39)      +d5(3)
      ec(34) =ppp(46)      
      ec(35) =ppp(47)+d4(3)      
      ec(36) =ppp(48)            
      ec(37) =ppp(31)            +d6(1)      +d9
      ec(38) =ppp(32)+d4(4)      +d6(2)         
      ec(39) =ppp(33)            +d6(3)         
      ec(40) =ppp(40)      +d5(4)+d6(4)         
      ec(41) =ppp(41)+d4(5)+d5(5)+d6(5)+d7+d8+d9
      ec(42) =ppp(42)      +d5(6)+d6(6)         
      ec(43) =ppp(49)            +d6(7)         
      ec(44) =ppp(50)+d4(6)      +d6(8)         
      ec(45) =ppp(51)            +d6(9)      +d9
      ec(46) =ppp(34)      
      ec(47) =ppp(35)+d4(7)      
      ec(48) =ppp(36)            
      ec(49) =ppp(43)      +d5(7)
      ec(50) =ppp(44)+d4(8)+d5(8)
      ec(51) =ppp(45)      +d5(9)         +d8
      ec(52) =ppp(52)      
      ec(53) =ppp(53)+d4(9)            +d7
      ec(54) =ppp(54)
      ec(55) =ppp(55)
      ec(56) =ppp(56)
      ec(57) =ppp(57)+d4(1)            +d7
      ec(58) =ppp(64)
      ec(59) =ppp(65)
      ec(60) =ppp(66)+d4(2)
      ec(61) =ppp(73)      +d5(1)         +d8
      ec(62) =ppp(74)      +d5(2)
      ec(63) =ppp(75)+d4(3)+d5(3)
      ec(64) =ppp(58)      
      ec(65) =ppp(59)            
      ec(66) =ppp(60)+d4(4)      
      ec(67) =ppp(67)      
      ec(68) =ppp(68)            
      ec(69) =ppp(69)+d4(5)            +d7
      ec(70) =ppp(76)      +d5(4)
      ec(71) =ppp(77)      +d5(5)         +d8
      ec(72) =ppp(78)+d4(6)+d5(6)
      ec(73) =ppp(61)            +d6(1)      +d9
      ec(74) =ppp(62)            +d6(2)         
      ec(75) =ppp(63)+d4(7)      +d6(3)         
      ec(76) =ppp(70)            +d6(4)         
      ec(77) =ppp(71)            +d6(5)      +d9
      ec(78) =ppp(72)+d4(8)      +d6(6)         
      ec(79) =ppp(79)      +d5(7)+d6(7)         
      ec(80) =ppp(80)      +d5(8)+d6(8)         
      ec(81) =ppp(81)+d4(9)+d5(9)+d6(9)+d7+d8+d9

      END
CC IPGEMM===========================================================
C   LEVEL3 BLAS            DGEMM
C ==================================================================

      SUBROUTINE ipgemm (n,p1,o1,tiu)
      
      IMPLICIT REAL(8)(a-h,o-z)
      DIMENSION p1(3*n),o1(3*n),tiu(9)

!     do i=1,n
!        do j=1,3
!           ky = i + (j-1)*n
!           p1(ky) = 0
!           do l = 1,3
!              kyo = i +(l-1)*n
!              kyt = l +(j-1)*3
!              p1(ky) = p1(ky) + o1(kyo)*tiu(kyt)
!           enddo
!        enddo
!     enddo

      do i=1,n
         kyo1= i
         kyo2= i +      n
         kyo3= i +   2 *n

         do j=1,3
            ky = i + (j-1)*n
            p1(ky) = 0
               kyt1= 1 +(j-1)*3
               kyt2= 2 +(j-1)*3
               kyt3= 3 +(j-1)*3

!              kyt1= 3*j - 2 !1 +(j-1)*3
!              kyt2= 3*j - 1 !2 +(j-1)*3
!              kyt3= 3*j     !3 +(j-1)*3




               p1(ky) = p1(ky) + o1(kyo1)*tiu(kyt1)
               p1(ky) = p1(ky) + o1(kyo2)*tiu(kyt2)
               p1(ky) = p1(ky) + o1(kyo3)*tiu(kyt3)

         enddo
      enddo

c     do i = 1,n
c        ky1= i
c        ky2= i +       n
c        ky3= i +   2 * n

c        p1(ky1) = 0
c        p1(ky2) = 0
c        p1(ky3) = 0

c     p1(ky1) = p1(ky1) + o1(ky1)*tiu(1)+ o1(ky2)*tiu(2)+ o1(ky3)*tiu(3)
c     p1(ky2) = p1(ky2) + o1(ky1)*tiu(4)+ o1(ky2)*tiu(5)+ o1(ky3)*tiu(6)
c     p1(ky3) = p1(ky3) + o1(ky1)*tiu(7)+ o1(ky2)*tiu(8)+ o1(ky3)*tiu(9)


c     enddo

c     do i = 1, n
c        kyo1 = i 
c        kyo2 = i + n
c        kyo3 = i + 2 * n
c        do j = 1, 3
c           ky = i + (j - 1) * n
c           p1 (ky) = 0
c   
c           kyt1 = 1 + (j - 1) * 3
c           kyt2 = 2 + (j - 1) * 3
c           kyt3 = 3 + (j - 1) * 3
    
!           p1 (ky) = p1 (ky) + o1 (kyo1) * tiu (kyt1)
!           p1 (ky) = p1 (ky) + o1 (kyo2) * tiu (kyt2)
!           p1 (ky) = p1 (ky) + o1 (kyo3) * tiu (kyt3)

c           p1 (ky) = p1 (ky) + o1 (kyo1) * tiu (kyt1)
c    &                        + o1 (kyo2) * tiu (kyt2)
c    &                        + o1 (kyo3) * tiu (kyt3)
c   
c        enddo
c     enddo

      END

CC IPGEMM===========================================================
C   LEVEL3 BLAS            DGEMM   TRANS A
C ==================================================================

      SUBROUTINE ipgemmt(n,p1,o1,tiu)
      
      IMPLICIT REAL(8)(a-h,o-z)
      DIMENSION p1(9),o1(9),tiu(9)
      
!     do i=1,n
!        do j=1,3
!           ky = i + (j-1)*3
!           p1(ky) = 0
!           do l = 1,3
!              kyo = l +(i-1)*3
!              kyt = l +(j-1)*3
!              p1(ky) = p1(ky) + o1(kyo)*tiu(kyt)
!           enddo
!        enddo
!     enddo

      do i = 1, n
            kyo1 = 3*i - 2
            kyo2 = 3*i - 1
            kyo3 = 3*i
         do j = 1, 3
    
            ky = i + (j - 1) * 3
            p1 (ky) = 0
    
            kyt3 = 3*j
            kyt2 = kyt3 - 1
            kyt1 = kyt3 - 2
    
            p1 (ky) = p1 (ky) + o1 (kyo1) * tiu (kyt1) 
     &                        + o1 (kyo2) * tiu (kyt2) 
     &                        + o1 (kyo3) * tiu (kyt3)
        enddo
      enddo

      END
      
