! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
C IVRRGR==============================================================
C
C GET  ANGULAR MOMENTUM (IJKL) SET  --NRED
C AND NUMBER OF OPERAND FOR VRR OPERATION TABLE
C 
C==================================================================== 
      SUBROUTINE IVRRGR( ITCOD ,JTCOD ,KTCOD ,LTCOD ,
     &                   NRED  ,NA    ,NOW   ,
     &                   IR    ,       IFLAG1,IFLAG2  )
  
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED(10,NA)

      now = 0

      DO 1300 I=1,NA
        DO 1200 J=1,10
          NRED (J,I)  = 0
 1200   CONTINUE
 1300 CONTINUE

      IF(IFLAG1. NE .0) THEN
         ITCODV   = ITCOD + JTCOD - 1
         JTCODV   = 1
      ELSE
         ITCODV   = ITCOD
         JTCODV   = JTCOD
      END IF
      IF(IFLAG2. NE .0) THEN
         KTCODV   = KTCOD + LTCOD - 1
         LTCODV   = 1
      ELSE
         KTCODV   = KTCOD
         LTCODV   = LTCOD
      END IF

C---GET A SEQUENCE OF VRR REDUCTION
      NRED(1,1)   = ITCODV
      NRED(2,1)   = JTCODV
      NRED(3,1)   = KTCODV
      NRED(4,1)   = LTCODV
      NRED(5,1)   = 1
      NRED(6,1)   = 1
      NRED(7,1)   = 1
      NRED(8,1)   = ITCODV+JTCODV+KTCODV+LTCODV
      NRED(9,1)   = (ITCODV*(ITCODV+1)/2)*(JTCODV*(JTCODV+1)/2)
     &                  *(KTCODV*(KTCODV+1)/2)*(LTCODV*(LTCODV+1)/2)
      NRED(10,1)  = 1
      IR   = 1

      DO 4000 I = 1,NA
        IREDPT   = 1
        DO 2010 II = 4,1,-1
 
          IF(NRED(II,I). GT .1) THEN
            IREDPT   = II
            GOTO 3000
          ENDIF
 2010   CONTINUE
C
 3000   NRED (10,I)  = IREDPT
        ICOD   = NRED(1,I)
        JCOD   = NRED(2,I)
        KCOD   = NRED(3,I)
        LCOD   = NRED(4,I)

        select case(iredpt)

        case(1)
C REDUCE A
          IF(ICOD. LE .1) GOTO 3500
          CALL IVRRAB(ICOD-1 ,JCOD ,KCOD ,LCOD ,NRED  ,NA    ,
     &                I     ,IR    ,IFLAG1 )!,IERR  ,LNPRN )

          mi = icod*(icod+1)/2
          mim= icod*(icod-1)/2

          if (mim.le.1) then
            mim = 0
          endif

          num = mi * 2 + mim * 2

          now = now + nred(7,i)*num

        case(2)
C REDUCE B
          IF(JCOD. LE .1) GOTO 3500
          CALL IVRRAB(ICOD ,JCOD-1 ,KCOD ,LCOD ,NRED  ,NA    ,
     &                I     ,IR    ,IFLAG1 )!,IERR  ,LNPRN )
          mi = icod*(icod+1)/2
          mim= icod*(icod-1)/2
          mj = jcod*(jcod+1)/2
          mjm= jcod*(jcod-1)/2

          if (jcod.le.2) then
           mjm = 0
          endif

          num = mi*mj*2 + 2*(mim*mj + mjm *mi)
! a: mm(jcod)*mm(icod-1) ,b:mm(icod-1)*mm(jcod)
          now = now + nred(7,i)*num 

        case(3)
C REDUCE C
          IF(KCOD. LE .1) GOTO 3500
          CALL IVRRCD(ICOD ,JCOD ,KCOD-1 ,LCOD ,NRED  ,NA    ,
     &                I     ,IR    ,IFLAG2 )!,IERR  ,LNPRN )

          mi  = icod * (icod+1) / 2
          mim = icod * (icod-1) / 2
          mj  = jcod * (jcod+1) / 2
          mjm = jcod * (jcod-1) / 2
          mk  = kcod * (kcod+1) / 2
          mkm = kcod * (kcod-1) / 2

          ma = mim * mj * mk
          mb = mi  * mjm* mk
          mc = mi  * mj * mkm

          if (kcod.le.2) mc = 0

          num = mi*mj*mk*2 +  ma + mb + 2*mc

          now = now + nred(7,i) * num

        case(4)
C REDUCE D
          IF(LCOD. LE .1) GOTO 3500
          CALL IVRRCD(ICOD ,JCOD ,KCOD ,LCOD-1 ,NRED  ,NA    ,
     &                I     ,IR    ,IFLAG2 )!,IERR  ,LNPRN )

          mi  = icod * (icod+1) / 2
          mim = icod * (icod-1) / 2
          mj  = jcod * (jcod+1) / 2
          mjm = jcod * (jcod-1) / 2
          mk  = kcod * (kcod+1) / 2
          mkm = kcod * (kcod-1) / 2
          ml  = lcod * (lcod+1) / 2
          mlm = lcod * (lcod-1) / 2

          ma = mim * mj * mk  * ml
          mb = mi  * mjm* mk  * ml
          mc = mi  * mj * mkm * ml
          md = mi  * mj * mk  * mlm
 
          if (lcod.le.2) md = 0

          num = mi*mj*mk*ml*2 + ma + mb + 2*(mc +md)

          now = now + nred(7,i) * num

          end select
 3500  IF(I. GE .IR) GOTO 5000
 4000 CONTINUE
   
 5000 continue
      end
   
C====================================================================
C GENERATES VRR OPERATION TABLE
C
C IF IJ,OR,KL PAIR IS SAME SHELL PAIR, (IJ,KL) IS MODEFIED TO
C ((I+J-1)0,(K+L-1)0).
C
C -INPUT-
C     ITCOD,JTCOD,KTCOD,LTCOD
C                 :SHELL TYPE CODES FOR SHELL I,J,K,L
C        NA       :MAXCOD**4
C        NBFSZ    :2*MAXCOD**4 + 4*MAXCOD*MAXCMP
C
C -OUTPUT-
C        NVTBL    :VRR OPERATION TABLR
C
C==================================================================== 
      subroutine ivrrgt  (nred,na,nvtbl,nv,nbf,nbfsz,
     &                     ir,maxcod,issss,ninto,nv2 )

      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED(10,NA),nvtbl(3,nv),nbf(nbfsz)

      iflag1 = 0
      iflag2 = 0
      IERR = 0
c      LNPRN = 16

C
C---GET VRR OPERATION TABLE
C
C SORT REDUCTION TABLE
C     CALL IVSORT(NRED  ,NA    ,IR    ,NBF   )
C
      MAXCMP   = MAXCOD*(MAXCOD+1) / 2
C
C GET ADDRESS TABLE
      MAXCD4   = MAXCOD**4

      CALL IVADDR(NRED  ,NA    ,NBF   ,MAXCOD,IR    ,NINTO  ,ISSSS  )

C
C GET VRR TABLE

      IV   = 1

      CALL IVRRTL(NRED  ,NA    ,NBF   ,MAXCOD,NVTBL ,NV    ,
     &            NBF(2*MAXCD4+1)     ,MAXCMP,IFLAG1,IFLAG2,
     &            IV    ,IR-1  ,2      )!,IERR  ,LNPRN    )
      NV2   = IV - 1

C GET VRR TABLE
C   FOR THE LAST INTEGRAL TYPE
      CALL IVRRTL(NRED  ,NA    ,NBF   ,MAXCOD,NVTBL ,NV    ,
     &            NBF(2*MAXCD4+1)     ,MAXCMP,IFLAG1,IFLAG2,
     &            IV    ,1     ,1      )!,IERR  ,LNPRN )
C
      IV   = IV - 1

      END
C## IVRRAB ========================================================== =*
C    REDUCE <(A-1)B,CD> OR <A(B-1),CD>
C       ITCOD   : SHELL TYPE CODE OF A-1 OR A
C       JTCOD   : SHELL TYPE CODE OF B   OR B-1
C       KTCOD   : SHELL TYPE CODE OF C
C       LTCOD   : SHELL TYPE CODE OF D
C
C======================================================================*
      SUBROUTINE IVRRAB(ITCOD ,JTCOD ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &                  INOW  ,IR    ,IFLAG1 )!,IERR  ,LNPRN)
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED (10,NA)
C
      MS   = NRED (5,INOW)
      ME   = NRED (6,INOW)
      NM   = NRED (7,INOW)
C
C <AB,CD>
      IF(IFLAG1.NE.0) THEN
        CALL IVCHCK(ITCOD ,JTCOD ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &              IR    ,MS+1  ,ME+1  ,NM     )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
      else
        call ivchck(itcod ,jtcod ,ktcod ,ltcod ,nred  ,na    ,
     &              IR    ,MS    ,ME+1  ,NM+1   )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
      END IF
C <(A-1)B,CD>
      IF(ITCOD. LT .2) GOTO 1000
      CALL IVCHCK(ITCOD-1      ,JTCOD ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &            IR    ,MS    ,ME+1  ,NM+1   )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
C <A(B-1),CD>
 1000 IF(JTCOD. LT .2) GOTO 2000
      CALL IVCHCK(ITCOD ,JTCOD-1      ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &            IR    ,MS    ,ME+1  ,NM+1   )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
C <AB,(C-1)D>
 2000 IF(KTCOD. LT .2) GOTO 3000
      CALL IVCHCK(ITCOD ,JTCOD ,KTCOD-1      ,LTCOD ,NRED  ,NA    ,
     &            IR    ,MS+1  ,ME+1  ,NM     )!, IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
C <AB,C(D-1)>
 3000 IF(LTCOD. LT .2) GOTO 9999
      CALL IVCHCK(ITCOD ,JTCOD ,KTCOD ,LTCOD-1      ,NRED  ,NA    ,
     &            IR    ,MS+1  ,ME+1  ,NM     )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
C
      GOTO 9999
C
c 9000 WRITE(LNPRN,8900)
c 8900 FORMAT('          CALLED FROM IVRRAB ')
C
 9999 RETURN
      END
C## IVRRCD ========================================================== =*
C    REDUCE <AB,(C-1)D> OR <AB,C(D-1)>
C       ITCOD   : SHELL TYPE CODE OF A
C       JTCOD   : SHELL TYPE CODE OF B
C       KTCOD   : SHELL TYPE CODE OF C-1 OR C
C       LTCOD   : SHELL TYPE CODE OF D   OR D-1
C
C======================================================================*
      SUBROUTINE IVRRCD(ITCOD ,JTCOD ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &                  INOW  ,IR    ,IFLAG2 )!,IERR  ,LNPRN)
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED (10,NA)
C
      MS   = NRED (5,INOW)
      ME   = NRED (6,INOW)
      NM   = NRED (7,INOW)
C <AB,CD>

      IF(IFLAG2.NE.0) THEN
         CALL IVCHCK(ITCOD ,JTCOD ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &              IR    ,MS+1  ,ME+1  ,NM     )!,IERR   ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
      ELSE
         CALL IVCHCK(ITCOD ,JTCOD ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &              IR    ,MS    ,ME+1  ,NM+1   )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
      END IF
C <AB,(C-1)D>
      IF(KTCOD. LT .2) GOTO 1000
      CALL IVCHCK(ITCOD ,JTCOD ,KTCOD-1      ,LTCOD ,NRED  ,NA    ,
     &            IR    ,MS    ,ME+1  ,NM+1   )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
C <AB,C(D-1)>
 1000 IF(LTCOD. LT .2) GOTO 2000
      CALL IVCHCK(ITCOD ,JTCOD ,KTCOD ,LTCOD-1      ,NRED  ,NA    ,
     &            IR    ,MS    ,ME+1  ,NM+1   )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
C <(A-1)B,CD>
 2000 IF(ITCOD. LT .2) GOTO 3000
      CALL IVCHCK(ITCOD-1      ,JTCOD ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &            IR    ,MS+1  ,ME+1  ,NM     )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
C <A(B-1),CD>
 3000 IF(JTCOD. LT .2) GOTO 9999
      CALL IVCHCK(ITCOD ,JTCOD-1      ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &            IR    ,MS+1  ,ME+1  ,NM     )!,IERR  ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
C
      GOTO 9999
C
c 9000 WRITE(LNPRN,8900)
c 8900 FORMAT('          CALLED FROM IVRRAB ')
C
 9999 RETURN
      END
C## IVCHCK ========================================================== =*
C   CHECK <IJ,KL> IN NRED TABLE
C
C======================================================================*
      SUBROUTINE IVCHCK(ITCOD ,JTCOD ,KTCOD ,LTCOD ,NRED  ,NA    ,
     &                  IR    ,MS    ,ME    ,NM     )!,IERR ,LNPRN)
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED(10,NA)
!     IF(LPOUT .GT .1) THEN
!     WRITE(LNPRN,8010) ITCOD,JTCOD,KTCOD,LTCOD
!8010 FORMAT(//' *** DEBUG *** SUB-IVCHCK '
!    &        ,' ITCOD,JTCOD,KTCOD,LTCOD=  ',4I5)
!     END IF
C
      IRR     = IR + 1
      DO 1000 I=1,IRR
C
!     IF(LPOUT .GT .1) THEN
!     WRITE(LNPRN,8011) (NRED(J,I),J=1,7),I,MS,ME,NM
!8011 FORMAT(' *** DEBUG         *** SUB-IVCHCK '
!    &        ,' NRED(1-4,I)            =  ',11I5)
!     END IF
C
        IF((NRED(1,I). EQ .ITCOD).AND.
     &    (NRED(2,I). EQ .JTCOD).AND.
     &    (NRED(3,I). EQ .KTCOD).AND.
     &    (NRED(4,I). EQ .LTCOD)    )   THEN
C
           IF(NRED(5,I). GT .MS) THEN
              NRED(7,I)   = NRED(7,I) + NRED(5,I) - MS
              NRED(5,I)   = MS
           END IF
           IF(ME. GT .NRED(6,I)) THEN
              NRED(7,I)   = NRED(7,I) + ME - NRED(6,I)
              NRED(6,I)   = ME
           END IF
           GOTO 3000
        ELSE
        END IF
 1000 CONTINUE
C
 2000 IR   = IR + 1


      IF(IR. GT .NA) GOTO 9010
      NRED (1,IR)   = ITCOD
      NRED (2,IR)   = JTCOD
      NRED (3,IR)   = KTCOD
      NRED (4,IR)   = LTCOD
      NRED (5,IR)   = MS
      NRED (6,IR)   = ME
      NRED (7,IR)   = NM
      NRED (8,IR)   = ITCOD+JTCOD+KTCOD+LTCOD
      NRED (9,IR)   = (ITCOD*(ITCOD+1)/2)*(JTCOD*(JTCOD+1)/2)
     &                   *(KTCOD*(KTCOD+1)/2)*(LTCOD*(LTCOD+1)/2)
C
 3000 GOTO 9999

 9010 IERR   = -1000
      WRITE(6,8910) ITCOD,JTCOD,KTCOD,LTCOD
 8910 FORMAT (//' >>> ERROR IN IVCHCK. ',
     &          '        COUNT IR WAS BEYOND REDUCTION TABLE SIZE. ',
     &          '        CURRENT INTEGRAL TYPE  IS  ',4I3)
C
C
 9999 RETURN
      END
C## IVSORT ========================================================== =
C     SET REDUCTION TABLE IN ORDER OF THE SUM OF SHELL TYPE CODES
C
C
C======================================================================
      SUBROUTINE IVSORT(NRED  ,NA    ,IR    ,NBF   )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED(10,NA),NBF(10)
C
      DO 3000 I=1,IR-1
        DO 1010 IBF=1,10
          NBF(IBF)   = NRED(IBF,I)
 1010   CONTINUE
C
        DO 2000 J=I+1,IR
          IF(NBF(8). LT .NRED(8,J)) THEN
            DO 1020 IBF=1,10
              NRED(IBF,I)   = NRED(IBF,J)
              NRED(IBF,J)   = NBF(IBF)
              NBF(IBF)      = NRED(IBF,I)
 1020       CONTINUE
          END IF
 2000   CONTINUE
C
 3000 CONTINUE
C
      RETURN
      END
C## IVADDR ========================================================== =*
C    SET VRR ADDRESS TABLE
C
C======================================================================*
      SUBROUTINE IVADDR(NRED  ,NA    ,NADD  ,MAXCOD,IR  ,NINTO ,ISSSS )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED (10,NA)
      DIMENSION NADD (2,MAXCOD,MAXCOD,MAXCOD,MAXCOD)
C
      IAD   = 1
C
      IC   = NRED(1,1)
      JC   = NRED(2,1)
      KC   = NRED(3,1)
      LC   = NRED(4,1)
      MS   = NRED(5,1)
      NAGL = NRED(9,1)
      NADD(1,IC,JC,KC,LC) = IAD
      NADD(2,IC,JC,KC,LC) = NRED(5,1)
C
      ITCOD   = IC
      JTCOD   = JC
      KTCOD   = KC
      LTCOD   = LC
      DO 1000 I=2,IR
        IC   = NRED(1,I)
        JC   = NRED(2,I)
        KC   = NRED(3,I)
        LC   = NRED(4,I)
        MS   = NRED(5,I)
        NM   = NRED(7,I)
        NAGL = NRED(9,I)
        NADD(1,IC,JC,KC,LC) = IAD
        NADD(2,IC,JC,KC,LC) = NRED(5,I)
        NMAG  = NM*NAGL
        IAD   = IAD + NMAG
 1000 CONTINUE
C
      NINTO   = ((IAD-1)/2)*2 + 1
      ISSSS   = NADD(1,1,1,1,1)

C# DEBUG
!     IF(LPOUT. GE .3) THEN
!     DO 2400 I=1,ITCOD
!       DO 2300 J=1,JTCOD
!         DO 2200 K=1,KTCOD
!           DO 2100 L=1,LTCOD
!             WRITE(LNPRN,8010) I,J,K,L,NADD(1,I,J,K,L)
!8010         FORMAT(' *** DEBUG      SUB-IVADDR **** ',
!    &               ' I,J,K,L,ADDRESS =  ',5I5)
!2100       CONTINUE
!2200     CONTINUE
!2300   CONTINUE
!2400 CONTINUE
!              WRITE(LNPRN,8020) NINTO
! 8020         FORMAT(' *** DEBUG      SUB-IVADDR **** ',
!     &               ' NINTO           =  ',I10)
!      END IF
C# DEBUG
C
      RETURN
      END
C
C## IVRRTL ========================================================== =*
C    GENERATE VRR TABLE
C       NVTBL   : VRR OPERATION TABLE
C       NADD    : INTEGRAL ADDRESS TABLE
C       NAGL    : ANGULAR COMPONENT TABLE
C       MAXCOD  : MAXIMUM OF TYPE CODE
C       MAXCMP  : MAXIMUM OF ANGULAR COMPONENT
C
C======================================================================*
      SUBROUTINE IVRRTL(NRED  ,NA    ,NADD  ,MAXCOD,NVTBL ,NV    ,
     &                  NAGL  ,MAXCMP,IFLAG1,IFLAG2,
     &                  IVCNT ,IRS   ,IRE    )!,IERR  ,LNPRN)
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED (10,NA)
      DIMENSION NADD (2,MAXCOD,MAXCOD,MAXCOD,MAXCOD)
      DIMENSION NAGL (4,MAXCOD,MAXCMP)
      DIMENSION NVTBL(3,NV)


      DO 2000 I=IRS,IRE,-1
C
C GET ANGULAR COMPONENT OF INTEGRAL <IJ,KL>
        CALL IVAGL (NRED  ,NA    ,I     ,NAGL  ,MAXCOD,MAXCMP,ISFLG )!,
c     &              IERR   ,LNPRN )
c        IF(IERR.NE.0) GOTO 9000
        IF (ISFLG. EQ .4) GOTO 2000
C# DEBUG
!       IF(LPOUT .GT .1) THEN
!         WRITE(LNPRN,1111) (NRED(II,I),II=1,4),NRED(10,I)
!1111     FORMAT(' I,J,K,L,IREDPT= ',5I5)
!         WRITE(LNPRN,1112) (NAGL(3,1,II),II=1,3)
!1112     FORMAT(' NAGL(3 1 I) I=1-3 ',3I5)
!       END IF
C#
C
        IC   = NRED(1,I)
        JC   = NRED(2,I)
        KC   = NRED(3,I)
        LC   = NRED(4,I)
        MS   = NRED(5,I)
        NM   = NRED(7,I)
        IREDPT = NRED(10,I)
        IADD   = NADD(1,IC,JC,KC,LC)
C
!        GOTO (1010,1020,1030,1040) IREDPT
        select case(iredpt)

        case(1)
C REDUCE A
          CALL IVTLA (IC    ,JC    ,KC    ,LC    ,MS    ,NM    ,IADD ,
     &                NADD  ,NAGL  ,MAXCOD,MAXCMP,IFLAG1,
     &                NVTBL ,NV    ,IVCNT )!,IERR  ,LNPRN )
c          IF(IERR.NE.0) GOTO 9000
          GOTO 2000
        case(2)
C REDUCE B
          CALL IVTLB (IC    ,JC    ,KC    ,LC    ,MS    ,NM    ,IADD ,
     &                NADD  ,NAGL  ,MAXCOD,MAXCMP,IFLAG1,
     &                NVTBL ,NV    ,IVCNT )!,IERR  ,LNPRN )
c          IF(IERR.NE.0) GOTO 9000
          GOTO 2000
        case(3)
C REDUCE C
          CONTINUE
          CALL IVTLC (IC    ,JC    ,KC    ,LC    ,MS    ,NM    ,IADD ,
     &                NADD  ,NAGL  ,MAXCOD,MAXCMP,IFLAG2,
     &                NVTBL ,NV    ,IVCNT )!,IERR  ,LNPRN )
c          IF(IERR.NE.0) GOTO 9000
          GOTO 2000
        case(4)
C REDUCE D
          CALL IVTLD (IC    ,JC    ,KC    ,LC    ,MS    ,NM    ,IADD ,
     &                NADD  ,NAGL  ,MAXCOD,MAXCMP,IFLAG2,
     &                NVTBL ,NV    ,IVCNT )!,IERR  ,LNPRN )
c          IF(IERR.NE.0) GOTO 9000
C
        endselect
 2000 CONTINUE
C
      GOTO 9999
C
 9000 continue!WRITE(LNPRN,8900)
c 8900 FORMAT('          CALLED FROM IVRRTL ')
C
 9999 RETURN
      END
C
C## IVAGL  ========================================================== =*
C    SET ANGULAR COMPONENT TABLE
C       NAGL    : ANGULAR COMPONENT TABLE
C       MAXCOD  : MAXIMUM OF TYPE CODE
C       MAXCMP  : MAXIMUM OF ANGULAR COMPONENT
C
C======================================================================*
      SUBROUTINE IVAGL (NRED  ,NA    ,INT   ,NAGL  ,MAXCOD,MAXCMP,
     &                  ISFLG )!,IERR  ,LNPRN )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NRED (10,NA)
      DIMENSION NAGL (4,MAXCOD,MAXCMP)

C
      ISFLG    = 0
      DO 10000 IC=1,4
        ICOD   = NRED(IC,INT)
C

         select case(icod)
C
        case(1)
          IF(IC. EQ .1) ISFLG = ISFLG + 1
          GOTO 10000
        case(2)
C P-TYPE
          DO 1100 ICMP=1,3
            NAGL(IC,1,ICMP) = ICMP
 1100     CONTINUE
          GOTO 10000
        case(3)
C D-TYPE
          ICMP   = 1
          DO 2200 I=1,3
            DO 2100 J=1,I
              NAGL(IC,1,ICMP) = I
              NAGL(IC,2,ICMP) = J
              ICMP   = ICMP + 1
 2100       CONTINUE
 2200     CONTINUE
          GOTO 10000
        case(4)
C F-TYPE
          ICMP   = 1
          DO 3300 I=1,3
            DO 3200 J=1,I
              DO 3100 K=1,J
                NAGL(IC,1,ICMP) = I
                NAGL(IC,2,ICMP) = J
                NAGL(IC,3,ICMP) = K
                ICMP   = ICMP + 1
 3100         CONTINUE
 3200       CONTINUE
 3300     CONTINUE
          GOTO 10000
        case(5)
C G-TYPE
          ICMP   = 1
          DO 4400 I=1,3
            DO 4300 J=1,I
              DO 4200 K=1,J
                DO 4100 L=1,K
                  NAGL(IC,1,ICMP) = I
                  NAGL(IC,2,ICMP) = J
                  NAGL(IC,3,ICMP) = K
                  NAGL(IC,4,ICMP) = L
                  ICMP   = ICMP + 1
 4100           CONTINUE
 4200         CONTINUE
 4300       CONTINUE
 4400     CONTINUE
          GOTO 10000
        case(6)
C H-TYPE
          ICMP   = 1
          DO 5400 I=1,3
            DO 5300 J=1,I
              DO 5200 K=1,J
                DO 5100 L=1,K
                  DO 5000 M=1,L
                  NAGL(IC,1,ICMP) = I
                  NAGL(IC,2,ICMP) = J
                  NAGL(IC,3,ICMP) = K
                  NAGL(IC,4,ICMP) = L
                  NAGL(IC,5,ICMP) = M
                  ICMP   = ICMP + 1
 5000             CONTINUE
 5100           CONTINUE
 5200         CONTINUE
 5300       CONTINUE
 5400     CONTINUE
          GOTO 10000

c          GOTO 9010
        case(7)
C I-TYPE
        ICMP = 1
        DO I=1,3
           DO J=1,I
              DO K=1,J
                 DO L=1,K
                    DO M=1,L
                       DO N=1,M
                       NAGL(IC,1,ICMP) = I
                       NAGL(IC,2,ICMP) = J
                       NAGL(IC,3,ICMP) = K
                       NAGL(IC,4,ICMP) = L
                       NAGL(IC,5,ICMP) = M
                       NAGL(IC,6,ICMP) = N
                       ICMP   = ICMP + 1
                       ENDDO
                    ENDDO
                 ENDDO
              ENDDO
           ENDDO
        ENDDO

c      GOTO 9010

       endselect

10000 CONTINUE
C
      GOTO 9999
C
 9010 IERR   = -1000
      WRITE(6,8910) ICOD
 8910 FORMAT(//,' >>> ERROR IN IVAGL.  ',
     &          ' SHELL TYPE CODE  ',I2,'  IS NOT SUPPORTED ')
C
 9999 RETURN
      END
C## IVTLA  ========================================================== =*
C    GENERATE VRR OPERATION TABLE FOR <(A+1)B,CD>
C       NAGL    : ANGULAR COMPONENT TABLE
C       MAXCOD  : MAXIMUM OF TYPE CODE
C       MAXCMP  : MAXIMUM OF ANGULAR COMPONENT
C
C======================================================================*
      SUBROUTINE IVTLA (IC    ,JC    ,KC    ,LC    ,MS    ,NM   ,IADD,
     &                 NADD  ,NAGL  ,MAXCOD,MAXCMP,IFLAG1,
     &                 NVTBL ,NV    ,IVCNT )!,IERR  ,LNPRN )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NADD (2,MAXCOD,MAXCOD,MAXCOD,MAXCOD)
      DIMENSION NAGL (4,MAXCOD,MAXCMP)
      DIMENSION NVTBL(3,NV)
C
      ICMP   = IC*(IC+1)/2
      JCMP   = JC*(JC+1)/2
      KCMP   = KC*(KC+1)/2
      LCMP   = LC*(LC+1)/2
      ICMP1  = IC*(IC-1)/2
      JCMP1  = JC*(JC-1)/2
      KCMP1  = KC*(KC-1)/2
      LCMP1  = LC*(LC-1)/2
      ICMP2  = (IC-1)*(IC-2)/2
      I1CMP  = ICMP1*JCMP*KCMP*LCMP
      I2CMP  = ICMP2*JCMP*KCMP*LCMP
      IJCMP  = ICMP1*JCMP1*KCMP*LCMP
      IKCMP  = ICMP1*JCMP*KCMP1*LCMP
      ILCMP  = ICMP1*JCMP*KCMP*LCMP1
C
      DO 8000 I=1,ICMP
        DO 7000 J=1,JCMP
          DO 6000 K=1,KCMP
            DO 5000 L=1,LCMP
              IXYZ   = NAGL(1,1,I)
c$$$          CALL IVAGOR(1,IC-1,NAGL(1,2,I),ICONT1,IERR  )!,LNPRN )!bug20100129
              CALL IVAGOR(1,IC-1,NAGL(1,2,I),ICONT1)!,IERR ,LNPRN )
c              IF(IERR.NE.0) GOTO 9000
              ICNT1   = (((ICONT1-1)*JCMP+(J-1))*KCMP+K-1)*LCMP + L
              ICADD   = NADD(1,IC-1,JC,KC,LC)
              ICADD1  = (MS-NADD(2,IC-1,JC,KC,LC))*I1CMP + ICADD
              IF(IC. GT .2) THEN
                CALL IVAGNM(1,IC-1,NAGL(1,2,I),ICNT2,
     &                      IXYZ,NIXYZ)!,IERR  ,LNPRN )
c                IF(IERR.NE.0) GOTO 9000
                ICNT2   = (((ICNT2-1)*JCMP+(J-1))*KCMP+K-1)*LCMP + L
                ICADD   = NADD(1,IC-2,JC,KC,LC)
                ICADD2  = (MS-NADD(2,IC-2,JC,KC,LC))*I2CMP + ICADD
              END IF
              IF(JC. GT .1) THEN
                CALL IVAGNM(2,JC,NAGL(1,1,J),JCNT2,
     &                      IXYZ,NJXYZ)!,IERR ,LNPRN )
c                IF(IERR.NE.0) GOTO 9000
                JCNT2   = (((ICONT1-1)*JCMP1+(JCNT2-1))*KCMP+K-1)*LCMP
     &                                               + L
                JCADD   = NADD(1,IC-1,JC-1,KC,LC)
                JCADD2  = (MS-NADD(2,IC-1,JC-1,KC,LC))*IJCMP + JCADD
              END IF
              IF(KC. GT .1) THEN
                CALL IVAGNM(3,KC,NAGL(1,1,K),KCNT2,
     &                      IXYZ,NKXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                KCNT2   = (((ICONT1-1)*JCMP+(J-1))*KCMP1+KCNT2-1)*LCMP
     &                                               + L
                KCADD   = NADD(1,IC-1,JC,KC-1,LC)
                KCADD2  = (MS-NADD(2,IC-1,JC,KC-1,LC))*IKCMP  + KCADD
              END IF
              IF(LC. GT .1) THEN
                CALL IVAGNM(4,LC,NAGL(1,1,L),LCNT2,
     &                      IXYZ,NLXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                LCNT2   = (((ICONT1-1)*JCMP+(J-1))*KCMP+K-1)*LCMP1
     &                                               + LCNT2
                LCADD   = NADD(1,IC-1,JC,KC,LC-1)
                LCADD2  = (MS-NADD(2,IC-1,JC,KC,LC-1))*ILCMP + LCADD
              END IF

              DO 4000 M=1,NM
                IADDM    = IADD  + (M-1)*ICMP*JCMP*KCMP*LCMP
                IF(IFLAG1.NE.0) GOTO 1900
C <(A+1)B,CD>
                NVTBL(1,IVCNT)   = IADDM
C PA
                NVTBL(2,IVCNT)   =      IXYZ
C <AB,CD>

                NVTBL(3,IVCNT)   = ICADD1 + ICNT1 - 1   + (M-1)*I1CMP
                IVCNT   = IVCNT + 1
C
C <(A+1)B,CD>
 1900           NVTBL(1,IVCNT)   = IADDM
C WP
                NVTBL(2,IVCNT)   = 6  + IXYZ
C <AB,CD>+1
                NVTBL(3,IVCNT)   = ICADD1 + ICNT1 - 1   + M*I1CMP
                IVCNT   = IVCNT + 1
C
                IF((IC. LE .2).OR.(NIXYZ. EQ .0))   GOTO 2000
C
C <(A+1)B,CD>
                NVTBL(1,IVCNT)   = IADDM
C 1/ETA
                NVTBL(2,IVCNT)   = 18 + NIXYZ
C <(A-1)B,CD>
                NVTBL(3,IVCNT)   = ICADD2 + ICNT2 - 1   + (M-1)*I2CMP
                IVCNT   = IVCNT + 1
C
C <(A+1)B,CD>
                NVTBL(1,IVCNT)   = IADDM
C ROO/ETA
c                NVTBL(2,IVCNT)   = 21 + NIXYZ
                NVTBL(2,IVCNT)   = 24 + NIXYZ
C <(A-1)B,CD>+1
                NVTBL(3,IVCNT)   = ICADD2 + ICNT2 - 1   + M*I2CMP
                IVCNT   = IVCNT + 1
C
 2000           IF((KC. LT .2).OR.(NKXYZ. EQ .0))   GOTO 2500
C
C <(A+1)B,CD>
                NVTBL(1,IVCNT)   = IADDM
C 1/2(ETA+ZETA)
c                NVTBL(2,IVCNT)   = 30 + NKXYZ
                NVTBL(2,IVCNT)   = 42 + NKXYZ
C <AB,(C-1)D>+1
                NVTBL(3,IVCNT)   = KCADD2 + KCNT2 - 1   + M*IKCMP
                IVCNT   = IVCNT + 1
C
 2500           IF((LC. LT .2).OR.(NLXYZ. EQ .0))   GOTO 2600
C
C <(A+1)B,CD>
                NVTBL(1,IVCNT)   = IADDM
C 1/2(ETA+ZETA)
c                NVTBL(2,IVCNT)   = 30 + NLXYZ
                NVTBL(2,IVCNT)   = 42 + NLXYZ
C <AB,C(D-1)>+1
                NVTBL(3,IVCNT)   = LCADD2 + LCNT2 - 1   + M*ILCMP
                IVCNT   = IVCNT + 1
C
 2600           IF((JC. LT .2).OR.(NJXYZ. EQ .0))   GOTO 4001
C
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C 1/ETA
                NVTBL(2,IVCNT)   = 18 + NJXYZ
C <A(B-1),CD>
                NVTBL(3,IVCNT)   = JCADD2 + JCNT2 - 1   + (M-1)*IJCMP
                IVCNT   = IVCNT + 1
C
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C ROO/ETA
c                NVTBL(2,IVCNT)   = 21 + NJXYZ
                NVTBL(2,IVCNT)   = 24 + NJXYZ
C <AB,C(D-1)>+1
                NVTBL(3,IVCNT)   = JCADD2 + JCNT2 - 1   + M*IJCMP
                IVCNT   = IVCNT + 1
 
 4001         IF(IVCNT-1.GT.NV) GOTO 9010
 4000         CONTINUE
              IADD   = IADD + 1
 5000       CONTINUE
 6000     CONTINUE
 7000   CONTINUE
 8000 CONTINUE
 
      GOTO 9999
 
 9000 WRITE(6,8900)
 8900 FORMAT('          CALLED FROM IVTLA ')
      GOTO 9999
 
 9010 WRITE(6,8910)
      IERR   = -1000
 8910 FORMAT(/' ERROR IN IVTLA : BEYOND THE OPERATION TABLE SIZE ',/)
 
 9999 RETURN
      END
C
C## IVTLB  ========================================================== =*
C    GENERATE VRR OPERATION TABLE FOR <A(B-1),CD>
C       NAGL    : ANGULAR COMPONENT TABLE
C       MAXCOD  : MAXIMUM OF TYPE CODE
C       MAXCMP  : MAXIMUM OF ANGULAR COMPONENT
C
C======================================================================*
      SUBROUTINE IVTLB (IC    ,JC    ,KC    ,LC    ,MS    ,NM   ,IADD,
     &                 NADD  ,NAGL  ,MAXCOD,MAXCMP,IFLAG1,
     &                 NVTBL ,NV    ,IVCNT )!,IERR  ,LNPRN )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NADD (2,MAXCOD,MAXCOD,MAXCOD,MAXCOD)
      DIMENSION NAGL (4,MAXCOD,MAXCMP)
      DIMENSION NVTBL(3,NV)
 
 
 
      ICMP   = IC*(IC+1)/2
      JCMP   = JC*(JC+1)/2
      KCMP   = KC*(KC+1)/2
      LCMP   = LC*(LC+1)/2
      ICMP1  = IC*(IC-1)/2
      JCMP1  = JC*(JC-1)/2
      KCMP1  = KC*(KC-1)/2
      LCMP1  = LC*(LC-1)/2
      JCMP2  = (JC-1)*(JC-2)/2
      J1CMP  = ICMP *JCMP1*KCMP *LCMP
      J2CMP  = ICMP *JCMP2*KCMP *LCMP
      IJCMP  = ICMP1*JCMP1*KCMP *LCMP
      JKCMP  = ICMP *JCMP1*KCMP1*LCMP
      JLCMP  = ICMP *JCMP1*KCMP *LCMP1
C
      DO 8000 I=1,ICMP
        DO 7000 J=1,JCMP
          DO 6000 K=1,KCMP
            DO 5000 L=1,LCMP
            JXYZ   = NAGL(2,1,J)
            CALL IVAGOR(2,JC-1,NAGL(1,2,J),JCONT1)!,IERR ,LNPRN)
c            IF(IERR.NE.0) GOTO 9000
              JCNT1   = (((I-1)*JCMP1+(JCONT1-1))*KCMP+K-1)*LCMP + L
              JCADD   = NADD(1,IC,JC-1,KC,LC)
              JCADD1  = (MS-NADD(2,IC,JC-1,KC,LC))*J1CMP + JCADD
              IF(JC. GT .2) THEN
                CALL IVAGNM(2,JC-1,NAGL(1,2,J),JCNT2,
     &                      JXYZ,NJXYZ)!,IERR  ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                JCNT2   = (((I-1)*JCMP2+(JCNT2-1))*KCMP+K-1)*LCMP
     &                                               + L
                JCADD   = NADD(1,IC,JC-2,KC,LC)
                JCADD2  = (MS-NADD(2,IC,JC-2,KC,LC))*J2CMP + JCADD
              END IF
              IF(IC. GT .1) THEN
                CALL IVAGNM(1,IC,NAGL(1,1,I),ICNT2,
     &                      JXYZ,NIXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                ICNT2   = (((ICNT2-1)*JCMP1+(JCONT1-1))*KCMP+K-1)*LCMP
     &                                               + L
                ICADD   = NADD(1,IC-1,JC-1,KC,LC)
                ICADD2  = (MS-NADD(2,IC-1,JC-1,KC,LC))*IJCMP + ICADD
              END IF
              IF(KC. GT .1) THEN
                CALL IVAGNM(3,KC,NAGL(1,1,K),KCNT2,
     &                      JXYZ,NKXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                KCNT2   = (((I-1)*JCMP1+(JCONT1-1))*KCMP1+KCNT2-1)*LCMP
     &                                               + L
                KCADD   = NADD(1,IC,JC-1,KC-1,LC)
                KCADD2  = (MS-NADD(2,IC,JC-1,KC-1,LC))*JKCMP  + KCADD
              END IF
              IF(LC. GT .1) THEN
                CALL IVAGNM(4,LC,NAGL(1,1,L),LCNT2,
     &                      JXYZ,NLXYZ)!,IERR ,LNPRN )
c                IF(IERR.NE.0) GOTO 9000
                LCNT2   = (((I-1)*JCMP1+(JCONT1-1))*KCMP+K-1)*LCMP1
     &                                               + LCNT2
                LCADD   = NADD(1,IC,JC-1,KC,LC-1)
                LCADD2  = (MS-NADD(2,IC,JC-1,KC,LC-1))*JLCMP + LCADD
              END IF
C
              DO 4000 M=1,NM
                IADDM    = IADD  + (M-1)*ICMP*JCMP*KCMP*LCMP
                IF(IFLAG1.NE.0) GOTO 1900
C <A(B+1),CD>
                NVTBL(1,IVCNT)   = IADDM
C PB
                NVTBL(2,IVCNT)   = 3  + JXYZ
C <AB,CD>
                NVTBL(3,IVCNT)   = JCADD1 + JCNT1 - 1   + (M-1)*J1CMP
                IVCNT   = IVCNT + 1
C
C <A(B+1),CD>
 1900           NVTBL(1,IVCNT)   = IADDM
C WP
                NVTBL(2,IVCNT)   = 6  + JXYZ
C <AB,CD>+1
                NVTBL(3,IVCNT)   = JCADD1 + JCNT1 - 1   + M*J1CMP
                IVCNT   = IVCNT + 1
C
                IF((JC. LE .2).OR.(NJXYZ. EQ .0))   GOTO 2000
C
C <A(B+1),CD>
                NVTBL(1,IVCNT)   = IADDM
C 1/ETA
                NVTBL(2,IVCNT)   = 18 + NJXYZ
C <A(B-1),CD>
                NVTBL(3,IVCNT)   = JCADD2 + JCNT2 - 1   + (M-1)*J2CMP
                IVCNT   = IVCNT + 1
C
C <A(B+1),CD>
                NVTBL(1,IVCNT)   = IADDM
C ROO/ETA
c                NVTBL(2,IVCNT)   = 21 + NJXYZ
                NVTBL(2,IVCNT)   = 24 + NJXYZ
C <A(B+1),CD>+1
                NVTBL(3,IVCNT)   = JCADD2 + JCNT2 - 1   + M*J2CMP
                IVCNT   = IVCNT + 1
C
 2000           IF((KC. LT .2).OR.(NKXYZ. EQ .0))   GOTO 2500
C
C <A(B+1),CD>
                NVTBL(1,IVCNT)   = IADDM
C 1/2(ETA+ZETA)
c                NVTBL(2,IVCNT)   = 30 + NKXYZ
                NVTBL(2,IVCNT)   = 42 + NKXYZ
C <AB,(C-1)D>+1
                NVTBL(3,IVCNT)   = KCADD2 + KCNT2 - 1   + M*JKCMP
                IVCNT   = IVCNT + 1
C
 2500           IF((LC. LT .2).OR.(NLXYZ. EQ .0))   GOTO 2600
C
C <A(B+1),CD>
                NVTBL(1,IVCNT)   = IADDM
C 1/2(ETA+ZETA)
c                NVTBL(2,IVCNT)   = 30 + NLXYZ
                NVTBL(2,IVCNT)   = 42 + NLXYZ
C <AB,C(D-1)>+1
                NVTBL(3,IVCNT)   = LCADD2 + LCNT2 - 1   + M*JLCMP
                IVCNT   = IVCNT + 1
C
 2600           IF((IC. LT .2).OR.(NIXYZ. EQ .0))   GOTO 4001
C
C <A(B+1),CD>
                NVTBL(1,IVCNT)   = IADDM
C 1/ETA
                NVTBL(2,IVCNT)   = 18 + NIXYZ
C <(A-1)B,CD>
                NVTBL(3,IVCNT)   = ICADD2 + ICNT2 - 1   + (M-1)*IJCMP
                IVCNT   = IVCNT + 1
C
C <A(B+1),CD>
                NVTBL(1,IVCNT)   = IADDM
C ROO/ETA
c                NVTBL(2,IVCNT)   = 21 + NIXYZ
                NVTBL(2,IVCNT)   = 24 + NIXYZ
C <(A-1)B,CD>+1
                NVTBL(3,IVCNT)   = ICADD2 + ICNT2 - 1   + M*IJCMP
                IVCNT   = IVCNT + 1
C
 4001           IF(IVCNT-1.GT.NV) GOTO 9010
 4000         CONTINUE
              IADD   = IADD + 1
 5000       CONTINUE
 6000     CONTINUE
 7000   CONTINUE
 8000 CONTINUE
C
      GOTO 9999
C
 9000 WRITE(6,8900)
 8900 FORMAT('          CALLED FROM IVTLB ')
      GOTO 9999
C
 9010 WRITE(6,8910)
      IERR   = -1000
 8910 FORMAT(/' ERROR IN IVTLB : BEYOND THE OPERATION TABLE SIZE ',/)
C
 9999 RETURN
      END
C
C
C## IVTLC  ========================================================== =*
C    GENERATE VRR OPERATION TABLE FOR <AB,(C+1)D>
C       NAGL    : ANGULAR COMPONENT TABLE
C       MAXCOD  : MAXIMUM OF TYPE CODE
C       MAXCMP  : MAXIMUM OF ANGULAR COMPONENT
C
C======================================================================*
      SUBROUTINE IVTLC (IC    ,JC    ,KC    ,LC    ,MS    ,NM   ,IADD,
     &                 NADD  ,NAGL  ,MAXCOD,MAXCMP,IFLAG2,
     &                 NVTBL ,NV    ,IVCNT )!,IERR  ,LNPRN )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NADD (2,MAXCOD,MAXCOD,MAXCOD,MAXCOD)
      DIMENSION NAGL (4,MAXCOD,MAXCMP)
      DIMENSION NVTBL(3,NV)
C
      ICMP   = IC*(IC+1)/2
      JCMP   = JC*(JC+1)/2
      KCMP   = KC*(KC+1)/2
      LCMP   = LC*(LC+1)/2
      ICMP1  = IC*(IC-1)/2
      JCMP1  = JC*(JC-1)/2
      KCMP1  = KC*(KC-1)/2
      LCMP1  = LC*(LC-1)/2
      KCMP2  = (KC-1)*(KC-2)/2
      K1CMP  = ICMP*JCMP*KCMP1*LCMP
      K2CMP  = ICMP*JCMP*KCMP2*LCMP
      IKCMP  = ICMP1*JCMP*KCMP1*LCMP
      JKCMP  = ICMP*JCMP1*KCMP1*LCMP
      KLCMP  = ICMP*JCMP*KCMP1*LCMP
C
      DO 8000 I=1,ICMP
        DO 7000 J=1,JCMP
          DO 6000 K=1,KCMP
            DO 5000 L=1,LCMP
            KXYZ   = NAGL(3,1,K)
            CALL IVAGOR(3,KC-1,NAGL(1,2,K),KCONT1)!,IERR ,LNPRN)
c            IF(IERR.NE.0) GOTO 9000
              KCNT1   = (((I-1)*JCMP+(J-1))*KCMP1+KCONT1-1)*LCMP + L
              KCADD   = NADD(1,IC,JC,KC-1,LC)
              KCADD1  = (MS-NADD(2,IC,JC,KC-1,LC))*K1CMP + KCADD
              IF(KC. GT .2) THEN
                CALL IVAGNM(3,KC-1,NAGL(1,2,K),KCNT2,
     &                      KXYZ,NKXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                KCNT2   = (((I-1)*JCMP+(J-1))*KCMP2+KCNT2-1)*LCMP + L
                KCADD   = NADD(1,IC,JC,KC-2,LC)
                KCADD2  = (MS-NADD(2,IC,JC,KC-2,LC))*K2CMP + KCADD
              END IF
              IF(IC. GT .1) THEN
                CALL IVAGNM(1,IC,NAGL(1,1,I),ICNT2,
     &                      KXYZ,NIXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                ICNT2   = (((ICNT2-1)*JCMP+(J-1))*KCMP1+KCONT1-1)*LCMP
     &                                               + L
                ICADD   = NADD(1,IC-1,JC,KC-1,LC)
                ICADD2  = (MS-NADD(2,IC-1,JC,KC-1,LC))*IKCMP + ICADD
              END IF
              IF(JC. GT .1) THEN
                CALL IVAGNM(2,JC,NAGL(1,1,J),JCNT2,
     &                      KXYZ,NJXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                JCNT2   = (((I-1)*JCMP1+(JCNT2-1))*KCMP1+KCONT1-1)*LCMP
     &                                               + L
                JCADD   = NADD(1,IC,JC-1,KC-1,LC)
                JCADD2  = (MS-NADD(2,IC,JC-1,KC-1,LC))*JKCMP + JCADD
              END IF
              IF(LC. GT .1) THEN
                CALL IVAGNM(4,LC,NAGL(1,1,L),LCNT2,
     &                      KXYZ,NLXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                LCNT2   = (((I-1)*JCMP+(J-1))*KCMP1+KCONT1-1)*LCMP1
     &                                               + LCNT2
                LCADD   = NADD(1,IC,JC,KC-1,LC-1)
                LCADD2  = (MS-NADD(2,IC,JC,KC-1,LC-1))*KLCMP  + LCADD
              END IF
C
              DO 4000 M=1,NM
                IADDM    = IADD  + (M-1)*ICMP*JCMP*KCMP*LCMP
                IF(IFLAG2.NE.0) GOTO 1900
C <AB,(C+1)D>
                NVTBL(1,IVCNT)   = IADDM
C QD
                NVTBL(2,IVCNT)   = 9  + KXYZ
C <AB,CD>
                NVTBL(3,IVCNT)   = KCADD1 + KCNT1 - 1   + (M-1)*K1CMP
                IVCNT   = IVCNT + 1
C
C <AB,(C+1)D>
 1900           NVTBL(1,IVCNT)   = IADDM
C WQ
                NVTBL(2,IVCNT)   = 15 + KXYZ
C <AB,CD>+1
                NVTBL(3,IVCNT)   = KCADD1 + KCNT1 - 1   + M*K1CMP
                IVCNT   = IVCNT + 1
C
                IF((KC. LE .2).OR.(NKXYZ. EQ .0))   GOTO 2000
C
C <AB,(C+1)D>
                NVTBL(1,IVCNT)   = IADDM
C 1/ETA
c                NVTBL(2,IVCNT)   = 24 + NKXYZ
                NVTBL(2,IVCNT)   = 30 + NKXYZ
C <AB,(C-1)D>
                NVTBL(3,IVCNT)   = KCADD2 + KCNT2 - 1   + (M-1)*K2CMP
                IVCNT   = IVCNT + 1
C
C <AB,(C+1)D>
                NVTBL(1,IVCNT)   = IADDM
C ROO/ETA
c                NVTBL(2,IVCNT)   = 27 + NKXYZ
                NVTBL(2,IVCNT)   = 36 + NKXYZ
C <AB,(C-1)D>+1
                NVTBL(3,IVCNT)   = KCADD2 + KCNT2 - 1   + M*K2CMP
                IVCNT   = IVCNT + 1
C
 2000           IF((IC. LT .2).OR.(NIXYZ. EQ .0))   GOTO 2500
C
C <AB,(C+1)D>
                NVTBL(1,IVCNT)   = IADDM
C 1/2(ETA+ZETA)
c                NVTBL(2,IVCNT)   = 30 + NIXYZ
                NVTBL(2,IVCNT)   = 42 + NIXYZ
C <(A-1)B,CD>+1
                NVTBL(3,IVCNT)   = ICADD2 + ICNT2 - 1   + M*IKCMP
                IVCNT   = IVCNT + 1
C
 2500           IF((JC. LT .2).OR.(NJXYZ. EQ .0))   GOTO 2600
C
C <AB,(C+1)D>
                NVTBL(1,IVCNT)   = IADDM
C 1/2(ETA+ZETA)
c                NVTBL(2,IVCNT)   = 30 + NJXYZ
                NVTBL(2,IVCNT)   = 42 + NJXYZ
C <A(B-1),CD>+1
                NVTBL(3,IVCNT)   = JCADD2 + JCNT2 - 1   + M*JKCMP
                IVCNT   = IVCNT + 1
C
 2600           IF((LC. LT .2).OR.(NLXYZ. EQ .0))   GOTO 4001
C
C <AB,(C+1)D>
                NVTBL(1,IVCNT)   = IADDM
C 1/ETA
c                NVTBL(2,IVCNT)   = 24 + NLXYZ
                NVTBL(2,IVCNT)   = 30 + NLXYZ
C <AB,C(D-1)>
                NVTBL(3,IVCNT)   = LCADD2 + LCNT2 - 1   + (M-1)*KLCMP
                IVCNT   = IVCNT + 1
C
C <AB,(C+1)D>
                NVTBL(1,IVCNT)   = IADDM
C ROO/ETA
c                NVTBL(2,IVCNT)   = 27 + NLXYZ
                NVTBL(2,IVCNT)   = 36 + NLXYZ
C <AB,C(D-1)>+1
                NVTBL(3,IVCNT)   = LCADD2 + LCNT2 - 1   + M*KLCMP
                IVCNT   = IVCNT + 1
C
 4001           IF(IVCNT-1.GT.NV) GOTO 9010
 4000         CONTINUE
              IADD   = IADD + 1
 5000       CONTINUE
 6000     CONTINUE
 7000   CONTINUE
 8000 CONTINUE
C
      GOTO 9999
C
 9000 WRITE(6,8900)
 8900 FORMAT('          CALLED FROM IVTLC ')
      GOTO 9999
C
 9010 WRITE(6,8910)
      IERR   = -1000
c       write(*,*)'ivcnt,nv ',ivcnt,nv
 8910 FORMAT(/' ERROR IN IVTLC : BEYOND THE OPERATION TABLE SIZE ',/)
C
 9999 RETURN
      END
C
C
C## IVTLD  ========================================================== =*
C    GENERATE VRR OPERATION TABLE FOR <AB,(C+1)D>
C       NAGL    : ANGULAR COMPONENT TABLE
C       MAXCOD  : MAXIMUM OF TYPE CODE
C       MAXCMP  : MAXIMUM OF ANGULAR COMPONENT
C
C======================================================================*
      SUBROUTINE IVTLD (IC    ,JC    ,KC    ,LC    ,MS    ,NM   ,IADD,
     &                 NADD  ,NAGL  ,MAXCOD,MAXCMP,IFLAG2,
     &                 NVTBL ,NV    ,IVCNT )!,IERR  ,LNPRN )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NADD (2,MAXCOD,MAXCOD,MAXCOD,MAXCOD)
      DIMENSION NAGL (4,MAXCOD,MAXCMP)
      DIMENSION NVTBL(3,NV)
C
      ICMP   = IC*(IC+1)/2
      JCMP   = JC*(JC+1)/2
      KCMP   = KC*(KC+1)/2
      LCMP   = LC*(LC+1)/2
      ICMP1  = IC*(IC-1)/2
      JCMP1  = JC*(JC-1)/2
      KCMP1  = KC*(KC-1)/2
      LCMP1  = LC*(LC-1)/2
      LCMP2  = (LC-1)*(LC-2)/2
      L1CMP  = ICMP*JCMP*KCMP* LCMP1
      L2CMP  = ICMP*JCMP*KCMP* LCMP2
      ILCMP  = ICMP1*JCMP*KCMP*LCMP1
      JLCMP  = ICMP*JCMP1*KCMP*LCMP1
      KLCMP  = ICMP*JCMP*KCMP1*LCMP1
C
      DO 8000 I=1,ICMP
        DO 7000 J=1,JCMP
          DO 6000 K=1,KCMP
            DO 5000 L=1,LCMP
            LXYZ   = NAGL(4,1,L)
            CALL IVAGOR(4,LC-1,NAGL(1,2,L),LCONT1)!,IERR ,LNPRN)
c            IF(IERR.NE.0) GOTO 9000
              LCNT1   = (((I-1)*JCMP+(J-1))*KCMP+K-1)*LCMP1 + LCONT1
              LCADD   = NADD(1,IC,JC,KC,LC-1)
              LCADD1  = (MS-NADD(2,IC,JC,KC,LC-1))*L1CMP + LCADD
              IF(LC. GT .2) THEN
                CALL IVAGNM(4,LC-1,NAGL(1,2,L),LCNT2,
     &                      LXYZ,NLXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                LCNT2   = (((I-1)*JCMP+(J-1))*KCMP+K-1)*LCMP2 + LCNT2
                LCADD   = NADD(1,IC,JC,KC,LC-2)
                LCADD2  = (MS-NADD(2,IC,JC,KC,LC-2))*L2CMP + LCADD
              END IF
              IF(IC. GT .1) THEN
                CALL IVAGNM(1,IC,NAGL(1,1,I),ICNT2,
     &                      LXYZ,NIXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                ICNT2   = (((ICNT2-1)*JCMP+(J-1))*KCMP+K-1)*LCMP1
     &                                               + LCONT1
                ICADD   = NADD(1,IC-1,JC,KC,LC-1)
                ICADD2  = (MS-NADD(2,IC-1,JC,KC,LC-1))*ILCMP + ICADD
              END IF
              IF(JC. GT .1) THEN
                CALL IVAGNM(2,JC,NAGL(1,1,J),JCNT2,
     &                      LXYZ,NJXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                JCNT2   = (((I-1)*JCMP1+(JCNT2-1))*KCMP+K-1)*LCMP1
     &                                               + LCONT1
                JCADD   = NADD(1,IC,JC-1,KC,LC-1)
                JCADD2  = (MS-NADD(2,IC,JC-1,KC,LC-1))*JLCMP + JCADD
              END IF
              IF(KC. GT .1) THEN
                CALL IVAGNM(3,KC,NAGL(1,1,K),KCNT2,
     &                      LXYZ,NKXYZ)!,IERR ,LNPRN)
c                IF(IERR.NE.0) GOTO 9000
                KCNT2   = (((I-1)*JCMP+(J-1))*KCMP1+KCNT2-1)*LCMP1
     &                                               + LCONT1
                KCADD   = NADD(1,IC,JC,KC-1,LC-1)
                KCADD2  = (MS-NADD(2,IC,JC,KC-1,LC-1))*KLCMP  + KCADD
              END IF
C
              DO 4000 M=1,NM
                IADDM    = IADD  + (M-1)*ICMP*JCMP*KCMP*LCMP
                IF(IFLAG2.NE.0) GOTO 1900
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C QD
                NVTBL(2,IVCNT)   = 12 + LXYZ
C <AB,CD>
                NVTBL(3,IVCNT)   = LCADD1 + LCNT1 - 1   + (M-1)*L1CMP
                IVCNT   = IVCNT + 1
C
C <AB,C(D+1)>
 1900           NVTBL(1,IVCNT)   = IADDM
C WQ
                NVTBL(2,IVCNT)   = 15 + LXYZ
C <AB,CD>+1
                NVTBL(3,IVCNT)   = LCADD1 + LCNT1 - 1   + M*L1CMP
                IVCNT   = IVCNT + 1
C
                IF((LC. LE .2).OR.(NLXYZ. EQ .0))   GOTO 2000
C
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C 1/ETA
c                NVTBL(2,IVCNT)   = 24 + NLXYZ
                NVTBL(2,IVCNT)   = 30 + NLXYZ
C <AB,C(D-1)>
                NVTBL(3,IVCNT)   = LCADD2 + LCNT2 - 1   + (M-1)*L2CMP
                IVCNT   = IVCNT + 1
C
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C ROO/ETA
c                NVTBL(2,IVCNT)   = 27 + NLXYZ
                NVTBL(2,IVCNT)   = 36 + NLXYZ
C <AB,C(D+1)>+1
                NVTBL(3,IVCNT)   = LCADD2 + LCNT2 - 1   + M*L2CMP
                IVCNT   = IVCNT + 1
C
 2000           IF((IC. LT .2).OR.(NIXYZ. EQ .0))   GOTO 2500
C
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C 1/2(ETA+ZETA)
c                NVTBL(2,IVCNT)   = 30 + NIXYZ
                NVTBL(2,IVCNT)   = 42 + NIXYZ
C <(A-1)B,CD>+1
                NVTBL(3,IVCNT)   = ICADD2 + ICNT2 - 1   + M*ILCMP
                IVCNT   = IVCNT + 1
C
 2500           IF((JC. LT .2).OR.(NJXYZ. EQ .0))   GOTO 2600
C
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C 1/2(ETA+ZETA)
c                NVTBL(2,IVCNT)   = 30 + NJXYZ
                NVTBL(2,IVCNT)   = 42 + NJXYZ
C <A(B-1),CD>+1
                NVTBL(3,IVCNT)   = JCADD2 + JCNT2 - 1   + M*JLCMP
                IVCNT   = IVCNT + 1
C
 2600           IF((KC. LT .2).OR.(NKXYZ. EQ .0))   GOTO 4001
C
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C 1/ETA
c                NVTBL(2,IVCNT)   = 24 + NKXYZ
                NVTBL(2,IVCNT)   = 30 + NKXYZ
C <AB,(C-1)D>
                NVTBL(3,IVCNT)   = KCADD2 + KCNT2 - 1   + (M-1)*KLCMP
                IVCNT   = IVCNT + 1
C
C <AB,C(D+1)>
                NVTBL(1,IVCNT)   = IADDM
C ROO/ETA
c                NVTBL(2,IVCNT)   = 27 + NKXYZ
                NVTBL(2,IVCNT)   = 36 + NKXYZ
C <AB,C(D-1)>+1
                NVTBL(3,IVCNT)   = KCADD2 + KCNT2 - 1   + M*KLCMP
                IVCNT   = IVCNT + 1
C
 4001           IF(IVCNT-1.GT.NV) GOTO 9010
 4000         CONTINUE
              IADD   = IADD + 1
 5000       CONTINUE
 6000     CONTINUE
 7000   CONTINUE
 8000 CONTINUE
C
      GOTO 9999
 9000 WRITE(6,8900)
 8900 FORMAT('          CALLED FROM IVTLD ')
      GOTO 9999
C
 9010 WRITE(6,8910)
      IERR   = -1000
 8910 FORMAT(/' ERROR IN IVTLD : BEYOND THE OPERATION TABLE SIZE ',/)
C
 9999 RETURN
      END
C
C## IVAGOR ========================================================== =*
C    SET ANGULAR COMPONENT ODER
C
C======================================================================*
      SUBROUTINE IVAGOR(IC    ,NC    ,NAGL  ,ICNT  )!,IERR  ,LNPRN )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NAGL (4,NC)
c       write(*,*)'ivagor'
      IF(NC. LT .1) GOTO 9999
C
         select case(nc)
C S-TYPE
         case(1)
          ICNT   = 1
          GOTO 10000
C P-TYPE
         case(2)
          ICNT   = NAGL(IC,1)
          GOTO 10000
C D-TYPE
         case(3)
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)

          ICNT   = II*(II-1)/2 + IJ
          GOTO 10000
         case(4)
C F-TYPE
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)!NAGL(IC,2)
          IK     = NAGL(IC,3)!NAGL(IC,3)

          ID     = IJ*(IJ-1)/2 + IK

          ICNT   = (II+1)*II*(II-1)/6 + ID

          GOTO 10000
         case(5)
C G-TYPE
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)
          IK     = NAGL(IC,3)
          IL     = NAGL(IC,4)

          ID     = IK*(IK-1)/2 + IL
          IF     = (IJ+1)*IJ*(IJ-1)/6 + ID

          ICNT   = (II+2)*(II+1)*II*(II-1)/24 + IF
          GOTO 10000

         case(6)

C H-TYPE
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)
          IK     = NAGL(IC,3)
          IL     = NAGL(IC,4)
          IM     = NAGL(IC,5)

          ID     = IL*(IL-1)/2 + IM
          IF     = (IK+1)*IK*(IK-1)/6 + ID
          IG     = (IJ+2)*(IJ+1)*IJ*(IJ-1)/24 + IF

          ICNT   = (II+3)*(II+2)*(II+1)*II*(II-1)/120 + IG


          GOTO 10000
         case(7)
C I-TYPE

          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)
          IK     = NAGL(IC,3)
          IL     = NAGL(IC,4)
          IM     = NAGL(IC,5)
          IA     = NAGL(IC,6)

          ID     =                      IM*(IM-1)/2 + IA
          IF     =               (IL+1)*IL*(IL-1)/6 + ID
          IG     =        (IK+2)*(IK+1)*IK*(IK-1)/24 + IF
          IH     = (IJ+3)*(IJ+2)*(IJ+1)*IJ*(IJ-1)/120 + IG

          ICNT   = (II+4)*(II+3)*(II+2)*(II+1)*II*(II-1)/720 + IH


c         GOTO 9010
          endselect
C
10000 GOTO 9999
C
 9010 IERR   = -1000
      WRITE(6,8910) NC
 8910 FORMAT(//,' >>> ERROR IN IVAGOR. ',
     &          ' SHELL TYPE CODE  ',I2,'  IS NOT SUPPORTED ')
C
 9999 RETURN
      END
C## IVAGNM ========================================================== =*
C  GET ANGULAR COMPONENT ADDRESS AND COUNT SPECIFIED ANGULAR COMPONENTS
C
C======================================================================*
      SUBROUTINE IVAGNM(IC    ,NC    ,NAGL  ,ICONT ,
     &                  IXYZ  ,NXYZ  )!,IERR  ,LNPRN )
C
      IMPLICIT REAL(8) (A-H,O-Z)
      DIMENSION NAGL (4,NC)
C
 
      IF(NC. LT .1) GOTO 9999
         select case(nc)
         case(1)
C S-TYPE
          NXYZ   = 0
          GOTO 9999
         case(2)
C P-TYPE
          NXYZ   = 0
          IF(IXYZ. EQ .NAGL(IC,1)) THEN
            NXYZ    = 1
            ICONT   = 1
          END IF
          GOTO 10000
         case(3)
C D-TYPE
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)
          NXYZ   = 0
          IF(IXYZ. EQ .II) THEN
            NXYZ    = NXYZ + 1
            ICONT   = IJ
          END IF
          IF(IXYZ. EQ .IJ) THEN
            NXYZ    = NXYZ + 1
            ICONT   = II
          END IF
          GOTO 10000
         case(4)
C F-TYPE
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)
          IK     = NAGL(IC,3)
          NXYZ   = 0
          IF(IXYZ. EQ .II) THEN
            NXYZ    = NXYZ + 1
            ICONT   = IJ*(IJ-1)/2 + IK
          END IF
          IF(IXYZ. EQ .IJ) THEN
            NXYZ    = NXYZ + 1
            ICONT   = II*(II-1)/2 + IK
          END IF
          IF(IXYZ. EQ .IK) THEN
            NXYZ    = NXYZ + 1
            ICONT   = II*(II-1)/2 + IJ
          END IF
          GOTO 10000
         case(5)
C G-TYPE
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)
          IK     = NAGL(IC,3)
          IL     = NAGL(IC,4)

          NXYZ   = 0
          IF(IXYZ. EQ .II) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (IJ+1)*IJ*(IJ-1)/6 + IK*(IK-1)/2 +IL
          END IF
          IF(IXYZ. EQ .IJ) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+1)*II*(II-1)/6 + IK*(IK-1)/2 +IL
          END IF
          IF(IXYZ. EQ .IK) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+1)*II*(II-1)/6 + IJ*(IJ-1)/2 +IL
          END IF
          IF(IXYZ. EQ .IL) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+1)*II*(II-1)/6 + IJ*(IJ-1)/2 + IK
          END IF

          GOTO 10000
         case(6)
C H-TYPE
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)
          IK     = NAGL(IC,3)
          IL     = NAGL(IC,4)
          IM     = NAGL(IC,5)

          NXYZ   = 0

          IF(IXYZ. EQ .II) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (IJ+2)*(IJ+1)*IJ*(IJ-1)/24 +  
     &                       (IK+1)*IK*(IK-1)/6  + IL*(IL-1)/2 + IM
          END IF

          IF(IXYZ. EQ .IJ) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+2)*(II+1)*II*(II-1)/24 +  
     &                       (IK+1)*IK*(IK-1)/6  + IL*(IL-1)/2 + IM
          END IF

          IF(IXYZ. EQ .IK) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+2)*(II+1)*II*(II-1)/24 +  
     &                       (IJ+1)*IJ*(IJ-1)/6  + IL*(IL-1)/2 + IM
          END IF

          IF(IXYZ. EQ .IL) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+2)*(II+1)*II*(II-1)/24 +  
     &                       (IJ+1)*IJ*(IJ-1)/6  + IK*(IK-1)/2 + IM
          END IF

          IF(IXYZ. EQ .IM) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+2)*(II+1)*II*(II-1)/24 +  
     &                       (IJ+1)*IJ*(IJ-1)/6  + IK*(IK-1)/2 + IL
          END IF

          GOTO 10000
C I-TYPE
         case(7)
          II     = NAGL(IC,1)
          IJ     = NAGL(IC,2)
          IK     = NAGL(IC,3)
          IL     = NAGL(IC,4)
          IM     = NAGL(IC,5)
          IA     = NAGL(IC,6)

          NXYZ   = 0

          IF(IXYZ. EQ .II) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (IJ+3)*(IJ+2)*(IJ+1)*IJ*(IJ-1)/120 +  
     &                       (IK+2)*(IK+1)*IK*(IK-1)/ 24 + 
     &                              (IL+1)*IL*(IL-1)/  6 +
     &                                     IM*(IM-1)/  2 + IA
          END IF

          IF(IXYZ. EQ .IJ) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+3)*(II+2)*(II+1)*II*(II-1)/120 +  
     &                       (IK+2)*(IK+1)*IK*(IK-1)/ 24 + 
     &                              (IL+1)*IL*(IL-1)/  6 +
     &                                     IM*(IM-1)/  2 + IA
          END IF

          IF(IXYZ. EQ .IK) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+3)*(II+2)*(II+1)*II*(II-1)/120 +  
     &                       (IJ+2)*(IJ+1)*IJ*(IJ-1)/ 24 + 
     &                              (IL+1)*IL*(IL-1)/  6 +
     &                                     IM*(IM-1)/  2 + IA
          END IF

          IF(IXYZ. EQ .IL) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+3)*(II+2)*(II+1)*II*(II-1)/120 +  
     &                       (IJ+2)*(IJ+1)*IJ*(IJ-1)/ 24 + 
     &                              (IK+1)*IK*(IK-1)/  6 +
     &                                     IM*(IM-1)/  2 + IA
          END IF

          IF(IXYZ. EQ .IM) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+3)*(II+2)*(II+1)*II*(II-1)/120 +  
     &                       (IJ+2)*(IJ+1)*IJ*(IJ-1)/ 24 + 
     &                              (IK+1)*IK*(IK-1)/  6 +
     &                                     IL*(IL-1)/  2 + IA
          END IF

          IF(IXYZ. EQ .IA) THEN
            NXYZ    = NXYZ + 1
            ICONT   = (II+3)*(II+2)*(II+1)*II*(II-1)/120 +  
     &                       (IJ+2)*(IJ+1)*IJ*(IJ-1)/ 24 + 
     &                              (IK+1)*IK*(IK-1)/  6 +
     &                                     IL*(IL-1)/  2 + IM
          END IF

          GOTO 10000

c         GOTO 9010

          endselect
C
10000 CONTINUE
C
      GOTO 9999
C
 9010 IERR    = -1000
      WRITE(6,8910) NC
 8910 FORMAT(//,' >>> ERROR IN SUB-IVAGNM. ',
     &          ' SHELL TYPE CODE  ',I2,'  IS NOT SUPPORTED ')
C
 9999 RETURN
      END

