! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
C ITMAIN ============================================================      
C     MAIN ROUTINE FOR ERI WITH OPERATION TABLE
C  =================================================================      
      SUBROUTINE itmain ( 
     &     ec     ,
     &     fdat   , edat   , 
     &     zetpq  , xyz    ,
     &     p      , q      ,  
     &     up     , uq     ,
     &     ntprm  , ita    ,
     &     mxxi   , mxxj   , mxxang, maxsize,
     &     iasp   , jasp   , kasp  , lasp   ,
     &     ishel  , jshel  , kshel , lshel  ,
     &     iatom  , jatom  , katom , latom  ,
     &     nasp   , mxsa   , mxprm , natom  ,
     &     ian    , jan    , kan   , lan    , 
     &     ianga  , mvhgp  ,
     &     iwk    , rwk    ,
     &     nisize , nrsize ,
     &     itnow  , jtnow  )

      implicit real(8)(a-h,o-z)
      
      dimension fdat(31,2001),edat(2001)
      dimension xyz(3,natom)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension p(3,mxprm,mxprm),q(3,mxprm,mxprm)
      dimension up(mxprm,mxprm) ,uq(mxprm,mxprm)

      dimension iwk(nisize),rwk(nrsize)

      dimension ec(mvhgp)
      dimension ita(mxxi,mxxj,mxxang,mxxang,5)

      dimension mm(7)
      data (mm(i),i=1,7) /1,3,6,10,15,21,28/

      iflag1 = 0
      iflag2 = 0
      
      do ijk=1,mvhgp
         ec(ijk) = 0.0d0
      enddo

      iang = ianga - 4
      
      maxcod = max(ian,jan,kan,lan)
      na = maxcod**4
      itaky = ita(ian,jan,kan,lan,1)

      if (itaky.eq.0) then
         
         if (itnow.gt.nisize) then
            write(*,*)"======STOP MEMOEY OVER=======",itnow
            stop
         endif
         ita(ian,jan,kan,lan,1) = itnow
         
         i01 =1                 ! mxxi*mxxj*mxxang*mxxang*5 + 1
         
         call ivrrgr (ian     , jan   , kan   , lan,
     &        iwk(i01), na    , nv    ,
     &        ir      , iflag1, iflag2  )

         nbfsz = 2*na + 4 * maxcod * mm(maxcod)
!     i01 = 1                   ! nred
         i02 = i01 + 10*na      ! nbf
         
         i03 = maxsize + itnow
         
         itnow =itnow + 3*nv
!     i03 = i02 +  nbfsz        ! nvtbl 
!     i04 = i03 +  3*nv        ! nvtbl 
         
         call ivrrgt (iwk(i01),na,iwk(i03),nv,iwk(i02),nbfsz,
     &        ir,maxcod,issss,ninto,nv2        )
         
         
         ita(ian,jan,kan,lan,2) = nv
         ita(ian,jan,kan,lan,3) = nv2
         ita(ian,jan,kan,lan,4) = issss
         ita(ian,jan,kan,lan,5) = ninto
         
      else
         nv     = ita(ian,jan,kan,lan,2)
         nv2    = ita(ian,jan,kan,lan,3)
         issss  = ita(ian,jan,kan,lan,4)
         ninto  = ita(ian,jan,kan,lan,5)
      endif

      i04   = maxsize + ita(ian,jan,kan,lan,1)
      iv    = nv
c$$$      j01   = mvhgp + 1
      j01   = 1
      jtnow = j01 + ninto - 1

!     write(*,*)'JTNOW ',jtnow
!     write(*,*)'ITNOW = ',itnow
!     write(*,*)'nv   = ',nv
!     write(*,*)'nv2  = ',nv2
!     write(*,*)'iv   = ',iv 
!     write(*,*)'issss= ',issss
!     write(*,*)'ninto= ',ninto
!     write(*,*)'mvhgp= ',mvhgp
!     write(*,*)'nbfsz= ',nbfsz

      call itos (fdat , edat  ,
     &     up   , uq    , xyz   ,
     &     zetpq, nasp , mxsa  , mxprm   ,
     &     iasp, jasp , kasp , lasp   ,
     &     ishel, jshel , kshel , lshel   ,
     &     iatom, jatom , katom , latom   ,
     &                    ntprm, natom   ,
     &     iang , p     , q     , iwk(i04), nv      , iv, nv2,
     &     issss, ninto , mvhgp , rwk(j01), ec      ) 

!     call itsortao ( mm,ian,jan,kan,lan,mvhgp,ec )
!     call itsortao ( ian,jan,kan,lan,mm,mvhgp,ec )

      end
