! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
subroutine set_index_geri4(index_geri4,mxang3,init,mm)
  integer :: index_geri4(3,mxang3,4),init(4),mm(7)
  integer,allocatable :: it_gsub(:,:,:)

  integer :: it_g2a(15,5)
  iang = init(1) 
  jang = init(2) 
  kang = init(3) 
  lang = init(4) 

  mi = mm(iang)
  mj = mm(jang)
  mk = mm(kang)
  ml = mm(lang)

  mx = maxval(init)

  allocate(it_gsub(mm(mx),3,3))

  it_gsub = 0
  call set_hgp_transt(init(4),it_g2a,it_gsub,mm(mx))
  mly = 0
  icount = 0
  !--------------- delt -------------
  mlx = mm(lang+1)
  if(lang > 1 ) mly = mm(lang-1)
  do i=1,mi
    i0 = it_g2a(i,iang)
    do j=1,mj
      j0 = it_g2a(j,jang)
      do k=1,mk
        k0 = it_g2a(k,kang)
        do l=1,ml
          l0 = it_g2a(l,lang)
          do ix = 1,3
            l0 = it_gsub(l,ix,1)
            lc = it_gsub(l,ix,2)
            l1 = it_gsub(l,ix,3)

            key = mk*mj*mlx*(i0-1) + mk*mlx*(j0-1) + mlx*(k0-1) + (l0-1) + 1
            kdy = mk*mj*mly*(i0-1) + mk*mly*(j0-1) + mly*(k0-1) + (l1-1) + 1

            icount = icount + 1
            index_geri4(1,icount,4) = key
            index_geri4(2,icount,4) = kdy
            index_geri4(3,icount,4) = lc
          enddo
        enddo
      enddo
    enddo
  enddo

  !--------------- delt -------------

  !--------------- lamd -------------
  mky = 0
  icount = 0
  mkx = mm(kang+1)
  if(kang > 1 ) mky = mm(kang-1)
  call set_hgp_transt(init(3),it_g2a,it_gsub,mm(mx))
  do i=1,mi
    i0 = it_g2a(i,iang)
    do j=1,mj
      j0 = it_g2a(j,jang)
      do k=1,mk
        k0 = it_g2a(k,kang)
        do l=1,ml
          l0 = it_g2a(l,lang)
          do ix = 1,3
            k0 = it_gsub(k,ix,1)
            kc = it_gsub(k,ix,2)
            k1 = it_gsub(k,ix,3)
            key = mkx*mj*ml*(i0-1) + mkx*ml*(j0-1) + ml*(k0-1) + (l0-1) + 1
            kdy = mky*mj*ml*(i0-1) + mky*ml*(j0-1) + ml*(k1-1) + (l0-1) + 1
            icount = icount + 1

            index_geri4(1,icount,3) = key
            index_geri4(2,icount,3) = kdy
            index_geri4(3,icount,3) = kc
          enddo
        enddo
      enddo
    enddo
  enddo
  !--------------- lamd -------------

  !--------------- Beta -------------
  icount = 0
  mjy = 0
  mjx = mm(jang+1)
  if(jang > 1 ) mjy = mm(jang-1)
  call set_hgp_transt(init(2),it_g2a,it_gsub,mm(mx))
  do i=1,mi
    i0 = it_g2a(i,iang)
    do j=1,mj
      j0 = it_g2a(j,jang)
      do k=1,mk
        k0 = it_g2a(k,kang)
        do l=1,ml
          l0 = it_g2a(l,lang)
          do ix = 1,3
            j0 = it_gsub(j,ix,1)
            jc = it_gsub(j,ix,2)
            j1 = it_gsub(j,ix,3)
            key = mjx*mk*ml*(i0-1) + mk*ml*(j0-1) + ml*(k0-1) + (l0-1) + 1
            kdy = mjy*mk*ml*(i0-1) + mk*ml*(j1-1) + ml*(k0-1) + (l0-1) + 1
            if (kdy <0 ) kdy = 0
            icount = icount + 1

            index_geri4(1,icount,2) = key
            index_geri4(2,icount,2) = kdy
            index_geri4(3,icount,2) = jc
          enddo
        enddo
      enddo
    enddo
  enddo
  !--------------- Beta -------------

  !--------------- Alpha -------------
  icount = 0
  call set_hgp_transt(init(1),it_g2a,it_gsub,mm(mx))
  do i=1,mi
    i0 = it_g2a(i,iang)
    do j=1,mj
      j0 = it_g2a(j,jang)
      do k=1,mk
        k0 = it_g2a(k,kang)
        do l=1,ml
          l0 = it_g2a(l,lang)
          do ix = 1,3
            i0 = it_gsub(i,ix,1)
            ic = it_gsub(i,ix,2)
            i1 = it_gsub(i,ix,3)
            key = mj*mk*ml*(i0-1) + mk*ml*(j0-1) + ml*(k0-1) + (l0-1) + 1
            kdy = mj*mk*ml*(i1-1) + mk*ml*(j0-1) + ml*(k0-1) + (l0-1) + 1
            if (kdy <0 ) kdy = 0
            icount = icount + 1

            index_geri4(1,icount,1) = key
            index_geri4(2,icount,1) = kdy
            index_geri4(3,icount,1) = ic
          enddo
        enddo
      enddo
    enddo
  enddo
  !--------------- Alpha -------------

  deallocate(it_gsub)

end subroutine set_index_geri4
subroutine  set_hgp_transt(ix,ind2,ind,max_ang)
  integer :: ind(max_ang,3,3),ind2(15,5)

  ind2 = 0
  ind  = 0
  ind2(1,1) =  1

  ind2(1,2) =  1
  ind2(2,2) =  2
  ind2(3,2) =  3

  ind2(1,3) =  1
  ind2(2,3) =  3
  ind2(3,3) =  6
  ind2(4,3) =  2
  ind2(5,3) =  4
  ind2(6,3) =  5

  ind2( 1,4) =  1
  ind2( 2,4) =  4
  ind2( 3,4) =  10
  ind2( 4,4) =  2
  ind2( 5,4) =  5
  ind2( 6,4) =  3
  ind2( 7,4) =  7
  ind2( 8,4) =  8
  ind2( 9,4) =  9
  ind2(10,4) =  6

  select case(ix)
  case(1)
    ind(1,1,1) = 1
    ind(1,2,1) = 2
    ind(1,3,1) = 3
  case(2)
    ind(1,1,1) = 1
    ind(1,2,1) = 2
    ind(1,3,1) = 4
    ind(2,1,1) = 2
    ind(2,2,1) = 3
    ind(2,3,1) = 5
    ind(3,1,1) = 4
    ind(3,2,1) = 5
    ind(3,3,1) = 6

    ind(1,1,2) = 1
    ind(2,2,2) = 1
    ind(3,3,2) = 1

    ind(1,1,3) = 1
    ind(2,2,3) = 1
    ind(3,3,3) = 1

  case(3)
    ind(1,1,1) = 1
    ind(1,2,1) = 2
    ind(1,3,1) = 5
    ind(2,1,1) = 3
    ind(2,2,1) = 4
    ind(2,3,1) = 7
    ind(3,1,1) = 8
    ind(3,2,1) = 9
    ind(3,3,1) =10
    ind(4,1,1) = 2
    ind(4,2,1) = 3
    ind(4,3,1) = 6
    ind(5,1,1) = 5
    ind(5,2,1) = 6
    ind(5,3,1) = 8
    ind(6,1,1) = 6
    ind(6,2,1) = 7
    ind(6,3,1) = 9

    ind(1,1,2) = 2
    ind(2,2,2) = 2
    ind(3,3,2) = 2
    ind(4,1,2) = 1
    ind(4,2,2) = 1
    ind(5,1,2) = 1
    ind(5,3,2) = 1
    ind(6,2,2) = 1
    ind(6,3,2) = 1

    ind(1,1,3) = 1
    ind(2,2,3) = 2
    ind(3,3,3) = 3
    ind(4,1,3) = 2
    ind(4,2,3) = 1
    ind(5,1,3) = 3
    ind(5,3,3) = 1
    ind(6,2,3) = 3
    ind(6,3,3) = 2

  case(4)
    ind( 1,1,1) = 1
    ind( 1,2,1) = 2
    ind( 1,3,1) = 6
    ind( 2,1,1) = 4
    ind( 2,2,1) = 5
    ind( 2,3,1) = 9
    ind( 3,1,1) =13
    ind( 3,2,1) =14
    ind( 3,3,1) =15
    ind( 4,1,1) = 2
    ind( 4,2,1) = 3
    ind( 4,3,1) = 7
    ind( 5,1,1) = 6
    ind( 5,2,1) = 7
    ind( 5,3,1) =10
    ind( 6,1,1) = 4
    ind( 6,2,1) = 5
    ind( 6,3,1) = 8
    ind( 7,1,1) = 8
    ind( 7,2,1) = 9
    ind( 7,3,1) =12
    ind( 8,1,1) =10
    ind( 8,2,1) =11
    ind( 8,3,1) =13
    ind( 9,1,1) =11
    ind( 9,2,1) =12
    ind( 9,3,1) =14
    ind(10,1,1) = 7
    ind(10,2,1) = 8
    ind(10,3,1) =11

    ind( 1,1,2) = 3
    ind( 2,2,2) = 3
    ind( 3,3,2) = 3
    ind( 4,1,2) = 2
    ind( 4,2,2) = 1
    ind( 5,1,2) = 2
    ind( 5,3,2) = 1
    ind( 6,1,2) = 1
    ind( 6,2,2) = 2
    ind( 7,2,2) = 2
    ind( 7,3,2) = 1
    ind( 8,1,2) = 1
    ind( 8,3,2) = 2
    ind( 9,2,2) = 1
    ind( 9,3,2) = 2
    ind(10,1,2) = 1
    ind(10,2,2) = 1
    ind(10,3,2) = 1

    ind( 1,1,2) = 1
    ind( 2,2,2) = 3
    ind( 3,3,2) = 6
    ind( 4,1,2) = 2
    ind( 4,2,2) = 1
    ind( 5,1,2) = 4
    ind( 5,3,2) = 1
    ind( 6,1,2) = 3
    ind( 6,2,2) = 2
    ind( 7,2,2) = 5
    ind( 7,3,2) = 3
    ind( 8,1,2) = 6
    ind( 8,3,2) = 4
    ind( 9,2,2) = 6
    ind( 9,3,2) = 5
    ind(10,1,2) = 5
    ind(10,2,2) = 4
    ind(10,3,2) = 2

  endselect
end subroutine set_hgp_transt
