! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
subroutine jthgp(init,icount, mm,ihgpx,index_set_hgp,ikey,ihs,ihe,msize)

  implicit real(8)(a-h,o-z)

  dimension mm(7),init(4)
  dimension ihgpx(3,ihs:ihe,6)
  dimension index_set_hgp(4,msize,6)
  integer,allocatable ::  ia2x(:,:,:,:),iab2x(:,:,:)

  iang = init(1)
  jang = init(2)
  kang = init(3)
  lang = init(4)

  select case(ikey)
  case(1)
    iang = iang + 1
  case(2)
    jang = jang + 1
  case(3)
    kang = kang + 1
  case(4)
    iang = iang - 1
  case(5)
    jang = jang - 1
  case(6)
    kang = kang - 1
  endselect
 
  iap = iang + jang -1
  iaq = kang + lang -1

  allocate(ia2x(iang:iap,jang,kang:iaq,lang))
  ia2x = 0

  ic2 = 1

  ichi = 1
  do i=1,icount
    ian = index_set_hgp(3,i,ikey)
    jan = index_set_hgp(4,i,ikey)
    if ((ian.ge.iang).and.(jan.ge.kang) )then

      mmv = mm(ian)*mm(jan)
      is = ic2
      ic2 = ic2 + mmv
      ie = ic2-1
      ia2x(ian,1,jan,1) = is

    endif
  enddo

  mall  = ic2
  ic2 = ic2 - 1

  do iab = 1,lang

    kk = kang  + iab - 1
    ll = 1

    do iabx = jang-1 ,1 ,-1
      do ix = 1,iabx
        ii = iang + ix - 1
        jj = jang - iabx + 1
        mvhgp = mm(ii)*mm(jj)*mm(kk)*mm(ll)

        is = mall
        mall = mall + mvhgp
        ie = mall - 1

        ia2x(ii,jj,kk,ll) = is

        ! ====
        miang = mm(ii)
        mjang = mm(jj)

        allocate(iab2x(2,miang,mjang))

        iab2x = 0

        call jtab2x(ii,jj,miang,mjang,mm,iab2x)
        il = ia2x(ii+1,jj-1,kk,ll)
        ir = ia2x(ii  ,jj-1,kk,ll)

        imxcount = 0
        do i0 = 1,mm(ii)
          do j0 = 1,mm(jj)
            iab1 = iab2x(1,i0,j0)
            iab2 = iab2x(2,i0,j0)

            if (j0.eq.1) ic1 = 1
            if ((j0.ge.2).and.(j0.le.jj)) ic1 = 2
            if (j0.gt.jj) ic1 = 3

            do k0 = 1,mm(kk)
              do l0 = 1,mm(ll)

                key = (k0-1)*mm(ll)+l0
                iadd1 = (iab1-1)*mm(kk)*mm(ll) + key + il - 1

                iadd2 = (iab2-1)*mm(kk)*mm(ll) + key + ir - 1

                imx = is + imxcount
                im1 = iadd1
                im2 = iadd2
                imxcount = imxcount + 1

                ihgpx(1,imx,ikey) = im1
                ihgpx(2,imx,ikey) = im2
                ihgpx(3,imx,ikey) = ic1

              enddo
            enddo
          enddo
        enddo

        deallocate(iab2x)
      enddo
    enddo

  enddo

  !     write(*,*)"----- CD part -----"
  ii = iang
  jj = jang

  do icdx = lang-1,1,-1
    do i = 1,icdx
      kk = kang + i - 1
      ll = lang - icdx + 1

      mvhgp = mm(ii)*mm(jj)*mm(kk)*mm(ll)

      is = mall
      mall = mall + mvhgp

      ie = mall - 1

      ia2x(ii,jj,kk,ll) = is

      mkang = mm(kk)
      mlang = mm(ll)

      allocate(iab2x(2,mkang,mlang))
      iab2x = 0

      call jtab2x(kk,ll,mkang,mlang,mm,iab2x)

      il = ia2x(ii,jj,kk+1,ll-1)
      ir = ia2x(ii,jj,kk  ,ll-1)

      imxcount = 0
      do i0 = 1,mm(ii)
        do j0 = 1,mm(jj)
          key = j0 + mm(jj)*(i0-1) 
          do k0 = 1,mm(kk)
            do l0 = 1,mm(ll)


              if (l0.eq.1) ic1 = 4
              if ((l0.ge.2).and.(l0.le.ll)) ic1 = 5
              if (l0.gt.ll) ic1 = 6

              icd1 = iab2x(1,k0,l0)+(key-1)*mm(kk+1)*mm(ll-1)
              icd2 = iab2x(2,k0,l0)+(key-1)*mm(kk  )*mm(ll-1)

              imx = is + imxcount
              im1 = icd1 + il -1
              im2 = icd2 + ir -1

              imxcount = imxcount + 1
              ihgpx(1,imx,ikey) = im1
              ihgpx(2,imx,ikey) = im2
              ihgpx(3,imx,ikey) = ic1

            enddo
          enddo
        enddo
      enddo
      deallocate(iab2x)

    enddo
  enddo

end subroutine jthgp

!JTAB2X ==============================================================
!
!
!===================================================================
subroutine jtab2x(iang,jang,miang,mjang,mm,iab2x)

  implicit real(8)(a-h,o-z)

  dimension mm(7) ,iab2x(2,miang,mjang)

  nang = iang + jang -2 !new ang

  mnang = mm(nang)

  do i=1,iang

    do j = 1,mjang
      if (j.eq.1) then
        key = i
        kiss = (key-1)*mm(jang-1) + j
      endif

      if ((j.ge.2).and.(j.le.jang)) then
        key = i + 1
        kiss = (key-1)*mm(jang-1) + j-1
      endif

      if (j.gt.jang) then
        key = i + iang + 1
        kiss = (key-1)*mm(jang-1) + j-jang
      endif
      iab2x(1,i,j) = kiss

    enddo


  enddo

  key0 = iang + 2
  icount = iang
  do ii = 1,iang-1
    ix = iang - ii
    do jj = 1,ix

      icount = icount + 1
      i = icount

      do j = 1,mjang
        if (j.eq.1) then
          key = key0 + jj - 1
          keyx = key
          kiss = (key-1)*mm(jang-1) + j
        endif

        if ((j.ge.2).and.(j.le.jang)) then
          key = keyx + 1
          keyy = key
          kiss = (key-1)*mm(jang-1) + j -1
        endif

        if (j.gt.jang) then
          key = keyy + ix
          kiss = (key-1)*mm(jang-1) + j - jang
        endif

        iab2x(1,i,j) = kiss
      enddo


    enddo
    key0 = key0 + ix + 1
  enddo

  !     iab2x = 0

  do i = 1,miang
    do j = 1,mjang

      if (j.eq.1) then
        key = (i-1)*mm(jang-1) + 1
        key1 = key
      endif

      if ((j.ge.2).and.(j.le.jang)) then
        key = key1 + j - 2
      endif
      !           
      if (j.gt.jang) then
        key = key1 + j - jang -1
      endif
      iab2x(2,i,j) = key
    enddo
  enddo

end subroutine jtab2x


subroutine jtshgp(init,mm,mall)

  implicit real(8)(a-h,o-z)

  dimension mm(7),init(4)

  iang = init(1)
  jang = init(2)
  kang = init(3)
  lang = init(4)
  mall = 1

  icount = 0
  mhgp2 = 0
  !     write(*,*)"====== AB PART ======"
  do iab = 1,lang

    kk = kang + iab-1
    ll = 1
    if (kk < 1 ) cycle !!!/2009/12/10
    do iabx = jang,1,-1
      do i=1,iabx
        ii = iang + i - 1 
        jj = jang-iabx+1

        if(jj.eq.1) cycle

        mvhgp = mm(ii)*mm(jj)*mm(kk)*mm(ll)

        is = mall
        mall = mall + mvhgp
        ie = mall-1

        icount = icount + 1
      enddo
    enddo

  enddo
  !     write(*,*)"====== CD PART ======"
  iad = ie 
  jcount = 0

  ii = iang
  jj = jang
  do icdx = lang-1,1,-1
    do i=1,icdx
      kk = kang + i -1
      ll = lang - icdx + 1
      if ( (ii < 1 ) .or. (jj < 1) ) then
          mvhgp = 0
      else

      mvhgp = mm(ii)*mm(jj)*mm(kk)*mm(ll)
      endif
      is = mall
      mall = mall + mvhgp
      ie = mall-1
      jcount = jcount + 1

    enddo
  enddo
  mall = mall -1
end subroutine jtshgp

