! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!#swz_cutthr == =======================================================
!     Calculating for Max Value of |(rr|rr)|
!     set cutthr  (erithr^2/|max(rr|rr)|)
! 
!     (rs|tu)^2  < |(rs|rs)||(tu|tu)|
!                < |(rs|rs)||max(rr|rr)| < erithr^2
!
!     |(rs|rs)| < erithr^2/|max(rr|rr)|
!======================================================================*
      subroutine swz_cutthr(
     &     cutthr,
     &     e_rrrr,
     &     nr_s  ,  nr_e,  ns_s,  ns_e,
     &     nt_s  ,  nt_e,  nu_s,  nu_e,
     &     nao   ,  erithr              )
      implicit real(8)(a-h,o-z)

      dimension e_rrrr(nao)

      rrmax = 0.d0

      do i = nr_s ,nr_e
       rmax = e_rrrr(i)
       if (rmax.gt.rrmax) rrmax = rmax
      enddo
        
      do i = ns_s ,ns_e
       rmax = e_rrrr(i)
       if (rmax.gt.rrmax) rrmax = rmax
      enddo
        
      do i = nt_s ,nt_e
       rmax = e_rrrr(i)
       if (rmax.gt.rrmax) rrmax = rmax
      enddo
        
      do i = nu_s ,nu_e
       rmax = e_rrrr(i)
       if (rmax.gt.rrmax) rrmax = rmax
      enddo
       
      cutthr =  erithr**2 / rrmax

      end
