! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!> 
!!
module physical_constants_class
  implicit none
  private

  ! Length
  ! 1 Bohr = 0.52917720859 Ang
  !real(8),public,parameter::BOHR = 0.52917720859d0 !(CODATA2006)
  real(8),public,parameter::Bohr2Ang = 0.529177249d0 !< Bohrs to Angstroms
  real(8),public,parameter::Bohr = Bohr2Ang

  ! Energy
  ! 1 Eh = 27.21138386 eV = 627.5094706 kcal/mol = 2625.4996251 kJ/mol
  real(8),public,parameter::Hartree2kcal_mol = 627.5094706d0
  real(8),public,parameter::Hartree2kJ_mol   = 2625.4996251d0
  real(8),public,parameter::Hartree2eV       = 27.21138386d0

  ! Dipole moment
  ! 1 a.u. = 2.5417462289 Debye

  real(8),public,parameter::PI = 3.141592653589793238462643383279d0
  real(8),public,parameter::ROOT3 = 1.732050807568877293527446341505d0
  real(8),public,parameter :: root3x2 = 3.0d0 !root3*root3
  real(8),public,parameter :: root3x3 = root3x2*root3
  real(8),public,parameter :: root3x4 = 9.0d0 !root3x3*root3

end module physical_constants_class
