! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
  module pl_bms_helper_class
    implicit none
!!$  private

contains
  !-----------------------------------------------------------------------------
  !> ファイル名の取得
  function pl_bms_helper_get_file_name(url, ext) result(file_name)
    character(len=*),intent(in)::url
    character(len=*),intent(in)::ext
    character(len=len(url)+len(ext))::file_name

    file_name = trim(adjustl(url)) // trim(ext)
  end function pl_bms_helper_get_file_name

  !-----------------------------------------------------------------------------
  !> データサイズの取得
  function pl_bms_helper_get_size(lshape) result(nsize)
    integer,intent(in)::lshape(:)
    integer::nsize

    integer::n
    integer::i

    n = size(lshape)
    nsize = 1
    do i = 1, n
       nsize = nsize*lshape(i)
    end do

  end function pl_bms_helper_get_size

  !-----------------------------------------------------------------------------
  end module pl_bms_helper_class
