! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!= iofsss ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine jossss(
     &     ec   ,
     &     fdat , edat  ,
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  ,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )

      implicit real(8) (a-h,o-z)           
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)
 
      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

#ifdef PL_SIMD_DERI
      dimension dmx(2,mxprm), val(4,mxprm)
#endif

!     do j=1,4
!        do i=1,mao3
!           ec(i,j) = 0.d0
!       enddo
!     enddo

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)

         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)

            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)

            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(2)) then
                     
                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f1   = (((((fdat(8,it)*dt6   + fdat(7,it))*dt5
     &                    + fdat(6,it))*dt4  + fdat(5,it))*dt3
     &                    + fdat(4,it))*dt2  + fdat(3,it))*dt
     &                    + fdat(2,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     
                  else
!                    qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
 
                  end if
                  
#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
 
                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
#endif                  
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  s0 = dm0
                  s1 = dm1      !/  roo2

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz

                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
                  
                  ec(1,1) = ec(1,1) +alp*( pax*s0 + wpx*s1)
                  ec(2,1) = ec(2,1) +alp*( pay*s0 + wpy*s1)
                  ec(3,1) = ec(3,1) +alp*( paz*s0 + wpz*s1)
                            
                  ec(1,2) = ec(1,2) +bet*( pbx*s0 + wpx*s1)
                  ec(2,2) = ec(2,2) +bet*( pby*s0 + wpy*s1)
                  ec(3,2) = ec(3,2) +bet*( pbz*s0 + wpz*s1)
                             
                  ec(1,3) = ec(1,3) +ram*( qcx*s0 + wqx*s1)
                  ec(2,3) = ec(2,3) +ram*( qcy*s0 + wqy*s1)
                  ec(3,3) = ec(3,3) +ram*( qcz*s0 + wqz*s1)
                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
!$omp end parallel
#endif
      ec(1,4) = -( ec(1,1) + ec(1,2) + ec(1,3) )
      ec(2,4) = -( ec(2,1) + ec(2,2) + ec(2,3) )
      ec(3,4) = -( ec(3,1) + ec(3,2) + ec(3,3) )

      end
!= iofsss ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine jopsss(
     &     ec   ,
     &     fdat , edat  ,
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  ,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )

      implicit real(8) (a-h,o-z)           
c$$$      dimension fdat(31,2001)
c$$$      dimension edat(2001)
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(5) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /)

#ifdef PL_SIMD_DERI
      dimension dmx(3,mxprm), val(5,mxprm)
#endif

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      s00 = 0.0d0

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

!     do j=1,4
!        do i=1,mao3
!          ec(i,j)=0.d0
!       enddo
!     enddo

#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)
         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)

c     up_rpi = up * sqrt_pi5
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)

                  roo2 = 1.0d0 / (zet + eta)
!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(3)) then
                     
                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f2   = (((((fdat(9,it)*dt6   + fdat(8,it))*dt5
     &                    + fdat(7,it))*dt4  + fdat(6,it))*dt3
     &                    + fdat(5,it))*dt2  + fdat(4,it))*dt
     &                    + fdat(3,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f1   =  (t2*f2 + ee)*rminv(2) 
                     f0   =   t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0

                     dm1 = fpp*f1
                     dm2 = fpp*f2
                     
                  else
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv
!                    qinv = 1.0d0/qp2
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
 
                  end if

#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
                  val(5,l) = eta
 
                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
                  dmx(3,l) = dm2
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)
                  eta  = val(5,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
                  dm2 = dmx(3,l)
#endif
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  s0 = dm0
                  s1 = dm1
                  s2 = dm2
                  s00 = s00 + s0

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz

!JOPSSS(dsss,ppss,psps)

                  px0=pax*s0 + wpx*s1
                  py0=pay*s0 + wpy*s1
                  pz0=paz*s0 + wpz*s1
                  px1=pax*s1 + wpx*s2
                  py1=pay*s1 + wpy*s2
                  pz1=paz*s1 + wpz*s2

                  rkp = rooz * eta
                  s01 = zet*(s0 - rooz*s1)
                  rs1 = rkp*s1
!dsss
                  ec(1,1) = ec(1,1) + alp*(pax*px0 + wpx*px1 + s01)
                  ec(4,1) = ec(4,1) + alp*(pay*px0 + wpy*px1      )
                  ec(5,1) = ec(5,1) + alp*(pay*py0 + wpy*py1 + s01)
                  ec(7,1) = ec(7,1) + alp*(paz*px0 + wpz*px1      )
                  ec(8,1) = ec(8,1) + alp*(paz*py0 + wpz*py1      )
                  ec(9,1) = ec(9,1) + alp*(paz*pz0 + wpz*pz1 + s01)
!ppss
                  ec(1,2) = ec(1,2) + bet*(pbx*px0 + wpx*px1 + s01)
                  ec(2,2) = ec(2,2) + bet*(pby*px0 + wpy*px1      )
                  ec(3,2) = ec(3,2) + bet*(pbz*px0 + wpz*px1      )
                  ec(4,2) = ec(4,2) + bet*(pbx*py0 + wpx*py1      )
                  ec(5,2) = ec(5,2) + bet*(pby*py0 + wpy*py1 + s01)
                  ec(6,2) = ec(6,2) + bet*(pbz*py0 + wpz*py1      )
                  ec(7,2) = ec(7,2) + bet*(pbx*pz0 + wpx*pz1      )
                  ec(8,2) = ec(8,2) + bet*(pby*pz0 + wpy*pz1      ) 
                  ec(9,2) = ec(9,2) + bet*(pbz*pz0 + wpz*pz1 + s01)
!psps
                  ec(1,3) = ec(1,3) + ram*(qcx*px0 + wqx*px1 + rs1)
                  ec(2,3) = ec(2,3) + ram*(qcy*px0 + wqy*px1      )
                  ec(3,3) = ec(3,3) + ram*(qcz*px0 + wqz*px1      )
                  ec(4,3) = ec(4,3) + ram*(qcx*py0 + wqx*py1      )
                  ec(5,3) = ec(5,3) + ram*(qcy*py0 + wqy*py1 + rs1)
                  ec(6,3) = ec(6,3) + ram*(qcz*py0 + wqz*py1      )
                  ec(7,3) = ec(7,3) + ram*(qcx*pz0 + wqx*pz1      )
                  ec(8,3) = ec(8,3) + ram*(qcy*pz0 + wqy*pz1      )
                  ec(9,3) = ec(9,3) + ram*(qcz*pz0 + wqz*pz1 + rs1)


                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
#endif

      ec(1,1) = ec(1,1) -s00
      ec(2,1) = ec(4,1)
      ec(3,1) = ec(7,1)
      ec(5,1) = ec(5,1) -s00
      ec(6,1) = ec(8,1)
      ec(9,1) = ec(9,1) -s00
#ifdef PL_OMP_DERI
!$omp end parallel
#endif

      do i=1,3
         do j=1,9
             ec(j,4) = ec(j,4) - ec(j,i)
         enddo
      enddo
      end
!= iofsss ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine joppss(
     &     ec   ,
     &     fdat , edat  ,
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  ,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )

      implicit real(8) (a-h,o-z)           
c$$$      dimension fdat(31,2001)
c$$$      dimension edat(2001)
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)
 
      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(5) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /)

#ifdef PL_SIMD_DERI
      dimension dmx(4,mxprm), val(5,mxprm)
#endif

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

!     do j = 1,4
!        do i = 1,mao3
!           ec(i,j) = 0.0d0
!        enddo
!     enddo

      px00 = 0.0d0
      py00 = 0.0d0
      pz00 = 0.0d0
      xp00 = 0.0d0
      yp00 = 0.0d0
      zp00 = 0.0d0

#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)
         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(4)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f3   = (((((fdat(10,it)*dt6   + fdat(9,it))*dt5
     &                    + fdat(8,it))*dt4  + fdat(7,it))*dt3
     &                    + fdat(6,it))*dt2  + fdat(5,it))*dt
     &                    + fdat(4,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0

                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f2   =  (t2*f3 + ee)*rminv(3)
                     f1   =  (t2*f2 + ee)*rminv(2)
                     f0   =   t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0

                     dm1 = fpp*f1
                     dm2 = fpp*f2
                     dm3 = fpp*f3
                     
                  else
!                    qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv

                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0

                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
 
                  end if
                  
#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
                  val(5,l) = eta

                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
                  dmx(3,l) = dm2
                  dmx(4,l) = dm3
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)
                  eta  = val(5,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
                  dm2 = dmx(3,l)
                  dm3 = dmx(4,l)
#endif
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  s0 = dm0
                  s1 = dm1
                  s2 = dm2
                  s3 = dm3

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
!psss
                  px0=pax*s0 + wpx*s1
                  py0=pay*s0 + wpy*s1
                  pz0=paz*s0 + wpz*s1
                  px1=pax*s1 + wpx*s2
                  py1=pay*s1 + wpy*s2
                  pz1=paz*s1 + wpz*s2
                  px2=pax*s2 + wpx*s3
                  py2=pay*s2 + wpy*s3
                  pz2=paz*s2 + wpz*s3

                  px00 = px00 + px0
                  py00 = py00 + py0
                  pz00 = pz00 + pz0

!spss
                  xp0=pbx*s0 + wpx*s1
                  yp0=pby*s0 + wpy*s1
                  zp0=pbz*s0 + wpz*s1
                  xp1=pbx*s1 + wpx*s2
                  yp1=pby*s1 + wpy*s2
                  zp1=pbz*s1 + wpz*s2

                  xp00 = xp00 + xp0
                  yp00 = yp00 + yp0
                  zp00 = zp00 + zp0

                  rkp =  rooz * eta
                  s01 = zet*(s0 -rooz*s1)
                  s12 = zet*(s1 -rooz*s2)
                  rs1 = rkp*s1
                  rs2 = rkp*s2
!ppss
                  ppxx0 = pbx*px0 + wpx*px1 + s01
                  ppxy0 = pby*px0 + wpy*px1
                  ppxz0 = pbz*px0 + wpz*px1
                  ppyx0 = pbx*py0 + wpx*py1
                  ppyy0 = pby*py0 + wpy*py1 + s01
                  ppyz0 = pbz*py0 + wpz*py1
                  ppzx0 = pbx*pz0 + wpx*pz1
                  ppzy0 = pby*pz0 + wpy*pz1
                  ppzz0 = pbz*pz0 + wpz*pz1 + s01
            
                  ppxx1 = pbx*px1 + wpx*px2 + s12
                  ppxy1 = pby*px1 + wpy*px2
                  ppxz1 = pbz*px1 + wpz*px2
                  ppyx1 = pbx*py1 + wpx*py2
                  ppyy1 = pby*py1 + wpy*py2 + s12
                  ppyz1 = pbz*py1 + wpz*py2
                  ppzx1 = pbx*pz1 + wpx*pz2
                  ppzy1 = pby*pz1 + wpy*pz2
                  ppzz1 = pbz*pz1 + wpz*pz2 + s12
!psss01
                  px01 = zet*(px0 -rooz*px1)
                  py01 = zet*(py0 -rooz*py1)
                  pz01 = zet*(pz0 -rooz*pz1)
!spss01
                  xp01 = zet*(xp0 -rooz*xp1)
                  yp01 = zet*(yp0 -rooz*yp1)
                  zp01 = zet*(zp0 -rooz*zp1)
!dpss
                  ec( 1,1)=ec( 1,1)+alp*(pax*ppxx0+wpx*ppxx1+xp01+px01)
                  ec( 4,1)=ec( 4,1)+alp*(pax*ppxy0+wpx*ppxy1+yp01     )
                  ec( 7,1)=ec( 7,1)+alp*(pax*ppxz0+wpx*ppxz1+zp01     )
                  ec(10,1)=ec(10,1)+alp*(pay*ppxx0+wpy*ppxx1          )
                  ec(11,1)=ec(11,1)+alp*(pay*ppyx0+wpy*ppyx1+xp01     )
                  ec(13,1)=ec(13,1)+alp*(pax*ppyy0+wpx*ppyy1          )
                  ec(14,1)=ec(14,1)+alp*(pay*ppyy0+wpy*ppyy1+yp01+py01)
                  ec(16,1)=ec(16,1)+alp*(pay*ppxz0+wpy*ppxz1          )
                  ec(17,1)=ec(17,1)+alp*(pay*ppyz0+wpy*ppyz1+zp01     )
                  ec(19,1)=ec(19,1)+alp*(paz*ppxx0+wpz*ppxx1          )
                  ec(20,1)=ec(20,1)+alp*(paz*ppyx0+wpz*ppyx1          )
                  ec(21,1)=ec(21,1)+alp*(paz*ppzx0+wpz*ppzx1+xp01     )
                  ec(22,1)=ec(22,1)+alp*(pax*ppzy0+wpx*ppzy1          )
                  ec(23,1)=ec(23,1)+alp*(paz*ppyy0+wpz*ppyy1          )
                  ec(24,1)=ec(24,1)+alp*(paz*ppzy0+wpz*ppzy1+yp01     )
                  ec(25,1)=ec(25,1)+alp*(pax*ppzz0+wpx*ppzz1          )
                  ec(26,1)=ec(26,1)+alp*(pay*ppzz0+wpy*ppzz1          )
                  ec(27,1)=ec(27,1)+alp*(paz*ppzz0+wpz*ppzz1+zp01+pz01)
!pdss
                  ec( 1,2)=ec( 1,2)+bet*(pbx*ppxx0+wpx*ppxx1+xp01+px01)
                  ec( 5,2)=ec( 5,2)+bet*(pby*ppxy0+wpy*ppxy1     +px01)
                  ec( 9,2)=ec( 9,2)+bet*(pbz*ppxz0+wpz*ppxz1     +px01)
                  ec( 4,2)=ec( 4,2)+bet*(pby*ppxx0+wpy*ppxx1          )
                  ec( 7,2)=ec( 7,2)+bet*(pbz*ppxx0+wpz*ppxx1          )
                  ec( 8,2)=ec( 8,2)+bet*(pbz*ppxy0+wpz*ppxy1          )
                  ec(10,2)=ec(10,2)+bet*(pbx*ppyx0+wpx*ppyx1     +py01)
                  ec(14,2)=ec(14,2)+bet*(pby*ppyy0+wpy*ppyy1+yp01+py01)
                  ec(18,2)=ec(18,2)+bet*(pbz*ppyz0+wpz*ppyz1     +py01)
                  ec(13,2)=ec(13,2)+bet*(pbx*ppyy0+wpx*ppyy1          )
                  ec(16,2)=ec(16,2)+bet*(pbz*ppyx0+wpz*ppyx1          )
                  ec(17,2)=ec(17,2)+bet*(pbz*ppyy0+wpz*ppyy1          )
                  ec(19,2)=ec(19,2)+bet*(pbx*ppzx0+wpx*ppzx1     +pz01)
                  ec(23,2)=ec(23,2)+bet*(pby*ppzy0+wpy*ppzy1     +pz01)
                  ec(27,2)=ec(27,2)+bet*(pbz*ppzz0+wpz*ppzz1+zp01+pz01)
                  ec(22,2)=ec(22,2)+bet*(pby*ppzx0+wpy*ppzx1          )
                  ec(25,2)=ec(25,2)+bet*(pbx*ppzz0+wpx*ppzz1          )
                  ec(26,2)=ec(26,2)+bet*(pby*ppzz0+wpy*ppzz1          )
!rspss
                  rxp1 = rkp * xp1
                  ryp1 = rkp * yp1
                  rzp1 = rkp * zp1
!rpsss
                  rpx1 = rkp * px1
                  rpy1 = rkp * py1
                  rpz1 = rkp * pz1
!ppps
                  ec( 1,3)=ec( 1,3)+ram*(qcx*ppxx0+wqx*ppxx1+rxp1+rpx1)
                  ec( 2,3)=ec( 2,3)+ram*(qcy*ppxx0+wqy*ppxx1          )
                  ec( 3,3)=ec( 3,3)+ram*(qcz*ppxx0+wqz*ppxx1          )
                  ec( 4,3)=ec( 4,3)+ram*(qcx*ppxy0+wqx*ppxy1+ryp1     )
                  ec( 5,3)=ec( 5,3)+ram*(qcy*ppxy0+wqy*ppxy1     +rpx1)
                  ec( 6,3)=ec( 6,3)+ram*(qcz*ppxy0+wqz*ppxy1          )
                  ec( 7,3)=ec( 7,3)+ram*(qcx*ppxz0+wqx*ppxz1+rzp1     )
                  ec( 8,3)=ec( 8,3)+ram*(qcy*ppxz0+wqy*ppxz1          )
                  ec( 9,3)=ec( 9,3)+ram*(qcz*ppxz0+wqz*ppxz1     +rpx1)
                  ec(10,3)=ec(10,3)+ram*(qcx*ppyx0+wqx*ppyx1     +rpy1)
                  ec(11,3)=ec(11,3)+ram*(qcy*ppyx0+wqy*ppyx1+rxp1     )
                  ec(12,3)=ec(12,3)+ram*(qcz*ppyx0+wqz*ppyx1          )
                  ec(13,3)=ec(13,3)+ram*(qcx*ppyy0+wqx*ppyy1          )
                  ec(14,3)=ec(14,3)+ram*(qcy*ppyy0+wqy*ppyy1+ryp1+rpy1)
                  ec(15,3)=ec(15,3)+ram*(qcz*ppyy0+wqz*ppyy1          )
                  ec(16,3)=ec(16,3)+ram*(qcx*ppyz0+wqx*ppyz1          )
                  ec(17,3)=ec(17,3)+ram*(qcy*ppyz0+wqy*ppyz1+rzp1     )
                  ec(18,3)=ec(18,3)+ram*(qcz*ppyz0+wqz*ppyz1     +rpy1)
                  ec(19,3)=ec(19,3)+ram*(qcx*ppzx0+wqx*ppzx1     +rpz1)
                  ec(20,3)=ec(20,3)+ram*(qcy*ppzx0+wqy*ppzx1          )
                  ec(21,3)=ec(21,3)+ram*(qcz*ppzx0+wqz*ppzx1+rxp1     )
                  ec(22,3)=ec(22,3)+ram*(qcx*ppzy0+wqx*ppzy1          )
                  ec(23,3)=ec(23,3)+ram*(qcy*ppzy0+wqy*ppzy1     +rpz1)
                  ec(24,3)=ec(24,3)+ram*(qcz*ppzy0+wqz*ppzy1+ryp1     )
                  ec(25,3)=ec(25,3)+ram*(qcx*ppzz0+wqx*ppzz1          )
                  ec(26,3)=ec(26,3)+ram*(qcy*ppzz0+wqy*ppzz1          )
                  ec(27,3)=ec(27,3)+ram*(qcz*ppzz0+wqz*ppzz1+rzp1+rpz1)

                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
#endif

      ec( 1,1) = ec( 1,1) - xp00
      ec( 2,1) = ec(10,1)
      ec( 3,1) = ec(19,1)
      ec( 4,1) = ec( 4,1) - yp00
      ec( 5,1) = ec(13,1)
      ec( 6,1) = ec(22,1)
      ec( 7,1) = ec( 7,1) - zp00
      ec( 8,1) = ec(16,1)
      ec( 9,1) = ec(25,1)
      ec(11,1) = ec(11,1) - xp00
      ec(12,1) = ec(20,1)
      ec(14,1) = ec(14,1) - yp00
      ec(15,1) = ec(23,1)
      ec(17,1) = ec(17,1) - zp00
      ec(18,1) = ec(26,1)
      ec(21,1) = ec(21,1) - xp00
      ec(24,1) = ec(24,1) - yp00
      ec(27,1) = ec(27,1) - zp00

      ec( 1,2) = ec( 1,2) - px00
      ec( 2,2) = ec( 4,2)
      ec( 3,2) = ec( 7,2)
      ec( 4,2) = ec( 4,2)
      ec( 5,2) = ec( 5,2) - px00
      ec( 6,2) = ec( 8,2)
      ec( 9,2) = ec( 9,2) - px00
      ec(10,2) = ec(10,2) - py00
      ec(11,2) = ec(13,2)
      ec(12,2) = ec(16,2)
      ec(14,2) = ec(14,2) - py00
      ec(15,2) = ec(17,2)
      ec(18,2) = ec(18,2) - py00
      ec(19,2) = ec(19,2) - pz00
      ec(20,2) = ec(22,2)
      ec(21,2) = ec(25,2)
      ec(23,2) = ec(23,2) - pz00
      ec(24,2) = ec(26,2)
      ec(27,2) = ec(27,2) - pz00
#ifdef PL_OMP_DERI
!$omp end parallel
#endif
               
       do i=1,3
          do j=1,mao3        
             ec(j,4) = ec(j,4) - ec(j,i)
          enddo
       enddo
      end
!= iofsss ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine jopsps(
     &     ec   ,
     &     fdat , edat  ,
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  ,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )

      implicit real(8) (a-h,o-z)           
c$$$      dimension fdat(31,2001)
c$$$      dimension edat(2001)
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(5) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /)

#ifdef PL_SIMD_DERI
      dimension dmx(4,mxprm), val(5,mxprm)
#endif

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

!     do j = 1,4
!        do i = 1,mao3
!           ec(i,j) = 0.0d0
!        enddo
!     enddo

      px00  = 0.0d0
      py00  = 0.0d0
      pz00  = 0.0d0
      sxp00 = 0.0d0
      syp00 = 0.0d0
      szp00 = 0.0d0

#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)
         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)

            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)

            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(4)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f3   = (((((fdat(10,it)*dt6   + fdat(9,it))*dt5
     &                    + fdat(8,it))*dt4  + fdat(7,it))*dt3
     &                    + fdat(6,it))*dt2  + fdat(5,it))*dt
     &                    + fdat(4,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0

                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f2   =  (t2*f3 + ee)*rminv(3)
                     f1   =  (t2*f2 + ee)*rminv(2)
                     f0   =   t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0

                     dm1 = fpp*f1
                     dm2 = fpp*f2
                     dm3 = fpp*f3
                     
                  else
!                    qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv

                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0

                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
 
                  end if
                  
#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
                  val(5,l) = eta
 
                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
                  dmx(3,l) = dm2
                  dmx(4,l) = dm3
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)
                  eta  = val(5,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
                  dm2 = dmx(3,l)
                  dm3 = dmx(4,l)
#endif
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  s0 = dm0
                  s1 = dm1
                  s2 = dm2
                  s3 = dm3

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
                  rkp =  rooz * eta

!psss
                  px0=pax*s0 + wpx*s1
                  py0=pay*s0 + wpy*s1
                  pz0=paz*s0 + wpz*s1
                  px1=pax*s1 + wpx*s2
                  py1=pay*s1 + wpy*s2
                  pz1=paz*s1 + wpz*s2
                  px2=pax*s2 + wpx*s3
                  py2=pay*s2 + wpy*s3
                  pz2=paz*s2 + wpz*s3

                  px00 = px00 + px0
                  py00 = py00 + py0
                  pz00 = pz00 + pz0
!ssps
                  sxp0  = qcx*s0 + wqx*s1
                  syp0  = qcy*s0 + wqy*s1
                  szp0  = qcz*s0 + wqz*s1

                  sxp1  = qcx*s1 + wqx*s2
                  syp1  = qcy*s1 + wqy*s2
                  szp1  = qcz*s1 + wqz*s2

                  sxp00 = sxp00 + sxp0
                  syp00 = syp00 + syp0
                  szp00 = szp00 + szp0
!rssss
                  rs1 = rkp * s1
                  rs2 = rkp * s2
!psps
                  pxpx0 = qcx*px0 + wqx*px1 + rs1
                  pxpy0 = qcy*px0 + wqy*px1
                  pxpz0 = qcz*px0 + wqz*px1
                  pypx0 = qcx*py0 + wqx*py1
                  pypy0 = qcy*py0 + wqy*py1 + rs1
                  pypz0 = qcz*py0 + wqz*py1
                  pzpx0 = qcx*pz0 + wqx*pz1
                  pzpy0 = qcy*pz0 + wqy*pz1
                  pzpz0 = qcz*pz0 + wqz*pz1 + rs1
            
                  pxpx1 = qcx*px1 + wqx*px2 + rs2
                  pxpy1 = qcy*px1 + wqy*px2
                  pxpz1 = qcz*px1 + wqz*px2
                  pypx1 = qcx*py1 + wqx*py2
                  pypy1 = qcy*py1 + wqy*py2 + rs2
                  pypz1 = qcz*py1 + wqz*py2
                  pzpx1 = qcx*pz1 + wqx*pz2
                  pzpy1 = qcy*pz1 + wqy*pz2
                  pzpz1 = qcz*pz1 + wqz*pz2 + rs2
!ssps01
                  sxp01 = zet*(sxp0 -rooz*sxp1)
                  syp01 = zet*(syp0 -rooz*syp1)
                  szp01 = zet*(szp0 -rooz*szp1)
!psss01
                  px01 = eta*(px0 -rooe*px1)
                  py01 = eta*(py0 -rooe*py1)
                  pz01 = eta*(pz0 -rooe*pz1)
!psss01
                  rsxp1= rkp*sxp1
                  rsyp1= rkp*syp1
                  rszp1= rkp*szp1
                  rpx1= rkp*px1
                  rpy1= rkp*py1
                  rpz1= rkp*pz1
!dsps
                  ec( 1,1)=ec( 1,1)+alp*(pax*pxpx0+wpx*pxpx1+sxp01+rpx1)
                  ec( 4,1)=ec( 4,1)+alp*(pax*pxpy0+wpx*pxpy1+syp01     )
                  ec( 7,1)=ec( 7,1)+alp*(pax*pxpz0+wpx*pxpz1+szp01     )
                  ec(11,1)=ec(11,1)+alp*(pay*pypx0+wpy*pypx1+sxp01     )
                  ec(14,1)=ec(14,1)+alp*(pay*pypy0+wpy*pypy1+syp01+rpy1)
                  ec(17,1)=ec(17,1)+alp*(pay*pypz0+wpy*pypz1+szp01     )
                  ec(21,1)=ec(21,1)+alp*(paz*pzpx0+wpz*pzpx1+sxp01     )
                  ec(24,1)=ec(24,1)+alp*(paz*pzpy0+wpz*pzpy1+syp01     )
                  ec(27,1)=ec(27,1)+alp*(paz*pzpz0+wpz*pzpz1+szp01+rpz1)
                  ec(10,1)=ec(10,1)+alp*(pay*pxpx0+wpy*pxpx1           )
                  ec(13,1)=ec(13,1)+alp*(pax*pypy0+wpx*pypy1           )
                  ec(16,1)=ec(16,1)+alp*(pay*pxpz0+wpy*pxpz1           )
                  ec(19,1)=ec(19,1)+alp*(paz*pxpx0+wpz*pxpx1           )
                  ec(22,1)=ec(22,1)+alp*(pax*pzpy0+wpx*pzpy1           )
                  ec(25,1)=ec(25,1)+alp*(pax*pzpz0+wpx*pzpz1           )
                  ec(20,1)=ec(20,1)+alp*(paz*pypx0+wpz*pypx1           )
                  ec(23,1)=ec(23,1)+alp*(paz*pypy0+wpz*pypy1           )
                  ec(26,1)=ec(26,1)+alp*(pay*pzpz0+wpy*pzpz1           )
!rpsss
                  rpx1 = rkp * px1
                  rpy1 = rkp * py1
                  rpz1 = rkp * pz1
!ppps
      ec( 1,2)=ec( 1,2)+bet*(pbx*pxpx0 + wpx*pxpx1 + sxp01 + rpx1)
      ec( 2,2)=ec( 2,2)+bet*(pby*pxpx0 + wpy*pxpx1               )
      ec( 3,2)=ec( 3,2)+bet*(pbz*pxpx0 + wpz*pxpx1               )
      ec( 4,2)=ec( 4,2)+bet*(pbx*pxpy0 + wpx*pxpy1 + syp01       )
      ec( 5,2)=ec( 5,2)+bet*(pby*pxpy0 + wpy*pxpy1         + rpx1)
      ec( 6,2)=ec( 6,2)+bet*(pbz*pxpy0 + wpz*pxpy1               )
      ec( 7,2)=ec( 7,2)+bet*(pbx*pxpz0 + wpx*pxpz1 + szp01       )
      ec( 8,2)=ec( 8,2)+bet*(pby*pxpz0 + wpy*pxpz1               )
      ec( 9,2)=ec( 9,2)+bet*(pbz*pxpz0 + wpz*pxpz1         + rpx1)
      ec(10,2)=ec(10,2)+bet*(pbx*pypx0 + wpx*pypx1         + rpy1)
      ec(11,2)=ec(11,2)+bet*(pby*pypx0 + wpy*pypx1 + sxp01       )
      ec(12,2)=ec(12,2)+bet*(pbz*pypx0 + wpz*pypx1               )
      ec(13,2)=ec(13,2)+bet*(pbx*pypy0 + wpx*pypy1               )
      ec(14,2)=ec(14,2)+bet*(pby*pypy0 + wpy*pypy1 + syp01 + rpy1)
      ec(15,2)=ec(15,2)+bet*(pbz*pypy0 + wpz*pypy1               )
      ec(16,2)=ec(16,2)+bet*(pbx*pypz0 + wpx*pypz1               )
      ec(17,2)=ec(17,2)+bet*(pby*pypz0 + wpy*pypz1 + szp01 )
      ec(18,2)=ec(18,2)+bet*(pbz*pypz0 + wpz*pypz1         + rpy1)
      ec(19,2)=ec(19,2)+bet*(pbx*pzpx0 + wpx*pzpx1         + rpz1)
      ec(20,2)=ec(20,2)+bet*(pby*pzpx0 + wpy*pzpx1)
      ec(21,2)=ec(21,2)+bet*(pbz*pzpx0 + wpz*pzpx1 + sxp01 )
      ec(22,2)=ec(22,2)+bet*(pbx*pzpy0 + wpx*pzpy1)
      ec(23,2)=ec(23,2)+bet*(pby*pzpy0 + wpy*pzpy1         + rpz1)
      ec(24,2)=ec(24,2)+bet*(pbz*pzpy0 + wpz*pzpy1 + syp01 )
      ec(25,2)=ec(25,2)+bet*(pbx*pzpz0 + wpx*pzpz1)
      ec(26,2)=ec(26,2)+bet*(pby*pzpz0 + wpy*pzpz1)
      ec(27,2)=ec(27,2)+bet*(pbz*pzpz0 + wpz*pzpz1 + szp01 + rpz1)
!psds
      ec( 1,3)=ec( 1,3)+ram*(qcx*pxpx0 + wqx*pxpx1 + rsxp1 + px01)
      ec( 5,3)=ec( 5,3)+ram*(qcy*pxpy0 + wqy*pxpy1         + px01)
      ec( 9,3)=ec( 9,3)+ram*(qcz*pxpz0 + wqz*pxpz1         + px01)
      ec( 4,3)=ec( 4,3)+ram*(qcy*pxpx0 + wqy*pxpx1               )
      ec( 7,3)=ec( 7,3)+ram*(qcz*pxpx0 + wqz*pxpx1               )
      ec( 8,3)=ec( 8,3)+ram*(qcy*pxpz0 + wqy*pxpz1               )
      ec(10,3)=ec(10,3)+ram*(qcx*pypx0 + wqx*pypx1         + py01)
      ec(14,3)=ec(14,3)+ram*(qcy*pypy0 + wqy*pypy1 + rsyp1 + py01)
      ec(18,3)=ec(18,3)+ram*(qcz*pypz0 + wqz*pypz1         + py01)
      ec(13,3)=ec(13,3)+ram*(qcx*pypy0 + wqx*pypy1               )
      ec(16,3)=ec(16,3)+ram*(qcx*pypz0 + wqx*pypz1               )
      ec(17,3)=ec(17,3)+ram*(qcz*pypy0 + wqz*pypy1               )
      ec(19,3)=ec(19,3)+ram*(qcx*pzpx0 + wqx*pzpx1         + pz01)
      ec(23,3)=ec(23,3)+ram*(qcy*pzpy0 + wqy*pzpy1         + pz01)
      ec(27,3)=ec(27,3)+ram*(qcz*pzpz0 + wqz*pzpz1 + rszp1 + pz01)
      ec(22,3)=ec(22,3)+ram*(qcy*pzpx0 + wqy*pzpx1               )
      ec(25,3)=ec(25,3)+ram*(qcx*pzpz0 + wqx*pzpz1               )
      ec(26,3)=ec(26,3)+ram*(qcy*pzpz0 + wqy*pzpz1               )

                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
#endif

      ec( 1,1) = ec( 1,1) - sxp00
      ec( 2,1) = ec(10,1)
      ec( 3,1) = ec(19,1)
      ec( 4,1) = ec( 4,1) - syp00
      ec( 5,1) = ec(13,1)
      ec( 6,1) = ec(22,1)
      ec( 7,1) = ec( 7,1) - szp00
      ec( 8,1) = ec(16,1)
      ec( 9,1) = ec(25,1)
      ec(11,1) = ec(11,1) - sxp00
      ec(12,1) = ec(20,1)
      ec(14,1) = ec(14,1) - syp00
      ec(15,1) = ec(23,1)
      ec(17,1) = ec(17,1) - szp00
      ec(18,1) = ec(26,1)
      ec(21,1) = ec(21,1) - sxp00
      ec(24,1) = ec(24,1) - syp00
      ec(27,1) = ec(27,1) - szp00

      ec( 1,3) = ec( 1,3) - px00
      ec( 2,3) = ec( 4,3)
      ec( 3,3) = ec( 7,3)
      ec( 4,3) = ec( 4,3)
      ec( 5,3) = ec( 5,3) - px00
      ec( 6,3) = ec( 8,3)
      ec( 9,3) = ec( 9,3) - px00
      ec(10,3) = ec(10,3) - py00
      ec(11,3) = ec(13,3)
      ec(12,3) = ec(16,3)
      ec(14,3) = ec(14,3) - py00
      ec(15,3) = ec(17,3)
      ec(18,3) = ec(18,3) - py00
      ec(19,3) = ec(19,3) - pz00
      ec(20,3) = ec(22,3)
      ec(21,3) = ec(25,3)
      ec(23,3) = ec(23,3) - pz00
      ec(24,3) = ec(26,3)
      ec(27,3) = ec(27,3) - pz00
#ifdef PL_OMP_DERI
!$omp end parallel
#endif
 
      do i=1,3
         do j=1,mao3
            ec(j,4) = ec(j,4) - ec(j,i)
         enddo
      enddo
      end
!= iofsss ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine joppps(
     &     ec   ,
     &     fdat , edat  ,
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  , jal  ,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )


      implicit real(8) (a-h,o-z)           
c$$$      dimension fdat(31,2001)
c$$$      dimension edat(2001)
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4),ed(mao3,3)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(5) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /)

#ifdef PL_SIMD_DERI
      dimension dmx(5,mxprm), val(5,mxprm)
#endif

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,jal,mao3,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do j = 1,3
         do i = 1,mao3
!c$$$            ec(i,j) = 0.0d0
            ed(i,j) = 0.0d0
         enddo
      enddo
!c$$$!     do j = 4,4
!c$$$         do i = 1,mao3
!c$$$            ec(i,4) = 0.0d0
!c$$$!           ed(i,j) = 0.0d0
!c$$$         enddo
!c$$$!     enddo

      sppsxx00 = 0.d0
      sppsxy00 = 0.d0
      sppsxz00 = 0.d0
      sppsyx00 = 0.d0
      sppsyy00 = 0.d0
      sppsyz00 = 0.d0
      sppszx00 = 0.d0
      sppszy00 = 0.d0
      sppszz00 = 0.d0
      ppxx00 = 0.d0
      ppxy00 = 0.d0
      ppxz00 = 0.d0
      ppyx00 = 0.d0
      ppyy00 = 0.d0
      ppyz00 = 0.d0
      ppzx00 = 0.d0
      ppzy00 = 0.d0
      ppzz00 = 0.d0
      pspsxx00 =0.d0 
      pspsxy00 =0.d0 
      pspsxz00 =0.d0 
      pspsyx00 =0.d0 
      pspsyy00 =0.d0 
      pspsyz00 =0.d0 
      pspszx00 =0.d0 
      pspszy00 =0.d0 
      pspszz00 =0.d0 

#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)
         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(5)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f4   = (((((fdat(11,it)*dt6   + fdat(10,it))*dt5
     &                    + fdat(9,it))*dt4  + fdat(8,it))*dt3
     &                    + fdat(7,it))*dt2  + fdat(6,it))*dt
     &                    + fdat(5,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0

                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f3   =  (t2*f4 + ee)*rminv(4)
                     f2   =  (t2*f3 + ee)*rminv(3)
                     f1   =  (t2*f2 + ee)*rminv(2)
                     f0   =   t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0

                     dm1 = fpp*f1
                     dm2 = fpp*f2
                     dm3 = fpp*f3
                     dm4 = fpp*f4
                     
                  else
!                    qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv

                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0

                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
 
                  end if
                  
#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
                  val(5,l) = eta

                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
                  dmx(3,l) = dm2
                  dmx(4,l) = dm3
                  dmx(5,l) = dm4
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)
                  eta  = val(5,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
                  dm2 = dmx(3,l)
                  dm3 = dmx(4,l)
                  dm4 = dmx(5,l)
#endif
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  s0 = dm0
                  s1 = dm1
                  s2 = dm2
                  s3 = dm3
                  s4 = dm4

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
                  rkp =  rooz * eta
!psss
      px0=pax*s0 + wpx*s1
      py0=pay*s0 + wpy*s1
      pz0=paz*s0 + wpz*s1
      px1=pax*s1 + wpx*s2
      py1=pay*s1 + wpy*s2
      pz1=paz*s1 + wpz*s2
      px2=pax*s2 + wpx*s3
      py2=pay*s2 + wpy*s3
      pz2=paz*s2 + wpz*s3
      px3=pax*s3 + wpx*s4
      py3=pay*s3 + wpy*s4
      pz3=paz*s3 + wpz*s4
!ssss01
      s01 = zet*(s0 - rooz*s1)
      s12 = zet*(s1 - rooz*s2)
      s23 = zet*(s2 - rooz*s3)
!rssss
      rs1 = rkp * s1
      rs2 = rkp * s2
!ppss
      ppxx0 = pbx*px0 + wpx*px1 + s01
      ppxy0 = pby*px0 + wpy*px1
      ppxz0 = pbz*px0 + wpz*px1
      ppyx0 = pbx*py0 + wpx*py1
      ppyy0 = pby*py0 + wpy*py1 + s01
      ppyz0 = pbz*py0 + wpz*py1
      ppzx0 = pbx*pz0 + wpx*pz1
      ppzy0 = pby*pz0 + wpy*pz1
      ppzz0 = pbz*pz0 + wpz*pz1 + s01

      ppxx1 = pbx*px1 + wpx*px2 + s12
      ppxy1 = pby*px1 + wpy*px2
      ppxz1 = pbz*px1 + wpz*px2
      ppyx1 = pbx*py1 + wpx*py2
      ppyy1 = pby*py1 + wpy*py2 + s12
      ppyz1 = pbz*py1 + wpz*py2
      ppzx1 = pbx*pz1 + wpx*pz2
      ppzy1 = pby*pz1 + wpy*pz2
      ppzz1 = pbz*pz1 + wpz*pz2 + s12

      ppxx2 = pbx*px2 + wpx*px3 + s23
      ppxy2 = pby*px2 + wpy*px3
      ppxz2 = pbz*px2 + wpz*px3
      ppyx2 = pbx*py2 + wpx*py3
      ppyy2 = pby*py2 + wpy*py3 + s23
      ppyz2 = pbz*py2 + wpz*py3
      ppzx2 = pbx*pz2 + wpx*pz3
      ppzy2 = pby*pz2 + wpy*pz3
      ppzz2 = pbz*pz2 + wpz*pz3 + s23
!ppss01
      ppxx01=eta*(ppxx0 -rooe*ppxx1)
      ppxy01=eta*(ppxy0 -rooe*ppxy1)
      ppxz01=eta*(ppxz0 -rooe*ppxz1)
      ppyx01=eta*(ppyx0 -rooe*ppyx1)
      ppyy01=eta*(ppyy0 -rooe*ppyy1)
      ppyz01=eta*(ppyz0 -rooe*ppyz1)
      ppzx01=eta*(ppzx0 -rooe*ppzx1)
      ppzy01=eta*(ppzy0 -rooe*ppzy1)
      ppzz01=eta*(ppzz0 -rooe*ppzz1)

      ppxx00 = ppxx00 + ppxx0
      ppxy00 = ppxy00 + ppxy0
      ppxz00 = ppxz00 + ppxz0
      ppyx00 = ppyx00 + ppyx0
      ppyy00 = ppyy00 + ppyy0
      ppyz00 = ppyz00 + ppyz0
      ppzx00 = ppzx00 + ppzx0
      ppzy00 = ppzy00 + ppzy0
      ppzz00 = ppzz00 + ppzz0
!spss
      xp0=pbx*s0 + wpx*s1
      yp0=pby*s0 + wpy*s1
      zp0=pbz*s0 + wpz*s1
      xp1=pbx*s1 + wpx*s2
      yp1=pby*s1 + wpy*s2
      zp1=pbz*s1 + wpz*s2
      xp2=pbx*s2 + wpx*s3
      yp2=pby*s2 + wpy*s3
      zp2=pbz*s2 + wpz*s3
!rspss
      rxp1 = rkp * xp1
      ryp1 = rkp * yp1
      rzp1 = rkp * zp1
      rxp2 = rkp * xp2
      ryp2 = rkp * yp2
      rzp2 = rkp * zp2
!rpsss
      rpx1 = rkp * px1
      rpy1 = rkp * py1
      rpz1 = rkp * pz1
      rpx2 = rkp * px2
      rpy2 = rkp * py2
      rpz2 = rkp * pz2
!ppps
      xxx0=qcx*ppxx0 + wqx*ppxx1 + rxp1 + rpx1
      xxy0=qcy*ppxx0 + wqy*ppxx1
      xxz0=qcz*ppxx0 + wqz*ppxx1
      xyx0=qcx*ppxy0 + wqx*ppxy1 + ryp1 
      xyy0=qcy*ppxy0 + wqy*ppxy1        + rpx1
      xyz0=qcz*ppxy0 + wqz*ppxy1
      xzx0=qcx*ppxz0 + wqx*ppxz1 + rzp1 
      xzy0=qcy*ppxz0 + wqy*ppxz1
      xzz0=qcz*ppxz0 + wqz*ppxz1        + rpx1
      yxx0=qcx*ppyx0 + wqx*ppyx1        + rpy1
      yxy0=qcy*ppyx0 + wqy*ppyx1 + rxp1 
      yxz0=qcz*ppyx0 + wqz*ppyx1
      yyx0=qcx*ppyy0 + wqx*ppyy1
      yyy0=qcy*ppyy0 + wqy*ppyy1 + ryp1 + rpy1
      yyz0=qcz*ppyy0 + wqz*ppyy1
      yzx0=qcx*ppyz0 + wqx*ppyz1
      yzy0=qcy*ppyz0 + wqy*ppyz1 + rzp1 
      yzz0=qcz*ppyz0 + wqz*ppyz1        + rpy1
      zxx0=qcx*ppzx0 + wqx*ppzx1        + rpz1
      zxy0=qcy*ppzx0 + wqy*ppzx1
      zxz0=qcz*ppzx0 + wqz*ppzx1 + rxp1 
      zyx0=qcx*ppzy0 + wqx*ppzy1
      zyy0=qcy*ppzy0 + wqy*ppzy1        + rpz1
      zyz0=qcz*ppzy0 + wqz*ppzy1 + ryp1 
      zzx0=qcx*ppzz0 + wqx*ppzz1
      zzy0=qcy*ppzz0 + wqy*ppzz1
      zzz0=qcz*ppzz0 + wqz*ppzz1 + rzp1 + rpz1

      xxx1=qcx*ppxx1 + wqx*ppxx2 + rxp2 + rpx2
      xxy1=qcy*ppxx1 + wqy*ppxx2
      xxz1=qcz*ppxx1 + wqz*ppxx2
      xyx1=qcx*ppxy1 + wqx*ppxy2 + ryp2
      xyy1=qcy*ppxy1 + wqy*ppxy2        + rpx2
      xyz1=qcz*ppxy1 + wqz*ppxy2
      xzx1=qcx*ppxz1 + wqx*ppxz2 + rzp2 
      xzy1=qcy*ppxz1 + wqy*ppxz2
      xzz1=qcz*ppxz1 + wqz*ppxz2        + rpx2
      yxx1=qcx*ppyx1 + wqx*ppyx2        + rpy2
      yxy1=qcy*ppyx1 + wqy*ppyx2 + rxp2 
      yxz1=qcz*ppyx1 + wqz*ppyx2
      yyx1=qcx*ppyy1 + wqx*ppyy2
      yyy1=qcy*ppyy1 + wqy*ppyy2 + ryp2 + rpy2
      yyz1=qcz*ppyy1 + wqz*ppyy2
      yzx1=qcx*ppyz1 + wqx*ppyz2
      yzy1=qcy*ppyz1 + wqy*ppyz2 + rzp2 
      yzz1=qcz*ppyz1 + wqz*ppyz2        + rpy2
      zxx1=qcx*ppzx1 + wqx*ppzx2        + rpz2
      zxy1=qcy*ppzx1 + wqy*ppzx2
      zxz1=qcz*ppzx1 + wqz*ppzx2 + rxp2 
      zyx1=qcx*ppzy1 + wqx*ppzy2
      zyy1=qcy*ppzy1 + wqy*ppzy2        + rpz2
      zyz1=qcz*ppzy1 + wqz*ppzy2 + ryp2 
      zzx1=qcx*ppzz1 + wqx*ppzz2
      zzy1=qcy*ppzz1 + wqy*ppzz2
      zzz1=qcz*ppzz1 + wqz*ppzz2 + rzp2 + rpz2

!spps
      sppsxx0 = qcx*xp0 + wqx*xp1 + rs1
      sppsxy0 = qcy*xp0 + wqy*xp1
      sppsxz0 = qcz*xp0 + wqz*xp1
      sppsyx0 = qcx*yp0 + wqx*yp1
      sppsyy0 = qcy*yp0 + wqy*yp1 + rs1
      sppsyz0 = qcz*yp0 + wqz*yp1
      sppszx0 = qcx*zp0 + wqx*zp1
      sppszy0 = qcy*zp0 + wqy*zp1
      sppszz0 = qcz*zp0 + wqz*zp1 + rs1

      sppsxx00 = sppsxx00 + sppsxx0
      sppsxy00 = sppsxy00 + sppsxy0
      sppsxz00 = sppsxz00 + sppsxz0
      sppsyx00 = sppsyx00 + sppsyx0
      sppsyy00 = sppsyy00 + sppsyy0
      sppsyz00 = sppsyz00 + sppsyz0
      sppszx00 = sppszx00 + sppszx0
      sppszy00 = sppszy00 + sppszy0
      sppszz00 = sppszz00 + sppszz0

      sppsxx1 = qcx*xp1 + wqx*xp2 + rs2
      sppsxy1 = qcy*xp1 + wqy*xp2
      sppsxz1 = qcz*xp1 + wqz*xp2
      sppsyx1 = qcx*yp1 + wqx*yp2
      sppsyy1 = qcy*yp1 + wqy*yp2 + rs2
      sppsyz1 = qcz*yp1 + wqz*yp2
      sppszx1 = qcx*zp1 + wqx*zp2
      sppszy1 = qcy*zp1 + wqy*zp2
      sppszz1 = qcz*zp1 + wqz*zp2 + rs2
!spps01
      sppsxx01 = zet*(sppsxx0 - rooz*sppsxx1)
      sppsxy01 = zet*(sppsxy0 - rooz*sppsxy1)
      sppsxz01 = zet*(sppsxz0 - rooz*sppsxz1)
      sppsyx01 = zet*(sppsyx0 - rooz*sppsyx1)
      sppsyy01 = zet*(sppsyy0 - rooz*sppsyy1)
      sppsyz01 = zet*(sppsyz0 - rooz*sppsyz1)
      sppszx01 = zet*(sppszx0 - rooz*sppszx1)
      sppszy01 = zet*(sppszy0 - rooz*sppszy1)
      sppszz01 = zet*(sppszz0 - rooz*sppszz1)
!rspps1
      rsppsxx1 = rkp*sppsxx1
      rsppsxy1 = rkp*sppsxy1
      rsppsxz1 = rkp*sppsxz1
      rsppsyx1 = rkp*sppsyx1
      rsppsyy1 = rkp*sppsyy1
      rsppsyz1 = rkp*sppsyz1
      rsppszx1 = rkp*sppszx1
      rsppszy1 = rkp*sppszy1
      rsppszz1 = rkp*sppszz1

!psps
      pspsxx0 = qcx*px0 + wqx*px1 + rs1
      pspsxy0 = qcy*px0 + wqy*px1
      pspsxz0 = qcz*px0 + wqz*px1
      pspsyx0 = qcx*py0 + wqx*py1
      pspsyy0 = qcy*py0 + wqy*py1 + rs1
      pspsyz0 = qcz*py0 + wqz*py1
      pspszx0 = qcx*pz0 + wqx*pz1
      pspszy0 = qcy*pz0 + wqy*pz1
      pspszz0 = qcz*pz0 + wqz*pz1 + rs1
      pspsxx1 = qcx*px1 + wqx*px2 + rs2
      pspsxy1 = qcy*px1 + wqy*px2
      pspsxz1 = qcz*px1 + wqz*px2
      pspsyx1 = qcx*py1 + wqx*py2
      pspsyy1 = qcy*py1 + wqy*py2 + rs2
      pspsyz1 = qcz*py1 + wqz*py2
      pspszx1 = qcx*pz1 + wqx*pz2
      pspszy1 = qcy*pz1 + wqy*pz2
      pspszz1 = qcz*pz1 + wqz*pz2 + rs2

      pspsxx00 = pspsxx00  + pspsxx0
      pspsxy00 = pspsxy00  + pspsxy0
      pspsxz00 = pspsxz00  + pspsxz0
      pspsyx00 = pspsyx00  + pspsyx0
      pspsyy00 = pspsyy00  + pspsyy0
      pspsyz00 = pspsyz00  + pspsyz0
      pspszx00 = pspszx00  + pspszx0
      pspszy00 = pspszy00  + pspszy0
      pspszz00 = pspszz00  + pspszz0
!psps01
      pspsxx01 = zet*(pspsxx0 - rooz*pspsxx1)
      pspsxy01 = zet*(pspsxy0 - rooz*pspsxy1)
      pspsxz01 = zet*(pspsxz0 - rooz*pspsxz1)
      pspsyx01 = zet*(pspsyx0 - rooz*pspsyx1)
      pspsyy01 = zet*(pspsyy0 - rooz*pspsyy1)
      pspsyz01 = zet*(pspsyz0 - rooz*pspsyz1)
      pspszx01 = zet*(pspszx0 - rooz*pspszx1)
      pspszy01 = zet*(pspszy0 - rooz*pspszy1)
      pspszz01 = zet*(pspszz0 - rooz*pspszz1)
!rpsps1
      rpspsxx1 =rkp*pspsxx1
      rpspsxy1 =rkp*pspsxy1
      rpspsxz1 =rkp*pspsxz1
      rpspsyx1 =rkp*pspsyx1
      rpspsyy1 =rkp*pspsyy1
      rpspsyz1 =rkp*pspsyz1
      rpspszx1 =rkp*pspszx1
      rpspszy1 =rkp*pspszy1
      rpspszz1 =rkp*pspszz1
!rppss
      rppxx1 = rkp * ppxx1
      rppxy1 = rkp * ppxy1
      rppxz1 = rkp * ppxz1
      rppyx1 = rkp * ppyx1
      rppyy1 = rkp * ppyy1
      rppyz1 = rkp * ppyz1
      rppzx1 = rkp * ppzx1
      rppzy1 = rkp * ppzy1
      rppzz1 = rkp * ppzz1

      ed( 1,1)=ed( 1,1)+alp*(pax*xxx0+wpx*xxx1+sppsxx01+pspsxx01+rppxx1)
      ed( 2,1)=ed( 2,1)+alp*(pax*xxy0+wpx*xxy1+sppsxy01+pspsxy01       )
      ed( 3,1)=ed( 3,1)+alp*(pax*xxz0+wpx*xxz1+sppsxz01+pspsxz01       )
      ed( 4,1)=ed( 4,1)+alp*(pax*xyx0+wpx*xyx1+sppsyx01         +rppxy1)
      ed( 5,1)=ed( 5,1)+alp*(pax*xyy0+wpx*xyy1+sppsyy01                )
      ed( 6,1)=ed( 6,1)+alp*(pax*xyz0+wpx*xyz1+sppsyz01                )
      ed( 7,1)=ed( 7,1)+alp*(pax*xzx0+wpx*xzx1+sppszx01         +rppxz1)
      ed( 8,1)=ed( 8,1)+alp*(pax*xzy0+wpx*xzy1+sppszy01                )
      ed( 9,1)=ed( 9,1)+alp*(pax*xzz0+wpx*xzz1+sppszz01                )
                                                                      
      ed(10,1)=ed(10,1)+alp*(pay*yxx0+wpy*yxx1+sppsxx01                )
      ed(11,1)=ed(11,1)+alp*(pay*yxy0+wpy*yxy1+sppsxy01         +rppyx1)
      ed(12,1)=ed(12,1)+alp*(pay*yxz0+wpy*yxz1+sppsxz01                )
      ed(13,1)=ed(13,1)+alp*(pay*yyx0+wpy*yyx1+sppsyx01+pspsyx01       )
      ed(14,1)=ed(14,1)+alp*(pay*yyy0+wpy*yyy1+sppsyy01+pspsyy01+rppyy1)
      ed(15,1)=ed(15,1)+alp*(pay*yyz0+wpy*yyz1+sppsyz01+pspsyz01       )
      ed(16,1)=ed(16,1)+alp*(pay*yzx0+wpy*yzx1+sppszx01                )
      ed(17,1)=ed(17,1)+alp*(pay*yzy0+wpy*yzy1+sppszy01         +rppyz1)
      ed(18,1)=ed(18,1)+alp*(pay*yzz0+wpy*yzz1+sppszz01                )
                                                                      
      ed(19,1)=ed(19,1)+alp*(paz*zxx0+wpz*zxx1+sppsxx01                )
      ed(20,1)=ed(20,1)+alp*(paz*zxy0+wpz*zxy1+sppsxy01                )
      ed(21,1)=ed(21,1)+alp*(paz*zxz0+wpz*zxz1+sppsxz01         +rppzx1)
      ed(22,1)=ed(22,1)+alp*(paz*zyx0+wpz*zyx1+sppsyx01                )
      ed(23,1)=ed(23,1)+alp*(paz*zyy0+wpz*zyy1+sppsyy01                )
      ed(24,1)=ed(24,1)+alp*(paz*zyz0+wpz*zyz1+sppsyz01         +rppzy1)
      ed(25,1)=ed(25,1)+alp*(paz*zzx0+wpz*zzx1+sppszx01+pspszx01       )
      ed(26,1)=ed(26,1)+alp*(paz*zzy0+wpz*zzy1+sppszy01+pspszy01       )
      ed(27,1)=ed(27,1)+alp*(paz*zzz0+wpz*zzz1+sppszz01+pspszz01+rppzz1)
                      
      ed(28,1)=ed(28,1)+alp*(pay*xxx0+wpy*xxx1                         )
      ed(29,1)=ed(29,1)+alp*(pay*xxy0+wpy*xxy1                  +rppxx1)
      ed(30,1)=ed(30,1)+alp*(pay*xxz0+wpy*xxz1                         )
      ed(31,1)=ed(31,1)+alp*(pay*xyx0+wpy*xyx1         +pspsxx01)
      ed(32,1)=ed(32,1)+alp*(pax*yyy0+wpx*yyy1                         )
      ed(33,1)=ed(33,1)+alp*(pax*yyz0+wpx*yyz1                         )
      ed(34,1)=ed(34,1)+alp*(pay*xzx0+wpy*xzx1                         )
      ed(35,1)=ed(35,1)+alp*(pax*yzy0+wpx*yzy1                         )
      ed(36,1)=ed(36,1)+alp*(pax*yzz0+wpx*yzz1                         )
                       
      ed(37,1)=ed(37,1)+alp*(paz*xxx0+wpz*xxx1                         )
      ed(38,1)=ed(38,1)+alp*(paz*xxy0+wpz*xxy1                         )
      ed(39,1)=ed(39,1)+alp*(paz*xxz0+wpz*xxz1                  +rppxx1)
      ed(40,1)=ed(40,1)+alp*(paz*xyx0+wpz*xyx1                         )
      ed(41,1)=ed(41,1)+alp*(paz*xyy0+wpz*xyy1                         )
      ed(42,1)=ed(42,1)+alp*(pax*zyz0+wpx*zyz1                         )
      ed(43,1)=ed(43,1)+alp*(paz*xzx0+wpz*xzx1         +pspsxx01       )
      ed(44,1)=ed(44,1)+alp*(pax*zzy0+wpx*zzy1                         )
      ed(45,1)=ed(45,1)+alp*(pax*zzz0+wpx*zzz1                         )
                       
      ed(46,1)=ed(46,1)+alp*(paz*yxx0+wpz*yxx1                         )
      ed(47,1)=ed(47,1)+alp*(paz*yxy0+wpz*yxy1                         )
      ed(48,1)=ed(48,1)+alp*(pay*zxz0+wpy*zxz1                         )
      ed(49,1)=ed(49,1)+alp*(paz*yyx0+wpz*yyx1                         )
      ed(50,1)=ed(50,1)+alp*(paz*yyy0+wpz*yyy1                         )
      ed(51,1)=ed(51,1)+alp*(paz*yyz0+wpz*yyz1                  +rppyy1)
      ed(52,1)=ed(52,1)+alp*(pay*zzx0+wpy*zzx1                         )
      ed(53,1)=ed(53,1)+alp*(paz*yzy0+wpz*yzy1         +pspsyy01       )
      ed(54,1)=ed(54,1)+alp*(pay*zzz0+wpy*zzz1                         )
!pdps
      ed( 1,2)=ed( 1,2)+bet*(pbx*xxx0+wpx*xxx1+sppsxx01+pspsxx01+rppxx1)
      ed( 2,2)=ed( 2,2)+bet*(pbx*xxy0+wpx*xxy1+sppsxy01+pspsxy01)
      ed( 3,2)=ed( 3,2)+bet*(pbx*xxz0+wpx*xxz1+sppsxz01+pspsxz01)
      ed( 4,2)=ed( 4,2)+bet*(pby*xyx0+wpy*xyx1         +pspsxx01)
      ed( 5,2)=ed( 5,2)+bet*(pby*xyy0+wpy*xyy1         +pspsxy01+rppxy1)
      ed( 6,2)=ed( 6,2)+bet*(pby*xyz0+wpy*xyz1         +pspsxz01)
      ed( 7,2)=ed( 7,2)+bet*(pbz*xzx0+wpz*xzx1         +pspsxx01)
      ed( 8,2)=ed( 8,2)+bet*(pbz*xzy0+wpz*xzy1         +pspsxy01)
      ed( 9,2)=ed( 9,2)+bet*(pbz*xzz0+wpz*xzz1         +pspsxz01+rppxz1)
      ed(10,2)=ed(10,2)+bet*(pby*xxx0+wpy*xxx1)
      ed(11,2)=ed(11,2)+bet*(pby*xxy0+wpy*xxy1                  +rppxx1)
      ed(12,2)=ed(12,2)+bet*(pby*xxz0+wpy*xxz1)
      ed(13,2)=ed(13,2)+bet*(pbz*xxx0+wpz*xxx1)
      ed(14,2)=ed(14,2)+bet*(pbz*xxy0+wpz*xxy1)
      ed(15,2)=ed(15,2)+bet*(pbz*xxz0+wpz*xxz1                  +rppxx1)
      ed(16,2)=ed(16,2)+bet*(pbz*xyx0+wpz*xyx1)
      ed(17,2)=ed(17,2)+bet*(pbz*xyy0+wpz*xyy1)
      ed(18,2)=ed(18,2)+bet*(pby*xzz0+wpy*xzz1)

      ed(19,2)=ed(19,2)+bet*(pbx*yxx0+wpx*yxx1         +pspsyx01+rppyx1)
      ed(20,2)=ed(20,2)+bet*(pbx*yxy0+wpx*yxy1         +pspsyy01)
      ed(21,2)=ed(21,2)+bet*(pbx*yxz0+wpx*yxz1         +pspsyz01)
      ed(22,2)=ed(22,2)+bet*(pby*yyx0+wpy*yyx1+sppsyx01+pspsyx01)
      ed(23,2)=ed(23,2)+bet*(pby*yyy0+wpy*yyy1+sppsyy01+pspsyy01+rppyy1)
      ed(24,2)=ed(24,2)+bet*(pby*yyz0+wpy*yyz1+sppsyz01+pspsyz01)
      ed(25,2)=ed(25,2)+bet*(pbz*yzx0+wpz*yzx1         +pspsyx01)
      ed(26,2)=ed(26,2)+bet*(pbz*yzy0+wpz*yzy1         +pspsyy01)
      ed(27,2)=ed(27,2)+bet*(pbz*yzz0+wpz*yzz1         +pspsyz01+rppyz1)
      ed(28,2)=ed(28,2)+bet*(pbx*yyx0+wpx*yyx1                  +rppyy1)
      ed(29,2)=ed(29,2)+bet*(pbx*yyy0+wpx*yyy1)
      ed(30,2)=ed(30,2)+bet*(pbx*yyz0+wpx*yyz1)
      ed(31,2)=ed(31,2)+bet*(pbz*yxx0+wpz*yxx1)
      ed(32,2)=ed(32,2)+bet*(pbz*yxy0+wpz*yxy1)
      ed(33,2)=ed(33,2)+bet*(pbx*yzz0+wpx*yzz1)
      ed(34,2)=ed(34,2)+bet*(pbz*yyx0+wpz*yyx1)
      ed(35,2)=ed(35,2)+bet*(pbz*yyy0+wpz*yyy1)
      ed(36,2)=ed(36,2)+bet*(pby*yzz0+wpy*yzz1+sppszz01)
              
      ed(37,2)=ed(37,2)+bet*(pbx*zxx0+wpx*zxx1         +pspszx01+rppzx1)
      ed(38,2)=ed(38,2)+bet*(pbx*zxy0+wpx*zxy1         +pspszy01)
      ed(39,2)=ed(39,2)+bet*(pbx*zxz0+wpx*zxz1         +pspszz01)
      ed(40,2)=ed(40,2)+bet*(pby*zyx0+wpy*zyx1         +pspszx01)
      ed(41,2)=ed(41,2)+bet*(pby*zyy0+wpy*zyy1         +pspszy01+rppzy1)
      ed(42,2)=ed(42,2)+bet*(pby*zyz0+wpy*zyz1         +pspszz01)
      ed(43,2)=ed(43,2)+bet*(pbz*zzx0+wpz*zzx1+sppszx01+pspszx01)
      ed(44,2)=ed(44,2)+bet*(pbz*zzy0+wpz*zzy1+sppszy01+pspszy01)
      ed(45,2)=ed(45,2)+bet*(pbz*zzz0+wpz*zzz1+sppszz01+pspszz01+rppzz1)
      ed(46,2)=ed(46,2)+bet*(pby*zxx0+wpy*zxx1       )
      ed(47,2)=ed(47,2)+bet*(pbx*zyy0+wpx*zyy1       )
      ed(48,2)=ed(48,2)+bet*(pby*zxz0+wpy*zxz1       )
      ed(49,2)=ed(49,2)+bet*(pbz*zxx0+wpz*zxx1+sppsxx01   )     
      ed(50,2)=ed(50,2)+bet*(pbx*zzy0+wpx*zzy1)
      ed(51,2)=ed(51,2)+bet*(pbx*zzz0+wpx*zzz1)
      ed(52,2)=ed(52,2)+bet*(pby*zzx0+wpy*zzx1)
      ed(53,2)=ed(53,2)+bet*(pbz*zyy0+wpz*zyy1+sppsyy01        )
      ed(54,2)=ed(54,2)+bet*(pby*zzz0+wpy*zzz1)
!ppds
      ed( 1,3)=ed( 1,3)+ram*(qcx*xxx0+wqx*xxx1+rsppsxx1+rpspsxx1+ppxx01)
      ed( 2,3)=ed( 2,3)+ram*(qcy*xxy0+wqy*xxy1                  +ppxx01)
      ed( 3,3)=ed( 3,3)+ram*(qcz*xxz0+wqz*xxz1                  +ppxx01)
      ed( 4,3)=ed( 4,3)+ram*(qcy*xxx0+wqy*xxx1                         )
      ed( 5,3)=ed( 5,3)+ram*(qcz*xxx0+wqz*xxx1                         )
      ed( 6,3)=ed( 6,3)+ram*(qcz*xxy0+wqz*xxy1                         )
      ed( 7,3)=ed( 7,3)+ram*(qcx*xyx0+wqx*xyx1+rsppsyx1         +ppxy01)
      ed( 8,3)=ed( 8,3)+ram*(qcy*xyy0+wqy*xyy1         +rpspsxy1+ppxy01)
      ed( 9,3)=ed( 9,3)+ram*(qcz*xyz0+wqz*xyz1                  +ppxy01)
      ed(10,3)=ed(10,3)+ram*(qcy*xyx0+wqy*xyx1         +rpspsxx1)
      ed(11,3)=ed(11,3)+ram*(qcz*xyx0+wqz*xyx1                  )
      ed(12,3)=ed(12,3)+ram*(qcz*xyy0+wqz*xyy1                  )
      ed(13,3)=ed(13,3)+ram*(qcx*xzx0+wqx*xzx1+rsppszx1         +ppxz01)
      ed(14,3)=ed(14,3)+ram*(qcy*xzy0+wqy*xzy1                  +ppxz01)
      ed(15,3)=ed(15,3)+ram*(qcz*xzz0+wqz*xzz1         +rpspsxz1+ppxz01)
      ed(16,3)=ed(16,3)+ram*(qcy*xzx0+wqy*xzx1                  )
      ed(17,3)=ed(17,3)+ram*(qcz*xzx0+wqz*xzx1         +rpspsxx1)
      ed(18,3)=ed(18,3)+ram*(qcy*xzz0+wqy*xzz1                  )

      ed(19,3)=ed(19,3)+ram*(qcx*yxx0+wqx*yxx1         +rpspsyx1+ppyx01)
      ed(20,3)=ed(20,3)+ram*(qcy*yxy0+wqy*yxy1+rsppsxy1         +ppyx01)
      ed(21,3)=ed(21,3)+ram*(qcz*yxz0+wqz*yxz1                  +ppyx01)
      ed(22,3)=ed(22,3)+ram*(qcy*yxx0+wqy*yxx1+rsppsxx1        )
      ed(23,3)=ed(23,3)+ram*(qcz*yxx0+wqz*yxx1                  )
      ed(24,3)=ed(24,3)+ram*(qcz*yxy0+wqz*yxy1                  )
      ed(25,3)=ed(25,3)+ram*(qcx*yyx0+wqx*yyx1                  +ppyy01)
      ed(26,3)=ed(26,3)+ram*(qcy*yyy0+wqy*yyy1+rsppsyy1+rpspsyy1+ppyy01)
      ed(27,3)=ed(27,3)+ram*(qcz*yyz0+wqz*yyz1                  +ppyy01)
      ed(28,3)=ed(28,3)+ram*(qcx*yyy0+wqx*yyy1        )
      ed(29,3)=ed(29,3)+ram*(qcz*yyx0+wqz*yyx1        )
      ed(30,3)=ed(30,3)+ram*(qcz*yyy0+wqz*yyy1        )
      ed(31,3)=ed(31,3)+ram*(qcx*yzx0+wqx*yzx1                  +ppyz01)
      ed(32,3)=ed(32,3)+ram*(qcy*yzy0+wqy*yzy1+rsppszy1         +ppyz01)
      ed(33,3)=ed(33,3)+ram*(qcz*yzz0+wqz*yzz1         +rpspsyz1+ppyz01)
      ed(34,3)=ed(34,3)+ram*(qcx*yzy0+wqx*yzy1)
      ed(35,3)=ed(35,3)+ram*(qcx*yzz0+wqx*yzz1)
      ed(36,3)=ed(36,3)+ram*(qcz*yzy0+wqz*yzy1         +rpspsyy1)

      ed(37,3)=ed(37,3)+ram*(qcx*zxx0+wqx*zxx1         +rpspszx1+ppzx01)
      ed(38,3)=ed(38,3)+ram*(qcy*zxy0+wqy*zxy1                  +ppzx01)
      ed(39,3)=ed(39,3)+ram*(qcz*zxz0+wqz*zxz1+rsppsxz1         +ppzx01)
      ed(40,3)=ed(40,3)+ram*(qcy*zxx0+wqy*zxx1         )
      ed(41,3)=ed(41,3)+ram*(qcz*zxx0+wqz*zxx1+rsppsxx1)
      ed(42,3)=ed(42,3)+ram*(qcy*zxz0+wqy*zxz1)
      ed(43,3)=ed(43,3)+ram*(qcx*zyx0+wqx*zyx1                  +ppzy01)
      ed(44,3)=ed(44,3)+ram*(qcy*zyy0+wqy*zyy1         +rpspszy1+ppzy01)
      ed(45,3)=ed(45,3)+ram*(qcz*zyz0+wqz*zyz1+rsppsyz1         +ppzy01)
      ed(46,3)=ed(46,3)+ram*(qcx*zyy0+wqx*zyy1)
      ed(47,3)=ed(47,3)+ram*(qcx*zyz0+wqx*zyz1)
      ed(48,3)=ed(48,3)+ram*(qcz*zyy0+wqz*zyy1+rsppsyy1)
      ed(49,3)=ed(49,3)+ram*(qcx*zzx0+wqx*zzx1                  +ppzz01)
      ed(50,3)=ed(50,3)+ram*(qcy*zzy0+wqy*zzy1                  +ppzz01)
      ed(51,3)=ed(51,3)+ram*(qcz*zzz0+wqz*zzz1+rsppszz1+rpspszz1+ppzz01)
      ed(52,3)=ed(52,3)+ram*(qcx*zzy0+wqx*zzy1)
      ed(53,3)=ed(53,3)+ram*(qcx*zzz0+wqx*zzz1)
      ed(54,3)=ed(54,3)+ram*(qcy*zzz0+wqy*zzz1)

                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
#endif
!     goto 9999
      if (jal.eq.0 ) then
!dpps
      ec( 1,1) = ed( 1,1) - sppsxx00
      ec( 2,1) = ed(28,1)
      ec( 3,1) = ed(37,1)
      ec( 4,1) = ed( 2,1) - sppsxy00
      ec( 5,1) = ed(29,1)
      ec( 6,1) = ed(38,1)
      ec( 7,1) = ed( 3,1) - sppsxz00
      ec( 8,1) = ed(30,1)
      ec( 9,1) = ed(39,1)
      ec(10,1) = ed( 4,1) - sppsyx00
      ec(11,1) = ed(31,1)
      ec(12,1) = ed(40,1)
      ec(13,1) = ed( 5,1) - sppsyy00
      ec(14,1) = ed(32,1)
      ec(15,1) = ed(41,1)
      ec(16,1) = ed( 6,1) - sppsyz00
      ec(17,1) = ed(33,1)
      ec(18,1) = ed(42,1)
      ec(19,1) = ed( 7,1) - sppszx00
      ec(20,1) = ed(34,1)
      ec(21,1) = ed(43,1)
      ec(22,1) = ed( 8,1) - sppszy00
      ec(23,1) = ed(35,1)
      ec(24,1) = ed(44,1)
      ec(25,1) = ed( 9,1) - sppszz00
      ec(26,1) = ed(36,1)
      ec(27,1) = ed(45,1)

      ec(28,1) = ed(28,1)
      ec(29,1) = ed(10,1) - sppsxx00
      ec(30,1) = ed(46,1)
      ec(31,1) = ed(29,1)
      ec(32,1) = ed(11,1) - sppsxy00
      ec(33,1) = ed(47,1)
      ec(34,1) = ed(30,1)
      ec(35,1) = ed(12,1) - sppsxz00
      ec(36,1) = ed(48,1)
      ec(37,1) = ed(31,1)
      ec(38,1) = ed(13,1) - sppsyx00
      ec(39,1) = ed(49,1)
      ec(40,1) = ed(32,1)
      ec(41,1) = ed(14,1) - sppsyy00
      ec(42,1) = ed(50,1)
      ec(43,1) = ed(33,1)
      ec(44,1) = ed(15,1) - sppsyz00
      ec(45,1) = ed(51,1)
      ec(46,1) = ed(34,1)
      ec(47,1) = ed(16,1) - sppszx00
      ec(48,1) = ed(52,1)
      ec(49,1) = ed(35,1)
      ec(50,1) = ed(17,1) - sppszy00
      ec(51,1) = ed(53,1)
      ec(52,1) = ed(36,1)
      ec(53,1) = ed(18,1) - sppszz00
      ec(54,1) = ed(54,1)

      ec(55,1) = ed(37,1)
      ec(56,1) = ed(46,1)
      ec(57,1) = ed(19,1) - sppsxx00
      ec(58,1) = ed(38,1)
      ec(59,1) = ed(47,1)
      ec(60,1) = ed(20,1) - sppsxy00
      ec(61,1) = ed(39,1)
      ec(62,1) = ed(48,1)
      ec(63,1) = ed(21,1) - sppsxz00
      ec(64,1) = ed(40,1)
      ec(65,1) = ed(49,1)
      ec(66,1) = ed(22,1) - sppsyx00
      ec(67,1) = ed(41,1)
      ec(68,1) = ed(50,1)
      ec(69,1) = ed(23,1) - sppsyy00
      ec(70,1) = ed(42,1)
      ec(71,1) = ed(51,1)
      ec(72,1) = ed(24,1) - sppsyz00
      ec(73,1) = ed(43,1)
      ec(74,1) = ed(52,1)
      ec(75,1) = ed(25,1) - sppszx00
      ec(76,1) = ed(44,1)
      ec(77,1) = ed(53,1)
      ec(78,1) = ed(26,1) - sppszy00
      ec(79,1) = ed(45,1)
      ec(80,1) = ed(54,1)
      ec(81,1) = ed(27,1) - sppszz00
!pdps=======================
      ec( 1,2) = ed( 1,2) - pspsxx00
      ec( 2,2) = ed(10,2)     
      ec( 3,2) = ed(13,2)     
      ec( 4,2) = ed( 2,2) - pspsxy00
      ec( 5,2) = ed(11,2)     
      ec( 6,2) = ed(14,2)     
      ec( 7,2) = ed( 3,2) - pspsxz00
      ec( 8,2) = ed(12,2)     
      ec( 9,2) = ed(15,2)     
      ec(10,2) = ed(10,2)
      ec(11,2) = ed( 4,2) - pspsxx00
      ec(12,2) = ed(16,2)     
      ec(13,2) = ed(11,2)     
      ec(14,2) = ed( 5,2) - pspsxy00
      ec(15,2) = ed(17,2)     
      ec(16,2) = ed(12,2)     
      ec(17,2) = ed( 6,2) - pspsxz00
      ec(18,2) = ed(18,2)
      ec(19,2) = ed(13,2)
      ec(20,2) = ed(16,2)
      ec(21,2) = ed( 7,2) - pspsxx00
      ec(22,2) = ed(14,2)     
      ec(23,2) = ed(17,2)     
      ec(24,2) = ed( 8,2) - pspsxy00
      ec(25,2) = ed(15,2)     
      ec(26,2) = ed(18,2)     
      ec(27,2) = ed( 9,2) - pspsxz00

      ec(28,2) = ed(19,2) - pspsyx00
      ec(29,2) = ed(28,2)     
      ec(30,2) = ed(31,2)     
      ec(31,2) = ed(20,2) - pspsyy00
      ec(32,2) = ed(29,2)     
      ec(33,2) = ed(32,2)     
      ec(34,2) = ed(21,2) - pspsyz00
      ec(35,2) = ed(30,2)     
      ec(36,2) = ed(33,2)     
      ec(37,2) = ed(28,2)
      ec(38,2) = ed(22,2) - pspsyx00
      ec(39,2) = ed(34,2)     
      ec(40,2) = ed(29,2)     
      ec(41,2) = ed(23,2) - pspsyy00
      ec(42,2) = ed(35,2)     
      ec(43,2) = ed(30,2)     
      ec(44,2) = ed(24,2) - pspsyz00
      ec(45,2) = ed(36,2)
      ec(46,2) = ed(31,2)
      ec(47,2) = ed(34,2)
      ec(48,2) = ed(25,2) - pspsyx00
      ec(49,2) = ed(32,2)     
      ec(50,2) = ed(35,2)     
      ec(51,2) = ed(26,2) - pspsyy00
      ec(52,2) = ed(33,2)     
      ec(53,2) = ed(36,2)     
      ec(54,2) = ed(27,2) - pspsyz00
                         
      ec(55,2) = ed(37,2) - pspszx00
      ec(56,2) = ed(46,2)     
      ec(57,2) = ed(49,2)     
      ec(58,2) = ed(38,2) - pspszy00
      ec(59,2) = ed(47,2)     
      ec(60,2) = ed(50,2)     
      ec(61,2) = ed(39,2) - pspszz00
      ec(62,2) = ed(48,2)     
      ec(63,2) = ed(51,2)     
      ec(64,2) = ed(46,2)
      ec(65,2) = ed(40,2) - pspszx00
      ec(66,2) = ed(52,2)     
      ec(67,2) = ed(47,2)     
      ec(68,2) = ed(41,2) - pspszy00
      ec(69,2) = ed(53,2)     
      ec(70,2) = ed(48,2)     
      ec(71,2) = ed(42,2) - pspszz00
      ec(72,2) = ed(54,2)
      ec(73,2) = ed(49,2)
      ec(74,2) = ed(52,2)
      ec(75,2) = ed(43,2) - pspszx00
      ec(76,2) = ed(50,2)     
      ec(77,2) = ed(53,2)     
      ec(78,2) = ed(44,2) - pspszy00
      ec(79,2) = ed(51,2)     
      ec(80,2) = ed(54,2)     
      ec(81,2) = ed(45,2) - pspszz00
!ppds
      ec( 1,3) = ed( 1,3) - ppxx00
      ec( 2,3) = ed( 4,3)
      ec( 3,3) = ed( 5,3)
      ec( 4,3) = ed( 4,3)
      ec( 5,3) = ed( 2,3) - ppxx00
      ec( 6,3) = ed( 6,3)
      ec( 7,3) = ed( 5,3)
      ec( 8,3) = ed( 6,3)
      ec( 9,3) = ed( 3,3) - ppxx00
      ec(10,3) = ed( 7,3) - ppxy00
      ec(11,3) = ed(10,3)
      ec(12,3) = ed(11,3)
      ec(13,3) = ed(10,3)
      ec(14,3) = ed( 8,3) - ppxy00
      ec(15,3) = ed(12,3)
      ec(16,3) = ed(11,3)
      ec(17,3) = ed(12,3)
      ec(18,3) = ed( 9,3) - ppxy00
      ec(19,3) = ed(13,3) - ppxz00
      ec(20,3) = ed(16,3)
      ec(21,3) = ed(17,3)
      ec(22,3) = ed(16,3)
      ec(23,3) = ed(14,3) - ppxz00
      ec(24,3) = ed(18,3)
      ec(25,3) = ed(17,3)
      ec(26,3) = ed(18,3)
      ec(27,3) = ed(15,3) - ppxz00

      ec(28,3) = ed(19,3) - ppyx00
      ec(29,3) = ed(22,3)
      ec(30,3) = ed(23,3)
      ec(31,3) = ed(22,3)
      ec(32,3) = ed(20,3) - ppyx00
      ec(33,3) = ed(24,3)
      ec(34,3) = ed(23,3)
      ec(35,3) = ed(24,3)
      ec(36,3) = ed(21,3) - ppyx00
      ec(37,3) = ed(25,3) - ppyy00
      ec(38,3) = ed(28,3)
      ec(39,3) = ed(29,3)
      ec(40,3) = ed(28,3)
      ec(41,3) = ed(26,3) - ppyy00
      ec(42,3) = ed(30,3)
      ec(43,3) = ed(29,3)
      ec(44,3) = ed(30,3)
      ec(45,3) = ed(27,3) - ppyy00
      ec(46,3) = ed(31,3) - ppyz00
      ec(47,3) = ed(34,3)
      ec(48,3) = ed(35,3)
      ec(49,3) = ed(34,3)
      ec(50,3) = ed(32,3) - ppyz00
      ec(51,3) = ed(36,3)
      ec(52,3) = ed(35,3)
      ec(53,3) = ed(36,3)
      ec(54,3) = ed(33,3) - ppyz00

      ec(55,3) = ed(37,3) - ppzx00
      ec(56,3) = ed(40,3)
      ec(57,3) = ed(41,3)
      ec(58,3) = ed(40,3)
      ec(59,3) = ed(38,3) - ppzx00
      ec(60,3) = ed(42,3)
      ec(61,3) = ed(41,3)
      ec(62,3) = ed(42,3)
      ec(63,3) = ed(39,3) - ppzx00
      ec(64,3) = ed(43,3) - ppzy00
      ec(65,3) = ed(46,3)
      ec(66,3) = ed(47,3)
      ec(67,3) = ed(46,3)
      ec(68,3) = ed(44,3) - ppzy00
      ec(69,3) = ed(48,3)
      ec(70,3) = ed(47,3)
      ec(71,3) = ed(48,3)
      ec(72,3) = ed(45,3) - ppzy00
      ec(73,3) = ed(49,3) - ppzz00
      ec(74,3) = ed(52,3)
      ec(75,3) = ed(53,3)
      ec(76,3) = ed(52,3)
      ec(77,3) = ed(50,3) - ppzz00
      ec(78,3) = ed(54,3)
      ec(79,3) = ed(53,3)
      ec(80,3) = ed(54,3)
      ec(81,3) = ed(51,3) - ppzz00

       else
!dpps
      ec( 1,1) = ed( 1,1) - sppsxx00
      ec( 2,1) = ed(28,1)
      ec( 3,1) = ed(37,1)
      ec( 4,1) = ed( 4,1) - sppsyx00
      ec( 5,1) = ed(31,1)
      ec( 6,1) = ed(40,1)
      ec( 7,1) = ed( 7,1) - sppszx00
      ec( 8,1) = ed(34,1)
      ec( 9,1) = ed(43,1)
      ec(10,1) = ed(28,1)
      ec(11,1) = ed(10,1) - sppsxx00
      ec(12,1) = ed(46,1)
      ec(13,1) = ed(31,1)
      ec(14,1) = ed(13,1) - sppsyx00
      ec(15,1) = ed(49,1)
      ec(16,1) = ed(34,1)
      ec(17,1) = ed(16,1) - sppszx00
      ec(18,1) = ed(52,1)
      ec(19,1) = ed(37,1)
      ec(20,1) = ed(46,1)
      ec(21,1) = ed(19,1) - sppsxx00
      ec(22,1) = ed(40,1)
      ec(23,1) = ed(49,1)
      ec(24,1) = ed(22,1) - sppsyx00
      ec(25,1) = ed(43,1)
      ec(26,1) = ed(52,1)
      ec(27,1) = ed(25,1) - sppszx00

      ec(28,1) = ed( 2,1) - sppsxy00
      ec(29,1) = ed(29,1)
      ec(30,1) = ed(38,1)
      ec(31,1) = ed( 5,1) - sppsyy00
      ec(32,1) = ed(32,1)
      ec(33,1) = ed(41,1)
      ec(34,1) = ed( 8,1) - sppszy00
      ec(35,1) = ed(35,1)
      ec(36,1) = ed(44,1)
      ec(37,1) = ed(29,1)
      ec(38,1) = ed(11,1) - sppsxy00
      ec(39,1) = ed(47,1)
      ec(40,1) = ed(32,1)
      ec(41,1) = ed(14,1) - sppsyy00
      ec(42,1) = ed(50,1)
      ec(43,1) = ed(35,1)
      ec(44,1) = ed(17,1) - sppszy00
      ec(45,1) = ed(53,1)
      ec(46,1) = ed(38,1)
      ec(47,1) = ed(47,1)
      ec(48,1) = ed(20,1) - sppsxy00
      ec(49,1) = ed(41,1)
      ec(50,1) = ed(50,1)
      ec(51,1) = ed(23,1) - sppsyy00
      ec(52,1) = ed(44,1)
      ec(53,1) = ed(53,1)
      ec(54,1) = ed(26,1) - sppszy00

      ec(55,1) = ed( 3,1) - sppsxz00
      ec(56,1) = ed(30,1)
      ec(57,1) = ed(39,1)
      ec(58,1) = ed( 6,1) - sppsyz00
      ec(59,1) = ed(33,1)
      ec(60,1) = ed(42,1)
      ec(61,1) = ed( 9,1) - sppszz00
      ec(62,1) = ed(36,1)
      ec(63,1) = ed(45,1)
      ec(64,1) = ed(30,1)
      ec(65,1) = ed(12,1) - sppsxz00
      ec(66,1) = ed(48,1)
      ec(67,1) = ed(33,1)
      ec(68,1) = ed(15,1) - sppsyz00
      ec(69,1) = ed(51,1)
      ec(70,1) = ed(36,1)
      ec(71,1) = ed(18,1) - sppszz00
      ec(72,1) = ed(54,1)
      ec(73,1) = ed(39,1)
      ec(74,1) = ed(48,1)
      ec(75,1) = ed(21,1) - sppsxz00
      ec(76,1) = ed(42,1)
      ec(77,1) = ed(51,1)
      ec(78,1) = ed(24,1) - sppsyz00
      ec(79,1) = ed(45,1)
      ec(80,1) = ed(54,1)
      ec(81,1) = ed(27,1) - sppszz00
!===================
!pdps
      ec( 1,2) = ed( 1,2) - pspsxx00
      ec( 2,2) = ed(10,2)
      ec( 3,2) = ed(13,2)
      ec( 4,2) = ed(10,2)
      ec( 5,2) = ed( 4,2) - pspsxx00
      ec( 6,2) = ed(16,2)
      ec( 7,2) = ed(13,2)
      ec( 8,2) = ed(16,2)
      ec( 9,2) = ed( 7,2) - pspsxx00
      ec(10,2) = ed(19,2) - pspsyx00
      ec(11,2) = ed(28,2)
      ec(12,2) = ed(31,2)
      ec(13,2) = ed(28,2)
      ec(14,2) = ed(22,2) - pspsyx00
      ec(15,2) = ed(34,2)
      ec(16,2) = ed(31,2)
      ec(17,2) = ed(34,2)
      ec(18,2) = ed(25,2) - pspsyx00
      ec(19,2) = ed(37,2) - pspszx00
      ec(20,2) = ed(46,2)
      ec(21,2) = ed(49,2)
      ec(22,2) = ed(46,2)
      ec(23,2) = ed(40,2) - pspszx00
      ec(24,2) = ed(52,2)
      ec(25,2) = ed(49,2)
      ec(26,2) = ed(52,2)
      ec(27,2) = ed(43,2) - pspszx00

      ec(28,2) = ed( 2,2) - pspsxy00
      ec(29,2) = ed(11,2)
      ec(30,2) = ed(14,2)
      ec(31,2) = ed(11,2)
      ec(32,2) = ed( 5,2) - pspsxy00
      ec(33,2) = ed(17,2)
      ec(34,2) = ed(14,2)
      ec(35,2) = ed(17,2)
      ec(36,2) = ed( 8,2) - pspsxy00
      ec(37,2) = ed(20,2) - pspsyy00
      ec(38,2) = ed(29,2)
      ec(39,2) = ed(32,2)
      ec(40,2) = ed(29,2)
      ec(41,2) = ed(23,2) - pspsyy00
      ec(42,2) = ed(35,2)
      ec(43,2) = ed(32,2)
      ec(44,2) = ed(35,2)
      ec(45,2) = ed(26,2) - pspsyy00
      ec(46,2) = ed(38,2) - pspszy00
      ec(47,2) = ed(47,2)
      ec(48,2) = ed(50,2)
      ec(49,2) = ed(47,2)
      ec(50,2) = ed(41,2) - pspszy00
      ec(51,2) = ed(53,2)
      ec(52,2) = ed(50,2)
      ec(53,2) = ed(53,2)
      ec(54,2) = ed(44,2) - pspszy00
                         
      ec(55,2) = ed( 3,2) - pspsxz00
      ec(56,2) = ed(12,2)
      ec(57,2) = ed(15,2)
      ec(58,2) = ed(12,2)
      ec(59,2) = ed( 6,2) - pspsxz00
      ec(60,2) = ed(18,2)
      ec(61,2) = ed(15,2)
      ec(62,2) = ed(18,2)
      ec(63,2) = ed( 9,2) - pspsxz00
      ec(64,2) = ed(21,2) - pspsyz00
      ec(65,2) = ed(30,2)
      ec(66,2) = ed(33,2)
      ec(67,2) = ed(30,2)
      ec(68,2) = ed(24,2) - pspsyz00
      ec(69,2) = ed(36,2)
      ec(70,2) = ed(33,2)
      ec(71,2) = ed(36,2)
      ec(72,2) = ed(27,2) - pspsyz00
      ec(73,2) = ed(39,2) - pspszz00
      ec(74,2) = ed(48,2)
      ec(75,2) = ed(51,2)
      ec(76,2) = ed(48,2)
      ec(77,2) = ed(42,2) - pspszz00
      ec(78,2) = ed(54,2)
      ec(79,2) = ed(51,2)
      ec(80,2) = ed(54,2)
      ec(81,2) = ed(45,2) - pspszz00
!ppds
      ec( 1,3) = ed( 1,3) - ppxx00
      ec( 2,3) = ed( 4,3)
      ec( 3,3) = ed( 5,3)
      ec( 4,3) = ed( 7,3) - ppxy00
      ec( 5,3) = ed(10,3)
      ec( 6,3) = ed(11,3)
      ec( 7,3) = ed(13,3) - ppxz00
      ec( 8,3) = ed(16,3)
      ec( 9,3) = ed(17,3)
      ec(10,3) = ed(19,3) - ppyx00
      ec(11,3) = ed(22,3)
      ec(12,3) = ed(23,3)
      ec(13,3) = ed(25,3) - ppyy00
      ec(14,3) = ed(28,3)
      ec(15,3) = ed(29,3)
      ec(16,3) = ed(31,3) - ppyz00
      ec(17,3) = ed(34,3)
      ec(18,3) = ed(35,3)
      ec(19,3) = ed(37,3) - ppzx00
      ec(20,3) = ed(40,3)
      ec(21,3) = ed(41,3)
      ec(22,3) = ed(43,3) - ppzy00
      ec(23,3) = ed(46,3)
      ec(24,3) = ed(47,3)
      ec(25,3) = ed(49,3) - ppzz00
      ec(26,3) = ed(52,3)
      ec(27,3) = ed(53,3)

      ec(28,3) = ed( 4,3)
      ec(29,3) = ed( 2,3) - ppxx00
      ec(30,3) = ed( 6,3)
      ec(31,3) = ed(10,3)
      ec(32,3) = ed( 8,3) - ppxy00
      ec(33,3) = ed(12,3)
      ec(34,3) = ed(16,3)
      ec(35,3) = ed(14,3) - ppxz00
      ec(36,3) = ed(18,3)
      ec(37,3) = ed(22,3)
      ec(38,3) = ed(20,3) - ppyx00
      ec(39,3) = ed(24,3)
      ec(40,3) = ed(28,3)
      ec(41,3) = ed(26,3) - ppyy00
      ec(42,3) = ed(30,3)
      ec(43,3) = ed(34,3)
      ec(44,3) = ed(32,3) - ppyz00
      ec(45,3) = ed(36,3)
      ec(46,3) = ed(40,3)
      ec(47,3) = ed(38,3) - ppzx00
      ec(48,3) = ed(42,3)
      ec(49,3) = ed(46,3)
      ec(50,3) = ed(44,3) - ppzy00
      ec(51,3) = ed(48,3)
      ec(52,3) = ed(52,3)
      ec(53,3) = ed(50,3) - ppzz00
      ec(54,3) = ed(54,3)

      ec(55,3) = ed( 5,3)
      ec(56,3) = ed( 6,3)
      ec(57,3) = ed( 3,3) - ppxx00
      ec(58,3) = ed(11,3)
      ec(59,3) = ed(12,3)
      ec(60,3) = ed( 9,3) - ppxy00
      ec(61,3) = ed(17,3)
      ec(62,3) = ed(18,3)
      ec(63,3) = ed(15,3) - ppxz00
      ec(64,3) = ed(23,3)
      ec(65,3) = ed(24,3)
      ec(66,3) = ed(21,3) - ppyx00
      ec(67,3) = ed(29,3)
      ec(68,3) = ed(30,3)
      ec(69,3) = ed(27,3) - ppyy00
      ec(70,3) = ed(35,3)
      ec(71,3) = ed(36,3)
      ec(72,3) = ed(33,3) - ppyz00
      ec(73,3) = ed(41,3)
      ec(74,3) = ed(42,3)
      ec(75,3) = ed(39,3) - ppzx00
      ec(76,3) = ed(47,3)
      ec(77,3) = ed(48,3)
      ec(78,3) = ed(45,3) - ppzy00
      ec(79,3) = ed(53,3)
      ec(80,3) = ed(54,3)
      ec(81,3) = ed(51,3) - ppzz00

      endif
#ifdef PL_OMP_DERI
!$omp end parallel
#endif

      do i=1,3
         do j=1,mao3
            ec(j,4) = ec(j,4) - ec(j,i)
         enddo
      enddo

      end
!= iopppp ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine jopppp(
     &     ec   ,
     &     fdat , edat  ,
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  , jal   ,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )


      implicit real(8) (a-h,o-z)
c$$$      dimension fdat(31,2001)
c$$$      dimension edat(2001)
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4),ed(mao3,3)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(5) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /)

#ifdef PL_SIMD_DERI
      dimension dmx(6,mxprm), val(5,mxprm)
#endif

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,jal,mao3,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do j = 1,3
         do i = 1,mao3
!           ec(i,j) = 0.0d0
            ed(i,j) = 0.0d0
         enddo
      enddo
!     do i = 1,mao3
!        ec(i,4) = 0.0d0
!     enddo
 
      sxxx00 = 0.d0
      sxxy00 = 0.d0
      sxxz00 = 0.d0
      sxyx00 = 0.d0
      sxyy00 = 0.d0
      sxyz00 = 0.d0
      sxzx00 = 0.d0
      sxzy00 = 0.d0
      sxzz00 = 0.d0
      syxx00 = 0.d0
      syxy00 = 0.d0
      syxz00 = 0.d0
      syyx00 = 0.d0
      syyy00 = 0.d0
      syyz00 = 0.d0
      syzx00 = 0.d0
      syzy00 = 0.d0
      syzz00 = 0.d0
      szxx00 = 0.d0
      szxy00 = 0.d0
      szxz00 = 0.d0
      szyx00 = 0.d0
      szyy00 = 0.d0
      szyz00 = 0.d0
      szzx00 = 0.d0
      szzy00 = 0.d0
      szzz00 = 0.d0

      xsxx00 = 0.d0
      xsxy00 = 0.d0
      xsxz00 = 0.d0
      xsyx00 = 0.d0
      xsyy00 = 0.d0
      xsyz00 = 0.d0
      xszx00 = 0.d0
      xszy00 = 0.d0
      xszz00 = 0.d0
      ysxx00 = 0.d0
      ysxy00 = 0.d0
      ysxz00 = 0.d0
      ysyx00 = 0.d0
      ysyy00 = 0.d0
      ysyz00 = 0.d0
      yszx00 = 0.d0
      yszy00 = 0.d0
      yszz00 = 0.d0
      zsxx00 = 0.d0
      zsxy00 = 0.d0
      zsxz00 = 0.d0
      zsyx00 = 0.d0
      zsyy00 = 0.d0
      zsyz00 = 0.d0
      zszx00 = 0.d0
      zszy00 = 0.d0
      zszz00 = 0.d0

      xxsx00 = 0.d0
      xxsy00 = 0.d0
      xxsz00 = 0.d0
      xysx00 = 0.d0
      xysy00 = 0.d0
      xysz00 = 0.d0
      xzsx00 = 0.d0
      xzsy00 = 0.d0
      xzsz00 = 0.d0
      yxsx00 = 0.d0
      yxsy00 = 0.d0
      yxsz00 = 0.d0
      yysx00 = 0.d0
      yysy00 = 0.d0
      yysz00 = 0.d0
      yzsx00 = 0.d0
      yzsy00 = 0.d0
      yzsz00 = 0.d0
      zxsx00 = 0.d0
      zxsy00 = 0.d0
      zxsz00 = 0.d0
      zysx00 = 0.d0
      zysy00 = 0.d0
      zysz00 = 0.d0
      zzsx00 = 0.d0
      zzsy00 = 0.d0
      zzsz00 = 0.d0

#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)
         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)
!c$$$
!c$$$                  qdx = yq(1,l,k) - xyz(1,latom)
!c$$$                  qdy = yq(2,l,k) - xyz(2,latom)
!c$$$                  qdz = yq(3,l,k) - xyz(3,latom)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(6)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f5   = (((((fdat(12,it)*dt6   + fdat(11,it))*dt5
     &                    + fdat(10,it))*dt4  + fdat(9,it))*dt3
     &                    + fdat(8,it))*dt2  + fdat(7,it))*dt
     &                    + fdat(6,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0

                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f4   =  (t2*f5 + ee)*rminv(5)
                     f3   =  (t2*f4 + ee)*rminv(4)
                     f2   =  (t2*f3 + ee)*rminv(3)
                     f1   =  (t2*f2 + ee)*rminv(2)
                     f0   =   t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0

                     dm1 = fpp*f1
                     dm2 = fpp*f2
                     dm3 = fpp*f3
                     dm4 = fpp*f4
                     dm5 = fpp*f5
                     
                  else
!                    qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv

                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0

                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
                     dm5 =  4.5d0 *tinv *  dm4
 
                  end if
                  
#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
                  val(5,l) = eta
 
                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
                  dmx(3,l) = dm2
                  dmx(4,l) = dm3
                  dmx(5,l) = dm4
                  dmx(6,l) = dm5
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)
                  eta  = val(5,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
                  dm2 = dmx(3,l)
                  dm3 = dmx(4,l)
                  dm4 = dmx(5,l)
                  dm5 = dmx(6,l)
#endif
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  qdx = yq(1,l,k) - xyz(1,latom)
                  qdy = yq(2,l,k) - xyz(2,latom)
                  qdz = yq(3,l,k) - xyz(3,latom)

                  s0 = dm0
                  s1 = dm1
                  s2 = dm2
                  s3 = dm3
                  s4 = dm4
                  s5 = dm5

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
                  rkp =  rooz * eta
!psss
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
!ssss01                  
                  s01 = zet*(s0 - rooz*s1)
                  s12 = zet*(s1 - rooz*s2)
                  s23 = zet*(s2 - rooz*s3)
                  s34 = zet*(s3 - rooz*s4)
!ppss                  
                  ppxx0 = pbx*px0 + wpx*px1 + s01
                  ppxy0 = pby*px0 + wpy*px1
                  ppxz0 = pbz*px0 + wpz*px1
                  ppyx0 = pbx*py0 + wpx*py1
                  ppyy0 = pby*py0 + wpy*py1 + s01
                  ppyz0 = pbz*py0 + wpz*py1
                  ppzx0 = pbx*pz0 + wpx*pz1
                  ppzy0 = pby*pz0 + wpy*pz1
                  ppzz0 = pbz*pz0 + wpz*pz1 + s01
                  ppxx1 = pbx*px1 + wpx*px2 + s12
                  ppxy1 = pby*px1 + wpy*px2
                  ppxz1 = pbz*px1 + wpz*px2
                  ppyx1 = pbx*py1 + wpx*py2
                  ppyy1 = pby*py1 + wpy*py2 + s12
                  ppyz1 = pbz*py1 + wpz*py2
                  ppzx1 = pbx*pz1 + wpx*pz2
                  ppzy1 = pby*pz1 + wpy*pz2
                  ppzz1 = pbz*pz1 + wpz*pz2 + s12
                  ppxx2 = pbx*px2 + wpx*px3 + s23
                  ppxy2 = pby*px2 + wpy*px3
                  ppxz2 = pbz*px2 + wpz*px3
                  ppyx2 = pbx*py2 + wpx*py3
                  ppyy2 = pby*py2 + wpy*py3 + s23
                  ppyz2 = pbz*py2 + wpz*py3
                  ppzx2 = pbx*pz2 + wpx*pz3
                  ppzy2 = pby*pz2 + wpy*pz3
                  ppzz2 = pbz*pz2 + wpz*pz3 + s23
                  ppxx3 = pbx*px3 + wpx*px4 + s34
                  ppxy3 = pby*px3 + wpy*px4
                  ppxz3 = pbz*px3 + wpz*px4
                  ppyx3 = pbx*py3 + wpx*py4
                  ppyy3 = pby*py3 + wpy*py4 + s34
                  ppyz3 = pbz*py3 + wpz*py4
                  ppzx3 = pbx*pz3 + wpx*pz4
                  ppzy3 = pby*pz3 + wpy*pz4
                  ppzz3 = pbz*pz3 + wpz*pz4 + s34
!spss 
                  xp0 = pbx*s0 +wpx*s1
                  yp0 = pby*s0 +wpy*s1
                  zp0 = pbz*s0 +wpz*s1
                  xp1 = pbx*s1 +wpx*s2
                  yp1 = pby*s1 +wpy*s2
                  zp1 = pbz*s1 +wpz*s2
                  xp2 = pbx*s2 +wpx*s3
                  yp2 = pby*s2 +wpy*s3
                  zp2 = pbz*s2 +wpz*s3
                  xp3 = pbx*s3 +wpx*s4
                  yp3 = pby*s3 +wpy*s4
                  zp3 = pbz*s3 +wpz*s4
!ppps
                  xxx0= qcx*ppxx0 + wqx*ppxx1 +rkp*(px1+xp1)
                  xxy0= qcy*ppxx0 + wqy*ppxx1
                  xxz0= qcz*ppxx0 + wqz*ppxx1
                  xyx0= qcx*ppxy0 + wqx*ppxy1 +rkp*yp1
                  xyy0= qcy*ppxy0 + wqy*ppxy1 +rkp*px1
                  xyz0= qcz*ppxy0 + wqz*ppxy1
                  xzx0= qcx*ppxz0 + wqx*ppxz1 +rkp*zp1
                  xzy0= qcy*ppxz0 + wqy*ppxz1
                  xzz0= qcz*ppxz0 + wqz*ppxz1 +rkp*px1
                  yxx0= qcx*ppyx0 + wqx*ppyx1 +rkp*py1
                  yxy0= qcy*ppyx0 + wqy*ppyx1 +rkp*xp1
                  yxz0= qcz*ppyx0 + wqz*ppyx1
                  yyx0= qcx*ppyy0 + wqx*ppyy1
                  yyy0= qcy*ppyy0 + wqy*ppyy1 +rkp*(py1+yp1)
                  yyz0= qcz*ppyy0 + wqz*ppyy1
                  yzx0= qcx*ppyz0 + wqx*ppyz1
                  yzy0= qcy*ppyz0 + wqy*ppyz1 +rkp*zp1
                  yzz0= qcz*ppyz0 + wqz*ppyz1 +rkp*py1
                  zxx0= qcx*ppzx0 + wqx*ppzx1 +rkp*pz1
                  zxy0= qcy*ppzx0 + wqy*ppzx1
                  zxz0= qcz*ppzx0 + wqz*ppzx1 +rkp*xp1
                  zyx0= qcx*ppzy0 + wqx*ppzy1
                  zyy0= qcy*ppzy0 + wqy*ppzy1 +rkp*pz1
                  zyz0= qcz*ppzy0 + wqz*ppzy1 +rkp*yp1
                  zzx0= qcx*ppzz0 + wqx*ppzz1
                  zzy0= qcy*ppzz0 + wqy*ppzz1
                  zzz0= qcz*ppzz0 + wqz*ppzz1 +rkp*(pz1+zp1)
                  
                  xxx1= qcx*ppxx1 + wqx*ppxx2 +rkp*(px2+xp2)
                  xxy1= qcy*ppxx1 + wqy*ppxx2
                  xxz1= qcz*ppxx1 + wqz*ppxx2
                  xyx1= qcx*ppxy1 + wqx*ppxy2 +rkp*yp2
                  xyy1= qcy*ppxy1 + wqy*ppxy2 +rkp*px2
                  xyz1= qcz*ppxy1 + wqz*ppxy2
                  xzx1= qcx*ppxz1 + wqx*ppxz2 +rkp*zp2
                  xzy1= qcy*ppxz1 + wqy*ppxz2
                  xzz1= qcz*ppxz1 + wqz*ppxz2 +rkp*px2
                  yxx1= qcx*ppyx1 + wqx*ppyx2 +rkp*py2
                  yxy1= qcy*ppyx1 + wqy*ppyx2 +rkp*xp2
                  yxz1= qcz*ppyx1 + wqz*ppyx2
                  yyx1= qcx*ppyy1 + wqx*ppyy2
                  yyy1= qcy*ppyy1 + wqy*ppyy2 +rkp*(py2+yp2)
                  yyz1= qcz*ppyy1 + wqz*ppyy2 
                  yzx1= qcx*ppyz1 + wqx*ppyz2
                  yzy1= qcy*ppyz1 + wqy*ppyz2 +rkp*zp2
                  yzz1= qcz*ppyz1 + wqz*ppyz2 +rkp*py2
                  zxx1= qcx*ppzx1 + wqx*ppzx2 +rkp*pz2
                  zxy1= qcy*ppzx1 + wqy*ppzx2
                  zxz1= qcz*ppzx1 + wqz*ppzx2 +rkp*xp2
                  zyx1= qcx*ppzy1 + wqx*ppzy2
                  zyy1= qcy*ppzy1 + wqy*ppzy2 +rkp*pz2
                  zyz1= qcz*ppzy1 + wqz*ppzy2 +rkp*yp2
                  zzx1= qcx*ppzz1 + wqx*ppzz2
                  zzy1= qcy*ppzz1 + wqy*ppzz2
                  zzz1= qcz*ppzz1 + wqz*ppzz2 +rkp*(pz2+zp2)
 
                  xxx2= qcx*ppxx2 + wqx*ppxx3 +rkp*(px3+xp3)
                  xxy2= qcy*ppxx2 + wqy*ppxx3
                  xxz2= qcz*ppxx2 + wqz*ppxx3
                  xyx2= qcx*ppxy2 + wqx*ppxy3 +rkp*yp3
                  xyy2= qcy*ppxy2 + wqy*ppxy3 +rkp*px3
                  xyz2= qcz*ppxy2 + wqz*ppxy3
                  xzx2= qcx*ppxz2 + wqx*ppxz3 +rkp*zp3
                  xzy2= qcy*ppxz2 + wqy*ppxz3
                  xzz2= qcz*ppxz2 + wqz*ppxz3 +rkp*px3
                  yxx2= qcx*ppyx2 + wqx*ppyx3 +rkp*py3
                  yxy2= qcy*ppyx2 + wqy*ppyx3 +rkp*xp3
                  yxz2= qcz*ppyx2 + wqz*ppyx3
                  yyx2= qcx*ppyy2 + wqx*ppyy3
                  yyy2= qcy*ppyy2 + wqy*ppyy3 +rkp*(py3+yp3)
                  yyz2= qcz*ppyy2 + wqz*ppyy3 
                  yzx2= qcx*ppyz2 + wqx*ppyz3
                  yzy2= qcy*ppyz2 + wqy*ppyz3 +rkp*zp3
                  yzz2= qcz*ppyz2 + wqz*ppyz3 +rkp*py3
                  zxx2= qcx*ppzx2 + wqx*ppzx3 +rkp*pz3
                  zxy2= qcy*ppzx2 + wqy*ppzx3
                  zxz2= qcz*ppzx2 + wqz*ppzx3 +rkp*xp3
                  zyx2= qcx*ppzy2 + wqx*ppzy3
                  zyy2= qcy*ppzy2 + wqy*ppzy3 +rkp*pz3
                  zyz2= qcz*ppzy2 + wqz*ppzy3 +rkp*yp3
                  zzx2= qcx*ppzz2 + wqx*ppzz3
                  zzy2= qcy*ppzz2 + wqy*ppzz3
                  zzz2= qcz*ppzz2 + wqz*ppzz3 +rkp*(pz3+zp3)
!eppss01 
                  xx01 = eta*(ppxx0 - rooe*ppxx1)
                  xy01 = eta*(ppxy0 - rooe*ppxy1)
                  xz01 = eta*(ppxz0 - rooe*ppxz1)
                  yx01 = eta*(ppyx0 - rooe*ppyx1)
                  yy01 = eta*(ppyy0 - rooe*ppyy1)
                  yz01 = eta*(ppyz0 - rooe*ppyz1)
                  zx01 = eta*(ppzx0 - rooe*ppzx1)
                  zy01 = eta*(ppzy0 - rooe*ppzy1)
                  zz01 = eta*(ppzz0 - rooe*ppzz1)
                  xx12 = eta*(ppxx1 - rooe*ppxx2)
                  xy12 = eta*(ppxy1 - rooe*ppxy2)
                  xz12 = eta*(ppxz1 - rooe*ppxz2)
                  yx12 = eta*(ppyx1 - rooe*ppyx2)
                  yy12 = eta*(ppyy1 - rooe*ppyy2)
                  yz12 = eta*(ppyz1 - rooe*ppyz2)
                  zx12 = eta*(ppzx1 - rooe*ppzx2)
                  zy12 = eta*(ppzy1 - rooe*ppzy2)
                  zz12 = eta*(ppzz1 - rooe*ppzz2)
!psps            
                  pxpx0=qcx*px0 + wqx*px1 +rkp*s1
                  pxpy0=qcy*px0 + wqy*px1
                  pxpz0=qcz*px0 + wqz*px1
                  pypx0=qcx*py0 + wqx*py1
                  pypy0=qcy*py0 + wqy*py1 +rkp*s1
                  pypz0=qcz*py0 + wqz*py1
                  pzpx0=qcx*pz0 + wqx*pz1
                  pzpy0=qcy*pz0 + wqy*pz1
                  pzpz0=qcz*pz0 + wqz*pz1 +rkp*s1

                  pxpx1=qcx*px1 + wqx*px2 +rkp*s2
                  pxpy1=qcy*px1 + wqy*px2        
                  pxpz1=qcz*px1 + wqz*px2        
                  pypx1=qcx*py1 + wqx*py2        
                  pypy1=qcy*py1 + wqy*py2 +rkp*s2
                  pypz1=qcz*py1 + wqz*py2        
                  pzpx1=qcx*pz1 + wqx*pz2        
                  pzpy1=qcy*pz1 + wqy*pz2        
                  pzpz1=qcz*pz1 + wqz*pz2 +rkp*s2

                  pxpx2=qcx*px2 + wqx*px3 +rkp*s3
                  pxpy2=qcy*px2 + wqy*px3
                  pxpz2=qcz*px2 + wqz*px3
                  pypx2=qcx*py2 + wqx*py3
                  pypy2=qcy*py2 + wqy*py3 +rkp*s3
                  pypz2=qcz*py2 + wqz*py3
                  pzpx2=qcx*pz2 + wqx*pz3
                  pzpy2=qcy*pz2 + wqy*pz3
                  pzpz2=qcz*pz2 + wqz*pz3 +rkp*s3

                  rpxpx1= rkp*pxpx1
                  rpxpy1= rkp*pxpy1
                  rpxpz1= rkp*pxpz1
                  rpypx1= rkp*pypx1
                  rpypy1= rkp*pypy1
                  rpypz1= rkp*pypz1
                  rpzpx1= rkp*pzpx1
                  rpzpy1= rkp*pzpy1
                  rpzpz1= rkp*pzpz1
                              
                  rpxpx2= rkp*pxpx2
                  rpxpy2= rkp*pxpy2
                  rpxpz2= rkp*pxpz2
                  rpypx2= rkp*pypx2
                  rpypy2= rkp*pypy2
                  rpypz2= rkp*pypz2
                  rpzpx2= rkp*pzpx2
                  rpzpy2= rkp*pzpy2
                  rpzpz2= rkp*pzpz2
! spps
                  pxxp0= qcx*xp0 + wqx*xp1 +rkp*s1
                  pxyp0= qcy*xp0 + wqy*xp1
                  pxzp0= qcz*xp0 + wqz*xp1
                  pyxp0= qcx*yp0 + wqx*yp1
                  pyyp0= qcy*yp0 + wqy*yp1 +rkp*s1
                  pyzp0= qcz*yp0 + wqz*yp1
                  pzxp0= qcx*zp0 + wqx*zp1
                  pzyp0= qcy*zp0 + wqy*zp1
                  pzzp0= qcz*zp0 + wqz*zp1 +rkp*s1

                  pxxp1= qcx*xp1 + wqx*xp2 +rkp*s2
                  pxyp1= qcy*xp1 + wqy*xp2
                  pxzp1= qcz*xp1 + wqz*xp2
                  pyxp1= qcx*yp1 + wqx*yp2
                  pyyp1= qcy*yp1 + wqy*yp2 +rkp*s2
                  pyzp1= qcz*yp1 + wqz*yp2
                  pzxp1= qcx*zp1 + wqx*zp2
                  pzyp1= qcy*zp1 + wqy*zp2
                  pzzp1= qcz*zp1 + wqz*zp2 +rkp*s2

                  pxxp2= qcx*xp2 + wqx*xp3 +rkp*s3
                  pxyp2= qcy*xp2 + wqy*xp3
                  pxzp2= qcz*xp2 + wqz*xp3
                  pyxp2= qcx*yp2 + wqx*yp3
                  pyyp2= qcy*yp2 + wqy*yp3 +rkp*s3
                  pyzp2= qcz*yp2 + wqz*yp3
                  pzxp2= qcx*zp2 + wqx*zp3
                  pzyp2= qcy*zp2 + wqy*zp3
                  pzzp2= qcz*zp2 + wqz*zp3 +rkp*s3
!rspps
                  rpxxp1=rkp*pxxp1
                  rpxyp1=rkp*pxyp1
                  rpxzp1=rkp*pxzp1
                  rpyxp1=rkp*pyxp1
                  rpyyp1=rkp*pyyp1
                  rpyzp1=rkp*pyzp1
                  rpzxp1=rkp*pzxp1
                  rpzyp1=rkp*pzyp1
                  rpzzp1=rkp*pzzp1

                  rpxxp2=rkp*pxxp2
                  rpxyp2=rkp*pxyp2
                  rpxzp2=rkp*pxzp2
                  rpyxp2=rkp*pyxp2
                  rpyyp2=rkp*pyyp2
                  rpyzp2=rkp*pyzp2
                  rpzxp2=rkp*pzxp2
                  rpzyp2=rkp*pzyp2
                  rpzzp2=rkp*pzzp2
!pppp
                  xxxx0=qdx*xxx0+wqx*xxx1+xx01+rpxpx1+rpxxp1
                  xxxy0=qdy*xxx0+wqy*xxx1
                  xxxz0=qdz*xxx0+wqz*xxx1
                  xxyx0=qdx*xxy0+wqx*xxy1     +rpxpy1+rpxyp1
                  xxyy0=qdy*xxy0+wqy*xxy1+xx01
                  xxyz0=qdz*xxy0+wqz*xxy1
                  xxzx0=qdx*xxz0+wqx*xxz1     +rpxpz1+rpxzp1
                  xxzy0=qdy*xxz0+wqy*xxz1
                  xxzz0=qdz*xxz0+wqz*xxz1+xx01
                  xyxx0=qdx*xyx0+wqx*xyx1+xy01       +rpyxp1
                  xyxy0=qdy*xyx0+wqy*xyx1     +rpxpx1
                  xyxz0=qdz*xyx0+wqz*xyx1
                  xyyx0=qdx*xyy0+wqx*xyy1            +rpyyp1
                  xyyy0=qdy*xyy0+wqy*xyy1+xy01+rpxpy1
                  xyyz0=qdz*xyy0+wqz*xyy1
                  xyzx0=qdx*xyz0+wqx*xyz1            +rpyzp1
                  xyzy0=qdy*xyz0+wqy*xyz1     +rpxpz1
                  xyzz0=qdz*xyz0+wqz*xyz1+xy01
                  xzxx0=qdx*xzx0+wqx*xzx1+xz01       +rpzxp1
                  xzxy0=qdy*xzx0+wqy*xzx1
                  xzxz0=qdz*xzx0+wqz*xzx1     +rpxpx1
                  xzyx0=qdx*xzy0+wqx*xzy1            +rpzyp1
                  xzyy0=qdy*xzy0+wqy*xzy1+xz01
                  xzyz0=qdz*xzy0+wqz*xzy1     +rpxpy1
                  xzzx0=qdx*xzz0+wqx*xzz1            +rpzzp1
                  xzzy0=qdy*xzz0+wqy*xzz1
                  xzzz0=qdz*xzz0+wqz*xzz1+xz01+rpxpz1

                  yxxx0=qdx*yxx0+wqx*yxx1+yx01+rpypx1
                  yxxy0=qdy*yxx0+wqy*yxx1            +rpxxp1
                  yxxz0=qdz*yxx0+wqz*yxx1
                  yxyx0=qdx*yxy0+wqx*yxy1     +rpypy1
                  yxyy0=qdy*yxy0+wqy*yxy1+yx01       +rpxyp1
                  yxyz0=qdz*yxy0+wqz*yxy1
                  yxzx0=qdx*yxz0+wqx*yxz1     +rpypz1
                  yxzy0=qdy*yxz0+wqy*yxz1            +rpxzp1
                  yxzz0=qdz*yxz0+wqz*yxz1+yx01
                  yyxx0=qdx*yyx0+wqx*yyx1+yy01
                  yyxy0=qdy*yyx0+wqy*yyx1     +rpypx1+rpyxp1
                  yyxz0=qdz*yyx0+wqz*yyx1
                  yyyx0=qdx*yyy0+wqx*yyy1
                  yyyy0=qdy*yyy0+wqy*yyy1+yy01+rpypy1+rpyyp1
                  yyyz0=qdz*yyy0+wqz*yyy1
                  yyzx0=qdx*yyz0+wqx*yyz1
                  yyzy0=qdy*yyz0+wqy*yyz1     +rpypz1+rpyzp1
                  yyzz0=qdz*yyz0+wqz*yyz1+yy01
                  yzxx0=qdx*yzx0+wqx*yzx1+yz01
                  yzxy0=qdy*yzx0+wqy*yzx1            +rpzxp1
                  yzxz0=qdz*yzx0+wqz*yzx1     +rpypx1
                  yzyx0=qdx*yzy0+wqx*yzy1
                  yzyy0=qdy*yzy0+wqy*yzy1+yz01       +rpzyp1
                  yzyz0=qdz*yzy0+wqz*yzy1     +rpypy1
                  yzzx0=qdx*yzz0+wqx*yzz1
                  yzzy0=qdy*yzz0+wqy*yzz1            +rpzzp1
                  yzzz0=qdz*yzz0+wqz*yzz1+yz01+rpypz1
                  
                  zxxx0=qdx*zxx0+wqx*zxx1+zx01+rpzpx1
                  zxxy0=qdy*zxx0+wqy*zxx1
                  zxxz0=qdz*zxx0+wqz*zxx1            +rpxxp1
                  zxyx0=qdx*zxy0+wqx*zxy1     +rpzpy1
                  zxyy0=qdy*zxy0+wqy*zxy1+zx01
                  zxyz0=qdz*zxy0+wqz*zxy1            +rpxyp1
                  zxzx0=qdx*zxz0+wqx*zxz1     +rpzpz1
                  zxzy0=qdy*zxz0+wqy*zxz1
                  zxzz0=qdz*zxz0+wqz*zxz1+zx01       +rpxzp1
                  zyxx0=qdx*zyx0+wqx*zyx1+zy01
                  zyxy0=qdy*zyx0+wqy*zyx1     +rpzpx1
                  zyxz0=qdz*zyx0+wqz*zyx1            +rpyxp1
                  zyyx0=qdx*zyy0+wqx*zyy1
                  zyyy0=qdy*zyy0+wqy*zyy1+zy01+rpzpy1
                  zyyz0=qdz*zyy0+wqz*zyy1            +rpyyp1
                  zyzx0=qdx*zyz0+wqx*zyz1
                  zyzy0=qdy*zyz0+wqy*zyz1     +rpzpz1
                  zyzz0=qdz*zyz0+wqz*zyz1+zy01       +rpyzp1
                  zzxx0=qdx*zzx0+wqx*zzx1+zz01
                  zzxy0=qdy*zzx0+wqy*zzx1
                  zzxz0=qdz*zzx0+wqz*zzx1     +rpzpx1+rpzxp1
                  zzyx0=qdx*zzy0+wqx*zzy1
                  zzyy0=qdy*zzy0+wqy*zzy1+zz01    
                  zzyz0=qdz*zzy0+wqz*zzy1     +rpzpy1+rpzyp1
                  zzzx0=qdx*zzz0+wqx*zzz1
                  zzzy0=qdy*zzz0+wqy*zzz1
                  zzzz0=qdz*zzz0+wqz*zzz1+zz01+rpzpz1+rpzzp1
 
                  xxxx1=qdx*xxx1+wqx*xxx2+xx12+rpxpx2+rpxxp2
                  xxxy1=qdy*xxx1+wqy*xxx2
                  xxxz1=qdz*xxx1+wqz*xxx2
                  xxyx1=qdx*xxy1+wqx*xxy2     +rpxpy2+rpxyp2
                  xxyy1=qdy*xxy1+wqy*xxy2+xx12
                  xxyz1=qdz*xxy1+wqz*xxy2
                  xxzx1=qdx*xxz1+wqx*xxz2     +rpxpz2+rpxzp2
                  xxzy1=qdy*xxz1+wqy*xxz2
                  xxzz1=qdz*xxz1+wqz*xxz2+xx12
                  xyxx1=qdx*xyx1+wqx*xyx2+xy12       +rpyxp2
                  xyxy1=qdy*xyx1+wqy*xyx2     +rpxpx2
                  xyxz1=qdz*xyx1+wqz*xyx2
                  xyyx1=qdx*xyy1+wqx*xyy2            +rpyyp2
                  xyyy1=qdy*xyy1+wqy*xyy2+xy12+rpxpy2
                  xyyz1=qdz*xyy1+wqz*xyy2
                  xyzx1=qdx*xyz1+wqx*xyz2            +rpyzp2
                  xyzy1=qdy*xyz1+wqy*xyz2     +rpxpz2
                  xyzz1=qdz*xyz1+wqz*xyz2+xy12
                  xzxx1=qdx*xzx1+wqx*xzx2+xz12       +rpzxp2
                  xzxy1=qdy*xzx1+wqy*xzx2
                  xzxz1=qdz*xzx1+wqz*xzx2     +rpxpx2
                  xzyx1=qdx*xzy1+wqx*xzy2            +rpzyp2
                  xzyy1=qdy*xzy1+wqy*xzy2+xz12
                  xzyz1=qdz*xzy1+wqz*xzy2     +rpxpy2
                  xzzx1=qdx*xzz1+wqx*xzz2            +rpzzp2
                  xzzy1=qdy*xzz1+wqy*xzz2
                  xzzz1=qdz*xzz1+wqz*xzz2+xz12+rpxpz2

                  yxxx1=qdx*yxx1+wqx*yxx2+yx12+rpypx2
                  yxxy1=qdy*yxx1+wqy*yxx2            +rpxxp2
                  yxxz1=qdz*yxx1+wqz*yxx2
                  yxyx1=qdx*yxy1+wqx*yxy2     +rpypy2
                  yxyy1=qdy*yxy1+wqy*yxy2+yx12       +rpxyp2
                  yxyz1=qdz*yxy1+wqz*yxy2
                  yxzx1=qdx*yxz1+wqx*yxz2     +rpypz2
                  yxzy1=qdy*yxz1+wqy*yxz2            +rpxzp2
                  yxzz1=qdz*yxz1+wqz*yxz2+yx12
                  yyxx1=qdx*yyx1+wqx*yyx2+yy12
                  yyxy1=qdy*yyx1+wqy*yyx2     +rpypx2+rpyxp2
                  yyxz1=qdz*yyx1+wqz*yyx2
                  yyyx1=qdx*yyy1+wqx*yyy2
                  yyyy1=qdy*yyy1+wqy*yyy2+yy12+rpypy2+rpyyp2
                  yyyz1=qdz*yyy1+wqz*yyy2
                  yyzx1=qdx*yyz1+wqx*yyz2
                  yyzy1=qdy*yyz1+wqy*yyz2     +rpypz2+rpyzp2
                  yyzz1=qdz*yyz1+wqz*yyz2+yy12
                  yzxx1=qdx*yzx1+wqx*yzx2+yz12
                  yzxy1=qdy*yzx1+wqy*yzx2            +rpzxp2
                  yzxz1=qdz*yzx1+wqz*yzx2     +rpypx2
                  yzyx1=qdx*yzy1+wqx*yzy2
                  yzyy1=qdy*yzy1+wqy*yzy2+yz12       +rpzyp2
                  yzyz1=qdz*yzy1+wqz*yzy2     +rpypy2
                  yzzx1=qdx*yzz1+wqx*yzz2
                  yzzy1=qdy*yzz1+wqy*yzz2            +rpzzp2
                  yzzz1=qdz*yzz1+wqz*yzz2+yz12+rpypz2
                  
                  zxxx1=qdx*zxx1+wqx*zxx2+zx12+rpzpx2
                  zxxy1=qdy*zxx1+wqy*zxx2
                  zxxz1=qdz*zxx1+wqz*zxx2            +rpxxp2
                  zxyx1=qdx*zxy1+wqx*zxy2     +rpzpy2
                  zxyy1=qdy*zxy1+wqy*zxy2+zx12
                  zxyz1=qdz*zxy1+wqz*zxy2            +rpxyp2
                  zxzx1=qdx*zxz1+wqx*zxz2     +rpzpz2
                  zxzy1=qdy*zxz1+wqy*zxz2
                  zxzz1=qdz*zxz1+wqz*zxz2+zx12       +rpxzp2
                  zyxx1=qdx*zyx1+wqx*zyx2+zy12
                  zyxy1=qdy*zyx1+wqy*zyx2     +rpzpx2
                  zyxz1=qdz*zyx1+wqz*zyx2            +rpyxp2
                  zyyx1=qdx*zyy1+wqx*zyy2
                  zyyy1=qdy*zyy1+wqy*zyy2+zy12+rpzpy2
                  zyyz1=qdz*zyy1+wqz*zyy2            +rpyyp2
                  zyzx1=qdx*zyz1+wqx*zyz2
                  zyzy1=qdy*zyz1+wqy*zyz2     +rpzpz2
                  zyzz1=qdz*zyz1+wqz*zyz2+zy12       +rpyzp2
                  zzxx1=qdx*zzx1+wqx*zzx2+zz12
                  zzxy1=qdy*zzx1+wqy*zzx2
                  zzxz1=qdz*zzx1+wqz*zzx2     +rpzpx2+rpzxp2
                  zzyx1=qdx*zzy1+wqx*zzy2
                  zzyy1=qdy*zzy1+wqy*zzy2+zz12    
                  zzyz1=qdz*zzy1+wqz*zzy2     +rpzpy2+rpzyp2
                  zzzx1=qdx*zzz1+wqx*zzz2
                  zzzy1=qdy*zzz1+wqy*zzz2
                  zzzz1=qdz*zzz1+wqz*zzz2+zz12+rpzpz2+rpzzp2
!rppps
      rxxx = rkp * xxx1
      rxxy = rkp * xxy1
      rxxz = rkp * xxz1
      rxyx = rkp * xyx1
      rxyy = rkp * xyy1
      rxyz = rkp * xyz1
      rxzx = rkp * xzx1
      rxzy = rkp * xzy1
      rxzz = rkp * xzz1
      ryxx = rkp * yxx1
      ryxy = rkp * yxy1
      ryxz = rkp * yxz1
      ryyx = rkp * yyx1
      ryyy = rkp * yyy1
      ryyz = rkp * yyz1
      ryzx = rkp * yzx1
      ryzy = rkp * yzy1
      ryzz = rkp * yzz1
      rzxx = rkp * zxx1
      rzxy = rkp * zxy1
      rzxz = rkp * zxz1
      rzyx = rkp * zyx1
      rzyy = rkp * zyy1
      rzyz = rkp * zyz1
      rzzx = rkp * zzx1
      rzzy = rkp * zzy1
      rzzz = rkp * zzz1
!rssps
                 rssxs1 = rkp*(qcx*s1 + wqx*s2)
                 rssys1 = rkp*(qcy*s1 + wqy*s2)
                 rsszs1 = rkp*(qcz*s1 + wqz*s2)

                 rssxs2 = rkp*(qcx*s2 + wqx*s3)
                 rssys2 = rkp*(qcy*s2 + wqy*s3)
                 rsszs2 = rkp*(qcz*s2 + wqz*s3)

!espss01
                 exp01 = eta*(xp0 -rooe*xp1)
                 eyp01 = eta*(yp0 -rooe*yp1)
                 ezp01 = eta*(zp0 -rooe*zp1)

                 exp12 = eta*(xp1 -rooe*xp2)
                 eyp12 = eta*(yp1 -rooe*yp2)
                 ezp12 = eta*(zp1 -rooe*zp2)

!sppp             spps        spps    ssps    spss
      sxxx0 = qdx*pxxp0 + wqx*pxxp1 + rssxs1 +exp01
      sxxy0 = qdy*pxxp0 + wqy*pxxp1
      sxxz0 = qdz*pxxp0 + wqz*pxxp1
      sxyx0 = qdx*pxyp0 + wqx*pxyp1 + rssys1
      sxyy0 = qdy*pxyp0 + wqy*pxyp1          +exp01
      sxyz0 = qdz*pxyp0 + wqz*pxyp1
      sxzx0 = qdx*pxzp0 + wqx*pxzp1 + rsszs1
      sxzy0 = qdy*pxzp0 + wqy*pxzp1
      sxzz0 = qdz*pxzp0 + wqz*pxzp1          +exp01
      syxx0 = qdx*pyxp0 + wqx*pyxp1          +eyp01
      syxy0 = qdy*pyxp0 + wqy*pyxp1 + rssxs1
      syxz0 = qdz*pyxp0 + wqz*pyxp1
      syyx0 = qdx*pyyp0 + wqx*pyyp1
      syyy0 = qdy*pyyp0 + wqy*pyyp1 + rssys1 +eyp01
      syyz0 = qdz*pyyp0 + wqz*pyyp1
      syzx0 = qdx*pyzp0 + wqx*pyzp1
      syzy0 = qdy*pyzp0 + wqy*pyzp1 + rsszs1
      syzz0 = qdz*pyzp0 + wqz*pyzp1          +eyp01
      szxx0 = qdx*pzxp0 + wqx*pzxp1          +ezp01
      szxy0 = qdy*pzxp0 + wqy*pzxp1
      szxz0 = qdz*pzxp0 + wqz*pzxp1 + rssxs1
      szyx0 = qdx*pzyp0 + wqx*pzyp1
      szyy0 = qdy*pzyp0 + wqy*pzyp1          +ezp01
      szyz0 = qdz*pzyp0 + wqz*pzyp1 + rssys1
      szzx0 = qdx*pzzp0 + wqx*pzzp1
      szzy0 = qdy*pzzp0 + wqy*pzzp1
      szzz0 = qdz*pzzp0 + wqz*pzzp1 + rsszs1 +ezp01

      sxxx00 = sxxx00 + sxxx0
      sxxy00 = sxxy00 + sxxy0
      sxxz00 = sxxz00 + sxxz0
      sxyx00 = sxyx00 + sxyx0
      sxyy00 = sxyy00 + sxyy0
      sxyz00 = sxyz00 + sxyz0
      sxzx00 = sxzx00 + sxzx0
      sxzy00 = sxzy00 + sxzy0
      sxzz00 = sxzz00 + sxzz0
      syxx00 = syxx00 + syxx0
      syxy00 = syxy00 + syxy0
      syxz00 = syxz00 + syxz0
      syyx00 = syyx00 + syyx0
      syyy00 = syyy00 + syyy0
      syyz00 = syyz00 + syyz0
      syzx00 = syzx00 + syzx0
      syzy00 = syzy00 + syzy0
      syzz00 = syzz00 + syzz0
      szxx00 = szxx00 + szxx0
      szxy00 = szxy00 + szxy0
      szxz00 = szxz00 + szxz0
      szyx00 = szyx00 + szyx0
      szyy00 = szyy00 + szyy0
      szyz00 = szyz00 + szyz0
      szzx00 = szzx00 + szzx0
      szzy00 = szzy00 + szzy0
      szzz00 = szzz00 + szzz0

      sxxx1 = qdx*pxxp1 + wqx*pxxp2 + rssxs2 +exp12
      sxxy1 = qdy*pxxp1 + wqy*pxxp2
      sxxz1 = qdz*pxxp1 + wqz*pxxp2
      sxyx1 = qdx*pxyp1 + wqx*pxyp2 + rssys2
      sxyy1 = qdy*pxyp1 + wqy*pxyp2          +exp12
      sxyz1 = qdz*pxyp1 + wqz*pxyp2
      sxzx1 = qdx*pxzp1 + wqx*pxzp2 + rsszs2
      sxzy1 = qdy*pxzp1 + wqy*pxzp2
      sxzz1 = qdz*pxzp1 + wqz*pxzp2          +exp12
      syxx1 = qdx*pyxp1 + wqx*pyxp2          +eyp12
      syxy1 = qdy*pyxp1 + wqy*pyxp2 + rssxs2
      syxz1 = qdz*pyxp1 + wqz*pyxp2
      syyx1 = qdx*pyyp1 + wqx*pyyp2
      syyy1 = qdy*pyyp1 + wqy*pyyp2 + rssys2 +eyp12
      syyz1 = qdz*pyyp1 + wqz*pyyp2
      syzx1 = qdx*pyzp1 + wqx*pyzp2
      syzy1 = qdy*pyzp1 + wqy*pyzp2 + rsszs2
      syzz1 = qdz*pyzp1 + wqz*pyzp2          +eyp12
      szxx1 = qdx*pzxp1 + wqx*pzxp2          +ezp12
      szxy1 = qdy*pzxp1 + wqy*pzxp2
      szxz1 = qdz*pzxp1 + wqz*pzxp2 + rssxs2
      szyx1 = qdx*pzyp1 + wqx*pzyp2
      szyy1 = qdy*pzyp1 + wqy*pzyp2          +ezp12
      szyz1 = qdz*pzyp1 + wqz*pzyp2 + rssys2
      szzx1 = qdx*pzzp1 + wqx*pzzp2
      szzy1 = qdy*pzzp1 + wqy*pzzp2
      szzz1 = qdz*pzzp1 + wqz*pzzp2 + rsszs2 +ezp12
!sppp01
      sxxx = zet*(sxxx0-rooz*sxxx1)
      sxxy = zet*(sxxy0-rooz*sxxy1)
      sxxz = zet*(sxxz0-rooz*sxxz1)
      sxyx = zet*(sxyx0-rooz*sxyx1)
      sxyy = zet*(sxyy0-rooz*sxyy1)
      sxyz = zet*(sxyz0-rooz*sxyz1)
      sxzx = zet*(sxzx0-rooz*sxzx1)
      sxzy = zet*(sxzy0-rooz*sxzy1)
      sxzz = zet*(sxzz0-rooz*sxzz1)
      syxx = zet*(syxx0-rooz*syxx1)
      syxy = zet*(syxy0-rooz*syxy1)
      syxz = zet*(syxz0-rooz*syxz1)
      syyx = zet*(syyx0-rooz*syyx1)
      syyy = zet*(syyy0-rooz*syyy1)
      syyz = zet*(syyz0-rooz*syyz1)
      syzx = zet*(syzx0-rooz*syzx1)
      syzy = zet*(syzy0-rooz*syzy1)
      syzz = zet*(syzz0-rooz*syzz1)
      szxx = zet*(szxx0-rooz*szxx1)
      szxy = zet*(szxy0-rooz*szxy1)
      szxz = zet*(szxz0-rooz*szxz1)
      szyx = zet*(szyx0-rooz*szyx1)
      szyy = zet*(szyy0-rooz*szyy1)
      szyz = zet*(szyz0-rooz*szyz1)
      szzx = zet*(szzx0-rooz*szzx1)
      szzy = zet*(szzy0-rooz*szzy1)
      szzz = zet*(szzz0-rooz*szzz1)
!rsppp
      rsxxx = rkp*sxxx1
      rsxxy = rkp*sxxy1
      rsxxz = rkp*sxxz1
      rsxyx = rkp*sxyx1
      rsxyy = rkp*sxyy1
      rsxyz = rkp*sxyz1
      rsxzx = rkp*sxzx1
      rsxzy = rkp*sxzy1
      rsxzz = rkp*sxzz1
      rsyxx = rkp*syxx1
      rsyxy = rkp*syxy1
      rsyxz = rkp*syxz1
      rsyyx = rkp*syyx1
      rsyyy = rkp*syyy1
      rsyyz = rkp*syyz1
      rsyzx = rkp*syzx1
      rsyzy = rkp*syzy1
      rsyzz = rkp*syzz1
      rszxx = rkp*szxx1
      rszxy = rkp*szxy1
      rszxz = rkp*szxz1
      rszyx = rkp*szyx1
      rszyy = rkp*szyy1
      rszyz = rkp*szyz1
      rszzx = rkp*szzx1
      rszzy = rkp*szzy1
      rszzz = rkp*szzz1
!epsss
      epx01 = eta*(px0 -rooe*px1)
      epy01 = eta*(py0 -rooe*py1)
      epz01 = eta*(pz0 -rooe*pz1)
      epx12 = eta*(px1 -rooe*px2)
      epy12 = eta*(py1 -rooe*py2)
      epz12 = eta*(pz1 -rooe*pz2)
!pspp           psps      psps    ssps  psss
      xsxx0 = qdx*pxpx0+wqx*pxpx1+rssxs1+epx01
      xsxy0 = qdy*pxpx0+wqy*pxpx1
      xsxz0 = qdz*pxpx0+wqz*pxpx1
      xsyx0 = qdx*pxpy0+wqx*pxpy1+rssys1      
      xsyy0 = qdy*pxpy0+wqy*pxpy1       +epx01
      xsyz0 = qdz*pxpy0+wqz*pxpy1
      xszx0 = qdx*pxpz0+wqx*pxpz1+rsszs1
      xszy0 = qdy*pxpz0+wqy*pxpz1
      xszz0 = qdz*pxpz0+wqz*pxpz1       +epx01
      ysxx0 = qdx*pypx0+wqx*pypx1       +epy01
      ysxy0 = qdy*pypx0+wqy*pypx1+rssxs1
      ysxz0 = qdz*pypx0+wqz*pypx1
      ysyx0 = qdx*pypy0+wqx*pypy1  
      ysyy0 = qdy*pypy0+wqy*pypy1+rssys1+epy01
      ysyz0 = qdz*pypy0+wqz*pypy1
      yszx0 = qdx*pypz0+wqx*pypz1  
      yszy0 = qdy*pypz0+wqy*pypz1+rsszs1
      yszz0 = qdz*pypz0+wqz*pypz1       +epy01
      zsxx0 = qdx*pzpx0+wqx*pzpx1       +epz01
      zsxy0 = qdy*pzpx0+wqy*pzpx1
      zsxz0 = qdz*pzpx0+wqz*pzpx1+rssxs1
      zsyx0 = qdx*pzpy0+wqx*pzpy1
      zsyy0 = qdy*pzpy0+wqy*pzpy1       +epz01
      zsyz0 = qdz*pzpy0+wqz*pzpy1+rssys1
      zszx0 = qdx*pzpz0+wqx*pzpz1
      zszy0 = qdy*pzpz0+wqy*pzpz1
      zszz0 = qdz*pzpz0+wqz*pzpz1+rsszs1+epz01

      xsxx00 = xsxx00 +xsxx0
      xsxy00 = xsxy00 +xsxy0
      xsxz00 = xsxz00 +xsxz0
      xsyx00 = xsyx00 +xsyx0
      xsyy00 = xsyy00 +xsyy0
      xsyz00 = xsyz00 +xsyz0
      xszx00 = xszx00 +xszx0
      xszy00 = xszy00 +xszy0
      xszz00 = xszz00 +xszz0
      ysxx00 = ysxx00 +ysxx0
      ysxy00 = ysxy00 +ysxy0
      ysxz00 = ysxz00 +ysxz0
      ysyx00 = ysyx00 +ysyx0
      ysyy00 = ysyy00 +ysyy0
      ysyz00 = ysyz00 +ysyz0
      yszx00 = yszx00 +yszx0
      yszy00 = yszy00 +yszy0
      yszz00 = yszz00 +yszz0
      zsxx00 = zsxx00 +zsxx0
      zsxy00 = zsxy00 +zsxy0
      zsxz00 = zsxz00 +zsxz0
      zsyx00 = zsyx00 +zsyx0
      zsyy00 = zsyy00 +zsyy0
      zsyz00 = zsyz00 +zsyz0
      zszx00 = zszx00 +zszx0
      zszy00 = zszy00 +zszy0
      zszz00 = zszz00 +zszz0

      xsxx1 = qdx*pxpx1+wqx*pxpx2+rssxs2+epx12
      xsxy1 = qdy*pxpx1+wqy*pxpx2
      xsxz1 = qdz*pxpx1+wqz*pxpx2
      xsyx1 = qdx*pxpy1+wqx*pxpy2+rssys2  
      xsyy1 = qdy*pxpy1+wqy*pxpy2       +epx12
      xsyz1 = qdz*pxpy1+wqz*pxpy2
      xszx1 = qdx*pxpz1+wqx*pxpz2+rsszs2
      xszy1 = qdy*pxpz1+wqy*pxpz2
      xszz1 = qdz*pxpz1+wqz*pxpz2       +epx12
      ysxx1 = qdx*pypx1+wqx*pypx2       +epy12
      ysxy1 = qdy*pypx1+wqy*pypx2+rssxs2
      ysxz1 = qdz*pypx1+wqz*pypx2  
      ysyx1 = qdx*pypy1+wqx*pypy2  
      ysyy1 = qdy*pypy1+wqy*pypy2+rssys2+epy12
      ysyz1 = qdz*pypy1+wqz*pypy2
      yszx1 = qdx*pypz1+wqx*pypz2  
      yszy1 = qdy*pypz1+wqy*pypz2+rsszs2
      yszz1 = qdz*pypz1+wqz*pypz2       +epy12
      zsxx1 = qdx*pzpx1+wqx*pzpx2       +epz12
      zsxy1 = qdy*pzpx1+wqy*pzpx2
      zsxz1 = qdz*pzpx1+wqz*pzpx2+rssxs2
      zsyx1 = qdx*pzpy1+wqx*pzpy2
      zsyy1 = qdy*pzpy1+wqy*pzpy2       +epz12
      zsyz1 = qdz*pzpy1+wqz*pzpy2+rssys2
      zszx1 = qdx*pzpz1+wqx*pzpz2
      zszy1 = qdy*pzpz1+wqy*pzpz2
      zszz1 = qdz*pzpz1+wqz*pzpz2+rsszs2+epz12
!pspp01
      xsxx = zet*(xsxx0-rooz*xsxx1)
      xsxy = zet*(xsxy0-rooz*xsxy1)
      xsxz = zet*(xsxz0-rooz*xsxz1)
      xsyx = zet*(xsyx0-rooz*xsyx1)
      xsyy = zet*(xsyy0-rooz*xsyy1)
      xsyz = zet*(xsyz0-rooz*xsyz1)
      xszx = zet*(xszx0-rooz*xszx1)
      xszy = zet*(xszy0-rooz*xszy1)
      xszz = zet*(xszz0-rooz*xszz1)
      ysxx = zet*(ysxx0-rooz*ysxx1)
      ysxy = zet*(ysxy0-rooz*ysxy1)
      ysxz = zet*(ysxz0-rooz*ysxz1)
      ysyx = zet*(ysyx0-rooz*ysyx1)
      ysyy = zet*(ysyy0-rooz*ysyy1)
      ysyz = zet*(ysyz0-rooz*ysyz1)
      yszx = zet*(yszx0-rooz*yszx1)
      yszy = zet*(yszy0-rooz*yszy1)
      yszz = zet*(yszz0-rooz*yszz1)
      zsxx = zet*(zsxx0-rooz*zsxx1)
      zsxy = zet*(zsxy0-rooz*zsxy1)
      zsxz = zet*(zsxz0-rooz*zsxz1)
      zsyx = zet*(zsyx0-rooz*zsyx1)
      zsyy = zet*(zsyy0-rooz*zsyy1)
      zsyz = zet*(zsyz0-rooz*zsyz1)
      zszx = zet*(zszx0-rooz*zszx1)
      zszy = zet*(zszy0-rooz*zszy1)
      zszz = zet*(zszz0-rooz*zszz1)
!rpspp
      rxsxx = rkp*xsxx1
      rxsxy = rkp*xsxy1
      rxsxz = rkp*xsxz1
      rxsyx = rkp*xsyx1
      rxsyy = rkp*xsyy1
      rxsyz = rkp*xsyz1
      rxszx = rkp*xszx1
      rxszy = rkp*xszy1
      rxszz = rkp*xszz1
      rysxx = rkp*ysxx1
      rysxy = rkp*ysxy1
      rysxz = rkp*ysxz1
      rysyx = rkp*ysyx1
      rysyy = rkp*ysyy1
      rysyz = rkp*ysyz1
      ryszx = rkp*yszx1
      ryszy = rkp*yszy1
      ryszz = rkp*yszz1
      rzsxx = rkp*zsxx1
      rzsxy = rkp*zsxy1
      rzsxz = rkp*zsxz1
      rzsyx = rkp*zsyx1
      rzsyy = rkp*zsyy1
      rzsyz = rkp*zsyz1
      rzszx = rkp*zszx1
      rzszy = rkp*zszy1
      rzszz = rkp*zszz1
!rspss
      rxp1 = rkp * xp1
      ryp1 = rkp * yp1
      rzp1 = rkp * zp1
      rxp2 = rkp * xp2
      ryp2 = rkp * yp2
      rzp2 = rkp * zp2
!rpsss
      rpx1 = rkp * px1
      rpy1 = rkp * py1
      rpz1 = rkp * pz1
      rpx2 = rkp * px2
      rpy2 = rkp * py2
      rpz2 = rkp * pz2

!ppsp
      xxsx0 = qdx*ppxx0 + wqx*ppxx1 + rxp1 + rpx1
      xxsy0 = qdy*ppxx0 + wqy*ppxx1
      xxsz0 = qdz*ppxx0 + wqz*ppxx1
      xysx0 = qdx*ppxy0 + wqx*ppxy1 + ryp1
      xysy0 = qdy*ppxy0 + wqy*ppxy1        + rpx1
      xysz0 = qdz*ppxy0 + wqz*ppxy1
      xzsx0 = qdx*ppxz0 + wqx*ppxz1 + rzp1
      xzsy0 = qdy*ppxz0 + wqy*ppxz1
      xzsz0 = qdz*ppxz0 + wqz*ppxz1        + rpx1
      yxsx0 = qdx*ppyx0 + wqx*ppyx1        + rpy1
      yxsy0 = qdy*ppyx0 + wqy*ppyx1 + rxp1
      yxsz0 = qdz*ppyx0 + wqz*ppyx1
      yysx0 = qdx*ppyy0 + wqx*ppyy1
      yysy0 = qdy*ppyy0 + wqy*ppyy1 + ryp1 + rpy1
      yysz0 = qdz*ppyy0 + wqz*ppyy1
      yzsx0 = qdx*ppyz0 + wqx*ppyz1
      yzsy0 = qdy*ppyz0 + wqy*ppyz1 + rzp1       
      yzsz0 = qdz*ppyz0 + wqz*ppyz1        + rpy1
      zxsx0 = qdx*ppzx0 + wqx*ppzx1        + rpz1
      zxsy0 = qdy*ppzx0 + wqy*ppzx1
      zxsz0 = qdz*ppzx0 + wqz*ppzx1 + rxp1
      zysx0 = qdx*ppzy0 + wqx*ppzy1        
      zysy0 = qdy*ppzy0 + wqy*ppzy1        + rpz1
      zysz0 = qdz*ppzy0 + wqz*ppzy1 + ryp1 
      zzsx0 = qdx*ppzz0 + wqx*ppzz1        
      zzsy0 = qdy*ppzz0 + wqy*ppzz1
      zzsz0 = qdz*ppzz0 + wqz*ppzz1 + rzp1 + rpz1

      xxsx00 = xxsx00 +xxsx0
      xxsy00 = xxsy00 +xxsy0
      xxsz00 = xxsz00 +xxsz0
      xysx00 = xysx00 +xysx0
      xysy00 = xysy00 +xysy0
      xysz00 = xysz00 +xysz0
      xzsx00 = xzsx00 +xzsx0
      xzsy00 = xzsy00 +xzsy0
      xzsz00 = xzsz00 +xzsz0
      yxsx00 = yxsx00 +yxsx0
      yxsy00 = yxsy00 +yxsy0
      yxsz00 = yxsz00 +yxsz0
      yysx00 = yysx00 +yysx0
      yysy00 = yysy00 +yysy0
      yysz00 = yysz00 +yysz0
      yzsx00 = yzsx00 +yzsx0
      yzsy00 = yzsy00 +yzsy0
      yzsz00 = yzsz00 +yzsz0
      zxsx00 = zxsx00 +zxsx0
      zxsy00 = zxsy00 +zxsy0
      zxsz00 = zxsz00 +zxsz0
      zysx00 = zysx00 +zysx0
      zysy00 = zysy00 +zysy0
      zysz00 = zysz00 +zysz0
      zzsx00 = zzsx00 +zzsx0
      zzsy00 = zzsy00 +zzsy0
      zzsz00 = zzsz00 +zzsz0

      xxsx1 = qdx*ppxx1 + wqx*ppxx2 + rxp2 + rpx2
      xxsy1 = qdy*ppxx1 + wqy*ppxx2
      xxsz1 = qdz*ppxx1 + wqz*ppxx2
      xysx1 = qdx*ppxy1 + wqx*ppxy2 + ryp2
      xysy1 = qdy*ppxy1 + wqy*ppxy2        + rpx2
      xysz1 = qdz*ppxy1 + wqz*ppxy2
      xzsx1 = qdx*ppxz1 + wqx*ppxz2 + rzp2
      xzsy1 = qdy*ppxz1 + wqy*ppxz2
      xzsz1 = qdz*ppxz1 + wqz*ppxz2        + rpx2
      yxsx1 = qdx*ppyx1 + wqx*ppyx2        + rpy2
      yxsy1 = qdy*ppyx1 + wqy*ppyx2 + rxp2
      yxsz1 = qdz*ppyx1 + wqz*ppyx2
      yysx1 = qdx*ppyy1 + wqx*ppyy2
      yysy1 = qdy*ppyy1 + wqy*ppyy2 + ryp2 + rpy2
      yysz1 = qdz*ppyy1 + wqz*ppyy2
      yzsx1 = qdx*ppyz1 + wqx*ppyz2
      yzsy1 = qdy*ppyz1 + wqy*ppyz2 + rzp2       
      yzsz1 = qdz*ppyz1 + wqz*ppyz2        + rpy2
      zxsx1 = qdx*ppzx1 + wqx*ppzx2        + rpz2
      zxsy1 = qdy*ppzx1 + wqy*ppzx2
      zxsz1 = qdz*ppzx1 + wqz*ppzx2 + rxp2
      zysx1 = qdx*ppzy1 + wqx*ppzy2        
      zysy1 = qdy*ppzy1 + wqy*ppzy2        + rpz2
      zysz1 = qdz*ppzy1 + wqz*ppzy2 + ryp2 
      zzsx1 = qdx*ppzz1 + wqx*ppzz2        
      zzsy1 = qdy*ppzz1 + wqy*ppzz2
      zzsz1 = qdz*ppzz1 + wqz*ppzz2 + rzp2 + rpz2
!rppsp
      rxxsx = rkp*xxsx1
      rxxsy = rkp*xxsy1
      rxxsz = rkp*xxsz1
      rxysx = rkp*xysx1
      rxysy = rkp*xysy1
      rxysz = rkp*xysz1
      rxzsx = rkp*xzsx1
      rxzsy = rkp*xzsy1
      rxzsz = rkp*xzsz1
      ryxsx = rkp*yxsx1
      ryxsy = rkp*yxsy1
      ryxsz = rkp*yxsz1
      ryysx = rkp*yysx1
      ryysy = rkp*yysy1
      ryysz = rkp*yysz1
      ryzsx = rkp*yzsx1
      ryzsy = rkp*yzsy1
      ryzsz = rkp*yzsz1
      rzxsx = rkp*zxsx1
      rzxsy = rkp*zxsy1
      rzxsz = rkp*zxsz1
      rzysx = rkp*zysx1
      rzysy = rkp*zysy1
      rzysz = rkp*zysz1
      rzzsx = rkp*zzsx1
      rzzsy = rkp*zzsy1
      rzzsz = rkp*zzsz1
!eppsp
      xxsx = eta*(xxsx0-rooe*xxsx1)
      xxsy = eta*(xxsy0-rooe*xxsy1)
      xxsz = eta*(xxsz0-rooe*xxsz1)
      xysx = eta*(xysx0-rooe*xysx1)
      xysy = eta*(xysy0-rooe*xysy1)
      xysz = eta*(xysz0-rooe*xysz1)
      xzsx = eta*(xzsx0-rooe*xzsx1)
      xzsy = eta*(xzsy0-rooe*xzsy1)
      xzsz = eta*(xzsz0-rooe*xzsz1)
      yxsx = eta*(yxsx0-rooe*yxsx1)
      yxsy = eta*(yxsy0-rooe*yxsy1)
      yxsz = eta*(yxsz0-rooe*yxsz1)
      yysx = eta*(yysx0-rooe*yysx1)
      yysy = eta*(yysy0-rooe*yysy1)
      yysz = eta*(yysz0-rooe*yysz1)
      yzsx = eta*(yzsx0-rooe*yzsx1)
      yzsy = eta*(yzsy0-rooe*yzsy1)
      yzsz = eta*(yzsz0-rooe*yzsz1)
      zxsx = eta*(zxsx0-rooe*zxsx1)
      zxsy = eta*(zxsy0-rooe*zxsy1)
      zxsz = eta*(zxsz0-rooe*zxsz1)
      zysx = eta*(zysx0-rooe*zysx1)
      zysy = eta*(zysy0-rooe*zysy1)
      zysz = eta*(zysz0-rooe*zysz1)
      zzsx = eta*(zzsx0-rooe*zzsx1)
      zzsy = eta*(zzsy0-rooe*zzsy1)
      zzsz = eta*(zzsz0-rooe*zzsz1)
!eppps
      xxx = eta*(xxx0-rooe*xxx1)
      xxy = eta*(xxy0-rooe*xxy1)
      xxz = eta*(xxz0-rooe*xxz1)
      xyx = eta*(xyx0-rooe*xyx1)
      xyy = eta*(xyy0-rooe*xyy1)
      exyz = eta*(xyz0-rooe*xyz1)
      xzx = eta*(xzx0-rooe*xzx1)
      xzy = eta*(xzy0-rooe*xzy1)
      xzz = eta*(xzz0-rooe*xzz1)
      yxx = eta*(yxx0-rooe*yxx1)
      yxy = eta*(yxy0-rooe*yxy1)
      yxz = eta*(yxz0-rooe*yxz1)
      yyx = eta*(yyx0-rooe*yyx1)
      yyy = eta*(yyy0-rooe*yyy1)
      yyz = eta*(yyz0-rooe*yyz1)
      yzx = eta*(yzx0-rooe*yzx1)
      yzy = eta*(yzy0-rooe*yzy1)
      yzz = eta*(yzz0-rooe*yzz1)
      zxx = eta*(zxx0-rooe*zxx1)
      zxy = eta*(zxy0-rooe*zxy1)
      zxz = eta*(zxz0-rooe*zxz1)
      zyx = eta*(zyx0-rooe*zyx1)
      zyy = eta*(zyy0-rooe*zyy1)
      zyz = eta*(zyz0-rooe*zyz1)
      zzx = eta*(zzx0-rooe*zzx1)
      zzy = eta*(zzy0-rooe*zzy1)
      zzz = eta*(zzz0-rooe*zzz1)

!     !dppp                       !pppp            sppp pspp ppsp ppps
      ed(  1,1)=ed(  1,1)+alp*(pax*xxxx0+wpx*xxxx1+sxxx+xsxx+rxxsx+rxxx)
      ed(  2,1)=ed(  2,1)+alp*(pax*xxxy0+wpx*xxxy1+sxxy+xsxy+rxxsy)
      ed(  3,1)=ed(  3,1)+alp*(pax*xxxz0+wpx*xxxz1+sxxz+xsxz+rxxsz)
      ed(  4,1)=ed(  4,1)+alp*(pax*xxyx0+wpx*xxyx1+sxyx+xsyx      +rxxy)
      ed(  5,1)=ed(  5,1)+alp*(pax*xxyy0+wpx*xxyy1+sxyy+xsyy)
      ed(  6,1)=ed(  6,1)+alp*(pax*xxyz0+wpx*xxyz1+sxyz+xsyz)
      ed(  7,1)=ed(  7,1)+alp*(pax*xxzx0+wpx*xxzx1+sxzx+xszx      +rxxz)
      ed(  8,1)=ed(  8,1)+alp*(pax*xxzy0+wpx*xxzy1+sxzy+xszy)
      ed(  9,1)=ed(  9,1)+alp*(pax*xxzz0+wpx*xxzz1+sxzz+xszz)
      ed( 10,1)=ed( 10,1)+alp*(pax*xyxx0+wpx*xyxx1+syxx     +rxysx+rxyx)
      ed( 11,1)=ed( 11,1)+alp*(pax*xyxy0+wpx*xyxy1+syxy     +rxysy)
      ed( 12,1)=ed( 12,1)+alp*(pax*xyxz0+wpx*xyxz1+syxz     +rxysz)
      ed( 13,1)=ed( 13,1)+alp*(pax*xyyx0+wpx*xyyx1+syyx           +rxyy)
      ed( 14,1)=ed( 14,1)+alp*(pax*xyyy0+wpx*xyyy1+syyy)
      ed( 15,1)=ed( 15,1)+alp*(pax*xyyz0+wpx*xyyz1+syyz)
      ed( 16,1)=ed( 16,1)+alp*(pax*xyzx0+wpx*xyzx1+syzx           +rxyz)
      ed( 17,1)=ed( 17,1)+alp*(pax*xyzy0+wpx*xyzy1+syzy)
      ed( 18,1)=ed( 18,1)+alp*(pax*xyzz0+wpx*xyzz1+syzz)
      ed( 19,1)=ed( 19,1)+alp*(pax*xzxx0+wpx*xzxx1+szxx     +rxzsx+rxzx)
      ed( 20,1)=ed( 20,1)+alp*(pax*xzxy0+wpx*xzxy1+szxy     +rxzsy)
      ed( 21,1)=ed( 21,1)+alp*(pax*xzxz0+wpx*xzxz1+szxz     +rxzsz)
      ed( 22,1)=ed( 22,1)+alp*(pax*xzyx0+wpx*xzyx1+szyx           +rxzy)
      ed( 23,1)=ed( 23,1)+alp*(pax*xzyy0+wpx*xzyy1+szyy)
      ed( 24,1)=ed( 24,1)+alp*(pax*xzyz0+wpx*xzyz1+szyz)
      ed( 25,1)=ed( 25,1)+alp*(pax*xzzx0+wpx*xzzx1+szzx           +rxzz)
      ed( 26,1)=ed( 26,1)+alp*(pax*xzzy0+wpx*xzzy1+szzy)
      ed( 27,1)=ed( 27,1)+alp*(pax*xzzz0+wpx*xzzz1+szzz)
      ed( 28,1)=ed( 28,1)+alp*(pay*yxxx0+wpy*yxxx1+sxxx)
      ed( 29,1)=ed( 29,1)+alp*(pay*yxxy0+wpy*yxxy1+sxxy           +ryxx)
      ed( 30,1)=ed( 30,1)+alp*(pay*yxxz0+wpy*yxxz1+sxxz)
      ed( 31,1)=ed( 31,1)+alp*(pay*yxyx0+wpy*yxyx1+sxyx     +ryxsx)
      ed( 32,1)=ed( 32,1)+alp*(pay*yxyy0+wpy*yxyy1+sxyy     +ryxsy+ryxy)
      ed( 33,1)=ed( 33,1)+alp*(pay*yxyz0+wpy*yxyz1+sxyz     +ryxsz)
      ed( 34,1)=ed( 34,1)+alp*(pay*yxzx0+wpy*yxzx1+sxzx)
      ed( 35,1)=ed( 35,1)+alp*(pay*yxzy0+wpy*yxzy1+sxzy           +ryxz)
      ed( 36,1)=ed( 36,1)+alp*(pay*yxzz0+wpy*yxzz1+sxzz)
      ed( 37,1)=ed( 37,1)+alp*(pay*yyxx0+wpy*yyxx1+syxx+ysxx)
      ed( 38,1)=ed( 38,1)+alp*(pay*yyxy0+wpy*yyxy1+syxy+ysxy      +ryyx)
      ed( 39,1)=ed( 39,1)+alp*(pay*yyxz0+wpy*yyxz1+syxz+ysxz)
      ed( 40,1)=ed( 40,1)+alp*(pay*yyyx0+wpy*yyyx1+syyx+ysyx+ryysx)
      ed( 41,1)=ed( 41,1)+alp*(pay*yyyy0+wpy*yyyy1+syyy+ysyy+ryysy+ryyy)
      ed( 42,1)=ed( 42,1)+alp*(pay*yyyz0+wpy*yyyz1+syyz+ysyz+ryysz)
      ed( 43,1)=ed( 43,1)+alp*(pay*yyzx0+wpy*yyzx1+syzx+yszx)
      ed( 44,1)=ed( 44,1)+alp*(pay*yyzy0+wpy*yyzy1+syzy+yszy      +ryyz)
      ed( 45,1)=ed( 45,1)+alp*(pay*yyzz0+wpy*yyzz1+syzz+yszz)
      ed( 46,1)=ed( 46,1)+alp*(pay*yzxx0+wpy*yzxx1+szxx      )     
      ed( 47,1)=ed( 47,1)+alp*(pay*yzxy0+wpy*yzxy1+szxy           +ryzx)
      ed( 48,1)=ed( 48,1)+alp*(pay*yzxz0+wpy*yzxz1+szxz)
      ed( 49,1)=ed( 49,1)+alp*(pay*yzyx0+wpy*yzyx1+szyx     +ryzsx)
      ed( 50,1)=ed( 50,1)+alp*(pay*yzyy0+wpy*yzyy1+szyy     +ryzsy+ryzy)
      ed( 51,1)=ed( 51,1)+alp*(pay*yzyz0+wpy*yzyz1+szyz     +ryzsz)
      ed( 52,1)=ed( 52,1)+alp*(pay*yzzx0+wpy*yzzx1+szzx)
      ed( 53,1)=ed( 53,1)+alp*(pay*yzzy0+wpy*yzzy1+szzy           +ryzz)
      ed( 54,1)=ed( 54,1)+alp*(pay*yzzz0+wpy*yzzz1+szzz           )
      ed( 55,1)=ed( 55,1)+alp*(paz*zxxx0+wpz*zxxx1+sxxx     )
      ed( 56,1)=ed( 56,1)+alp*(paz*zxxy0+wpz*zxxy1+sxxy     )
      ed( 57,1)=ed( 57,1)+alp*(paz*zxxz0+wpz*zxxz1+sxxz           +rzxx)
      ed( 58,1)=ed( 58,1)+alp*(paz*zxyx0+wpz*zxyx1+sxyx     )
      ed( 59,1)=ed( 59,1)+alp*(paz*zxyy0+wpz*zxyy1+sxyy     )
      ed( 60,1)=ed( 60,1)+alp*(paz*zxyz0+wpz*zxyz1+sxyz           +rzxy)
      ed( 61,1)=ed( 61,1)+alp*(paz*zxzx0+wpz*zxzx1+sxzx     +rzxsx)
      ed( 62,1)=ed( 62,1)+alp*(paz*zxzy0+wpz*zxzy1+sxzy     +rzxsy)
      ed( 63,1)=ed( 63,1)+alp*(paz*zxzz0+wpz*zxzz1+sxzz     +rzxsz+rzxz)
      ed( 64,1)=ed( 64,1)+alp*(paz*zyxx0+wpz*zyxx1+syxx           )
      ed( 65,1)=ed( 65,1)+alp*(paz*zyxy0+wpz*zyxy1+syxy           )
      ed( 66,1)=ed( 66,1)+alp*(paz*zyxz0+wpz*zyxz1+syxz           +rzyx)
      ed( 67,1)=ed( 67,1)+alp*(paz*zyyx0+wpz*zyyx1+syyx           )
      ed( 68,1)=ed( 68,1)+alp*(paz*zyyy0+wpz*zyyy1+syyy           )
      ed( 69,1)=ed( 69,1)+alp*(paz*zyyz0+wpz*zyyz1+syyz           +rzyy)
      ed( 70,1)=ed( 70,1)+alp*(paz*zyzx0+wpz*zyzx1+syzx     +rzysx)
      ed( 71,1)=ed( 71,1)+alp*(paz*zyzy0+wpz*zyzy1+syzy     +rzysy)
      ed( 72,1)=ed( 72,1)+alp*(paz*zyzz0+wpz*zyzz1+syzz     +rzysz+rzyz)
      ed( 73,1)=ed( 73,1)+alp*(paz*zzxx0+wpz*zzxx1+szxx+zsxx      )
      ed( 74,1)=ed( 74,1)+alp*(paz*zzxy0+wpz*zzxy1+szxy+zsxy      )
      ed( 75,1)=ed( 75,1)+alp*(paz*zzxz0+wpz*zzxz1+szxz+zsxz      +rzzx)
      ed( 76,1)=ed( 76,1)+alp*(paz*zzyx0+wpz*zzyx1+szyx+zsyx      )
      ed( 77,1)=ed( 77,1)+alp*(paz*zzyy0+wpz*zzyy1+szyy+zsyy      )
      ed( 78,1)=ed( 78,1)+alp*(paz*zzyz0+wpz*zzyz1+szyz+zsyz      +rzzy)
      ed( 79,1)=ed( 79,1)+alp*(paz*zzzx0+wpz*zzzx1+szzx+zszx+rzzsx)
      ed( 80,1)=ed( 80,1)+alp*(paz*zzzy0+wpz*zzzy1+szzy+zszy+rzzsy)
      ed( 81,1)=ed( 81,1)+alp*(paz*zzzz0+wpz*zzzz1+szzz+zszz+rzzsz+rzzz)
      ed( 82,1)=ed( 82,1)+alp*(pay*xxxx0+wpy*xxxx1)
      ed( 83,1)=ed( 83,1)+alp*(pay*xxxy0+wpy*xxxy1                +rxxx)
      ed( 84,1)=ed( 84,1)+alp*(pay*xxxz0+wpy*xxxz1)
      ed( 85,1)=ed( 85,1)+alp*(pay*xxyx0+wpy*xxyx1          +rxxsx)
      ed( 86,1)=ed( 86,1)+alp*(pax*yxyy0+wpx*yxyy1     +ysyy)
      ed( 87,1)=ed( 87,1)+alp*(pay*xxyz0+wpy*xxyz1          +rxxsz)
      ed( 88,1)=ed( 88,1)+alp*(pay*xxzx0+wpy*xxzx1)
      ed( 89,1)=ed( 89,1)+alp*(pay*xxzy0+wpy*xxzy1                +rxxz)
      ed( 90,1)=ed( 90,1)+alp*(pay*xxzz0+wpy*xxzz1                     )
      ed( 91,1)=ed( 91,1)+alp*(pay*xyxx0+wpy*xyxx1     +xsxx)
      ed( 92,1)=ed( 92,1)+alp*(pax*yyxy0+wpx*yyxy1          +ryysy)
      ed( 93,1)=ed( 93,1)+alp*(pay*xyxz0+wpy*xyxz1     +xsxz)
      ed( 94,1)=ed( 94,1)+alp*(pax*yyyx0+wpx*yyyx1                +ryyy)
      ed( 95,1)=ed( 95,1)+alp*(pax*yyyy0+wpx*yyyy1)
      ed( 96,1)=ed( 96,1)+alp*(pax*yyyz0+wpx*yyyz1)
      ed( 97,1)=ed( 97,1)+alp*(pay*xyzx0+wpy*xyzx1     +xszx)
      ed( 98,1)=ed( 98,1)+alp*(pax*yyzy0+wpx*yyzy1)
      ed( 99,1)=ed( 99,1)+alp*(pax*yyzz0+wpx*yyzz1)
      ed(100,1)=ed(100,1)+alp*(pay*xzxx0+wpy*xzxx1)
      ed(101,1)=ed(101,1)+alp*(pay*xzxy0+wpy*xzxy1                +rxzx)
      ed(102,1)=ed(102,1)+alp*(pay*xzxz0+wpy*xzxz1)
      ed(103,1)=ed(103,1)+alp*(pax*yzyx0+wpx*yzyx1                +ryzy)
      ed(104,1)=ed(104,1)+alp*(pax*yzyy0+wpx*yzyy1)
      ed(105,1)=ed(105,1)+alp*(pax*yzyz0+wpx*yzyz1)
      ed(106,1)=ed(106,1)+alp*(pay*xzzx0+wpy*xzzx1)
      ed(107,1)=ed(107,1)+alp*(pax*yzzy0+wpx*yzzy1)
      ed(108,1)=ed(108,1)+alp*(pax*yzzz0+wpx*yzzz1)
      ed(109,1)=ed(109,1)+alp*(paz*xxxx0+wpz*xxxx1)
      ed(110,1)=ed(110,1)+alp*(paz*xxxy0+wpz*xxxy1)
      ed(111,1)=ed(111,1)+alp*(paz*xxxz0+wpz*xxxz1                +rxxx)
      ed(112,1)=ed(112,1)+alp*(paz*xxyx0+wpz*xxyx1)
      ed(113,1)=ed(113,1)+alp*(paz*xxyy0+wpz*xxyy1)
      ed(114,1)=ed(114,1)+alp*(paz*xxyz0+wpz*xxyz1                +rxxy)
      ed(115,1)=ed(115,1)+alp*(paz*xxzx0+wpz*xxzx1          +rxxsx)
      ed(116,1)=ed(116,1)+alp*(paz*xxzy0+wpz*xxzy1          +rxxsy)
      ed(117,1)=ed(117,1)+alp*(pax*zxzz0+wpx*zxzz1     +zszz)
      ed(118,1)=ed(118,1)+alp*(paz*xyxx0+wpz*xyxx1)
      ed(119,1)=ed(119,1)+alp*(paz*xyxy0+wpz*xyxy1)
      ed(120,1)=ed(120,1)+alp*(paz*xyxz0+wpz*xyxz1                +rxyx)
      ed(121,1)=ed(121,1)+alp*(paz*xyyx0+wpz*xyyx1)
      ed(122,1)=ed(122,1)+alp*(paz*xyyy0+wpz*xyyy1)
      ed(123,1)=ed(123,1)+alp*(pax*zyyz0+wpx*zyyz1)
      ed(124,1)=ed(124,1)+alp*(paz*xyzx0+wpz*xyzx1          +rxysx)
      ed(125,1)=ed(125,1)+alp*(pax*zyzy0+wpx*zyzy1)
      ed(126,1)=ed(126,1)+alp*(pax*zyzz0+wpx*zyzz1)
      ed(127,1)=ed(127,1)+alp*(paz*xzxx0+wpz*xzxx1     +xsxx)
      ed(128,1)=ed(128,1)+alp*(paz*xzxy0+wpz*xzxy1     +xsxy)
      ed(129,1)=ed(129,1)+alp*(pax*zzxz0+wpx*zzxz1          +rzzsz)
      ed(130,1)=ed(130,1)+alp*(paz*xzyx0+wpz*xzyx1     +xsyx)
      ed(131,1)=ed(131,1)+alp*(pax*zzyy0+wpx*zzyy1)
      ed(132,1)=ed(132,1)+alp*(pax*zzyz0+wpx*zzyz1)
      ed(133,1)=ed(133,1)+alp*(pax*zzzx0+wpx*zzzx1                +rzzz)
      ed(134,1)=ed(134,1)+alp*(pax*zzzy0+wpx*zzzy1)
      ed(135,1)=ed(135,1)+alp*(pax*zzzz0+wpx*zzzz1)
      ed(136,1)=ed(136,1)+alp*(paz*yxxx0+wpz*yxxx1)
      ed(137,1)=ed(137,1)+alp*(paz*yxxy0+wpz*yxxy1)
      ed(138,1)=ed(138,1)+alp*(pay*zxxz0+wpy*zxxz1)
      ed(139,1)=ed(139,1)+alp*(paz*yxyx0+wpz*yxyx1)
      ed(140,1)=ed(140,1)+alp*(paz*yxyy0+wpz*yxyy1)
      ed(141,1)=ed(141,1)+alp*(paz*yxyz0+wpz*yxyz1                +ryxy)
      ed(142,1)=ed(142,1)+alp*(pay*zxzx0+wpy*zxzx1)
      ed(143,1)=ed(143,1)+alp*(paz*yxzy0+wpz*yxzy1          +ryxsy)
      ed(144,1)=ed(144,1)+alp*(pay*zxzz0+wpy*zxzz1)
      ed(145,1)=ed(145,1)+alp*(paz*yyxx0+wpz*yyxx1)
      ed(146,1)=ed(146,1)+alp*(paz*yyxy0+wpz*yyxy1)
      ed(147,1)=ed(147,1)+alp*(paz*yyxz0+wpz*yyxz1                +ryyx)
      ed(148,1)=ed(148,1)+alp*(paz*yyyx0+wpz*yyyx1)
      ed(149,1)=ed(149,1)+alp*(paz*yyyy0+wpz*yyyy1)
      ed(150,1)=ed(150,1)+alp*(paz*yyyz0+wpz*yyyz1                +ryyy)
      ed(151,1)=ed(151,1)+alp*(paz*yyzx0+wpz*yyzx1          +ryysx)
      ed(152,1)=ed(152,1)+alp*(paz*yyzy0+wpz*yyzy1          +ryysy)
      ed(153,1)=ed(153,1)+alp*(pay*zyzz0+wpy*zyzz1     +zszz)
      ed(154,1)=ed(154,1)+alp*(pay*zzxx0+wpy*zzxx1)
      ed(155,1)=ed(155,1)+alp*(paz*yzxy0+wpz*yzxy1     +ysxy)
      ed(156,1)=ed(156,1)+alp*(pay*zzxz0+wpy*zzxz1)
      ed(157,1)=ed(157,1)+alp*(pay*zzyx0+wpy*zzyx1          +rzzsx)
      ed(158,1)=ed(158,1)+alp*(paz*yzyy0+wpz*yzyy1     +ysyy)
      ed(159,1)=ed(159,1)+alp*(pay*zzyz0+wpy*zzyz1          +rzzsz)
      ed(160,1)=ed(160,1)+alp*(pay*zzzx0+wpy*zzzx1)
      ed(161,1)=ed(161,1)+alp*(pay*zzzy0+wpy*zzzy1                +rzzz)
      ed(162,1)=ed(162,1)+alp*(pay*zzzz0+wpy*zzzz1)
!pdps
      ed(  1,2)=ed(  1,2)+bet*(pbx*xxxx0+wpx*xxxx1+sxxx+xsxx+rxxsx+rxxx)
      ed(  2,2)=ed(  2,2)+bet*(pbx*xxxy0+wpx*xxxy1+sxxy+xsxy+rxxsy     )
      ed(  3,2)=ed(  3,2)+bet*(pbx*xxxz0+wpx*xxxz1+sxxz+xsxz+rxxsz     )
      ed(  4,2)=ed(  4,2)+bet*(pbx*xxyx0+wpx*xxyx1+sxyx+xsyx      +rxxy)
      ed(  5,2)=ed(  5,2)+bet*(pbx*xxyy0+wpx*xxyy1+sxyy+xsyy           )
      ed(  6,2)=ed(  6,2)+bet*(pbx*xxyz0+wpx*xxyz1+sxyz+xsyz           )
      ed(  7,2)=ed(  7,2)+bet*(pbx*xxzx0+wpx*xxzx1+sxzx+xszx      +rxxz)
      ed(  8,2)=ed(  8,2)+bet*(pbx*xxzy0+wpx*xxzy1+sxzy+xszy           )
      ed(  9,2)=ed(  9,2)+bet*(pbx*xxzz0+wpx*xxzz1+sxzz+xszz           )
                          
      ed( 10,2)=ed( 10,2)+bet*(pby*xyxx0+wpy*xyxx1     +xsxx           )
      ed( 11,2)=ed( 11,2)+bet*(pby*xyxy0+wpy*xyxy1     +xsxy      +rxyx)
      ed( 12,2)=ed( 12,2)+bet*(pby*xyxz0+wpy*xyxz1     +xsxz           )
      ed( 13,2)=ed( 13,2)+bet*(pby*xyyx0+wpy*xyyx1     +xsyx+rxysx     )
      ed( 14,2)=ed( 14,2)+bet*(pby*xyyy0+wpy*xyyy1     +xsyy+rxysy+rxyy)
      ed( 15,2)=ed( 15,2)+bet*(pby*xyyz0+wpy*xyyz1     +xsyz+rxysz     )
      ed( 16,2)=ed( 16,2)+bet*(pby*xyzx0+wpy*xyzx1     +xszx           )
      ed( 17,2)=ed( 17,2)+bet*(pby*xyzy0+wpy*xyzy1     +xszy      +rxyz)
      ed( 18,2)=ed( 18,2)+bet*(pby*xyzz0+wpy*xyzz1     +xszz           )
                          
      ed( 19,2)=ed( 19,2)+bet*(pbz*xzxx0+wpz*xzxx1     +xsxx           )
      ed( 20,2)=ed( 20,2)+bet*(pbz*xzxy0+wpz*xzxy1     +xsxy           )
      ed( 21,2)=ed( 21,2)+bet*(pbz*xzxz0+wpz*xzxz1     +xsxz      +rxzx)
      ed( 22,2)=ed( 22,2)+bet*(pbz*xzyx0+wpz*xzyx1     +xsyx           )
      ed( 23,2)=ed( 23,2)+bet*(pbz*xzyy0+wpz*xzyy1     +xsyy           )
      ed( 24,2)=ed( 24,2)+bet*(pbz*xzyz0+wpz*xzyz1     +xsyz      +rxzy)
      ed( 25,2)=ed( 25,2)+bet*(pbz*xzzx0+wpz*xzzx1     +xszx+rxzsx     )
      ed( 26,2)=ed( 26,2)+bet*(pbz*xzzy0+wpz*xzzy1     +xszy+rxzsy     )
      ed( 27,2)=ed( 27,2)+bet*(pbz*xzzz0+wpz*xzzz1     +xszz+rxzsz+rxzz)
                          
      ed( 28,2)=ed( 28,2)+bet*(pby*xxxx0+wpy*xxxx1                     )
      ed( 29,2)=ed( 29,2)+bet*(pby*xxxy0+wpy*xxxy1                +rxxx)
      ed( 30,2)=ed( 30,2)+bet*(pby*xxxz0+wpy*xxxz1                     )
      ed( 31,2)=ed( 31,2)+bet*(pby*xxyx0+wpy*xxyx1          +rxxsx     )
      ed( 32,2)=ed( 32,2)+bet*(pbx*xyyy0+wpx*xyyy1+syyy                )
      ed( 33,2)=ed( 33,2)+bet*(pby*xxyz0+wpy*xxyz1          +rxxsz     )
      ed( 34,2)=ed( 34,2)+bet*(pby*xxzx0+wpy*xxzx1                     )
      ed( 35,2)=ed( 35,2)+bet*(pby*xxzy0+wpy*xxzy1                +rxxz)
      ed( 36,2)=ed( 36,2)+bet*(pby*xxzz0+wpy*xxzz1                     )
                          
      ed( 37,2)=ed( 37,2)+bet*(pbz*xxxx0+wpz*xxxx1                     )
      ed( 38,2)=ed( 38,2)+bet*(pbz*xxxy0+wpz*xxxy1                     )
      ed( 39,2)=ed( 39,2)+bet*(pbz*xxxz0+wpz*xxxz1                +rxxx)
      ed( 40,2)=ed( 40,2)+bet*(pbz*xxyx0+wpz*xxyx1                     )
      ed( 41,2)=ed( 41,2)+bet*(pbz*xxyy0+wpz*xxyy1                     )
      ed( 42,2)=ed( 42,2)+bet*(pbz*xxyz0+wpz*xxyz1                +rxxy)
      ed( 43,2)=ed( 43,2)+bet*(pbz*xxzx0+wpz*xxzx1          +rxxsx     )
      ed( 44,2)=ed( 44,2)+bet*(pbz*xxzy0+wpz*xxzy1          +rxxsy     )
      ed( 45,2)=ed( 45,2)+bet*(pbx*xzzz0+wpx*xzzz1+szzz                )
                          
      ed( 46,2)=ed( 46,2)+bet*(pbz*xyxx0+wpz*xyxx1                     )
      ed( 47,2)=ed( 47,2)+bet*(pbz*xyxy0+wpz*xyxy1                     )
      ed( 48,2)=ed( 48,2)+bet*(pby*xzxz0+wpy*xzxz1                     )
      ed( 49,2)=ed( 49,2)+bet*(pbz*xyyx0+wpz*xyyx1                     )
      ed( 50,2)=ed( 50,2)+bet*(pbz*xyyy0+wpz*xyyy1                     )
      ed( 51,2)=ed( 51,2)+bet*(pbz*xyyz0+wpz*xyyz1                +rxyy)
      ed( 52,2)=ed( 52,2)+bet*(pby*xzzx0+wpy*xzzx1                     )
      ed( 53,2)=ed( 53,2)+bet*(pbz*xyzy0+wpz*xyzy1          +rxysy     )
      ed( 54,2)=ed( 54,2)+bet*(pby*xzzz0+wpy*xzzz1                     )

      ed( 55,2)=ed( 55,2)+bet*(pbx*yxxx0+wpx*yxxx1     +ysxx+ryxsx+ryxx)
      ed( 56,2)=ed( 56,2)+bet*(pbx*yxxy0+wpx*yxxy1     +ysxy+ryxsy     )
      ed( 57,2)=ed( 57,2)+bet*(pbx*yxxz0+wpx*yxxz1     +ysxz+ryxsz     )
      ed( 58,2)=ed( 58,2)+bet*(pbx*yxyx0+wpx*yxyx1     +ysyx      +ryxy)
      ed( 59,2)=ed( 59,2)+bet*(pbx*yxyy0+wpx*yxyy1     +ysyy           )
      ed( 60,2)=ed( 60,2)+bet*(pbx*yxyz0+wpx*yxyz1     +ysyz           )
      ed( 61,2)=ed( 61,2)+bet*(pbx*yxzx0+wpx*yxzx1     +yszx      +ryxz)
      ed( 62,2)=ed( 62,2)+bet*(pbx*yxzy0+wpx*yxzy1     +yszy           )
      ed( 63,2)=ed( 63,2)+bet*(pbx*yxzz0+wpx*yxzz1     +yszz           )

      ed( 64,2)=ed( 64,2)+bet*(pby*yyxx0+wpy*yyxx1+syxx+ysxx           )
      ed( 65,2)=ed( 65,2)+bet*(pby*yyxy0+wpy*yyxy1+syxy+ysxy      +ryyx)
      ed( 66,2)=ed( 66,2)+bet*(pby*yyxz0+wpy*yyxz1+syxz+ysxz           )
      ed( 67,2)=ed( 67,2)+bet*(pby*yyyx0+wpy*yyyx1+syyx+ysyx+ryysx     )
      ed( 68,2)=ed( 68,2)+bet*(pby*yyyy0+wpy*yyyy1+syyy+ysyy+ryysy+ryyy)
      ed( 69,2)=ed( 69,2)+bet*(pby*yyyz0+wpy*yyyz1+syyz+ysyz+ryysz     )
      ed( 70,2)=ed( 70,2)+bet*(pby*yyzx0+wpy*yyzx1+syzx+yszx           )
      ed( 71,2)=ed( 71,2)+bet*(pby*yyzy0+wpy*yyzy1+syzy+yszy      +ryyz)
      ed( 72,2)=ed( 72,2)+bet*(pby*yyzz0+wpy*yyzz1+syzz+yszz           )
                          
      ed( 73,2)=ed( 73,2)+bet*(pbz*yzxx0+wpz*yzxx1     +ysxx           )
      ed( 74,2)=ed( 74,2)+bet*(pbz*yzxy0+wpz*yzxy1     +ysxy           )
      ed( 75,2)=ed( 75,2)+bet*(pbz*yzxz0+wpz*yzxz1     +ysxz      +ryzx)
      ed( 76,2)=ed( 76,2)+bet*(pbz*yzyx0+wpz*yzyx1     +ysyx           )
      ed( 77,2)=ed( 77,2)+bet*(pbz*yzyy0+wpz*yzyy1     +ysyy           )
      ed( 78,2)=ed( 78,2)+bet*(pbz*yzyz0+wpz*yzyz1     +ysyz      +ryzy)
      ed( 79,2)=ed( 79,2)+bet*(pbz*yzzx0+wpz*yzzx1     +yszx+ryzsx     )
      ed( 80,2)=ed( 80,2)+bet*(pbz*yzzy0+wpz*yzzy1     +yszy+ryzsy     )
      ed( 81,2)=ed( 81,2)+bet*(pbz*yzzz0+wpz*yzzz1     +yszz+ryzsz+ryzz)
                          
      ed( 82,2)=ed( 82,2)+bet*(pby*yxxx0+wpy*yxxx1+sxxx                )
      ed( 83,2)=ed( 83,2)+bet*(pbx*yyxy0+wpx*yyxy1          +ryysy     )
      ed( 84,2)=ed( 84,2)+bet*(pby*yxxz0+wpy*yxxz1+sxxz                )
      ed( 85,2)=ed( 85,2)+bet*(pbx*yyyx0+wpx*yyyx1                +ryyy)
      ed( 86,2)=ed( 86,2)+bet*(pbx*yyyy0+wpx*yyyy1                     )
      ed( 87,2)=ed( 87,2)+bet*(pbx*yyyz0+wpx*yyyz1                     )
      ed( 88,2)=ed( 88,2)+bet*(pbx*yyzx0+wpx*yyzx1                +ryyz)
      ed( 89,2)=ed( 89,2)+bet*(pbx*yyzy0+wpx*yyzy1                     )
      ed( 90,2)=ed( 90,2)+bet*(pbx*yyzz0+wpx*yyzz1                     )

      ed( 91,2)=ed( 91,2)+bet*(pbz*yxxx0+wpz*yxxx1                     )
      ed( 92,2)=ed( 92,2)+bet*(pbz*yxxy0+wpz*yxxy1                     )
      ed( 93,2)=ed( 93,2)+bet*(pbz*yxxz0+wpz*yxxz1                +ryxx)
      ed( 94,2)=ed( 94,2)+bet*(pbz*yxyx0+wpz*yxyx1                     )
      ed( 95,2)=ed( 95,2)+bet*(pbz*yxyy0+wpz*yxyy1                     )
      ed( 96,2)=ed( 96,2)+bet*(pbx*yzyz0+wpx*yzyz1                     )
      ed( 97,2)=ed( 97,2)+bet*(pbz*yxzx0+wpz*yxzx1          +ryxsx     )
      ed( 98,2)=ed( 98,2)+bet*(pbx*yzzy0+wpx*yzzy1                     )
      ed( 99,2)=ed( 99,2)+bet*(pbx*yzzz0+wpx*yzzz1                     )

      ed(100,2)=ed(100,2)+bet*(pbz*yyxx0+wpz*yyxx1                     )
      ed(101,2)=ed(101,2)+bet*(pbz*yyxy0+wpz*yyxy1                     )
      ed(102,2)=ed(102,2)+bet*(pbz*yyxz0+wpz*yyxz1                +ryyx)
      ed(103,2)=ed(103,2)+bet*(pbz*yyyx0+wpz*yyyx1                     )
      ed(104,2)=ed(104,2)+bet*(pbz*yyyy0+wpz*yyyy1                     )
      ed(105,2)=ed(105,2)+bet*(pbz*yyyz0+wpz*yyyz1                +ryyy)
      ed(106,2)=ed(106,2)+bet*(pby*yzzx0+wpy*yzzx1+szzx                )
      ed(107,2)=ed(107,2)+bet*(pbz*yyzy0+wpz*yyzy1          +ryysy     )
      ed(108,2)=ed(108,2)+bet*(pby*yzzz0+wpy*yzzz1+szzz                )
                          
      ed(109,2)=ed(109,2)+bet*(pbx*zxxx0+wpx*zxxx1     +zsxx+rzxsx+rzxx)
      ed(110,2)=ed(110,2)+bet*(pbx*zxxy0+wpx*zxxy1     +zsxy+rzxsy     )
      ed(111,2)=ed(111,2)+bet*(pbx*zxxz0+wpx*zxxz1     +zsxz+rzxsz     )
      ed(112,2)=ed(112,2)+bet*(pbx*zxyx0+wpx*zxyx1     +zsyx      +rzxy)
      ed(113,2)=ed(113,2)+bet*(pbx*zxyy0+wpx*zxyy1     +zsyy           )
      ed(114,2)=ed(114,2)+bet*(pbx*zxyz0+wpx*zxyz1     +zsyz           )
      ed(115,2)=ed(115,2)+bet*(pbx*zxzx0+wpx*zxzx1     +zszx      +rzxz)
      ed(116,2)=ed(116,2)+bet*(pbx*zxzy0+wpx*zxzy1     +zszy           )
      ed(117,2)=ed(117,2)+bet*(pbx*zxzz0+wpx*zxzz1     +zszz           )
                          
      ed(118,2)=ed(118,2)+bet*(pby*zyxx0+wpy*zyxx1     +zsxx           )
      ed(119,2)=ed(119,2)+bet*(pby*zyxy0+wpy*zyxy1     +zsxy      +rzyx)
      ed(120,2)=ed(120,2)+bet*(pby*zyxz0+wpy*zyxz1     +zsxz           )
      ed(121,2)=ed(121,2)+bet*(pby*zyyx0+wpy*zyyx1     +zsyx+rzysx     )
      ed(122,2)=ed(122,2)+bet*(pby*zyyy0+wpy*zyyy1     +zsyy+rzysy+rzyy)
      ed(123,2)=ed(123,2)+bet*(pby*zyyz0+wpy*zyyz1     +zsyz+rzysz     )
      ed(124,2)=ed(124,2)+bet*(pby*zyzx0+wpy*zyzx1     +zszx           )
      ed(125,2)=ed(125,2)+bet*(pby*zyzy0+wpy*zyzy1     +zszy      +rzyz)
      ed(126,2)=ed(126,2)+bet*(pby*zyzz0+wpy*zyzz1     +zszz           )
                          
      ed(127,2)=ed(127,2)+bet*(pbz*zzxx0+wpz*zzxx1+szxx+zsxx           )
      ed(128,2)=ed(128,2)+bet*(pbz*zzxy0+wpz*zzxy1+szxy+zsxy           )
      ed(129,2)=ed(129,2)+bet*(pbz*zzxz0+wpz*zzxz1+szxz+zsxz      +rzzx)
      ed(130,2)=ed(130,2)+bet*(pbz*zzyx0+wpz*zzyx1+szyx+zsyx           )
      ed(131,2)=ed(131,2)+bet*(pbz*zzyy0+wpz*zzyy1+szyy+zsyy           )
      ed(132,2)=ed(132,2)+bet*(pbz*zzyz0+wpz*zzyz1+szyz+zsyz      +rzzy)
      ed(133,2)=ed(133,2)+bet*(pbz*zzzx0+wpz*zzzx1+szzx+zszx+rzzsx     )
      ed(134,2)=ed(134,2)+bet*(pbz*zzzy0+wpz*zzzy1+szzy+zszy+rzzsy     )
      ed(135,2)=ed(135,2)+bet*(pbz*zzzz0+wpz*zzzz1+szzz+zszz+rzzsz+rzzz)
                          
      ed(136,2)=ed(136,2)+bet*(pby*zxxx0+wpy*zxxx1                     )
      ed(137,2)=ed(137,2)+bet*(pby*zxxy0+wpy*zxxy1                +rzxx)
      ed(138,2)=ed(138,2)+bet*(pby*zxxz0+wpy*zxxz1                     )
      ed(139,2)=ed(139,2)+bet*(pby*zxyx0+wpy*zxyx1          +rzxsx     )
      ed(140,2)=ed(140,2)+bet*(pbx*zyyy0+wpx*zyyy1                     )
      ed(141,2)=ed(141,2)+bet*(pbx*zyyz0+wpx*zyyz1                     )
      ed(142,2)=ed(142,2)+bet*(pby*zxzx0+wpy*zxzx1                     )
      ed(143,2)=ed(143,2)+bet*(pbx*zyzy0+wpx*zyzy1                     )
      ed(144,2)=ed(144,2)+bet*(pby*zxzz0+wpy*zxzz1                     )
                          
      ed(145,2)=ed(145,2)+bet*(pbz*zxxx0+wpz*zxxx1+sxxx                )
      ed(146,2)=ed(146,2)+bet*(pbz*zxxy0+wpz*zxxy1+sxxy                )
      ed(147,2)=ed(147,2)+bet*(pbx*zzxz0+wpx*zzxz1          +rzzsz     )
      ed(148,2)=ed(148,2)+bet*(pbz*zxyx0+wpz*zxyx1+sxyx                )
      ed(149,2)=ed(149,2)+bet*(pbx*zzyy0+wpx*zzyy1                     )
      ed(150,2)=ed(150,2)+bet*(pbx*zzyz0+wpx*zzyz1                     )
      ed(151,2)=ed(151,2)+bet*(pbx*zzzx0+wpx*zzzx1                +rzzz)
      ed(152,2)=ed(152,2)+bet*(pbx*zzzy0+wpx*zzzy1                     )
      ed(153,2)=ed(153,2)+bet*(pbx*zzzz0+wpx*zzzz1                     )
                          
      ed(154,2)=ed(154,2)+bet*(pby*zzxx0+wpy*zzxx1                     )
      ed(155,2)=ed(155,2)+bet*(pbz*zyxy0+wpz*zyxy1+syxy                )
      ed(156,2)=ed(156,2)+bet*(pby*zzxz0+wpy*zzxz1                     )
      ed(157,2)=ed(157,2)+bet*(pbz*zyyx0+wpz*zyyx1+syyx                )
      ed(158,2)=ed(158,2)+bet*(pbz*zyyy0+wpz*zyyy1+syyy                )
      ed(159,2)=ed(159,2)+bet*(pby*zzyz0+wpy*zzyz1          +rzzsz     )
      ed(160,2)=ed(160,2)+bet*(pby*zzzx0+wpy*zzzx1                     )
      ed(161,2)=ed(161,2)+bet*(pby*zzzy0+wpy*zzzy1                +rzzz)
      ed(162,2)=ed(162,2)+bet*(pby*zzzz0+wpy*zzzz1                     )
!ppdp
      ed(  1,3)=ed(  1,3)+ram*(qcx*xxxx0+wqx*xxxx1+rsxxx+rxsxx+xxsx+xxx)
      ed(  2,3)=ed(  2,3)+ram*(qcx*xxxy0+wqx*xxxy1+rsxxy+rxsxy+xxsy    )
      ed(  3,3)=ed(  3,3)+ram*(qcx*xxxz0+wqx*xxxz1+rsxxz+rxsxz+xxsz    )
      ed(  4,3)=ed(  4,3)+ram*(qcy*xxyx0+wqy*xxyx1            +xxsx    )
      ed(  5,3)=ed(  5,3)+ram*(qcy*xxyy0+wqy*xxyy1            +xxsy+xxy)
      ed(  6,3)=ed(  6,3)+ram*(qcy*xxyz0+wqy*xxyz1            +xxsz    )
      ed(  7,3)=ed(  7,3)+ram*(qcz*xxzx0+wqz*xxzx1            +xxsx    )
      ed(  8,3)=ed(  8,3)+ram*(qcz*xxzy0+wqz*xxzy1            +xxsy    )
      ed(  9,3)=ed(  9,3)+ram*(qcz*xxzz0+wqz*xxzz1            +xxsz+xxz)
                         
      ed( 10,3)=ed( 10,3)+ram*(qcy*xxxx0+wqy*xxxx1                     )
      ed( 11,3)=ed( 11,3)+ram*(qcy*xxxy0+wqy*xxxy1                 +xxx)
      ed( 12,3)=ed( 12,3)+ram*(qcy*xxxz0+wqy*xxxz1                     )
      ed( 13,3)=ed( 13,3)+ram*(qcz*xxxx0+wqz*xxxx1                     )
      ed( 14,3)=ed( 14,3)+ram*(qcz*xxxy0+wqz*xxxy1                     )
      ed( 15,3)=ed( 15,3)+ram*(qcz*xxxz0+wqz*xxxz1                 +xxx)
      ed( 16,3)=ed( 16,3)+ram*(qcz*xxyx0+wqz*xxyx1                     )
      ed( 17,3)=ed( 17,3)+ram*(qcz*xxyy0+wqz*xxyy1                     )
      ed( 18,3)=ed( 18,3)+ram*(qcy*xxzz0+wqy*xxzz1                     )
                         
      ed( 19,3)=ed( 19,3)+ram*(qcx*xyxx0+wqx*xyxx1+rsyxx      +xysx+xyx)
      ed( 20,3)=ed( 20,3)+ram*(qcx*xyxy0+wqx*xyxy1+rsyxy      +xysy    )
      ed( 21,3)=ed( 21,3)+ram*(qcx*xyxz0+wqx*xyxz1+rsyxz      +xysz    )
      ed( 22,3)=ed( 22,3)+ram*(qcy*xyyx0+wqy*xyyx1      +rxsyx+xysx    )
      ed( 23,3)=ed( 23,3)+ram*(qcy*xyyy0+wqy*xyyy1      +rxsyy+xysy+xyy)
      ed( 24,3)=ed( 24,3)+ram*(qcy*xyyz0+wqy*xyyz1      +rxsyz+xysz    )
      ed( 25,3)=ed( 25,3)+ram*(qcz*xyzx0+wqz*xyzx1            +xysx    )
      ed( 26,3)=ed( 26,3)+ram*(qcz*xyzy0+wqz*xyzy1            +xysy    )
      ed( 27,3)=ed( 27,3)+ram*(qcz*xyzz0+wqz*xyzz1           +xysz+exyz)

      ed( 28,3)=ed( 28,3)+ram*(qcy*xyxx0+wqy*xyxx1      +rxsxx         )
      ed( 29,3)=ed( 29,3)+ram*(qcx*xyyy0+wqx*xyyy1+rsyyy               )
      ed( 30,3)=ed( 30,3)+ram*(qcy*xyxz0+wqy*xyxz1      +rxsxz         )
      ed( 31,3)=ed( 31,3)+ram*(qcz*xyxx0+wqz*xyxx1                     )
      ed( 32,3)=ed( 32,3)+ram*(qcz*xyxy0+wqz*xyxy1                     )
      ed( 33,3)=ed( 33,3)+ram*(qcz*xyxz0+wqz*xyxz1                 +xyx)
      ed( 34,3)=ed( 34,3)+ram*(qcz*xyyx0+wqz*xyyx1                     )
      ed( 35,3)=ed( 35,3)+ram*(qcz*xyyy0+wqz*xyyy1                     )
      ed( 36,3)=ed( 36,3)+ram*(qcz*xyyz0+wqz*xyyz1                 +xyy)
                         
      ed( 37,3)=ed( 37,3)+ram*(qcx*xzxx0+wqx*xzxx1+rszxx      +xzsx+xzx)
      ed( 38,3)=ed( 38,3)+ram*(qcx*xzxy0+wqx*xzxy1+rszxy      +xzsy    )
      ed( 39,3)=ed( 39,3)+ram*(qcx*xzxz0+wqx*xzxz1+rszxz      +xzsz    )
      ed( 40,3)=ed( 40,3)+ram*(qcy*xzyx0+wqy*xzyx1            +xzsx    )
      ed( 41,3)=ed( 41,3)+ram*(qcy*xzyy0+wqy*xzyy1            +xzsy+xzy)
      ed( 42,3)=ed( 42,3)+ram*(qcy*xzyz0+wqy*xzyz1            +xzsz    )
      ed( 43,3)=ed( 43,3)+ram*(qcz*xzzx0+wqz*xzzx1      +rxszx+xzsx    )
      ed( 44,3)=ed( 44,3)+ram*(qcz*xzzy0+wqz*xzzy1      +rxszy+xzsy    )
      ed( 45,3)=ed( 45,3)+ram*(qcz*xzzz0+wqz*xzzz1      +rxszz+xzsz+xzz)
                         
      ed( 46,3)=ed( 46,3)+ram*(qcy*xzxx0+wqy*xzxx1                     )
      ed( 47,3)=ed( 47,3)+ram*(qcy*xzxy0+wqy*xzxy1                 +xzx)
      ed( 48,3)=ed( 48,3)+ram*(qcy*xzxz0+wqy*xzxz1                     )
      ed( 49,3)=ed( 49,3)+ram*(qcz*xzxx0+wqz*xzxx1      +rxsxx         )
      ed( 50,3)=ed( 50,3)+ram*(qcz*xzxy0+wqz*xzxy1      +rxsxy         )
      ed( 51,3)=ed( 51,3)+ram*(qcx*xzzz0+wqx*xzzz1+rszzz               )
      ed( 52,3)=ed( 52,3)+ram*(qcy*xzzx0+wqy*xzzx1                     )
      ed( 53,3)=ed( 53,3)+ram*(qcz*xzyy0+wqz*xzyy1      +rxsyy         )
      ed( 54,3)=ed( 54,3)+ram*(qcy*xzzz0+wqy*xzzz1                     )
                         
      ed( 55,3)=ed( 55,3)+ram*(qcx*yxxx0+wqx*yxxx1      +rysxx+yxsx+yxx)
      ed( 56,3)=ed( 56,3)+ram*(qcx*yxxy0+wqx*yxxy1      +rysxy+yxsy    )
      ed( 57,3)=ed( 57,3)+ram*(qcx*yxxz0+wqx*yxxz1      +rysxz+yxsz    )
      ed( 58,3)=ed( 58,3)+ram*(qcy*yxyx0+wqy*yxyx1+rsxyx      +yxsx    )
      ed( 59,3)=ed( 59,3)+ram*(qcy*yxyy0+wqy*yxyy1+rsxyy      +yxsy+yxy)
      ed( 60,3)=ed( 60,3)+ram*(qcy*yxyz0+wqy*yxyz1+rsxyz      +yxsz    )
      ed( 61,3)=ed( 61,3)+ram*(qcz*yxzx0+wqz*yxzx1            +yxsx    )
      ed( 62,3)=ed( 62,3)+ram*(qcz*yxzy0+wqz*yxzy1            +yxsy    )
      ed( 63,3)=ed( 63,3)+ram*(qcz*yxzz0+wqz*yxzz1            +yxsz+yxz)
                         
      ed( 64,3)=ed( 64,3)+ram*(qcy*yxxx0+wqy*yxxx1+rsxxx               )
      ed( 65,3)=ed( 65,3)+ram*(qcx*yxyy0+wqx*yxyy1      +rysyy         )
      ed( 66,3)=ed( 66,3)+ram*(qcy*yxxz0+wqy*yxxz1+rsxxz               )
      ed( 67,3)=ed( 67,3)+ram*(qcz*yxxx0+wqz*yxxx1                     )
      ed( 68,3)=ed( 68,3)+ram*(qcz*yxxy0+wqz*yxxy1                     )
      ed( 69,3)=ed( 69,3)+ram*(qcz*yxxz0+wqz*yxxz1                 +yxx)
      ed( 70,3)=ed( 70,3)+ram*(qcz*yxyx0+wqz*yxyx1                     )
      ed( 71,3)=ed( 71,3)+ram*(qcz*yxyy0+wqz*yxyy1                     )
      ed( 72,3)=ed( 72,3)+ram*(qcz*yxyz0+wqz*yxyz1                 +yxy)
                         
      ed( 73,3)=ed( 73,3)+ram*(qcx*yyxx0+wqx*yyxx1            +yysx+yyx)
      ed( 74,3)=ed( 74,3)+ram*(qcx*yyxy0+wqx*yyxy1            +yysy    )
      ed( 75,3)=ed( 75,3)+ram*(qcx*yyxz0+wqx*yyxz1            +yysz    )
      ed( 76,3)=ed( 76,3)+ram*(qcy*yyyx0+wqy*yyyx1+rsyyx+rysyx+yysx    )
      ed( 77,3)=ed( 77,3)+ram*(qcy*yyyy0+wqy*yyyy1+rsyyy+rysyy+yysy+yyy)
      ed( 78,3)=ed( 78,3)+ram*(qcy*yyyz0+wqy*yyyz1+rsyyz+rysyz+yysz    )
      ed( 79,3)=ed( 79,3)+ram*(qcz*yyzx0+wqz*yyzx1            +yysx    )
      ed( 80,3)=ed( 80,3)+ram*(qcz*yyzy0+wqz*yyzy1            +yysy    )
      ed( 81,3)=ed( 81,3)+ram*(qcz*yyzz0+wqz*yyzz1            +yysz+yyz)
                         
      ed( 82,3)=ed( 82,3)+ram*(qcx*yyyx0+wqx*yyyx1                 +yyy)
      ed( 83,3)=ed( 83,3)+ram*(qcx*yyyy0+wqx*yyyy1                     )
      ed( 84,3)=ed( 84,3)+ram*(qcx*yyyz0+wqx*yyyz1                     )
      ed( 85,3)=ed( 85,3)+ram*(qcz*yyxx0+wqz*yyxx1                     )
      ed( 86,3)=ed( 86,3)+ram*(qcz*yyxy0+wqz*yyxy1                     )
      ed( 87,3)=ed( 87,3)+ram*(qcx*yyzz0+wqx*yyzz1                     )
      ed( 88,3)=ed( 88,3)+ram*(qcz*yyyx0+wqz*yyyx1                     )
      ed( 89,3)=ed( 89,3)+ram*(qcz*yyyy0+wqz*yyyy1                     )
      ed( 90,3)=ed( 90,3)+ram*(qcz*yyyz0+wqz*yyyz1                 +yyy)
                         
      ed( 91,3)=ed( 91,3)+ram*(qcx*yzxx0+wqx*yzxx1            +yzsx+yzx)
      ed( 92,3)=ed( 92,3)+ram*(qcx*yzxy0+wqx*yzxy1            +yzsy    )
      ed( 93,3)=ed( 93,3)+ram*(qcx*yzxz0+wqx*yzxz1            +yzsz    )
      ed( 94,3)=ed( 94,3)+ram*(qcy*yzyx0+wqy*yzyx1+rszyx      +yzsx    )
      ed( 95,3)=ed( 95,3)+ram*(qcy*yzyy0+wqy*yzyy1+rszyy      +yzsy+yzy)
      ed( 96,3)=ed( 96,3)+ram*(qcy*yzyz0+wqy*yzyz1+rszyz      +yzsz    )
      ed( 97,3)=ed( 97,3)+ram*(qcz*yzzx0+wqz*yzzx1      +ryszx+yzsx    )
      ed( 98,3)=ed( 98,3)+ram*(qcz*yzzy0+wqz*yzzy1      +ryszy+yzsy    )
      ed( 99,3)=ed( 99,3)+ram*(qcz*yzzz0+wqz*yzzz1      +ryszz+yzsz+yzz)
                         
      ed(100,3)=ed(100,3)+ram*(qcy*yzxx0+wqy*yzxx1+rszxx               )
      ed(101,3)=ed(101,3)+ram*(qcx*yzyy0+wqx*yzyy1                     )
      ed(102,3)=ed(102,3)+ram*(qcx*yzyz0+wqx*yzyz1                     )
      ed(103,3)=ed(103,3)+ram*(qcz*yzxx0+wqz*yzxx1      +rysxx         )
      ed(104,3)=ed(104,3)+ram*(qcx*yzzy0+wqx*yzzy1                     )
      ed(105,3)=ed(105,3)+ram*(qcx*yzzz0+wqx*yzzz1                     )
      ed(106,3)=ed(106,3)+ram*(qcz*yzyx0+wqz*yzyx1      +rysyx         )
      ed(107,3)=ed(107,3)+ram*(qcz*yzyy0+wqz*yzyy1      +rysyy         )
      ed(108,3)=ed(108,3)+ram*(qcy*yzzz0+wqy*yzzz1+rszzz               )
                         
      ed(109,3)=ed(109,3)+ram*(qcx*zxxx0+wqx*zxxx1      +rzsxx+zxsx+zxx)
      ed(110,3)=ed(110,3)+ram*(qcx*zxxy0+wqx*zxxy1      +rzsxy+zxsy    )
      ed(111,3)=ed(111,3)+ram*(qcx*zxxz0+wqx*zxxz1      +rzsxz+zxsz    )
      ed(112,3)=ed(112,3)+ram*(qcy*zxyx0+wqy*zxyx1            +zxsx    )
      ed(113,3)=ed(113,3)+ram*(qcy*zxyy0+wqy*zxyy1            +zxsy+zxy)
      ed(114,3)=ed(114,3)+ram*(qcy*zxyz0+wqy*zxyz1            +zxsz    )
      ed(115,3)=ed(115,3)+ram*(qcz*zxzx0+wqz*zxzx1+rsxzx      +zxsx    )
      ed(116,3)=ed(116,3)+ram*(qcz*zxzy0+wqz*zxzy1+rsxzy      +zxsy    )
      ed(117,3)=ed(117,3)+ram*(qcz*zxzz0+wqz*zxzz1+rsxzz      +zxsz+zxz)
                         
      ed(118,3)=ed(118,3)+ram*(qcy*zxxx0+wqy*zxxx1                     )
      ed(119,3)=ed(119,3)+ram*(qcy*zxxy0+wqy*zxxy1                 +zxx)
      ed(120,3)=ed(120,3)+ram*(qcy*zxxz0+wqy*zxxz1                     )
      ed(121,3)=ed(121,3)+ram*(qcz*zxxx0+wqz*zxxx1+rsxxx               )
      ed(122,3)=ed(122,3)+ram*(qcz*zxxy0+wqz*zxxy1+rsxxy               )
      ed(123,3)=ed(123,3)+ram*(qcx*zxzz0+wqx*zxzz1      +rzszz         )
      ed(124,3)=ed(124,3)+ram*(qcy*zxzx0+wqy*zxzx1                     )
      ed(125,3)=ed(125,3)+ram*(qcz*zxyy0+wqz*zxyy1+rsxyy               )
      ed(126,3)=ed(126,3)+ram*(qcy*zxzz0+wqy*zxzz1                     )
                         
      ed(127,3)=ed(127,3)+ram*(qcx*zyxx0+wqx*zyxx1            +zysx+zyx)
      ed(128,3)=ed(128,3)+ram*(qcx*zyxy0+wqx*zyxy1            +zysy    )
      ed(129,3)=ed(129,3)+ram*(qcx*zyxz0+wqx*zyxz1            +zysz    )
      ed(130,3)=ed(130,3)+ram*(qcy*zyyx0+wqy*zyyx1      +rzsyx+zysx    )
      ed(131,3)=ed(131,3)+ram*(qcy*zyyy0+wqy*zyyy1      +rzsyy+zysy+zyy)
      ed(132,3)=ed(132,3)+ram*(qcy*zyyz0+wqy*zyyz1      +rzsyz+zysz    )
      ed(133,3)=ed(133,3)+ram*(qcz*zyzx0+wqz*zyzx1+rsyzx      +zysx    )
      ed(134,3)=ed(134,3)+ram*(qcz*zyzy0+wqz*zyzy1+rsyzy      +zysy    )
      ed(135,3)=ed(135,3)+ram*(qcz*zyzz0+wqz*zyzz1+rsyzz      +zysz+zyz)
                         
      ed(136,3)=ed(136,3)+ram*(qcy*zyxx0+wqy*zyxx1      +rzsxx         )
      ed(137,3)=ed(137,3)+ram*(qcx*zyyy0+wqx*zyyy1                     )
      ed(138,3)=ed(138,3)+ram*(qcx*zyyz0+wqx*zyyz1                     )
      ed(139,3)=ed(139,3)+ram*(qcz*zyxx0+wqz*zyxx1+rsyxx               )
      ed(140,3)=ed(140,3)+ram*(qcx*zyzy0+wqx*zyzy1                     )
      ed(141,3)=ed(141,3)+ram*(qcx*zyzz0+wqx*zyzz1                     )
      ed(142,3)=ed(142,3)+ram*(qcz*zyyx0+wqz*zyyx1+rsyyx               )
      ed(143,3)=ed(143,3)+ram*(qcz*zyyy0+wqz*zyyy1+rsyyy               )
      ed(144,3)=ed(144,3)+ram*(qcz*zyyz0+wqz*zyyz1+rsyyz           +zyy)
                         
      ed(145,3)=ed(145,3)+ram*(qcx*zzxx0+wqx*zzxx1            +zzsx+zzx)
      ed(146,3)=ed(146,3)+ram*(qcx*zzxy0+wqx*zzxy1            +zzsy    )
      ed(147,3)=ed(147,3)+ram*(qcx*zzxz0+wqx*zzxz1            +zzsz    )
      ed(148,3)=ed(148,3)+ram*(qcy*zzyx0+wqy*zzyx1            +zzsx    )
      ed(149,3)=ed(149,3)+ram*(qcy*zzyy0+wqy*zzyy1            +zzsy+zzy)
      ed(150,3)=ed(150,3)+ram*(qcy*zzyz0+wqy*zzyz1            +zzsz    )
      ed(151,3)=ed(151,3)+ram*(qcz*zzzx0+wqz*zzzx1+rszzx+rzszx+zzsx    )
      ed(152,3)=ed(152,3)+ram*(qcz*zzzy0+wqz*zzzy1+rszzy+rzszy+zzsy    )
      ed(153,3)=ed(153,3)+ram*(qcz*zzzz0+wqz*zzzz1+rszzz+rzszz+zzsz+zzz)
                         
      ed(154,3)=ed(154,3)+ram*(qcy*zzxx0+wqy*zzxx1                     )
      ed(155,3)=ed(155,3)+ram*(qcx*zzyy0+wqx*zzyy1                     )
      ed(156,3)=ed(156,3)+ram*(qcx*zzyz0+wqx*zzyz1                     )
      ed(157,3)=ed(157,3)+ram*(qcx*zzzx0+wqx*zzzx1                 +zzz)
      ed(158,3)=ed(158,3)+ram*(qcx*zzzy0+wqx*zzzy1                     )
      ed(159,3)=ed(159,3)+ram*(qcx*zzzz0+wqx*zzzz1                     )
      ed(160,3)=ed(160,3)+ram*(qcy*zzzx0+wqy*zzzx1                     )
      ed(161,3)=ed(161,3)+ram*(qcy*zzzy0+wqy*zzzy1                 +zzz)
      ed(162,3)=ed(162,3)+ram*(qcy*zzzz0+wqy*zzzz1                     )

                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
#endif
!dppp
      ec(  1,1)=ed(  1,1) - sxxx00
      ec(  2,1)=ed( 82,1)
      ec(  3,1)=ed(109,1)
      ec(  4,1)=ed(  2,1) - sxxy00
      ec(  5,1)=ed( 83,1)
      ec(  6,1)=ed(110,1)
      ec(  7,1)=ed(  3,1) - sxxz00
      ec(  8,1)=ed( 84,1)
      ec(  9,1)=ed(111,1)
      ec( 10,1)=ed(  4,1) - sxyx00
      ec( 11,1)=ed( 85,1)
      ec( 12,1)=ed(112,1)
      ec( 13,1)=ed(  5,1) - sxyy00
      ec( 14,1)=ed( 86,1)
      ec( 15,1)=ed(113,1)
      ec( 16,1)=ed(  6,1) - sxyz00
      ec( 17,1)=ed( 87,1)
      ec( 18,1)=ed(114,1)
      ec( 19,1)=ed(  7,1) - sxzx00
      ec( 20,1)=ed( 88,1)
      ec( 21,1)=ed(115,1)
      ec( 22,1)=ed(  8,1) - sxzy00
      ec( 23,1)=ed( 89,1)
      ec( 24,1)=ed(116,1)
      ec( 25,1)=ed(  9,1) - sxzz00
      ec( 26,1)=ed( 90,1)
      ec( 27,1)=ed(117,1)

      ec( 28,1)=ed( 10,1) - syxx00
      ec( 29,1)=ed( 91,1)
      ec( 30,1)=ed(118,1)
      ec( 31,1)=ed( 11,1) - syxy00
      ec( 32,1)=ed( 92,1)
      ec( 33,1)=ed(119,1)
      ec( 34,1)=ed( 12,1) - syxz00
      ec( 35,1)=ed( 93,1)
      ec( 36,1)=ed(120,1)
      ec( 37,1)=ed( 13,1) - syyx00
      ec( 38,1)=ed( 94,1)
      ec( 39,1)=ed(121,1)
      ec( 40,1)=ed( 14,1) - syyy00
      ec( 41,1)=ed( 95,1)
      ec( 42,1)=ed(122,1)
      ec( 43,1)=ed( 15,1) - syyz00
      ec( 44,1)=ed( 96,1)
      ec( 45,1)=ed(123,1)
      ec( 46,1)=ed( 16,1) - syzx00
      ec( 47,1)=ed( 97,1)
      ec( 48,1)=ed(124,1)
      ec( 49,1)=ed( 17,1) - syzy00
      ec( 50,1)=ed( 98,1)
      ec( 51,1)=ed(125,1)
      ec( 52,1)=ed( 18,1) - syzz00
      ec( 53,1)=ed( 99,1)
      ec( 54,1)=ed(126,1)
                      
      ec( 55,1)=ed( 19,1) - szxx00
      ec( 56,1)=ed(100,1)
      ec( 57,1)=ed(127,1)
      ec( 58,1)=ed( 20,1) - szxy00
      ec( 59,1)=ed(101,1)
      ec( 60,1)=ed(128,1)
      ec( 61,1)=ed( 21,1) - szxz00
      ec( 62,1)=ed(102,1)
      ec( 63,1)=ed(129,1)
      ec( 64,1)=ed( 22,1) - szyx00
      ec( 65,1)=ed(103,1)
      ec( 66,1)=ed(130,1)
      ec( 67,1)=ed( 23,1) - szyy00
      ec( 68,1)=ed(104,1)
      ec( 69,1)=ed(131,1)
      ec( 70,1)=ed( 24,1) - szyz00
      ec( 71,1)=ed(105,1)
      ec( 72,1)=ed(132,1)
      ec( 73,1)=ed( 25,1) - szzx00
      ec( 74,1)=ed(106,1)
      ec( 75,1)=ed(133,1)
      ec( 76,1)=ed( 26,1) - szzy00
      ec( 77,1)=ed(107,1)
      ec( 78,1)=ed(134,1)
      ec( 79,1)=ed( 27,1) - szzz00
      ec( 80,1)=ed(108,1)
      ec( 81,1)=ed(135,1)

      ec( 82,1)=ed( 82,1)
      ec( 83,1)=ed( 28,1) - sxxx00
      ec( 84,1)=ed(136,1)
      ec( 85,1)=ed( 83,1)
      ec( 86,1)=ed( 29,1) - sxxy00
      ec( 87,1)=ed(137,1)
      ec( 88,1)=ed( 84,1)
      ec( 89,1)=ed( 30,1) - sxxz00
      ec( 90,1)=ed(138,1)
      ec( 91,1)=ed( 85,1)
      ec( 92,1)=ed( 31,1) - sxyx00
      ec( 93,1)=ed(139,1)
      ec( 94,1)=ed( 86,1)
      ec( 95,1)=ed( 32,1) - sxyy00
      ec( 96,1)=ed(140,1)
      ec( 97,1)=ed( 87,1)
      ec( 98,1)=ed( 33,1) - sxyz00
      ec( 99,1)=ed(141,1)
      ec(100,1)=ed( 88,1)
      ec(101,1)=ed( 34,1) - sxzx00
      ec(102,1)=ed(142,1)
      ec(103,1)=ed( 89,1)
      ec(104,1)=ed( 35,1) - sxzy00
      ec(105,1)=ed(143,1)
      ec(106,1)=ed( 90,1)
      ec(107,1)=ed( 36,1) - sxzz00
      ec(108,1)=ed(144,1)
                         
      ec(109,1)=ed( 91,1)         
      ec(110,1)=ed( 37,1) - syxx00
      ec(111,1)=ed(145,1)
      ec(112,1)=ed( 92,1)
      ec(113,1)=ed( 38,1) - syxy00
      ec(114,1)=ed(146,1)
      ec(115,1)=ed( 93,1)
      ec(116,1)=ed( 39,1) - syxz00
      ec(117,1)=ed(147,1)
      ec(118,1)=ed( 94,1)
      ec(119,1)=ed( 40,1) - syyx00
      ec(120,1)=ed(148,1)
      ec(121,1)=ed( 95,1)
      ec(122,1)=ed( 41,1) - syyy00
      ec(123,1)=ed(149,1)
      ec(124,1)=ed( 96,1)
      ec(125,1)=ed( 42,1) - syyz00
      ec(126,1)=ed(150,1)
      ec(127,1)=ed( 97,1)
      ec(128,1)=ed( 43,1) - syzx00
      ec(129,1)=ed(151,1)
      ec(130,1)=ed( 98,1)
      ec(131,1)=ed( 44,1) - syzy00
      ec(132,1)=ed(152,1)
      ec(133,1)=ed( 99,1)
      ec(134,1)=ed( 45,1) - syzz00
      ec(135,1)=ed(153,1)
                         
      ec(136,1)=ed(100,1)         
      ec(137,1)=ed( 46,1) - szxx00
      ec(138,1)=ed(154,1)
      ec(139,1)=ed(101,1)
      ec(140,1)=ed( 47,1) - szxy00
      ec(141,1)=ed(155,1)
      ec(142,1)=ed(102,1)
      ec(143,1)=ed( 48,1) - szxz00
      ec(144,1)=ed(156,1)
      ec(145,1)=ed(103,1)
      ec(146,1)=ed( 49,1) - szyx00
      ec(147,1)=ed(157,1)
      ec(148,1)=ed(104,1)
      ec(149,1)=ed( 50,1) - szyy00
      ec(150,1)=ed(158,1)
      ec(151,1)=ed(105,1)
      ec(152,1)=ed( 51,1) - szyz00
      ec(153,1)=ed(159,1)
      ec(154,1)=ed(106,1)
      ec(155,1)=ed( 52,1) - szzx00
      ec(156,1)=ed(160,1)
      ec(157,1)=ed(107,1)
      ec(158,1)=ed( 53,1) - szzy00
      ec(159,1)=ed(161,1)
      ec(160,1)=ed(108,1)
      ec(161,1)=ed( 54,1) - szzz00
      ec(162,1)=ed(162,1)

      ec(163,1)=ed(109,1)
      ec(164,1)=ed(136,1)
      ec(165,1)=ed( 55,1) - sxxx00
      ec(166,1)=ed(110,1)
      ec(167,1)=ed(137,1)
      ec(168,1)=ed( 56,1) - sxxy00
      ec(169,1)=ed(111,1)
      ec(170,1)=ed(138,1)
      ec(171,1)=ed( 57,1) - sxxz00
      ec(172,1)=ed(112,1)
      ec(173,1)=ed(139,1)
      ec(174,1)=ed( 58,1) - sxyx00
      ec(175,1)=ed(113,1)
      ec(176,1)=ed(140,1)
      ec(177,1)=ed( 59,1) - sxyy00
      ec(178,1)=ed(114,1)
      ec(179,1)=ed(141,1)
      ec(180,1)=ed( 60,1) - sxyz00
      ec(181,1)=ed(115,1)
      ec(182,1)=ed(142,1)
      ec(183,1)=ed( 61,1) - sxzx00
      ec(184,1)=ed(116,1)
      ec(185,1)=ed(143,1)
      ec(186,1)=ed( 62,1) - sxzy00
      ec(187,1)=ed(117,1)
      ec(188,1)=ed(144,1)
      ec(189,1)=ed( 63,1) - sxzz00
                         
      ec(190,1)=ed(118,1)
      ec(191,1)=ed(145,1)         
      ec(192,1)=ed( 64,1) - syxx00
      ec(193,1)=ed(119,1)
      ec(194,1)=ed(146,1)
      ec(195,1)=ed( 65,1) - syxy00
      ec(196,1)=ed(120,1)
      ec(197,1)=ed(147,1)
      ec(198,1)=ed( 66,1) - syxz00
      ec(199,1)=ed(121,1)
      ec(200,1)=ed(148,1)
      ec(201,1)=ed( 67,1) - syyx00
      ec(202,1)=ed(122,1)
      ec(203,1)=ed(149,1)
      ec(204,1)=ed( 68,1) - syyy00
      ec(205,1)=ed(123,1)
      ec(206,1)=ed(150,1)
      ec(207,1)=ed( 69,1) - syyz00
      ec(208,1)=ed(124,1)
      ec(209,1)=ed(151,1)
      ec(210,1)=ed( 70,1) - syzx00
      ec(211,1)=ed(125,1)
      ec(212,1)=ed(152,1)
      ec(213,1)=ed( 71,1) - syzy00
      ec(214,1)=ed(126,1)
      ec(215,1)=ed(153,1)
      ec(216,1)=ed( 72,1) - syzz00
                         
      ec(217,1)=ed(127,1)
      ec(218,1)=ed(154,1)         
      ec(219,1)=ed( 73,1) - szxx00
      ec(220,1)=ed(128,1)
      ec(221,1)=ed(155,1)
      ec(222,1)=ed( 74,1) - szxy00
      ec(223,1)=ed(129,1)
      ec(224,1)=ed(156,1)
      ec(225,1)=ed( 75,1) - szxz00
      ec(226,1)=ed(130,1)
      ec(227,1)=ed(157,1)
      ec(228,1)=ed( 76,1) - szyx00
      ec(229,1)=ed(131,1)
      ec(230,1)=ed(158,1)
      ec(231,1)=ed( 77,1) - szyy00
      ec(232,1)=ed(132,1)
      ec(233,1)=ed(159,1)
      ec(234,1)=ed( 78,1) - szyz00
      ec(235,1)=ed(133,1)
      ec(236,1)=ed(160,1)
      ec(237,1)=ed( 79,1) - szzx00
      ec(238,1)=ed(134,1)
      ec(239,1)=ed(161,1)
      ec(240,1)=ed( 80,1) - szzy00
      ec(241,1)=ed(135,1)
      ec(242,1)=ed(162,1)
      ec(243,1)=ed( 81,1) - szzz00
!pdpp
      ec(  1,2)=ed(  1,2) - xsxx00
      ec(  2,2)=ed( 28,2)     
      ec(  3,2)=ed( 37,2)
      ec(  4,2)=ed(  2,2) - xsxy00
      ec(  5,2)=ed( 29,2)     
      ec(  6,2)=ed( 38,2)     
      ec(  7,2)=ed(  3,2) - xsxz00
      ec(  8,2)=ed( 30,2)     
      ec(  9,2)=ed( 39,2)     
      ec( 10,2)=ed(  4,2) - xsyx00
      ec( 11,2)=ed( 31,2)     
      ec( 12,2)=ed( 40,2)     
      ec( 13,2)=ed(  5,2) - xsyy00
      ec( 14,2)=ed( 32,2)     
      ec( 15,2)=ed( 41,2)     
      ec( 16,2)=ed(  6,2) - xsyz00
      ec( 17,2)=ed( 33,2)     
      ec( 18,2)=ed( 42,2)     
      ec( 19,2)=ed(  7,2) - xszx00
      ec( 20,2)=ed( 34,2)     
      ec( 21,2)=ed( 43,2)     
      ec( 22,2)=ed(  8,2) - xszy00
      ec( 23,2)=ed( 35,2)     
      ec( 24,2)=ed( 44,2)     
      ec( 25,2)=ed(  9,2) - xszz00
      ec( 26,2)=ed( 36,2)     
      ec( 27,2)=ed( 45,2)     
                              
      ec( 28,2)=ed( 28,2)     
      ec( 29,2)=ed( 10,2) - xsxx00
      ec( 30,2)=ed( 46,2)     
      ec( 31,2)=ed( 29,2)     
      ec( 32,2)=ed( 11,2) - xsxy00
      ec( 33,2)=ed( 47,2)     
      ec( 34,2)=ed( 30,2)     
      ec( 35,2)=ed( 12,2) - xsxz00
      ec( 36,2)=ed( 48,2)     
      ec( 37,2)=ed( 31,2)     
      ec( 38,2)=ed( 13,2) - xsyx00
      ec( 39,2)=ed( 49,2)     
      ec( 40,2)=ed( 32,2)     
      ec( 41,2)=ed( 14,2) - xsyy00
      ec( 42,2)=ed( 50,2)     
      ec( 43,2)=ed( 33,2)     
      ec( 44,2)=ed( 15,2) - xsyz00
      ec( 45,2)=ed( 51,2)     
      ec( 46,2)=ed( 34,2)     
      ec( 47,2)=ed( 16,2) - xszx00
      ec( 48,2)=ed( 52,2)     
      ec( 49,2)=ed( 35,2)     
      ec( 50,2)=ed( 17,2) - xszy00
      ec( 51,2)=ed( 53,2)     
      ec( 52,2)=ed( 36,2)     
      ec( 53,2)=ed( 18,2) - xszz00
      ec( 54,2)=ed( 54,2)     
                              
      ec( 55,2)=ed( 37,2)     
      ec( 56,2)=ed( 46,2)     
      ec( 57,2)=ed( 19,2) - xsxx00
      ec( 58,2)=ed( 38,2)     
      ec( 59,2)=ed( 47,2)     
      ec( 60,2)=ed( 20,2) - xsxy00
      ec( 61,2)=ed( 39,2)     
      ec( 62,2)=ed( 48,2)     
      ec( 63,2)=ed( 21,2) - xsxz00
      ec( 64,2)=ed( 40,2)     
      ec( 65,2)=ed( 49,2)     
      ec( 66,2)=ed( 22,2) - xsyx00
      ec( 67,2)=ed( 41,2)     
      ec( 68,2)=ed( 50,2)     
      ec( 69,2)=ed( 23,2) - xsyy00
      ec( 70,2)=ed( 42,2)     
      ec( 71,2)=ed( 51,2)     
      ec( 72,2)=ed( 24,2) - xsyz00
      ec( 73,2)=ed( 43,2)     
      ec( 74,2)=ed( 52,2)     
      ec( 75,2)=ed( 25,2) - xszx00
      ec( 76,2)=ed( 44,2)     
      ec( 77,2)=ed( 53,2)     
      ec( 78,2)=ed( 26,2) - xszy00
      ec( 79,2)=ed( 45,2)     
      ec( 80,2)=ed( 54,2)     
      ec( 81,2)=ed( 27,2) - xszz00
                              
      ec( 82,2)=ed( 55,2) - ysxx00
      ec( 83,2)=ed( 82,2)     
      ec( 84,2)=ed( 91,2)     
      ec( 85,2)=ed( 56,2) - ysxy00
      ec( 86,2)=ed( 83,2)     
      ec( 87,2)=ed( 92,2)     
      ec( 88,2)=ed( 57,2) - ysxz00
      ec( 89,2)=ed( 84,2)     
      ec( 90,2)=ed( 93,2)     
      ec( 91,2)=ed( 58,2) - ysyx00
      ec( 92,2)=ed( 85,2)     
      ec( 93,2)=ed( 94,2)     
      ec( 94,2)=ed( 59,2) - ysyy00
      ec( 95,2)=ed( 86,2)     
      ec( 96,2)=ed( 95,2)     
      ec( 97,2)=ed( 60,2) - ysyz00
      ec( 98,2)=ed( 87,2)     
      ec( 99,2)=ed( 96,2)     
      ec(100,2)=ed( 61,2) - yszx00
      ec(101,2)=ed( 88,2)     
      ec(102,2)=ed( 97,2)     
      ec(103,2)=ed( 62,2) - yszy00
      ec(104,2)=ed( 89,2)     
      ec(105,2)=ed( 98,2)     
      ec(106,2)=ed( 63,2) - yszz00
      ec(107,2)=ed( 90,2)     
      ec(108,2)=ed( 99,2)     
                              
      ec(109,2)=ed( 82,2)     
      ec(110,2)=ed( 64,2) - ysxx00
      ec(111,2)=ed(100,2)     
      ec(112,2)=ed( 83,2)     
      ec(113,2)=ed( 65,2) - ysxy00
      ec(114,2)=ed(101,2)     
      ec(115,2)=ed( 84,2)     
      ec(116,2)=ed( 66,2) - ysxz00
      ec(117,2)=ed(102,2)     
      ec(118,2)=ed( 85,2)     
      ec(119,2)=ed( 67,2) - ysyx00
      ec(120,2)=ed(103,2)     
      ec(121,2)=ed( 86,2)     
      ec(122,2)=ed( 68,2) - ysyy00
      ec(123,2)=ed(104,2)     
      ec(124,2)=ed( 87,2)     
      ec(125,2)=ed( 69,2) - ysyz00
      ec(126,2)=ed(105,2)     
      ec(127,2)=ed( 88,2)     
      ec(128,2)=ed( 70,2) - yszx00
      ec(129,2)=ed(106,2)     
      ec(130,2)=ed( 89,2)     
      ec(131,2)=ed( 71,2) - yszy00
      ec(132,2)=ed(107,2)     
      ec(133,2)=ed( 90,2)     
      ec(134,2)=ed( 72,2) - yszz00
      ec(135,2)=ed(108,2)     
                              
      ec(136,2)=ed( 91,2)     
      ec(137,2)=ed(100,2)     
      ec(138,2)=ed( 73,2) - ysxx00
      ec(139,2)=ed( 92,2)     
      ec(140,2)=ed(101,2)     
      ec(141,2)=ed( 74,2) - ysxy00
      ec(142,2)=ed( 93,2)     
      ec(143,2)=ed(102,2)     
      ec(144,2)=ed( 75,2) - ysxz00
      ec(145,2)=ed( 94,2)     
      ec(146,2)=ed(103,2)     
      ec(147,2)=ed( 76,2) - ysyx00
      ec(148,2)=ed( 95,2)     
      ec(149,2)=ed(104,2)     
      ec(150,2)=ed( 77,2) - ysyy00
      ec(151,2)=ed( 96,2)     
      ec(152,2)=ed(105,2)     
      ec(153,2)=ed( 78,2) - ysyz00
      ec(154,2)=ed( 97,2)     
      ec(155,2)=ed(106,2)     
      ec(156,2)=ed( 79,2) - yszx00
      ec(157,2)=ed( 98,2)     
      ec(158,2)=ed(107,2)     
      ec(159,2)=ed( 80,2) - yszy00
      ec(160,2)=ed( 99,2)     
      ec(161,2)=ed(108,2)     
      ec(162,2)=ed( 81,2) - yszz00
                              
      ec(163,2)=ed(109,2) - zsxx00
      ec(164,2)=ed(136,2)     
      ec(165,2)=ed(145,2)     
      ec(166,2)=ed(110,2) - zsxy00
      ec(167,2)=ed(137,2)     
      ec(168,2)=ed(146,2)     
      ec(169,2)=ed(111,2) - zsxz00
      ec(170,2)=ed(138,2)     
      ec(171,2)=ed(147,2)     
      ec(172,2)=ed(112,2) - zsyx00
      ec(173,2)=ed(139,2)     
      ec(174,2)=ed(148,2)     
      ec(175,2)=ed(113,2) - zsyy00
      ec(176,2)=ed(140,2)     
      ec(177,2)=ed(149,2)     
      ec(178,2)=ed(114,2) - zsyz00
      ec(179,2)=ed(141,2)     
      ec(180,2)=ed(150,2)     
      ec(181,2)=ed(115,2) - zszx00
      ec(182,2)=ed(142,2)     
      ec(183,2)=ed(151,2)     
      ec(184,2)=ed(116,2) - zszy00
      ec(185,2)=ed(143,2)     
      ec(186,2)=ed(152,2)     
      ec(187,2)=ed(117,2) - zszz00
      ec(188,2)=ed(144,2)     
      ec(189,2)=ed(153,2)     
                              
      ec(190,2)=ed(136,2)     
      ec(191,2)=ed(118,2) - zsxx00
      ec(192,2)=ed(154,2)     
      ec(193,2)=ed(137,2)     
      ec(194,2)=ed(119,2) - zsxy00
      ec(195,2)=ed(155,2)     
      ec(196,2)=ed(138,2)     
      ec(197,2)=ed(120,2) - zsxz00
      ec(198,2)=ed(156,2)     
      ec(199,2)=ed(139,2)     
      ec(200,2)=ed(121,2) - zsyx00
      ec(201,2)=ed(157,2)     
      ec(202,2)=ed(140,2)     
      ec(203,2)=ed(122,2) - zsyy00
      ec(204,2)=ed(158,2)     
      ec(205,2)=ed(141,2)     
      ec(206,2)=ed(123,2) - zsyz00
      ec(207,2)=ed(159,2)     
      ec(208,2)=ed(142,2)     
      ec(209,2)=ed(124,2) - zszx00
      ec(210,2)=ed(160,2)     
      ec(211,2)=ed(143,2)     
      ec(212,2)=ed(125,2) - zszy00
      ec(213,2)=ed(161,2)     
      ec(214,2)=ed(144,2)     
      ec(215,2)=ed(126,2) - zszz00
      ec(216,2)=ed(162,2)     
                              
      ec(217,2)=ed(145,2)     
      ec(218,2)=ed(154,2)     
      ec(219,2)=ed(127,2) - zsxx00
      ec(220,2)=ed(146,2)     
      ec(221,2)=ed(155,2)     
      ec(222,2)=ed(128,2) - zsxy00
      ec(223,2)=ed(147,2)     
      ec(224,2)=ed(156,2)     
      ec(225,2)=ed(129,2) - zsxz00
      ec(226,2)=ed(148,2)     
      ec(227,2)=ed(157,2)     
      ec(228,2)=ed(130,2) - zsyx00
      ec(229,2)=ed(149,2)     
      ec(230,2)=ed(158,2)     
      ec(231,2)=ed(131,2) - zsyy00
      ec(232,2)=ed(150,2)     
      ec(233,2)=ed(159,2)     
      ec(234,2)=ed(132,2) - zsyz00
      ec(235,2)=ed(151,2)     
      ec(236,2)=ed(160,2)     
      ec(237,2)=ed(133,2) - zszx00
      ec(238,2)=ed(152,2)     
      ec(239,2)=ed(161,2)     
      ec(240,2)=ed(134,2) - zszy00
      ec(241,2)=ed(153,2)     
      ec(242,2)=ed(162,2)     
      ec(243,2)=ed(135,2) - zszz00
!ppdp
      ec(  1,3)=ed(  1,3) - xxsx00
      ec(  2,3)=ed( 10,3)
      ec(  3,3)=ed( 13,3)
      ec(  4,3)=ed(  2,3) - xxsy00
      ec(  5,3)=ed( 11,3)
      ec(  6,3)=ed( 14,3)
      ec(  7,3)=ed(  3,3) - xxsz00
      ec(  8,3)=ed( 12,3)
      ec(  9,3)=ed( 15,3)
      ec( 10,3)=ed( 10,3)
      ec( 11,3)=ed(  4,3) - xxsx00
      ec( 12,3)=ed( 16,3)
      ec( 13,3)=ed( 11,3)
      ec( 14,3)=ed(  5,3) - xxsy00
      ec( 15,3)=ed( 17,3)
      ec( 16,3)=ed( 12,3)
      ec( 17,3)=ed(  6,3) - xxsz00
      ec( 18,3)=ed( 18,3)
      ec( 19,3)=ed( 13,3)
      ec( 20,3)=ed( 16,3)
      ec( 21,3)=ed(  7,3) - xxsx00
      ec( 22,3)=ed( 14,3)
      ec( 23,3)=ed( 17,3)
      ec( 24,3)=ed(  8,3) - xxsy00
      ec( 25,3)=ed( 15,3)
      ec( 26,3)=ed( 18,3)
      ec( 27,3)=ed(  9,3) - xxsz00
                      
      ec( 28,3)=ed( 19,3) - xysx00
      ec( 29,3)=ed( 28,3)
      ec( 30,3)=ed( 31,3)
      ec( 31,3)=ed( 20,3) - xysy00
      ec( 32,3)=ed( 29,3)
      ec( 33,3)=ed( 32,3)
      ec( 34,3)=ed( 21,3) - xysz00
      ec( 35,3)=ed( 30,3)
      ec( 36,3)=ed( 33,3)
      ec( 37,3)=ed( 28,3)
      ec( 38,3)=ed( 22,3) - xysx00
      ec( 39,3)=ed( 34,3)
      ec( 40,3)=ed( 29,3)
      ec( 41,3)=ed( 23,3) - xysy00
      ec( 42,3)=ed( 35,3)
      ec( 43,3)=ed( 30,3)
      ec( 44,3)=ed( 24,3) - xysz00
      ec( 45,3)=ed( 36,3)
      ec( 46,3)=ed( 31,3)
      ec( 47,3)=ed( 34,3)
      ec( 48,3)=ed( 25,3) - xysx00
      ec( 49,3)=ed( 32,3)
      ec( 50,3)=ed( 35,3)
      ec( 51,3)=ed( 26,3) - xysy00
      ec( 52,3)=ed( 33,3)
      ec( 53,3)=ed( 36,3)
      ec( 54,3)=ed( 27,3) - xysz00
                      
      ec( 55,3)=ed( 37,3) - xzsx00
      ec( 56,3)=ed( 46,3)
      ec( 57,3)=ed( 49,3)
      ec( 58,3)=ed( 38,3) - xzsy00
      ec( 59,3)=ed( 47,3)
      ec( 60,3)=ed( 50,3)
      ec( 61,3)=ed( 39,3) - xzsz00
      ec( 62,3)=ed( 48,3)
      ec( 63,3)=ed( 51,3)
      ec( 64,3)=ed( 46,3)
      ec( 65,3)=ed( 40,3) - xzsx00
      ec( 66,3)=ed( 52,3)
      ec( 67,3)=ed( 47,3)
      ec( 68,3)=ed( 41,3) - xzsy00
      ec( 69,3)=ed( 53,3)
      ec( 70,3)=ed( 48,3)
      ec( 71,3)=ed( 42,3) - xzsz00
      ec( 72,3)=ed( 54,3)
      ec( 73,3)=ed( 49,3)
      ec( 74,3)=ed( 52,3)
      ec( 75,3)=ed( 43,3) - xzsx00
      ec( 76,3)=ed( 50,3)
      ec( 77,3)=ed( 53,3)
      ec( 78,3)=ed( 44,3) - xzsy00
      ec( 79,3)=ed( 51,3)
      ec( 80,3)=ed( 54,3)
      ec( 81,3)=ed( 45,3) - xzsz00
                      
      ec( 82,3)=ed( 55,3) - yxsx00
      ec( 83,3)=ed( 64,3)
      ec( 84,3)=ed( 67,3)
      ec( 85,3)=ed( 56,3) - yxsy00
      ec( 86,3)=ed( 65,3)
      ec( 87,3)=ed( 68,3)
      ec( 88,3)=ed( 57,3) - yxsz00
      ec( 89,3)=ed( 66,3)
      ec( 90,3)=ed( 69,3)
      ec( 91,3)=ed( 64,3)
      ec( 92,3)=ed( 58,3) - yxsx00
      ec( 93,3)=ed( 70,3)
      ec( 94,3)=ed( 65,3)
      ec( 95,3)=ed( 59,3) - yxsy00
      ec( 96,3)=ed( 71,3)
      ec( 97,3)=ed( 66,3)
      ec( 98,3)=ed( 60,3) - yxsz00
      ec( 99,3)=ed( 72,3)
      ec(100,3)=ed( 67,3)
      ec(101,3)=ed( 70,3)
      ec(102,3)=ed( 61,3) - yxsx00
      ec(103,3)=ed( 68,3)
      ec(104,3)=ed( 71,3)
      ec(105,3)=ed( 62,3) - yxsy00
      ec(106,3)=ed( 69,3)
      ec(107,3)=ed( 72,3)
      ec(108,3)=ed( 63,3) - yxsz00
                      
      ec(109,3)=ed( 73,3) - yysx00
      ec(110,3)=ed( 82,3)
      ec(111,3)=ed( 85,3)
      ec(112,3)=ed( 74,3) - yysy00
      ec(113,3)=ed( 83,3)
      ec(114,3)=ed( 86,3)
      ec(115,3)=ed( 75,3) - yysz00
      ec(116,3)=ed( 84,3)
      ec(117,3)=ed( 87,3)
      ec(118,3)=ed( 82,3)
      ec(119,3)=ed( 76,3) - yysx00
      ec(120,3)=ed( 88,3)
      ec(121,3)=ed( 83,3)
      ec(122,3)=ed( 77,3) - yysy00
      ec(123,3)=ed( 89,3)
      ec(124,3)=ed( 84,3)
      ec(125,3)=ed( 78,3) - yysz00
      ec(126,3)=ed( 90,3)
      ec(127,3)=ed( 85,3)
      ec(128,3)=ed( 88,3)
      ec(129,3)=ed( 79,3) - yysx00
      ec(130,3)=ed( 86,3)
      ec(131,3)=ed( 89,3)
      ec(132,3)=ed( 80,3) - yysy00
      ec(133,3)=ed( 87,3)
      ec(134,3)=ed( 90,3)
      ec(135,3)=ed( 81,3) - yysz00
                      
      ec(136,3)=ed( 91,3) - yzsx00
      ec(137,3)=ed(100,3)
      ec(138,3)=ed(103,3)
      ec(139,3)=ed( 92,3) - yzsy00
      ec(140,3)=ed(101,3)
      ec(141,3)=ed(104,3)
      ec(142,3)=ed( 93,3) - yzsz00
      ec(143,3)=ed(102,3)
      ec(144,3)=ed(105,3)
      ec(145,3)=ed(100,3)
      ec(146,3)=ed( 94,3) - yzsx00
      ec(147,3)=ed(106,3)
      ec(148,3)=ed(101,3)
      ec(149,3)=ed( 95,3) - yzsy00
      ec(150,3)=ed(107,3)
      ec(151,3)=ed(102,3)
      ec(152,3)=ed( 96,3) - yzsz00
      ec(153,3)=ed(108,3)
      ec(154,3)=ed(103,3)
      ec(155,3)=ed(106,3)
      ec(156,3)=ed( 97,3) - yzsx00
      ec(157,3)=ed(104,3)
      ec(158,3)=ed(107,3)
      ec(159,3)=ed( 98,3) - yzsy00
      ec(160,3)=ed(105,3)
      ec(161,3)=ed(108,3)
      ec(162,3)=ed( 99,3) - yzsz00
                      
      ec(163,3)=ed(109,3) - zxsx00
      ec(164,3)=ed(118,3)
      ec(165,3)=ed(121,3)
      ec(166,3)=ed(110,3) - zxsy00
      ec(167,3)=ed(119,3)
      ec(168,3)=ed(122,3)
      ec(169,3)=ed(111,3) - zxsz00
      ec(170,3)=ed(120,3)
      ec(171,3)=ed(123,3)
      ec(172,3)=ed(118,3)
      ec(173,3)=ed(112,3) - zxsx00
      ec(174,3)=ed(124,3)
      ec(175,3)=ed(119,3)
      ec(176,3)=ed(113,3) - zxsy00
      ec(177,3)=ed(125,3)
      ec(178,3)=ed(120,3)
      ec(179,3)=ed(114,3) - zxsz00
      ec(180,3)=ed(126,3)
      ec(181,3)=ed(121,3)
      ec(182,3)=ed(124,3)
      ec(183,3)=ed(115,3) - zxsx00
      ec(184,3)=ed(122,3)
      ec(185,3)=ed(125,3)
      ec(186,3)=ed(116,3) - zxsy00
      ec(187,3)=ed(123,3)
      ec(188,3)=ed(126,3)
      ec(189,3)=ed(117,3) - zxsz00
                            
      ec(190,3)=ed(127,3) - zysx00
      ec(191,3)=ed(136,3)
      ec(192,3)=ed(139,3)
      ec(193,3)=ed(128,3) - zysy00
      ec(194,3)=ed(137,3)
      ec(195,3)=ed(140,3)
      ec(196,3)=ed(129,3) - zysz00
      ec(197,3)=ed(138,3)
      ec(198,3)=ed(141,3)
      ec(199,3)=ed(136,3)
      ec(200,3)=ed(130,3) - zysx00
      ec(201,3)=ed(142,3)
      ec(202,3)=ed(137,3)
      ec(203,3)=ed(131,3) - zysy00
      ec(204,3)=ed(143,3)
      ec(205,3)=ed(138,3)
      ec(206,3)=ed(132,3) - zysz00
      ec(207,3)=ed(144,3)
      ec(208,3)=ed(139,3)
      ec(209,3)=ed(142,3)
      ec(210,3)=ed(133,3) - zysx00
      ec(211,3)=ed(140,3)
      ec(212,3)=ed(143,3)
      ec(213,3)=ed(134,3) - zysy00
      ec(214,3)=ed(141,3)
      ec(215,3)=ed(144,3)
      ec(216,3)=ed(135,3) - zysz00
                      
      ec(217,3)=ed(145,3) - zzsx00
      ec(218,3)=ed(154,3)
      ec(219,3)=ed(157,3)
      ec(220,3)=ed(146,3) - zzsy00
      ec(221,3)=ed(155,3)
      ec(222,3)=ed(158,3)
      ec(223,3)=ed(147,3) - zzsz00
      ec(224,3)=ed(156,3)
      ec(225,3)=ed(159,3)
      ec(226,3)=ed(154,3)
      ec(227,3)=ed(148,3) - zzsx00
      ec(228,3)=ed(160,3)
      ec(229,3)=ed(155,3)
      ec(230,3)=ed(149,3) - zzsy00
      ec(231,3)=ed(161,3)
      ec(232,3)=ed(156,3)
      ec(233,3)=ed(150,3) - zzsz00
      ec(234,3)=ed(162,3)
      ec(235,3)=ed(157,3)
      ec(236,3)=ed(160,3)
      ec(237,3)=ed(151,3) - zzsx00
      ec(238,3)=ed(158,3)
      ec(239,3)=ed(161,3)
      ec(240,3)=ed(152,3) - zzsy00
      ec(241,3)=ed(159,3)
      ec(242,3)=ed(162,3)
      ec(243,3)=ed(153,3) - zzsz00
#ifdef PL_OMP_DERI
!$omp end parallel
#endif

      do i=1,3  
         do j=1,mao3  
            ec(j,4) = ec(j,4) - ec(j,i)
         enddo     
      enddo

      end
!= iodsss ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine jodsss(
     &     ec   ,
     &     fdat , edat  ,
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  ,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )


      implicit real(8) (a-h,o-z)           
c$$$      dimension fdat(31,2001)
c$$$      dimension edat(2001)
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4),ed(mao3,3)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(5) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /)

      real(8),parameter::root3 = 1.73205080756887729353d+00

#ifdef PL_SIMD_DERI
      dimension dmx(4,mxprm), val(5,mxprm)
#endif

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,mao3,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do j = 1,3
         do i = 1,mao3
!c$$$            ec(i,j) = 0.0d0
            ed(i,j) = 0.0d0
         enddo
      enddo

      px00 = 0.0d0
      py00 = 0.0d0
      pz00 = 0.0d0
      xp00 = 0.0d0
      yp00 = 0.0d0
      zp00 = 0.0d0

#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)
         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(4)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f3   = (((((fdat(10,it)*dt6   + fdat(9,it))*dt5
     &                    + fdat(8,it))*dt4  + fdat(7,it))*dt3
     &                    + fdat(6,it))*dt2  + fdat(5,it))*dt
     &                    + fdat(4,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0

                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f2   =  (t2*f3 + ee)*rminv(3)
                     f1   =  (t2*f2 + ee)*rminv(2)
                     f0   =   t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0

                     dm1 = fpp*f1
                     dm2 = fpp*f2
                     dm3 = fpp*f3
                     
                  else
!                    qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv

                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0

                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
 
                  end if
                  
#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
                  val(5,l) = eta
 
                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
                  dmx(3,l) = dm2
                  dmx(4,l) = dm3
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)
                  eta  = val(5,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
                  dm2 = dmx(3,l)
                  dm3 = dmx(4,l)
#endif
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  s0 = dm0
                  s1 = dm1
                  s2 = dm2
                  s3 = dm3

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
                  rkp = rooz*eta
!psss
                  px0=pax*s0 + wpx*s1
                  py0=pay*s0 + wpy*s1
                  pz0=paz*s0 + wpz*s1
                  px1=pax*s1 + wpx*s2
                  py1=pay*s1 + wpy*s2
                  pz1=paz*s1 + wpz*s2
                  px2=pax*s2 + wpx*s3
                  py2=pay*s2 + wpy*s3
                  pz2=paz*s2 + wpz*s3

                  px00 = px00 + px0
                  py00 = py00 + py0
                  pz00 = pz00 + pz0

                  px01 = zet*(px0 - rooz*px1)
                  py01 = zet*(py0 - rooz*py1)
                  pz01 = zet*(pz0 - rooz*pz1)
!ssss01
                  s01 = zet*(s0 - rooz*s1)
                  s12 = zet*(s1 - rooz*s2)
!dsss
                  dxx0 = pax*px0 + wpx*px1 + s01
                  dyy0 = pay*py0 + wpy*py1 + s01
                  dzz0 = paz*pz0 + wpz*pz1 + s01
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2 + s12
                  dyy1 = pay*py1 + wpy*py2 + s12
                  dzz1 = paz*pz1 + wpz*pz2 + s12
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2

!fsss
                  ed( 1,1)=ed( 1,1)+alp*(pax*dxx0 + wpx*dxx1+2.d0*px01)
                  ed( 2,1)=ed( 2,1)+alp*(pay*dyy0 + wpy*dyy1+2.d0*py01)
                  ed( 3,1)=ed( 3,1)+alp*(paz*dzz0 + wpz*dzz1+2.d0*pz01)
                  ed( 4,1)=ed( 4,1)+alp*(pay*dxx0 + wpy*dxx1)
                  ed( 5,1)=ed( 5,1)+alp*(paz*dxx0 + wpz*dxx1)
                  ed( 6,1)=ed( 6,1)+alp*(pax*dyy0 + wpx*dyy1)
                  ed( 7,1)=ed( 7,1)+alp*(paz*dyy0 + wpz*dyy1)
                  ed( 8,1)=ed( 8,1)+alp*(pax*dzz0 + wpx*dzz1)
                  ed( 9,1)=ed( 9,1)+alp*(pay*dzz0 + wpy*dzz1)
                  ed(10,1)=ed(10,1)+alp*(paz*dyx0 + wpz*dyx1)
!dpss
                  ec( 1,2) =ec( 1,2)+bet*(pbx*dxx0 + wpx*dxx1+2.d0*px01)
                  ec( 2,2) =ec( 2,2)+bet*(pby*dxx0 + wpy*dxx1)
                  ec( 3,2) =ec( 3,2)+bet*(pbz*dxx0 + wpz*dxx1)
                  ec( 4,2) =ec( 4,2)+bet*(pbx*dyy0 + wpx*dyy1)
                  ec( 5,2) =ec( 5,2)+bet*(pby*dyy0 + wpy*dyy1+2.d0*py01)
                  ec( 6,2) =ec( 6,2)+bet*(pbz*dyy0 + wpz*dyy1)
                  ec( 7,2) =ec( 7,2)+bet*(pbx*dzz0 + wpx*dzz1)
                  ec( 8,2) =ec( 8,2)+bet*(pby*dzz0 + wpy*dzz1)
                  ec( 9,2) =ec( 9,2)+bet*(pbz*dzz0 + wpz*dzz1+2.d0*pz01)

                  ec(10,2) =ec(10,2)+bet*(pbx*dyx0 + wpx*dyx1+     py01)
                  ec(11,2) =ec(11,2)+bet*(pby*dyx0 + wpy*dyx1+     px01)
                  ec(12,2) =ec(12,2)+bet*(pbz*dyx0 + wpz*dyx1          )
                  ec(13,2) =ec(13,2)+bet*(pbx*dzx0 + wpx*dzx1+     pz01)
                  ec(14,2) =ec(14,2)+bet*(pby*dzx0 + wpy*dzx1          )
                  ec(15,2) =ec(15,2)+bet*(pbz*dzx0 + wpz*dzx1+     px01)
                  ec(16,2) =ec(16,2)+bet*(pbx*dzy0 + wpx*dzy1          )
                  ec(17,2) =ec(17,2)+bet*(pby*dzy0 + wpy*dzy1+     pz01)
                  ec(18,2) =ec(18,2)+bet*(pbz*dzy0 + wpz*dzy1+     py01)
!rpsss
                  rpx1 = rkp * px1
                  rpy1 = rkp * py1
                  rpz1 = rkp * pz1

!dsps
                  ec( 1,3)=ec( 1,3)+ram*(qcx*dxx0+wqx*dxx1+2.d0*rpx1)
                  ec( 2,3)=ec( 2,3)+ram*(qcy*dxx0+wqy*dxx1          )
                  ec( 3,3)=ec( 3,3)+ram*(qcz*dxx0+wqz*dxx1          )
                  ec( 4,3)=ec( 4,3)+ram*(qcx*dyy0+wqx*dyy1          )
                  ec( 5,3)=ec( 5,3)+ram*(qcy*dyy0+wqy*dyy1+2.d0*rpy1)
                  ec( 6,3)=ec( 6,3)+ram*(qcz*dyy0+wqz*dyy1          )
                  ec( 7,3)=ec( 7,3)+ram*(qcx*dzz0+wqx*dzz1          )
                  ec( 8,3)=ec( 8,3)+ram*(qcy*dzz0+wqy*dzz1          )
                  ec( 9,3)=ec( 9,3)+ram*(qcz*dzz0+wqz*dzz1+2.d0*rpz1)

                  ec(10,3)=ec(10,3)+ram*(qcx*dyx0+wqx*dyx1+     rpy1)
                  ec(11,3)=ec(11,3)+ram*(qcy*dyx0+wqy*dyx1+     rpx1)
                  ec(12,3)=ec(12,3)+ram*(qcz*dyx0+wqz*dyx1          )
                  ec(13,3)=ec(13,3)+ram*(qcx*dzx0+wqx*dzx1+     rpz1)
                  ec(14,3)=ec(14,3)+ram*(qcy*dzx0+wqy*dzx1          )
                  ec(15,3)=ec(15,3)+ram*(qcz*dzx0+wqz*dzx1+     rpx1)
                  ec(16,3)=ec(16,3)+ram*(qcx*dzy0+wqx*dzy1          )
                  ec(17,3)=ec(17,3)+ram*(qcy*dzy0+wqy*dzy1+     rpz1)
                  ec(18,3)=ec(18,3)+ram*(qcz*dzy0+wqz*dzy1+     rpy1)

                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
#endif

      ec( 1,1) = ed( 1,1) - 2.d0*px00
      ec( 2,1) = ed( 4,1)
      ec( 3,1) = ed( 5,1)
      ec( 4,1) = ed( 6,1)
      ec( 5,1) = ed( 2,1) - 2.d0*py00
      ec( 6,1) = ed( 7,1)
      ec( 7,1) = ed( 8,1)
      ec( 8,1) = ed( 9,1)
      ec( 9,1) = ed( 3,1) - 2.d0*pz00
      ec(10,1) = ed( 4,1) -      py00
      ec(11,1) = ed( 6,1) -      px00
      ec(12,1) = ed(10,1)
      ec(13,1) = ed( 5,1) -      pz00
      ec(14,1) = ed(10,1)
      ec(15,1) = ed( 8,1) -      px00
      ec(16,1) = ed(10,1)
      ec(17,1) = ed( 7,1) -      pz00
      ec(18,1) = ed( 9,1) -      py00
#ifdef PL_OMP_DERI
!$omp end parallel
#endif

       do j=1,mao3
          do i=1,3
             ec(j,4) = ec(j,4) - ec(j,i)
          enddo
       enddo

      do j=1,4
         do i=10,18
            ec(i,j) = ec(i,j)*root3
         enddo
      enddo

      end
!= iodsps ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine jodsps(
     &     ec   ,
     &     fdat , edat  ,
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  , jal   ,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )


      implicit real(8) (a-h,o-z)           
c$$$      dimension fdat(31,2001)
c$$$      dimension edat(2001)
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4),ed(mao3,3)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(5) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /)

      real(8),parameter::root3 = 1.73205080756887729353d+00

#ifdef PL_SIMD_DERI
      dimension dmx(5,mxprm), val(5,mxprm)
#endif

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,jal,mao3,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do j = 1,3
         do i = 1,mao3
!c$$$            ec(i,j) = 0.0d0
            ed(i,j) = 0.0d0
         enddo
      enddo
      dxx00 = 0.d0
      dyy00 = 0.d0
      dzz00 = 0.d0
      dyx00 = 0.d0
      dzx00 = 0.d0
      dzy00 = 0.d0
      pspsxx00 =0.d0 
      pspsxy00 =0.d0 
      pspsxz00 =0.d0 
      pspsyx00 =0.d0 
      pspsyy00 =0.d0 
      pspsyz00 =0.d0 
      pspszx00 =0.d0 
      pspszy00 =0.d0 
      pspszz00 =0.d0 

#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)
         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(5)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f4   = (((((fdat(11,it)*dt6   + fdat(10,it))*dt5
     &                    + fdat(9,it))*dt4  + fdat(8,it))*dt3
     &                    + fdat(7,it))*dt2  + fdat(6,it))*dt
     &                    + fdat(5,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0

                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f3   =  (t2*f4 + ee)*rminv(4)
                     f2   =  (t2*f3 + ee)*rminv(3)
                     f1   =  (t2*f2 + ee)*rminv(2)
                     f0   =   t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0

                     dm1 = fpp*f1
                     dm2 = fpp*f2
                     dm3 = fpp*f3
                     dm4 = fpp*f4
                     
                  else
!                    qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv

                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0

                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
 
                  end if
                  
#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
                  val(5,l) = eta
 
                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
                  dmx(3,l) = dm2
                  dmx(4,l) = dm3
                  dmx(5,l) = dm4
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)
                  eta  = val(5,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
                  dm2 = dmx(3,l)
                  dm3 = dmx(4,l)
                  dm4 = dmx(5,l)
#endif
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  s0 = dm0
                  s1 = dm1
                  s2 = dm2
                  s3 = dm3
                  s4 = dm4

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
                  rkp =  rooz * eta
!psss
      px0=pax*s0 + wpx*s1
      py0=pay*s0 + wpy*s1
      pz0=paz*s0 + wpz*s1
      px1=pax*s1 + wpx*s2
      py1=pay*s1 + wpy*s2
      pz1=paz*s1 + wpz*s2
      px2=pax*s2 + wpx*s3
      py2=pay*s2 + wpy*s3
      pz2=paz*s2 + wpz*s3
      px3=pax*s3 + wpx*s4
      py3=pay*s3 + wpy*s4
      pz3=paz*s3 + wpz*s4
!rpsss1
      rpx1 = rkp*px1
      rpy1 = rkp*py1
      rpz1 = rkp*pz1
      rpx2 = rkp*px2
      rpy2 = rkp*py2
      rpz2 = rkp*pz2
!ssss01
      s01 = zet*(s0 - rooz*s1)
      s12 = zet*(s1 - rooz*s2)
      s23 = zet*(s2 - rooz*s3)
!rssss
      rs1 = rkp*s1
      rs2 = rkp*s2
!dsss
      dxx0 = pax*px0 + wpx*px1 + s01
      dyy0 = pay*py0 + wpy*py1 + s01
      dzz0 = paz*pz0 + wpz*pz1 + s01
      dyx0 = pay*px0 + wpy*px1
      dzx0 = paz*px0 + wpz*px1
      dzy0 = paz*py0 + wpz*py1

      dxx00 = dxx00 + dxx0
      dyy00 = dyy00 + dyy0
      dzz00 = dzz00 + dzz0
      dyx00 = dyx00 + dyx0
      dzx00 = dzx00 + dzx0
      dzy00 = dzy00 + dzy0

      dxx1 = pax*px1 + wpx*px2 + s12
      dyy1 = pay*py1 + wpy*py2 + s12
      dzz1 = paz*pz1 + wpz*pz2 + s12
      dyx1 = pay*px1 + wpy*px2
      dzx1 = paz*px1 + wpz*px2
      dzy1 = paz*py1 + wpz*py2

      dxx2 = pax*px2 + wpx*px3 + s23
      dyy2 = pay*py2 + wpy*py3 + s23
      dzz2 = paz*pz2 + wpz*pz3 + s23
      dyx2 = pay*px2 + wpy*px3
      dzx2 = paz*px2 + wpz*px3
      dzy2 = paz*py2 + wpz*py3
!psps
      xx0 = qcx*px0 + wqx*px1 + rs1
      xy0 = qcy*px0 + wqy*px1
      xz0 = qcz*px0 + wqz*px1
      yx0 = qcx*py0 + wqx*py1
      yy0 = qcy*py0 + wqy*py1 + rs1
      yz0 = qcz*py0 + wqz*py1
      zx0 = qcx*pz0 + wqx*pz1
      zy0 = qcy*pz0 + wqy*pz1
      zz0 = qcz*pz0 + wqz*pz1 + rs1
 
      pspsxx00 = pspsxx00 + xx0
      pspsxy00 = pspsxy00 + xy0
      pspsxz00 = pspsxz00 + xz0
      pspsyx00 = pspsyx00 + yx0
      pspsyy00 = pspsyy00 + yy0
      pspsyz00 = pspsyz00 + yz0
      pspszx00 = pspszx00 + zx0
      pspszy00 = pspszy00 + zy0
      pspszz00 = pspszz00 + zz0

      xx1 = qcx*px1 + wqx*px2 + rs2
      xy1 = qcy*px1 + wqy*px2
      xz1 = qcz*px1 + wqz*px2
      yx1 = qcx*py1 + wqx*py2
      yy1 = qcy*py1 + wqy*py2 + rs2
      yz1 = qcz*py1 + wqz*py2
      zx1 = qcx*pz1 + wqx*pz2
      zy1 = qcy*pz1 + wqy*pz2
      zz1 = qcz*pz1 + wqz*pz2 + rs2
!psps01 rpsps
      xx01 = zet*(xx0 - rooz*xx1)
      xy01 = zet*(xy0 - rooz*xy1)
      xz01 = zet*(xz0 - rooz*xz1)
      yx01 = zet*(yx0 - rooz*yx1)
      yy01 = zet*(yy0 - rooz*yy1)
      yz01 = zet*(yz0 - rooz*yz1)
      zx01 = zet*(zx0 - rooz*zx1)
      zy01 = zet*(zy0 - rooz*zy1)
      zz01 = zet*(zz0 - rooz*zz1)

      rxx1 = rkp*xx1
      rxy1 = rkp*xy1
      rxz1 = rkp*xz1
      ryx1 = rkp*yx1
      ryy1 = rkp*yy1
      ryz1 = rkp*yz1
      rzx1 = rkp*zx1
      rzy1 = rkp*zy1
      rzz1 = rkp*zz1

!edsss01 rdsss
      edxx01 = eta*(dxx0 - rooe*dxx1)
      edyy01 = eta*(dyy0 - rooe*dyy1)
      edzz01 = eta*(dzz0 - rooe*dzz1)
      edyx01 = eta*(dyx0 - rooe*dyx1)
      edzx01 = eta*(dzx0 - rooe*dzx1)
      edzy01 = eta*(dzy0 - rooe*dzy1)

      rdxx1 = rkp*dxx1
      rdyy1 = rkp*dyy1
      rdzz1 = rkp*dzz1
      rdyx1 = rkp*dyx1
      rdzx1 = rkp*dzx1
      rdzy1 = rkp*dzy1
!dsps
      dxxpx0 = qcx*dxx0 + wqx*dxx1 + 2.d0*rpx1
      dxxpy0 = qcy*dxx0 + wqy*dxx1
      dxxpz0 = qcz*dxx0 + wqz*dxx1
      dyypx0 = qcx*dyy0 + wqx*dyy1
      dyypy0 = qcy*dyy0 + wqy*dyy1 + 2.d0*rpy1
      dyypz0 = qcz*dyy0 + wqz*dyy1
      dzzpx0 = qcx*dzz0 + wqx*dzz1
      dzzpy0 = qcy*dzz0 + wqy*dzz1
      dzzpz0 = qcz*dzz0 + wqz*dzz1 + 2.d0*rpz1
      dyxpx0 = qcx*dyx0 + wqx*dyx1 +      rpy1
      dyxpy0 = qcy*dyx0 + wqy*dyx1 +      rpx1
      dyxpz0 = qcz*dyx0 + wqz*dyx1
      dzxpx0 = qcx*dzx0 + wqx*dzx1 +      rpz1
      dzxpy0 = qcy*dzx0 + wqy*dzx1
      dzxpz0 = qcz*dzx0 + wqz*dzx1 +      rpx1
      dzypx0 = qcx*dzy0 + wqx*dzy1
      dzypy0 = qcy*dzy0 + wqy*dzy1 +      rpz1
      dzypz0 = qcz*dzy0 + wqz*dzy1 +      rpy1

      dxxpx1 = qcx*dxx1 + wqx*dxx2 + 2.d0*rpx2
      dxxpy1 = qcy*dxx1 + wqy*dxx2
      dxxpz1 = qcz*dxx1 + wqz*dxx2
      dyypx1 = qcx*dyy1 + wqx*dyy2
      dyypy1 = qcy*dyy1 + wqy*dyy2 + 2.d0*rpy2
      dyypz1 = qcz*dyy1 + wqz*dyy2
      dzzpx1 = qcx*dzz1 + wqx*dzz2
      dzzpy1 = qcy*dzz1 + wqy*dzz2
      dzzpz1 = qcz*dzz1 + wqz*dzz2 + 2.d0*rpz2
      dyxpx1 = qcx*dyx1 + wqx*dyx2 +      rpy2
      dyxpy1 = qcy*dyx1 + wqy*dyx2 +      rpx2
      dyxpz1 = qcz*dyx1 + wqz*dyx2
      dzxpx1 = qcx*dzx1 + wqx*dzx2 +      rpz2
      dzxpy1 = qcy*dzx1 + wqy*dzx2
      dzxpz1 = qcz*dzx1 + wqz*dzx2 +      rpx2
      dzypx1 = qcx*dzy1 + wqx*dzy2
      dzypy1 = qcy*dzy1 + wqy*dzy2 +      rpz2
      dzypz1 = qcz*dzy1 + wqz*dzy2 +      rpy2

!fsps
      ed( 1,1)=ed( 1,1)+alp*(pax*dxxpx0+wpx*dxxpx1+2.d0*xx01+rdxx1)
      ed( 2,1)=ed( 2,1)+alp*(pax*dxxpy0+wpx*dxxpy1+2.d0*xy01      )
      ed( 3,1)=ed( 3,1)+alp*(pax*dxxpz0+wpx*dxxpz1+2.d0*xz01      )
      ed( 4,1)=ed( 4,1)+alp*(pay*dyypx0+wpy*dyypx1+2.d0*yx01      )
      ed( 5,1)=ed( 5,1)+alp*(pay*dyypy0+wpy*dyypy1+2.d0*yy01+rdyy1)
      ed( 6,1)=ed( 6,1)+alp*(pay*dyypz0+wpy*dyypz1+2.d0*yz01      )
      ed( 7,1)=ed( 7,1)+alp*(paz*dzzpx0+wpz*dzzpx1+2.d0*zx01      )
      ed( 8,1)=ed( 8,1)+alp*(paz*dzzpy0+wpz*dzzpy1+2.d0*zy01      )
      ed( 9,1)=ed( 9,1)+alp*(paz*dzzpz0+wpz*dzzpz1+2.d0*zz01+rdzz1)
      ed(10,1)=ed(10,1)+alp*(pay*dxxpx0+wpy*dxxpx1                )
      ed(11,1)=ed(11,1)+alp*(pay*dxxpy0+wpy*dxxpy1          +rdxx1)
      ed(12,1)=ed(12,1)+alp*(pay*dxxpz0+wpy*dxxpz1                )
      ed(13,1)=ed(13,1)+alp*(paz*dxxpx0+wpz*dxxpx1                )
      ed(14,1)=ed(14,1)+alp*(paz*dxxpy0+wpz*dxxpy1                )
      ed(15,1)=ed(15,1)+alp*(paz*dxxpz0+wpz*dxxpz1          +rdxx1)
      ed(16,1)=ed(16,1)+alp*(pax*dyypx0+wpx*dyypx1          +rdyy1)
      ed(17,1)=ed(17,1)+alp*(pax*dyypy0+wpx*dyypy1                )
      ed(18,1)=ed(18,1)+alp*(pax*dyypz0+wpx*dyypz1                )
      ed(19,1)=ed(19,1)+alp*(paz*dyypx0+wpz*dyypx1                )
      ed(20,1)=ed(20,1)+alp*(paz*dyypy0+wpz*dyypy1                )
      ed(21,1)=ed(21,1)+alp*(paz*dyypz0+wpz*dyypz1          +rdyy1)
      ed(22,1)=ed(22,1)+alp*(pax*dzzpx0+wpx*dzzpx1          +rdzz1)
      ed(23,1)=ed(23,1)+alp*(pax*dzzpy0+wpx*dzzpy1                )
      ed(24,1)=ed(24,1)+alp*(pax*dzzpz0+wpx*dzzpz1                )
      ed(25,1)=ed(25,1)+alp*(pay*dzzpx0+wpy*dzzpx1                )
      ed(26,1)=ed(26,1)+alp*(pay*dzzpy0+wpy*dzzpy1          +rdzz1)
      ed(27,1)=ed(27,1)+alp*(pay*dzzpz0+wpy*dzzpz1                )
      ed(28,1)=ed(28,1)+alp*(paz*dyxpx0+wpz*dyxpx1                )
      ed(29,1)=ed(29,1)+alp*(paz*dyxpy0+wpz*dyxpy1                )
      ed(30,1)=ed(30,1)+alp*(paz*dyxpz0+wpz*dyxpz1          +rdyx1)
!dpps
      ed( 1,2)=ed( 1,2)+bet*(pbx*dxxpx0+wpx*dxxpx1+2.d0*xx01+rdxx1)
      ed( 2,2)=ed( 2,2)+bet*(pbx*dxxpy0+wpx*dxxpy1+2.d0*xy01      )
      ed( 3,2)=ed( 3,2)+bet*(pbx*dxxpz0+wpx*dxxpz1+2.d0*xz01      )
      ed( 4,2)=ed( 4,2)+bet*(pby*dxxpx0+wpy*dxxpx1                )
      ed( 5,2)=ed( 5,2)+bet*(pby*dxxpy0+wpy*dxxpy1          +rdxx1)
      ed( 6,2)=ed( 6,2)+bet*(pby*dxxpz0+wpy*dxxpz1                )
      ed( 7,2)=ed( 7,2)+bet*(pbz*dxxpx0+wpz*dxxpx1                )
      ed( 8,2)=ed( 8,2)+bet*(pbz*dxxpy0+wpz*dxxpy1                )
      ed( 9,2)=ed( 9,2)+bet*(pbz*dxxpz0+wpz*dxxpz1          +rdxx1)
      ed(10,2)=ed(10,2)+bet*(pbx*dyypx0+wpx*dyypx1          +rdyy1)
      ed(11,2)=ed(11,2)+bet*(pbx*dyypy0+wpx*dyypy1                )
      ed(12,2)=ed(12,2)+bet*(pbx*dyypz0+wpx*dyypz1                )
      ed(13,2)=ed(13,2)+bet*(pby*dyypx0+wpy*dyypx1+2.d0*yx01      )
      ed(14,2)=ed(14,2)+bet*(pby*dyypy0+wpy*dyypy1+2.d0*yy01+rdyy1)
      ed(15,2)=ed(15,2)+bet*(pby*dyypz0+wpy*dyypz1+2.d0*yz01      )
      ed(16,2)=ed(16,2)+bet*(pbz*dyypx0+wpz*dyypx1                )
      ed(17,2)=ed(17,2)+bet*(pbz*dyypy0+wpz*dyypy1                )
      ed(18,2)=ed(18,2)+bet*(pbz*dyypz0+wpz*dyypz1          +rdyy1)
      ed(19,2)=ed(19,2)+bet*(pbx*dzzpx0+wpx*dzzpx1          +rdzz1)
      ed(20,2)=ed(20,2)+bet*(pbx*dzzpy0+wpx*dzzpy1                )
      ed(21,2)=ed(21,2)+bet*(pbx*dzzpz0+wpx*dzzpz1                )
      ed(22,2)=ed(22,2)+bet*(pby*dzzpx0+wpy*dzzpx1                )
      ed(23,2)=ed(23,2)+bet*(pby*dzzpy0+wpy*dzzpy1          +rdzz1)
      ed(24,2)=ed(24,2)+bet*(pby*dzzpz0+wpy*dzzpz1                )
      ed(25,2)=ed(25,2)+bet*(pbz*dzzpx0+wpz*dzzpx1+2.d0*zx01      )
      ed(26,2)=ed(26,2)+bet*(pbz*dzzpy0+wpz*dzzpy1+2.d0*zy01      )
      ed(27,2)=ed(27,2)+bet*(pbz*dzzpz0+wpz*dzzpz1+2.d0*zz01+rdzz1)
      ed(28,2)=ed(28,2)+bet*(pbx*dyxpx0+wpx*dyxpx1+     yx01+rdyx1)
      ed(29,2)=ed(29,2)+bet*(pbx*dyxpy0+wpx*dyxpy1+     yy01      )
      ed(30,2)=ed(30,2)+bet*(pbx*dyxpz0+wpx*dyxpz1+     yz01      )
      ed(31,2)=ed(31,2)+bet*(pby*dyxpx0+wpy*dyxpx1+     xx01      )
      ed(32,2)=ed(32,2)+bet*(pby*dyxpy0+wpy*dyxpy1+     xy01+rdyx1)
      ed(33,2)=ed(33,2)+bet*(pby*dyxpz0+wpy*dyxpz1+     xz01      )
      ed(34,2)=ed(34,2)+bet*(pbz*dyxpx0+wpz*dyxpx1                )
      ed(35,2)=ed(35,2)+bet*(pbz*dyxpy0+wpz*dyxpy1                )
      ed(36,2)=ed(36,2)+bet*(pbz*dyxpz0+wpz*dyxpz1          +rdyx1)
      ed(37,2)=ed(37,2)+bet*(pbx*dzxpx0+wpx*dzxpx1+     zx01+rdzx1)
      ed(38,2)=ed(38,2)+bet*(pbx*dzxpy0+wpx*dzxpy1+     zy01      )
      ed(39,2)=ed(39,2)+bet*(pbx*dzxpz0+wpx*dzxpz1+     zz01      )
      ed(40,2)=ed(40,2)+bet*(pby*dzxpx0+wpy*dzxpx1                )
      ed(41,2)=ed(41,2)+bet*(pby*dzxpy0+wpy*dzxpy1          +rdzx1)
      ed(42,2)=ed(42,2)+bet*(pby*dzxpz0+wpy*dzxpz1                )
      ed(43,2)=ed(43,2)+bet*(pbz*dzxpx0+wpz*dzxpx1+     xx01      )
      ed(44,2)=ed(44,2)+bet*(pbz*dzxpy0+wpz*dzxpy1+     xy01      )
      ed(45,2)=ed(45,2)+bet*(pbz*dzxpz0+wpz*dzxpz1+     xz01+rdzx1)
      ed(46,2)=ed(46,2)+bet*(pbx*dzypx0+wpx*dzypx1          +rdzy1)
      ed(47,2)=ed(47,2)+bet*(pbx*dzypy0+wpx*dzypy1                )
      ed(48,2)=ed(48,2)+bet*(pbx*dzypz0+wpx*dzypz1                )
      ed(49,2)=ed(49,2)+bet*(pby*dzypx0+wpy*dzypx1+     zx01      )
      ed(50,2)=ed(50,2)+bet*(pby*dzypy0+wpy*dzypy1+     zy01+rdzy1)
      ed(51,2)=ed(51,2)+bet*(pby*dzypz0+wpy*dzypz1+     zz01      )
      ed(52,2)=ed(52,2)+bet*(pbz*dzypx0+wpz*dzypx1+     yx01      )
      ed(53,2)=ed(53,2)+bet*(pbz*dzypy0+wpz*dzypy1+     yy01      )
      ed(54,2)=ed(54,2)+bet*(pbz*dzypz0+wpz*dzypz1+     yz01+rdzy1)
!dsds
      ed( 1,3)=ed( 1,3)+ram*(qcx*dxxpx0+wqx*dxxpx1+2.d0*rxx1+edxx01)
      ed( 2,3)=ed( 2,3)+ram*(qcy*dxxpy0+wqy*dxxpy1          +edxx01)
      ed( 3,3)=ed( 3,3)+ram*(qcz*dxxpz0+wqz*dxxpz1          +edxx01)
      ed( 4,3)=ed( 4,3)+ram*(qcy*dxxpx0+wqy*dxxpx1                 )
      ed( 5,3)=ed( 5,3)+ram*(qcz*dxxpx0+wqz*dxxpx1                 )
      ed( 6,3)=ed( 6,3)+ram*(qcy*dxxpz0+wqy*dxxpz1                 )
      ed( 7,3)=ed( 7,3)+ram*(qcx*dyypx0+wqx*dyypx1          +edyy01)
      ed( 8,3)=ed( 8,3)+ram*(qcy*dyypy0+wqy*dyypy1+2.d0*ryy1+edyy01)
      ed( 9,3)=ed( 9,3)+ram*(qcz*dyypz0+wqz*dyypz1          +edyy01)
      ed(10,3)=ed(10,3)+ram*(qcx*dyypy0+wqx*dyypy1                 )
      ed(11,3)=ed(11,3)+ram*(qcx*dyypz0+wqx*dyypz1                 )
      ed(12,3)=ed(12,3)+ram*(qcz*dyypy0+wqz*dyypy1                 )
      ed(13,3)=ed(13,3)+ram*(qcx*dzzpx0+wqx*dzzpx1          +edzz01)
      ed(14,3)=ed(14,3)+ram*(qcy*dzzpy0+wqy*dzzpy1          +edzz01)
      ed(15,3)=ed(15,3)+ram*(qcz*dzzpz0+wqz*dzzpz1+2.d0*rzz1+edzz01)
      ed(16,3)=ed(16,3)+ram*(qcx*dzzpy0+wqx*dzzpy1                 )
      ed(17,3)=ed(17,3)+ram*(qcx*dzzpz0+wqx*dzzpz1                 )
      ed(18,3)=ed(18,3)+ram*(qcy*dzzpz0+wqy*dzzpz1                 )
      ed(19,3)=ed(19,3)+ram*(qcx*dyxpx0+wqx*dyxpx1+     ryx1+edyx01)
      ed(20,3)=ed(20,3)+ram*(qcy*dyxpy0+wqy*dyxpy1+     rxy1+edyx01)
      ed(21,3)=ed(21,3)+ram*(qcz*dyxpz0+wqz*dyxpz1          +edyx01)
      ed(22,3)=ed(22,3)+ram*(qcx*dyxpy0+wqx*dyxpy1+     ryy1       )
      ed(23,3)=ed(23,3)+ram*(qcz*dyxpx0+wqz*dyxpx1                 )
      ed(24,3)=ed(24,3)+ram*(qcz*dyxpy0+wqz*dyxpy1                 )
      ed(25,3)=ed(25,3)+ram*(qcx*dzxpx0+wqx*dzxpx1+     rzx1+edzx01)
      ed(26,3)=ed(26,3)+ram*(qcy*dzxpy0+wqy*dzxpy1          +edzx01)
      ed(27,3)=ed(27,3)+ram*(qcz*dzxpz0+wqz*dzxpz1+     rxz1+edzx01)
      ed(28,3)=ed(28,3)+ram*(qcy*dzxpx0+wqy*dzxpx1                 )
      ed(29,3)=ed(29,3)+ram*(qcx*dzxpz0+wqx*dzxpz1+     rzz1       )
      ed(30,3)=ed(30,3)+ram*(qcy*dzxpz0+wqy*dzxpz1                 )
      ed(31,3)=ed(31,3)+ram*(qcx*dzypx0+wqx*dzypx1          +edzy01)
      ed(32,3)=ed(32,3)+ram*(qcy*dzypy0+wqy*dzypy1+     rzy1+edzy01)
      ed(33,3)=ed(33,3)+ram*(qcz*dzypz0+wqz*dzypz1+     ryz1+edzy01)
      ed(34,3)=ed(34,3)+ram*(qcx*dzypy0+wqx*dzypy1                 )
      ed(35,3)=ed(35,3)+ram*(qcx*dzypz0+wqx*dzypz1                 )
      ed(36,3)=ed(36,3)+ram*(qcy*dzypz0+wqy*dzypz1+     rzz1       )

                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
#endif
!fsps
      if (jal.eq.0) then

      ec( 1,1)=ed( 1,1) - 2.d0*pspsxx00
      ec( 2,1)=ed(10,1)
      ec( 3,1)=ed(13,1)
      ec( 4,1)=ed( 2,1) - 2.d0*pspsxy00
      ec( 5,1)=ed(11,1)
      ec( 6,1)=ed(14,1)
      ec( 7,1)=ed( 3,1) - 2.d0*pspsxz00
      ec( 8,1)=ed(12,1)
      ec( 9,1)=ed(15,1)
      ec(10,1)=ed(16,1)
      ec(11,1)=ed( 4,1) - 2.d0*pspsyx00
      ec(12,1)=ed(19,1)
      ec(13,1)=ed(17,1)
      ec(14,1)=ed( 5,1) - 2.d0*pspsyy00
      ec(15,1)=ed(20,1)
      ec(16,1)=ed(18,1)
      ec(17,1)=ed( 6,1) - 2.d0*pspsyz00
      ec(18,1)=ed(21,1)
      ec(19,1)=ed(22,1)
      ec(20,1)=ed(25,1)
      ec(21,1)=ed( 7,1) - 2.d0*pspszx00
      ec(22,1)=ed(23,1)
      ec(23,1)=ed(26,1)
      ec(24,1)=ed( 8,1) - 2.d0*pspszy00
      ec(25,1)=ed(24,1)
      ec(26,1)=ed(27,1)
      ec(27,1)=ed( 9,1) - 2.d0*pspszz00
      ec(28,1)=ed(10,1) -      pspsyx00
      ec(29,1)=ed(16,1) -      pspsxx00
      ec(30,1)=ed(28,1)
      ec(31,1)=ed(11,1) -      pspsyy00
      ec(32,1)=ed(17,1) -      pspsxy00
      ec(33,1)=ed(29,1)
      ec(34,1)=ed(12,1) -      pspsyz00
      ec(35,1)=ed(18,1) -      pspsxz00
      ec(36,1)=ed(30,1)
      ec(37,1)=ed(13,1) -      pspszx00
      ec(38,1)=ed(28,1)
      ec(39,1)=ed(22,1) -      pspsxx00
      ec(40,1)=ed(14,1) -      pspszy00
      ec(41,1)=ed(29,1)
      ec(42,1)=ed(23,1) -      pspsxy00
      ec(43,1)=ed(15,1) -      pspszz00
      ec(44,1)=ed(30,1)
      ec(45,1)=ed(24,1) -      pspsxz00
      ec(46,1)=ed(28,1)
      ec(47,1)=ed(19,1) -      pspszx00
      ec(48,1)=ed(25,1) -      pspsyx00
      ec(49,1)=ed(29,1)
      ec(50,1)=ed(20,1) -      pspszy00
      ec(51,1)=ed(26,1) -      pspsyy00
      ec(52,1)=ed(30,1)
      ec(53,1)=ed(21,1) -      pspszz00
      ec(54,1)=ed(27,1) -      pspsyz00
!dpps
      ec( 1,2)=ed( 1,2)
      ec( 2,2)=ed( 4,2)
      ec( 3,2)=ed( 7,2)
      ec( 4,2)=ed( 2,2)
      ec( 5,2)=ed( 5,2)
      ec( 6,2)=ed( 8,2)
      ec( 7,2)=ed( 3,2)
      ec( 8,2)=ed( 6,2)
      ec( 9,2)=ed( 9,2)
      ec(10,2)=ed(10,2)
      ec(11,2)=ed(13,2)
      ec(12,2)=ed(16,2)
      ec(13,2)=ed(11,2)
      ec(14,2)=ed(14,2)
      ec(15,2)=ed(17,2)
      ec(16,2)=ed(12,2)
      ec(17,2)=ed(15,2)
      ec(18,2)=ed(18,2)
      ec(19,2)=ed(19,2)
      ec(20,2)=ed(22,2)
      ec(21,2)=ed(25,2)
      ec(22,2)=ed(20,2)
      ec(23,2)=ed(23,2)
      ec(24,2)=ed(26,2)
      ec(25,2)=ed(21,2)
      ec(26,2)=ed(24,2)
      ec(27,2)=ed(27,2)
      ec(28,2)=ed(28,2)
      ec(29,2)=ed(31,2)
      ec(30,2)=ed(34,2)
      ec(31,2)=ed(29,2)
      ec(32,2)=ed(32,2)
      ec(33,2)=ed(35,2)
      ec(34,2)=ed(30,2)
      ec(35,2)=ed(33,2)
      ec(36,2)=ed(36,2)
      ec(37,2)=ed(37,2)
      ec(38,2)=ed(40,2)
      ec(39,2)=ed(43,2)
      ec(40,2)=ed(38,2)
      ec(41,2)=ed(41,2)
      ec(42,2)=ed(44,2)
      ec(43,2)=ed(39,2)
      ec(44,2)=ed(42,2)
      ec(45,2)=ed(45,2)
      ec(46,2)=ed(46,2)
      ec(47,2)=ed(49,2)
      ec(48,2)=ed(52,2)
      ec(49,2)=ed(47,2)
      ec(50,2)=ed(50,2)
      ec(51,2)=ed(53,2)
      ec(52,2)=ed(48,2)
      ec(53,2)=ed(51,2)
      ec(54,2)=ed(54,2)
     
!dsds
      ec( 1,3)=ed( 1,3) - dxx00
      ec( 2,3)=ed( 4,3)
      ec( 3,3)=ed( 5,3)
      ec( 4,3)=ed( 4,3)
      ec( 5,3)=ed( 2,3) - dxx00
      ec( 6,3)=ed( 6,3)
      ec( 7,3)=ed( 5,3)
      ec( 8,3)=ed( 6,3)
      ec( 9,3)=ed( 3,3) - dxx00
      ec(10,3)=ed( 7,3) - dyy00
      ec(11,3)=ed(10,3)
      ec(12,3)=ed(11,3)
      ec(13,3)=ed(10,3)
      ec(14,3)=ed( 8,3) - dyy00
      ec(15,3)=ed(12,3)
      ec(16,3)=ed(11,3)
      ec(17,3)=ed(12,3)
      ec(18,3)=ed( 9,3) - dyy00
      ec(19,3)=ed(13,3) - dzz00
      ec(20,3)=ed(16,3)
      ec(21,3)=ed(17,3)
      ec(22,3)=ed(16,3)
      ec(23,3)=ed(14,3) - dzz00
      ec(24,3)=ed(18,3)
      ec(25,3)=ed(17,3)
      ec(26,3)=ed(18,3)
      ec(27,3)=ed(15,3) - dzz00
      ec(28,3)=ed(19,3) - dyx00
      ec(29,3)=ed(22,3)
      ec(30,3)=ed(23,3)
      ec(31,3)=ed(22,3)
      ec(32,3)=ed(20,3) - dyx00
      ec(33,3)=ed(24,3)
      ec(34,3)=ed(23,3)
      ec(35,3)=ed(24,3)
      ec(36,3)=ed(21,3) - dyx00
      ec(37,3)=ed(25,3) - dzx00
      ec(38,3)=ed(28,3)
      ec(39,3)=ed(29,3)
      ec(40,3)=ed(28,3)
      ec(41,3)=ed(26,3) - dzx00
      ec(42,3)=ed(30,3)
      ec(43,3)=ed(29,3)
      ec(44,3)=ed(30,3)
      ec(45,3)=ed(27,3) - dzx00
      ec(46,3)=ed(31,3) - dzy00
      ec(47,3)=ed(34,3)
      ec(48,3)=ed(35,3)
      ec(49,3)=ed(34,3)
      ec(50,3)=ed(32,3) - dzy00
      ec(51,3)=ed(36,3)
      ec(52,3)=ed(35,3)
      ec(53,3)=ed(36,3)
      ec(54,3)=ed(33,3) - dzy00

!c$$$      do j=1,mao3
!c$$$         do i=1,3
!c$$$            ec(j,4) = ec(j,4) - ec(j,i)
!c$$$         enddo
!c$$$      enddo
!c$$$ 
!c$$$      do i=1,4
!c$$$         do j=28,mao3
!c$$$            ec(j,i) = ec(j,i) * root3
!c$$$         enddo
!c$$$      enddo

       else
      ec( 1,1)=ed( 1,1) - 2.d0*pspsxx00
      ec( 2,1)=ed(10,1)
      ec( 3,1)=ed(13,1)
      ec( 4,1)=ed(16,1)
      ec( 5,1)=ed( 4,1) - 2.d0*pspsyx00
      ec( 6,1)=ed(19,1)
      ec( 7,1)=ed(22,1)
      ec( 8,1)=ed(25,1)
      ec( 9,1)=ed( 7,1) - 2.d0*pspszx00
      ec(10,1)=ed(10,1) -      pspsyx00
      ec(11,1)=ed(16,1) -      pspsxx00
      ec(12,1)=ed(28,1)
      ec(13,1)=ed(13,1) -      pspszx00
      ec(14,1)=ed(28,1)
      ec(15,1)=ed(22,1) -      pspsxx00
      ec(16,1)=ed(28,1)
      ec(17,1)=ed(19,1) -      pspszx00
      ec(18,1)=ed(25,1) -      pspsyx00
      ec(19,1)=ed( 2,1) - 2.d0*pspsxy00
      ec(20,1)=ed(11,1)
      ec(21,1)=ed(14,1)
      ec(22,1)=ed(17,1)
      ec(23,1)=ed( 5,1) - 2.d0*pspsyy00
      ec(24,1)=ed(20,1)
      ec(25,1)=ed(23,1)
      ec(26,1)=ed(26,1)
      ec(27,1)=ed( 8,1) - 2.d0*pspszy00
      ec(28,1)=ed(11,1) -      pspsyy00
      ec(29,1)=ed(17,1) -      pspsxy00
      ec(30,1)=ed(29,1)
      ec(31,1)=ed(14,1) -      pspszy00
      ec(32,1)=ed(29,1)
      ec(33,1)=ed(23,1) -      pspsxy00
      ec(34,1)=ed(29,1)
      ec(35,1)=ed(20,1) -      pspszy00
      ec(36,1)=ed(26,1) -      pspsyy00
      ec(37,1)=ed( 3,1) - 2.d0*pspsxz00
      ec(38,1)=ed(12,1)
      ec(39,1)=ed(15,1)
      ec(40,1)=ed(18,1)
      ec(41,1)=ed( 6,1) - 2.d0*pspsyz00
      ec(42,1)=ed(21,1)
      ec(43,1)=ed(24,1)
      ec(44,1)=ed(27,1)
      ec(45,1)=ed( 9,1) - 2.d0*pspszz00
      ec(46,1)=ed(12,1) -      pspsyz00
      ec(47,1)=ed(18,1) -      pspsxz00
      ec(48,1)=ed(30,1)
      ec(49,1)=ed(15,1) -      pspszz00
      ec(50,1)=ed(30,1)
      ec(51,1)=ed(24,1) -      pspsxz00
      ec(52,1)=ed(30,1)
      ec(53,1)=ed(21,1) -      pspszz00
      ec(54,1)=ed(27,1) -      pspsyz00
!dpps 
      ec( 1,2)=ed( 1,2)
      ec( 2,2)=ed( 4,2)
      ec( 3,2)=ed( 7,2)
      ec( 4,2)=ed(10,2)
      ec( 5,2)=ed(13,2)
      ec( 6,2)=ed(16,2)
      ec( 7,2)=ed(19,2)
      ec( 8,2)=ed(22,2)
      ec( 9,2)=ed(25,2)
      ec(10,2)=ed(28,2)
      ec(11,2)=ed(31,2)
      ec(12,2)=ed(34,2)
      ec(13,2)=ed(37,2)
      ec(14,2)=ed(40,2)
      ec(15,2)=ed(43,2)
      ec(16,2)=ed(46,2)
      ec(17,2)=ed(49,2)
      ec(18,2)=ed(52,2)
      ec(19,2)=ed( 2,2)
      ec(20,2)=ed( 5,2)
      ec(21,2)=ed( 8,2)
      ec(22,2)=ed(11,2)
      ec(23,2)=ed(14,2)
      ec(24,2)=ed(17,2)
      ec(25,2)=ed(20,2)
      ec(26,2)=ed(23,2)
      ec(27,2)=ed(26,2)
      ec(28,2)=ed(29,2)
      ec(29,2)=ed(32,2)
      ec(30,2)=ed(35,2)
      ec(31,2)=ed(38,2)
      ec(32,2)=ed(41,2)
      ec(33,2)=ed(44,2)
      ec(34,2)=ed(47,2)
      ec(35,2)=ed(50,2)
      ec(36,2)=ed(53,2)
      ec(37,2)=ed( 3,2)
      ec(38,2)=ed( 6,2)
      ec(39,2)=ed( 9,2)
      ec(40,2)=ed(12,2)
      ec(41,2)=ed(15,2)
      ec(42,2)=ed(18,2)
      ec(43,2)=ed(21,2)
      ec(44,2)=ed(24,2)
      ec(45,2)=ed(27,2)
      ec(46,2)=ed(30,2)
      ec(47,2)=ed(33,2)
      ec(48,2)=ed(36,2)
      ec(49,2)=ed(39,2)
      ec(50,2)=ed(42,2)
      ec(51,2)=ed(45,2)
      ec(52,2)=ed(48,2)
      ec(53,2)=ed(51,2)
      ec(54,2)=ed(54,2)
!dsds
      ec( 1,3)=ed( 1,3) -dxx00
      ec( 2,3)=ed( 4,3)
      ec( 3,3)=ed( 5,3)
      ec( 4,3)=ed( 7,3) -dyy00
      ec( 5,3)=ed(10,3)
      ec( 6,3)=ed(11,3)
      ec( 7,3)=ed(13,3) -dzz00
      ec( 8,3)=ed(16,3)
      ec( 9,3)=ed(17,3)
      ec(10,3)=ed(19,3) -dyx00
      ec(11,3)=ed(22,3)
      ec(12,3)=ed(23,3)
      ec(13,3)=ed(25,3) -dzx00
      ec(14,3)=ed(28,3)
      ec(15,3)=ed(29,3)
      ec(16,3)=ed(31,3) -dzy00
      ec(17,3)=ed(34,3)
      ec(18,3)=ed(35,3)
      ec(19,3)=ed( 4,3)
      ec(20,3)=ed( 2,3) -dxx00
      ec(21,3)=ed( 6,3)
      ec(22,3)=ed(10,3)
      ec(23,3)=ed( 8,3) -dyy00
      ec(24,3)=ed(12,3)
      ec(25,3)=ed(16,3)
      ec(26,3)=ed(14,3) -dzz00
      ec(27,3)=ed(18,3)
      ec(28,3)=ed(22,3)
      ec(29,3)=ed(20,3) -dyx00
      ec(30,3)=ed(24,3)
      ec(31,3)=ed(28,3)
      ec(32,3)=ed(26,3) -dzx00
      ec(33,3)=ed(30,3)
      ec(34,3)=ed(34,3)
      ec(35,3)=ed(32,3) -dzy00
      ec(36,3)=ed(36,3)
      ec(37,3)=ed( 5,3)
      ec(38,3)=ed( 6,3)
      ec(39,3)=ed( 3,3) -dxx00
      ec(40,3)=ed(11,3)
      ec(41,3)=ed(12,3)
      ec(42,3)=ed( 9,3) -dyy00
      ec(43,3)=ed(17,3)
      ec(44,3)=ed(18,3)
      ec(45,3)=ed(15,3) -dzz00
      ec(46,3)=ed(23,3)
      ec(47,3)=ed(24,3)
      ec(48,3)=ed(21,3) -dyx00
      ec(49,3)=ed(29,3)
      ec(50,3)=ed(30,3)
      ec(51,3)=ed(27,3) -dzx00
      ec(52,3)=ed(35,3)
      ec(53,3)=ed(36,3)
      ec(54,3)=ed(33,3) -dzy00

!c$$$      do i=1,3
!c$$$         do j=1,mao3
!c$$$            ec(j,4) = ec(j,4) - ec(j,i)
!c$$$         enddo
!c$$$      enddo
!c$$$ 
!c$$$      do i=1,4
!c$$$         do k=1,3
!c$$$            do j=10,18
!c$$$               key = j+(k-1)*18
!c$$$               ec(key,i) = ec(key,i) * root3
!c$$$            enddo
!c$$$         enddo
!c$$$      enddo

      endif
#ifdef PL_OMP_DERI
!$omp end parallel
#endif

      if (jal.eq.0) then
      do j=1,mao3
         do i=1,3
            ec(j,4) = ec(j,4) - ec(j,i)
         enddo
      enddo
 
      do i=1,4
         do j=28,mao3
            ec(j,i) = ec(j,i) * root3
         enddo
      enddo

      else

      do i=1,3
         do j=1,mao3
            ec(j,4) = ec(j,4) - ec(j,i)
         enddo
      enddo
 
      do i=1,4
         do k=1,3
            do j=10,18
               key = j+(k-1)*18
               ec(key,i) = ec(key,i) * root3
            enddo
         enddo
      enddo
      endif

      end
!= iofsss ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine jodpss(
     &     ec   ,
     &     fdat , edat  , 
     &     z    , xyz   , zetpq,
     &     yp   , yq    , uu   , uv,
     &     ntprm,
     &     nfsz , nesz  ,jpq,
     &     nasp , mxsa  , mxprm , natom, mao3,
     &     ishel, jshel , kshel , lshel,
     &     iatom, jatom , katom , latom,
     &     iasp , jasp  , kasp  , lasp )


      implicit real(8) (a-h,o-z)           
c$$$      dimension fdat(31,2001)
c$$$      dimension edat(2001)
      dimension fdat(nfsz,nesz)
      dimension edat(nesz)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
c$$$      dimension ntprm(mxsa,natom)
      dimension ntprm(mxsa,nasp)

      dimension ec(mao3,4),ed(mao3,3)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(5) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /)

      real(8),parameter::root3 = 1.73205080756887729353d+00

#ifdef PL_SIMD_DERI
      dimension dmx(5,mxprm), val(5,mxprm)
#endif

#ifdef PL_OMP_DERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,jpq,mao3,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do j = 1,3
         do i = 1,mao3
!c$$$            ec(i,j) = 0.0d0
            ed(i,j) = 0.0d0
         enddo
      enddo

      sppsxx00 = 0.d0
      sppsxy00 = 0.d0
      sppsxz00 = 0.d0
      sppsyx00 = 0.d0
      sppsyy00 = 0.d0
      sppsyz00 = 0.d0
      sppszx00 = 0.d0
      sppszy00 = 0.d0
      sppszz00 = 0.d0
      ppxx00 = 0.d0
      ppxy00 = 0.d0
      ppxz00 = 0.d0
      ppyx00 = 0.d0
      ppyy00 = 0.d0
      ppyz00 = 0.d0
      ppzx00 = 0.d0
      ppzy00 = 0.d0
      ppzz00 = 0.d0
      pspsxx00 =0.d0 
      pspsxy00 =0.d0 
      pspsxz00 =0.d0 
      pspsyx00 =0.d0 
      pspsyy00 =0.d0 
      pspsyz00 =0.d0 
      pspszx00 =0.d0 
      pspszy00 =0.d0 
      pspszz00 =0.d0 
      dxx00 = 0.0d0
      dyy00 = 0.0d0
      dzz00 = 0.0d0
      dyx00 = 0.0d0
      dzx00 = 0.0d0
      dzy00 = 0.0d0


#ifdef PL_OMP_DERI
!$omp do
#endif
      do i = 1, igp
         alp = z(i,ishel,iasp)
         do j = 1, jgp
            bet = z(j,jshel,jasp)
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               ram = z(k,kshel,kasp)
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

!c$$$                  qcx = yq(1,l,k) - xyz(1,katom)
!c$$$                  qcy = yq(2,l,k) - xyz(2,katom)
!c$$$                  qcz = yq(3,l,k) - xyz(3,katom)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(5)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f4   = (((((fdat(11,it)*dt6   + fdat(10,it))*dt5
     &                    + fdat(9,it))*dt4  + fdat(8,it))*dt3
     &                    + fdat(7,it))*dt2  + fdat(6,it))*dt
     &                    + fdat(5,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0

                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f3   =  (t2*f4 + ee)*rminv(4)
                     f2   =  (t2*f3 + ee)*rminv(3)
                     f1   =  (t2*f2 + ee)*rminv(2)
                     f0   =   t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0

                     dm1 = fpp*f1
                     dm2 = fpp*f2
                     dm3 = fpp*f3
                     dm4 = fpp*f4
                     
                  else
!                    qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     qinv = 0.5d0*roo2*tinv

                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0

                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
 
                  end if
                  
#ifdef PL_SIMD_DERI
                  val(1,l) = qpx
                  val(2,l) = qpy
                  val(3,l) = qpz
                  val(4,l) = roo2
                  val(5,l) = eta
 
                  dmx(1,l) = dm0
                  dmx(2,l) = dm1
                  dmx(3,l) = dm2
                  dmx(4,l) = dm3
                  dmx(5,l) = dm4
               enddo

               do l = 1, lgp
                  qpx  = val(1,l)
                  qpy  = val(2,l)
                  qpz  = val(3,l)
                  roo2 = val(4,l)
                  eta  = val(5,l)

                  dm0 = dmx(1,l)
                  dm1 = dmx(2,l)
                  dm2 = dmx(3,l)
                  dm3 = dmx(4,l)
                  dm4 = dmx(5,l)
#endif
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)

                  s0 = dm0
                  s1 = dm1
                  s2 = dm2
                  s3 = dm3
                  s4 = dm4

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
                  rkp =  rooz * eta
!psss
      px0=pax*s0 + wpx*s1
      py0=pay*s0 + wpy*s1
      pz0=paz*s0 + wpz*s1
      px1=pax*s1 + wpx*s2
      py1=pay*s1 + wpy*s2
      pz1=paz*s1 + wpz*s2
      px2=pax*s2 + wpx*s3
      py2=pay*s2 + wpy*s3
      pz2=paz*s2 + wpz*s3
      px3=pax*s3 + wpx*s4
      py3=pay*s3 + wpy*s4
      pz3=paz*s3 + wpz*s4
!spss
      xp0=pbx*s0 + wpx*s1
      yp0=pby*s0 + wpy*s1
      zp0=pbz*s0 + wpz*s1
      xp1=pbx*s1 + wpx*s2
      yp1=pby*s1 + wpy*s2
      zp1=pbz*s1 + wpz*s2
      xp2=pbx*s2 + wpx*s3
      yp2=pby*s2 + wpy*s3
      zp2=pbz*s2 + wpz*s3
!psss01
      px01 = zet*(px0 - rooz*px1)
      py01 = zet*(py0 - rooz*py1)
      pz01 = zet*(pz0 - rooz*pz1)
      px12 = zet*(px1 - rooz*px2)
      py12 = zet*(py1 - rooz*py2)
      pz12 = zet*(pz1 - rooz*pz2)
!spss01
      xp01 = zet*(xp0 - rooz*xp1)
      yp01 = zet*(yp0 - rooz*yp1)
      zp01 = zet*(zp0 - rooz*zp1)
      xp12 = zet*(xp1 - rooz*xp2)
      yp12 = zet*(yp1 - rooz*yp2)
      zp12 = zet*(zp1 - rooz*zp2)

!ssss01
      s01 = zet*(s0 - rooz*s1)
      s12 = zet*(s1 - rooz*s2)
      s23 = zet*(s2 - rooz*s3)
!     s34 = zet*(s3 - rooz*s4)
!dsss
      dxx0 = pax*px0 + wpx*px1 + s01
      dyy0 = pay*py0 + wpy*py1 + s01
      dzz0 = paz*pz0 + wpz*pz1 + s01
      dyx0 = pay*px0 + wpy*px1
      dzx0 = paz*px0 + wpz*px1
      dzy0 = paz*py0 + wpz*py1

      dxx00 = dxx00 + dxx0
      dyy00 = dyy00 + dyy0
      dzz00 = dzz00 + dzz0
      dyx00 = dyx00 + dyx0
      dzx00 = dzx00 + dzx0
      dzy00 = dzy00 + dzy0

      dxx1 = pax*px1 + wpx*px2 + s12
      dyy1 = pay*py1 + wpy*py2 + s12
      dzz1 = paz*pz1 + wpz*pz2 + s12
      dyx1 = pay*px1 + wpy*px2
      dzx1 = paz*px1 + wpz*px2
      dzy1 = paz*py1 + wpz*py2

      dxx2 = pax*px2 + wpx*px3 + s23
      dyy2 = pay*py2 + wpy*py3 + s23
      dzz2 = paz*pz2 + wpz*pz3 + s23
      dyx2 = pay*px2 + wpy*px3
      dzx2 = paz*px2 + wpz*px3
      dzy2 = paz*py2 + wpz*py3
!ppss
      xx0 = pbx*px0 + wpx*px1 + s01
      xy0 = pby*px0 + wpy*px1
      xz0 = pbz*px0 + wpz*px1
      yx0 = pbx*py0 + wpx*py1
      yy0 = pby*py0 + wpy*py1 + s01
      yz0 = pbz*py0 + wpz*py1
      zx0 = pbx*pz0 + wpx*pz1
      zy0 = pby*pz0 + wpy*pz1
      zz0 = pbz*pz0 + wpz*pz1 + s01

      ppxx00 = ppxx00 + xx0
      ppxy00 = ppxy00 + xy0
      ppxz00 = ppxz00 + xz0
      ppyx00 = ppyx00 + yx0
      ppyy00 = ppyy00 + yy0
      ppyz00 = ppyz00 + yz0
      ppzx00 = ppzx00 + zx0
      ppzy00 = ppzy00 + zy0
      ppzz00 = ppzz00 + zz0

      xx1 = pbx*px1 + wpx*px2 + s12
      xy1 = pby*px1 + wpy*px2
      xz1 = pbz*px1 + wpz*px2
      yx1 = pbx*py1 + wpx*py2
      yy1 = pby*py1 + wpy*py2 + s12
      yz1 = pbz*py1 + wpz*py2
      zx1 = pbx*pz1 + wpx*pz2
      zy1 = pby*pz1 + wpy*pz2
      zz1 = pbz*pz1 + wpz*pz2 + s12

      xx2 = pbx*px2 + wpx*px3 + s23
      xy2 = pby*px2 + wpy*px3
      xz2 = pbz*px2 + wpz*px3
      yx2 = pbx*py2 + wpx*py3
      yy2 = pby*py2 + wpy*py3 + s23
      yz2 = pbz*py2 + wpz*py3
      zx2 = pbx*pz2 + wpx*pz3
      zy2 = pby*pz2 + wpy*pz3
      zz2 = pbz*pz2 + wpz*pz3 + s23
!dsss01 rdsss
      dxx01 = zet*(dxx0 - rooz*dxx1)
      dyy01 = zet*(dyy0 - rooz*dyy1)
      dzz01 = zet*(dzz0 - rooz*dzz1)
      dyx01 = zet*(dyx0 - rooz*dyx1)
      dzx01 = zet*(dzx0 - rooz*dzx1)
      dzy01 = zet*(dzy0 - rooz*dzy1)

      rdxx1 = rkp*dxx1
      rdyy1 = rkp*dyy1
      rdzz1 = rkp*dzz1
      rdyx1 = rkp*dyx1
      rdzx1 = rkp*dzx1
      rdzy1 = rkp*dzy1
!ppss01 rppss
      xx01 = zet*(xx0 - rooz*xx1)
      xy01 = zet*(xy0 - rooz*xy1)
      xz01 = zet*(xz0 - rooz*xz1)
      yx01 = zet*(yx0 - rooz*yx1)
      yy01 = zet*(yy0 - rooz*yy1)
      yz01 = zet*(yz0 - rooz*yz1)
      zx01 = zet*(zx0 - rooz*zx1)
      zy01 = zet*(zy0 - rooz*zy1)
      zz01 = zet*(zz0 - rooz*zz1)

      rxx1 = rkp*xx1
      rxy1 = rkp*xy1
      rxz1 = rkp*xz1
      ryx1 = rkp*yx1
      ryy1 = rkp*yy1
      ryz1 = rkp*yz1
      rzx1 = rkp*zx1
      rzy1 = rkp*zy1
      rzz1 = rkp*zz1
!dpss
      dxxpx0 = pax*xx0 + wpx*xx1 + xp01 + px01
      dxxpy0 = pax*xy0 + wpx*xy1 + yp01
      dxxpz0 = pax*xz0 + wpx*xz1 + zp01
      dyypx0 = pay*yx0 + wpy*yx1 + xp01
      dyypy0 = pay*yy0 + wpy*yy1 + yp01 + py01
      dyypz0 = pay*yz0 + wpy*yz1 + zp01
      dzzpx0 = paz*zx0 + wpz*zx1 + xp01
      dzzpy0 = paz*zy0 + wpz*zy1 + yp01
      dzzpz0 = paz*zz0 + wpz*zz1 + zp01 + pz01
      dyxpx0 = pay*xx0 + wpy*xx1
      dyxpy0 = pax*yy0 + wpx*yy1
      dyxpz0 = pay*xz0 + wpy*xz1
      dzxpx0 = paz*xx0 + wpz*xx1
      dzxpy0 = paz*xy0 + wpz*xy1
      dzxpz0 = pax*zz0 + wpx*zz1
      dzypx0 = paz*yx0 + wpz*yx1
      dzypy0 = paz*yy0 + wpz*yy1
      dzypz0 = pay*zz0 + wpy*zz1

      dxxpx1 = pax*xx1 + wpx*xx2 + xp12 + px12
      dxxpy1 = pax*xy1 + wpx*xy2 + yp12
      dxxpz1 = pax*xz1 + wpx*xz2 + zp12
      dyypx1 = pay*yx1 + wpy*yx2 + xp12
      dyypy1 = pay*yy1 + wpy*yy2 + yp12 + py12
      dyypz1 = pay*yz1 + wpy*yz2 + zp12
      dzzpx1 = paz*zx1 + wpz*zx2 + xp12
      dzzpy1 = paz*zy1 + wpz*zy2 + yp12
      dzzpz1 = paz*zz1 + wpz*zz2 + zp12 + pz12

      dyxpx1 = pay*xx1 + wpy*xx2
      dyxpy1 = pax*yy1 + wpx*yy2
      dyxpz1 = pay*xz1 + wpy*xz2
      dzxpx1 = paz*xx1 + wpz*xx2
      dzxpy1 = paz*xy1 + wpz*xy2
      dzxpz1 = pax*zz1 + wpx*zz2
      dzypx1 = paz*yx1 + wpz*yx2
      dzypy1 = paz*yy1 + wpz*yy2
      dzypz1 = pay*zz1 + wpy*zz2
!fpss
      ed( 1,1)=ed( 1,1)+alp*(pax*dxxpx0+wpx*dxxpx1+2.d0*xx01+dxx01)
      ed( 2,1)=ed( 2,1)+alp*(pax*dxxpy0+wpx*dxxpy1+2.d0*xy01      )
      ed( 3,1)=ed( 3,1)+alp*(pax*dxxpz0+wpx*dxxpz1+2.d0*xz01      )
      ed( 4,1)=ed( 4,1)+alp*(pay*dyypx0+wpy*dyypx1+2.d0*yx01      )
      ed( 5,1)=ed( 5,1)+alp*(pay*dyypy0+wpy*dyypy1+2.d0*yy01+dyy01)
      ed( 6,1)=ed( 6,1)+alp*(pay*dyypz0+wpy*dyypz1+2.d0*yz01      )
      ed( 7,1)=ed( 7,1)+alp*(paz*dzzpx0+wpz*dzzpx1+2.d0*zx01      )
      ed( 8,1)=ed( 8,1)+alp*(paz*dzzpy0+wpz*dzzpy1+2.d0*zy01      )
      ed( 9,1)=ed( 9,1)+alp*(paz*dzzpz0+wpz*dzzpz1+2.d0*zz01+dzz01)
      ed(10,1)=ed(10,1)+alp*(pay*dxxpx0+wpy*dxxpx1                )
      ed(11,1)=ed(11,1)+alp*(pay*dxxpy0+wpy*dxxpy1          +dxx01)
      ed(12,1)=ed(12,1)+alp*(pay*dxxpz0+wpy*dxxpz1                )
      ed(13,1)=ed(13,1)+alp*(paz*dxxpx0+wpz*dxxpx1                )
      ed(14,1)=ed(14,1)+alp*(paz*dxxpy0+wpz*dxxpy1                )
      ed(15,1)=ed(15,1)+alp*(paz*dxxpz0+wpz*dxxpz1          +dxx01)
      ed(16,1)=ed(16,1)+alp*(pax*dyypx0+wpx*dyypx1          +dyy01)
      ed(17,1)=ed(17,1)+alp*(pax*dyypy0+wpx*dyypy1                )
      ed(18,1)=ed(18,1)+alp*(pax*dyypz0+wpx*dyypz1                )
      ed(19,1)=ed(19,1)+alp*(paz*dyypx0+wpz*dyypx1                )
      ed(20,1)=ed(20,1)+alp*(paz*dyypy0+wpz*dyypy1                )
      ed(21,1)=ed(21,1)+alp*(paz*dyypz0+wpz*dyypz1          +dyy01)
      ed(22,1)=ed(22,1)+alp*(pax*dzzpx0+wpx*dzzpx1          +dzz01)
      ed(23,1)=ed(23,1)+alp*(pax*dzzpy0+wpx*dzzpy1                )
      ed(24,1)=ed(24,1)+alp*(pax*dzzpz0+wpx*dzzpz1                )
      ed(25,1)=ed(25,1)+alp*(pay*dzzpx0+wpy*dzzpx1                )
      ed(26,1)=ed(26,1)+alp*(pay*dzzpy0+wpy*dzzpy1          +dzz01)
      ed(27,1)=ed(27,1)+alp*(pay*dzzpz0+wpy*dzzpz1                )
      ed(28,1)=ed(28,1)+alp*(paz*dyxpx0+wpz*dyxpx1                )
      ed(29,1)=ed(29,1)+alp*(paz*dyxpy0+wpz*dyxpy1                )
      ed(30,1)=ed(30,1)+alp*(paz*dyxpz0+wpz*dyxpz1          +dyx01)
!ddss
      ed( 1,2)=ed( 1,2)+bet*(pbx*dxxpx0+wpx*dxxpx1+2.d0*xx01+dxx01)
      ed( 2,2)=ed( 2,2)+bet*(pby*dxxpy0+wpy*dxxpy1          +dxx01)
      ed( 3,2)=ed( 3,2)+bet*(pbz*dxxpz0+wpz*dxxpz1          +dxx01)
      ed( 4,2)=ed( 4,2)+bet*(pby*dxxpx0+wpy*dxxpx1                )
      ed( 5,2)=ed( 5,2)+bet*(pbz*dxxpx0+wpz*dxxpx1                )
      ed( 6,2)=ed( 6,2)+bet*(pby*dxxpz0+wpy*dxxpz1                )
      ed( 7,2)=ed( 7,2)+bet*(pbx*dyypx0+wpx*dyypx1          +dyy01)
      ed( 8,2)=ed( 8,2)+bet*(pby*dyypy0+wpy*dyypy1+2.d0*yy01+dyy01)
      ed( 9,2)=ed( 9,2)+bet*(pbz*dyypz0+wpz*dyypz1          +dyy01)
      ed(10,2)=ed(10,2)+bet*(pbx*dyypy0+wpx*dyypy1                )
      ed(11,2)=ed(11,2)+bet*(pbx*dyypz0+wpx*dyypz1                )
      ed(12,2)=ed(12,2)+bet*(pbz*dyypy0+wpz*dyypy1                )
      ed(13,2)=ed(13,2)+bet*(pbx*dzzpx0+wpx*dzzpx1          +dzz01)
      ed(14,2)=ed(14,2)+bet*(pby*dzzpy0+wpy*dzzpy1          +dzz01)
      ed(15,2)=ed(15,2)+bet*(pbz*dzzpz0+wpz*dzzpz1+2.d0*zz01+dzz01)
      ed(16,2)=ed(16,2)+bet*(pbx*dzzpy0+wpx*dzzpy1                )
      ed(17,2)=ed(17,2)+bet*(pbx*dzzpz0+wpx*dzzpz1                )
      ed(18,2)=ed(18,2)+bet*(pby*dzzpz0+wpy*dzzpz1                )
      ed(19,2)=ed(19,2)+bet*(pbx*dyxpx0+wpx*dyxpx1+     yx01+dyx01)
      ed(20,2)=ed(20,2)+bet*(pby*dyxpy0+wpy*dyxpy1+     xy01+dyx01)
      ed(21,2)=ed(21,2)+bet*(pbz*dyxpz0+wpz*dyxpz1          +dyx01)
      ed(22,2)=ed(22,2)+bet*(pbx*dyxpy0+wpx*dyxpy1+     yy01      )
      ed(23,2)=ed(23,2)+bet*(pbz*dyxpx0+wpz*dyxpx1                )
      ed(24,2)=ed(24,2)+bet*(pbz*dyxpy0+wpz*dyxpy1                )
      ed(25,2)=ed(25,2)+bet*(pbx*dzxpx0+wpx*dzxpx1+1.d0*zx01+dzx01)
      ed(26,2)=ed(26,2)+bet*(pby*dzxpy0+wpy*dzxpy1          +dzx01)
      ed(27,2)=ed(27,2)+bet*(pbz*dzxpz0+wpz*dzxpz1+1.d0*xz01+dzx01)
      ed(28,2)=ed(28,2)+bet*(pby*dzxpx0+wpy*dzxpx1                )
      ed(29,2)=ed(29,2)+bet*(pbx*dzxpz0+wpx*dzxpz1+1.d0*zz01      )
      ed(30,2)=ed(30,2)+bet*(pby*dzxpz0+wpy*dzxpz1                )
      ed(31,2)=ed(31,2)+bet*(pbx*dzypx0+wpx*dzypx1          +dzy01)
      ed(32,2)=ed(32,2)+bet*(pby*dzypy0+wpy*dzypy1+1.d0*zy01+dzy01)
      ed(33,2)=ed(33,2)+bet*(pbz*dzypz0+wpz*dzypz1+1.d0*yz01+dzy01)
      ed(34,2)=ed(34,2)+bet*(pbx*dzypy0+wpx*dzypy1                )
      ed(35,2)=ed(35,2)+bet*(pbx*dzypz0+wpx*dzypz1                )
      ed(36,2)=ed(36,2)+bet*(pby*dzypz0+wpy*dzypz1+1.d0*zz01      )
!dpps
      ed( 1,3)=ed( 1,3)+ram*(qcx*dxxpx0+wqx*dxxpx1+2.d0*rxx1+rdxx1)
      ed( 2,3)=ed( 2,3)+ram*(qcy*dxxpx0+wqy*dxxpx1                )
      ed( 3,3)=ed( 3,3)+ram*(qcz*dxxpx0+wqz*dxxpx1                )
      ed( 4,3)=ed( 4,3)+ram*(qcx*dxxpy0+wqx*dxxpy1+2.d0*rxy1      )
      ed( 5,3)=ed( 5,3)+ram*(qcy*dxxpy0+wqy*dxxpy1          +rdxx1)
      ed( 6,3)=ed( 6,3)+ram*(qcz*dxxpy0+wqz*dxxpy1                )
      ed( 7,3)=ed( 7,3)+ram*(qcx*dxxpz0+wqx*dxxpz1+2.d0*rxz1      )
      ed( 8,3)=ed( 8,3)+ram*(qcy*dxxpz0+wqy*dxxpz1                )
      ed( 9,3)=ed( 9,3)+ram*(qcz*dxxpz0+wqz*dxxpz1          +rdxx1)
      ed(10,3)=ed(10,3)+ram*(qcx*dyypx0+wqx*dyypx1          +rdyy1)
      ed(11,3)=ed(11,3)+ram*(qcy*dyypx0+wqy*dyypx1+2.d0*ryx1      )
      ed(12,3)=ed(12,3)+ram*(qcz*dyypx0+wqz*dyypx1                )
      ed(13,3)=ed(13,3)+ram*(qcx*dyypy0+wqx*dyypy1                )
      ed(14,3)=ed(14,3)+ram*(qcy*dyypy0+wqy*dyypy1+2.d0*ryy1+rdyy1)
      ed(15,3)=ed(15,3)+ram*(qcz*dyypy0+wqz*dyypy1                )
      ed(16,3)=ed(16,3)+ram*(qcx*dyypz0+wqx*dyypz1                )
      ed(17,3)=ed(17,3)+ram*(qcy*dyypz0+wqy*dyypz1+2.d0*ryz1      )
      ed(18,3)=ed(18,3)+ram*(qcz*dyypz0+wqz*dyypz1          +rdyy1)
      ed(19,3)=ed(19,3)+ram*(qcx*dzzpx0+wqx*dzzpx1          +rdzz1)
      ed(20,3)=ed(20,3)+ram*(qcy*dzzpx0+wqy*dzzpx1                )
      ed(21,3)=ed(21,3)+ram*(qcz*dzzpx0+wqz*dzzpx1+2.d0*rzx1      )
      ed(22,3)=ed(22,3)+ram*(qcx*dzzpy0+wqx*dzzpy1                )
      ed(23,3)=ed(23,3)+ram*(qcy*dzzpy0+wqy*dzzpy1          +rdzz1)
      ed(24,3)=ed(24,3)+ram*(qcz*dzzpy0+wqz*dzzpy1+2.d0*rzy1      )
      ed(25,3)=ed(25,3)+ram*(qcx*dzzpz0+wqx*dzzpz1                )
      ed(26,3)=ed(26,3)+ram*(qcy*dzzpz0+wqy*dzzpz1                )
      ed(27,3)=ed(27,3)+ram*(qcz*dzzpz0+wqz*dzzpz1+2.d0*rzz1+rdzz1)
      ed(28,3)=ed(28,3)+ram*(qcx*dyxpx0+wqx*dyxpx1+     ryx1+rdyx1)
      ed(29,3)=ed(29,3)+ram*(qcy*dyxpx0+wqy*dyxpx1+     rxx1      )
      ed(30,3)=ed(30,3)+ram*(qcz*dyxpx0+wqz*dyxpx1                )
      ed(31,3)=ed(31,3)+ram*(qcx*dyxpy0+wqx*dyxpy1+     ryy1      )
      ed(32,3)=ed(32,3)+ram*(qcy*dyxpy0+wqy*dyxpy1+     rxy1+rdyx1)
      ed(33,3)=ed(33,3)+ram*(qcz*dyxpy0+wqz*dyxpy1                )
      ed(34,3)=ed(34,3)+ram*(qcx*dyxpz0+wqx*dyxpz1+     ryz1      )
      ed(35,3)=ed(35,3)+ram*(qcy*dyxpz0+wqy*dyxpz1+     rxz1      )
      ed(36,3)=ed(36,3)+ram*(qcz*dyxpz0+wqz*dyxpz1          +rdyx1)
      ed(37,3)=ed(37,3)+ram*(qcx*dzxpx0+wqx*dzxpx1+     rzx1+rdzx1)
      ed(38,3)=ed(38,3)+ram*(qcy*dzxpx0+wqy*dzxpx1                )
      ed(39,3)=ed(39,3)+ram*(qcz*dzxpx0+wqz*dzxpx1+     rxx1      )
      ed(40,3)=ed(40,3)+ram*(qcx*dzxpy0+wqx*dzxpy1+     rzy1      )
      ed(41,3)=ed(41,3)+ram*(qcy*dzxpy0+wqy*dzxpy1          +rdzx1)
      ed(42,3)=ed(42,3)+ram*(qcz*dzxpy0+wqz*dzxpy1+     rxy1      )
      ed(43,3)=ed(43,3)+ram*(qcx*dzxpz0+wqx*dzxpz1+     rzz1      )
      ed(44,3)=ed(44,3)+ram*(qcy*dzxpz0+wqy*dzxpz1                )
      ed(45,3)=ed(45,3)+ram*(qcz*dzxpz0+wqz*dzxpz1+     rxz1+rdzx1)
      ed(46,3)=ed(46,3)+ram*(qcx*dzypx0+wqx*dzypx1          +rdzy1)
      ed(47,3)=ed(47,3)+ram*(qcy*dzypx0+wqy*dzypx1+     rzx1      )
      ed(48,3)=ed(48,3)+ram*(qcz*dzypx0+wqz*dzypx1+     ryx1      )
      ed(49,3)=ed(49,3)+ram*(qcx*dzypy0+wqx*dzypy1                )
      ed(50,3)=ed(50,3)+ram*(qcy*dzypy0+wqy*dzypy1+     rzy1+rdzy1)
      ed(51,3)=ed(51,3)+ram*(qcz*dzypy0+wqz*dzypy1+     ryy1      )
      ed(52,3)=ed(52,3)+ram*(qcx*dzypz0+wqx*dzypz1                )
      ed(53,3)=ed(53,3)+ram*(qcy*dzypz0+wqy*dzypz1+     rzz1      )
      ed(54,3)=ed(54,3)+ram*(qcz*dzypz0+wqz*dzypz1+     ryz1+rdzy1)

                enddo
            enddo
         enddo
      enddo
#ifdef PL_OMP_DERI
!$omp end do
#endif
!fpss

      if (jpq.eq.0) then

      ec( 1,1)=ed( 1,1) - 2.d0*ppxx00
      ec( 2,1)=ed(10,1)
      ec( 3,1)=ed(13,1)
      ec( 4,1)=ed( 2,1) - 2.d0*ppxy00
      ec( 5,1)=ed(11,1)
      ec( 6,1)=ed(14,1)
      ec( 7,1)=ed( 3,1) - 2.d0*ppxz00
      ec( 8,1)=ed(12,1)
      ec( 9,1)=ed(15,1)
      ec(10,1)=ed(16,1)
      ec(11,1)=ed( 4,1) - 2.d0*ppyx00
      ec(12,1)=ed(19,1)
      ec(13,1)=ed(17,1)
      ec(14,1)=ed( 5,1) - 2.d0*ppyy00
      ec(15,1)=ed(20,1)
      ec(16,1)=ed(18,1)
      ec(17,1)=ed( 6,1) - 2.d0*ppyz00
      ec(18,1)=ed(21,1)
      ec(19,1)=ed(22,1)
      ec(20,1)=ed(25,1)
      ec(21,1)=ed( 7,1) - 2.d0*ppzx00
      ec(22,1)=ed(23,1)
      ec(23,1)=ed(26,1)
      ec(24,1)=ed( 8,1) - 2.d0*ppzy00
      ec(25,1)=ed(24,1)
      ec(26,1)=ed(27,1)
      ec(27,1)=ed( 9,1) - 2.d0*ppzz00
      ec(28,1)=ed(10,1) -      ppyx00
      ec(29,1)=ed(16,1) -      ppxx00
      ec(30,1)=ed(28,1)
      ec(31,1)=ed(11,1) -      ppyy00
      ec(32,1)=ed(17,1) -      ppxy00
      ec(33,1)=ed(29,1)
      ec(34,1)=ed(12,1) -      ppyz00
      ec(35,1)=ed(18,1) -      ppxz00
      ec(36,1)=ed(30,1)
      ec(37,1)=ed(13,1) -      ppzx00
      ec(38,1)=ed(28,1)
      ec(39,1)=ed(22,1) -      ppxx00
      ec(40,1)=ed(14,1) -      ppzy00
      ec(41,1)=ed(29,1)
      ec(42,1)=ed(23,1) -      ppxy00
      ec(43,1)=ed(15,1) -      ppzz00
      ec(44,1)=ed(30,1)
      ec(45,1)=ed(24,1) -      ppxz00
      ec(46,1)=ed(28,1)
      ec(47,1)=ed(19,1) -      ppzx00
      ec(48,1)=ed(25,1) -      ppyx00
      ec(49,1)=ed(29,1)
      ec(50,1)=ed(20,1) -      ppzy00
      ec(51,1)=ed(26,1) -      ppyy00
      ec(52,1)=ed(30,1)
      ec(53,1)=ed(21,1) -      ppzz00
      ec(54,1)=ed(27,1) -      ppyz00
!ddss
      ec( 1,2)=ed( 1,2) - dxx00
      ec( 2,2)=ed( 4,2)
      ec( 3,2)=ed( 5,2)
      ec( 4,2)=ed( 4,2)
      ec( 5,2)=ed( 2,2) - dxx00
      ec( 6,2)=ed( 6,2)
      ec( 7,2)=ed( 5,2)
      ec( 8,2)=ed( 6,2)
      ec( 9,2)=ed( 3,2) - dxx00
      ec(10,2)=ed( 7,2) - dyy00
      ec(11,2)=ed(10,2)
      ec(12,2)=ed(11,2)
      ec(13,2)=ed(10,2)
      ec(14,2)=ed( 8,2) - dyy00
      ec(15,2)=ed(12,2)
      ec(16,2)=ed(11,2)
      ec(17,2)=ed(12,2)
      ec(18,2)=ed( 9,2) - dyy00
      ec(19,2)=ed(13,2) - dzz00
      ec(20,2)=ed(16,2)
      ec(21,2)=ed(17,2)
      ec(22,2)=ed(16,2)
      ec(23,2)=ed(14,2) - dzz00
      ec(24,2)=ed(18,2)
      ec(25,2)=ed(17,2)
      ec(26,2)=ed(18,2)
      ec(27,2)=ed(15,2) - dzz00
      ec(28,2)=ed(19,2) - dyx00
      ec(29,2)=ed(22,2)
      ec(30,2)=ed(23,2)
      ec(31,2)=ed(22,2)
      ec(32,2)=ed(20,2) - dyx00
      ec(33,2)=ed(24,2)
      ec(34,2)=ed(23,2)
      ec(35,2)=ed(24,2)
      ec(36,2)=ed(21,2) - dyx00
      ec(37,2)=ed(25,2) - dzx00
      ec(38,2)=ed(28,2)
      ec(39,2)=ed(29,2)
      ec(40,2)=ed(28,2)
      ec(41,2)=ed(26,2) - dzx00
      ec(42,2)=ed(30,2)
      ec(43,2)=ed(29,2)
      ec(44,2)=ed(30,2)
      ec(45,2)=ed(27,2) - dzx00
      ec(46,2)=ed(31,2) - dzy00
      ec(47,2)=ed(34,2)
      ec(48,2)=ed(35,2)
      ec(49,2)=ed(34,2)
      ec(50,2)=ed(32,2) - dzy00
      ec(51,2)=ed(36,2)
      ec(52,2)=ed(35,2)
      ec(53,2)=ed(36,2)
      ec(54,2)=ed(33,2) - dzy00

      do i3=1,54
         ec(i3,3) = ed(i3,3)
      enddo

!c$$$      do j=1,mao3
!c$$$         do i=1,3
!c$$$            ec(j,4) = ec(j,4) - ec(j,i)
!c$$$         enddo
!c$$$      enddo
!c$$$
!c$$$      do j=1,4
!c$$$         do i=28,54
!c$$$            ec(i,j) = ec(i,j)*root3
!c$$$         enddo
!c$$$      enddo

      else
      ec( 1,1)=ed( 1,1) - 2.d0*ppxx00
      ec( 2,1)=ed(10,1)
      ec( 3,1)=ed(13,1)
      ec( 4,1)=ed(16,1)
      ec( 5,1)=ed( 4,1) - 2.d0*ppyx00
      ec( 6,1)=ed(19,1)
      ec( 7,1)=ed(22,1)
      ec( 8,1)=ed(25,1)
      ec( 9,1)=ed( 7,1) - 2.d0*ppzx00
      ec(10,1)=ed(10,1) -      ppyx00
      ec(11,1)=ed(16,1) -      ppxx00
      ec(12,1)=ed(28,1)
      ec(13,1)=ed(13,1) -      ppzx00
      ec(14,1)=ed(28,1)
      ec(15,1)=ed(22,1) -      ppxx00
      ec(16,1)=ed(28,1)
      ec(17,1)=ed(19,1) -      ppzx00
      ec(18,1)=ed(25,1) -      ppyx00
      ec(19,1)=ed( 2,1) - 2.d0*ppxy00
      ec(20,1)=ed(11,1)
      ec(21,1)=ed(14,1)
      ec(22,1)=ed(17,1)
      ec(23,1)=ed( 5,1) - 2.d0*ppyy00
      ec(24,1)=ed(20,1)
      ec(25,1)=ed(23,1)
      ec(26,1)=ed(26,1)
      ec(27,1)=ed( 8,1) - 2.d0*ppzy00
      ec(28,1)=ed(11,1) -      ppyy00
      ec(29,1)=ed(17,1) -      ppxy00
      ec(30,1)=ed(29,1)
      ec(31,1)=ed(14,1) -      ppzy00
      ec(32,1)=ed(29,1)
      ec(33,1)=ed(23,1) -      ppxy00
      ec(34,1)=ed(29,1)
      ec(35,1)=ed(20,1) -      ppzy00
      ec(36,1)=ed(26,1) -      ppyy00
      ec(37,1)=ed( 3,1) - 2.d0*ppxz00
      ec(38,1)=ed(12,1)
      ec(39,1)=ed(15,1)
      ec(40,1)=ed(18,1)
      ec(41,1)=ed( 6,1) - 2.d0*ppyz00
      ec(42,1)=ed(21,1)
      ec(43,1)=ed(24,1)
      ec(44,1)=ed(27,1)
      ec(45,1)=ed( 9,1) - 2.d0*ppzz00
      ec(46,1)=ed(12,1) -      ppyz00
      ec(47,1)=ed(18,1) -      ppxz00
      ec(48,1)=ed(30,1)
      ec(49,1)=ed(15,1) -      ppzz00
      ec(50,1)=ed(30,1)
      ec(51,1)=ed(24,1) -      ppxz00
      ec(52,1)=ed(30,1)
      ec(53,1)=ed(21,1) -      ppzz00
      ec(54,1)=ed(27,1) -      ppyz00
!ddss
      ec( 1,2)=ed( 1,2) -dxx00
      ec( 2,2)=ed( 4,2)
      ec( 3,2)=ed( 5,2)
      ec( 4,2)=ed( 7,2) -dyy00
      ec( 5,2)=ed(10,2)
      ec( 6,2)=ed(11,2)
      ec( 7,2)=ed(13,2) -dzz00
      ec( 8,2)=ed(16,2)
      ec( 9,2)=ed(17,2)
      ec(10,2)=ed(19,2) -dyx00
      ec(11,2)=ed(22,2)
      ec(12,2)=ed(23,2)
      ec(13,2)=ed(25,2) -dzx00
      ec(14,2)=ed(28,2)
      ec(15,2)=ed(29,2)
      ec(16,2)=ed(31,2) -dzy00
      ec(17,2)=ed(34,2)
      ec(18,2)=ed(35,2)
      ec(19,2)=ed( 4,2)
      ec(20,2)=ed( 2,2) -dxx00
      ec(21,2)=ed( 6,2)
      ec(22,2)=ed(10,2)
      ec(23,2)=ed( 8,2) -dyy00
      ec(24,2)=ed(12,2)
      ec(25,2)=ed(16,2)
      ec(26,2)=ed(14,2) -dzz00
      ec(27,2)=ed(18,2)
      ec(28,2)=ed(22,2)
      ec(29,2)=ed(20,2) -dyx00
      ec(30,2)=ed(24,2)
      ec(31,2)=ed(28,2)
      ec(32,2)=ed(26,2) -dzx00
      ec(33,2)=ed(30,2)
      ec(34,2)=ed(34,2)
      ec(35,2)=ed(32,2) -dzy00
      ec(36,2)=ed(36,2)
      ec(37,2)=ed( 5,2)
      ec(38,2)=ed( 6,2)
      ec(39,2)=ed( 3,2) -dxx00
      ec(40,2)=ed(11,2)
      ec(41,2)=ed(12,2)
      ec(42,2)=ed( 9,2) -dyy00
      ec(43,2)=ed(17,2)
      ec(44,2)=ed(18,2)
      ec(45,2)=ed(15,2) -dzz00
      ec(46,2)=ed(23,2)
      ec(47,2)=ed(24,2)
      ec(48,2)=ed(21,2) -dyx00
      ec(49,2)=ed(29,2)
      ec(50,2)=ed(30,2)
      ec(51,2)=ed(27,2) -dzx00
      ec(52,2)=ed(35,2)
      ec(53,2)=ed(36,2)
      ec(54,2)=ed(33,2) -dzy00
!dpps
      ec( 1,3)=ed( 1,3)
      ec( 2,3)=ed( 2,3)
      ec( 3,3)=ed( 3,3)
      ec( 4,3)=ed(10,3)
      ec( 5,3)=ed(11,3)
      ec( 6,3)=ed(12,3)
      ec( 7,3)=ed(19,3)
      ec( 8,3)=ed(20,3)
      ec( 9,3)=ed(21,3)
      ec(10,3)=ed(28,3)
      ec(11,3)=ed(29,3)
      ec(12,3)=ed(30,3)
      ec(13,3)=ed(37,3)
      ec(14,3)=ed(38,3)
      ec(15,3)=ed(39,3)
      ec(16,3)=ed(46,3)
      ec(17,3)=ed(47,3)
      ec(18,3)=ed(48,3)
      ec(19,3)=ed( 4,3)
      ec(20,3)=ed( 5,3)
      ec(21,3)=ed( 6,3)
      ec(22,3)=ed(13,3)
      ec(23,3)=ed(14,3)
      ec(24,3)=ed(15,3)
      ec(25,3)=ed(22,3)
      ec(26,3)=ed(23,3)
      ec(27,3)=ed(24,3)
      ec(28,3)=ed(31,3)
      ec(29,3)=ed(32,3)
      ec(30,3)=ed(33,3)
      ec(31,3)=ed(40,3)
      ec(32,3)=ed(41,3)
      ec(33,3)=ed(42,3)
      ec(34,3)=ed(49,3)
      ec(35,3)=ed(50,3)
      ec(36,3)=ed(51,3)
      ec(37,3)=ed( 7,3)
      ec(38,3)=ed( 8,3)
      ec(39,3)=ed( 9,3)
      ec(40,3)=ed(16,3)
      ec(41,3)=ed(17,3)
      ec(42,3)=ed(18,3)
      ec(43,3)=ed(25,3)
      ec(44,3)=ed(26,3)
      ec(45,3)=ed(27,3)
      ec(46,3)=ed(34,3)
      ec(47,3)=ed(35,3)
      ec(48,3)=ed(36,3)
      ec(49,3)=ed(43,3)
      ec(50,3)=ed(44,3)
      ec(51,3)=ed(45,3)
      ec(52,3)=ed(52,3)
      ec(53,3)=ed(53,3)
      ec(54,3)=ed(54,3)

!c$$$      do j=1,mao3
!c$$$         do i=1,3
!c$$$            ec(j,4) = ec(j,4) - ec(j,i)
!c$$$         enddo
!c$$$      enddo
!c$$$
!c$$$      do j=1,4
!c$$$      do k=1,3
!c$$$         do i=10,18
!c$$$           key = i+(k-1)*18 
!c$$$            ec(key,j) = ec(key,j)*root3
!c$$$         enddo
!c$$$      enddo
!c$$$      enddo

      endif
#ifdef PL_OMP_DERI
!$omp end parallel
#endif

      if (jpq.eq.0) then

      do j=1,mao3
         do i=1,3
            ec(j,4) = ec(j,4) - ec(j,i)
         enddo
      enddo

      do j=1,4
         do i=28,54
            ec(i,j) = ec(i,j)*root3
         enddo
      enddo

      else

      do j=1,mao3
         do i=1,3
            ec(j,4) = ec(j,4) - ec(j,i)
         enddo
      enddo

      do j=1,4
      do k=1,3
         do i=10,18
           key = i+(k-1)*18 
            ec(key,j) = ec(key,j)*root3
         enddo
      enddo
      enddo

      endif
      end
