! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!= dddd =============================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================
      subroutine iodddd(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)

      dimension ec(1296)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(8) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 ,
     &   0.09090909090909090d+00,  0.07692307692307692d+00 ,
     &   0.06666666666666666d+00 /)

      real(8),parameter::root3 = 1.73205080756887729352d+00

#ifdef PL_SIMD_ERI
c$$$      dimension dmx(9,mxprm), val(5,mxprm)
#endif

      do i = 1,1296
        ec(i) = 0.d0
      enddo

#ifdef PL_OMP_ERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif
      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

#ifdef PL_OMP_ERI
!$omp do
#endif
      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(9)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f8   = (((((fdat(15,it)*dt6   + fdat(14,it))*dt5
     &                    + fdat(13,it))*dt4  + fdat(12,it))*dt3
     &                    + fdat(11,it))*dt2  + fdat(10,it))*dt
     &                    + fdat(9,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f7   = (t2*f8 + ee)*rminv(8)
                     f6   = (t2*f7 + ee)*rminv(7)
                     f5   = (t2*f6 + ee)*rminv(6)
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)

                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     dm6 = fpp*f6! *( roo2)**3
                     dm7 = fpp*f7! *( roo2)**3
                     dm8 = fpp*f8! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
                     dm5 =  4.5d0 *tinv *  dm4
                     dm6 =  5.5d0 *tinv *  dm5
                     dm7 =  6.5d0 *tinv *  dm6
                     dm8 =  7.5d0 *tinv *  dm7
                     
                  end if

#ifdef PL_SIMD_ERI
c$$$                  val(1,l) = qpx
c$$$                  val(2,l) = qpy
c$$$                  val(3,l) = qpz
c$$$                  val(4,l) = roo2
c$$$                  val(5,l) = eta
c$$$
c$$$                  dmx(1,l) = dm0
c$$$                  dmx(2,l) = dm1
c$$$                  dmx(3,l) = dm2
c$$$                  dmx(4,l) = dm3
c$$$                  dmx(5,l) = dm4
c$$$                  dmx(6,l) = dm5
c$$$                  dmx(7,l) = dm6
c$$$                  dmx(8,l) = dm7
c$$$                  dmx(9,l) = dm8
c$$$               enddo
c$$$
c$$$               do l = 1, lgp
c$$$                  qpx  = val(1,l)
c$$$                  qpy  = val(2,l)
c$$$                  qpz  = val(3,l)
c$$$                  roo2 = val(4,l)
c$$$                  eta  = val(5,l)
c$$$
c$$$                  dm0 = dmx(1,l)
c$$$                  dm1 = dmx(2,l)
c$$$                  dm2 = dmx(3,l)
c$$$                  dm3 = dmx(4,l)
c$$$                  dm4 = dmx(5,l)
c$$$                  dm5 = dmx(6,l)
c$$$                  dm6 = dmx(7,l)
c$$$                  dm7 = dmx(8,l)
c$$$                  dm8 = dmx(9,l)
#endif

                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)

                  qdx =  yq(1,l,k) - xyz(1,latom)
                  qdy =  yq(2,l,k) - xyz(2,latom)
                  qdz =  yq(3,l,k) - xyz(3,latom)
!ssss (0-8)                 
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)
                  s6 = dm6      !/( roo2**3)
                  s7 = dm7      !/( roo2**3)
                  s8 = dm8      !/( roo2**3)

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
!psss(0-7) 
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
                  px5 = pax*s5 + wpx*s6
                  py5 = pay*s5 + wpy*s6
                  pz5 = paz*s5 + wpz*s6
                  px6 = pax*s6 + wpx*s7
                  py6 = pay*s6 + wpy*s7
                  pz6 = paz*s6 + wpz*s7
                  px7 = pax*s7 + wpx*s8
                  py7 = pay*s7 + wpy*s8
                  pz7 = paz*s7 + wpz*s8
!spss(1-5)
                  xp1 = pbx*s1 + wpx*s2
                  yp1 = pby*s1 + wpy*s2
                  zp1 = pbz*s1 + wpz*s2
                  xp2 = pbx*s2 + wpx*s3
                  yp2 = pby*s2 + wpy*s3
                  zp2 = pbz*s2 + wpz*s3
                  xp3 = pbx*s3 + wpx*s4
                  yp3 = pby*s3 + wpy*s4
                  zp3 = pbz*s3 + wpz*s4
                  xp4 = pbx*s4 + wpx*s5
                  yp4 = pby*s4 + wpy*s5
                  zp4 = pbz*s4 + wpz*s5
                  xp5 = pbx*s5 + wpx*s6
                  yp5 = pby*s5 + wpy*s6
                  zp5 = pbz*s5 + wpz*s6
!ssss01(01-67)
                  s01 = zet*(s0-rooz*s1)
                  s12 = zet*(s1-rooz*s2)
                  s23 = zet*(s2-rooz*s3)
                  s34 = zet*(s3-rooz*s4)
                  s45 = zet*(s4-rooz*s5)
                  s56 = zet*(s5-rooz*s6)
                  s67 = zet*(s6-rooz*s7)
! dsss (0-6)
                  dxx0 = pax*px0 + wpx*px1+s01
                  dyy0 = pay*py0 + wpy*py1+s01
                  dzz0 = paz*pz0 + wpz*pz1+s01
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1
                  dxx1 = pax*px1 + wpx*px2+s12
                  dyy1 = pay*py1 + wpy*py2+s12
                  dzz1 = paz*pz1 + wpz*pz2+s12
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  dxx2 = pax*px2 + wpx*px3+s23
                  dyy2 = pay*py2 + wpy*py3+s23
                  dzz2 = paz*pz2 + wpz*pz3+s23
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
                  dxx3 = pax*px3 + wpx*px4+s34
                  dyy3 = pay*py3 + wpy*py4+s34
                  dzz3 = paz*pz3 + wpz*pz4+s34
                  dyx3 = pay*px3 + wpy*px4
                  dzx3 = paz*px3 + wpz*px4
                  dzy3 = paz*py3 + wpz*py4
                  dxx4 = pax*px4 + wpx*px5+s45
                  dyy4 = pay*py4 + wpy*py5+s45
                  dzz4 = paz*pz4 + wpz*pz5+s45
                  dyx4 = pay*px4 + wpy*px5
                  dzx4 = paz*px4 + wpz*px5
                  dzy4 = paz*py4 + wpz*py5
                  dxx5 = pax*px5 + wpx*px6+s56
                  dyy5 = pay*py5 + wpy*py6+s56
                  dzz5 = paz*pz5 + wpz*pz6+s56
                  dyx5 = pay*px5 + wpy*px6
                  dzx5 = paz*px5 + wpz*px6
                  dzy5 = paz*py5 + wpz*py6
                  dxx6 = pax*px6 + wpx*px7+s67
                  dyy6 = pay*py6 + wpy*py7+s67
                  dzz6 = paz*pz6 + wpz*pz7+s67
                  dyx6 = pay*px6 + wpy*px7
                  dzx6 = paz*px6 + wpz*px7
                  dzy6 = paz*py6 + wpz*py7

!sdss(2-4)
                  sdxx2 = pbx*xp2 + wpx*xp3 + s23
                  sdyy2 = pby*yp2 + wpy*yp3 + s23
                  sdzz2 = pbz*zp2 + wpz*zp3 + s23
                  sdyx2 = pby*xp2 + wpy*xp3
                  sdzx2 = pbz*xp2 + wpz*xp3
                  sdzy2 = pbz*yp2 + wpz*yp3
                  sdxx3 = pbx*xp3 + wpx*xp4 + s34
                  sdyy3 = pby*yp3 + wpy*yp4 + s34
                  sdzz3 = pbz*zp3 + wpz*zp4 + s34
                  sdyx3 = pby*xp3 + wpy*xp4
                  sdzx3 = pbz*xp3 + wpz*xp4
                  sdzy3 = pbz*yp3 + wpz*yp4
                  sdxx4 = pbx*xp4 + wpx*xp5 + s45
                  sdyy4 = pby*yp4 + wpy*yp5 + s45
                  sdzz4 = pbz*zp4 + wpz*zp5 + s45
                  sdyx4 = pby*xp4 + wpy*xp5
                  sdzx4 = pbz*xp4 + wpz*xp5
                  sdzy4 = pbz*yp4 + wpz*yp5
!rssss(4)
                  rs4 = rkp * s4

!spps(3)      
                  pxpx3 = qcx * xp3 + wqx * xp4 + rs4
                  pxpy3 = qcy * xp3 + wqy * xp4
                  pxpz3 = qcz * xp3 + wqz * xp4
                  pypx3 = qcx * yp3 + wqx * yp4
                  pypy3 = qcy * yp3 + wqy * yp4 + rs4
                  pypz3 = qcz * yp3 + wqz * yp4
                  pzpx3 = qcx * zp3 + wqx * zp4
                  pzpy3 = qcy * zp3 + wqy * zp4
                  pzpz3 = qcz * zp3 + wqz * zp4 + rs4
!psps(3)
                  pxspx3 = qcx * px3 + wqx * px4 + rs4
                  pxspy3 = qcy * px3 + wqy * px4
                  pxspz3 = qcz * px3 + wqz * px4
                  pyspx3 = qcx * py3 + wqx * py4
                  pyspy3 = qcy * py3 + wqy * py4 + rs4
                  pyspz3 = qcz * py3 + wqz * py4
                  pzspx3 = qcx * pz3 + wqx * pz4
                  pzspy3 = qcy * pz3 + wqy * pz4
                  pzspz3 = qcz * pz3 + wqz * pz4 + rs4

!ppss(0-5)
                  ppxx0 = pbx * px0 + wpx*px1 + s01
                  ppyx0 = pbx * py0 + wpx*py1
                  ppzx0 = pbx * pz0 + wpx*pz1
                  ppxy0 = pby * px0 + wpy*px1
                  ppyy0 = pby * py0 + wpy*py1 + s01
                  ppzy0 = pby * pz0 + wpy*pz1
                  ppxz0 = pbz * px0 + wpz*px1
                  ppyz0 = pbz * py0 + wpz*py1
                  ppzz0 = pbz * pz0 + wpz*pz1 + s01
                  ppxx1 = pbx * px1 + wpx*px2 + s12
                  ppyx1 = pbx * py1 + wpx*py2
                  ppzx1 = pbx * pz1 + wpx*pz2
                  ppxy1 = pby * px1 + wpy*px2
                  ppyy1 = pby * py1 + wpy*py2 + s12
                  ppzy1 = pby * pz1 + wpy*pz2
                  ppxz1 = pbz * px1 + wpz*px2
                  ppyz1 = pbz * py1 + wpz*py2
                  ppzz1 = pbz * pz1 + wpz*pz2 + s12
                  ppxx2 = pbx * px2 + wpx*px3 + s23
                  ppyx2 = pbx * py2 + wpx*py3
                  ppzx2 = pbx * pz2 + wpx*pz3
                  ppxy2 = pby * px2 + wpy*px3
                  ppyy2 = pby * py2 + wpy*py3 + s23
                  ppzy2 = pby * pz2 + wpy*pz3
                  ppxz2 = pbz * px2 + wpz*px3
                  ppyz2 = pbz * py2 + wpz*py3
                  ppzz2 = pbz * pz2 + wpz*pz3 + s23
                  ppxx3 = pbx * px3 + wpx*px4 + s34
                  ppyx3 = pbx * py3 + wpx*py4
                  ppzx3 = pbx * pz3 + wpx*pz4
                  ppxy3 = pby * px3 + wpy*px4
                  ppyy3 = pby * py3 + wpy*py4 + s34
                  ppzy3 = pby * pz3 + wpy*pz4
                  ppxz3 = pbz * px3 + wpz*px4
                  ppyz3 = pbz * py3 + wpz*py4
                  ppzz3 = pbz * pz3 + wpz*pz4 + s34
                  ppxx4 = pbx * px4 + wpx*px5 + s45
                  ppyx4 = pbx * py4 + wpx*py5
                  ppzx4 = pbx * pz4 + wpx*pz5
                  ppxy4 = pby * px4 + wpy*px5
                  ppyy4 = pby * py4 + wpy*py5 + s45
                  ppzy4 = pby * pz4 + wpy*pz5
                  ppxz4 = pbz * px4 + wpz*px5
                  ppyz4 = pbz * py4 + wpz*py5
                  ppzz4 = pbz * pz4 + wpz*pz5 + s45
                  ppxx5 = pbx * px5 + wpx*px6 + s56
                  ppyx5 = pbx * py5 + wpx*py6
                  ppzx5 = pbx * pz5 + wpx*pz6
                  ppxy5 = pby * px5 + wpy*px6
                  ppyy5 = pby * py5 + wpy*py6 + s56
                  ppzy5 = pby * pz5 + wpy*pz6
                  ppxz5 = pbz * px5 + wpz*px6
                  ppyz5 = pbz * py5 + wpz*py6
                  ppzz5 = pbz * pz5 + wpz*pz6 + s56

!psss01(01-56)
                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  px34 = zet*(px3-rooz*px4)
                  py34 = zet*(py3-rooz*py4)
                  pz34 = zet*(pz3-rooz*pz4)
                  px45 = zet*(px4-rooz*px5)
                  py45 = zet*(py4-rooz*py5)
                  pz45 = zet*(pz4-rooz*pz5)
                  px56 = zet*(px5-rooz*px6)
                  py56 = zet*(py5-rooz*py6)
                  pz56 = zet*(pz5-rooz*pz6)

!dpss(0-5) 
                  dpxxx0 =  pbx*dxx0 + wpx*dxx1 + 2.0d0*px01
                  dpxxy0 =  pby*dxx0 + wpy*dxx1             
                  dpxxz0 =  pbz*dxx0 + wpz*dxx1             
                  dpyyx0 =  pbx*dyy0 + wpx*dyy1             
                  dpyyy0 =  pby*dyy0 + wpy*dyy1 + 2.0d0*py01
                  dpyyz0 =  pbz*dyy0 + wpz*dyy1             
                  dpzzx0 =  pbx*dzz0 + wpx*dzz1             
                  dpzzy0 =  pby*dzz0 + wpy*dzz1             
                  dpzzz0 =  pbz*dzz0 + wpz*dzz1 + 2.0d0*pz01
                  dpyxx0 =  pbx*dyx0 + wpx*dyx1 +       py01
                  dpyxy0 =  pby*dyx0 + wpy*dyx1 +       px01
                  dpyxz0 =  pbz*dyx0 + wpz*dyx1             
                  dpzxx0 =  pbx*dzx0 + wpx*dzx1 +       pz01
                  dpzxy0 =  pby*dzx0 + wpy*dzx1             
                  dpzxz0 =  pbz*dzx0 + wpz*dzx1 +       px01
                  dpzyx0 =  pbx*dzy0 + wpx*dzy1             
                  dpzyy0 =  pby*dzy0 + wpy*dzy1 +       pz01
                  dpzyz0 =  pbz*dzy0 + wpz*dzy1 +       py01
                  dpxxx1 =  pbx*dxx1 + wpx*dxx2 + 2.0d0*px12
                  dpxxy1 =  pby*dxx1 + wpy*dxx2             
                  dpxxz1 =  pbz*dxx1 + wpz*dxx2             
                  dpyyx1 =  pbx*dyy1 + wpx*dyy2             
                  dpyyy1 =  pby*dyy1 + wpy*dyy2 + 2.0d0*py12
                  dpyyz1 =  pbz*dyy1 + wpz*dyy2             
                  dpzzx1 =  pbx*dzz1 + wpx*dzz2             
                  dpzzy1 =  pby*dzz1 + wpy*dzz2             
                  dpzzz1 =  pbz*dzz1 + wpz*dzz2 + 2.0d0*pz12
                  dpyxx1 =  pbx*dyx1 + wpx*dyx2 +       py12
                  dpyxy1 =  pby*dyx1 + wpy*dyx2 +       px12
                  dpyxz1 =  pbz*dyx1 + wpz*dyx2             
                  dpzxx1 =  pbx*dzx1 + wpx*dzx2 +       pz12
                  dpzxy1 =  pby*dzx1 + wpy*dzx2             
                  dpzxz1 =  pbz*dzx1 + wpz*dzx2 +       px12
                  dpzyx1 =  pbx*dzy1 + wpx*dzy2             
                  dpzyy1 =  pby*dzy1 + wpy*dzy2 +       pz12
                  dpzyz1 =  pbz*dzy1 + wpz*dzy2 +       py12
                  dpxxx2 =  pbx*dxx2 + wpx*dxx3 + 2.0d0*px23
                  dpxxy2 =  pby*dxx2 + wpy*dxx3
                  dpxxz2 =  pbz*dxx2 + wpz*dxx3
                  dpyyx2 =  pbx*dyy2 + wpx*dyy3
                  dpyyy2 =  pby*dyy2 + wpy*dyy3 + 2.0d0*py23
                  dpyyz2 =  pbz*dyy2 + wpz*dyy3             
                  dpzzx2 =  pbx*dzz2 + wpx*dzz3             
                  dpzzy2 =  pby*dzz2 + wpy*dzz3             
                  dpzzz2 =  pbz*dzz2 + wpz*dzz3 + 2.0d0*pz23
                  dpyxx2 =  pbx*dyx2 + wpx*dyx3 +       py23
                  dpyxy2 =  pby*dyx2 + wpy*dyx3 +       px23
                  dpyxz2 =  pbz*dyx2 + wpz*dyx3             
                  dpzxx2 =  pbx*dzx2 + wpx*dzx3 +       pz23
                  dpzxy2 =  pby*dzx2 + wpy*dzx3             
                  dpzxz2 =  pbz*dzx2 + wpz*dzx3 +       px23
                  dpzyx2 =  pbx*dzy2 + wpx*dzy3             
                  dpzyy2 =  pby*dzy2 + wpy*dzy3 +       pz23
                  dpzyz2 =  pbz*dzy2 + wpz*dzy3 +       py23
                  dpxxx3 =  pbx*dxx3 + wpx*dxx4 + 2.0d0*px34
                  dpxxy3 =  pby*dxx3 + wpy*dxx4             
                  dpxxz3 =  pbz*dxx3 + wpz*dxx4             
                  dpyyx3 =  pbx*dyy3 + wpx*dyy4             
                  dpyyy3 =  pby*dyy3 + wpy*dyy4 + 2.0d0*py34
                  dpyyz3 =  pbz*dyy3 + wpz*dyy4             
                  dpzzx3 =  pbx*dzz3 + wpx*dzz4             
                  dpzzy3 =  pby*dzz3 + wpy*dzz4             
                  dpzzz3 =  pbz*dzz3 + wpz*dzz4 + 2.0d0*pz34
                  dpyxx3 =  pbx*dyx3 + wpx*dyx4 +       py34
                  dpyxy3 =  pby*dyx3 + wpy*dyx4 +       px34
                  dpyxz3 =  pbz*dyx3 + wpz*dyx4             
                  dpzxx3 =  pbx*dzx3 + wpx*dzx4 +       pz34
                  dpzxy3 =  pby*dzx3 + wpy*dzx4             
                  dpzxz3 =  pbz*dzx3 + wpz*dzx4 +       px34
                  dpzyx3 =  pbx*dzy3 + wpx*dzy4             
                  dpzyy3 =  pby*dzy3 + wpy*dzy4 +       pz34
                  dpzyz3 =  pbz*dzy3 + wpz*dzy4 +       py34
                  dpxxx4 =  pbx*dxx4 + wpx*dxx5 + 2.0d0*px45
                  dpxxy4 =  pby*dxx4 + wpy*dxx5             
                  dpxxz4 =  pbz*dxx4 + wpz*dxx5             
                  dpyyx4 =  pbx*dyy4 + wpx*dyy5             
                  dpyyy4 =  pby*dyy4 + wpy*dyy5 + 2.0d0*py45
                  dpyyz4 =  pbz*dyy4 + wpz*dyy5             
                  dpzzx4 =  pbx*dzz4 + wpx*dzz5             
                  dpzzy4 =  pby*dzz4 + wpy*dzz5             
                  dpzzz4 =  pbz*dzz4 + wpz*dzz5 + 2.0d0*pz45
                  dpyxx4 =  pbx*dyx4 + wpx*dyx5 +       py45
                  dpyxy4 =  pby*dyx4 + wpy*dyx5 +       px45
                  dpyxz4 =  pbz*dyx4 + wpz*dyx5             
                  dpzxx4 =  pbx*dzx4 + wpx*dzx5 +       pz45
                  dpzxy4 =  pby*dzx4 + wpy*dzx5             
                  dpzxz4 =  pbz*dzx4 + wpz*dzx5 +       px45
                  dpzyx4 =  pbx*dzy4 + wpx*dzy5             
                  dpzyy4 =  pby*dzy4 + wpy*dzy5 +       pz45
                  dpzyz4 =  pbz*dzy4 + wpz*dzy5 +       py45
                  dpxxx5 =  pbx*dxx5 + wpx*dxx6 + 2.0d0*px56
                  dpxxy5 =  pby*dxx5 + wpy*dxx6             
                  dpxxz5 =  pbz*dxx5 + wpz*dxx6             
                  dpyyx5 =  pbx*dyy5 + wpx*dyy6             
                  dpyyy5 =  pby*dyy5 + wpy*dyy6 + 2.0d0*py56
                  dpyyz5 =  pbz*dyy5 + wpz*dyy6             
                  dpzzx5 =  pbx*dzz5 + wpx*dzz6             
                  dpzzy5 =  pby*dzz5 + wpy*dzz6             
                  dpzzz5 =  pbz*dzz5 + wpz*dzz6 + 2.0d0*pz56
                  dpyxx5 =  pbx*dyx5 + wpx*dyx6 +       py56
                  dpyxy5 =  pby*dyx5 + wpy*dyx6 +       px56
                  dpyxz5 =  pbz*dyx5 + wpz*dyx6             
                  dpzxx5 =  pbx*dzx5 + wpx*dzx6 +       pz56
                  dpzxy5 =  pby*dzx5 + wpy*dzx6             
                  dpzxz5 =  pbz*dzx5 + wpz*dzx6 +       px56
                  dpzyx5 =  pbx*dzy5 + wpx*dzy6             
                  dpzyy5 =  pby*dzy5 + wpy*dzy6 +       pz56
                  dpzyz5 =  pbz*dzy5 + wpz*dzy6 +       py56

!rpsss(3-4)
                  rpx3 = rkp*px3
                  rpy3 = rkp*py3
                  rpz3 = rkp*pz3
                  rpx4 = rkp*px4
                  rpy4 = rkp*py4
                  rpz4 = rkp*pz4
!rspss(3-4)
                  rxp3 = rkp*xp3
                  ryp3 = rkp*yp3
                  rzp3 = rkp*zp3
                  rxp4 = rkp*xp4
                  ryp4 = rkp*yp4
                  rzp4 = rkp*zp4

!ppps(2-3)
                  pppxxx2 = qcx*ppxx2 + wqx*ppxx3 + rxp3 + rpx3
                  pppxxy2 = qcy*ppxx2 + wqy*ppxx3        
                  pppxxz2 = qcz*ppxx2 + wqz*ppxx3        
                  pppxyx2 = qcx*ppxy2 + wqx*ppxy3 + ryp3
                  pppxyy2 = qcy*ppxy2 + wqy*ppxy3        + rpx3
                  pppxyz2 = qcz*ppxy2 + wqz*ppxy3              
                  pppxzx2 = qcx*ppxz2 + wqx*ppxz3 + rzp3       
                  pppxzy2 = qcy*ppxz2 + wqy*ppxz3              
                  pppxzz2 = qcz*ppxz2 + wqz*ppxz3        + rpx3
                  pppyxx2 = qcx*ppyx2 + wqx*ppyx3        + rpy3
                  pppyxy2 = qcy*ppyx2 + wqy*ppyx3 + rxp3       
                  pppyxz2 = qcz*ppyx2 + wqz*ppyx3              
                  pppyyx2 = qcx*ppyy2 + wqx*ppyy3              
                  pppyyy2 = qcy*ppyy2 + wqy*ppyy3 + ryp3 + rpy3
                  pppyyz2 = qcz*ppyy2 + wqz*ppyy3              
                  pppyzx2 = qcx*ppyz2 + wqx*ppyz3              
                  pppyzy2 = qcy*ppyz2 + wqy*ppyz3 + rzp3       
                  pppyzz2 = qcz*ppyz2 + wqz*ppyz3        + rpy3
                  pppzxx2 = qcx*ppzx2 + wqx*ppzx3        + rpz3
                  pppzxy2 = qcy*ppzx2 + wqy*ppzx3              
                  pppzxz2 = qcz*ppzx2 + wqz*ppzx3 + rxp3       
                  pppzyx2 = qcx*ppzy2 + wqx*ppzy3              
                  pppzyy2 = qcy*ppzy2 + wqy*ppzy3        + rpz3
                  pppzyz2 = qcz*ppzy2 + wqz*ppzy3 + ryp3       
                  pppzzx2 = qcx*ppzz2 + wqx*ppzz3
                  pppzzy2 = qcy*ppzz2 + wqy*ppzz3              
                  pppzzz2 = qcz*ppzz2 + wqz*ppzz3 + rzp3 + rpz3
                  pppxxx3 = qcx*ppxx3 + wqx*ppxx4 + rxp4 + rpx4
                  pppxxy3 = qcy*ppxx3 + wqy*ppxx4        
                  pppxxz3 = qcz*ppxx3 + wqz*ppxx4        
                  pppxyx3 = qcx*ppxy3 + wqx*ppxy4 + ryp4
                  pppxyy3 = qcy*ppxy3 + wqy*ppxy4        + rpx4
                  pppxyz3 = qcz*ppxy3 + wqz*ppxy4              
                  pppxzx3 = qcx*ppxz3 + wqx*ppxz4 + rzp4       
                  pppxzy3 = qcy*ppxz3 + wqy*ppxz4              
                  pppxzz3 = qcz*ppxz3 + wqz*ppxz4        + rpx4
                  pppyxx3 = qcx*ppyx3 + wqx*ppyx4        + rpy4
                  pppyxy3 = qcy*ppyx3 + wqy*ppyx4 + rxp4       
                  pppyxz3 = qcz*ppyx3 + wqz*ppyx4              
                  pppyyx3 = qcx*ppyy3 + wqx*ppyy4              
                  pppyyy3 = qcy*ppyy3 + wqy*ppyy4 + ryp4 + rpy4
                  pppyyz3 = qcz*ppyy3 + wqz*ppyy4              
                  pppyzx3 = qcx*ppyz3 + wqx*ppyz4              
                  pppyzy3 = qcy*ppyz3 + wqy*ppyz4 + rzp4       
                  pppyzz3 = qcz*ppyz3 + wqz*ppyz4        + rpy4
                  pppzxx3 = qcx*ppzx3 + wqx*ppzx4        + rpz4
                  pppzxy3 = qcy*ppzx3 + wqy*ppzx4              
                  pppzxz3 = qcz*ppzx3 + wqz*ppzx4 + rxp4       
                  pppzyx3 = qcx*ppzy3 + wqx*ppzy4              
                  pppzyy3 = qcy*ppzy3 + wqy*ppzy4        + rpz4
                  pppzyz3 = qcz*ppzy3 + wqz*ppzy4 + ryp4       
                  pppzzx3 = qcx*ppzz3 + wqx*ppzz4
                  pppzzy3 = qcy*ppzz3 + wqy*ppzz4              
                  pppzzz3 = qcz*ppzz3 + wqz*ppzz4 + rzp4 + rpz4

!sdps(2-3)
                  xxdpx2 = qcx*sdxx2 + wqx*sdxx3 + 2.d0*rxp3
                  xxdpy2 = qcy*sdxx2 + wqy*sdxx3
                  xxdpz2 = qcz*sdxx2 + wqz*sdxx3
                  yydpx2 = qcx*sdyy2 + wqx*sdyy3
                  yydpy2 = qcy*sdyy2 + wqy*sdyy3 + 2.d0*ryp3
                  yydpz2 = qcz*sdyy2 + wqz*sdyy3
                  zzdpx2 = qcx*sdzz2 + wqx*sdzz3
                  zzdpy2 = qcy*sdzz2 + wqy*sdzz3
                  zzdpz2 = qcz*sdzz2 + wqz*sdzz3 + 2.d0*rzp3
                  yxdpx2 = qcx*sdyx2 + wqx*sdyx3 + 1.d0*ryp3
                  yxdpy2 = qcy*sdyx2 + wqy*sdyx3 + 1.d0*rxp3
                  yxdpz2 = qcz*sdyx2 + wqz*sdyx3
                  zxdpx2 = qcx*sdzx2 + wqx*sdzx3 + 1.d0*rzp3
                  zxdpy2 = qcy*sdzx2 + wqy*sdzx3
                  zxdpz2 = qcz*sdzx2 + wqz*sdzx3 + 1.d0*rxp3
                  zydpx2 = qcx*sdzy2 + wqx*sdzy3
                  zydpy2 = qcy*sdzy2 + wqy*sdzy3 + 1.d0*rzp3
                  zydpz2 = qcz*sdzy2 + wqz*sdzy3 + 1.d0*ryp3
                  xxdpx3 = qcx*sdxx3 + wqx*sdxx4 + 2.d0*rxp4
                  xxdpy3 = qcy*sdxx3 + wqy*sdxx4
                  xxdpz3 = qcz*sdxx3 + wqz*sdxx4
                  yydpx3 = qcx*sdyy3 + wqx*sdyy4
                  yydpy3 = qcy*sdyy3 + wqy*sdyy4 + 2.d0*ryp4
                  yydpz3 = qcz*sdyy3 + wqz*sdyy4
                  zzdpx3 = qcx*sdzz3 + wqx*sdzz4
                  zzdpy3 = qcy*sdzz3 + wqy*sdzz4
                  zzdpz3 = qcz*sdzz3 + wqz*sdzz4 + 2.d0*rzp4
                  yxdpx3 = qcx*sdyx3 + wqx*sdyx4 + 1.d0*ryp4
                  yxdpy3 = qcy*sdyx3 + wqy*sdyx4 + 1.d0*rxp4
                  yxdpz3 = qcz*sdyx3 + wqz*sdyx4
                  zxdpx3 = qcx*sdzx3 + wqx*sdzx4 + 1.d0*rzp4
                  zxdpy3 = qcy*sdzx3 + wqy*sdzx4
                  zxdpz3 = qcz*sdzx3 + wqz*sdzx4 + 1.d0*rxp4
                  zydpx3 = qcx*sdzy3 + wqx*sdzy4
                  zydpy3 = qcy*sdzy3 + wqy*sdzy4 + 1.d0*rzp4
                  zydpz3 = qcz*sdzy3 + wqz*sdzy4 + 1.d0*ryp4

!dsps(2-3)
                  dxxpx2 =  qcx*dxx2 + wqx*dxx3 + 2.0d0*rpx3
                  dxxpy2 =  qcy*dxx2 + wqy*dxx3
                  dxxpz2 =  qcz*dxx2 + wqz*dxx3
                  dyypx2 =  qcx*dyy2 + wqx*dyy3
                  dyypy2 =  qcy*dyy2 + wqy*dyy3 + 2.0d0*rpy3
                  dyypz2 =  qcz*dyy2 + wqz*dyy3
                  dzzpx2 =  qcx*dzz2 + wqx*dzz3
                  dzzpy2 =  qcy*dzz2 + wqy*dzz3
                  dzzpz2 =  qcz*dzz2 + wqz*dzz3 + 2.0d0*rpz3
                  dyxpx2 =  qcx*dyx2 + wqx*dyx3 +       rpy3
                  dyxpy2 =  qcy*dyx2 + wqy*dyx3 +       rpx3
                  dyxpz2 =  qcz*dyx2 + wqz*dyx3
                  dzxpx2 =  qcx*dzx2 + wqx*dzx3 +       rpz3
                  dzxpy2 =  qcy*dzx2 + wqy*dzx3
                  dzxpz2 =  qcz*dzx2 + wqz*dzx3 +       rpx3
                  dzypx2 =  qcx*dzy2 + wqx*dzy3
                  dzypy2 =  qcy*dzy2 + wqy*dzy3 +       rpz3
                  dzypz2 =  qcz*dzy2 + wqz*dzy3 +       rpy3
                  dxxpx3 =  qcx*dxx3 + wqx*dxx4 + 2.0d0*rpx4
                  dxxpy3 =  qcy*dxx3 + wqy*dxx4
                  dxxpz3 =  qcz*dxx3 + wqz*dxx4
                  dyypx3 =  qcx*dyy3 + wqx*dyy4
                  dyypy3 =  qcy*dyy3 + wqy*dyy4 + 2.0d0*rpy4
                  dyypz3 =  qcz*dyy3 + wqz*dyy4
                  dzzpx3 =  qcx*dzz3 + wqx*dzz4
                  dzzpy3 =  qcy*dzz3 + wqy*dzz4
                  dzzpz3 =  qcz*dzz3 + wqz*dzz4 + 2.0d0*rpz4
                  dyxpx3 =  qcx*dyx3 + wqx*dyx4 +       rpy4
                  dyxpy3 =  qcy*dyx3 + wqy*dyx4 +       rpx4
                  dyxpz3 =  qcz*dyx3 + wqz*dyx4
                  dzxpx3 =  qcx*dzx3 + wqx*dzx4 +       rpz4
                  dzxpy3 =  qcy*dzx3 + wqy*dzx4
                  dzxpz3 =  qcz*dzx3 + wqz*dzx4 +       rpx4
                  dzypx3 =  qcx*dzy3 + wqx*dzy4
                  dzypy3 =  qcy*dzy3 + wqy*dzy4 +       rpz4
                  dzypz3 =  qcz*dzy3 + wqz*dzy4 +       rpy4

!spss01(12-45)
         xp12 = zet*(xp1 - rooz*xp2)
         yp12 = zet*(yp1 - rooz*yp2)
         zp12 = zet*(zp1 - rooz*zp2)
         xp23 = zet*(xp2 - rooz*xp3)
         yp23 = zet*(yp2 - rooz*yp3)
         zp23 = zet*(zp2 - rooz*zp3)
         xp34 = zet*(xp3 - rooz*xp4)
         yp34 = zet*(yp3 - rooz*yp4)
         zp34 = zet*(zp3 - rooz*zp4)
         xp45 = zet*(xp4 - rooz*xp5)
         yp45 = zet*(yp4 - rooz*yp5)
         zp45 = zet*(zp4 - rooz*zp5)

!pdss(1-4)
         pdxxx1 = pbx*ppxx1 + wpx*ppxx2 +px12 +xp12
         pdxyy1 = pby*ppxy1 + wpy*ppxy2 +px12 
         pdxzz1 = pbz*ppxz1 + wpz*ppxz2 +px12 
         pdxyx1 = pby*ppxx1 + wpy*ppxx2 
         pdxzx1 = pbz*ppxx1 + wpz*ppxx2 
         pdxzy1 = pby*ppxz1 + wpy*ppxz2
         pdyxx1 = pbx*ppyx1 + wpx*ppyx2 +py12
         pdyyy1 = pby*ppyy1 + wpy*ppyy2 +py12 +yp12 
         pdyzz1 = pbz*ppyz1 + wpz*ppyz2 +py12 
         pdyyx1 = pbx*ppyy1 + wpx*ppyy2 
         pdyzx1 = pbx*ppyz1 + wpx*ppyz2 
         pdyzy1 = pbz*ppyy1 + wpz*ppyy2 
         pdzxx1 = pbx*ppzx1 + wpx*ppzx2 +pz12
         pdzyy1 = pby*ppzy1 + wpy*ppzy2 +pz12
         pdzzz1 = pbz*ppzz1 + wpz*ppzz2 +pz12 +zp12
         pdzyx1 = pbx*ppzy1 + wpx*ppzy2
         pdzzx1 = pbx*ppzz1 + wpx*ppzz2
         pdzzy1 = pby*ppzz1 + wpy*ppzz2

         pdxxx2 = pbx*ppxx2 + wpx*ppxx3 +px23 +xp23
         pdxyy2 = pby*ppxy2 + wpy*ppxy3 +px23
         pdxzz2 = pbz*ppxz2 + wpz*ppxz3 +px23
         pdxyx2 = pby*ppxx2 + wpy*ppxx3
         pdxzx2 = pbz*ppxx2 + wpz*ppxx3
         pdxzy2 = pby*ppxz2 + wpy*ppxz3
         pdyxx2 = pbx*ppyx2 + wpx*ppyx3 +py23
         pdyyy2 = pby*ppyy2 + wpy*ppyy3 +py23 +yp23
         pdyzz2 = pbz*ppyz2 + wpz*ppyz3 +py23
         pdyyx2 = pbx*ppyy2 + wpx*ppyy3
         pdyzx2 = pbx*ppyz2 + wpx*ppyz3
         pdyzy2 = pbz*ppyy2 + wpz*ppyy3
         pdzxx2 = pbx*ppzx2 + wpx*ppzx3 +pz23
         pdzyy2 = pby*ppzy2 + wpy*ppzy3 +pz23
         pdzzz2 = pbz*ppzz2 + wpz*ppzz3 +pz23 +zp23
         pdzyx2 = pbx*ppzy2 + wpx*ppzy3
         pdzzx2 = pbx*ppzz2 + wpx*ppzz3
         pdzzy2 = pby*ppzz2 + wpy*ppzz3

         pdxxx3 = pbx*ppxx3 + wpx*ppxx4 +px34 +xp34
         pdxyy3 = pby*ppxy3 + wpy*ppxy4 +px34
         pdxzz3 = pbz*ppxz3 + wpz*ppxz4 +px34
         pdxyx3 = pby*ppxx3 + wpy*ppxx4
         pdxzx3 = pbz*ppxx3 + wpz*ppxx4
         pdxzy3 = pby*ppxz3 + wpy*ppxz4
         pdyxx3 = pbx*ppyx3 + wpx*ppyx4 +py34
         pdyyy3 = pby*ppyy3 + wpy*ppyy4 +py34 +yp34
         pdyzz3 = pbz*ppyz3 + wpz*ppyz4 +py34
         pdyyx3 = pbx*ppyy3 + wpx*ppyy4
         pdyzx3 = pbx*ppyz3 + wpx*ppyz4
         pdyzy3 = pbz*ppyy3 + wpz*ppyy4
         pdzxx3 = pbx*ppzx3 + wpx*ppzx4 +pz34
         pdzyy3 = pby*ppzy3 + wpy*ppzy4 +pz34
         pdzzz3 = pbz*ppzz3 + wpz*ppzz4 +pz34 +zp34
         pdzyx3 = pbx*ppzy3 + wpx*ppzy4
         pdzzx3 = pbx*ppzz3 + wpx*ppzz4
         pdzzy3 = pby*ppzz3 + wpy*ppzz4

         pdxxx4 = pbx*ppxx4 + wpx*ppxx5 +px45 +xp45
         pdxyy4 = pby*ppxy4 + wpy*ppxy5 +px45
         pdxzz4 = pbz*ppxz4 + wpz*ppxz5 +px45
         pdxyx4 = pby*ppxx4 + wpy*ppxx5
         pdxzx4 = pbz*ppxx4 + wpz*ppxx5
         pdxzy4 = pby*ppxz4 + wpy*ppxz5
         pdyxx4 = pbx*ppyx4 + wpx*ppyx5 +py45
         pdyyy4 = pby*ppyy4 + wpy*ppyy5 +py45 +yp45
         pdyzz4 = pbz*ppyz4 + wpz*ppyz5 +py45
         pdyyx4 = pbx*ppyy4 + wpx*ppyy5
         pdyzx4 = pbx*ppyz4 + wpx*ppyz5
         pdyzy4 = pbz*ppyy4 + wpz*ppyy5
         pdzxx4 = pbx*ppzx4 + wpx*ppzx5 +pz45
         pdzyy4 = pby*ppzy4 + wpy*ppzy5 +pz45
         pdzzz4 = pbz*ppzz4 + wpz*ppzz5 +pz45 +zp45
         pdzyx4 = pbx*ppzy4 + wpx*ppzy5
         pdzzx4 = pbx*ppzz4 + wpx*ppzz5
         pdzzy4 = pby*ppzz4 + wpy*ppzz5

!ppss01(01-45)
         ppxx01 = zet*(ppxx0 - rooz*ppxx1)
         ppxy01 = zet*(ppxy0 - rooz*ppxy1)
         ppxz01 = zet*(ppxz0 - rooz*ppxz1)
         ppyx01 = zet*(ppyx0 - rooz*ppyx1)
         ppyy01 = zet*(ppyy0 - rooz*ppyy1)
         ppyz01 = zet*(ppyz0 - rooz*ppyz1)
         ppzx01 = zet*(ppzx0 - rooz*ppzx1)
         ppzy01 = zet*(ppzy0 - rooz*ppzy1)
         ppzz01 = zet*(ppzz0 - rooz*ppzz1)
  
         ppxx12 = zet*(ppxx1 - rooz*ppxx2)
         ppxy12 = zet*(ppxy1 - rooz*ppxy2)
         ppxz12 = zet*(ppxz1 - rooz*ppxz2)
         ppyx12 = zet*(ppyx1 - rooz*ppyx2)
         ppyy12 = zet*(ppyy1 - rooz*ppyy2)
         ppyz12 = zet*(ppyz1 - rooz*ppyz2)
         ppzx12 = zet*(ppzx1 - rooz*ppzx2)
         ppzy12 = zet*(ppzy1 - rooz*ppzy2)
         ppzz12 = zet*(ppzz1 - rooz*ppzz2)
  
         ppxx23 = zet*(ppxx2 - rooz*ppxx3)
         ppxy23 = zet*(ppxy2 - rooz*ppxy3)
         ppxz23 = zet*(ppxz2 - rooz*ppxz3)
         ppyx23 = zet*(ppyx2 - rooz*ppyx3)
         ppyy23 = zet*(ppyy2 - rooz*ppyy3)
         ppyz23 = zet*(ppyz2 - rooz*ppyz3)
         ppzx23 = zet*(ppzx2 - rooz*ppzx3)
         ppzy23 = zet*(ppzy2 - rooz*ppzy3)
         ppzz23 = zet*(ppzz2 - rooz*ppzz3)
  
         ppxx34 = zet*(ppxx3 - rooz*ppxx4)
         ppxy34 = zet*(ppxy3 - rooz*ppxy4)
         ppxz34 = zet*(ppxz3 - rooz*ppxz4)
         ppyx34 = zet*(ppyx3 - rooz*ppyx4)
         ppyy34 = zet*(ppyy3 - rooz*ppyy4)
         ppyz34 = zet*(ppyz3 - rooz*ppyz4)
         ppzx34 = zet*(ppzx3 - rooz*ppzx4)
         ppzy34 = zet*(ppzy3 - rooz*ppzy4)
         ppzz34 = zet*(ppzz3 - rooz*ppzz4)

         ppxx45 = zet*(ppxx4 - rooz*ppxx5)
         ppxy45 = zet*(ppxy4 - rooz*ppxy5)
         ppxz45 = zet*(ppxz4 - rooz*ppxz5)
         ppyx45 = zet*(ppyx4 - rooz*ppyx5)
         ppyy45 = zet*(ppyy4 - rooz*ppyy5)
         ppyz45 = zet*(ppyz4 - rooz*ppyz5)
         ppzx45 = zet*(ppzx4 - rooz*ppzx5)
         ppzy45 = zet*(ppzy4 - rooz*ppzy5)
         ppzz45 = zet*(ppzz4 - rooz*ppzz5)

!dsss01(01-45)
       dxx01 = zet*(dxx0 -rooz*dxx1)
       dyy01 = zet*(dyy0 -rooz*dyy1)
       dzz01 = zet*(dzz0 -rooz*dzz1)
       dyx01 = zet*(dyx0 -rooz*dyx1)
       dzx01 = zet*(dzx0 -rooz*dzx1)
       dzy01 = zet*(dzy0 -rooz*dzy1)

       dxx12 = zet*(dxx1 -rooz*dxx2)
       dyy12 = zet*(dyy1 -rooz*dyy2)
       dzz12 = zet*(dzz1 -rooz*dzz2)
       dyx12 = zet*(dyx1 -rooz*dyx2)
       dzx12 = zet*(dzx1 -rooz*dzx2)
       dzy12 = zet*(dzy1 -rooz*dzy2)

       dxx23 = zet*(dxx2 -rooz*dxx3)
       dyy23 = zet*(dyy2 -rooz*dyy3)
       dzz23 = zet*(dzz2 -rooz*dzz3)
       dyx23 = zet*(dyx2 -rooz*dyx3)
       dzx23 = zet*(dzx2 -rooz*dzx3)
       dzy23 = zet*(dzy2 -rooz*dzy3)

       dxx34 = zet*(dxx3 -rooz*dxx4)
       dyy34 = zet*(dyy3 -rooz*dyy4)
       dzz34 = zet*(dzz3 -rooz*dzz4)
       dyx34 = zet*(dyx3 -rooz*dyx4)
       dzx34 = zet*(dzx3 -rooz*dzx4)
       dzy34 = zet*(dzy3 -rooz*dzy4)

       dxx45 = zet*(dxx4 -rooz*dxx5)
       dyy45 = zet*(dyy4 -rooz*dyy5)
       dzz45 = zet*(dzz4 -rooz*dzz5)
       dyx45 = zet*(dyx4 -rooz*dyx5)
       dzx45 = zet*(dzx4 -rooz*dzx5)
       dzy45 = zet*(dzy4 -rooz*dzy5)

!ddss(0-4)
       ddxxxx0 = pbx*dpxxx0 + wpx*dpxxx1 + 2.0d0*ppxx01 + dxx01
       ddxxyy0 = pby*dpxxy0 + wpy*dpxxy1                + dxx01
       ddxxzz0 = pbz*dpxxz0 + wpz*dpxxz1                + dxx01
       ddxxyx0 = pby*dpxxx0 + wpy*dpxxx1
       ddxxzx0 = pbz*dpxxx0 + wpz*dpxxx1
       ddxxzy0 = pby*dpxxz0 + wpy*dpxxz1
       ddyyxx0 = pbx*dpyyx0 + wpx*dpyyx1                + dyy01
       ddyyyy0 = pby*dpyyy0 + wpy*dpyyy1 + 2.0d0*ppyy01 + dyy01
       ddyyzz0 = pbz*dpyyz0 + wpz*dpyyz1                + dyy01
       ddyyyx0 = pbx*dpyyy0 + wpx*dpyyy1
       ddyyzx0 = pbx*dpyyz0 + wpx*dpyyz1
       ddyyzy0 = pbz*dpyyy0 + wpz*dpyyy1
       ddzzxx0 = pbx*dpzzx0 + wpx*dpzzx1                + dzz01
       ddzzyy0 = pby*dpzzy0 + wpy*dpzzy1                + dzz01
       ddzzzz0 = pbz*dpzzz0 + wpz*dpzzz1 + 2.0d0*ppzz01 + dzz01
       ddzzyx0 = pbx*dpzzy0 + wpx*dpzzy1
       ddzzzx0 = pbx*dpzzz0 + wpx*dpzzz1
       ddzzzy0 = pby*dpzzz0 + wpy*dpzzz1
       ddyxxx0 = pbx*dpyxx0 + wpx*dpyxx1 +       ppyx01 + dyx01
       ddyxyy0 = pby*dpyxy0 + wpy*dpyxy1 +       ppxy01 + dyx01
       ddyxzz0 = pbz*dpyxz0 + wpz*dpyxz1                + dyx01
       ddyxyx0 = pbx*dpyxy0 + wpx*dpyxy1 +       ppyy01
       ddyxzx0 = pbz*dpyxx0 + wpz*dpyxx1
       ddyxzy0 = pbz*dpyxy0 + wpz*dpyxy1
       ddzxxx0 = pbx*dpzxx0 + wpx*dpzxx1 +       ppzx01 + dzx01
       ddzxyy0 = pby*dpzxy0 + wpy*dpzxy1                + dzx01
       ddzxzz0 = pbz*dpzxz0 + wpz*dpzxz1 +       ppxz01 + dzx01
       ddzxyx0 = pby*dpzxx0 + wpy*dpzxx1
       ddzxzx0 = pbx*dpzxz0 + wpx*dpzxz1 +       ppzz01
       ddzxzy0 = pby*dpzxz0 + wpy*dpzxz1
       ddzyxx0 = pbx*dpzyx0 + wpx*dpzyx1                + dzy01
       ddzyyy0 = pby*dpzyy0 + wpy*dpzyy1 +       ppzy01 + dzy01
       ddzyzz0 = pbz*dpzyz0 + wpz*dpzyz1 +       ppyz01 + dzy01
       ddzyyx0 = pbx*dpzyy0 + wpx*dpzyy1
       ddzyzx0 = pbx*dpzyz0 + wpx*dpzyz1
       ddzyzy0 = pby*dpzyz0 + wpy*dpzyz1 +       ppzz01

       ddxxxx1 = pbx*dpxxx1 + wpx*dpxxx2 + 2.0d0*ppxx12 + dxx12
       ddxxyy1 = pby*dpxxy1 + wpy*dpxxy2                + dxx12
       ddxxzz1 = pbz*dpxxz1 + wpz*dpxxz2                + dxx12
       ddxxyx1 = pby*dpxxx1 + wpy*dpxxx2
       ddxxzx1 = pbz*dpxxx1 + wpz*dpxxx2
       ddxxzy1 = pby*dpxxz1 + wpy*dpxxz2
       ddyyxx1 = pbx*dpyyx1 + wpx*dpyyx2                + dyy12
       ddyyyy1 = pby*dpyyy1 + wpy*dpyyy2 + 2.0d0*ppyy12 + dyy12
       ddyyzz1 = pbz*dpyyz1 + wpz*dpyyz2                + dyy12
       ddyyyx1 = pbx*dpyyy1 + wpx*dpyyy2
       ddyyzx1 = pbx*dpyyz1 + wpx*dpyyz2
       ddyyzy1 = pbz*dpyyy1 + wpz*dpyyy2
       ddzzxx1 = pbx*dpzzx1 + wpx*dpzzx2                + dzz12
       ddzzyy1 = pby*dpzzy1 + wpy*dpzzy2                + dzz12
       ddzzzz1 = pbz*dpzzz1 + wpz*dpzzz2 + 2.0d0*ppzz12 + dzz12
       ddzzyx1 = pbx*dpzzy1 + wpx*dpzzy2
       ddzzzx1 = pbx*dpzzz1 + wpx*dpzzz2
       ddzzzy1 = pby*dpzzz1 + wpy*dpzzz2
       ddyxxx1 = pbx*dpyxx1 + wpx*dpyxx2 +       ppyx12 + dyx12
       ddyxyy1 = pby*dpyxy1 + wpy*dpyxy2 +       ppxy12 + dyx12
       ddyxzz1 = pbz*dpyxz1 + wpz*dpyxz2                + dyx12
       ddyxyx1 = pbx*dpyxy1 + wpx*dpyxy2 +       ppyy12
       ddyxzx1 = pbz*dpyxx1 + wpz*dpyxx2
       ddyxzy1 = pbz*dpyxy1 + wpz*dpyxy2
       ddzxxx1 = pbx*dpzxx1 + wpx*dpzxx2 +       ppzx12 + dzx12
       ddzxyy1 = pby*dpzxy1 + wpy*dpzxy2                + dzx12
       ddzxzz1 = pbz*dpzxz1 + wpz*dpzxz2 +       ppxz12 + dzx12
       ddzxyx1 = pby*dpzxx1 + wpy*dpzxx2
       ddzxzx1 = pbx*dpzxz1 + wpx*dpzxz2 +       ppzz12
       ddzxzy1 = pby*dpzxz1 + wpy*dpzxz2
       ddzyxx1 = pbx*dpzyx1 + wpx*dpzyx2                + dzy12
       ddzyyy1 = pby*dpzyy1 + wpy*dpzyy2 +       ppzy12 + dzy12
       ddzyzz1 = pbz*dpzyz1 + wpz*dpzyz2 +       ppyz12 + dzy12
       ddzyyx1 = pbx*dpzyy1 + wpx*dpzyy2
       ddzyzx1 = pbx*dpzyz1 + wpx*dpzyz2
       ddzyzy1 = pby*dpzyz1 + wpy*dpzyz2 +       ppzz12

       ddxxxx2 = pbx*dpxxx2 + wpx*dpxxx3 + 2.0d0*ppxx23 + dxx23
       ddxxyy2 = pby*dpxxy2 + wpy*dpxxy3                + dxx23
       ddxxzz2 = pbz*dpxxz2 + wpz*dpxxz3                + dxx23
       ddxxyx2 = pby*dpxxx2 + wpy*dpxxx3
       ddxxzx2 = pbz*dpxxx2 + wpz*dpxxx3
       ddxxzy2 = pby*dpxxz2 + wpy*dpxxz3
       ddyyxx2 = pbx*dpyyx2 + wpx*dpyyx3                + dyy23
       ddyyyy2 = pby*dpyyy2 + wpy*dpyyy3 + 2.0d0*ppyy23 + dyy23
       ddyyzz2 = pbz*dpyyz2 + wpz*dpyyz3                + dyy23
       ddyyyx2 = pbx*dpyyy2 + wpx*dpyyy3
       ddyyzx2 = pbx*dpyyz2 + wpx*dpyyz3
       ddyyzy2 = pbz*dpyyy2 + wpz*dpyyy3
       ddzzxx2 = pbx*dpzzx2 + wpx*dpzzx3                + dzz23
       ddzzyy2 = pby*dpzzy2 + wpy*dpzzy3                + dzz23
       ddzzzz2 = pbz*dpzzz2 + wpz*dpzzz3 + 2.0d0*ppzz23 + dzz23
       ddzzyx2 = pbx*dpzzy2 + wpx*dpzzy3
       ddzzzx2 = pbx*dpzzz2 + wpx*dpzzz3
       ddzzzy2 = pby*dpzzz2 + wpy*dpzzz3
       ddyxxx2 = pbx*dpyxx2 + wpx*dpyxx3 +       ppyx23 + dyx23
       ddyxyy2 = pby*dpyxy2 + wpy*dpyxy3 +       ppxy23 + dyx23
       ddyxzz2 = pbz*dpyxz2 + wpz*dpyxz3                + dyx23
       ddyxyx2 = pbx*dpyxy2 + wpx*dpyxy3 +       ppyy23
       ddyxzx2 = pbz*dpyxx2 + wpz*dpyxx3
       ddyxzy2 = pbz*dpyxy2 + wpz*dpyxy3
       ddzxxx2 = pbx*dpzxx2 + wpx*dpzxx3 +       ppzx23 + dzx23
       ddzxyy2 = pby*dpzxy2 + wpy*dpzxy3                + dzx23
       ddzxzz2 = pbz*dpzxz2 + wpz*dpzxz3 +       ppxz23 + dzx23
       ddzxyx2 = pby*dpzxx2 + wpy*dpzxx3
       ddzxzx2 = pbx*dpzxz2 + wpx*dpzxz3 +       ppzz23
       ddzxzy2 = pby*dpzxz2 + wpy*dpzxz3
       ddzyxx2 = pbx*dpzyx2 + wpx*dpzyx3                + dzy23
       ddzyyy2 = pby*dpzyy2 + wpy*dpzyy3 +       ppzy23 + dzy23
       ddzyzz2 = pbz*dpzyz2 + wpz*dpzyz3 +       ppyz23 + dzy23
       ddzyyx2 = pbx*dpzyy2 + wpx*dpzyy3
       ddzyzx2 = pbx*dpzyz2 + wpx*dpzyz3
       ddzyzy2 = pby*dpzyz2 + wpy*dpzyz3 +       ppzz23

       ddxxxx3 = pbx*dpxxx3 + wpx*dpxxx4 + 2.0d0*ppxx34 + dxx34
       ddxxyy3 = pby*dpxxy3 + wpy*dpxxy4                + dxx34
       ddxxzz3 = pbz*dpxxz3 + wpz*dpxxz4                + dxx34
       ddxxyx3 = pby*dpxxx3 + wpy*dpxxx4
       ddxxzx3 = pbz*dpxxx3 + wpz*dpxxx4
       ddxxzy3 = pby*dpxxz3 + wpy*dpxxz4
       ddyyxx3 = pbx*dpyyx3 + wpx*dpyyx4                + dyy34
       ddyyyy3 = pby*dpyyy3 + wpy*dpyyy4 + 2.0d0*ppyy34 + dyy34
       ddyyzz3 = pbz*dpyyz3 + wpz*dpyyz4                + dyy34
       ddyyyx3 = pbx*dpyyy3 + wpx*dpyyy4
       ddyyzx3 = pbx*dpyyz3 + wpx*dpyyz4
       ddyyzy3 = pbz*dpyyy3 + wpz*dpyyy4
       ddzzxx3 = pbx*dpzzx3 + wpx*dpzzx4                + dzz34
       ddzzyy3 = pby*dpzzy3 + wpy*dpzzy4                + dzz34
       ddzzzz3 = pbz*dpzzz3 + wpz*dpzzz4 + 2.0d0*ppzz34 + dzz34
       ddzzyx3 = pbx*dpzzy3 + wpx*dpzzy4
       ddzzzx3 = pbx*dpzzz3 + wpx*dpzzz4
       ddzzzy3 = pby*dpzzz3 + wpy*dpzzz4
       ddyxxx3 = pbx*dpyxx3 + wpx*dpyxx4 +       ppyx34 + dyx34
       ddyxyy3 = pby*dpyxy3 + wpy*dpyxy4 +       ppxy34 + dyx34
       ddyxzz3 = pbz*dpyxz3 + wpz*dpyxz4                + dyx34
       ddyxyx3 = pbx*dpyxy3 + wpx*dpyxy4 +       ppyy34
       ddyxzx3 = pbz*dpyxx3 + wpz*dpyxx4
       ddyxzy3 = pbz*dpyxy3 + wpz*dpyxy4
       ddzxxx3 = pbx*dpzxx3 + wpx*dpzxx4 +       ppzx34 + dzx34
       ddzxyy3 = pby*dpzxy3 + wpy*dpzxy4                + dzx34
       ddzxzz3 = pbz*dpzxz3 + wpz*dpzxz4 +       ppxz34 + dzx34
       ddzxyx3 = pby*dpzxx3 + wpy*dpzxx4
       ddzxzx3 = pbx*dpzxz3 + wpx*dpzxz4 +       ppzz34
       ddzxzy3 = pby*dpzxz3 + wpy*dpzxz4
       ddzyxx3 = pbx*dpzyx3 + wpx*dpzyx4                + dzy34
       ddzyyy3 = pby*dpzyy3 + wpy*dpzyy4 +       ppzy34 + dzy34
       ddzyzz3 = pbz*dpzyz3 + wpz*dpzyz4 +       ppyz34 + dzy34
       ddzyyx3 = pbx*dpzyy3 + wpx*dpzyy4
       ddzyzx3 = pbx*dpzyz3 + wpx*dpzyz4
       ddzyzy3 = pby*dpzyz3 + wpy*dpzyz4 +       ppzz34

       ddxxxx4 = pbx*dpxxx4 + wpx*dpxxx5 + 2.0d0*ppxx45 + dxx45
       ddxxyy4 = pby*dpxxy4 + wpy*dpxxy5                + dxx45
       ddxxzz4 = pbz*dpxxz4 + wpz*dpxxz5                + dxx45
       ddxxyx4 = pby*dpxxx4 + wpy*dpxxx5
       ddxxzx4 = pbz*dpxxx4 + wpz*dpxxx5
       ddxxzy4 = pby*dpxxz4 + wpy*dpxxz5
       ddyyxx4 = pbx*dpyyx4 + wpx*dpyyx5                + dyy45
       ddyyyy4 = pby*dpyyy4 + wpy*dpyyy5 + 2.0d0*ppyy45 + dyy45
       ddyyzz4 = pbz*dpyyz4 + wpz*dpyyz5                + dyy45
       ddyyyx4 = pbx*dpyyy4 + wpx*dpyyy5
       ddyyzx4 = pbx*dpyyz4 + wpx*dpyyz5
       ddyyzy4 = pbz*dpyyy4 + wpz*dpyyy5
       ddzzxx4 = pbx*dpzzx4 + wpx*dpzzx5                + dzz45
       ddzzyy4 = pby*dpzzy4 + wpy*dpzzy5                + dzz45
       ddzzzz4 = pbz*dpzzz4 + wpz*dpzzz5 + 2.0d0*ppzz45 + dzz45
       ddzzyx4 = pbx*dpzzy4 + wpx*dpzzy5
       ddzzzx4 = pbx*dpzzz4 + wpx*dpzzz5
       ddzzzy4 = pby*dpzzz4 + wpy*dpzzz5
       ddyxxx4 = pbx*dpyxx4 + wpx*dpyxx5 +       ppyx45 + dyx45
       ddyxyy4 = pby*dpyxy4 + wpy*dpyxy5 +       ppxy45 + dyx45
       ddyxzz4 = pbz*dpyxz4 + wpz*dpyxz5                + dyx45
       ddyxyx4 = pbx*dpyxy4 + wpx*dpyxy5 +       ppyy45
       ddyxzx4 = pbz*dpyxx4 + wpz*dpyxx5
       ddyxzy4 = pbz*dpyxy4 + wpz*dpyxy5
       ddzxxx4 = pbx*dpzxx4 + wpx*dpzxx5 +       ppzx45 + dzx45
       ddzxyy4 = pby*dpzxy4 + wpy*dpzxy5                + dzx45
       ddzxzz4 = pbz*dpzxz4 + wpz*dpzxz5 +       ppxz45 + dzx45
       ddzxyx4 = pby*dpzxx4 + wpy*dpzxx5
       ddzxzx4 = pbx*dpzxz4 + wpx*dpzxz5 +       ppzz45
       ddzxzy4 = pby*dpzxz4 + wpy*dpzxz5
       ddzyxx4 = pbx*dpzyx4 + wpx*dpzyx5                + dzy45
       ddzyyy4 = pby*dpzyy4 + wpy*dpzyy5 +       ppzy45 + dzy45
       ddzyzz4 = pbz*dpzyz4 + wpz*dpzyz5 +       ppyz45 + dzy45
       ddzyyx4 = pbx*dpzyy4 + wpx*dpzyy5
       ddzyzx4 = pbx*dpzyz4 + wpx*dpzyz5
       ddzyzy4 = pby*dpzyz4 + wpy*dpzyz5 +       ppzz45

!rppss (2-4)
      rppxx2 = rkp*ppxx2
      rppxy2 = rkp*ppxy2
      rppxz2 = rkp*ppxz2
      rppyx2 = rkp*ppyx2
      rppyy2 = rkp*ppyy2
      rppyz2 = rkp*ppyz2
      rppzx2 = rkp*ppzx2
      rppzy2 = rkp*ppzy2
      rppzz2 = rkp*ppzz2
      rppxx3 = rkp*ppxx3
      rppxy3 = rkp*ppxy3
      rppxz3 = rkp*ppxz3
      rppyx3 = rkp*ppyx3
      rppyy3 = rkp*ppyy3
      rppyz3 = rkp*ppyz3
      rppzx3 = rkp*ppzx3
      rppzy3 = rkp*ppzy3
      rppzz3 = rkp*ppzz3
      rppxx4 = rkp*ppxx4
      rppxy4 = rkp*ppxy4
      rppxz4 = rkp*ppxz4
      rppyx4 = rkp*ppyx4
      rppyy4 = rkp*ppyy4
      rppyz4 = rkp*ppyz4
      rppzx4 = rkp*ppzx4
      rppzy4 = rkp*ppzy4
      rppzz4 = rkp*ppzz4
!edsss01(23)
       edxx23 = eta*(dxx2 -rooe*dxx3)
       edyy23 = eta*(dyy2 -rooe*dyy3)
       edzz23 = eta*(dzz2 -rooe*dzz3)
       edyx23 = eta*(dyx2 -rooe*dyx3)
       edzx23 = eta*(dzx2 -rooe*dzx3)
       edzy23 = eta*(dzy2 -rooe*dzy3)
!rdsss (2-4)
      rdxx2 = rkp*dxx2
      rdyy2 = rkp*dyy2
      rdzz2 = rkp*dzz2
      rdyx2 = rkp*dyx2
      rdzx2 = rkp*dzx2
      rdzy2 = rkp*dzy2
      rdxx3 = rkp*dxx3
      rdyy3 = rkp*dyy3
      rdzz3 = rkp*dzz3
      rdyx3 = rkp*dyx3
      rdzx3 = rkp*dzx3
      rdzy3 = rkp*dzy3
      rdxx4 = rkp*dxx4
      rdyy4 = rkp*dyy4
      rdzz4 = rkp*dzz4
      rdyx4 = rkp*dyx4
      rdzx4 = rkp*dzx4
      rdzy4 = rkp*dzy4

!dpps(1-3)
      axx1= qcx*dpxxx1 + wqx*dpxxx2 + 2.0d0*rppxx2 + rdxx2
      axy1= qcy*dpxxx1 + wqy*dpxxx2 
      axz1= qcz*dpxxx1 + wqz*dpxxx2 
      ayx1= qcx*dpxxy1 + wqx*dpxxy2 + 2.0d0*rppxy2        
      ayy1= qcy*dpxxy1 + wqy*dpxxy2                + rdxx2
      ayz1= qcz*dpxxy1 + wqz*dpxxy2                       
      azx1= qcx*dpxxz1 + wqx*dpxxz2 + 2.0d0*rppxz2        
      azy1= qcy*dpxxz1 + wqy*dpxxz2                       
      azz1= qcz*dpxxz1 + wqz*dpxxz2                + rdxx2
      bxx1= qcx*dpyyx1 + wqx*dpyyx2                + rdyy2
      bxy1= qcy*dpyyx1 + wqy*dpyyx2 + 2.0d0*rppyx2        
      bxz1= qcz*dpyyx1 + wqz*dpyyx2                       
      byx1= qcx*dpyyy1 + wqx*dpyyy2                       
      byy1= qcy*dpyyy1 + wqy*dpyyy2 + 2.0d0*rppyy2 + rdyy2
      byz1= qcz*dpyyy1 + wqz*dpyyy2                       
      bzx1= qcx*dpyyz1 + wqx*dpyyz2                       
      bzy1= qcy*dpyyz1 + wqy*dpyyz2 + 2.0d0*rppyz2        
      bzz1= qcz*dpyyz1 + wqz*dpyyz2                + rdyy2
      cxx1= qcx*dpzzx1 + wqx*dpzzx2                + rdzz2
      cxy1= qcy*dpzzx1 + wqy*dpzzx2
      cxz1= qcz*dpzzx1 + wqz*dpzzx2 + 2.0d0*rppzx2
      cyx1= qcx*dpzzy1 + wqx*dpzzy2               
      cyy1= qcy*dpzzy1 + wqy*dpzzy2                + rdzz2
      cyz1= qcz*dpzzy1 + wqz*dpzzy2 + 2.0d0*rppzy2        
      czx1= qcx*dpzzz1 + wqx*dpzzz2                       
      czy1= qcy*dpzzz1 + wqy*dpzzz2                       
      czz1= qcz*dpzzz1 + wqz*dpzzz2 + 2.0d0*rppzz2 + rdzz2
      dxx1= qcx*dpyxx1 + wqx*dpyxx2 +       rppyx2 + rdyx2
      dxy1= qcy*dpyxx1 + wqy*dpyxx2 +       rppxx2        
      dxz1= qcz*dpyxx1 + wqz*dpyxx2                       
      dyx1= qcx*dpyxy1 + wqx*dpyxy2 +       rppyy2        
      dyy1= qcy*dpyxy1 + wqy*dpyxy2 +       rppxy2 + rdyx2
      dyz1= qcz*dpyxy1 + wqz*dpyxy2            !    + rdyx2
      dzx1= qcx*dpyxz1 + wqx*dpyxz2 +       rppyz2        
      dzy1= qcy*dpyxz1 + wqy*dpyxz2 +       rppxz2        
      dzz1= qcz*dpyxz1 + wqz*dpyxz2                + rdyx2
      exx1= qcx*dpzxx1 + wqx*dpzxx2 +       rppzx2 + rdzx2
      exy1= qcy*dpzxx1 + wqy*dpzxx2                       
      exz1= qcz*dpzxx1 + wqz*dpzxx2 +       rppxx2        
      eyx1= qcx*dpzxy1 + wqx*dpzxy2 +       rppzy2        
      eyy1= qcy*dpzxy1 + wqy*dpzxy2                + rdzx2
      eyz1= qcz*dpzxy1 + wqz*dpzxy2 +       rppxy2        
      ezx1= qcx*dpzxz1 + wqx*dpzxz2 +       rppzz2        
      ezy1= qcy*dpzxz1 + wqy*dpzxz2                       
      ezz1= qcz*dpzxz1 + wqz*dpzxz2 +       rppxz2 + rdzx2
      fxx1= qcx*dpzyx1 + wqx*dpzyx2                + rdzy2
      fxy1= qcy*dpzyx1 + wqy*dpzyx2 +       rppzx2        
      fxz1= qcz*dpzyx1 + wqz*dpzyx2 +       rppyx2        
      fyx1= qcx*dpzyy1 + wqx*dpzyy2                       
      fyy1= qcy*dpzyy1 + wqy*dpzyy2 +       rppzy2 + rdzy2
      fyz1= qcz*dpzyy1 + wqz*dpzyy2 +       rppyy2        
      fzx1= qcx*dpzyz1 + wqx*dpzyz2                       
      fzy1= qcy*dpzyz1 + wqy*dpzyz2 +       rppzz2        
      fzz1= qcz*dpzyz1 + wqz*dpzyz2 +       rppyz2 + rdzy2

      axx2= qcx*dpxxx2 + wqx*dpxxx3 + 2.0d0*rppxx3 + rdxx3
      axy2= qcy*dpxxx2 + wqy*dpxxx3 
      axz2= qcz*dpxxx2 + wqz*dpxxx3 
      ayx2= qcx*dpxxy2 + wqx*dpxxy3 + 2.0d0*rppxy3        
      ayy2= qcy*dpxxy2 + wqy*dpxxy3                + rdxx3
      ayz2= qcz*dpxxy2 + wqz*dpxxy3                       
      azx2= qcx*dpxxz2 + wqx*dpxxz3 + 2.0d0*rppxz3        
      azy2= qcy*dpxxz2 + wqy*dpxxz3                       
      azz2= qcz*dpxxz2 + wqz*dpxxz3                + rdxx3
      bxx2= qcx*dpyyx2 + wqx*dpyyx3                + rdyy3
      bxy2= qcy*dpyyx2 + wqy*dpyyx3 + 2.0d0*rppyx3        
      bxz2= qcz*dpyyx2 + wqz*dpyyx3                       
      byx2= qcx*dpyyy2 + wqx*dpyyy3                       
      byy2= qcy*dpyyy2 + wqy*dpyyy3 + 2.0d0*rppyy3 + rdyy3
      byz2= qcz*dpyyy2 + wqz*dpyyy3                       
      bzx2= qcx*dpyyz2 + wqx*dpyyz3                       
      bzy2= qcy*dpyyz2 + wqy*dpyyz3 + 2.0d0*rppyz3        
      bzz2= qcz*dpyyz2 + wqz*dpyyz3                + rdyy3
      cxx2= qcx*dpzzx2 + wqx*dpzzx3                + rdzz3
      cxy2= qcy*dpzzx2 + wqy*dpzzx3                       
      cxz2= qcz*dpzzx2 + wqz*dpzzx3 + 2.0d0*rppzx3        
      cyx2= qcx*dpzzy2 + wqx*dpzzy3                       
      cyy2= qcy*dpzzy2 + wqy*dpzzy3                + rdzz3
      cyz2= qcz*dpzzy2 + wqz*dpzzy3 + 2.0d0*rppzy3        
      czx2= qcx*dpzzz2 + wqx*dpzzz3                       
      czy2= qcy*dpzzz2 + wqy*dpzzz3                       
      czz2= qcz*dpzzz2 + wqz*dpzzz3 + 2.0d0*rppzz3 + rdzz3
      dxx2= qcx*dpyxx2 + wqx*dpyxx3 +       rppyx3 + rdyx3
      dxy2= qcy*dpyxx2 + wqy*dpyxx3 +       rppxx3        
      dxz2= qcz*dpyxx2 + wqz*dpyxx3                       
      dyx2= qcx*dpyxy2 + wqx*dpyxy3 +       rppyy3        
      dyy2= qcy*dpyxy2 + wqy*dpyxy3 +       rppxy3 + rdyx3
      dyz2= qcz*dpyxy2 + wqz*dpyxy3
      dzx2= qcx*dpyxz2 + wqx*dpyxz3 +       rppyz3        
      dzy2= qcy*dpyxz2 + wqy*dpyxz3 +       rppxz3        
      dzz2= qcz*dpyxz2 + wqz*dpyxz3                + rdyx3
      exx2= qcx*dpzxx2 + wqx*dpzxx3 +       rppzx3 + rdzx3
      exy2= qcy*dpzxx2 + wqy*dpzxx3                       
      exz2= qcz*dpzxx2 + wqz*dpzxx3 +       rppxx3        
      eyx2= qcx*dpzxy2 + wqx*dpzxy3 +       rppzy3        
      eyy2= qcy*dpzxy2 + wqy*dpzxy3                + rdzx3
      eyz2= qcz*dpzxy2 + wqz*dpzxy3 +       rppxy3        
      ezx2= qcx*dpzxz2 + wqx*dpzxz3 +       rppzz3        
      ezy2= qcy*dpzxz2 + wqy*dpzxz3                       
      ezz2= qcz*dpzxz2 + wqz*dpzxz3 +       rppxz3 + rdzx3
      fxx2= qcx*dpzyx2 + wqx*dpzyx3                + rdzy3
      fxy2= qcy*dpzyx2 + wqy*dpzyx3 +       rppzx3        
      fxz2= qcz*dpzyx2 + wqz*dpzyx3 +       rppyx3        
      fyx2= qcx*dpzyy2 + wqx*dpzyy3                       
      fyy2= qcy*dpzyy2 + wqy*dpzyy3 +       rppzy3 + rdzy3
      fyz2= qcz*dpzyy2 + wqz*dpzyy3 +       rppyy3        
      fzx2= qcx*dpzyz2 + wqx*dpzyz3                       
      fzy2= qcy*dpzyz2 + wqy*dpzyz3 +       rppzz3        
      fzz2= qcz*dpzyz2 + wqz*dpzyz3 +       rppyz3 + rdzy3

      axx3= qcx*dpxxx3 + wqx*dpxxx4 + 2.0d0*rppxx4 + rdxx4
      axy3= qcy*dpxxx3 + wqy*dpxxx4 
      axz3= qcz*dpxxx3 + wqz*dpxxx4 
      ayx3= qcx*dpxxy3 + wqx*dpxxy4 + 2.0d0*rppxy4        
      ayy3= qcy*dpxxy3 + wqy*dpxxy4                + rdxx4
      ayz3= qcz*dpxxy3 + wqz*dpxxy4                       
      azx3= qcx*dpxxz3 + wqx*dpxxz4 + 2.0d0*rppxz4        
      azy3= qcy*dpxxz3 + wqy*dpxxz4                       
      azz3= qcz*dpxxz3 + wqz*dpxxz4                + rdxx4
      bxx3= qcx*dpyyx3 + wqx*dpyyx4                + rdyy4
      bxy3= qcy*dpyyx3 + wqy*dpyyx4 + 2.0d0*rppyx4        
      bxz3= qcz*dpyyx3 + wqz*dpyyx4                       
      byx3= qcx*dpyyy3 + wqx*dpyyy4                       
      byy3= qcy*dpyyy3 + wqy*dpyyy4 + 2.0d0*rppyy4 + rdyy4
      byz3= qcz*dpyyy3 + wqz*dpyyy4                       
      bzx3= qcx*dpyyz3 + wqx*dpyyz4                       
      bzy3= qcy*dpyyz3 + wqy*dpyyz4 + 2.0d0*rppyz4        
      bzz3= qcz*dpyyz3 + wqz*dpyyz4                + rdyy4
      cxx3= qcx*dpzzx3 + wqx*dpzzx4                + rdzz4
      cxy3= qcy*dpzzx3 + wqy*dpzzx4                       
      cxz3= qcz*dpzzx3 + wqz*dpzzx4 + 2.0d0*rppzx4        
      cyx3= qcx*dpzzy3 + wqx*dpzzy4                       
      cyy3= qcy*dpzzy3 + wqy*dpzzy4                + rdzz4
      cyz3= qcz*dpzzy3 + wqz*dpzzy4 + 2.0d0*rppzy4        
      czx3= qcx*dpzzz3 + wqx*dpzzz4                       
      czy3= qcy*dpzzz3 + wqy*dpzzz4                       
      czz3= qcz*dpzzz3 + wqz*dpzzz4 + 2.0d0*rppzz4 + rdzz4
      dxx3= qcx*dpyxx3 + wqx*dpyxx4 +       rppyx4 + rdyx4
      dxy3= qcy*dpyxx3 + wqy*dpyxx4 +       rppxx4        
      dxz3= qcz*dpyxx3 + wqz*dpyxx4                       
      dyx3= qcx*dpyxy3 + wqx*dpyxy4 +       rppyy4        
      dyy3= qcy*dpyxy3 + wqy*dpyxy4 +       rppxy4 + rdyx4
      dyz3= qcz*dpyxy3 + wqz*dpyxy4
      dzx3= qcx*dpyxz3 + wqx*dpyxz4 +       rppyz4        
      dzy3= qcy*dpyxz3 + wqy*dpyxz4 +       rppxz4        
      dzz3= qcz*dpyxz3 + wqz*dpyxz4                + rdyx4
      exx3= qcx*dpzxx3 + wqx*dpzxx4 +       rppzx4 + rdzx4
      exy3= qcy*dpzxx3 + wqy*dpzxx4                       
      exz3= qcz*dpzxx3 + wqz*dpzxx4 +       rppxx4        
      eyx3= qcx*dpzxy3 + wqx*dpzxy4 +       rppzy4        
      eyy3= qcy*dpzxy3 + wqy*dpzxy4                + rdzx4
      eyz3= qcz*dpzxy3 + wqz*dpzxy4 +       rppxy4        
      ezx3= qcx*dpzxz3 + wqx*dpzxz4 +       rppzz4        
      ezy3= qcy*dpzxz3 + wqy*dpzxz4                       
      ezz3= qcz*dpzxz3 + wqz*dpzxz4 +       rppxz4 + rdzx4
      fxx3= qcx*dpzyx3 + wqx*dpzyx4                + rdzy4
      fxy3= qcy*dpzyx3 + wqy*dpzyx4 +       rppzx4        
      fxz3= qcz*dpzyx3 + wqz*dpzyx4 +       rppyx4        
      fyx3= qcx*dpzyy3 + wqx*dpzyy4                       
      fyy3= qcy*dpzyy3 + wqy*dpzyy4 +       rppzy4 + rdzy4
      fyz3= qcz*dpzyy3 + wqz*dpzyy4 +       rppyy4        
      fzx3= qcx*dpzyz3 + wqx*dpzyz4                       
      fzy3= qcy*dpzyz3 + wqy*dpzyz4 +       rppzz4        
      fzz3= qcz*dpzyz3 + wqz*dpzyz4 +       rppyz4 + rdzy4

!rsdss(2-4)
      rsdxx2 = rkp * sdxx2
      rsdyy2 = rkp * sdyy2
      rsdzz2 = rkp * sdzz2
      rsdyx2 = rkp * sdyx2
      rsdzx2 = rkp * sdzx2
      rsdzy2 = rkp * sdzy2
      rsdxx3 = rkp * sdxx3
      rsdyy3 = rkp * sdyy3
      rsdzz3 = rkp * sdzz3
      rsdyx3 = rkp * sdyx3
      rsdzx3 = rkp * sdzx3
      rsdzy3 = rkp * sdzy3
      rsdxx4 = rkp * sdxx4
      rsdyy4 = rkp * sdyy4
      rsdzz4 = rkp * sdzz4
      rsdyx4 = rkp * sdyx4
      rsdzx4 = rkp * sdzx4
      rsdzy4 = rkp * sdzy4

!sdss01(23)

      sdxx23 = eta*(sdxx2 - rooe*sdxx3)
      sdyy23 = eta*(sdyy2 - rooe*sdyy3)
      sdzz23 = eta*(sdzz2 - rooe*sdzz3)
      sdyx23 = eta*(sdyx2 - rooe*sdyx3)
      sdzx23 = eta*(sdzx2 - rooe*sdzx3)
      sdzy23 = eta*(sdzy2 - rooe*sdzy3)
!rspps(3)
      rpxpx3 =rkp * pxpx3
      rpxpy3 =rkp * pxpy3
      rpxpz3 =rkp * pxpz3
      rpypx3 =rkp * pypx3
      rpypy3 =rkp * pypy3
      rpypz3 =rkp * pypz3
      rpzpx3 =rkp * pzpx3
      rpzpy3 =rkp * pzpy3
      rpzpz3 =rkp * pzpz3

!sdds(2)
      xxdxxd2 = qcx*xxdpx2 + wqx*xxdpx3 +2.d0*rpxpx3 + sdxx23
      xxdyyd2 = qcy*xxdpy2 + wqy*xxdpy3              + sdxx23
      xxdzzd2 = qcz*xxdpz2 + wqz*xxdpz3              + sdxx23
      xxdyxd2 = qcy*xxdpx2 + wqy*xxdpx3
      xxdzxd2 = qcz*xxdpx2 + wqz*xxdpx3
      xxdzyd2 = qcz*xxdpy2 + wqz*xxdpy3
      yydxxd2 = qcx*yydpx2 + wqx*yydpx3              + sdyy23
      yydyyd2 = qcy*yydpy2 + wqy*yydpy3 +2.d0*rpypy3 + sdyy23
      yydzzd2 = qcz*yydpz2 + wqz*yydpz3              + sdyy23
      yydyxd2 = qcx*yydpy2 + wqx*yydpy3
      yydzxd2 = qcz*yydpx2 + wqz*yydpx3
      yydzyd2 = qcz*yydpy2 + wqz*yydpy3
      zzdxxd2 = qcx*zzdpx2 + wqx*zzdpx3              + sdzz23
      zzdyyd2 = qcy*zzdpy2 + wqy*zzdpy3              + sdzz23
      zzdzzd2 = qcz*zzdpz2 + wqz*zzdpz3 +2.d0*rpzpz3 + sdzz23
      zzdyxd2 = qcx*zzdpy2 + wqx*zzdpy3
      zzdzxd2 = qcx*zzdpz2 + wqx*zzdpz3
      zzdzyd2 = qcy*zzdpz2 + wqy*zzdpz3
      yxdxxd2 = qcx*yxdpx2 + wqx*yxdpx3 +1.d0*rpypx3 + sdyx23
      yxdyyd2 = qcy*yxdpy2 + wqy*yxdpy3 +1.d0*rpxpy3 + sdyx23
      yxdzzd2 = qcz*yxdpz2 + wqz*yxdpz3              + sdyx23
      yxdyxd2 = qcx*yxdpy2 + wqx*yxdpy3 +1.d0*rpypy3
      yxdzxd2 = qcz*yxdpx2 + wqz*yxdpx3
      yxdzyd2 = qcz*yxdpy2 + wqz*yxdpy3
      zxdxxd2 = qcx*zxdpx2 + wqx*zxdpx3 +1.d0*rpzpx3 + sdzx23
      zxdyyd2 = qcy*zxdpy2 + wqy*zxdpy3              + sdzx23
      zxdzzd2 = qcz*zxdpz2 + wqz*zxdpz3 +1.d0*rpxpz3 + sdzx23
      zxdyxd2 = qcy*zxdpx2 + wqy*zxdpx3
      zxdzxd2 = qcx*zxdpz2 + wqx*zxdpz3 +1.d0*rpzpz3
      zxdzyd2 = qcy*zxdpz2 + wqy*zxdpz3
      zydxxd2 = qcx*zydpx2 + wqx*zydpx3              + sdzy23
      zydyyd2 = qcy*zydpy2 + wqy*zydpy3 +1.d0*rpzpy3 + sdzy23
      zydzzd2 = qcz*zydpz2 + wqz*zydpz3 +1.d0*rpypz3 + sdzy23
      zydyxd2 = qcx*zydpy2 + wqx*zydpy3
      zydzxd2 = qcx*zydpz2 + wqx*zydpz3
      zydzyd2 = qcy*zydpz2 + wqy*zydpz3 +1.d0*rpzpz3

!rpsps(3)
                 rpxspx3 =  rkp * pxspx3
                 rpxspy3 =  rkp * pxspy3
                 rpxspz3 =  rkp * pxspz3
                 rpyspx3 =  rkp * pyspx3
                 rpyspy3 =  rkp * pyspy3
                 rpyspz3 =  rkp * pyspz3
                 rpzspx3 =  rkp * pzspx3
                 rpzspy3 =  rkp * pzspy3
                 rpzspz3 =  rkp * pzspz3

!dsds(2)
      dxxdxx2 = qcx*dxxpx2 + wqx*dxxpx3 + 2.d0*rpxspx3 + edxx23
      dxxdyy2 = qcy*dxxpy2 + wqy*dxxpy3                + edxx23
      dxxdzz2 = qcz*dxxpz2 + wqz*dxxpz3                + edxx23
      dxxdyx2 = qcy*dxxpx2 + wqy*dxxpx3
      dxxdzx2 = qcz*dxxpx2 + wqz*dxxpx3
      dxxdzy2 = qcy*dxxpz2 + wqy*dxxpz3
      dyydxx2 = qcx*dyypx2 + wqx*dyypx3                + edyy23
      dyydyy2 = qcy*dyypy2 + wqy*dyypy3 + 2.d0*rpyspy3 + edyy23
      dyydzz2 = qcz*dyypz2 + wqz*dyypz3                + edyy23
      dyydyx2 = qcx*dyypy2 + wqx*dyypy3
      dyydzx2 = qcz*dyypx2 + wqz*dyypx3
      dyydzy2 = qcz*dyypy2 + wqz*dyypy3
      dzzdxx2 = qcx*dzzpx2 + wqx*dzzpx3                + edzz23
      dzzdyy2 = qcy*dzzpy2 + wqy*dzzpy3                + edzz23
      dzzdzz2 = qcz*dzzpz2 + wqz*dzzpz3 + 2.d0*rpzspz3 + edzz23
      dzzdyx2 = qcy*dzzpx2 + wqy*dzzpx3
      dzzdzx2 = qcx*dzzpz2 + wqx*dzzpz3
      dzzdzy2 = qcy*dzzpz2 + wqy*dzzpz3
      dyxdxx2 = qcx*dyxpx2 + wqx*dyxpx3 + 1.d0*rpyspx3 + edyx23
      dyxdyy2 = qcy*dyxpy2 + wqy*dyxpy3 + 1.d0*rpxspy3 + edyx23
      dyxdzz2 = qcz*dyxpz2 + wqz*dyxpz3                + edyx23
      dyxdyx2 = qcy*dyxpx2 + wqy*dyxpx3 + 1.d0*rpxspx3
      dyxdzx2 = qcz*dyxpx2 + wqz*dyxpx3               
      dyxdzy2 = qcz*dyxpy2 + wqz*dyxpy3               
      dzxdxx2 = qcx*dzxpx2 + wqx*dzxpx3 + 1.d0*rpzspx3 + edzx23
      dzxdyy2 = qcy*dzxpy2 + wqy*dzxpy3                + edzx23
      dzxdzz2 = qcz*dzxpz2 + wqz*dzxpz3 + 1.d0*rpxspz3 + edzx23
      dzxdyx2 = qcy*dzxpx2 + wqy*dzxpx3
      dzxdzx2 = qcz*dzxpx2 + wqz*dzxpx3 + 1.d0*rpxspx3
      dzxdzy2 = qcy*dzxpz2 + wqy*dzxpz3

      dzydxx2 = qcx*dzypx2 + wqx*dzypx3                + edzy23
      dzydyy2 = qcy*dzypy2 + wqy*dzypy3 + 1.d0*rpzspy3 + edzy23
      dzydzz2 = qcz*dzypz2 + wqz*dzypz3 + 1.d0*rpyspz3 + edzy23
      dzydyx2 = qcx*dzypy2 + wqx*dzypy3
      dzydzx2 = qcx*dzypz2 + wqx*dzypz3
      dzydzy2 = qcy*dzypz2 + wqy*dzypz3 + 1.d0*rpzspz3



!eppss01(2,3)
         eppxx23 = eta*(ppxx2 - rooe*ppxx3)
         eppxy23 = eta*(ppxy2 - rooe*ppxy3)
         eppxz23 = eta*(ppxz2 - rooe*ppxz3)
         eppyx23 = eta*(ppyx2 - rooe*ppyx3)
         eppyy23 = eta*(ppyy2 - rooe*ppyy3)
         eppyz23 = eta*(ppyz2 - rooe*ppyz3)
         eppzx23 = eta*(ppzx2 - rooe*ppzx3)
         eppzy23 = eta*(ppzy2 - rooe*ppzy3)
         eppzz23 = eta*(ppzz2 - rooe*ppzz3)

!ppds(2)
      xxdxx2 = qcx*pppxxx2 + wqx*pppxxx3 + rpxpx3 + rpxspx3 +eppxx23
      xxdyy2 = qcy*pppxxy2 + wqy*pppxxy3                    +eppxx23
      xxdzz2 = qcz*pppxxz2 + wqz*pppxxz3                    +eppxx23
      xxdyx2 = qcy*pppxxx2 + wqy*pppxxx3                   
      xxdzx2 = qcz*pppxxx2 + wqz*pppxxx3                   
      xxdzy2 = qcz*pppxxy2 + wqz*pppxxy3                   
      xydxx2 = qcx*pppxyx2 + wqx*pppxyx3 + rpypx3           +eppxy23
      xydyy2 = qcy*pppxyy2 + wqy*pppxyy3          + rpxspy3 +eppxy23
      xydzz2 = qcz*pppxyz2 + wqz*pppxyz3                    +eppxy23
      xydyx2 = qcx*pppxyy2 + wqx*pppxyy3 + rpypy3          
      xydzx2 = qcz*pppxyx2 + wqz*pppxyx3                   
      xydzy2 = qcz*pppxyy2 + wqz*pppxyy3                   
      xzdxx2 = qcx*pppxzx2 + wqx*pppxzx3 + rpzpx3           +eppxz23
      xzdyy2 = qcy*pppxzy2 + wqy*pppxzy3                    +eppxz23
      xzdzz2 = qcz*pppxzz2 + wqz*pppxzz3          + rpxspz3 +eppxz23
      xzdyx2 = qcy*pppxzx2 + wqy*pppxzx3                   
      xzdzx2 = qcz*pppxzx2 + wqz*pppxzx3          + rpxspx3
      xzdzy2 = qcy*pppxzz2 + wqy*pppxzz3                   
      yxdxx2 = qcx*pppyxx2 + wqx*pppyxx3          + rpyspx3 +eppyx23
      yxdyy2 = qcy*pppyxy2 + wqy*pppyxy3 + rpxpy3           +eppyx23
      yxdzz2 = qcz*pppyxz2 + wqz*pppyxz3                    +eppyx23
      yxdyx2 = qcy*pppyxx2 + wqy*pppyxx3 + rpxpx3          
      yxdzx2 = qcz*pppyxx2 + wqz*pppyxx3                   
      yxdzy2 = qcz*pppyxy2 + wqz*pppyxy3                   
      yydxx2 = qcx*pppyyx2 + wqx*pppyyx3                    +eppyy23
      yydyy2 = qcy*pppyyy2 + wqy*pppyyy3 + rpypy3 + rpyspy3 +eppyy23
      yydzz2 = qcz*pppyyz2 + wqz*pppyyz3                    +eppyy23
      yydyx2 = qcx*pppyyy2 + wqx*pppyyy3
      yydzx2 = qcz*pppyyx2 + wqz*pppyyx3
      yydzy2 = qcz*pppyyy2 + wqz*pppyyy3
      yzdxx2 = qcx*pppyzx2 + wqx*pppyzx3                    +eppyz23
      yzdyy2 = qcy*pppyzy2 + wqy*pppyzy3 + rpzpy3           +eppyz23
      yzdzz2 = qcz*pppyzz2 + wqz*pppyzz3          + rpyspz3 +eppyz23
      yzdyx2 = qcx*pppyzy2 + wqx*pppyzy3                   
      yzdzx2 = qcx*pppyzz2 + wqx*pppyzz3                   
      yzdzy2 = qcz*pppyzy2 + wqz*pppyzy3          + rpyspy3
      zxdxx2 = qcx*pppzxx2 + wqx*pppzxx3          + rpzspx3 +eppzx23
      zxdyy2 = qcy*pppzxy2 + wqy*pppzxy3                    +eppzx23
      zxdzz2 = qcz*pppzxz2 + wqz*pppzxz3 + rpxpz3           +eppzx23
      zxdyx2 = qcy*pppzxx2 + wqy*pppzxx3                   
      zxdzx2 = qcz*pppzxx2 + wqz*pppzxx3 + rpxpx3
      zxdzy2 = qcy*pppzxz2 + wqy*pppzxz3                   
      zydxx2 = qcx*pppzyx2 + wqx*pppzyx3                    +eppzy23
      zydyy2 = qcy*pppzyy2 + wqy*pppzyy3          + rpzspy3 +eppzy23
      zydzz2 = qcz*pppzyz2 + wqz*pppzyz3 + rpypz3           +eppzy23
      zydyx2 = qcx*pppzyy2 + wqx*pppzyy3                   
      zydzx2 = qcx*pppzyz2 + wqx*pppzyz3                   
      zydzy2 = qcz*pppzyy2 + wqz*pppzyy3 + rpypy3          
      zzdxx2 = qcx*pppzzx2 + wqx*pppzzx3                    +eppzz23
      zzdyy2 = qcy*pppzzy2 + wqy*pppzzy3                    +eppzz23
      zzdzz2 = qcz*pppzzz2 + wqz*pppzzz3 + rpzpz3 + rpzspz3 +eppzz23
      zzdyx2 = qcy*pppzzx2 + wqy*pppzzx3                   
      zzdzx2 = qcx*pppzzz2 + wqx*pppzzz3                   
      zzdzy2 = qcy*pppzzz2 + wqy*pppzzz3                   

!pdps (1-3)
      pxdxxpx1 = qcx*pdxxx1+wqx*pdxxx2+rsdxx2+2.0d0*rppxx2
      pxdxxpy1 = qcy*pdxxx1+wqy*pdxxx2                   
      pxdxxpz1 = qcz*pdxxx1+wqz*pdxxx2                   
      pxdyypx1 = qcx*pdxyy1+wqx*pdxyy2+rsdyy2
      pxdyypy1 = qcy*pdxyy1+wqy*pdxyy2       +2.0d0*rppxy2
      pxdyypz1 = qcz*pdxyy1+wqz*pdxyy2                   
      pxdzzpx1 = qcx*pdxzz1+wqx*pdxzz2+rsdzz2
      pxdzzpy1 = qcy*pdxzz1+wqy*pdxzz2                   
      pxdzzpz1 = qcz*pdxzz1+wqz*pdxzz2       +2.0d0*rppxz2
      pxdyxpx1 = qcx*pdxyx1+wqx*pdxyx2+rsdyx2+      rppxy2
      pxdyxpy1 = qcy*pdxyx1+wqy*pdxyx2       +      rppxx2
      pxdyxpz1 = qcz*pdxyx1+wqz*pdxyx2                   
      pxdzxpx1 = qcx*pdxzx1+wqx*pdxzx2+rsdzx2+      rppxz2
      pxdzxpy1 = qcy*pdxzx1+wqy*pdxzx2                   
      pxdzxpz1 = qcz*pdxzx1+wqz*pdxzx2       +      rppxx2
      pxdzypx1 = qcx*pdxzy1+wqx*pdxzy2+rsdzy2             
      pxdzypy1 = qcy*pdxzy1+wqy*pdxzy2       +      rppxz2
      pxdzypz1 = qcz*pdxzy1+wqz*pdxzy2       +      rppxy2
      pydxxpx1 = qcx*pdyxx1+wqx*pdyxx2       +2.0d0*rppyx2
      pydxxpy1 = qcy*pdyxx1+wqy*pdyxx2+rsdxx2             
      pydxxpz1 = qcz*pdyxx1+wqz*pdyxx2                   
      pydyypx1 = qcx*pdyyy1+wqx*pdyyy2                   
      pydyypy1 = qcy*pdyyy1+wqy*pdyyy2+rsdyy2+2.0d0*rppyy2
      pydyypz1 = qcz*pdyyy1+wqz*pdyyy2                   
      pydzzpx1 = qcx*pdyzz1+wqx*pdyzz2                   
      pydzzpy1 = qcy*pdyzz1+wqy*pdyzz2+rsdzz2             
      pydzzpz1 = qcz*pdyzz1+wqz*pdyzz2       +2.0d0*rppyz2
      pydyxpx1 = qcx*pdyyx1+wqx*pdyyx2       +      rppyy2
      pydyxpy1 = qcy*pdyyx1+wqy*pdyyx2+rsdyx2+      rppyx2
      pydyxpz1 = qcz*pdyyx1+wqz*pdyyx2                   
      pydzxpx1 = qcx*pdyzx1+wqx*pdyzx2       +      rppyz2
      pydzxpy1 = qcy*pdyzx1+wqy*pdyzx2+rsdzx2             
      pydzxpz1 = qcz*pdyzx1+wqz*pdyzx2       +      rppyx2
      pydzypx1 = qcx*pdyzy1+wqx*pdyzy2                   
      pydzypy1 = qcy*pdyzy1+wqy*pdyzy2+rsdzy2+      rppyz2
      pydzypz1 = qcz*pdyzy1+wqz*pdyzy2       +      rppyy2
      pzdxxpx1 = qcx*pdzxx1+wqx*pdzxx2       +2.0d0*rppzx2 
      pzdxxpy1 = qcy*pdzxx1+wqy*pdzxx2                    
      pzdxxpz1 = qcz*pdzxx1+wqz*pdzxx2+rsdxx2              
      pzdyypx1 = qcx*pdzyy1+wqx*pdzyy2                    
      pzdyypy1 = qcy*pdzyy1+wqy*pdzyy2       +2.0d0*rppzy2 
      pzdyypz1 = qcz*pdzyy1+wqz*pdzyy2+rsdyy2
      pzdzzpx1 = qcx*pdzzz1+wqx*pdzzz2                    
      pzdzzpy1 = qcy*pdzzz1+wqy*pdzzz2                    
      pzdzzpz1 = qcz*pdzzz1+wqz*pdzzz2+rsdzz2+2.0d0*rppzz2 
      pzdyxpx1 = qcx*pdzyx1+wqx*pdzyx2       +      rppzy2 
      pzdyxpy1 = qcy*pdzyx1+wqy*pdzyx2       +      rppzx2 
      pzdyxpz1 = qcz*pdzyx1+wqz*pdzyx2+rsdyx2              
      pzdzxpx1 = qcx*pdzzx1+wqx*pdzzx2       +      rppzz2 
      pzdzxpy1 = qcy*pdzzx1+wqy*pdzzx2                    
      pzdzxpz1 = qcz*pdzzx1+wqz*pdzzx2+rsdzx2+      rppzx2 
      pzdzypx1 = qcx*pdzzy1+wqx*pdzzy2                    
      pzdzypy1 = qcy*pdzzy1+wqy*pdzzy2       +      rppzz2 
      pzdzypz1 = qcz*pdzzy1+wqz*pdzzy2+rsdzy2+      rppzy2 

      pxdxxpx2 = qcx*pdxxx2+wqx*pdxxx3+rsdxx3+2.0d0*rppxx3
      pxdxxpy2 = qcy*pdxxx2+wqy*pdxxx3                   
      pxdxxpz2 = qcz*pdxxx2+wqz*pdxxx3                   
      pxdyypx2 = qcx*pdxyy2+wqx*pdxyy3+rsdyy3             
      pxdyypy2 = qcy*pdxyy2+wqy*pdxyy3       +2.0d0*rppxy3
      pxdyypz2 = qcz*pdxyy2+wqz*pdxyy3                   
      pxdzzpx2 = qcx*pdxzz2+wqx*pdxzz3+rsdzz3
      pxdzzpy2 = qcy*pdxzz2+wqy*pdxzz3                   
      pxdzzpz2 = qcz*pdxzz2+wqz*pdxzz3       +2.0d0*rppxz3
      pxdyxpx2 = qcx*pdxyx2+wqx*pdxyx3+rsdyx3+      rppxy3
      pxdyxpy2 = qcy*pdxyx2+wqy*pdxyx3       +      rppxx3
      pxdyxpz2 = qcz*pdxyx2+wqz*pdxyx3                   
      pxdzxpx2 = qcx*pdxzx2+wqx*pdxzx3+rsdzx3+      rppxz3
      pxdzxpy2 = qcy*pdxzx2+wqy*pdxzx3                   
      pxdzxpz2 = qcz*pdxzx2+wqz*pdxzx3       +      rppxx3
      pxdzypx2 = qcx*pdxzy2+wqx*pdxzy3+rsdzy3             
      pxdzypy2 = qcy*pdxzy2+wqy*pdxzy3       +      rppxz3
      pxdzypz2 = qcz*pdxzy2+wqz*pdxzy3       +      rppxy3
      pydxxpx2 = qcx*pdyxx2+wqx*pdyxx3       +2.0d0*rppyx3
      pydxxpy2 = qcy*pdyxx2+wqy*pdyxx3+rsdxx3             
      pydxxpz2 = qcz*pdyxx2+wqz*pdyxx3                   
      pydyypx2 = qcx*pdyyy2+wqx*pdyyy3                   
      pydyypy2 = qcy*pdyyy2+wqy*pdyyy3+rsdyy3+2.0d0*rppyy3
      pydyypz2 = qcz*pdyyy2+wqz*pdyyy3                   
      pydzzpx2 = qcx*pdyzz2+wqx*pdyzz3                   
      pydzzpy2 = qcy*pdyzz2+wqy*pdyzz3+rsdzz3             
      pydzzpz2 = qcz*pdyzz2+wqz*pdyzz3       +2.0d0*rppyz3
      pydyxpx2 = qcx*pdyyx2+wqx*pdyyx3       +      rppyy3
      pydyxpy2 = qcy*pdyyx2+wqy*pdyyx3+rsdyx3+      rppyx3
      pydyxpz2 = qcz*pdyyx2+wqz*pdyyx3                   
      pydzxpx2 = qcx*pdyzx2+wqx*pdyzx3       +      rppyz3
      pydzxpy2 = qcy*pdyzx2+wqy*pdyzx3+rsdzx3             
      pydzxpz2 = qcz*pdyzx2+wqz*pdyzx3       +      rppyx3
      pydzypx2 = qcx*pdyzy2+wqx*pdyzy3                   
      pydzypy2 = qcy*pdyzy2+wqy*pdyzy3+rsdzy3+      rppyz3
      pydzypz2 = qcz*pdyzy2+wqz*pdyzy3       +      rppyy3
      pzdxxpx2 = qcx*pdzxx2+wqx*pdzxx3       +2.0d0*rppzx3 
      pzdxxpy2 = qcy*pdzxx2+wqy*pdzxx3                    
      pzdxxpz2 = qcz*pdzxx2+wqz*pdzxx3+rsdxx3              
      pzdyypx2 = qcx*pdzyy2+wqx*pdzyy3                    
      pzdyypy2 = qcy*pdzyy2+wqy*pdzyy3       +2.0d0*rppzy3 
      pzdyypz2 = qcz*pdzyy2+wqz*pdzyy3+rsdyy3
      pzdzzpx2 = qcx*pdzzz2+wqx*pdzzz3                    
      pzdzzpy2 = qcy*pdzzz2+wqy*pdzzz3                    
      pzdzzpz2 = qcz*pdzzz2+wqz*pdzzz3+rsdzz3+2.0d0*rppzz3 
      pzdyxpx2 = qcx*pdzyx2+wqx*pdzyx3       +      rppzy3 
      pzdyxpy2 = qcy*pdzyx2+wqy*pdzyx3       +      rppzx3 
      pzdyxpz2 = qcz*pdzyx2+wqz*pdzyx3+rsdyx3              
      pzdzxpx2 = qcx*pdzzx2+wqx*pdzzx3       +      rppzz3 
      pzdzxpy2 = qcy*pdzzx2+wqy*pdzzx3                    
      pzdzxpz2 = qcz*pdzzx2+wqz*pdzzx3+rsdzx3+      rppzx3 
      pzdzypx2 = qcx*pdzzy2+wqx*pdzzy3                    
      pzdzypy2 = qcy*pdzzy2+wqy*pdzzy3       +      rppzz3 
      pzdzypz2 = qcz*pdzzy2+wqz*pdzzy3+rsdzy3+      rppzy3 

      pxdxxpx3 = qcx*pdxxx3+wqx*pdxxx4+rsdxx4+2.0d0*rppxx4
      pxdxxpy3 = qcy*pdxxx3+wqy*pdxxx4                   
      pxdxxpz3 = qcz*pdxxx3+wqz*pdxxx4                   
      pxdyypx3 = qcx*pdxyy3+wqx*pdxyy4+rsdyy4             
      pxdyypy3 = qcy*pdxyy3+wqy*pdxyy4       +2.0d0*rppxy4
      pxdyypz3 = qcz*pdxyy3+wqz*pdxyy4                   
      pxdzzpx3 = qcx*pdxzz3+wqx*pdxzz4+rsdzz4
      pxdzzpy3 = qcy*pdxzz3+wqy*pdxzz4                   
      pxdzzpz3 = qcz*pdxzz3+wqz*pdxzz4       +2.0d0*rppxz4
      pxdyxpx3 = qcx*pdxyx3+wqx*pdxyx4+rsdyx4+      rppxy4
      pxdyxpy3 = qcy*pdxyx3+wqy*pdxyx4       +      rppxx4
      pxdyxpz3 = qcz*pdxyx3+wqz*pdxyx4                   
      pxdzxpx3 = qcx*pdxzx3+wqx*pdxzx4+rsdzx4+      rppxz4
      pxdzxpy3 = qcy*pdxzx3+wqy*pdxzx4                   
      pxdzxpz3 = qcz*pdxzx3+wqz*pdxzx4       +      rppxx4
      pxdzypx3 = qcx*pdxzy3+wqx*pdxzy4+rsdzy4             
      pxdzypy3 = qcy*pdxzy3+wqy*pdxzy4       +      rppxz4
      pxdzypz3 = qcz*pdxzy3+wqz*pdxzy4       +      rppxy4
      pydxxpx3 = qcx*pdyxx3+wqx*pdyxx4       +2.0d0*rppyx4
      pydxxpy3 = qcy*pdyxx3+wqy*pdyxx4+rsdxx4             
      pydxxpz3 = qcz*pdyxx3+wqz*pdyxx4                   
      pydyypx3 = qcx*pdyyy3+wqx*pdyyy4                   
      pydyypy3 = qcy*pdyyy3+wqy*pdyyy4+rsdyy4+2.0d0*rppyy4
      pydyypz3 = qcz*pdyyy3+wqz*pdyyy4                   
      pydzzpx3 = qcx*pdyzz3+wqx*pdyzz4                   
      pydzzpy3 = qcy*pdyzz3+wqy*pdyzz4+rsdzz4             
      pydzzpz3 = qcz*pdyzz3+wqz*pdyzz4       +2.0d0*rppyz4
      pydyxpx3 = qcx*pdyyx3+wqx*pdyyx4       +      rppyy4
      pydyxpy3 = qcy*pdyyx3+wqy*pdyyx4+rsdyx4+      rppyx4
      pydyxpz3 = qcz*pdyyx3+wqz*pdyyx4                   
      pydzxpx3 = qcx*pdyzx3+wqx*pdyzx4       +      rppyz4
      pydzxpy3 = qcy*pdyzx3+wqy*pdyzx4+rsdzx4             
      pydzxpz3 = qcz*pdyzx3+wqz*pdyzx4       +      rppyx4
      pydzypx3 = qcx*pdyzy3+wqx*pdyzy4                   
      pydzypy3 = qcy*pdyzy3+wqy*pdyzy4+rsdzy4+      rppyz4
      pydzypz3 = qcz*pdyzy3+wqz*pdyzy4       +      rppyy4
      pzdxxpx3 = qcx*pdzxx3+wqx*pdzxx4       +2.0d0*rppzx4
      pzdxxpy3 = qcy*pdzxx3+wqy*pdzxx4                    
      pzdxxpz3 = qcz*pdzxx3+wqz*pdzxx4+rsdxx4             
      pzdyypx3 = qcx*pdzyy3+wqx*pdzyy4                    
      pzdyypy3 = qcy*pdzyy3+wqy*pdzyy4       +2.0d0*rppzy4
      pzdyypz3 = qcz*pdzyy3+wqz*pdzyy4+rsdyy4
      pzdzzpx3 = qcx*pdzzz3+wqx*pdzzz4                    
      pzdzzpy3 = qcy*pdzzz3+wqy*pdzzz4                    
      pzdzzpz3 = qcz*pdzzz3+wqz*pdzzz4+rsdzz4+2.0d0*rppzz4
      pzdyxpx3 = qcx*pdzyx3+wqx*pdzyx4       +      rppzy4
      pzdyxpy3 = qcy*pdzyx3+wqy*pdzyx4       +      rppzx4
      pzdyxpz3 = qcz*pdzyx3+wqz*pdzyx4+rsdyx4             
      pzdzxpx3 = qcx*pdzzx3+wqx*pdzzx4       +      rppzz4
      pzdzxpy3 = qcy*pdzzx3+wqy*pdzzx4                    
      pzdzxpz3 = qcz*pdzzx3+wqz*pdzzx4+rsdzx4+      rppzx4
      pzdzypx3 = qcx*pdzzy3+wqx*pdzzy4                    
      pzdzypy3 = qcy*pdzzy3+wqy*pdzzy4       +      rppzz4
      pzdzypz3 = qcz*pdzzy3+wqz*pdzzy4+rsdzy4+      rppzy4

!rdpss(1-4)
         rdpxxx1 = rkp * dpxxx1
         rdpxxy1 = rkp * dpxxy1
         rdpxxz1 = rkp * dpxxz1
         rdpyyx1 = rkp * dpyyx1
         rdpyyy1 = rkp * dpyyy1
         rdpyyz1 = rkp * dpyyz1
         rdpzzx1 = rkp * dpzzx1
         rdpzzy1 = rkp * dpzzy1
         rdpzzz1 = rkp * dpzzz1
         rdpyxx1 = rkp * dpyxx1
         rdpyxy1 = rkp * dpyxy1
         rdpyxz1 = rkp * dpyxz1
         rdpzxx1 = rkp * dpzxx1
         rdpzxy1 = rkp * dpzxy1
         rdpzxz1 = rkp * dpzxz1
         rdpzyx1 = rkp * dpzyx1
         rdpzyy1 = rkp * dpzyy1
         rdpzyz1 = rkp * dpzyz1
         rdpxxx2 = rkp * dpxxx2
         rdpxxy2 = rkp * dpxxy2
         rdpxxz2 = rkp * dpxxz2
         rdpyyx2 = rkp * dpyyx2
         rdpyyy2 = rkp * dpyyy2
         rdpyyz2 = rkp * dpyyz2
         rdpzzx2 = rkp * dpzzx2
         rdpzzy2 = rkp * dpzzy2
         rdpzzz2 = rkp * dpzzz2
         rdpyxx2 = rkp * dpyxx2
         rdpyxy2 = rkp * dpyxy2
         rdpyxz2 = rkp * dpyxz2
         rdpzxx2 = rkp * dpzxx2
         rdpzxy2 = rkp * dpzxy2
         rdpzxz2 = rkp * dpzxz2
         rdpzyx2 = rkp * dpzyx2
         rdpzyy2 = rkp * dpzyy2
         rdpzyz2 = rkp * dpzyz2
         rdpxxx3 = rkp * dpxxx3
         rdpxxy3 = rkp * dpxxy3
         rdpxxz3 = rkp * dpxxz3
         rdpyyx3 = rkp * dpyyx3
         rdpyyy3 = rkp * dpyyy3
         rdpyyz3 = rkp * dpyyz3
         rdpzzx3 = rkp * dpzzx3
         rdpzzy3 = rkp * dpzzy3
         rdpzzz3 = rkp * dpzzz3
         rdpyxx3 = rkp * dpyxx3
         rdpyxy3 = rkp * dpyxy3
         rdpyxz3 = rkp * dpyxz3
         rdpzxx3 = rkp * dpzxx3
         rdpzxy3 = rkp * dpzxy3
         rdpzxz3 = rkp * dpzxz3
         rdpzyx3 = rkp * dpzyx3
         rdpzyy3 = rkp * dpzyy3
         rdpzyz3 = rkp * dpzyz3
         rdpxxx4 = rkp * dpxxx4
         rdpxxy4 = rkp * dpxxy4
         rdpxxz4 = rkp * dpxxz4
         rdpyyx4 = rkp * dpyyx4
         rdpyyy4 = rkp * dpyyy4
         rdpyyz4 = rkp * dpyyz4
         rdpzzx4 = rkp * dpzzx4
         rdpzzy4 = rkp * dpzzy4
         rdpzzz4 = rkp * dpzzz4
         rdpyxx4 = rkp * dpyxx4
         rdpyxy4 = rkp * dpyxy4
         rdpyxz4 = rkp * dpyxz4
         rdpzxx4 = rkp * dpzxx4
         rdpzxy4 = rkp * dpzxy4
         rdpzxz4 = rkp * dpzxz4
         rdpzyx4 = rkp * dpzyx4
         rdpzyy4 = rkp * dpzyy4
         rdpzyz4 = rkp * dpzyz4
!rpdss(1-4)
         rpdxxx1 = rkp * pdxxx1
         rpdxyy1 = rkp * pdxyy1
         rpdxzz1 = rkp * pdxzz1
         rpdxyx1 = rkp * pdxyx1
         rpdxzx1 = rkp * pdxzx1
         rpdxzy1 = rkp * pdxzy1
         rpdyxx1 = rkp * pdyxx1
         rpdyyy1 = rkp * pdyyy1
         rpdyzz1 = rkp * pdyzz1
         rpdyyx1 = rkp * pdyyx1
         rpdyzx1 = rkp * pdyzx1
         rpdyzy1 = rkp * pdyzy1
         rpdzxx1 = rkp * pdzxx1
         rpdzyy1 = rkp * pdzyy1
         rpdzzz1 = rkp * pdzzz1
         rpdzyx1 = rkp * pdzyx1
         rpdzzx1 = rkp * pdzzx1
         rpdzzy1 = rkp * pdzzy1

         rpdxxx2 = rkp * pdxxx2
         rpdxyy2 = rkp * pdxyy2
         rpdxzz2 = rkp * pdxzz2
         rpdxyx2 = rkp * pdxyx2
         rpdxzx2 = rkp * pdxzx2
         rpdxzy2 = rkp * pdxzy2
         rpdyxx2 = rkp * pdyxx2
         rpdyyy2 = rkp * pdyyy2
         rpdyzz2 = rkp * pdyzz2
         rpdyyx2 = rkp * pdyyx2
         rpdyzx2 = rkp * pdyzx2
         rpdyzy2 = rkp * pdyzy2
         rpdzxx2 = rkp * pdzxx2
         rpdzyy2 = rkp * pdzyy2
         rpdzzz2 = rkp * pdzzz2
         rpdzyx2 = rkp * pdzyx2
         rpdzzx2 = rkp * pdzzx2
         rpdzzy2 = rkp * pdzzy2

         rpdxxx3 = rkp * pdxxx3
         rpdxyy3 = rkp * pdxyy3
         rpdxzz3 = rkp * pdxzz3
         rpdxyx3 = rkp * pdxyx3
         rpdxzx3 = rkp * pdxzx3
         rpdxzy3 = rkp * pdxzy3
         rpdyxx3 = rkp * pdyxx3
         rpdyyy3 = rkp * pdyyy3
         rpdyzz3 = rkp * pdyzz3
         rpdyyx3 = rkp * pdyyx3
         rpdyzx3 = rkp * pdyzx3
         rpdyzy3 = rkp * pdyzy3
         rpdzxx3 = rkp * pdzxx3
         rpdzyy3 = rkp * pdzyy3
         rpdzzz3 = rkp * pdzzz3
         rpdzyx3 = rkp * pdzyx3
         rpdzzx3 = rkp * pdzzx3
         rpdzzy3 = rkp * pdzzy3

         rpdxxx4 = rkp * pdxxx4
         rpdxyy4 = rkp * pdxyy4
         rpdxzz4 = rkp * pdxzz4
         rpdxyx4 = rkp * pdxyx4
         rpdxzx4 = rkp * pdxzx4
         rpdxzy4 = rkp * pdxzy4
         rpdyxx4 = rkp * pdyxx4
         rpdyyy4 = rkp * pdyyy4
         rpdyzz4 = rkp * pdyzz4
         rpdyyx4 = rkp * pdyyx4
         rpdyzx4 = rkp * pdyzx4
         rpdyzy4 = rkp * pdyzy4
         rpdzxx4 = rkp * pdzxx4
         rpdzyy4 = rkp * pdzyy4
         rpdzzz4 = rkp * pdzzz4
         rpdzyx4 = rkp * pdzyx4
         rpdzzx4 = rkp * pdzzx4
         rpdzzy4 = rkp * pdzzy4

!ddps(0-3)
      dxxdxxpx0=qcx*ddxxxx0 + wqx*ddxxxx1 + 2.0d0*rpdxxx1+2.0d0*rdpxxx1
      dxxdxxpy0=qcy*ddxxxx0 + wqy*ddxxxx1
      dxxdxxpz0=qcz*ddxxxx0 + wqz*ddxxxx1
      dxxdyypx0=qcx*ddxxyy0 + wqx*ddxxyy1 + 2.0d0*rpdxyy1
      dxxdyypy0=qcy*ddxxyy0 + wqy*ddxxyy1                +2.0d0*rdpxxy1
      dxxdyypz0=qcz*ddxxyy0 + wqz*ddxxyy1
      dxxdzzpx0=qcx*ddxxzz0 + wqx*ddxxzz1 + 2.0d0*rpdxzz1
      dxxdzzpy0=qcy*ddxxzz0 + wqy*ddxxzz1
      dxxdzzpz0=qcz*ddxxzz0 + wqz*ddxxzz1                +2.0d0*rdpxxz1
      dxxdyxpx0=qcx*ddxxyx0 + wqx*ddxxyx1 + 2.0d0*rpdxyx1+      rdpxxy1
      dxxdyxpy0=qcy*ddxxyx0 + wqy*ddxxyx1                +      rdpxxx1
      dxxdyxpz0=qcz*ddxxyx0 + wqz*ddxxyx1 
      dxxdzxpx0=qcx*ddxxzx0 + wqx*ddxxzx1 + 2.0d0*rpdxzx1+      rdpxxz1
      dxxdzxpy0=qcy*ddxxzx0 + wqy*ddxxzx1
      dxxdzxpz0=qcz*ddxxzx0 + wqz*ddxxzx1                +      rdpxxx1
      dxxdzypx0=qcx*ddxxzy0 + wqx*ddxxzy1 + 2.0d0*rpdxzy1
      dxxdzypy0=qcy*ddxxzy0 + wqy*ddxxzy1                +      rdpxxz1
      dxxdzypz0=qcz*ddxxzy0 + wqz*ddxxzy1                +      rdpxxy1
      dyydxxpx0=qcx*ddyyxx0 + wqx*ddyyxx1                +2.0d0*rdpyyx1
      dyydxxpy0=qcy*ddyyxx0 + wqy*ddyyxx1 + 2.0d0*rpdyxx1
      dyydxxpz0=qcz*ddyyxx0 + wqz*ddyyxx1
      dyydyypx0=qcx*ddyyyy0 + wqx*ddyyyy1
      dyydyypy0=qcy*ddyyyy0 + wqy*ddyyyy1 + 2.0d0*rpdyyy1+2.0d0*rdpyyy1
      dyydyypz0=qcz*ddyyyy0 + wqz*ddyyyy1
      dyydzzpx0=qcx*ddyyzz0 + wqx*ddyyzz1
      dyydzzpy0=qcy*ddyyzz0 + wqy*ddyyzz1 + 2.0d0*rpdyzz1
      dyydzzpz0=qcz*ddyyzz0 + wqz*ddyyzz1                +2.0d0*rdpyyz1
      dyydyxpx0=qcx*ddyyyx0 + wqx*ddyyyx1                +      rdpyyy1
      dyydyxpy0=qcy*ddyyyx0 + wqy*ddyyyx1 + 2.0d0*rpdyyx1+      rdpyyx1
      dyydyxpz0=qcz*ddyyyx0 + wqz*ddyyyx1
      dyydzxpx0=qcx*ddyyzx0 + wqx*ddyyzx1                +      rdpyyz1
      dyydzxpy0=qcy*ddyyzx0 + wqy*ddyyzx1 + 2.0d0*rpdyzx1
      dyydzxpz0=qcz*ddyyzx0 + wqz*ddyyzx1                +      rdpyyx1
      dyydzypx0=qcx*ddyyzy0 + wqx*ddyyzy1
      dyydzypy0=qcy*ddyyzy0 + wqy*ddyyzy1 + 2.0d0*rpdyzy1+      rdpyyz1
      dyydzypz0=qcz*ddyyzy0 + wqz*ddyyzy1                +      rdpyyy1
      dzzdxxpx0=qcx*ddzzxx0 + wqx*ddzzxx1                +2.0d0*rdpzzx1
      dzzdxxpy0=qcy*ddzzxx0 + wqy*ddzzxx1 
      dzzdxxpz0=qcz*ddzzxx0 + wqz*ddzzxx1 + 2.0d0*rpdzxx1
      dzzdyypx0=qcx*ddzzyy0 + wqx*ddzzyy1
      dzzdyypy0=qcy*ddzzyy0 + wqy*ddzzyy1                +2.0d0*rdpzzy1
      dzzdyypz0=qcz*ddzzyy0 + wqz*ddzzyy1 + 2.0d0*rpdzyy1
      dzzdzzpx0=qcx*ddzzzz0 + wqx*ddzzzz1
      dzzdzzpy0=qcy*ddzzzz0 + wqy*ddzzzz1
      dzzdzzpz0=qcz*ddzzzz0 + wqz*ddzzzz1 + 2.0d0*rpdzzz1+2.0d0*rdpzzz1
      dzzdyxpx0=qcx*ddzzyx0 + wqx*ddzzyx1                +      rdpzzy1
      dzzdyxpy0=qcy*ddzzyx0 + wqy*ddzzyx1                +      rdpzzx1
      dzzdyxpz0=qcz*ddzzyx0 + wqz*ddzzyx1 + 2.0d0*rpdzyx1
      dzzdzxpx0=qcx*ddzzzx0 + wqx*ddzzzx1                +      rdpzzz1
      dzzdzxpy0=qcy*ddzzzx0 + wqy*ddzzzx1 
      dzzdzxpz0=qcz*ddzzzx0 + wqz*ddzzzx1 + 2.0d0*rpdzzx1+      rdpzzx1
      dzzdzypx0=qcx*ddzzzy0 + wqx*ddzzzy1
      dzzdzypy0=qcy*ddzzzy0 + wqy*ddzzzy1                +      rdpzzz1
      dzzdzypz0=qcz*ddzzzy0 + wqz*ddzzzy1 + 2.0d0*rpdzzy1+      rdpzzy1
      dyxdxxpx0=qcx*ddyxxx0 + wqx*ddyxxx1 +       rpdyxx1+2.0d0*rdpyxx1
      dyxdxxpy0=qcy*ddyxxx0 + wqy*ddyxxx1 +       rpdxxx1
      dyxdxxpz0=qcz*ddyxxx0 + wqz*ddyxxx1
      dyxdyypx0=qcx*ddyxyy0 + wqx*ddyxyy1 +       rpdyyy1
      dyxdyypy0=qcy*ddyxyy0 + wqy*ddyxyy1 +       rpdxyy1+2.0d0*rdpyxy1
      dyxdyypz0=qcz*ddyxyy0 + wqz*ddyxyy1
      dyxdzzpx0=qcx*ddyxzz0 + wqx*ddyxzz1 +       rpdyzz1
      dyxdzzpy0=qcy*ddyxzz0 + wqy*ddyxzz1 +       rpdxzz1
      dyxdzzpz0=qcz*ddyxzz0 + wqz*ddyxzz1                +2.0d0*rdpyxz1
      dyxdyxpx0=qcx*ddyxyx0 + wqx*ddyxyx1 +       rpdyyx1+      rdpyxy1
      dyxdyxpy0=qcy*ddyxyx0 + wqy*ddyxyx1 +       rpdxyx1+      rdpyxx1
      dyxdyxpz0=qcz*ddyxyx0 + wqz*ddyxyx1
      dyxdzxpx0=qcx*ddyxzx0 + wqx*ddyxzx1 +       rpdyzx1+      rdpyxz1
      dyxdzxpy0=qcy*ddyxzx0 + wqy*ddyxzx1 +       rpdxzx1
      dyxdzxpz0=qcz*ddyxzx0 + wqz*ddyxzx1                +      rdpyxx1
      dyxdzypx0=qcx*ddyxzy0 + wqx*ddyxzy1 +       rpdyzy1
      dyxdzypy0=qcy*ddyxzy0 + wqy*ddyxzy1 +       rpdxzy1+      rdpyxz1
      dyxdzypz0=qcz*ddyxzy0 + wqz*ddyxzy1                +      rdpyxy1
      dzxdxxpx0=qcx*ddzxxx0 + wqx*ddzxxx1 +       rpdzxx1+2.0d0*rdpzxx1
      dzxdxxpy0=qcy*ddzxxx0 + wqy*ddzxxx1
      dzxdxxpz0=qcz*ddzxxx0 + wqz*ddzxxx1 +       rpdxxx1
      dzxdyypx0=qcx*ddzxyy0 + wqx*ddzxyy1 +       rpdzyy1
      dzxdyypy0=qcy*ddzxyy0 + wqy*ddzxyy1                +2.0d0*rdpzxy1
      dzxdyypz0=qcz*ddzxyy0 + wqz*ddzxyy1 +       rpdxyy1
      dzxdzzpx0=qcx*ddzxzz0 + wqx*ddzxzz1 +       rpdzzz1
      dzxdzzpy0=qcy*ddzxzz0 + wqy*ddzxzz1
      dzxdzzpz0=qcz*ddzxzz0 + wqz*ddzxzz1 +       rpdxzz1+2.0d0*rdpzxz1
      dzxdyxpx0=qcx*ddzxyx0 + wqx*ddzxyx1 +       rpdzyx1+      rdpzxy1
      dzxdyxpy0=qcy*ddzxyx0 + wqy*ddzxyx1                +      rdpzxx1
      dzxdyxpz0=qcz*ddzxyx0 + wqz*ddzxyx1 +       rpdxyx1
      dzxdzxpx0=qcx*ddzxzx0 + wqx*ddzxzx1 +       rpdzzx1+      rdpzxz1
      dzxdzxpy0=qcy*ddzxzx0 + wqy*ddzxzx1
      dzxdzxpz0=qcz*ddzxzx0 + wqz*ddzxzx1 +       rpdxzx1+      rdpzxx1
      dzxdzypx0=qcx*ddzxzy0 + wqx*ddzxzy1 +       rpdzzy1
      dzxdzypy0=qcy*ddzxzy0 + wqy*ddzxzy1                +      rdpzxz1
      dzxdzypz0=qcz*ddzxzy0 + wqz*ddzxzy1 +       rpdxzy1+      rdpzxy1
      dzydxxpx0=qcx*ddzyxx0 + wqx*ddzyxx1                +2.0d0*rdpzyx1
      dzydxxpy0=qcy*ddzyxx0 + wqy*ddzyxx1 +       rpdzxx1
      dzydxxpz0=qcz*ddzyxx0 + wqz*ddzyxx1 +       rpdyxx1
      dzydyypx0=qcx*ddzyyy0 + wqx*ddzyyy1
      dzydyypy0=qcy*ddzyyy0 + wqy*ddzyyy1 +       rpdzyy1+2.0d0*rdpzyy1
      dzydyypz0=qcz*ddzyyy0 + wqz*ddzyyy1 +       rpdyyy1
      dzydzzpx0=qcx*ddzyzz0 + wqx*ddzyzz1
      dzydzzpy0=qcy*ddzyzz0 + wqy*ddzyzz1 +       rpdzzz1
      dzydzzpz0=qcz*ddzyzz0 + wqz*ddzyzz1 +       rpdyzz1+2.0d0*rdpzyz1
      dzydyxpx0=qcx*ddzyyx0 + wqx*ddzyyx1                +      rdpzyy1
      dzydyxpy0=qcy*ddzyyx0 + wqy*ddzyyx1 +       rpdzyx1+      rdpzyx1
      dzydyxpz0=qcz*ddzyyx0 + wqz*ddzyyx1 +       rpdyyx1
      dzydzxpx0=qcx*ddzyzx0 + wqx*ddzyzx1                +      rdpzyz1
      dzydzxpy0=qcy*ddzyzx0 + wqy*ddzyzx1 +       rpdzzx1
      dzydzxpz0=qcz*ddzyzx0 + wqz*ddzyzx1 +       rpdyzx1+      rdpzyx1
      dzydzypx0=qcx*ddzyzy0 + wqx*ddzyzy1
      dzydzypy0=qcy*ddzyzy0 + wqy*ddzyzy1 +       rpdzzy1+      rdpzyz1
      dzydzypz0=qcz*ddzyzy0 + wqz*ddzyzy1 +       rpdyzy1+      rdpzyy1

      dxxdxxpx1=qcx*ddxxxx1 + wqx*ddxxxx2 + 2.0d0*rpdxxx2+2.0d0*rdpxxx2
      dxxdxxpy1=qcy*ddxxxx1 + wqy*ddxxxx2
      dxxdxxpz1=qcz*ddxxxx1 + wqz*ddxxxx2
      dxxdyypx1=qcx*ddxxyy1 + wqx*ddxxyy2 + 2.0d0*rpdxyy2
      dxxdyypy1=qcy*ddxxyy1 + wqy*ddxxyy2                +2.0d0*rdpxxy2
      dxxdyypz1=qcz*ddxxyy1 + wqz*ddxxyy2
      dxxdzzpx1=qcx*ddxxzz1 + wqx*ddxxzz2 + 2.0d0*rpdxzz2
      dxxdzzpy1=qcy*ddxxzz1 + wqy*ddxxzz2
      dxxdzzpz1=qcz*ddxxzz1 + wqz*ddxxzz2                +2.0d0*rdpxxz2
      dxxdyxpx1=qcx*ddxxyx1 + wqx*ddxxyx2 + 2.0d0*rpdxyx2+      rdpxxy2
      dxxdyxpy1=qcy*ddxxyx1 + wqy*ddxxyx2                +      rdpxxx2
      dxxdyxpz1=qcz*ddxxyx1 + wqz*ddxxyx2 
      dxxdzxpx1=qcx*ddxxzx1 + wqx*ddxxzx2 + 2.0d0*rpdxzx2+      rdpxxz2
      dxxdzxpy1=qcy*ddxxzx1 + wqy*ddxxzx2
      dxxdzxpz1=qcz*ddxxzx1 + wqz*ddxxzx2                +      rdpxxx2
      dxxdzypx1=qcx*ddxxzy1 + wqx*ddxxzy2 + 2.0d0*rpdxzy2
      dxxdzypy1=qcy*ddxxzy1 + wqy*ddxxzy2                +      rdpxxz2
      dxxdzypz1=qcz*ddxxzy1 + wqz*ddxxzy2                +      rdpxxy2
      dyydxxpx1=qcx*ddyyxx1 + wqx*ddyyxx2                +2.0d0*rdpyyx2
      dyydxxpy1=qcy*ddyyxx1 + wqy*ddyyxx2 + 2.0d0*rpdyxx2
      dyydxxpz1=qcz*ddyyxx1 + wqz*ddyyxx2
      dyydyypx1=qcx*ddyyyy1 + wqx*ddyyyy2
      dyydyypy1=qcy*ddyyyy1 + wqy*ddyyyy2 + 2.0d0*rpdyyy2+2.0d0*rdpyyy2
      dyydyypz1=qcz*ddyyyy1 + wqz*ddyyyy2
      dyydzzpx1=qcx*ddyyzz1 + wqx*ddyyzz2
      dyydzzpy1=qcy*ddyyzz1 + wqy*ddyyzz2 + 2.0d0*rpdyzz2
      dyydzzpz1=qcz*ddyyzz1 + wqz*ddyyzz2                +2.0d0*rdpyyz2
      dyydyxpx1=qcx*ddyyyx1 + wqx*ddyyyx2                +      rdpyyy2
      dyydyxpy1=qcy*ddyyyx1 + wqy*ddyyyx2 + 2.0d0*rpdyyx2+      rdpyyx2
      dyydyxpz1=qcz*ddyyyx1 + wqz*ddyyyx2
      dyydzxpx1=qcx*ddyyzx1 + wqx*ddyyzx2                +      rdpyyz2
      dyydzxpy1=qcy*ddyyzx1 + wqy*ddyyzx2 + 2.0d0*rpdyzx2
      dyydzxpz1=qcz*ddyyzx1 + wqz*ddyyzx2                +      rdpyyx2
      dyydzypx1=qcx*ddyyzy1 + wqx*ddyyzy2
      dyydzypy1=qcy*ddyyzy1 + wqy*ddyyzy2 + 2.0d0*rpdyzy2+      rdpyyz2
      dyydzypz1=qcz*ddyyzy1 + wqz*ddyyzy2                +      rdpyyy2
      dzzdxxpx1=qcx*ddzzxx1 + wqx*ddzzxx2                +2.0d0*rdpzzx2
      dzzdxxpy1=qcy*ddzzxx1 + wqy*ddzzxx2 
      dzzdxxpz1=qcz*ddzzxx1 + wqz*ddzzxx2 + 2.0d0*rpdzxx2
      dzzdyypx1=qcx*ddzzyy1 + wqx*ddzzyy2
      dzzdyypy1=qcy*ddzzyy1 + wqy*ddzzyy2                +2.0d0*rdpzzy2
      dzzdyypz1=qcz*ddzzyy1 + wqz*ddzzyy2 + 2.0d0*rpdzyy2
      dzzdzzpx1=qcx*ddzzzz1 + wqx*ddzzzz2
      dzzdzzpy1=qcy*ddzzzz1 + wqy*ddzzzz2
      dzzdzzpz1=qcz*ddzzzz1 + wqz*ddzzzz2 + 2.0d0*rpdzzz2+2.0d0*rdpzzz2
      dzzdyxpx1=qcx*ddzzyx1 + wqx*ddzzyx2                +      rdpzzy2
      dzzdyxpy1=qcy*ddzzyx1 + wqy*ddzzyx2                +      rdpzzx2
      dzzdyxpz1=qcz*ddzzyx1 + wqz*ddzzyx2 + 2.0d0*rpdzyx2
      dzzdzxpx1=qcx*ddzzzx1 + wqx*ddzzzx2                +      rdpzzz2
      dzzdzxpy1=qcy*ddzzzx1 + wqy*ddzzzx2 
      dzzdzxpz1=qcz*ddzzzx1 + wqz*ddzzzx2 + 2.0d0*rpdzzx2+      rdpzzx2
      dzzdzypx1=qcx*ddzzzy1 + wqx*ddzzzy2
      dzzdzypy1=qcy*ddzzzy1 + wqy*ddzzzy2                +      rdpzzz2
      dzzdzypz1=qcz*ddzzzy1 + wqz*ddzzzy2 + 2.0d0*rpdzzy2+      rdpzzy2

      dyxdxxpx1=qcx*ddyxxx1 + wqx*ddyxxx2 +       rpdyxx2+2.0d0*rdpyxx2
      dyxdxxpy1=qcy*ddyxxx1 + wqy*ddyxxx2 +       rpdxxx2
      dyxdxxpz1=qcz*ddyxxx1 + wqz*ddyxxx2
      dyxdyypx1=qcx*ddyxyy1 + wqx*ddyxyy2 +       rpdyyy2
      dyxdyypy1=qcy*ddyxyy1 + wqy*ddyxyy2 +       rpdxyy2+2.0d0*rdpyxy2
      dyxdyypz1=qcz*ddyxyy1 + wqz*ddyxyy2
      dyxdzzpx1=qcx*ddyxzz1 + wqx*ddyxzz2 +       rpdyzz2
      dyxdzzpy1=qcy*ddyxzz1 + wqy*ddyxzz2 +       rpdxzz2
      dyxdzzpz1=qcz*ddyxzz1 + wqz*ddyxzz2                +2.0d0*rdpyxz2
      dyxdyxpx1=qcx*ddyxyx1 + wqx*ddyxyx2 +       rpdyyx2+      rdpyxy2
      dyxdyxpy1=qcy*ddyxyx1 + wqy*ddyxyx2 +       rpdxyx2+      rdpyxx2
      dyxdyxpz1=qcz*ddyxyx1 + wqz*ddyxyx2
      dyxdzxpx1=qcx*ddyxzx1 + wqx*ddyxzx2 +       rpdyzx2+      rdpyxz2
      dyxdzxpy1=qcy*ddyxzx1 + wqy*ddyxzx2 +       rpdxzx2
      dyxdzxpz1=qcz*ddyxzx1 + wqz*ddyxzx2                +      rdpyxx2
      dyxdzypx1=qcx*ddyxzy1 + wqx*ddyxzy2 +       rpdyzy2
      dyxdzypy1=qcy*ddyxzy1 + wqy*ddyxzy2 +       rpdxzy2+      rdpyxz2
      dyxdzypz1=qcz*ddyxzy1 + wqz*ddyxzy2                +      rdpyxy2
      dzxdxxpx1=qcx*ddzxxx1 + wqx*ddzxxx2 +       rpdzxx2+2.0d0*rdpzxx2
      dzxdxxpy1=qcy*ddzxxx1 + wqy*ddzxxx2
      dzxdxxpz1=qcz*ddzxxx1 + wqz*ddzxxx2 +       rpdxxx2
      dzxdyypx1=qcx*ddzxyy1 + wqx*ddzxyy2 +       rpdzyy2
      dzxdyypy1=qcy*ddzxyy1 + wqy*ddzxyy2                +2.0d0*rdpzxy2
      dzxdyypz1=qcz*ddzxyy1 + wqz*ddzxyy2 +       rpdxyy2
      dzxdzzpx1=qcx*ddzxzz1 + wqx*ddzxzz2 +       rpdzzz2
      dzxdzzpy1=qcy*ddzxzz1 + wqy*ddzxzz2
      dzxdzzpz1=qcz*ddzxzz1 + wqz*ddzxzz2 +       rpdxzz2+2.0d0*rdpzxz2
      dzxdyxpx1=qcx*ddzxyx1 + wqx*ddzxyx2 +       rpdzyx2+      rdpzxy2
      dzxdyxpy1=qcy*ddzxyx1 + wqy*ddzxyx2                +      rdpzxx2
      dzxdyxpz1=qcz*ddzxyx1 + wqz*ddzxyx2 +       rpdxyx2
      dzxdzxpx1=qcx*ddzxzx1 + wqx*ddzxzx2 +       rpdzzx2+      rdpzxz2
      dzxdzxpy1=qcy*ddzxzx1 + wqy*ddzxzx2
      dzxdzxpz1=qcz*ddzxzx1 + wqz*ddzxzx2 +       rpdxzx2+      rdpzxx2
      dzxdzypx1=qcx*ddzxzy1 + wqx*ddzxzy2 +       rpdzzy2
      dzxdzypy1=qcy*ddzxzy1 + wqy*ddzxzy2                +      rdpzxz2
      dzxdzypz1=qcz*ddzxzy1 + wqz*ddzxzy2 +       rpdxzy2+      rdpzxy2
      dzydxxpx1=qcx*ddzyxx1 + wqx*ddzyxx2                +2.0d0*rdpzyx2
      dzydxxpy1=qcy*ddzyxx1 + wqy*ddzyxx2 +       rpdzxx2
      dzydxxpz1=qcz*ddzyxx1 + wqz*ddzyxx2 +       rpdyxx2
      dzydyypx1=qcx*ddzyyy1 + wqx*ddzyyy2
      dzydyypy1=qcy*ddzyyy1 + wqy*ddzyyy2 +       rpdzyy2+2.0d0*rdpzyy2
      dzydyypz1=qcz*ddzyyy1 + wqz*ddzyyy2 +       rpdyyy2
      dzydzzpx1=qcx*ddzyzz1 + wqx*ddzyzz2
      dzydzzpy1=qcy*ddzyzz1 + wqy*ddzyzz2 +       rpdzzz2
      dzydzzpz1=qcz*ddzyzz1 + wqz*ddzyzz2 +       rpdyzz2+2.0d0*rdpzyz2
      dzydyxpx1=qcx*ddzyyx1 + wqx*ddzyyx2                +      rdpzyy2
      dzydyxpy1=qcy*ddzyyx1 + wqy*ddzyyx2 +       rpdzyx2+      rdpzyx2
      dzydyxpz1=qcz*ddzyyx1 + wqz*ddzyyx2 +       rpdyyx2
      dzydzxpx1=qcx*ddzyzx1 + wqx*ddzyzx2                +      rdpzyz2
      dzydzxpy1=qcy*ddzyzx1 + wqy*ddzyzx2 +       rpdzzx2
      dzydzxpz1=qcz*ddzyzx1 + wqz*ddzyzx2 +       rpdyzx2+      rdpzyx2
      dzydzypx1=qcx*ddzyzy1 + wqx*ddzyzy2
      dzydzypy1=qcy*ddzyzy1 + wqy*ddzyzy2 +       rpdzzy2+      rdpzyz2
      dzydzypz1=qcz*ddzyzy1 + wqz*ddzyzy2 +       rpdyzy2+      rdpzyy2

      dxxdxxpx2=qcx*ddxxxx2 + wqx*ddxxxx3 + 2.0d0*rpdxxx3+2.0d0*rdpxxx3
      dxxdxxpy2=qcy*ddxxxx2 + wqy*ddxxxx3
      dxxdxxpz2=qcz*ddxxxx2 + wqz*ddxxxx3
      dxxdyypx2=qcx*ddxxyy2 + wqx*ddxxyy3 + 2.0d0*rpdxyy3
      dxxdyypy2=qcy*ddxxyy2 + wqy*ddxxyy3                +2.0d0*rdpxxy3
      dxxdyypz2=qcz*ddxxyy2 + wqz*ddxxyy3
      dxxdzzpx2=qcx*ddxxzz2 + wqx*ddxxzz3 + 2.0d0*rpdxzz3
      dxxdzzpy2=qcy*ddxxzz2 + wqy*ddxxzz3
      dxxdzzpz2=qcz*ddxxzz2 + wqz*ddxxzz3                +2.0d0*rdpxxz3
      dxxdyxpx2=qcx*ddxxyx2 + wqx*ddxxyx3 + 2.0d0*rpdxyx3+      rdpxxy3
      dxxdyxpy2=qcy*ddxxyx2 + wqy*ddxxyx3                +      rdpxxx3
      dxxdyxpz2=qcz*ddxxyx2 + wqz*ddxxyx3 
      dxxdzxpx2=qcx*ddxxzx2 + wqx*ddxxzx3 + 2.0d0*rpdxzx3+      rdpxxz3
      dxxdzxpy2=qcy*ddxxzx2 + wqy*ddxxzx3
      dxxdzxpz2=qcz*ddxxzx2 + wqz*ddxxzx3                +      rdpxxx3
      dxxdzypx2=qcx*ddxxzy2 + wqx*ddxxzy3 + 2.0d0*rpdxzy3
      dxxdzypy2=qcy*ddxxzy2 + wqy*ddxxzy3                +      rdpxxz3
      dxxdzypz2=qcz*ddxxzy2 + wqz*ddxxzy3                +      rdpxxy3
      dyydxxpx2=qcx*ddyyxx2 + wqx*ddyyxx3                +2.0d0*rdpyyx3
      dyydxxpy2=qcy*ddyyxx2 + wqy*ddyyxx3 + 2.0d0*rpdyxx3
      dyydxxpz2=qcz*ddyyxx2 + wqz*ddyyxx3
      dyydyypx2=qcx*ddyyyy2 + wqx*ddyyyy3
      dyydyypy2=qcy*ddyyyy2 + wqy*ddyyyy3 + 2.0d0*rpdyyy3+2.0d0*rdpyyy3
      dyydyypz2=qcz*ddyyyy2 + wqz*ddyyyy3
      dyydzzpx2=qcx*ddyyzz2 + wqx*ddyyzz3
      dyydzzpy2=qcy*ddyyzz2 + wqy*ddyyzz3 + 2.0d0*rpdyzz3
      dyydzzpz2=qcz*ddyyzz2 + wqz*ddyyzz3                +2.0d0*rdpyyz3
      dyydyxpx2=qcx*ddyyyx2 + wqx*ddyyyx3                +      rdpyyy3
      dyydyxpy2=qcy*ddyyyx2 + wqy*ddyyyx3 + 2.0d0*rpdyyx3+      rdpyyx3
      dyydyxpz2=qcz*ddyyyx2 + wqz*ddyyyx3
      dyydzxpx2=qcx*ddyyzx2 + wqx*ddyyzx3                +      rdpyyz3
      dyydzxpy2=qcy*ddyyzx2 + wqy*ddyyzx3 + 2.0d0*rpdyzx3
      dyydzxpz2=qcz*ddyyzx2 + wqz*ddyyzx3                +      rdpyyx3
      dyydzypx2=qcx*ddyyzy2 + wqx*ddyyzy3
      dyydzypy2=qcy*ddyyzy2 + wqy*ddyyzy3 + 2.0d0*rpdyzy3+      rdpyyz3
      dyydzypz2=qcz*ddyyzy2 + wqz*ddyyzy3                +      rdpyyy3
      dzzdxxpx2=qcx*ddzzxx2 + wqx*ddzzxx3                +2.0d0*rdpzzx3
      dzzdxxpy2=qcy*ddzzxx2 + wqy*ddzzxx3 
      dzzdxxpz2=qcz*ddzzxx2 + wqz*ddzzxx3 + 2.0d0*rpdzxx3
      dzzdyypx2=qcx*ddzzyy2 + wqx*ddzzyy3
      dzzdyypy2=qcy*ddzzyy2 + wqy*ddzzyy3                +2.0d0*rdpzzy3
      dzzdyypz2=qcz*ddzzyy2 + wqz*ddzzyy3 + 2.0d0*rpdzyy3
      dzzdzzpx2=qcx*ddzzzz2 + wqx*ddzzzz3
      dzzdzzpy2=qcy*ddzzzz2 + wqy*ddzzzz3
      dzzdzzpz2=qcz*ddzzzz2 + wqz*ddzzzz3 + 2.0d0*rpdzzz3+2.0d0*rdpzzz3
      dzzdyxpx2=qcx*ddzzyx2 + wqx*ddzzyx3                +      rdpzzy3
      dzzdyxpy2=qcy*ddzzyx2 + wqy*ddzzyx3                +      rdpzzx3
      dzzdyxpz2=qcz*ddzzyx2 + wqz*ddzzyx3 + 2.0d0*rpdzyx3
      dzzdzxpx2=qcx*ddzzzx2 + wqx*ddzzzx3                +      rdpzzz3
      dzzdzxpy2=qcy*ddzzzx2 + wqy*ddzzzx3 
      dzzdzxpz2=qcz*ddzzzx2 + wqz*ddzzzx3 + 2.0d0*rpdzzx3+      rdpzzx3
      dzzdzypx2=qcx*ddzzzy2 + wqx*ddzzzy3
      dzzdzypy2=qcy*ddzzzy2 + wqy*ddzzzy3                +      rdpzzz3
      dzzdzypz2=qcz*ddzzzy2 + wqz*ddzzzy3 + 2.0d0*rpdzzy3+      rdpzzy3

      dyxdxxpx2=qcx*ddyxxx2 + wqx*ddyxxx3 +       rpdyxx3+2.0d0*rdpyxx3
      dyxdxxpy2=qcy*ddyxxx2 + wqy*ddyxxx3 +       rpdxxx3
      dyxdxxpz2=qcz*ddyxxx2 + wqz*ddyxxx3
      dyxdyypx2=qcx*ddyxyy2 + wqx*ddyxyy3 +       rpdyyy3
      dyxdyypy2=qcy*ddyxyy2 + wqy*ddyxyy3 +       rpdxyy3+2.0d0*rdpyxy3
      dyxdyypz2=qcz*ddyxyy2 + wqz*ddyxyy3
      dyxdzzpx2=qcx*ddyxzz2 + wqx*ddyxzz3 +       rpdyzz3
      dyxdzzpy2=qcy*ddyxzz2 + wqy*ddyxzz3 +       rpdxzz3
      dyxdzzpz2=qcz*ddyxzz2 + wqz*ddyxzz3                +2.0d0*rdpyxz3
      dyxdyxpx2=qcx*ddyxyx2 + wqx*ddyxyx3 +       rpdyyx3+      rdpyxy3
      dyxdyxpy2=qcy*ddyxyx2 + wqy*ddyxyx3 +       rpdxyx3+      rdpyxx3
      dyxdyxpz2=qcz*ddyxyx2 + wqz*ddyxyx3
      dyxdzxpx2=qcx*ddyxzx2 + wqx*ddyxzx3 +       rpdyzx3+      rdpyxz3
      dyxdzxpy2=qcy*ddyxzx2 + wqy*ddyxzx3 +       rpdxzx3
      dyxdzxpz2=qcz*ddyxzx2 + wqz*ddyxzx3                +      rdpyxx3
      dyxdzypx2=qcx*ddyxzy2 + wqx*ddyxzy3 +       rpdyzy3
      dyxdzypy2=qcy*ddyxzy2 + wqy*ddyxzy3 +       rpdxzy3+      rdpyxz3
      dyxdzypz2=qcz*ddyxzy2 + wqz*ddyxzy3                +      rdpyxy3
      dzxdxxpx2=qcx*ddzxxx2 + wqx*ddzxxx3 +       rpdzxx3+2.0d0*rdpzxx3
      dzxdxxpy2=qcy*ddzxxx2 + wqy*ddzxxx3
      dzxdxxpz2=qcz*ddzxxx2 + wqz*ddzxxx3 +       rpdxxx3
      dzxdyypx2=qcx*ddzxyy2 + wqx*ddzxyy3 +       rpdzyy3
      dzxdyypy2=qcy*ddzxyy2 + wqy*ddzxyy3                +2.0d0*rdpzxy3
      dzxdyypz2=qcz*ddzxyy2 + wqz*ddzxyy3 +       rpdxyy3
      dzxdzzpx2=qcx*ddzxzz2 + wqx*ddzxzz3 +       rpdzzz3
      dzxdzzpy2=qcy*ddzxzz2 + wqy*ddzxzz3
      dzxdzzpz2=qcz*ddzxzz2 + wqz*ddzxzz3 +       rpdxzz3+2.0d0*rdpzxz3
      dzxdyxpx2=qcx*ddzxyx2 + wqx*ddzxyx3 +       rpdzyx3+      rdpzxy3
      dzxdyxpy2=qcy*ddzxyx2 + wqy*ddzxyx3                +      rdpzxx3
      dzxdyxpz2=qcz*ddzxyx2 + wqz*ddzxyx3 +       rpdxyx3
      dzxdzxpx2=qcx*ddzxzx2 + wqx*ddzxzx3 +       rpdzzx3+      rdpzxz3
      dzxdzxpy2=qcy*ddzxzx2 + wqy*ddzxzx3
      dzxdzxpz2=qcz*ddzxzx2 + wqz*ddzxzx3 +       rpdxzx3+      rdpzxx3
      dzxdzypx2=qcx*ddzxzy2 + wqx*ddzxzy3 +       rpdzzy3
      dzxdzypy2=qcy*ddzxzy2 + wqy*ddzxzy3                +      rdpzxz3
      dzxdzypz2=qcz*ddzxzy2 + wqz*ddzxzy3 +       rpdxzy3+      rdpzxy3
      dzydxxpx2=qcx*ddzyxx2 + wqx*ddzyxx3                +2.0d0*rdpzyx3
      dzydxxpy2=qcy*ddzyxx2 + wqy*ddzyxx3 +       rpdzxx3
      dzydxxpz2=qcz*ddzyxx2 + wqz*ddzyxx3 +       rpdyxx3
      dzydyypx2=qcx*ddzyyy2 + wqx*ddzyyy3
      dzydyypy2=qcy*ddzyyy2 + wqy*ddzyyy3 +       rpdzyy3+2.0d0*rdpzyy3
      dzydyypz2=qcz*ddzyyy2 + wqz*ddzyyy3 +       rpdyyy3
      dzydzzpx2=qcx*ddzyzz2 + wqx*ddzyzz3
      dzydzzpy2=qcy*ddzyzz2 + wqy*ddzyzz3 +       rpdzzz3
      dzydzzpz2=qcz*ddzyzz2 + wqz*ddzyzz3 +       rpdyzz3+2.0d0*rdpzyz3
      dzydyxpx2=qcx*ddzyyx2 + wqx*ddzyyx3                +      rdpzyy3
      dzydyxpy2=qcy*ddzyyx2 + wqy*ddzyyx3 +       rpdzyx3+      rdpzyx3
      dzydyxpz2=qcz*ddzyyx2 + wqz*ddzyyx3 +       rpdyyx3
      dzydzxpx2=qcx*ddzyzx2 + wqx*ddzyzx3                +      rdpzyz3
      dzydzxpy2=qcy*ddzyzx2 + wqy*ddzyzx3 +       rpdzzx3
      dzydzxpz2=qcz*ddzyzx2 + wqz*ddzyzx3 +       rpdyzx3+      rdpzyx3
      dzydzypx2=qcx*ddzyzy2 + wqx*ddzyzy3
      dzydzypy2=qcy*ddzyzy2 + wqy*ddzyzy3 +       rpdzzy3+      rdpzyz3
      dzydzypz2=qcz*ddzyzy2 + wqz*ddzyzy3 +       rpdyzy3+      rdpzyy3

      dxxdxxpx3=qcx*ddxxxx3 + wqx*ddxxxx4 + 2.0d0*rpdxxx4+2.0d0*rdpxxx4
      dxxdxxpy3=qcy*ddxxxx3 + wqy*ddxxxx4
      dxxdxxpz3=qcz*ddxxxx3 + wqz*ddxxxx4
      dxxdyypx3=qcx*ddxxyy3 + wqx*ddxxyy4 + 2.0d0*rpdxyy4
      dxxdyypy3=qcy*ddxxyy3 + wqy*ddxxyy4                +2.0d0*rdpxxy4
      dxxdyypz3=qcz*ddxxyy3 + wqz*ddxxyy4
      dxxdzzpx3=qcx*ddxxzz3 + wqx*ddxxzz4 + 2.0d0*rpdxzz4
      dxxdzzpy3=qcy*ddxxzz3 + wqy*ddxxzz4
      dxxdzzpz3=qcz*ddxxzz3 + wqz*ddxxzz4                +2.0d0*rdpxxz4
      dxxdyxpx3=qcx*ddxxyx3 + wqx*ddxxyx4 + 2.0d0*rpdxyx4+      rdpxxy4
      dxxdyxpy3=qcy*ddxxyx3 + wqy*ddxxyx4                +      rdpxxx4
      dxxdyxpz3=qcz*ddxxyx3 + wqz*ddxxyx4 
      dxxdzxpx3=qcx*ddxxzx3 + wqx*ddxxzx4 + 2.0d0*rpdxzx4+      rdpxxz4
      dxxdzxpy3=qcy*ddxxzx3 + wqy*ddxxzx4
      dxxdzxpz3=qcz*ddxxzx3 + wqz*ddxxzx4                +      rdpxxx4
      dxxdzypx3=qcx*ddxxzy3 + wqx*ddxxzy4 + 2.0d0*rpdxzy4
      dxxdzypy3=qcy*ddxxzy3 + wqy*ddxxzy4                +      rdpxxz4
      dxxdzypz3=qcz*ddxxzy3 + wqz*ddxxzy4                +      rdpxxy4
      dyydxxpx3=qcx*ddyyxx3 + wqx*ddyyxx4                +2.0d0*rdpyyx4
      dyydxxpy3=qcy*ddyyxx3 + wqy*ddyyxx4 + 2.0d0*rpdyxx4
      dyydxxpz3=qcz*ddyyxx3 + wqz*ddyyxx4
      dyydyypx3=qcx*ddyyyy3 + wqx*ddyyyy4
      dyydyypy3=qcy*ddyyyy3 + wqy*ddyyyy4 + 2.0d0*rpdyyy4+2.0d0*rdpyyy4
      dyydyypz3=qcz*ddyyyy3 + wqz*ddyyyy4
      dyydzzpx3=qcx*ddyyzz3 + wqx*ddyyzz4
      dyydzzpy3=qcy*ddyyzz3 + wqy*ddyyzz4 + 2.0d0*rpdyzz4
      dyydzzpz3=qcz*ddyyzz3 + wqz*ddyyzz4                +2.0d0*rdpyyz4
      dyydyxpx3=qcx*ddyyyx3 + wqx*ddyyyx4                +      rdpyyy4
      dyydyxpy3=qcy*ddyyyx3 + wqy*ddyyyx4 + 2.0d0*rpdyyx4+      rdpyyx4
      dyydyxpz3=qcz*ddyyyx3 + wqz*ddyyyx4
      dyydzxpx3=qcx*ddyyzx3 + wqx*ddyyzx4                +      rdpyyz4
      dyydzxpy3=qcy*ddyyzx3 + wqy*ddyyzx4 + 2.0d0*rpdyzx4
      dyydzxpz3=qcz*ddyyzx3 + wqz*ddyyzx4                +      rdpyyx4
      dyydzypx3=qcx*ddyyzy3 + wqx*ddyyzy4
      dyydzypy3=qcy*ddyyzy3 + wqy*ddyyzy4 + 2.0d0*rpdyzy4+      rdpyyz4
      dyydzypz3=qcz*ddyyzy3 + wqz*ddyyzy4                +      rdpyyy4
      dzzdxxpx3=qcx*ddzzxx3 + wqx*ddzzxx4                +2.0d0*rdpzzx4
      dzzdxxpy3=qcy*ddzzxx3 + wqy*ddzzxx4 
      dzzdxxpz3=qcz*ddzzxx3 + wqz*ddzzxx4 + 2.0d0*rpdzxx4
      dzzdyypx3=qcx*ddzzyy3 + wqx*ddzzyy4
      dzzdyypy3=qcy*ddzzyy3 + wqy*ddzzyy4                +2.0d0*rdpzzy4
      dzzdyypz3=qcz*ddzzyy3 + wqz*ddzzyy4 + 2.0d0*rpdzyy4
      dzzdzzpx3=qcx*ddzzzz3 + wqx*ddzzzz4
      dzzdzzpy3=qcy*ddzzzz3 + wqy*ddzzzz4
      dzzdzzpz3=qcz*ddzzzz3 + wqz*ddzzzz4 + 2.0d0*rpdzzz4+2.0d0*rdpzzz4
      dzzdyxpx3=qcx*ddzzyx3 + wqx*ddzzyx4                +      rdpzzy4
      dzzdyxpy3=qcy*ddzzyx3 + wqy*ddzzyx4                +      rdpzzx4
      dzzdyxpz3=qcz*ddzzyx3 + wqz*ddzzyx4 + 2.0d0*rpdzyx4
      dzzdzxpx3=qcx*ddzzzx3 + wqx*ddzzzx4                +      rdpzzz4
      dzzdzxpy3=qcy*ddzzzx3 + wqy*ddzzzx4 
      dzzdzxpz3=qcz*ddzzzx3 + wqz*ddzzzx4 + 2.0d0*rpdzzx4+      rdpzzx4
      dzzdzypx3=qcx*ddzzzy3 + wqx*ddzzzy4
      dzzdzypy3=qcy*ddzzzy3 + wqy*ddzzzy4                +      rdpzzz4
      dzzdzypz3=qcz*ddzzzy3 + wqz*ddzzzy4 + 2.0d0*rpdzzy4+      rdpzzy4

      dyxdxxpx3=qcx*ddyxxx3 + wqx*ddyxxx4 +       rpdyxx4+2.0d0*rdpyxx4
      dyxdxxpy3=qcy*ddyxxx3 + wqy*ddyxxx4 +       rpdxxx4
      dyxdxxpz3=qcz*ddyxxx3 + wqz*ddyxxx4
      dyxdyypx3=qcx*ddyxyy3 + wqx*ddyxyy4 +       rpdyyy4
      dyxdyypy3=qcy*ddyxyy3 + wqy*ddyxyy4 +       rpdxyy4+2.0d0*rdpyxy4
      dyxdyypz3=qcz*ddyxyy3 + wqz*ddyxyy4
      dyxdzzpx3=qcx*ddyxzz3 + wqx*ddyxzz4 +       rpdyzz4
      dyxdzzpy3=qcy*ddyxzz3 + wqy*ddyxzz4 +       rpdxzz4
      dyxdzzpz3=qcz*ddyxzz3 + wqz*ddyxzz4                +2.0d0*rdpyxz4
      dyxdyxpx3=qcx*ddyxyx3 + wqx*ddyxyx4 +       rpdyyx4+      rdpyxy4
      dyxdyxpy3=qcy*ddyxyx3 + wqy*ddyxyx4 +       rpdxyx4+      rdpyxx4
      dyxdyxpz3=qcz*ddyxyx3 + wqz*ddyxyx4
      dyxdzxpx3=qcx*ddyxzx3 + wqx*ddyxzx4 +       rpdyzx4+      rdpyxz4
      dyxdzxpy3=qcy*ddyxzx3 + wqy*ddyxzx4 +       rpdxzx4
      dyxdzxpz3=qcz*ddyxzx3 + wqz*ddyxzx4                +      rdpyxx4
      dyxdzypx3=qcx*ddyxzy3 + wqx*ddyxzy4 +       rpdyzy4
      dyxdzypy3=qcy*ddyxzy3 + wqy*ddyxzy4 +       rpdxzy4+      rdpyxz4
      dyxdzypz3=qcz*ddyxzy3 + wqz*ddyxzy4                +      rdpyxy4
      dzxdxxpx3=qcx*ddzxxx3 + wqx*ddzxxx4 +       rpdzxx4+2.0d0*rdpzxx4
      dzxdxxpy3=qcy*ddzxxx3 + wqy*ddzxxx4
      dzxdxxpz3=qcz*ddzxxx3 + wqz*ddzxxx4 +       rpdxxx4
      dzxdyypx3=qcx*ddzxyy3 + wqx*ddzxyy4 +       rpdzyy4
      dzxdyypy3=qcy*ddzxyy3 + wqy*ddzxyy4                +2.0d0*rdpzxy4
      dzxdyypz3=qcz*ddzxyy3 + wqz*ddzxyy4 +       rpdxyy4
      dzxdzzpx3=qcx*ddzxzz3 + wqx*ddzxzz4 +       rpdzzz4
      dzxdzzpy3=qcy*ddzxzz3 + wqy*ddzxzz4
      dzxdzzpz3=qcz*ddzxzz3 + wqz*ddzxzz4 +       rpdxzz4+2.0d0*rdpzxz4
      dzxdyxpx3=qcx*ddzxyx3 + wqx*ddzxyx4 +       rpdzyx4+      rdpzxy4
      dzxdyxpy3=qcy*ddzxyx3 + wqy*ddzxyx4                +      rdpzxx4
      dzxdyxpz3=qcz*ddzxyx3 + wqz*ddzxyx4 +       rpdxyx4
      dzxdzxpx3=qcx*ddzxzx3 + wqx*ddzxzx4 +       rpdzzx4+      rdpzxz4
      dzxdzxpy3=qcy*ddzxzx3 + wqy*ddzxzx4
      dzxdzxpz3=qcz*ddzxzx3 + wqz*ddzxzx4 +       rpdxzx4+      rdpzxx4
      dzxdzypx3=qcx*ddzxzy3 + wqx*ddzxzy4 +       rpdzzy4
      dzxdzypy3=qcy*ddzxzy3 + wqy*ddzxzy4                +      rdpzxz4
      dzxdzypz3=qcz*ddzxzy3 + wqz*ddzxzy4 +       rpdxzy4+      rdpzxy4
      dzydxxpx3=qcx*ddzyxx3 + wqx*ddzyxx4                +2.0d0*rdpzyx4
      dzydxxpy3=qcy*ddzyxx3 + wqy*ddzyxx4 +       rpdzxx4
      dzydxxpz3=qcz*ddzyxx3 + wqz*ddzyxx4 +       rpdyxx4
      dzydyypx3=qcx*ddzyyy3 + wqx*ddzyyy4
      dzydyypy3=qcy*ddzyyy3 + wqy*ddzyyy4 +       rpdzyy4+2.0d0*rdpzyy4
      dzydyypz3=qcz*ddzyyy3 + wqz*ddzyyy4 +       rpdyyy4
      dzydzzpx3=qcx*ddzyzz3 + wqx*ddzyzz4
      dzydzzpy3=qcy*ddzyzz3 + wqy*ddzyzz4 +       rpdzzz4
      dzydzzpz3=qcz*ddzyzz3 + wqz*ddzyzz4 +       rpdyzz4+2.0d0*rdpzyz4
      dzydyxpx3=qcx*ddzyyx3 + wqx*ddzyyx4                +      rdpzyy4
      dzydyxpy3=qcy*ddzyyx3 + wqy*ddzyyx4 +       rpdzyx4+      rdpzyx4
      dzydyxpz3=qcz*ddzyyx3 + wqz*ddzyyx4 +       rpdyyx4
      dzydzxpx3=qcx*ddzyzx3 + wqx*ddzyzx4                +      rdpzyz4
      dzydzxpy3=qcy*ddzyzx3 + wqy*ddzyzx4 +       rpdzzx4
      dzydzxpz3=qcz*ddzyzx3 + wqz*ddzyzx4 +       rpdyzx4+      rdpzyx4
      dzydzypx3=qcx*ddzyzy3 + wqx*ddzyzy4
      dzydzypy3=qcy*ddzyzy3 + wqy*ddzyzy4 +       rpdzzy4+      rdpzyz4
      dzydzypz3=qcz*ddzyzy3 + wqz*ddzyzy4 +       rpdyzy4+      rdpzyy4

!dpss01(12-23)
      dpxxx12=  eta*(dpxxx1 -rooe*dpxxx2)
      dpxxy12=  eta*(dpxxy1 -rooe*dpxxy2)
      dpxxz12=  eta*(dpxxz1 -rooe*dpxxz2)
      dpyyx12=  eta*(dpyyx1 -rooe*dpyyx2)
      dpyyy12=  eta*(dpyyy1 -rooe*dpyyy2)
      dpyyz12=  eta*(dpyyz1 -rooe*dpyyz2)
      dpzzx12=  eta*(dpzzx1 -rooe*dpzzx2)
      dpzzy12=  eta*(dpzzy1 -rooe*dpzzy2)
      dpzzz12=  eta*(dpzzz1 -rooe*dpzzz2)
      dpyxx12=  eta*(dpyxx1 -rooe*dpyxx2)
      dpyxy12=  eta*(dpyxy1 -rooe*dpyxy2)
      dpyxz12=  eta*(dpyxz1 -rooe*dpyxz2)
      dpzxx12=  eta*(dpzxx1 -rooe*dpzxx2)
      dpzxy12=  eta*(dpzxy1 -rooe*dpzxy2)
      dpzxz12=  eta*(dpzxz1 -rooe*dpzxz2)
      dpzyx12=  eta*(dpzyx1 -rooe*dpzyx2)
      dpzyy12=  eta*(dpzyy1 -rooe*dpzyy2)
      dpzyz12=  eta*(dpzyz1 -rooe*dpzyz2)
      dpxxx23=  eta*(dpxxx2 -rooe*dpxxx3)
      dpxxy23=  eta*(dpxxy2 -rooe*dpxxy3)
      dpxxz23=  eta*(dpxxz2 -rooe*dpxxz3)
      dpyyx23=  eta*(dpyyx2 -rooe*dpyyx3)
      dpyyy23=  eta*(dpyyy2 -rooe*dpyyy3)
      dpyyz23=  eta*(dpyyz2 -rooe*dpyyz3)
      dpzzx23=  eta*(dpzzx2 -rooe*dpzzx3)
      dpzzy23=  eta*(dpzzy2 -rooe*dpzzy3)
      dpzzz23=  eta*(dpzzz2 -rooe*dpzzz3)
      dpyxx23=  eta*(dpyxx2 -rooe*dpyxx3)
      dpyxy23=  eta*(dpyxy2 -rooe*dpyxy3)
      dpyxz23=  eta*(dpyxz2 -rooe*dpyxz3)
      dpzxx23=  eta*(dpzxx2 -rooe*dpzxx3)
      dpzxy23=  eta*(dpzxy2 -rooe*dpzxy3)
      dpzxz23=  eta*(dpzxz2 -rooe*dpzxz3)
      dpzyx23=  eta*(dpzyx2 -rooe*dpzyx3)
      dpzyy23=  eta*(dpzyy2 -rooe*dpzyy3)
      dpzyz23=  eta*(dpzyz2 -rooe*dpzyz3)
!rdsps (2-3)
      rdxxpx2 =  rkp*dxxpx2
      rdxxpy2 =  rkp*dxxpy2
      rdxxpz2 =  rkp*dxxpz2
      rdyypx2 =  rkp*dyypx2
      rdyypy2 =  rkp*dyypy2
      rdyypz2 =  rkp*dyypz2
      rdzzpx2 =  rkp*dzzpx2
      rdzzpy2 =  rkp*dzzpy2
      rdzzpz2 =  rkp*dzzpz2
      rdyxpx2 =  rkp*dyxpx2
      rdyxpy2 =  rkp*dyxpy2
      rdyxpz2 =  rkp*dyxpz2
      rdzxpx2 =  rkp*dzxpx2
      rdzxpy2 =  rkp*dzxpy2
      rdzxpz2 =  rkp*dzxpz2
      rdzypx2 =  rkp*dzypx2
      rdzypy2 =  rkp*dzypy2
      rdzypz2 =  rkp*dzypz2
      rdxxpx3 =  rkp*dxxpx3
      rdxxpy3 =  rkp*dxxpy3
      rdxxpz3 =  rkp*dxxpz3
      rdyypx3 =  rkp*dyypx3
      rdyypy3 =  rkp*dyypy3
      rdyypz3 =  rkp*dyypz3
      rdzzpx3 =  rkp*dzzpx3
      rdzzpy3 =  rkp*dzzpy3
      rdzzpz3 =  rkp*dzzpz3
      rdyxpx3 =  rkp*dyxpx3
      rdyxpy3 =  rkp*dyxpy3
      rdyxpz3 =  rkp*dyxpz3
      rdzxpx3 =  rkp*dzxpx3
      rdzxpy3 =  rkp*dzxpy3
      rdzxpz3 =  rkp*dzxpz3
      rdzypx3 =  rkp*dzypx3
      rdzypy3 =  rkp*dzypy3
      rdzypz3 =  rkp*dzypz3
!rppps(2-3)
      rpppxxx2 = rkp*pppxxx2
      rpppxxy2 = rkp*pppxxy2
      rpppxxz2 = rkp*pppxxz2
      rpppxyx2 = rkp*pppxyx2
      rpppxyy2 = rkp*pppxyy2
      rpppxyz2 = rkp*pppxyz2
      rpppxzx2 = rkp*pppxzx2
      rpppxzy2 = rkp*pppxzy2
      rpppxzz2 = rkp*pppxzz2
      rpppyxx2 = rkp*pppyxx2
      rpppyxy2 = rkp*pppyxy2
      rpppyxz2 = rkp*pppyxz2
      rpppyyx2 = rkp*pppyyx2
      rpppyyy2 = rkp*pppyyy2
      rpppyyz2 = rkp*pppyyz2
      rpppyzx2 = rkp*pppyzx2
      rpppyzy2 = rkp*pppyzy2
      rpppyzz2 = rkp*pppyzz2
      rpppzxx2 = rkp*pppzxx2
      rpppzxy2 = rkp*pppzxy2
      rpppzxz2 = rkp*pppzxz2
      rpppzyx2 = rkp*pppzyx2
      rpppzyy2 = rkp*pppzyy2
      rpppzyz2 = rkp*pppzyz2
      rpppzzx2 = rkp*pppzzx2
      rpppzzy2 = rkp*pppzzy2
      rpppzzz2 = rkp*pppzzz2

      rpppxxx3 = rkp*pppxxx3
      rpppxxy3 = rkp*pppxxy3
      rpppxxz3 = rkp*pppxxz3
      rpppxyx3 = rkp*pppxyx3
      rpppxyy3 = rkp*pppxyy3
      rpppxyz3 = rkp*pppxyz3
      rpppxzx3 = rkp*pppxzx3
      rpppxzy3 = rkp*pppxzy3
      rpppxzz3 = rkp*pppxzz3
      rpppyxx3 = rkp*pppyxx3
      rpppyxy3 = rkp*pppyxy3
      rpppyxz3 = rkp*pppyxz3
      rpppyyx3 = rkp*pppyyx3
      rpppyyy3 = rkp*pppyyy3
      rpppyyz3 = rkp*pppyyz3
      rpppyzx3 = rkp*pppyzx3
      rpppyzy3 = rkp*pppyzy3
      rpppyzz3 = rkp*pppyzz3
      rpppzxx3 = rkp*pppzxx3
      rpppzxy3 = rkp*pppzxy3
      rpppzxz3 = rkp*pppzxz3
      rpppzyx3 = rkp*pppzyx3
      rpppzyy3 = rkp*pppzyy3
      rpppzyz3 = rkp*pppzyz3
      rpppzzx3 = rkp*pppzzx3
      rpppzzy3 = rkp*pppzzy3
      rpppzzz3 = rkp*pppzzz3

!dpds(1-2)
      axa1= qcx*axx1+wqx*axx2+2.d0*rpppxxx2+rdxxpx2+dpxxx12
      axb1= qcy*axy1+wqy*axy2                      +dpxxx12
      axc1= qcz*axz1+wqz*axz2                      +dpxxx12
      axd1= qcy*axx1+wqy*axx2                              
      axe1= qcz*axx1+wqz*axx2                              
      axf1= qcy*axz1+wqy*axz2                              
      aya1= qcx*ayx1+wqx*ayx2+2.d0*rpppxyx2        +dpxxy12
      ayb1= qcy*ayy1+wqy*ayy2              +rdxxpy2+dpxxy12
      ayc1= qcz*ayz1+wqz*ayz2                      +dpxxy12
      ayd1= qcy*ayx1+wqy*ayx2              +rdxxpx2        
      aye1= qcz*ayx1+wqz*ayx2                              
      ayf1= qcz*ayy1+wqz*ayy2                              
      aza1= qcx*azx1+wqx*azx2+2.d0*rpppxzx2        +dpxxz12
      azb1= qcy*azy1+wqy*azy2                      +dpxxz12
      azc1= qcz*azz1+wqz*azz2              +rdxxpz2+dpxxz12
      azd1= qcy*azx1+wqy*azx2                              
      aze1= qcz*azx1+wqz*azx2              +rdxxpx2        
      azf1= qcy*azz1+wqy*azz2
      bxa1= qcx*bxx1+wqx*bxx2              +rdyypx2+dpyyx12
      bxb1= qcy*bxy1+wqy*bxy2+2.d0*rpppyxy2        +dpyyx12
      bxc1= qcz*bxz1+wqz*bxz2                      +dpyyx12
      bxd1= qcx*bxy1+wqx*bxy2              +rdyypy2        
      bxe1= qcx*bxz1+wqx*bxz2              +rdyypz2        
      bxf1= qcz*bxy1+wqz*bxy2                              
      bya1= qcx*byx1+wqx*byx2                      +dpyyy12
      byb1= qcy*byy1+wqy*byy2+2.d0*rpppyyy2+rdyypy2+dpyyy12
      byc1= qcz*byz1+wqz*byz2                      +dpyyy12
      byd1= qcx*byy1+wqx*byy2                              
      bye1= qcx*byz1+wqx*byz2                              
      byf1= qcz*byy1+wqz*byy2                              
      bza1= qcx*bzx1+wqx*bzx2                      +dpyyz12
      bzb1= qcy*bzy1+wqy*bzy2+2.d0*rpppyzy2        +dpyyz12
      bzc1= qcz*bzz1+wqz*bzz2              +rdyypz2+dpyyz12
      bzd1= qcx*bzy1+wqx*bzy2                              
      bze1= qcx*bzz1+wqx*bzz2                              
      bzf1= qcz*bzy1+wqz*bzy2              +rdyypy2        
      cxa1= qcx*cxx1+wqx*cxx2              +rdzzpx2+dpzzx12
      cxb1= qcy*cxy1+wqy*cxy2                      +dpzzx12
      cxc1= qcz*cxz1+wqz*cxz2+2.d0*rpppzxz2        +dpzzx12
      cxd1= qcy*cxx1+wqy*cxx2                              
      cxe1= qcx*cxz1+wqx*cxz2              +rdzzpz2        
      cxf1= qcy*cxz1+wqy*cxz2                              
      cya1= qcx*cyx1+wqx*cyx2                      +dpzzy12
      cyb1= qcy*cyy1+wqy*cyy2              +rdzzpy2+dpzzy12
      cyc1= qcz*cyz1+wqz*cyz2+2.d0*rpppzyz2        +dpzzy12
      cyd1= qcx*cyy1+wqx*cyy2                              
      cye1= qcx*cyz1+wqx*cyz2                              
      cyf1= qcy*cyz1+wqy*cyz2              +rdzzpz2        
      cza1= qcx*czx1+wqx*czx2                      +dpzzz12
      czb1= qcy*czy1+wqy*czy2                      +dpzzz12
      czc1= qcz*czz1+wqz*czz2+2.d0*rpppzzz2+rdzzpz2+dpzzz12
      czd1= qcx*czy1+wqx*czy2                              
      cze1= qcx*czz1+wqx*czz2                              
      czf1= qcy*czz1+wqy*czz2                              
      dxa1= qcx*dxx1+wqx*dxx2+1.d0*rpppyxx2+rdyxpx2+dpyxx12
      dxb1= qcy*dxy1+wqy*dxy2+1.d0*rpppxxy2        +dpyxx12
      dxc1= qcz*dxz1+wqz*dxz2                      +dpyxx12
      dxd1= qcx*dxy1+wqx*dxy2+1.d0*rpppyxy2+rdyxpy2        
      dxe1= qcx*dxz1+wqx*dxz2+1.d0*rpppyxz2+rdyxpz2        
      dxf1= qcz*dxy1+wqz*dxy2                              
      dya1= qcx*dyx1+wqx*dyx2+1.d0*rpppyyx2        +dpyxy12
      dyb1= qcy*dyy1+wqy*dyy2+1.d0*rpppxyy2+rdyxpy2+dpyxy12
      dyc1= qcz*dyz1+wqz*dyz2                      +dpyxy12
      dyd1= qcx*dyy1+wqx*dyy2+1.d0*rpppyyy2                
      dye1= qcz*dyx1+wqz*dyx2                              
      dyf1= qcz*dyy1+wqz*dyy2                              
      dza1= qcx*dzx1+wqx*dzx2+1.d0*rpppyzx2        +dpyxz12
      dzb1= qcy*dzy1+wqy*dzy2+1.d0*rpppxzy2        +dpyxz12
      dzc1= qcz*dzz1+wqz*dzz2              +rdyxpz2+dpyxz12
      dzd1= qcx*dzy1+wqx*dzy2+1.d0*rpppyzy2               
      dze1= qcx*dzz1+wqx*dzz2+1.d0*rpppyzz2                
      dzf1= qcy*dzz1+wqy*dzz2+1.d0*rpppxzz2                
      exa1= qcx*exx1+wqx*exx2+1.d0*rpppzxx2+rdzxpx2+dpzxx12
      exb1= qcy*exy1+wqy*exy2                      +dpzxx12
      exc1= qcz*exz1+wqz*exz2+1.d0*rpppxxz2        +dpzxx12
      exd1= qcy*exx1+wqy*exx2                              
      exe1= qcz*exx1+wqz*exx2+1.d0*rpppxxx2                
      exf1= qcy*exz1+wqy*exz2                              
      eya1= qcx*eyx1+wqx*eyx2+1.d0*rpppzyx2        +dpzxy12
      eyb1= qcy*eyy1+wqy*eyy2              +rdzxpy2+dpzxy12
      eyc1= qcz*eyz1+wqz*eyz2+1.d0*rpppxyz2        +dpzxy12
      eyd1= qcx*eyy1+wqx*eyy2+1.d0*rpppzyy2                
      eye1= qcz*eyx1+wqz*eyx2+1.d0*rpppxyx2                
      eyf1= qcz*eyy1+wqz*eyy2+1.d0*rpppxyy2                
      eza1= qcx*ezx1+wqx*ezx2+1.d0*rpppzzx2        +dpzxz12
      ezb1= qcy*ezy1+wqy*ezy2                      +dpzxz12
      ezc1= qcz*ezz1+wqz*ezz2+1.d0*rpppxzz2+rdzxpz2+dpzxz12
      ezd1= qcy*ezx1+wqy*ezx2
      eze1= qcx*ezz1+wqx*ezz2+1.d0*rpppzzz2                
      ezf1= qcy*ezz1+wqy*ezz2                              
      fxa1= qcx*fxx1+wqx*fxx2              +rdzypx2+dpzyx12
      fxb1= qcy*fxy1+wqy*fxy2+1.d0*rpppzxy2        +dpzyx12
      fxc1= qcz*fxz1+wqz*fxz2+1.d0*rpppyxz2        +dpzyx12
      fxd1= qcy*fxx1+wqy*fxx2+1.d0*rpppzxx2                
      fxe1= qcz*fxx1+wqz*fxx2+1.d0*rpppyxx2                
      fxf1= qcz*fxy1+wqz*fxy2+1.d0*rpppyxy2                
      fya1= qcx*fyx1+wqx*fyx2                      +dpzyy12
      fyb1= qcy*fyy1+wqy*fyy2+1.d0*rpppzyy2+rdzypy2+dpzyy12
      fyc1= qcz*fyz1+wqz*fyz2+1.d0*rpppyyz2        +dpzyy12
      fyd1= qcx*fyy1+wqx*fyy2                              
      fye1= qcx*fyz1+wqx*fyz2                              
      fyf1= qcz*fyy1+wqz*fyy2+1.d0*rpppyyy2                
      fza1= qcx*fzx1+wqx*fzx2                      +dpzyz12
      fzb1= qcy*fzy1+wqy*fzy2+1.d0*rpppzzy2        +dpzyz12
      fzc1= qcz*fzz1+wqz*fzz2+1.d0*rpppyzz2+rdzypz2+dpzyz12
      fzd1= qcx*fzy1+wqx*fzy2                      
      fze1= qcx*fzz1+wqx*fzz2                      
      fzf1= qcy*fzz1+wqy*fzz2+1.d0*rpppzzz2        

      axa2= qcx*axx2+wqx*axx3+2.d0*rpppxxx3+rdxxpx3+dpxxx23
      axb2= qcy*axy2+wqy*axy3                      +dpxxx23
      axc2= qcz*axz2+wqz*axz3                      +dpxxx23
      axd2= qcy*axx2+wqy*axx3                              
      axe2= qcz*axx2+wqz*axx3                              
      axf2= qcy*axz2+wqy*axz3                              
      aya2= qcx*ayx2+wqx*ayx3+2.d0*rpppxyx3        +dpxxy23
      ayb2= qcy*ayy2+wqy*ayy3              +rdxxpy3+dpxxy23
      ayc2= qcz*ayz2+wqz*ayz3                      +dpxxy23
      ayd2= qcy*ayx2+wqy*ayx3              +rdxxpx3        
      aye2= qcz*ayx2+wqz*ayx3                              
      ayf2= qcz*ayy2+wqz*ayy3                              
      aza2= qcx*azx2+wqx*azx3+2.d0*rpppxzx3        +dpxxz23
      azb2= qcy*azy2+wqy*azy3                      +dpxxz23
      azc2= qcz*azz2+wqz*azz3              +rdxxpz3+dpxxz23
      azd2= qcy*azx2+wqy*azx3                              
      aze2= qcz*azx2+wqz*azx3              +rdxxpx3        
      azf2= qcy*azz2+wqy*azz3
      bxa2= qcx*bxx2+wqx*bxx3              +rdyypx3+dpyyx23
      bxb2= qcy*bxy2+wqy*bxy3+2.d0*rpppyxy3        +dpyyx23
      bxc2= qcz*bxz2+wqz*bxz3                      +dpyyx23
      bxd2= qcx*bxy2+wqx*bxy3              +rdyypy3        
      bxe2= qcx*bxz2+wqx*bxz3              +rdyypz3        
      bxf2= qcz*bxy2+wqz*bxy3                              
      bya2= qcx*byx2+wqx*byx3                      +dpyyy23
      byb2= qcy*byy2+wqy*byy3+2.d0*rpppyyy3+rdyypy3+dpyyy23
      byc2= qcz*byz2+wqz*byz3                      +dpyyy23
      byd2= qcx*byy2+wqx*byy3                             
      bye2= qcx*byz2+wqx*byz3                             
      byf2= qcz*byy2+wqz*byy3                             
      bza2= qcx*bzx2+wqx*bzx3                      +dpyyz23
      bzb2= qcy*bzy2+wqy*bzy3+2.d0*rpppyzy3        +dpyyz23
      bzc2= qcz*bzz2+wqz*bzz3              +rdyypz3+dpyyz23
      bzd2= qcx*bzy2+wqx*bzy3                              
      bze2= qcx*bzz2+wqx*bzz3                              
      bzf2= qcz*bzy2+wqz*bzy3              +rdyypy3        
      cxa2= qcx*cxx2+wqx*cxx3              +rdzzpx3+dpzzx23
      cxb2= qcy*cxy2+wqy*cxy3                      +dpzzx23
      cxc2= qcz*cxz2+wqz*cxz3+2.d0*rpppzxz3        +dpzzx23
      cxd2= qcy*cxx2+wqy*cxx3                              
      cxe2= qcx*cxz2+wqx*cxz3              +rdzzpz3        
      cxf2= qcy*cxz2+wqy*cxz3                              
      cya2= qcx*cyx2+wqx*cyx3                      +dpzzy23
      cyb2= qcy*cyy2+wqy*cyy3              +rdzzpy3+dpzzy23
      cyc2= qcz*cyz2+wqz*cyz3+2.d0*rpppzyz3        +dpzzy23
      cyd2= qcx*cyy2+wqx*cyy3                              
      cye2= qcx*cyz2+wqx*cyz3                              
      cyf2= qcy*cyz2+wqy*cyz3              +rdzzpz3        
      cza2= qcx*czx2+wqx*czx3                      +dpzzz23
      czb2= qcy*czy2+wqy*czy3                      +dpzzz23
      czc2= qcz*czz2+wqz*czz3+2.d0*rpppzzz3+rdzzpz3+dpzzz23
      czd2= qcx*czy2+wqx*czy3                              
      cze2= qcx*czz2+wqx*czz3                              
      czf2= qcy*czz2+wqy*czz3                              
      dxa2= qcx*dxx2+wqx*dxx3+1.d0*rpppyxx3+rdyxpx3+dpyxx23
      dxb2= qcy*dxy2+wqy*dxy3+1.d0*rpppxxy3        +dpyxx23
      dxc2= qcz*dxz2+wqz*dxz3                      +dpyxx23
      dxd2= qcx*dxy2+wqx*dxy3+1.d0*rpppyxy3+rdyxpy3        
      dxe2= qcx*dxz2+wqx*dxz3+1.d0*rpppyxz3+rdyxpz3        
      dxf2= qcz*dxy2+wqz*dxy3                              
      dya2= qcx*dyx2+wqx*dyx3+1.d0*rpppyyx3        +dpyxy23
      dyb2= qcy*dyy2+wqy*dyy3+1.d0*rpppxyy3+rdyxpy3+dpyxy23
      dyc2= qcz*dyz2+wqz*dyz3                      +dpyxy23
      dyd2= qcx*dyy2+wqx*dyy3+1.d0*rpppyyy3                
      dye2= qcz*dyx2+wqz*dyx3                              
      dyf2= qcz*dyy2+wqz*dyy3                              
      dza2= qcx*dzx2+wqx*dzx3+1.d0*rpppyzx3        +dpyxz23
      dzb2= qcy*dzy2+wqy*dzy3+1.d0*rpppxzy3        +dpyxz23
      dzc2= qcz*dzz2+wqz*dzz3              +rdyxpz3+dpyxz23
      dzd2= qcx*dzy2+wqx*dzy3+1.d0*rpppyzy3               
      dze2= qcx*dzz2+wqx*dzz3+1.d0*rpppyzz3                
      dzf2= qcy*dzz2+wqy*dzz3+1.d0*rpppxzz3                
      exa2= qcx*exx2+wqx*exx3+1.d0*rpppzxx3+rdzxpx3+dpzxx23
      exb2= qcy*exy2+wqy*exy3                      +dpzxx23
      exc2= qcz*exz2+wqz*exz3+1.d0*rpppxxz3        +dpzxx23
      exd2= qcy*exx2+wqy*exx3                              
      exe2= qcz*exx2+wqz*exx3+1.d0*rpppxxx3
      exf2= qcy*exz2+wqy*exz3                              
      eya2= qcx*eyx2+wqx*eyx3+1.d0*rpppzyx3        +dpzxy23
      eyb2= qcy*eyy2+wqy*eyy3              +rdzxpy3+dpzxy23
      eyc2= qcz*eyz2+wqz*eyz3+1.d0*rpppxyz3        +dpzxy23
      eyd2= qcx*eyy2+wqx*eyy3+1.d0*rpppzyy3                
      eye2= qcz*eyx2+wqz*eyx3+1.d0*rpppxyx3                
      eyf2= qcz*eyy2+wqz*eyy3+1.d0*rpppxyy3                
      eza2= qcx*ezx2+wqx*ezx3+1.d0*rpppzzx3        +dpzxz23
      ezb2= qcy*ezy2+wqy*ezy3                      +dpzxz23
      ezc2= qcz*ezz2+wqz*ezz3+1.d0*rpppxzz3+rdzxpz3+dpzxz23
      ezd2= qcy*ezx2+wqy*ezx3
      eze2= qcx*ezz2+wqx*ezz3+1.d0*rpppzzz3                
      ezf2= qcy*ezz2+wqy*ezz3                              
      fxa2= qcx*fxx2+wqx*fxx3              +rdzypx3+dpzyx23
      fxb2= qcy*fxy2+wqy*fxy3+1.d0*rpppzxy3        +dpzyx23
      fxc2= qcz*fxz2+wqz*fxz3+1.d0*rpppyxz3        +dpzyx23
      fxd2= qcy*fxx2+wqy*fxx3+1.d0*rpppzxx3                
      fxe2= qcz*fxx2+wqz*fxx3+1.d0*rpppyxx3                
      fxf2= qcz*fxy2+wqz*fxy3+1.d0*rpppyxy3                
      fya2= qcx*fyx2+wqx*fyx3                      +dpzyy23
      fyb2= qcy*fyy2+wqy*fyy3+1.d0*rpppzyy3+rdzypy3+dpzyy23
      fyc2= qcz*fyz2+wqz*fyz3+1.d0*rpppyyz3        +dpzyy23
      fyd2= qcx*fyy2+wqx*fyy3                              
      fye2= qcx*fyz2+wqx*fyz3                              
      fyf2= qcz*fyy2+wqz*fyy3+1.d0*rpppyyy3                
      fza2= qcx*fzx2+wqx*fzx3                      +dpzyz23
      fzb2= qcy*fzy2+wqy*fzy3+1.d0*rpppzzy3        +dpzyz23
      fzc2= qcz*fzz2+wqz*fzz3+1.d0*rpppyzz3+rdzypz3+dpzyz23
      fzd2= qcx*fzy2+wqx*fzy3                      
      fze2= qcx*fzz2+wqx*fzz3                      
      fzf2= qcy*fzz2+wqy*fzz3+1.d0*rpppzzz3        
  
!pdss01(12-23) 
      pdxxx12 = eta*(pdxxx1 - rooe*pdxxx2)
      pdxyy12 = eta*(pdxyy1 - rooe*pdxyy2)
      pdxzz12 = eta*(pdxzz1 - rooe*pdxzz2)
      pdxyx12 = eta*(pdxyx1 - rooe*pdxyx2)
      pdxzx12 = eta*(pdxzx1 - rooe*pdxzx2)
      pdxzy12 = eta*(pdxzy1 - rooe*pdxzy2)
      pdyxx12 = eta*(pdyxx1 - rooe*pdyxx2)
      pdyyy12 = eta*(pdyyy1 - rooe*pdyyy2)
      pdyzz12 = eta*(pdyzz1 - rooe*pdyzz2)
      pdyyx12 = eta*(pdyyx1 - rooe*pdyyx2)
      pdyzx12 = eta*(pdyzx1 - rooe*pdyzx2)
      pdyzy12 = eta*(pdyzy1 - rooe*pdyzy2)
      pdzxx12 = eta*(pdzxx1 - rooe*pdzxx2)
      pdzyy12 = eta*(pdzyy1 - rooe*pdzyy2)
      pdzzz12 = eta*(pdzzz1 - rooe*pdzzz2)
      pdzyx12 = eta*(pdzyx1 - rooe*pdzyx2)
      pdzzx12 = eta*(pdzzx1 - rooe*pdzzx2)
      pdzzy12 = eta*(pdzzy1 - rooe*pdzzy2)
 
      pdxxx23 = eta*(pdxxx2 - rooe*pdxxx3)
      pdxyy23 = eta*(pdxyy2 - rooe*pdxyy3)
      pdxzz23 = eta*(pdxzz2 - rooe*pdxzz3)
      pdxyx23 = eta*(pdxyx2 - rooe*pdxyx3)
      pdxzx23 = eta*(pdxzx2 - rooe*pdxzx3)
      pdxzy23 = eta*(pdxzy2 - rooe*pdxzy3)
      pdyxx23 = eta*(pdyxx2 - rooe*pdyxx3)
      pdyyy23 = eta*(pdyyy2 - rooe*pdyyy3)
      pdyzz23 = eta*(pdyzz2 - rooe*pdyzz3)
      pdyyx23 = eta*(pdyyx2 - rooe*pdyyx3)
      pdyzx23 = eta*(pdyzx2 - rooe*pdyzx3)
      pdyzy23 = eta*(pdyzy2 - rooe*pdyzy3)
      pdzxx23 = eta*(pdzxx2 - rooe*pdzxx3)
      pdzyy23 = eta*(pdzyy2 - rooe*pdzyy3)
      pdzzz23 = eta*(pdzzz2 - rooe*pdzzz3)
      pdzyx23 = eta*(pdzyx2 - rooe*pdzyx3)
      pdzzx23 = eta*(pdzzx2 - rooe*pdzzx3)
      pdzzy23 = eta*(pdzzy2 - rooe*pdzzy3)
!rsdps (2-3)
      rxxdpx2 = rkp*xxdpx2
      rxxdpy2 = rkp*xxdpy2
      rxxdpz2 = rkp*xxdpz2
      ryydpx2 = rkp*yydpx2
      ryydpy2 = rkp*yydpy2
      ryydpz2 = rkp*yydpz2
      rzzdpx2 = rkp*zzdpx2
      rzzdpy2 = rkp*zzdpy2
      rzzdpz2 = rkp*zzdpz2
      ryxdpx2 = rkp*yxdpx2
      ryxdpy2 = rkp*yxdpy2
      ryxdpz2 = rkp*yxdpz2
      rzxdpx2 = rkp*zxdpx2
      rzxdpy2 = rkp*zxdpy2
      rzxdpz2 = rkp*zxdpz2
      rzydpx2 = rkp*zydpx2
      rzydpy2 = rkp*zydpy2
      rzydpz2 = rkp*zydpz2
      rxxdpx3 = rkp*xxdpx3
      rxxdpy3 = rkp*xxdpy3
      rxxdpz3 = rkp*xxdpz3
      ryydpx3 = rkp*yydpx3
      ryydpy3 = rkp*yydpy3
      ryydpz3 = rkp*yydpz3
      rzzdpx3 = rkp*zzdpx3
      rzzdpy3 = rkp*zzdpy3
      rzzdpz3 = rkp*zzdpz3
      ryxdpx3 = rkp*yxdpx3
      ryxdpy3 = rkp*yxdpy3
      ryxdpz3 = rkp*yxdpz3
      rzxdpx3 = rkp*zxdpx3
      rzxdpy3 = rkp*zxdpy3
      rzxdpz3 = rkp*zxdpz3
      rzydpx3 = rkp*zydpx3
      rzydpy3 = rkp*zydpy3
      rzydpz3 = rkp*zydpz3
  
! pdds(1-2) 
      xdxxdxx1=qcx*pxdxxpx1+wqx*pxdxxpx2+rxxdpx2+2.d0*rpppxxx2+pdxxx12
      xdxxdyy1=qcy*pxdxxpy1+wqy*pxdxxpy2                      +pdxxx12
      xdxxdzz1=qcz*pxdxxpz1+wqz*pxdxxpz2                      +pdxxx12
      xdxxdyx1=qcy*pxdxxpx1+wqy*pxdxxpx2
      xdxxdzx1=qcz*pxdxxpx1+wqz*pxdxxpx2
      xdxxdzy1=qcy*pxdxxpz1+wqy*pxdxxpz2
      xdyydxx1=qcx*pxdyypx1+wqx*pxdyypx2+ryydpx2              +pdxyy12
      xdyydyy1=qcy*pxdyypy1+wqy*pxdyypy2        +2.d0*rpppxyy2+pdxyy12
      xdyydzz1=qcz*pxdyypz1+wqz*pxdyypz2                      +pdxyy12
      xdyydyx1=qcx*pxdyypy1+wqx*pxdyypy2+ryydpy2
      xdyydzx1=qcz*pxdyypx1+wqz*pxdyypx2
      xdyydzy1=qcz*pxdyypy1+wqz*pxdyypy2
      xdzzdxx1=qcx*pxdzzpx1+wqx*pxdzzpx2+rzzdpx2              +pdxzz12
      xdzzdyy1=qcy*pxdzzpy1+wqy*pxdzzpy2                      +pdxzz12
      xdzzdzz1=qcz*pxdzzpz1+wqz*pxdzzpz2        +2.d0*rpppxzz2+pdxzz12
      xdzzdyx1=qcy*pxdzzpx1+wqy*pxdzzpx2                              
      xdzzdzx1=qcx*pxdzzpz1+wqx*pxdzzpz2+rzzdpz2                      
      xdzzdzy1=qcy*pxdzzpz1+wqy*pxdzzpz2                              
      xdyxdxx1=qcx*pxdyxpx1+wqx*pxdyxpx2+ryxdpx2+1.d0*rpppxyx2+pdxyx12
      xdyxdyy1=qcy*pxdyxpy1+wqy*pxdyxpy2        +1.d0*rpppxxy2+pdxyx12
      xdyxdzz1=qcz*pxdyxpz1+wqz*pxdyxpz2                      +pdxyx12
      xdyxdyx1=qcy*pxdyxpx1+wqy*pxdyxpx2        +1.d0*rpppxxx2
      xdyxdzx1=qcz*pxdyxpx1+wqz*pxdyxpx2
      xdyxdzy1=qcz*pxdyxpy1+wqz*pxdyxpy2
      xdzxdxx1=qcx*pxdzxpx1+wqx*pxdzxpx2+rzxdpx2+1.d0*rpppxzx2+pdxzx12
      xdzxdyy1=qcy*pxdzxpy1+wqy*pxdzxpy2                      +pdxzx12
      xdzxdzz1=qcz*pxdzxpz1+wqz*pxdzxpz2        +1.d0*rpppxxz2+pdxzx12
      xdzxdyx1=qcy*pxdzxpx1+wqy*pxdzxpx2                              
      xdzxdzx1=qcz*pxdzxpx1+wqz*pxdzxpx2        +1.d0*rpppxxx2        
      xdzxdzy1=qcy*pxdzxpz1+wqy*pxdzxpz2                              
      xdzydxx1=qcx*pxdzypx1+wqx*pxdzypx2+rzydpx2              +pdxzy12
      xdzydyy1=qcy*pxdzypy1+wqy*pxdzypy2        +1.d0*rpppxzy2+pdxzy12
      xdzydzz1=qcz*pxdzypz1+wqz*pxdzypz2        +1.d0*rpppxyz2+pdxzy12
      xdzydyx1=qcx*pxdzypy1+wqx*pxdzypy2+rzydpy2                      
      xdzydzx1=qcx*pxdzypz1+wqx*pxdzypz2+rzydpz2                      
      xdzydzy1=qcy*pxdzypz1+wqy*pxdzypz2        +1.d0*rpppxzz2        
      ydxxdxx1=qcx*pydxxpx1+wqx*pydxxpx2        +2.d0*rpppyxx2+pdyxx12
      ydxxdyy1=qcy*pydxxpy1+wqy*pydxxpy2+rxxdpy2              +pdyxx12
      ydxxdzz1=qcz*pydxxpz1+wqz*pydxxpz2                      +pdyxx12
      ydxxdyx1=qcy*pydxxpx1+wqy*pydxxpx2+rxxdpx2      
      ydxxdzx1=qcz*pydxxpx1+wqz*pydxxpx2              
      ydxxdzy1=qcz*pydxxpy1+wqz*pydxxpy2              
      ydyydxx1=qcx*pydyypx1+wqx*pydyypx2                      +pdyyy12
      ydyydyy1=qcy*pydyypy1+wqy*pydyypy2+ryydpy2+2.d0*rpppyyy2+pdyyy12
      ydyydzz1=qcz*pydyypz1+wqz*pydyypz2                      +pdyyy12
      ydyydyx1=qcx*pydyypy1+wqx*pydyypy2
      ydyydzx1=qcx*pydyypz1+wqx*pydyypz2
      ydyydzy1=qcz*pydyypy1+wqz*pydyypy2
      ydzzdxx1=qcx*pydzzpx1+wqx*pydzzpx2                      +pdyzz12
      ydzzdyy1=qcy*pydzzpy1+wqy*pydzzpy2+rzzdpy2              +pdyzz12
      ydzzdzz1=qcz*pydzzpz1+wqz*pydzzpz2        +2.d0*rpppyzz2+pdyzz12
      ydzzdyx1=qcx*pydzzpy1+wqx*pydzzpy2       
      ydzzdzx1=qcx*pydzzpz1+wqx*pydzzpz2       
      ydzzdzy1=qcy*pydzzpz1+wqy*pydzzpz2+rzzdpz2
      ydyxdxx1=qcx*pydyxpx1+wqx*pydyxpx2        +1.d0*rpppyyx2+pdyyx12
      ydyxdyy1=qcy*pydyxpy1+wqy*pydyxpy2+ryxdpy2+1.d0*rpppyxy2+pdyyx12
      ydyxdzz1=qcz*pydyxpz1+wqz*pydyxpz2                      +pdyyx12
      ydyxdyx1=qcx*pydyxpy1+wqx*pydyxpy2        +1.d0*rpppyyy2
      ydyxdzx1=qcz*pydyxpx1+wqz*pydyxpx2
      ydyxdzy1=qcz*pydyxpy1+wqz*pydyxpy2
      ydzxdxx1=qcx*pydzxpx1+wqx*pydzxpx2        +1.d0*rpppyzx2+pdyzx12
      ydzxdyy1=qcy*pydzxpy1+wqy*pydzxpy2+rzxdpy2              +pdyzx12
      ydzxdzz1=qcz*pydzxpz1+wqz*pydzxpz2        +1.d0*rpppyxz2+pdyzx12
      ydzxdyx1=qcy*pydzxpx1+wqy*pydzxpx2+rzxdpx2              
      ydzxdzx1=qcx*pydzxpz1+wqx*pydzxpz2        +1.d0*rpppyzz2
      ydzxdzy1=qcy*pydzxpz1+wqy*pydzxpz2+rzxdpz2              
      ydzydxx1=qcx*pydzypx1+wqx*pydzypx2                      +pdyzy12
      ydzydyy1=qcy*pydzypy1+wqy*pydzypy2+rzydpy2+1.d0*rpppyzy2+pdyzy12
      ydzydzz1=qcz*pydzypz1+wqz*pydzypz2        +1.d0*rpppyyz2+pdyzy12
      ydzydyx1=qcx*pydzypy1+wqx*pydzypy2
      ydzydzx1=qcx*pydzypz1+wqx*pydzypz2
      ydzydzy1=qcz*pydzypy1+wqz*pydzypy2        +1.d0*rpppyyy2
      zdxxdxx1=qcx*pzdxxpx1+wqx*pzdxxpx2        +2.d0*rpppzxx2+pdzxx12
      zdxxdyy1=qcy*pzdxxpy1+wqy*pzdxxpy2                      +pdzxx12
      zdxxdzz1=qcz*pzdxxpz1+wqz*pzdxxpz2+rxxdpz2              +pdzxx12
      zdxxdyx1=qcy*pzdxxpx1+wqy*pzdxxpx2                      
      zdxxdzx1=qcz*pzdxxpx1+wqz*pzdxxpx2+rxxdpx2              
      zdxxdzy1=qcy*pzdxxpz1+wqy*pzdxxpz2                      
      zdyydxx1=qcx*pzdyypx1+wqx*pzdyypx2                      +pdzyy12
      zdyydyy1=qcy*pzdyypy1+wqy*pzdyypy2        +2.d0*rpppzyy2+pdzyy12
      zdyydzz1=qcz*pzdyypz1+wqz*pzdyypz2+ryydpz2              +pdzyy12
      zdyydyx1=qcx*pzdyypy1+wqx*pzdyypy2        
      zdyydzx1=qcx*pzdyypz1+wqx*pzdyypz2        
      zdyydzy1=qcz*pzdyypy1+wqz*pzdyypy2+ryydpy2
      zdzzdxx1=qcx*pzdzzpx1+wqx*pzdzzpx2                      +pdzzz12
      zdzzdyy1=qcy*pzdzzpy1+wqy*pzdzzpy2                      +pdzzz12
      zdzzdzz1=qcz*pzdzzpz1+wqz*pzdzzpz2+rzzdpz2+2.d0*rpppzzz2+pdzzz12
      zdzzdyx1=qcx*pzdzzpy1+wqx*pzdzzpy2
      zdzzdzx1=qcx*pzdzzpz1+wqx*pzdzzpz2
      zdzzdzy1=qcy*pzdzzpz1+wqy*pzdzzpz2
      zdyxdxx1=qcx*pzdyxpx1+wqx*pzdyxpx2        +1.d0*rpppzyx2+pdzyx12
      zdyxdyy1=qcy*pzdyxpy1+wqy*pzdyxpy2        +1.d0*rpppzxy2+pdzyx12
      zdyxdzz1=qcz*pzdyxpz1+wqz*pzdyxpz2+ryxdpz2              +pdzyx12
      zdyxdyx1=qcx*pzdyxpy1+wqx*pzdyxpy2        +1.d0*rpppzyy2
      zdyxdzx1=qcz*pzdyxpx1+wqz*pzdyxpx2+ryxdpx2
      zdyxdzy1=qcz*pzdyxpy1+wqz*pzdyxpy2+ryxdpy2
      zdzxdxx1=qcx*pzdzxpx1+wqx*pzdzxpx2        +1.d0*rpppzzx2+pdzzx12
      zdzxdyy1=qcy*pzdzxpy1+wqy*pzdzxpy2                      +pdzzx12
      zdzxdzz1=qcz*pzdzxpz1+wqz*pzdzxpz2+rzxdpz2+1.d0*rpppzxz2+pdzzx12
      zdzxdyx1=qcy*pzdzxpx1+wqy*pzdzxpx2                      
      zdzxdzx1=qcx*pzdzxpz1+wqx*pzdzxpz2        +1.d0*rpppzzz2
      zdzxdzy1=qcy*pzdzxpz1+wqy*pzdzxpz2                      
      zdzydxx1=qcx*pzdzypx1+wqx*pzdzypx2                      +pdzzy12
      zdzydyy1=qcy*pzdzypy1+wqy*pzdzypy2        +1.d0*rpppzzy2+pdzzy12
      zdzydzz1=qcz*pzdzypz1+wqz*pzdzypz2+rzydpz2+1.d0*rpppzyz2+pdzzy12
      zdzydyx1=qcx*pzdzypy1+wqx*pzdzypy2                      
      zdzydzx1=qcx*pzdzypz1+wqx*pzdzypz2                      
      zdzydzy1=qcy*pzdzypz1+wqy*pzdzypz2        +1.d0*rpppzzz2
  
      xdxxdxx2=qcx*pxdxxpx2+wqx*pxdxxpx3+rxxdpx3+2.d0*rpppxxx3+pdxxx23
      xdxxdyy2=qcy*pxdxxpy2+wqy*pxdxxpy3                      +pdxxx23
      xdxxdzz2=qcz*pxdxxpz2+wqz*pxdxxpz3                      +pdxxx23
      xdxxdyx2=qcy*pxdxxpx2+wqy*pxdxxpx3
      xdxxdzx2=qcz*pxdxxpx2+wqz*pxdxxpx3
      xdxxdzy2=qcy*pxdxxpz2+wqy*pxdxxpz3
      xdyydxx2=qcx*pxdyypx2+wqx*pxdyypx3+ryydpx3              +pdxyy23
      xdyydyy2=qcy*pxdyypy2+wqy*pxdyypy3        +2.d0*rpppxyy3+pdxyy23
      xdyydzz2=qcz*pxdyypz2+wqz*pxdyypz3                      +pdxyy23
      xdyydyx2=qcx*pxdyypy2+wqx*pxdyypy3+ryydpy3
      xdyydzx2=qcz*pxdyypx2+wqz*pxdyypx3
      xdyydzy2=qcz*pxdyypy2+wqz*pxdyypy3
      xdzzdxx2=qcx*pxdzzpx2+wqx*pxdzzpx3+rzzdpx3              +pdxzz23
      xdzzdyy2=qcy*pxdzzpy2+wqy*pxdzzpy3                      +pdxzz23
      xdzzdzz2=qcz*pxdzzpz2+wqz*pxdzzpz3        +2.d0*rpppxzz3+pdxzz23
      xdzzdyx2=qcy*pxdzzpx2+wqy*pxdzzpx3                              
      xdzzdzx2=qcx*pxdzzpz2+wqx*pxdzzpz3+rzzdpz3                      
      xdzzdzy2=qcy*pxdzzpz2+wqy*pxdzzpz3                              
      xdyxdxx2=qcx*pxdyxpx2+wqx*pxdyxpx3+ryxdpx3+1.d0*rpppxyx3+pdxyx23
      xdyxdyy2=qcy*pxdyxpy2+wqy*pxdyxpy3        +1.d0*rpppxxy3+pdxyx23
      xdyxdzz2=qcz*pxdyxpz2+wqz*pxdyxpz3                      +pdxyx23
      xdyxdyx2=qcy*pxdyxpx2+wqy*pxdyxpx3        +1.d0*rpppxxx3
      xdyxdzx2=qcz*pxdyxpx2+wqz*pxdyxpx3
      xdyxdzy2=qcz*pxdyxpy2+wqz*pxdyxpy3
      xdzxdxx2=qcx*pxdzxpx2+wqx*pxdzxpx3+rzxdpx3+1.d0*rpppxzx3+pdxzx23
      xdzxdyy2=qcy*pxdzxpy2+wqy*pxdzxpy3                      +pdxzx23
      xdzxdzz2=qcz*pxdzxpz2+wqz*pxdzxpz3        +1.d0*rpppxxz3+pdxzx23
      xdzxdyx2=qcy*pxdzxpx2+wqy*pxdzxpx3                              
      xdzxdzx2=qcz*pxdzxpx2+wqz*pxdzxpx3        +1.d0*rpppxxx3        
      xdzxdzy2=qcy*pxdzxpz2+wqy*pxdzxpz3                              
      xdzydxx2=qcx*pxdzypx2+wqx*pxdzypx3+rzydpx3              +pdxzy23
      xdzydyy2=qcy*pxdzypy2+wqy*pxdzypy3        +1.d0*rpppxzy3+pdxzy23
      xdzydzz2=qcz*pxdzypz2+wqz*pxdzypz3        +1.d0*rpppxyz3+pdxzy23
      xdzydyx2=qcx*pxdzypy2+wqx*pxdzypy3+rzydpy3                      
      xdzydzx2=qcx*pxdzypz2+wqx*pxdzypz3+rzydpz3                      
      xdzydzy2=qcy*pxdzypz2+wqy*pxdzypz3        +1.d0*rpppxzz3        
      ydxxdxx2=qcx*pydxxpx2+wqx*pydxxpx3        +2.d0*rpppyxx3+pdyxx23
      ydxxdyy2=qcy*pydxxpy2+wqy*pydxxpy3+rxxdpy3              +pdyxx23
      ydxxdzz2=qcz*pydxxpz2+wqz*pydxxpz3                      +pdyxx23
      ydxxdyx2=qcy*pydxxpx2+wqy*pydxxpx3+rxxdpx3      
      ydxxdzx2=qcz*pydxxpx2+wqz*pydxxpx3              
      ydxxdzy2=qcz*pydxxpy2+wqz*pydxxpy3              
      ydyydxx2=qcx*pydyypx2+wqx*pydyypx3                      +pdyyy23
      ydyydyy2=qcy*pydyypy2+wqy*pydyypy3+ryydpy3+2.d0*rpppyyy3+pdyyy23
      ydyydzz2=qcz*pydyypz2+wqz*pydyypz3                      +pdyyy23
      ydyydyx2=qcx*pydyypy2+wqx*pydyypy3
      ydyydzx2=qcx*pydyypz2+wqx*pydyypz3
      ydyydzy2=qcz*pydyypy2+wqz*pydyypy3
      ydzzdxx2=qcx*pydzzpx2+wqx*pydzzpx3                      +pdyzz23
      ydzzdyy2=qcy*pydzzpy2+wqy*pydzzpy3+rzzdpy3              +pdyzz23
      ydzzdzz2=qcz*pydzzpz2+wqz*pydzzpz3        +2.d0*rpppyzz3+pdyzz23
      ydzzdyx2=qcx*pydzzpy2+wqx*pydzzpy3       
      ydzzdzx2=qcx*pydzzpz2+wqx*pydzzpz3       
      ydzzdzy2=qcy*pydzzpz2+wqy*pydzzpz3+rzzdpz3
      ydyxdxx2=qcx*pydyxpx2+wqx*pydyxpx3        +1.d0*rpppyyx3+pdyyx23
      ydyxdyy2=qcy*pydyxpy2+wqy*pydyxpy3+ryxdpy3+1.d0*rpppyxy3+pdyyx23
      ydyxdzz2=qcz*pydyxpz2+wqz*pydyxpz3                      +pdyyx23
      ydyxdyx2=qcx*pydyxpy2+wqx*pydyxpy3        +1.d0*rpppyyy3
      ydyxdzx2=qcz*pydyxpx2+wqz*pydyxpx3
      ydyxdzy2=qcz*pydyxpy2+wqz*pydyxpy3
      ydzxdxx2=qcx*pydzxpx2+wqx*pydzxpx3        +1.d0*rpppyzx3+pdyzx23
      ydzxdyy2=qcy*pydzxpy2+wqy*pydzxpy3+rzxdpy3              +pdyzx23
      ydzxdzz2=qcz*pydzxpz2+wqz*pydzxpz3        +1.d0*rpppyxz3+pdyzx23
      ydzxdyx2=qcy*pydzxpx2+wqy*pydzxpx3+rzxdpx3              
      ydzxdzx2=qcx*pydzxpz2+wqx*pydzxpz3        +1.d0*rpppyzz3
      ydzxdzy2=qcy*pydzxpz2+wqy*pydzxpz3+rzxdpz3              
      ydzydxx2=qcx*pydzypx2+wqx*pydzypx3                      +pdyzy23
      ydzydyy2=qcy*pydzypy2+wqy*pydzypy3+rzydpy3+1.d0*rpppyzy3+pdyzy23
      ydzydzz2=qcz*pydzypz2+wqz*pydzypz3        +1.d0*rpppyyz3+pdyzy23
      ydzydyx2=qcx*pydzypy2+wqx*pydzypy3
      ydzydzx2=qcx*pydzypz2+wqx*pydzypz3
      ydzydzy2=qcz*pydzypy2+wqz*pydzypy3        +1.d0*rpppyyy3
      zdxxdxx2=qcx*pzdxxpx2+wqx*pzdxxpx3        +2.d0*rpppzxx3+pdzxx23
      zdxxdyy2=qcy*pzdxxpy2+wqy*pzdxxpy3                      +pdzxx23
      zdxxdzz2=qcz*pzdxxpz2+wqz*pzdxxpz3+rxxdpz3              +pdzxx23
      zdxxdyx2=qcy*pzdxxpx2+wqy*pzdxxpx3                      
      zdxxdzx2=qcz*pzdxxpx2+wqz*pzdxxpx3+rxxdpx3              
      zdxxdzy2=qcy*pzdxxpz2+wqy*pzdxxpz3                      
      zdyydxx2=qcx*pzdyypx2+wqx*pzdyypx3                      +pdzyy23
      zdyydyy2=qcy*pzdyypy2+wqy*pzdyypy3        +2.d0*rpppzyy3+pdzyy23
      zdyydzz2=qcz*pzdyypz2+wqz*pzdyypz3+ryydpz3              +pdzyy23
      zdyydyx2=qcx*pzdyypy2+wqx*pzdyypy3        
      zdyydzx2=qcx*pzdyypz2+wqx*pzdyypz3        
      zdyydzy2=qcz*pzdyypy2+wqz*pzdyypy3+ryydpy3
      zdzzdxx2=qcx*pzdzzpx2+wqx*pzdzzpx3                      +pdzzz23
      zdzzdyy2=qcy*pzdzzpy2+wqy*pzdzzpy3                      +pdzzz23
      zdzzdzz2=qcz*pzdzzpz2+wqz*pzdzzpz3+rzzdpz3+2.d0*rpppzzz3+pdzzz23
      zdzzdyx2=qcx*pzdzzpy2+wqx*pzdzzpy3
      zdzzdzx2=qcx*pzdzzpz2+wqx*pzdzzpz3
      zdzzdzy2=qcy*pzdzzpz2+wqy*pzdzzpz3
      zdyxdxx2=qcx*pzdyxpx2+wqx*pzdyxpx3        +1.d0*rpppzyx3+pdzyx23
      zdyxdyy2=qcy*pzdyxpy2+wqy*pzdyxpy3        +1.d0*rpppzxy3+pdzyx23
      zdyxdzz2=qcz*pzdyxpz2+wqz*pzdyxpz3+ryxdpz3              +pdzyx23
      zdyxdyx2=qcx*pzdyxpy2+wqx*pzdyxpy3        +1.d0*rpppzyy3
      zdyxdzx2=qcz*pzdyxpx2+wqz*pzdyxpx3+ryxdpx3
      zdyxdzy2=qcz*pzdyxpy2+wqz*pzdyxpy3+ryxdpy3
      zdzxdxx2=qcx*pzdzxpx2+wqx*pzdzxpx3        +1.d0*rpppzzx3+pdzzx23
      zdzxdyy2=qcy*pzdzxpy2+wqy*pzdzxpy3                      +pdzzx23
      zdzxdzz2=qcz*pzdzxpz2+wqz*pzdzxpz3+rzxdpz3+1.d0*rpppzxz3+pdzzx23
      zdzxdyx2=qcy*pzdzxpx2+wqy*pzdzxpx3                      
      zdzxdzx2=qcx*pzdzxpz2+wqx*pzdzxpz3        +1.d0*rpppzzz3
      zdzxdzy2=qcy*pzdzxpz2+wqy*pzdzxpz3                      
      zdzydxx2=qcx*pzdzypx2+wqx*pzdzypx3                      +pdzzy23
      zdzydyy2=qcy*pzdzypy2+wqy*pzdzypy3        +1.d0*rpppzzy3+pdzzy23
      zdzydzz2=qcz*pzdzypz2+wqz*pzdzypz3+rzydpz3+1.d0*rpppzyz3+pdzzy23
      zdzydyx2=qcx*pzdzypy2+wqx*pzdzypy3                      
      zdzydzx2=qcx*pzdzypz2+wqx*pzdzypz3                      
      zdzydzy2=qcy*pzdzypz2+wqy*pzdzypz3        +1.d0*rpppzzz3

!RANK=6
!rpdps(1-3)
      xax1= rkp * pxdxxpx1
      xay1= rkp * pxdxxpy1
      xaz1= rkp * pxdxxpz1
      xbx1= rkp * pxdyypx1
      xby1= rkp * pxdyypy1
      xbz1= rkp * pxdyypz1
      xcx1= rkp * pxdzzpx1
      xcy1= rkp * pxdzzpy1
      xcz1= rkp * pxdzzpz1
      xdx1= rkp * pxdyxpx1
      xdy1= rkp * pxdyxpy1
      xdz1= rkp * pxdyxpz1
      xex1= rkp * pxdzxpx1
      xey1= rkp * pxdzxpy1
      xez1= rkp * pxdzxpz1
      xfx1= rkp * pxdzypx1
      xfy1= rkp * pxdzypy1
      xfz1= rkp * pxdzypz1
      yax1= rkp * pydxxpx1
      yay1= rkp * pydxxpy1
      yaz1= rkp * pydxxpz1
      ybx1= rkp * pydyypx1
      yby1= rkp * pydyypy1
      ybz1= rkp * pydyypz1
      ycx1= rkp * pydzzpx1
      ycy1= rkp * pydzzpy1
      ycz1= rkp * pydzzpz1
      ydx1= rkp * pydyxpx1
      ydy1= rkp * pydyxpy1
      ydz1= rkp * pydyxpz1
      yex1= rkp * pydzxpx1
      yey1= rkp * pydzxpy1
      yez1= rkp * pydzxpz1
      yfx1= rkp * pydzypx1
      yfy1= rkp * pydzypy1
      yfz1= rkp * pydzypz1
      zax1= rkp * pzdxxpx1
      zay1= rkp * pzdxxpy1
      zaz1= rkp * pzdxxpz1
      zbx1= rkp * pzdyypx1
      zby1= rkp * pzdyypy1
      zbz1= rkp * pzdyypz1
      zcx1= rkp * pzdzzpx1
      zcy1= rkp * pzdzzpy1
      zcz1= rkp * pzdzzpz1
      zdx1= rkp * pzdyxpx1
      zdy1= rkp * pzdyxpy1
      zdz1= rkp * pzdyxpz1
      zex1= rkp * pzdzxpx1
      zey1= rkp * pzdzxpy1
      zez1= rkp * pzdzxpz1
      zfx1= rkp * pzdzypx1
      zfy1= rkp * pzdzypy1
      zfz1= rkp * pzdzypz1
      xax2= rkp * pxdxxpx2
      xay2= rkp * pxdxxpy2
      xaz2= rkp * pxdxxpz2
      xbx2= rkp * pxdyypx2
      xby2= rkp * pxdyypy2
      xbz2= rkp * pxdyypz2
      xcx2= rkp * pxdzzpx2
      xcy2= rkp * pxdzzpy2
      xcz2= rkp * pxdzzpz2
      xdx2= rkp * pxdyxpx2
      xdy2= rkp * pxdyxpy2
      xdz2= rkp * pxdyxpz2
      xex2= rkp * pxdzxpx2
      xey2= rkp * pxdzxpy2
      xez2= rkp * pxdzxpz2
      xfx2= rkp * pxdzypx2
      xfy2= rkp * pxdzypy2
      xfz2= rkp * pxdzypz2
      yax2= rkp * pydxxpx2
      yay2= rkp * pydxxpy2
      yaz2= rkp * pydxxpz2
      ybx2= rkp * pydyypx2
      yby2= rkp * pydyypy2
      ybz2= rkp * pydyypz2
      ycx2= rkp * pydzzpx2
      ycy2= rkp * pydzzpy2
      ycz2= rkp * pydzzpz2
      ydx2= rkp * pydyxpx2
      ydy2= rkp * pydyxpy2
      ydz2= rkp * pydyxpz2
      yex2= rkp * pydzxpx2
      yey2= rkp * pydzxpy2
      yez2= rkp * pydzxpz2
      yfx2= rkp * pydzypx2
      yfy2= rkp * pydzypy2
      yfz2= rkp * pydzypz2
      zax2= rkp * pzdxxpx2
      zay2= rkp * pzdxxpy2
      zaz2= rkp * pzdxxpz2
      zbx2= rkp * pzdyypx2
      zby2= rkp * pzdyypy2
      zbz2= rkp * pzdyypz2
      zcx2= rkp * pzdzzpx2
      zcy2= rkp * pzdzzpy2
      zcz2= rkp * pzdzzpz2
      zdx2= rkp * pzdyxpx2
      zdy2= rkp * pzdyxpy2
      zdz2= rkp * pzdyxpz2
      zex2= rkp * pzdzxpx2
      zey2= rkp * pzdzxpy2
      zez2= rkp * pzdzxpz2
      zfx2= rkp * pzdzypx2
      zfy2= rkp * pzdzypy2
      zfz2= rkp * pzdzypz2
      xax3= rkp * pxdxxpx3
      xay3= rkp * pxdxxpy3
      xaz3= rkp * pxdxxpz3
      xbx3= rkp * pxdyypx3
      xby3= rkp * pxdyypy3
      xbz3= rkp * pxdyypz3
      xcx3= rkp * pxdzzpx3
      xcy3= rkp * pxdzzpy3
      xcz3= rkp * pxdzzpz3
      xdx3= rkp * pxdyxpx3
      xdy3= rkp * pxdyxpy3
      xdz3= rkp * pxdyxpz3
      xex3= rkp * pxdzxpx3
      xey3= rkp * pxdzxpy3
      xez3= rkp * pxdzxpz3
      xfx3= rkp * pxdzypx3
      xfy3= rkp * pxdzypy3
      xfz3= rkp * pxdzypz3
      yax3= rkp * pydxxpx3
      yay3= rkp * pydxxpy3
      yaz3= rkp * pydxxpz3
      ybx3= rkp * pydyypx3
      yby3= rkp * pydyypy3
      ybz3= rkp * pydyypz3
      ycx3= rkp * pydzzpx3
      ycy3= rkp * pydzzpy3
      ycz3= rkp * pydzzpz3
      ydx3= rkp * pydyxpx3
      ydy3= rkp * pydyxpy3
      ydz3= rkp * pydyxpz3
      yex3= rkp * pydzxpx3
      yey3= rkp * pydzxpy3
      yez3= rkp * pydzxpz3
      yfx3= rkp * pydzypx3
      yfy3= rkp * pydzypy3
      yfz3= rkp * pydzypz3
      zax3= rkp * pzdxxpx3
      zay3= rkp * pzdxxpy3
      zaz3= rkp * pzdxxpz3
      zbx3= rkp * pzdyypx3
      zby3= rkp * pzdyypy3
      zbz3= rkp * pzdyypz3
      zcx3= rkp * pzdzzpx3
      zcy3= rkp * pzdzzpy3
      zcz3= rkp * pzdzzpz3
      zdx3= rkp * pzdyxpx3
      zdy3= rkp * pzdyxpy3
      zdz3= rkp * pzdyxpz3
      zex3= rkp * pzdzxpx3
      zey3= rkp * pzdzxpy3
      zez3= rkp * pzdzxpz3
      zfx3= rkp * pzdzypx3
      zfy3= rkp * pzdzypy3
      zfz3= rkp * pzdzypz3
!rdpps(1-3)
      raxx1= rkp *axx1
      raxy1= rkp *axy1
      raxz1= rkp *axz1
      rayx1= rkp *ayx1
      rayy1= rkp *ayy1
      rayz1= rkp *ayz1
      razx1= rkp *azx1
      razy1= rkp *azy1
      razz1= rkp *azz1
      rbxx1= rkp *bxx1
      rbxy1= rkp *bxy1
      rbxz1= rkp *bxz1
      rbyx1= rkp *byx1
      rbyy1= rkp *byy1
      rbyz1= rkp *byz1
      rbzx1= rkp *bzx1
      rbzy1= rkp *bzy1
      rbzz1= rkp *bzz1
      rcxx1= rkp *cxx1
      rcxy1= rkp *cxy1
      rcxz1= rkp *cxz1
      rcyx1= rkp *cyx1
      rcyy1= rkp *cyy1
      rcyz1= rkp *cyz1
      rczx1= rkp *czx1
      rczy1= rkp *czy1
      rczz1= rkp *czz1
      rdxx1= rkp *dxx1
      rdxy1= rkp *dxy1
      rdxz1= rkp *dxz1
      rdyx1= rkp *dyx1
      rdyy1= rkp *dyy1
      rdyz1= rkp *dyz1
      rdzx1= rkp *dzx1
      rdzy1= rkp *dzy1
      rdzz1= rkp *dzz1
      rexx1= rkp *exx1
      rexy1= rkp *exy1
      rexz1= rkp *exz1
      reyx1= rkp *eyx1
      reyy1= rkp *eyy1
      reyz1= rkp *eyz1
      rezx1= rkp *ezx1
      rezy1= rkp *ezy1
      rezz1= rkp *ezz1
      rfxx1= rkp *fxx1
      rfxy1= rkp *fxy1
      rfxz1= rkp *fxz1
      rfyx1= rkp *fyx1
      rfyy1= rkp *fyy1
      rfyz1= rkp *fyz1
      rfzx1= rkp *fzx1
      rfzy1= rkp *fzy1
      rfzz1= rkp *fzz1
      raxx2= rkp *axx2
      raxy2= rkp *axy2
      raxz2= rkp *axz2
      rayx2= rkp *ayx2
      rayy2= rkp *ayy2
      rayz2= rkp *ayz2
      razx2= rkp *azx2
      razy2= rkp *azy2
      razz2= rkp *azz2
      rbxx2= rkp *bxx2
      rbxy2= rkp *bxy2
      rbxz2= rkp *bxz2
      rbyx2= rkp *byx2
      rbyy2= rkp *byy2
      rbyz2= rkp *byz2
      rbzx2= rkp *bzx2
      rbzy2= rkp *bzy2
      rbzz2= rkp *bzz2
      rcxx2= rkp *cxx2
      rcxy2= rkp *cxy2
      rcxz2= rkp *cxz2
      rcyx2= rkp *cyx2
      rcyy2= rkp *cyy2
      rcyz2= rkp *cyz2
      rczx2= rkp *czx2
      rczy2= rkp *czy2
      rczz2= rkp *czz2
      rdxx2= rkp *dxx2
      rdxy2= rkp *dxy2
      rdxz2= rkp *dxz2
      rdyx2= rkp *dyx2
      rdyy2= rkp *dyy2
      rdyz2= rkp *dyz2
      rdzx2= rkp *dzx2
      rdzy2= rkp *dzy2
      rdzz2= rkp *dzz2
      rexx2= rkp *exx2
      rexy2= rkp *exy2
      rexz2= rkp *exz2
      reyx2= rkp *eyx2
      reyy2= rkp *eyy2
      reyz2= rkp *eyz2
      rezx2= rkp *ezx2
      rezy2= rkp *ezy2
      rezz2= rkp *ezz2
      rfxx2= rkp *fxx2
      rfxy2= rkp *fxy2
      rfxz2= rkp *fxz2
      rfyx2= rkp *fyx2
      rfyy2= rkp *fyy2
      rfyz2= rkp *fyz2
      rfzx2= rkp *fzx2
      rfzy2= rkp *fzy2
      rfzz2= rkp *fzz2
      raxx3= rkp *axx3
      raxy3= rkp *axy3
      raxz3= rkp *axz3
      rayx3= rkp *ayx3
      rayy3= rkp *ayy3
      rayz3= rkp *ayz3
      razx3= rkp *azx3
      razy3= rkp *azy3
      razz3= rkp *azz3
      rbxx3= rkp *bxx3
      rbxy3= rkp *bxy3
      rbxz3= rkp *bxz3
      rbyx3= rkp *byx3
      rbyy3= rkp *byy3
      rbyz3= rkp *byz3
      rbzx3= rkp *bzx3
      rbzy3= rkp *bzy3
      rbzz3= rkp *bzz3
      rcxx3= rkp *cxx3
      rcxy3= rkp *cxy3
      rcxz3= rkp *cxz3
      rcyx3= rkp *cyx3
      rcyy3= rkp *cyy3
      rcyz3= rkp *cyz3
      rczx3= rkp *czx3
      rczy3= rkp *czy3
      rczz3= rkp *czz3
      rdxx3= rkp *dxx3
      rdxy3= rkp *dxy3
      rdxz3= rkp *dxz3
      rdyx3= rkp *dyx3
      rdyy3= rkp *dyy3
      rdyz3= rkp *dyz3
      rdzx3= rkp *dzx3
      rdzy3= rkp *dzy3
      rdzz3= rkp *dzz3
      rexx3= rkp *exx3
      rexy3= rkp *exy3
      rexz3= rkp *exz3
      reyx3= rkp *eyx3
      reyy3= rkp *eyy3
      reyz3= rkp *eyz3
      rezx3= rkp *ezx3
      rezy3= rkp *ezy3
      rezz3= rkp *ezz3
      rfxx3= rkp *fxx3
      rfxy3= rkp *fxy3
      rfxz3= rkp *fxz3
      rfyx3= rkp *fyx3
      rfyy3= rkp *fyy3
      rfyz3= rkp *fyz3
      rfzx3= rkp *fzx3
      rfzy3= rkp *fzy3
      rfzz3= rkp *fzz3
!ddss01(01-23)
      aa0 = eta*(ddxxxx0 - rooe*ddxxxx1)
      ab0 = eta*(ddxxyy0 - rooe*ddxxyy1)
      ac0 = eta*(ddxxzz0 - rooe*ddxxzz1)
      ad0 = eta*(ddxxyx0 - rooe*ddxxyx1)
      ae0 = eta*(ddxxzx0 - rooe*ddxxzx1)
      af0 = eta*(ddxxzy0 - rooe*ddxxzy1)
      ba0 = eta*(ddyyxx0 - rooe*ddyyxx1)
      bb0 = eta*(ddyyyy0 - rooe*ddyyyy1)
      bc0 = eta*(ddyyzz0 - rooe*ddyyzz1)
      bd0 = eta*(ddyyyx0 - rooe*ddyyyx1)
      be0 = eta*(ddyyzx0 - rooe*ddyyzx1)
      bf0 = eta*(ddyyzy0 - rooe*ddyyzy1)
      ca0 = eta*(ddzzxx0 - rooe*ddzzxx1)
      cb0 = eta*(ddzzyy0 - rooe*ddzzyy1)
      cc0 = eta*(ddzzzz0 - rooe*ddzzzz1)
      cd0 = eta*(ddzzyx0 - rooe*ddzzyx1)
      ce0 = eta*(ddzzzx0 - rooe*ddzzzx1)
      cf0 = eta*(ddzzzy0 - rooe*ddzzzy1)
      da0 = eta*(ddyxxx0 - rooe*ddyxxx1)
      db0 = eta*(ddyxyy0 - rooe*ddyxyy1)
      dc0 = eta*(ddyxzz0 - rooe*ddyxzz1)
      dd0 = eta*(ddyxyx0 - rooe*ddyxyx1)
      de0 = eta*(ddyxzx0 - rooe*ddyxzx1)
      df0 = eta*(ddyxzy0 - rooe*ddyxzy1)
      ea0 = eta*(ddzxxx0 - rooe*ddzxxx1)
      eb0 = eta*(ddzxyy0 - rooe*ddzxyy1)
      ec0 = eta*(ddzxzz0 - rooe*ddzxzz1)
      ed0 = eta*(ddzxyx0 - rooe*ddzxyx1)
      ee0 = eta*(ddzxzx0 - rooe*ddzxzx1)
      ef0 = eta*(ddzxzy0 - rooe*ddzxzy1)
      fa0 = eta*(ddzyxx0 - rooe*ddzyxx1)
      fb0 = eta*(ddzyyy0 - rooe*ddzyyy1)
      fc0 = eta*(ddzyzz0 - rooe*ddzyzz1)
      fd0 = eta*(ddzyyx0 - rooe*ddzyyx1)
      fe0 = eta*(ddzyzx0 - rooe*ddzyzx1)
      ff0 = eta*(ddzyzy0 - rooe*ddzyzy1)

      aa1 = eta*(ddxxxx1 - rooe*ddxxxx2)
      ab1 = eta*(ddxxyy1 - rooe*ddxxyy2)
      ac1 = eta*(ddxxzz1 - rooe*ddxxzz2)
      ad1 = eta*(ddxxyx1 - rooe*ddxxyx2)
      ae1 = eta*(ddxxzx1 - rooe*ddxxzx2)
      af1 = eta*(ddxxzy1 - rooe*ddxxzy2)
      ba1 = eta*(ddyyxx1 - rooe*ddyyxx2)
      bb1 = eta*(ddyyyy1 - rooe*ddyyyy2)
      bc1 = eta*(ddyyzz1 - rooe*ddyyzz2)
      bd1 = eta*(ddyyyx1 - rooe*ddyyyx2)
      be1 = eta*(ddyyzx1 - rooe*ddyyzx2)
      bf1 = eta*(ddyyzy1 - rooe*ddyyzy2)
      ca1 = eta*(ddzzxx1 - rooe*ddzzxx2)
      cb1 = eta*(ddzzyy1 - rooe*ddzzyy2)
      cc1 = eta*(ddzzzz1 - rooe*ddzzzz2)
      cd1 = eta*(ddzzyx1 - rooe*ddzzyx2)
      ce1 = eta*(ddzzzx1 - rooe*ddzzzx2)
      cf1 = eta*(ddzzzy1 - rooe*ddzzzy2)
      da1 = eta*(ddyxxx1 - rooe*ddyxxx2)
      db1 = eta*(ddyxyy1 - rooe*ddyxyy2)
      dc1 = eta*(ddyxzz1 - rooe*ddyxzz2)
      dd1 = eta*(ddyxyx1 - rooe*ddyxyx2)
      de1 = eta*(ddyxzx1 - rooe*ddyxzx2)
      df1 = eta*(ddyxzy1 - rooe*ddyxzy2)
      ea1 = eta*(ddzxxx1 - rooe*ddzxxx2)
      eb1 = eta*(ddzxyy1 - rooe*ddzxyy2)
      ec1 = eta*(ddzxzz1 - rooe*ddzxzz2)
      ed1 = eta*(ddzxyx1 - rooe*ddzxyx2)
      ee1 = eta*(ddzxzx1 - rooe*ddzxzx2)
      ef1 = eta*(ddzxzy1 - rooe*ddzxzy2)
      fa1 = eta*(ddzyxx1 - rooe*ddzyxx2)
      fb1 = eta*(ddzyyy1 - rooe*ddzyyy2)
      fc1 = eta*(ddzyzz1 - rooe*ddzyzz2)
      fd1 = eta*(ddzyyx1 - rooe*ddzyyx2)
      fe1 = eta*(ddzyzx1 - rooe*ddzyzx2)
      ff1 = eta*(ddzyzy1 - rooe*ddzyzy2)

      aa2 = eta*(ddxxxx2 - rooe*ddxxxx3)
      ab2 = eta*(ddxxyy2 - rooe*ddxxyy3)
      ac2 = eta*(ddxxzz2 - rooe*ddxxzz3)
      ad2 = eta*(ddxxyx2 - rooe*ddxxyx3)
      ae2 = eta*(ddxxzx2 - rooe*ddxxzx3)
      af2 = eta*(ddxxzy2 - rooe*ddxxzy3)
      ba2 = eta*(ddyyxx2 - rooe*ddyyxx3)
      bb2 = eta*(ddyyyy2 - rooe*ddyyyy3)
      bc2 = eta*(ddyyzz2 - rooe*ddyyzz3)
      bd2 = eta*(ddyyyx2 - rooe*ddyyyx3)
      be2 = eta*(ddyyzx2 - rooe*ddyyzx3)
      bf2 = eta*(ddyyzy2 - rooe*ddyyzy3)
      ca2 = eta*(ddzzxx2 - rooe*ddzzxx3)
      cb2 = eta*(ddzzyy2 - rooe*ddzzyy3)
      cc2 = eta*(ddzzzz2 - rooe*ddzzzz3)
      cd2 = eta*(ddzzyx2 - rooe*ddzzyx3)
      ce2 = eta*(ddzzzx2 - rooe*ddzzzx3)
      cf2 = eta*(ddzzzy2 - rooe*ddzzzy3)
      da2 = eta*(ddyxxx2 - rooe*ddyxxx3)
      db2 = eta*(ddyxyy2 - rooe*ddyxyy3)
      dc2 = eta*(ddyxzz2 - rooe*ddyxzz3)
      dd2 = eta*(ddyxyx2 - rooe*ddyxyx3)
      de2 = eta*(ddyxzx2 - rooe*ddyxzx3)
      df2 = eta*(ddyxzy2 - rooe*ddyxzy3)
      ea2 = eta*(ddzxxx2 - rooe*ddzxxx3)
      eb2 = eta*(ddzxyy2 - rooe*ddzxyy3)
      ec2 = eta*(ddzxzz2 - rooe*ddzxzz3)
      ed2 = eta*(ddzxyx2 - rooe*ddzxyx3)
      ee2 = eta*(ddzxzx2 - rooe*ddzxzx3)
      ef2 = eta*(ddzxzy2 - rooe*ddzxzy3)
      fa2 = eta*(ddzyxx2 - rooe*ddzyxx3)
      fb2 = eta*(ddzyyy2 - rooe*ddzyyy3)
      fc2 = eta*(ddzyzz2 - rooe*ddzyzz3)
      fd2 = eta*(ddzyyx2 - rooe*ddzyyx3)
      fe2 = eta*(ddzyzx2 - rooe*ddzyzx3)
      ff2 = eta*(ddzyzy2 - rooe*ddzyzy3)

!ddds(0-2)
      aaa0=qcx*dxxdxxpx0+wqx*dxxdxxpx1+2.d0*xax1+2.d0*raxx1+aa0
      aab0=qcy*dxxdxxpy0+wqy*dxxdxxpy1                     +aa0
      aac0=qcz*dxxdxxpz0+wqz*dxxdxxpz1                     +aa0
      aad0=qcy*dxxdxxpx0+wqy*dxxdxxpx1
      aae0=qcz*dxxdxxpx0+wqz*dxxdxxpx1
      aaf0=qcy*dxxdxxpz0+wqy*dxxdxxpz1
      aba0=qcx*dxxdyypx0+wqx*dxxdyypx1+2.d0*xbx1           +ab0
      abb0=qcy*dxxdyypy0+wqy*dxxdyypy1          +2.d0*rayy1+ab0
      abc0=qcz*dxxdyypz0+wqz*dxxdyypz1                     +ab0
      abd0=qcx*dxxdyypy0+wqx*dxxdyypy1+2.d0*xby1
      abe0=qcz*dxxdyypx0+wqz*dxxdyypx1
      abf0=qcz*dxxdyypy0+wqz*dxxdyypy1
      aca0=qcx*dxxdzzpx0+wqx*dxxdzzpx1+2.d0*xcx1           +ac0
      acb0=qcy*dxxdzzpy0+wqy*dxxdzzpy1                     +ac0
      acc0=qcz*dxxdzzpz0+wqz*dxxdzzpz1          +2.d0*razz1+ac0
      acd0=qcy*dxxdzzpx0+wqy*dxxdzzpx1
      ace0=qcx*dxxdzzpz0+wqx*dxxdzzpz1+2.d0*xcz1
      acf0=qcy*dxxdzzpz0+wqy*dxxdzzpz1
      ada0=qcx*dxxdyxpx0+wqx*dxxdyxpx1+2.d0*xdx1+     rayx1+ad0
      adb0=qcy*dxxdyxpy0+wqy*dxxdyxpy1          +     raxy1+ad0
      adc0=qcz*dxxdyxpz0+wqz*dxxdyxpz1                     +ad0
      add0=qcy*dxxdyxpx0+wqy*dxxdyxpx1          +     raxx1
      ade0=qcz*dxxdyxpx0+wqz*dxxdyxpx1
      adf0=qcz*dxxdyxpy0+wqz*dxxdyxpy1
      aea0=qcx*dxxdzxpx0+wqx*dxxdzxpx1+2.d0*xex1+     razx1+ae0
      aeb0=qcy*dxxdzxpy0+wqy*dxxdzxpy1                     +ae0
      aec0=qcz*dxxdzxpz0+wqz*dxxdzxpz1          +     raxz1+ae0
      aed0=qcy*dxxdzxpx0+wqy*dxxdzxpx1        
      aee0=qcz*dxxdzxpx0+wqz*dxxdzxpx1          +      raxx1
      aef0=qcy*dxxdzxpz0+wqy*dxxdzxpz1
      afa0=qcx*dxxdzypx0+wqx*dxxdzypx1+2.d0*xfx1           +af0
      afb0=qcy*dxxdzypy0+wqy*dxxdzypy1          +     razy1+af0
      afc0=qcz*dxxdzypz0+wqz*dxxdzypz1          +     rayz1+af0
      afd0=qcy*dxxdzypx0+wqy*dxxdzypx1          +     razx1
      afe0=qcz*dxxdzypx0+wqz*dxxdzypx1          +     rayx1
      aff0=qcy*dxxdzypz0+wqy*dxxdzypz1          +     razz1
      baa0=qcx*dyydxxpx0+wqx*dyydxxpx1          +2.d0*rbxx1+ba0
      bab0=qcy*dyydxxpy0+wqy*dyydxxpy1+2.d0*yay1           +ba0
      bac0=qcz*dyydxxpz0+wqz*dyydxxpz1                     +ba0
      bad0=qcx*dyydxxpy0+wqx*dyydxxpy1          +2.d0*rbxy1
      bae0=qcz*dyydxxpx0+wqz*dyydxxpx1
      baf0=qcz*dyydxxpy0+wqz*dyydxxpy1
      bba0=qcx*dyydyypx0+wqx*dyydyypx1                     +bb0
      bbb0=qcy*dyydyypy0+wqy*dyydyypy1+2.d0*yby1+2.d0*rbyy1+bb0
      bbc0=qcz*dyydyypz0+wqz*dyydyypz1                     +bb0
      bbd0=qcx*dyydyypy0+wqx*dyydyypy1               
      bbe0=qcx*dyydyypz0+wqx*dyydyypz1               
      bbf0=qcz*dyydyypy0+wqz*dyydyypy1               
      bca0=qcx*dyydzzpx0+wqx*dyydzzpx1                     +bc0
      bcb0=qcy*dyydzzpy0+wqy*dyydzzpy1+2.d0*ycy1           +bc0
      bcc0=qcz*dyydzzpz0+wqz*dyydzzpz1          +2.d0*rbzz1+bc0
      bcd0=qcx*dyydzzpy0+wqx*dyydzzpy1                   
      bce0=qcx*dyydzzpz0+wqx*dyydzzpz1                   
      bcf0=qcy*dyydzzpz0+wqy*dyydzzpz1+2.d0*ycz1             
      bda0=qcx*dyydyxpx0+wqx*dyydyxpx1          +     rbyx1+bd0
      bdb0=qcy*dyydyxpy0+wqy*dyydyxpy1+2.d0*ydy1+     rbxy1+bd0
      bdc0=qcz*dyydyxpz0+wqz*dyydyxpz1                     +bd0
      bdd0=qcx*dyydyxpy0+wqx*dyydyxpy1          +     rbyy1
      bde0=qcz*dyydyxpx0+wqz*dyydyxpx1                   
      bdf0=qcz*dyydyxpy0+wqz*dyydyxpy1                   
      bea0=qcx*dyydzxpx0+wqx*dyydzxpx1          +     rbzx1+be0
      beb0=qcy*dyydzxpy0+wqy*dyydzxpy1+2.d0*yey1           +be0
      bec0=qcz*dyydzxpz0+wqz*dyydzxpz1          +     rbxz1+be0
      bed0=qcx*dyydzxpy0+wqx*dyydzxpy1          +     rbzy1
      bee0=qcx*dyydzxpz0+wqx*dyydzxpz1          +     rbzz1
      bef0=qcz*dyydzxpy0+wqz*dyydzxpy1          +     rbxy1
      bfa0=qcx*dyydzypx0+wqx*dyydzypx1                     +bf0
      bfb0=qcy*dyydzypy0+wqy*dyydzypy1+2.d0*yfy1+     rbzy1+bf0
      bfc0=qcz*dyydzypz0+wqz*dyydzypz1          +     rbyz1+bf0
      bfd0=qcx*dyydzypy0+wqx*dyydzypy1                   
      bfe0=qcx*dyydzypz0+wqx*dyydzypz1                   
      bff0=qcz*dyydzypy0+wqz*dyydzypy1          +     rbyy1
      caa0=qcx*dzzdxxpx0+wqx*dzzdxxpx1          +2.d0*rcxx1+ca0
      cab0=qcy*dzzdxxpy0+wqy*dzzdxxpy1                     +ca0
      cac0=qcz*dzzdxxpz0+wqz*dzzdxxpz1+2.d0*zaz1           +ca0
      cad0=qcy*dzzdxxpx0+wqy*dzzdxxpx1                   
      cae0=qcx*dzzdxxpz0+wqx*dzzdxxpz1          +2.d0*rcxz1
      caf0=qcy*dzzdxxpz0+wqy*dzzdxxpz1                   
      cba0=qcx*dzzdyypx0+wqx*dzzdyypx1                     +cb0
      cbb0=qcy*dzzdyypy0+wqy*dzzdyypy1          +2.d0*rcyy1+cb0
      cbc0=qcz*dzzdyypz0+wqz*dzzdyypz1+2.d0*zbz1           +cb0
      cbd0=qcx*dzzdyypy0+wqx*dzzdyypy1                   
      cbe0=qcx*dzzdyypz0+wqx*dzzdyypz1                   
      cbf0=qcy*dzzdyypz0+wqy*dzzdyypz1          +2.d0*rcyz1
      cca0=qcx*dzzdzzpx0+wqx*dzzdzzpx1                     +cc0
      ccb0=qcy*dzzdzzpy0+wqy*dzzdzzpy1                     +cc0
      ccc0=qcz*dzzdzzpz0+wqz*dzzdzzpz1+2.d0*zcz1+2.d0*rczz1+cc0
      ccd0=qcx*dzzdzzpy0+wqx*dzzdzzpy1
      cce0=qcx*dzzdzzpz0+wqx*dzzdzzpz1
      ccf0=qcy*dzzdzzpz0+wqy*dzzdzzpz1
      cda0=qcx*dzzdyxpx0+wqx*dzzdyxpx1          +     rcyx1+cd0
      cdb0=qcy*dzzdyxpy0+wqy*dzzdyxpy1          +     rcxy1+cd0
      cdc0=qcz*dzzdyxpz0+wqz*dzzdyxpz1+2.d0*zdz1           +cd0
      cdd0=qcx*dzzdyxpy0+wqx*dzzdyxpy1          +     rcyy1
      cde0=qcx*dzzdyxpz0+wqx*dzzdyxpz1          +     rcyz1
      cdf0=qcy*dzzdyxpz0+wqy*dzzdyxpz1          +     rcxz1
      cea0=qcx*dzzdzxpx0+wqx*dzzdzxpx1          +     rczx1+ce0
      ceb0=qcy*dzzdzxpy0+wqy*dzzdzxpy1                     +ce0
      cec0=qcz*dzzdzxpz0+wqz*dzzdzxpz1+2.d0*zez1+     rcxz1+ce0
      ced0=qcy*dzzdzxpx0+wqy*dzzdzxpx1                
      cee0=qcx*dzzdzxpz0+wqx*dzzdzxpz1          +     rczz1
      cef0=qcy*dzzdzxpz0+wqy*dzzdzxpz1               
      cfa0=qcx*dzzdzypx0+wqx*dzzdzypx1                     +cf0
      cfb0=qcy*dzzdzypy0+wqy*dzzdzypy1          +     rczy1+cf0
      cfc0=qcz*dzzdzypz0+wqz*dzzdzypz1+2.d0*zfz1+     rcyz1+cf0
      cfd0=qcx*dzzdzypy0+wqx*dzzdzypy1                   
      cfe0=qcx*dzzdzypz0+wqx*dzzdzypz1                   
      cff0=qcy*dzzdzypz0+wqy*dzzdzypz1          +     rczz1
      daa0=qcx*dyxdxxpx0+wqx*dyxdxxpx1+     yax1+2.d0*rdxx1+da0
      dab0=qcy*dyxdxxpy0+wqy*dyxdxxpy1+     xay1           +da0
      dac0=qcz*dyxdxxpz0+wqz*dyxdxxpz1                     +da0
      dad0=qcy*dyxdxxpx0+wqy*dyxdxxpx1+     xax1
      dae0=qcz*dyxdxxpx0+wqz*dyxdxxpx1
      daf0=qcz*dyxdxxpy0+wqz*dyxdxxpy1
      dba0=qcx*dyxdyypx0+wqx*dyxdyypx1+     ybx1           +db0
      dbb0=qcy*dyxdyypy0+wqy*dyxdyypy1+     xby1+2.d0*rdyy1+db0
      dbc0=qcz*dyxdyypz0+wqz*dyxdyypz1                     +db0
      dbd0=qcx*dyxdyypy0+wqx*dyxdyypy1+     yby1
      dbe0=qcz*dyxdyypx0+wqz*dyxdyypx1
      dbf0=qcz*dyxdyypy0+wqz*dyxdyypy1
      dca0=qcx*dyxdzzpx0+wqx*dyxdzzpx1+     ycx1           +dc0
      dcb0=qcy*dyxdzzpy0+wqy*dyxdzzpy1+     xcy1           +dc0
      dcc0=qcz*dyxdzzpz0+wqz*dyxdzzpz1          +2.d0*rdzz1+dc0
      dcd0=qcx*dyxdzzpy0+wqx*dyxdzzpy1+     ycy1          
      dce0=qcx*dyxdzzpz0+wqx*dyxdzzpz1+     ycz1          
      dcf0=qcy*dyxdzzpz0+wqy*dyxdzzpz1+     xcz1          
      dda0=qcx*dyxdyxpx0+wqx*dyxdyxpx1+     ydx1+     rdyx1+dd0
      ddb0=qcy*dyxdyxpy0+wqy*dyxdyxpy1+     xdy1+     rdxy1+dd0
      ddc0=qcz*dyxdyxpz0+wqz*dyxdyxpz1                     +dd0
      ddd0=qcx*dyxdyxpy0+wqx*dyxdyxpy1+     ydy1+     rdyy1
      dde0=qcz*dyxdyxpx0+wqz*dyxdyxpx1
      ddf0=qcz*dyxdyxpy0+wqz*dyxdyxpy1
      dea0=qcx*dyxdzxpx0+wqx*dyxdzxpx1+     yex1+     rdzx1+de0
      deb0=qcy*dyxdzxpy0+wqy*dyxdzxpy1+     xey1           +de0
      dec0=qcz*dyxdzxpz0+wqz*dyxdzxpz1          +     rdxz1+de0
      ded0=qcy*dyxdzxpx0+wqy*dyxdzxpx1+     xex1
      dee0=qcz*dyxdzxpx0+wqz*dyxdzxpx1          +     rdxx1
      def0=qcy*dyxdzxpz0+wqy*dyxdzxpz1+     xez1
      dfa0=qcx*dyxdzypx0+wqx*dyxdzypx1+     yfx1           +df0
      dfb0=qcy*dyxdzypy0+wqy*dyxdzypy1+     xfy1+     rdzy1+df0
      dfc0=qcz*dyxdzypz0+wqz*dyxdzypz1          +     rdyz1+df0
      dfd0=qcx*dyxdzypy0+wqx*dyxdzypy1+     yfy1
      dfe0=qcx*dyxdzypz0+wqx*dyxdzypz1+     yfz1
      dff0=qcz*dyxdzypy0+wqz*dyxdzypy1          +     rdyy1
      eaa0=qcx*dzxdxxpx0+wqx*dzxdxxpx1+     zax1+2.d0*rexx1+ea0
      eab0=qcy*dzxdxxpy0+wqy*dzxdxxpy1                     +ea0
      eac0=qcz*dzxdxxpz0+wqz*dzxdxxpz1+     xaz1           +ea0
      ead0=qcy*dzxdxxpx0+wqy*dzxdxxpx1
      eae0=qcz*dzxdxxpx0+wqz*dzxdxxpx1+     xax1
      eaf0=qcy*dzxdxxpz0+wqy*dzxdxxpz1
      eba0=qcx*dzxdyypx0+wqx*dzxdyypx1+     zbx1           +eb0
      ebb0=qcy*dzxdyypy0+wqy*dzxdyypy1          +2.d0*reyy1+eb0
      ebc0=qcz*dzxdyypz0+wqz*dzxdyypz1+     xbz1           +eb0
      ebd0=qcx*dzxdyypy0+wqx*dzxdyypy1+     zby1
      ebe0=qcx*dzxdyypz0+wqx*dzxdyypz1+     zbz1
      ebf0=qcz*dzxdyypy0+wqz*dzxdyypy1+     xby1
      eca0=qcx*dzxdzzpx0+wqx*dzxdzzpx1+     zcx1           +ec0
      ecb0=qcy*dzxdzzpy0+wqy*dzxdzzpy1                     +ec0
      ecc0=qcz*dzxdzzpz0+wqz*dzxdzzpz1+     xcz1+2.d0*rezz1+ec0
      ecd0=qcy*dzxdzzpx0+wqy*dzxdzzpx1
      ece0=qcx*dzxdzzpz0+wqx*dzxdzzpz1+     zcz1
      ecf0=qcy*dzxdzzpz0+wqy*dzxdzzpz1
      eda0=qcx*dzxdyxpx0+wqx*dzxdyxpx1+     zdx1+     reyx1+ed0
      edb0=qcy*dzxdyxpy0+wqy*dzxdyxpy1          +     rexy1+ed0
      edc0=qcz*dzxdyxpz0+wqz*dzxdyxpz1+     xdz1           +ed0
      edd0=qcy*dzxdyxpx0+wqy*dzxdyxpx1          +     rexx1
      ede0=qcz*dzxdyxpx0+wqz*dzxdyxpx1+     xdx1
      edf0=qcz*dzxdyxpy0+wqz*dzxdyxpy1+     xdy1
      eea0=qcx*dzxdzxpx0+wqx*dzxdzxpx1+     zex1+     rezx1+ee0
      eeb0=qcy*dzxdzxpy0+wqy*dzxdzxpy1                     +ee0
      eec0=qcz*dzxdzxpz0+wqz*dzxdzxpz1+     xez1+     rexz1+ee0
      eed0=qcy*dzxdzxpx0+wqy*dzxdzxpx1
      eee0=qcx*dzxdzxpz0+wqx*dzxdzxpz1+     zez1+     rezz1
      eef0=qcy*dzxdzxpz0+wqy*dzxdzxpz1
      efa0=qcx*dzxdzypx0+wqx*dzxdzypx1+     zfx1           +ef0
      efb0=qcy*dzxdzypy0+wqy*dzxdzypy1          +     rezy1+ef0
      efc0=qcz*dzxdzypz0+wqz*dzxdzypz1+     xfz1+     reyz1+ef0
      efd0=qcy*dzxdzypx0+wqy*dzxdzypx1          +     rezx1
      efe0=qcx*dzxdzypz0+wqx*dzxdzypz1+     zfz1
      eff0=qcy*dzxdzypz0+wqy*dzxdzypz1          +     rezz1
      faa0=qcx*dzydxxpx0+wqx*dzydxxpx1          +2.d0*rfxx1+fa0
      fab0=qcy*dzydxxpy0+wqy*dzydxxpy1+     zay1           +fa0
      fac0=qcz*dzydxxpz0+wqz*dzydxxpz1+     yaz1           +fa0
      fad0=qcy*dzydxxpx0+wqy*dzydxxpx1+     zax1
      fae0=qcz*dzydxxpx0+wqz*dzydxxpx1+     yax1
      faf0=qcy*dzydxxpz0+wqy*dzydxxpz1+     zaz1
      fba0=qcx*dzydyypx0+wqx*dzydyypx1                     +fb0
      fbb0=qcy*dzydyypy0+wqy*dzydyypy1+     zby1+2.d0*rfyy1+fb0
      fbc0=qcz*dzydyypz0+wqz*dzydyypz1+     ybz1           +fb0
      fbd0=qcx*dzydyypy0+wqx*dzydyypy1
      fbe0=qcx*dzydyypz0+wqx*dzydyypz1
      fbf0=qcz*dzydyypy0+wqz*dzydyypy1+     yby1
      fca0=qcx*dzydzzpx0+wqx*dzydzzpx1                     +fc0
      fcb0=qcy*dzydzzpy0+wqy*dzydzzpy1+     zcy1           +fc0
      fcc0=qcz*dzydzzpz0+wqz*dzydzzpz1+     ycz1+2.d0*rfzz1+fc0
      fcd0=qcx*dzydzzpy0+wqx*dzydzzpy1
      fce0=qcx*dzydzzpz0+wqx*dzydzzpz1
      fcf0=qcy*dzydzzpz0+wqy*dzydzzpz1+     zcz1
      fda0=qcx*dzydyxpx0+wqx*dzydyxpx1          +     rfyx1+fd0
      fdb0=qcy*dzydyxpy0+wqy*dzydyxpy1+     zdy1+     rfxy1+fd0
      fdc0=qcz*dzydyxpz0+wqz*dzydyxpz1+     ydz1           +fd0
      fdd0=qcx*dzydyxpy0+wqx*dzydyxpy1          +     rfyy1
      fde0=qcx*dzydyxpz0+wqx*dzydyxpz1          +     rfyz1
      fdf0=qcz*dzydyxpy0+wqz*dzydyxpy1+     ydy1
      fea0=qcx*dzydzxpx0+wqx*dzydzxpx1          +     rfzx1+fe0
      feb0=qcy*dzydzxpy0+wqy*dzydzxpy1+     zey1           +fe0
      fec0=qcz*dzydzxpz0+wqz*dzydzxpz1+     yez1+     rfxz1+fe0
      fed0=qcy*dzydzxpx0+wqy*dzydzxpx1+     zex1
      fee0=qcx*dzydzxpz0+wqx*dzydzxpz1          +     rfzz1
      fef0=qcy*dzydzxpz0+wqy*dzydzxpz1+     zez1
      ffa0=qcx*dzydzypx0+wqx*dzydzypx1                     +ff0
      ffb0=qcy*dzydzypy0+wqy*dzydzypy1+     zfy1+     rfzy1+ff0
      ffc0=qcz*dzydzypz0+wqz*dzydzypz1+     yfz1+     rfyz1+ff0
      ffd0=qcx*dzydzypy0+wqx*dzydzypy1
      ffe0=qcx*dzydzypz0+wqx*dzydzypz1
      fff0=qcy*dzydzypz0+wqy*dzydzypz1+     zfz1+     rfzz1

      aaa1=qcx*dxxdxxpx1+wqx*dxxdxxpx2+2.d0*xax2+2.d0*raxx2+aa1
      aab1=qcy*dxxdxxpy1+wqy*dxxdxxpy2                     +aa1
      aac1=qcz*dxxdxxpz1+wqz*dxxdxxpz2                     +aa1
      aad1=qcy*dxxdxxpx1+wqy*dxxdxxpx2
      aae1=qcz*dxxdxxpx1+wqz*dxxdxxpx2
      aaf1=qcy*dxxdxxpz1+wqy*dxxdxxpz2
      aba1=qcx*dxxdyypx1+wqx*dxxdyypx2+2.d0*xbx2           +ab1
      abb1=qcy*dxxdyypy1+wqy*dxxdyypy2          +2.d0*rayy2+ab1
      abc1=qcz*dxxdyypz1+wqz*dxxdyypz2                     +ab1
      abd1=qcx*dxxdyypy1+wqx*dxxdyypy2+2.d0*xby2
      abe1=qcz*dxxdyypx1+wqz*dxxdyypx2
      abf1=qcz*dxxdyypy1+wqz*dxxdyypy2
      aca1=qcx*dxxdzzpx1+wqx*dxxdzzpx2+2.d0*xcx2           +ac1
      acb1=qcy*dxxdzzpy1+wqy*dxxdzzpy2                     +ac1
      acc1=qcz*dxxdzzpz1+wqz*dxxdzzpz2          +2.d0*razz2+ac1
      acd1=qcy*dxxdzzpx1+wqy*dxxdzzpx2
      ace1=qcx*dxxdzzpz1+wqx*dxxdzzpz2+2.d0*xcz2
      acf1=qcy*dxxdzzpz1+wqy*dxxdzzpz2
      ada1=qcx*dxxdyxpx1+wqx*dxxdyxpx2+2.d0*xdx2+     rayx2+ad1
      adb1=qcy*dxxdyxpy1+wqy*dxxdyxpy2          +     raxy2+ad1
      adc1=qcz*dxxdyxpz1+wqz*dxxdyxpz2                     +ad1
      add1=qcy*dxxdyxpx1+wqy*dxxdyxpx2          +     raxx2
      ade1=qcz*dxxdyxpx1+wqz*dxxdyxpx2
      adf1=qcz*dxxdyxpy1+wqz*dxxdyxpy2
      aea1=qcx*dxxdzxpx1+wqx*dxxdzxpx2+2.d0*xex2+     razx2+ae1
      aeb1=qcy*dxxdzxpy1+wqy*dxxdzxpy2                     +ae1
      aec1=qcz*dxxdzxpz1+wqz*dxxdzxpz2          +     raxz2+ae1
      aed1=qcy*dxxdzxpx1+wqy*dxxdzxpx2
      aee1=qcz*dxxdzxpx1+wqz*dxxdzxpx2          +     raxx2
      aef1=qcy*dxxdzxpz1+wqy*dxxdzxpz2
      afa1=qcx*dxxdzypx1+wqx*dxxdzypx2+2.d0*xfx2           +af1
      afb1=qcy*dxxdzypy1+wqy*dxxdzypy2          +     razy2+af1
      afc1=qcz*dxxdzypz1+wqz*dxxdzypz2          +     rayz2+af1
      afd1=qcy*dxxdzypx1+wqy*dxxdzypx2          +     razx2
      afe1=qcz*dxxdzypx1+wqz*dxxdzypx2          +     rayx2
      aff1=qcy*dxxdzypz1+wqy*dxxdzypz2          +     razz2
      baa1=qcx*dyydxxpx1+wqx*dyydxxpx2          +2.d0*rbxx2+ba1
      bab1=qcy*dyydxxpy1+wqy*dyydxxpy2+2.d0*yay2           +ba1
      bac1=qcz*dyydxxpz1+wqz*dyydxxpz2                     +ba1
      bad1=qcx*dyydxxpy1+wqx*dyydxxpy2          +2.d0*rbxy2
      bae1=qcz*dyydxxpx1+wqz*dyydxxpx2
      baf1=qcz*dyydxxpy1+wqz*dyydxxpy2
      bba1=qcx*dyydyypx1+wqx*dyydyypx2                     +bb1
      bbb1=qcy*dyydyypy1+wqy*dyydyypy2+2.d0*yby2+2.d0*rbyy2+bb1
      bbc1=qcz*dyydyypz1+wqz*dyydyypz2                     +bb1
      bbd1=qcx*dyydyypy1+wqx*dyydyypy2
      bbe1=qcx*dyydyypz1+wqx*dyydyypz2
      bbf1=qcz*dyydyypy1+wqz*dyydyypy2
      bca1=qcx*dyydzzpx1+wqx*dyydzzpx2                     +bc1
      bcb1=qcy*dyydzzpy1+wqy*dyydzzpy2+2.d0*ycy2           +bc1
      bcc1=qcz*dyydzzpz1+wqz*dyydzzpz2          +2.d0*rbzz2+bc1
      bcd1=qcx*dyydzzpy1+wqx*dyydzzpy2
      bce1=qcx*dyydzzpz1+wqx*dyydzzpz2
      bcf1=qcy*dyydzzpz1+wqy*dyydzzpz2+2.d0*ycz2
      bda1=qcx*dyydyxpx1+wqx*dyydyxpx2          +     rbyx2+bd1
      bdb1=qcy*dyydyxpy1+wqy*dyydyxpy2+2.d0*ydy2+     rbxy2+bd1
      bdc1=qcz*dyydyxpz1+wqz*dyydyxpz2                     +bd1
      bdd1=qcx*dyydyxpy1+wqx*dyydyxpy2          +     rbyy2
      bde1=qcz*dyydyxpx1+wqz*dyydyxpx2
      bdf1=qcz*dyydyxpy1+wqz*dyydyxpy2
      bea1=qcx*dyydzxpx1+wqx*dyydzxpx2          +     rbzx2+be1
      beb1=qcy*dyydzxpy1+wqy*dyydzxpy2+2.d0*yey2           +be1
      bec1=qcz*dyydzxpz1+wqz*dyydzxpz2          +     rbxz2+be1
      bed1=qcx*dyydzxpy1+wqx*dyydzxpy2          +     rbzy2
      bee1=qcx*dyydzxpz1+wqx*dyydzxpz2          +     rbzz2
      bef1=qcz*dyydzxpy1+wqz*dyydzxpy2          +     rbxy2
      bfa1=qcx*dyydzypx1+wqx*dyydzypx2                     +bf1
      bfb1=qcy*dyydzypy1+wqy*dyydzypy2+2.d0*yfy2+     rbzy2+bf1
      bfc1=qcz*dyydzypz1+wqz*dyydzypz2          +     rbyz2+bf1
      bfd1=qcx*dyydzypy1+wqx*dyydzypy2
      bfe1=qcx*dyydzypz1+wqx*dyydzypz2
      bff1=qcz*dyydzypy1+wqz*dyydzypy2          +     rbyy2
      caa1=qcx*dzzdxxpx1+wqx*dzzdxxpx2          +2.d0*rcxx2+ca1
      cab1=qcy*dzzdxxpy1+wqy*dzzdxxpy2                     +ca1
      cac1=qcz*dzzdxxpz1+wqz*dzzdxxpz2+2.d0*zaz2           +ca1
      cad1=qcy*dzzdxxpx1+wqy*dzzdxxpx2
      cae1=qcx*dzzdxxpz1+wqx*dzzdxxpz2          +2.d0*rcxz2
      caf1=qcy*dzzdxxpz1+wqy*dzzdxxpz2
      cba1=qcx*dzzdyypx1+wqx*dzzdyypx2                     +cb1
      cbb1=qcy*dzzdyypy1+wqy*dzzdyypy2          +2.d0*rcyy2+cb1
      cbc1=qcz*dzzdyypz1+wqz*dzzdyypz2+2.d0*zbz2           +cb1
      cbd1=qcx*dzzdyypy1+wqx*dzzdyypy2
      cbe1=qcx*dzzdyypz1+wqx*dzzdyypz2
      cbf1=qcy*dzzdyypz1+wqy*dzzdyypz2          +2.d0*rcyz2
      cca1=qcx*dzzdzzpx1+wqx*dzzdzzpx2                     +cc1
      ccb1=qcy*dzzdzzpy1+wqy*dzzdzzpy2                     +cc1
      ccc1=qcz*dzzdzzpz1+wqz*dzzdzzpz2+2.d0*zcz2+2.d0*rczz2+cc1
      ccd1=qcx*dzzdzzpy1+wqx*dzzdzzpy2
      cce1=qcx*dzzdzzpz1+wqx*dzzdzzpz2
      ccf1=qcy*dzzdzzpz1+wqy*dzzdzzpz2
      cda1=qcx*dzzdyxpx1+wqx*dzzdyxpx2          +     rcyx2+cd1
      cdb1=qcy*dzzdyxpy1+wqy*dzzdyxpy2          +     rcxy2+cd1
      cdc1=qcz*dzzdyxpz1+wqz*dzzdyxpz2+2.d0*zdz2           +cd1
      cdd1=qcx*dzzdyxpy1+wqx*dzzdyxpy2          +     rcyy2
      cde1=qcx*dzzdyxpz1+wqx*dzzdyxpz2          +     rcyz2
      cdf1=qcy*dzzdyxpz1+wqy*dzzdyxpz2          +     rcxz2
      cea1=qcx*dzzdzxpx1+wqx*dzzdzxpx2          +     rczx2+ce1
      ceb1=qcy*dzzdzxpy1+wqy*dzzdzxpy2                     +ce1
      cec1=qcz*dzzdzxpz1+wqz*dzzdzxpz2+2.d0*zez2+     rcxz2+ce1
      ced1=qcy*dzzdzxpx1+wqy*dzzdzxpx2
      cee1=qcx*dzzdzxpz1+wqx*dzzdzxpz2          +     rczz2
      cef1=qcy*dzzdzxpz1+wqy*dzzdzxpz2
      cfa1=qcx*dzzdzypx1+wqx*dzzdzypx2                     +cf1
      cfb1=qcy*dzzdzypy1+wqy*dzzdzypy2          +     rczy2+cf1
      cfc1=qcz*dzzdzypz1+wqz*dzzdzypz2+2.d0*zfz2+     rcyz2+cf1
      cfd1=qcx*dzzdzypy1+wqx*dzzdzypy2
      cfe1=qcx*dzzdzypz1+wqx*dzzdzypz2
      cff1=qcy*dzzdzypz1+wqy*dzzdzypz2          +     rczz2
      daa1=qcx*dyxdxxpx1+wqx*dyxdxxpx2+     yax2+2.d0*rdxx2+da1
      dab1=qcy*dyxdxxpy1+wqy*dyxdxxpy2+     xay2           +da1
      dac1=qcz*dyxdxxpz1+wqz*dyxdxxpz2                     +da1
      dad1=qcy*dyxdxxpx1+wqy*dyxdxxpx2+     xax2
      dae1=qcz*dyxdxxpx1+wqz*dyxdxxpx2
      daf1=qcz*dyxdxxpy1+wqz*dyxdxxpy2
      dba1=qcx*dyxdyypx1+wqx*dyxdyypx2+     ybx2           +db1
      dbb1=qcy*dyxdyypy1+wqy*dyxdyypy2+     xby2+2.d0*rdyy2+db1
      dbc1=qcz*dyxdyypz1+wqz*dyxdyypz2                     +db1
      dbd1=qcx*dyxdyypy1+wqx*dyxdyypy2+     yby2
      dbe1=qcz*dyxdyypx1+wqz*dyxdyypx2
      dbf1=qcz*dyxdyypy1+wqz*dyxdyypy2
      dca1=qcx*dyxdzzpx1+wqx*dyxdzzpx2+     ycx2           +dc1
      dcb1=qcy*dyxdzzpy1+wqy*dyxdzzpy2+     xcy2           +dc1
      dcc1=qcz*dyxdzzpz1+wqz*dyxdzzpz2          +2.d0*rdzz2+dc1
      dcd1=qcx*dyxdzzpy1+wqx*dyxdzzpy2+     ycy2
      dce1=qcx*dyxdzzpz1+wqx*dyxdzzpz2+     ycz2
      dcf1=qcy*dyxdzzpz1+wqy*dyxdzzpz2+     xcz2
      dda1=qcx*dyxdyxpx1+wqx*dyxdyxpx2+     ydx2+     rdyx2+dd1
      ddb1=qcy*dyxdyxpy1+wqy*dyxdyxpy2+     xdy2+     rdxy2+dd1
      ddc1=qcz*dyxdyxpz1+wqz*dyxdyxpz2                     +dd1
      ddd1=qcx*dyxdyxpy1+wqx*dyxdyxpy2+     ydy2+     rdyy2
      dde1=qcz*dyxdyxpx1+wqz*dyxdyxpx2
      ddf1=qcz*dyxdyxpy1+wqz*dyxdyxpy2
      dea1=qcx*dyxdzxpx1+wqx*dyxdzxpx2+     yex2+     rdzx2+de1
      deb1=qcy*dyxdzxpy1+wqy*dyxdzxpy2+     xey2           +de1
      dec1=qcz*dyxdzxpz1+wqz*dyxdzxpz2          +     rdxz2+de1
      ded1=qcy*dyxdzxpx1+wqy*dyxdzxpx2+     xex2
      dee1=qcz*dyxdzxpx1+wqz*dyxdzxpx2          +     rdxx2
      def1=qcy*dyxdzxpz1+wqy*dyxdzxpz2+     xez2
      dfa1=qcx*dyxdzypx1+wqx*dyxdzypx2+     yfx2           +df1
      dfb1=qcy*dyxdzypy1+wqy*dyxdzypy2+     xfy2+     rdzy2+df1
      dfc1=qcz*dyxdzypz1+wqz*dyxdzypz2          +     rdyz2+df1
      dfd1=qcx*dyxdzypy1+wqx*dyxdzypy2+     yfy2
      dfe1=qcx*dyxdzypz1+wqx*dyxdzypz2+     yfz2
      dff1=qcz*dyxdzypy1+wqz*dyxdzypy2          +     rdyy2
      eaa1=qcx*dzxdxxpx1+wqx*dzxdxxpx2+     zax2+2.d0*rexx2+ea1
      eab1=qcy*dzxdxxpy1+wqy*dzxdxxpy2                     +ea1
      eac1=qcz*dzxdxxpz1+wqz*dzxdxxpz2+     xaz2           +ea1
      ead1=qcy*dzxdxxpx1+wqy*dzxdxxpx2
      eae1=qcz*dzxdxxpx1+wqz*dzxdxxpx2+     xax2
      eaf1=qcy*dzxdxxpz1+wqy*dzxdxxpz2
      eba1=qcx*dzxdyypx1+wqx*dzxdyypx2+     zbx2           +eb1
      ebb1=qcy*dzxdyypy1+wqy*dzxdyypy2          +2.d0*reyy2+eb1
      ebc1=qcz*dzxdyypz1+wqz*dzxdyypz2+     xbz2           +eb1
      ebd1=qcx*dzxdyypy1+wqx*dzxdyypy2+     zby2
      ebe1=qcx*dzxdyypz1+wqx*dzxdyypz2+     zbz2
      ebf1=qcz*dzxdyypy1+wqz*dzxdyypy2+     xby2
      eca1=qcx*dzxdzzpx1+wqx*dzxdzzpx2+     zcx2           +ec1
      ecb1=qcy*dzxdzzpy1+wqy*dzxdzzpy2                     +ec1
      ecc1=qcz*dzxdzzpz1+wqz*dzxdzzpz2+     xcz2+2.d0*rezz2+ec1
      ecd1=qcy*dzxdzzpx1+wqy*dzxdzzpx2
      ece1=qcx*dzxdzzpz1+wqx*dzxdzzpz2+     zcz2
      ecf1=qcy*dzxdzzpz1+wqy*dzxdzzpz2
      eda1=qcx*dzxdyxpx1+wqx*dzxdyxpx2+     zdx2+     reyx2+ed1
      edb1=qcy*dzxdyxpy1+wqy*dzxdyxpy2          +     rexy2+ed1
      edc1=qcz*dzxdyxpz1+wqz*dzxdyxpz2+     xdz2           +ed1
      edd1=qcy*dzxdyxpx1+wqy*dzxdyxpx2          +     rexx2
      ede1=qcz*dzxdyxpx1+wqz*dzxdyxpx2+     xdx2
      edf1=qcz*dzxdyxpy1+wqz*dzxdyxpy2+     xdy2
      eea1=qcx*dzxdzxpx1+wqx*dzxdzxpx2+     zex2+     rezx2+ee1
      eeb1=qcy*dzxdzxpy1+wqy*dzxdzxpy2                     +ee1
      eec1=qcz*dzxdzxpz1+wqz*dzxdzxpz2+     xez2+     rexz2+ee1
      eed1=qcy*dzxdzxpx1+wqy*dzxdzxpx2
      eee1=qcx*dzxdzxpz1+wqx*dzxdzxpz2+     zez2+     rezz2
      eef1=qcy*dzxdzxpz1+wqy*dzxdzxpz2
      efa1=qcx*dzxdzypx1+wqx*dzxdzypx2+     zfx2           +ef1
      efb1=qcy*dzxdzypy1+wqy*dzxdzypy2          +     rezy2+ef1
      efc1=qcz*dzxdzypz1+wqz*dzxdzypz2+     xfz2+     reyz2+ef1
      efd1=qcy*dzxdzypx1+wqy*dzxdzypx2          +     rezx2
      efe1=qcx*dzxdzypz1+wqx*dzxdzypz2+     zfz2
      eff1=qcy*dzxdzypz1+wqy*dzxdzypz2          +     rezz2
      faa1=qcx*dzydxxpx1+wqx*dzydxxpx2          +2.d0*rfxx2+fa1
      fab1=qcy*dzydxxpy1+wqy*dzydxxpy2+     zay2           +fa1
      fac1=qcz*dzydxxpz1+wqz*dzydxxpz2+     yaz2           +fa1
      fad1=qcy*dzydxxpx1+wqy*dzydxxpx2+     zax2
      fae1=qcz*dzydxxpx1+wqz*dzydxxpx2+     yax2
      faf1=qcy*dzydxxpz1+wqy*dzydxxpz2+     zaz2
      fba1=qcx*dzydyypx1+wqx*dzydyypx2                     +fb1
      fbb1=qcy*dzydyypy1+wqy*dzydyypy2+     zby2+2.d0*rfyy2+fb1
      fbc1=qcz*dzydyypz1+wqz*dzydyypz2+     ybz2           +fb1
      fbd1=qcx*dzydyypy1+wqx*dzydyypy2
      fbe1=qcx*dzydyypz1+wqx*dzydyypz2
      fbf1=qcz*dzydyypy1+wqz*dzydyypy2+     yby2
      fca1=qcx*dzydzzpx1+wqx*dzydzzpx2                     +fc1
      fcb1=qcy*dzydzzpy1+wqy*dzydzzpy2+     zcy2           +fc1
      fcc1=qcz*dzydzzpz1+wqz*dzydzzpz2+     ycz2+2.d0*rfzz2+fc1
      fcd1=qcx*dzydzzpy1+wqx*dzydzzpy2
      fce1=qcx*dzydzzpz1+wqx*dzydzzpz2
      fcf1=qcy*dzydzzpz1+wqy*dzydzzpz2+     zcz2
      fda1=qcx*dzydyxpx1+wqx*dzydyxpx2          +     rfyx2+fd1
      fdb1=qcy*dzydyxpy1+wqy*dzydyxpy2+     zdy2+     rfxy2+fd1
      fdc1=qcz*dzydyxpz1+wqz*dzydyxpz2+     ydz2           +fd1
      fdd1=qcx*dzydyxpy1+wqx*dzydyxpy2          +     rfyy2
      fde1=qcx*dzydyxpz1+wqx*dzydyxpz2          +     rfyz2
      fdf1=qcz*dzydyxpy1+wqz*dzydyxpy2+     ydy2
      fea1=qcx*dzydzxpx1+wqx*dzydzxpx2          +     rfzx2+fe1
      feb1=qcy*dzydzxpy1+wqy*dzydzxpy2+     zey2           +fe1
      fec1=qcz*dzydzxpz1+wqz*dzydzxpz2+     yez2+     rfxz2+fe1
      fed1=qcy*dzydzxpx1+wqy*dzydzxpx2+     zex2
      fee1=qcx*dzydzxpz1+wqx*dzydzxpz2          +     rfzz2
      fef1=qcy*dzydzxpz1+wqy*dzydzxpz2+     zez2
      ffa1=qcx*dzydzypx1+wqx*dzydzypx2                     +ff1
      ffb1=qcy*dzydzypy1+wqy*dzydzypy2+     zfy2+     rfzy2+ff1
      ffc1=qcz*dzydzypz1+wqz*dzydzypz2+     yfz2+     rfyz2+ff1
      ffd1=qcx*dzydzypy1+wqx*dzydzypy2
      ffe1=qcx*dzydzypz1+wqx*dzydzypz2
      fff1=qcy*dzydzypz1+wqy*dzydzypz2+     zfz2+     rfzz2

      aaa2=qcx*dxxdxxpx2+wqx*dxxdxxpx3+2.d0*xax3+2.d0*raxx3+aa2
      aab2=qcy*dxxdxxpy2+wqy*dxxdxxpy3                     +aa2
      aac2=qcz*dxxdxxpz2+wqz*dxxdxxpz3                     +aa2
      aad2=qcy*dxxdxxpx2+wqy*dxxdxxpx3
      aae2=qcz*dxxdxxpx2+wqz*dxxdxxpx3
      aaf2=qcy*dxxdxxpz2+wqy*dxxdxxpz3
      aba2=qcx*dxxdyypx2+wqx*dxxdyypx3+2.d0*xbx3           +ab2
      abb2=qcy*dxxdyypy2+wqy*dxxdyypy3          +2.d0*rayy3+ab2
      abc2=qcz*dxxdyypz2+wqz*dxxdyypz3                     +ab2
      abd2=qcx*dxxdyypy2+wqx*dxxdyypy3+2.d0*xby3
      abe2=qcz*dxxdyypx2+wqz*dxxdyypx3
      abf2=qcz*dxxdyypy2+wqz*dxxdyypy3
      aca2=qcx*dxxdzzpx2+wqx*dxxdzzpx3+2.d0*xcx3           +ac2
      acb2=qcy*dxxdzzpy2+wqy*dxxdzzpy3                     +ac2
      acc2=qcz*dxxdzzpz2+wqz*dxxdzzpz3          +2.d0*razz3+ac2
      acd2=qcy*dxxdzzpx2+wqy*dxxdzzpx3
      ace2=qcx*dxxdzzpz2+wqx*dxxdzzpz3+2.d0*xcz3
      acf2=qcy*dxxdzzpz2+wqy*dxxdzzpz3
      ada2=qcx*dxxdyxpx2+wqx*dxxdyxpx3+2.d0*xdx3+     rayx3+ad2
      adb2=qcy*dxxdyxpy2+wqy*dxxdyxpy3          +     raxy3+ad2
      adc2=qcz*dxxdyxpz2+wqz*dxxdyxpz3                     +ad2
      add2=qcy*dxxdyxpx2+wqy*dxxdyxpx3          +     raxx3
      ade2=qcz*dxxdyxpx2+wqz*dxxdyxpx3
      adf2=qcz*dxxdyxpy2+wqz*dxxdyxpy3
      aea2=qcx*dxxdzxpx2+wqx*dxxdzxpx3+2.d0*xex3+     razx3+ae2
      aeb2=qcy*dxxdzxpy2+wqy*dxxdzxpy3                     +ae2
      aec2=qcz*dxxdzxpz2+wqz*dxxdzxpz3          +     raxz3+ae2
      aed2=qcy*dxxdzxpx2+wqy*dxxdzxpx3
      aee2=qcz*dxxdzxpx2+wqz*dxxdzxpx3          +     raxx3
      aef2=qcy*dxxdzxpz2+wqy*dxxdzxpz3
      afa2=qcx*dxxdzypx2+wqx*dxxdzypx3+2.d0*xfx3           +af2
      afb2=qcy*dxxdzypy2+wqy*dxxdzypy3          +     razy3+af2
      afc2=qcz*dxxdzypz2+wqz*dxxdzypz3          +     rayz3+af2
      afd2=qcy*dxxdzypx2+wqy*dxxdzypx3          +     razx3
      afe2=qcz*dxxdzypx2+wqz*dxxdzypx3          +     rayx3
      aff2=qcy*dxxdzypz2+wqy*dxxdzypz3          +     razz3
      baa2=qcx*dyydxxpx2+wqx*dyydxxpx3          +2.d0*rbxx3+ba2
      bab2=qcy*dyydxxpy2+wqy*dyydxxpy3+2.d0*yay3           +ba2
      bac2=qcz*dyydxxpz2+wqz*dyydxxpz3                     +ba2
      bad2=qcx*dyydxxpy2+wqx*dyydxxpy3          +2.d0*rbxy3
      bae2=qcz*dyydxxpx2+wqz*dyydxxpx3
      baf2=qcz*dyydxxpy2+wqz*dyydxxpy3
      bba2=qcx*dyydyypx2+wqx*dyydyypx3                     +bb2
      bbb2=qcy*dyydyypy2+wqy*dyydyypy3+2.d0*yby3+2.d0*rbyy3+bb2
      bbc2=qcz*dyydyypz2+wqz*dyydyypz3                     +bb2
      bbd2=qcx*dyydyypy2+wqx*dyydyypy3
      bbe2=qcx*dyydyypz2+wqx*dyydyypz3
      bbf2=qcz*dyydyypy2+wqz*dyydyypy3
      bca2=qcx*dyydzzpx2+wqx*dyydzzpx3                     +bc2
      bcb2=qcy*dyydzzpy2+wqy*dyydzzpy3+2.d0*ycy3           +bc2
      bcc2=qcz*dyydzzpz2+wqz*dyydzzpz3          +2.d0*rbzz3+bc2
      bcd2=qcx*dyydzzpy2+wqx*dyydzzpy3
      bce2=qcx*dyydzzpz2+wqx*dyydzzpz3
      bcf2=qcy*dyydzzpz2+wqy*dyydzzpz3+2.d0*ycz3
      bda2=qcx*dyydyxpx2+wqx*dyydyxpx3          +     rbyx3+bd2
      bdb2=qcy*dyydyxpy2+wqy*dyydyxpy3+2.d0*ydy3+     rbxy3+bd2
      bdc2=qcz*dyydyxpz2+wqz*dyydyxpz3                     +bd2
      bdd2=qcx*dyydyxpy2+wqx*dyydyxpy3          +     rbyy3
      bde2=qcz*dyydyxpx2+wqz*dyydyxpx3
      bdf2=qcz*dyydyxpy2+wqz*dyydyxpy3
      bea2=qcx*dyydzxpx2+wqx*dyydzxpx3          +     rbzx3+be2
      beb2=qcy*dyydzxpy2+wqy*dyydzxpy3+2.d0*yey3           +be2
      bec2=qcz*dyydzxpz2+wqz*dyydzxpz3          +     rbxz3+be2
      bed2=qcx*dyydzxpy2+wqx*dyydzxpy3          +     rbzy3
      bee2=qcx*dyydzxpz2+wqx*dyydzxpz3          +     rbzz3
      bef2=qcz*dyydzxpy2+wqz*dyydzxpy3          +     rbxy3
      bfa2=qcx*dyydzypx2+wqx*dyydzypx3                     +bf2
      bfb2=qcy*dyydzypy2+wqy*dyydzypy3+2.d0*yfy3+     rbzy3+bf2
      bfc2=qcz*dyydzypz2+wqz*dyydzypz3          +     rbyz3+bf2
      bfd2=qcx*dyydzypy2+wqx*dyydzypy3
      bfe2=qcx*dyydzypz2+wqx*dyydzypz3
      bff2=qcz*dyydzypy2+wqz*dyydzypy3          +     rbyy3
      caa2=qcx*dzzdxxpx2+wqx*dzzdxxpx3          +2.d0*rcxx3+ca2
      cab2=qcy*dzzdxxpy2+wqy*dzzdxxpy3                     +ca2
      cac2=qcz*dzzdxxpz2+wqz*dzzdxxpz3+2.d0*zaz3           +ca2
      cad2=qcy*dzzdxxpx2+wqy*dzzdxxpx3
      cae2=qcx*dzzdxxpz2+wqx*dzzdxxpz3          +2.d0*rcxz3
      caf2=qcy*dzzdxxpz2+wqy*dzzdxxpz3
      cba2=qcx*dzzdyypx2+wqx*dzzdyypx3                     +cb2
      cbb2=qcy*dzzdyypy2+wqy*dzzdyypy3          +2.d0*rcyy3+cb2
      cbc2=qcz*dzzdyypz2+wqz*dzzdyypz3+2.d0*zbz3           +cb2
      cbd2=qcx*dzzdyypy2+wqx*dzzdyypy3
      cbe2=qcx*dzzdyypz2+wqx*dzzdyypz3
      cbf2=qcy*dzzdyypz2+wqy*dzzdyypz3          +2.d0*rcyz3
      cca2=qcx*dzzdzzpx2+wqx*dzzdzzpx3                     +cc2
      ccb2=qcy*dzzdzzpy2+wqy*dzzdzzpy3                     +cc2
      ccc2=qcz*dzzdzzpz2+wqz*dzzdzzpz3+2.d0*zcz3+2.d0*rczz3+cc2
      ccd2=qcx*dzzdzzpy2+wqx*dzzdzzpy3
      cce2=qcx*dzzdzzpz2+wqx*dzzdzzpz3
      ccf2=qcy*dzzdzzpz2+wqy*dzzdzzpz3
      cda2=qcx*dzzdyxpx2+wqx*dzzdyxpx3          +     rcyx3+cd2
      cdb2=qcy*dzzdyxpy2+wqy*dzzdyxpy3          +     rcxy3+cd2
      cdc2=qcz*dzzdyxpz2+wqz*dzzdyxpz3+2.d0*zdz3           +cd2
      cdd2=qcx*dzzdyxpy2+wqx*dzzdyxpy3          +     rcyy3
      cde2=qcx*dzzdyxpz2+wqx*dzzdyxpz3          +     rcyz3
      cdf2=qcy*dzzdyxpz2+wqy*dzzdyxpz3          +     rcxz3
      cea2=qcx*dzzdzxpx2+wqx*dzzdzxpx3          +     rczx3+ce2
      ceb2=qcy*dzzdzxpy2+wqy*dzzdzxpy3                     +ce2
      cec2=qcz*dzzdzxpz2+wqz*dzzdzxpz3+2.d0*zez3+     rcxz3+ce2
      ced2=qcy*dzzdzxpx2+wqy*dzzdzxpx3
      cee2=qcx*dzzdzxpz2+wqx*dzzdzxpz3          +     rczz3
      cef2=qcy*dzzdzxpz2+wqy*dzzdzxpz3
      cfa2=qcx*dzzdzypx2+wqx*dzzdzypx3                     +cf2
      cfb2=qcy*dzzdzypy2+wqy*dzzdzypy3          +     rczy3+cf2
      cfc2=qcz*dzzdzypz2+wqz*dzzdzypz3+2.d0*zfz3+     rcyz3+cf2
      cfd2=qcx*dzzdzypy2+wqx*dzzdzypy3
      cfe2=qcx*dzzdzypz2+wqx*dzzdzypz3
      cff2=qcy*dzzdzypz2+wqy*dzzdzypz3          +     rczz3
      daa2=qcx*dyxdxxpx2+wqx*dyxdxxpx3+     yax3+2.d0*rdxx3+da2
      dab2=qcy*dyxdxxpy2+wqy*dyxdxxpy3+     xay3           +da2
      dac2=qcz*dyxdxxpz2+wqz*dyxdxxpz3                     +da2
      dad2=qcy*dyxdxxpx2+wqy*dyxdxxpx3+     xax3
      dae2=qcz*dyxdxxpx2+wqz*dyxdxxpx3
      daf2=qcz*dyxdxxpy2+wqz*dyxdxxpy3
      dba2=qcx*dyxdyypx2+wqx*dyxdyypx3+     ybx3           +db2
      dbb2=qcy*dyxdyypy2+wqy*dyxdyypy3+     xby3+2.d0*rdyy3+db2
      dbc2=qcz*dyxdyypz2+wqz*dyxdyypz3                     +db2
      dbd2=qcx*dyxdyypy2+wqx*dyxdyypy3+     yby3
      dbe2=qcz*dyxdyypx2+wqz*dyxdyypx3
      dbf2=qcz*dyxdyypy2+wqz*dyxdyypy3
      dca2=qcx*dyxdzzpx2+wqx*dyxdzzpx3+     ycx3           +dc2
      dcb2=qcy*dyxdzzpy2+wqy*dyxdzzpy3+     xcy3           +dc2
      dcc2=qcz*dyxdzzpz2+wqz*dyxdzzpz3          +2.d0*rdzz3+dc2
      dcd2=qcx*dyxdzzpy2+wqx*dyxdzzpy3+     ycy3
      dce2=qcx*dyxdzzpz2+wqx*dyxdzzpz3+     ycz3
      dcf2=qcy*dyxdzzpz2+wqy*dyxdzzpz3+     xcz3
      dda2=qcx*dyxdyxpx2+wqx*dyxdyxpx3+     ydx3+     rdyx3+dd2
      ddb2=qcy*dyxdyxpy2+wqy*dyxdyxpy3+     xdy3+     rdxy3+dd2
      ddc2=qcz*dyxdyxpz2+wqz*dyxdyxpz3                     +dd2
      ddd2=qcx*dyxdyxpy2+wqx*dyxdyxpy3+     ydy3+     rdyy3
      dde2=qcz*dyxdyxpx2+wqz*dyxdyxpx3
      ddf2=qcz*dyxdyxpy2+wqz*dyxdyxpy3
      dea2=qcx*dyxdzxpx2+wqx*dyxdzxpx3+     yex3+     rdzx3+de2
      deb2=qcy*dyxdzxpy2+wqy*dyxdzxpy3+     xey3           +de2
      dec2=qcz*dyxdzxpz2+wqz*dyxdzxpz3          +     rdxz3+de2
      ded2=qcy*dyxdzxpx2+wqy*dyxdzxpx3+     xex3
      dee2=qcz*dyxdzxpx2+wqz*dyxdzxpx3          +     rdxx3
      def2=qcy*dyxdzxpz2+wqy*dyxdzxpz3+     xez3
      dfa2=qcx*dyxdzypx2+wqx*dyxdzypx3+     yfx3           +df2
      dfb2=qcy*dyxdzypy2+wqy*dyxdzypy3+     xfy3+     rdzy3+df2
      dfc2=qcz*dyxdzypz2+wqz*dyxdzypz3          +     rdyz3+df2
      dfd2=qcx*dyxdzypy2+wqx*dyxdzypy3+     yfy3
      dfe2=qcx*dyxdzypz2+wqx*dyxdzypz3+     yfz3
      dff2=qcz*dyxdzypy2+wqz*dyxdzypy3          +     rdyy3
      eaa2=qcx*dzxdxxpx2+wqx*dzxdxxpx3+     zax3+2.d0*rexx3+ea2
      eab2=qcy*dzxdxxpy2+wqy*dzxdxxpy3                     +ea2
      eac2=qcz*dzxdxxpz2+wqz*dzxdxxpz3+     xaz3           +ea2
      ead2=qcy*dzxdxxpx2+wqy*dzxdxxpx3
      eae2=qcz*dzxdxxpx2+wqz*dzxdxxpx3+     xax3
      eaf2=qcy*dzxdxxpz2+wqy*dzxdxxpz3
      eba2=qcx*dzxdyypx2+wqx*dzxdyypx3+     zbx3           +eb2
      ebb2=qcy*dzxdyypy2+wqy*dzxdyypy3          +2.d0*reyy3+eb2
      ebc2=qcz*dzxdyypz2+wqz*dzxdyypz3+     xbz3           +eb2
      ebd2=qcx*dzxdyypy2+wqx*dzxdyypy3+     zby3
      ebe2=qcx*dzxdyypz2+wqx*dzxdyypz3+     zbz3
      ebf2=qcz*dzxdyypy2+wqz*dzxdyypy3+     xby3
      eca2=qcx*dzxdzzpx2+wqx*dzxdzzpx3+     zcx3           +ec2
      ecb2=qcy*dzxdzzpy2+wqy*dzxdzzpy3                     +ec2
      ecc2=qcz*dzxdzzpz2+wqz*dzxdzzpz3+     xcz3+2.d0*rezz3+ec2
      ecd2=qcy*dzxdzzpx2+wqy*dzxdzzpx3
      ece2=qcx*dzxdzzpz2+wqx*dzxdzzpz3+     zcz3
      ecf2=qcy*dzxdzzpz2+wqy*dzxdzzpz3
      eda2=qcx*dzxdyxpx2+wqx*dzxdyxpx3+     zdx3+     reyx3+ed2
      edb2=qcy*dzxdyxpy2+wqy*dzxdyxpy3          +     rexy3+ed2
      edc2=qcz*dzxdyxpz2+wqz*dzxdyxpz3+     xdz3           +ed2
      edd2=qcy*dzxdyxpx2+wqy*dzxdyxpx3          +     rexx3
      ede2=qcz*dzxdyxpx2+wqz*dzxdyxpx3+     xdx3
      edf2=qcz*dzxdyxpy2+wqz*dzxdyxpy3+     xdy3
      eea2=qcx*dzxdzxpx2+wqx*dzxdzxpx3+     zex3+     rezx3+ee2
      eeb2=qcy*dzxdzxpy2+wqy*dzxdzxpy3                     +ee2
      eec2=qcz*dzxdzxpz2+wqz*dzxdzxpz3+     xez3+     rexz3+ee2
      eed2=qcy*dzxdzxpx2+wqy*dzxdzxpx3
      eee2=qcx*dzxdzxpz2+wqx*dzxdzxpz3+     zez3+     rezz3
      eef2=qcy*dzxdzxpz2+wqy*dzxdzxpz3
      efa2=qcx*dzxdzypx2+wqx*dzxdzypx3+     zfx3           +ef2
      efb2=qcy*dzxdzypy2+wqy*dzxdzypy3          +     rezy3+ef2
      efc2=qcz*dzxdzypz2+wqz*dzxdzypz3+     xfz3+     reyz3+ef2
      efd2=qcy*dzxdzypx2+wqy*dzxdzypx3          +     rezx3
      efe2=qcx*dzxdzypz2+wqx*dzxdzypz3+     zfz3
      eff2=qcy*dzxdzypz2+wqy*dzxdzypz3          +     rezz3
      faa2=qcx*dzydxxpx2+wqx*dzydxxpx3          +2.d0*rfxx3+fa2
      fab2=qcy*dzydxxpy2+wqy*dzydxxpy3+     zay3           +fa2
      fac2=qcz*dzydxxpz2+wqz*dzydxxpz3+     yaz3           +fa2
      fad2=qcy*dzydxxpx2+wqy*dzydxxpx3+     zax3
      fae2=qcz*dzydxxpx2+wqz*dzydxxpx3+     yax3
      faf2=qcy*dzydxxpz2+wqy*dzydxxpz3+     zaz3
      fba2=qcx*dzydyypx2+wqx*dzydyypx3                     +fb2
      fbb2=qcy*dzydyypy2+wqy*dzydyypy3+     zby3+2.d0*rfyy3+fb2
      fbc2=qcz*dzydyypz2+wqz*dzydyypz3+     ybz3           +fb2
      fbd2=qcx*dzydyypy2+wqx*dzydyypy3
      fbe2=qcx*dzydyypz2+wqx*dzydyypz3
      fbf2=qcz*dzydyypy2+wqz*dzydyypy3+     yby3
      fca2=qcx*dzydzzpx2+wqx*dzydzzpx3                     +fc2
      fcb2=qcy*dzydzzpy2+wqy*dzydzzpy3+     zcy3           +fc2
      fcc2=qcz*dzydzzpz2+wqz*dzydzzpz3+     ycz3+2.d0*rfzz3+fc2
      fcd2=qcx*dzydzzpy2+wqx*dzydzzpy3
      fce2=qcx*dzydzzpz2+wqx*dzydzzpz3
      fcf2=qcy*dzydzzpz2+wqy*dzydzzpz3+     zcz3
      fda2=qcx*dzydyxpx2+wqx*dzydyxpx3          +     rfyx3+fd2
      fdb2=qcy*dzydyxpy2+wqy*dzydyxpy3+     zdy3+     rfxy3+fd2
      fdc2=qcz*dzydyxpz2+wqz*dzydyxpz3+     ydz3           +fd2
      fdd2=qcx*dzydyxpy2+wqx*dzydyxpy3          +     rfyy3
      fde2=qcx*dzydyxpz2+wqx*dzydyxpz3          +     rfyz3
      fdf2=qcz*dzydyxpy2+wqz*dzydyxpy3+     ydy3
      fea2=qcx*dzydzxpx2+wqx*dzydzxpx3          +     rfzx3+fe2
      feb2=qcy*dzydzxpy2+wqy*dzydzxpy3+     zey3           +fe2
      fec2=qcz*dzydzxpz2+wqz*dzydzxpz3+     yez3+     rfxz3+fe2
      fed2=qcy*dzydzxpx2+wqy*dzydzxpx3+     zex3
      fee2=qcx*dzydzxpz2+wqx*dzydzxpz3          +     rfzz3
      fef2=qcy*dzydzxpz2+wqy*dzydzxpz3+     zez3
      ffa2=qcx*dzydzypx2+wqx*dzydzypx3                     +ff2
      ffb2=qcy*dzydzypy2+wqy*dzydzypy3+     zfy3+     rfzy3+ff2
      ffc2=qcz*dzydzypz2+wqz*dzydzypz3+     yfz3+     rfyz3+ff2
      ffd2=qcx*dzydzypy2+wqx*dzydzypy3
      ffe2=qcx*dzydzypz2+wqx*dzydzypz3
      fff2=qcy*dzydzypz2+wqy*dzydzypz3+     zfz3+     rfzz3

!rsdds(2)
      rxxdxxd2 = rkp * xxdxxd2
      rxxdyyd2 = rkp * xxdyyd2
      rxxdzzd2 = rkp * xxdzzd2
      rxxdyxd2 = rkp * xxdyxd2
      rxxdzxd2 = rkp * xxdzxd2
      rxxdzyd2 = rkp * xxdzyd2
      ryydxxd2 = rkp * yydxxd2
      ryydyyd2 = rkp * yydyyd2
      ryydzzd2 = rkp * yydzzd2
      ryydyxd2 = rkp * yydyxd2
      ryydzxd2 = rkp * yydzxd2
      ryydzyd2 = rkp * yydzyd2
      rzzdxxd2 = rkp * zzdxxd2
      rzzdyyd2 = rkp * zzdyyd2
      rzzdzzd2 = rkp * zzdzzd2
      rzzdyxd2 = rkp * zzdyxd2
      rzzdzxd2 = rkp * zzdzxd2
      rzzdzyd2 = rkp * zzdzyd2
      ryxdxxd2 = rkp * yxdxxd2
      ryxdyyd2 = rkp * yxdyyd2
      ryxdzzd2 = rkp * yxdzzd2
      ryxdyxd2 = rkp * yxdyxd2
      ryxdzxd2 = rkp * yxdzxd2
      ryxdzyd2 = rkp * yxdzyd2
      rzxdxxd2 = rkp * zxdxxd2
      rzxdyyd2 = rkp * zxdyyd2
      rzxdzzd2 = rkp * zxdzzd2
      rzxdyxd2 = rkp * zxdyxd2
      rzxdzxd2 = rkp * zxdzxd2
      rzxdzyd2 = rkp * zxdzyd2
      rzydxxd2 = rkp * zydxxd2
      rzydyyd2 = rkp * zydyyd2
      rzydzzd2 = rkp * zydzzd2
      rzydyxd2 = rkp * zydyxd2
      rzydzxd2 = rkp * zydzxd2
      rzydzyd2 = rkp * zydzyd2
!rppds(2)
      rxxdxx2 = rkp*xxdxx2
      rxxdyy2 = rkp*xxdyy2
      rxxdzz2 = rkp*xxdzz2
      rxxdyx2 = rkp*xxdyx2
      rxxdzx2 = rkp*xxdzx2
      rxxdzy2 = rkp*xxdzy2
      rxydxx2 = rkp*xydxx2
      rxydyy2 = rkp*xydyy2
      rxydzz2 = rkp*xydzz2
      rxydyx2 = rkp*xydyx2
      rxydzx2 = rkp*xydzx2
      rxydzy2 = rkp*xydzy2
      rxzdxx2 = rkp*xzdxx2
      rxzdyy2 = rkp*xzdyy2
      rxzdzz2 = rkp*xzdzz2
      rxzdyx2 = rkp*xzdyx2
      rxzdzx2 = rkp*xzdzx2
      rxzdzy2 = rkp*xzdzy2
      ryxdxx2 = rkp*yxdxx2
      ryxdyy2 = rkp*yxdyy2
      ryxdzz2 = rkp*yxdzz2
      ryxdyx2 = rkp*yxdyx2
      ryxdzx2 = rkp*yxdzx2
      ryxdzy2 = rkp*yxdzy2
      ryydxx2 = rkp*yydxx2
      ryydyy2 = rkp*yydyy2
      ryydzz2 = rkp*yydzz2
      ryydyx2 = rkp*yydyx2
      ryydzx2 = rkp*yydzx2
      ryydzy2 = rkp*yydzy2
      ryzdxx2 = rkp*yzdxx2
      ryzdyy2 = rkp*yzdyy2
      ryzdzz2 = rkp*yzdzz2
      ryzdyx2 = rkp*yzdyx2
      ryzdzx2 = rkp*yzdzx2
      ryzdzy2 = rkp*yzdzy2
      rzxdxx2 = rkp*zxdxx2
      rzxdyy2 = rkp*zxdyy2
      rzxdzz2 = rkp*zxdzz2
      rzxdyx2 = rkp*zxdyx2
      rzxdzx2 = rkp*zxdzx2
      rzxdzy2 = rkp*zxdzy2
      rzydxx2 = rkp*zydxx2
      rzydyy2 = rkp*zydyy2
      rzydzz2 = rkp*zydzz2
      rzydyx2 = rkp*zydyx2
      rzydzx2 = rkp*zydzx2
      rzydzy2 = rkp*zydzy2
      rzzdxx2 = rkp*zzdxx2
      rzzdyy2 = rkp*zzdyy2
      rzzdzz2 = rkp*zzdzz2
      rzzdyx2 = rkp*zzdyx2
      rzzdzx2 = rkp*zzdzx2
      rzzdzy2 = rkp*zzdzy2

!pdps01(12)
      pxdxxpx= eta *(pxdxxpx1 - rooe * pxdxxpx2)
      pxdxxpy= eta *(pxdxxpy1 - rooe * pxdxxpy2)
      pxdxxpz= eta *(pxdxxpz1 - rooe * pxdxxpz2)
      pxdyypx= eta *(pxdyypx1 - rooe * pxdyypx2)
      pxdyypy= eta *(pxdyypy1 - rooe * pxdyypy2)
      pxdyypz= eta *(pxdyypz1 - rooe * pxdyypz2)
      pxdzzpx= eta *(pxdzzpx1 - rooe * pxdzzpx2)
      pxdzzpy= eta *(pxdzzpy1 - rooe * pxdzzpy2)
      pxdzzpz= eta *(pxdzzpz1 - rooe * pxdzzpz2)
      pxdyxpx= eta *(pxdyxpx1 - rooe * pxdyxpx2)
      pxdyxpy= eta *(pxdyxpy1 - rooe * pxdyxpy2)
      pxdyxpz= eta *(pxdyxpz1 - rooe * pxdyxpz2)
      pxdzxpx= eta *(pxdzxpx1 - rooe * pxdzxpx2)
      pxdzxpy= eta *(pxdzxpy1 - rooe * pxdzxpy2)
      pxdzxpz= eta *(pxdzxpz1 - rooe * pxdzxpz2)
      pxdzypx= eta *(pxdzypx1 - rooe * pxdzypx2)
      pxdzypy= eta *(pxdzypy1 - rooe * pxdzypy2)
      pxdzypz= eta *(pxdzypz1 - rooe * pxdzypz2)
      pydxxpx= eta *(pydxxpx1 - rooe * pydxxpx2)
      pydxxpy= eta *(pydxxpy1 - rooe * pydxxpy2)
      pydxxpz= eta *(pydxxpz1 - rooe * pydxxpz2)
      pydyypx= eta *(pydyypx1 - rooe * pydyypx2)
      pydyypy= eta *(pydyypy1 - rooe * pydyypy2)
      pydyypz= eta *(pydyypz1 - rooe * pydyypz2)
      pydzzpx= eta *(pydzzpx1 - rooe * pydzzpx2)
      pydzzpy= eta *(pydzzpy1 - rooe * pydzzpy2)
      pydzzpz= eta *(pydzzpz1 - rooe * pydzzpz2)
      pydyxpx= eta *(pydyxpx1 - rooe * pydyxpx2)
      pydyxpy= eta *(pydyxpy1 - rooe * pydyxpy2)
      pydyxpz= eta *(pydyxpz1 - rooe * pydyxpz2)
      pydzxpx= eta *(pydzxpx1 - rooe * pydzxpx2)
      pydzxpy= eta *(pydzxpy1 - rooe * pydzxpy2)
      pydzxpz= eta *(pydzxpz1 - rooe * pydzxpz2)
      pydzypx= eta *(pydzypx1 - rooe * pydzypx2)
      pydzypy= eta *(pydzypy1 - rooe * pydzypy2)
      pydzypz= eta *(pydzypz1 - rooe * pydzypz2)
      pzdxxpx= eta *(pzdxxpx1 - rooe * pzdxxpx2)
      pzdxxpy= eta *(pzdxxpy1 - rooe * pzdxxpy2)
      pzdxxpz= eta *(pzdxxpz1 - rooe * pzdxxpz2)
      pzdyypx= eta *(pzdyypx1 - rooe * pzdyypx2)
      pzdyypy= eta *(pzdyypy1 - rooe * pzdyypy2)
      pzdyypz= eta *(pzdyypz1 - rooe * pzdyypz2)
      pzdzzpx= eta *(pzdzzpx1 - rooe * pzdzzpx2)
      pzdzzpy= eta *(pzdzzpy1 - rooe * pzdzzpy2)
      pzdzzpz= eta *(pzdzzpz1 - rooe * pzdzzpz2)
      pzdyxpx= eta *(pzdyxpx1 - rooe * pzdyxpx2)
      pzdyxpy= eta *(pzdyxpy1 - rooe * pzdyxpy2)
      pzdyxpz= eta *(pzdyxpz1 - rooe * pzdyxpz2)
      pzdzxpx= eta *(pzdzxpx1 - rooe * pzdzxpx2)
      pzdzxpy= eta *(pzdzxpy1 - rooe * pzdzxpy2)
      pzdzxpz= eta *(pzdzxpz1 - rooe * pzdzxpz2)
      pzdzypx= eta *(pzdzypx1 - rooe * pzdzypx2)
      pzdzypy= eta *(pzdzypy1 - rooe * pzdzypy2)
      pzdzypz= eta *(pzdzypz1 - rooe * pzdzypz2)
!pddp(1)
      xaax1=qdx*xdxxdxx1+wqx*xdxxdxx2+rxxdxxd2+2.d0*rxxdxx2+2.d0*pxdxxpx
      xaay1=qdy*xdxxdxx1+wqy*xdxxdxx2
      xaaz1=qdz*xdxxdxx1+wqz*xdxxdxx2
      xabx1=qdx*xdxxdyy1+wqx*xdxxdyy2+rxxdyyd2+2.d0*rxxdyy2
      xaby1=qdy*xdxxdyy1+wqy*xdxxdyy2                      +2.d0*pxdxxpy
      xabz1=qdz*xdxxdyy1+wqz*xdxxdyy2                      
      xacx1=qdx*xdxxdzz1+wqx*xdxxdzz2+rxxdzzd2+2.d0*rxxdzz2
      xacy1=qdy*xdxxdzz1+wqy*xdxxdzz2                      
      xacz1=qdz*xdxxdzz1+wqz*xdxxdzz2                      +2.d0*pxdxxpz
      xadx1=qdx*xdxxdyx1+wqx*xdxxdyx2+rxxdyxd2+2.d0*rxxdyx2+1.d0*pxdxxpy
      xady1=qdy*xdxxdyx1+wqy*xdxxdyx2                      +1.d0*pxdxxpx
      xadz1=qdz*xdxxdyx1+wqz*xdxxdyx2                      
      xaex1=qdx*xdxxdzx1+wqx*xdxxdzx2+rxxdzxd2+2.d0*rxxdzx2+1.d0*pxdxxpz
      xaey1=qdy*xdxxdzx1+wqy*xdxxdzx2                      
      xaez1=qdz*xdxxdzx1+wqz*xdxxdzx2                      +1.d0*pxdxxpx
      xafx1=qdx*xdxxdzy1+wqx*xdxxdzy2+rxxdzyd2+2.d0*rxxdzy2
      xafy1=qdy*xdxxdzy1+wqy*xdxxdzy2                      +1.d0*pxdxxpz
      xafz1=qdz*xdxxdzy1+wqz*xdxxdzy2                      +1.d0*pxdxxpy
      xbax1=qdx*xdyydxx1+wqx*xdyydxx2+ryydxxd2             +2.d0*pxdyypx
      xbay1=qdy*xdyydxx1+wqy*xdyydxx2         +2.d0*rxydxx2
      xbaz1=qdz*xdyydxx1+wqz*xdyydxx2                      
      xbbx1=qdx*xdyydyy1+wqx*xdyydyy2+ryydyyd2             
      xbby1=qdy*xdyydyy1+wqy*xdyydyy2         +2.d0*rxydyy2+2.d0*pxdyypy
      xbbz1=qdz*xdyydyy1+wqz*xdyydyy2                      
      xbcx1=qdx*xdyydzz1+wqx*xdyydzz2+ryydzzd2             
      xbcy1=qdy*xdyydzz1+wqy*xdyydzz2         +2.d0*rxydzz2
      xbcz1=qdz*xdyydzz1+wqz*xdyydzz2                      +2.d0*pxdyypz
      xbdx1=qdx*xdyydyx1+wqx*xdyydyx2+ryydyxd2             +1.d0*pxdyypy
      xbdy1=qdy*xdyydyx1+wqy*xdyydyx2         +2.d0*rxydyx2+1.d0*pxdyypx
      xbdz1=qdz*xdyydyx1+wqz*xdyydyx2                      
      xbex1=qdx*xdyydzx1+wqx*xdyydzx2+ryydzxd2             +1.d0*pxdyypz
      xbey1=qdy*xdyydzx1+wqy*xdyydzx2         +2.d0*rxydzx2
      xbez1=qdz*xdyydzx1+wqz*xdyydzx2                      +1.d0*pxdyypx
      xbfx1=qdx*xdyydzy1+wqx*xdyydzy2+ryydzyd2             
      xbfy1=qdy*xdyydzy1+wqy*xdyydzy2         +2.d0*rxydzy2+1.d0*pxdyypz
      xbfz1=qdz*xdyydzy1+wqz*xdyydzy2                      +1.d0*pxdyypy
      xcax1=qdx*xdzzdxx1+wqx*xdzzdxx2+rzzdxxd2             +2.d0*pxdzzpx
      xcay1=qdy*xdzzdxx1+wqy*xdzzdxx2                      
      xcaz1=qdz*xdzzdxx1+wqz*xdzzdxx2         +2.d0*rxzdxx2
      xcbx1=qdx*xdzzdyy1+wqx*xdzzdyy2+rzzdyyd2             
      xcby1=qdy*xdzzdyy1+wqy*xdzzdyy2                      +2.d0*pxdzzpy
      xcbz1=qdz*xdzzdyy1+wqz*xdzzdyy2         +2.d0*rxzdyy2
      xccx1=qdx*xdzzdzz1+wqx*xdzzdzz2+rzzdzzd2             
      xccy1=qdy*xdzzdzz1+wqy*xdzzdzz2                      
      xccz1=qdz*xdzzdzz1+wqz*xdzzdzz2         +2.d0*rxzdzz2+2.d0*pxdzzpz
      xcdx1=qdx*xdzzdyx1+wqx*xdzzdyx2+rzzdyxd2             +1.d0*pxdzzpy
      xcdy1=qdy*xdzzdyx1+wqy*xdzzdyx2                      +1.d0*pxdzzpx
      xcdz1=qdz*xdzzdyx1+wqz*xdzzdyx2         +2.d0*rxzdyx2
      xcex1=qdx*xdzzdzx1+wqx*xdzzdzx2+rzzdzxd2             +1.d0*pxdzzpz
      xcey1=qdy*xdzzdzx1+wqy*xdzzdzx2                      
      xcez1=qdz*xdzzdzx1+wqz*xdzzdzx2         +2.d0*rxzdzx2+1.d0*pxdzzpx
      xcfx1=qdx*xdzzdzy1+wqx*xdzzdzy2+rzzdzyd2             
      xcfy1=qdy*xdzzdzy1+wqy*xdzzdzy2                      +1.d0*pxdzzpz
      xcfz1=qdz*xdzzdzy1+wqz*xdzzdzy2         +2.d0*rxzdzy2+1.d0*pxdzzpy
      xdax1=qdx*xdyxdxx1+wqx*xdyxdxx2+ryxdxxd2+1.d0*rxydxx2+2.d0*pxdyxpx
      xday1=qdy*xdyxdxx1+wqy*xdyxdxx2         +1.d0*rxxdxx2
      xdaz1=qdz*xdyxdxx1+wqz*xdyxdxx2                      
      xdbx1=qdx*xdyxdyy1+wqx*xdyxdyy2+ryxdyyd2+1.d0*rxydyy2
      xdby1=qdy*xdyxdyy1+wqy*xdyxdyy2         +1.d0*rxxdyy2+2.d0*pxdyxpy
      xdbz1=qdz*xdyxdyy1+wqz*xdyxdyy2                      
      xdcx1=qdx*xdyxdzz1+wqx*xdyxdzz2+ryxdzzd2+1.d0*rxydzz2
      xdcy1=qdy*xdyxdzz1+wqy*xdyxdzz2         +1.d0*rxxdzz2
      xdcz1=qdz*xdyxdzz1+wqz*xdyxdzz2                      +2.d0*pxdyxpz
      xddx1=qdx*xdyxdyx1+wqx*xdyxdyx2+ryxdyxd2+1.d0*rxydyx2+1.d0*pxdyxpy
      xddy1=qdy*xdyxdyx1+wqy*xdyxdyx2         +1.d0*rxxdyx2+1.d0*pxdyxpx
      xddz1=qdz*xdyxdyx1+wqz*xdyxdyx2                      
      xdex1=qdx*xdyxdzx1+wqx*xdyxdzx2+ryxdzxd2+1.d0*rxydzx2+1.d0*pxdyxpz
      xdey1=qdy*xdyxdzx1+wqy*xdyxdzx2         +1.d0*rxxdzx2
      xdez1=qdz*xdyxdzx1+wqz*xdyxdzx2                      +1.d0*pxdyxpx
      xdfx1=qdx*xdyxdzy1+wqx*xdyxdzy2+ryxdzyd2+1.d0*rxydzy2
      xdfy1=qdy*xdyxdzy1+wqy*xdyxdzy2         +1.d0*rxxdzy2+1.d0*pxdyxpz
      xdfz1=qdz*xdyxdzy1+wqz*xdyxdzy2                      +1.d0*pxdyxpy
      xeax1=qdx*xdzxdxx1+wqx*xdzxdxx2+rzxdxxd2+1.d0*rxzdxx2+2.d0*pxdzxpx
      xeay1=qdy*xdzxdxx1+wqy*xdzxdxx2                      
      xeaz1=qdz*xdzxdxx1+wqz*xdzxdxx2         +1.d0*rxxdxx2
      xebx1=qdx*xdzxdyy1+wqx*xdzxdyy2+rzxdyyd2+1.d0*rxzdyy2
      xeby1=qdy*xdzxdyy1+wqy*xdzxdyy2                      +2.d0*pxdzxpy
      xebz1=qdz*xdzxdyy1+wqz*xdzxdyy2         +1.d0*rxxdyy2
      xecx1=qdx*xdzxdzz1+wqx*xdzxdzz2+rzxdzzd2+1.d0*rxzdzz2
      xecy1=qdy*xdzxdzz1+wqy*xdzxdzz2                      
      xecz1=qdz*xdzxdzz1+wqz*xdzxdzz2         +1.d0*rxxdzz2+2.d0*pxdzxpz
      xedx1=qdx*xdzxdyx1+wqx*xdzxdyx2+rzxdyxd2+1.d0*rxzdyx2+1.d0*pxdzxpy
      xedy1=qdy*xdzxdyx1+wqy*xdzxdyx2                      +1.d0*pxdzxpx
      xedz1=qdz*xdzxdyx1+wqz*xdzxdyx2         +1.d0*rxxdyx2
      xeex1=qdx*xdzxdzx1+wqx*xdzxdzx2+rzxdzxd2+1.d0*rxzdzx2+1.d0*pxdzxpz
      xeey1=qdy*xdzxdzx1+wqy*xdzxdzx2                      
      xeez1=qdz*xdzxdzx1+wqz*xdzxdzx2         +1.d0*rxxdzx2+1.d0*pxdzxpx
      xefx1=qdx*xdzxdzy1+wqx*xdzxdzy2+rzxdzyd2+1.d0*rxzdzy2
      xefy1=qdy*xdzxdzy1+wqy*xdzxdzy2                      +1.d0*pxdzxpz
      xefz1=qdz*xdzxdzy1+wqz*xdzxdzy2         +1.d0*rxxdzy2+1.d0*pxdzxpy
           
      xfax1=qdx*xdzydxx1+wqx*xdzydxx2+rzydxxd2             +2.d0*pxdzypx
      xfay1=qdy*xdzydxx1+wqy*xdzydxx2         +1.d0*rxzdxx2
      xfaz1=qdz*xdzydxx1+wqz*xdzydxx2         +1.d0*rxydxx2
      xfbx1=qdx*xdzydyy1+wqx*xdzydyy2+rzydyyd2             
      xfby1=qdy*xdzydyy1+wqy*xdzydyy2         +1.d0*rxzdyy2+2.d0*pxdzypy
      xfbz1=qdz*xdzydyy1+wqz*xdzydyy2         +1.d0*rxydyy2
      xfcx1=qdx*xdzydzz1+wqx*xdzydzz2+rzydzzd2             
      xfcy1=qdy*xdzydzz1+wqy*xdzydzz2         +1.d0*rxzdzz2
      xfcz1=qdz*xdzydzz1+wqz*xdzydzz2         +1.d0*rxydzz2+2.d0*pxdzypz
      xfdx1=qdx*xdzydyx1+wqx*xdzydyx2+rzydyxd2             +1.d0*pxdzypy
      xfdy1=qdy*xdzydyx1+wqy*xdzydyx2         +1.d0*rxzdyx2+1.d0*pxdzypx
      xfdz1=qdz*xdzydyx1+wqz*xdzydyx2         +1.d0*rxydyx2
      xfex1=qdx*xdzydzx1+wqx*xdzydzx2+rzydzxd2             +1.d0*pxdzypz
      xfey1=qdy*xdzydzx1+wqy*xdzydzx2         +1.d0*rxzdzx2
      xfez1=qdz*xdzydzx1+wqz*xdzydzx2         +1.d0*rxydzx2+1.d0*pxdzypx
      xffx1=qdx*xdzydzy1+wqx*xdzydzy2+rzydzyd2             
      xffy1=qdy*xdzydzy1+wqy*xdzydzy2         +1.d0*rxzdzy2+1.d0*pxdzypz
      xffz1=qdz*xdzydzy1+wqz*xdzydzy2         +1.d0*rxydzy2+1.d0*pxdzypy
           
      yaax1=qdx*ydxxdxx1+wqx*ydxxdxx2         +2.d0*ryxdxx2+2.d0*pydxxpx
      yaay1=qdy*ydxxdxx1+wqy*ydxxdxx2+rxxdxxd2             
      yaaz1=qdz*ydxxdxx1+wqz*ydxxdxx2                     
      yabx1=qdx*ydxxdyy1+wqx*ydxxdyy2         +2.d0*ryxdyy2
      yaby1=qdy*ydxxdyy1+wqy*ydxxdyy2+rxxdyyd2             +2.d0*pydxxpy
      yabz1=qdz*ydxxdyy1+wqz*ydxxdyy2                      
      yacx1=qdx*ydxxdzz1+wqx*ydxxdzz2         +2.d0*ryxdzz2
      yacy1=qdy*ydxxdzz1+wqy*ydxxdzz2+rxxdzzd2             
      yacz1=qdz*ydxxdzz1+wqz*ydxxdzz2                      +2.d0*pydxxpz
      yadx1=qdx*ydxxdyx1+wqx*ydxxdyx2         +2.d0*ryxdyx2+1.d0*pydxxpy
      yady1=qdy*ydxxdyx1+wqy*ydxxdyx2+rxxdyxd2             +1.d0*pydxxpx
      yadz1=qdz*ydxxdyx1+wqz*ydxxdyx2                      
      yaex1=qdx*ydxxdzx1+wqx*ydxxdzx2         +2.d0*ryxdzx2+1.d0*pydxxpz
      yaey1=qdy*ydxxdzx1+wqy*ydxxdzx2+rxxdzxd2             
      yaez1=qdz*ydxxdzx1+wqz*ydxxdzx2                      +1.d0*pydxxpx
      yafx1=qdx*ydxxdzy1+wqx*ydxxdzy2         +2.d0*ryxdzy2
      yafy1=qdy*ydxxdzy1+wqy*ydxxdzy2+rxxdzyd2             +1.d0*pydxxpz
      yafz1=qdz*ydxxdzy1+wqz*ydxxdzy2                      +1.d0*pydxxpy
                                              
      ybax1=qdx*ydyydxx1+wqx*ydyydxx2                      +2.d0*pydyypx
      ybay1=qdy*ydyydxx1+wqy*ydyydxx2+ryydxxd2+2.d0*ryydxx2
      ybaz1=qdz*ydyydxx1+wqz*ydyydxx2                      
      ybbx1=qdx*ydyydyy1+wqx*ydyydyy2                      
      ybby1=qdy*ydyydyy1+wqy*ydyydyy2+ryydyyd2+2.d0*ryydyy2+2.d0*pydyypy
      ybbz1=qdz*ydyydyy1+wqz*ydyydyy2                      
      ybcx1=qdx*ydyydzz1+wqx*ydyydzz2                      
      ybcy1=qdy*ydyydzz1+wqy*ydyydzz2+ryydzzd2+2.d0*ryydzz2
      ybcz1=qdz*ydyydzz1+wqz*ydyydzz2                      +2.d0*pydyypz
      ybdx1=qdx*ydyydyx1+wqx*ydyydyx2                      +1.d0*pydyypy
      ybdy1=qdy*ydyydyx1+wqy*ydyydyx2+ryydyxd2+2.d0*ryydyx2+1.d0*pydyypx
      ybdz1=qdz*ydyydyx1+wqz*ydyydyx2                      
      ybex1=qdx*ydyydzx1+wqx*ydyydzx2                      +1.d0*pydyypz
      ybey1=qdy*ydyydzx1+wqy*ydyydzx2+ryydzxd2+2.d0*ryydzx2
      ybez1=qdz*ydyydzx1+wqz*ydyydzx2                      +1.d0*pydyypx
      ybfx1=qdx*ydyydzy1+wqx*ydyydzy2                      
      ybfy1=qdy*ydyydzy1+wqy*ydyydzy2+ryydzyd2+2.d0*ryydzy2+1.d0*pydyypz
      ybfz1=qdz*ydyydzy1+wqz*ydyydzy2                      +1.d0*pydyypy
                                           
      ycax1=qdx*ydzzdxx1+wqx*ydzzdxx2                      +2.d0*pydzzpx
      ycay1=qdy*ydzzdxx1+wqy*ydzzdxx2+rzzdxxd2             
      ycaz1=qdz*ydzzdxx1+wqz*ydzzdxx2         +2.d0*ryzdxx2
      ycbx1=qdx*ydzzdyy1+wqx*ydzzdyy2                      
      ycby1=qdy*ydzzdyy1+wqy*ydzzdyy2+rzzdyyd2             +2.d0*pydzzpy
      ycbz1=qdz*ydzzdyy1+wqz*ydzzdyy2         +2.d0*ryzdyy2
      yccx1=qdx*ydzzdzz1+wqx*ydzzdzz2                      
      yccy1=qdy*ydzzdzz1+wqy*ydzzdzz2+rzzdzzd2             
      yccz1=qdz*ydzzdzz1+wqz*ydzzdzz2         +2.d0*ryzdzz2+2.d0*pydzzpz
      ycdx1=qdx*ydzzdyx1+wqx*ydzzdyx2                      +1.d0*pydzzpy
      ycdy1=qdy*ydzzdyx1+wqy*ydzzdyx2+rzzdyxd2             +1.d0*pydzzpx
      ycdz1=qdz*ydzzdyx1+wqz*ydzzdyx2         +2.d0*ryzdyx2
      ycex1=qdx*ydzzdzx1+wqx*ydzzdzx2                      +1.d0*pydzzpz
      ycey1=qdy*ydzzdzx1+wqy*ydzzdzx2+rzzdzxd2             
      ycez1=qdz*ydzzdzx1+wqz*ydzzdzx2         +2.d0*ryzdzx2+1.d0*pydzzpx
      ycfx1=qdx*ydzzdzy1+wqx*ydzzdzy2                      
      ycfy1=qdy*ydzzdzy1+wqy*ydzzdzy2+rzzdzyd2             +1.d0*pydzzpz
      ycfz1=qdz*ydzzdzy1+wqz*ydzzdzy2         +2.d0*ryzdzy2+1.d0*pydzzpy
                                
      ydax1=qdx*ydyxdxx1+wqx*ydyxdxx2         +1.d0*ryydxx2+2.d0*pydyxpx
      yday1=qdy*ydyxdxx1+wqy*ydyxdxx2+ryxdxxd2+1.d0*ryxdxx2
      ydaz1=qdz*ydyxdxx1+wqz*ydyxdxx2         
      ydbx1=qdx*ydyxdyy1+wqx*ydyxdyy2         +1.d0*ryydyy2
      ydby1=qdy*ydyxdyy1+wqy*ydyxdyy2+ryxdyyd2+1.d0*ryxdyy2+2.d0*pydyxpy
      ydbz1=qdz*ydyxdyy1+wqz*ydyxdyy2      
      ydcx1=qdx*ydyxdzz1+wqx*ydyxdzz2         +1.d0*ryydzz2
      ydcy1=qdy*ydyxdzz1+wqy*ydyxdzz2+ryxdzzd2+1.d0*ryxdzz2
      ydcz1=qdz*ydyxdzz1+wqz*ydyxdzz2                      +2.d0*pydyxpz
      yddx1=qdx*ydyxdyx1+wqx*ydyxdyx2         +1.d0*ryydyx2+1.d0*pydyxpy
      yddy1=qdy*ydyxdyx1+wqy*ydyxdyx2+ryxdyxd2+1.d0*ryxdyx2+1.d0*pydyxpx
      yddz1=qdz*ydyxdyx1+wqz*ydyxdyx2                      
      ydex1=qdx*ydyxdzx1+wqx*ydyxdzx2         +1.d0*ryydzx2+1.d0*pydyxpz
      ydey1=qdy*ydyxdzx1+wqy*ydyxdzx2+ryxdzxd2+1.d0*ryxdzx2
      ydez1=qdz*ydyxdzx1+wqz*ydyxdzx2                      +1.d0*pydyxpx
      ydfx1=qdx*ydyxdzy1+wqx*ydyxdzy2         +1.d0*ryydzy2
      ydfy1=qdy*ydyxdzy1+wqy*ydyxdzy2+ryxdzyd2+1.d0*ryxdzy2+1.d0*pydyxpz
      ydfz1=qdz*ydyxdzy1+wqz*ydyxdzy2                      +1.d0*pydyxpy
                                                  
      yeax1=qdx*ydzxdxx1+wqx*ydzxdxx2         +1.d0*ryzdxx2+2.d0*pydzxpx
      yeay1=qdy*ydzxdxx1+wqy*ydzxdxx2+rzxdxxd2
      yeaz1=qdz*ydzxdxx1+wqz*ydzxdxx2         +1.d0*ryxdxx2
      yebx1=qdx*ydzxdyy1+wqx*ydzxdyy2         +1.d0*ryzdyy2
      yeby1=qdy*ydzxdyy1+wqy*ydzxdyy2+rzxdyyd2             +2.d0*pydzxpy
      yebz1=qdz*ydzxdyy1+wqz*ydzxdyy2         +1.d0*ryxdyy2
      yecx1=qdx*ydzxdzz1+wqx*ydzxdzz2         +1.d0*ryzdzz2
      yecy1=qdy*ydzxdzz1+wqy*ydzxdzz2+rzxdzzd2             
      yecz1=qdz*ydzxdzz1+wqz*ydzxdzz2         +1.d0*ryxdzz2+2.d0*pydzxpz
      yedx1=qdx*ydzxdyx1+wqx*ydzxdyx2         +1.d0*ryzdyx2+1.d0*pydzxpy
      yedy1=qdy*ydzxdyx1+wqy*ydzxdyx2+rzxdyxd2             +1.d0*pydzxpx
      yedz1=qdz*ydzxdyx1+wqz*ydzxdyx2         +1.d0*ryxdyx2
      yeex1=qdx*ydzxdzx1+wqx*ydzxdzx2         +1.d0*ryzdzx2+1.d0*pydzxpz
      yeey1=qdy*ydzxdzx1+wqy*ydzxdzx2+rzxdzxd2             
      yeez1=qdz*ydzxdzx1+wqz*ydzxdzx2         +1.d0*ryxdzx2+1.d0*pydzxpx
      yefx1=qdx*ydzxdzy1+wqx*ydzxdzy2         +1.d0*ryzdzy2
      yefy1=qdy*ydzxdzy1+wqy*ydzxdzy2+rzxdzyd2             +1.d0*pydzxpz
      yefz1=qdz*ydzxdzy1+wqz*ydzxdzy2         +1.d0*ryxdzy2+1.d0*pydzxpy
                                            
      yfax1=qdx*ydzydxx1+wqx*ydzydxx2                      +2.d0*pydzypx
      yfay1=qdy*ydzydxx1+wqy*ydzydxx2+rzydxxd2+1.d0*ryzdxx2
      yfaz1=qdz*ydzydxx1+wqz*ydzydxx2         +1.d0*ryydxx2
      yfbx1=qdx*ydzydyy1+wqx*ydzydyy2                      
      yfby1=qdy*ydzydyy1+wqy*ydzydyy2+rzydyyd2+1.d0*ryzdyy2+2.d0*pydzypy
      yfbz1=qdz*ydzydyy1+wqz*ydzydyy2         +1.d0*ryydyy2
      yfcx1=qdx*ydzydzz1+wqx*ydzydzz2                      
      yfcy1=qdy*ydzydzz1+wqy*ydzydzz2+rzydzzd2+1.d0*ryzdzz2
      yfcz1=qdz*ydzydzz1+wqz*ydzydzz2         +1.d0*ryydzz2+2.d0*pydzypz
      yfdx1=qdx*ydzydyx1+wqx*ydzydyx2                      +1.d0*pydzypy
      yfdy1=qdy*ydzydyx1+wqy*ydzydyx2+rzydyxd2+1.d0*ryzdyx2+1.d0*pydzypx
      yfdz1=qdz*ydzydyx1+wqz*ydzydyx2         +1.d0*ryydyx2
      yfex1=qdx*ydzydzx1+wqx*ydzydzx2                      +1.d0*pydzypz
      yfey1=qdy*ydzydzx1+wqy*ydzydzx2+rzydzxd2+1.d0*ryzdzx2
      yfez1=qdz*ydzydzx1+wqz*ydzydzx2         +1.d0*ryydzx2+1.d0*pydzypx
      yffx1=qdx*ydzydzy1+wqx*ydzydzy2                      
      yffy1=qdy*ydzydzy1+wqy*ydzydzy2+rzydzyd2+1.d0*ryzdzy2+1.d0*pydzypz
      yffz1=qdz*ydzydzy1+wqz*ydzydzy2         +1.d0*ryydzy2+1.d0*pydzypy
           
      zaax1=qdx*zdxxdxx1+wqx*zdxxdxx2         +2.d0*rzxdxx2+2.d0*pzdxxpx
      zaay1=qdy*zdxxdxx1+wqy*zdxxdxx2                      
      zaaz1=qdz*zdxxdxx1+wqz*zdxxdxx2+rxxdxxd2             
      zabx1=qdx*zdxxdyy1+wqx*zdxxdyy2         +2.d0*rzxdyy2
      zaby1=qdy*zdxxdyy1+wqy*zdxxdyy2                      +2.d0*pzdxxpy
      zabz1=qdz*zdxxdyy1+wqz*zdxxdyy2+rxxdyyd2             
      zacx1=qdx*zdxxdzz1+wqx*zdxxdzz2         +2.d0*rzxdzz2
      zacy1=qdy*zdxxdzz1+wqy*zdxxdzz2                      
      zacz1=qdz*zdxxdzz1+wqz*zdxxdzz2+rxxdzzd2             +2.d0*pzdxxpz
      zadx1=qdx*zdxxdyx1+wqx*zdxxdyx2         +2.d0*rzxdyx2+1.d0*pzdxxpy
      zady1=qdy*zdxxdyx1+wqy*zdxxdyx2                      +1.d0*pzdxxpx
      zadz1=qdz*zdxxdyx1+wqz*zdxxdyx2+rxxdyxd2             
      zaex1=qdx*zdxxdzx1+wqx*zdxxdzx2         +2.d0*rzxdzx2+1.d0*pzdxxpz
      zaey1=qdy*zdxxdzx1+wqy*zdxxdzx2                      
      zaez1=qdz*zdxxdzx1+wqz*zdxxdzx2+rxxdzxd2             +1.d0*pzdxxpx
      zafx1=qdx*zdxxdzy1+wqx*zdxxdzy2         +2.d0*rzxdzy2
      zafy1=qdy*zdxxdzy1+wqy*zdxxdzy2                      +1.d0*pzdxxpz
      zafz1=qdz*zdxxdzy1+wqz*zdxxdzy2+rxxdzyd2             +1.d0*pzdxxpy
                                                
      zbax1=qdx*zdyydxx1+wqx*zdyydxx2                      +2.d0*pzdyypx
      zbay1=qdy*zdyydxx1+wqy*zdyydxx2         +2.d0*rzydxx2
      zbaz1=qdz*zdyydxx1+wqz*zdyydxx2+ryydxxd2             
      zbbx1=qdx*zdyydyy1+wqx*zdyydyy2                      
      zbby1=qdy*zdyydyy1+wqy*zdyydyy2         +2.d0*rzydyy2+2.d0*pzdyypy
      zbbz1=qdz*zdyydyy1+wqz*zdyydyy2+ryydyyd2             
      zbcx1=qdx*zdyydzz1+wqx*zdyydzz2                      
      zbcy1=qdy*zdyydzz1+wqy*zdyydzz2         +2.d0*rzydzz2
      zbcz1=qdz*zdyydzz1+wqz*zdyydzz2+ryydzzd2             +2.d0*pzdyypz
      zbdx1=qdx*zdyydyx1+wqx*zdyydyx2                      +1.d0*pzdyypy
      zbdy1=qdy*zdyydyx1+wqy*zdyydyx2         +2.d0*rzydyx2+1.d0*pzdyypx
      zbdz1=qdz*zdyydyx1+wqz*zdyydyx2+ryydyxd2             
      zbex1=qdx*zdyydzx1+wqx*zdyydzx2                      +1.d0*pzdyypz
      zbey1=qdy*zdyydzx1+wqy*zdyydzx2         +2.d0*rzydzx2
      zbez1=qdz*zdyydzx1+wqz*zdyydzx2+ryydzxd2             +1.d0*pzdyypx
      zbfx1=qdx*zdyydzy1+wqx*zdyydzy2                      
      zbfy1=qdy*zdyydzy1+wqy*zdyydzy2         +2.d0*rzydzy2+1.d0*pzdyypz
      zbfz1=qdz*zdyydzy1+wqz*zdyydzy2+ryydzyd2             +1.d0*pzdyypy
                                               
      zcax1=qdx*zdzzdxx1+wqx*zdzzdxx2                      +2.d0*pzdzzpx
      zcay1=qdy*zdzzdxx1+wqy*zdzzdxx2                      
      zcaz1=qdz*zdzzdxx1+wqz*zdzzdxx2+rzzdxxd2+2.d0*rzzdxx2
      zcbx1=qdx*zdzzdyy1+wqx*zdzzdyy2                      
      zcby1=qdy*zdzzdyy1+wqy*zdzzdyy2                      +2.d0*pzdzzpy
      zcbz1=qdz*zdzzdyy1+wqz*zdzzdyy2+rzzdyyd2+2.d0*rzzdyy2
      zccx1=qdx*zdzzdzz1+wqx*zdzzdzz2                      
      zccy1=qdy*zdzzdzz1+wqy*zdzzdzz2                      
      zccz1=qdz*zdzzdzz1+wqz*zdzzdzz2+rzzdzzd2+2.d0*rzzdzz2+2.d0*pzdzzpz
      zcdx1=qdx*zdzzdyx1+wqx*zdzzdyx2                      +1.d0*pzdzzpy
      zcdy1=qdy*zdzzdyx1+wqy*zdzzdyx2                      +1.d0*pzdzzpx
      zcdz1=qdz*zdzzdyx1+wqz*zdzzdyx2+rzzdyxd2+2.d0*rzzdyx2
      zcex1=qdx*zdzzdzx1+wqx*zdzzdzx2                      +1.d0*pzdzzpz
      zcey1=qdy*zdzzdzx1+wqy*zdzzdzx2                      
      zcez1=qdz*zdzzdzx1+wqz*zdzzdzx2+rzzdzxd2+2.d0*rzzdzx2+1.d0*pzdzzpx
      zcfx1=qdx*zdzzdzy1+wqx*zdzzdzy2                      
      zcfy1=qdy*zdzzdzy1+wqy*zdzzdzy2                      +1.d0*pzdzzpz
      zcfz1=qdz*zdzzdzy1+wqz*zdzzdzy2+rzzdzyd2+2.d0*rzzdzy2+1.d0*pzdzzpy
                                                      
      zdax1=qdx*zdyxdxx1+wqx*zdyxdxx2         +1.d0*rzydxx2+2.d0*pzdyxpx
      zday1=qdy*zdyxdxx1+wqy*zdyxdxx2         +1.d0*rzxdxx2
      zdaz1=qdz*zdyxdxx1+wqz*zdyxdxx2+ryxdxxd2             
      zdbx1=qdx*zdyxdyy1+wqx*zdyxdyy2         +1.d0*rzydyy2
      zdby1=qdy*zdyxdyy1+wqy*zdyxdyy2         +1.d0*rzxdyy2+2.d0*pzdyxpy
      zdbz1=qdz*zdyxdyy1+wqz*zdyxdyy2+ryxdyyd2             
      zdcx1=qdx*zdyxdzz1+wqx*zdyxdzz2         +1.d0*rzydzz2
      zdcy1=qdy*zdyxdzz1+wqy*zdyxdzz2         +1.d0*rzxdzz2
      zdcz1=qdz*zdyxdzz1+wqz*zdyxdzz2+ryxdzzd2             +2.d0*pzdyxpz
      zddx1=qdx*zdyxdyx1+wqx*zdyxdyx2         +1.d0*rzydyx2+1.d0*pzdyxpy
      zddy1=qdy*zdyxdyx1+wqy*zdyxdyx2         +1.d0*rzxdyx2+1.d0*pzdyxpx
      zddz1=qdz*zdyxdyx1+wqz*zdyxdyx2+ryxdyxd2             
      zdex1=qdx*zdyxdzx1+wqx*zdyxdzx2         +1.d0*rzydzx2+1.d0*pzdyxpz
      zdey1=qdy*zdyxdzx1+wqy*zdyxdzx2         +1.d0*rzxdzx2
      zdez1=qdz*zdyxdzx1+wqz*zdyxdzx2+ryxdzxd2             +1.d0*pzdyxpx
      zdfx1=qdx*zdyxdzy1+wqx*zdyxdzy2         +1.d0*rzydzy2
      zdfy1=qdy*zdyxdzy1+wqy*zdyxdzy2         +1.d0*rzxdzy2+1.d0*pzdyxpz
      zdfz1=qdz*zdyxdzy1+wqz*zdyxdzy2+ryxdzyd2             +1.d0*pzdyxpy
           
      zeax1=qdx*zdzxdxx1+wqx*zdzxdxx2         +1.d0*rzzdxx2+2.d0*pzdzxpx
      zeay1=qdy*zdzxdxx1+wqy*zdzxdxx2                      
      zeaz1=qdz*zdzxdxx1+wqz*zdzxdxx2+rzxdxxd2+1.d0*rzxdxx2
      zebx1=qdx*zdzxdyy1+wqx*zdzxdyy2         +1.d0*rzzdyy2
      zeby1=qdy*zdzxdyy1+wqy*zdzxdyy2                      +2.d0*pzdzxpy
      zebz1=qdz*zdzxdyy1+wqz*zdzxdyy2+rzxdyyd2+1.d0*rzxdyy2
      zecx1=qdx*zdzxdzz1+wqx*zdzxdzz2         +1.d0*rzzdzz2
      zecy1=qdy*zdzxdzz1+wqy*zdzxdzz2                      
      zecz1=qdz*zdzxdzz1+wqz*zdzxdzz2+rzxdzzd2+1.d0*rzxdzz2+2.d0*pzdzxpz
      zedx1=qdx*zdzxdyx1+wqx*zdzxdyx2         +1.d0*rzzdyx2+1.d0*pzdzxpy
      zedy1=qdy*zdzxdyx1+wqy*zdzxdyx2                      +1.d0*pzdzxpx
      zedz1=qdz*zdzxdyx1+wqz*zdzxdyx2+rzxdyxd2+1.d0*rzxdyx2
      zeex1=qdx*zdzxdzx1+wqx*zdzxdzx2         +1.d0*rzzdzx2+1.d0*pzdzxpz
      zeey1=qdy*zdzxdzx1+wqy*zdzxdzx2                      
      zeez1=qdz*zdzxdzx1+wqz*zdzxdzx2+rzxdzxd2+1.d0*rzxdzx2+1.d0*pzdzxpx
      zefx1=qdx*zdzxdzy1+wqx*zdzxdzy2         +1.d0*rzzdzy2
      zefy1=qdy*zdzxdzy1+wqy*zdzxdzy2                      +1.d0*pzdzxpz
      zefz1=qdz*zdzxdzy1+wqz*zdzxdzy2+rzxdzyd2+1.d0*rzxdzy2+1.d0*pzdzxpy
           
      zfax1=qdx*zdzydxx1+wqx*zdzydxx2                      +2.d0*pzdzypx
      zfay1=qdy*zdzydxx1+wqy*zdzydxx2         +1.d0*rzzdxx2
      zfaz1=qdz*zdzydxx1+wqz*zdzydxx2+rzydxxd2+1.d0*rzydxx2
      zfbx1=qdx*zdzydyy1+wqx*zdzydyy2                      
      zfby1=qdy*zdzydyy1+wqy*zdzydyy2         +1.d0*rzzdyy2+2.d0*pzdzypy
      zfbz1=qdz*zdzydyy1+wqz*zdzydyy2+rzydyyd2+1.d0*rzydyy2
      zfcx1=qdx*zdzydzz1+wqx*zdzydzz2                      
      zfcy1=qdy*zdzydzz1+wqy*zdzydzz2         +1.d0*rzzdzz2
      zfcz1=qdz*zdzydzz1+wqz*zdzydzz2+rzydzzd2+1.d0*rzydzz2+2.d0*pzdzypz
      zfdx1=qdx*zdzydyx1+wqx*zdzydyx2                      +1.d0*pzdzypy
      zfdy1=qdy*zdzydyx1+wqy*zdzydyx2         +1.d0*rzzdyx2+1.d0*pzdzypx
      zfdz1=qdz*zdzydyx1+wqz*zdzydyx2+rzydyxd2+1.d0*rzydyx2
      zfex1=qdx*zdzydzx1+wqx*zdzydzx2                      +1.d0*pzdzypz
      zfey1=qdy*zdzydzx1+wqy*zdzydzx2         +1.d0*rzzdzx2
      zfez1=qdz*zdzydzx1+wqz*zdzydzx2+rzydzxd2+1.d0*rzydzx2+1.d0*pzdzypx
      zffx1=qdx*zdzydzy1+wqx*zdzydzy2                      
      zffy1=qdy*zdzydzy1+wqy*zdzydzy2         +1.d0*rzzdzy2+1.d0*pzdzypz
      zffz1=qdz*zdzydzy1+wqz*zdzydzy2+rzydzyd2+1.d0*rzydzy2+1.d0*pzdzypy


!rpdds(1-2) 
      rxaa1=rkp*xdxxdxx1
      rxab1=rkp*xdxxdyy1
      rxac1=rkp*xdxxdzz1
      rxad1=rkp*xdxxdyx1
      rxae1=rkp*xdxxdzx1
      rxaf1=rkp*xdxxdzy1
      rxba1=rkp*xdyydxx1
      rxbb1=rkp*xdyydyy1
      rxbc1=rkp*xdyydzz1
      rxbd1=rkp*xdyydyx1
      rxbe1=rkp*xdyydzx1
      rxbf1=rkp*xdyydzy1
      rxca1=rkp*xdzzdxx1
      rxcb1=rkp*xdzzdyy1
      rxcc1=rkp*xdzzdzz1
      rxcd1=rkp*xdzzdyx1
      rxce1=rkp*xdzzdzx1
      rxcf1=rkp*xdzzdzy1
      rxda1=rkp*xdyxdxx1
      rxdb1=rkp*xdyxdyy1
      rxdc1=rkp*xdyxdzz1
      rxdd1=rkp*xdyxdyx1
      rxde1=rkp*xdyxdzx1
      rxdf1=rkp*xdyxdzy1
      rxea1=rkp*xdzxdxx1
      rxeb1=rkp*xdzxdyy1
      rxec1=rkp*xdzxdzz1
      rxed1=rkp*xdzxdyx1
      rxee1=rkp*xdzxdzx1
      rxef1=rkp*xdzxdzy1
      rxfa1=rkp*xdzydxx1
      rxfb1=rkp*xdzydyy1
      rxfc1=rkp*xdzydzz1
      rxfd1=rkp*xdzydyx1
      rxfe1=rkp*xdzydzx1
      rxff1=rkp*xdzydzy1
      ryaa1=rkp*ydxxdxx1
      ryab1=rkp*ydxxdyy1
      ryac1=rkp*ydxxdzz1
      ryad1=rkp*ydxxdyx1
      ryae1=rkp*ydxxdzx1
      ryaf1=rkp*ydxxdzy1
      ryba1=rkp*ydyydxx1
      rybb1=rkp*ydyydyy1
      rybc1=rkp*ydyydzz1
      rybd1=rkp*ydyydyx1
      rybe1=rkp*ydyydzx1
      rybf1=rkp*ydyydzy1
      ryca1=rkp*ydzzdxx1
      rycb1=rkp*ydzzdyy1
      rycc1=rkp*ydzzdzz1
      rycd1=rkp*ydzzdyx1
      ryce1=rkp*ydzzdzx1
      rycf1=rkp*ydzzdzy1
      ryda1=rkp*ydyxdxx1
      rydb1=rkp*ydyxdyy1
      rydc1=rkp*ydyxdzz1
      rydd1=rkp*ydyxdyx1
      ryde1=rkp*ydyxdzx1
      rydf1=rkp*ydyxdzy1
      ryea1=rkp*ydzxdxx1
      ryeb1=rkp*ydzxdyy1
      ryec1=rkp*ydzxdzz1
      ryed1=rkp*ydzxdyx1
      ryee1=rkp*ydzxdzx1
      ryef1=rkp*ydzxdzy1
      ryfa1=rkp*ydzydxx1
      ryfb1=rkp*ydzydyy1
      ryfc1=rkp*ydzydzz1
      ryfd1=rkp*ydzydyx1
      ryfe1=rkp*ydzydzx1
      ryff1=rkp*ydzydzy1
      rzaa1=rkp*zdxxdxx1
      rzab1=rkp*zdxxdyy1
      rzac1=rkp*zdxxdzz1
      rzad1=rkp*zdxxdyx1
      rzae1=rkp*zdxxdzx1
      rzaf1=rkp*zdxxdzy1
      rzba1=rkp*zdyydxx1
      rzbb1=rkp*zdyydyy1
      rzbc1=rkp*zdyydzz1
      rzbd1=rkp*zdyydyx1
      rzbe1=rkp*zdyydzx1
      rzbf1=rkp*zdyydzy1
      rzca1=rkp*zdzzdxx1
      rzcb1=rkp*zdzzdyy1
      rzcc1=rkp*zdzzdzz1
      rzcd1=rkp*zdzzdyx1
      rzce1=rkp*zdzzdzx1
      rzcf1=rkp*zdzzdzy1
      rzda1=rkp*zdyxdxx1
      rzdb1=rkp*zdyxdyy1
      rzdc1=rkp*zdyxdzz1
      rzdd1=rkp*zdyxdyx1
      rzde1=rkp*zdyxdzx1
      rzdf1=rkp*zdyxdzy1
      rzea1=rkp*zdzxdxx1
      rzeb1=rkp*zdzxdyy1
      rzec1=rkp*zdzxdzz1
      rzed1=rkp*zdzxdyx1
      rzee1=rkp*zdzxdzx1
      rzef1=rkp*zdzxdzy1
      rzfa1=rkp*zdzydxx1
      rzfb1=rkp*zdzydyy1
      rzfc1=rkp*zdzydzz1
      rzfd1=rkp*zdzydyx1
      rzfe1=rkp*zdzydzx1
      rzff1=rkp*zdzydzy1
      rxaa2=rkp*xdxxdxx2
      rxab2=rkp*xdxxdyy2
      rxac2=rkp*xdxxdzz2
      rxad2=rkp*xdxxdyx2
      rxae2=rkp*xdxxdzx2
      rxaf2=rkp*xdxxdzy2
      rxba2=rkp*xdyydxx2
      rxbb2=rkp*xdyydyy2
      rxbc2=rkp*xdyydzz2
      rxbd2=rkp*xdyydyx2
      rxbe2=rkp*xdyydzx2
      rxbf2=rkp*xdyydzy2
      rxca2=rkp*xdzzdxx2
      rxcb2=rkp*xdzzdyy2
      rxcc2=rkp*xdzzdzz2
      rxcd2=rkp*xdzzdyx2
      rxce2=rkp*xdzzdzx2
      rxcf2=rkp*xdzzdzy2
      rxda2=rkp*xdyxdxx2
      rxdb2=rkp*xdyxdyy2
      rxdc2=rkp*xdyxdzz2
      rxdd2=rkp*xdyxdyx2
      rxde2=rkp*xdyxdzx2
      rxdf2=rkp*xdyxdzy2
      rxea2=rkp*xdzxdxx2
      rxeb2=rkp*xdzxdyy2
      rxec2=rkp*xdzxdzz2
      rxed2=rkp*xdzxdyx2
      rxee2=rkp*xdzxdzx2
      rxef2=rkp*xdzxdzy2
      rxfa2=rkp*xdzydxx2
      rxfb2=rkp*xdzydyy2
      rxfc2=rkp*xdzydzz2
      rxfd2=rkp*xdzydyx2
      rxfe2=rkp*xdzydzx2
      rxff2=rkp*xdzydzy2
      ryaa2=rkp*ydxxdxx2
      ryab2=rkp*ydxxdyy2
      ryac2=rkp*ydxxdzz2
      ryad2=rkp*ydxxdyx2
      ryae2=rkp*ydxxdzx2
      ryaf2=rkp*ydxxdzy2
      ryba2=rkp*ydyydxx2
      rybb2=rkp*ydyydyy2
      rybc2=rkp*ydyydzz2
      rybd2=rkp*ydyydyx2
      rybe2=rkp*ydyydzx2
      rybf2=rkp*ydyydzy2
      ryca2=rkp*ydzzdxx2
      rycb2=rkp*ydzzdyy2
      rycc2=rkp*ydzzdzz2
      rycd2=rkp*ydzzdyx2
      ryce2=rkp*ydzzdzx2
      rycf2=rkp*ydzzdzy2
      ryda2=rkp*ydyxdxx2
      rydb2=rkp*ydyxdyy2
      rydc2=rkp*ydyxdzz2
      rydd2=rkp*ydyxdyx2
      ryde2=rkp*ydyxdzx2
      rydf2=rkp*ydyxdzy2
      ryea2=rkp*ydzxdxx2
      ryeb2=rkp*ydzxdyy2
      ryec2=rkp*ydzxdzz2
      ryed2=rkp*ydzxdyx2
      ryee2=rkp*ydzxdzx2
      ryef2=rkp*ydzxdzy2
      ryfa2=rkp*ydzydxx2
      ryfb2=rkp*ydzydyy2
      ryfc2=rkp*ydzydzz2
      ryfd2=rkp*ydzydyx2
      ryfe2=rkp*ydzydzx2
      ryff2=rkp*ydzydzy2
      rzaa2=rkp*zdxxdxx2
      rzab2=rkp*zdxxdyy2
      rzac2=rkp*zdxxdzz2
      rzad2=rkp*zdxxdyx2
      rzae2=rkp*zdxxdzx2
      rzaf2=rkp*zdxxdzy2
      rzba2=rkp*zdyydxx2
      rzbb2=rkp*zdyydyy2
      rzbc2=rkp*zdyydzz2
      rzbd2=rkp*zdyydyx2
      rzbe2=rkp*zdyydzx2
      rzbf2=rkp*zdyydzy2
      rzca2=rkp*zdzzdxx2
      rzcb2=rkp*zdzzdyy2
      rzcc2=rkp*zdzzdzz2
      rzcd2=rkp*zdzzdyx2
      rzce2=rkp*zdzzdzx2
      rzcf2=rkp*zdzzdzy2
      rzda2=rkp*zdyxdxx2
      rzdb2=rkp*zdyxdyy2
      rzdc2=rkp*zdyxdzz2
      rzdd2=rkp*zdyxdyx2
      rzde2=rkp*zdyxdzx2
      rzdf2=rkp*zdyxdzy2
      rzea2=rkp*zdzxdxx2
      rzeb2=rkp*zdzxdyy2
      rzec2=rkp*zdzxdzz2
      rzed2=rkp*zdzxdyx2
      rzee2=rkp*zdzxdzx2
      rzef2=rkp*zdzxdzy2
      rzfa2=rkp*zdzydxx2
      rzfb2=rkp*zdzydyy2
      rzfc2=rkp*zdzydzz2
      rzfd2=rkp*zdzydyx2
      rzfe2=rkp*zdzydzx2
      rzff2=rkp*zdzydzy2
 
!rdpds(1-2)
      raxa1=rkp* axa1
      raxb1=rkp* axb1
      raxc1=rkp* axc1
      raxd1=rkp* axd1
      raxe1=rkp* axe1
      raxf1=rkp* axf1
      raya1=rkp* aya1
      rayb1=rkp* ayb1
      rayc1=rkp* ayc1
      rayd1=rkp* ayd1
      raye1=rkp* aye1
      rayf1=rkp* ayf1
      raza1=rkp* aza1
      razb1=rkp* azb1
      razc1=rkp* azc1
      razd1=rkp* azd1
      raze1=rkp* aze1
      razf1=rkp* azf1
      rbxa1=rkp* bxa1
      rbxb1=rkp* bxb1
      rbxc1=rkp* bxc1
      rbxd1=rkp* bxd1
      rbxe1=rkp* bxe1
      rbxf1=rkp* bxf1
      rbya1=rkp* bya1
      rbyb1=rkp* byb1
      rbyc1=rkp* byc1
      rbyd1=rkp* byd1
      rbye1=rkp* bye1
      rbyf1=rkp* byf1
      rbza1=rkp* bza1
      rbzb1=rkp* bzb1
      rbzc1=rkp* bzc1
      rbzd1=rkp* bzd1
      rbze1=rkp* bze1
      rbzf1=rkp* bzf1
      rcxa1=rkp* cxa1
      rcxb1=rkp* cxb1
      rcxc1=rkp* cxc1
      rcxd1=rkp* cxd1
      rcxe1=rkp* cxe1
      rcxf1=rkp* cxf1
      rcya1=rkp* cya1
      rcyb1=rkp* cyb1
      rcyc1=rkp* cyc1
      rcyd1=rkp* cyd1
      rcye1=rkp* cye1
      rcyf1=rkp* cyf1
      rcza1=rkp* cza1
      rczb1=rkp* czb1
      rczc1=rkp* czc1
      rczd1=rkp* czd1
      rcze1=rkp* cze1
      rczf1=rkp* czf1
      rdxa1=rkp* dxa1
      rdxb1=rkp* dxb1
      rdxc1=rkp* dxc1
      rdxd1=rkp* dxd1
      rdxe1=rkp* dxe1
      rdxf1=rkp* dxf1
      rdya1=rkp* dya1
      rdyb1=rkp* dyb1
      rdyc1=rkp* dyc1
      rdyd1=rkp* dyd1
      rdye1=rkp* dye1
      rdyf1=rkp* dyf1
      rdza1=rkp* dza1
      rdzb1=rkp* dzb1
      rdzc1=rkp* dzc1
      rdzd1=rkp* dzd1
      rdze1=rkp* dze1
      rdzf1=rkp* dzf1
      rexa1=rkp* exa1
      rexb1=rkp* exb1
      rexc1=rkp* exc1
      rexd1=rkp* exd1
      rexe1=rkp* exe1
      rexf1=rkp* exf1
      reya1=rkp* eya1
      reyb1=rkp* eyb1
      reyc1=rkp* eyc1
      reyd1=rkp* eyd1
      reye1=rkp* eye1
      reyf1=rkp* eyf1
      reza1=rkp* eza1
      rezb1=rkp* ezb1
      rezc1=rkp* ezc1
      rezd1=rkp* ezd1
      reze1=rkp* eze1
      rezf1=rkp* ezf1
      rfxa1=rkp* fxa1
      rfxb1=rkp* fxb1
      rfxc1=rkp* fxc1
      rfxd1=rkp* fxd1
      rfxe1=rkp* fxe1
      rfxf1=rkp* fxf1
      rfya1=rkp* fya1
      rfyb1=rkp* fyb1
      rfyc1=rkp* fyc1
      rfyd1=rkp* fyd1
      rfye1=rkp* fye1
      rfyf1=rkp* fyf1
      rfza1=rkp* fza1
      rfzb1=rkp* fzb1
      rfzc1=rkp* fzc1
      rfzd1=rkp* fzd1
      rfze1=rkp* fze1
      rfzf1=rkp* fzf1
      raxa2=rkp* axa2
      raxb2=rkp* axb2
      raxc2=rkp* axc2
      raxd2=rkp* axd2
      raxe2=rkp* axe2
      raxf2=rkp* axf2
      raya2=rkp* aya2
      rayb2=rkp* ayb2
      rayc2=rkp* ayc2
      rayd2=rkp* ayd2
      raye2=rkp* aye2
      rayf2=rkp* ayf2
      raza2=rkp* aza2
      razb2=rkp* azb2
      razc2=rkp* azc2
      razd2=rkp* azd2
      raze2=rkp* aze2
      razf2=rkp* azf2
      rbxa2=rkp* bxa2
      rbxb2=rkp* bxb2
      rbxc2=rkp* bxc2
      rbxd2=rkp* bxd2
      rbxe2=rkp* bxe2
      rbxf2=rkp* bxf2
      rbya2=rkp* bya2
      rbyb2=rkp* byb2
      rbyc2=rkp* byc2
      rbyd2=rkp* byd2
      rbye2=rkp* bye2
      rbyf2=rkp* byf2
      rbza2=rkp* bza2
      rbzb2=rkp* bzb2
      rbzc2=rkp* bzc2
      rbzd2=rkp* bzd2
      rbze2=rkp* bze2
      rbzf2=rkp* bzf2
      rcxa2=rkp* cxa2
      rcxb2=rkp* cxb2
      rcxc2=rkp* cxc2
      rcxd2=rkp* cxd2
      rcxe2=rkp* cxe2
      rcxf2=rkp* cxf2
      rcya2=rkp* cya2
      rcyb2=rkp* cyb2
      rcyc2=rkp* cyc2
      rcyd2=rkp* cyd2
      rcye2=rkp* cye2
      rcyf2=rkp* cyf2
      rcza2=rkp* cza2
      rczb2=rkp* czb2
      rczc2=rkp* czc2
      rczd2=rkp* czd2
      rcze2=rkp* cze2
      rczf2=rkp* czf2
      rdxa2=rkp* dxa2
      rdxb2=rkp* dxb2
      rdxc2=rkp* dxc2
      rdxd2=rkp* dxd2
      rdxe2=rkp* dxe2
      rdxf2=rkp* dxf2
      rdya2=rkp* dya2
      rdyb2=rkp* dyb2
      rdyc2=rkp* dyc2
      rdyd2=rkp* dyd2
      rdye2=rkp* dye2
      rdyf2=rkp* dyf2
      rdza2=rkp* dza2
      rdzb2=rkp* dzb2
      rdzc2=rkp* dzc2
      rdzd2=rkp* dzd2
      rdze2=rkp* dze2
      rdzf2=rkp* dzf2
      rexa2=rkp* exa2
      rexb2=rkp* exb2
      rexc2=rkp* exc2
      rexd2=rkp* exd2
      rexe2=rkp* exe2
      rexf2=rkp* exf2
      reya2=rkp* eya2
      reyb2=rkp* eyb2
      reyc2=rkp* eyc2
      reyd2=rkp* eyd2
      reye2=rkp* eye2
      reyf2=rkp* eyf2
      reza2=rkp* eza2
      rezb2=rkp* ezb2
      rezc2=rkp* ezc2
      rezd2=rkp* ezd2
      reze2=rkp* eze2
      rezf2=rkp* ezf2
      rfxa2=rkp* fxa2
      rfxb2=rkp* fxb2
      rfxc2=rkp* fxc2
      rfxd2=rkp* fxd2
      rfxe2=rkp* fxe2
      rfxf2=rkp* fxf2
      rfya2=rkp* fya2
      rfyb2=rkp* fyb2
      rfyc2=rkp* fyc2
      rfyd2=rkp* fyd2
      rfye2=rkp* fye2
      rfyf2=rkp* fyf2
      rfza2=rkp* fza2
      rfzb2=rkp* fzb2
      rfzc2=rkp* fzc2
      rfzd2=rkp* fzd2
      rfze2=rkp* fze2
      rfzf2=rkp* fzf2
 
!ddps01(01-12)
      aax01= eta*(dxxdxxpx0 -rooe*dxxdxxpx1)
      aay01= eta*(dxxdxxpy0 -rooe*dxxdxxpy1)
      aaz01= eta*(dxxdxxpz0 -rooe*dxxdxxpz1)
      abx01= eta*(dxxdyypx0 -rooe*dxxdyypx1)
      aby01= eta*(dxxdyypy0 -rooe*dxxdyypy1)
      abz01= eta*(dxxdyypz0 -rooe*dxxdyypz1)
      acx01= eta*(dxxdzzpx0 -rooe*dxxdzzpx1)
      acy01= eta*(dxxdzzpy0 -rooe*dxxdzzpy1)
      acz01= eta*(dxxdzzpz0 -rooe*dxxdzzpz1)
      adx01= eta*(dxxdyxpx0 -rooe*dxxdyxpx1)
      ady01= eta*(dxxdyxpy0 -rooe*dxxdyxpy1)
      adz01= eta*(dxxdyxpz0 -rooe*dxxdyxpz1)
      aex01= eta*(dxxdzxpx0 -rooe*dxxdzxpx1)
      aey01= eta*(dxxdzxpy0 -rooe*dxxdzxpy1)
      aez01= eta*(dxxdzxpz0 -rooe*dxxdzxpz1)
      afx01= eta*(dxxdzypx0 -rooe*dxxdzypx1)
      afy01= eta*(dxxdzypy0 -rooe*dxxdzypy1)
      afz01= eta*(dxxdzypz0 -rooe*dxxdzypz1)
      bax01= eta*(dyydxxpx0 -rooe*dyydxxpx1)
      bay01= eta*(dyydxxpy0 -rooe*dyydxxpy1)
      baz01= eta*(dyydxxpz0 -rooe*dyydxxpz1)
      bbx01= eta*(dyydyypx0 -rooe*dyydyypx1)
      bby01= eta*(dyydyypy0 -rooe*dyydyypy1)
      bbz01= eta*(dyydyypz0 -rooe*dyydyypz1)
      bcx01= eta*(dyydzzpx0 -rooe*dyydzzpx1)
      bcy01= eta*(dyydzzpy0 -rooe*dyydzzpy1)
      bcz01= eta*(dyydzzpz0 -rooe*dyydzzpz1)
      bdx01= eta*(dyydyxpx0 -rooe*dyydyxpx1)
      bdy01= eta*(dyydyxpy0 -rooe*dyydyxpy1)
      bdz01= eta*(dyydyxpz0 -rooe*dyydyxpz1)
      bex01= eta*(dyydzxpx0 -rooe*dyydzxpx1)
      bey01= eta*(dyydzxpy0 -rooe*dyydzxpy1)
      bez01= eta*(dyydzxpz0 -rooe*dyydzxpz1)
      bfx01= eta*(dyydzypx0 -rooe*dyydzypx1)
      bfy01= eta*(dyydzypy0 -rooe*dyydzypy1)
      bfz01= eta*(dyydzypz0 -rooe*dyydzypz1)
      cax01= eta*(dzzdxxpx0 -rooe*dzzdxxpx1)
      cay01= eta*(dzzdxxpy0 -rooe*dzzdxxpy1)
      caz01= eta*(dzzdxxpz0 -rooe*dzzdxxpz1)
      cbx01= eta*(dzzdyypx0 -rooe*dzzdyypx1)
      cby01= eta*(dzzdyypy0 -rooe*dzzdyypy1)
      cbz01= eta*(dzzdyypz0 -rooe*dzzdyypz1)
      ccx01= eta*(dzzdzzpx0 -rooe*dzzdzzpx1)
      ccy01= eta*(dzzdzzpy0 -rooe*dzzdzzpy1)
      ccz01= eta*(dzzdzzpz0 -rooe*dzzdzzpz1)
      cdx01= eta*(dzzdyxpx0 -rooe*dzzdyxpx1)
      cdy01= eta*(dzzdyxpy0 -rooe*dzzdyxpy1)
      cdz01= eta*(dzzdyxpz0 -rooe*dzzdyxpz1)
      cex01= eta*(dzzdzxpx0 -rooe*dzzdzxpx1)
      cey01= eta*(dzzdzxpy0 -rooe*dzzdzxpy1)
      cez01= eta*(dzzdzxpz0 -rooe*dzzdzxpz1)
      cfx01= eta*(dzzdzypx0 -rooe*dzzdzypx1)
      cfy01= eta*(dzzdzypy0 -rooe*dzzdzypy1)
      cfz01= eta*(dzzdzypz0 -rooe*dzzdzypz1)
      dax01= eta*(dyxdxxpx0 -rooe*dyxdxxpx1)
      day01= eta*(dyxdxxpy0 -rooe*dyxdxxpy1)
      daz01= eta*(dyxdxxpz0 -rooe*dyxdxxpz1)
      dbx01= eta*(dyxdyypx0 -rooe*dyxdyypx1)
      dby01= eta*(dyxdyypy0 -rooe*dyxdyypy1)
      dbz01= eta*(dyxdyypz0 -rooe*dyxdyypz1)
      dcx01= eta*(dyxdzzpx0 -rooe*dyxdzzpx1)
      dcy01= eta*(dyxdzzpy0 -rooe*dyxdzzpy1)
      dcz01= eta*(dyxdzzpz0 -rooe*dyxdzzpz1)
      ddx01= eta*(dyxdyxpx0 -rooe*dyxdyxpx1)
      ddy01= eta*(dyxdyxpy0 -rooe*dyxdyxpy1)
      ddz01= eta*(dyxdyxpz0 -rooe*dyxdyxpz1)
      dex01= eta*(dyxdzxpx0 -rooe*dyxdzxpx1)
      dey01= eta*(dyxdzxpy0 -rooe*dyxdzxpy1)
      dez01= eta*(dyxdzxpz0 -rooe*dyxdzxpz1)
      dfx01= eta*(dyxdzypx0 -rooe*dyxdzypx1)
      dfy01= eta*(dyxdzypy0 -rooe*dyxdzypy1)
      dfz01= eta*(dyxdzypz0 -rooe*dyxdzypz1)
      eax01= eta*(dzxdxxpx0 -rooe*dzxdxxpx1)
      eay01= eta*(dzxdxxpy0 -rooe*dzxdxxpy1)
      eaz01= eta*(dzxdxxpz0 -rooe*dzxdxxpz1)
      ebx01= eta*(dzxdyypx0 -rooe*dzxdyypx1)
      eby01= eta*(dzxdyypy0 -rooe*dzxdyypy1)
      ebz01= eta*(dzxdyypz0 -rooe*dzxdyypz1)
      ecx01= eta*(dzxdzzpx0 -rooe*dzxdzzpx1)
      ecy01= eta*(dzxdzzpy0 -rooe*dzxdzzpy1)
      ecz01= eta*(dzxdzzpz0 -rooe*dzxdzzpz1)
      edx01= eta*(dzxdyxpx0 -rooe*dzxdyxpx1)
      edy01= eta*(dzxdyxpy0 -rooe*dzxdyxpy1)
      edz01= eta*(dzxdyxpz0 -rooe*dzxdyxpz1)
      eex01= eta*(dzxdzxpx0 -rooe*dzxdzxpx1)
      eey01= eta*(dzxdzxpy0 -rooe*dzxdzxpy1)
      eez01= eta*(dzxdzxpz0 -rooe*dzxdzxpz1)
      efx01= eta*(dzxdzypx0 -rooe*dzxdzypx1)
      efy01= eta*(dzxdzypy0 -rooe*dzxdzypy1)
      efz01= eta*(dzxdzypz0 -rooe*dzxdzypz1)
      fax01= eta*(dzydxxpx0 -rooe*dzydxxpx1)
      fay01= eta*(dzydxxpy0 -rooe*dzydxxpy1)
      faz01= eta*(dzydxxpz0 -rooe*dzydxxpz1)
      fbx01= eta*(dzydyypx0 -rooe*dzydyypx1)
      fby01= eta*(dzydyypy0 -rooe*dzydyypy1)
      fbz01= eta*(dzydyypz0 -rooe*dzydyypz1)
      fcx01= eta*(dzydzzpx0 -rooe*dzydzzpx1)
      fcy01= eta*(dzydzzpy0 -rooe*dzydzzpy1)
      fcz01= eta*(dzydzzpz0 -rooe*dzydzzpz1)
      fdx01= eta*(dzydyxpx0 -rooe*dzydyxpx1)
      fdy01= eta*(dzydyxpy0 -rooe*dzydyxpy1)
      fdz01= eta*(dzydyxpz0 -rooe*dzydyxpz1)
      fex01= eta*(dzydzxpx0 -rooe*dzydzxpx1)
      fey01= eta*(dzydzxpy0 -rooe*dzydzxpy1)
      fez01= eta*(dzydzxpz0 -rooe*dzydzxpz1)
      ffx01= eta*(dzydzypx0 -rooe*dzydzypx1)
      ffy01= eta*(dzydzypy0 -rooe*dzydzypy1)
      ffz01= eta*(dzydzypz0 -rooe*dzydzypz1)
      aax12= eta*(dxxdxxpx1 -rooe*dxxdxxpx2)
      aay12= eta*(dxxdxxpy1 -rooe*dxxdxxpy2)
      aaz12= eta*(dxxdxxpz1 -rooe*dxxdxxpz2)
      abx12= eta*(dxxdyypx1 -rooe*dxxdyypx2)
      aby12= eta*(dxxdyypy1 -rooe*dxxdyypy2)
      abz12= eta*(dxxdyypz1 -rooe*dxxdyypz2)
      acx12= eta*(dxxdzzpx1 -rooe*dxxdzzpx2)
      acy12= eta*(dxxdzzpy1 -rooe*dxxdzzpy2)
      acz12= eta*(dxxdzzpz1 -rooe*dxxdzzpz2)
      adx12= eta*(dxxdyxpx1 -rooe*dxxdyxpx2)
      ady12= eta*(dxxdyxpy1 -rooe*dxxdyxpy2)
      adz12= eta*(dxxdyxpz1 -rooe*dxxdyxpz2)
      aex12= eta*(dxxdzxpx1 -rooe*dxxdzxpx2)
      aey12= eta*(dxxdzxpy1 -rooe*dxxdzxpy2)
      aez12= eta*(dxxdzxpz1 -rooe*dxxdzxpz2)
      afx12= eta*(dxxdzypx1 -rooe*dxxdzypx2)
      afy12= eta*(dxxdzypy1 -rooe*dxxdzypy2)
      afz12= eta*(dxxdzypz1 -rooe*dxxdzypz2)
      bax12= eta*(dyydxxpx1 -rooe*dyydxxpx2)
      bay12= eta*(dyydxxpy1 -rooe*dyydxxpy2)
      baz12= eta*(dyydxxpz1 -rooe*dyydxxpz2)
      bbx12= eta*(dyydyypx1 -rooe*dyydyypx2)
      bby12= eta*(dyydyypy1 -rooe*dyydyypy2)
      bbz12= eta*(dyydyypz1 -rooe*dyydyypz2)
      bcx12= eta*(dyydzzpx1 -rooe*dyydzzpx2)
      bcy12= eta*(dyydzzpy1 -rooe*dyydzzpy2)
      bcz12= eta*(dyydzzpz1 -rooe*dyydzzpz2)
      bdx12= eta*(dyydyxpx1 -rooe*dyydyxpx2)
      bdy12= eta*(dyydyxpy1 -rooe*dyydyxpy2)
      bdz12= eta*(dyydyxpz1 -rooe*dyydyxpz2)
      bex12= eta*(dyydzxpx1 -rooe*dyydzxpx2)
      bey12= eta*(dyydzxpy1 -rooe*dyydzxpy2)
      bez12= eta*(dyydzxpz1 -rooe*dyydzxpz2)
      bfx12= eta*(dyydzypx1 -rooe*dyydzypx2)
      bfy12= eta*(dyydzypy1 -rooe*dyydzypy2)
      bfz12= eta*(dyydzypz1 -rooe*dyydzypz2)
      cax12= eta*(dzzdxxpx1 -rooe*dzzdxxpx2)
      cay12= eta*(dzzdxxpy1 -rooe*dzzdxxpy2)
      caz12= eta*(dzzdxxpz1 -rooe*dzzdxxpz2)
      cbx12= eta*(dzzdyypx1 -rooe*dzzdyypx2)
      cby12= eta*(dzzdyypy1 -rooe*dzzdyypy2)
      cbz12= eta*(dzzdyypz1 -rooe*dzzdyypz2)
      ccx12= eta*(dzzdzzpx1 -rooe*dzzdzzpx2)
      ccy12= eta*(dzzdzzpy1 -rooe*dzzdzzpy2)
      ccz12= eta*(dzzdzzpz1 -rooe*dzzdzzpz2)
      cdx12= eta*(dzzdyxpx1 -rooe*dzzdyxpx2)
      cdy12= eta*(dzzdyxpy1 -rooe*dzzdyxpy2)
      cdz12= eta*(dzzdyxpz1 -rooe*dzzdyxpz2)
      cex12= eta*(dzzdzxpx1 -rooe*dzzdzxpx2)
      cey12= eta*(dzzdzxpy1 -rooe*dzzdzxpy2)
      cez12= eta*(dzzdzxpz1 -rooe*dzzdzxpz2)
      cfx12= eta*(dzzdzypx1 -rooe*dzzdzypx2)
      cfy12= eta*(dzzdzypy1 -rooe*dzzdzypy2)
      cfz12= eta*(dzzdzypz1 -rooe*dzzdzypz2)
      dax12= eta*(dyxdxxpx1 -rooe*dyxdxxpx2)
      day12= eta*(dyxdxxpy1 -rooe*dyxdxxpy2)
      daz12= eta*(dyxdxxpz1 -rooe*dyxdxxpz2)
      dbx12= eta*(dyxdyypx1 -rooe*dyxdyypx2)
      dby12= eta*(dyxdyypy1 -rooe*dyxdyypy2)
      dbz12= eta*(dyxdyypz1 -rooe*dyxdyypz2)
      dcx12= eta*(dyxdzzpx1 -rooe*dyxdzzpx2)
      dcy12= eta*(dyxdzzpy1 -rooe*dyxdzzpy2)
      dcz12= eta*(dyxdzzpz1 -rooe*dyxdzzpz2)
      ddx12= eta*(dyxdyxpx1 -rooe*dyxdyxpx2)
      ddy12= eta*(dyxdyxpy1 -rooe*dyxdyxpy2)
      ddz12= eta*(dyxdyxpz1 -rooe*dyxdyxpz2)
      dex12= eta*(dyxdzxpx1 -rooe*dyxdzxpx2)
      dey12= eta*(dyxdzxpy1 -rooe*dyxdzxpy2)
      dez12= eta*(dyxdzxpz1 -rooe*dyxdzxpz2)
      dfx12= eta*(dyxdzypx1 -rooe*dyxdzypx2)
      dfy12= eta*(dyxdzypy1 -rooe*dyxdzypy2)
      dfz12= eta*(dyxdzypz1 -rooe*dyxdzypz2)
      eax12= eta*(dzxdxxpx1 -rooe*dzxdxxpx2)
      eay12= eta*(dzxdxxpy1 -rooe*dzxdxxpy2)
      eaz12= eta*(dzxdxxpz1 -rooe*dzxdxxpz2)
      ebx12= eta*(dzxdyypx1 -rooe*dzxdyypx2)
      eby12= eta*(dzxdyypy1 -rooe*dzxdyypy2)
      ebz12= eta*(dzxdyypz1 -rooe*dzxdyypz2)
      ecx12= eta*(dzxdzzpx1 -rooe*dzxdzzpx2)
      ecy12= eta*(dzxdzzpy1 -rooe*dzxdzzpy2)
      ecz12= eta*(dzxdzzpz1 -rooe*dzxdzzpz2)
      edx12= eta*(dzxdyxpx1 -rooe*dzxdyxpx2)
      edy12= eta*(dzxdyxpy1 -rooe*dzxdyxpy2)
      edz12= eta*(dzxdyxpz1 -rooe*dzxdyxpz2)
      eex12= eta*(dzxdzxpx1 -rooe*dzxdzxpx2)
      eey12= eta*(dzxdzxpy1 -rooe*dzxdzxpy2)
      eez12= eta*(dzxdzxpz1 -rooe*dzxdzxpz2)
      efx12= eta*(dzxdzypx1 -rooe*dzxdzypx2)
      efy12= eta*(dzxdzypy1 -rooe*dzxdzypy2)
      efz12= eta*(dzxdzypz1 -rooe*dzxdzypz2)
      fax12= eta*(dzydxxpx1 -rooe*dzydxxpx2)
      fay12= eta*(dzydxxpy1 -rooe*dzydxxpy2)
      faz12= eta*(dzydxxpz1 -rooe*dzydxxpz2)
      fbx12= eta*(dzydyypx1 -rooe*dzydyypx2)
      fby12= eta*(dzydyypy1 -rooe*dzydyypy2)
      fbz12= eta*(dzydyypz1 -rooe*dzydyypz2)
      fcx12= eta*(dzydzzpx1 -rooe*dzydzzpx2)
      fcy12= eta*(dzydzzpy1 -rooe*dzydzzpy2)
      fcz12= eta*(dzydzzpz1 -rooe*dzydzzpz2)
      fdx12= eta*(dzydyxpx1 -rooe*dzydyxpx2)
      fdy12= eta*(dzydyxpy1 -rooe*dzydyxpy2)
      fdz12= eta*(dzydyxpz1 -rooe*dzydyxpz2)
      fex12= eta*(dzydzxpx1 -rooe*dzydzxpx2)
      fey12= eta*(dzydzxpy1 -rooe*dzydzxpy2)
      fez12= eta*(dzydzxpz1 -rooe*dzydzxpz2)
      ffx12= eta*(dzydzypx1 -rooe*dzydzypx2)
      ffy12= eta*(dzydzypy1 -rooe*dzydzypy2)
      ffz12= eta*(dzydzypz1 -rooe*dzydzypz2)
                           
!dddp(0-1)
      aaax0=qdx*aaa0+wqx*aaa1+2.d0*rxaa1+2.d0*raxa1+2.d0*aax01
      aaay0=qdy*aaa0+wqy*aaa1                      
      aaaz0=qdz*aaa0+wqz*aaa1                      
      aabx0=qdx*aab0+wqx*aab1+2.d0*rxab1+2.d0*raxb1
      aaby0=qdy*aab0+wqy*aab1                      +2.d0*aay01
      aabz0=qdz*aab0+wqz*aab1                      
      aacx0=qdx*aac0+wqx*aac1+2.d0*rxac1+2.d0*raxc1
      aacy0=qdy*aac0+wqy*aac1                      
      aacz0=qdz*aac0+wqz*aac1                      +2.d0*aaz01
      aadx0=qdx*aad0+wqx*aad1+2.d0*rxad1+2.d0*raxd1+     aay01
      aady0=qdy*aad0+wqy*aad1                      +     aax01
      aadz0=qdz*aad0+wqz*aad1                      
      aaex0=qdx*aae0+wqx*aae1+2.d0*rxae1+2.d0*raxe1+     aaz01
      aaey0=qdy*aae0+wqy*aae1                      
      aaez0=qdz*aae0+wqz*aae1                      +     aax01
      aafx0=qdx*aaf0+wqx*aaf1+2.d0*rxaf1+2.d0*raxf1
      aafy0=qdy*aaf0+wqy*aaf1                      +     aaz01
      aafz0=qdz*aaf0+wqz*aaf1                      +     aay01
      abax0=qdx*aba0+wqx*aba1+2.d0*rxba1           +2.d0*abx01
      abay0=qdy*aba0+wqy*aba1           +2.d0*raya1
      abaz0=qdz*aba0+wqz*aba1                      
      abbx0=qdx*abb0+wqx*abb1+2.d0*rxbb1           
      abby0=qdy*abb0+wqy*abb1           +2.d0*rayb1+2.d0*aby01
      abbz0=qdz*abb0+wqz*abb1                      
      abcx0=qdx*abc0+wqx*abc1+2.d0*rxbc1           
      abcy0=qdy*abc0+wqy*abc1           +2.d0*rayc1
      abcz0=qdz*abc0+wqz*abc1                      +2.d0*abz01
      abdx0=qdx*abd0+wqx*abd1+2.d0*rxbd1           +     aby01
      abdy0=qdy*abd0+wqy*abd1           +2.d0*rayd1+     abx01
      abdz0=qdz*abd0+wqz*abd1                      
      abex0=qdx*abe0+wqx*abe1+2.d0*rxbe1           +     abz01
      abey0=qdy*abe0+wqy*abe1           +2.d0*raye1
      abez0=qdz*abe0+wqz*abe1                      +     abx01
      abfx0=qdx*abf0+wqx*abf1+2.d0*rxbf1           
      abfy0=qdy*abf0+wqy*abf1           +2.d0*rayf1+     abz01
      abfz0=qdz*abf0+wqz*abf1                      +     aby01
      acax0=qdx*aca0+wqx*aca1+2.d0*rxca1           +2.d0*acx01
      acay0=qdy*aca0+wqy*aca1                      
      acaz0=qdz*aca0+wqz*aca1           +2.d0*raza1
      acbx0=qdx*acb0+wqx*acb1+2.d0*rxcb1           
      acby0=qdy*acb0+wqy*acb1                      +2.d0*acy01
      acbz0=qdz*acb0+wqz*acb1           +2.d0*razb1
      accx0=qdx*acc0+wqx*acc1+2.d0*rxcc1           
      accy0=qdy*acc0+wqy*acc1                      
      accz0=qdz*acc0+wqz*acc1           +2.d0*razc1+2.d0*acz01
      acdx0=qdx*acd0+wqx*acd1+2.d0*rxcd1           +     acy01
      acdy0=qdy*acd0+wqy*acd1                      +     acx01
      acdz0=qdz*acd0+wqz*acd1           +2.d0*razd1
      acex0=qdx*ace0+wqx*ace1+2.d0*rxce1           +     acz01
      acey0=qdy*ace0+wqy*ace1                      
      acez0=qdz*ace0+wqz*ace1           +2.d0*raze1+     acx01
      acfx0=qdx*acf0+wqx*acf1+2.d0*rxcf1           
      acfy0=qdy*acf0+wqy*acf1                      +     acz01
      acfz0=qdz*acf0+wqz*acf1           +2.d0*razf1+     acy01
      adax0=qdx*ada0+wqx*ada1+2.d0*rxda1+     raya1+2.d0*adx01
      aday0=qdy*ada0+wqy*ada1           +     raxa1
      adaz0=qdz*ada0+wqz*ada1                      
      adbx0=qdx*adb0+wqx*adb1+2.d0*rxdb1+     rayb1
      adby0=qdy*adb0+wqy*adb1           +     raxb1+2.d0*ady01
      adbz0=qdz*adb0+wqz*adb1                      
      adcx0=qdx*adc0+wqx*adc1+2.d0*rxdc1+     rayc1
      adcy0=qdy*adc0+wqy*adc1           +     raxc1
      adcz0=qdz*adc0+wqz*adc1                      +2.d0*adz01
      addx0=qdx*add0+wqx*add1+2.d0*rxdd1+     rayd1+     ady01
      addy0=qdy*add0+wqy*add1           +     raxd1+     adx01
      addz0=qdz*add0+wqz*add1                      
      adex0=qdx*ade0+wqx*ade1+2.d0*rxde1+     raye1+     adz01
      adey0=qdy*ade0+wqy*ade1           +     raxe1
      adez0=qdz*ade0+wqz*ade1                      +     adx01
      adfx0=qdx*adf0+wqx*adf1+2.d0*rxdf1+     rayf1
      adfy0=qdy*adf0+wqy*adf1           +     raxf1+     adz01
      adfz0=qdz*adf0+wqz*adf1                      +     ady01
      aeax0=qdx*aea0+wqx*aea1+2.d0*rxea1+     raza1+2.d0*aex01
      aeay0=qdy*aea0+wqy*aea1                      
      aeaz0=qdz*aea0+wqz*aea1           +     raxa1
      aebx0=qdx*aeb0+wqx*aeb1+2.d0*rxeb1+     razb1
      aeby0=qdy*aeb0+wqy*aeb1                      +2.d0*aey01
      aebz0=qdz*aeb0+wqz*aeb1           +     raxb1
      aecx0=qdx*aec0+wqx*aec1+2.d0*rxec1+     razc1
      aecy0=qdy*aec0+wqy*aec1                      
      aecz0=qdz*aec0+wqz*aec1           +     raxc1+2.d0*aez01
      aedx0=qdx*aed0+wqx*aed1+2.d0*rxed1+     razd1+     aey01
      aedy0=qdy*aed0+wqy*aed1                      +     aex01
      aedz0=qdz*aed0+wqz*aed1           +     raxd1
      aeex0=qdx*aee0+wqx*aee1+2.d0*rxee1+     raze1+     aez01
      aeey0=qdy*aee0+wqy*aee1                      
      aeez0=qdz*aee0+wqz*aee1           +     raxe1+     aex01
      aefx0=qdx*aef0+wqx*aef1+2.d0*rxef1+     razf1
      aefy0=qdy*aef0+wqy*aef1                      +     aez01
      aefz0=qdz*aef0+wqz*aef1           +     raxf1+     aey01
      afax0=qdx*afa0+wqx*afa1+2.d0*rxfa1           +2.d0*afx01
      afay0=qdy*afa0+wqy*afa1           +     raza1
      afaz0=qdz*afa0+wqz*afa1           +     raya1
      afbx0=qdx*afb0+wqx*afb1+2.d0*rxfb1           
      afby0=qdy*afb0+wqy*afb1           +     razb1+2.d0*afy01
      afbz0=qdz*afb0+wqz*afb1           +     rayb1
      afcx0=qdx*afc0+wqx*afc1+2.d0*rxfc1           
      afcy0=qdy*afc0+wqy*afc1           +     razc1
      afcz0=qdz*afc0+wqz*afc1           +     rayc1+2.d0*afz01
      afdx0=qdx*afd0+wqx*afd1+2.d0*rxfd1           +     afy01
      afdy0=qdy*afd0+wqy*afd1           +     razd1+     afx01
      afdz0=qdz*afd0+wqz*afd1           +     rayd1
      afex0=qdx*afe0+wqx*afe1+2.d0*rxfe1           +     afz01
      afey0=qdy*afe0+wqy*afe1           +     raze1
      afez0=qdz*afe0+wqz*afe1           +     raye1+     afx01
      affx0=qdx*aff0+wqx*aff1+2.d0*rxff1           
      affy0=qdy*aff0+wqy*aff1           +     razf1+     afz01
      affz0=qdz*aff0+wqz*aff1           +     rayf1+     afy01
      baax0=qdx*baa0+wqx*baa1           +2.d0*rbxa1+2.d0*bax01
      baay0=qdy*baa0+wqy*baa1+2.d0*ryaa1           
      baaz0=qdz*baa0+wqz*baa1                      
      babx0=qdx*bab0+wqx*bab1           +2.d0*rbxb1
      baby0=qdy*bab0+wqy*bab1+2.d0*ryab1           +2.d0*bay01
      babz0=qdz*bab0+wqz*bab1                      
      bacx0=qdx*bac0+wqx*bac1           +2.d0*rbxc1
      bacy0=qdy*bac0+wqy*bac1+2.d0*ryac1           
      bacz0=qdz*bac0+wqz*bac1                      +2.d0*baz01
      badx0=qdx*bad0+wqx*bad1           +2.d0*rbxd1+     bay01
      bady0=qdy*bad0+wqy*bad1+2.d0*ryad1           +     bax01
      badz0=qdz*bad0+wqz*bad1                      
      baex0=qdx*bae0+wqx*bae1           +2.d0*rbxe1+     baz01
      baey0=qdy*bae0+wqy*bae1+2.d0*ryae1           
      baez0=qdz*bae0+wqz*bae1                      +     bax01
      bafx0=qdx*baf0+wqx*baf1           +2.d0*rbxf1
      bafy0=qdy*baf0+wqy*baf1+2.d0*ryaf1           +     baz01
      bafz0=qdz*baf0+wqz*baf1                      +     bay01
      bbax0=qdx*bba0+wqx*bba1                      +2.d0*bbx01
      bbay0=qdy*bba0+wqy*bba1+2.d0*ryba1+2.d0*rbya1
      bbaz0=qdz*bba0+wqz*bba1                      
      bbbx0=qdx*bbb0+wqx*bbb1                      
      bbby0=qdy*bbb0+wqy*bbb1+2.d0*rybb1+2.d0*rbyb1+2.d0*bby01
      bbbz0=qdz*bbb0+wqz*bbb1                      
      bbcx0=qdx*bbc0+wqx*bbc1                      
      bbcy0=qdy*bbc0+wqy*bbc1+2.d0*rybc1+2.d0*rbyc1
      bbcz0=qdz*bbc0+wqz*bbc1                      +2.d0*bbz01
      bbdx0=qdx*bbd0+wqx*bbd1                      +     bby01
      bbdy0=qdy*bbd0+wqy*bbd1+2.d0*rybd1+2.d0*rbyd1+     bbx01
      bbdz0=qdz*bbd0+wqz*bbd1                      
      bbex0=qdx*bbe0+wqx*bbe1                      +     bbz01
      bbey0=qdy*bbe0+wqy*bbe1+2.d0*rybe1+2.d0*rbye1
      bbez0=qdz*bbe0+wqz*bbe1                      +     bbx01
      bbfx0=qdx*bbf0+wqx*bbf1                      
      bbfy0=qdy*bbf0+wqy*bbf1+2.d0*rybf1+2.d0*rbyf1+     bbz01
      bbfz0=qdz*bbf0+wqz*bbf1                      +     bby01
      bcax0=qdx*bca0+wqx*bca1                      +2.d0*bcx01
      bcay0=qdy*bca0+wqy*bca1+2.d0*ryca1           
      bcaz0=qdz*bca0+wqz*bca1           +2.d0*rbza1
      bcbx0=qdx*bcb0+wqx*bcb1                      
      bcby0=qdy*bcb0+wqy*bcb1+2.d0*rycb1           +2.d0*bcy01
      bcbz0=qdz*bcb0+wqz*bcb1           +2.d0*rbzb1
      bccx0=qdx*bcc0+wqx*bcc1                      
      bccy0=qdy*bcc0+wqy*bcc1+2.d0*rycc1           
      bccz0=qdz*bcc0+wqz*bcc1           +2.d0*rbzc1+2.d0*bcz01
      bcdx0=qdx*bcd0+wqx*bcd1                      +     bcy01
      bcdy0=qdy*bcd0+wqy*bcd1+2.d0*rycd1           +     bcx01
      bcdz0=qdz*bcd0+wqz*bcd1           +2.d0*rbzd1
      bcex0=qdx*bce0+wqx*bce1                      +     bcz01
      bcey0=qdy*bce0+wqy*bce1+2.d0*ryce1           
      bcez0=qdz*bce0+wqz*bce1           +2.d0*rbze1+     bcx01
      bcfx0=qdx*bcf0+wqx*bcf1                      
      bcfy0=qdy*bcf0+wqy*bcf1+2.d0*rycf1           +     bcz01
      bcfz0=qdz*bcf0+wqz*bcf1           +2.d0*rbzf1+     bcy01
      bdax0=qdx*bda0+wqx*bda1           +     rbya1+2.d0*bdx01
      bday0=qdy*bda0+wqy*bda1+2.d0*ryda1+     rbxa1
      bdaz0=qdz*bda0+wqz*bda1                      
      bdbx0=qdx*bdb0+wqx*bdb1           +     rbyb1
      bdby0=qdy*bdb0+wqy*bdb1+2.d0*rydb1+     rbxb1+2.d0*bdy01
      bdbz0=qdz*bdb0+wqz*bdb1                      
      bdcx0=qdx*bdc0+wqx*bdc1           +     rbyc1
      bdcy0=qdy*bdc0+wqy*bdc1+2.d0*rydc1+     rbxc1
      bdcz0=qdz*bdc0+wqz*bdc1                      +2.d0*bdz01
      bddx0=qdx*bdd0+wqx*bdd1           +     rbyd1+     bdy01
      bddy0=qdy*bdd0+wqy*bdd1+2.d0*rydd1+     rbxd1+     bdx01
      bddz0=qdz*bdd0+wqz*bdd1                      
      bdex0=qdx*bde0+wqx*bde1           +     rbye1+     bdz01
      bdey0=qdy*bde0+wqy*bde1+2.d0*ryde1+     rbxe1
      bdez0=qdz*bde0+wqz*bde1                      +     bdx01
      bdfx0=qdx*bdf0+wqx*bdf1           +     rbyf1
      bdfy0=qdy*bdf0+wqy*bdf1+2.d0*rydf1+     rbxf1+     bdz01
      bdfz0=qdz*bdf0+wqz*bdf1                      +     bdy01
      beax0=qdx*bea0+wqx*bea1           +     rbza1+2.d0*bex01
      beay0=qdy*bea0+wqy*bea1+2.d0*ryea1           
      beaz0=qdz*bea0+wqz*bea1           +     rbxa1
      bebx0=qdx*beb0+wqx*beb1           +     rbzb1
      beby0=qdy*beb0+wqy*beb1+2.d0*ryeb1           +2.d0*bey01
      bebz0=qdz*beb0+wqz*beb1           +     rbxb1
      becx0=qdx*bec0+wqx*bec1           +     rbzc1
      becy0=qdy*bec0+wqy*bec1+2.d0*ryec1           
      becz0=qdz*bec0+wqz*bec1           +     rbxc1+2.d0*bez01
      bedx0=qdx*bed0+wqx*bed1           +     rbzd1+     bey01
      bedy0=qdy*bed0+wqy*bed1+2.d0*ryed1           +     bex01
      bedz0=qdz*bed0+wqz*bed1           +     rbxd1
      beex0=qdx*bee0+wqx*bee1           +     rbze1+     bez01
      beey0=qdy*bee0+wqy*bee1+2.d0*ryee1           
      beez0=qdz*bee0+wqz*bee1           +     rbxe1+     bex01
      befx0=qdx*bef0+wqx*bef1           +     rbzf1
      befy0=qdy*bef0+wqy*bef1+2.d0*ryef1           +     bez01
      befz0=qdz*bef0+wqz*bef1           +     rbxf1+     bey01
      bfax0=qdx*bfa0+wqx*bfa1                      +2.d0*bfx01
      bfay0=qdy*bfa0+wqy*bfa1+2.d0*ryfa1+     rbza1
      bfaz0=qdz*bfa0+wqz*bfa1           +     rbya1
      bfbx0=qdx*bfb0+wqx*bfb1                      
      bfby0=qdy*bfb0+wqy*bfb1+2.d0*ryfb1+     rbzb1+2.d0*bfy01
      bfbz0=qdz*bfb0+wqz*bfb1           +     rbyb1
      bfcx0=qdx*bfc0+wqx*bfc1                      
      bfcy0=qdy*bfc0+wqy*bfc1+2.d0*ryfc1+     rbzc1
      bfcz0=qdz*bfc0+wqz*bfc1           +     rbyc1+2.d0*bfz01
      bfdx0=qdx*bfd0+wqx*bfd1                      +     bfy01
      bfdy0=qdy*bfd0+wqy*bfd1+2.d0*ryfd1+     rbzd1+     bfx01
      bfdz0=qdz*bfd0+wqz*bfd1           +     rbyd1
      bfex0=qdx*bfe0+wqx*bfe1                      +     bfz01
      bfey0=qdy*bfe0+wqy*bfe1+2.d0*ryfe1+     rbze1
      bfez0=qdz*bfe0+wqz*bfe1           +     rbye1+     bfx01
      bffx0=qdx*bff0+wqx*bff1                      
      bffy0=qdy*bff0+wqy*bff1+2.d0*ryff1+     rbzf1+     bfz01
      bffz0=qdz*bff0+wqz*bff1           +     rbyf1+     bfy01
      caax0=qdx*caa0+wqx*caa1           +2.d0*rcxa1+2.d0*cax01
      caay0=qdy*caa0+wqy*caa1                      
      caaz0=qdz*caa0+wqz*caa1+2.d0*rzaa1           
      cabx0=qdx*cab0+wqx*cab1           +2.d0*rcxb1
      caby0=qdy*cab0+wqy*cab1                      +2.d0*cay01
      cabz0=qdz*cab0+wqz*cab1+2.d0*rzab1           
      cacx0=qdx*cac0+wqx*cac1           +2.d0*rcxc1
      cacy0=qdy*cac0+wqy*cac1                      
      cacz0=qdz*cac0+wqz*cac1+2.d0*rzac1           +2.d0*caz01
      cadx0=qdx*cad0+wqx*cad1           +2.d0*rcxd1+     cay01
      cady0=qdy*cad0+wqy*cad1                      +     cax01
      cadz0=qdz*cad0+wqz*cad1+2.d0*rzad1           
      caex0=qdx*cae0+wqx*cae1           +2.d0*rcxe1+     caz01
      caey0=qdy*cae0+wqy*cae1                      
      caez0=qdz*cae0+wqz*cae1+2.d0*rzae1           +     cax01
      cafx0=qdx*caf0+wqx*caf1           +2.d0*rcxf1
      cafy0=qdy*caf0+wqy*caf1                      +     caz01
      cafz0=qdz*caf0+wqz*caf1+2.d0*rzaf1           +     cay01
      cbax0=qdx*cba0+wqx*cba1                      +2.d0*cbx01
      cbay0=qdy*cba0+wqy*cba1           +2.d0*rcya1
      cbaz0=qdz*cba0+wqz*cba1+2.d0*rzba1           
      cbbx0=qdx*cbb0+wqx*cbb1                      
      cbby0=qdy*cbb0+wqy*cbb1           +2.d0*rcyb1+2.d0*cby01
      cbbz0=qdz*cbb0+wqz*cbb1+2.d0*rzbb1           
      cbcx0=qdx*cbc0+wqx*cbc1                      
      cbcy0=qdy*cbc0+wqy*cbc1           +2.d0*rcyc1
      cbcz0=qdz*cbc0+wqz*cbc1+2.d0*rzbc1           +2.d0*cbz01
      cbdx0=qdx*cbd0+wqx*cbd1                      +     cby01
      cbdy0=qdy*cbd0+wqy*cbd1           +2.d0*rcyd1+     cbx01
      cbdz0=qdz*cbd0+wqz*cbd1+2.d0*rzbd1           
      cbex0=qdx*cbe0+wqx*cbe1                      +     cbz01
      cbey0=qdy*cbe0+wqy*cbe1           +2.d0*rcye1
      cbez0=qdz*cbe0+wqz*cbe1+2.d0*rzbe1           +     cbx01
      cbfx0=qdx*cbf0+wqx*cbf1                      
      cbfy0=qdy*cbf0+wqy*cbf1           +2.d0*rcyf1+     cbz01
      cbfz0=qdz*cbf0+wqz*cbf1+2.d0*rzbf1           +     cby01
      ccax0=qdx*cca0+wqx*cca1                      +2.d0*ccx01
      ccay0=qdy*cca0+wqy*cca1                      
      ccaz0=qdz*cca0+wqz*cca1+2.d0*rzca1+2.d0*rcza1
      ccbx0=qdx*ccb0+wqx*ccb1                      
      ccby0=qdy*ccb0+wqy*ccb1                      +2.d0*ccy01
      ccbz0=qdz*ccb0+wqz*ccb1+2.d0*rzcb1+2.d0*rczb1
      cccx0=qdx*ccc0+wqx*ccc1                      
      cccy0=qdy*ccc0+wqy*ccc1                      
      cccz0=qdz*ccc0+wqz*ccc1+2.d0*rzcc1+2.d0*rczc1+2.d0*ccz01
      ccdx0=qdx*ccd0+wqx*ccd1                      +     ccy01
      ccdy0=qdy*ccd0+wqy*ccd1                      +     ccx01
      ccdz0=qdz*ccd0+wqz*ccd1+2.d0*rzcd1+2.d0*rczd1
      ccex0=qdx*cce0+wqx*cce1                      +     ccz01
      ccey0=qdy*cce0+wqy*cce1                      
      ccez0=qdz*cce0+wqz*cce1+2.d0*rzce1+2.d0*rcze1+     ccx01
      ccfx0=qdx*ccf0+wqx*ccf1                      
      ccfy0=qdy*ccf0+wqy*ccf1                      +     ccz01
      ccfz0=qdz*ccf0+wqz*ccf1+2.d0*rzcf1+2.d0*rczf1+     ccy01
      cdax0=qdx*cda0+wqx*cda1           +     rcya1+2.d0*cdx01
      cday0=qdy*cda0+wqy*cda1           +     rcxa1
      cdaz0=qdz*cda0+wqz*cda1+2.d0*rzda1           
      cdbx0=qdx*cdb0+wqx*cdb1           +     rcyb1
      cdby0=qdy*cdb0+wqy*cdb1           +     rcxb1+2.d0*cdy01
      cdbz0=qdz*cdb0+wqz*cdb1+2.d0*rzdb1           
      cdcx0=qdx*cdc0+wqx*cdc1           +     rcyc1
      cdcy0=qdy*cdc0+wqy*cdc1           +     rcxc1
      cdcz0=qdz*cdc0+wqz*cdc1+2.d0*rzdc1           +2.d0*cdz01
      cddx0=qdx*cdd0+wqx*cdd1           +     rcyd1+     cdy01
      cddy0=qdy*cdd0+wqy*cdd1           +     rcxd1+     cdx01
      cddz0=qdz*cdd0+wqz*cdd1+2.d0*rzdd1           
      cdex0=qdx*cde0+wqx*cde1           +     rcye1+     cdz01
      cdey0=qdy*cde0+wqy*cde1           +     rcxe1
      cdez0=qdz*cde0+wqz*cde1+2.d0*rzde1           +     cdx01
      cdfx0=qdx*cdf0+wqx*cdf1           +     rcyf1
      cdfy0=qdy*cdf0+wqy*cdf1           +     rcxf1+     cdz01
      cdfz0=qdz*cdf0+wqz*cdf1+2.d0*rzdf1           +     cdy01
      ceax0=qdx*cea0+wqx*cea1           +     rcza1+2.d0*cex01
      ceay0=qdy*cea0+wqy*cea1                      
      ceaz0=qdz*cea0+wqz*cea1+2.d0*rzea1+     rcxa1
      cebx0=qdx*ceb0+wqx*ceb1           +     rczb1
      ceby0=qdy*ceb0+wqy*ceb1                      +2.d0*cey01
      cebz0=qdz*ceb0+wqz*ceb1+2.d0*rzeb1+     rcxb1
      cecx0=qdx*cec0+wqx*cec1           +     rczc1
      cecy0=qdy*cec0+wqy*cec1                      
      cecz0=qdz*cec0+wqz*cec1+2.d0*rzec1+     rcxc1+2.d0*cez01
      cedx0=qdx*ced0+wqx*ced1           +     rczd1+     cey01
      cedy0=qdy*ced0+wqy*ced1                      +     cex01
      cedz0=qdz*ced0+wqz*ced1+2.d0*rzed1+     rcxd1
      ceex0=qdx*cee0+wqx*cee1           +     rcze1+     cez01
      ceey0=qdy*cee0+wqy*cee1                      
      ceez0=qdz*cee0+wqz*cee1+2.d0*rzee1+     rcxe1+     cex01
      cefx0=qdx*cef0+wqx*cef1           +     rczf1
      cefy0=qdy*cef0+wqy*cef1                      +     cez01
      cefz0=qdz*cef0+wqz*cef1+2.d0*rzef1+     rcxf1+     cey01
      cfax0=qdx*cfa0+wqx*cfa1                      +2.d0*cfx01
      cfay0=qdy*cfa0+wqy*cfa1           +     rcza1
      cfaz0=qdz*cfa0+wqz*cfa1+2.d0*rzfa1+     rcya1
      cfbx0=qdx*cfb0+wqx*cfb1                      
      cfby0=qdy*cfb0+wqy*cfb1           +     rczb1+2.d0*cfy01
      cfbz0=qdz*cfb0+wqz*cfb1+2.d0*rzfb1+     rcyb1
      cfcx0=qdx*cfc0+wqx*cfc1                      
      cfcy0=qdy*cfc0+wqy*cfc1           +     rczc1
      cfcz0=qdz*cfc0+wqz*cfc1+2.d0*rzfc1+     rcyc1+2.d0*cfz01
      cfdx0=qdx*cfd0+wqx*cfd1                      +     cfy01
      cfdy0=qdy*cfd0+wqy*cfd1           +     rczd1+     cfx01
      cfdz0=qdz*cfd0+wqz*cfd1+2.d0*rzfd1+     rcyd1
      cfex0=qdx*cfe0+wqx*cfe1                      +     cfz01
      cfey0=qdy*cfe0+wqy*cfe1           +     rcze1
      cfez0=qdz*cfe0+wqz*cfe1+2.d0*rzfe1+     rcye1+     cfx01
      cffx0=qdx*cff0+wqx*cff1                      
      cffy0=qdy*cff0+wqy*cff1           +     rczf1+     cfz01
      cffz0=qdz*cff0+wqz*cff1+2.d0*rzff1+     rcyf1+     cfy01
      daax0=qdx*daa0+wqx*daa1+     ryaa1+2.d0*rdxa1+2.d0*dax01
      daay0=qdy*daa0+wqy*daa1+     rxaa1           
      daaz0=qdz*daa0+wqz*daa1                      
      dabx0=qdx*dab0+wqx*dab1+     ryab1+2.d0*rdxb1
      daby0=qdy*dab0+wqy*dab1+     rxab1           +2.d0*day01
      dabz0=qdz*dab0+wqz*dab1                      
      dacx0=qdx*dac0+wqx*dac1+     ryac1+2.d0*rdxc1
      dacy0=qdy*dac0+wqy*dac1+     rxac1           
      dacz0=qdz*dac0+wqz*dac1                      +2.d0*daz01
      dadx0=qdx*dad0+wqx*dad1+     ryad1+2.d0*rdxd1+     day01
      dady0=qdy*dad0+wqy*dad1+     rxad1           +     dax01
      dadz0=qdz*dad0+wqz*dad1                      
      daex0=qdx*dae0+wqx*dae1+     ryae1+2.d0*rdxe1+     daz01
      daey0=qdy*dae0+wqy*dae1+     rxae1           
      daez0=qdz*dae0+wqz*dae1                      +     dax01
      dafx0=qdx*daf0+wqx*daf1+     ryaf1+2.d0*rdxf1
      dafy0=qdy*daf0+wqy*daf1+     rxaf1           +     daz01
      dafz0=qdz*daf0+wqz*daf1                      +     day01
      dbax0=qdx*dba0+wqx*dba1+     ryba1           +2.d0*dbx01
      dbay0=qdy*dba0+wqy*dba1+     rxba1+2.d0*rdya1
      dbaz0=qdz*dba0+wqz*dba1                      
      dbbx0=qdx*dbb0+wqx*dbb1+     rybb1           
      dbby0=qdy*dbb0+wqy*dbb1+     rxbb1+2.d0*rdyb1+2.d0*dby01
      dbbz0=qdz*dbb0+wqz*dbb1                      
      dbcx0=qdx*dbc0+wqx*dbc1+     rybc1           
      dbcy0=qdy*dbc0+wqy*dbc1+     rxbc1+2.d0*rdyc1
      dbcz0=qdz*dbc0+wqz*dbc1                      +2.d0*dbz01
      dbdx0=qdx*dbd0+wqx*dbd1+     rybd1           +     dby01
      dbdy0=qdy*dbd0+wqy*dbd1+     rxbd1+2.d0*rdyd1+     dbx01
      dbdz0=qdz*dbd0+wqz*dbd1                      
      dbex0=qdx*dbe0+wqx*dbe1+     rybe1           +     dbz01
      dbey0=qdy*dbe0+wqy*dbe1+     rxbe1+2.d0*rdye1
      dbez0=qdz*dbe0+wqz*dbe1                      +     dbx01
      dbfx0=qdx*dbf0+wqx*dbf1+     rybf1           
      dbfy0=qdy*dbf0+wqy*dbf1+     rxbf1+2.d0*rdyf1+     dbz01
      dbfz0=qdz*dbf0+wqz*dbf1                      +     dby01
      dcax0=qdx*dca0+wqx*dca1+     ryca1           +2.d0*dcx01
      dcay0=qdy*dca0+wqy*dca1+     rxca1           
      dcaz0=qdz*dca0+wqz*dca1           +2.d0*rdza1
      dcbx0=qdx*dcb0+wqx*dcb1+     rycb1           
      dcby0=qdy*dcb0+wqy*dcb1+     rxcb1           +2.d0*dcy01
      dcbz0=qdz*dcb0+wqz*dcb1           +2.d0*rdzb1
      dccx0=qdx*dcc0+wqx*dcc1+     rycc1           
      dccy0=qdy*dcc0+wqy*dcc1+     rxcc1           
      dccz0=qdz*dcc0+wqz*dcc1           +2.d0*rdzc1+2.d0*dcz01
      dcdx0=qdx*dcd0+wqx*dcd1+     rycd1           +     dcy01
      dcdy0=qdy*dcd0+wqy*dcd1+     rxcd1           +     dcx01
      dcdz0=qdz*dcd0+wqz*dcd1           +2.d0*rdzd1
      dcex0=qdx*dce0+wqx*dce1+     ryce1           +     dcz01
      dcey0=qdy*dce0+wqy*dce1+     rxce1           
      dcez0=qdz*dce0+wqz*dce1           +2.d0*rdze1+     dcx01
      dcfx0=qdx*dcf0+wqx*dcf1+     rycf1           
      dcfy0=qdy*dcf0+wqy*dcf1+     rxcf1           +     dcz01
      dcfz0=qdz*dcf0+wqz*dcf1           +2.d0*rdzf1+     dcy01
      ddax0=qdx*dda0+wqx*dda1+     ryda1+     rdya1+2.d0*ddx01
      dday0=qdy*dda0+wqy*dda1+     rxda1+     rdxa1
      ddaz0=qdz*dda0+wqz*dda1                      
      ddbx0=qdx*ddb0+wqx*ddb1+     rydb1+     rdyb1
      ddby0=qdy*ddb0+wqy*ddb1+     rxdb1+     rdxb1+2.d0*ddy01
      ddbz0=qdz*ddb0+wqz*ddb1                      
      ddcx0=qdx*ddc0+wqx*ddc1+     rydc1+     rdyc1
      ddcy0=qdy*ddc0+wqy*ddc1+     rxdc1+     rdxc1
      ddcz0=qdz*ddc0+wqz*ddc1                      +2.d0*ddz01
      dddx0=qdx*ddd0+wqx*ddd1+     rydd1+     rdyd1+     ddy01
      dddy0=qdy*ddd0+wqy*ddd1+     rxdd1+     rdxd1+     ddx01
      dddz0=qdz*ddd0+wqz*ddd1                      
      ddex0=qdx*dde0+wqx*dde1+     ryde1+     rdye1+     ddz01
      ddey0=qdy*dde0+wqy*dde1+     rxde1+     rdxe1
      ddez0=qdz*dde0+wqz*dde1                      +     ddx01
      ddfx0=qdx*ddf0+wqx*ddf1+     rydf1+     rdyf1
      ddfy0=qdy*ddf0+wqy*ddf1+     rxdf1+     rdxf1+     ddz01
      ddfz0=qdz*ddf0+wqz*ddf1                      +     ddy01
      deax0=qdx*dea0+wqx*dea1+     ryea1+     rdza1+2.d0*dex01
      deay0=qdy*dea0+wqy*dea1+     rxea1           
      deaz0=qdz*dea0+wqz*dea1           +     rdxa1
      debx0=qdx*deb0+wqx*deb1+     ryeb1+     rdzb1
      deby0=qdy*deb0+wqy*deb1+     rxeb1           +2.d0*dey01
      debz0=qdz*deb0+wqz*deb1           +     rdxb1
      decx0=qdx*dec0+wqx*dec1+     ryec1+     rdzc1
      decy0=qdy*dec0+wqy*dec1+     rxec1           
      decz0=qdz*dec0+wqz*dec1           +     rdxc1+2.d0*dez01
      dedx0=qdx*ded0+wqx*ded1+     ryed1+     rdzd1+     dey01
      dedy0=qdy*ded0+wqy*ded1+     rxed1           +     dex01
      dedz0=qdz*ded0+wqz*ded1           +     rdxd1
      deex0=qdx*dee0+wqx*dee1+     ryee1+     rdze1+     dez01
      deey0=qdy*dee0+wqy*dee1+     rxee1           
      deez0=qdz*dee0+wqz*dee1           +     rdxe1+     dex01
      defx0=qdx*def0+wqx*def1+     ryef1+     rdzf1
      defy0=qdy*def0+wqy*def1+     rxef1           +     dez01
      defz0=qdz*def0+wqz*def1           +     rdxf1+     dey01
      dfax0=qdx*dfa0+wqx*dfa1+     ryfa1           +2.d0*dfx01
      dfay0=qdy*dfa0+wqy*dfa1+     rxfa1+     rdza1
      dfaz0=qdz*dfa0+wqz*dfa1           +     rdya1
      dfbx0=qdx*dfb0+wqx*dfb1+     ryfb1                     
      dfby0=qdy*dfb0+wqy*dfb1+     rxfb1+     rdzb1+2.d0*dfy01
      dfbz0=qdz*dfb0+wqz*dfb1           +     rdyb1
      dfcx0=qdx*dfc0+wqx*dfc1+     ryfc1                     
      dfcy0=qdy*dfc0+wqy*dfc1+     rxfc1+     rdzc1
      dfcz0=qdz*dfc0+wqz*dfc1           +     rdyc1+2.d0*dfz01
      dfdx0=qdx*dfd0+wqx*dfd1+     ryfd1           +     dfy01
      dfdy0=qdy*dfd0+wqy*dfd1+     rxfd1+     rdzd1+     dfx01
      dfdz0=qdz*dfd0+wqz*dfd1           +     rdyd1
      dfex0=qdx*dfe0+wqx*dfe1+     ryfe1           +     dfz01
      dfey0=qdy*dfe0+wqy*dfe1+     rxfe1+     rdze1
      dfez0=qdz*dfe0+wqz*dfe1           +     rdye1+     dfx01
      dffx0=qdx*dff0+wqx*dff1+     ryff1                    
      dffy0=qdy*dff0+wqy*dff1+     rxff1+     rdzf1+     dfz01
      dffz0=qdz*dff0+wqz*dff1           +     rdyf1+     dfy01
      eaax0=qdx*eaa0+wqx*eaa1+     rzaa1+2.d0*rexa1+2.d0*eax01
      eaay0=qdy*eaa0+wqy*eaa1                      
      eaaz0=qdz*eaa0+wqz*eaa1+     rxaa1           
      eabx0=qdx*eab0+wqx*eab1+     rzab1+2.d0*rexb1
      eaby0=qdy*eab0+wqy*eab1                      +2.d0*eay01
      eabz0=qdz*eab0+wqz*eab1+     rxab1           
      eacx0=qdx*eac0+wqx*eac1+     rzac1+2.d0*rexc1
      eacy0=qdy*eac0+wqy*eac1                      
      eacz0=qdz*eac0+wqz*eac1+     rxac1           +2.d0*eaz01
      eadx0=qdx*ead0+wqx*ead1+     rzad1+2.d0*rexd1+     eay01
      eady0=qdy*ead0+wqy*ead1                      +     eax01
      eadz0=qdz*ead0+wqz*ead1+     rxad1           
      eaex0=qdx*eae0+wqx*eae1+     rzae1+2.d0*rexe1+     eaz01
      eaey0=qdy*eae0+wqy*eae1                      
      eaez0=qdz*eae0+wqz*eae1+     rxae1           +     eax01
      eafx0=qdx*eaf0+wqx*eaf1+     rzaf1+2.d0*rexf1
      eafy0=qdy*eaf0+wqy*eaf1                      +     eaz01
      eafz0=qdz*eaf0+wqz*eaf1+     rxaf1           +     eay01
      ebax0=qdx*eba0+wqx*eba1+     rzba1           +2.d0*ebx01
      ebay0=qdy*eba0+wqy*eba1           +2.d0*reya1
      ebaz0=qdz*eba0+wqz*eba1+     rxba1           
      ebbx0=qdx*ebb0+wqx*ebb1+     rzbb1           
      ebby0=qdy*ebb0+wqy*ebb1           +2.d0*reyb1+2.d0*eby01
      ebbz0=qdz*ebb0+wqz*ebb1+     rxbb1           
      ebcx0=qdx*ebc0+wqx*ebc1+     rzbc1           
      ebcy0=qdy*ebc0+wqy*ebc1           +2.d0*reyc1
      ebcz0=qdz*ebc0+wqz*ebc1+     rxbc1           +2.d0*ebz01
      ebdx0=qdx*ebd0+wqx*ebd1+     rzbd1           +     eby01
      ebdy0=qdy*ebd0+wqy*ebd1           +2.d0*reyd1+     ebx01
      ebdz0=qdz*ebd0+wqz*ebd1+     rxbd1           
      ebex0=qdx*ebe0+wqx*ebe1+     rzbe1           +     ebz01
      ebey0=qdy*ebe0+wqy*ebe1           +2.d0*reye1
      ebez0=qdz*ebe0+wqz*ebe1+     rxbe1           +     ebx01
      ebfx0=qdx*ebf0+wqx*ebf1+     rzbf1           
      ebfy0=qdy*ebf0+wqy*ebf1           +2.d0*reyf1+     ebz01
      ebfz0=qdz*ebf0+wqz*ebf1+     rxbf1           +     eby01
      ecax0=qdx*eca0+wqx*eca1+     rzca1           +2.d0*ecx01
      ecay0=qdy*eca0+wqy*eca1                      
      ecaz0=qdz*eca0+wqz*eca1+     rxca1+2.d0*reza1
      ecbx0=qdx*ecb0+wqx*ecb1+     rzcb1           
      ecby0=qdy*ecb0+wqy*ecb1                      +2.d0*ecy01
      ecbz0=qdz*ecb0+wqz*ecb1+     rxcb1+2.d0*rezb1
      eccx0=qdx*ecc0+wqx*ecc1+     rzcc1           
      eccy0=qdy*ecc0+wqy*ecc1                      
      eccz0=qdz*ecc0+wqz*ecc1+     rxcc1+2.d0*rezc1+2.d0*ecz01
      ecdx0=qdx*ecd0+wqx*ecd1+     rzcd1           +     ecy01
      ecdy0=qdy*ecd0+wqy*ecd1                      +     ecx01
      ecdz0=qdz*ecd0+wqz*ecd1+     rxcd1+2.d0*rezd1
      ecex0=qdx*ece0+wqx*ece1+     rzce1           +     ecz01
      ecey0=qdy*ece0+wqy*ece1                      
      ecez0=qdz*ece0+wqz*ece1+     rxce1+2.d0*reze1+     ecx01
      ecfx0=qdx*ecf0+wqx*ecf1+     rzcf1           
      ecfy0=qdy*ecf0+wqy*ecf1                      +     ecz01
      ecfz0=qdz*ecf0+wqz*ecf1+     rxcf1+2.d0*rezf1+     ecy01
      edax0=qdx*eda0+wqx*eda1+     rzda1+     reya1+2.d0*edx01
      eday0=qdy*eda0+wqy*eda1           +     rexa1
      edaz0=qdz*eda0+wqz*eda1+     rxda1           
      edbx0=qdx*edb0+wqx*edb1+     rzdb1+     reyb1
      edby0=qdy*edb0+wqy*edb1           +     rexb1+2.d0*edy01
      edbz0=qdz*edb0+wqz*edb1+     rxdb1           
      edcx0=qdx*edc0+wqx*edc1+     rzdc1+     reyc1
      edcy0=qdy*edc0+wqy*edc1           +     rexc1
      edcz0=qdz*edc0+wqz*edc1+     rxdc1           +2.d0*edz01
      eddx0=qdx*edd0+wqx*edd1+     rzdd1+     reyd1+     edy01
      eddy0=qdy*edd0+wqy*edd1           +     rexd1+     edx01
      eddz0=qdz*edd0+wqz*edd1+     rxdd1           
      edex0=qdx*ede0+wqx*ede1+     rzde1+     reye1+     edz01
      edey0=qdy*ede0+wqy*ede1           +     rexe1
      edez0=qdz*ede0+wqz*ede1+     rxde1           +     edx01
      edfx0=qdx*edf0+wqx*edf1+     rzdf1+     reyf1
      edfy0=qdy*edf0+wqy*edf1           +     rexf1+     edz01
      edfz0=qdz*edf0+wqz*edf1+     rxdf1           +     edy01
      eeax0=qdx*eea0+wqx*eea1+     rzea1+     reza1+2.d0*eex01
      eeay0=qdy*eea0+wqy*eea1                      
      eeaz0=qdz*eea0+wqz*eea1+     rxea1+     rexa1
      eebx0=qdx*eeb0+wqx*eeb1+     rzeb1+     rezb1
      eeby0=qdy*eeb0+wqy*eeb1                      +2.d0*eey01
      eebz0=qdz*eeb0+wqz*eeb1+     rxeb1+     rexb1
      eecx0=qdx*eec0+wqx*eec1+     rzec1+     rezc1
      eecy0=qdy*eec0+wqy*eec1                      
      eecz0=qdz*eec0+wqz*eec1+     rxec1+     rexc1+2.d0*eez01
      eedx0=qdx*eed0+wqx*eed1+     rzed1+     rezd1+     eey01
      eedy0=qdy*eed0+wqy*eed1                      +     eex01
      eedz0=qdz*eed0+wqz*eed1+     rxed1+     rexd1
      eeex0=qdx*eee0+wqx*eee1+     rzee1+     reze1+     eez01
      eeey0=qdy*eee0+wqy*eee1                      
      eeez0=qdz*eee0+wqz*eee1+     rxee1+     rexe1+     eex01
      eefx0=qdx*eef0+wqx*eef1+     rzef1+     rezf1
      eefy0=qdy*eef0+wqy*eef1                      +     eez01
      eefz0=qdz*eef0+wqz*eef1+     rxef1+     rexf1+     eey01
      efax0=qdx*efa0+wqx*efa1+     rzfa1           +2.d0*efx01
      efay0=qdy*efa0+wqy*efa1           +     reza1
      efaz0=qdz*efa0+wqz*efa1+     rxfa1+     reya1
      efbx0=qdx*efb0+wqx*efb1+     rzfb1           
      efby0=qdy*efb0+wqy*efb1           +     rezb1+2.d0*efy01
      efbz0=qdz*efb0+wqz*efb1+     rxfb1+     reyb1
      efcx0=qdx*efc0+wqx*efc1+     rzfc1           
      efcy0=qdy*efc0+wqy*efc1           +     rezc1
      efcz0=qdz*efc0+wqz*efc1+     rxfc1+     reyc1+2.d0*efz01
      efdx0=qdx*efd0+wqx*efd1+     rzfd1           +     efy01
      efdy0=qdy*efd0+wqy*efd1           +     rezd1+     efx01
      efdz0=qdz*efd0+wqz*efd1+     rxfd1+     reyd1
      efex0=qdx*efe0+wqx*efe1+     rzfe1           +     efz01
      efey0=qdy*efe0+wqy*efe1           +     reze1
      efez0=qdz*efe0+wqz*efe1+     rxfe1+     reye1+     efx01
      effx0=qdx*eff0+wqx*eff1+     rzff1           
      effy0=qdy*eff0+wqy*eff1           +     rezf1+     efz01
      effz0=qdz*eff0+wqz*eff1+     rxff1+     reyf1+     efy01
      faax0=qdx*faa0+wqx*faa1           +2.d0*rfxa1+2.d0*fax01
      faay0=qdy*faa0+wqy*faa1+     rzaa1           
      faaz0=qdz*faa0+wqz*faa1+     ryaa1           
      fabx0=qdx*fab0+wqx*fab1           +2.d0*rfxb1
      faby0=qdy*fab0+wqy*fab1+     rzab1           +2.d0*fay01
      fabz0=qdz*fab0+wqz*fab1+     ryab1           
      facx0=qdx*fac0+wqx*fac1           +2.d0*rfxc1
      facy0=qdy*fac0+wqy*fac1+     rzac1           
      facz0=qdz*fac0+wqz*fac1+     ryac1           +2.d0*faz01
      fadx0=qdx*fad0+wqx*fad1           +2.d0*rfxd1+     fay01
      fady0=qdy*fad0+wqy*fad1+     rzad1           +     fax01
      fadz0=qdz*fad0+wqz*fad1+     ryad1           
      faex0=qdx*fae0+wqx*fae1           +2.d0*rfxe1+     faz01
      faey0=qdy*fae0+wqy*fae1+     rzae1           
      faez0=qdz*fae0+wqz*fae1+     ryae1           +     fax01
      fafx0=qdx*faf0+wqx*faf1           +2.d0*rfxf1
      fafy0=qdy*faf0+wqy*faf1+     rzaf1           +     faz01
      fafz0=qdz*faf0+wqz*faf1+     ryaf1           +     fay01
      fbax0=qdx*fba0+wqx*fba1                      +2.d0*fbx01
      fbay0=qdy*fba0+wqy*fba1+     rzba1+2.d0*rfya1
      fbaz0=qdz*fba0+wqz*fba1+     ryba1           
      fbbx0=qdx*fbb0+wqx*fbb1                      
      fbby0=qdy*fbb0+wqy*fbb1+     rzbb1+2.d0*rfyb1+2.d0*fby01
      fbbz0=qdz*fbb0+wqz*fbb1+     rybb1           
      fbcx0=qdx*fbc0+wqx*fbc1                      
      fbcy0=qdy*fbc0+wqy*fbc1+     rzbc1+2.d0*rfyc1
      fbcz0=qdz*fbc0+wqz*fbc1+     rybc1           +2.d0*fbz01
      fbdx0=qdx*fbd0+wqx*fbd1                      +     fby01
      fbdy0=qdy*fbd0+wqy*fbd1+     rzbd1+2.d0*rfyd1+     fbx01
      fbdz0=qdz*fbd0+wqz*fbd1+     rybd1           
      fbex0=qdx*fbe0+wqx*fbe1                      +     fbz01
      fbey0=qdy*fbe0+wqy*fbe1+     rzbe1+2.d0*rfye1
      fbez0=qdz*fbe0+wqz*fbe1+     rybe1           +     fbx01
      fbfx0=qdx*fbf0+wqx*fbf1                      
      fbfy0=qdy*fbf0+wqy*fbf1+     rzbf1+2.d0*rfyf1+     fbz01
      fbfz0=qdz*fbf0+wqz*fbf1+     rybf1           +     fby01
      fcax0=qdx*fca0+wqx*fca1                      +2.d0*fcx01
      fcay0=qdy*fca0+wqy*fca1+     rzca1           
      fcaz0=qdz*fca0+wqz*fca1+     ryca1+2.d0*rfza1
      fcbx0=qdx*fcb0+wqx*fcb1                      
      fcby0=qdy*fcb0+wqy*fcb1+     rzcb1           +2.d0*fcy01
      fcbz0=qdz*fcb0+wqz*fcb1+     rycb1+2.d0*rfzb1
      fccx0=qdx*fcc0+wqx*fcc1                      
      fccy0=qdy*fcc0+wqy*fcc1+     rzcc1           
      fccz0=qdz*fcc0+wqz*fcc1+     rycc1+2.d0*rfzc1+2.d0*fcz01
      fcdx0=qdx*fcd0+wqx*fcd1                      +     fcy01
      fcdy0=qdy*fcd0+wqy*fcd1+     rzcd1           +     fcx01
      fcdz0=qdz*fcd0+wqz*fcd1+     rycd1+2.d0*rfzd1
      fcex0=qdx*fce0+wqx*fce1                      +     fcz01
      fcey0=qdy*fce0+wqy*fce1+     rzce1           
      fcez0=qdz*fce0+wqz*fce1+     ryce1+2.d0*rfze1+     fcx01
      fcfx0=qdx*fcf0+wqx*fcf1                      
      fcfy0=qdy*fcf0+wqy*fcf1+     rzcf1           +     fcz01
      fcfz0=qdz*fcf0+wqz*fcf1+     rycf1+2.d0*rfzf1+     fcy01
      fdax0=qdx*fda0+wqx*fda1           +     rfya1+2.d0*fdx01
      fday0=qdy*fda0+wqy*fda1+     rzda1+     rfxa1
      fdaz0=qdz*fda0+wqz*fda1+     ryda1           
      fdbx0=qdx*fdb0+wqx*fdb1           +     rfyb1
      fdby0=qdy*fdb0+wqy*fdb1+     rzdb1+     rfxb1+2.d0*fdy01
      fdbz0=qdz*fdb0+wqz*fdb1+     rydb1           
      fdcx0=qdx*fdc0+wqx*fdc1           +     rfyc1
      fdcy0=qdy*fdc0+wqy*fdc1+     rzdc1+     rfxc1
      fdcz0=qdz*fdc0+wqz*fdc1+     rydc1           +2.d0*fdz01
      fddx0=qdx*fdd0+wqx*fdd1           +     rfyd1+     fdy01
      fddy0=qdy*fdd0+wqy*fdd1+     rzdd1+     rfxd1+     fdx01
      fddz0=qdz*fdd0+wqz*fdd1+     rydd1           
      fdex0=qdx*fde0+wqx*fde1           +     rfye1+     fdz01
      fdey0=qdy*fde0+wqy*fde1+     rzde1+     rfxe1
      fdez0=qdz*fde0+wqz*fde1+     ryde1           +     fdx01
      fdfx0=qdx*fdf0+wqx*fdf1           +     rfyf1
      fdfy0=qdy*fdf0+wqy*fdf1+     rzdf1+     rfxf1+     fdz01
      fdfz0=qdz*fdf0+wqz*fdf1+     rydf1           +     fdy01
      feax0=qdx*fea0+wqx*fea1           +     rfza1+2.d0*fex01
      feay0=qdy*fea0+wqy*fea1+     rzea1           
      feaz0=qdz*fea0+wqz*fea1+     ryea1+     rfxa1
      febx0=qdx*feb0+wqx*feb1           +     rfzb1
      feby0=qdy*feb0+wqy*feb1+     rzeb1           +2.d0*fey01
      febz0=qdz*feb0+wqz*feb1+     ryeb1+     rfxb1
      fecx0=qdx*fec0+wqx*fec1           +     rfzc1
      fecy0=qdy*fec0+wqy*fec1+     rzec1           
      fecz0=qdz*fec0+wqz*fec1+     ryec1+     rfxc1+2.d0*fez01
      fedx0=qdx*fed0+wqx*fed1           +     rfzd1+     fey01
      fedy0=qdy*fed0+wqy*fed1+     rzed1           +     fex01
      fedz0=qdz*fed0+wqz*fed1+     ryed1+     rfxd1
      feex0=qdx*fee0+wqx*fee1           +     rfze1+     fez01
      feey0=qdy*fee0+wqy*fee1+     rzee1           
      feez0=qdz*fee0+wqz*fee1+     ryee1+     rfxe1+     fex01
      fefx0=qdx*fef0+wqx*fef1           +     rfzf1
      fefy0=qdy*fef0+wqy*fef1+     rzef1           +     fez01
      fefz0=qdz*fef0+wqz*fef1+     ryef1+     rfxf1+     fey01
      ffax0=qdx*ffa0+wqx*ffa1                      +2.d0*ffx01
      ffay0=qdy*ffa0+wqy*ffa1+     rzfa1+     rfza1
      ffaz0=qdz*ffa0+wqz*ffa1+     ryfa1+     rfya1
      ffbx0=qdx*ffb0+wqx*ffb1                      
      ffby0=qdy*ffb0+wqy*ffb1+     rzfb1+     rfzb1+2.d0*ffy01
      ffbz0=qdz*ffb0+wqz*ffb1+     ryfb1+     rfyb1
      ffcx0=qdx*ffc0+wqx*ffc1                      
      ffcy0=qdy*ffc0+wqy*ffc1+     rzfc1+     rfzc1
      ffcz0=qdz*ffc0+wqz*ffc1+     ryfc1+     rfyc1+2.d0*ffz01
      ffdx0=qdx*ffd0+wqx*ffd1                      +     ffy01
      ffdy0=qdy*ffd0+wqy*ffd1+     rzfd1+     rfzd1+     ffx01
      ffdz0=qdz*ffd0+wqz*ffd1+     ryfd1+     rfyd1
      ffex0=qdx*ffe0+wqx*ffe1                      +     ffz01
      ffey0=qdy*ffe0+wqy*ffe1+     rzfe1+     rfze1
      ffez0=qdz*ffe0+wqz*ffe1+     ryfe1+     rfye1+     ffx01
      fffx0=qdx*fff0+wqx*fff1                      
      fffy0=qdy*fff0+wqy*fff1+     rzff1+     rfzf1+     ffz01
      fffz0=qdz*fff0+wqz*fff1+     ryff1+     rfyf1+     ffy01

      aaax1=qdx*aaa1+wqx*aaa2+2.d0*rxaa2+2.d0*raxa2+2.d0*aax12
      aaay1=qdy*aaa1+wqy*aaa2                                 
      aaaz1=qdz*aaa1+wqz*aaa2                                 
      aabx1=qdx*aab1+wqx*aab2+2.d0*rxab2+2.d0*raxb2           
      aaby1=qdy*aab1+wqy*aab2                      +2.d0*aay12
      aabz1=qdz*aab1+wqz*aab2                                 
      aacx1=qdx*aac1+wqx*aac2+2.d0*rxac2+2.d0*raxc2           
      aacy1=qdy*aac1+wqy*aac2                                 
      aacz1=qdz*aac1+wqz*aac2                      +2.d0*aaz12
      aadx1=qdx*aad1+wqx*aad2+2.d0*rxad2+2.d0*raxd2+     aay12
      aady1=qdy*aad1+wqy*aad2                      +     aax12
      aadz1=qdz*aad1+wqz*aad2                                 
      aaex1=qdx*aae1+wqx*aae2+2.d0*rxae2+2.d0*raxe2+     aaz12
      aaey1=qdy*aae1+wqy*aae2                                 
      aaez1=qdz*aae1+wqz*aae2                      +     aax12
      aafx1=qdx*aaf1+wqx*aaf2+2.d0*rxaf2+2.d0*raxf2           
      aafy1=qdy*aaf1+wqy*aaf2                      +     aaz12
      aafz1=qdz*aaf1+wqz*aaf2                      +     aay12
      abax1=qdx*aba1+wqx*aba2+2.d0*rxba2           +2.d0*abx12
      abay1=qdy*aba1+wqy*aba2           +2.d0*raya2           
      abaz1=qdz*aba1+wqz*aba2                                 
      abbx1=qdx*abb1+wqx*abb2+2.d0*rxbb2                      
      abby1=qdy*abb1+wqy*abb2           +2.d0*rayb2+2.d0*aby12
      abbz1=qdz*abb1+wqz*abb2                                 
      abcx1=qdx*abc1+wqx*abc2+2.d0*rxbc2                      
      abcy1=qdy*abc1+wqy*abc2           +2.d0*rayc2           
      abcz1=qdz*abc1+wqz*abc2                      +2.d0*abz12
      abdx1=qdx*abd1+wqx*abd2+2.d0*rxbd2           +     aby12
      abdy1=qdy*abd1+wqy*abd2           +2.d0*rayd2+     abx12
      abdz1=qdz*abd1+wqz*abd2                                 
      abex1=qdx*abe1+wqx*abe2+2.d0*rxbe2           +     abz12
      abey1=qdy*abe1+wqy*abe2           +2.d0*raye2           
      abez1=qdz*abe1+wqz*abe2                      +     abx12
      abfx1=qdx*abf1+wqx*abf2+2.d0*rxbf2                      
      abfy1=qdy*abf1+wqy*abf2           +2.d0*rayf2+     abz12
      abfz1=qdz*abf1+wqz*abf2                      +     aby12
      acax1=qdx*aca1+wqx*aca2+2.d0*rxca2           +2.d0*acx12
      acay1=qdy*aca1+wqy*aca2                                 
      acaz1=qdz*aca1+wqz*aca2           +2.d0*raza2           
      acbx1=qdx*acb1+wqx*acb2+2.d0*rxcb2                      
      acby1=qdy*acb1+wqy*acb2                      +2.d0*acy12
      acbz1=qdz*acb1+wqz*acb2           +2.d0*razb2           
      accx1=qdx*acc1+wqx*acc2+2.d0*rxcc2                      
      accy1=qdy*acc1+wqy*acc2                                 
      accz1=qdz*acc1+wqz*acc2           +2.d0*razc2+2.d0*acz12
      acdx1=qdx*acd1+wqx*acd2+2.d0*rxcd2           +     acy12
      acdy1=qdy*acd1+wqy*acd2                      +     acx12
      acdz1=qdz*acd1+wqz*acd2           +2.d0*razd2           
      acex1=qdx*ace1+wqx*ace2+2.d0*rxce2           +     acz12
      acey1=qdy*ace1+wqy*ace2                                 
      acez1=qdz*ace1+wqz*ace2           +2.d0*raze2+     acx12
      acfx1=qdx*acf1+wqx*acf2+2.d0*rxcf2                      
      acfy1=qdy*acf1+wqy*acf2                      +     acz12
      acfz1=qdz*acf1+wqz*acf2           +2.d0*razf2+     acy12
      adax1=qdx*ada1+wqx*ada2+2.d0*rxda2+     raya2+2.d0*adx12
      aday1=qdy*ada1+wqy*ada2           +     raxa2           
      adaz1=qdz*ada1+wqz*ada2                                 
      adbx1=qdx*adb1+wqx*adb2+2.d0*rxdb2+     rayb2           
      adby1=qdy*adb1+wqy*adb2           +     raxb2+2.d0*ady12
      adbz1=qdz*adb1+wqz*adb2                                 
      adcx1=qdx*adc1+wqx*adc2+2.d0*rxdc2+     rayc2           
      adcy1=qdy*adc1+wqy*adc2           +     raxc2           
      adcz1=qdz*adc1+wqz*adc2                      +2.d0*adz12
      addx1=qdx*add1+wqx*add2+2.d0*rxdd2+     rayd2+     ady12
      addy1=qdy*add1+wqy*add2           +     raxd2+     adx12
      addz1=qdz*add1+wqz*add2                                 
      adex1=qdx*ade1+wqx*ade2+2.d0*rxde2+     raye2+     adz12
      adey1=qdy*ade1+wqy*ade2           +     raxe2           
      adez1=qdz*ade1+wqz*ade2                      +     adx12
      adfx1=qdx*adf1+wqx*adf2+2.d0*rxdf2+     rayf2           
      adfy1=qdy*adf1+wqy*adf2           +     raxf2+     adz12
      adfz1=qdz*adf1+wqz*adf2                      +     ady12
      aeax1=qdx*aea1+wqx*aea2+2.d0*rxea2+     raza2+2.d0*aex12
      aeay1=qdy*aea1+wqy*aea2                                 
      aeaz1=qdz*aea1+wqz*aea2           +     raxa2           
      aebx1=qdx*aeb1+wqx*aeb2+2.d0*rxeb2+     razb2           
      aeby1=qdy*aeb1+wqy*aeb2                      +2.d0*aey12
      aebz1=qdz*aeb1+wqz*aeb2           +     raxb2           
      aecx1=qdx*aec1+wqx*aec2+2.d0*rxec2+     razc2           
      aecy1=qdy*aec1+wqy*aec2                                 
      aecz1=qdz*aec1+wqz*aec2           +     raxc2+2.d0*aez12
      aedx1=qdx*aed1+wqx*aed2+2.d0*rxed2+     razd2+     aey12
      aedy1=qdy*aed1+wqy*aed2                      +     aex12
      aedz1=qdz*aed1+wqz*aed2           +     raxd2           
      aeex1=qdx*aee1+wqx*aee2+2.d0*rxee2+     raze2+     aez12
      aeey1=qdy*aee1+wqy*aee2                                 
      aeez1=qdz*aee1+wqz*aee2           +     raxe2+     aex12
      aefx1=qdx*aef1+wqx*aef2+2.d0*rxef2+     razf2           
      aefy1=qdy*aef1+wqy*aef2                      +     aez12
      aefz1=qdz*aef1+wqz*aef2           +     raxf2+     aey12
      afax1=qdx*afa1+wqx*afa2+2.d0*rxfa2           +2.d0*afx12
      afay1=qdy*afa1+wqy*afa2           +     raza2           
      afaz1=qdz*afa1+wqz*afa2           +     raya2           
      afbx1=qdx*afb1+wqx*afb2+2.d0*rxfb2                      
      afby1=qdy*afb1+wqy*afb2           +     razb2+2.d0*afy12
      afbz1=qdz*afb1+wqz*afb2           +     rayb2           
      afcx1=qdx*afc1+wqx*afc2+2.d0*rxfc2                      
      afcy1=qdy*afc1+wqy*afc2           +     razc2           
      afcz1=qdz*afc1+wqz*afc2           +     rayc2+2.d0*afz12
      afdx1=qdx*afd1+wqx*afd2+2.d0*rxfd2           +     afy12
      afdy1=qdy*afd1+wqy*afd2           +     razd2+     afx12
      afdz1=qdz*afd1+wqz*afd2           +     rayd2           
      afex1=qdx*afe1+wqx*afe2+2.d0*rxfe2           +     afz12
      afey1=qdy*afe1+wqy*afe2           +     raze2           
      afez1=qdz*afe1+wqz*afe2           +     raye2+     afx12
      affx1=qdx*aff1+wqx*aff2+2.d0*rxff2                      
      affy1=qdy*aff1+wqy*aff2           +     razf2+     afz12
      affz1=qdz*aff1+wqz*aff2           +     rayf2+     afy12
      baax1=qdx*baa1+wqx*baa2           +2.d0*rbxa2+2.d0*bax12
      baay1=qdy*baa1+wqy*baa2+2.d0*ryaa2                      
      baaz1=qdz*baa1+wqz*baa2                                 
      babx1=qdx*bab1+wqx*bab2           +2.d0*rbxb2           
      baby1=qdy*bab1+wqy*bab2+2.d0*ryab2           +2.d0*bay12
      babz1=qdz*bab1+wqz*bab2                                 
      bacx1=qdx*bac1+wqx*bac2           +2.d0*rbxc2           
      bacy1=qdy*bac1+wqy*bac2+2.d0*ryac2                      
      bacz1=qdz*bac1+wqz*bac2                      +2.d0*baz12
      badx1=qdx*bad1+wqx*bad2           +2.d0*rbxd2+     bay12
      bady1=qdy*bad1+wqy*bad2+2.d0*ryad2           +     bax12
      badz1=qdz*bad1+wqz*bad2                                 
      baex1=qdx*bae1+wqx*bae2           +2.d0*rbxe2+     baz12
      baey1=qdy*bae1+wqy*bae2+2.d0*ryae2                      
      baez1=qdz*bae1+wqz*bae2                      +     bax12
      bafx1=qdx*baf1+wqx*baf2           +2.d0*rbxf2           
      bafy1=qdy*baf1+wqy*baf2+2.d0*ryaf2           +     baz12
      bafz1=qdz*baf1+wqz*baf2                      +     bay12
      bbax1=qdx*bba1+wqx*bba2                      +2.d0*bbx12
      bbay1=qdy*bba1+wqy*bba2+2.d0*ryba2+2.d0*rbya2           
      bbaz1=qdz*bba1+wqz*bba2                                 
      bbbx1=qdx*bbb1+wqx*bbb2                                 
      bbby1=qdy*bbb1+wqy*bbb2+2.d0*rybb2+2.d0*rbyb2+2.d0*bby12
      bbbz1=qdz*bbb1+wqz*bbb2                                 
      bbcx1=qdx*bbc1+wqx*bbc2                                 
      bbcy1=qdy*bbc1+wqy*bbc2+2.d0*rybc2+2.d0*rbyc2           
      bbcz1=qdz*bbc1+wqz*bbc2                      +2.d0*bbz12
      bbdx1=qdx*bbd1+wqx*bbd2                      +     bby12
      bbdy1=qdy*bbd1+wqy*bbd2+2.d0*rybd2+2.d0*rbyd2+     bbx12
      bbdz1=qdz*bbd1+wqz*bbd2                                 
      bbex1=qdx*bbe1+wqx*bbe2                      +     bbz12
      bbey1=qdy*bbe1+wqy*bbe2+2.d0*rybe2+2.d0*rbye2           
      bbez1=qdz*bbe1+wqz*bbe2                      +     bbx12
      bbfx1=qdx*bbf1+wqx*bbf2                                 
      bbfy1=qdy*bbf1+wqy*bbf2+2.d0*rybf2+2.d0*rbyf2+     bbz12
      bbfz1=qdz*bbf1+wqz*bbf2                      +     bby12
      bcax1=qdx*bca1+wqx*bca2                      +2.d0*bcx12
      bcay1=qdy*bca1+wqy*bca2+2.d0*ryca2                      
      bcaz1=qdz*bca1+wqz*bca2           +2.d0*rbza2           
      bcbx1=qdx*bcb1+wqx*bcb2                                 
      bcby1=qdy*bcb1+wqy*bcb2+2.d0*rycb2           +2.d0*bcy12
      bcbz1=qdz*bcb1+wqz*bcb2           +2.d0*rbzb2           
      bccx1=qdx*bcc1+wqx*bcc2                                 
      bccy1=qdy*bcc1+wqy*bcc2+2.d0*rycc2                      
      bccz1=qdz*bcc1+wqz*bcc2           +2.d0*rbzc2+2.d0*bcz12
      bcdx1=qdx*bcd1+wqx*bcd2                      +     bcy12
      bcdy1=qdy*bcd1+wqy*bcd2+2.d0*rycd2           +     bcx12
      bcdz1=qdz*bcd1+wqz*bcd2           +2.d0*rbzd2           
      bcex1=qdx*bce1+wqx*bce2                      +     bcz12
      bcey1=qdy*bce1+wqy*bce2+2.d0*ryce2                      
      bcez1=qdz*bce1+wqz*bce2           +2.d0*rbze2+     bcx12
      bcfx1=qdx*bcf1+wqx*bcf2                                 
      bcfy1=qdy*bcf1+wqy*bcf2+2.d0*rycf2           +     bcz12
      bcfz1=qdz*bcf1+wqz*bcf2           +2.d0*rbzf2+     bcy12
      bdax1=qdx*bda1+wqx*bda2           +     rbya2+2.d0*bdx12
      bday1=qdy*bda1+wqy*bda2+2.d0*ryda2+     rbxa2           
      bdaz1=qdz*bda1+wqz*bda2                                 
      bdbx1=qdx*bdb1+wqx*bdb2           +     rbyb2           
      bdby1=qdy*bdb1+wqy*bdb2+2.d0*rydb2+     rbxb2+2.d0*bdy12
      bdbz1=qdz*bdb1+wqz*bdb2                                 
      bdcx1=qdx*bdc1+wqx*bdc2           +     rbyc2           
      bdcy1=qdy*bdc1+wqy*bdc2+2.d0*rydc2+     rbxc2           
      bdcz1=qdz*bdc1+wqz*bdc2                      +2.d0*bdz12
      bddx1=qdx*bdd1+wqx*bdd2           +     rbyd2+     bdy12
      bddy1=qdy*bdd1+wqy*bdd2+2.d0*rydd2+     rbxd2+     bdx12
      bddz1=qdz*bdd1+wqz*bdd2                                 
      bdex1=qdx*bde1+wqx*bde2           +     rbye2+     bdz12
      bdey1=qdy*bde1+wqy*bde2+2.d0*ryde2+     rbxe2           
      bdez1=qdz*bde1+wqz*bde2                      +     bdx12
      bdfx1=qdx*bdf1+wqx*bdf2           +     rbyf2           
      bdfy1=qdy*bdf1+wqy*bdf2+2.d0*rydf2+     rbxf2+     bdz12
      bdfz1=qdz*bdf1+wqz*bdf2                      +     bdy12
      beax1=qdx*bea1+wqx*bea2           +     rbza2+2.d0*bex12
      beay1=qdy*bea1+wqy*bea2+2.d0*ryea2                      
      beaz1=qdz*bea1+wqz*bea2           +     rbxa2           
      bebx1=qdx*beb1+wqx*beb2           +     rbzb2           
      beby1=qdy*beb1+wqy*beb2+2.d0*ryeb2           +2.d0*bey12
      bebz1=qdz*beb1+wqz*beb2           +     rbxb2           
      becx1=qdx*bec1+wqx*bec2           +     rbzc2           
      becy1=qdy*bec1+wqy*bec2+2.d0*ryec2                      
      becz1=qdz*bec1+wqz*bec2           +     rbxc2+2.d0*bez12
      bedx1=qdx*bed1+wqx*bed2           +     rbzd2+     bey12
      bedy1=qdy*bed1+wqy*bed2+2.d0*ryed2           +     bex12
      bedz1=qdz*bed1+wqz*bed2           +     rbxd2           
      beex1=qdx*bee1+wqx*bee2           +     rbze2+     bez12
      beey1=qdy*bee1+wqy*bee2+2.d0*ryee2                      
      beez1=qdz*bee1+wqz*bee2           +     rbxe2+     bex12
      befx1=qdx*bef1+wqx*bef2           +     rbzf2           
      befy1=qdy*bef1+wqy*bef2+2.d0*ryef2           +     bez12
      befz1=qdz*bef1+wqz*bef2           +     rbxf2+     bey12
      bfax1=qdx*bfa1+wqx*bfa2                      +2.d0*bfx12
      bfay1=qdy*bfa1+wqy*bfa2+2.d0*ryfa2+     rbza2           
      bfaz1=qdz*bfa1+wqz*bfa2           +     rbya2           
      bfbx1=qdx*bfb1+wqx*bfb2                                 
      bfby1=qdy*bfb1+wqy*bfb2+2.d0*ryfb2+     rbzb2+2.d0*bfy12
      bfbz1=qdz*bfb1+wqz*bfb2           +     rbyb2           
      bfcx1=qdx*bfc1+wqx*bfc2                                 
      bfcy1=qdy*bfc1+wqy*bfc2+2.d0*ryfc2+     rbzc2           
      bfcz1=qdz*bfc1+wqz*bfc2           +     rbyc2+2.d0*bfz12
      bfdx1=qdx*bfd1+wqx*bfd2                      +     bfy12
      bfdy1=qdy*bfd1+wqy*bfd2+2.d0*ryfd2+     rbzd2+     bfx12
      bfdz1=qdz*bfd1+wqz*bfd2           +     rbyd2           
      bfex1=qdx*bfe1+wqx*bfe2                      +     bfz12
      bfey1=qdy*bfe1+wqy*bfe2+2.d0*ryfe2+     rbze2           
      bfez1=qdz*bfe1+wqz*bfe2           +     rbye2+     bfx12
      bffx1=qdx*bff1+wqx*bff2                                 
      bffy1=qdy*bff1+wqy*bff2+2.d0*ryff2+     rbzf2+     bfz12
      bffz1=qdz*bff1+wqz*bff2           +     rbyf2+     bfy12
      caax1=qdx*caa1+wqx*caa2           +2.d0*rcxa2+2.d0*cax12
      caay1=qdy*caa1+wqy*caa2                                 
      caaz1=qdz*caa1+wqz*caa2+2.d0*rzaa2                      
      cabx1=qdx*cab1+wqx*cab2           +2.d0*rcxb2           
      caby1=qdy*cab1+wqy*cab2                      +2.d0*cay12
      cabz1=qdz*cab1+wqz*cab2+2.d0*rzab2                      
      cacx1=qdx*cac1+wqx*cac2           +2.d0*rcxc2           
      cacy1=qdy*cac1+wqy*cac2                                 
      cacz1=qdz*cac1+wqz*cac2+2.d0*rzac2           +2.d0*caz12
      cadx1=qdx*cad1+wqx*cad2           +2.d0*rcxd2+     cay12
      cady1=qdy*cad1+wqy*cad2                      +     cax12
      cadz1=qdz*cad1+wqz*cad2+2.d0*rzad2                      
      caex1=qdx*cae1+wqx*cae2           +2.d0*rcxe2+     caz12
      caey1=qdy*cae1+wqy*cae2                                 
      caez1=qdz*cae1+wqz*cae2+2.d0*rzae2           +     cax12
      cafx1=qdx*caf1+wqx*caf2           +2.d0*rcxf2           
      cafy1=qdy*caf1+wqy*caf2                      +     caz12
      cafz1=qdz*caf1+wqz*caf2+2.d0*rzaf2           +     cay12
      cbax1=qdx*cba1+wqx*cba2                      +2.d0*cbx12
      cbay1=qdy*cba1+wqy*cba2           +2.d0*rcya2           
      cbaz1=qdz*cba1+wqz*cba2+2.d0*rzba2                      
      cbbx1=qdx*cbb1+wqx*cbb2                                 
      cbby1=qdy*cbb1+wqy*cbb2           +2.d0*rcyb2+2.d0*cby12
      cbbz1=qdz*cbb1+wqz*cbb2+2.d0*rzbb2                      
      cbcx1=qdx*cbc1+wqx*cbc2                                 
      cbcy1=qdy*cbc1+wqy*cbc2           +2.d0*rcyc2           
      cbcz1=qdz*cbc1+wqz*cbc2+2.d0*rzbc2           +2.d0*cbz12
      cbdx1=qdx*cbd1+wqx*cbd2                      +     cby12
      cbdy1=qdy*cbd1+wqy*cbd2           +2.d0*rcyd2+     cbx12
      cbdz1=qdz*cbd1+wqz*cbd2+2.d0*rzbd2                      
      cbex1=qdx*cbe1+wqx*cbe2                      +     cbz12
      cbey1=qdy*cbe1+wqy*cbe2           +2.d0*rcye2           
      cbez1=qdz*cbe1+wqz*cbe2+2.d0*rzbe2           +     cbx12
      cbfx1=qdx*cbf1+wqx*cbf2                                 
      cbfy1=qdy*cbf1+wqy*cbf2           +2.d0*rcyf2+     cbz12
      cbfz1=qdz*cbf1+wqz*cbf2+2.d0*rzbf2           +     cby12
      ccax1=qdx*cca1+wqx*cca2                      +2.d0*ccx12
      ccay1=qdy*cca1+wqy*cca2                                 
      ccaz1=qdz*cca1+wqz*cca2+2.d0*rzca2+2.d0*rcza2           
      ccbx1=qdx*ccb1+wqx*ccb2                                 
      ccby1=qdy*ccb1+wqy*ccb2                      +2.d0*ccy12
      ccbz1=qdz*ccb1+wqz*ccb2+2.d0*rzcb2+2.d0*rczb2           
      cccx1=qdx*ccc1+wqx*ccc2                                 
      cccy1=qdy*ccc1+wqy*ccc2                                 
      cccz1=qdz*ccc1+wqz*ccc2+2.d0*rzcc2+2.d0*rczc2+2.d0*ccz12
      ccdx1=qdx*ccd1+wqx*ccd2                      +     ccy12
      ccdy1=qdy*ccd1+wqy*ccd2                      +     ccx12
      ccdz1=qdz*ccd1+wqz*ccd2+2.d0*rzcd2+2.d0*rczd2           
      ccex1=qdx*cce1+wqx*cce2                      +     ccz12
      ccey1=qdy*cce1+wqy*cce2                                 
      ccez1=qdz*cce1+wqz*cce2+2.d0*rzce2+2.d0*rcze2+     ccx12
      ccfx1=qdx*ccf1+wqx*ccf2                                 
      ccfy1=qdy*ccf1+wqy*ccf2                      +     ccz12
      ccfz1=qdz*ccf1+wqz*ccf2+2.d0*rzcf2+2.d0*rczf2+     ccy12
      cdax1=qdx*cda1+wqx*cda2           +     rcya2+2.d0*cdx12
      cday1=qdy*cda1+wqy*cda2           +     rcxa2           
      cdaz1=qdz*cda1+wqz*cda2+2.d0*rzda2                      
      cdbx1=qdx*cdb1+wqx*cdb2           +     rcyb2           
      cdby1=qdy*cdb1+wqy*cdb2           +     rcxb2+2.d0*cdy12
      cdbz1=qdz*cdb1+wqz*cdb2+2.d0*rzdb2                      
      cdcx1=qdx*cdc1+wqx*cdc2           +     rcyc2           
      cdcy1=qdy*cdc1+wqy*cdc2           +     rcxc2           
      cdcz1=qdz*cdc1+wqz*cdc2+2.d0*rzdc2           +2.d0*cdz12
      cddx1=qdx*cdd1+wqx*cdd2           +     rcyd2+     cdy12
      cddy1=qdy*cdd1+wqy*cdd2           +     rcxd2+     cdx12
      cddz1=qdz*cdd1+wqz*cdd2+2.d0*rzdd2                      
      cdex1=qdx*cde1+wqx*cde2           +     rcye2+     cdz12
      cdey1=qdy*cde1+wqy*cde2           +     rcxe2           
      cdez1=qdz*cde1+wqz*cde2+2.d0*rzde2           +     cdx12
      cdfx1=qdx*cdf1+wqx*cdf2           +     rcyf2           
      cdfy1=qdy*cdf1+wqy*cdf2           +     rcxf2+     cdz12
      cdfz1=qdz*cdf1+wqz*cdf2+2.d0*rzdf2           +     cdy12
      ceax1=qdx*cea1+wqx*cea2           +     rcza2+2.d0*cex12
      ceay1=qdy*cea1+wqy*cea2                                 
      ceaz1=qdz*cea1+wqz*cea2+2.d0*rzea2+     rcxa2           
      cebx1=qdx*ceb1+wqx*ceb2           +     rczb2           
      ceby1=qdy*ceb1+wqy*ceb2                      +2.d0*cey12
      cebz1=qdz*ceb1+wqz*ceb2+2.d0*rzeb2+     rcxb2           
      cecx1=qdx*cec1+wqx*cec2           +     rczc2           
      cecy1=qdy*cec1+wqy*cec2                                 
      cecz1=qdz*cec1+wqz*cec2+2.d0*rzec2+     rcxc2+2.d0*cez12
      cedx1=qdx*ced1+wqx*ced2           +     rczd2+     cey12
      cedy1=qdy*ced1+wqy*ced2                      +     cex12
      cedz1=qdz*ced1+wqz*ced2+2.d0*rzed2+     rcxd2           
      ceex1=qdx*cee1+wqx*cee2           +     rcze2+     cez12
      ceey1=qdy*cee1+wqy*cee2                                 
      ceez1=qdz*cee1+wqz*cee2+2.d0*rzee2+     rcxe2+     cex12
      cefx1=qdx*cef1+wqx*cef2           +     rczf2           
      cefy1=qdy*cef1+wqy*cef2                      +     cez12
      cefz1=qdz*cef1+wqz*cef2+2.d0*rzef2+     rcxf2+     cey12
      cfax1=qdx*cfa1+wqx*cfa2                      +2.d0*cfx12
      cfay1=qdy*cfa1+wqy*cfa2           +     rcza2           
      cfaz1=qdz*cfa1+wqz*cfa2+2.d0*rzfa2+     rcya2           
      cfbx1=qdx*cfb1+wqx*cfb2                                 
      cfby1=qdy*cfb1+wqy*cfb2           +     rczb2+2.d0*cfy12
      cfbz1=qdz*cfb1+wqz*cfb2+2.d0*rzfb2+     rcyb2           
      cfcx1=qdx*cfc1+wqx*cfc2                                 
      cfcy1=qdy*cfc1+wqy*cfc2           +     rczc2           
      cfcz1=qdz*cfc1+wqz*cfc2+2.d0*rzfc2+     rcyc2+2.d0*cfz12
      cfdx1=qdx*cfd1+wqx*cfd2                      +     cfy12
      cfdy1=qdy*cfd1+wqy*cfd2           +     rczd2+     cfx12
      cfdz1=qdz*cfd1+wqz*cfd2+2.d0*rzfd2+     rcyd2           
      cfex1=qdx*cfe1+wqx*cfe2                      +     cfz12
      cfey1=qdy*cfe1+wqy*cfe2           +     rcze2           
      cfez1=qdz*cfe1+wqz*cfe2+2.d0*rzfe2+     rcye2+     cfx12
      cffx1=qdx*cff1+wqx*cff2                                 
      cffy1=qdy*cff1+wqy*cff2           +     rczf2+     cfz12
      cffz1=qdz*cff1+wqz*cff2+2.d0*rzff2+     rcyf2+     cfy12
      daax1=qdx*daa1+wqx*daa2+     ryaa2+2.d0*rdxa2+2.d0*dax12
      daay1=qdy*daa1+wqy*daa2+     rxaa2                      
      daaz1=qdz*daa1+wqz*daa2                                 
      dabx1=qdx*dab1+wqx*dab2+     ryab2+2.d0*rdxb2           
      daby1=qdy*dab1+wqy*dab2+     rxab2           +2.d0*day12
      dabz1=qdz*dab1+wqz*dab2                                 
      dacx1=qdx*dac1+wqx*dac2+     ryac2+2.d0*rdxc2           
      dacy1=qdy*dac1+wqy*dac2+     rxac2                      
      dacz1=qdz*dac1+wqz*dac2                      +2.d0*daz12
      dadx1=qdx*dad1+wqx*dad2+     ryad2+2.d0*rdxd2+     day12
      dady1=qdy*dad1+wqy*dad2+     rxad2           +     dax12
      dadz1=qdz*dad1+wqz*dad2                                 
      daex1=qdx*dae1+wqx*dae2+     ryae2+2.d0*rdxe2+     daz12
      daey1=qdy*dae1+wqy*dae2+     rxae2                      
      daez1=qdz*dae1+wqz*dae2                      +     dax12
      dafx1=qdx*daf1+wqx*daf2+     ryaf2+2.d0*rdxf2           
      dafy1=qdy*daf1+wqy*daf2+     rxaf2           +     daz12
      dafz1=qdz*daf1+wqz*daf2                      +     day12
      dbax1=qdx*dba1+wqx*dba2+     ryba2           +2.d0*dbx12
      dbay1=qdy*dba1+wqy*dba2+     rxba2+2.d0*rdya2           
      dbaz1=qdz*dba1+wqz*dba2                                 
      dbbx1=qdx*dbb1+wqx*dbb2+     rybb2                      
      dbby1=qdy*dbb1+wqy*dbb2+     rxbb2+2.d0*rdyb2+2.d0*dby12
      dbbz1=qdz*dbb1+wqz*dbb2                                 
      dbcx1=qdx*dbc1+wqx*dbc2+     rybc2                      
      dbcy1=qdy*dbc1+wqy*dbc2+     rxbc2+2.d0*rdyc2           
      dbcz1=qdz*dbc1+wqz*dbc2                      +2.d0*dbz12
      dbdx1=qdx*dbd1+wqx*dbd2+     rybd2           +     dby12
      dbdy1=qdy*dbd1+wqy*dbd2+     rxbd2+2.d0*rdyd2+     dbx12
      dbdz1=qdz*dbd1+wqz*dbd2                                 
      dbex1=qdx*dbe1+wqx*dbe2+     rybe2           +     dbz12
      dbey1=qdy*dbe1+wqy*dbe2+     rxbe2+2.d0*rdye2           
      dbez1=qdz*dbe1+wqz*dbe2                      +     dbx12
      dbfx1=qdx*dbf1+wqx*dbf2+     rybf2                      
      dbfy1=qdy*dbf1+wqy*dbf2+     rxbf2+2.d0*rdyf2+     dbz12
      dbfz1=qdz*dbf1+wqz*dbf2                      +     dby12
      dcax1=qdx*dca1+wqx*dca2+     ryca2           +2.d0*dcx12
      dcay1=qdy*dca1+wqy*dca2+     rxca2                      
      dcaz1=qdz*dca1+wqz*dca2           +2.d0*rdza2           
      dcbx1=qdx*dcb1+wqx*dcb2+     rycb2                      
      dcby1=qdy*dcb1+wqy*dcb2+     rxcb2           +2.d0*dcy12
      dcbz1=qdz*dcb1+wqz*dcb2           +2.d0*rdzb2           
      dccx1=qdx*dcc1+wqx*dcc2+     rycc2                      
      dccy1=qdy*dcc1+wqy*dcc2+     rxcc2                      
      dccz1=qdz*dcc1+wqz*dcc2           +2.d0*rdzc2+2.d0*dcz12
      dcdx1=qdx*dcd1+wqx*dcd2+     rycd2           +     dcy12
      dcdy1=qdy*dcd1+wqy*dcd2+     rxcd2           +     dcx12
      dcdz1=qdz*dcd1+wqz*dcd2           +2.d0*rdzd2           
      dcex1=qdx*dce1+wqx*dce2+     ryce2           +     dcz12
      dcey1=qdy*dce1+wqy*dce2+     rxce2                      
      dcez1=qdz*dce1+wqz*dce2           +2.d0*rdze2+     dcx12
      dcfx1=qdx*dcf1+wqx*dcf2+     rycf2                      
      dcfy1=qdy*dcf1+wqy*dcf2+     rxcf2           +     dcz12
      dcfz1=qdz*dcf1+wqz*dcf2           +2.d0*rdzf2+     dcy12
      ddax1=qdx*dda1+wqx*dda2+     ryda2+     rdya2+2.d0*ddx12
      dday1=qdy*dda1+wqy*dda2+     rxda2+     rdxa2           
      ddaz1=qdz*dda1+wqz*dda2                                 
      ddbx1=qdx*ddb1+wqx*ddb2+     rydb2+     rdyb2           
      ddby1=qdy*ddb1+wqy*ddb2+     rxdb2+     rdxb2+2.d0*ddy12
      ddbz1=qdz*ddb1+wqz*ddb2                                 
      ddcx1=qdx*ddc1+wqx*ddc2+     rydc2+     rdyc2           
      ddcy1=qdy*ddc1+wqy*ddc2+     rxdc2+     rdxc2           
      ddcz1=qdz*ddc1+wqz*ddc2                      +2.d0*ddz12
      dddx1=qdx*ddd1+wqx*ddd2+     rydd2+     rdyd2+     ddy12
      dddy1=qdy*ddd1+wqy*ddd2+     rxdd2+     rdxd2+     ddx12
      dddz1=qdz*ddd1+wqz*ddd2                                 
      ddex1=qdx*dde1+wqx*dde2+     ryde2+     rdye2+     ddz12
      ddey1=qdy*dde1+wqy*dde2+     rxde2+     rdxe2           
      ddez1=qdz*dde1+wqz*dde2                      +     ddx12
      ddfx1=qdx*ddf1+wqx*ddf2+     rydf2+     rdyf2           
      ddfy1=qdy*ddf1+wqy*ddf2+     rxdf2+     rdxf2+     ddz12
      ddfz1=qdz*ddf1+wqz*ddf2                      +     ddy12
      deax1=qdx*dea1+wqx*dea2+     ryea2+     rdza2+2.d0*dex12
      deay1=qdy*dea1+wqy*dea2+     rxea2                      
      deaz1=qdz*dea1+wqz*dea2           +     rdxa2           
      debx1=qdx*deb1+wqx*deb2+     ryeb2+     rdzb2           
      deby1=qdy*deb1+wqy*deb2+     rxeb2           +2.d0*dey12
      debz1=qdz*deb1+wqz*deb2           +     rdxb2           
      decx1=qdx*dec1+wqx*dec2+     ryec2+     rdzc2           
      decy1=qdy*dec1+wqy*dec2+     rxec2                      
      decz1=qdz*dec1+wqz*dec2           +     rdxc2+2.d0*dez12
      dedx1=qdx*ded1+wqx*ded2+     ryed2+     rdzd2+     dey12
      dedy1=qdy*ded1+wqy*ded2+     rxed2           +     dex12
      dedz1=qdz*ded1+wqz*ded2           +     rdxd2           
      deex1=qdx*dee1+wqx*dee2+     ryee2+     rdze2+     dez12
      deey1=qdy*dee1+wqy*dee2+     rxee2                      
      deez1=qdz*dee1+wqz*dee2           +     rdxe2+     dex12
      defx1=qdx*def1+wqx*def2+     ryef2+     rdzf2           
      defy1=qdy*def1+wqy*def2+     rxef2           +     dez12
      defz1=qdz*def1+wqz*def2           +     rdxf2+     dey12
      dfax1=qdx*dfa1+wqx*dfa2+     ryfa2           +2.d0*dfx12
      dfay1=qdy*dfa1+wqy*dfa2+     rxfa2+     rdza2           
      dfaz1=qdz*dfa1+wqz*dfa2           +     rdya2           
      dfbx1=qdx*dfb1+wqx*dfb2+     ryfb2                      
      dfby1=qdy*dfb1+wqy*dfb2+     rxfb2+     rdzb2+2.d0*dfy12
      dfbz1=qdz*dfb1+wqz*dfb2           +     rdyb2           
      dfcx1=qdx*dfc1+wqx*dfc2+     ryfc2                      
      dfcy1=qdy*dfc1+wqy*dfc2+     rxfc2+     rdzc2           
      dfcz1=qdz*dfc1+wqz*dfc2           +     rdyc2+2.d0*dfz12
      dfdx1=qdx*dfd1+wqx*dfd2+     ryfd2           +     dfy12
      dfdy1=qdy*dfd1+wqy*dfd2+     rxfd2+     rdzd2+     dfx12
      dfdz1=qdz*dfd1+wqz*dfd2           +     rdyd2           
      dfex1=qdx*dfe1+wqx*dfe2+     ryfe2           +     dfz12
      dfey1=qdy*dfe1+wqy*dfe2+     rxfe2+     rdze2           
      dfez1=qdz*dfe1+wqz*dfe2           +     rdye2+     dfx12
      dffx1=qdx*dff1+wqx*dff2+     ryff2                    
      dffy1=qdy*dff1+wqy*dff2+     rxff2+     rdzf2+     dfz12
      dffz1=qdz*dff1+wqz*dff2           +     rdyf2+     dfy12
      eaax1=qdx*eaa1+wqx*eaa2+     rzaa2+2.d0*rexa2+2.d0*eax12
      eaay1=qdy*eaa1+wqy*eaa2                                 
      eaaz1=qdz*eaa1+wqz*eaa2+     rxaa2                      
      eabx1=qdx*eab1+wqx*eab2+     rzab2+2.d0*rexb2           
      eaby1=qdy*eab1+wqy*eab2                      +2.d0*eay12
      eabz1=qdz*eab1+wqz*eab2+     rxab2                      
      eacx1=qdx*eac1+wqx*eac2+     rzac2+2.d0*rexc2           
      eacy1=qdy*eac1+wqy*eac2                                 
      eacz1=qdz*eac1+wqz*eac2+     rxac2           +2.d0*eaz12
      eadx1=qdx*ead1+wqx*ead2+     rzad2+2.d0*rexd2+     eay12
      eady1=qdy*ead1+wqy*ead2                      +     eax12
      eadz1=qdz*ead1+wqz*ead2+     rxad2                      
      eaex1=qdx*eae1+wqx*eae2+     rzae2+2.d0*rexe2+     eaz12
      eaey1=qdy*eae1+wqy*eae2                                 
      eaez1=qdz*eae1+wqz*eae2+     rxae2           +     eax12
      eafx1=qdx*eaf1+wqx*eaf2+     rzaf2+2.d0*rexf2           
      eafy1=qdy*eaf1+wqy*eaf2                      +     eaz12
      eafz1=qdz*eaf1+wqz*eaf2+     rxaf2           +     eay12
      ebax1=qdx*eba1+wqx*eba2+     rzba2           +2.d0*ebx12
      ebay1=qdy*eba1+wqy*eba2           +2.d0*reya2           
      ebaz1=qdz*eba1+wqz*eba2+     rxba2                      
      ebbx1=qdx*ebb1+wqx*ebb2+     rzbb2                      
      ebby1=qdy*ebb1+wqy*ebb2           +2.d0*reyb2+2.d0*eby12
      ebbz1=qdz*ebb1+wqz*ebb2+     rxbb2                      
      ebcx1=qdx*ebc1+wqx*ebc2+     rzbc2                      
      ebcy1=qdy*ebc1+wqy*ebc2           +2.d0*reyc2           
      ebcz1=qdz*ebc1+wqz*ebc2+     rxbc2           +2.d0*ebz12
      ebdx1=qdx*ebd1+wqx*ebd2+     rzbd2           +     eby12
      ebdy1=qdy*ebd1+wqy*ebd2           +2.d0*reyd2+     ebx12
      ebdz1=qdz*ebd1+wqz*ebd2+     rxbd2                      
      ebex1=qdx*ebe1+wqx*ebe2+     rzbe2           +     ebz12
      ebey1=qdy*ebe1+wqy*ebe2           +2.d0*reye2           
      ebez1=qdz*ebe1+wqz*ebe2+     rxbe2           +     ebx12
      ebfx1=qdx*ebf1+wqx*ebf2+     rzbf2                      
      ebfy1=qdy*ebf1+wqy*ebf2           +2.d0*reyf2+     ebz12
      ebfz1=qdz*ebf1+wqz*ebf2+     rxbf2           +     eby12
      ecax1=qdx*eca1+wqx*eca2+     rzca2           +2.d0*ecx12
      ecay1=qdy*eca1+wqy*eca2                                 
      ecaz1=qdz*eca1+wqz*eca2+     rxca2+2.d0*reza2           
      ecbx1=qdx*ecb1+wqx*ecb2+     rzcb2                      
      ecby1=qdy*ecb1+wqy*ecb2                      +2.d0*ecy12
      ecbz1=qdz*ecb1+wqz*ecb2+     rxcb2+2.d0*rezb2           
      eccx1=qdx*ecc1+wqx*ecc2+     rzcc2                      
      eccy1=qdy*ecc1+wqy*ecc2                                 
      eccz1=qdz*ecc1+wqz*ecc2+     rxcc2+2.d0*rezc2+2.d0*ecz12
      ecdx1=qdx*ecd1+wqx*ecd2+     rzcd2           +     ecy12
      ecdy1=qdy*ecd1+wqy*ecd2                      +     ecx12
      ecdz1=qdz*ecd1+wqz*ecd2+     rxcd2+2.d0*rezd2           
      ecex1=qdx*ece1+wqx*ece2+     rzce2           +     ecz12
      ecey1=qdy*ece1+wqy*ece2                                 
      ecez1=qdz*ece1+wqz*ece2+     rxce2+2.d0*reze2+     ecx12
      ecfx1=qdx*ecf1+wqx*ecf2+     rzcf2                      
      ecfy1=qdy*ecf1+wqy*ecf2                      +     ecz12
      ecfz1=qdz*ecf1+wqz*ecf2+     rxcf2+2.d0*rezf2+     ecy12
      edax1=qdx*eda1+wqx*eda2+     rzda2+     reya2+2.d0*edx12
      eday1=qdy*eda1+wqy*eda2           +     rexa2           
      edaz1=qdz*eda1+wqz*eda2+     rxda2                      
      edbx1=qdx*edb1+wqx*edb2+     rzdb2+     reyb2           
      edby1=qdy*edb1+wqy*edb2           +     rexb2+2.d0*edy12
      edbz1=qdz*edb1+wqz*edb2+     rxdb2                      
      edcx1=qdx*edc1+wqx*edc2+     rzdc2+     reyc2           
      edcy1=qdy*edc1+wqy*edc2           +     rexc2           
      edcz1=qdz*edc1+wqz*edc2+     rxdc2           +2.d0*edz12
      eddx1=qdx*edd1+wqx*edd2+     rzdd2+     reyd2+     edy12
      eddy1=qdy*edd1+wqy*edd2           +     rexd2+     edx12
      eddz1=qdz*edd1+wqz*edd2+     rxdd2                      
      edex1=qdx*ede1+wqx*ede2+     rzde2+     reye2+     edz12
      edey1=qdy*ede1+wqy*ede2           +     rexe2           
      edez1=qdz*ede1+wqz*ede2+     rxde2           +     edx12
      edfx1=qdx*edf1+wqx*edf2+     rzdf2+     reyf2           
      edfy1=qdy*edf1+wqy*edf2           +     rexf2+     edz12
      edfz1=qdz*edf1+wqz*edf2+     rxdf2           +     edy12
      eeax1=qdx*eea1+wqx*eea2+     rzea2+     reza2+2.d0*eex12
      eeay1=qdy*eea1+wqy*eea2                                 
      eeaz1=qdz*eea1+wqz*eea2+     rxea2+     rexa2           
      eebx1=qdx*eeb1+wqx*eeb2+     rzeb2+     rezb2           
      eeby1=qdy*eeb1+wqy*eeb2                      +2.d0*eey12
      eebz1=qdz*eeb1+wqz*eeb2+     rxeb2+     rexb2           
      eecx1=qdx*eec1+wqx*eec2+     rzec2+     rezc2           
      eecy1=qdy*eec1+wqy*eec2                                 
      eecz1=qdz*eec1+wqz*eec2+     rxec2+     rexc2+2.d0*eez12
      eedx1=qdx*eed1+wqx*eed2+     rzed2+     rezd2+     eey12
      eedy1=qdy*eed1+wqy*eed2                      +     eex12
      eedz1=qdz*eed1+wqz*eed2+     rxed2+     rexd2           
      eeex1=qdx*eee1+wqx*eee2+     rzee2+     reze2+     eez12
      eeey1=qdy*eee1+wqy*eee2                                 
      eeez1=qdz*eee1+wqz*eee2+     rxee2+     rexe2+     eex12
      eefx1=qdx*eef1+wqx*eef2+     rzef2+     rezf2           
      eefy1=qdy*eef1+wqy*eef2                      +     eez12
      eefz1=qdz*eef1+wqz*eef2+     rxef2+     rexf2+     eey12
      efax1=qdx*efa1+wqx*efa2+     rzfa2           +2.d0*efx12
      efay1=qdy*efa1+wqy*efa2           +     reza2           
      efaz1=qdz*efa1+wqz*efa2+     rxfa2+     reya2           
      efbx1=qdx*efb1+wqx*efb2+     rzfb2                      
      efby1=qdy*efb1+wqy*efb2           +     rezb2+2.d0*efy12
      efbz1=qdz*efb1+wqz*efb2+     rxfb2+     reyb2           
      efcx1=qdx*efc1+wqx*efc2+     rzfc2                      
      efcy1=qdy*efc1+wqy*efc2           +     rezc2           
      efcz1=qdz*efc1+wqz*efc2+     rxfc2+     reyc2+2.d0*efz12
      efdx1=qdx*efd1+wqx*efd2+     rzfd2           +     efy12
      efdy1=qdy*efd1+wqy*efd2           +     rezd2+     efx12
      efdz1=qdz*efd1+wqz*efd2+     rxfd2+     reyd2           
      efex1=qdx*efe1+wqx*efe2+     rzfe2           +     efz12
      efey1=qdy*efe1+wqy*efe2           +     reze2           
      efez1=qdz*efe1+wqz*efe2+     rxfe2+     reye2+     efx12
      effx1=qdx*eff1+wqx*eff2+     rzff2                      
      effy1=qdy*eff1+wqy*eff2           +     rezf2+     efz12
      effz1=qdz*eff1+wqz*eff2+     rxff2+     reyf2+     efy12
      faax1=qdx*faa1+wqx*faa2           +2.d0*rfxa2+2.d0*fax12
      faay1=qdy*faa1+wqy*faa2+     rzaa2                      
      faaz1=qdz*faa1+wqz*faa2+     ryaa2                      
      fabx1=qdx*fab1+wqx*fab2           +2.d0*rfxb2           
      faby1=qdy*fab1+wqy*fab2+     rzab2           +2.d0*fay12
      fabz1=qdz*fab1+wqz*fab2+     ryab2                      
      facx1=qdx*fac1+wqx*fac2           +2.d0*rfxc2           
      facy1=qdy*fac1+wqy*fac2+     rzac2                      
      facz1=qdz*fac1+wqz*fac2+     ryac2           +2.d0*faz12
      fadx1=qdx*fad1+wqx*fad2           +2.d0*rfxd2+     fay12
      fady1=qdy*fad1+wqy*fad2+     rzad2           +     fax12
      fadz1=qdz*fad1+wqz*fad2+     ryad2                      
      faex1=qdx*fae1+wqx*fae2           +2.d0*rfxe2+     faz12
      faey1=qdy*fae1+wqy*fae2+     rzae2                      
      faez1=qdz*fae1+wqz*fae2+     ryae2           +     fax12
      fafx1=qdx*faf1+wqx*faf2           +2.d0*rfxf2           
      fafy1=qdy*faf1+wqy*faf2+     rzaf2           +     faz12
      fafz1=qdz*faf1+wqz*faf2+     ryaf2           +     fay12
      fbax1=qdx*fba1+wqx*fba2                      +2.d0*fbx12
      fbay1=qdy*fba1+wqy*fba2+     rzba2+2.d0*rfya2           
      fbaz1=qdz*fba1+wqz*fba2+     ryba2                      
      fbbx1=qdx*fbb1+wqx*fbb2                                 
      fbby1=qdy*fbb1+wqy*fbb2+     rzbb2+2.d0*rfyb2+2.d0*fby12
      fbbz1=qdz*fbb1+wqz*fbb2+     rybb2                      
      fbcx1=qdx*fbc1+wqx*fbc2                                 
      fbcy1=qdy*fbc1+wqy*fbc2+     rzbc2+2.d0*rfyc2           
      fbcz1=qdz*fbc1+wqz*fbc2+     rybc2           +2.d0*fbz12
      fbdx1=qdx*fbd1+wqx*fbd2                      +     fby12
      fbdy1=qdy*fbd1+wqy*fbd2+     rzbd2+2.d0*rfyd2+     fbx12
      fbdz1=qdz*fbd1+wqz*fbd2+     rybd2                      
      fbex1=qdx*fbe1+wqx*fbe2                      +     fbz12
      fbey1=qdy*fbe1+wqy*fbe2+     rzbe2+2.d0*rfye2           
      fbez1=qdz*fbe1+wqz*fbe2+     rybe2           +     fbx12
      fbfx1=qdx*fbf1+wqx*fbf2                                 
      fbfy1=qdy*fbf1+wqy*fbf2+     rzbf2+2.d0*rfyf2+     fbz12
      fbfz1=qdz*fbf1+wqz*fbf2+     rybf2           +     fby12
      fcax1=qdx*fca1+wqx*fca2                      +2.d0*fcx12
      fcay1=qdy*fca1+wqy*fca2+     rzca2                      
      fcaz1=qdz*fca1+wqz*fca2+     ryca2+2.d0*rfza2           
      fcbx1=qdx*fcb1+wqx*fcb2                                 
      fcby1=qdy*fcb1+wqy*fcb2+     rzcb2           +2.d0*fcy12
      fcbz1=qdz*fcb1+wqz*fcb2+     rycb2+2.d0*rfzb2           
      fccx1=qdx*fcc1+wqx*fcc2                                 
      fccy1=qdy*fcc1+wqy*fcc2+     rzcc2                      
      fccz1=qdz*fcc1+wqz*fcc2+     rycc2+2.d0*rfzc2+2.d0*fcz12
      fcdx1=qdx*fcd1+wqx*fcd2                      +     fcy12
      fcdy1=qdy*fcd1+wqy*fcd2+     rzcd2           +     fcx12
      fcdz1=qdz*fcd1+wqz*fcd2+     rycd2+2.d0*rfzd2           
      fcex1=qdx*fce1+wqx*fce2                      +     fcz12
      fcey1=qdy*fce1+wqy*fce2+     rzce2                      
      fcez1=qdz*fce1+wqz*fce2+     ryce2+2.d0*rfze2+     fcx12
      fcfx1=qdx*fcf1+wqx*fcf2                                 
      fcfy1=qdy*fcf1+wqy*fcf2+     rzcf2           +     fcz12
      fcfz1=qdz*fcf1+wqz*fcf2+     rycf2+2.d0*rfzf2+     fcy12
      fdax1=qdx*fda1+wqx*fda2           +     rfya2+2.d0*fdx12
      fday1=qdy*fda1+wqy*fda2+     rzda2+     rfxa2           
      fdaz1=qdz*fda1+wqz*fda2+     ryda2                      
      fdbx1=qdx*fdb1+wqx*fdb2           +     rfyb2           
      fdby1=qdy*fdb1+wqy*fdb2+     rzdb2+     rfxb2+2.d0*fdy12
      fdbz1=qdz*fdb1+wqz*fdb2+     rydb2                      
      fdcx1=qdx*fdc1+wqx*fdc2           +     rfyc2           
      fdcy1=qdy*fdc1+wqy*fdc2+     rzdc2+     rfxc2           
      fdcz1=qdz*fdc1+wqz*fdc2+     rydc2           +2.d0*fdz12
      fddx1=qdx*fdd1+wqx*fdd2           +     rfyd2+     fdy12
      fddy1=qdy*fdd1+wqy*fdd2+     rzdd2+     rfxd2+     fdx12
      fddz1=qdz*fdd1+wqz*fdd2+     rydd2                      
      fdex1=qdx*fde1+wqx*fde2           +     rfye2+     fdz12
      fdey1=qdy*fde1+wqy*fde2+     rzde2+     rfxe2           
      fdez1=qdz*fde1+wqz*fde2+     ryde2           +     fdx12
      fdfx1=qdx*fdf1+wqx*fdf2           +     rfyf2           
      fdfy1=qdy*fdf1+wqy*fdf2+     rzdf2+     rfxf2+     fdz12
      fdfz1=qdz*fdf1+wqz*fdf2+     rydf2           +     fdy12
      feax1=qdx*fea1+wqx*fea2           +     rfza2+2.d0*fex12
      feay1=qdy*fea1+wqy*fea2+     rzea2                      
      feaz1=qdz*fea1+wqz*fea2+     ryea2+     rfxa2           
      febx1=qdx*feb1+wqx*feb2           +     rfzb2           
      feby1=qdy*feb1+wqy*feb2+     rzeb2           +2.d0*fey12
      febz1=qdz*feb1+wqz*feb2+     ryeb2+     rfxb2           
      fecx1=qdx*fec1+wqx*fec2           +     rfzc2           
      fecy1=qdy*fec1+wqy*fec2+     rzec2                      
      fecz1=qdz*fec1+wqz*fec2+     ryec2+     rfxc2+2.d0*fez12
      fedx1=qdx*fed1+wqx*fed2           +     rfzd2+     fey12
      fedy1=qdy*fed1+wqy*fed2+     rzed2           +     fex12
      fedz1=qdz*fed1+wqz*fed2+     ryed2+     rfxd2           
      feex1=qdx*fee1+wqx*fee2           +     rfze2+     fez12
      feey1=qdy*fee1+wqy*fee2+     rzee2                      
      feez1=qdz*fee1+wqz*fee2+     ryee2+     rfxe2+     fex12
      fefx1=qdx*fef1+wqx*fef2           +     rfzf2           
      fefy1=qdy*fef1+wqy*fef2+     rzef2           +     fez12
      fefz1=qdz*fef1+wqz*fef2+     ryef2+     rfxf2+     fey12
      ffax1=qdx*ffa1+wqx*ffa2                      +2.d0*ffx12
      ffay1=qdy*ffa1+wqy*ffa2+     rzfa2+     rfza2           
      ffaz1=qdz*ffa1+wqz*ffa2+     ryfa2+     rfya2           
      ffbx1=qdx*ffb1+wqx*ffb2                                 
      ffby1=qdy*ffb1+wqy*ffb2+     rzfb2+     rfzb2+2.d0*ffy12
      ffbz1=qdz*ffb1+wqz*ffb2+     ryfb2+     rfyb2           
      ffcx1=qdx*ffc1+wqx*ffc2                                 
      ffcy1=qdy*ffc1+wqy*ffc2+     rzfc2+     rfzc2           
      ffcz1=qdz*ffc1+wqz*ffc2+     ryfc2+     rfyc2+2.d0*ffz12
      ffdx1=qdx*ffd1+wqx*ffd2                      +     ffy12
      ffdy1=qdy*ffd1+wqy*ffd2+     rzfd2+     rfzd2+     ffx12
      ffdz1=qdz*ffd1+wqz*ffd2+     ryfd2+     rfyd2           
      ffex1=qdx*ffe1+wqx*ffe2                      +     ffz12
      ffey1=qdy*ffe1+wqy*ffe2+     rzfe2+     rfze2           
      ffez1=qdz*ffe1+wqz*ffe2+     ryfe2+     rfye2+     ffx12
      fffx1=qdx*fff1+wqx*fff2                                 
      fffy1=qdy*fff1+wqy*fff2+     rzff2+     rfzf2+     ffz12
      fffz1=qdz*fff1+wqz*fff2+     ryff2+     rfyf2+     ffy12

!rdsds(2)
      aa2 = rkp*dxxdxx2
      ab2 = rkp*dxxdyy2
      ac2 = rkp*dxxdzz2
      ad2 = rkp*dxxdyx2
      ae2 = rkp*dxxdzx2
      af2 = rkp*dxxdzy2
      ba2 = rkp*dyydxx2
      bb2 = rkp*dyydyy2
      bc2 = rkp*dyydzz2
      bd2 = rkp*dyydyx2
      be2 = rkp*dyydzx2
      bf2 = rkp*dyydzy2
      ca2 = rkp*dzzdxx2
      cb2 = rkp*dzzdyy2
      cc2 = rkp*dzzdzz2
      cd2 = rkp*dzzdyx2
      ce2 = rkp*dzzdzx2
      cf2 = rkp*dzzdzy2
      da2 = rkp*dyxdxx2
      db2 = rkp*dyxdyy2
      dc2 = rkp*dyxdzz2
      dd2 = rkp*dyxdyx2
      de2 = rkp*dyxdzx2
      df2 = rkp*dyxdzy2
      ea2 = rkp*dzxdxx2
      eb2 = rkp*dzxdyy2
      ec2 = rkp*dzxdzz2
      ed2 = rkp*dzxdyx2
      ee2 = rkp*dzxdzx2
      ef2 = rkp*dzxdzy2

      fa2 = rkp*dzydxx2
      fb2 = rkp*dzydyy2
      fc2 = rkp*dzydzz2
      fd2 = rkp*dzydyx2
      fe2 = rkp*dzydzx2
      ff2 = rkp*dzydzy2

!edpps01(12)

      dxxpxpx12= eta*(axx1-rooe *axx2)
      dxxpxpy12= eta*(axy1-rooe *axy2)
      dxxpxpz12= eta*(axz1-rooe *axz2)
      dxxpypx12= eta*(ayx1-rooe *ayx2)
      dxxpypy12= eta*(ayy1-rooe *ayy2)
      dxxpypz12= eta*(ayz1-rooe *ayz2)
      dxxpzpx12= eta*(azx1-rooe *azx2)
      dxxpzpy12= eta*(azy1-rooe *azy2)
      dxxpzpz12= eta*(azz1-rooe *azz2)
      dyypxpx12= eta*(bxx1-rooe *bxx2)
      dyypxpy12= eta*(bxy1-rooe *bxy2)
      dyypxpz12= eta*(bxz1-rooe *bxz2)
      dyypypx12= eta*(byx1-rooe *byx2)
      dyypypy12= eta*(byy1-rooe *byy2)
      dyypypz12= eta*(byz1-rooe *byz2)
      dyypzpx12= eta*(bzx1-rooe *bzx2)
      dyypzpy12= eta*(bzy1-rooe *bzy2)
      dyypzpz12= eta*(bzz1-rooe *bzz2)
      dzzpxpx12= eta*(cxx1-rooe *cxx2)
      dzzpxpy12= eta*(cxy1-rooe *cxy2)
      dzzpxpz12= eta*(cxz1-rooe *cxz2)
      dzzpypx12= eta*(cyx1-rooe *cyx2)
      dzzpypy12= eta*(cyy1-rooe *cyy2)
      dzzpypz12= eta*(cyz1-rooe *cyz2)
      dzzpzpx12= eta*(czx1-rooe *czx2)
      dzzpzpy12= eta*(czy1-rooe *czy2)
      dzzpzpz12= eta*(czz1-rooe *czz2)
      dyxpxpx12= eta*(dxx1-rooe *dxx2)
      dyxpxpy12= eta*(dxy1-rooe *dxy2)
      dyxpxpz12= eta*(dxz1-rooe *dxz2)
      dyxpypx12= eta*(dyx1-rooe *dyx2)
      dyxpypy12= eta*(dyy1-rooe *dyy2)
      dyxpypz12= eta*(dyz1-rooe *dyz2)
      dyxpzpx12= eta*(dzx1-rooe *dzx2)
      dyxpzpy12= eta*(dzy1-rooe *dzy2)
      dyxpzpz12= eta*(dzz1-rooe *dzz2)
      dzxpxpx12= eta*(exx1-rooe *exx2)
      dzxpxpy12= eta*(exy1-rooe *exy2)
      dzxpxpz12= eta*(exz1-rooe *exz2)
      dzxpypx12= eta*(eyx1-rooe *eyx2)
      dzxpypy12= eta*(eyy1-rooe *eyy2)
      dzxpypz12= eta*(eyz1-rooe *eyz2)
      dzxpzpx12= eta*(ezx1-rooe *ezx2)
      dzxpzpy12= eta*(ezy1-rooe *ezy2)
      dzxpzpz12= eta*(ezz1-rooe *ezz2)
      dzypxpx12= eta*(fxx1-rooe *fxx2)
      dzypxpy12= eta*(fxy1-rooe *fxy2)
      dzypxpz12= eta*(fxz1-rooe *fxz2)
      dzypypx12= eta*(fyx1-rooe *fyx2)
      dzypypy12= eta*(fyy1-rooe *fyy2)
      dzypypz12= eta*(fyz1-rooe *fyz2)
      dzypzpx12= eta*(fzx1-rooe *fzx2)
      dzypzpy12= eta*(fzy1-rooe *fzy2)
      dzypzpz12= eta*(fzz1-rooe *fzz2)

!dpdp(1)
      axax1=qdx*axa1+wqx*axa2+2.d0*rxxdxx2+aa2+2.d0*dxxpxpx12
      axay1=qdy*axa1+wqy*axa2                 
      axaz1=qdz*axa1+wqz*axa2                 
      axbx1=qdx*axb1+wqx*axb2+2.d0*rxxdyy2+ab2
      axby1=qdy*axb1+wqy*axb2                 +2.d0*dxxpxpy12
      axbz1=qdz*axb1+wqz*axb2                     
      axcx1=qdx*axc1+wqx*axc2+2.d0*rxxdzz2+ac2
      axcy1=qdy*axc1+wqy*axc2                     
      axcz1=qdz*axc1+wqz*axc2                 +2.d0*dxxpxpz12
      axdx1=qdx*axd1+wqx*axd2+2.d0*rxxdyx2+ad2+     dxxpxpy12
      axdy1=qdy*axd1+wqy*axd2                 +     dxxpxpx12
      axdz1=qdz*axd1+wqz*axd2                     
      axex1=qdx*axe1+wqx*axe2+2.d0*rxxdzx2+ae2+     dxxpxpz12
      axey1=qdy*axe1+wqy*axe2                     
      axez1=qdz*axe1+wqz*axe2                 +     dxxpxpx12
      axfx1=qdx*axf1+wqx*axf2+2.d0*rxxdzy2+af2
      axfy1=qdy*axf1+wqy*axf2                 +     dxxpxpz12
      axfz1=qdz*axf1+wqz*axf2                 +     dxxpxpy12
      ayax1=qdx*aya1+wqx*aya2+2.d0*rxydxx2    +2.d0*dxxpypx12
      ayay1=qdy*aya1+wqy*aya2             +aa2
      ayaz1=qdz*aya1+wqz*aya2                 
      aybx1=qdx*ayb1+wqx*ayb2+2.d0*rxydyy2    
      ayby1=qdy*ayb1+wqy*ayb2             +ab2+2.d0*dxxpypy12
      aybz1=qdz*ayb1+wqz*ayb2                     
      aycx1=qdx*ayc1+wqx*ayc2+2.d0*rxydzz2        
      aycy1=qdy*ayc1+wqy*ayc2             +ac2
      aycz1=qdz*ayc1+wqz*ayc2                 +2.d0*dxxpypz12
      aydx1=qdx*ayd1+wqx*ayd2+2.d0*rxydyx2    +     dxxpypy12
      aydy1=qdy*ayd1+wqy*ayd2             +ad2+     dxxpypx12
      aydz1=qdz*ayd1+wqz*ayd2                     
      ayex1=qdx*aye1+wqx*aye2+2.d0*rxydzx2    +     dxxpypz12
      ayey1=qdy*aye1+wqy*aye2             +ae2
      ayez1=qdz*aye1+wqz*aye2                 +     dxxpypx12
      ayfx1=qdx*ayf1+wqx*ayf2+2.d0*rxydzy2        
      ayfy1=qdy*ayf1+wqy*ayf2             +af2+     dxxpypz12
      ayfz1=qdz*ayf1+wqz*ayf2                 +     dxxpypy12
      azax1=qdx*aza1+wqx*aza2+2.d0*rxzdxx2    +2.d0*dxxpzpx12
      azay1=qdy*aza1+wqy*aza2                     
      azaz1=qdz*aza1+wqz*aza2             +aa2
      azbx1=qdx*azb1+wqx*azb2+2.d0*rxzdyy2        
      azby1=qdy*azb1+wqy*azb2                 +2.d0*dxxpzpy12
      azbz1=qdz*azb1+wqz*azb2             +ab2
      azcx1=qdx*azc1+wqx*azc2+2.d0*rxzdzz2        
      azcy1=qdy*azc1+wqy*azc2                     
      azcz1=qdz*azc1+wqz*azc2             +ac2+2.d0*dxxpzpz12
      azdx1=qdx*azd1+wqx*azd2+2.d0*rxzdyx2    +     dxxpzpy12
      azdy1=qdy*azd1+wqy*azd2                 +     dxxpzpx12
      azdz1=qdz*azd1+wqz*azd2             +ad2
      azex1=qdx*aze1+wqx*aze2+2.d0*rxzdzx2    +     dxxpzpz12
      azey1=qdy*aze1+wqy*aze2                 
      azez1=qdz*aze1+wqz*aze2             +ae2+     dxxpzpx12
      azfx1=qdx*azf1+wqx*azf2+2.d0*rxzdzy2        
      azfy1=qdy*azf1+wqy*azf2                 +     dxxpzpz12
      azfz1=qdz*azf1+wqz*azf2             +af2+     dxxpzpy12
      bxax1=qdx*bxa1+wqx*bxa2             +ba2+2.d0*dyypxpx12
      bxay1=qdy*bxa1+wqy*bxa2+2.d0*ryxdxx2        
      bxaz1=qdz*bxa1+wqz*bxa2                     
      bxbx1=qdx*bxb1+wqx*bxb2             +bb2
      bxby1=qdy*bxb1+wqy*bxb2+2.d0*ryxdyy2    +2.d0*dyypxpy12
      bxbz1=qdz*bxb1+wqz*bxb2                     
      bxcx1=qdx*bxc1+wqx*bxc2             +bc2
      bxcy1=qdy*bxc1+wqy*bxc2+2.d0*ryxdzz2        
      bxcz1=qdz*bxc1+wqz*bxc2                 +2.d0*dyypxpz12
      bxdx1=qdx*bxd1+wqx*bxd2             +bd2+     dyypxpy12
      bxdy1=qdy*bxd1+wqy*bxd2+2.d0*ryxdyx2    +     dyypxpx12
      bxdz1=qdz*bxd1+wqz*bxd2                     
      bxex1=qdx*bxe1+wqx*bxe2             +be2+     dyypxpz12
      bxey1=qdy*bxe1+wqy*bxe2+2.d0*ryxdzx2        
      bxez1=qdz*bxe1+wqz*bxe2                 +     dyypxpx12
      bxfx1=qdx*bxf1+wqx*bxf2             +bf2
      bxfy1=qdy*bxf1+wqy*bxf2+2.d0*ryxdzy2    +     dyypxpz12
      bxfz1=qdz*bxf1+wqz*bxf2                 +     dyypxpy12
      byax1=qdx*bya1+wqx*bya2                 +2.d0*dyypypx12
      byay1=qdy*bya1+wqy*bya2+2.d0*ryydxx2+ba2
      byaz1=qdz*bya1+wqz*bya2                     
      bybx1=qdx*byb1+wqx*byb2                     
      byby1=qdy*byb1+wqy*byb2+2.d0*ryydyy2+bb2+2.d0*dyypypy12
      bybz1=qdz*byb1+wqz*byb2                 
      bycx1=qdx*byc1+wqx*byc2                     
      bycy1=qdy*byc1+wqy*byc2+2.d0*ryydzz2+bc2
      bycz1=qdz*byc1+wqz*byc2                 +2.d0*dyypypz12
      bydx1=qdx*byd1+wqx*byd2                 +     dyypypy12
      bydy1=qdy*byd1+wqy*byd2+2.d0*ryydyx2+bd2+     dyypypx12
      bydz1=qdz*byd1+wqz*byd2                 
      byex1=qdx*bye1+wqx*bye2                 +     dyypypz12
      byey1=qdy*bye1+wqy*bye2+2.d0*ryydzx2+be2
      byez1=qdz*bye1+wqz*bye2                 +     dyypypx12
      byfx1=qdx*byf1+wqx*byf2                 
      byfy1=qdy*byf1+wqy*byf2+2.d0*ryydzy2+bf2+     dyypypz12
      byfz1=qdz*byf1+wqz*byf2                 +     dyypypy12
      bzax1=qdx*bza1+wqx*bza2                 +2.d0*dyypzpx12
      bzay1=qdy*bza1+wqy*bza2+2.d0*ryzdxx2        
      bzaz1=qdz*bza1+wqz*bza2             +ba2
      bzbx1=qdx*bzb1+wqx*bzb2                     
      bzby1=qdy*bzb1+wqy*bzb2+2.d0*ryzdyy2    +2.d0*dyypzpy12
      bzbz1=qdz*bzb1+wqz*bzb2             +bb2
      bzcx1=qdx*bzc1+wqx*bzc2                     
      bzcy1=qdy*bzc1+wqy*bzc2+2.d0*ryzdzz2        
      bzcz1=qdz*bzc1+wqz*bzc2             +bc2+2.d0*dyypzpz12
      bzdx1=qdx*bzd1+wqx*bzd2                 +     dyypzpy12
      bzdy1=qdy*bzd1+wqy*bzd2+2.d0*ryzdyx2    +     dyypzpx12
      bzdz1=qdz*bzd1+wqz*bzd2             +bd2
      bzex1=qdx*bze1+wqx*bze2                 +     dyypzpz12
      bzey1=qdy*bze1+wqy*bze2+2.d0*ryzdzx2    
      bzez1=qdz*bze1+wqz*bze2             +be2+     dyypzpx12
      bzfx1=qdx*bzf1+wqx*bzf2                     
      bzfy1=qdy*bzf1+wqy*bzf2+2.d0*ryzdzy2    +     dyypzpz12
      bzfz1=qdz*bzf1+wqz*bzf2             +bf2+     dyypzpy12
      cxax1=qdx*cxa1+wqx*cxa2             +ca2+2.d0*dzzpxpx12
      cxay1=qdy*cxa1+wqy*cxa2                     
      cxaz1=qdz*cxa1+wqz*cxa2+2.d0*rzxdxx2        
      cxbx1=qdx*cxb1+wqx*cxb2             +cb2
      cxby1=qdy*cxb1+wqy*cxb2                 +2.d0*dzzpxpy12
      cxbz1=qdz*cxb1+wqz*cxb2+2.d0*rzxdyy2        
      cxcx1=qdx*cxc1+wqx*cxc2             +cc2
      cxcy1=qdy*cxc1+wqy*cxc2                     
      cxcz1=qdz*cxc1+wqz*cxc2+2.d0*rzxdzz2    +2.d0*dzzpxpz12
      cxdx1=qdx*cxd1+wqx*cxd2             +cd2+     dzzpxpy12
      cxdy1=qdy*cxd1+wqy*cxd2                 +     dzzpxpx12
      cxdz1=qdz*cxd1+wqz*cxd2+2.d0*rzxdyx2        
      cxex1=qdx*cxe1+wqx*cxe2             +ce2+     dzzpxpz12
      cxey1=qdy*cxe1+wqy*cxe2                    
      cxez1=qdz*cxe1+wqz*cxe2+2.d0*rzxdzx2    +     dzzpxpx12
      cxfx1=qdx*cxf1+wqx*cxf2             +cf2
      cxfy1=qdy*cxf1+wqy*cxf2                 +     dzzpxpz12
      cxfz1=qdz*cxf1+wqz*cxf2+2.d0*rzxdzy2    +     dzzpxpy12
      cyax1=qdx*cya1+wqx*cya2                 +2.d0*dzzpypx12
      cyay1=qdy*cya1+wqy*cya2             +ca2
      cyaz1=qdz*cya1+wqz*cya2+2.d0*rzydxx2        
      cybx1=qdx*cyb1+wqx*cyb2                     
      cyby1=qdy*cyb1+wqy*cyb2             +cb2+2.d0*dzzpypy12
      cybz1=qdz*cyb1+wqz*cyb2+2.d0*rzydyy2        
      cycx1=qdx*cyc1+wqx*cyc2                     
      cycy1=qdy*cyc1+wqy*cyc2             +cc2
      cycz1=qdz*cyc1+wqz*cyc2+2.d0*rzydzz2    +2.d0*dzzpypz12
      cydx1=qdx*cyd1+wqx*cyd2                 +     dzzpypy12
      cydy1=qdy*cyd1+wqy*cyd2             +cd2+     dzzpypx12
      cydz1=qdz*cyd1+wqz*cyd2+2.d0*rzydyx2        
      cyex1=qdx*cye1+wqx*cye2                 +     dzzpypz12
      cyey1=qdy*cye1+wqy*cye2             +ce2 
      cyez1=qdz*cye1+wqz*cye2+2.d0*rzydzx2    +     dzzpypx12
      cyfx1=qdx*cyf1+wqx*cyf2                     
      cyfy1=qdy*cyf1+wqy*cyf2             +cf2+     dzzpypz12
      cyfz1=qdz*cyf1+wqz*cyf2+2.d0*rzydzy2    +     dzzpypy12
      czax1=qdx*cza1+wqx*cza2                 +2.d0*dzzpzpx12
      czay1=qdy*cza1+wqy*cza2                     
      czaz1=qdz*cza1+wqz*cza2+2.d0*rzzdxx2+ca2
      czbx1=qdx*czb1+wqx*czb2                     
      czby1=qdy*czb1+wqy*czb2                 +2.d0*dzzpzpy12
      czbz1=qdz*czb1+wqz*czb2+2.d0*rzzdyy2+cb2
      czcx1=qdx*czc1+wqx*czc2                     
      czcy1=qdy*czc1+wqy*czc2                     
      czcz1=qdz*czc1+wqz*czc2+2.d0*rzzdzz2+cc2+2.d0*dzzpzpz12
      czdx1=qdx*czd1+wqx*czd2                 +     dzzpzpy12
      czdy1=qdy*czd1+wqy*czd2                 +     dzzpzpx12
      czdz1=qdz*czd1+wqz*czd2+2.d0*rzzdyx2+cd2
      czex1=qdx*cze1+wqx*cze2                 +     dzzpzpz12
      czey1=qdy*cze1+wqy*cze2                  
      czez1=qdz*cze1+wqz*cze2+2.d0*rzzdzx2+ce2+     dzzpzpx12
      czfx1=qdx*czf1+wqx*czf2                 
      czfy1=qdy*czf1+wqy*czf2                 +     dzzpzpz12
      czfz1=qdz*czf1+wqz*czf2+2.d0*rzzdzy2+cf2+     dzzpzpy12
      dxax1=qdx*dxa1+wqx*dxa2+     ryxdxx2+da2+2.d0*dyxpxpx12
      dxay1=qdy*dxa1+wqy*dxa2+     rxxdxx2    
      dxaz1=qdz*dxa1+wqz*dxa2                 
      dxbx1=qdx*dxb1+wqx*dxb2+     ryxdyy2+db2
      dxby1=qdy*dxb1+wqy*dxb2+     rxxdyy2    +2.d0*dyxpxpy12
      dxbz1=qdz*dxb1+wqz*dxb2                     
      dxcx1=qdx*dxc1+wqx*dxc2+     ryxdzz2+dc2
      dxcy1=qdy*dxc1+wqy*dxc2+     rxxdzz2        
      dxcz1=qdz*dxc1+wqz*dxc2                 +2.d0*dyxpxpz12
      dxdx1=qdx*dxd1+wqx*dxd2+     ryxdyx2+dd2+     dyxpxpy12
      dxdy1=qdy*dxd1+wqy*dxd2+     rxxdyx2    +     dyxpxpx12
      dxdz1=qdz*dxd1+wqz*dxd2                     
      dxex1=qdx*dxe1+wqx*dxe2+     ryxdzx2+de2+     dyxpxpz12
      dxey1=qdy*dxe1+wqy*dxe2+     rxxdzx2           
      dxez1=qdz*dxe1+wqz*dxe2                 +     dyxpxpx12
      dxfx1=qdx*dxf1+wqx*dxf2+     ryxdzy2+df2
      dxfy1=qdy*dxf1+wqy*dxf2+     rxxdzy2    +     dyxpxpz12
      dxfz1=qdz*dxf1+wqz*dxf2                 +     dyxpxpy12
      dyax1=qdx*dya1+wqx*dya2+     ryydxx2    +2.d0*dyxpypx12
      dyay1=qdy*dya1+wqy*dya2+     rxydxx2+da2
      dyaz1=qdz*dya1+wqz*dya2                     
      dybx1=qdx*dyb1+wqx*dyb2+     ryydyy2        
      dyby1=qdy*dyb1+wqy*dyb2+     rxydyy2+db2+2.d0*dyxpypy12
      dybz1=qdz*dyb1+wqz*dyb2                     
      dycx1=qdx*dyc1+wqx*dyc2+     ryydzz2        
      dycy1=qdy*dyc1+wqy*dyc2+     rxydzz2+dc2
      dycz1=qdz*dyc1+wqz*dyc2                 +2.d0*dyxpypz12
      dydx1=qdx*dyd1+wqx*dyd2+     ryydyx2    +     dyxpypy12
      dydy1=qdy*dyd1+wqy*dyd2+     rxydyx2+dd2+     dyxpypx12
      dydz1=qdz*dyd1+wqz*dyd2                     
      dyex1=qdx*dye1+wqx*dye2+     ryydzx2    +     dyxpypz12
      dyey1=qdy*dye1+wqy*dye2+     rxydzx2+de2
      dyez1=qdz*dye1+wqz*dye2                 +     dyxpypx12
      dyfx1=qdx*dyf1+wqx*dyf2+     ryydzy2        
      dyfy1=qdy*dyf1+wqy*dyf2+     rxydzy2+df2+     dyxpypz12
      dyfz1=qdz*dyf1+wqz*dyf2                 +     dyxpypy12
      dzax1=qdx*dza1+wqx*dza2+     ryzdxx2    +2.d0*dyxpzpx12
      dzay1=qdy*dza1+wqy*dza2+     rxzdxx2        
      dzaz1=qdz*dza1+wqz*dza2             +da2
      dzbx1=qdx*dzb1+wqx*dzb2+     ryzdyy2        
      dzby1=qdy*dzb1+wqy*dzb2+     rxzdyy2    +2.d0*dyxpzpy12
      dzbz1=qdz*dzb1+wqz*dzb2             +db2
      dzcx1=qdx*dzc1+wqx*dzc2+     ryzdzz2        
      dzcy1=qdy*dzc1+wqy*dzc2+     rxzdzz2        
      dzcz1=qdz*dzc1+wqz*dzc2             +dc2+2.d0*dyxpzpz12
      dzdx1=qdx*dzd1+wqx*dzd2+     ryzdyx2    +     dyxpzpy12
      dzdy1=qdy*dzd1+wqy*dzd2+     rxzdyx2    +     dyxpzpx12
      dzdz1=qdz*dzd1+wqz*dzd2             +dd2
      dzex1=qdx*dze1+wqx*dze2+     ryzdzx2    +     dyxpzpz12
      dzey1=qdy*dze1+wqy*dze2+     rxzdzx2    
      dzez1=qdz*dze1+wqz*dze2             +de2+     dyxpzpx12
      dzfx1=qdx*dzf1+wqx*dzf2+     ryzdzy2    
      dzfy1=qdy*dzf1+wqy*dzf2+     rxzdzy2    +     dyxpzpz12
      dzfz1=qdz*dzf1+wqz*dzf2             +df2+     dyxpzpy12
      exax1=qdx*exa1+wqx*exa2+     rzxdxx2+ea2+2.d0*dzxpxpx12
      exay1=qdy*exa1+wqy*exa2                     
      exaz1=qdz*exa1+wqz*exa2+     rxxdxx2        
      exbx1=qdx*exb1+wqx*exb2+     rzxdyy2+eb2
      exby1=qdy*exb1+wqy*exb2                 +2.d0*dzxpxpy12
      exbz1=qdz*exb1+wqz*exb2+     rxxdyy2        
      excx1=qdx*exc1+wqx*exc2+     rzxdzz2+ec2
      excy1=qdy*exc1+wqy*exc2                     
      excz1=qdz*exc1+wqz*exc2+     rxxdzz2    +2.d0*dzxpxpz12
      exdx1=qdx*exd1+wqx*exd2+     rzxdyx2+ed2+     dzxpxpy12
      exdy1=qdy*exd1+wqy*exd2                 +     dzxpxpx12
      exdz1=qdz*exd1+wqz*exd2+     rxxdyx2        
      exex1=qdx*exe1+wqx*exe2+     rzxdzx2+ee2+     dzxpxpz12
      exey1=qdy*exe1+wqy*exe2                      
      exez1=qdz*exe1+wqz*exe2+     rxxdzx2    +     dzxpxpx12
      exfx1=qdx*exf1+wqx*exf2+     rzxdzy2+ef2
      exfy1=qdy*exf1+wqy*exf2                 +     dzxpxpz12
      exfz1=qdz*exf1+wqz*exf2+     rxxdzy2    +     dzxpxpy12
      eyax1=qdx*eya1+wqx*eya2+     rzydxx2    +2.d0*dzxpypx12
      eyay1=qdy*eya1+wqy*eya2             +ea2
      eyaz1=qdz*eya1+wqz*eya2+     rxydxx2        
      eybx1=qdx*eyb1+wqx*eyb2+     rzydyy2        
      eyby1=qdy*eyb1+wqy*eyb2             +eb2+2.d0*dzxpypy12
      eybz1=qdz*eyb1+wqz*eyb2+     rxydyy2        
      eycx1=qdx*eyc1+wqx*eyc2+     rzydzz2        
      eycy1=qdy*eyc1+wqy*eyc2             +ec2
      eycz1=qdz*eyc1+wqz*eyc2+     rxydzz2    +2.d0*dzxpypz12
      eydx1=qdx*eyd1+wqx*eyd2+     rzydyx2    +     dzxpypy12
      eydy1=qdy*eyd1+wqy*eyd2             +ed2+     dzxpypx12
      eydz1=qdz*eyd1+wqz*eyd2+     rxydyx2    
      eyex1=qdx*eye1+wqx*eye2+     rzydzx2    +     dzxpypz12
      eyey1=qdy*eye1+wqy*eye2             +ee2 
      eyez1=qdz*eye1+wqz*eye2+     rxydzx2    +     dzxpypx12
      eyfx1=qdx*eyf1+wqx*eyf2+     rzydzy2        
      eyfy1=qdy*eyf1+wqy*eyf2             +ef2+     dzxpypz12
      eyfz1=qdz*eyf1+wqz*eyf2+     rxydzy2    +     dzxpypy12
      ezax1=qdx*eza1+wqx*eza2+     rzzdxx2    +2.d0*dzxpzpx12
      ezay1=qdy*eza1+wqy*eza2                     
      ezaz1=qdz*eza1+wqz*eza2+     rxzdxx2+ea2
      ezbx1=qdx*ezb1+wqx*ezb2+     rzzdyy2        
      ezby1=qdy*ezb1+wqy*ezb2                 +2.d0*dzxpzpy12
      ezbz1=qdz*ezb1+wqz*ezb2+     rxzdyy2+eb2
      ezcx1=qdx*ezc1+wqx*ezc2+     rzzdzz2        
      ezcy1=qdy*ezc1+wqy*ezc2                     
      ezcz1=qdz*ezc1+wqz*ezc2+     rxzdzz2+ec2+2.d0*dzxpzpz12
      ezdx1=qdx*ezd1+wqx*ezd2+     rzzdyx2    +     dzxpzpy12
      ezdy1=qdy*ezd1+wqy*ezd2                 +     dzxpzpx12
      ezdz1=qdz*ezd1+wqz*ezd2+     rxzdyx2+ed2
      ezex1=qdx*eze1+wqx*eze2+     rzzdzx2    +     dzxpzpz12
      ezey1=qdy*eze1+wqy*eze2                      
      ezez1=qdz*eze1+wqz*eze2+     rxzdzx2+ee2+     dzxpzpx12
      ezfx1=qdx*ezf1+wqx*ezf2+     rzzdzy2     
      ezfy1=qdy*ezf1+wqy*ezf2                 +     dzxpzpz12
      ezfz1=qdz*ezf1+wqz*ezf2+     rxzdzy2+ef2+     dzxpzpy12
      fxax1=qdx*fxa1+wqx*fxa2             +fa2+2.d0*dzypxpx12
      fxay1=qdy*fxa1+wqy*fxa2+     rzxdxx2        
      fxaz1=qdz*fxa1+wqz*fxa2+     ryxdxx2        
      fxbx1=qdx*fxb1+wqx*fxb2             +fb2
      fxby1=qdy*fxb1+wqy*fxb2+     rzxdyy2    +2.d0*dzypxpy12
      fxbz1=qdz*fxb1+wqz*fxb2+     ryxdyy2        
      fxcx1=qdx*fxc1+wqx*fxc2             +fc2
      fxcy1=qdy*fxc1+wqy*fxc2+     rzxdzz2        
      fxcz1=qdz*fxc1+wqz*fxc2+     ryxdzz2    +2.d0*dzypxpz12
      fxdx1=qdx*fxd1+wqx*fxd2             +fd2+     dzypxpy12
      fxdy1=qdy*fxd1+wqy*fxd2+     rzxdyx2    +     dzypxpx12
      fxdz1=qdz*fxd1+wqz*fxd2+     ryxdyx2        
      fxex1=qdx*fxe1+wqx*fxe2             +fe2+     dzypxpz12
      fxey1=qdy*fxe1+wqy*fxe2+     rzxdzx2          
      fxez1=qdz*fxe1+wqz*fxe2+     ryxdzx2    +     dzypxpx12
      fxfx1=qdx*fxf1+wqx*fxf2             +ff2
      fxfy1=qdy*fxf1+wqy*fxf2+     rzxdzy2    +     dzypxpz12
      fxfz1=qdz*fxf1+wqz*fxf2+     ryxdzy2    +     dzypxpy12
      fyax1=qdx*fya1+wqx*fya2                 +2.d0*dzypypx12
      fyay1=qdy*fya1+wqy*fya2+     rzydxx2+fa2
      fyaz1=qdz*fya1+wqz*fya2+     ryydxx2        
      fybx1=qdx*fyb1+wqx*fyb2                 
      fyby1=qdy*fyb1+wqy*fyb2+     rzydyy2+fb2+2.d0*dzypypy12
      fybz1=qdz*fyb1+wqz*fyb2+     ryydyy2        
      fycx1=qdx*fyc1+wqx*fyc2                     
      fycy1=qdy*fyc1+wqy*fyc2+     rzydzz2+fc2 !sak
      fycz1=qdz*fyc1+wqz*fyc2+     ryydzz2    +2.d0*dzypypz12
      fydx1=qdx*fyd1+wqx*fyd2                 +     dzypypy12
      fydy1=qdy*fyd1+wqy*fyd2+     rzydyx2+fd2+     dzypypx12
      fydz1=qdz*fyd1+wqz*fyd2+     ryydyx2    
      fyex1=qdx*fye1+wqx*fye2                 +     dzypypz12
      fyey1=qdy*fye1+wqy*fye2+     rzydzx2+fe2 
      fyez1=qdz*fye1+wqz*fye2+     ryydzx2    +     dzypypx12
      fyfx1=qdx*fyf1+wqx*fyf2                     
      fyfy1=qdy*fyf1+wqy*fyf2+     rzydzy2+ff2+     dzypypz12
      fyfz1=qdz*fyf1+wqz*fyf2+     ryydzy2    +     dzypypy12
      fzax1=qdx*fza1+wqx*fza2                 +2.d0*dzypzpx12
      fzay1=qdy*fza1+wqy*fza2+     rzzdxx2        
      fzaz1=qdz*fza1+wqz*fza2+     ryzdxx2+fa2
      fzbx1=qdx*fzb1+wqx*fzb2                     
      fzby1=qdy*fzb1+wqy*fzb2+     rzzdyy2    +2.d0*dzypzpy12
      fzbz1=qdz*fzb1+wqz*fzb2+     ryzdyy2+fb2
      fzcx1=qdx*fzc1+wqx*fzc2                 
      fzcy1=qdy*fzc1+wqy*fzc2+     rzzdzz2        
      fzcz1=qdz*fzc1+wqz*fzc2+     ryzdzz2+fc2+2.d0*dzypzpz12
      fzdx1=qdx*fzd1+wqx*fzd2                 +     dzypzpy12
      fzdy1=qdy*fzd1+wqy*fzd2+     rzzdyx2    +     dzypzpx12
      fzdz1=qdz*fzd1+wqz*fzd2+     ryzdyx2+fd2
      fzex1=qdx*fze1+wqx*fze2                 +     dzypzpz12
      fzey1=qdy*fze1+wqy*fze2+     rzzdzx2         
      fzez1=qdz*fze1+wqz*fze2+     ryzdzx2+fe2+     dzypzpx12
      fzfx1=qdx*fzf1+wqx*fzf2                     
      fzfy1=qdy*fzf1+wqy*fzf2+     rzzdzy2    +     dzypzpz12
      fzfz1=qdz*fzf1+wqz*fzf2+     ryzdzy2+ff2+     dzypzpy12
!ddpp(0-1)
      aaxx0=qdx*dxxdxxpx0+wqx*dxxdxxpx1+2.d0*xax1+2.d0*raxx1+aa0
      aaxy0=qdy*dxxdxxpx0+wqy*dxxdxxpx1                         
      aaxz0=qdz*dxxdxxpx0+wqz*dxxdxxpx1                         
      aayx0=qdx*dxxdxxpy0+wqx*dxxdxxpy1+2.d0*xay1+2.d0*raxy1    
      aayy0=qdy*dxxdxxpy0+wqy*dxxdxxpy1                     +aa0
      aayz0=qdz*dxxdxxpy0+wqz*dxxdxxpy1                         
      aazx0=qdx*dxxdxxpz0+wqx*dxxdxxpz1+2.d0*xaz1+2.d0*raxz1    
      aazy0=qdy*dxxdxxpz0+wqy*dxxdxxpz1                         
      aazz0=qdz*dxxdxxpz0+wqz*dxxdxxpz1                     +aa0
      abxx0=qdx*dxxdyypx0+wqx*dxxdyypx1+2.d0*xbx1           +ab0
      abxy0=qdy*dxxdyypx0+wqy*dxxdyypx1          +2.d0*rayx1    
      abxz0=qdz*dxxdyypx0+wqz*dxxdyypx1                         
      abyx0=qdx*dxxdyypy0+wqx*dxxdyypy1+2.d0*xby1               
      abyy0=qdy*dxxdyypy0+wqy*dxxdyypy1          +2.d0*rayy1+ab0
      abyz0=qdz*dxxdyypy0+wqz*dxxdyypy1                         
      abzx0=qdx*dxxdyypz0+wqx*dxxdyypz1+2.d0*xbz1               
      abzy0=qdy*dxxdyypz0+wqy*dxxdyypz1          +2.d0*rayz1    
      abzz0=qdz*dxxdyypz0+wqz*dxxdyypz1                     +ab0
      acxx0=qdx*dxxdzzpx0+wqx*dxxdzzpx1+2.d0*xcx1           +ac0
      acxy0=qdy*dxxdzzpx0+wqy*dxxdzzpx1                         
      acxz0=qdz*dxxdzzpx0+wqz*dxxdzzpx1          +2.d0*razx1    
      acyx0=qdx*dxxdzzpy0+wqx*dxxdzzpy1+2.d0*xcy1               
      acyy0=qdy*dxxdzzpy0+wqy*dxxdzzpy1                     +ac0
      acyz0=qdz*dxxdzzpy0+wqz*dxxdzzpy1          +2.d0*razy1    
      aczx0=qdx*dxxdzzpz0+wqx*dxxdzzpz1+2.d0*xcz1               
      aczy0=qdy*dxxdzzpz0+wqy*dxxdzzpz1                         
      aczz0=qdz*dxxdzzpz0+wqz*dxxdzzpz1          +2.d0*razz1+ac0
      adxx0=qdx*dxxdyxpx0+wqx*dxxdyxpx1+2.d0*xdx1+     rayx1+ad0
      adxy0=qdy*dxxdyxpx0+wqy*dxxdyxpx1          +     raxx1    
      adxz0=qdz*dxxdyxpx0+wqz*dxxdyxpx1                         
      adyx0=qdx*dxxdyxpy0+wqx*dxxdyxpy1+2.d0*xdy1+     rayy1    
      adyy0=qdy*dxxdyxpy0+wqy*dxxdyxpy1          +     raxy1+ad0
      adyz0=qdz*dxxdyxpy0+wqz*dxxdyxpy1                         
      adzx0=qdx*dxxdyxpz0+wqx*dxxdyxpz1+2.d0*xdz1+     rayz1    
      adzy0=qdy*dxxdyxpz0+wqy*dxxdyxpz1          +     raxz1    
      adzz0=qdz*dxxdyxpz0+wqz*dxxdyxpz1                     +ad0
      aexx0=qdx*dxxdzxpx0+wqx*dxxdzxpx1+2.d0*xex1+     razx1+ae0
      aexy0=qdy*dxxdzxpx0+wqy*dxxdzxpx1                         
      aexz0=qdz*dxxdzxpx0+wqz*dxxdzxpx1          +     raxx1    
      aeyx0=qdx*dxxdzxpy0+wqx*dxxdzxpy1+2.d0*xey1+     razy1    
      aeyy0=qdy*dxxdzxpy0+wqy*dxxdzxpy1                     +ae0
      aeyz0=qdz*dxxdzxpy0+wqz*dxxdzxpy1          +     raxy1    
      aezx0=qdx*dxxdzxpz0+wqx*dxxdzxpz1+2.d0*xez1+     razz1    
      aezy0=qdy*dxxdzxpz0+wqy*dxxdzxpz1                         
      aezz0=qdz*dxxdzxpz0+wqz*dxxdzxpz1          +     raxz1+ae0
      afxx0=qdx*dxxdzypx0+wqx*dxxdzypx1+2.d0*xfx1           +af0
      afxy0=qdy*dxxdzypx0+wqy*dxxdzypx1          +     razx1    
      afxz0=qdz*dxxdzypx0+wqz*dxxdzypx1          +     rayx1    
      afyx0=qdx*dxxdzypy0+wqx*dxxdzypy1+2.d0*xfy1               
      afyy0=qdy*dxxdzypy0+wqy*dxxdzypy1          +     razy1+af0
      afyz0=qdz*dxxdzypy0+wqz*dxxdzypy1          +     rayy1    
      afzx0=qdx*dxxdzypz0+wqx*dxxdzypz1+2.d0*xfz1               
      afzy0=qdy*dxxdzypz0+wqy*dxxdzypz1          +     razz1    
      afzz0=qdz*dxxdzypz0+wqz*dxxdzypz1          +     rayz1+af0
      baxx0=qdx*dyydxxpx0+wqx*dyydxxpx1          +2.d0*rbxx1+ba0
      baxy0=qdy*dyydxxpx0+wqy*dyydxxpx1+2.d0*yax1               
      baxz0=qdz*dyydxxpx0+wqz*dyydxxpx1                         
      bayx0=qdx*dyydxxpy0+wqx*dyydxxpy1          +2.d0*rbxy1    
      bayy0=qdy*dyydxxpy0+wqy*dyydxxpy1+2.d0*yay1           +ba0
      bayz0=qdz*dyydxxpy0+wqz*dyydxxpy1                         
      bazx0=qdx*dyydxxpz0+wqx*dyydxxpz1          +2.d0*rbxz1    
      bazy0=qdy*dyydxxpz0+wqy*dyydxxpz1+2.d0*yaz1               
      bazz0=qdz*dyydxxpz0+wqz*dyydxxpz1                     +ba0
      bbxx0=qdx*dyydyypx0+wqx*dyydyypx1                     +bb0
      bbxy0=qdy*dyydyypx0+wqy*dyydyypx1+2.d0*ybx1+2.d0*rbyx1    
      bbxz0=qdz*dyydyypx0+wqz*dyydyypx1                         
      bbyx0=qdx*dyydyypy0+wqx*dyydyypy1                         
      bbyy0=qdy*dyydyypy0+wqy*dyydyypy1+2.d0*yby1+2.d0*rbyy1+bb0
      bbyz0=qdz*dyydyypy0+wqz*dyydyypy1                         
      bbzx0=qdx*dyydyypz0+wqx*dyydyypz1                         
      bbzy0=qdy*dyydyypz0+wqy*dyydyypz1+2.d0*ybz1+2.d0*rbyz1    
      bbzz0=qdz*dyydyypz0+wqz*dyydyypz1                     +bb0
      bcxx0=qdx*dyydzzpx0+wqx*dyydzzpx1                     +bc0
      bcxy0=qdy*dyydzzpx0+wqy*dyydzzpx1+2.d0*ycx1               
      bcxz0=qdz*dyydzzpx0+wqz*dyydzzpx1          +2.d0*rbzx1    
      bcyx0=qdx*dyydzzpy0+wqx*dyydzzpy1                         
      bcyy0=qdy*dyydzzpy0+wqy*dyydzzpy1+2.d0*ycy1           +bc0
      bcyz0=qdz*dyydzzpy0+wqz*dyydzzpy1          +2.d0*rbzy1    
      bczx0=qdx*dyydzzpz0+wqx*dyydzzpz1                         
      bczy0=qdy*dyydzzpz0+wqy*dyydzzpz1+2.d0*ycz1               
      bczz0=qdz*dyydzzpz0+wqz*dyydzzpz1          +2.d0*rbzz1+bc0
      bdxx0=qdx*dyydyxpx0+wqx*dyydyxpx1          +     rbyx1+bd0
      bdxy0=qdy*dyydyxpx0+wqy*dyydyxpx1+2.d0*ydx1+     rbxx1    
      bdxz0=qdz*dyydyxpx0+wqz*dyydyxpx1                         
      bdyx0=qdx*dyydyxpy0+wqx*dyydyxpy1          +     rbyy1    
      bdyy0=qdy*dyydyxpy0+wqy*dyydyxpy1+2.d0*ydy1+     rbxy1+bd0
      bdyz0=qdz*dyydyxpy0+wqz*dyydyxpy1                         
      bdzx0=qdx*dyydyxpz0+wqx*dyydyxpz1          +     rbyz1    
      bdzy0=qdy*dyydyxpz0+wqy*dyydyxpz1+2.d0*ydz1+     rbxz1    
      bdzz0=qdz*dyydyxpz0+wqz*dyydyxpz1                     +bd0
      bexx0=qdx*dyydzxpx0+wqx*dyydzxpx1          +     rbzx1+be0
      bexy0=qdy*dyydzxpx0+wqy*dyydzxpx1+2.d0*yex1               
      bexz0=qdz*dyydzxpx0+wqz*dyydzxpx1          +     rbxx1    
      beyx0=qdx*dyydzxpy0+wqx*dyydzxpy1          +     rbzy1    
      beyy0=qdy*dyydzxpy0+wqy*dyydzxpy1+2.d0*yey1           +be0
      beyz0=qdz*dyydzxpy0+wqz*dyydzxpy1          +     rbxy1    
      bezx0=qdx*dyydzxpz0+wqx*dyydzxpz1          +     rbzz1    
      bezy0=qdy*dyydzxpz0+wqy*dyydzxpz1+2.d0*yez1               
      bezz0=qdz*dyydzxpz0+wqz*dyydzxpz1          +     rbxz1+be0
      bfxx0=qdx*dyydzypx0+wqx*dyydzypx1                     +bf0
      bfxy0=qdy*dyydzypx0+wqy*dyydzypx1+2.d0*yfx1+     rbzx1    
      bfxz0=qdz*dyydzypx0+wqz*dyydzypx1          +     rbyx1    
      bfyx0=qdx*dyydzypy0+wqx*dyydzypy1                         
      bfyy0=qdy*dyydzypy0+wqy*dyydzypy1+2.d0*yfy1+     rbzy1+bf0
      bfyz0=qdz*dyydzypy0+wqz*dyydzypy1          +     rbyy1    
      bfzx0=qdx*dyydzypz0+wqx*dyydzypz1                         
      bfzy0=qdy*dyydzypz0+wqy*dyydzypz1+2.d0*yfz1+     rbzz1    
      bfzz0=qdz*dyydzypz0+wqz*dyydzypz1          +     rbyz1+bf0
      caxx0=qdx*dzzdxxpx0+wqx*dzzdxxpx1          +2.d0*rcxx1+ca0
      caxy0=qdy*dzzdxxpx0+wqy*dzzdxxpx1                         
      caxz0=qdz*dzzdxxpx0+wqz*dzzdxxpx1+2.d0*zax1               
      cayx0=qdx*dzzdxxpy0+wqx*dzzdxxpy1          +2.d0*rcxy1    
      cayy0=qdy*dzzdxxpy0+wqy*dzzdxxpy1                     +ca0
      cayz0=qdz*dzzdxxpy0+wqz*dzzdxxpy1+2.d0*zay1               
      cazx0=qdx*dzzdxxpz0+wqx*dzzdxxpz1          +2.d0*rcxz1    
      cazy0=qdy*dzzdxxpz0+wqy*dzzdxxpz1                         
      cazz0=qdz*dzzdxxpz0+wqz*dzzdxxpz1+2.d0*zaz1           +ca0
      cbxx0=qdx*dzzdyypx0+wqx*dzzdyypx1                     +cb0
      cbxy0=qdy*dzzdyypx0+wqy*dzzdyypx1          +2.d0*rcyx1    
      cbxz0=qdz*dzzdyypx0+wqz*dzzdyypx1+2.d0*zbx1               
      cbyx0=qdx*dzzdyypy0+wqx*dzzdyypy1                         
      cbyy0=qdy*dzzdyypy0+wqy*dzzdyypy1          +2.d0*rcyy1+cb0
      cbyz0=qdz*dzzdyypy0+wqz*dzzdyypy1+2.d0*zby1               
      cbzx0=qdx*dzzdyypz0+wqx*dzzdyypz1                         
      cbzy0=qdy*dzzdyypz0+wqy*dzzdyypz1          +2.d0*rcyz1    
      cbzz0=qdz*dzzdyypz0+wqz*dzzdyypz1+2.d0*zbz1           +cb0
      ccxx0=qdx*dzzdzzpx0+wqx*dzzdzzpx1                     +cc0
      ccxy0=qdy*dzzdzzpx0+wqy*dzzdzzpx1                         
      ccxz0=qdz*dzzdzzpx0+wqz*dzzdzzpx1+2.d0*zcx1+2.d0*rczx1    
      ccyx0=qdx*dzzdzzpy0+wqx*dzzdzzpy1                         
      ccyy0=qdy*dzzdzzpy0+wqy*dzzdzzpy1                     +cc0
      ccyz0=qdz*dzzdzzpy0+wqz*dzzdzzpy1+2.d0*zcy1+2.d0*rczy1    
      cczx0=qdx*dzzdzzpz0+wqx*dzzdzzpz1                         
      cczy0=qdy*dzzdzzpz0+wqy*dzzdzzpz1                         
      cczz0=qdz*dzzdzzpz0+wqz*dzzdzzpz1+2.d0*zcz1+2.d0*rczz1+cc0
      cdxx0=qdx*dzzdyxpx0+wqx*dzzdyxpx1          +     rcyx1+cd0
      cdxy0=qdy*dzzdyxpx0+wqy*dzzdyxpx1          +     rcxx1    
      cdxz0=qdz*dzzdyxpx0+wqz*dzzdyxpx1+2.d0*zdx1               
      cdyx0=qdx*dzzdyxpy0+wqx*dzzdyxpy1          +     rcyy1    
      cdyy0=qdy*dzzdyxpy0+wqy*dzzdyxpy1          +     rcxy1+cd0
      cdyz0=qdz*dzzdyxpy0+wqz*dzzdyxpy1+2.d0*zdy1               
      cdzx0=qdx*dzzdyxpz0+wqx*dzzdyxpz1          +     rcyz1    
      cdzy0=qdy*dzzdyxpz0+wqy*dzzdyxpz1          +     rcxz1    
      cdzz0=qdz*dzzdyxpz0+wqz*dzzdyxpz1+2.d0*zdz1           +cd0
      cexx0=qdx*dzzdzxpx0+wqx*dzzdzxpx1          +     rczx1+ce0
      cexy0=qdy*dzzdzxpx0+wqy*dzzdzxpx1                         
      cexz0=qdz*dzzdzxpx0+wqz*dzzdzxpx1+2.d0*zex1+     rcxx1    
      ceyx0=qdx*dzzdzxpy0+wqx*dzzdzxpy1          +     rczy1    
      ceyy0=qdy*dzzdzxpy0+wqy*dzzdzxpy1                     +ce0
      ceyz0=qdz*dzzdzxpy0+wqz*dzzdzxpy1+2.d0*zey1+     rcxy1    
      cezx0=qdx*dzzdzxpz0+wqx*dzzdzxpz1          +     rczz1    
      cezy0=qdy*dzzdzxpz0+wqy*dzzdzxpz1                         
      cezz0=qdz*dzzdzxpz0+wqz*dzzdzxpz1+2.d0*zez1+     rcxz1+ce0
      cfxx0=qdx*dzzdzypx0+wqx*dzzdzypx1                     +cf0
      cfxy0=qdy*dzzdzypx0+wqy*dzzdzypx1          +     rczx1    
      cfxz0=qdz*dzzdzypx0+wqz*dzzdzypx1+2.d0*zfx1+     rcyx1    
      cfyx0=qdx*dzzdzypy0+wqx*dzzdzypy1                         
      cfyy0=qdy*dzzdzypy0+wqy*dzzdzypy1          +     rczy1+cf0
      cfyz0=qdz*dzzdzypy0+wqz*dzzdzypy1+2.d0*zfy1+     rcyy1    
      cfzx0=qdx*dzzdzypz0+wqx*dzzdzypz1                         
      cfzy0=qdy*dzzdzypz0+wqy*dzzdzypz1          +     rczz1    
      cfzz0=qdz*dzzdzypz0+wqz*dzzdzypz1+2.d0*zfz1+     rcyz1+cf0
      daxx0=qdx*dyxdxxpx0+wqx*dyxdxxpx1+     yax1+2.d0*rdxx1+da0
      daxy0=qdy*dyxdxxpx0+wqy*dyxdxxpx1+     xax1               
      daxz0=qdz*dyxdxxpx0+wqz*dyxdxxpx1                         
      dayx0=qdx*dyxdxxpy0+wqx*dyxdxxpy1+     yay1+2.d0*rdxy1    
      dayy0=qdy*dyxdxxpy0+wqy*dyxdxxpy1+     xay1           +da0
      dayz0=qdz*dyxdxxpy0+wqz*dyxdxxpy1                         
      dazx0=qdx*dyxdxxpz0+wqx*dyxdxxpz1+     yaz1+2.d0*rdxz1    
      dazy0=qdy*dyxdxxpz0+wqy*dyxdxxpz1+     xaz1               
      dazz0=qdz*dyxdxxpz0+wqz*dyxdxxpz1                     +da0
      dbxx0=qdx*dyxdyypx0+wqx*dyxdyypx1+     ybx1           +db0
      dbxy0=qdy*dyxdyypx0+wqy*dyxdyypx1+     xbx1+2.d0*rdyx1    
      dbxz0=qdz*dyxdyypx0+wqz*dyxdyypx1                         
      dbyx0=qdx*dyxdyypy0+wqx*dyxdyypy1+     yby1               
      dbyy0=qdy*dyxdyypy0+wqy*dyxdyypy1+     xby1+2.d0*rdyy1+db0
      dbyz0=qdz*dyxdyypy0+wqz*dyxdyypy1                         
      dbzx0=qdx*dyxdyypz0+wqx*dyxdyypz1+     ybz1               
      dbzy0=qdy*dyxdyypz0+wqy*dyxdyypz1+     xbz1+2.d0*rdyz1    
      dbzz0=qdz*dyxdyypz0+wqz*dyxdyypz1                     +db0
      dcxx0=qdx*dyxdzzpx0+wqx*dyxdzzpx1+     ycx1           +dc0
      dcxy0=qdy*dyxdzzpx0+wqy*dyxdzzpx1+     xcx1               
      dcxz0=qdz*dyxdzzpx0+wqz*dyxdzzpx1          +2.d0*rdzx1    
      dcyx0=qdx*dyxdzzpy0+wqx*dyxdzzpy1+     ycy1               
      dcyy0=qdy*dyxdzzpy0+wqy*dyxdzzpy1+     xcy1           +dc0
      dcyz0=qdz*dyxdzzpy0+wqz*dyxdzzpy1          +2.d0*rdzy1    
      dczx0=qdx*dyxdzzpz0+wqx*dyxdzzpz1+     ycz1               
      dczy0=qdy*dyxdzzpz0+wqy*dyxdzzpz1+     xcz1               
      dczz0=qdz*dyxdzzpz0+wqz*dyxdzzpz1          +2.d0*rdzz1+dc0
      ddxx0=qdx*dyxdyxpx0+wqx*dyxdyxpx1+     ydx1+     rdyx1+dd0
      ddxy0=qdy*dyxdyxpx0+wqy*dyxdyxpx1+     xdx1+     rdxx1    
      ddxz0=qdz*dyxdyxpx0+wqz*dyxdyxpx1                         
      ddyx0=qdx*dyxdyxpy0+wqx*dyxdyxpy1+     ydy1+     rdyy1    
      ddyy0=qdy*dyxdyxpy0+wqy*dyxdyxpy1+     xdy1+     rdxy1+dd0
      ddyz0=qdz*dyxdyxpy0+wqz*dyxdyxpy1                         
      ddzx0=qdx*dyxdyxpz0+wqx*dyxdyxpz1+     ydz1+     rdyz1    
      ddzy0=qdy*dyxdyxpz0+wqy*dyxdyxpz1+     xdz1+     rdxz1    
      ddzz0=qdz*dyxdyxpz0+wqz*dyxdyxpz1                     +dd0
      dexx0=qdx*dyxdzxpx0+wqx*dyxdzxpx1+     yex1+     rdzx1+de0
      dexy0=qdy*dyxdzxpx0+wqy*dyxdzxpx1+     xex1               
      dexz0=qdz*dyxdzxpx0+wqz*dyxdzxpx1          +     rdxx1    
      deyx0=qdx*dyxdzxpy0+wqx*dyxdzxpy1+     yey1+     rdzy1    
      deyy0=qdy*dyxdzxpy0+wqy*dyxdzxpy1+     xey1           +de0
      deyz0=qdz*dyxdzxpy0+wqz*dyxdzxpy1          +     rdxy1    
      dezx0=qdx*dyxdzxpz0+wqx*dyxdzxpz1+     yez1+     rdzz1    
      dezy0=qdy*dyxdzxpz0+wqy*dyxdzxpz1+     xez1               
      dezz0=qdz*dyxdzxpz0+wqz*dyxdzxpz1          +     rdxz1+de0
      dfxx0=qdx*dyxdzypx0+wqx*dyxdzypx1+     yfx1           +df0
      dfxy0=qdy*dyxdzypx0+wqy*dyxdzypx1+     xfx1+     rdzx1    
      dfxz0=qdz*dyxdzypx0+wqz*dyxdzypx1          +     rdyx1    
      dfyx0=qdx*dyxdzypy0+wqx*dyxdzypy1+     yfy1               
      dfyy0=qdy*dyxdzypy0+wqy*dyxdzypy1+     xfy1+     rdzy1+df0
      dfyz0=qdz*dyxdzypy0+wqz*dyxdzypy1          +     rdyy1    
      dfzx0=qdx*dyxdzypz0+wqx*dyxdzypz1+     yfz1               
      dfzy0=qdy*dyxdzypz0+wqy*dyxdzypz1+     xfz1+     rdzz1    
      dfzz0=qdz*dyxdzypz0+wqz*dyxdzypz1          +     rdyz1+df0
      eaxx0=qdx*dzxdxxpx0+wqx*dzxdxxpx1+     zax1+2.d0*rexx1+ea0
      eaxy0=qdy*dzxdxxpx0+wqy*dzxdxxpx1                         
      eaxz0=qdz*dzxdxxpx0+wqz*dzxdxxpx1+     xax1               
      eayx0=qdx*dzxdxxpy0+wqx*dzxdxxpy1+     zay1+2.d0*rexy1    
      eayy0=qdy*dzxdxxpy0+wqy*dzxdxxpy1                     +ea0
      eayz0=qdz*dzxdxxpy0+wqz*dzxdxxpy1+     xay1               
      eazx0=qdx*dzxdxxpz0+wqx*dzxdxxpz1+     zaz1+2.d0*rexz1    
      eazy0=qdy*dzxdxxpz0+wqy*dzxdxxpz1                         
      eazz0=qdz*dzxdxxpz0+wqz*dzxdxxpz1+     xaz1           +ea0
      ebxx0=qdx*dzxdyypx0+wqx*dzxdyypx1+     zbx1           +eb0
      ebxy0=qdy*dzxdyypx0+wqy*dzxdyypx1          +2.d0*reyx1    
      ebxz0=qdz*dzxdyypx0+wqz*dzxdyypx1+     xbx1               
      ebyx0=qdx*dzxdyypy0+wqx*dzxdyypy1+     zby1               
      ebyy0=qdy*dzxdyypy0+wqy*dzxdyypy1          +2.d0*reyy1+eb0
      ebyz0=qdz*dzxdyypy0+wqz*dzxdyypy1+     xby1               
      ebzx0=qdx*dzxdyypz0+wqx*dzxdyypz1+     zbz1               
      ebzy0=qdy*dzxdyypz0+wqy*dzxdyypz1          +2.d0*reyz1    
      ebzz0=qdz*dzxdyypz0+wqz*dzxdyypz1+     xbz1           +eb0
      ecxx0=qdx*dzxdzzpx0+wqx*dzxdzzpx1+     zcx1           +ec0
      ecxy0=qdy*dzxdzzpx0+wqy*dzxdzzpx1                         
      ecxz0=qdz*dzxdzzpx0+wqz*dzxdzzpx1+     xcx1+2.d0*rezx1    
      ecyx0=qdx*dzxdzzpy0+wqx*dzxdzzpy1+     zcy1               
      ecyy0=qdy*dzxdzzpy0+wqy*dzxdzzpy1                     +ec0
      ecyz0=qdz*dzxdzzpy0+wqz*dzxdzzpy1+     xcy1+2.d0*rezy1    
      eczx0=qdx*dzxdzzpz0+wqx*dzxdzzpz1+     zcz1               
      eczy0=qdy*dzxdzzpz0+wqy*dzxdzzpz1                         
      eczz0=qdz*dzxdzzpz0+wqz*dzxdzzpz1+     xcz1+2.d0*rezz1+ec0
      edxx0=qdx*dzxdyxpx0+wqx*dzxdyxpx1+     zdx1+     reyx1+ed0
      edxy0=qdy*dzxdyxpx0+wqy*dzxdyxpx1          +     rexx1    
      edxz0=qdz*dzxdyxpx0+wqz*dzxdyxpx1+     xdx1               
      edyx0=qdx*dzxdyxpy0+wqx*dzxdyxpy1+     zdy1+     reyy1    
      edyy0=qdy*dzxdyxpy0+wqy*dzxdyxpy1          +     rexy1+ed0
      edyz0=qdz*dzxdyxpy0+wqz*dzxdyxpy1+     xdy1               
      edzx0=qdx*dzxdyxpz0+wqx*dzxdyxpz1+     zdz1+     reyz1    
      edzy0=qdy*dzxdyxpz0+wqy*dzxdyxpz1          +     rexz1    
      edzz0=qdz*dzxdyxpz0+wqz*dzxdyxpz1+     xdz1           +ed0
      eexx0=qdx*dzxdzxpx0+wqx*dzxdzxpx1+     zex1+     rezx1+ee0
      eexy0=qdy*dzxdzxpx0+wqy*dzxdzxpx1                         
      eexz0=qdz*dzxdzxpx0+wqz*dzxdzxpx1+     xex1+     rexx1    
      eeyx0=qdx*dzxdzxpy0+wqx*dzxdzxpy1+     zey1+     rezy1    
      eeyy0=qdy*dzxdzxpy0+wqy*dzxdzxpy1                     +ee0
      eeyz0=qdz*dzxdzxpy0+wqz*dzxdzxpy1+     xey1+     rexy1    
      eezx0=qdx*dzxdzxpz0+wqx*dzxdzxpz1+     zez1+     rezz1    
      eezy0=qdy*dzxdzxpz0+wqy*dzxdzxpz1                         
      eezz0=qdz*dzxdzxpz0+wqz*dzxdzxpz1+     xez1+     rexz1+ee0
      efxx0=qdx*dzxdzypx0+wqx*dzxdzypx1+     zfx1           +ef0
      efxy0=qdy*dzxdzypx0+wqy*dzxdzypx1          +     rezx1    
      efxz0=qdz*dzxdzypx0+wqz*dzxdzypx1+     xfx1+     reyx1    
      efyx0=qdx*dzxdzypy0+wqx*dzxdzypy1+     zfy1               
      efyy0=qdy*dzxdzypy0+wqy*dzxdzypy1          +     rezy1+ef0
      efyz0=qdz*dzxdzypy0+wqz*dzxdzypy1+     xfy1+     reyy1    
      efzx0=qdx*dzxdzypz0+wqx*dzxdzypz1+     zfz1               
      efzy0=qdy*dzxdzypz0+wqy*dzxdzypz1          +     rezz1    
      efzz0=qdz*dzxdzypz0+wqz*dzxdzypz1+1.d0*xfz1+     reyz1+ef0
      faxx0=qdx*dzydxxpx0+wqx*dzydxxpx1          +2.d0*rfxx1+fa0
      faxy0=qdy*dzydxxpx0+wqy*dzydxxpx1+     zax1               
      faxz0=qdz*dzydxxpx0+wqz*dzydxxpx1+     yax1               
      fayx0=qdx*dzydxxpy0+wqx*dzydxxpy1          +2.d0*rfxy1    
      fayy0=qdy*dzydxxpy0+wqy*dzydxxpy1+     zay1           +fa0
      fayz0=qdz*dzydxxpy0+wqz*dzydxxpy1+     yay1               
      fazx0=qdx*dzydxxpz0+wqx*dzydxxpz1          +2.d0*rfxz1    
      fazy0=qdy*dzydxxpz0+wqy*dzydxxpz1+     zaz1               
      fazz0=qdz*dzydxxpz0+wqz*dzydxxpz1+     yaz1           +fa0
      fbxx0=qdx*dzydyypx0+wqx*dzydyypx1                     +fb0
      fbxy0=qdy*dzydyypx0+wqy*dzydyypx1+     zbx1+2.d0*rfyx1    
      fbxz0=qdz*dzydyypx0+wqz*dzydyypx1+     ybx1               
      fbyx0=qdx*dzydyypy0+wqx*dzydyypy1                         
      fbyy0=qdy*dzydyypy0+wqy*dzydyypy1+     zby1+2.d0*rfyy1+fb0
      fbyz0=qdz*dzydyypy0+wqz*dzydyypy1+     yby1               
      fbzx0=qdx*dzydyypz0+wqx*dzydyypz1                         
      fbzy0=qdy*dzydyypz0+wqy*dzydyypz1+     zbz1+2.d0*rfyz1    
      fbzz0=qdz*dzydyypz0+wqz*dzydyypz1+     ybz1           +fb0
      fcxx0=qdx*dzydzzpx0+wqx*dzydzzpx1                     +fc0
      fcxy0=qdy*dzydzzpx0+wqy*dzydzzpx1+     zcx1               
      fcxz0=qdz*dzydzzpx0+wqz*dzydzzpx1+     ycx1+2.d0*rfzx1    
      fcyx0=qdx*dzydzzpy0+wqx*dzydzzpy1                         
      fcyy0=qdy*dzydzzpy0+wqy*dzydzzpy1+     zcy1           +fc0
      fcyz0=qdz*dzydzzpy0+wqz*dzydzzpy1+     ycy1+2.d0*rfzy1    
      fczx0=qdx*dzydzzpz0+wqx*dzydzzpz1                         
      fczy0=qdy*dzydzzpz0+wqy*dzydzzpz1+     zcz1               
      fczz0=qdz*dzydzzpz0+wqz*dzydzzpz1+     ycz1+2.d0*rfzz1+fc0
      fdxx0=qdx*dzydyxpx0+wqx*dzydyxpx1          +     rfyx1+fd0
      fdxy0=qdy*dzydyxpx0+wqy*dzydyxpx1+     zdx1+     rfxx1    
      fdxz0=qdz*dzydyxpx0+wqz*dzydyxpx1+     ydx1               
      fdyx0=qdx*dzydyxpy0+wqx*dzydyxpy1          +     rfyy1    
      fdyy0=qdy*dzydyxpy0+wqy*dzydyxpy1+     zdy1+     rfxy1+fd0
      fdyz0=qdz*dzydyxpy0+wqz*dzydyxpy1+     ydy1               
      fdzx0=qdx*dzydyxpz0+wqx*dzydyxpz1          +     rfyz1    
      fdzy0=qdy*dzydyxpz0+wqy*dzydyxpz1+     zdz1+     rfxz1    
      fdzz0=qdz*dzydyxpz0+wqz*dzydyxpz1+     ydz1           +fd0
      fexx0=qdx*dzydzxpx0+wqx*dzydzxpx1          +     rfzx1+fe0
      fexy0=qdy*dzydzxpx0+wqy*dzydzxpx1+     zex1               
      fexz0=qdz*dzydzxpx0+wqz*dzydzxpx1+     yex1+     rfxx1    
      feyx0=qdx*dzydzxpy0+wqx*dzydzxpy1          +     rfzy1    
      feyy0=qdy*dzydzxpy0+wqy*dzydzxpy1+     zey1           +fe0
      feyz0=qdz*dzydzxpy0+wqz*dzydzxpy1+     yey1+     rfxy1    
      fezx0=qdx*dzydzxpz0+wqx*dzydzxpz1          +     rfzz1    
      fezy0=qdy*dzydzxpz0+wqy*dzydzxpz1+     zez1               
      fezz0=qdz*dzydzxpz0+wqz*dzydzxpz1+     yez1+     rfxz1+fe0
      ffxx0=qdx*dzydzypx0+wqx*dzydzypx1                     +ff0
      ffxy0=qdy*dzydzypx0+wqy*dzydzypx1+     zfx1+     rfzx1    
      ffxz0=qdz*dzydzypx0+wqz*dzydzypx1+     yfx1+     rfyx1    
      ffyx0=qdx*dzydzypy0+wqx*dzydzypy1                         
      ffyy0=qdy*dzydzypy0+wqy*dzydzypy1+     zfy1+     rfzy1+ff0
      ffyz0=qdz*dzydzypy0+wqz*dzydzypy1+     yfy1+     rfyy1    
      ffzx0=qdx*dzydzypz0+wqx*dzydzypz1                         
      ffzy0=qdy*dzydzypz0+wqy*dzydzypz1+     zfz1+     rfzz1
      ffzz0=qdz*dzydzypz0+wqz*dzydzypz1+     yfz1+     rfyz1+ff0      

      aaxx1=qdx*dxxdxxpx1+wqx*dxxdxxpx2+2.d0*xax2+2.d0*raxx2+aa1
      aaxy1=qdy*dxxdxxpx1+wqy*dxxdxxpx2                         
      aaxz1=qdz*dxxdxxpx1+wqz*dxxdxxpx2                         
      aayx1=qdx*dxxdxxpy1+wqx*dxxdxxpy2+2.d0*xay2+2.d0*raxy2    
      aayy1=qdy*dxxdxxpy1+wqy*dxxdxxpy2                     +aa1
      aayz1=qdz*dxxdxxpy1+wqz*dxxdxxpy2                         
      aazx1=qdx*dxxdxxpz1+wqx*dxxdxxpz2+2.d0*xaz2+2.d0*raxz2    
      aazy1=qdy*dxxdxxpz1+wqy*dxxdxxpz2                         
      aazz1=qdz*dxxdxxpz1+wqz*dxxdxxpz2                     +aa1
      abxx1=qdx*dxxdyypx1+wqx*dxxdyypx2+2.d0*xbx2           +ab1
      abxy1=qdy*dxxdyypx1+wqy*dxxdyypx2          +2.d0*rayx2    
      abxz1=qdz*dxxdyypx1+wqz*dxxdyypx2                         
      abyx1=qdx*dxxdyypy1+wqx*dxxdyypy2+2.d0*xby2               
      abyy1=qdy*dxxdyypy1+wqy*dxxdyypy2          +2.d0*rayy2+ab1
      abyz1=qdz*dxxdyypy1+wqz*dxxdyypy2                         
      abzx1=qdx*dxxdyypz1+wqx*dxxdyypz2+2.d0*xbz2               
      abzy1=qdy*dxxdyypz1+wqy*dxxdyypz2          +2.d0*rayz2    
      abzz1=qdz*dxxdyypz1+wqz*dxxdyypz2                     +ab1
      acxx1=qdx*dxxdzzpx1+wqx*dxxdzzpx2+2.d0*xcx2           +ac1
      acxy1=qdy*dxxdzzpx1+wqy*dxxdzzpx2                         
      acxz1=qdz*dxxdzzpx1+wqz*dxxdzzpx2          +2.d0*razx2    
      acyx1=qdx*dxxdzzpy1+wqx*dxxdzzpy2+2.d0*xcy2               
      acyy1=qdy*dxxdzzpy1+wqy*dxxdzzpy2                     +ac1
      acyz1=qdz*dxxdzzpy1+wqz*dxxdzzpy2          +2.d0*razy2    
      aczx1=qdx*dxxdzzpz1+wqx*dxxdzzpz2+2.d0*xcz2               
      aczy1=qdy*dxxdzzpz1+wqy*dxxdzzpz2                         
      aczz1=qdz*dxxdzzpz1+wqz*dxxdzzpz2          +2.d0*razz2+ac1
      adxx1=qdx*dxxdyxpx1+wqx*dxxdyxpx2+2.d0*xdx2+     rayx2+ad1
      adxy1=qdy*dxxdyxpx1+wqy*dxxdyxpx2          +     raxx2    
      adxz1=qdz*dxxdyxpx1+wqz*dxxdyxpx2                         
      adyx1=qdx*dxxdyxpy1+wqx*dxxdyxpy2+2.d0*xdy2+     rayy2    
      adyy1=qdy*dxxdyxpy1+wqy*dxxdyxpy2          +     raxy2+ad1
      adyz1=qdz*dxxdyxpy1+wqz*dxxdyxpy2                         
      adzx1=qdx*dxxdyxpz1+wqx*dxxdyxpz2+2.d0*xdz2+     rayz2    
      adzy1=qdy*dxxdyxpz1+wqy*dxxdyxpz2          +     raxz2    
      adzz1=qdz*dxxdyxpz1+wqz*dxxdyxpz2                     +ad1
      aexx1=qdx*dxxdzxpx1+wqx*dxxdzxpx2+2.d0*xex2+     razx2+ae1
      aexy1=qdy*dxxdzxpx1+wqy*dxxdzxpx2                         
      aexz1=qdz*dxxdzxpx1+wqz*dxxdzxpx2          +     raxx2    
      aeyx1=qdx*dxxdzxpy1+wqx*dxxdzxpy2+2.d0*xey2+     razy2    
      aeyy1=qdy*dxxdzxpy1+wqy*dxxdzxpy2                     +ae1
      aeyz1=qdz*dxxdzxpy1+wqz*dxxdzxpy2          +     raxy2    
      aezx1=qdx*dxxdzxpz1+wqx*dxxdzxpz2+2.d0*xez2+     razz2    
      aezy1=qdy*dxxdzxpz1+wqy*dxxdzxpz2                         
      aezz1=qdz*dxxdzxpz1+wqz*dxxdzxpz2          +     raxz2+ae1
      afxx1=qdx*dxxdzypx1+wqx*dxxdzypx2+2.d0*xfx2           +af1
      afxy1=qdy*dxxdzypx1+wqy*dxxdzypx2          +     razx2    
      afxz1=qdz*dxxdzypx1+wqz*dxxdzypx2          +     rayx2    
      afyx1=qdx*dxxdzypy1+wqx*dxxdzypy2+2.d0*xfy2               
      afyy1=qdy*dxxdzypy1+wqy*dxxdzypy2          +     razy2+af1
      afyz1=qdz*dxxdzypy1+wqz*dxxdzypy2          +     rayy2    
      afzx1=qdx*dxxdzypz1+wqx*dxxdzypz2+2.d0*xfz2               
      afzy1=qdy*dxxdzypz1+wqy*dxxdzypz2          +     razz2    
      afzz1=qdz*dxxdzypz1+wqz*dxxdzypz2          +     rayz2+af1
      baxx1=qdx*dyydxxpx1+wqx*dyydxxpx2          +2.d0*rbxx2+ba1
      baxy1=qdy*dyydxxpx1+wqy*dyydxxpx2+2.d0*yax2               
      baxz1=qdz*dyydxxpx1+wqz*dyydxxpx2                         
      bayx1=qdx*dyydxxpy1+wqx*dyydxxpy2          +2.d0*rbxy2    
      bayy1=qdy*dyydxxpy1+wqy*dyydxxpy2+2.d0*yay2           +ba1
      bayz1=qdz*dyydxxpy1+wqz*dyydxxpy2                         
      bazx1=qdx*dyydxxpz1+wqx*dyydxxpz2          +2.d0*rbxz2    
      bazy1=qdy*dyydxxpz1+wqy*dyydxxpz2+2.d0*yaz2               
      bazz1=qdz*dyydxxpz1+wqz*dyydxxpz2                     +ba1
      bbxx1=qdx*dyydyypx1+wqx*dyydyypx2                     +bb1
      bbxy1=qdy*dyydyypx1+wqy*dyydyypx2+2.d0*ybx2+2.d0*rbyx2    
      bbxz1=qdz*dyydyypx1+wqz*dyydyypx2                         
      bbyx1=qdx*dyydyypy1+wqx*dyydyypy2                         
      bbyy1=qdy*dyydyypy1+wqy*dyydyypy2+2.d0*yby2+2.d0*rbyy2+bb1
      bbyz1=qdz*dyydyypy1+wqz*dyydyypy2                         
      bbzx1=qdx*dyydyypz1+wqx*dyydyypz2                         
      bbzy1=qdy*dyydyypz1+wqy*dyydyypz2+2.d0*ybz2+2.d0*rbyz2    
      bbzz1=qdz*dyydyypz1+wqz*dyydyypz2                     +bb1
      bcxx1=qdx*dyydzzpx1+wqx*dyydzzpx2                     +bc1
      bcxy1=qdy*dyydzzpx1+wqy*dyydzzpx2+2.d0*ycx2               
      bcxz1=qdz*dyydzzpx1+wqz*dyydzzpx2          +2.d0*rbzx2    
      bcyx1=qdx*dyydzzpy1+wqx*dyydzzpy2                         
      bcyy1=qdy*dyydzzpy1+wqy*dyydzzpy2+2.d0*ycy2           +bc1
      bcyz1=qdz*dyydzzpy1+wqz*dyydzzpy2          +2.d0*rbzy2    
      bczx1=qdx*dyydzzpz1+wqx*dyydzzpz2                         
      bczy1=qdy*dyydzzpz1+wqy*dyydzzpz2+2.d0*ycz2               
      bczz1=qdz*dyydzzpz1+wqz*dyydzzpz2          +2.d0*rbzz2+bc1
      bdxx1=qdx*dyydyxpx1+wqx*dyydyxpx2          +     rbyx2+bd1
      bdxy1=qdy*dyydyxpx1+wqy*dyydyxpx2+2.d0*ydx2+     rbxx2    
      bdxz1=qdz*dyydyxpx1+wqz*dyydyxpx2                         
      bdyx1=qdx*dyydyxpy1+wqx*dyydyxpy2          +     rbyy2    
      bdyy1=qdy*dyydyxpy1+wqy*dyydyxpy2+2.d0*ydy2+     rbxy2+bd1
      bdyz1=qdz*dyydyxpy1+wqz*dyydyxpy2                         
      bdzx1=qdx*dyydyxpz1+wqx*dyydyxpz2          +     rbyz2    
      bdzy1=qdy*dyydyxpz1+wqy*dyydyxpz2+2.d0*ydz2+     rbxz2    
      bdzz1=qdz*dyydyxpz1+wqz*dyydyxpz2                     +bd1
      bexx1=qdx*dyydzxpx1+wqx*dyydzxpx2          +     rbzx2+be1
      bexy1=qdy*dyydzxpx1+wqy*dyydzxpx2+2.d0*yex2               
      bexz1=qdz*dyydzxpx1+wqz*dyydzxpx2          +     rbxx2    
      beyx1=qdx*dyydzxpy1+wqx*dyydzxpy2          +     rbzy2    
      beyy1=qdy*dyydzxpy1+wqy*dyydzxpy2+2.d0*yey2           +be1
      beyz1=qdz*dyydzxpy1+wqz*dyydzxpy2          +     rbxy2    
      bezx1=qdx*dyydzxpz1+wqx*dyydzxpz2          +     rbzz2    
      bezy1=qdy*dyydzxpz1+wqy*dyydzxpz2+2.d0*yez2               
      bezz1=qdz*dyydzxpz1+wqz*dyydzxpz2          +     rbxz2+be1
      bfxx1=qdx*dyydzypx1+wqx*dyydzypx2                     +bf1
      bfxy1=qdy*dyydzypx1+wqy*dyydzypx2+2.d0*yfx2+     rbzx2    
      bfxz1=qdz*dyydzypx1+wqz*dyydzypx2          +     rbyx2    
      bfyx1=qdx*dyydzypy1+wqx*dyydzypy2                         
      bfyy1=qdy*dyydzypy1+wqy*dyydzypy2+2.d0*yfy2+     rbzy2+bf1
      bfyz1=qdz*dyydzypy1+wqz*dyydzypy2          +     rbyy2    
      bfzx1=qdx*dyydzypz1+wqx*dyydzypz2                         
      bfzy1=qdy*dyydzypz1+wqy*dyydzypz2+2.d0*yfz2+     rbzz2    
      bfzz1=qdz*dyydzypz1+wqz*dyydzypz2          +     rbyz2+bf1
      caxx1=qdx*dzzdxxpx1+wqx*dzzdxxpx2          +2.d0*rcxx2+ca1
      caxy1=qdy*dzzdxxpx1+wqy*dzzdxxpx2                         
      caxz1=qdz*dzzdxxpx1+wqz*dzzdxxpx2+2.d0*zax2               
      cayx1=qdx*dzzdxxpy1+wqx*dzzdxxpy2          +2.d0*rcxy2    
      cayy1=qdy*dzzdxxpy1+wqy*dzzdxxpy2                     +ca1
      cayz1=qdz*dzzdxxpy1+wqz*dzzdxxpy2+2.d0*zay2               
      cazx1=qdx*dzzdxxpz1+wqx*dzzdxxpz2          +2.d0*rcxz2    
      cazy1=qdy*dzzdxxpz1+wqy*dzzdxxpz2                         
      cazz1=qdz*dzzdxxpz1+wqz*dzzdxxpz2+2.d0*zaz2           +ca1
      cbxx1=qdx*dzzdyypx1+wqx*dzzdyypx2                     +cb1
      cbxy1=qdy*dzzdyypx1+wqy*dzzdyypx2          +2.d0*rcyx2    
      cbxz1=qdz*dzzdyypx1+wqz*dzzdyypx2+2.d0*zbx2               
      cbyx1=qdx*dzzdyypy1+wqx*dzzdyypy2                         
      cbyy1=qdy*dzzdyypy1+wqy*dzzdyypy2          +2.d0*rcyy2+cb1
      cbyz1=qdz*dzzdyypy1+wqz*dzzdyypy2+2.d0*zby2               
      cbzx1=qdx*dzzdyypz1+wqx*dzzdyypz2                         
      cbzy1=qdy*dzzdyypz1+wqy*dzzdyypz2          +2.d0*rcyz2    
      cbzz1=qdz*dzzdyypz1+wqz*dzzdyypz2+2.d0*zbz2           +cb1
      ccxx1=qdx*dzzdzzpx1+wqx*dzzdzzpx2                     +cc1
      ccxy1=qdy*dzzdzzpx1+wqy*dzzdzzpx2                         
      ccxz1=qdz*dzzdzzpx1+wqz*dzzdzzpx2+2.d0*zcx2+2.d0*rczx2    
      ccyx1=qdx*dzzdzzpy1+wqx*dzzdzzpy2                         
      ccyy1=qdy*dzzdzzpy1+wqy*dzzdzzpy2                     +cc1
      ccyz1=qdz*dzzdzzpy1+wqz*dzzdzzpy2+2.d0*zcy2+2.d0*rczy2    
      cczx1=qdx*dzzdzzpz1+wqx*dzzdzzpz2                         
      cczy1=qdy*dzzdzzpz1+wqy*dzzdzzpz2                         
      cczz1=qdz*dzzdzzpz1+wqz*dzzdzzpz2+2.d0*zcz2+2.d0*rczz2+cc1
      cdxx1=qdx*dzzdyxpx1+wqx*dzzdyxpx2          +     rcyx2+cd1
      cdxy1=qdy*dzzdyxpx1+wqy*dzzdyxpx2          +     rcxx2    
      cdxz1=qdz*dzzdyxpx1+wqz*dzzdyxpx2+2.d0*zdx2               
      cdyx1=qdx*dzzdyxpy1+wqx*dzzdyxpy2          +     rcyy2    
      cdyy1=qdy*dzzdyxpy1+wqy*dzzdyxpy2          +     rcxy2+cd1
      cdyz1=qdz*dzzdyxpy1+wqz*dzzdyxpy2+2.d0*zdy2               
      cdzx1=qdx*dzzdyxpz1+wqx*dzzdyxpz2          +     rcyz2    
      cdzy1=qdy*dzzdyxpz1+wqy*dzzdyxpz2          +     rcxz2    
      cdzz1=qdz*dzzdyxpz1+wqz*dzzdyxpz2+2.d0*zdz2           +cd1
      cexx1=qdx*dzzdzxpx1+wqx*dzzdzxpx2          +     rczx2+ce1
      cexy1=qdy*dzzdzxpx1+wqy*dzzdzxpx2                         
      cexz1=qdz*dzzdzxpx1+wqz*dzzdzxpx2+2.d0*zex2+     rcxx2    
      ceyx1=qdx*dzzdzxpy1+wqx*dzzdzxpy2          +     rczy2    
      ceyy1=qdy*dzzdzxpy1+wqy*dzzdzxpy2                     +ce1
      ceyz1=qdz*dzzdzxpy1+wqz*dzzdzxpy2+2.d0*zey2+     rcxy2    
      cezx1=qdx*dzzdzxpz1+wqx*dzzdzxpz2          +     rczz2    
      cezy1=qdy*dzzdzxpz1+wqy*dzzdzxpz2                         
      cezz1=qdz*dzzdzxpz1+wqz*dzzdzxpz2+2.d0*zez2+     rcxz2+ce1
      cfxx1=qdx*dzzdzypx1+wqx*dzzdzypx2                     +cf1
      cfxy1=qdy*dzzdzypx1+wqy*dzzdzypx2          +     rczx2    
      cfxz1=qdz*dzzdzypx1+wqz*dzzdzypx2+2.d0*zfx2+     rcyx2    
      cfyx1=qdx*dzzdzypy1+wqx*dzzdzypy2                         
      cfyy1=qdy*dzzdzypy1+wqy*dzzdzypy2          +     rczy2+cf1
      cfyz1=qdz*dzzdzypy1+wqz*dzzdzypy2+2.d0*zfy2+     rcyy2    
      cfzx1=qdx*dzzdzypz1+wqx*dzzdzypz2                         
      cfzy1=qdy*dzzdzypz1+wqy*dzzdzypz2          +     rczz2    
      cfzz1=qdz*dzzdzypz1+wqz*dzzdzypz2+2.d0*zfz2+     rcyz2+cf1
      daxx1=qdx*dyxdxxpx1+wqx*dyxdxxpx2+     yax2+2.d0*rdxx2+da1
      daxy1=qdy*dyxdxxpx1+wqy*dyxdxxpx2+     xax2               
      daxz1=qdz*dyxdxxpx1+wqz*dyxdxxpx2                         
      dayx1=qdx*dyxdxxpy1+wqx*dyxdxxpy2+     yay2+2.d0*rdxy2    
      dayy1=qdy*dyxdxxpy1+wqy*dyxdxxpy2+     xay2           +da1
      dayz1=qdz*dyxdxxpy1+wqz*dyxdxxpy2                         
      dazx1=qdx*dyxdxxpz1+wqx*dyxdxxpz2+     yaz2+2.d0*rdxz2    
      dazy1=qdy*dyxdxxpz1+wqy*dyxdxxpz2+     xaz2               
      dazz1=qdz*dyxdxxpz1+wqz*dyxdxxpz2                     +da1
      dbxx1=qdx*dyxdyypx1+wqx*dyxdyypx2+     ybx2           +db1
      dbxy1=qdy*dyxdyypx1+wqy*dyxdyypx2+     xbx2+2.d0*rdyx2    
      dbxz1=qdz*dyxdyypx1+wqz*dyxdyypx2                         
      dbyx1=qdx*dyxdyypy1+wqx*dyxdyypy2+     yby2               
      dbyy1=qdy*dyxdyypy1+wqy*dyxdyypy2+     xby2+2.d0*rdyy2+db1
      dbyz1=qdz*dyxdyypy1+wqz*dyxdyypy2                         
      dbzx1=qdx*dyxdyypz1+wqx*dyxdyypz2+     ybz2               
      dbzy1=qdy*dyxdyypz1+wqy*dyxdyypz2+     xbz2+2.d0*rdyz2    
      dbzz1=qdz*dyxdyypz1+wqz*dyxdyypz2                     +db1
      dcxx1=qdx*dyxdzzpx1+wqx*dyxdzzpx2+     ycx2           +dc1
      dcxy1=qdy*dyxdzzpx1+wqy*dyxdzzpx2+     xcx2               
      dcxz1=qdz*dyxdzzpx1+wqz*dyxdzzpx2          +2.d0*rdzx2    
      dcyx1=qdx*dyxdzzpy1+wqx*dyxdzzpy2+     ycy2               
      dcyy1=qdy*dyxdzzpy1+wqy*dyxdzzpy2+     xcy2           +dc1
      dcyz1=qdz*dyxdzzpy1+wqz*dyxdzzpy2          +2.d0*rdzy2    
      dczx1=qdx*dyxdzzpz1+wqx*dyxdzzpz2+     ycz2               
      dczy1=qdy*dyxdzzpz1+wqy*dyxdzzpz2+     xcz2               
      dczz1=qdz*dyxdzzpz1+wqz*dyxdzzpz2          +2.d0*rdzz2+dc1
      ddxx1=qdx*dyxdyxpx1+wqx*dyxdyxpx2+     ydx2+     rdyx2+dd1
      ddxy1=qdy*dyxdyxpx1+wqy*dyxdyxpx2+     xdx2+     rdxx2    
      ddxz1=qdz*dyxdyxpx1+wqz*dyxdyxpx2                         
      ddyx1=qdx*dyxdyxpy1+wqx*dyxdyxpy2+     ydy2+     rdyy2    
      ddyy1=qdy*dyxdyxpy1+wqy*dyxdyxpy2+     xdy2+     rdxy2+dd1
      ddyz1=qdz*dyxdyxpy1+wqz*dyxdyxpy2                         
      ddzx1=qdx*dyxdyxpz1+wqx*dyxdyxpz2+     ydz2+     rdyz2    
      ddzy1=qdy*dyxdyxpz1+wqy*dyxdyxpz2+     xdz2+     rdxz2    
      ddzz1=qdz*dyxdyxpz1+wqz*dyxdyxpz2                     +dd1
      dexx1=qdx*dyxdzxpx1+wqx*dyxdzxpx2+     yex2+     rdzx2+de1
      dexy1=qdy*dyxdzxpx1+wqy*dyxdzxpx2+     xex2               
      dexz1=qdz*dyxdzxpx1+wqz*dyxdzxpx2          +     rdxx2    
      deyx1=qdx*dyxdzxpy1+wqx*dyxdzxpy2+     yey2+     rdzy2    
      deyy1=qdy*dyxdzxpy1+wqy*dyxdzxpy2+     xey2           +de1
      deyz1=qdz*dyxdzxpy1+wqz*dyxdzxpy2          +     rdxy2    
      dezx1=qdx*dyxdzxpz1+wqx*dyxdzxpz2+     yez2+     rdzz2    
      dezy1=qdy*dyxdzxpz1+wqy*dyxdzxpz2+     xez2               
      dezz1=qdz*dyxdzxpz1+wqz*dyxdzxpz2          +     rdxz2+de1
      dfxx1=qdx*dyxdzypx1+wqx*dyxdzypx2+     yfx2           +df1
      dfxy1=qdy*dyxdzypx1+wqy*dyxdzypx2+     xfx2+     rdzx2    
      dfxz1=qdz*dyxdzypx1+wqz*dyxdzypx2          +     rdyx2    
      dfyx1=qdx*dyxdzypy1+wqx*dyxdzypy2+     yfy2               
      dfyy1=qdy*dyxdzypy1+wqy*dyxdzypy2+     xfy2+     rdzy2+df1
      dfyz1=qdz*dyxdzypy1+wqz*dyxdzypy2          +     rdyy2    
      dfzx1=qdx*dyxdzypz1+wqx*dyxdzypz2+     yfz2               
      dfzy1=qdy*dyxdzypz1+wqy*dyxdzypz2+     xfz2+     rdzz2    
      dfzz1=qdz*dyxdzypz1+wqz*dyxdzypz2          +     rdyz2+df1
      eaxx1=qdx*dzxdxxpx1+wqx*dzxdxxpx2+     zax2+2.d0*rexx2+ea1
      eaxy1=qdy*dzxdxxpx1+wqy*dzxdxxpx2                         
      eaxz1=qdz*dzxdxxpx1+wqz*dzxdxxpx2+     xax2               
      eayx1=qdx*dzxdxxpy1+wqx*dzxdxxpy2+     zay2+2.d0*rexy2    
      eayy1=qdy*dzxdxxpy1+wqy*dzxdxxpy2                     +ea1
      eayz1=qdz*dzxdxxpy1+wqz*dzxdxxpy2+     xay2               
      eazx1=qdx*dzxdxxpz1+wqx*dzxdxxpz2+     zaz2+2.d0*rexz2    
      eazy1=qdy*dzxdxxpz1+wqy*dzxdxxpz2                         
      eazz1=qdz*dzxdxxpz1+wqz*dzxdxxpz2+     xaz2           +ea1
      ebxx1=qdx*dzxdyypx1+wqx*dzxdyypx2+     zbx2           +eb1
      ebxy1=qdy*dzxdyypx1+wqy*dzxdyypx2          +2.d0*reyx2    
      ebxz1=qdz*dzxdyypx1+wqz*dzxdyypx2+     xbx2               
      ebyx1=qdx*dzxdyypy1+wqx*dzxdyypy2+     zby2               
      ebyy1=qdy*dzxdyypy1+wqy*dzxdyypy2          +2.d0*reyy2+eb1
      ebyz1=qdz*dzxdyypy1+wqz*dzxdyypy2+     xby2               
      ebzx1=qdx*dzxdyypz1+wqx*dzxdyypz2+     zbz2               
      ebzy1=qdy*dzxdyypz1+wqy*dzxdyypz2          +2.d0*reyz2    
      ebzz1=qdz*dzxdyypz1+wqz*dzxdyypz2+     xbz2           +eb1
      ecxx1=qdx*dzxdzzpx1+wqx*dzxdzzpx2+     zcx2           +ec1
      ecxy1=qdy*dzxdzzpx1+wqy*dzxdzzpx2                         
      ecxz1=qdz*dzxdzzpx1+wqz*dzxdzzpx2+     xcx2+2.d0*rezx2    
      ecyx1=qdx*dzxdzzpy1+wqx*dzxdzzpy2+     zcy2               
      ecyy1=qdy*dzxdzzpy1+wqy*dzxdzzpy2                     +ec1
      ecyz1=qdz*dzxdzzpy1+wqz*dzxdzzpy2+     xcy2+2.d0*rezy2    
      eczx1=qdx*dzxdzzpz1+wqx*dzxdzzpz2+     zcz2               
      eczy1=qdy*dzxdzzpz1+wqy*dzxdzzpz2                         
      eczz1=qdz*dzxdzzpz1+wqz*dzxdzzpz2+     xcz2+2.d0*rezz2+ec1
      edxx1=qdx*dzxdyxpx1+wqx*dzxdyxpx2+     zdx2+     reyx2+ed1
      edxy1=qdy*dzxdyxpx1+wqy*dzxdyxpx2          +     rexx2    
      edxz1=qdz*dzxdyxpx1+wqz*dzxdyxpx2+     xdx2               
      edyx1=qdx*dzxdyxpy1+wqx*dzxdyxpy2+     zdy2+     reyy2    
      edyy1=qdy*dzxdyxpy1+wqy*dzxdyxpy2          +     rexy2+ed1
      edyz1=qdz*dzxdyxpy1+wqz*dzxdyxpy2+     xdy2               
      edzx1=qdx*dzxdyxpz1+wqx*dzxdyxpz2+     zdz2+     reyz2    
      edzy1=qdy*dzxdyxpz1+wqy*dzxdyxpz2          +     rexz2    
      edzz1=qdz*dzxdyxpz1+wqz*dzxdyxpz2+     xdz2           +ed1
      eexx1=qdx*dzxdzxpx1+wqx*dzxdzxpx2+     zex2+     rezx2+ee1
      eexy1=qdy*dzxdzxpx1+wqy*dzxdzxpx2                         
      eexz1=qdz*dzxdzxpx1+wqz*dzxdzxpx2+     xex2+     rexx2    
      eeyx1=qdx*dzxdzxpy1+wqx*dzxdzxpy2+     zey2+     rezy2    
      eeyy1=qdy*dzxdzxpy1+wqy*dzxdzxpy2                     +ee1
      eeyz1=qdz*dzxdzxpy1+wqz*dzxdzxpy2+     xey2+     rexy2    
      eezx1=qdx*dzxdzxpz1+wqx*dzxdzxpz2+     zez2+     rezz2    
      eezy1=qdy*dzxdzxpz1+wqy*dzxdzxpz2                         
      eezz1=qdz*dzxdzxpz1+wqz*dzxdzxpz2+     xez2+     rexz2+ee1
      efxx1=qdx*dzxdzypx1+wqx*dzxdzypx2+     zfx2           +ef1
      efxy1=qdy*dzxdzypx1+wqy*dzxdzypx2          +     rezx2    
      efxz1=qdz*dzxdzypx1+wqz*dzxdzypx2+     xfx2+     reyx2    
      efyx1=qdx*dzxdzypy1+wqx*dzxdzypy2+     zfy2               
      efyy1=qdy*dzxdzypy1+wqy*dzxdzypy2          +     rezy2+ef1
      efyz1=qdz*dzxdzypy1+wqz*dzxdzypy2+     xfy2+     reyy2    
      efzx1=qdx*dzxdzypz1+wqx*dzxdzypz2+     zfz2               
      efzy1=qdy*dzxdzypz1+wqy*dzxdzypz2          +     rezz2    
      efzz1=qdz*dzxdzypz1+wqz*dzxdzypz2+1.d0*xfz2+     reyz2+ef1
      faxx1=qdx*dzydxxpx1+wqx*dzydxxpx2          +2.d0*rfxx2+fa1
      faxy1=qdy*dzydxxpx1+wqy*dzydxxpx2+     zax2               
      faxz1=qdz*dzydxxpx1+wqz*dzydxxpx2+     yax2               
      fayx1=qdx*dzydxxpy1+wqx*dzydxxpy2          +2.d0*rfxy2    
      fayy1=qdy*dzydxxpy1+wqy*dzydxxpy2+     zay2           +fa1
      fayz1=qdz*dzydxxpy1+wqz*dzydxxpy2+     yay2               
      fazx1=qdx*dzydxxpz1+wqx*dzydxxpz2          +2.d0*rfxz2    
      fazy1=qdy*dzydxxpz1+wqy*dzydxxpz2+     zaz2               
      fazz1=qdz*dzydxxpz1+wqz*dzydxxpz2+     yaz2           +fa1
      fbxx1=qdx*dzydyypx1+wqx*dzydyypx2                     +fb1
      fbxy1=qdy*dzydyypx1+wqy*dzydyypx2+     zbx2+2.d0*rfyx2    
      fbxz1=qdz*dzydyypx1+wqz*dzydyypx2+     ybx2               
      fbyx1=qdx*dzydyypy1+wqx*dzydyypy2                         
      fbyy1=qdy*dzydyypy1+wqy*dzydyypy2+     zby2+2.d0*rfyy2+fb1
      fbyz1=qdz*dzydyypy1+wqz*dzydyypy2+     yby2               
      fbzx1=qdx*dzydyypz1+wqx*dzydyypz2                         
      fbzy1=qdy*dzydyypz1+wqy*dzydyypz2+     zbz2+2.d0*rfyz2    
      fbzz1=qdz*dzydyypz1+wqz*dzydyypz2+     ybz2           +fb1
      fcxx1=qdx*dzydzzpx1+wqx*dzydzzpx2                     +fc1
      fcxy1=qdy*dzydzzpx1+wqy*dzydzzpx2+     zcx2               
      fcxz1=qdz*dzydzzpx1+wqz*dzydzzpx2+     ycx2+2.d0*rfzx2    
      fcyx1=qdx*dzydzzpy1+wqx*dzydzzpy2                         
      fcyy1=qdy*dzydzzpy1+wqy*dzydzzpy2+     zcy2           +fc1
      fcyz1=qdz*dzydzzpy1+wqz*dzydzzpy2+     ycy2+2.d0*rfzy2    
      fczx1=qdx*dzydzzpz1+wqx*dzydzzpz2                         
      fczy1=qdy*dzydzzpz1+wqy*dzydzzpz2+     zcz2               
      fczz1=qdz*dzydzzpz1+wqz*dzydzzpz2+     ycz2+2.d0*rfzz2+fc1
      fdxx1=qdx*dzydyxpx1+wqx*dzydyxpx2          +     rfyx2+fd1
      fdxy1=qdy*dzydyxpx1+wqy*dzydyxpx2+     zdx2+     rfxx2    
      fdxz1=qdz*dzydyxpx1+wqz*dzydyxpx2+     ydx2               
      fdyx1=qdx*dzydyxpy1+wqx*dzydyxpy2          +     rfyy2    
      fdyy1=qdy*dzydyxpy1+wqy*dzydyxpy2+     zdy2+     rfxy2+fd1
      fdyz1=qdz*dzydyxpy1+wqz*dzydyxpy2+     ydy2               
      fdzx1=qdx*dzydyxpz1+wqx*dzydyxpz2          +     rfyz2    
      fdzy1=qdy*dzydyxpz1+wqy*dzydyxpz2+     zdz2+     rfxz2    
      fdzz1=qdz*dzydyxpz1+wqz*dzydyxpz2+     ydz2           +fd1
      fexx1=qdx*dzydzxpx1+wqx*dzydzxpx2          +     rfzx2+fe1
      fexy1=qdy*dzydzxpx1+wqy*dzydzxpx2+     zex2               
      fexz1=qdz*dzydzxpx1+wqz*dzydzxpx2+     yex2+     rfxx2    
      feyx1=qdx*dzydzxpy1+wqx*dzydzxpy2          +     rfzy2    
      feyy1=qdy*dzydzxpy1+wqy*dzydzxpy2+     zey2           +fe1
      feyz1=qdz*dzydzxpy1+wqz*dzydzxpy2+     yey2+     rfxy2    
      fezx1=qdx*dzydzxpz1+wqx*dzydzxpz2          +     rfzz2    
      fezy1=qdy*dzydzxpz1+wqy*dzydzxpz2+     zez2               
      fezz1=qdz*dzydzxpz1+wqz*dzydzxpz2+     yez2+     rfxz2+fe1
      ffxx1=qdx*dzydzypx1+wqx*dzydzypx2                     +ff1
      ffxy1=qdy*dzydzypx1+wqy*dzydzypx2+     zfx2+     rfzx2    
      ffxz1=qdz*dzydzypx1+wqz*dzydzypx2+     yfx2+     rfyx2    
      ffyx1=qdx*dzydzypy1+wqx*dzydzypy2                         
      ffyy1=qdy*dzydzypy1+wqy*dzydzypy2+     zfy2+     rfzy2+ff1
      ffyz1=qdz*dzydzypy1+wqz*dzydzypy2+     yfy2+     rfyy2    
      ffzx1=qdx*dzydzypz1+wqx*dzydzypz2                         
      ffzy1=qdy*dzydzypz1+wqy*dzydzypz2+     zfz2+     rfzz2
      ffzz1=qdz*dzydzypz1+wqz*dzydzypz2+     yfz2+     rfyz2+ff1

!rpddp(1)
      xaax=rkp*xaax1
      xaay=rkp*xaay1
      xaaz=rkp*xaaz1
      xabx=rkp*xabx1
      xaby=rkp*xaby1
      xabz=rkp*xabz1
      xacx=rkp*xacx1
      xacy=rkp*xacy1
      xacz=rkp*xacz1
      xadx=rkp*xadx1
      xady=rkp*xady1
      xadz=rkp*xadz1
      xaex=rkp*xaex1
      xaey=rkp*xaey1
      xaez=rkp*xaez1
      xafx=rkp*xafx1
      xafy=rkp*xafy1
      xafz=rkp*xafz1
                
      xbax=rkp*xbax1
      xbay=rkp*xbay1
      xbaz=rkp*xbaz1
      xbbx=rkp*xbbx1
      xbby=rkp*xbby1
      xbbz=rkp*xbbz1
      xbcx=rkp*xbcx1
      xbcy=rkp*xbcy1
      xbcz=rkp*xbcz1
      xbdx=rkp*xbdx1
      xbdy=rkp*xbdy1
      xbdz=rkp*xbdz1
      xbex=rkp*xbex1
      xbey=rkp*xbey1
      xbez=rkp*xbez1
      xbfx=rkp*xbfx1
      xbfy=rkp*xbfy1
      xbfz=rkp*xbfz1
                
      xcax=rkp*xcax1
      xcay=rkp*xcay1
      xcaz=rkp*xcaz1
      xcbx=rkp*xcbx1
      xcby=rkp*xcby1
      xcbz=rkp*xcbz1
      xccx=rkp*xccx1
      xccy=rkp*xccy1
      xccz=rkp*xccz1
      xcdx=rkp*xcdx1
      xcdy=rkp*xcdy1
      xcdz=rkp*xcdz1
      xcex=rkp*xcex1
      xcey=rkp*xcey1
      xcez=rkp*xcez1
      xcfx=rkp*xcfx1
      xcfy=rkp*xcfy1
      xcfz=rkp*xcfz1
                
      xdax=rkp*xdax1
      xday=rkp*xday1
      xdaz=rkp*xdaz1
      xdbx=rkp*xdbx1
      xdby=rkp*xdby1
      xdbz=rkp*xdbz1
      xdcx=rkp*xdcx1
      xdcy=rkp*xdcy1
      xdcz=rkp*xdcz1
      xddx=rkp*xddx1
      xddy=rkp*xddy1
      xddz=rkp*xddz1
      xdex=rkp*xdex1
      xdey=rkp*xdey1
      xdez=rkp*xdez1
      xdfx=rkp*xdfx1
      xdfy=rkp*xdfy1
      xdfz=rkp*xdfz1
                
      xeax=rkp*xeax1
      xeay=rkp*xeay1
      xeaz=rkp*xeaz1
      xebx=rkp*xebx1
      xeby=rkp*xeby1
      xebz=rkp*xebz1
      xecx=rkp*xecx1
      xecy=rkp*xecy1
      xecz=rkp*xecz1
      xedx=rkp*xedx1
      xedy=rkp*xedy1
      xedz=rkp*xedz1
      xeex=rkp*xeex1
      xeey=rkp*xeey1
      xeez=rkp*xeez1
      xefx=rkp*xefx1
      xefy=rkp*xefy1
      xefz=rkp*xefz1
                
      xfax=rkp*xfax1
      xfay=rkp*xfay1
      xfaz=rkp*xfaz1
      xfbx=rkp*xfbx1
      xfby=rkp*xfby1
      xfbz=rkp*xfbz1
      xfcx=rkp*xfcx1
      xfcy=rkp*xfcy1
      xfcz=rkp*xfcz1
      xfdx=rkp*xfdx1
      xfdy=rkp*xfdy1
      xfdz=rkp*xfdz1
      xfex=rkp*xfex1
      xfey=rkp*xfey1
      xfez=rkp*xfez1
      xffx=rkp*xffx1
      xffy=rkp*xffy1
      xffz=rkp*xffz1
                
      yaax=rkp*yaax1
      yaay=rkp*yaay1
      yaaz=rkp*yaaz1
      yabx=rkp*yabx1
      yaby=rkp*yaby1
      yabz=rkp*yabz1
      yacx=rkp*yacx1
      yacy=rkp*yacy1
      yacz=rkp*yacz1
      yadx=rkp*yadx1
      yady=rkp*yady1
      yadz=rkp*yadz1
      yaex=rkp*yaex1
      yaey=rkp*yaey1
      yaez=rkp*yaez1
      yafx=rkp*yafx1
      yafy=rkp*yafy1
      yafz=rkp*yafz1
                
      ybax=rkp*ybax1
      ybay=rkp*ybay1
      ybaz=rkp*ybaz1
      ybbx=rkp*ybbx1
      ybby=rkp*ybby1
      ybbz=rkp*ybbz1
      ybcx=rkp*ybcx1
      ybcy=rkp*ybcy1
      ybcz=rkp*ybcz1
      ybdx=rkp*ybdx1
      ybdy=rkp*ybdy1
      ybdz=rkp*ybdz1
      ybex=rkp*ybex1
      ybey=rkp*ybey1
      ybez=rkp*ybez1
      ybfx=rkp*ybfx1
      ybfy=rkp*ybfy1
      ybfz=rkp*ybfz1
                
      ycax=rkp*ycax1
      ycay=rkp*ycay1
      ycaz=rkp*ycaz1
      ycbx=rkp*ycbx1
      ycby=rkp*ycby1
      ycbz=rkp*ycbz1
      yccx=rkp*yccx1
      yccy=rkp*yccy1
      yccz=rkp*yccz1
      ycdx=rkp*ycdx1
      ycdy=rkp*ycdy1
      ycdz=rkp*ycdz1
      ycex=rkp*ycex1
      ycey=rkp*ycey1
      ycez=rkp*ycez1
      ycfx=rkp*ycfx1
      ycfy=rkp*ycfy1
      ycfz=rkp*ycfz1
                
      ydax=rkp*ydax1
      yday=rkp*yday1
      ydaz=rkp*ydaz1
      ydbx=rkp*ydbx1
      ydby=rkp*ydby1
      ydbz=rkp*ydbz1
      ydcx=rkp*ydcx1
      ydcy=rkp*ydcy1
      ydcz=rkp*ydcz1
      yddx=rkp*yddx1
      yddy=rkp*yddy1
      yddz=rkp*yddz1
      ydex=rkp*ydex1
      ydey=rkp*ydey1
      ydez=rkp*ydez1
      ydfx=rkp*ydfx1
      ydfy=rkp*ydfy1
      ydfz=rkp*ydfz1
                
      yeax=rkp*yeax1
      yeay=rkp*yeay1
      yeaz=rkp*yeaz1
      yebx=rkp*yebx1
      yeby=rkp*yeby1
      yebz=rkp*yebz1
      yecx=rkp*yecx1
      yecy=rkp*yecy1
      yecz=rkp*yecz1
      yedx=rkp*yedx1
      yedy=rkp*yedy1
      yedz=rkp*yedz1
      yeex=rkp*yeex1
      yeey=rkp*yeey1
      yeez=rkp*yeez1
      yefx=rkp*yefx1
      yefy=rkp*yefy1
      yefz=rkp*yefz1
                
      yfax=rkp*yfax1
      yfay=rkp*yfay1
      yfaz=rkp*yfaz1
      yfbx=rkp*yfbx1
      yfby=rkp*yfby1
      yfbz=rkp*yfbz1
      yfcx=rkp*yfcx1
      yfcy=rkp*yfcy1
      yfcz=rkp*yfcz1
      yfdx=rkp*yfdx1
      yfdy=rkp*yfdy1
      yfdz=rkp*yfdz1
      yfex=rkp*yfex1
      yfey=rkp*yfey1
      yfez=rkp*yfez1
      yffx=rkp*yffx1
      yffy=rkp*yffy1
      yffz=rkp*yffz1
                
      zaax=rkp*zaax1
      zaay=rkp*zaay1
      zaaz=rkp*zaaz1
      zabx=rkp*zabx1
      zaby=rkp*zaby1
      zabz=rkp*zabz1
      zacx=rkp*zacx1
      zacy=rkp*zacy1
      zacz=rkp*zacz1
      zadx=rkp*zadx1
      zady=rkp*zady1
      zadz=rkp*zadz1
      zaex=rkp*zaex1
      zaey=rkp*zaey1
      zaez=rkp*zaez1
      zafx=rkp*zafx1
      zafy=rkp*zafy1
      zafz=rkp*zafz1
                
      zbax=rkp*zbax1
      zbay=rkp*zbay1
      zbaz=rkp*zbaz1
      zbbx=rkp*zbbx1
      zbby=rkp*zbby1
      zbbz=rkp*zbbz1
      zbcx=rkp*zbcx1
      zbcy=rkp*zbcy1
      zbcz=rkp*zbcz1
      zbdx=rkp*zbdx1
      zbdy=rkp*zbdy1
      zbdz=rkp*zbdz1
      zbex=rkp*zbex1
      zbey=rkp*zbey1
      zbez=rkp*zbez1
      zbfx=rkp*zbfx1
      zbfy=rkp*zbfy1
      zbfz=rkp*zbfz1
                
      zcax=rkp*zcax1
      zcay=rkp*zcay1
      zcaz=rkp*zcaz1
      zcbx=rkp*zcbx1
      zcby=rkp*zcby1
      zcbz=rkp*zcbz1
      zccx=rkp*zccx1
      zccy=rkp*zccy1
      zccz=rkp*zccz1
      zcdx=rkp*zcdx1
      zcdy=rkp*zcdy1
      zcdz=rkp*zcdz1
      zcex=rkp*zcex1
      zcey=rkp*zcey1
      zcez=rkp*zcez1
      zcfx=rkp*zcfx1
      zcfy=rkp*zcfy1
      zcfz=rkp*zcfz1
                
      zdax=rkp*zdax1
      zday=rkp*zday1
      zdaz=rkp*zdaz1
      zdbx=rkp*zdbx1
      zdby=rkp*zdby1
      zdbz=rkp*zdbz1
      zdcx=rkp*zdcx1
      zdcy=rkp*zdcy1
      zdcz=rkp*zdcz1
      zddx=rkp*zddx1
      zddy=rkp*zddy1
      zddz=rkp*zddz1
      zdex=rkp*zdex1
      zdey=rkp*zdey1
      zdez=rkp*zdez1
      zdfx=rkp*zdfx1
      zdfy=rkp*zdfy1
      zdfz=rkp*zdfz1
                
      zeax=rkp*zeax1
      zeay=rkp*zeay1
      zeaz=rkp*zeaz1
      zebx=rkp*zebx1
      zeby=rkp*zeby1
      zebz=rkp*zebz1
      zecx=rkp*zecx1
      zecy=rkp*zecy1
      zecz=rkp*zecz1
      zedx=rkp*zedx1
      zedy=rkp*zedy1
      zedz=rkp*zedz1
      zeex=rkp*zeex1
      zeey=rkp*zeey1
      zeez=rkp*zeez1
      zefx=rkp*zefx1
      zefy=rkp*zefy1
      zefz=rkp*zefz1
                
      zfax=rkp*zfax1
      zfay=rkp*zfay1
      zfaz=rkp*zfaz1
      zfbx=rkp*zfbx1
      zfby=rkp*zfby1
      zfbz=rkp*zfbz1
      zfcx=rkp*zfcx1
      zfcy=rkp*zfcy1
      zfcz=rkp*zfcz1
      zfdx=rkp*zfdx1
      zfdy=rkp*zfdy1
      zfdz=rkp*zfdz1
      zfex=rkp*zfex1
      zfey=rkp*zfey1
      zfez=rkp*zfez1
      zffx=rkp*zffx1
      zffy=rkp*zffy1
      zffz=rkp*zffz1
!rdpdp(1) 
      axax=rkp*axax1
      axay=rkp*axay1
      axaz=rkp*axaz1
      axbx=rkp*axbx1
      axby=rkp*axby1
      axbz=rkp*axbz1
      axcx=rkp*axcx1
      axcy=rkp*axcy1
      axcz=rkp*axcz1
      axdx=rkp*axdx1
      axdy=rkp*axdy1
      axdz=rkp*axdz1
      axex=rkp*axex1
      axey=rkp*axey1
      axez=rkp*axez1
      axfx=rkp*axfx1
      axfy=rkp*axfy1
      axfz=rkp*axfz1
      ayax=rkp*ayax1
      ayay=rkp*ayay1
      ayaz=rkp*ayaz1
      aybx=rkp*aybx1
      ayby=rkp*ayby1
      aybz=rkp*aybz1
      aycx=rkp*aycx1
      aycy=rkp*aycy1
      aycz=rkp*aycz1
      aydx=rkp*aydx1
      aydy=rkp*aydy1
      aydz=rkp*aydz1
      ayex=rkp*ayex1
      ayey=rkp*ayey1
      ayez=rkp*ayez1
      ayfx=rkp*ayfx1
      ayfy=rkp*ayfy1
      ayfz=rkp*ayfz1
      azax=rkp*azax1
      azay=rkp*azay1
      azaz=rkp*azaz1
      azbx=rkp*azbx1
      azby=rkp*azby1
      azbz=rkp*azbz1
      azcx=rkp*azcx1
      azcy=rkp*azcy1
      azcz=rkp*azcz1
      azdx=rkp*azdx1
      azdy=rkp*azdy1
      azdz=rkp*azdz1
      azex=rkp*azex1
      azey=rkp*azey1
      azez=rkp*azez1
      azfx=rkp*azfx1
      azfy=rkp*azfy1
      azfz=rkp*azfz1
      bxax=rkp*bxax1
      bxay=rkp*bxay1
      bxaz=rkp*bxaz1
      bxbx=rkp*bxbx1
      bxby=rkp*bxby1
      bxbz=rkp*bxbz1
      bxcx=rkp*bxcx1
      bxcy=rkp*bxcy1
      bxcz=rkp*bxcz1
      bxdx=rkp*bxdx1
      bxdy=rkp*bxdy1
      bxdz=rkp*bxdz1
      bxex=rkp*bxex1
      bxey=rkp*bxey1
      bxez=rkp*bxez1
      bxfx=rkp*bxfx1
      bxfy=rkp*bxfy1
      bxfz=rkp*bxfz1
      byax=rkp*byax1
      byay=rkp*byay1
      byaz=rkp*byaz1
      bybx=rkp*bybx1
      byby=rkp*byby1
      bybz=rkp*bybz1
      bycx=rkp*bycx1
      bycy=rkp*bycy1
      bycz=rkp*bycz1
      bydx=rkp*bydx1
      bydy=rkp*bydy1
      bydz=rkp*bydz1
      byex=rkp*byex1
      byey=rkp*byey1
      byez=rkp*byez1
      byfx=rkp*byfx1
      byfy=rkp*byfy1
      byfz=rkp*byfz1
      bzax=rkp*bzax1
      bzay=rkp*bzay1
      bzaz=rkp*bzaz1
      bzbx=rkp*bzbx1
      bzby=rkp*bzby1
      bzbz=rkp*bzbz1
      bzcx=rkp*bzcx1
      bzcy=rkp*bzcy1
      bzcz=rkp*bzcz1
      bzdx=rkp*bzdx1
      bzdy=rkp*bzdy1
      bzdz=rkp*bzdz1
      bzex=rkp*bzex1
      bzey=rkp*bzey1
      bzez=rkp*bzez1
      bzfx=rkp*bzfx1
      bzfy=rkp*bzfy1
      bzfz=rkp*bzfz1
      cxax=rkp*cxax1
      cxay=rkp*cxay1
      cxaz=rkp*cxaz1
      cxbx=rkp*cxbx1
      cxby=rkp*cxby1
      cxbz=rkp*cxbz1
      cxcx=rkp*cxcx1
      cxcy=rkp*cxcy1
      cxcz=rkp*cxcz1
      cxdx=rkp*cxdx1
      cxdy=rkp*cxdy1
      cxdz=rkp*cxdz1
      cxex=rkp*cxex1
      cxey=rkp*cxey1
      cxez=rkp*cxez1
      cxfx=rkp*cxfx1
      cxfy=rkp*cxfy1
      cxfz=rkp*cxfz1
      cyax=rkp*cyax1
      cyay=rkp*cyay1
      cyaz=rkp*cyaz1
      cybx=rkp*cybx1
      cyby=rkp*cyby1
      cybz=rkp*cybz1
      cycx=rkp*cycx1
      cycy=rkp*cycy1
      cycz=rkp*cycz1
      cydx=rkp*cydx1
      cydy=rkp*cydy1
      cydz=rkp*cydz1
      cyex=rkp*cyex1
      cyey=rkp*cyey1
      cyez=rkp*cyez1
      cyfx=rkp*cyfx1
      cyfy=rkp*cyfy1
      cyfz=rkp*cyfz1
      czax=rkp*czax1
      czay=rkp*czay1
      czaz=rkp*czaz1
      czbx=rkp*czbx1
      czby=rkp*czby1
      czbz=rkp*czbz1
      czcx=rkp*czcx1
      czcy=rkp*czcy1
      czcz=rkp*czcz1
      czdx=rkp*czdx1
      czdy=rkp*czdy1
      czdz=rkp*czdz1
      czex=rkp*czex1
      czey=rkp*czey1
      czez=rkp*czez1
      czfx=rkp*czfx1
      czfy=rkp*czfy1
      czfz=rkp*czfz1
      dxax=rkp*dxax1
      dxay=rkp*dxay1
      dxaz=rkp*dxaz1
      dxbx=rkp*dxbx1
      dxby=rkp*dxby1
      dxbz=rkp*dxbz1
      dxcx=rkp*dxcx1
      dxcy=rkp*dxcy1
      dxcz=rkp*dxcz1
      dxdx=rkp*dxdx1
      dxdy=rkp*dxdy1
      dxdz=rkp*dxdz1
      dxex=rkp*dxex1
      dxey=rkp*dxey1
      dxez=rkp*dxez1
      dxfx=rkp*dxfx1
      dxfy=rkp*dxfy1
      dxfz=rkp*dxfz1
      dyax=rkp*dyax1
      dyay=rkp*dyay1
      dyaz=rkp*dyaz1
      dybx=rkp*dybx1
      dyby=rkp*dyby1
      dybz=rkp*dybz1
      dycx=rkp*dycx1
      dycy=rkp*dycy1
      dycz=rkp*dycz1
      dydx=rkp*dydx1
      dydy=rkp*dydy1
      dydz=rkp*dydz1
      dyex=rkp*dyex1
      dyey=rkp*dyey1
      dyez=rkp*dyez1
      dyfx=rkp*dyfx1
      dyfy=rkp*dyfy1
      dyfz=rkp*dyfz1
      dzax=rkp*dzax1
      dzay=rkp*dzay1
      dzaz=rkp*dzaz1
      dzbx=rkp*dzbx1
      dzby=rkp*dzby1
      dzbz=rkp*dzbz1
      dzcx=rkp*dzcx1
      dzcy=rkp*dzcy1
      dzcz=rkp*dzcz1
      dzdx=rkp*dzdx1
      dzdy=rkp*dzdy1
      dzdz=rkp*dzdz1
      dzex=rkp*dzex1
      dzey=rkp*dzey1
      dzez=rkp*dzez1
      dzfx=rkp*dzfx1
      dzfy=rkp*dzfy1
      dzfz=rkp*dzfz1
      exax=rkp*exax1
      exay=rkp*exay1
      exaz=rkp*exaz1
      exbx=rkp*exbx1
      exby=rkp*exby1
      exbz=rkp*exbz1
      excx=rkp*excx1
      excy=rkp*excy1
      excz=rkp*excz1
      exdx=rkp*exdx1
      exdy=rkp*exdy1
      exdz=rkp*exdz1
      exex=rkp*exex1
      exey=rkp*exey1
      exez=rkp*exez1
      exfx=rkp*exfx1
      exfy=rkp*exfy1
      exfz=rkp*exfz1
      eyax=rkp*eyax1
      eyay=rkp*eyay1
      eyaz=rkp*eyaz1
      eybx=rkp*eybx1
      eyby=rkp*eyby1
      eybz=rkp*eybz1
      eycx=rkp*eycx1
      eycy=rkp*eycy1
      eycz=rkp*eycz1
      eydx=rkp*eydx1
      eydy=rkp*eydy1
      eydz=rkp*eydz1
      eyex=rkp*eyex1
      eyey=rkp*eyey1
      eyez=rkp*eyez1
      eyfx=rkp*eyfx1
      eyfy=rkp*eyfy1
      eyfz=rkp*eyfz1
      ezax=rkp*ezax1
      ezay=rkp*ezay1
      ezaz=rkp*ezaz1
      ezbx=rkp*ezbx1
      ezby=rkp*ezby1
      ezbz=rkp*ezbz1
      ezcx=rkp*ezcx1
      ezcy=rkp*ezcy1
      ezcz=rkp*ezcz1
      ezdx=rkp*ezdx1
      ezdy=rkp*ezdy1
      ezdz=rkp*ezdz1
      ezex=rkp*ezex1
      ezey=rkp*ezey1
      ezez=rkp*ezez1
      ezfx=rkp*ezfx1
      ezfy=rkp*ezfy1
      ezfz=rkp*ezfz1
      fxax=rkp*fxax1
      fxay=rkp*fxay1
      fxaz=rkp*fxaz1
      fxbx=rkp*fxbx1
      fxby=rkp*fxby1
      fxbz=rkp*fxbz1
      fxcx=rkp*fxcx1
      fxcy=rkp*fxcy1
      fxcz=rkp*fxcz1
      fxdx=rkp*fxdx1
      fxdy=rkp*fxdy1
      fxdz=rkp*fxdz1
      fxex=rkp*fxex1
      fxey=rkp*fxey1
      fxez=rkp*fxez1
      fxfx=rkp*fxfx1
      fxfy=rkp*fxfy1
      fxfz=rkp*fxfz1
      fyax=rkp*fyax1
      fyay=rkp*fyay1
      fyaz=rkp*fyaz1
      fybx=rkp*fybx1
      fyby=rkp*fyby1
      fybz=rkp*fybz1
      fycx=rkp*fycx1
      fycy=rkp*fycy1
      fycz=rkp*fycz1
      fydx=rkp*fydx1
      fydy=rkp*fydy1
      fydz=rkp*fydz1
      fyex=rkp*fyex1
      fyey=rkp*fyey1
      fyez=rkp*fyez1
      fyfx=rkp*fyfx1
      fyfy=rkp*fyfy1
      fyfz=rkp*fyfz1
      fzax=rkp*fzax1
      fzay=rkp*fzay1
      fzaz=rkp*fzaz1
      fzbx=rkp*fzbx1
      fzby=rkp*fzby1
      fzbz=rkp*fzbz1
      fzcx=rkp*fzcx1
      fzcy=rkp*fzcy1
      fzcz=rkp*fzcz1
      fzdx=rkp*fzdx1
      fzdy=rkp*fzdy1
      fzdz=rkp*fzdz1
      fzex=rkp*fzex1
      fzey=rkp*fzey1
      fzez=rkp*fzez1
      fzfx=rkp*fzfx1
      fzfy=rkp*fzfy1
      fzfz=rkp*fzfz1
!ddds01(01)
      aaa=eta*(aaa0-rooe*aaa1)
      aab=eta*(aab0-rooe*aab1)
      aac=eta*(aac0-rooe*aac1)
      aad=eta*(aad0-rooe*aad1)
      aae=eta*(aae0-rooe*aae1)
      aaf=eta*(aaf0-rooe*aaf1)
      aba=eta*(aba0-rooe*aba1)
      abb=eta*(abb0-rooe*abb1)
      abc=eta*(abc0-rooe*abc1)
      abd=eta*(abd0-rooe*abd1)
      abe=eta*(abe0-rooe*abe1)
      abf=eta*(abf0-rooe*abf1)
      aca=eta*(aca0-rooe*aca1)
      acb=eta*(acb0-rooe*acb1)
      acc=eta*(acc0-rooe*acc1)
      acd=eta*(acd0-rooe*acd1)
      ace=eta*(ace0-rooe*ace1)
      acf=eta*(acf0-rooe*acf1)
      ada=eta*(ada0-rooe*ada1)
      adb=eta*(adb0-rooe*adb1)
      adc=eta*(adc0-rooe*adc1)
      add=eta*(add0-rooe*add1)
      ade=eta*(ade0-rooe*ade1)
      adf=eta*(adf0-rooe*adf1)
      aea=eta*(aea0-rooe*aea1)
      aeb=eta*(aeb0-rooe*aeb1)
      aec=eta*(aec0-rooe*aec1)
      aed=eta*(aed0-rooe*aed1)
      aee=eta*(aee0-rooe*aee1)
      aef=eta*(aef0-rooe*aef1)
      afa=eta*(afa0-rooe*afa1)
      afb=eta*(afb0-rooe*afb1)
      afc=eta*(afc0-rooe*afc1)
      afd=eta*(afd0-rooe*afd1)
      afe=eta*(afe0-rooe*afe1)
      aff=eta*(aff0-rooe*aff1)
      baa=eta*(baa0-rooe*baa1)
      bab=eta*(bab0-rooe*bab1)
      bac=eta*(bac0-rooe*bac1)
      bad=eta*(bad0-rooe*bad1)
      bae=eta*(bae0-rooe*bae1)
      baf=eta*(baf0-rooe*baf1)
      bba=eta*(bba0-rooe*bba1)
      bbb=eta*(bbb0-rooe*bbb1)
      bbc=eta*(bbc0-rooe*bbc1)
      bbd=eta*(bbd0-rooe*bbd1)
      bbe=eta*(bbe0-rooe*bbe1)
      bbf=eta*(bbf0-rooe*bbf1)
      bca=eta*(bca0-rooe*bca1)
      bcb=eta*(bcb0-rooe*bcb1)
      bcc=eta*(bcc0-rooe*bcc1)
      bcd=eta*(bcd0-rooe*bcd1)
      bce=eta*(bce0-rooe*bce1)
      bcf=eta*(bcf0-rooe*bcf1)
      bda=eta*(bda0-rooe*bda1)
      bdb=eta*(bdb0-rooe*bdb1)
      bdc=eta*(bdc0-rooe*bdc1)
      bdd=eta*(bdd0-rooe*bdd1)
      bde=eta*(bde0-rooe*bde1)
      bdf=eta*(bdf0-rooe*bdf1)
      bea=eta*(bea0-rooe*bea1)
      beb=eta*(beb0-rooe*beb1)
      bec=eta*(bec0-rooe*bec1)
      bed=eta*(bed0-rooe*bed1)
      bee=eta*(bee0-rooe*bee1)
      bef=eta*(bef0-rooe*bef1)
      bfa=eta*(bfa0-rooe*bfa1)
      bfb=eta*(bfb0-rooe*bfb1)
      bfc=eta*(bfc0-rooe*bfc1)
      bfd=eta*(bfd0-rooe*bfd1)
      bfe=eta*(bfe0-rooe*bfe1)
      bff=eta*(bff0-rooe*bff1)
      caa=eta*(caa0-rooe*caa1)
      cab=eta*(cab0-rooe*cab1)
      cac=eta*(cac0-rooe*cac1)
      cad=eta*(cad0-rooe*cad1)
      cae=eta*(cae0-rooe*cae1)
      caf=eta*(caf0-rooe*caf1)
      cba=eta*(cba0-rooe*cba1)
      cbb=eta*(cbb0-rooe*cbb1)
      cbc=eta*(cbc0-rooe*cbc1)
      cbd=eta*(cbd0-rooe*cbd1)
      cbe=eta*(cbe0-rooe*cbe1)
      cbf=eta*(cbf0-rooe*cbf1)
      cca=eta*(cca0-rooe*cca1)
      ccb=eta*(ccb0-rooe*ccb1)
      ccc=eta*(ccc0-rooe*ccc1)
      ccd=eta*(ccd0-rooe*ccd1)
      cce=eta*(cce0-rooe*cce1)
      ccf=eta*(ccf0-rooe*ccf1)
      cda=eta*(cda0-rooe*cda1)
      cdb=eta*(cdb0-rooe*cdb1)
      cdc=eta*(cdc0-rooe*cdc1)
      cdd=eta*(cdd0-rooe*cdd1)
      cde=eta*(cde0-rooe*cde1)
      cdf=eta*(cdf0-rooe*cdf1)
      cea=eta*(cea0-rooe*cea1)
      ceb=eta*(ceb0-rooe*ceb1)
      cec=eta*(cec0-rooe*cec1)
      ced=eta*(ced0-rooe*ced1)
      cee=eta*(cee0-rooe*cee1)
      cef=eta*(cef0-rooe*cef1)
      cfa=eta*(cfa0-rooe*cfa1)
      cfb=eta*(cfb0-rooe*cfb1)
      cfc=eta*(cfc0-rooe*cfc1)
      cfd=eta*(cfd0-rooe*cfd1)
      cfe=eta*(cfe0-rooe*cfe1)
      cff=eta*(cff0-rooe*cff1)
      daa=eta*(daa0-rooe*daa1)
      dab=eta*(dab0-rooe*dab1)
      dac=eta*(dac0-rooe*dac1)
      dad=eta*(dad0-rooe*dad1)
      dae=eta*(dae0-rooe*dae1)
      daf=eta*(daf0-rooe*daf1)
      dba=eta*(dba0-rooe*dba1)
      dbb=eta*(dbb0-rooe*dbb1)
      dbc=eta*(dbc0-rooe*dbc1)
      dbd=eta*(dbd0-rooe*dbd1)
      dbe=eta*(dbe0-rooe*dbe1)
      dbf=eta*(dbf0-rooe*dbf1)
      dca=eta*(dca0-rooe*dca1)
      dcb=eta*(dcb0-rooe*dcb1)
      dcc=eta*(dcc0-rooe*dcc1)
      dcd=eta*(dcd0-rooe*dcd1)
      dce=eta*(dce0-rooe*dce1)
      dcf=eta*(dcf0-rooe*dcf1)
      dda=eta*(dda0-rooe*dda1)
      ddb=eta*(ddb0-rooe*ddb1)
      ddc=eta*(ddc0-rooe*ddc1)
      ddd=eta*(ddd0-rooe*ddd1)
      dde=eta*(dde0-rooe*dde1)
      ddf=eta*(ddf0-rooe*ddf1)
      dea=eta*(dea0-rooe*dea1)
      deb=eta*(deb0-rooe*deb1)
      dec=eta*(dec0-rooe*dec1)
      ded=eta*(ded0-rooe*ded1)
      dee=eta*(dee0-rooe*dee1)
      def=eta*(def0-rooe*def1)
      dfa=eta*(dfa0-rooe*dfa1)
      dfb=eta*(dfb0-rooe*dfb1)
      dfc=eta*(dfc0-rooe*dfc1)
      dfd=eta*(dfd0-rooe*dfd1)
      dfe=eta*(dfe0-rooe*dfe1)
      dff=eta*(dff0-rooe*dff1)
      eaa=eta*(eaa0-rooe*eaa1)
      eab=eta*(eab0-rooe*eab1)
      eac=eta*(eac0-rooe*eac1)
      ead=eta*(ead0-rooe*ead1)
      eae=eta*(eae0-rooe*eae1)
      eaf=eta*(eaf0-rooe*eaf1)
      eba=eta*(eba0-rooe*eba1)
      ebb=eta*(ebb0-rooe*ebb1)
      ebc=eta*(ebc0-rooe*ebc1)
      ebd=eta*(ebd0-rooe*ebd1)
      ebe=eta*(ebe0-rooe*ebe1)
      ebf=eta*(ebf0-rooe*ebf1)
      eca=eta*(eca0-rooe*eca1)
      ecb=eta*(ecb0-rooe*ecb1)
      ecc=eta*(ecc0-rooe*ecc1)
      ecd=eta*(ecd0-rooe*ecd1)
      ece=eta*(ece0-rooe*ece1)
      ecf=eta*(ecf0-rooe*ecf1)
      eda=eta*(eda0-rooe*eda1)
      edb=eta*(edb0-rooe*edb1)
      edc=eta*(edc0-rooe*edc1)
      edd=eta*(edd0-rooe*edd1)
      ede=eta*(ede0-rooe*ede1)
      edf=eta*(edf0-rooe*edf1)
      eea=eta*(eea0-rooe*eea1)
      eeb=eta*(eeb0-rooe*eeb1)
      eec=eta*(eec0-rooe*eec1)
      eed=eta*(eed0-rooe*eed1)
      eee=eta*(eee0-rooe*eee1)
      eef=eta*(eef0-rooe*eef1)
      efa=eta*(efa0-rooe*efa1)
      efb=eta*(efb0-rooe*efb1)
      efc=eta*(efc0-rooe*efc1)
      efd=eta*(efd0-rooe*efd1)
      efe=eta*(efe0-rooe*efe1)
      eff=eta*(eff0-rooe*eff1)
      faa=eta*(faa0-rooe*faa1)
      fab=eta*(fab0-rooe*fab1)
      fac=eta*(fac0-rooe*fac1)
      fad=eta*(fad0-rooe*fad1)
      fae=eta*(fae0-rooe*fae1)
      faf=eta*(faf0-rooe*faf1)
      fba=eta*(fba0-rooe*fba1)
      fbb=eta*(fbb0-rooe*fbb1)
      fbc=eta*(fbc0-rooe*fbc1)
      fbd=eta*(fbd0-rooe*fbd1)
      fbe=eta*(fbe0-rooe*fbe1)
      fbf=eta*(fbf0-rooe*fbf1)
      fca=eta*(fca0-rooe*fca1)
      fcb=eta*(fcb0-rooe*fcb1)
      fcc=eta*(fcc0-rooe*fcc1)
      fcd=eta*(fcd0-rooe*fcd1)
      fce=eta*(fce0-rooe*fce1)
      fcf=eta*(fcf0-rooe*fcf1)
      fda=eta*(fda0-rooe*fda1)
      fdb=eta*(fdb0-rooe*fdb1)
      fdc=eta*(fdc0-rooe*fdc1)
      fdd=eta*(fdd0-rooe*fdd1)
      fde=eta*(fde0-rooe*fde1)
      fdf=eta*(fdf0-rooe*fdf1)
      fea=eta*(fea0-rooe*fea1)
      feb=eta*(feb0-rooe*feb1)
      fec=eta*(fec0-rooe*fec1)
      fed=eta*(fed0-rooe*fed1)
      fee=eta*(fee0-rooe*fee1)
      fef=eta*(fef0-rooe*fef1)
      ffa=eta*(ffa0-rooe*ffa1)
      ffb=eta*(ffb0-rooe*ffb1)
      ffc=eta*(ffc0-rooe*ffc1)
      ffd=eta*(ffd0-rooe*ffd1)
      ffe=eta*(ffe0-rooe*ffe1)
      fff=eta*(fff0-rooe*fff1)

!ddpp01(01)
      aaxx=eta*(aaxx0-rooe*aaxx1)
      aaxy=eta*(aaxy0-rooe*aaxy1)
      aaxz=eta*(aaxz0-rooe*aaxz1)
      aayx=eta*(aayx0-rooe*aayx1)
      aayy=eta*(aayy0-rooe*aayy1)
      aayz=eta*(aayz0-rooe*aayz1)
      aazx=eta*(aazx0-rooe*aazx1)
      aazy=eta*(aazy0-rooe*aazy1)
      aazz=eta*(aazz0-rooe*aazz1)
      abxx=eta*(abxx0-rooe*abxx1)
      abxy=eta*(abxy0-rooe*abxy1)
      abxz=eta*(abxz0-rooe*abxz1)
      abyx=eta*(abyx0-rooe*abyx1)
      abyy=eta*(abyy0-rooe*abyy1)
      abyz=eta*(abyz0-rooe*abyz1)
      abzx=eta*(abzx0-rooe*abzx1)
      abzy=eta*(abzy0-rooe*abzy1)
      abzz=eta*(abzz0-rooe*abzz1)
      acxx=eta*(acxx0-rooe*acxx1)
      acxy=eta*(acxy0-rooe*acxy1)
      acxz=eta*(acxz0-rooe*acxz1)
      acyx=eta*(acyx0-rooe*acyx1)
      acyy=eta*(acyy0-rooe*acyy1)
      acyz=eta*(acyz0-rooe*acyz1)
      aczx=eta*(aczx0-rooe*aczx1)
      aczy=eta*(aczy0-rooe*aczy1)
      aczz=eta*(aczz0-rooe*aczz1)
      adxx=eta*(adxx0-rooe*adxx1)
      adxy=eta*(adxy0-rooe*adxy1)
      adxz=eta*(adxz0-rooe*adxz1)
      adyx=eta*(adyx0-rooe*adyx1)
      adyy=eta*(adyy0-rooe*adyy1)
      adyz=eta*(adyz0-rooe*adyz1)
      adzx=eta*(adzx0-rooe*adzx1)
      adzy=eta*(adzy0-rooe*adzy1)
      adzz=eta*(adzz0-rooe*adzz1)
      aexx=eta*(aexx0-rooe*aexx1)
      aexy=eta*(aexy0-rooe*aexy1)
      aexz=eta*(aexz0-rooe*aexz1)
      aeyx=eta*(aeyx0-rooe*aeyx1)
      aeyy=eta*(aeyy0-rooe*aeyy1)
      aeyz=eta*(aeyz0-rooe*aeyz1)
      aezx=eta*(aezx0-rooe*aezx1)
      aezy=eta*(aezy0-rooe*aezy1)
      aezz=eta*(aezz0-rooe*aezz1)
      afxx=eta*(afxx0-rooe*afxx1)
      afxy=eta*(afxy0-rooe*afxy1)
      afxz=eta*(afxz0-rooe*afxz1)
      afyx=eta*(afyx0-rooe*afyx1)
      afyy=eta*(afyy0-rooe*afyy1)
      afyz=eta*(afyz0-rooe*afyz1)
      afzx=eta*(afzx0-rooe*afzx1)
      afzy=eta*(afzy0-rooe*afzy1)
      afzz=eta*(afzz0-rooe*afzz1)
      baxx=eta*(baxx0-rooe*baxx1)
      baxy=eta*(baxy0-rooe*baxy1)
      baxz=eta*(baxz0-rooe*baxz1)
      bayx=eta*(bayx0-rooe*bayx1)
      bayy=eta*(bayy0-rooe*bayy1)
      bayz=eta*(bayz0-rooe*bayz1)
      bazx=eta*(bazx0-rooe*bazx1)
      bazy=eta*(bazy0-rooe*bazy1)
      bazz=eta*(bazz0-rooe*bazz1)
      bbxx=eta*(bbxx0-rooe*bbxx1)
      bbxy=eta*(bbxy0-rooe*bbxy1)
      bbxz=eta*(bbxz0-rooe*bbxz1)
      bbyx=eta*(bbyx0-rooe*bbyx1)
      bbyy=eta*(bbyy0-rooe*bbyy1)
      bbyz=eta*(bbyz0-rooe*bbyz1)
      bbzx=eta*(bbzx0-rooe*bbzx1)
      bbzy=eta*(bbzy0-rooe*bbzy1)
      bbzz=eta*(bbzz0-rooe*bbzz1)
      bcxx=eta*(bcxx0-rooe*bcxx1)
      bcxy=eta*(bcxy0-rooe*bcxy1)
      bcxz=eta*(bcxz0-rooe*bcxz1)
      bcyx=eta*(bcyx0-rooe*bcyx1)
      bcyy=eta*(bcyy0-rooe*bcyy1)
      bcyz=eta*(bcyz0-rooe*bcyz1)
      bczx=eta*(bczx0-rooe*bczx1)
      bczy=eta*(bczy0-rooe*bczy1)
      bczz=eta*(bczz0-rooe*bczz1)
      bdxx=eta*(bdxx0-rooe*bdxx1)
      bdxy=eta*(bdxy0-rooe*bdxy1)
      bdxz=eta*(bdxz0-rooe*bdxz1)
      bdyx=eta*(bdyx0-rooe*bdyx1)
      bdyy=eta*(bdyy0-rooe*bdyy1)
      bdyz=eta*(bdyz0-rooe*bdyz1)
      bdzx=eta*(bdzx0-rooe*bdzx1)
      bdzy=eta*(bdzy0-rooe*bdzy1)
      bdzz=eta*(bdzz0-rooe*bdzz1)
      bexx=eta*(bexx0-rooe*bexx1)
      bexy=eta*(bexy0-rooe*bexy1)
      bexz=eta*(bexz0-rooe*bexz1)
      beyx=eta*(beyx0-rooe*beyx1)
      beyy=eta*(beyy0-rooe*beyy1)
      beyz=eta*(beyz0-rooe*beyz1)
      bezx=eta*(bezx0-rooe*bezx1)
      bezy=eta*(bezy0-rooe*bezy1)
      bezz=eta*(bezz0-rooe*bezz1)
      bfxx=eta*(bfxx0-rooe*bfxx1)
      bfxy=eta*(bfxy0-rooe*bfxy1)
      bfxz=eta*(bfxz0-rooe*bfxz1)
      bfyx=eta*(bfyx0-rooe*bfyx1)
      bfyy=eta*(bfyy0-rooe*bfyy1)
      bfyz=eta*(bfyz0-rooe*bfyz1)
      bfzx=eta*(bfzx0-rooe*bfzx1)
      bfzy=eta*(bfzy0-rooe*bfzy1)
      bfzz=eta*(bfzz0-rooe*bfzz1)
      caxx=eta*(caxx0-rooe*caxx1)
      caxy=eta*(caxy0-rooe*caxy1)
      caxz=eta*(caxz0-rooe*caxz1)
      cayx=eta*(cayx0-rooe*cayx1)
      cayy=eta*(cayy0-rooe*cayy1)
      cayz=eta*(cayz0-rooe*cayz1)
      cazx=eta*(cazx0-rooe*cazx1)
      cazy=eta*(cazy0-rooe*cazy1)
      cazz=eta*(cazz0-rooe*cazz1)
      cbxx=eta*(cbxx0-rooe*cbxx1)
      cbxy=eta*(cbxy0-rooe*cbxy1)
      cbxz=eta*(cbxz0-rooe*cbxz1)
      cbyx=eta*(cbyx0-rooe*cbyx1)
      cbyy=eta*(cbyy0-rooe*cbyy1)
      cbyz=eta*(cbyz0-rooe*cbyz1)
      cbzx=eta*(cbzx0-rooe*cbzx1)
      cbzy=eta*(cbzy0-rooe*cbzy1)
      cbzz=eta*(cbzz0-rooe*cbzz1)
      ccxx=eta*(ccxx0-rooe*ccxx1)
      ccxy=eta*(ccxy0-rooe*ccxy1)
      ccxz=eta*(ccxz0-rooe*ccxz1)
      ccyx=eta*(ccyx0-rooe*ccyx1)
      ccyy=eta*(ccyy0-rooe*ccyy1)
      ccyz=eta*(ccyz0-rooe*ccyz1)
      cczx=eta*(cczx0-rooe*cczx1)
      cczy=eta*(cczy0-rooe*cczy1)
      cczz=eta*(cczz0-rooe*cczz1)
      cdxx=eta*(cdxx0-rooe*cdxx1)
      cdxy=eta*(cdxy0-rooe*cdxy1)
      cdxz=eta*(cdxz0-rooe*cdxz1)
      cdyx=eta*(cdyx0-rooe*cdyx1)
      cdyy=eta*(cdyy0-rooe*cdyy1)
      cdyz=eta*(cdyz0-rooe*cdyz1)
      cdzx=eta*(cdzx0-rooe*cdzx1)
      cdzy=eta*(cdzy0-rooe*cdzy1)
      cdzz=eta*(cdzz0-rooe*cdzz1)
      cexx=eta*(cexx0-rooe*cexx1)
      cexy=eta*(cexy0-rooe*cexy1)
      cexz=eta*(cexz0-rooe*cexz1)
      ceyx=eta*(ceyx0-rooe*ceyx1)
      ceyy=eta*(ceyy0-rooe*ceyy1)
      ceyz=eta*(ceyz0-rooe*ceyz1)
      cezx=eta*(cezx0-rooe*cezx1)
      cezy=eta*(cezy0-rooe*cezy1)
      cezz=eta*(cezz0-rooe*cezz1)
      cfxx=eta*(cfxx0-rooe*cfxx1)
      cfxy=eta*(cfxy0-rooe*cfxy1)
      cfxz=eta*(cfxz0-rooe*cfxz1)
      cfyx=eta*(cfyx0-rooe*cfyx1)
      cfyy=eta*(cfyy0-rooe*cfyy1)
      cfyz=eta*(cfyz0-rooe*cfyz1)
      cfzx=eta*(cfzx0-rooe*cfzx1)
      cfzy=eta*(cfzy0-rooe*cfzy1)
      cfzz=eta*(cfzz0-rooe*cfzz1)
      daxx=eta*(daxx0-rooe*daxx1)
      daxy=eta*(daxy0-rooe*daxy1)
      daxz=eta*(daxz0-rooe*daxz1)
      dayx=eta*(dayx0-rooe*dayx1)
      dayy=eta*(dayy0-rooe*dayy1)
      dayz=eta*(dayz0-rooe*dayz1)
      dazx=eta*(dazx0-rooe*dazx1)
      dazy=eta*(dazy0-rooe*dazy1)
      dazz=eta*(dazz0-rooe*dazz1)
      dbxx=eta*(dbxx0-rooe*dbxx1)
      dbxy=eta*(dbxy0-rooe*dbxy1)
      dbxz=eta*(dbxz0-rooe*dbxz1)
      dbyx=eta*(dbyx0-rooe*dbyx1)
      dbyy=eta*(dbyy0-rooe*dbyy1)
      dbyz=eta*(dbyz0-rooe*dbyz1)
      dbzx=eta*(dbzx0-rooe*dbzx1)
      dbzy=eta*(dbzy0-rooe*dbzy1)
      dbzz=eta*(dbzz0-rooe*dbzz1)
      dcxx=eta*(dcxx0-rooe*dcxx1)
      dcxy=eta*(dcxy0-rooe*dcxy1)
      dcxz=eta*(dcxz0-rooe*dcxz1)
      dcyx=eta*(dcyx0-rooe*dcyx1)
      dcyy=eta*(dcyy0-rooe*dcyy1)
      dcyz=eta*(dcyz0-rooe*dcyz1)
      dczx=eta*(dczx0-rooe*dczx1)
      dczy=eta*(dczy0-rooe*dczy1)
      dczz=eta*(dczz0-rooe*dczz1)
      ddxx=eta*(ddxx0-rooe*ddxx1)
      ddxy=eta*(ddxy0-rooe*ddxy1)
      ddxz=eta*(ddxz0-rooe*ddxz1)
      ddyx=eta*(ddyx0-rooe*ddyx1)
      ddyy=eta*(ddyy0-rooe*ddyy1)
      ddyz=eta*(ddyz0-rooe*ddyz1)
      ddzx=eta*(ddzx0-rooe*ddzx1)
      ddzy=eta*(ddzy0-rooe*ddzy1)
      ddzz=eta*(ddzz0-rooe*ddzz1)
      dexx=eta*(dexx0-rooe*dexx1)
      dexy=eta*(dexy0-rooe*dexy1)
      dexz=eta*(dexz0-rooe*dexz1)
      deyx=eta*(deyx0-rooe*deyx1)
      deyy=eta*(deyy0-rooe*deyy1)
      deyz=eta*(deyz0-rooe*deyz1)
      dezx=eta*(dezx0-rooe*dezx1)
      dezy=eta*(dezy0-rooe*dezy1)
      dezz=eta*(dezz0-rooe*dezz1)
      dfxx=eta*(dfxx0-rooe*dfxx1)
      dfxy=eta*(dfxy0-rooe*dfxy1)
      dfxz=eta*(dfxz0-rooe*dfxz1)
      dfyx=eta*(dfyx0-rooe*dfyx1)
      dfyy=eta*(dfyy0-rooe*dfyy1)
      dfyz=eta*(dfyz0-rooe*dfyz1)
      dfzx=eta*(dfzx0-rooe*dfzx1)
      dfzy=eta*(dfzy0-rooe*dfzy1)
      dfzz=eta*(dfzz0-rooe*dfzz1)
      eaxx=eta*(eaxx0-rooe*eaxx1)
      eaxy=eta*(eaxy0-rooe*eaxy1)
      eaxz=eta*(eaxz0-rooe*eaxz1)
      eayx=eta*(eayx0-rooe*eayx1)
      eayy=eta*(eayy0-rooe*eayy1)
      eayz=eta*(eayz0-rooe*eayz1)
      eazx=eta*(eazx0-rooe*eazx1)
      eazy=eta*(eazy0-rooe*eazy1)
      eazz=eta*(eazz0-rooe*eazz1)
      ebxx=eta*(ebxx0-rooe*ebxx1)
      ebxy=eta*(ebxy0-rooe*ebxy1)
      ebxz=eta*(ebxz0-rooe*ebxz1)
      ebyx=eta*(ebyx0-rooe*ebyx1)
      ebyy=eta*(ebyy0-rooe*ebyy1)
      ebyz=eta*(ebyz0-rooe*ebyz1)
      ebzx=eta*(ebzx0-rooe*ebzx1)
      ebzy=eta*(ebzy0-rooe*ebzy1)
      ebzz=eta*(ebzz0-rooe*ebzz1)
      ecxx=eta*(ecxx0-rooe*ecxx1)
      ecxy=eta*(ecxy0-rooe*ecxy1)
      ecxz=eta*(ecxz0-rooe*ecxz1)
      ecyx=eta*(ecyx0-rooe*ecyx1)
      ecyy=eta*(ecyy0-rooe*ecyy1)
      ecyz=eta*(ecyz0-rooe*ecyz1)
      eczx=eta*(eczx0-rooe*eczx1)
      eczy=eta*(eczy0-rooe*eczy1)
      eczz=eta*(eczz0-rooe*eczz1)
      edxx=eta*(edxx0-rooe*edxx1)
      edxy=eta*(edxy0-rooe*edxy1)
      edxz=eta*(edxz0-rooe*edxz1)
      edyx=eta*(edyx0-rooe*edyx1)
      edyy=eta*(edyy0-rooe*edyy1)
      edyz=eta*(edyz0-rooe*edyz1)
      edzx=eta*(edzx0-rooe*edzx1)
      edzy=eta*(edzy0-rooe*edzy1)
      edzz=eta*(edzz0-rooe*edzz1)
      eexx=eta*(eexx0-rooe*eexx1)
      eexy=eta*(eexy0-rooe*eexy1)
      eexz=eta*(eexz0-rooe*eexz1)
      eeyx=eta*(eeyx0-rooe*eeyx1)
      eeyy=eta*(eeyy0-rooe*eeyy1)
      eeyz=eta*(eeyz0-rooe*eeyz1)
      eezx=eta*(eezx0-rooe*eezx1)
      eezy=eta*(eezy0-rooe*eezy1)
      eezz=eta*(eezz0-rooe*eezz1)
      efxx=eta*(efxx0-rooe*efxx1)
      efxy=eta*(efxy0-rooe*efxy1)
      efxz=eta*(efxz0-rooe*efxz1)
      efyx=eta*(efyx0-rooe*efyx1)
      efyy=eta*(efyy0-rooe*efyy1)
      efyz=eta*(efyz0-rooe*efyz1)
      efzx=eta*(efzx0-rooe*efzx1)
      efzy=eta*(efzy0-rooe*efzy1)
      efzz=eta*(efzz0-rooe*efzz1)
      faxx=eta*(faxx0-rooe*faxx1)
      faxy=eta*(faxy0-rooe*faxy1)
      faxz=eta*(faxz0-rooe*faxz1)
      fayx=eta*(fayx0-rooe*fayx1)
      fayy=eta*(fayy0-rooe*fayy1)
      fayz=eta*(fayz0-rooe*fayz1)
      fazx=eta*(fazx0-rooe*fazx1)
      fazy=eta*(fazy0-rooe*fazy1)
      fazz=eta*(fazz0-rooe*fazz1)
      fbxx=eta*(fbxx0-rooe*fbxx1)
      fbxy=eta*(fbxy0-rooe*fbxy1)
      fbxz=eta*(fbxz0-rooe*fbxz1)
      fbyx=eta*(fbyx0-rooe*fbyx1)
      fbyy=eta*(fbyy0-rooe*fbyy1)
      fbyz=eta*(fbyz0-rooe*fbyz1)
      fbzx=eta*(fbzx0-rooe*fbzx1)
      fbzy=eta*(fbzy0-rooe*fbzy1)
      fbzz=eta*(fbzz0-rooe*fbzz1)
      fcxx=eta*(fcxx0-rooe*fcxx1)
      fcxy=eta*(fcxy0-rooe*fcxy1)
      fcxz=eta*(fcxz0-rooe*fcxz1)
      fcyx=eta*(fcyx0-rooe*fcyx1)
      fcyy=eta*(fcyy0-rooe*fcyy1)
      fcyz=eta*(fcyz0-rooe*fcyz1)
      fczx=eta*(fczx0-rooe*fczx1)
      fczy=eta*(fczy0-rooe*fczy1)
      fczz=eta*(fczz0-rooe*fczz1)
      fdxx=eta*(fdxx0-rooe*fdxx1)
      fdxy=eta*(fdxy0-rooe*fdxy1)
      fdxz=eta*(fdxz0-rooe*fdxz1)
      fdyx=eta*(fdyx0-rooe*fdyx1)
      fdyy=eta*(fdyy0-rooe*fdyy1)
      fdyz=eta*(fdyz0-rooe*fdyz1)
      fdzx=eta*(fdzx0-rooe*fdzx1)
      fdzy=eta*(fdzy0-rooe*fdzy1)
      fdzz=eta*(fdzz0-rooe*fdzz1)
      fexx=eta*(fexx0-rooe*fexx1)
      fexy=eta*(fexy0-rooe*fexy1)
      fexz=eta*(fexz0-rooe*fexz1)
      feyx=eta*(feyx0-rooe*feyx1)
      feyy=eta*(feyy0-rooe*feyy1)
      feyz=eta*(feyz0-rooe*feyz1)
      fezx=eta*(fezx0-rooe*fezx1)
      fezy=eta*(fezy0-rooe*fezy1)
      fezz=eta*(fezz0-rooe*fezz1)
      ffxx=eta*(ffxx0-rooe*ffxx1)
      ffxy=eta*(ffxy0-rooe*ffxy1)
      ffxz=eta*(ffxz0-rooe*ffxz1)
      ffyx=eta*(ffyx0-rooe*ffyx1)
      ffyy=eta*(ffyy0-rooe*ffyy1)
      ffyz=eta*(ffyz0-rooe*ffyz1)
      ffzx=eta*(ffzx0-rooe*ffzx1)
      ffzy=eta*(ffzy0-rooe*ffzy1)
      ffzz=eta*(ffzz0-rooe*ffzz1)



!dddd

      dx = qdx
      dy = qdy
      dz = qdz
 
      tw = 2.d0

      ec(   1)=ec(   1)+dx*aaax0+wqx*aaax1+tw*xaax+tw*axax+tw*aaxx+aaa
      ec(   2)=ec(   2)+dy*aaay0+wqy*aaay1                        +aaa
      ec(   3)=ec(   3)+dz*aaaz0+wqz*aaaz1                        +aaa
      ec(   4)=ec(   4)+dy*aaax0+wqy*aaax1
      ec(   5)=ec(   5)+dz*aaax0+wqz*aaax1
      ec(   6)=ec(   6)+dy*aaaz0+wqy*aaaz1
      ec(   7)=ec(   7)+dx*aabx0+wqx*aabx1+tw*xabx+tw*axbx        +aab
      ec(   8)=ec(   8)+dy*aaby0+wqy*aaby1                +tw*aayy+aab
      ec(   9)=ec(   9)+dz*aabz0+wqz*aabz1                        +aab
      ec(  10)=ec(  10)+dy*aabx0+wqy*aabx1                +tw*aayx
      ec(  11)=ec(  11)+dz*aabx0+wqz*aabx1
      ec(  12)=ec(  12)+dz*aaby0+wqz*aaby1
      ec(  13)=ec(  13)+dx*aacx0+wqx*aacx1+tw*xacx+tw*axcx        +aac
      ec(  14)=ec(  14)+dy*aacy0+wqy*aacy1                        +aac
      ec(  15)=ec(  15)+dz*aacz0+wqz*aacz1                +tw*aazz+aac
      ec(  16)=ec(  16)+dy*aacx0+wqy*aacx1
      ec(  17)=ec(  17)+dz*aacx0+wqz*aacx1                +tw*aazx
      ec(  18)=ec(  18)+dy*aacz0+wqy*aacz1
      ec(  19)=ec(  19)+dx*aadx0+wqx*aadx1+tw*xadx+tw*axdx+   aayx+aad
      ec(  20)=ec(  20)+dy*aady0+wqy*aady1                +   aaxy+aad
      ec(  21)=ec(  21)+dz*aadz0+wqz*aadz1                        +aad
      ec(  22)=ec(  22)+dy*aadx0+wqy*aadx1                +   aaxx  
      ec(  23)=ec(  23)+dz*aadx0+wqz*aadx1
      ec(  24)=ec(  24)+dz*aady0+wqz*aady1
      ec(  25)=ec(  25)+dx*aaex0+wqx*aaex1+tw*xaex+tw*axex+   aazx+aae
      ec(  26)=ec(  26)+dy*aaey0+wqy*aaey1                        +aae
      ec(  27)=ec(  27)+dz*aaez0+wqz*aaez1                +   aaxz+aae
      ec(  28)=ec(  28)+dy*aaex0+wqy*aaex1                  
      ec(  29)=ec(  29)+dz*aaex0+wqz*aaex1                +   aaxx
      ec(  30)=ec(  30)+dy*aaez0+wqy*aaez1
      ec(  31)=ec(  31)+dx*aafx0+wqx*aafx1+tw*xafx+tw*axfx        +aaf
      ec(  32)=ec(  32)+dy*aafy0+wqy*aafy1                +   aazy+aaf
      ec(  33)=ec(  33)+dz*aafz0+wqz*aafz1                +   aayz+aaf
      ec(  34)=ec(  34)+dy*aafx0+wqy*aafx1                +   aazx  
      ec(  35)=ec(  35)+dz*aafx0+wqz*aafx1                +   aayx  
      ec(  36)=ec(  36)+dy*aafz0+wqy*aafz1                +   aazz  
                              
      ec(  37)=ec(  37)+dx*abax0+wqx*abax1+tw*xbax        +tw*abxx+aba
      ec(  38)=ec(  38)+dy*abay0+wqy*abay1        +tw*ayay        +aba
      ec(  39)=ec(  39)+dz*abaz0+wqz*abaz1                        +aba
      ec(  40)=ec(  40)+dy*abax0+wqy*abax1        +tw*ayax
      ec(  41)=ec(  41)+dz*abax0+wqz*abax1
      ec(  42)=ec(  42)+dz*abay0+wqz*abay1
      ec(  43)=ec(  43)+dx*abbx0+wqx*abbx1+tw*xbbx                +abb
      ec(  44)=ec(  44)+dy*abby0+wqy*abby1        +tw*ayby+tw*abyy+abb
      ec(  45)=ec(  45)+dz*abbz0+wqz*abbz1                        +abb
      ec(  46)=ec(  46)+dx*abby0+wqx*abby1+tw*xbby
      ec(  47)=ec(  47)+dz*abbx0+wqz*abbx1
      ec(  48)=ec(  48)+dz*abby0+wqz*abby1
      ec(  49)=ec(  49)+dx*abcx0+wqx*abcx1+tw*xbcx                +abc
      ec(  50)=ec(  50)+dy*abcy0+wqy*abcy1        +tw*aycy        +abc
      ec(  51)=ec(  51)+dz*abcz0+wqz*abcz1        +tw*abzz        +abc
      ec(  52)=ec(  52)+dx*abcy0+wqx*abcy1+tw*xbcy
      ec(  53)=ec(  53)+dx*abcz0+wqx*abcz1+tw*xbcz
      ec(  54)=ec(  54)+dy*abcz0+wqy*abcz1        +tw*aycz
      ec(  55)=ec(  55)+dx*abdx0+wqx*abdx1+tw*xbdx        +   abyx+abd
      ec(  56)=ec(  56)+dy*abdy0+wqy*abdy1        +tw*aydy+   abxy+abd
      ec(  57)=ec(  57)+dz*abdz0+wqz*abdz1                        +abd
      ec(  58)=ec(  58)+dx*abdy0+wqx*abdy1+tw*xbdy        +   abyy
      ec(  59)=ec(  59)+dz*abdx0+wqz*abdx1
      ec(  60)=ec(  60)+dz*abdy0+wqz*abdy1
      ec(  61)=ec(  61)+dx*abex0+wqx*abex1+tw*xbex        +   abzx+abe
      ec(  62)=ec(  62)+dy*abey0+wqy*abey1        +tw*ayey        +abe
      ec(  63)=ec(  63)+dz*abez0+wqz*abez1                +   abxz+abe
      ec(  64)=ec(  64)+dy*abex0+wqy*abex1        +tw*ayex
      ec(  65)=ec(  65)+dz*abex0+wqz*abex1                +   abxx
      ec(  66)=ec(  66)+dz*abey0+wqz*abey1                +   abxy
      ec(  67)=ec(  67)+dx*abfx0+wqx*abfx1+tw*xbfx                +abf
      ec(  68)=ec(  68)+dy*abfy0+wqy*abfy1        +tw*ayfy+   abzy+abf
      ec(  69)=ec(  69)+dz*abfz0+wqz*abfz1                +   abyz+abf
      ec(  70)=ec(  70)+dx*abfy0+wqx*abfy1+tw*xbfy
      ec(  71)=ec(  71)+dz*abfx0+wqz*abfx1                +   abyx
      ec(  72)=ec(  72)+dz*abfy0+wqz*abfy1                +   abyy
                                                  
      ec(  73)=ec(  73)+dx*acax0+wqx*acax1+tw*xcax        +tw*acxx+aca
      ec(  74)=ec(  74)+dy*acay0+wqy*acay1                        +aca
      ec(  75)=ec(  75)+dz*acaz0+wqz*acaz1        +tw*azaz        +aca
      ec(  76)=ec(  76)+dy*acax0+wqy*acax1                        
      ec(  77)=ec(  77)+dz*acax0+wqz*acax1        +tw*azax 
      ec(  78)=ec(  78)+dy*acaz0+wqy*acaz1
      ec(  79)=ec(  79)+dx*acbx0+wqx*acbx1+tw*xcbx                +acb
      ec(  80)=ec(  80)+dy*acby0+wqy*acby1                +tw*acyy+acb
      ec(  81)=ec(  81)+dz*acbz0+wqz*acbz1        +tw*azbz        +acb
      ec(  82)=ec(  82)+dx*acby0+wqx*acby1+tw*xcby
      ec(  83)=ec(  83)+dx*acbz0+wqx*acbz1+tw*xcbz
      ec(  84)=ec(  84)+dy*acbz0+wqy*acbz1                +tw*acyz  
      ec(  85)=ec(  85)+dx*accx0+wqx*accx1+tw*xccx                +acc
      ec(  86)=ec(  86)+dy*accy0+wqy*accy1                        +acc
      ec(  87)=ec(  87)+dz*accz0+wqz*accz1        +tw*azcz+tw*aczz+acc
      ec(  88)=ec(  88)+dy*accx0+wqy*accx1
      ec(  89)=ec(  89)+dx*accz0+wqx*accz1+tw*xccz
      ec(  90)=ec(  90)+dy*accz0+wqy*accz1
      ec(  91)=ec(  91)+dx*acdx0+wqx*acdx1+tw*xcdx        +   acyx+acd
      ec(  92)=ec(  92)+dy*acdy0+wqy*acdy1                +   acxy+acd
      ec(  93)=ec(  93)+dz*acdz0+wqz*acdz1        +tw*azdz        +acd
      ec(  94)=ec(  94)+dy*acdx0+wqy*acdx1                +   acxx  
      ec(  95)=ec(  95)+dz*acdx0+wqz*acdx1        +tw*azdx
      ec(  96)=ec(  96)+dy*acdz0+wqy*acdz1                +   acxz  
      ec(  97)=ec(  97)+dx*acex0+wqx*acex1+tw*xcex        +   aczx+ace
      ec(  98)=ec(  98)+dy*acey0+wqy*acey1                        +ace
      ec(  99)=ec(  99)+dz*acez0+wqz*acez1        +tw*azez+   acxz+ace
      ec( 100)=ec( 100)+dy*acex0+wqy*acex1
      ec( 101)=ec( 101)+dz*acex0+wqz*acex1        +tw*azex+   acxx
      ec( 102)=ec( 102)+dy*acez0+wqy*acez1
      ec( 103)=ec( 103)+dx*acfx0+wqx*acfx1+tw*xcfx                +acf
      ec( 104)=ec( 104)+dy*acfy0+wqy*acfy1                +   aczy+acf
      ec( 105)=ec( 105)+dz*acfz0+wqz*acfz1        +tw*azfz+   acyz+acf
      ec( 106)=ec( 106)+dy*acfx0+wqy*acfx1                +   aczx
      ec( 107)=ec( 107)+dx*acfz0+wqx*acfz1+tw*xcfz
      ec( 108)=ec( 108)+dy*acfz0+wqy*acfz1                +   aczz
  
      ec( 109)=ec( 109)+dx*adax0+wqx*adax1+tw*xdax+   ayax+tw*adxx+ada
      ec( 110)=ec( 110)+dy*aday0+wqy*aday1        +   axay        +ada
      ec( 111)=ec( 111)+dz*adaz0+wqz*adaz1                        +ada
      ec( 112)=ec( 112)+dy*adax0+wqy*adax1        +   axax
      ec( 113)=ec( 113)+dz*adax0+wqz*adax1
      ec( 114)=ec( 114)+dz*aday0+wqz*aday1
      ec( 115)=ec( 115)+dx*adbx0+wqx*adbx1+tw*xdbx+   aybx        +adb
      ec( 116)=ec( 116)+dy*adby0+wqy*adby1        +   axby+tw*adyy+adb
      ec( 117)=ec( 117)+dz*adbz0+wqz*adbz1                        +adb
      ec( 118)=ec( 118)+dx*adby0+wqx*adby1+tw*xdby+   ayby
      ec( 119)=ec( 119)+dz*adbx0+wqz*adbx1
      ec( 120)=ec( 120)+dz*adby0+wqz*adby1
      ec( 121)=ec( 121)+dx*adcx0+wqx*adcx1+tw*xdcx+   aycx        +adc
      ec( 122)=ec( 122)+dy*adcy0+wqy*adcy1        +   axcy        +adc
      ec( 123)=ec( 123)+dz*adcz0+wqz*adcz1                +tw*adzz+adc
      ec( 124)=ec( 124)+dy*adcx0+wqy*adcx1        +   axcx
      ec( 125)=ec( 125)+dz*adcx0+wqz*adcx1                +tw*adzx
      ec( 126)=ec( 126)+dy*adcz0+wqy*adcz1        +   axcz
      ec( 127)=ec( 127)+dx*addx0+wqx*addx1+tw*xddx+   aydx+   adyx+add
      ec( 128)=ec( 128)+dy*addy0+wqy*addy1        +   axdy+   adxy+add
      ec( 129)=ec( 129)+dz*addz0+wqz*addz1                        +add
      ec( 130)=ec( 130)+dy*addx0+wqy*addx1        +   axdx+   adxx  
      ec( 131)=ec( 131)+dz*addx0+wqz*addx1
      ec( 132)=ec( 132)+dz*addy0+wqz*addy1
      ec( 133)=ec( 133)+dx*adex0+wqx*adex1+tw*xdex+   ayex+   adzx+ade
      ec( 134)=ec( 134)+dy*adey0+wqy*adey1        +   axey        +ade
      ec( 135)=ec( 135)+dz*adez0+wqz*adez1                +   adxz+ade
      ec( 136)=ec( 136)+dy*adex0+wqy*adex1        +   axex
      ec( 137)=ec( 137)+dz*adex0+wqz*adex1                +   adxx
      ec( 138)=ec( 138)+dy*adez0+wqy*adez1        +   axez
      ec( 139)=ec( 139)+dx*adfx0+wqx*adfx1+tw*xdfx+   ayfx        +adf
      ec( 140)=ec( 140)+dy*adfy0+wqy*adfy1        +   axfy+   adzy+adf
      ec( 141)=ec( 141)+dz*adfz0+wqz*adfz1                +   adyz+adf
      ec( 142)=ec( 142)+dy*adfx0+wqy*adfx1        +   axfx+   adzx
      ec( 143)=ec( 143)+dz*adfx0+wqz*adfx1                +   adyx  
      ec( 144)=ec( 144)+dz*adfy0+wqz*adfy1                +   adyy  
                                                  
      ec( 145)=ec( 145)+dx*aeax0+wqx*aeax1+tw*xeax+   azax+tw*aexx+aea
      ec( 146)=ec( 146)+dy*aeay0+wqy*aeay1                        +aea
      ec( 147)=ec( 147)+dz*aeaz0+wqz*aeaz1        +   axaz        +aea
      ec( 148)=ec( 148)+dy*aeax0+wqy*aeax1
      ec( 149)=ec( 149)+dz*aeax0+wqz*aeax1        +   axax
      ec( 150)=ec( 150)+dy*aeaz0+wqy*aeaz1
      ec( 151)=ec( 151)+dx*aebx0+wqx*aebx1+tw*xebx+   azbx        +aeb
      ec( 152)=ec( 152)+dy*aeby0+wqy*aeby1                +tw*aeyy+aeb
      ec( 153)=ec( 153)+dz*aebz0+wqz*aebz1        +   axbz        +aeb
      ec( 154)=ec( 154)+dy*aebx0+wqy*aebx1                +tw*aeyx
      ec( 155)=ec( 155)+dz*aebx0+wqz*aebx1        +   axbx
      ec( 156)=ec( 156)+dz*aeby0+wqz*aeby1        +   axby
      ec( 157)=ec( 157)+dx*aecx0+wqx*aecx1+tw*xecx+   azcx        +aec
      ec( 158)=ec( 158)+dy*aecy0+wqy*aecy1                        +aec
      ec( 159)=ec( 159)+dz*aecz0+wqz*aecz1        +   axcz+tw*aezz+aec
      ec( 160)=ec( 160)+dy*aecx0+wqy*aecx1
      ec( 161)=ec( 161)+dx*aecz0+wqx*aecz1+tw*xecz+   azcz
      ec( 162)=ec( 162)+dy*aecz0+wqy*aecz1
      ec( 163)=ec( 163)+dx*aedx0+wqx*aedx1+tw*xedx+   azdx+   aeyx+aed
      ec( 164)=ec( 164)+dy*aedy0+wqy*aedy1                +   aexy+aed
      ec( 165)=ec( 165)+dz*aedz0+wqz*aedz1        +   axdz        +aed
      ec( 166)=ec( 166)+dy*aedx0+wqy*aedx1                +   aexx  
      ec( 167)=ec( 167)+dz*aedx0+wqz*aedx1        +   axdx
      ec( 168)=ec( 168)+dz*aedy0+wqz*aedy1        +   axdy
      ec( 169)=ec( 169)+dx*aeex0+wqx*aeex1+tw*xeex+   azex+   aezx+aee
      ec( 170)=ec( 170)+dy*aeey0+wqy*aeey1                        +aee
      ec( 171)=ec( 171)+dz*aeez0+wqz*aeez1        +   axez+   aexz+aee
      ec( 172)=ec( 172)+dy*aeex0+wqy*aeex1
      ec( 173)=ec( 173)+dz*aeex0+wqz*aeex1        +   axex+   aexx
      ec( 174)=ec( 174)+dy*aeez0+wqy*aeez1
      ec( 175)=ec( 175)+dx*aefx0+wqx*aefx1+tw*xefx+   azfx        +aef
      ec( 176)=ec( 176)+dy*aefy0+wqy*aefy1                +   aezy+aef
      ec( 177)=ec( 177)+dz*aefz0+wqz*aefz1        +   axfz+   aeyz+aef
      ec( 178)=ec( 178)+dy*aefx0+wqy*aefx1                +   aezx
      ec( 179)=ec( 179)+dz*aefx0+wqz*aefx1        +   axfx+   aeyx
      ec( 180)=ec( 180)+dy*aefz0+wqy*aefz1                +   aezz
                                                  
      ec( 181)=ec( 181)+dx*afax0+wqx*afax1+tw*xfax        +tw*afxx+afa
      ec( 182)=ec( 182)+dy*afay0+wqy*afay1        +   azay        +afa
      ec( 183)=ec( 183)+dz*afaz0+wqz*afaz1        +   ayaz        +afa
      ec( 184)=ec( 184)+dy*afax0+wqy*afax1        +   azax
      ec( 185)=ec( 185)+dz*afax0+wqz*afax1        +   ayax
      ec( 186)=ec( 186)+dy*afaz0+wqy*afaz1        +   azaz
      ec( 187)=ec( 187)+dx*afbx0+wqx*afbx1+tw*xfbx                +afb
      ec( 188)=ec( 188)+dy*afby0+wqy*afby1        +   azby+tw*afyy+afb
      ec( 189)=ec( 189)+dz*afbz0+wqz*afbz1        +   aybz        +afb
      ec( 190)=ec( 190)+dx*afby0+wqx*afby1+tw*xfby
      ec( 191)=ec( 191)+dz*afbx0+wqz*afbx1        +   aybx
      ec( 192)=ec( 192)+dz*afby0+wqz*afby1        +   ayby
      ec( 193)=ec( 193)+dx*afcx0+wqx*afcx1+tw*xfcx                +afc
      ec( 194)=ec( 194)+dy*afcy0+wqy*afcy1        +   azcy        +afc
      ec( 195)=ec( 195)+dz*afcz0+wqz*afcz1        +   aycz+tw*afzz+afc
      ec( 196)=ec( 196)+dy*afcx0+wqy*afcx1        +   azcx
      ec( 197)=ec( 197)+dx*afcz0+wqx*afcz1+tw*xfcz
      ec( 198)=ec( 198)+dy*afcz0+wqy*afcz1        +   azcz
      ec( 199)=ec( 199)+dx*afdx0+wqx*afdx1+tw*xfdx        +   afyx+afd
      ec( 200)=ec( 200)+dy*afdy0+wqy*afdy1        +   azdy+   afxy+afd
      ec( 201)=ec( 201)+dz*afdz0+wqz*afdz1        +   aydz        +afd
      ec( 202)=ec( 202)+dy*afdx0+wqy*afdx1        +   azdx+   afxx  
      ec( 203)=ec( 203)+dz*afdx0+wqz*afdx1        +   aydx
      ec( 204)=ec( 204)+dz*afdy0+wqz*afdy1        +   aydy
      ec( 205)=ec( 205)+dx*afex0+wqx*afex1+tw*xfex        +   afzx+afe
      ec( 206)=ec( 206)+dy*afey0+wqy*afey1        +   azey        +afe
      ec( 207)=ec( 207)+dz*afez0+wqz*afez1        +   ayez+   afxz+afe
      ec( 208)=ec( 208)+dy*afex0+wqy*afex1        +   azex
      ec( 209)=ec( 209)+dz*afex0+wqz*afex1        +   ayex+   afxx
      ec( 210)=ec( 210)+dy*afez0+wqy*afez1        +   azez
      ec( 211)=ec( 211)+dx*affx0+wqx*affx1+tw*xffx                +aff
      ec( 212)=ec( 212)+dy*affy0+wqy*affy1        +   azfy+   afzy+aff
      ec( 213)=ec( 213)+dz*affz0+wqz*affz1        +   ayfz+   afyz+aff
      ec( 214)=ec( 214)+dx*affy0+wqx*affy1+tw*xffy
      ec( 215)=ec( 215)+dx*affz0+wqx*affz1+tw*xffz
      ec( 216)=ec( 216)+dy*affz0+wqy*affz1        +   azfz+   afzz
                                           
      ec( 217)=ec( 217)+dx*baax0+wqx*baax1        +tw*bxax+tw*baxx+baa
      ec( 218)=ec( 218)+dy*baay0+wqy*baay1+tw*yaay                +baa
      ec( 219)=ec( 219)+dz*baaz0+wqz*baaz1                        +baa
      ec( 220)=ec( 220)+dy*baax0+wqy*baax1+tw*yaax
      ec( 221)=ec( 221)+dz*baax0+wqz*baax1
      ec( 222)=ec( 222)+dz*baay0+wqz*baay1
      ec( 223)=ec( 223)+dx*babx0+wqx*babx1        +tw*bxbx        +bab
      ec( 224)=ec( 224)+dy*baby0+wqy*baby1+tw*yaby        +tw*bayy+bab
      ec( 225)=ec( 225)+dz*babz0+wqz*babz1                        +bab
      ec( 226)=ec( 226)+dx*baby0+wqx*baby1        +tw*bxby
      ec( 227)=ec( 227)+dz*babx0+wqz*babx1
      ec( 228)=ec( 228)+dz*baby0+wqz*baby1
      ec( 229)=ec( 229)+dx*bacx0+wqx*bacx1        +tw*bxcx        +bac
      ec( 230)=ec( 230)+dy*bacy0+wqy*bacy1+tw*yacy                +bac
      ec( 231)=ec( 231)+dz*bacz0+wqz*bacz1                +tw*bazz+bac
      ec( 232)=ec( 232)+dy*bacx0+wqy*bacx1+tw*yacx
      ec( 233)=ec( 233)+dz*bacx0+wqz*bacx1                +tw*bazx
      ec( 234)=ec( 234)+dy*bacz0+wqy*bacz1+tw*yacz
      ec( 235)=ec( 235)+dx*badx0+wqx*badx1        +tw*bxdx+   bayx+bad
      ec( 236)=ec( 236)+dy*bady0+wqy*bady1+tw*yady        +   baxy+bad
      ec( 237)=ec( 237)+dz*badz0+wqz*badz1                        +bad
      ec( 238)=ec( 238)+dy*badx0+wqy*badx1+tw*yadx        +   baxx
      ec( 239)=ec( 239)+dz*badx0+wqz*badx1
      ec( 240)=ec( 240)+dz*bady0+wqz*bady1
      ec( 241)=ec( 241)+dx*baex0+wqx*baex1        +tw*bxex+   bazx+bae
      ec( 242)=ec( 242)+dy*baey0+wqy*baey1+tw*yaey                +bae
      ec( 243)=ec( 243)+dz*baez0+wqz*baez1                +   baxz+bae
      ec( 244)=ec( 244)+dy*baex0+wqy*baex1+tw*yaex    
      ec( 245)=ec( 245)+dz*baex0+wqz*baex1                +   baxx
      ec( 246)=ec( 246)+dz*baey0+wqz*baey1                +   baxy
      ec( 247)=ec( 247)+dx*bafx0+wqx*bafx1        +tw*bxfx        +baf
      ec( 248)=ec( 248)+dy*bafy0+wqy*bafy1+tw*yafy        +   bazy+baf
      ec( 249)=ec( 249)+dz*bafz0+wqz*bafz1                +   bayz+baf
      ec( 250)=ec( 250)+dx*bafy0+wqx*bafy1        +tw*bxfy
      ec( 251)=ec( 251)+dz*bafx0+wqz*bafx1                +   bayx
      ec( 252)=ec( 252)+dz*bafy0+wqz*bafy1                +   bayy
                                                  
      ec( 253)=ec( 253)+dx*bbax0+wqx*bbax1                +tw*bbxx+bba
      ec( 254)=ec( 254)+dy*bbay0+wqy*bbay1+tw*ybay+tw*byay        +bba
      ec( 255)=ec( 255)+dz*bbaz0+wqz*bbaz1                        +bba
      ec( 256)=ec( 256)+dx*bbay0+wqx*bbay1                +tw*bbxy
      ec( 257)=ec( 257)+dz*bbax0+wqz*bbax1
      ec( 258)=ec( 258)+dz*bbay0+wqz*bbay1
      ec( 259)=ec( 259)+dx*bbbx0+wqx*bbbx1                        +bbb
      ec( 260)=ec( 260)+dy*bbby0+wqy*bbby1+tw*ybby+tw*byby+tw*bbyy+bbb
      ec( 261)=ec( 261)+dz*bbbz0+wqz*bbbz1                        +bbb
      ec( 262)=ec( 262)+dx*bbby0+wqx*bbby1
      ec( 263)=ec( 263)+dz*bbbx0+wqz*bbbx1
      ec( 264)=ec( 264)+dz*bbby0+wqz*bbby1
      ec( 265)=ec( 265)+dx*bbcx0+wqx*bbcx1                        +bbc
      ec( 266)=ec( 266)+dy*bbcy0+wqy*bbcy1+tw*ybcy+tw*bycy        +bbc
      ec( 267)=ec( 267)+dz*bbcz0+wqz*bbcz1                +tw*bbzz+bbc
      ec( 268)=ec( 268)+dx*bbcy0+wqx*bbcy1
      ec( 269)=ec( 269)+dz*bbcx0+wqz*bbcx1                +tw*bbzx
      ec( 270)=ec( 270)+dz*bbcy0+wqz*bbcy1                +tw*bbzy
      ec( 271)=ec( 271)+dx*bbdx0+wqx*bbdx1                +   bbyx+bbd
      ec( 272)=ec( 272)+dy*bbdy0+wqy*bbdy1+tw*ybdy+tw*bydy+   bbxy+bbd
      ec( 273)=ec( 273)+dz*bbdz0+wqz*bbdz1                        +bbd
      ec( 274)=ec( 274)+dx*bbdy0+wqx*bbdy1                +   bbyy
      ec( 275)=ec( 275)+dz*bbdx0+wqz*bbdx1
      ec( 276)=ec( 276)+dz*bbdy0+wqz*bbdy1
      ec( 277)=ec( 277)+dx*bbex0+wqx*bbex1                +   bbzx+bbe
      ec( 278)=ec( 278)+dy*bbey0+wqy*bbey1+tw*ybey+tw*byey        +bbe
      ec( 279)=ec( 279)+dz*bbez0+wqz*bbez1                +   bbxz+bbe
      ec( 280)=ec( 280)+dx*bbey0+wqx*bbey1                +   bbzy
      ec( 281)=ec( 281)+dx*bbez0+wqx*bbez1                +   bbzz
      ec( 282)=ec( 282)+dz*bbey0+wqz*bbey1                +   bbxy
      ec( 283)=ec( 283)+dx*bbfx0+wqx*bbfx1                        +bbf
      ec( 284)=ec( 284)+dy*bbfy0+wqy*bbfy1+tw*ybfy+tw*byfy+   bbzy+bbf
      ec( 285)=ec( 285)+dz*bbfz0+wqz*bbfz1                +   bbyz+bbf
      ec( 286)=ec( 286)+dx*bbfy0+wqx*bbfy1
      ec( 287)=ec( 287)+dx*bbfz0+wqx*bbfz1
      ec( 288)=ec( 288)+dz*bbfy0+wqz*bbfy1                      + bbyy
                                                  
      ec( 289)=ec( 289)+dx*bcax0+wqx*bcax1                +tw*bcxx+bca
      ec( 290)=ec( 290)+dy*bcay0+wqy*bcay1+tw*ycay                +bca
      ec( 291)=ec( 291)+dz*bcaz0+wqz*bcaz1        +tw*bzaz        +bca
      ec( 292)=ec( 292)+dy*bcax0+wqy*bcax1+tw*ycax
      ec( 293)=ec( 293)+dz*bcax0+wqz*bcax1        +tw*bzax
      ec( 294)=ec( 294)+dy*bcaz0+wqy*bcaz1+tw*ycaz
      ec( 295)=ec( 295)+dx*bcbx0+wqx*bcbx1                        +bcb
      ec( 296)=ec( 296)+dy*bcby0+wqy*bcby1+tw*ycby        +tw*bcyy+bcb
      ec( 297)=ec( 297)+dz*bcbz0+wqz*bcbz1        +tw*bzbz        +bcb
      ec( 298)=ec( 298)+dx*bcby0+wqx*bcby1
      ec( 299)=ec( 299)+dx*bcbz0+wqx*bcbz1
      ec( 300)=ec( 300)+dz*bcby0+wqz*bcby1        +tw*bzby
      ec( 301)=ec( 301)+dx*bccx0+wqx*bccx1                        +bcc
      ec( 302)=ec( 302)+dy*bccy0+wqy*bccy1+tw*yccy                +bcc
      ec( 303)=ec( 303)+dz*bccz0+wqz*bccz1        +tw*bzcz+tw*bczz+bcc
      ec( 304)=ec( 304)+dx*bccy0+wqx*bccy1
      ec( 305)=ec( 305)+dx*bccz0+wqx*bccz1
      ec( 306)=ec( 306)+dy*bccz0+wqy*bccz1+tw*yccz
      ec( 307)=ec( 307)+dx*bcdx0+wqx*bcdx1                +   bcyx+bcd
      ec( 308)=ec( 308)+dy*bcdy0+wqy*bcdy1+tw*ycdy        +   bcxy+bcd
      ec( 309)=ec( 309)+dz*bcdz0+wqz*bcdz1        +tw*bzdz        +bcd
      ec( 310)=ec( 310)+dx*bcdy0+wqx*bcdy1                      + bcyy
      ec( 311)=ec( 311)+dx*bcdz0+wqx*bcdz1                      + bcyz
      ec( 312)=ec( 312)+dz*bcdy0+wqz*bcdy1        +tw*bzdy
      ec( 313)=ec( 313)+dx*bcex0+wqx*bcex1                +   bczx+bce
      ec( 314)=ec( 314)+dy*bcey0+wqy*bcey1+tw*ycey                +bce
      ec( 315)=ec( 315)+dz*bcez0+wqz*bcez1        +tw*bzez+   bcxz+bce
      ec( 316)=ec( 316)+dx*bcey0+wqx*bcey1                +   bczy
      ec( 317)=ec( 317)+dx*bcez0+wqx*bcez1                +   bczz
      ec( 318)=ec( 318)+dy*bcez0+wqy*bcez1+tw*ycez
      ec( 319)=ec( 319)+dx*bcfx0+wqx*bcfx1                        +bcf
      ec( 320)=ec( 320)+dy*bcfy0+wqy*bcfy1+tw*ycfy        +   bczy+bcf
      ec( 321)=ec( 321)+dz*bcfz0+wqz*bcfz1        +tw*bzfz+   bcyz+bcf
      ec( 322)=ec( 322)+dx*bcfy0+wqx*bcfy1
      ec( 323)=ec( 323)+dx*bcfz0+wqx*bcfz1
      ec( 324)=ec( 324)+dy*bcfz0+wqy*bcfz1+tw*ycfz        +   bczz
                                                  
      ec( 325)=ec( 325)+dx*bdax0+wqx*bdax1        +   byax+tw*bdxx+bda
      ec( 326)=ec( 326)+dy*bday0+wqy*bday1+tw*yday+   bxay        +bda
      ec( 327)=ec( 327)+dz*bdaz0+wqz*bdaz1                        +bda
      ec( 328)=ec( 328)+dy*bdax0+wqy*bdax1+tw*ydax+   bxax
      ec( 329)=ec( 329)+dz*bdax0+wqz*bdax1
      ec( 330)=ec( 330)+dz*bday0+wqz*bday1
      ec( 331)=ec( 331)+dx*bdbx0+wqx*bdbx1        +   bybx        +bdb
      ec( 332)=ec( 332)+dy*bdby0+wqy*bdby1+tw*ydby+   bxby+tw*bdyy+bdb
      ec( 333)=ec( 333)+dz*bdbz0+wqz*bdbz1                        +bdb
      ec( 334)=ec( 334)+dx*bdby0+wqx*bdby1        +   byby
      ec( 335)=ec( 335)+dz*bdbx0+wqz*bdbx1
      ec( 336)=ec( 336)+dz*bdby0+wqz*bdby1
      ec( 337)=ec( 337)+dx*bdcx0+wqx*bdcx1        +   bycx        +bdc
      ec( 338)=ec( 338)+dy*bdcy0+wqy*bdcy1+tw*ydcy+   bxcy        +bdc
      ec( 339)=ec( 339)+dz*bdcz0+wqz*bdcz1                +tw*bdzz+bdc
      ec( 340)=ec( 340)+dx*bdcy0+wqx*bdcy1        +   bycy
      ec( 341)=ec( 341)+dx*bdcz0+wqx*bdcz1        +   bycz
      ec( 342)=ec( 342)+dz*bdcy0+wqz*bdcy1                +tw*bdzy
      ec( 343)=ec( 343)+dx*bddx0+wqx*bddx1        +   bydx+   bdyx+bdd
      ec( 344)=ec( 344)+dy*bddy0+wqy*bddy1+tw*yddy+   bxdy+   bdxy+bdd
      ec( 345)=ec( 345)+dz*bddz0+wqz*bddz1                        +bdd
      ec( 346)=ec( 346)+dx*bddy0+wqx*bddy1        +   bydy+   bdyy
      ec( 347)=ec( 347)+dz*bddx0+wqz*bddx1
      ec( 348)=ec( 348)+dz*bddy0+wqz*bddy1
      ec( 349)=ec( 349)+dx*bdex0+wqx*bdex1        +   byex+   bdzx+bde
      ec( 350)=ec( 350)+dy*bdey0+wqy*bdey1+tw*ydey+   bxey        +bde
      ec( 351)=ec( 351)+dz*bdez0+wqz*bdez1                +   bdxz+bde
      ec( 352)=ec( 352)+dx*bdey0+wqx*bdey1        +   byey+   bdzy
      ec( 353)=ec( 353)+dz*bdex0+wqz*bdex1                +   bdxx
      ec( 354)=ec( 354)+dz*bdey0+wqz*bdey1                +   bdxy
      ec( 355)=ec( 355)+dx*bdfx0+wqx*bdfx1        +   byfx        +bdf
      ec( 356)=ec( 356)+dy*bdfy0+wqy*bdfy1+tw*ydfy+   bxfy+   bdzy+bdf
      ec( 357)=ec( 357)+dz*bdfz0+wqz*bdfz1                +   bdyz+bdf
      ec( 358)=ec( 358)+dx*bdfy0+wqx*bdfy1        +   byfy            
      ec( 359)=ec( 359)+dz*bdfx0+wqz*bdfx1                +   bdyx
      ec( 360)=ec( 360)+dz*bdfy0+wqz*bdfy1                +   bdyy
                                                  
      ec( 361)=ec( 361)+dx*beax0+wqx*beax1        +   bzax+tw*bexx+bea
      ec( 362)=ec( 362)+dy*beay0+wqy*beay1+tw*yeay                +bea
      ec( 363)=ec( 363)+dz*beaz0+wqz*beaz1        +   bxaz        +bea
      ec( 364)=ec( 364)+dy*beax0+wqy*beax1+tw*yeax
      ec( 365)=ec( 365)+dz*beax0+wqz*beax1        +   bxax
      ec( 366)=ec( 366)+dy*beaz0+wqy*beaz1+tw*yeaz
      ec( 367)=ec( 367)+dx*bebx0+wqx*bebx1        +   bzbx        +beb
      ec( 368)=ec( 368)+dy*beby0+wqy*beby1+tw*yeby        +tw*beyy+beb
      ec( 369)=ec( 369)+dz*bebz0+wqz*bebz1        +   bxbz        +beb
      ec( 370)=ec( 370)+dx*beby0+wqx*beby1        +   bzby
      ec( 371)=ec( 371)+dz*bebx0+wqz*bebx1        +   bxbx
      ec( 372)=ec( 372)+dz*beby0+wqz*beby1        +   bxby
      ec( 373)=ec( 373)+dx*becx0+wqx*becx1        +   bzcx        +bec
      ec( 374)=ec( 374)+dy*becy0+wqy*becy1+tw*yecy                +bec
      ec( 375)=ec( 375)+dz*becz0+wqz*becz1        +   bxcz+tw*bezz+bec
      ec( 376)=ec( 376)+dx*becy0+wqx*becy1        +   bzcy
      ec( 377)=ec( 377)+dx*becz0+wqx*becz1        +   bzcz
      ec( 378)=ec( 378)+dy*becz0+wqy*becz1+tw*yecz
      ec( 379)=ec( 379)+dx*bedx0+wqx*bedx1        +   bzdx+   beyx+bed
      ec( 380)=ec( 380)+dy*bedy0+wqy*bedy1+tw*yedy        +   bexy+bed
      ec( 381)=ec( 381)+dz*bedz0+wqz*bedz1        +   bxdz        +bed
      ec( 382)=ec( 382)+dx*bedy0+wqx*bedy1        +   bzdy+   beyy
      ec( 383)=ec( 383)+dz*bedx0+wqz*bedx1        +   bxdx
      ec( 384)=ec( 384)+dz*bedy0+wqz*bedy1        +   bxdy
      ec( 385)=ec( 385)+dx*beex0+wqx*beex1        +   bzex+   bezx+bee
      ec( 386)=ec( 386)+dy*beey0+wqy*beey1+tw*yeey                +bee
      ec( 387)=ec( 387)+dz*beez0+wqz*beez1        +   bxez+   bexz+bee
      ec( 388)=ec( 388)+dy*beex0+wqy*beex1+tw*yeex
      ec( 389)=ec( 389)+dx*beez0+wqx*beez1        +   bzez+   bezz
      ec( 390)=ec( 390)+dy*beez0+wqy*beez1+tw*yeez
      ec( 391)=ec( 391)+dx*befx0+wqx*befx1        +   bzfx        +bef
      ec( 392)=ec( 392)+dy*befy0+wqy*befy1+tw*yefy        +   bezy+bef
      ec( 393)=ec( 393)+dz*befz0+wqz*befz1        +   bxfz+   beyz+bef
      ec( 394)=ec( 394)+dx*befy0+wqx*befy1        +   bzfy
      ec( 395)=ec( 395)+dx*befz0+wqx*befz1        +   bzfz
      ec( 396)=ec( 396)+dz*befy0+wqz*befy1        +   bxfy+   beyy
                                                  
      ec( 397)=ec( 397)+dx*bfax0+wqx*bfax1                +tw*bfxx+bfa
      ec( 398)=ec( 398)+dy*bfay0+wqy*bfay1+tw*yfay+   bzay        +bfa
      ec( 399)=ec( 399)+dz*bfaz0+wqz*bfaz1        +   byaz        +bfa
      ec( 400)=ec( 400)+dx*bfay0+wqx*bfay1                +tw*bfxy
      ec( 401)=ec( 401)+dz*bfax0+wqz*bfax1        +   byax
      ec( 402)=ec( 402)+dz*bfay0+wqz*bfay1        +   byay
      ec( 403)=ec( 403)+dx*bfbx0+wqx*bfbx1                        +bfb
      ec( 404)=ec( 404)+dy*bfby0+wqy*bfby1+tw*yfby+   bzby+tw*bfyy+bfb
      ec( 405)=ec( 405)+dz*bfbz0+wqz*bfbz1        +   bybz        +bfb
      ec( 406)=ec( 406)+dx*bfby0+wqx*bfby1
      ec( 407)=ec( 407)+dx*bfbz0+wqx*bfbz1
      ec( 408)=ec( 408)+dz*bfby0+wqz*bfby1        +   byby
      ec( 409)=ec( 409)+dx*bfcx0+wqx*bfcx1                        +bfc
      ec( 410)=ec( 410)+dy*bfcy0+wqy*bfcy1+tw*yfcy+   bzcy        +bfc
      ec( 411)=ec( 411)+dz*bfcz0+wqz*bfcz1        +   bycz+tw*bfzz+bfc
      ec( 412)=ec( 412)+dx*bfcy0+wqx*bfcy1
      ec( 413)=ec( 413)+dx*bfcz0+wqx*bfcz1
      ec( 414)=ec( 414)+dy*bfcz0+wqy*bfcz1+tw*yfcz+   bzcz            
      ec( 415)=ec( 415)+dx*bfdx0+wqx*bfdx1                +   bfyx+bfd
      ec( 416)=ec( 416)+dy*bfdy0+wqy*bfdy1+tw*yfdy+   bzdy+   bfxy+bfd
      ec( 417)=ec( 417)+dz*bfdz0+wqz*bfdz1        +   bydz        +bfd
      ec( 418)=ec( 418)+dx*bfdy0+wqx*bfdy1                +   bfyy
      ec( 419)=ec( 419)+dz*bfdx0+wqz*bfdx1        +   bydx
      ec( 420)=ec( 420)+dz*bfdy0+wqz*bfdy1        +   bydy
      ec( 421)=ec( 421)+dx*bfex0+wqx*bfex1                +   bfzx+bfe
      ec( 422)=ec( 422)+dy*bfey0+wqy*bfey1+tw*yfey+   bzey        +bfe
      ec( 423)=ec( 423)+dz*bfez0+wqz*bfez1        +   byez+   bfxz+bfe
      ec( 424)=ec( 424)+dx*bfey0+wqx*bfey1                +   bfzy
      ec( 425)=ec( 425)+dz*bfex0+wqz*bfex1        +   byex+   bfxx
      ec( 426)=ec( 426)+dz*bfey0+wqz*bfey1        +   byey+   bfxy
      ec( 427)=ec( 427)+dx*bffx0+wqx*bffx1                        +bff
      ec( 428)=ec( 428)+dy*bffy0+wqy*bffy1+tw*yffy+   bzfy+   bfzy+bff
      ec( 429)=ec( 429)+dz*bffz0+wqz*bffz1        +   byfz+   bfyz+bff
      ec( 430)=ec( 430)+dx*bffy0+wqx*bffy1
      ec( 431)=ec( 431)+dx*bffz0+wqx*bffz1
      ec( 432)=ec( 432)+dz*bffy0+wqz*bffy1        +   byfy+   bfyy
                                                  
      ec( 433)=ec( 433)+dx*caax0+wqx*caax1        +tw*cxax+tw*caxx+caa
      ec( 434)=ec( 434)+dy*caay0+wqy*caay1                        +caa
      ec( 435)=ec( 435)+dz*caaz0+wqz*caaz1+tw*zaaz                +caa
      ec( 436)=ec( 436)+dy*caax0+wqy*caax1
      ec( 437)=ec( 437)+dz*caax0+wqz*caax1+tw*zaax   
      ec( 438)=ec( 438)+dy*caaz0+wqy*caaz1
      ec( 439)=ec( 439)+dx*cabx0+wqx*cabx1        +tw*cxbx        +cab
      ec( 440)=ec( 440)+dy*caby0+wqy*caby1                +tw*cayy+cab
      ec( 441)=ec( 441)+dz*cabz0+wqz*cabz1+tw*zabz                +cab
      ec( 442)=ec( 442)+dy*cabx0+wqy*cabx1                +tw*cayx
      ec( 443)=ec( 443)+dz*cabx0+wqz*cabx1+tw*zabx
      ec( 444)=ec( 444)+dy*cabz0+wqy*cabz1                +tw*cayz
      ec( 445)=ec( 445)+dx*cacx0+wqx*cacx1        +tw*cxcx        +cac
      ec( 446)=ec( 446)+dy*cacy0+wqy*cacy1                        +cac
      ec( 447)=ec( 447)+dz*cacz0+wqz*cacz1+tw*zacz        +tw*cazz+cac
      ec( 448)=ec( 448)+dy*cacx0+wqy*cacx1
      ec( 449)=ec( 449)+dx*cacz0+wqx*cacz1        +tw*cxcz
      ec( 450)=ec( 450)+dy*cacz0+wqy*cacz1
      ec( 451)=ec( 451)+dx*cadx0+wqx*cadx1        +tw*cxdx+   cayx+cad
      ec( 452)=ec( 452)+dy*cady0+wqy*cady1                +   caxy+cad
      ec( 453)=ec( 453)+dz*cadz0+wqz*cadz1+tw*zadz                +cad
      ec( 454)=ec( 454)+dy*cadx0+wqy*cadx1                +   caxx
      ec( 455)=ec( 455)+dz*cadx0+wqz*cadx1+tw*zadx
      ec( 456)=ec( 456)+dy*cadz0+wqy*cadz1                +   caxz
      ec( 457)=ec( 457)+dx*caex0+wqx*caex1        +tw*cxex+   cazx+cae
      ec( 458)=ec( 458)+dy*caey0+wqy*caey1                        +cae
      ec( 459)=ec( 459)+dz*caez0+wqz*caez1+tw*zaez        +   caxz+cae
      ec( 460)=ec( 460)+dy*caex0+wqy*caex1
      ec( 461)=ec( 461)+dz*caex0+wqz*caex1+tw*zaex        +   caxx
      ec( 462)=ec( 462)+dy*caez0+wqy*caez1
      ec( 463)=ec( 463)+dx*cafx0+wqx*cafx1        +tw*cxfx        +caf
      ec( 464)=ec( 464)+dy*cafy0+wqy*cafy1                +   cazy+caf
      ec( 465)=ec( 465)+dz*cafz0+wqz*cafz1+tw*zafz        +   cayz+caf
      ec( 466)=ec( 466)+dy*cafx0+wqy*cafx1                +   cazx
      ec( 467)=ec( 467)+dz*cafx0+wqz*cafx1+tw*zafx        +   cayx
      ec( 468)=ec( 468)+dy*cafz0+wqy*cafz1                +   cazz
                                                  
      ec( 469)=ec( 469)+dx*cbax0+wqx*cbax1                +tw*cbxx+cba
      ec( 470)=ec( 470)+dy*cbay0+wqy*cbay1        +tw*cyay        +cba
      ec( 471)=ec( 471)+dz*cbaz0+wqz*cbaz1+tw*zbaz                +cba
      ec( 472)=ec( 472)+dy*cbax0+wqy*cbax1        +tw*cyax
      ec( 473)=ec( 473)+dz*cbax0+wqz*cbax1+tw*zbax
      ec( 474)=ec( 474)+dy*cbaz0+wqy*cbaz1        +tw*cyaz
      ec( 475)=ec( 475)+dx*cbbx0+wqx*cbbx1                        +cbb
      ec( 476)=ec( 476)+dy*cbby0+wqy*cbby1        +tw*cyby+tw*cbyy+cbb
      ec( 477)=ec( 477)+dz*cbbz0+wqz*cbbz1+tw*zbbz                +cbb
      ec( 478)=ec( 478)+dx*cbby0+wqx*cbby1
      ec( 479)=ec( 479)+dx*cbbz0+wqx*cbbz1
      ec( 480)=ec( 480)+dz*cbby0+wqz*cbby1+tw*zbby
      ec( 481)=ec( 481)+dx*cbcx0+wqx*cbcx1                        +cbc
      ec( 482)=ec( 482)+dy*cbcy0+wqy*cbcy1        +tw*cycy        +cbc
      ec( 483)=ec( 483)+dz*cbcz0+wqz*cbcz1+tw*zbcz        +tw*cbzz+cbc
      ec( 484)=ec( 484)+dx*cbcy0+wqx*cbcy1
      ec( 485)=ec( 485)+dx*cbcz0+wqx*cbcz1
      ec( 486)=ec( 486)+dy*cbcz0+wqy*cbcz1        +tw*cycz
      ec( 487)=ec( 487)+dx*cbdx0+wqx*cbdx1                +   cbyx+cbd
      ec( 488)=ec( 488)+dy*cbdy0+wqy*cbdy1        +tw*cydy+   cbxy+cbd
      ec( 489)=ec( 489)+dz*cbdz0+wqz*cbdz1+tw*zbdz                +cbd
      ec( 490)=ec( 490)+dx*cbdy0+wqx*cbdy1                +   cbyy
      ec( 491)=ec( 491)+dx*cbdz0+wqx*cbdz1                +   cbyz
      ec( 492)=ec( 492)+dz*cbdy0+wqz*cbdy1+tw*zbdy
      ec( 493)=ec( 493)+dx*cbex0+wqx*cbex1                +   cbzx+cbe
      ec( 494)=ec( 494)+dy*cbey0+wqy*cbey1        +tw*cyey        +cbe
      ec( 495)=ec( 495)+dz*cbez0+wqz*cbez1+tw*zbez        +   cbxz+cbe
      ec( 496)=ec( 496)+dx*cbey0+wqx*cbey1                +   cbzy
      ec( 497)=ec( 497)+dx*cbez0+wqx*cbez1                +   cbzz
      ec( 498)=ec( 498)+dy*cbez0+wqy*cbez1        +tw*cyez
      ec( 499)=ec( 499)+dx*cbfx0+wqx*cbfx1                        +cbf
      ec( 500)=ec( 500)+dy*cbfy0+wqy*cbfy1        +tw*cyfy+   cbzy+cbf
      ec( 501)=ec( 501)+dz*cbfz0+wqz*cbfz1+tw*zbfz        +   cbyz+cbf
      ec( 502)=ec( 502)+dx*cbfy0+wqx*cbfy1
      ec( 503)=ec( 503)+dx*cbfz0+wqx*cbfz1
      ec( 504)=ec( 504)+dy*cbfz0+wqy*cbfz1        +tw*cyfz+   cbzz
                                                  
      ec( 505)=ec( 505)+dx*ccax0+wqx*ccax1                +tw*ccxx+cca
      ec( 506)=ec( 506)+dy*ccay0+wqy*ccay1                        +cca
      ec( 507)=ec( 507)+dz*ccaz0+wqz*ccaz1+tw*zcaz+tw*czaz        +cca
      ec( 508)=ec( 508)+dx*ccay0+wqx*ccay1                +tw*ccxy
      ec( 509)=ec( 509)+dx*ccaz0+wqx*ccaz1                +tw*ccxz
      ec( 510)=ec( 510)+dy*ccaz0+wqy*ccaz1
      ec( 511)=ec( 511)+dx*ccbx0+wqx*ccbx1                        +ccb
      ec( 512)=ec( 512)+dy*ccby0+wqy*ccby1                +tw*ccyy+ccb
      ec( 513)=ec( 513)+dz*ccbz0+wqz*ccbz1+tw*zcbz+tw*czbz        +ccb
      ec( 514)=ec( 514)+dx*ccby0+wqx*ccby1
      ec( 515)=ec( 515)+dx*ccbz0+wqx*ccbz1
      ec( 516)=ec( 516)+dy*ccbz0+wqy*ccbz1                +tw*ccyz
      ec( 517)=ec( 517)+dx*cccx0+wqx*cccx1                        +ccc
      ec( 518)=ec( 518)+dy*cccy0+wqy*cccy1                        +ccc
      ec( 519)=ec( 519)+dz*cccz0+wqz*cccz1+tw*zccz+tw*czcz+tw*cczz+ccc
      ec( 520)=ec( 520)+dy*cccx0+wqy*cccx1
      ec( 521)=ec( 521)+dx*cccz0+wqx*cccz1
      ec( 522)=ec( 522)+dy*cccz0+wqy*cccz1
      ec( 523)=ec( 523)+dx*ccdx0+wqx*ccdx1                +   ccyx+ccd
      ec( 524)=ec( 524)+dy*ccdy0+wqy*ccdy1                +   ccxy+ccd
      ec( 525)=ec( 525)+dz*ccdz0+wqz*ccdz1+tw*zcdz+tw*czdz        +ccd
      ec( 526)=ec( 526)+dy*ccdx0+wqy*ccdx1                +   ccxx
      ec( 527)=ec( 527)+dx*ccdz0+wqx*ccdz1                +   ccyz
      ec( 528)=ec( 528)+dy*ccdz0+wqy*ccdz1                +   ccxz
      ec( 529)=ec( 529)+dx*ccex0+wqx*ccex1                +   cczx+cce
      ec( 530)=ec( 530)+dy*ccey0+wqy*ccey1                        +cce
      ec( 531)=ec( 531)+dz*ccez0+wqz*ccez1+tw*zcez+tw*czez+   ccxz+cce
      ec( 532)=ec( 532)+dy*ccex0+wqy*ccex1
      ec( 533)=ec( 533)+dx*ccez0+wqx*ccez1                +   cczz
      ec( 534)=ec( 534)+dy*ccez0+wqy*ccez1
      ec( 535)=ec( 535)+dx*ccfx0+wqx*ccfx1                        +ccf
      ec( 536)=ec( 536)+dy*ccfy0+wqy*ccfy1                +   cczy+ccf
      ec( 537)=ec( 537)+dz*ccfz0+wqz*ccfz1+tw*zcfz+tw*czfz+   ccyz+ccf
      ec( 538)=ec( 538)+dx*ccfy0+wqx*ccfy1
      ec( 539)=ec( 539)+dx*ccfz0+wqx*ccfz1
      ec( 540)=ec( 540)+dy*ccfz0+wqy*ccfz1                +   cczz
                                                  
      ec( 541)=ec( 541)+dx*cdax0+wqx*cdax1        +   cyax+tw*cdxx+cda
      ec( 542)=ec( 542)+dy*cday0+wqy*cday1        +   cxay        +cda
      ec( 543)=ec( 543)+dz*cdaz0+wqz*cdaz1+tw*zdaz                +cda
      ec( 544)=ec( 544)+dy*cdax0+wqy*cdax1        +   cxax
      ec( 545)=ec( 545)+dz*cdax0+wqz*cdax1+tw*zdax
      ec( 546)=ec( 546)+dy*cdaz0+wqy*cdaz1        +   cxaz
      ec( 547)=ec( 547)+dx*cdbx0+wqx*cdbx1        +   cybx        +cdb
      ec( 548)=ec( 548)+dy*cdby0+wqy*cdby1        +   cxby+tw*cdyy+cdb
      ec( 549)=ec( 549)+dz*cdbz0+wqz*cdbz1+tw*zdbz                +cdb
      ec( 550)=ec( 550)+dx*cdby0+wqx*cdby1        +   cyby
      ec( 551)=ec( 551)+dx*cdbz0+wqx*cdbz1        +   cybz
      ec( 552)=ec( 552)+dz*cdby0+wqz*cdby1+tw*zdby
      ec( 553)=ec( 553)+dx*cdcx0+wqx*cdcx1        +   cycx        +cdc
      ec( 554)=ec( 554)+dy*cdcy0+wqy*cdcy1        +   cxcy        +cdc
      ec( 555)=ec( 555)+dz*cdcz0+wqz*cdcz1+tw*zdcz        +tw*cdzz+cdc
      ec( 556)=ec( 556)+dx*cdcy0+wqx*cdcy1        +   cycy
      ec( 557)=ec( 557)+dx*cdcz0+wqx*cdcz1        +   cycz
      ec( 558)=ec( 558)+dy*cdcz0+wqy*cdcz1        +   cxcz
      ec( 559)=ec( 559)+dx*cddx0+wqx*cddx1        +   cydx+   cdyx+cdd
      ec( 560)=ec( 560)+dy*cddy0+wqy*cddy1        +   cxdy+   cdxy+cdd
      ec( 561)=ec( 561)+dz*cddz0+wqz*cddz1+tw*zddz                +cdd
      ec( 562)=ec( 562)+dy*cddx0+wqy*cddx1        +   cxdx+   cdxx
      ec( 563)=ec( 563)+dz*cddx0+wqz*cddx1+tw*zddx
      ec( 564)=ec( 564)+dz*cddy0+wqz*cddy1+tw*zddy
      ec( 565)=ec( 565)+dx*cdex0+wqx*cdex1        +   cyex+   cdzx+cde
      ec( 566)=ec( 566)+dy*cdey0+wqy*cdey1        +   cxey        +cde
      ec( 567)=ec( 567)+dz*cdez0+wqz*cdez1+tw*zdez        +   cdxz+cde
      ec( 568)=ec( 568)+dy*cdex0+wqy*cdex1        +   cxex
      ec( 569)=ec( 569)+dx*cdez0+wqx*cdez1        +   cyez+   cdzz
      ec( 570)=ec( 570)+dy*cdez0+wqy*cdez1        +   cxez
      ec( 571)=ec( 571)+dx*cdfx0+wqx*cdfx1        +   cyfx        +cdf
      ec( 572)=ec( 572)+dy*cdfy0+wqy*cdfy1        +   cxfy+   cdzy+cdf
      ec( 573)=ec( 573)+dz*cdfz0+wqz*cdfz1+tw*zdfz        +   cdyz+cdf
      ec( 574)=ec( 574)+dx*cdfy0+wqx*cdfy1        +   cyfy
      ec( 575)=ec( 575)+dx*cdfz0+wqx*cdfz1        +   cyfz
      ec( 576)=ec( 576)+dy*cdfz0+wqy*cdfz1        +   cxfz+   cdzz
                                                 
      ec( 577)=ec( 577)+dx*ceax0+wqx*ceax1        +   czax+tw*cexx+cea
      ec( 578)=ec( 578)+dy*ceay0+wqy*ceay1                        +cea
      ec( 579)=ec( 579)+dz*ceaz0+wqz*ceaz1+tw*zeaz+   cxaz        +cea
      ec( 580)=ec( 580)+dy*ceax0+wqy*ceax1
      ec( 581)=ec( 581)+dz*ceax0+wqz*ceax1+tw*zeax+   cxax
      ec( 582)=ec( 582)+dy*ceaz0+wqy*ceaz1
      ec( 583)=ec( 583)+dx*cebx0+wqx*cebx1        +   czbx        +ceb
      ec( 584)=ec( 584)+dy*ceby0+wqy*ceby1                +tw*ceyy+ceb
      ec( 585)=ec( 585)+dz*cebz0+wqz*cebz1+tw*zebz+   cxbz        +ceb
      ec( 586)=ec( 586)+dx*ceby0+wqx*ceby1        +   czby
      ec( 587)=ec( 587)+dx*cebz0+wqx*cebz1        +   czbz
      ec( 588)=ec( 588)+dy*cebz0+wqy*cebz1                +tw*ceyz
      ec( 589)=ec( 589)+dx*cecx0+wqx*cecx1        +   czcx        +cec
      ec( 590)=ec( 590)+dy*cecy0+wqy*cecy1                        +cec
      ec( 591)=ec( 591)+dz*cecz0+wqz*cecz1+tw*zecz+   cxcz+tw*cezz+cec
      ec( 592)=ec( 592)+dy*cecx0+wqy*cecx1
      ec( 593)=ec( 593)+dx*cecz0+wqx*cecz1        +   czcz
      ec( 594)=ec( 594)+dy*cecz0+wqy*cecz1
      ec( 595)=ec( 595)+dx*cedx0+wqx*cedx1        +   czdx+   ceyx+ced
      ec( 596)=ec( 596)+dy*cedy0+wqy*cedy1                +   cexy+ced
      ec( 597)=ec( 597)+dz*cedz0+wqz*cedz1+tw*zedz+   cxdz        +ced
      ec( 598)=ec( 598)+dy*cedx0+wqy*cedx1                +   cexx
      ec( 599)=ec( 599)+dx*cedz0+wqx*cedz1        +   czdz+   ceyz
      ec( 600)=ec( 600)+dy*cedz0+wqy*cedz1                +   cexz
      ec( 601)=ec( 601)+dx*ceex0+wqx*ceex1        +   czex+   cezx+cee
      ec( 602)=ec( 602)+dy*ceey0+wqy*ceey1                        +cee
      ec( 603)=ec( 603)+dz*ceez0+wqz*ceez1+tw*zeez+   cxez+   cexz+cee
      ec( 604)=ec( 604)+dy*ceex0+wqy*ceex1
      ec( 605)=ec( 605)+dx*ceez0+wqx*ceez1        +   czez+   cezz
      ec( 606)=ec( 606)+dy*ceez0+wqy*ceez1
      ec( 607)=ec( 607)+dx*cefx0+wqx*cefx1        +   czfx        +cef
      ec( 608)=ec( 608)+dy*cefy0+wqy*cefy1                +   cezy+cef
      ec( 609)=ec( 609)+dz*cefz0+wqz*cefz1+tw*zefz+   cxfz+   ceyz+cef
      ec( 610)=ec( 610)+dx*cefy0+wqx*cefy1        +   czfy
      ec( 611)=ec( 611)+dx*cefz0+wqx*cefz1        +   czfz
      ec( 612)=ec( 612)+dy*cefz0+wqy*cefz1                +   cezz
                                                  
      ec( 613)=ec( 613)+dx*cfax0+wqx*cfax1                +tw*cfxx+cfa
      ec( 614)=ec( 614)+dy*cfay0+wqy*cfay1        +   czay        +cfa
      ec( 615)=ec( 615)+dz*cfaz0+wqz*cfaz1+tw*zfaz+   cyaz        +cfa
      ec( 616)=ec( 616)+dy*cfax0+wqy*cfax1        +   czax
      ec( 617)=ec( 617)+dx*cfaz0+wqx*cfaz1                +tw*cfxz
      ec( 618)=ec( 618)+dy*cfaz0+wqy*cfaz1        +   czaz
      ec( 619)=ec( 619)+dx*cfbx0+wqx*cfbx1                        +cfb
      ec( 620)=ec( 620)+dy*cfby0+wqy*cfby1        +   czby+tw*cfyy+cfb
      ec( 621)=ec( 621)+dz*cfbz0+wqz*cfbz1+tw*zfbz+   cybz        +cfb
      ec( 622)=ec( 622)+dx*cfby0+wqx*cfby1
      ec( 623)=ec( 623)+dx*cfbz0+wqx*cfbz1
      ec( 624)=ec( 624)+dy*cfbz0+wqy*cfbz1        +   czbz+tw*cfyz
      ec( 625)=ec( 625)+dx*cfcx0+wqx*cfcx1                        +cfc
      ec( 626)=ec( 626)+dy*cfcy0+wqy*cfcy1        +   czcy        +cfc
      ec( 627)=ec( 627)+dz*cfcz0+wqz*cfcz1+tw*zfcz+   cycz+tw*cfzz+cfc
      ec( 628)=ec( 628)+dx*cfcy0+wqx*cfcy1
      ec( 629)=ec( 629)+dx*cfcz0+wqx*cfcz1
      ec( 630)=ec( 630)+dy*cfcz0+wqy*cfcz1        +   czcz
      ec( 631)=ec( 631)+dx*cfdx0+wqx*cfdx1                +   cfyx+cfd
      ec( 632)=ec( 632)+dy*cfdy0+wqy*cfdy1        +   czdy+   cfxy+cfd
      ec( 633)=ec( 633)+dz*cfdz0+wqz*cfdz1+tw*zfdz+   cydz        +cfd
      ec( 634)=ec( 634)+dx*cfdy0+wqx*cfdy1                +   cfyy
      ec( 635)=ec( 635)+dx*cfdz0+wqx*cfdz1                +   cfyz
      ec( 636)=ec( 636)+dy*cfdz0+wqy*cfdz1        +   czdz+   cfxz
      ec( 637)=ec( 637)+dx*cfex0+wqx*cfex1                +   cfzx+cfe
      ec( 638)=ec( 638)+dy*cfey0+wqy*cfey1        +   czey        +cfe
      ec( 639)=ec( 639)+dz*cfez0+wqz*cfez1+tw*zfez+   cyez+   cfxz+cfe
      ec( 640)=ec( 640)+dx*cfey0+wqx*cfey1                +   cfzy
      ec( 641)=ec( 641)+dx*cfez0+wqx*cfez1                +   cfzz
      ec( 642)=ec( 642)+dy*cfez0+wqy*cfez1        +   czez        
      ec( 643)=ec( 643)+dx*cffx0+wqx*cffx1                        +cff
      ec( 644)=ec( 644)+dy*cffy0+wqy*cffy1        +   czfy+   cfzy+cff
      ec( 645)=ec( 645)+dz*cffz0+wqz*cffz1+tw*zffz+   cyfz+   cfyz+cff
      ec( 646)=ec( 646)+dx*cffy0+wqx*cffy1
      ec( 647)=ec( 647)+dx*cffz0+wqx*cffz1
      ec( 648)=ec( 648)+dy*cffz0+wqy*cffz1        +   czfz+   cfzz
                                                  
      ec( 649)=ec( 649)+dx*daax0+wqx*daax1+   yaax+tw*dxax+tw*daxx+daa
      ec( 650)=ec( 650)+dy*daay0+wqy*daay1+   xaay                +daa
      ec( 651)=ec( 651)+dz*daaz0+wqz*daaz1                        +daa
      ec( 652)=ec( 652)+dy*daax0+wqy*daax1+   xaax
      ec( 653)=ec( 653)+dz*daax0+wqz*daax1
      ec( 654)=ec( 654)+dz*daay0+wqz*daay1
      ec( 655)=ec( 655)+dx*dabx0+wqx*dabx1+   yabx+tw*dxbx        +dab
      ec( 656)=ec( 656)+dy*daby0+wqy*daby1+   xaby        +tw*dayy+dab
      ec( 657)=ec( 657)+dz*dabz0+wqz*dabz1                        +dab
      ec( 658)=ec( 658)+dy*dabx0+wqy*dabx1+   xabx        +tw*dayx
      ec( 659)=ec( 659)+dz*dabx0+wqz*dabx1
      ec( 660)=ec( 660)+dy*dabz0+wqy*dabz1+   xabz        +tw*dayz
      ec( 661)=ec( 661)+dx*dacx0+wqx*dacx1+   yacx+tw*dxcx        +dac
      ec( 662)=ec( 662)+dy*dacy0+wqy*dacy1+   xacy                +dac
      ec( 663)=ec( 663)+dz*dacz0+wqz*dacz1                +tw*dazz+dac
      ec( 664)=ec( 664)+dy*dacx0+wqy*dacx1+   xacx       
      ec( 665)=ec( 665)+dz*dacx0+wqz*dacx1                +tw*dazx
      ec( 666)=ec( 666)+dy*dacz0+wqy*dacz1+   xacz
      ec( 667)=ec( 667)+dx*dadx0+wqx*dadx1+   yadx+tw*dxdx+   dayx+dad
      ec( 668)=ec( 668)+dy*dady0+wqy*dady1+   xady        +   daxy+dad
      ec( 669)=ec( 669)+dz*dadz0+wqz*dadz1                        +dad
      ec( 670)=ec( 670)+dy*dadx0+wqy*dadx1+   xadx        +   daxx
      ec( 671)=ec( 671)+dz*dadx0+wqz*dadx1
      ec( 672)=ec( 672)+dz*dady0+wqz*dady1
      ec( 673)=ec( 673)+dx*daex0+wqx*daex1+   yaex+tw*dxex+   dazx+dae
      ec( 674)=ec( 674)+dy*daey0+wqy*daey1+   xaey                +dae
      ec( 675)=ec( 675)+dz*daez0+wqz*daez1                +   daxz+dae
      ec( 676)=ec( 676)+dy*daex0+wqy*daex1+   xaex
      ec( 677)=ec( 677)+dz*daex0+wqz*daex1                +   daxx
      ec( 678)=ec( 678)+dy*daez0+wqy*daez1+   xaez
      ec( 679)=ec( 679)+dx*dafx0+wqx*dafx1+   yafx+tw*dxfx        +daf
      ec( 680)=ec( 680)+dy*dafy0+wqy*dafy1+   xafy        +   dazy+daf
      ec( 681)=ec( 681)+dz*dafz0+wqz*dafz1                +   dayz+daf
      ec( 682)=ec( 682)+dy*dafx0+wqy*dafx1+   xafx        +   dazx
      ec( 683)=ec( 683)+dz*dafx0+wqz*dafx1                +   dayx
      ec( 684)=ec( 684)+dz*dafy0+wqz*dafy1                +   dayy
                                                  
      ec( 685)=ec( 685)+dx*dbax0+wqx*dbax1+   ybax        +tw*dbxx+dba
      ec( 686)=ec( 686)+dy*dbay0+wqy*dbay1+   xbay+tw*dyay        +dba
      ec( 687)=ec( 687)+dz*dbaz0+wqz*dbaz1                        +dba
      ec( 688)=ec( 688)+dy*dbax0+wqy*dbax1+   xbax+tw*dyax
      ec( 689)=ec( 689)+dz*dbax0+wqz*dbax1
      ec( 690)=ec( 690)+dz*dbay0+wqz*dbay1
      ec( 691)=ec( 691)+dx*dbbx0+wqx*dbbx1+   ybbx                +dbb
      ec( 692)=ec( 692)+dy*dbby0+wqy*dbby1+   xbby+tw*dyby+tw*dbyy+dbb
      ec( 693)=ec( 693)+dz*dbbz0+wqz*dbbz1                        +dbb
      ec( 694)=ec( 694)+dx*dbby0+wqx*dbby1+   ybby
      ec( 695)=ec( 695)+dz*dbbx0+wqz*dbbx1
      ec( 696)=ec( 696)+dz*dbby0+wqz*dbby1
      ec( 697)=ec( 697)+dx*dbcx0+wqx*dbcx1+   ybcx                +dbc
      ec( 698)=ec( 698)+dy*dbcy0+wqy*dbcy1+   xbcy+tw*dycy        +dbc
      ec( 699)=ec( 699)+dz*dbcz0+wqz*dbcz1                +tw*dbzz+dbc
      ec( 700)=ec( 700)+dx*dbcy0+wqx*dbcy1+   ybcy
      ec( 701)=ec( 701)+dx*dbcz0+wqx*dbcz1+   ybcz
      ec( 702)=ec( 702)+dz*dbcy0+wqz*dbcy1                +tw*dbzy
      ec( 703)=ec( 703)+dx*dbdx0+wqx*dbdx1+   ybdx        +   dbyx+dbd
      ec( 704)=ec( 704)+dy*dbdy0+wqy*dbdy1+   xbdy+tw*dydy+   dbxy+dbd
      ec( 705)=ec( 705)+dz*dbdz0+wqz*dbdz1                        +dbd
      ec( 706)=ec( 706)+dx*dbdy0+wqx*dbdy1+   ybdy              + dbyy
      ec( 707)=ec( 707)+dz*dbdx0+wqz*dbdx1
      ec( 708)=ec( 708)+dz*dbdy0+wqz*dbdy1
      ec( 709)=ec( 709)+dx*dbex0+wqx*dbex1+   ybex        +   dbzx+dbe
      ec( 710)=ec( 710)+dy*dbey0+wqy*dbey1+   xbey+tw*dyey        +dbe
      ec( 711)=ec( 711)+dz*dbez0+wqz*dbez1                +   dbxz+dbe
      ec( 712)=ec( 712)+dx*dbey0+wqx*dbey1+   ybey        +   dbzy
      ec( 713)=ec( 713)+dz*dbex0+wqz*dbex1                +   dbxx
      ec( 714)=ec( 714)+dz*dbey0+wqz*dbey1                +   dbxy
      ec( 715)=ec( 715)+dx*dbfx0+wqx*dbfx1+   ybfx                +dbf
      ec( 716)=ec( 716)+dy*dbfy0+wqy*dbfy1+   xbfy+tw*dyfy+   dbzy+dbf
      ec( 717)=ec( 717)+dz*dbfz0+wqz*dbfz1                +   dbyz+dbf
      ec( 718)=ec( 718)+dx*dbfy0+wqx*dbfy1+   ybfy
      ec( 719)=ec( 719)+dz*dbfx0+wqz*dbfx1                +   dbyx
      ec( 720)=ec( 720)+dz*dbfy0+wqz*dbfy1                +   dbyy
                                                  
      ec( 721)=ec( 721)+dx*dcax0+wqx*dcax1+   ycax        +tw*dcxx+dca
      ec( 722)=ec( 722)+dy*dcay0+wqy*dcay1+   xcay                +dca
      ec( 723)=ec( 723)+dz*dcaz0+wqz*dcaz1        +tw*dzaz        +dca
      ec( 724)=ec( 724)+dy*dcax0+wqy*dcax1+   xcax
      ec( 725)=ec( 725)+dz*dcax0+wqz*dcax1        +tw*dzax
      ec( 726)=ec( 726)+dy*dcaz0+wqy*dcaz1+   xcaz
      ec( 727)=ec( 727)+dx*dcbx0+wqx*dcbx1+   ycbx                +dcb
      ec( 728)=ec( 728)+dy*dcby0+wqy*dcby1+   xcby        +tw*dcyy+dcb
      ec( 729)=ec( 729)+dz*dcbz0+wqz*dcbz1        +tw*dzbz        +dcb
      ec( 730)=ec( 730)+dx*dcby0+wqx*dcby1+   ycby
      ec( 731)=ec( 731)+dx*dcbz0+wqx*dcbz1+   ycbz
      ec( 732)=ec( 732)+dz*dcby0+wqz*dcby1        +tw*dzby
      ec( 733)=ec( 733)+dx*dccx0+wqx*dccx1+   yccx                +dcc
      ec( 734)=ec( 734)+dy*dccy0+wqy*dccy1+   xccy                +dcc
      ec( 735)=ec( 735)+dz*dccz0+wqz*dccz1        +tw*dzcz+tw*dczz+dcc
      ec( 736)=ec( 736)+dy*dccx0+wqy*dccx1+   xccx
      ec( 737)=ec( 737)+dx*dccz0+wqx*dccz1+   yccz
      ec( 738)=ec( 738)+dy*dccz0+wqy*dccz1+   xccz
      ec( 739)=ec( 739)+dx*dcdx0+wqx*dcdx1+   ycdx        +   dcyx+dcd
      ec( 740)=ec( 740)+dy*dcdy0+wqy*dcdy1+   xcdy        +   dcxy+dcd
      ec( 741)=ec( 741)+dz*dcdz0+wqz*dcdz1        +tw*dzdz        +dcd
      ec( 742)=ec( 742)+dx*dcdy0+wqx*dcdy1+   ycdy        +   dcyy
      ec( 743)=ec( 743)+dz*dcdx0+wqz*dcdx1        +tw*dzdx
      ec( 744)=ec( 744)+dz*dcdy0+wqz*dcdy1        +tw*dzdy
      ec( 745)=ec( 745)+dx*dcex0+wqx*dcex1+   ycex        +   dczx+dce
      ec( 746)=ec( 746)+dy*dcey0+wqy*dcey1+   xcey                +dce
      ec( 747)=ec( 747)+dz*dcez0+wqz*dcez1        +tw*dzez+   dcxz+dce
      ec( 748)=ec( 748)+dy*dcex0+wqy*dcex1+   xcex
      ec( 749)=ec( 749)+dx*dcez0+wqx*dcez1+   ycez        +   dczz
      ec( 750)=ec( 750)+dy*dcez0+wqy*dcez1+   xcez
      ec( 751)=ec( 751)+dx*dcfx0+wqx*dcfx1+   ycfx                +dcf
      ec( 752)=ec( 752)+dy*dcfy0+wqy*dcfy1+   xcfy        +   dczy+dcf
      ec( 753)=ec( 753)+dz*dcfz0+wqz*dcfz1        +tw*dzfz+   dcyz+dcf
      ec( 754)=ec( 754)+dx*dcfy0+wqx*dcfy1+   ycfy
      ec( 755)=ec( 755)+dx*dcfz0+wqx*dcfz1+   ycfz
      ec( 756)=ec( 756)+dy*dcfz0+wqy*dcfz1+   xcfz        +   dczz
                                                  
      ec( 757)=ec( 757)+dx*ddax0+wqx*ddax1+   ydax+   dyax+tw*ddxx+dda
      ec( 758)=ec( 758)+dy*dday0+wqy*dday1+   xday+   dxay        +dda
      ec( 759)=ec( 759)+dz*ddaz0+wqz*ddaz1                        +dda
      ec( 760)=ec( 760)+dy*ddax0+wqy*ddax1+   xdax+   dxax
      ec( 761)=ec( 761)+dz*ddax0+wqz*ddax1
      ec( 762)=ec( 762)+dz*dday0+wqz*dday1
      ec( 763)=ec( 763)+dx*ddbx0+wqx*ddbx1+   ydbx+   dybx        +ddb
      ec( 764)=ec( 764)+dy*ddby0+wqy*ddby1+   xdby+   dxby+tw*ddyy+ddb
      ec( 765)=ec( 765)+dz*ddbz0+wqz*ddbz1                        +ddb
      ec( 766)=ec( 766)+dx*ddby0+wqx*ddby1+   ydby+   dyby
      ec( 767)=ec( 767)+dz*ddbx0+wqz*ddbx1
      ec( 768)=ec( 768)+dz*ddby0+wqz*ddby1
      ec( 769)=ec( 769)+dx*ddcx0+wqx*ddcx1+   ydcx+   dycx        +ddc
      ec( 770)=ec( 770)+dy*ddcy0+wqy*ddcy1+   xdcy+   dxcy        +ddc
      ec( 771)=ec( 771)+dz*ddcz0+wqz*ddcz1                +tw*ddzz+ddc
      ec( 772)=ec( 772)+dy*ddcx0+wqy*ddcx1+   xdcx+   dxcx
      ec( 773)=ec( 773)+dz*ddcx0+wqz*ddcx1                +tw*ddzx
      ec( 774)=ec( 774)+dz*ddcy0+wqz*ddcy1                +tw*ddzy
      ec( 775)=ec( 775)+dx*dddx0+wqx*dddx1+   yddx+   dydx+   ddyx+ddd
      ec( 776)=ec( 776)+dy*dddy0+wqy*dddy1+   xddy+   dxdy+   ddxy+ddd
      ec( 777)=ec( 777)+dz*dddz0+wqz*dddz1                        +ddd
      ec( 778)=ec( 778)+dy*dddx0+wqy*dddx1+   xddx+   dxdx+   ddxx
      ec( 779)=ec( 779)+dz*dddx0+wqz*dddx1
      ec( 780)=ec( 780)+dz*dddy0+wqz*dddy1
      ec( 781)=ec( 781)+dx*ddex0+wqx*ddex1+   ydex+   dyex+   ddzx+dde
      ec( 782)=ec( 782)+dy*ddey0+wqy*ddey1+   xdey+   dxey        +dde
      ec( 783)=ec( 783)+dz*ddez0+wqz*ddez1                +   ddxz+dde
      ec( 784)=ec( 784)+dy*ddex0+wqy*ddex1+   xdex+   dxex
      ec( 785)=ec( 785)+dz*ddex0+wqz*ddex1                +   ddxx
      ec( 786)=ec( 786)+dz*ddey0+wqz*ddey1                +   ddxy
      ec( 787)=ec( 787)+dx*ddfx0+wqx*ddfx1+   ydfx+   dyfx        +ddf
      ec( 788)=ec( 788)+dy*ddfy0+wqy*ddfy1+   xdfy+   dxfy+   ddzy+ddf
      ec( 789)=ec( 789)+dz*ddfz0+wqz*ddfz1                +   ddyz+ddf
      ec( 790)=ec( 790)+dx*ddfy0+wqx*ddfy1+   ydfy+   dyfy
      ec( 791)=ec( 791)+dz*ddfx0+wqz*ddfx1                +   ddyx
      ec( 792)=ec( 792)+dz*ddfy0+wqz*ddfy1                +   ddyy
                                                  
      ec( 793)=ec( 793)+dx*deax0+wqx*deax1+   yeax+   dzax+tw*dexx+dea
      ec( 794)=ec( 794)+dy*deay0+wqy*deay1+   xeay                +dea
      ec( 795)=ec( 795)+dz*deaz0+wqz*deaz1        +   dxaz        +dea
      ec( 796)=ec( 796)+dy*deax0+wqy*deax1+   xeax
      ec( 797)=ec( 797)+dz*deax0+wqz*deax1        +   dxax
      ec( 798)=ec( 798)+dy*deaz0+wqy*deaz1+   xeaz
      ec( 799)=ec( 799)+dx*debx0+wqx*debx1+   yebx+   dzbx        +deb
      ec( 800)=ec( 800)+dy*deby0+wqy*deby1+   xeby        +tw*deyy+deb
      ec( 801)=ec( 801)+dz*debz0+wqz*debz1        +   dxbz        +deb
      ec( 802)=ec( 802)+dx*deby0+wqx*deby1+   yeby+   dzby
      ec( 803)=ec( 803)+dz*debx0+wqz*debx1        +   dxbx
      ec( 804)=ec( 804)+dz*deby0+wqz*deby1        +   dxby
      ec( 805)=ec( 805)+dx*decx0+wqx*decx1+   yecx+   dzcx        +dec
      ec( 806)=ec( 806)+dy*decy0+wqy*decy1+   xecy                +dec
      ec( 807)=ec( 807)+dz*decz0+wqz*decz1        +   dxcz+tw*dezz+dec
      ec( 808)=ec( 808)+dy*decx0+wqy*decx1+   xecx
      ec( 809)=ec( 809)+dx*decz0+wqx*decz1+   yecz+   dzcz
      ec( 810)=ec( 810)+dy*decz0+wqy*decz1+   xecz
      ec( 811)=ec( 811)+dx*dedx0+wqx*dedx1+   yedx+   dzdx+   deyx+ded
      ec( 812)=ec( 812)+dy*dedy0+wqy*dedy1+   xedy        +   dexy+ded
      ec( 813)=ec( 813)+dz*dedz0+wqz*dedz1        +   dxdz        +ded
      ec( 814)=ec( 814)+dy*dedx0+wqy*dedx1+   xedx              + dexx
      ec( 815)=ec( 815)+dz*dedx0+wqz*dedx1        +   dxdx
      ec( 816)=ec( 816)+dz*dedy0+wqz*dedy1        +   dxdy
      ec( 817)=ec( 817)+dx*deex0+wqx*deex1+   yeex+   dzex+   dezx+dee
      ec( 818)=ec( 818)+dy*deey0+wqy*deey1+   xeey                +dee
      ec( 819)=ec( 819)+dz*deez0+wqz*deez1        +   dxez+   dexz+dee
      ec( 820)=ec( 820)+dy*deex0+wqy*deex1+   xeex
      ec( 821)=ec( 821)+dz*deex0+wqz*deex1        +   dxex+   dexx
      ec( 822)=ec( 822)+dy*deez0+wqy*deez1+   xeez
      ec( 823)=ec( 823)+dx*defx0+wqx*defx1+   yefx+   dzfx        +def
      ec( 824)=ec( 824)+dy*defy0+wqy*defy1+   xefy        +   dezy+def
      ec( 825)=ec( 825)+dz*defz0+wqz*defz1        +   dxfz+   deyz+def
      ec( 826)=ec( 826)+dy*defx0+wqy*defx1+   xefx        +   dezx
      ec( 827)=ec( 827)+dz*defx0+wqz*defx1        +   dxfx+   deyx
      ec( 828)=ec( 828)+dy*defz0+wqy*defz1+   xefz        +   dezz
                                                 
      ec( 829)=ec( 829)+dx*dfax0+wqx*dfax1+   yfax        +tw*dfxx+dfa
      ec( 830)=ec( 830)+dy*dfay0+wqy*dfay1+   xfay+   dzay        +dfa
      ec( 831)=ec( 831)+dz*dfaz0+wqz*dfaz1        +   dyaz        +dfa
      ec( 832)=ec( 832)+dy*dfax0+wqy*dfax1+   xfax+   dzax
      ec( 833)=ec( 833)+dz*dfax0+wqz*dfax1        +   dyax
      ec( 834)=ec( 834)+dz*dfay0+wqz*dfay1        +   dyay
      ec( 835)=ec( 835)+dx*dfbx0+wqx*dfbx1+   yfbx                +dfb
      ec( 836)=ec( 836)+dy*dfby0+wqy*dfby1+   xfby+   dzby+tw*dfyy+dfb
      ec( 837)=ec( 837)+dz*dfbz0+wqz*dfbz1        +   dybz        +dfb
      ec( 838)=ec( 838)+dx*dfby0+wqx*dfby1+   yfby
      ec( 839)=ec( 839)+dz*dfbx0+wqz*dfbx1        +   dybx
      ec( 840)=ec( 840)+dz*dfby0+wqz*dfby1        +   dyby
      ec( 841)=ec( 841)+dx*dfcx0+wqx*dfcx1+   yfcx                +dfc
      ec( 842)=ec( 842)+dy*dfcy0+wqy*dfcy1+   xfcy+   dzcy        +dfc
      ec( 843)=ec( 843)+dz*dfcz0+wqz*dfcz1        +   dycz+tw*dfzz+dfc
      ec( 844)=ec( 844)+dx*dfcy0+wqx*dfcy1+   yfcy
      ec( 845)=ec( 845)+dx*dfcz0+wqx*dfcz1+   yfcz
      ec( 846)=ec( 846)+dy*dfcz0+wqy*dfcz1+   xfcz+   dzcz        
      ec( 847)=ec( 847)+dx*dfdx0+wqx*dfdx1+   yfdx        +   dfyx+dfd
      ec( 848)=ec( 848)+dy*dfdy0+wqy*dfdy1+   xfdy+   dzdy+   dfxy+dfd
      ec( 849)=ec( 849)+dz*dfdz0+wqz*dfdz1        +   dydz        +dfd
      ec( 850)=ec( 850)+dx*dfdy0+wqx*dfdy1+   yfdy        +   dfyy
      ec( 851)=ec( 851)+dz*dfdx0+wqz*dfdx1        +   dydx
      ec( 852)=ec( 852)+dz*dfdy0+wqz*dfdy1        +   dydy
      ec( 853)=ec( 853)+dx*dfex0+wqx*dfex1+   yfex        +   dfzx+dfe
      ec( 854)=ec( 854)+dy*dfey0+wqy*dfey1+   xfey+   dzey        +dfe
      ec( 855)=ec( 855)+dz*dfez0+wqz*dfez1        +   dyez+   dfxz+dfe
      ec( 856)=ec( 856)+dx*dfey0+wqx*dfey1+   yfey        +   dfzy
      ec( 857)=ec( 857)+dx*dfez0+wqx*dfez1+   yfez        +   dfzz
      ec( 858)=ec( 858)+dz*dfey0+wqz*dfey1        +   dyey+   dfxy
      ec( 859)=ec( 859)+dx*dffx0+wqx*dffx1+   yffx                +dff
      ec( 860)=ec( 860)+dy*dffy0+wqy*dffy1+   xffy+   dzfy+   dfzy+dff
      ec( 861)=ec( 861)+dz*dffz0+wqz*dffz1        +   dyfz+   dfyz+dff
      ec( 862)=ec( 862)+dx*dffy0+wqx*dffy1+   yffy
      ec( 863)=ec( 863)+dx*dffz0+wqx*dffz1+   yffz
      ec( 864)=ec( 864)+dz*dffy0+wqz*dffy1        +   dyfy+   dfyy
                                                  
      ec( 865)=ec( 865)+dx*eaax0+wqx*eaax1+   zaax+tw*exax+tw*eaxx+eaa
      ec( 866)=ec( 866)+dy*eaay0+wqy*eaay1                        +eaa
      ec( 867)=ec( 867)+dz*eaaz0+wqz*eaaz1+   xaaz                +eaa
      ec( 868)=ec( 868)+dy*eaax0+wqy*eaax1
      ec( 869)=ec( 869)+dz*eaax0+wqz*eaax1+   xaax
      ec( 870)=ec( 870)+dy*eaaz0+wqy*eaaz1
      ec( 871)=ec( 871)+dx*eabx0+wqx*eabx1+   zabx+tw*exbx        +eab
      ec( 872)=ec( 872)+dy*eaby0+wqy*eaby1                +tw*eayy+eab
      ec( 873)=ec( 873)+dz*eabz0+wqz*eabz1+   xabz                +eab
      ec( 874)=ec( 874)+dy*eabx0+wqy*eabx1                +tw*eayx
      ec( 875)=ec( 875)+dz*eabx0+wqz*eabx1+   xabx
      ec( 876)=ec( 876)+dz*eaby0+wqz*eaby1+   xaby
      ec( 877)=ec( 877)+dx*eacx0+wqx*eacx1+   zacx+tw*excx        +eac
      ec( 878)=ec( 878)+dy*eacy0+wqy*eacy1                        +eac
      ec( 879)=ec( 879)+dz*eacz0+wqz*eacz1+   xacz        +tw*eazz+eac
      ec( 880)=ec( 880)+dy*eacx0+wqy*eacx1
      ec( 881)=ec( 881)+dx*eacz0+wqx*eacz1+   zacz+tw*excz
      ec( 882)=ec( 882)+dy*eacz0+wqy*eacz1
      ec( 883)=ec( 883)+dx*eadx0+wqx*eadx1+   zadx+tw*exdx+   eayx+ead
      ec( 884)=ec( 884)+dy*eady0+wqy*eady1                +   eaxy+ead
      ec( 885)=ec( 885)+dz*eadz0+wqz*eadz1+   xadz                +ead
      ec( 886)=ec( 886)+dy*eadx0+wqy*eadx1                +   eaxx
      ec( 887)=ec( 887)+dz*eadx0+wqz*eadx1+   xadx
      ec( 888)=ec( 888)+dy*eadz0+wqy*eadz1                +   eaxz
      ec( 889)=ec( 889)+dx*eaex0+wqx*eaex1+   zaex+tw*exex+   eazx+eae
      ec( 890)=ec( 890)+dy*eaey0+wqy*eaey1                        +eae
      ec( 891)=ec( 891)+dz*eaez0+wqz*eaez1+   xaez        +   eaxz+eae
      ec( 892)=ec( 892)+dy*eaex0+wqy*eaex1
      ec( 893)=ec( 893)+dz*eaex0+wqz*eaex1+   xaex        +   eaxx
      ec( 894)=ec( 894)+dy*eaez0+wqy*eaez1
      ec( 895)=ec( 895)+dx*eafx0+wqx*eafx1+   zafx+tw*exfx        +eaf
      ec( 896)=ec( 896)+dy*eafy0+wqy*eafy1                +   eazy+eaf
      ec( 897)=ec( 897)+dz*eafz0+wqz*eafz1+   xafz        +   eayz+eaf
      ec( 898)=ec( 898)+dy*eafx0+wqy*eafx1                +   eazx
      ec( 899)=ec( 899)+dz*eafx0+wqz*eafx1+   xafx        +   eayx
      ec( 900)=ec( 900)+dy*eafz0+wqy*eafz1                +   eazz
                                                  
      ec( 901)=ec( 901)+dx*ebax0+wqx*ebax1+   zbax        +tw*ebxx+eba
      ec( 902)=ec( 902)+dy*ebay0+wqy*ebay1        +tw*eyay        +eba
      ec( 903)=ec( 903)+dz*ebaz0+wqz*ebaz1+   xbaz                +eba
      ec( 904)=ec( 904)+dy*ebax0+wqy*ebax1        +tw*eyax
      ec( 905)=ec( 905)+dz*ebax0+wqz*ebax1+   xbax
      ec( 906)=ec( 906)+dz*ebay0+wqz*ebay1+   xbay
      ec( 907)=ec( 907)+dx*ebbx0+wqx*ebbx1+   zbbx                +ebb
      ec( 908)=ec( 908)+dy*ebby0+wqy*ebby1        +tw*eyby+tw*ebyy+ebb
      ec( 909)=ec( 909)+dz*ebbz0+wqz*ebbz1+   xbbz                +ebb
      ec( 910)=ec( 910)+dx*ebby0+wqx*ebby1+   zbby
      ec( 911)=ec( 911)+dx*ebbz0+wqx*ebbz1+   zbbz
      ec( 912)=ec( 912)+dz*ebby0+wqz*ebby1+   xbby
      ec( 913)=ec( 913)+dx*ebcx0+wqx*ebcx1+   zbcx                +ebc
      ec( 914)=ec( 914)+dy*ebcy0+wqy*ebcy1        +tw*eycy        +ebc
      ec( 915)=ec( 915)+dz*ebcz0+wqz*ebcz1+   xbcz        +tw*ebzz+ebc
      ec( 916)=ec( 916)+dx*ebcy0+wqx*ebcy1+   zbcy
      ec( 917)=ec( 917)+dx*ebcz0+wqx*ebcz1+   zbcz
      ec( 918)=ec( 918)+dy*ebcz0+wqy*ebcz1        +tw*eycz            
      ec( 919)=ec( 919)+dx*ebdx0+wqx*ebdx1+   zbdx        +   ebyx+ebd
      ec( 920)=ec( 920)+dy*ebdy0+wqy*ebdy1        +tw*eydy+   ebxy+ebd
      ec( 921)=ec( 921)+dz*ebdz0+wqz*ebdz1+   xbdz                +ebd
      ec( 922)=ec( 922)+dx*ebdy0+wqx*ebdy1+   zbdy        +   ebyy
      ec( 923)=ec( 923)+dz*ebdx0+wqz*ebdx1+   xbdx
      ec( 924)=ec( 924)+dz*ebdy0+wqz*ebdy1+   xbdy
      ec( 925)=ec( 925)+dx*ebex0+wqx*ebex1+   zbex        +   ebzx+ebe
      ec( 926)=ec( 926)+dy*ebey0+wqy*ebey1        +tw*eyey        +ebe
      ec( 927)=ec( 927)+dz*ebez0+wqz*ebez1+   xbez        +   ebxz+ebe
      ec( 928)=ec( 928)+dy*ebex0+wqy*ebex1        +tw*eyex
      ec( 929)=ec( 929)+dz*ebex0+wqz*ebex1+   xbex        +   ebxx
      ec( 930)=ec( 930)+dy*ebez0+wqy*ebez1        +tw*eyez
      ec( 931)=ec( 931)+dx*ebfx0+wqx*ebfx1+   zbfx                +ebf
      ec( 932)=ec( 932)+dy*ebfy0+wqy*ebfy1        +tw*eyfy+   ebzy+ebf
      ec( 933)=ec( 933)+dz*ebfz0+wqz*ebfz1+   xbfz        +   ebyz+ebf
      ec( 934)=ec( 934)+dx*ebfy0+wqx*ebfy1+   zbfy
      ec( 935)=ec( 935)+dx*ebfz0+wqx*ebfz1+   zbfz
      ec( 936)=ec( 936)+dy*ebfz0+wqy*ebfz1        +tw*eyfz+   ebzz
                                                  
      ec( 937)=ec( 937)+dx*ecax0+wqx*ecax1+   zcax        +tw*ecxx+eca
      ec( 938)=ec( 938)+dy*ecay0+wqy*ecay1                        +eca
      ec( 939)=ec( 939)+dz*ecaz0+wqz*ecaz1+   xcaz+tw*ezaz        +eca
      ec( 940)=ec( 940)+dy*ecax0+wqy*ecax1
      ec( 941)=ec( 941)+dz*ecax0+wqz*ecax1+   xcax+tw*ezax
      ec( 942)=ec( 942)+dy*ecaz0+wqy*ecaz1
      ec( 943)=ec( 943)+dx*ecbx0+wqx*ecbx1+   zcbx                +ecb
      ec( 944)=ec( 944)+dy*ecby0+wqy*ecby1                +tw*ecyy+ecb
      ec( 945)=ec( 945)+dz*ecbz0+wqz*ecbz1+   xcbz+tw*ezbz        +ecb
      ec( 946)=ec( 946)+dx*ecby0+wqx*ecby1+   zcby
      ec( 947)=ec( 947)+dx*ecbz0+wqx*ecbz1+   zcbz
      ec( 948)=ec( 948)+dy*ecbz0+wqy*ecbz1                +tw*ecyz
      ec( 949)=ec( 949)+dx*eccx0+wqx*eccx1+   zccx                +ecc
      ec( 950)=ec( 950)+dy*eccy0+wqy*eccy1                        +ecc
      ec( 951)=ec( 951)+dz*eccz0+wqz*eccz1+   xccz+tw*ezcz+tw*eczz+ecc
      ec( 952)=ec( 952)+dy*eccx0+wqy*eccx1
      ec( 953)=ec( 953)+dx*eccz0+wqx*eccz1+   zccz
      ec( 954)=ec( 954)+dy*eccz0+wqy*eccz1
      ec( 955)=ec( 955)+dx*ecdx0+wqx*ecdx1+   zcdx        +   ecyx+ecd
      ec( 956)=ec( 956)+dy*ecdy0+wqy*ecdy1                +   ecxy+ecd
      ec( 957)=ec( 957)+dz*ecdz0+wqz*ecdz1+   xcdz+tw*ezdz        +ecd
      ec( 958)=ec( 958)+dy*ecdx0+wqy*ecdx1                +   ecxx
      ec( 959)=ec( 959)+dz*ecdx0+wqz*ecdx1+   xcdx+tw*ezdx
      ec( 960)=ec( 960)+dy*ecdz0+wqy*ecdz1                +   ecxz
      ec( 961)=ec( 961)+dx*ecex0+wqx*ecex1+   zcex        +   eczx+ece
      ec( 962)=ec( 962)+dy*ecey0+wqy*ecey1                        +ece
      ec( 963)=ec( 963)+dz*ecez0+wqz*ecez1+   xcez+tw*ezez+   ecxz+ece
      ec( 964)=ec( 964)+dy*ecex0+wqy*ecex1
      ec( 965)=ec( 965)+dx*ecez0+wqx*ecez1+   zcez        +   eczz
      ec( 966)=ec( 966)+dy*ecez0+wqy*ecez1
      ec( 967)=ec( 967)+dx*ecfx0+wqx*ecfx1+   zcfx                +ecf
      ec( 968)=ec( 968)+dy*ecfy0+wqy*ecfy1                +   eczy+ecf
      ec( 969)=ec( 969)+dz*ecfz0+wqz*ecfz1+   xcfz+tw*ezfz+   ecyz+ecf
      ec( 970)=ec( 970)+dx*ecfy0+wqx*ecfy1+   zcfy
      ec( 971)=ec( 971)+dx*ecfz0+wqx*ecfz1+   zcfz
      ec( 972)=ec( 972)+dy*ecfz0+wqy*ecfz1                +   eczz
                                                  
      ec( 973)=ec( 973)+dx*edax0+wqx*edax1+   zdax+   eyax+tw*edxx+eda
      ec( 974)=ec( 974)+dy*eday0+wqy*eday1        +   exay        +eda
      ec( 975)=ec( 975)+dz*edaz0+wqz*edaz1+   xdaz                +eda
      ec( 976)=ec( 976)+dy*edax0+wqy*edax1        +   exax
      ec( 977)=ec( 977)+dz*edax0+wqz*edax1+   xdax
      ec( 978)=ec( 978)+dy*edaz0+wqy*edaz1        +   exaz
      ec( 979)=ec( 979)+dx*edbx0+wqx*edbx1+   zdbx+   eybx        +edb
      ec( 980)=ec( 980)+dy*edby0+wqy*edby1        +   exby+tw*edyy+edb
      ec( 981)=ec( 981)+dz*edbz0+wqz*edbz1+   xdbz                +edb
      ec( 982)=ec( 982)+dx*edby0+wqx*edby1+   zdby+   eyby
      ec( 983)=ec( 983)+dz*edbx0+wqz*edbx1+   xdbx
      ec( 984)=ec( 984)+dz*edby0+wqz*edby1+   xdby
      ec( 985)=ec( 985)+dx*edcx0+wqx*edcx1+   zdcx+   eycx        +edc
      ec( 986)=ec( 986)+dy*edcy0+wqy*edcy1        +   excy        +edc
      ec( 987)=ec( 987)+dz*edcz0+wqz*edcz1+   xdcz        +tw*edzz+edc
      ec( 988)=ec( 988)+dy*edcx0+wqy*edcx1        +   excx
      ec( 989)=ec( 989)+dx*edcz0+wqx*edcz1+   zdcz+   eycz
      ec( 990)=ec( 990)+dy*edcz0+wqy*edcz1        +   excz
      ec( 991)=ec( 991)+dx*eddx0+wqx*eddx1+   zddx+   eydx+   edyx+edd
      ec( 992)=ec( 992)+dy*eddy0+wqy*eddy1        +   exdy+   edxy+edd
      ec( 993)=ec( 993)+dz*eddz0+wqz*eddz1+   xddz                +edd
      ec( 994)=ec( 994)+dy*eddx0+wqy*eddx1        +   exdx+   edxx
      ec( 995)=ec( 995)+dz*eddx0+wqz*eddx1+   xddx
      ec( 996)=ec( 996)+dz*eddy0+wqz*eddy1+   xddy
      ec( 997)=ec( 997)+dx*edex0+wqx*edex1+   zdex+   eyex+   edzx+ede
      ec( 998)=ec( 998)+dy*edey0+wqy*edey1        +   exey        +ede
      ec( 999)=ec( 999)+dz*edez0+wqz*edez1+   xdez        +   edxz+ede
      ec(1000)=ec(1000)+dy*edex0+wqy*edex1        +   exex
      ec(1001)=ec(1001)+dz*edex0+wqz*edex1+   xdex        +   edxx
      ec(1002)=ec(1002)+dy*edez0+wqy*edez1        +   exez
      ec(1003)=ec(1003)+dx*edfx0+wqx*edfx1+   zdfx+   eyfx        +edf
      ec(1004)=ec(1004)+dy*edfy0+wqy*edfy1        +   exfy+   edzy+edf
      ec(1005)=ec(1005)+dz*edfz0+wqz*edfz1+   xdfz        +   edyz+edf
      ec(1006)=ec(1006)+dx*edfy0+wqx*edfy1+   zdfy+   eyfy
      ec(1007)=ec(1007)+dx*edfz0+wqx*edfz1+   zdfz+   eyfz
      ec(1008)=ec(1008)+dy*edfz0+wqy*edfz1        +   exfz+   edzz
                                                  
      ec(1009)=ec(1009)+dx*eeax0+wqx*eeax1+   zeax+   ezax+tw*eexx+eea
      ec(1010)=ec(1010)+dy*eeay0+wqy*eeay1                        +eea
      ec(1011)=ec(1011)+dz*eeaz0+wqz*eeaz1+   xeaz+   exaz        +eea
      ec(1012)=ec(1012)+dy*eeax0+wqy*eeax1
      ec(1013)=ec(1013)+dz*eeax0+wqz*eeax1+   xeax+   exax
      ec(1014)=ec(1014)+dy*eeaz0+wqy*eeaz1
      ec(1015)=ec(1015)+dx*eebx0+wqx*eebx1+   zebx+   ezbx        +eeb
      ec(1016)=ec(1016)+dy*eeby0+wqy*eeby1                +tw*eeyy+eeb
      ec(1017)=ec(1017)+dz*eebz0+wqz*eebz1+   xebz+   exbz        +eeb
      ec(1018)=ec(1018)+dy*eebx0+wqy*eebx1                +tw*eeyx
      ec(1019)=ec(1019)+dx*eebz0+wqx*eebz1+   zebz+   ezbz
      ec(1020)=ec(1020)+dy*eebz0+wqy*eebz1                +tw*eeyz
      ec(1021)=ec(1021)+dx*eecx0+wqx*eecx1+   zecx+   ezcx        +eec
      ec(1022)=ec(1022)+dy*eecy0+wqy*eecy1                        +eec
      ec(1023)=ec(1023)+dz*eecz0+wqz*eecz1+   xecz+   excz+tw*eezz+eec
      ec(1024)=ec(1024)+dy*eecx0+wqy*eecx1
      ec(1025)=ec(1025)+dx*eecz0+wqx*eecz1+   zecz+   ezcz
      ec(1026)=ec(1026)+dy*eecz0+wqy*eecz1
      ec(1027)=ec(1027)+dx*eedx0+wqx*eedx1+   zedx+   ezdx+   eeyx+eed
      ec(1028)=ec(1028)+dy*eedy0+wqy*eedy1                +   eexy+eed
      ec(1029)=ec(1029)+dz*eedz0+wqz*eedz1+   xedz+   exdz        +eed
      ec(1030)=ec(1030)+dy*eedx0+wqy*eedx1                +   eexx
      ec(1031)=ec(1031)+dz*eedx0+wqz*eedx1+   xedx+   exdx
      ec(1032)=ec(1032)+dy*eedz0+wqy*eedz1                +   eexz
      ec(1033)=ec(1033)+dx*eeex0+wqx*eeex1+   zeex+   ezex+   eezx+eee
      ec(1034)=ec(1034)+dy*eeey0+wqy*eeey1                        +eee
      ec(1035)=ec(1035)+dz*eeez0+wqz*eeez1+   xeez+   exez+   eexz+eee
      ec(1036)=ec(1036)+dy*eeex0+wqy*eeex1
      ec(1037)=ec(1037)+dz*eeex0+wqz*eeex1+   xeex+   exex+   eexx
      ec(1038)=ec(1038)+dy*eeez0+wqy*eeez1
      ec(1039)=ec(1039)+dx*eefx0+wqx*eefx1+   zefx+   ezfx        +eef
      ec(1040)=ec(1040)+dy*eefy0+wqy*eefy1                +   eezy+eef
      ec(1041)=ec(1041)+dz*eefz0+wqz*eefz1+   xefz+   exfz+   eeyz+eef
      ec(1042)=ec(1042)+dy*eefx0+wqy*eefx1                +   eezx
      ec(1043)=ec(1043)+dx*eefz0+wqx*eefz1+   zefz+   ezfz
      ec(1044)=ec(1044)+dy*eefz0+wqy*eefz1                +   eezz
                                                  
      ec(1045)=ec(1045)+dx*efax0+wqx*efax1+   zfax        +tw*efxx+efa
      ec(1046)=ec(1046)+dy*efay0+wqy*efay1        +   ezay        +efa
      ec(1047)=ec(1047)+dz*efaz0+wqz*efaz1+   xfaz+   eyaz        +efa
      ec(1048)=ec(1048)+dy*efax0+wqy*efax1        +   ezax
      ec(1049)=ec(1049)+dz*efax0+wqz*efax1+   xfax+   eyax
      ec(1050)=ec(1050)+dy*efaz0+wqy*efaz1        +   ezaz
      ec(1051)=ec(1051)+dx*efbx0+wqx*efbx1+   zfbx                +efb
      ec(1052)=ec(1052)+dy*efby0+wqy*efby1        +   ezby+tw*efyy+efb
      ec(1053)=ec(1053)+dz*efbz0+wqz*efbz1+   xfbz+   eybz        +efb
      ec(1054)=ec(1054)+dx*efby0+wqx*efby1+   zfby
      ec(1055)=ec(1055)+dx*efbz0+wqx*efbz1+   zfbz
      ec(1056)=ec(1056)+dz*efby0+wqz*efby1+   xfby+   eyby
      ec(1057)=ec(1057)+dx*efcx0+wqx*efcx1+   zfcx                +efc
      ec(1058)=ec(1058)+dy*efcy0+wqy*efcy1        +   ezcy        +efc
      ec(1059)=ec(1059)+dz*efcz0+wqz*efcz1+   xfcz+   eycz+tw*efzz+efc
      ec(1060)=ec(1060)+dx*efcy0+wqx*efcy1+   zfcy
      ec(1061)=ec(1061)+dx*efcz0+wqx*efcz1+   zfcz
      ec(1062)=ec(1062)+dy*efcz0+wqy*efcz1        +   ezcz
      ec(1063)=ec(1063)+dx*efdx0+wqx*efdx1+   zfdx        +   efyx+efd
      ec(1064)=ec(1064)+dy*efdy0+wqy*efdy1        +   ezdy+   efxy+efd
      ec(1065)=ec(1065)+dz*efdz0+wqz*efdz1+   xfdz+   eydz        +efd
      ec(1066)=ec(1066)+dy*efdx0+wqy*efdx1        +   ezdx+   efxx
      ec(1067)=ec(1067)+dz*efdx0+wqz*efdx1+   xfdx+   eydx
      ec(1068)=ec(1068)+dy*efdz0+wqy*efdz1        +   ezdz+   efxz
      ec(1069)=ec(1069)+dx*efex0+wqx*efex1+   zfex        +   efzx+efe
      ec(1070)=ec(1070)+dy*efey0+wqy*efey1        +   ezey        +efe
      ec(1071)=ec(1071)+dz*efez0+wqz*efez1+   xfez+   eyez+   efxz+efe
      ec(1072)=ec(1072)+dy*efex0+wqy*efex1        +   ezex
      ec(1073)=ec(1073)+dx*efez0+wqx*efez1+   zfez        +   efzz
      ec(1074)=ec(1074)+dy*efez0+wqy*efez1        +   ezez
      ec(1075)=ec(1075)+dx*effx0+wqx*effx1+   zffx                +eff
      ec(1076)=ec(1076)+dy*effy0+wqy*effy1        +   ezfy+   efzy+eff
      ec(1077)=ec(1077)+dz*effz0+wqz*effz1+   xffz+   eyfz+   efyz+eff
      ec(1078)=ec(1078)+dx*effy0+wqx*effy1+   zffy
      ec(1079)=ec(1079)+dx*effz0+wqx*effz1+   zffz
      ec(1080)=ec(1080)+dy*effz0+wqy*effz1        +   ezfz+   efzz
                                                  
      ec(1081)=ec(1081)+dx*faax0+wqx*faax1        +tw*fxax+tw*faxx+faa
      ec(1082)=ec(1082)+dy*faay0+wqy*faay1+   zaay                +faa
      ec(1083)=ec(1083)+dz*faaz0+wqz*faaz1+   yaaz                +faa
      ec(1084)=ec(1084)+dy*faax0+wqy*faax1+   zaax
      ec(1085)=ec(1085)+dz*faax0+wqz*faax1+   yaax
      ec(1086)=ec(1086)+dy*faaz0+wqy*faaz1+   zaaz
      ec(1087)=ec(1087)+dx*fabx0+wqx*fabx1        +tw*fxbx        +fab
      ec(1088)=ec(1088)+dy*faby0+wqy*faby1+   zaby        +tw*fayy+fab
      ec(1089)=ec(1089)+dz*fabz0+wqz*fabz1+   yabz                +fab
      ec(1090)=ec(1090)+dx*faby0+wqx*faby1        +tw*fxby
      ec(1091)=ec(1091)+dz*fabx0+wqz*fabx1+   yabx
      ec(1092)=ec(1092)+dz*faby0+wqz*faby1+   yaby
      ec(1093)=ec(1093)+dx*facx0+wqx*facx1        +tw*fxcx        +fac
      ec(1094)=ec(1094)+dy*facy0+wqy*facy1+   zacy                +fac
      ec(1095)=ec(1095)+dz*facz0+wqz*facz1+   yacz        +tw*fazz+fac
      ec(1096)=ec(1096)+dy*facx0+wqy*facx1+   zacx
      ec(1097)=ec(1097)+dx*facz0+wqx*facz1        +tw*fxcz
      ec(1098)=ec(1098)+dy*facz0+wqy*facz1+   zacz
      ec(1099)=ec(1099)+dx*fadx0+wqx*fadx1        +tw*fxdx+   fayx+fad
      ec(1100)=ec(1100)+dy*fady0+wqy*fady1+   zady        +   faxy+fad
      ec(1101)=ec(1101)+dz*fadz0+wqz*fadz1+   yadz                +fad
      ec(1102)=ec(1102)+dy*fadx0+wqy*fadx1+   zadx        +   faxx
      ec(1103)=ec(1103)+dz*fadx0+wqz*fadx1+   yadx
      ec(1104)=ec(1104)+dz*fady0+wqz*fady1+   yady
      ec(1105)=ec(1105)+dx*faex0+wqx*faex1        +tw*fxex+   fazx+fae
      ec(1106)=ec(1106)+dy*faey0+wqy*faey1+   zaey                +fae
      ec(1107)=ec(1107)+dz*faez0+wqz*faez1+   yaez        +   faxz+fae
      ec(1108)=ec(1108)+dy*faex0+wqy*faex1+   zaex
      ec(1109)=ec(1109)+dz*faex0+wqz*faex1+   yaex        +   faxx
      ec(1110)=ec(1110)+dy*faez0+wqy*faez1+   zaez
      ec(1111)=ec(1111)+dx*fafx0+wqx*fafx1        +tw*fxfx        +faf
      ec(1112)=ec(1112)+dy*fafy0+wqy*fafy1+   zafy        +   fazy+faf
      ec(1113)=ec(1113)+dz*fafz0+wqz*fafz1+   yafz        +   fayz+faf
      ec(1114)=ec(1114)+dx*fafy0+wqx*fafy1        +tw*fxfy            
      ec(1115)=ec(1115)+dx*fafz0+wqx*fafz1        +tw*fxfz            
      ec(1116)=ec(1116)+dy*fafz0+wqy*fafz1+   zafz        +   fazz
                                                  
      ec(1117)=ec(1117)+dx*fbax0+wqx*fbax1                +tw*fbxx+fba
      ec(1118)=ec(1118)+dy*fbay0+wqy*fbay1+   zbay+tw*fyay        +fba
      ec(1119)=ec(1119)+dz*fbaz0+wqz*fbaz1+   ybaz                +fba
      ec(1120)=ec(1120)+dx*fbay0+wqx*fbay1                +tw*fbxy
      ec(1121)=ec(1121)+dz*fbax0+wqz*fbax1+   ybax
      ec(1122)=ec(1122)+dz*fbay0+wqz*fbay1+   ybay
      ec(1123)=ec(1123)+dx*fbbx0+wqx*fbbx1                        +fbb
      ec(1124)=ec(1124)+dy*fbby0+wqy*fbby1+   zbby+tw*fyby+tw*fbyy+fbb
      ec(1125)=ec(1125)+dz*fbbz0+wqz*fbbz1+   ybbz                +fbb
      ec(1126)=ec(1126)+dx*fbby0+wqx*fbby1
      ec(1127)=ec(1127)+dx*fbbz0+wqx*fbbz1
      ec(1128)=ec(1128)+dz*fbby0+wqz*fbby1+   ybby
      ec(1129)=ec(1129)+dx*fbcx0+wqx*fbcx1                        +fbc
      ec(1130)=ec(1130)+dy*fbcy0+wqy*fbcy1+   zbcy+tw*fycy        +fbc
      ec(1131)=ec(1131)+dz*fbcz0+wqz*fbcz1+   ybcz        +tw*fbzz+fbc
      ec(1132)=ec(1132)+dx*fbcy0+wqx*fbcy1
      ec(1133)=ec(1133)+dx*fbcz0+wqx*fbcz1
      ec(1134)=ec(1134)+dy*fbcz0+wqy*fbcz1+   zbcz+tw*fycz
      ec(1135)=ec(1135)+dx*fbdx0+wqx*fbdx1                +   fbyx+fbd
      ec(1136)=ec(1136)+dy*fbdy0+wqy*fbdy1+   zbdy+tw*fydy+   fbxy+fbd
      ec(1137)=ec(1137)+dz*fbdz0+wqz*fbdz1+   ybdz                +fbd
      ec(1138)=ec(1138)+dx*fbdy0+wqx*fbdy1                +   fbyy
      ec(1139)=ec(1139)+dx*fbdz0+wqx*fbdz1                +   fbyz
      ec(1140)=ec(1140)+dz*fbdy0+wqz*fbdy1+   ybdy
      ec(1141)=ec(1141)+dx*fbex0+wqx*fbex1                +   fbzx+fbe
      ec(1142)=ec(1142)+dy*fbey0+wqy*fbey1+   zbey+tw*fyey        +fbe
      ec(1143)=ec(1143)+dz*fbez0+wqz*fbez1+   ybez        +   fbxz+fbe
      ec(1144)=ec(1144)+dx*fbey0+wqx*fbey1                +   fbzy
      ec(1145)=ec(1145)+dx*fbez0+wqx*fbez1                +   fbzz
      ec(1146)=ec(1146)+dz*fbey0+wqz*fbey1+   ybey        +   fbxy
      ec(1147)=ec(1147)+dx*fbfx0+wqx*fbfx1                        +fbf
      ec(1148)=ec(1148)+dy*fbfy0+wqy*fbfy1+   zbfy+tw*fyfy+   fbzy+fbf
      ec(1149)=ec(1149)+dz*fbfz0+wqz*fbfz1+   ybfz        +   fbyz+fbf
      ec(1150)=ec(1150)+dx*fbfy0+wqx*fbfy1
      ec(1151)=ec(1151)+dx*fbfz0+wqx*fbfz1
      ec(1152)=ec(1152)+dz*fbfy0+wqz*fbfy1+   ybfy        +   fbyy
                                                  
      ec(1153)=ec(1153)+dx*fcax0+wqx*fcax1                +tw*fcxx+fca
      ec(1154)=ec(1154)+dy*fcay0+wqy*fcay1+   zcay                +fca
      ec(1155)=ec(1155)+dz*fcaz0+wqz*fcaz1+   ycaz+tw*fzaz        +fca
      ec(1156)=ec(1156)+dy*fcax0+wqy*fcax1+   zcax
      ec(1157)=ec(1157)+dx*fcaz0+wqx*fcaz1                +tw*fcxz
      ec(1158)=ec(1158)+dy*fcaz0+wqy*fcaz1+   zcaz
      ec(1159)=ec(1159)+dx*fcbx0+wqx*fcbx1                        +fcb
      ec(1160)=ec(1160)+dy*fcby0+wqy*fcby1+   zcby        +tw*fcyy+fcb
      ec(1161)=ec(1161)+dz*fcbz0+wqz*fcbz1+   ycbz+tw*fzbz        +fcb
      ec(1162)=ec(1162)+dx*fcby0+wqx*fcby1
      ec(1163)=ec(1163)+dx*fcbz0+wqx*fcbz1
      ec(1164)=ec(1164)+dy*fcbz0+wqy*fcbz1+   zcbz        +tw*fcyz
      ec(1165)=ec(1165)+dx*fccx0+wqx*fccx1                        +fcc
      ec(1166)=ec(1166)+dy*fccy0+wqy*fccy1+   zccy                +fcc
      ec(1167)=ec(1167)+dz*fccz0+wqz*fccz1+   yccz+tw*fzcz+tw*fczz+fcc
      ec(1168)=ec(1168)+dx*fccy0+wqx*fccy1
      ec(1169)=ec(1169)+dx*fccz0+wqx*fccz1
      ec(1170)=ec(1170)+dy*fccz0+wqy*fccz1+   zccz
      ec(1171)=ec(1171)+dx*fcdx0+wqx*fcdx1                +   fcyx+fcd
      ec(1172)=ec(1172)+dy*fcdy0+wqy*fcdy1+   zcdy        +   fcxy+fcd
      ec(1173)=ec(1173)+dz*fcdz0+wqz*fcdz1+   ycdz+tw*fzdz        +fcd
      ec(1174)=ec(1174)+dx*fcdy0+wqx*fcdy1                +   fcyy
      ec(1175)=ec(1175)+dx*fcdz0+wqx*fcdz1                +   fcyz
      ec(1176)=ec(1176)+dy*fcdz0+wqy*fcdz1+   zcdz        +   fcxz
      ec(1177)=ec(1177)+dx*fcex0+wqx*fcex1                +   fczx+fce
      ec(1178)=ec(1178)+dy*fcey0+wqy*fcey1+   zcey                +fce
      ec(1179)=ec(1179)+dz*fcez0+wqz*fcez1+   ycez+tw*fzez+   fcxz+fce
      ec(1180)=ec(1180)+dy*fcex0+wqy*fcex1+   zcex
      ec(1181)=ec(1181)+dx*fcez0+wqx*fcez1                +   fczz
      ec(1182)=ec(1182)+dy*fcez0+wqy*fcez1+   zcez
      ec(1183)=ec(1183)+dx*fcfx0+wqx*fcfx1                        +fcf
      ec(1184)=ec(1184)+dy*fcfy0+wqy*fcfy1+   zcfy        +   fczy+fcf
      ec(1185)=ec(1185)+dz*fcfz0+wqz*fcfz1+   ycfz+tw*fzfz+   fcyz+fcf
      ec(1186)=ec(1186)+dx*fcfy0+wqx*fcfy1
      ec(1187)=ec(1187)+dx*fcfz0+wqx*fcfz1
      ec(1188)=ec(1188)+dy*fcfz0+wqy*fcfz1+   zcfz        +   fczz
                                                  
      ec(1189)=ec(1189)+dx*fdax0+wqx*fdax1        +   fyax+tw*fdxx+fda
      ec(1190)=ec(1190)+dy*fday0+wqy*fday1+   zday+   fxay        +fda
      ec(1191)=ec(1191)+dz*fdaz0+wqz*fdaz1+   ydaz                +fda
      ec(1192)=ec(1192)+dx*fday0+wqx*fday1        +   fyay+tw*fdxy
      ec(1193)=ec(1193)+dz*fdax0+wqz*fdax1+   ydax
      ec(1194)=ec(1194)+dz*fday0+wqz*fday1+   yday
      ec(1195)=ec(1195)+dx*fdbx0+wqx*fdbx1        +   fybx        +fdb
      ec(1196)=ec(1196)+dy*fdby0+wqy*fdby1+   zdby+   fxby+tw*fdyy+fdb
      ec(1197)=ec(1197)+dz*fdbz0+wqz*fdbz1+   ydbz                +fdb
      ec(1198)=ec(1198)+dx*fdby0+wqx*fdby1        +   fyby
      ec(1199)=ec(1199)+dz*fdbx0+wqz*fdbx1+   ydbx
      ec(1200)=ec(1200)+dz*fdby0+wqz*fdby1+   ydby
      ec(1201)=ec(1201)+dx*fdcx0+wqx*fdcx1        +   fycx        +fdc
      ec(1202)=ec(1202)+dy*fdcy0+wqy*fdcy1+   zdcy+   fxcy        +fdc
      ec(1203)=ec(1203)+dz*fdcz0+wqz*fdcz1+   ydcz        +tw*fdzz+fdc
      ec(1204)=ec(1204)+dx*fdcy0+wqx*fdcy1        +   fycy
      ec(1205)=ec(1205)+dx*fdcz0+wqx*fdcz1        +   fycz
      ec(1206)=ec(1206)+dy*fdcz0+wqy*fdcz1+   zdcz+   fxcz
      ec(1207)=ec(1207)+dx*fddx0+wqx*fddx1        +   fydx+   fdyx+fdd
      ec(1208)=ec(1208)+dy*fddy0+wqy*fddy1+   zddy+   fxdy+   fdxy+fdd
      ec(1209)=ec(1209)+dz*fddz0+wqz*fddz1+   yddz                +fdd
      ec(1210)=ec(1210)+dx*fddy0+wqx*fddy1        +   fydy+   fdyy
      ec(1211)=ec(1211)+dz*fddx0+wqz*fddx1+   yddx
      ec(1212)=ec(1212)+dz*fddy0+wqz*fddy1+   yddy
      ec(1213)=ec(1213)+dx*fdex0+wqx*fdex1        +   fyex+   fdzx+fde
      ec(1214)=ec(1214)+dy*fdey0+wqy*fdey1+   zdey+   fxey        +fde
      ec(1215)=ec(1215)+dz*fdez0+wqz*fdez1+   ydez        +   fdxz+fde
      ec(1216)=ec(1216)+dy*fdex0+wqy*fdex1+   zdex+   fxex            
      ec(1217)=ec(1217)+dx*fdez0+wqx*fdez1        +   fyez+   fdzz
      ec(1218)=ec(1218)+dy*fdez0+wqy*fdez1+   zdez+   fxez
      ec(1219)=ec(1219)+dx*fdfx0+wqx*fdfx1        +   fyfx        +fdf
      ec(1220)=ec(1220)+dy*fdfy0+wqy*fdfy1+   zdfy+   fxfy+   fdzy+fdf
      ec(1221)=ec(1221)+dz*fdfz0+wqz*fdfz1+   ydfz        +   fdyz+fdf
      ec(1222)=ec(1222)+dx*fdfy0+wqx*fdfy1        +   fyfy
      ec(1223)=ec(1223)+dx*fdfz0+wqx*fdfz1        +   fyfz
      ec(1224)=ec(1224)+dy*fdfz0+wqy*fdfz1+   zdfz+   fxfz+   fdzz
                                                  
      ec(1225)=ec(1225)+dx*feax0+wqx*feax1        +   fzax+tw*fexx+fea
      ec(1226)=ec(1226)+dy*feay0+wqy*feay1+   zeay                +fea
      ec(1227)=ec(1227)+dz*feaz0+wqz*feaz1+   yeaz+   fxaz        +fea
      ec(1228)=ec(1228)+dy*feax0+wqy*feax1+   zeax
      ec(1229)=ec(1229)+dz*feax0+wqz*feax1+   yeax+   fxax
      ec(1230)=ec(1230)+dy*feaz0+wqy*feaz1+   zeaz
      ec(1231)=ec(1231)+dx*febx0+wqx*febx1        +   fzbx        +feb
      ec(1232)=ec(1232)+dy*feby0+wqy*feby1+   zeby        +tw*feyy+feb
      ec(1233)=ec(1233)+dz*febz0+wqz*febz1+   yebz+   fxbz        +feb
      ec(1234)=ec(1234)+dx*feby0+wqx*feby1        +   fzby
      ec(1235)=ec(1235)+dx*febz0+wqx*febz1        +   fzbz
      ec(1236)=ec(1236)+dz*feby0+wqz*feby1+   yeby+   fxby
      ec(1237)=ec(1237)+dx*fecx0+wqx*fecx1        +   fzcx        +fec
      ec(1238)=ec(1238)+dy*fecy0+wqy*fecy1+   zecy                +fec
      ec(1239)=ec(1239)+dz*fecz0+wqz*fecz1+   yecz+   fxcz+tw*fezz+fec
      ec(1240)=ec(1240)+dy*fecx0+wqy*fecx1+   zecx
      ec(1241)=ec(1241)+dx*fecz0+wqx*fecz1        +   fzcz
      ec(1242)=ec(1242)+dy*fecz0+wqy*fecz1+   zecz
      ec(1243)=ec(1243)+dx*fedx0+wqx*fedx1        +   fzdx+   feyx+fed
      ec(1244)=ec(1244)+dy*fedy0+wqy*fedy1+   zedy        +   fexy+fed
      ec(1245)=ec(1245)+dz*fedz0+wqz*fedz1+   yedz+   fxdz        +fed
      ec(1246)=ec(1246)+dy*fedx0+wqy*fedx1+   zedx        +   fexx
      ec(1247)=ec(1247)+dx*fedz0+wqx*fedz1        +   fzdz+   feyz
      ec(1248)=ec(1248)+dy*fedz0+wqy*fedz1+   zedz        +   fexz
      ec(1249)=ec(1249)+dx*feex0+wqx*feex1        +   fzex+   fezx+fee
      ec(1250)=ec(1250)+dy*feey0+wqy*feey1+   zeey                +fee
      ec(1251)=ec(1251)+dz*feez0+wqz*feez1+   yeez+   fxez+   fexz+fee
      ec(1252)=ec(1252)+dy*feex0+wqy*feex1+   zeex
      ec(1253)=ec(1253)+dx*feez0+wqx*feez1        +   fzez+   fezz
      ec(1254)=ec(1254)+dy*feez0+wqy*feez1+   zeez
      ec(1255)=ec(1255)+dx*fefx0+wqx*fefx1        +   fzfx        +fef
      ec(1256)=ec(1256)+dy*fefy0+wqy*fefy1+   zefy        +   fezy+fef
      ec(1257)=ec(1257)+dz*fefz0+wqz*fefz1+   yefz+   fxfz+   feyz+fef
      ec(1258)=ec(1258)+dx*fefy0+wqx*fefy1        +   fzfy
      ec(1259)=ec(1259)+dx*fefz0+wqx*fefz1        +   fzfz
      ec(1260)=ec(1260)+dy*fefz0+wqy*fefz1+   zefz        +   fezz
                                                  
      ec(1261)=ec(1261)+dx*ffax0+wqx*ffax1                +tw*ffxx+ffa
      ec(1262)=ec(1262)+dy*ffay0+wqy*ffay1+   zfay+   fzay        +ffa
      ec(1263)=ec(1263)+dz*ffaz0+wqz*ffaz1+   yfaz+   fyaz        +ffa
      ec(1264)=ec(1264)+dx*ffay0+wqx*ffay1                +tw*ffxy
      ec(1265)=ec(1265)+dx*ffaz0+wqx*ffaz1                +tw*ffxz
      ec(1266)=ec(1266)+dy*ffaz0+wqy*ffaz1+   zfaz+   fzaz
      ec(1267)=ec(1267)+dx*ffbx0+wqx*ffbx1                        +ffb
      ec(1268)=ec(1268)+dy*ffby0+wqy*ffby1+   zfby+   fzby+tw*ffyy+ffb
      ec(1269)=ec(1269)+dz*ffbz0+wqz*ffbz1+   yfbz+   fybz        +ffb
      ec(1270)=ec(1270)+dx*ffby0+wqx*ffby1
      ec(1271)=ec(1271)+dx*ffbz0+wqx*ffbz1
      ec(1272)=ec(1272)+dz*ffby0+wqz*ffby1+   yfby+   fyby
      ec(1273)=ec(1273)+dx*ffcx0+wqx*ffcx1                        +ffc
      ec(1274)=ec(1274)+dy*ffcy0+wqy*ffcy1+   zfcy+   fzcy        +ffc
      ec(1275)=ec(1275)+dz*ffcz0+wqz*ffcz1+   yfcz+   fycz+tw*ffzz+ffc
      ec(1276)=ec(1276)+dx*ffcy0+wqx*ffcy1
      ec(1277)=ec(1277)+dx*ffcz0+wqx*ffcz1
      ec(1278)=ec(1278)+dy*ffcz0+wqy*ffcz1+   zfcz+   fzcz
      ec(1279)=ec(1279)+dx*ffdx0+wqx*ffdx1                +   ffyx+ffd
      ec(1280)=ec(1280)+dy*ffdy0+wqy*ffdy1+   zfdy+   fzdy+   ffxy+ffd
      ec(1281)=ec(1281)+dz*ffdz0+wqz*ffdz1+   yfdz+   fydz        +ffd
      ec(1282)=ec(1282)+dx*ffdy0+wqx*ffdy1                +   ffyy
      ec(1283)=ec(1283)+dx*ffdz0+wqx*ffdz1                +   ffyz
      ec(1284)=ec(1284)+dz*ffdy0+wqz*ffdy1+   yfdy+   fydy
      ec(1285)=ec(1285)+dx*ffex0+wqx*ffex1                +   ffzx+ffe
      ec(1286)=ec(1286)+dy*ffey0+wqy*ffey1+   zfey+   fzey        +ffe
      ec(1287)=ec(1287)+dz*ffez0+wqz*ffez1+   yfez+   fyez+   ffxz+ffe
      ec(1288)=ec(1288)+dx*ffey0+wqx*ffey1                +   ffzy
      ec(1289)=ec(1289)+dx*ffez0+wqx*ffez1                +   ffzz
      ec(1290)=ec(1290)+dy*ffez0+wqy*ffez1+   zfez+   fzez
      ec(1291)=ec(1291)+dx*fffx0+wqx*fffx1                        +fff
      ec(1292)=ec(1292)+dy*fffy0+wqy*fffy1+   zffy+   fzfy+   ffzy+fff
      ec(1293)=ec(1293)+dz*fffz0+wqz*fffz1+   yffz+   fyfz+   ffyz+fff
      ec(1294)=ec(1294)+dx*fffy0+wqx*fffy1
      ec(1295)=ec(1295)+dx*fffz0+wqx*fffz1
      ec(1296)=ec(1296)+dy*fffz0+wqy*fffz1+   zffz+   fzfz+   ffzz

 9996           enddo
 9997       enddo
 9998    enddo
 9999 enddo
#ifdef PL_OMP_ERI
!$omp end do
!$omp end parallel
#endif

      if (ierisw.eq.0) then 

        do i=649,1296
          ec(i)= ec(i)*root3
        enddo

         do i=1,36
            do ii=19,36
               iii = ii + 36*(i-1)
               ec(iii)=ec(iii)*root3
           enddo
        enddo

        do i=1,6
           do ii=109,216
              iii = ii + 216*(i-1)
              ec(iii) = ec(iii)*root3
           enddo
        enddo

        do i=1,216
             do ii=4,6
              iii = ii + 6*(i-1)
              ec(iii) = ec(iii)*root3
           enddo
        enddo

      endif
      
      end
