! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!= dddp =============================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================
      subroutine iodddp(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )


      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)

      dimension ec(648)

      real(8),parameter::pi    = 3.14159265358979323846d+00
      real(8),parameter::tf(25) = (/
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /)

      real(8),parameter::ga0 = 1.0d+00
      real(8),parameter::ga1 = 1.000 000 000 000 005 298d+00
      real(8),parameter::ga2 = 0.5d+00
      real(8),parameter::ga3 = 0.166 666 666 598 849 826d+00
      real(8),parameter::ga4 = 0.416 666 666 666 666 667d-01
      real(8),parameter::ga5 = 0.833 355 034 722 222 222d-02
      real(8),parameter::ga6 = 0.138 888 888 888 888 889d-02

      real(8),parameter::rminv(7) = (/
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 ,
     &   0.09090909090909090d+00,  0.07692307692307692d+00 /)

      real(8),parameter::root3 = 1.73205080756887729352d+00

#ifdef PL_SIMD_DERI
c$$$      dimension dmx(8,mxprm), val(5,mxprm)
#endif

      do i = 1,648
        ec(i) = 0.d0
      enddo

#ifdef PL_OMP_ERI
!$omp parallel reduction(+:ec)
!$omp& default(private)
!$omp& shared(xyz,fdat,edat,
!$omp&        zetpq,ntprm,z,yp,yq,uu,uv,iatom,jatom,katom,latom,
!$omp&        ishel,jshel,kshel,lshel,iasp,jasp,kasp,lasp)
#endif

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

#ifdef PL_OMP_ERI
!$omp do
#endif
      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(8)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f7   = (((((fdat(14,it)*dt6   + fdat(13,it))*dt5
     &                    + fdat(12,it))*dt4  + fdat(11,it))*dt3
     &                    + fdat(10,it))*dt2  + fdat(9,it))*dt
     &                    + fdat(8,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f6   = (t2*f7 + ee)*rminv(7)
                     f5   = (t2*f6 + ee)*rminv(6)
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)

                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     dm6 = fpp*f6! *( roo2)**3
                     dm7 = fpp*f7! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
                     dm5 =  4.5d0 *tinv *  dm4
                     dm6 =  5.5d0 *tinv *  dm5
                     dm7 =  6.5d0 *tinv *  dm6
                     
                  end if

#ifdef PL_SIMD_ERI
c$$$                  val(1,l) = qpx
c$$$                  val(2,l) = qpy
c$$$                  val(3,l) = qpz
c$$$                  val(4,l) = roo2
c$$$                  val(5,l) = eta
c$$$
c$$$                  dmx(1,l) = dm0
c$$$                  dmx(2,l) = dm1
c$$$                  dmx(3,l) = dm2
c$$$                  dmx(4,l) = dm3
c$$$                  dmx(5,l) = dm4
c$$$                  dmx(6,l) = dm5
c$$$                  dmx(7,l) = dm6
c$$$                  dmx(8,l) = dm7
c$$$               enddo
c$$$
c$$$               do l = 1, lgp
c$$$                  qpx  = val(1,l)
c$$$                  qpy  = val(2,l)
c$$$                  qpz  = val(3,l)
c$$$                  roo2 = val(4,l)
c$$$                  eta  = val(5,l)
c$$$
c$$$                  dm0 = dmx(1,l)
c$$$                  dm1 = dmx(2,l)
c$$$                  dm2 = dmx(3,l)
c$$$                  dm3 = dmx(4,l)
c$$$                  dm4 = dmx(5,l)
c$$$                  dm5 = dmx(6,l)
c$$$                  dm6 = dmx(7,l)
c$$$                  dm7 = dmx(8,l)
#endif

                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)

                  qdx =  yq(1,l,k) - xyz(1,latom)
                  qdy =  yq(2,l,k) - xyz(2,latom)
                  qdz =  yq(3,l,k) - xyz(3,latom)
!ssss (0-7)                 
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)
                  s6 = dm6      !/( roo2**3)
                  s7 = dm7      !/( roo2**3)

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz

!psss(0-6) 
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
                  px5 = pax*s5 + wpx*s6
                  py5 = pay*s5 + wpy*s6
                  pz5 = paz*s5 + wpz*s6
                  px6 = pax*s6 + wpx*s7
                  py6 = pay*s6 + wpy*s7
                  pz6 = paz*s6 + wpz*s7
!spss(1-4)
                  xp1 = pbx*s1 + wpx*s2
                  yp1 = pby*s1 + wpy*s2
                  zp1 = pbz*s1 + wpz*s2
                  xp2 = pbx*s2 + wpx*s3
                  yp2 = pby*s2 + wpy*s3
                  zp2 = pbz*s2 + wpz*s3
                  xp3 = pbx*s3 + wpx*s4
                  yp3 = pby*s3 + wpy*s4
                  zp3 = pbz*s3 + wpz*s4
                  xp4 = pbx*s4 + wpx*s5
                  yp4 = pby*s4 + wpy*s5
                  zp4 = pbz*s4 + wpz*s5
!ssss01(01-56)
                  s01 = zet*(s0-rooz*s1)
                  s12 = zet*(s1-rooz*s2)
                  s23 = zet*(s2-rooz*s3)
                  s34 = zet*(s3-rooz*s4)
                  s45 = zet*(s4-rooz*s5)
                  s56 = zet*(s5-rooz*s6)
! dsss (0-5)
                  dxx0 = pax*px0 + wpx*px1+s01
                  dyy0 = pay*py0 + wpy*py1+s01
                  dzz0 = paz*pz0 + wpz*pz1+s01
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+s12
                  dyy1 = pay*py1 + wpy*py2+s12
                  dzz1 = paz*pz1 + wpz*pz2+s12
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+s23
                  dyy2 = pay*py2 + wpy*py3+s23
                  dzz2 = paz*pz2 + wpz*pz3+s23
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
 
                  dxx3 = pax*px3 + wpx*px4+s34
                  dyy3 = pay*py3 + wpy*py4+s34
                  dzz3 = paz*pz3 + wpz*pz4+s34
                  dyx3 = pay*px3 + wpy*px4
                  dzx3 = paz*px3 + wpz*px4
                  dzy3 = paz*py3 + wpz*py4

                  dxx4 = pax*px4 + wpx*px5+s45
                  dyy4 = pay*py4 + wpy*py5+s45
                  dzz4 = paz*pz4 + wpz*pz5+s45
                  dyx4 = pay*px4 + wpy*px5
                  dzx4 = paz*px4 + wpz*px5
                  dzy4 = paz*py4 + wpz*py5

                  dxx5 = pax*px5 + wpx*px6+s56
                  dyy5 = pay*py5 + wpy*py6+s56
                  dzz5 = paz*pz5 + wpz*pz6+s56
                  dyx5 = pay*px5 + wpy*px6
                  dzx5 = paz*px5 + wpz*px6
                  dzy5 = paz*py5 + wpz*py6

!sdss(2-3)
                  sdxx2 = pbx*xp2 + wpx*xp3 + s23
                  sdyy2 = pby*yp2 + wpy*yp3 + s23
                  sdzz2 = pbz*zp2 + wpz*zp3 + s23
                  sdyx2 = pby*xp2 + wpy*xp3
                  sdzx2 = pbz*xp2 + wpz*xp3
                  sdzy2 = pbz*yp2 + wpz*yp3
                  sdxx3 = pbx*xp3 + wpx*xp4 + s34
                  sdyy3 = pby*yp3 + wpy*yp4 + s34
                  sdzz3 = pbz*zp3 + wpz*zp4 + s34
                  sdyx3 = pby*xp3 + wpy*xp4
                  sdzx3 = pbz*xp3 + wpz*xp4
                  sdzy3 = pbz*yp3 + wpz*yp4

!ppss(0-4)
                  ppxx0 = pbx * px0 + wpx*px1 + s01
                  ppyx0 = pbx * py0 + wpx*py1
                  ppzx0 = pbx * pz0 + wpx*pz1
                  ppxy0 = pby * px0 + wpy*px1
                  ppyy0 = pby * py0 + wpy*py1 + s01
                  ppzy0 = pby * pz0 + wpy*pz1
                  ppxz0 = pbz * px0 + wpz*px1
                  ppyz0 = pbz * py0 + wpz*py1
                  ppzz0 = pbz * pz0 + wpz*pz1 + s01
                            
                  ppxx1 = pbx * px1 + wpx*px2 + s12
                  ppyx1 = pbx * py1 + wpx*py2
                  ppzx1 = pbx * pz1 + wpx*pz2
                  ppxy1 = pby * px1 + wpy*px2
                  ppyy1 = pby * py1 + wpy*py2 + s12
                  ppzy1 = pby * pz1 + wpy*pz2
                  ppxz1 = pbz * px1 + wpz*px2
                  ppyz1 = pbz * py1 + wpz*py2
                  ppzz1 = pbz * pz1 + wpz*pz2 + s12
                             
                  ppxx2 = pbx * px2 + wpx*px3 + s23
                  ppyx2 = pbx * py2 + wpx*py3
                  ppzx2 = pbx * pz2 + wpx*pz3
                  ppxy2 = pby * px2 + wpy*px3
                  ppyy2 = pby * py2 + wpy*py3 + s23
                  ppzy2 = pby * pz2 + wpy*pz3
                  ppxz2 = pbz * px2 + wpz*px3
                  ppyz2 = pbz * py2 + wpz*py3
                  ppzz2 = pbz * pz2 + wpz*pz3 + s23
           
                  ppxx3 = pbx * px3 + wpx*px4 + s34
                  ppyx3 = pbx * py3 + wpx*py4
                  ppzx3 = pbx * pz3 + wpx*pz4
                  ppxy3 = pby * px3 + wpy*px4
                  ppyy3 = pby * py3 + wpy*py4 + s34
                  ppzy3 = pby * pz3 + wpy*pz4
                  ppxz3 = pbz * px3 + wpz*px4
                  ppyz3 = pbz * py3 + wpz*py4
                  ppzz3 = pbz * pz3 + wpz*pz4 + s34

                  ppxx4 = pbx * px4 + wpx*px5 + s45
                  ppyx4 = pbx * py4 + wpx*py5
                  ppzx4 = pbx * pz4 + wpx*pz5
                  ppxy4 = pby * px4 + wpy*px5
                  ppyy4 = pby * py4 + wpy*py5 + s45
                  ppzy4 = pby * pz4 + wpy*pz5
                  ppxz4 = pbz * px4 + wpz*px5
                  ppyz4 = pbz * py4 + wpz*py5
                  ppzz4 = pbz * pz4 + wpz*pz5 + s45


!psss01(01-45)
                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  px34 = zet*(px3-rooz*px4)
                  py34 = zet*(py3-rooz*py4)
                  pz34 = zet*(pz3-rooz*pz4)
                  px45 = zet*(px4-rooz*px5)
                  py45 = zet*(py4-rooz*py5)
                  pz45 = zet*(pz4-rooz*pz5)

!dpss(0-4) 
                  dpxxx0 =  pbx*dxx0 + wpx*dxx1 + 2.0d0*px01
                  dpxxy0 =  pby*dxx0 + wpy*dxx1             
                  dpxxz0 =  pbz*dxx0 + wpz*dxx1             
                  dpyyx0 =  pbx*dyy0 + wpx*dyy1             
                  dpyyy0 =  pby*dyy0 + wpy*dyy1 + 2.0d0*py01
                  dpyyz0 =  pbz*dyy0 + wpz*dyy1             
                  dpzzx0 =  pbx*dzz0 + wpx*dzz1             
                  dpzzy0 =  pby*dzz0 + wpy*dzz1             
                  dpzzz0 =  pbz*dzz0 + wpz*dzz1 + 2.0d0*pz01
                  dpyxx0 =  pbx*dyx0 + wpx*dyx1 +       py01
                  dpyxy0 =  pby*dyx0 + wpy*dyx1 +       px01
                  dpyxz0 =  pbz*dyx0 + wpz*dyx1             
                  dpzxx0 =  pbx*dzx0 + wpx*dzx1 +       pz01
                  dpzxy0 =  pby*dzx0 + wpy*dzx1             
                  dpzxz0 =  pbz*dzx0 + wpz*dzx1 +       px01
                  dpzyx0 =  pbx*dzy0 + wpx*dzy1             
                  dpzyy0 =  pby*dzy0 + wpy*dzy1 +       pz01
                  dpzyz0 =  pbz*dzy0 + wpz*dzy1 +       py01
           
                  dpxxx1 =  pbx*dxx1 + wpx*dxx2 + 2.0d0*px12
                  dpxxy1 =  pby*dxx1 + wpy*dxx2             
                  dpxxz1 =  pbz*dxx1 + wpz*dxx2             
                  dpyyx1 =  pbx*dyy1 + wpx*dyy2             
                  dpyyy1 =  pby*dyy1 + wpy*dyy2 + 2.0d0*py12
                  dpyyz1 =  pbz*dyy1 + wpz*dyy2             
                  dpzzx1 =  pbx*dzz1 + wpx*dzz2             
                  dpzzy1 =  pby*dzz1 + wpy*dzz2             
                  dpzzz1 =  pbz*dzz1 + wpz*dzz2 + 2.0d0*pz12
                  dpyxx1 =  pbx*dyx1 + wpx*dyx2 +       py12
                  dpyxy1 =  pby*dyx1 + wpy*dyx2 +       px12
                  dpyxz1 =  pbz*dyx1 + wpz*dyx2             
                  dpzxx1 =  pbx*dzx1 + wpx*dzx2 +       pz12
                  dpzxy1 =  pby*dzx1 + wpy*dzx2             
                  dpzxz1 =  pbz*dzx1 + wpz*dzx2 +       px12
                  dpzyx1 =  pbx*dzy1 + wpx*dzy2             
                  dpzyy1 =  pby*dzy1 + wpy*dzy2 +       pz12
                  dpzyz1 =  pbz*dzy1 + wpz*dzy2 +       py12
           
                  dpxxx2 =  pbx*dxx2 + wpx*dxx3 + 2.0d0*px23
                  dpxxy2 =  pby*dxx2 + wpy*dxx3
                  dpxxz2 =  pbz*dxx2 + wpz*dxx3
                  dpyyx2 =  pbx*dyy2 + wpx*dyy3
                  dpyyy2 =  pby*dyy2 + wpy*dyy3 + 2.0d0*py23
                  dpyyz2 =  pbz*dyy2 + wpz*dyy3             
                  dpzzx2 =  pbx*dzz2 + wpx*dzz3             
                  dpzzy2 =  pby*dzz2 + wpy*dzz3             
                  dpzzz2 =  pbz*dzz2 + wpz*dzz3 + 2.0d0*pz23
                  dpyxx2 =  pbx*dyx2 + wpx*dyx3 +       py23
                  dpyxy2 =  pby*dyx2 + wpy*dyx3 +       px23
                  dpyxz2 =  pbz*dyx2 + wpz*dyx3             
                  dpzxx2 =  pbx*dzx2 + wpx*dzx3 +       pz23
                  dpzxy2 =  pby*dzx2 + wpy*dzx3             
                  dpzxz2 =  pbz*dzx2 + wpz*dzx3 +       px23
                  dpzyx2 =  pbx*dzy2 + wpx*dzy3             
                  dpzyy2 =  pby*dzy2 + wpy*dzy3 +       pz23
                  dpzyz2 =  pbz*dzy2 + wpz*dzy3 +       py23
           
                  dpxxx3 =  pbx*dxx3 + wpx*dxx4 + 2.0d0*px34
                  dpxxy3 =  pby*dxx3 + wpy*dxx4             
                  dpxxz3 =  pbz*dxx3 + wpz*dxx4             
                  dpyyx3 =  pbx*dyy3 + wpx*dyy4             
                  dpyyy3 =  pby*dyy3 + wpy*dyy4 + 2.0d0*py34
                  dpyyz3 =  pbz*dyy3 + wpz*dyy4             
                  dpzzx3 =  pbx*dzz3 + wpx*dzz4             
                  dpzzy3 =  pby*dzz3 + wpy*dzz4             
                  dpzzz3 =  pbz*dzz3 + wpz*dzz4 + 2.0d0*pz34
                  dpyxx3 =  pbx*dyx3 + wpx*dyx4 +       py34
                  dpyxy3 =  pby*dyx3 + wpy*dyx4 +       px34
                  dpyxz3 =  pbz*dyx3 + wpz*dyx4             
                  dpzxx3 =  pbx*dzx3 + wpx*dzx4 +       pz34
                  dpzxy3 =  pby*dzx3 + wpy*dzx4             
                  dpzxz3 =  pbz*dzx3 + wpz*dzx4 +       px34
                  dpzyx3 =  pbx*dzy3 + wpx*dzy4             
                  dpzyy3 =  pby*dzy3 + wpy*dzy4 +       pz34
                  dpzyz3 =  pbz*dzy3 + wpz*dzy4 +       py34

                  dpxxx4 =  pbx*dxx4 + wpx*dxx5 + 2.0d0*px45
                  dpxxy4 =  pby*dxx4 + wpy*dxx5             
                  dpxxz4 =  pbz*dxx4 + wpz*dxx5             
                  dpyyx4 =  pbx*dyy4 + wpx*dyy5             
                  dpyyy4 =  pby*dyy4 + wpy*dyy5 + 2.0d0*py45
                  dpyyz4 =  pbz*dyy4 + wpz*dyy5             
                  dpzzx4 =  pbx*dzz4 + wpx*dzz5             
                  dpzzy4 =  pby*dzz4 + wpy*dzz5             
                  dpzzz4 =  pbz*dzz4 + wpz*dzz5 + 2.0d0*pz45
                  dpyxx4 =  pbx*dyx4 + wpx*dyx5 +       py45
                  dpyxy4 =  pby*dyx4 + wpy*dyx5 +       px45
                  dpyxz4 =  pbz*dyx4 + wpz*dyx5             
                  dpzxx4 =  pbx*dzx4 + wpx*dzx5 +       pz45
                  dpzxy4 =  pby*dzx4 + wpy*dzx5             
                  dpzxz4 =  pbz*dzx4 + wpz*dzx5 +       px45
                  dpzyx4 =  pbx*dzy4 + wpx*dzy5             
                  dpzyy4 =  pby*dzy4 + wpy*dzy5 +       pz45
                  dpzyz4 =  pbz*dzy4 + wpz*dzy5 +       py45

!rpsss(3)
                  rpx3 = rkp*px3
                  rpy3 = rkp*py3
                  rpz3 = rkp*pz3
!rspss(3)
                  rxp3 = rkp*xp3
                  ryp3 = rkp*yp3
                  rzp3 = rkp*zp3

!ppps(2)
                  pppxxx2 = qcx*ppxx2 + wqx*ppxx3 + rxp3 + rpx3
                  pppxxy2 = qcy*ppxx2 + wqy*ppxx3        
                  pppxxz2 = qcz*ppxx2 + wqz*ppxx3        
                  pppxyx2 = qcx*ppxy2 + wqx*ppxy3 + ryp3
                  pppxyy2 = qcy*ppxy2 + wqy*ppxy3        + rpx3
                  pppxyz2 = qcz*ppxy2 + wqz*ppxy3              
                  pppxzx2 = qcx*ppxz2 + wqx*ppxz3 + rzp3       
                  pppxzy2 = qcy*ppxz2 + wqy*ppxz3              
                  pppxzz2 = qcz*ppxz2 + wqz*ppxz3        + rpx3
                  pppyxx2 = qcx*ppyx2 + wqx*ppyx3        + rpy3
                  pppyxy2 = qcy*ppyx2 + wqy*ppyx3 + rxp3       
                  pppyxz2 = qcz*ppyx2 + wqz*ppyx3              
                  pppyyx2 = qcx*ppyy2 + wqx*ppyy3              
                  pppyyy2 = qcy*ppyy2 + wqy*ppyy3 + ryp3 + rpy3
                  pppyyz2 = qcz*ppyy2 + wqz*ppyy3              
                  pppyzx2 = qcx*ppyz2 + wqx*ppyz3              
                  pppyzy2 = qcy*ppyz2 + wqy*ppyz3 + rzp3       
                  pppyzz2 = qcz*ppyz2 + wqz*ppyz3        + rpy3
                  pppzxx2 = qcx*ppzx2 + wqx*ppzx3        + rpz3
                  pppzxy2 = qcy*ppzx2 + wqy*ppzx3              
                  pppzxz2 = qcz*ppzx2 + wqz*ppzx3 + rxp3       
                  pppzyx2 = qcx*ppzy2 + wqx*ppzy3              
                  pppzyy2 = qcy*ppzy2 + wqy*ppzy3        + rpz3
                  pppzyz2 = qcz*ppzy2 + wqz*ppzy3 + ryp3       
                  pppzzx2 = qcx*ppzz2 + wqx*ppzz3
                  pppzzy2 = qcy*ppzz2 + wqy*ppzz3              
                  pppzzz2 = qcz*ppzz2 + wqz*ppzz3 + rzp3 + rpz3

!sdps(2)
                  xxdpx2 = qcx*sdxx2 + wqx*sdxx3 + 2.d0*rxp3
                  xxdpy2 = qcy*sdxx2 + wqy*sdxx3
                  xxdpz2 = qcz*sdxx2 + wqz*sdxx3
                  yydpx2 = qcx*sdyy2 + wqx*sdyy3
                  yydpy2 = qcy*sdyy2 + wqy*sdyy3 + 2.d0*ryp3
                  yydpz2 = qcz*sdyy2 + wqz*sdyy3
                  zzdpx2 = qcx*sdzz2 + wqx*sdzz3
                  zzdpy2 = qcy*sdzz2 + wqy*sdzz3
                  zzdpz2 = qcz*sdzz2 + wqz*sdzz3 + 2.d0*rzp3
                  yxdpx2 = qcx*sdyx2 + wqx*sdyx3 + 1.d0*ryp3
                  yxdpy2 = qcy*sdyx2 + wqy*sdyx3 + 1.d0*rxp3
                  yxdpz2 = qcz*sdyx2 + wqz*sdyx3
                  zxdpx2 = qcx*sdzx2 + wqx*sdzx3 + 1.d0*rzp3
                  zxdpy2 = qcy*sdzx2 + wqy*sdzx3
                  zxdpz2 = qcz*sdzx2 + wqz*sdzx3 + 1.d0*rxp3
                  zydpx2 = qcx*sdzy2 + wqx*sdzy3
                  zydpy2 = qcy*sdzy2 + wqy*sdzy3 + 1.d0*rzp3
                  zydpz2 = qcz*sdzy2 + wqz*sdzy3 + 1.d0*ryp3

!dsps(2)
                  dxxpx2 =  qcx*dxx2 + wqx*dxx3 + 2.0d0*rpx3
                  dxxpy2 =  qcy*dxx2 + wqy*dxx3
                  dxxpz2 =  qcz*dxx2 + wqz*dxx3
                  dyypx2 =  qcx*dyy2 + wqx*dyy3
                  dyypy2 =  qcy*dyy2 + wqy*dyy3 + 2.0d0*rpy3
                  dyypz2 =  qcz*dyy2 + wqz*dyy3
                  dzzpx2 =  qcx*dzz2 + wqx*dzz3
                  dzzpy2 =  qcy*dzz2 + wqy*dzz3
                  dzzpz2 =  qcz*dzz2 + wqz*dzz3 + 2.0d0*rpz3
                  dyxpx2 =  qcx*dyx2 + wqx*dyx3 +       rpy3
                  dyxpy2 =  qcy*dyx2 + wqy*dyx3 +       rpx3
                  dyxpz2 =  qcz*dyx2 + wqz*dyx3
                  dzxpx2 =  qcx*dzx2 + wqx*dzx3 +       rpz3
                  dzxpy2 =  qcy*dzx2 + wqy*dzx3
                  dzxpz2 =  qcz*dzx2 + wqz*dzx3 +       rpx3
                  dzypx2 =  qcx*dzy2 + wqx*dzy3
                  dzypy2 =  qcy*dzy2 + wqy*dzy3 +       rpz3
                  dzypz2 =  qcz*dzy2 + wqz*dzy3 +       rpy3

!spss01(12-34)
         xp12 = zet*(xp1 - rooz*xp2)
         yp12 = zet*(yp1 - rooz*yp2)
         zp12 = zet*(zp1 - rooz*zp2)
         xp23 = zet*(xp2 - rooz*xp3)
         yp23 = zet*(yp2 - rooz*yp3)
         zp23 = zet*(zp2 - rooz*zp3)
         xp34 = zet*(xp3 - rooz*xp4)
         yp34 = zet*(yp3 - rooz*yp4)
         zp34 = zet*(zp3 - rooz*zp4)

!pdss(1-3)
         pdxxx1 = pbx*ppxx1 + wpx*ppxx2 +px12 +xp12
         pdxyy1 = pby*ppxy1 + wpy*ppxy2 +px12 
         pdxzz1 = pbz*ppxz1 + wpz*ppxz2 +px12 
         pdxyx1 = pby*ppxx1 + wpy*ppxx2 
         pdxzx1 = pbz*ppxx1 + wpz*ppxx2 
         pdxzy1 = pby*ppxz1 + wpy*ppxz2
         pdyxx1 = pbx*ppyx1 + wpx*ppyx2 +py12
         pdyyy1 = pby*ppyy1 + wpy*ppyy2 +py12 +yp12 
         pdyzz1 = pbz*ppyz1 + wpz*ppyz2 +py12 
         pdyyx1 = pbx*ppyy1 + wpx*ppyy2 
         pdyzx1 = pbx*ppyz1 + wpx*ppyz2 
         pdyzy1 = pbz*ppyy1 + wpz*ppyy2 
         pdzxx1 = pbx*ppzx1 + wpx*ppzx2 +pz12
         pdzyy1 = pby*ppzy1 + wpy*ppzy2 +pz12
         pdzzz1 = pbz*ppzz1 + wpz*ppzz2 +pz12 +zp12
         pdzyx1 = pbx*ppzy1 + wpx*ppzy2
         pdzzx1 = pbx*ppzz1 + wpx*ppzz2
         pdzzy1 = pby*ppzz1 + wpy*ppzz2

         pdxxx2 = pbx*ppxx2 + wpx*ppxx3 +px23 +xp23
         pdxyy2 = pby*ppxy2 + wpy*ppxy3 +px23
         pdxzz2 = pbz*ppxz2 + wpz*ppxz3 +px23
         pdxyx2 = pby*ppxx2 + wpy*ppxx3
         pdxzx2 = pbz*ppxx2 + wpz*ppxx3
         pdxzy2 = pby*ppxz2 + wpy*ppxz3
         pdyxx2 = pbx*ppyx2 + wpx*ppyx3 +py23
         pdyyy2 = pby*ppyy2 + wpy*ppyy3 +py23 +yp23
         pdyzz2 = pbz*ppyz2 + wpz*ppyz3 +py23
         pdyyx2 = pbx*ppyy2 + wpx*ppyy3
         pdyzx2 = pbx*ppyz2 + wpx*ppyz3
         pdyzy2 = pbz*ppyy2 + wpz*ppyy3
         pdzxx2 = pbx*ppzx2 + wpx*ppzx3 +pz23
         pdzyy2 = pby*ppzy2 + wpy*ppzy3 +pz23
         pdzzz2 = pbz*ppzz2 + wpz*ppzz3 +pz23 +zp23
         pdzyx2 = pbx*ppzy2 + wpx*ppzy3
         pdzzx2 = pbx*ppzz2 + wpx*ppzz3
         pdzzy2 = pby*ppzz2 + wpy*ppzz3

         pdxxx3 = pbx*ppxx3 + wpx*ppxx4 +px34 +xp34
         pdxyy3 = pby*ppxy3 + wpy*ppxy4 +px34
         pdxzz3 = pbz*ppxz3 + wpz*ppxz4 +px34
         pdxyx3 = pby*ppxx3 + wpy*ppxx4
         pdxzx3 = pbz*ppxx3 + wpz*ppxx4
         pdxzy3 = pby*ppxz3 + wpy*ppxz4
         pdyxx3 = pbx*ppyx3 + wpx*ppyx4 +py34
         pdyyy3 = pby*ppyy3 + wpy*ppyy4 +py34 +yp34
         pdyzz3 = pbz*ppyz3 + wpz*ppyz4 +py34
         pdyyx3 = pbx*ppyy3 + wpx*ppyy4
         pdyzx3 = pbx*ppyz3 + wpx*ppyz4
         pdyzy3 = pbz*ppyy3 + wpz*ppyy4
         pdzxx3 = pbx*ppzx3 + wpx*ppzx4 +pz34
         pdzyy3 = pby*ppzy3 + wpy*ppzy4 +pz34
         pdzzz3 = pbz*ppzz3 + wpz*ppzz4 +pz34 +zp34
         pdzyx3 = pbx*ppzy3 + wpx*ppzy4
         pdzzx3 = pbx*ppzz3 + wpx*ppzz4
         pdzzy3 = pby*ppzz3 + wpy*ppzz4

!ppss01(01-34)
         ppxx01 = zet*(ppxx0 - rooz*ppxx1)
         ppxy01 = zet*(ppxy0 - rooz*ppxy1)
         ppxz01 = zet*(ppxz0 - rooz*ppxz1)
         ppyx01 = zet*(ppyx0 - rooz*ppyx1)
         ppyy01 = zet*(ppyy0 - rooz*ppyy1)
         ppyz01 = zet*(ppyz0 - rooz*ppyz1)
         ppzx01 = zet*(ppzx0 - rooz*ppzx1)
         ppzy01 = zet*(ppzy0 - rooz*ppzy1)
         ppzz01 = zet*(ppzz0 - rooz*ppzz1)
  
         ppxx12 = zet*(ppxx1 - rooz*ppxx2)
         ppxy12 = zet*(ppxy1 - rooz*ppxy2)
         ppxz12 = zet*(ppxz1 - rooz*ppxz2)
         ppyx12 = zet*(ppyx1 - rooz*ppyx2)
         ppyy12 = zet*(ppyy1 - rooz*ppyy2)
         ppyz12 = zet*(ppyz1 - rooz*ppyz2)
         ppzx12 = zet*(ppzx1 - rooz*ppzx2)
         ppzy12 = zet*(ppzy1 - rooz*ppzy2)
         ppzz12 = zet*(ppzz1 - rooz*ppzz2)
  
         ppxx23 = zet*(ppxx2 - rooz*ppxx3)
         ppxy23 = zet*(ppxy2 - rooz*ppxy3)
         ppxz23 = zet*(ppxz2 - rooz*ppxz3)
         ppyx23 = zet*(ppyx2 - rooz*ppyx3)
         ppyy23 = zet*(ppyy2 - rooz*ppyy3)
         ppyz23 = zet*(ppyz2 - rooz*ppyz3)
         ppzx23 = zet*(ppzx2 - rooz*ppzx3)
         ppzy23 = zet*(ppzy2 - rooz*ppzy3)
         ppzz23 = zet*(ppzz2 - rooz*ppzz3)
  
         ppxx34 = zet*(ppxx3 - rooz*ppxx4)
         ppxy34 = zet*(ppxy3 - rooz*ppxy4)
         ppxz34 = zet*(ppxz3 - rooz*ppxz4)
         ppyx34 = zet*(ppyx3 - rooz*ppyx4)
         ppyy34 = zet*(ppyy3 - rooz*ppyy4)
         ppyz34 = zet*(ppyz3 - rooz*ppyz4)
         ppzx34 = zet*(ppzx3 - rooz*ppzx4)
         ppzy34 = zet*(ppzy3 - rooz*ppzy4)
         ppzz34 = zet*(ppzz3 - rooz*ppzz4)

!dsss01(01-34)
       dxx01 = zet*(dxx0 -rooz*dxx1)
       dyy01 = zet*(dyy0 -rooz*dyy1)
       dzz01 = zet*(dzz0 -rooz*dzz1)
       dyx01 = zet*(dyx0 -rooz*dyx1)
       dzx01 = zet*(dzx0 -rooz*dzx1)
       dzy01 = zet*(dzy0 -rooz*dzy1)

       dxx12 = zet*(dxx1 -rooz*dxx2)
       dyy12 = zet*(dyy1 -rooz*dyy2)
       dzz12 = zet*(dzz1 -rooz*dzz2)
       dyx12 = zet*(dyx1 -rooz*dyx2)
       dzx12 = zet*(dzx1 -rooz*dzx2)
       dzy12 = zet*(dzy1 -rooz*dzy2)

       dxx23 = zet*(dxx2 -rooz*dxx3)
       dyy23 = zet*(dyy2 -rooz*dyy3)
       dzz23 = zet*(dzz2 -rooz*dzz3)
       dyx23 = zet*(dyx2 -rooz*dyx3)
       dzx23 = zet*(dzx2 -rooz*dzx3)
       dzy23 = zet*(dzy2 -rooz*dzy3)

       dxx34 = zet*(dxx3 -rooz*dxx4)
       dyy34 = zet*(dyy3 -rooz*dyy4)
       dzz34 = zet*(dzz3 -rooz*dzz4)
       dyx34 = zet*(dyx3 -rooz*dyx4)
       dzx34 = zet*(dzx3 -rooz*dzx4)
       dzy34 = zet*(dzy3 -rooz*dzy4)

!ddss(0-3)
       ddxxxx0 = pbx*dpxxx0 + wpx*dpxxx1 + 2.0d0*ppxx01 + dxx01
       ddxxyy0 = pby*dpxxy0 + wpy*dpxxy1                + dxx01
       ddxxzz0 = pbz*dpxxz0 + wpz*dpxxz1                + dxx01
       ddxxyx0 = pby*dpxxx0 + wpy*dpxxx1
       ddxxzx0 = pbz*dpxxx0 + wpz*dpxxx1
       ddxxzy0 = pby*dpxxz0 + wpy*dpxxz1
       ddyyxx0 = pbx*dpyyx0 + wpx*dpyyx1                + dyy01
       ddyyyy0 = pby*dpyyy0 + wpy*dpyyy1 + 2.0d0*ppyy01 + dyy01
       ddyyzz0 = pbz*dpyyz0 + wpz*dpyyz1                + dyy01
       ddyyyx0 = pbx*dpyyy0 + wpx*dpyyy1
       ddyyzx0 = pbx*dpyyz0 + wpx*dpyyz1
       ddyyzy0 = pbz*dpyyy0 + wpz*dpyyy1
       ddzzxx0 = pbx*dpzzx0 + wpx*dpzzx1                + dzz01
       ddzzyy0 = pby*dpzzy0 + wpy*dpzzy1                + dzz01
       ddzzzz0 = pbz*dpzzz0 + wpz*dpzzz1 + 2.0d0*ppzz01 + dzz01
       ddzzyx0 = pbx*dpzzy0 + wpx*dpzzy1
       ddzzzx0 = pbx*dpzzz0 + wpx*dpzzz1
       ddzzzy0 = pby*dpzzz0 + wpy*dpzzz1
       ddyxxx0 = pbx*dpyxx0 + wpx*dpyxx1 +       ppyx01 + dyx01
       ddyxyy0 = pby*dpyxy0 + wpy*dpyxy1 +       ppxy01 + dyx01
       ddyxzz0 = pbz*dpyxz0 + wpz*dpyxz1                + dyx01
       ddyxyx0 = pbx*dpyxy0 + wpx*dpyxy1 +       ppyy01
       ddyxzx0 = pbz*dpyxx0 + wpz*dpyxx1
       ddyxzy0 = pbz*dpyxy0 + wpz*dpyxy1
       ddzxxx0 = pbx*dpzxx0 + wpx*dpzxx1 +       ppzx01 + dzx01
       ddzxyy0 = pby*dpzxy0 + wpy*dpzxy1                + dzx01
       ddzxzz0 = pbz*dpzxz0 + wpz*dpzxz1 +       ppxz01 + dzx01
       ddzxyx0 = pby*dpzxx0 + wpy*dpzxx1
       ddzxzx0 = pbx*dpzxz0 + wpx*dpzxz1 +       ppzz01
       ddzxzy0 = pby*dpzxz0 + wpy*dpzxz1
       ddzyxx0 = pbx*dpzyx0 + wpx*dpzyx1                + dzy01
       ddzyyy0 = pby*dpzyy0 + wpy*dpzyy1 +       ppzy01 + dzy01
       ddzyzz0 = pbz*dpzyz0 + wpz*dpzyz1 +       ppyz01 + dzy01
       ddzyyx0 = pbx*dpzyy0 + wpx*dpzyy1
       ddzyzx0 = pbx*dpzyz0 + wpx*dpzyz1
       ddzyzy0 = pby*dpzyz0 + wpy*dpzyz1 +       ppzz01

       ddxxxx1 = pbx*dpxxx1 + wpx*dpxxx2 + 2.0d0*ppxx12 + dxx12
       ddxxyy1 = pby*dpxxy1 + wpy*dpxxy2                + dxx12
       ddxxzz1 = pbz*dpxxz1 + wpz*dpxxz2                + dxx12
       ddxxyx1 = pby*dpxxx1 + wpy*dpxxx2
       ddxxzx1 = pbz*dpxxx1 + wpz*dpxxx2
       ddxxzy1 = pby*dpxxz1 + wpy*dpxxz2
       ddyyxx1 = pbx*dpyyx1 + wpx*dpyyx2                + dyy12
       ddyyyy1 = pby*dpyyy1 + wpy*dpyyy2 + 2.0d0*ppyy12 + dyy12
       ddyyzz1 = pbz*dpyyz1 + wpz*dpyyz2                + dyy12
       ddyyyx1 = pbx*dpyyy1 + wpx*dpyyy2
       ddyyzx1 = pbx*dpyyz1 + wpx*dpyyz2
       ddyyzy1 = pbz*dpyyy1 + wpz*dpyyy2
       ddzzxx1 = pbx*dpzzx1 + wpx*dpzzx2                + dzz12
       ddzzyy1 = pby*dpzzy1 + wpy*dpzzy2                + dzz12
       ddzzzz1 = pbz*dpzzz1 + wpz*dpzzz2 + 2.0d0*ppzz12 + dzz12
       ddzzyx1 = pbx*dpzzy1 + wpx*dpzzy2
       ddzzzx1 = pbx*dpzzz1 + wpx*dpzzz2
       ddzzzy1 = pby*dpzzz1 + wpy*dpzzz2
       ddyxxx1 = pbx*dpyxx1 + wpx*dpyxx2 +       ppyx12 + dyx12
       ddyxyy1 = pby*dpyxy1 + wpy*dpyxy2 +       ppxy12 + dyx12
       ddyxzz1 = pbz*dpyxz1 + wpz*dpyxz2                + dyx12
       ddyxyx1 = pbx*dpyxy1 + wpx*dpyxy2 +       ppyy12
       ddyxzx1 = pbz*dpyxx1 + wpz*dpyxx2
       ddyxzy1 = pbz*dpyxy1 + wpz*dpyxy2
       ddzxxx1 = pbx*dpzxx1 + wpx*dpzxx2 +       ppzx12 + dzx12
       ddzxyy1 = pby*dpzxy1 + wpy*dpzxy2                + dzx12
       ddzxzz1 = pbz*dpzxz1 + wpz*dpzxz2 +       ppxz12 + dzx12
       ddzxyx1 = pby*dpzxx1 + wpy*dpzxx2
       ddzxzx1 = pbx*dpzxz1 + wpx*dpzxz2 +       ppzz12
       ddzxzy1 = pby*dpzxz1 + wpy*dpzxz2
       ddzyxx1 = pbx*dpzyx1 + wpx*dpzyx2                + dzy12
       ddzyyy1 = pby*dpzyy1 + wpy*dpzyy2 +       ppzy12 + dzy12
       ddzyzz1 = pbz*dpzyz1 + wpz*dpzyz2 +       ppyz12 + dzy12
       ddzyyx1 = pbx*dpzyy1 + wpx*dpzyy2
       ddzyzx1 = pbx*dpzyz1 + wpx*dpzyz2
       ddzyzy1 = pby*dpzyz1 + wpy*dpzyz2 +       ppzz12

       ddxxxx2 = pbx*dpxxx2 + wpx*dpxxx3 + 2.0d0*ppxx23 + dxx23
       ddxxyy2 = pby*dpxxy2 + wpy*dpxxy3                + dxx23
       ddxxzz2 = pbz*dpxxz2 + wpz*dpxxz3                + dxx23
       ddxxyx2 = pby*dpxxx2 + wpy*dpxxx3
       ddxxzx2 = pbz*dpxxx2 + wpz*dpxxx3
       ddxxzy2 = pby*dpxxz2 + wpy*dpxxz3
       ddyyxx2 = pbx*dpyyx2 + wpx*dpyyx3                + dyy23
       ddyyyy2 = pby*dpyyy2 + wpy*dpyyy3 + 2.0d0*ppyy23 + dyy23
       ddyyzz2 = pbz*dpyyz2 + wpz*dpyyz3                + dyy23
       ddyyyx2 = pbx*dpyyy2 + wpx*dpyyy3
       ddyyzx2 = pbx*dpyyz2 + wpx*dpyyz3
       ddyyzy2 = pbz*dpyyy2 + wpz*dpyyy3
       ddzzxx2 = pbx*dpzzx2 + wpx*dpzzx3                + dzz23
       ddzzyy2 = pby*dpzzy2 + wpy*dpzzy3                + dzz23
       ddzzzz2 = pbz*dpzzz2 + wpz*dpzzz3 + 2.0d0*ppzz23 + dzz23
       ddzzyx2 = pbx*dpzzy2 + wpx*dpzzy3
       ddzzzx2 = pbx*dpzzz2 + wpx*dpzzz3
       ddzzzy2 = pby*dpzzz2 + wpy*dpzzz3
       ddyxxx2 = pbx*dpyxx2 + wpx*dpyxx3 +       ppyx23 + dyx23
       ddyxyy2 = pby*dpyxy2 + wpy*dpyxy3 +       ppxy23 + dyx23
       ddyxzz2 = pbz*dpyxz2 + wpz*dpyxz3                + dyx23
       ddyxyx2 = pbx*dpyxy2 + wpx*dpyxy3 +       ppyy23
       ddyxzx2 = pbz*dpyxx2 + wpz*dpyxx3
       ddyxzy2 = pbz*dpyxy2 + wpz*dpyxy3
       ddzxxx2 = pbx*dpzxx2 + wpx*dpzxx3 +       ppzx23 + dzx23
       ddzxyy2 = pby*dpzxy2 + wpy*dpzxy3                + dzx23
       ddzxzz2 = pbz*dpzxz2 + wpz*dpzxz3 +       ppxz23 + dzx23
       ddzxyx2 = pby*dpzxx2 + wpy*dpzxx3
       ddzxzx2 = pbx*dpzxz2 + wpx*dpzxz3 +       ppzz23
       ddzxzy2 = pby*dpzxz2 + wpy*dpzxz3
       ddzyxx2 = pbx*dpzyx2 + wpx*dpzyx3                + dzy23
       ddzyyy2 = pby*dpzyy2 + wpy*dpzyy3 +       ppzy23 + dzy23
       ddzyzz2 = pbz*dpzyz2 + wpz*dpzyz3 +       ppyz23 + dzy23
       ddzyyx2 = pbx*dpzyy2 + wpx*dpzyy3
       ddzyzx2 = pbx*dpzyz2 + wpx*dpzyz3
       ddzyzy2 = pby*dpzyz2 + wpy*dpzyz3 +       ppzz23

       ddxxxx3 = pbx*dpxxx3 + wpx*dpxxx4 + 2.0d0*ppxx34 + dxx34
       ddxxyy3 = pby*dpxxy3 + wpy*dpxxy4                + dxx34
       ddxxzz3 = pbz*dpxxz3 + wpz*dpxxz4                + dxx34
       ddxxyx3 = pby*dpxxx3 + wpy*dpxxx4
       ddxxzx3 = pbz*dpxxx3 + wpz*dpxxx4
       ddxxzy3 = pby*dpxxz3 + wpy*dpxxz4
       ddyyxx3 = pbx*dpyyx3 + wpx*dpyyx4                + dyy34
       ddyyyy3 = pby*dpyyy3 + wpy*dpyyy4 + 2.0d0*ppyy34 + dyy34
       ddyyzz3 = pbz*dpyyz3 + wpz*dpyyz4                + dyy34
       ddyyyx3 = pbx*dpyyy3 + wpx*dpyyy4
       ddyyzx3 = pbx*dpyyz3 + wpx*dpyyz4
       ddyyzy3 = pbz*dpyyy3 + wpz*dpyyy4
       ddzzxx3 = pbx*dpzzx3 + wpx*dpzzx4                + dzz34
       ddzzyy3 = pby*dpzzy3 + wpy*dpzzy4                + dzz34
       ddzzzz3 = pbz*dpzzz3 + wpz*dpzzz4 + 2.0d0*ppzz34 + dzz34
       ddzzyx3 = pbx*dpzzy3 + wpx*dpzzy4
       ddzzzx3 = pbx*dpzzz3 + wpx*dpzzz4
       ddzzzy3 = pby*dpzzz3 + wpy*dpzzz4
       ddyxxx3 = pbx*dpyxx3 + wpx*dpyxx4 +       ppyx34 + dyx34
       ddyxyy3 = pby*dpyxy3 + wpy*dpyxy4 +       ppxy34 + dyx34
       ddyxzz3 = pbz*dpyxz3 + wpz*dpyxz4                + dyx34
       ddyxyx3 = pbx*dpyxy3 + wpx*dpyxy4 +       ppyy34
       ddyxzx3 = pbz*dpyxx3 + wpz*dpyxx4
       ddyxzy3 = pbz*dpyxy3 + wpz*dpyxy4
       ddzxxx3 = pbx*dpzxx3 + wpx*dpzxx4 +       ppzx34 + dzx34
       ddzxyy3 = pby*dpzxy3 + wpy*dpzxy4                + dzx34
       ddzxzz3 = pbz*dpzxz3 + wpz*dpzxz4 +       ppxz34 + dzx34
       ddzxyx3 = pby*dpzxx3 + wpy*dpzxx4
       ddzxzx3 = pbx*dpzxz3 + wpx*dpzxz4 +       ppzz34
       ddzxzy3 = pby*dpzxz3 + wpy*dpzxz4
       ddzyxx3 = pbx*dpzyx3 + wpx*dpzyx4                + dzy34
       ddzyyy3 = pby*dpzyy3 + wpy*dpzyy4 +       ppzy34 + dzy34
       ddzyzz3 = pbz*dpzyz3 + wpz*dpzyz4 +       ppyz34 + dzy34
       ddzyyx3 = pbx*dpzyy3 + wpx*dpzyy4
       ddzyzx3 = pbx*dpzyz3 + wpx*dpzyz4
       ddzyzy3 = pby*dpzyz3 + wpy*dpzyz4 +       ppzz34

!rppss (2-3)
      rppxx2 = rkp*ppxx2
      rppxy2 = rkp*ppxy2
      rppxz2 = rkp*ppxz2
      rppyx2 = rkp*ppyx2
      rppyy2 = rkp*ppyy2
      rppyz2 = rkp*ppyz2
      rppzx2 = rkp*ppzx2
      rppzy2 = rkp*ppzy2
      rppzz2 = rkp*ppzz2
      rppxx3 = rkp*ppxx3
      rppxy3 = rkp*ppxy3
      rppxz3 = rkp*ppxz3
      rppyx3 = rkp*ppyx3
      rppyy3 = rkp*ppyy3
      rppyz3 = rkp*ppyz3
      rppzx3 = rkp*ppzx3
      rppzy3 = rkp*ppzy3
      rppzz3 = rkp*ppzz3
!rdsss (2-3)
      rdxx2 = rkp*dxx2
      rdyy2 = rkp*dyy2
      rdzz2 = rkp*dzz2
      rdyx2 = rkp*dyx2
      rdzx2 = rkp*dzx2
      rdzy2 = rkp*dzy2
      rdxx3 = rkp*dxx3
      rdyy3 = rkp*dyy3
      rdzz3 = rkp*dzz3
      rdyx3 = rkp*dyx3
      rdzx3 = rkp*dzx3
      rdzy3 = rkp*dzy3

!dpps(1-2)
      axx1= qcx*dpxxx1 + wqx*dpxxx2 + 2.0d0*rppxx2 + rdxx2
      axy1= qcy*dpxxx1 + wqy*dpxxx2 
      axz1= qcz*dpxxx1 + wqz*dpxxx2 
      ayx1= qcx*dpxxy1 + wqx*dpxxy2 + 2.0d0*rppxy2        
      ayy1= qcy*dpxxy1 + wqy*dpxxy2                + rdxx2
      ayz1= qcz*dpxxy1 + wqz*dpxxy2                       
      azx1= qcx*dpxxz1 + wqx*dpxxz2 + 2.0d0*rppxz2        
      azy1= qcy*dpxxz1 + wqy*dpxxz2                       
      azz1= qcz*dpxxz1 + wqz*dpxxz2                + rdxx2
      bxx1= qcx*dpyyx1 + wqx*dpyyx2                + rdyy2
      bxy1= qcy*dpyyx1 + wqy*dpyyx2 + 2.0d0*rppyx2        
      bxz1= qcz*dpyyx1 + wqz*dpyyx2                       
      byx1= qcx*dpyyy1 + wqx*dpyyy2                       
      byy1= qcy*dpyyy1 + wqy*dpyyy2 + 2.0d0*rppyy2 + rdyy2
      byz1= qcz*dpyyy1 + wqz*dpyyy2                       
      bzx1= qcx*dpyyz1 + wqx*dpyyz2                       
      bzy1= qcy*dpyyz1 + wqy*dpyyz2 + 2.0d0*rppyz2        
      bzz1= qcz*dpyyz1 + wqz*dpyyz2                + rdyy2
      cxx1= qcx*dpzzx1 + wqx*dpzzx2                + rdzz2
      cxy1= qcy*dpzzx1 + wqy*dpzzx2                       
      cxz1= qcz*dpzzx1 + wqz*dpzzx2 + 2.0d0*rppzx2        
      cyx1= qcx*dpzzy1 + wqx*dpzzy2                       
      cyy1= qcy*dpzzy1 + wqy*dpzzy2                + rdzz2
      cyz1= qcz*dpzzy1 + wqz*dpzzy2 + 2.0d0*rppzy2        
      czx1= qcx*dpzzz1 + wqx*dpzzz2                       
      czy1= qcy*dpzzz1 + wqy*dpzzz2                       
      czz1= qcz*dpzzz1 + wqz*dpzzz2 + 2.0d0*rppzz2 + rdzz2
      dxx1= qcx*dpyxx1 + wqx*dpyxx2 +       rppyx2 + rdyx2
      dxy1= qcy*dpyxx1 + wqy*dpyxx2 +       rppxx2        
      dxz1= qcz*dpyxx1 + wqz*dpyxx2                       
      dyx1= qcx*dpyxy1 + wqx*dpyxy2 +       rppyy2        
      dyy1= qcy*dpyxy1 + wqy*dpyxy2 +       rppxy2 + rdyx2
      dyz1= qcz*dpyxy1 + wqz*dpyxy2            !    + rdyx2
      dzx1= qcx*dpyxz1 + wqx*dpyxz2 +       rppyz2        
      dzy1= qcy*dpyxz1 + wqy*dpyxz2 +       rppxz2        
      dzz1= qcz*dpyxz1 + wqz*dpyxz2                + rdyx2
      exx1= qcx*dpzxx1 + wqx*dpzxx2 +       rppzx2 + rdzx2
      exy1= qcy*dpzxx1 + wqy*dpzxx2                       
      exz1= qcz*dpzxx1 + wqz*dpzxx2 +       rppxx2        
      eyx1= qcx*dpzxy1 + wqx*dpzxy2 +       rppzy2        
      eyy1= qcy*dpzxy1 + wqy*dpzxy2                + rdzx2
      eyz1= qcz*dpzxy1 + wqz*dpzxy2 +       rppxy2        
      ezx1= qcx*dpzxz1 + wqx*dpzxz2 +       rppzz2        
      ezy1= qcy*dpzxz1 + wqy*dpzxz2                       
      ezz1= qcz*dpzxz1 + wqz*dpzxz2 +       rppxz2 + rdzx2
      fxx1= qcx*dpzyx1 + wqx*dpzyx2                + rdzy2
      fxy1= qcy*dpzyx1 + wqy*dpzyx2 +       rppzx2        
      fxz1= qcz*dpzyx1 + wqz*dpzyx2 +       rppyx2        
      fyx1= qcx*dpzyy1 + wqx*dpzyy2                       
      fyy1= qcy*dpzyy1 + wqy*dpzyy2 +       rppzy2 + rdzy2
      fyz1= qcz*dpzyy1 + wqz*dpzyy2 +       rppyy2        
      fzx1= qcx*dpzyz1 + wqx*dpzyz2                       
      fzy1= qcy*dpzyz1 + wqy*dpzyz2 +       rppzz2        
      fzz1= qcz*dpzyz1 + wqz*dpzyz2 +       rppyz2 + rdzy2

      axx2= qcx*dpxxx2 + wqx*dpxxx3 + 2.0d0*rppxx3 + rdxx3
      axy2= qcy*dpxxx2 + wqy*dpxxx3 
      axz2= qcz*dpxxx2 + wqz*dpxxx3 
      ayx2= qcx*dpxxy2 + wqx*dpxxy3 + 2.0d0*rppxy3        
      ayy2= qcy*dpxxy2 + wqy*dpxxy3                + rdxx3
      ayz2= qcz*dpxxy2 + wqz*dpxxy3                       
      azx2= qcx*dpxxz2 + wqx*dpxxz3 + 2.0d0*rppxz3        
      azy2= qcy*dpxxz2 + wqy*dpxxz3                       
      azz2= qcz*dpxxz2 + wqz*dpxxz3                + rdxx3
      bxx2= qcx*dpyyx2 + wqx*dpyyx3                + rdyy3
      bxy2= qcy*dpyyx2 + wqy*dpyyx3 + 2.0d0*rppyx3        
      bxz2= qcz*dpyyx2 + wqz*dpyyx3                       
      byx2= qcx*dpyyy2 + wqx*dpyyy3                       
      byy2= qcy*dpyyy2 + wqy*dpyyy3 + 2.0d0*rppyy3 + rdyy3
      byz2= qcz*dpyyy2 + wqz*dpyyy3                       
      bzx2= qcx*dpyyz2 + wqx*dpyyz3                       
      bzy2= qcy*dpyyz2 + wqy*dpyyz3 + 2.0d0*rppyz3        
      bzz2= qcz*dpyyz2 + wqz*dpyyz3                + rdyy3
      cxx2= qcx*dpzzx2 + wqx*dpzzx3                + rdzz3
      cxy2= qcy*dpzzx2 + wqy*dpzzx3                       
      cxz2= qcz*dpzzx2 + wqz*dpzzx3 + 2.0d0*rppzx3        
      cyx2= qcx*dpzzy2 + wqx*dpzzy3                       
      cyy2= qcy*dpzzy2 + wqy*dpzzy3                + rdzz3
      cyz2= qcz*dpzzy2 + wqz*dpzzy3 + 2.0d0*rppzy3        
      czx2= qcx*dpzzz2 + wqx*dpzzz3                       
      czy2= qcy*dpzzz2 + wqy*dpzzz3                       
      czz2= qcz*dpzzz2 + wqz*dpzzz3 + 2.0d0*rppzz3 + rdzz3
      dxx2= qcx*dpyxx2 + wqx*dpyxx3 +       rppyx3 + rdyx3
      dxy2= qcy*dpyxx2 + wqy*dpyxx3 +       rppxx3        
      dxz2= qcz*dpyxx2 + wqz*dpyxx3                       
      dyx2= qcx*dpyxy2 + wqx*dpyxy3 +       rppyy3        
      dyy2= qcy*dpyxy2 + wqy*dpyxy3 +       rppxy3 + rdyx3
      dyz2= qcz*dpyxy2 + wqz*dpyxy3            !    + rdyx2
      dzx2= qcx*dpyxz2 + wqx*dpyxz3 +       rppyz3        
      dzy2= qcy*dpyxz2 + wqy*dpyxz3 +       rppxz3        
      dzz2= qcz*dpyxz2 + wqz*dpyxz3                + rdyx3
      exx2= qcx*dpzxx2 + wqx*dpzxx3 +       rppzx3 + rdzx3
      exy2= qcy*dpzxx2 + wqy*dpzxx3                       
      exz2= qcz*dpzxx2 + wqz*dpzxx3 +       rppxx3        
      eyx2= qcx*dpzxy2 + wqx*dpzxy3 +       rppzy3        
      eyy2= qcy*dpzxy2 + wqy*dpzxy3                + rdzx3
      eyz2= qcz*dpzxy2 + wqz*dpzxy3 +       rppxy3        
      ezx2= qcx*dpzxz2 + wqx*dpzxz3 +       rppzz3        
      ezy2= qcy*dpzxz2 + wqy*dpzxz3                       
      ezz2= qcz*dpzxz2 + wqz*dpzxz3 +       rppxz3 + rdzx3
      fxx2= qcx*dpzyx2 + wqx*dpzyx3                + rdzy3
      fxy2= qcy*dpzyx2 + wqy*dpzyx3 +       rppzx3        
      fxz2= qcz*dpzyx2 + wqz*dpzyx3 +       rppyx3        
      fyx2= qcx*dpzyy2 + wqx*dpzyy3                       
      fyy2= qcy*dpzyy2 + wqy*dpzyy3 +       rppzy3 + rdzy3
      fyz2= qcz*dpzyy2 + wqz*dpzyy3 +       rppyy3        
      fzx2= qcx*dpzyz2 + wqx*dpzyz3                       
      fzy2= qcy*dpzyz2 + wqy*dpzyz3 +       rppzz3        
      fzz2= qcz*dpzyz2 + wqz*dpzyz3 +       rppyz3 + rdzy3

!rsdss(2-3)
      rsdxx2 = rkp * sdxx2
      rsdyy2 = rkp * sdyy2
      rsdzz2 = rkp * sdzz2
      rsdyx2 = rkp * sdyx2
      rsdzx2 = rkp * sdzx2
      rsdzy2 = rkp * sdzy2
      rsdxx3 = rkp * sdxx3
      rsdyy3 = rkp * sdyy3
      rsdzz3 = rkp * sdzz3
      rsdyx3 = rkp * sdyx3
      rsdzx3 = rkp * sdzx3
      rsdzy3 = rkp * sdzy3

!pdps (1-2)
      pxdxxpx1 = qcx*pdxxx1+wqx*pdxxx2+rsdxx2+2.0d0*rppxx2
      pxdxxpy1 = qcy*pdxxx1+wqy*pdxxx2                   
      pxdxxpz1 = qcz*pdxxx1+wqz*pdxxx2                   
      pxdyypx1 = qcx*pdxyy1+wqx*pdxyy2+rsdyy2
      pxdyypy1 = qcy*pdxyy1+wqy*pdxyy2       +2.0d0*rppxy2
      pxdyypz1 = qcz*pdxyy1+wqz*pdxyy2                   
      pxdzzpx1 = qcx*pdxzz1+wqx*pdxzz2+rsdzz2
      pxdzzpy1 = qcy*pdxzz1+wqy*pdxzz2                   
      pxdzzpz1 = qcz*pdxzz1+wqz*pdxzz2       +2.0d0*rppxz2
      pxdyxpx1 = qcx*pdxyx1+wqx*pdxyx2+rsdyx2+      rppxy2
      pxdyxpy1 = qcy*pdxyx1+wqy*pdxyx2       +      rppxx2
      pxdyxpz1 = qcz*pdxyx1+wqz*pdxyx2                   
      pxdzxpx1 = qcx*pdxzx1+wqx*pdxzx2+rsdzx2+      rppxz2
      pxdzxpy1 = qcy*pdxzx1+wqy*pdxzx2                   
      pxdzxpz1 = qcz*pdxzx1+wqz*pdxzx2       +      rppxx2
      pxdzypx1 = qcx*pdxzy1+wqx*pdxzy2+rsdzy2             
      pxdzypy1 = qcy*pdxzy1+wqy*pdxzy2       +      rppxz2
      pxdzypz1 = qcz*pdxzy1+wqz*pdxzy2       +      rppxy2
      pydxxpx1 = qcx*pdyxx1+wqx*pdyxx2       +2.0d0*rppyx2
      pydxxpy1 = qcy*pdyxx1+wqy*pdyxx2+rsdxx2             
      pydxxpz1 = qcz*pdyxx1+wqz*pdyxx2                   
      pydyypx1 = qcx*pdyyy1+wqx*pdyyy2                   
      pydyypy1 = qcy*pdyyy1+wqy*pdyyy2+rsdyy2+2.0d0*rppyy2
      pydyypz1 = qcz*pdyyy1+wqz*pdyyy2                   
      pydzzpx1 = qcx*pdyzz1+wqx*pdyzz2                   
      pydzzpy1 = qcy*pdyzz1+wqy*pdyzz2+rsdzz2             
      pydzzpz1 = qcz*pdyzz1+wqz*pdyzz2       +2.0d0*rppyz2
      pydyxpx1 = qcx*pdyyx1+wqx*pdyyx2       +      rppyy2
      pydyxpy1 = qcy*pdyyx1+wqy*pdyyx2+rsdyx2+      rppyx2
      pydyxpz1 = qcz*pdyyx1+wqz*pdyyx2                   
      pydzxpx1 = qcx*pdyzx1+wqx*pdyzx2       +      rppyz2
      pydzxpy1 = qcy*pdyzx1+wqy*pdyzx2+rsdzx2             
      pydzxpz1 = qcz*pdyzx1+wqz*pdyzx2       +      rppyx2
      pydzypx1 = qcx*pdyzy1+wqx*pdyzy2                   
      pydzypy1 = qcy*pdyzy1+wqy*pdyzy2+rsdzy2+      rppyz2
      pydzypz1 = qcz*pdyzy1+wqz*pdyzy2       +      rppyy2
      pzdxxpx1 = qcx*pdzxx1+wqx*pdzxx2       +2.0d0*rppzx2 
      pzdxxpy1 = qcy*pdzxx1+wqy*pdzxx2                    
      pzdxxpz1 = qcz*pdzxx1+wqz*pdzxx2+rsdxx2              
      pzdyypx1 = qcx*pdzyy1+wqx*pdzyy2                    
      pzdyypy1 = qcy*pdzyy1+wqy*pdzyy2       +2.0d0*rppzy2 
      pzdyypz1 = qcz*pdzyy1+wqz*pdzyy2+rsdyy2
      pzdzzpx1 = qcx*pdzzz1+wqx*pdzzz2                    
      pzdzzpy1 = qcy*pdzzz1+wqy*pdzzz2                    
      pzdzzpz1 = qcz*pdzzz1+wqz*pdzzz2+rsdzz2+2.0d0*rppzz2 
      pzdyxpx1 = qcx*pdzyx1+wqx*pdzyx2       +      rppzy2 
      pzdyxpy1 = qcy*pdzyx1+wqy*pdzyx2       +      rppzx2 
      pzdyxpz1 = qcz*pdzyx1+wqz*pdzyx2+rsdyx2              
      pzdzxpx1 = qcx*pdzzx1+wqx*pdzzx2       +      rppzz2 
      pzdzxpy1 = qcy*pdzzx1+wqy*pdzzx2                    
      pzdzxpz1 = qcz*pdzzx1+wqz*pdzzx2+rsdzx2+      rppzx2 
      pzdzypx1 = qcx*pdzzy1+wqx*pdzzy2                    
      pzdzypy1 = qcy*pdzzy1+wqy*pdzzy2       +      rppzz2 
      pzdzypz1 = qcz*pdzzy1+wqz*pdzzy2+rsdzy2+      rppzy2 

      pxdxxpx2 = qcx*pdxxx2+wqx*pdxxx3+rsdxx3+2.0d0*rppxx3
      pxdxxpy2 = qcy*pdxxx2+wqy*pdxxx3                   
      pxdxxpz2 = qcz*pdxxx2+wqz*pdxxx3                   
      pxdyypx2 = qcx*pdxyy2+wqx*pdxyy3+rsdyy3             
      pxdyypy2 = qcy*pdxyy2+wqy*pdxyy3       +2.0d0*rppxy3
      pxdyypz2 = qcz*pdxyy2+wqz*pdxyy3                   
      pxdzzpx2 = qcx*pdxzz2+wqx*pdxzz3+rsdzz3
      pxdzzpy2 = qcy*pdxzz2+wqy*pdxzz3                   
      pxdzzpz2 = qcz*pdxzz2+wqz*pdxzz3       +2.0d0*rppxz3
      pxdyxpx2 = qcx*pdxyx2+wqx*pdxyx3+rsdyx3+      rppxy3
      pxdyxpy2 = qcy*pdxyx2+wqy*pdxyx3       +      rppxx3
      pxdyxpz2 = qcz*pdxyx2+wqz*pdxyx3                   
      pxdzxpx2 = qcx*pdxzx2+wqx*pdxzx3+rsdzx3+      rppxz3
      pxdzxpy2 = qcy*pdxzx2+wqy*pdxzx3                   
      pxdzxpz2 = qcz*pdxzx2+wqz*pdxzx3       +      rppxx3
      pxdzypx2 = qcx*pdxzy2+wqx*pdxzy3+rsdzy3             
      pxdzypy2 = qcy*pdxzy2+wqy*pdxzy3       +      rppxz3
      pxdzypz2 = qcz*pdxzy2+wqz*pdxzy3       +      rppxy3
      pydxxpx2 = qcx*pdyxx2+wqx*pdyxx3       +2.0d0*rppyx3
      pydxxpy2 = qcy*pdyxx2+wqy*pdyxx3+rsdxx3             
      pydxxpz2 = qcz*pdyxx2+wqz*pdyxx3                   
      pydyypx2 = qcx*pdyyy2+wqx*pdyyy3                   
      pydyypy2 = qcy*pdyyy2+wqy*pdyyy3+rsdyy3+2.0d0*rppyy3
      pydyypz2 = qcz*pdyyy2+wqz*pdyyy3                   
      pydzzpx2 = qcx*pdyzz2+wqx*pdyzz3                   
      pydzzpy2 = qcy*pdyzz2+wqy*pdyzz3+rsdzz3             
      pydzzpz2 = qcz*pdyzz2+wqz*pdyzz3       +2.0d0*rppyz3
      pydyxpx2 = qcx*pdyyx2+wqx*pdyyx3       +      rppyy3
      pydyxpy2 = qcy*pdyyx2+wqy*pdyyx3+rsdyx3+      rppyx3
      pydyxpz2 = qcz*pdyyx2+wqz*pdyyx3                   
      pydzxpx2 = qcx*pdyzx2+wqx*pdyzx3       +      rppyz3
      pydzxpy2 = qcy*pdyzx2+wqy*pdyzx3+rsdzx3             
      pydzxpz2 = qcz*pdyzx2+wqz*pdyzx3       +      rppyx3
      pydzypx2 = qcx*pdyzy2+wqx*pdyzy3                   
      pydzypy2 = qcy*pdyzy2+wqy*pdyzy3+rsdzy3+      rppyz3
      pydzypz2 = qcz*pdyzy2+wqz*pdyzy3       +      rppyy3
      pzdxxpx2 = qcx*pdzxx2+wqx*pdzxx3       +2.0d0*rppzx3 
      pzdxxpy2 = qcy*pdzxx2+wqy*pdzxx3                    
      pzdxxpz2 = qcz*pdzxx2+wqz*pdzxx3+rsdxx3              
      pzdyypx2 = qcx*pdzyy2+wqx*pdzyy3                    
      pzdyypy2 = qcy*pdzyy2+wqy*pdzyy3       +2.0d0*rppzy3 
      pzdyypz2 = qcz*pdzyy2+wqz*pdzyy3+rsdyy3
      pzdzzpx2 = qcx*pdzzz2+wqx*pdzzz3                    
      pzdzzpy2 = qcy*pdzzz2+wqy*pdzzz3                    
      pzdzzpz2 = qcz*pdzzz2+wqz*pdzzz3+rsdzz3+2.0d0*rppzz3 
      pzdyxpx2 = qcx*pdzyx2+wqx*pdzyx3       +      rppzy3 
      pzdyxpy2 = qcy*pdzyx2+wqy*pdzyx3       +      rppzx3 
      pzdyxpz2 = qcz*pdzyx2+wqz*pdzyx3+rsdyx3              
      pzdzxpx2 = qcx*pdzzx2+wqx*pdzzx3       +      rppzz3 
      pzdzxpy2 = qcy*pdzzx2+wqy*pdzzx3                    
      pzdzxpz2 = qcz*pdzzx2+wqz*pdzzx3+rsdzx3+      rppzx3 
      pzdzypx2 = qcx*pdzzy2+wqx*pdzzy3                    
      pzdzypy2 = qcy*pdzzy2+wqy*pdzzy3       +      rppzz3 
      pzdzypz2 = qcz*pdzzy2+wqz*pdzzy3+rsdzy3+      rppzy3 

!rdpss(1-3)
         rdpxxx1 = rkp * dpxxx1
         rdpxxy1 = rkp * dpxxy1
         rdpxxz1 = rkp * dpxxz1
         rdpyyx1 = rkp * dpyyx1
         rdpyyy1 = rkp * dpyyy1
         rdpyyz1 = rkp * dpyyz1
         rdpzzx1 = rkp * dpzzx1
         rdpzzy1 = rkp * dpzzy1
         rdpzzz1 = rkp * dpzzz1
         rdpyxx1 = rkp * dpyxx1
         rdpyxy1 = rkp * dpyxy1
         rdpyxz1 = rkp * dpyxz1
         rdpzxx1 = rkp * dpzxx1
         rdpzxy1 = rkp * dpzxy1
         rdpzxz1 = rkp * dpzxz1
         rdpzyx1 = rkp * dpzyx1
         rdpzyy1 = rkp * dpzyy1
         rdpzyz1 = rkp * dpzyz1
         rdpxxx2 = rkp * dpxxx2
         rdpxxy2 = rkp * dpxxy2
         rdpxxz2 = rkp * dpxxz2
         rdpyyx2 = rkp * dpyyx2
         rdpyyy2 = rkp * dpyyy2
         rdpyyz2 = rkp * dpyyz2
         rdpzzx2 = rkp * dpzzx2
         rdpzzy2 = rkp * dpzzy2
         rdpzzz2 = rkp * dpzzz2
         rdpyxx2 = rkp * dpyxx2
         rdpyxy2 = rkp * dpyxy2
         rdpyxz2 = rkp * dpyxz2
         rdpzxx2 = rkp * dpzxx2
         rdpzxy2 = rkp * dpzxy2
         rdpzxz2 = rkp * dpzxz2
         rdpzyx2 = rkp * dpzyx2
         rdpzyy2 = rkp * dpzyy2
         rdpzyz2 = rkp * dpzyz2
         rdpxxx3 = rkp * dpxxx3
         rdpxxy3 = rkp * dpxxy3
         rdpxxz3 = rkp * dpxxz3
         rdpyyx3 = rkp * dpyyx3
         rdpyyy3 = rkp * dpyyy3
         rdpyyz3 = rkp * dpyyz3
         rdpzzx3 = rkp * dpzzx3
         rdpzzy3 = rkp * dpzzy3
         rdpzzz3 = rkp * dpzzz3
         rdpyxx3 = rkp * dpyxx3
         rdpyxy3 = rkp * dpyxy3
         rdpyxz3 = rkp * dpyxz3
         rdpzxx3 = rkp * dpzxx3
         rdpzxy3 = rkp * dpzxy3
         rdpzxz3 = rkp * dpzxz3
         rdpzyx3 = rkp * dpzyx3
         rdpzyy3 = rkp * dpzyy3
         rdpzyz3 = rkp * dpzyz3
!rpdss(1-3)
         rpdxxx1 = rkp * pdxxx1
         rpdxyy1 = rkp * pdxyy1
         rpdxzz1 = rkp * pdxzz1
         rpdxyx1 = rkp * pdxyx1
         rpdxzx1 = rkp * pdxzx1
         rpdxzy1 = rkp * pdxzy1
         rpdyxx1 = rkp * pdyxx1
         rpdyyy1 = rkp * pdyyy1
         rpdyzz1 = rkp * pdyzz1
         rpdyyx1 = rkp * pdyyx1
         rpdyzx1 = rkp * pdyzx1
         rpdyzy1 = rkp * pdyzy1
         rpdzxx1 = rkp * pdzxx1
         rpdzyy1 = rkp * pdzyy1
         rpdzzz1 = rkp * pdzzz1
         rpdzyx1 = rkp * pdzyx1
         rpdzzx1 = rkp * pdzzx1
         rpdzzy1 = rkp * pdzzy1

         rpdxxx2 = rkp * pdxxx2
         rpdxyy2 = rkp * pdxyy2
         rpdxzz2 = rkp * pdxzz2
         rpdxyx2 = rkp * pdxyx2
         rpdxzx2 = rkp * pdxzx2
         rpdxzy2 = rkp * pdxzy2
         rpdyxx2 = rkp * pdyxx2
         rpdyyy2 = rkp * pdyyy2
         rpdyzz2 = rkp * pdyzz2
         rpdyyx2 = rkp * pdyyx2
         rpdyzx2 = rkp * pdyzx2
         rpdyzy2 = rkp * pdyzy2
         rpdzxx2 = rkp * pdzxx2
         rpdzyy2 = rkp * pdzyy2
         rpdzzz2 = rkp * pdzzz2
         rpdzyx2 = rkp * pdzyx2
         rpdzzx2 = rkp * pdzzx2
         rpdzzy2 = rkp * pdzzy2

         rpdxxx3 = rkp * pdxxx3
         rpdxyy3 = rkp * pdxyy3
         rpdxzz3 = rkp * pdxzz3
         rpdxyx3 = rkp * pdxyx3
         rpdxzx3 = rkp * pdxzx3
         rpdxzy3 = rkp * pdxzy3
         rpdyxx3 = rkp * pdyxx3
         rpdyyy3 = rkp * pdyyy3
         rpdyzz3 = rkp * pdyzz3
         rpdyyx3 = rkp * pdyyx3
         rpdyzx3 = rkp * pdyzx3
         rpdyzy3 = rkp * pdyzy3
         rpdzxx3 = rkp * pdzxx3
         rpdzyy3 = rkp * pdzyy3
         rpdzzz3 = rkp * pdzzz3
         rpdzyx3 = rkp * pdzyx3
         rpdzzx3 = rkp * pdzzx3
         rpdzzy3 = rkp * pdzzy3

!ddps(0-2)
      dxxdxxpx0=qcx*ddxxxx0 + wqx*ddxxxx1 + 2.0d0*rpdxxx1+2.0d0*rdpxxx1
      dxxdxxpy0=qcy*ddxxxx0 + wqy*ddxxxx1
      dxxdxxpz0=qcz*ddxxxx0 + wqz*ddxxxx1
      dxxdyypx0=qcx*ddxxyy0 + wqx*ddxxyy1 + 2.0d0*rpdxyy1
      dxxdyypy0=qcy*ddxxyy0 + wqy*ddxxyy1                +2.0d0*rdpxxy1
      dxxdyypz0=qcz*ddxxyy0 + wqz*ddxxyy1
      dxxdzzpx0=qcx*ddxxzz0 + wqx*ddxxzz1 + 2.0d0*rpdxzz1
      dxxdzzpy0=qcy*ddxxzz0 + wqy*ddxxzz1
      dxxdzzpz0=qcz*ddxxzz0 + wqz*ddxxzz1                +2.0d0*rdpxxz1
      dxxdyxpx0=qcx*ddxxyx0 + wqx*ddxxyx1 + 2.0d0*rpdxyx1+      rdpxxy1
      dxxdyxpy0=qcy*ddxxyx0 + wqy*ddxxyx1                +      rdpxxx1
      dxxdyxpz0=qcz*ddxxyx0 + wqz*ddxxyx1 
      dxxdzxpx0=qcx*ddxxzx0 + wqx*ddxxzx1 + 2.0d0*rpdxzx1+      rdpxxz1
      dxxdzxpy0=qcy*ddxxzx0 + wqy*ddxxzx1
      dxxdzxpz0=qcz*ddxxzx0 + wqz*ddxxzx1                +      rdpxxx1
      dxxdzypx0=qcx*ddxxzy0 + wqx*ddxxzy1 + 2.0d0*rpdxzy1
      dxxdzypy0=qcy*ddxxzy0 + wqy*ddxxzy1                +      rdpxxz1
      dxxdzypz0=qcz*ddxxzy0 + wqz*ddxxzy1                +      rdpxxy1
      dyydxxpx0=qcx*ddyyxx0 + wqx*ddyyxx1                +2.0d0*rdpyyx1
      dyydxxpy0=qcy*ddyyxx0 + wqy*ddyyxx1 + 2.0d0*rpdyxx1
      dyydxxpz0=qcz*ddyyxx0 + wqz*ddyyxx1
      dyydyypx0=qcx*ddyyyy0 + wqx*ddyyyy1
      dyydyypy0=qcy*ddyyyy0 + wqy*ddyyyy1 + 2.0d0*rpdyyy1+2.0d0*rdpyyy1
      dyydyypz0=qcz*ddyyyy0 + wqz*ddyyyy1
      dyydzzpx0=qcx*ddyyzz0 + wqx*ddyyzz1
      dyydzzpy0=qcy*ddyyzz0 + wqy*ddyyzz1 + 2.0d0*rpdyzz1
      dyydzzpz0=qcz*ddyyzz0 + wqz*ddyyzz1                +2.0d0*rdpyyz1
      dyydyxpx0=qcx*ddyyyx0 + wqx*ddyyyx1                +      rdpyyy1
      dyydyxpy0=qcy*ddyyyx0 + wqy*ddyyyx1 + 2.0d0*rpdyyx1+      rdpyyx1
      dyydyxpz0=qcz*ddyyyx0 + wqz*ddyyyx1
      dyydzxpx0=qcx*ddyyzx0 + wqx*ddyyzx1                +      rdpyyz1
      dyydzxpy0=qcy*ddyyzx0 + wqy*ddyyzx1 + 2.0d0*rpdyzx1
      dyydzxpz0=qcz*ddyyzx0 + wqz*ddyyzx1                +      rdpyyx1
      dyydzypx0=qcx*ddyyzy0 + wqx*ddyyzy1
      dyydzypy0=qcy*ddyyzy0 + wqy*ddyyzy1 + 2.0d0*rpdyzy1+      rdpyyz1
      dyydzypz0=qcz*ddyyzy0 + wqz*ddyyzy1                +      rdpyyy1
      dzzdxxpx0=qcx*ddzzxx0 + wqx*ddzzxx1                +2.0d0*rdpzzx1
      dzzdxxpy0=qcy*ddzzxx0 + wqy*ddzzxx1 
      dzzdxxpz0=qcz*ddzzxx0 + wqz*ddzzxx1 + 2.0d0*rpdzxx1
      dzzdyypx0=qcx*ddzzyy0 + wqx*ddzzyy1
      dzzdyypy0=qcy*ddzzyy0 + wqy*ddzzyy1                +2.0d0*rdpzzy1
      dzzdyypz0=qcz*ddzzyy0 + wqz*ddzzyy1 + 2.0d0*rpdzyy1
      dzzdzzpx0=qcx*ddzzzz0 + wqx*ddzzzz1
      dzzdzzpy0=qcy*ddzzzz0 + wqy*ddzzzz1
      dzzdzzpz0=qcz*ddzzzz0 + wqz*ddzzzz1 + 2.0d0*rpdzzz1+2.0d0*rdpzzz1
      dzzdyxpx0=qcx*ddzzyx0 + wqx*ddzzyx1                +      rdpzzy1
      dzzdyxpy0=qcy*ddzzyx0 + wqy*ddzzyx1                +      rdpzzx1
      dzzdyxpz0=qcz*ddzzyx0 + wqz*ddzzyx1 + 2.0d0*rpdzyx1
      dzzdzxpx0=qcx*ddzzzx0 + wqx*ddzzzx1                +      rdpzzz1
      dzzdzxpy0=qcy*ddzzzx0 + wqy*ddzzzx1 
      dzzdzxpz0=qcz*ddzzzx0 + wqz*ddzzzx1 + 2.0d0*rpdzzx1+      rdpzzx1
      dzzdzypx0=qcx*ddzzzy0 + wqx*ddzzzy1
      dzzdzypy0=qcy*ddzzzy0 + wqy*ddzzzy1                +      rdpzzz1
      dzzdzypz0=qcz*ddzzzy0 + wqz*ddzzzy1 + 2.0d0*rpdzzy1+      rdpzzy1
      dyxdxxpx0=qcx*ddyxxx0 + wqx*ddyxxx1 +       rpdyxx1+2.0d0*rdpyxx1
      dyxdxxpy0=qcy*ddyxxx0 + wqy*ddyxxx1 +       rpdxxx1
      dyxdxxpz0=qcz*ddyxxx0 + wqz*ddyxxx1
      dyxdyypx0=qcx*ddyxyy0 + wqx*ddyxyy1 +       rpdyyy1
      dyxdyypy0=qcy*ddyxyy0 + wqy*ddyxyy1 +       rpdxyy1+2.0d0*rdpyxy1
      dyxdyypz0=qcz*ddyxyy0 + wqz*ddyxyy1
      dyxdzzpx0=qcx*ddyxzz0 + wqx*ddyxzz1 +       rpdyzz1
      dyxdzzpy0=qcy*ddyxzz0 + wqy*ddyxzz1 +       rpdxzz1
      dyxdzzpz0=qcz*ddyxzz0 + wqz*ddyxzz1                +2.0d0*rdpyxz1
      dyxdyxpx0=qcx*ddyxyx0 + wqx*ddyxyx1 +       rpdyyx1+      rdpyxy1
      dyxdyxpy0=qcy*ddyxyx0 + wqy*ddyxyx1 +       rpdxyx1+      rdpyxx1
      dyxdyxpz0=qcz*ddyxyx0 + wqz*ddyxyx1
      dyxdzxpx0=qcx*ddyxzx0 + wqx*ddyxzx1 +       rpdyzx1+      rdpyxz1
      dyxdzxpy0=qcy*ddyxzx0 + wqy*ddyxzx1 +       rpdxzx1
      dyxdzxpz0=qcz*ddyxzx0 + wqz*ddyxzx1                +      rdpyxx1
      dyxdzypx0=qcx*ddyxzy0 + wqx*ddyxzy1 +       rpdyzy1
      dyxdzypy0=qcy*ddyxzy0 + wqy*ddyxzy1 +       rpdxzy1+      rdpyxz1
      dyxdzypz0=qcz*ddyxzy0 + wqz*ddyxzy1                +      rdpyxy1
      dzxdxxpx0=qcx*ddzxxx0 + wqx*ddzxxx1 +       rpdzxx1+2.0d0*rdpzxx1
      dzxdxxpy0=qcy*ddzxxx0 + wqy*ddzxxx1
      dzxdxxpz0=qcz*ddzxxx0 + wqz*ddzxxx1 +       rpdxxx1
      dzxdyypx0=qcx*ddzxyy0 + wqx*ddzxyy1 +       rpdzyy1
      dzxdyypy0=qcy*ddzxyy0 + wqy*ddzxyy1                +2.0d0*rdpzxy1
      dzxdyypz0=qcz*ddzxyy0 + wqz*ddzxyy1 +       rpdxyy1
      dzxdzzpx0=qcx*ddzxzz0 + wqx*ddzxzz1 +       rpdzzz1
      dzxdzzpy0=qcy*ddzxzz0 + wqy*ddzxzz1
      dzxdzzpz0=qcz*ddzxzz0 + wqz*ddzxzz1 +       rpdxzz1+2.0d0*rdpzxz1
      dzxdyxpx0=qcx*ddzxyx0 + wqx*ddzxyx1 +       rpdzyx1+      rdpzxy1
      dzxdyxpy0=qcy*ddzxyx0 + wqy*ddzxyx1                +      rdpzxx1
      dzxdyxpz0=qcz*ddzxyx0 + wqz*ddzxyx1 +       rpdxyx1
      dzxdzxpx0=qcx*ddzxzx0 + wqx*ddzxzx1 +       rpdzzx1+      rdpzxz1
      dzxdzxpy0=qcy*ddzxzx0 + wqy*ddzxzx1
      dzxdzxpz0=qcz*ddzxzx0 + wqz*ddzxzx1 +       rpdxzx1+      rdpzxx1
      dzxdzypx0=qcx*ddzxzy0 + wqx*ddzxzy1 +       rpdzzy1
      dzxdzypy0=qcy*ddzxzy0 + wqy*ddzxzy1                +      rdpzxz1
      dzxdzypz0=qcz*ddzxzy0 + wqz*ddzxzy1 +       rpdxzy1+      rdpzxy1
      dzydxxpx0=qcx*ddzyxx0 + wqx*ddzyxx1                +2.0d0*rdpzyx1
      dzydxxpy0=qcy*ddzyxx0 + wqy*ddzyxx1 +       rpdzxx1
      dzydxxpz0=qcz*ddzyxx0 + wqz*ddzyxx1 +       rpdyxx1
      dzydyypx0=qcx*ddzyyy0 + wqx*ddzyyy1
      dzydyypy0=qcy*ddzyyy0 + wqy*ddzyyy1 +       rpdzyy1+2.0d0*rdpzyy1
      dzydyypz0=qcz*ddzyyy0 + wqz*ddzyyy1 +       rpdyyy1
      dzydzzpx0=qcx*ddzyzz0 + wqx*ddzyzz1
      dzydzzpy0=qcy*ddzyzz0 + wqy*ddzyzz1 +       rpdzzz1
      dzydzzpz0=qcz*ddzyzz0 + wqz*ddzyzz1 +       rpdyzz1+2.0d0*rdpzyz1
      dzydyxpx0=qcx*ddzyyx0 + wqx*ddzyyx1                +      rdpzyy1
      dzydyxpy0=qcy*ddzyyx0 + wqy*ddzyyx1 +       rpdzyx1+      rdpzyx1
      dzydyxpz0=qcz*ddzyyx0 + wqz*ddzyyx1 +       rpdyyx1
      dzydzxpx0=qcx*ddzyzx0 + wqx*ddzyzx1                +      rdpzyz1
      dzydzxpy0=qcy*ddzyzx0 + wqy*ddzyzx1 +       rpdzzx1
      dzydzxpz0=qcz*ddzyzx0 + wqz*ddzyzx1 +       rpdyzx1+      rdpzyx1
      dzydzypx0=qcx*ddzyzy0 + wqx*ddzyzy1
      dzydzypy0=qcy*ddzyzy0 + wqy*ddzyzy1 +       rpdzzy1+      rdpzyz1
      dzydzypz0=qcz*ddzyzy0 + wqz*ddzyzy1 +       rpdyzy1+      rdpzyy1

      dxxdxxpx1=qcx*ddxxxx1 + wqx*ddxxxx2 + 2.0d0*rpdxxx2+2.0d0*rdpxxx2
      dxxdxxpy1=qcy*ddxxxx1 + wqy*ddxxxx2
      dxxdxxpz1=qcz*ddxxxx1 + wqz*ddxxxx2
      dxxdyypx1=qcx*ddxxyy1 + wqx*ddxxyy2 + 2.0d0*rpdxyy2
      dxxdyypy1=qcy*ddxxyy1 + wqy*ddxxyy2                +2.0d0*rdpxxy2
      dxxdyypz1=qcz*ddxxyy1 + wqz*ddxxyy2
      dxxdzzpx1=qcx*ddxxzz1 + wqx*ddxxzz2 + 2.0d0*rpdxzz2
      dxxdzzpy1=qcy*ddxxzz1 + wqy*ddxxzz2
      dxxdzzpz1=qcz*ddxxzz1 + wqz*ddxxzz2                +2.0d0*rdpxxz2
      dxxdyxpx1=qcx*ddxxyx1 + wqx*ddxxyx2 + 2.0d0*rpdxyx2+      rdpxxy2
      dxxdyxpy1=qcy*ddxxyx1 + wqy*ddxxyx2                +      rdpxxx2
      dxxdyxpz1=qcz*ddxxyx1 + wqz*ddxxyx2 
      dxxdzxpx1=qcx*ddxxzx1 + wqx*ddxxzx2 + 2.0d0*rpdxzx2+      rdpxxz2
      dxxdzxpy1=qcy*ddxxzx1 + wqy*ddxxzx2
      dxxdzxpz1=qcz*ddxxzx1 + wqz*ddxxzx2                +      rdpxxx2
      dxxdzypx1=qcx*ddxxzy1 + wqx*ddxxzy2 + 2.0d0*rpdxzy2
      dxxdzypy1=qcy*ddxxzy1 + wqy*ddxxzy2                +      rdpxxz2
      dxxdzypz1=qcz*ddxxzy1 + wqz*ddxxzy2                +      rdpxxy2
      dyydxxpx1=qcx*ddyyxx1 + wqx*ddyyxx2                +2.0d0*rdpyyx2
      dyydxxpy1=qcy*ddyyxx1 + wqy*ddyyxx2 + 2.0d0*rpdyxx2
      dyydxxpz1=qcz*ddyyxx1 + wqz*ddyyxx2
      dyydyypx1=qcx*ddyyyy1 + wqx*ddyyyy2
      dyydyypy1=qcy*ddyyyy1 + wqy*ddyyyy2 + 2.0d0*rpdyyy2+2.0d0*rdpyyy2
      dyydyypz1=qcz*ddyyyy1 + wqz*ddyyyy2
      dyydzzpx1=qcx*ddyyzz1 + wqx*ddyyzz2
      dyydzzpy1=qcy*ddyyzz1 + wqy*ddyyzz2 + 2.0d0*rpdyzz2
      dyydzzpz1=qcz*ddyyzz1 + wqz*ddyyzz2                +2.0d0*rdpyyz2
      dyydyxpx1=qcx*ddyyyx1 + wqx*ddyyyx2                +      rdpyyy2
      dyydyxpy1=qcy*ddyyyx1 + wqy*ddyyyx2 + 2.0d0*rpdyyx2+      rdpyyx2
      dyydyxpz1=qcz*ddyyyx1 + wqz*ddyyyx2
      dyydzxpx1=qcx*ddyyzx1 + wqx*ddyyzx2                +      rdpyyz2
      dyydzxpy1=qcy*ddyyzx1 + wqy*ddyyzx2 + 2.0d0*rpdyzx2
      dyydzxpz1=qcz*ddyyzx1 + wqz*ddyyzx2                +      rdpyyx2
      dyydzypx1=qcx*ddyyzy1 + wqx*ddyyzy2
      dyydzypy1=qcy*ddyyzy1 + wqy*ddyyzy2 + 2.0d0*rpdyzy2+      rdpyyz2
      dyydzypz1=qcz*ddyyzy1 + wqz*ddyyzy2                +      rdpyyy2
      dzzdxxpx1=qcx*ddzzxx1 + wqx*ddzzxx2                +2.0d0*rdpzzx2
      dzzdxxpy1=qcy*ddzzxx1 + wqy*ddzzxx2 
      dzzdxxpz1=qcz*ddzzxx1 + wqz*ddzzxx2 + 2.0d0*rpdzxx2
      dzzdyypx1=qcx*ddzzyy1 + wqx*ddzzyy2
      dzzdyypy1=qcy*ddzzyy1 + wqy*ddzzyy2                +2.0d0*rdpzzy2
      dzzdyypz1=qcz*ddzzyy1 + wqz*ddzzyy2 + 2.0d0*rpdzyy2
      dzzdzzpx1=qcx*ddzzzz1 + wqx*ddzzzz2
      dzzdzzpy1=qcy*ddzzzz1 + wqy*ddzzzz2
      dzzdzzpz1=qcz*ddzzzz1 + wqz*ddzzzz2 + 2.0d0*rpdzzz2+2.0d0*rdpzzz2
      dzzdyxpx1=qcx*ddzzyx1 + wqx*ddzzyx2                +      rdpzzy2
      dzzdyxpy1=qcy*ddzzyx1 + wqy*ddzzyx2                +      rdpzzx2
      dzzdyxpz1=qcz*ddzzyx1 + wqz*ddzzyx2 + 2.0d0*rpdzyx2
      dzzdzxpx1=qcx*ddzzzx1 + wqx*ddzzzx2                +      rdpzzz2
      dzzdzxpy1=qcy*ddzzzx1 + wqy*ddzzzx2 
      dzzdzxpz1=qcz*ddzzzx1 + wqz*ddzzzx2 + 2.0d0*rpdzzx2+      rdpzzx2
      dzzdzypx1=qcx*ddzzzy1 + wqx*ddzzzy2
      dzzdzypy1=qcy*ddzzzy1 + wqy*ddzzzy2                +      rdpzzz2
      dzzdzypz1=qcz*ddzzzy1 + wqz*ddzzzy2 + 2.0d0*rpdzzy2+      rdpzzy2

      dyxdxxpx1=qcx*ddyxxx1 + wqx*ddyxxx2 +       rpdyxx2+2.0d0*rdpyxx2
      dyxdxxpy1=qcy*ddyxxx1 + wqy*ddyxxx2 +       rpdxxx2
      dyxdxxpz1=qcz*ddyxxx1 + wqz*ddyxxx2
      dyxdyypx1=qcx*ddyxyy1 + wqx*ddyxyy2 +       rpdyyy2
      dyxdyypy1=qcy*ddyxyy1 + wqy*ddyxyy2 +       rpdxyy2+2.0d0*rdpyxy2
      dyxdyypz1=qcz*ddyxyy1 + wqz*ddyxyy2
      dyxdzzpx1=qcx*ddyxzz1 + wqx*ddyxzz2 +       rpdyzz2
      dyxdzzpy1=qcy*ddyxzz1 + wqy*ddyxzz2 +       rpdxzz2
      dyxdzzpz1=qcz*ddyxzz1 + wqz*ddyxzz2                +2.0d0*rdpyxz2
      dyxdyxpx1=qcx*ddyxyx1 + wqx*ddyxyx2 +       rpdyyx2+      rdpyxy2
      dyxdyxpy1=qcy*ddyxyx1 + wqy*ddyxyx2 +       rpdxyx2+      rdpyxx2
      dyxdyxpz1=qcz*ddyxyx1 + wqz*ddyxyx2
      dyxdzxpx1=qcx*ddyxzx1 + wqx*ddyxzx2 +       rpdyzx2+      rdpyxz2
      dyxdzxpy1=qcy*ddyxzx1 + wqy*ddyxzx2 +       rpdxzx2
      dyxdzxpz1=qcz*ddyxzx1 + wqz*ddyxzx2                +      rdpyxx2
      dyxdzypx1=qcx*ddyxzy1 + wqx*ddyxzy2 +       rpdyzy2
      dyxdzypy1=qcy*ddyxzy1 + wqy*ddyxzy2 +       rpdxzy2+      rdpyxz2
      dyxdzypz1=qcz*ddyxzy1 + wqz*ddyxzy2                +      rdpyxy2
      dzxdxxpx1=qcx*ddzxxx1 + wqx*ddzxxx2 +       rpdzxx2+2.0d0*rdpzxx2
      dzxdxxpy1=qcy*ddzxxx1 + wqy*ddzxxx2
      dzxdxxpz1=qcz*ddzxxx1 + wqz*ddzxxx2 +       rpdxxx2
      dzxdyypx1=qcx*ddzxyy1 + wqx*ddzxyy2 +       rpdzyy2
      dzxdyypy1=qcy*ddzxyy1 + wqy*ddzxyy2                +2.0d0*rdpzxy2
      dzxdyypz1=qcz*ddzxyy1 + wqz*ddzxyy2 +       rpdxyy2
      dzxdzzpx1=qcx*ddzxzz1 + wqx*ddzxzz2 +       rpdzzz2
      dzxdzzpy1=qcy*ddzxzz1 + wqy*ddzxzz2
      dzxdzzpz1=qcz*ddzxzz1 + wqz*ddzxzz2 +       rpdxzz2+2.0d0*rdpzxz2
      dzxdyxpx1=qcx*ddzxyx1 + wqx*ddzxyx2 +       rpdzyx2+      rdpzxy2
      dzxdyxpy1=qcy*ddzxyx1 + wqy*ddzxyx2                +      rdpzxx2
      dzxdyxpz1=qcz*ddzxyx1 + wqz*ddzxyx2 +       rpdxyx2
      dzxdzxpx1=qcx*ddzxzx1 + wqx*ddzxzx2 +       rpdzzx2+      rdpzxz2
      dzxdzxpy1=qcy*ddzxzx1 + wqy*ddzxzx2
      dzxdzxpz1=qcz*ddzxzx1 + wqz*ddzxzx2 +       rpdxzx2+      rdpzxx2
      dzxdzypx1=qcx*ddzxzy1 + wqx*ddzxzy2 +       rpdzzy2
      dzxdzypy1=qcy*ddzxzy1 + wqy*ddzxzy2                +      rdpzxz2
      dzxdzypz1=qcz*ddzxzy1 + wqz*ddzxzy2 +       rpdxzy2+      rdpzxy2
      dzydxxpx1=qcx*ddzyxx1 + wqx*ddzyxx2                +2.0d0*rdpzyx2
      dzydxxpy1=qcy*ddzyxx1 + wqy*ddzyxx2 +       rpdzxx2
      dzydxxpz1=qcz*ddzyxx1 + wqz*ddzyxx2 +       rpdyxx2
      dzydyypx1=qcx*ddzyyy1 + wqx*ddzyyy2
      dzydyypy1=qcy*ddzyyy1 + wqy*ddzyyy2 +       rpdzyy2+2.0d0*rdpzyy2
      dzydyypz1=qcz*ddzyyy1 + wqz*ddzyyy2 +       rpdyyy2
      dzydzzpx1=qcx*ddzyzz1 + wqx*ddzyzz2
      dzydzzpy1=qcy*ddzyzz1 + wqy*ddzyzz2 +       rpdzzz2
      dzydzzpz1=qcz*ddzyzz1 + wqz*ddzyzz2 +       rpdyzz2+2.0d0*rdpzyz2
      dzydyxpx1=qcx*ddzyyx1 + wqx*ddzyyx2                +      rdpzyy2
      dzydyxpy1=qcy*ddzyyx1 + wqy*ddzyyx2 +       rpdzyx2+      rdpzyx2
      dzydyxpz1=qcz*ddzyyx1 + wqz*ddzyyx2 +       rpdyyx2
      dzydzxpx1=qcx*ddzyzx1 + wqx*ddzyzx2                +      rdpzyz2
      dzydzxpy1=qcy*ddzyzx1 + wqy*ddzyzx2 +       rpdzzx2
      dzydzxpz1=qcz*ddzyzx1 + wqz*ddzyzx2 +       rpdyzx2+      rdpzyx2
      dzydzypx1=qcx*ddzyzy1 + wqx*ddzyzy2
      dzydzypy1=qcy*ddzyzy1 + wqy*ddzyzy2 +       rpdzzy2+      rdpzyz2
      dzydzypz1=qcz*ddzyzy1 + wqz*ddzyzy2 +       rpdyzy2+      rdpzyy2

      dxxdxxpx2=qcx*ddxxxx2 + wqx*ddxxxx3 + 2.0d0*rpdxxx3+2.0d0*rdpxxx3
      dxxdxxpy2=qcy*ddxxxx2 + wqy*ddxxxx3
      dxxdxxpz2=qcz*ddxxxx2 + wqz*ddxxxx3
      dxxdyypx2=qcx*ddxxyy2 + wqx*ddxxyy3 + 2.0d0*rpdxyy3
      dxxdyypy2=qcy*ddxxyy2 + wqy*ddxxyy3                +2.0d0*rdpxxy3
      dxxdyypz2=qcz*ddxxyy2 + wqz*ddxxyy3
      dxxdzzpx2=qcx*ddxxzz2 + wqx*ddxxzz3 + 2.0d0*rpdxzz3
      dxxdzzpy2=qcy*ddxxzz2 + wqy*ddxxzz3
      dxxdzzpz2=qcz*ddxxzz2 + wqz*ddxxzz3                +2.0d0*rdpxxz3
      dxxdyxpx2=qcx*ddxxyx2 + wqx*ddxxyx3 + 2.0d0*rpdxyx3+      rdpxxy3
      dxxdyxpy2=qcy*ddxxyx2 + wqy*ddxxyx3                +      rdpxxx3
      dxxdyxpz2=qcz*ddxxyx2 + wqz*ddxxyx3 
      dxxdzxpx2=qcx*ddxxzx2 + wqx*ddxxzx3 + 2.0d0*rpdxzx3+      rdpxxz3
      dxxdzxpy2=qcy*ddxxzx2 + wqy*ddxxzx3
      dxxdzxpz2=qcz*ddxxzx2 + wqz*ddxxzx3                +      rdpxxx3
      dxxdzypx2=qcx*ddxxzy2 + wqx*ddxxzy3 + 2.0d0*rpdxzy3
      dxxdzypy2=qcy*ddxxzy2 + wqy*ddxxzy3                +      rdpxxz3
      dxxdzypz2=qcz*ddxxzy2 + wqz*ddxxzy3                +      rdpxxy3
      dyydxxpx2=qcx*ddyyxx2 + wqx*ddyyxx3                +2.0d0*rdpyyx3
      dyydxxpy2=qcy*ddyyxx2 + wqy*ddyyxx3 + 2.0d0*rpdyxx3
      dyydxxpz2=qcz*ddyyxx2 + wqz*ddyyxx3
      dyydyypx2=qcx*ddyyyy2 + wqx*ddyyyy3
      dyydyypy2=qcy*ddyyyy2 + wqy*ddyyyy3 + 2.0d0*rpdyyy3+2.0d0*rdpyyy3
      dyydyypz2=qcz*ddyyyy2 + wqz*ddyyyy3
      dyydzzpx2=qcx*ddyyzz2 + wqx*ddyyzz3
      dyydzzpy2=qcy*ddyyzz2 + wqy*ddyyzz3 + 2.0d0*rpdyzz3
      dyydzzpz2=qcz*ddyyzz2 + wqz*ddyyzz3                +2.0d0*rdpyyz3
      dyydyxpx2=qcx*ddyyyx2 + wqx*ddyyyx3                +      rdpyyy3
      dyydyxpy2=qcy*ddyyyx2 + wqy*ddyyyx3 + 2.0d0*rpdyyx3+      rdpyyx3
      dyydyxpz2=qcz*ddyyyx2 + wqz*ddyyyx3
      dyydzxpx2=qcx*ddyyzx2 + wqx*ddyyzx3                +      rdpyyz3
      dyydzxpy2=qcy*ddyyzx2 + wqy*ddyyzx3 + 2.0d0*rpdyzx3
      dyydzxpz2=qcz*ddyyzx2 + wqz*ddyyzx3                +      rdpyyx3
      dyydzypx2=qcx*ddyyzy2 + wqx*ddyyzy3
      dyydzypy2=qcy*ddyyzy2 + wqy*ddyyzy3 + 2.0d0*rpdyzy3+      rdpyyz3
      dyydzypz2=qcz*ddyyzy2 + wqz*ddyyzy3                +      rdpyyy3
      dzzdxxpx2=qcx*ddzzxx2 + wqx*ddzzxx3                +2.0d0*rdpzzx3
      dzzdxxpy2=qcy*ddzzxx2 + wqy*ddzzxx3 
      dzzdxxpz2=qcz*ddzzxx2 + wqz*ddzzxx3 + 2.0d0*rpdzxx3
      dzzdyypx2=qcx*ddzzyy2 + wqx*ddzzyy3
      dzzdyypy2=qcy*ddzzyy2 + wqy*ddzzyy3                +2.0d0*rdpzzy3
      dzzdyypz2=qcz*ddzzyy2 + wqz*ddzzyy3 + 2.0d0*rpdzyy3
      dzzdzzpx2=qcx*ddzzzz2 + wqx*ddzzzz3
      dzzdzzpy2=qcy*ddzzzz2 + wqy*ddzzzz3
      dzzdzzpz2=qcz*ddzzzz2 + wqz*ddzzzz3 + 2.0d0*rpdzzz3+2.0d0*rdpzzz3
      dzzdyxpx2=qcx*ddzzyx2 + wqx*ddzzyx3                +      rdpzzy3
      dzzdyxpy2=qcy*ddzzyx2 + wqy*ddzzyx3                +      rdpzzx3
      dzzdyxpz2=qcz*ddzzyx2 + wqz*ddzzyx3 + 2.0d0*rpdzyx3
      dzzdzxpx2=qcx*ddzzzx2 + wqx*ddzzzx3                +      rdpzzz3
      dzzdzxpy2=qcy*ddzzzx2 + wqy*ddzzzx3 
      dzzdzxpz2=qcz*ddzzzx2 + wqz*ddzzzx3 + 2.0d0*rpdzzx3+      rdpzzx3
      dzzdzypx2=qcx*ddzzzy2 + wqx*ddzzzy3
      dzzdzypy2=qcy*ddzzzy2 + wqy*ddzzzy3                +      rdpzzz3
      dzzdzypz2=qcz*ddzzzy2 + wqz*ddzzzy3 + 2.0d0*rpdzzy3+      rdpzzy3

      dyxdxxpx2=qcx*ddyxxx2 + wqx*ddyxxx3 +       rpdyxx3+2.0d0*rdpyxx3
      dyxdxxpy2=qcy*ddyxxx2 + wqy*ddyxxx3 +       rpdxxx3
      dyxdxxpz2=qcz*ddyxxx2 + wqz*ddyxxx3
      dyxdyypx2=qcx*ddyxyy2 + wqx*ddyxyy3 +       rpdyyy3
      dyxdyypy2=qcy*ddyxyy2 + wqy*ddyxyy3 +       rpdxyy3+2.0d0*rdpyxy3
      dyxdyypz2=qcz*ddyxyy2 + wqz*ddyxyy3
      dyxdzzpx2=qcx*ddyxzz2 + wqx*ddyxzz3 +       rpdyzz3
      dyxdzzpy2=qcy*ddyxzz2 + wqy*ddyxzz3 +       rpdxzz3
      dyxdzzpz2=qcz*ddyxzz2 + wqz*ddyxzz3                +2.0d0*rdpyxz3
      dyxdyxpx2=qcx*ddyxyx2 + wqx*ddyxyx3 +       rpdyyx3+      rdpyxy3
      dyxdyxpy2=qcy*ddyxyx2 + wqy*ddyxyx3 +       rpdxyx3+      rdpyxx3
      dyxdyxpz2=qcz*ddyxyx2 + wqz*ddyxyx3
      dyxdzxpx2=qcx*ddyxzx2 + wqx*ddyxzx3 +       rpdyzx3+      rdpyxz3
      dyxdzxpy2=qcy*ddyxzx2 + wqy*ddyxzx3 +       rpdxzx3
      dyxdzxpz2=qcz*ddyxzx2 + wqz*ddyxzx3                +      rdpyxx3
      dyxdzypx2=qcx*ddyxzy2 + wqx*ddyxzy3 +       rpdyzy3
      dyxdzypy2=qcy*ddyxzy2 + wqy*ddyxzy3 +       rpdxzy3+      rdpyxz3
      dyxdzypz2=qcz*ddyxzy2 + wqz*ddyxzy3                +      rdpyxy3
      dzxdxxpx2=qcx*ddzxxx2 + wqx*ddzxxx3 +       rpdzxx3+2.0d0*rdpzxx3
      dzxdxxpy2=qcy*ddzxxx2 + wqy*ddzxxx3
      dzxdxxpz2=qcz*ddzxxx2 + wqz*ddzxxx3 +       rpdxxx3
      dzxdyypx2=qcx*ddzxyy2 + wqx*ddzxyy3 +       rpdzyy3
      dzxdyypy2=qcy*ddzxyy2 + wqy*ddzxyy3                +2.0d0*rdpzxy3
      dzxdyypz2=qcz*ddzxyy2 + wqz*ddzxyy3 +       rpdxyy3
      dzxdzzpx2=qcx*ddzxzz2 + wqx*ddzxzz3 +       rpdzzz3
      dzxdzzpy2=qcy*ddzxzz2 + wqy*ddzxzz3
      dzxdzzpz2=qcz*ddzxzz2 + wqz*ddzxzz3 +       rpdxzz3+2.0d0*rdpzxz3
      dzxdyxpx2=qcx*ddzxyx2 + wqx*ddzxyx3 +       rpdzyx3+      rdpzxy3
      dzxdyxpy2=qcy*ddzxyx2 + wqy*ddzxyx3                +      rdpzxx3
      dzxdyxpz2=qcz*ddzxyx2 + wqz*ddzxyx3 +       rpdxyx3
      dzxdzxpx2=qcx*ddzxzx2 + wqx*ddzxzx3 +       rpdzzx3+      rdpzxz3
      dzxdzxpy2=qcy*ddzxzx2 + wqy*ddzxzx3
      dzxdzxpz2=qcz*ddzxzx2 + wqz*ddzxzx3 +       rpdxzx3+      rdpzxx3
      dzxdzypx2=qcx*ddzxzy2 + wqx*ddzxzy3 +       rpdzzy3
      dzxdzypy2=qcy*ddzxzy2 + wqy*ddzxzy3                +      rdpzxz3
      dzxdzypz2=qcz*ddzxzy2 + wqz*ddzxzy3 +       rpdxzy3+      rdpzxy3
      dzydxxpx2=qcx*ddzyxx2 + wqx*ddzyxx3                +2.0d0*rdpzyx3
      dzydxxpy2=qcy*ddzyxx2 + wqy*ddzyxx3 +       rpdzxx3
      dzydxxpz2=qcz*ddzyxx2 + wqz*ddzyxx3 +       rpdyxx3
      dzydyypx2=qcx*ddzyyy2 + wqx*ddzyyy3
      dzydyypy2=qcy*ddzyyy2 + wqy*ddzyyy3 +       rpdzyy3+2.0d0*rdpzyy3
      dzydyypz2=qcz*ddzyyy2 + wqz*ddzyyy3 +       rpdyyy3
      dzydzzpx2=qcx*ddzyzz2 + wqx*ddzyzz3
      dzydzzpy2=qcy*ddzyzz2 + wqy*ddzyzz3 +       rpdzzz3
      dzydzzpz2=qcz*ddzyzz2 + wqz*ddzyzz3 +       rpdyzz3+2.0d0*rdpzyz3
      dzydyxpx2=qcx*ddzyyx2 + wqx*ddzyyx3                +      rdpzyy3
      dzydyxpy2=qcy*ddzyyx2 + wqy*ddzyyx3 +       rpdzyx3+      rdpzyx3
      dzydyxpz2=qcz*ddzyyx2 + wqz*ddzyyx3 +       rpdyyx3
      dzydzxpx2=qcx*ddzyzx2 + wqx*ddzyzx3                +      rdpzyz3
      dzydzxpy2=qcy*ddzyzx2 + wqy*ddzyzx3 +       rpdzzx3
      dzydzxpz2=qcz*ddzyzx2 + wqz*ddzyzx3 +       rpdyzx3+      rdpzyx3
      dzydzypx2=qcx*ddzyzy2 + wqx*ddzyzy3
      dzydzypy2=qcy*ddzyzy2 + wqy*ddzyzy3 +       rpdzzy3+      rdpzyz3
      dzydzypz2=qcz*ddzyzy2 + wqz*ddzyzy3 +       rpdyzy3+      rdpzyy3

!dpss01(12)
      dpxxx12=  eta*(dpxxx1 -rooe*dpxxx2)
      dpxxy12=  eta*(dpxxy1 -rooe*dpxxy2)
      dpxxz12=  eta*(dpxxz1 -rooe*dpxxz2)
      dpyyx12=  eta*(dpyyx1 -rooe*dpyyx2)
      dpyyy12=  eta*(dpyyy1 -rooe*dpyyy2)
      dpyyz12=  eta*(dpyyz1 -rooe*dpyyz2)
      dpzzx12=  eta*(dpzzx1 -rooe*dpzzx2)
      dpzzy12=  eta*(dpzzy1 -rooe*dpzzy2)
      dpzzz12=  eta*(dpzzz1 -rooe*dpzzz2)
      dpyxx12=  eta*(dpyxx1 -rooe*dpyxx2)
      dpyxy12=  eta*(dpyxy1 -rooe*dpyxy2)
      dpyxz12=  eta*(dpyxz1 -rooe*dpyxz2)
      dpzxx12=  eta*(dpzxx1 -rooe*dpzxx2)
      dpzxy12=  eta*(dpzxy1 -rooe*dpzxy2)
      dpzxz12=  eta*(dpzxz1 -rooe*dpzxz2)
      dpzyx12=  eta*(dpzyx1 -rooe*dpzyx2)
      dpzyy12=  eta*(dpzyy1 -rooe*dpzyy2)
      dpzyz12=  eta*(dpzyz1 -rooe*dpzyz2)
!rdsps (2)
      rdxxpx2 =  rkp*dxxpx2
      rdxxpy2 =  rkp*dxxpy2
      rdxxpz2 =  rkp*dxxpz2
      rdyypx2 =  rkp*dyypx2
      rdyypy2 =  rkp*dyypy2
      rdyypz2 =  rkp*dyypz2
      rdzzpx2 =  rkp*dzzpx2
      rdzzpy2 =  rkp*dzzpy2
      rdzzpz2 =  rkp*dzzpz2
      rdyxpx2 =  rkp*dyxpx2
      rdyxpy2 =  rkp*dyxpy2
      rdyxpz2 =  rkp*dyxpz2
      rdzxpx2 =  rkp*dzxpx2
      rdzxpy2 =  rkp*dzxpy2
      rdzxpz2 =  rkp*dzxpz2
      rdzypx2 =  rkp*dzypx2
      rdzypy2 =  rkp*dzypy2
      rdzypz2 =  rkp*dzypz2
!rppps(2)
      rpppxxx2 = rkp*pppxxx2
      rpppxxy2 = rkp*pppxxy2
      rpppxxz2 = rkp*pppxxz2
      rpppxyx2 = rkp*pppxyx2
      rpppxyy2 = rkp*pppxyy2
      rpppxyz2 = rkp*pppxyz2
      rpppxzx2 = rkp*pppxzx2
      rpppxzy2 = rkp*pppxzy2
      rpppxzz2 = rkp*pppxzz2
      rpppyxx2 = rkp*pppyxx2
      rpppyxy2 = rkp*pppyxy2
      rpppyxz2 = rkp*pppyxz2
      rpppyyx2 = rkp*pppyyx2
      rpppyyy2 = rkp*pppyyy2
      rpppyyz2 = rkp*pppyyz2
      rpppyzx2 = rkp*pppyzx2
      rpppyzy2 = rkp*pppyzy2
      rpppyzz2 = rkp*pppyzz2
      rpppzxx2 = rkp*pppzxx2
      rpppzxy2 = rkp*pppzxy2
      rpppzxz2 = rkp*pppzxz2
      rpppzyx2 = rkp*pppzyx2
      rpppzyy2 = rkp*pppzyy2
      rpppzyz2 = rkp*pppzyz2
      rpppzzx2 = rkp*pppzzx2
      rpppzzy2 = rkp*pppzzy2
      rpppzzz2 = rkp*pppzzz2

!dpds(1)
      axa1= qcx*axx1+wqx*axx2+2.d0*rpppxxx2+rdxxpx2+dpxxx12
      axb1= qcy*axy1+wqy*axy2                      +dpxxx12
      axc1= qcz*axz1+wqz*axz2                      +dpxxx12
      axd1= qcy*axx1+wqy*axx2                              
      axe1= qcz*axx1+wqz*axx2                              
      axf1= qcy*axz1+wqy*axz2                              
      aya1= qcx*ayx1+wqx*ayx2+2.d0*rpppxyx2        +dpxxy12
      ayb1= qcy*ayy1+wqy*ayy2              +rdxxpy2+dpxxy12
      ayc1= qcz*ayz1+wqz*ayz2                      +dpxxy12
      ayd1= qcy*ayx1+wqy*ayx2              +rdxxpx2        
      aye1= qcz*ayx1+wqz*ayx2                              
      ayf1= qcz*ayy1+wqz*ayy2                              
      aza1= qcx*azx1+wqx*azx2+2.d0*rpppxzx2        +dpxxz12
      azb1= qcy*azy1+wqy*azy2                      +dpxxz12
      azc1= qcz*azz1+wqz*azz2              +rdxxpz2+dpxxz12
      azd1= qcy*azx1+wqy*azx2                              
      aze1= qcz*azx1+wqz*azx2              +rdxxpx2        
      azf1= qcy*azz1+wqy*azz2
      bxa1= qcx*bxx1+wqx*bxx2              +rdyypx2+dpyyx12
      bxb1= qcy*bxy1+wqy*bxy2+2.d0*rpppyxy2        +dpyyx12
      bxc1= qcz*bxz1+wqz*bxz2                      +dpyyx12
      bxd1= qcx*bxy1+wqx*bxy2              +rdyypy2        
      bxe1= qcx*bxz1+wqx*bxz2              +rdyypz2        
      bxf1= qcz*bxy1+wqz*bxy2                              
      bya1= qcx*byx1+wqx*byx2                      +dpyyy12
      byb1= qcy*byy1+wqy*byy2+2.d0*rpppyyy2+rdyypy2+dpyyy12
      byc1= qcz*byz1+wqz*byz2                      +dpyyy12
      byd1= qcx*byy1+wqx*byy2                              
      bye1= qcx*byz1+wqx*byz2                              
      byf1= qcz*byy1+wqz*byy2                              
      bza1= qcx*bzx1+wqx*bzx2                      +dpyyz12
      bzb1= qcy*bzy1+wqy*bzy2+2.d0*rpppyzy2        +dpyyz12
      bzc1= qcz*bzz1+wqz*bzz2              +rdyypz2+dpyyz12
      bzd1= qcx*bzy1+wqx*bzy2                              
      bze1= qcx*bzz1+wqx*bzz2                              
      bzf1= qcz*bzy1+wqz*bzy2              +rdyypy2        
      cxa1= qcx*cxx1+wqx*cxx2              +rdzzpx2+dpzzx12
      cxb1= qcy*cxy1+wqy*cxy2                      +dpzzx12
      cxc1= qcz*cxz1+wqz*cxz2+2.d0*rpppzxz2        +dpzzx12
      cxd1= qcy*cxx1+wqy*cxx2                              
      cxe1= qcx*cxz1+wqx*cxz2              +rdzzpz2        
      cxf1= qcy*cxz1+wqy*cxz2                              
      cya1= qcx*cyx1+wqx*cyx2                      +dpzzy12
      cyb1= qcy*cyy1+wqy*cyy2              +rdzzpy2+dpzzy12
      cyc1= qcz*cyz1+wqz*cyz2+2.d0*rpppzyz2        +dpzzy12
      cyd1= qcx*cyy1+wqx*cyy2                              
      cye1= qcx*cyz1+wqx*cyz2                              
      cyf1= qcy*cyz1+wqy*cyz2              +rdzzpz2        
      cza1= qcx*czx1+wqx*czx2                      +dpzzz12
      czb1= qcy*czy1+wqy*czy2                      +dpzzz12
      czc1= qcz*czz1+wqz*czz2+2.d0*rpppzzz2+rdzzpz2+dpzzz12
      czd1= qcx*czy1+wqx*czy2                              
      cze1= qcx*czz1+wqx*czz2                              
      czf1= qcy*czz1+wqy*czz2                              
      dxa1= qcx*dxx1+wqx*dxx2+1.d0*rpppyxx2+rdyxpx2+dpyxx12
      dxb1= qcy*dxy1+wqy*dxy2+1.d0*rpppxxy2        +dpyxx12
      dxc1= qcz*dxz1+wqz*dxz2                      +dpyxx12
      dxd1= qcx*dxy1+wqx*dxy2+1.d0*rpppyxy2+rdyxpy2        
      dxe1= qcx*dxz1+wqx*dxz2+1.d0*rpppyxz2+rdyxpz2        
      dxf1= qcz*dxy1+wqz*dxy2                              
      dya1= qcx*dyx1+wqx*dyx2+1.d0*rpppyyx2        +dpyxy12
      dyb1= qcy*dyy1+wqy*dyy2+1.d0*rpppxyy2+rdyxpy2+dpyxy12
      dyc1= qcz*dyz1+wqz*dyz2                      +dpyxy12
      dyd1= qcx*dyy1+wqx*dyy2+1.d0*rpppyyy2                
      dye1= qcz*dyx1+wqz*dyx2                              
      dyf1= qcz*dyy1+wqz*dyy2                              
      dza1= qcx*dzx1+wqx*dzx2+1.d0*rpppyzx2        +dpyxz12
      dzb1= qcy*dzy1+wqy*dzy2+1.d0*rpppxzy2        +dpyxz12
      dzc1= qcz*dzz1+wqz*dzz2              +rdyxpz2+dpyxz12
      dzd1= qcx*dzy1+wqx*dzy2+1.d0*rpppyzy2               
      dze1= qcx*dzz1+wqx*dzz2+1.d0*rpppyzz2                
      dzf1= qcy*dzz1+wqy*dzz2+1.d0*rpppxzz2                
      exa1= qcx*exx1+wqx*exx2+1.d0*rpppzxx2+rdzxpx2+dpzxx12
      exb1= qcy*exy1+wqy*exy2                      +dpzxx12
      exc1= qcz*exz1+wqz*exz2+1.d0*rpppxxz2        +dpzxx12
      exd1= qcy*exx1+wqy*exx2                              
      exe1= qcz*exx1+wqz*exx2+1.d0*rpppxxx2                
      exf1= qcy*exz1+wqy*exz2                              
      eya1= qcx*eyx1+wqx*eyx2+1.d0*rpppzyx2        +dpzxy12
      eyb1= qcy*eyy1+wqy*eyy2              +rdzxpy2+dpzxy12
      eyc1= qcz*eyz1+wqz*eyz2+1.d0*rpppxyz2        +dpzxy12
      eyd1= qcx*eyy1+wqx*eyy2+1.d0*rpppzyy2                
      eye1= qcz*eyx1+wqz*eyx2+1.d0*rpppxyx2                
      eyf1= qcz*eyy1+wqz*eyy2+1.d0*rpppxyy2                
      eza1= qcx*ezx1+wqx*ezx2+1.d0*rpppzzx2        +dpzxz12
      ezb1= qcy*ezy1+wqy*ezy2                      +dpzxz12
      ezc1= qcz*ezz1+wqz*ezz2+1.d0*rpppxzz2+rdzxpz2+dpzxz12
      ezd1= qcy*ezx1+wqy*ezx2
      eze1= qcx*ezz1+wqx*ezz2+1.d0*rpppzzz2                
      ezf1= qcy*ezz1+wqy*ezz2                              
      fxa1= qcx*fxx1+wqx*fxx2              +rdzypx2+dpzyx12
      fxb1= qcy*fxy1+wqy*fxy2+1.d0*rpppzxy2        +dpzyx12
      fxc1= qcz*fxz1+wqz*fxz2+1.d0*rpppyxz2        +dpzyx12
      fxd1= qcy*fxx1+wqy*fxx2+1.d0*rpppzxx2                
      fxe1= qcz*fxx1+wqz*fxx2+1.d0*rpppyxx2                
      fxf1= qcz*fxy1+wqz*fxy2+1.d0*rpppyxy2                
      fya1= qcx*fyx1+wqx*fyx2                      +dpzyy12
      fyb1= qcy*fyy1+wqy*fyy2+1.d0*rpppzyy2+rdzypy2+dpzyy12
      fyc1= qcz*fyz1+wqz*fyz2+1.d0*rpppyyz2        +dpzyy12
      fyd1= qcx*fyy1+wqx*fyy2                              
      fye1= qcx*fyz1+wqx*fyz2                              
      fyf1= qcz*fyy1+wqz*fyy2+1.d0*rpppyyy2                
      fza1= qcx*fzx1+wqx*fzx2                      +dpzyz12
      fzb1= qcy*fzy1+wqy*fzy2+1.d0*rpppzzy2        +dpzyz12
      fzc1= qcz*fzz1+wqz*fzz2+1.d0*rpppyzz2+rdzypz2+dpzyz12
      fzd1= qcx*fzy1+wqx*fzy2                      
      fze1= qcx*fzz1+wqx*fzz2                      
      fzf1= qcy*fzz1+wqy*fzz2+1.d0*rpppzzz2        
 
!pdss01(12) 
      pdxxx12 = eta*(pdxxx1 - rooe*pdxxx2)
      pdxyy12 = eta*(pdxyy1 - rooe*pdxyy2)
      pdxzz12 = eta*(pdxzz1 - rooe*pdxzz2)
      pdxyx12 = eta*(pdxyx1 - rooe*pdxyx2)
      pdxzx12 = eta*(pdxzx1 - rooe*pdxzx2)
      pdxzy12 = eta*(pdxzy1 - rooe*pdxzy2)
      pdyxx12 = eta*(pdyxx1 - rooe*pdyxx2)
      pdyyy12 = eta*(pdyyy1 - rooe*pdyyy2)
      pdyzz12 = eta*(pdyzz1 - rooe*pdyzz2)
      pdyyx12 = eta*(pdyyx1 - rooe*pdyyx2)
      pdyzx12 = eta*(pdyzx1 - rooe*pdyzx2)
      pdyzy12 = eta*(pdyzy1 - rooe*pdyzy2)
      pdzxx12 = eta*(pdzxx1 - rooe*pdzxx2)
      pdzyy12 = eta*(pdzyy1 - rooe*pdzyy2)
      pdzzz12 = eta*(pdzzz1 - rooe*pdzzz2)
      pdzyx12 = eta*(pdzyx1 - rooe*pdzyx2)
      pdzzx12 = eta*(pdzzx1 - rooe*pdzzx2)
      pdzzy12 = eta*(pdzzy1 - rooe*pdzzy2)
 
!rsdps (2)
      rxxdpx2 = rkp*xxdpx2
      rxxdpy2 = rkp*xxdpy2
      rxxdpz2 = rkp*xxdpz2
      ryydpx2 = rkp*yydpx2
      ryydpy2 = rkp*yydpy2
      ryydpz2 = rkp*yydpz2
      rzzdpx2 = rkp*zzdpx2
      rzzdpy2 = rkp*zzdpy2
      rzzdpz2 = rkp*zzdpz2
      ryxdpx2 = rkp*yxdpx2
      ryxdpy2 = rkp*yxdpy2
      ryxdpz2 = rkp*yxdpz2
      rzxdpx2 = rkp*zxdpx2
      rzxdpy2 = rkp*zxdpy2
      rzxdpz2 = rkp*zxdpz2
      rzydpx2 = rkp*zydpx2
      rzydpy2 = rkp*zydpy2
      rzydpz2 = rkp*zydpz2
 
! pdds(1) 
      xdxxdxx1=qcx*pxdxxpx1+wqx*pxdxxpx2+rxxdpx2+2.d0*rpppxxx2+pdxxx12
      xdxxdyy1=qcy*pxdxxpy1+wqy*pxdxxpy2                      +pdxxx12
      xdxxdzz1=qcz*pxdxxpz1+wqz*pxdxxpz2                      +pdxxx12
      xdxxdyx1=qcy*pxdxxpx1+wqy*pxdxxpx2
      xdxxdzx1=qcz*pxdxxpx1+wqz*pxdxxpx2
      xdxxdzy1=qcy*pxdxxpz1+wqy*pxdxxpz2
      xdyydxx1=qcx*pxdyypx1+wqx*pxdyypx2+ryydpx2              +pdxyy12
      xdyydyy1=qcy*pxdyypy1+wqy*pxdyypy2        +2.d0*rpppxyy2+pdxyy12
      xdyydzz1=qcz*pxdyypz1+wqz*pxdyypz2                      +pdxyy12
      xdyydyx1=qcx*pxdyypy1+wqx*pxdyypy2+ryydpy2
      xdyydzx1=qcz*pxdyypx1+wqz*pxdyypx2
      xdyydzy1=qcz*pxdyypy1+wqz*pxdyypy2
      xdzzdxx1=qcx*pxdzzpx1+wqx*pxdzzpx2+rzzdpx2              +pdxzz12
      xdzzdyy1=qcy*pxdzzpy1+wqy*pxdzzpy2                      +pdxzz12
      xdzzdzz1=qcz*pxdzzpz1+wqz*pxdzzpz2        +2.d0*rpppxzz2+pdxzz12
      xdzzdyx1=qcy*pxdzzpx1+wqy*pxdzzpx2                              
      xdzzdzx1=qcx*pxdzzpz1+wqx*pxdzzpz2+rzzdpz2                      
      xdzzdzy1=qcy*pxdzzpz1+wqy*pxdzzpz2                              
      xdyxdxx1=qcx*pxdyxpx1+wqx*pxdyxpx2+ryxdpx2+1.d0*rpppxyx2+pdxyx12
      xdyxdyy1=qcy*pxdyxpy1+wqy*pxdyxpy2        +1.d0*rpppxxy2+pdxyx12
      xdyxdzz1=qcz*pxdyxpz1+wqz*pxdyxpz2                      +pdxyx12
      xdyxdyx1=qcy*pxdyxpx1+wqy*pxdyxpx2        +1.d0*rpppxxx2
      xdyxdzx1=qcz*pxdyxpx1+wqz*pxdyxpx2
      xdyxdzy1=qcz*pxdyxpy1+wqz*pxdyxpy2
      xdzxdxx1=qcx*pxdzxpx1+wqx*pxdzxpx2+rzxdpx2+1.d0*rpppxzx2+pdxzx12
      xdzxdyy1=qcy*pxdzxpy1+wqy*pxdzxpy2                      +pdxzx12
      xdzxdzz1=qcz*pxdzxpz1+wqz*pxdzxpz2        +1.d0*rpppxxz2+pdxzx12
      xdzxdyx1=qcy*pxdzxpx1+wqy*pxdzxpx2                              
      xdzxdzx1=qcz*pxdzxpx1+wqz*pxdzxpx2        +1.d0*rpppxxx2        
      xdzxdzy1=qcy*pxdzxpz1+wqy*pxdzxpz2                              
      xdzydxx1=qcx*pxdzypx1+wqx*pxdzypx2+rzydpx2              +pdxzy12
      xdzydyy1=qcy*pxdzypy1+wqy*pxdzypy2        +1.d0*rpppxzy2+pdxzy12
      xdzydzz1=qcz*pxdzypz1+wqz*pxdzypz2        +1.d0*rpppxyz2+pdxzy12
      xdzydyx1=qcx*pxdzypy1+wqx*pxdzypy2+rzydpy2                      
      xdzydzx1=qcx*pxdzypz1+wqx*pxdzypz2+rzydpz2                      
      xdzydzy1=qcy*pxdzypz1+wqy*pxdzypz2        +1.d0*rpppxzz2        
      ydxxdxx1=qcx*pydxxpx1+wqx*pydxxpx2        +2.d0*rpppyxx2+pdyxx12
      ydxxdyy1=qcy*pydxxpy1+wqy*pydxxpy2+rxxdpy2              +pdyxx12
      ydxxdzz1=qcz*pydxxpz1+wqz*pydxxpz2                      +pdyxx12
      ydxxdyx1=qcy*pydxxpx1+wqy*pydxxpx2+rxxdpx2      
      ydxxdzx1=qcz*pydxxpx1+wqz*pydxxpx2              
      ydxxdzy1=qcz*pydxxpy1+wqz*pydxxpy2              
      ydyydxx1=qcx*pydyypx1+wqx*pydyypx2                      +pdyyy12
      ydyydyy1=qcy*pydyypy1+wqy*pydyypy2+ryydpy2+2.d0*rpppyyy2+pdyyy12
      ydyydzz1=qcz*pydyypz1+wqz*pydyypz2                      +pdyyy12
      ydyydyx1=qcx*pydyypy1+wqx*pydyypy2
      ydyydzx1=qcx*pydyypz1+wqx*pydyypz2
      ydyydzy1=qcz*pydyypy1+wqz*pydyypy2
      ydzzdxx1=qcx*pydzzpx1+wqx*pydzzpx2                      +pdyzz12
      ydzzdyy1=qcy*pydzzpy1+wqy*pydzzpy2+rzzdpy2              +pdyzz12
      ydzzdzz1=qcz*pydzzpz1+wqz*pydzzpz2        +2.d0*rpppyzz2+pdyzz12
      ydzzdyx1=qcx*pydzzpy1+wqx*pydzzpy2       
      ydzzdzx1=qcx*pydzzpz1+wqx*pydzzpz2       
      ydzzdzy1=qcy*pydzzpz1+wqy*pydzzpz2+rzzdpz2
      ydyxdxx1=qcx*pydyxpx1+wqx*pydyxpx2        +1.d0*rpppyyx2+pdyyx12
      ydyxdyy1=qcy*pydyxpy1+wqy*pydyxpy2+ryxdpy2+1.d0*rpppyxy2+pdyyx12
      ydyxdzz1=qcz*pydyxpz1+wqz*pydyxpz2                      +pdyyx12
      ydyxdyx1=qcx*pydyxpy1+wqx*pydyxpy2        +1.d0*rpppyyy2
      ydyxdzx1=qcz*pydyxpx1+wqz*pydyxpx2
      ydyxdzy1=qcz*pydyxpy1+wqz*pydyxpy2
      ydzxdxx1=qcx*pydzxpx1+wqx*pydzxpx2        +1.d0*rpppyzx2+pdyzx12
      ydzxdyy1=qcy*pydzxpy1+wqy*pydzxpy2+rzxdpy2              +pdyzx12
      ydzxdzz1=qcz*pydzxpz1+wqz*pydzxpz2        +1.d0*rpppyxz2+pdyzx12
      ydzxdyx1=qcy*pydzxpx1+wqy*pydzxpx2+rzxdpx2              
      ydzxdzx1=qcx*pydzxpz1+wqx*pydzxpz2        +1.d0*rpppyzz2
      ydzxdzy1=qcy*pydzxpz1+wqy*pydzxpz2+rzxdpz2              
      ydzydxx1=qcx*pydzypx1+wqx*pydzypx2                      +pdyzy12
      ydzydyy1=qcy*pydzypy1+wqy*pydzypy2+rzydpy2+1.d0*rpppyzy2+pdyzy12
      ydzydzz1=qcz*pydzypz1+wqz*pydzypz2        +1.d0*rpppyyz2+pdyzy12
      ydzydyx1=qcx*pydzypy1+wqx*pydzypy2
      ydzydzx1=qcx*pydzypz1+wqx*pydzypz2
      ydzydzy1=qcz*pydzypy1+wqz*pydzypy2        +1.d0*rpppyyy2
      zdxxdxx1=qcx*pzdxxpx1+wqx*pzdxxpx2        +2.d0*rpppzxx2+pdzxx12
      zdxxdyy1=qcy*pzdxxpy1+wqy*pzdxxpy2                      +pdzxx12
      zdxxdzz1=qcz*pzdxxpz1+wqz*pzdxxpz2+rxxdpz2              +pdzxx12
      zdxxdyx1=qcy*pzdxxpx1+wqy*pzdxxpx2                      
      zdxxdzx1=qcz*pzdxxpx1+wqz*pzdxxpx2+rxxdpx2              
      zdxxdzy1=qcy*pzdxxpz1+wqy*pzdxxpz2                      
      zdyydxx1=qcx*pzdyypx1+wqx*pzdyypx2                      +pdzyy12
      zdyydyy1=qcy*pzdyypy1+wqy*pzdyypy2        +2.d0*rpppzyy2+pdzyy12
      zdyydzz1=qcz*pzdyypz1+wqz*pzdyypz2+ryydpz2              +pdzyy12
      zdyydyx1=qcx*pzdyypy1+wqx*pzdyypy2        
      zdyydzx1=qcx*pzdyypz1+wqx*pzdyypz2        
      zdyydzy1=qcz*pzdyypy1+wqz*pzdyypy2+ryydpy2
      zdzzdxx1=qcx*pzdzzpx1+wqx*pzdzzpx2                      +pdzzz12
      zdzzdyy1=qcy*pzdzzpy1+wqy*pzdzzpy2                      +pdzzz12
      zdzzdzz1=qcz*pzdzzpz1+wqz*pzdzzpz2+rzzdpz2+2.d0*rpppzzz2+pdzzz12
      zdzzdyx1=qcx*pzdzzpy1+wqx*pzdzzpy2
      zdzzdzx1=qcx*pzdzzpz1+wqx*pzdzzpz2
      zdzzdzy1=qcy*pzdzzpz1+wqy*pzdzzpz2
      zdyxdxx1=qcx*pzdyxpx1+wqx*pzdyxpx2        +1.d0*rpppzyx2+pdzyx12
      zdyxdyy1=qcy*pzdyxpy1+wqy*pzdyxpy2        +1.d0*rpppzxy2+pdzyx12
      zdyxdzz1=qcz*pzdyxpz1+wqz*pzdyxpz2+ryxdpz2              +pdzyx12
      zdyxdyx1=qcx*pzdyxpy1+wqx*pzdyxpy2        +1.d0*rpppzyy2
      zdyxdzx1=qcz*pzdyxpx1+wqz*pzdyxpx2+ryxdpx2
      zdyxdzy1=qcz*pzdyxpy1+wqz*pzdyxpy2+ryxdpy2
      zdzxdxx1=qcx*pzdzxpx1+wqx*pzdzxpx2        +1.d0*rpppzzx2+pdzzx12
      zdzxdyy1=qcy*pzdzxpy1+wqy*pzdzxpy2                      +pdzzx12
      zdzxdzz1=qcz*pzdzxpz1+wqz*pzdzxpz2+rzxdpz2+1.d0*rpppzxz2+pdzzx12
      zdzxdyx1=qcy*pzdzxpx1+wqy*pzdzxpx2                      
      zdzxdzx1=qcx*pzdzxpz1+wqx*pzdzxpz2        +1.d0*rpppzzz2
      zdzxdzy1=qcy*pzdzxpz1+wqy*pzdzxpz2                      
      zdzydxx1=qcx*pzdzypx1+wqx*pzdzypx2                      +pdzzy12
      zdzydyy1=qcy*pzdzypy1+wqy*pzdzypy2        +1.d0*rpppzzy2+pdzzy12
      zdzydzz1=qcz*pzdzypz1+wqz*pzdzypz2+rzydpz2+1.d0*rpppzyz2+pdzzy12
      zdzydyx1=qcx*pzdzypy1+wqx*pzdzypy2                      
      zdzydzx1=qcx*pzdzypz1+wqx*pzdzypz2                      
      zdzydzy1=qcy*pzdzypz1+wqy*pzdzypz2        +1.d0*rpppzzz2
  
!RANK=6
!rpdps(1-2)    
      xax1= rkp * pxdxxpx1
      xay1= rkp * pxdxxpy1
      xaz1= rkp * pxdxxpz1
      xbx1= rkp * pxdyypx1
      xby1= rkp * pxdyypy1
      xbz1= rkp * pxdyypz1
      xcx1= rkp * pxdzzpx1
      xcy1= rkp * pxdzzpy1
      xcz1= rkp * pxdzzpz1
      xdx1= rkp * pxdyxpx1
      xdy1= rkp * pxdyxpy1
      xdz1= rkp * pxdyxpz1
      xex1= rkp * pxdzxpx1
      xey1= rkp * pxdzxpy1
      xez1= rkp * pxdzxpz1
      xfx1= rkp * pxdzypx1
      xfy1= rkp * pxdzypy1
      xfz1= rkp * pxdzypz1
      yax1= rkp * pydxxpx1
      yay1= rkp * pydxxpy1
      yaz1= rkp * pydxxpz1
      ybx1= rkp * pydyypx1
      yby1= rkp * pydyypy1
      ybz1= rkp * pydyypz1
      ycx1= rkp * pydzzpx1
      ycy1= rkp * pydzzpy1
      ycz1= rkp * pydzzpz1
      ydx1= rkp * pydyxpx1
      ydy1= rkp * pydyxpy1
      ydz1= rkp * pydyxpz1
      yex1= rkp * pydzxpx1
      yey1= rkp * pydzxpy1
      yez1= rkp * pydzxpz1
      yfx1= rkp * pydzypx1
      yfy1= rkp * pydzypy1
      yfz1= rkp * pydzypz1
      zax1= rkp * pzdxxpx1
      zay1= rkp * pzdxxpy1
      zaz1= rkp * pzdxxpz1
      zbx1= rkp * pzdyypx1
      zby1= rkp * pzdyypy1
      zbz1= rkp * pzdyypz1
      zcx1= rkp * pzdzzpx1
      zcy1= rkp * pzdzzpy1
      zcz1= rkp * pzdzzpz1
      zdx1= rkp * pzdyxpx1
      zdy1= rkp * pzdyxpy1
      zdz1= rkp * pzdyxpz1
      zex1= rkp * pzdzxpx1
      zey1= rkp * pzdzxpy1
      zez1= rkp * pzdzxpz1
      zfx1= rkp * pzdzypx1
      zfy1= rkp * pzdzypy1
      zfz1= rkp * pzdzypz1
      xax2= rkp * pxdxxpx2
      xay2= rkp * pxdxxpy2
      xaz2= rkp * pxdxxpz2
      xbx2= rkp * pxdyypx2
      xby2= rkp * pxdyypy2
      xbz2= rkp * pxdyypz2
      xcx2= rkp * pxdzzpx2
      xcy2= rkp * pxdzzpy2
      xcz2= rkp * pxdzzpz2
      xdx2= rkp * pxdyxpx2
      xdy2= rkp * pxdyxpy2
      xdz2= rkp * pxdyxpz2
      xex2= rkp * pxdzxpx2
      xey2= rkp * pxdzxpy2
      xez2= rkp * pxdzxpz2
      xfx2= rkp * pxdzypx2
      xfy2= rkp * pxdzypy2
      xfz2= rkp * pxdzypz2
      yax2= rkp * pydxxpx2
      yay2= rkp * pydxxpy2
      yaz2= rkp * pydxxpz2
      ybx2= rkp * pydyypx2
      yby2= rkp * pydyypy2
      ybz2= rkp * pydyypz2
      ycx2= rkp * pydzzpx2
      ycy2= rkp * pydzzpy2
      ycz2= rkp * pydzzpz2
      ydx2= rkp * pydyxpx2
      ydy2= rkp * pydyxpy2
      ydz2= rkp * pydyxpz2
      yex2= rkp * pydzxpx2
      yey2= rkp * pydzxpy2
      yez2= rkp * pydzxpz2
      yfx2= rkp * pydzypx2
      yfy2= rkp * pydzypy2
      yfz2= rkp * pydzypz2
      zax2= rkp * pzdxxpx2
      zay2= rkp * pzdxxpy2
      zaz2= rkp * pzdxxpz2
      zbx2= rkp * pzdyypx2
      zby2= rkp * pzdyypy2
      zbz2= rkp * pzdyypz2
      zcx2= rkp * pzdzzpx2
      zcy2= rkp * pzdzzpy2
      zcz2= rkp * pzdzzpz2
      zdx2= rkp * pzdyxpx2
      zdy2= rkp * pzdyxpy2
      zdz2= rkp * pzdyxpz2
      zex2= rkp * pzdzxpx2
      zey2= rkp * pzdzxpy2
      zez2= rkp * pzdzxpz2
      zfx2= rkp * pzdzypx2
      zfy2= rkp * pzdzypy2
      zfz2= rkp * pzdzypz2
!rdpps(1-2)
      raxx1= rkp *axx1
      raxy1= rkp *axy1
      raxz1= rkp *axz1
      rayx1= rkp *ayx1
      rayy1= rkp *ayy1
      rayz1= rkp *ayz1
      razx1= rkp *azx1
      razy1= rkp *azy1
      razz1= rkp *azz1
      rbxx1= rkp *bxx1
      rbxy1= rkp *bxy1
      rbxz1= rkp *bxz1
      rbyx1= rkp *byx1
      rbyy1= rkp *byy1
      rbyz1= rkp *byz1
      rbzx1= rkp *bzx1
      rbzy1= rkp *bzy1
      rbzz1= rkp *bzz1
      rcxx1= rkp *cxx1
      rcxy1= rkp *cxy1
      rcxz1= rkp *cxz1
      rcyx1= rkp *cyx1
      rcyy1= rkp *cyy1
      rcyz1= rkp *cyz1
      rczx1= rkp *czx1
      rczy1= rkp *czy1
      rczz1= rkp *czz1
      rdxx1= rkp *dxx1
      rdxy1= rkp *dxy1
      rdxz1= rkp *dxz1
      rdyx1= rkp *dyx1
      rdyy1= rkp *dyy1
      rdyz1= rkp *dyz1
      rdzx1= rkp *dzx1
      rdzy1= rkp *dzy1
      rdzz1= rkp *dzz1
      rexx1= rkp *exx1
      rexy1= rkp *exy1
      rexz1= rkp *exz1
      reyx1= rkp *eyx1
      reyy1= rkp *eyy1
      reyz1= rkp *eyz1
      rezx1= rkp *ezx1
      rezy1= rkp *ezy1
      rezz1= rkp *ezz1
      rfxx1= rkp *fxx1
      rfxy1= rkp *fxy1
      rfxz1= rkp *fxz1
      rfyx1= rkp *fyx1
      rfyy1= rkp *fyy1
      rfyz1= rkp *fyz1
      rfzx1= rkp *fzx1
      rfzy1= rkp *fzy1
      rfzz1= rkp *fzz1
      raxx2= rkp *axx2
      raxy2= rkp *axy2
      raxz2= rkp *axz2
      rayx2= rkp *ayx2
      rayy2= rkp *ayy2
      rayz2= rkp *ayz2
      razx2= rkp *azx2
      razy2= rkp *azy2
      razz2= rkp *azz2
      rbxx2= rkp *bxx2
      rbxy2= rkp *bxy2
      rbxz2= rkp *bxz2
      rbyx2= rkp *byx2
      rbyy2= rkp *byy2
      rbyz2= rkp *byz2
      rbzx2= rkp *bzx2
      rbzy2= rkp *bzy2
      rbzz2= rkp *bzz2
      rcxx2= rkp *cxx2
      rcxy2= rkp *cxy2
      rcxz2= rkp *cxz2
      rcyx2= rkp *cyx2
      rcyy2= rkp *cyy2
      rcyz2= rkp *cyz2
      rczx2= rkp *czx2
      rczy2= rkp *czy2
      rczz2= rkp *czz2
      rdxx2= rkp *dxx2
      rdxy2= rkp *dxy2
      rdxz2= rkp *dxz2
      rdyx2= rkp *dyx2
      rdyy2= rkp *dyy2
      rdyz2= rkp *dyz2
      rdzx2= rkp *dzx2
      rdzy2= rkp *dzy2
      rdzz2= rkp *dzz2
      rexx2= rkp *exx2
      rexy2= rkp *exy2
      rexz2= rkp *exz2
      reyx2= rkp *eyx2
      reyy2= rkp *eyy2
      reyz2= rkp *eyz2
      rezx2= rkp *ezx2
      rezy2= rkp *ezy2
      rezz2= rkp *ezz2
      rfxx2= rkp *fxx2
      rfxy2= rkp *fxy2
      rfxz2= rkp *fxz2
      rfyx2= rkp *fyx2
      rfyy2= rkp *fyy2
      rfyz2= rkp *fyz2
      rfzx2= rkp *fzx2
      rfzy2= rkp *fzy2
      rfzz2= rkp *fzz2
!ddss01(01-12)
      aa0 = eta*(ddxxxx0 - rooe*ddxxxx1)
      ab0 = eta*(ddxxyy0 - rooe*ddxxyy1)
      ac0 = eta*(ddxxzz0 - rooe*ddxxzz1)
      ad0 = eta*(ddxxyx0 - rooe*ddxxyx1)
      ae0 = eta*(ddxxzx0 - rooe*ddxxzx1)
      af0 = eta*(ddxxzy0 - rooe*ddxxzy1)
      ba0 = eta*(ddyyxx0 - rooe*ddyyxx1)
      bb0 = eta*(ddyyyy0 - rooe*ddyyyy1)
      bc0 = eta*(ddyyzz0 - rooe*ddyyzz1)
      bd0 = eta*(ddyyyx0 - rooe*ddyyyx1)
      be0 = eta*(ddyyzx0 - rooe*ddyyzx1)
      bf0 = eta*(ddyyzy0 - rooe*ddyyzy1)
      ca0 = eta*(ddzzxx0 - rooe*ddzzxx1)
      cb0 = eta*(ddzzyy0 - rooe*ddzzyy1)
      cc0 = eta*(ddzzzz0 - rooe*ddzzzz1)
      cd0 = eta*(ddzzyx0 - rooe*ddzzyx1)
      ce0 = eta*(ddzzzx0 - rooe*ddzzzx1)
      cf0 = eta*(ddzzzy0 - rooe*ddzzzy1)
      da0 = eta*(ddyxxx0 - rooe*ddyxxx1)
      db0 = eta*(ddyxyy0 - rooe*ddyxyy1)
      dc0 = eta*(ddyxzz0 - rooe*ddyxzz1)
      dd0 = eta*(ddyxyx0 - rooe*ddyxyx1)
      de0 = eta*(ddyxzx0 - rooe*ddyxzx1)
      df0 = eta*(ddyxzy0 - rooe*ddyxzy1)
      ea0 = eta*(ddzxxx0 - rooe*ddzxxx1)
      eb0 = eta*(ddzxyy0 - rooe*ddzxyy1)
      ec0 = eta*(ddzxzz0 - rooe*ddzxzz1)
      ed0 = eta*(ddzxyx0 - rooe*ddzxyx1)
      ee0 = eta*(ddzxzx0 - rooe*ddzxzx1)
      ef0 = eta*(ddzxzy0 - rooe*ddzxzy1)
      fa0 = eta*(ddzyxx0 - rooe*ddzyxx1)
      fb0 = eta*(ddzyyy0 - rooe*ddzyyy1)
      fc0 = eta*(ddzyzz0 - rooe*ddzyzz1)
      fd0 = eta*(ddzyyx0 - rooe*ddzyyx1)
      fe0 = eta*(ddzyzx0 - rooe*ddzyzx1)
      ff0 = eta*(ddzyzy0 - rooe*ddzyzy1)

      aa1 = eta*(ddxxxx1 - rooe*ddxxxx2)
      ab1 = eta*(ddxxyy1 - rooe*ddxxyy2)
      ac1 = eta*(ddxxzz1 - rooe*ddxxzz2)
      ad1 = eta*(ddxxyx1 - rooe*ddxxyx2)
      ae1 = eta*(ddxxzx1 - rooe*ddxxzx2)
      af1 = eta*(ddxxzy1 - rooe*ddxxzy2)
      ba1 = eta*(ddyyxx1 - rooe*ddyyxx2)
      bb1 = eta*(ddyyyy1 - rooe*ddyyyy2)
      bc1 = eta*(ddyyzz1 - rooe*ddyyzz2)
      bd1 = eta*(ddyyyx1 - rooe*ddyyyx2)
      be1 = eta*(ddyyzx1 - rooe*ddyyzx2)
      bf1 = eta*(ddyyzy1 - rooe*ddyyzy2)
      ca1 = eta*(ddzzxx1 - rooe*ddzzxx2)
      cb1 = eta*(ddzzyy1 - rooe*ddzzyy2)
      cc1 = eta*(ddzzzz1 - rooe*ddzzzz2)
      cd1 = eta*(ddzzyx1 - rooe*ddzzyx2)
      ce1 = eta*(ddzzzx1 - rooe*ddzzzx2)
      cf1 = eta*(ddzzzy1 - rooe*ddzzzy2)
      da1 = eta*(ddyxxx1 - rooe*ddyxxx2)
      db1 = eta*(ddyxyy1 - rooe*ddyxyy2)
      dc1 = eta*(ddyxzz1 - rooe*ddyxzz2)
      dd1 = eta*(ddyxyx1 - rooe*ddyxyx2)
      de1 = eta*(ddyxzx1 - rooe*ddyxzx2)
      df1 = eta*(ddyxzy1 - rooe*ddyxzy2)
      ea1 = eta*(ddzxxx1 - rooe*ddzxxx2)
      eb1 = eta*(ddzxyy1 - rooe*ddzxyy2)
      ec1 = eta*(ddzxzz1 - rooe*ddzxzz2)
      ed1 = eta*(ddzxyx1 - rooe*ddzxyx2)
      ee1 = eta*(ddzxzx1 - rooe*ddzxzx2)
      ef1 = eta*(ddzxzy1 - rooe*ddzxzy2)
      fa1 = eta*(ddzyxx1 - rooe*ddzyxx2)
      fb1 = eta*(ddzyyy1 - rooe*ddzyyy2)
      fc1 = eta*(ddzyzz1 - rooe*ddzyzz2)
      fd1 = eta*(ddzyyx1 - rooe*ddzyyx2)
      fe1 = eta*(ddzyzx1 - rooe*ddzyzx2)
      ff1 = eta*(ddzyzy1 - rooe*ddzyzy2)

!ddds(0-1)
      aaa0=qcx*dxxdxxpx0+wqx*dxxdxxpx1+2.d0*xax1+2.d0*raxx1+aa0
      aab0=qcy*dxxdxxpy0+wqy*dxxdxxpy1                     +aa0
      aac0=qcz*dxxdxxpz0+wqz*dxxdxxpz1                     +aa0
      aad0=qcy*dxxdxxpx0+wqy*dxxdxxpx1
      aae0=qcz*dxxdxxpx0+wqz*dxxdxxpx1
      aaf0=qcy*dxxdxxpz0+wqy*dxxdxxpz1
      aba0=qcx*dxxdyypx0+wqx*dxxdyypx1+2.d0*xbx1           +ab0
      abb0=qcy*dxxdyypy0+wqy*dxxdyypy1          +2.d0*rayy1+ab0
      abc0=qcz*dxxdyypz0+wqz*dxxdyypz1                     +ab0
      abd0=qcx*dxxdyypy0+wqx*dxxdyypy1+2.d0*xby1
      abe0=qcz*dxxdyypx0+wqz*dxxdyypx1
      abf0=qcz*dxxdyypy0+wqz*dxxdyypy1
      aca0=qcx*dxxdzzpx0+wqx*dxxdzzpx1+2.d0*xcx1           +ac0
      acb0=qcy*dxxdzzpy0+wqy*dxxdzzpy1                     +ac0
      acc0=qcz*dxxdzzpz0+wqz*dxxdzzpz1          +2.d0*razz1+ac0
      acd0=qcy*dxxdzzpx0+wqy*dxxdzzpx1
      ace0=qcx*dxxdzzpz0+wqx*dxxdzzpz1+2.d0*xcz1
      acf0=qcy*dxxdzzpz0+wqy*dxxdzzpz1
      ada0=qcx*dxxdyxpx0+wqx*dxxdyxpx1+2.d0*xdx1+     rayx1+ad0
      adb0=qcy*dxxdyxpy0+wqy*dxxdyxpy1          +     raxy1+ad0
      adc0=qcz*dxxdyxpz0+wqz*dxxdyxpz1                     +ad0
      add0=qcy*dxxdyxpx0+wqy*dxxdyxpx1          +     raxx1
      ade0=qcz*dxxdyxpx0+wqz*dxxdyxpx1
      adf0=qcz*dxxdyxpy0+wqz*dxxdyxpy1
      aea0=qcx*dxxdzxpx0+wqx*dxxdzxpx1+2.d0*xex1+     razx1+ae0
      aeb0=qcy*dxxdzxpy0+wqy*dxxdzxpy1                     +ae0
      aec0=qcz*dxxdzxpz0+wqz*dxxdzxpz1          +     raxz1+ae0
      aed0=qcy*dxxdzxpx0+wqy*dxxdzxpx1        
      aee0=qcz*dxxdzxpx0+wqz*dxxdzxpx1          +      raxx1
      aef0=qcy*dxxdzxpz0+wqy*dxxdzxpz1
      afa0=qcx*dxxdzypx0+wqx*dxxdzypx1+2.d0*xfx1           +af0
      afb0=qcy*dxxdzypy0+wqy*dxxdzypy1          +     razy1+af0
      afc0=qcz*dxxdzypz0+wqz*dxxdzypz1          +     rayz1+af0
      afd0=qcy*dxxdzypx0+wqy*dxxdzypx1          +     razx1
      afe0=qcz*dxxdzypx0+wqz*dxxdzypx1          +     rayx1
      aff0=qcy*dxxdzypz0+wqy*dxxdzypz1          +     razz1
      baa0=qcx*dyydxxpx0+wqx*dyydxxpx1          +2.d0*rbxx1+ba0
      bab0=qcy*dyydxxpy0+wqy*dyydxxpy1+2.d0*yay1           +ba0
      bac0=qcz*dyydxxpz0+wqz*dyydxxpz1                     +ba0
      bad0=qcx*dyydxxpy0+wqx*dyydxxpy1          +2.d0*rbxy1
      bae0=qcz*dyydxxpx0+wqz*dyydxxpx1
      baf0=qcz*dyydxxpy0+wqz*dyydxxpy1
      bba0=qcx*dyydyypx0+wqx*dyydyypx1                     +bb0
      bbb0=qcy*dyydyypy0+wqy*dyydyypy1+2.d0*yby1+2.d0*rbyy1+bb0
      bbc0=qcz*dyydyypz0+wqz*dyydyypz1                     +bb0
      bbd0=qcx*dyydyypy0+wqx*dyydyypy1               
      bbe0=qcx*dyydyypz0+wqx*dyydyypz1               
      bbf0=qcz*dyydyypy0+wqz*dyydyypy1               
      bca0=qcx*dyydzzpx0+wqx*dyydzzpx1                     +bc0
      bcb0=qcy*dyydzzpy0+wqy*dyydzzpy1+2.d0*ycy1           +bc0
      bcc0=qcz*dyydzzpz0+wqz*dyydzzpz1          +2.d0*rbzz1+bc0
      bcd0=qcx*dyydzzpy0+wqx*dyydzzpy1                   
      bce0=qcx*dyydzzpz0+wqx*dyydzzpz1                   
      bcf0=qcy*dyydzzpz0+wqy*dyydzzpz1+2.d0*ycz1             
      bda0=qcx*dyydyxpx0+wqx*dyydyxpx1          +     rbyx1+bd0
      bdb0=qcy*dyydyxpy0+wqy*dyydyxpy1+2.d0*ydy1+     rbxy1+bd0
      bdc0=qcz*dyydyxpz0+wqz*dyydyxpz1                     +bd0
      bdd0=qcx*dyydyxpy0+wqx*dyydyxpy1          +     rbyy1
      bde0=qcz*dyydyxpx0+wqz*dyydyxpx1                   
      bdf0=qcz*dyydyxpy0+wqz*dyydyxpy1                   
      bea0=qcx*dyydzxpx0+wqx*dyydzxpx1          +     rbzx1+be0
      beb0=qcy*dyydzxpy0+wqy*dyydzxpy1+2.d0*yey1           +be0
      bec0=qcz*dyydzxpz0+wqz*dyydzxpz1          +     rbxz1+be0
      bed0=qcx*dyydzxpy0+wqx*dyydzxpy1          +     rbzy1
      bee0=qcx*dyydzxpz0+wqx*dyydzxpz1          +     rbzz1
      bef0=qcz*dyydzxpy0+wqz*dyydzxpy1          +     rbxy1
      bfa0=qcx*dyydzypx0+wqx*dyydzypx1                     +bf0
      bfb0=qcy*dyydzypy0+wqy*dyydzypy1+2.d0*yfy1+     rbzy1+bf0
      bfc0=qcz*dyydzypz0+wqz*dyydzypz1          +     rbyz1+bf0
      bfd0=qcx*dyydzypy0+wqx*dyydzypy1                   
      bfe0=qcx*dyydzypz0+wqx*dyydzypz1                   
      bff0=qcz*dyydzypy0+wqz*dyydzypy1          +     rbyy1
      caa0=qcx*dzzdxxpx0+wqx*dzzdxxpx1          +2.d0*rcxx1+ca0
      cab0=qcy*dzzdxxpy0+wqy*dzzdxxpy1                     +ca0
      cac0=qcz*dzzdxxpz0+wqz*dzzdxxpz1+2.d0*zaz1           +ca0
      cad0=qcy*dzzdxxpx0+wqy*dzzdxxpx1                   
      cae0=qcx*dzzdxxpz0+wqx*dzzdxxpz1          +2.d0*rcxz1
      caf0=qcy*dzzdxxpz0+wqy*dzzdxxpz1                   
      cba0=qcx*dzzdyypx0+wqx*dzzdyypx1                     +cb0
      cbb0=qcy*dzzdyypy0+wqy*dzzdyypy1          +2.d0*rcyy1+cb0
      cbc0=qcz*dzzdyypz0+wqz*dzzdyypz1+2.d0*zbz1           +cb0
      cbd0=qcx*dzzdyypy0+wqx*dzzdyypy1                   
      cbe0=qcx*dzzdyypz0+wqx*dzzdyypz1                   
      cbf0=qcy*dzzdyypz0+wqy*dzzdyypz1          +2.d0*rcyz1
      cca0=qcx*dzzdzzpx0+wqx*dzzdzzpx1                     +cc0
      ccb0=qcy*dzzdzzpy0+wqy*dzzdzzpy1                     +cc0
      ccc0=qcz*dzzdzzpz0+wqz*dzzdzzpz1+2.d0*zcz1+2.d0*rczz1+cc0
      ccd0=qcx*dzzdzzpy0+wqx*dzzdzzpy1
      cce0=qcx*dzzdzzpz0+wqx*dzzdzzpz1
      ccf0=qcy*dzzdzzpz0+wqy*dzzdzzpz1
      cda0=qcx*dzzdyxpx0+wqx*dzzdyxpx1          +     rcyx1+cd0
      cdb0=qcy*dzzdyxpy0+wqy*dzzdyxpy1          +     rcxy1+cd0
      cdc0=qcz*dzzdyxpz0+wqz*dzzdyxpz1+2.d0*zdz1           +cd0
      cdd0=qcx*dzzdyxpy0+wqx*dzzdyxpy1          +     rcyy1
      cde0=qcx*dzzdyxpz0+wqx*dzzdyxpz1          +     rcyz1
      cdf0=qcy*dzzdyxpz0+wqy*dzzdyxpz1          +     rcxz1
      cea0=qcx*dzzdzxpx0+wqx*dzzdzxpx1          +     rczx1+ce0
      ceb0=qcy*dzzdzxpy0+wqy*dzzdzxpy1                     +ce0
      cec0=qcz*dzzdzxpz0+wqz*dzzdzxpz1+2.d0*zez1+     rcxz1+ce0
      ced0=qcy*dzzdzxpx0+wqy*dzzdzxpx1                
      cee0=qcx*dzzdzxpz0+wqx*dzzdzxpz1          +     rczz1
      cef0=qcy*dzzdzxpz0+wqy*dzzdzxpz1               
      cfa0=qcx*dzzdzypx0+wqx*dzzdzypx1                     +cf0
      cfb0=qcy*dzzdzypy0+wqy*dzzdzypy1          +     rczy1+cf0
      cfc0=qcz*dzzdzypz0+wqz*dzzdzypz1+2.d0*zfz1+     rcyz1+cf0
      cfd0=qcx*dzzdzypy0+wqx*dzzdzypy1                   
      cfe0=qcx*dzzdzypz0+wqx*dzzdzypz1                   
      cff0=qcy*dzzdzypz0+wqy*dzzdzypz1          +     rczz1
      daa0=qcx*dyxdxxpx0+wqx*dyxdxxpx1+     yax1+2.d0*rdxx1+da0
      dab0=qcy*dyxdxxpy0+wqy*dyxdxxpy1+     xay1           +da0
      dac0=qcz*dyxdxxpz0+wqz*dyxdxxpz1                     +da0
      dad0=qcy*dyxdxxpx0+wqy*dyxdxxpx1+     xax1
      dae0=qcz*dyxdxxpx0+wqz*dyxdxxpx1
      daf0=qcz*dyxdxxpy0+wqz*dyxdxxpy1
      dba0=qcx*dyxdyypx0+wqx*dyxdyypx1+     ybx1           +db0
      dbb0=qcy*dyxdyypy0+wqy*dyxdyypy1+     xby1+2.d0*rdyy1+db0
      dbc0=qcz*dyxdyypz0+wqz*dyxdyypz1                     +db0
      dbd0=qcx*dyxdyypy0+wqx*dyxdyypy1+     yby1
      dbe0=qcz*dyxdyypx0+wqz*dyxdyypx1
      dbf0=qcz*dyxdyypy0+wqz*dyxdyypy1
      dca0=qcx*dyxdzzpx0+wqx*dyxdzzpx1+     ycx1           +dc0
      dcb0=qcy*dyxdzzpy0+wqy*dyxdzzpy1+     xcy1           +dc0
      dcc0=qcz*dyxdzzpz0+wqz*dyxdzzpz1          +2.d0*rdzz1+dc0
      dcd0=qcx*dyxdzzpy0+wqx*dyxdzzpy1+     ycy1          
      dce0=qcx*dyxdzzpz0+wqx*dyxdzzpz1+     ycz1          
      dcf0=qcy*dyxdzzpz0+wqy*dyxdzzpz1+     xcz1          
      dda0=qcx*dyxdyxpx0+wqx*dyxdyxpx1+     ydx1+     rdyx1+dd0
      ddb0=qcy*dyxdyxpy0+wqy*dyxdyxpy1+     xdy1+     rdxy1+dd0
      ddc0=qcz*dyxdyxpz0+wqz*dyxdyxpz1                     +dd0
      ddd0=qcx*dyxdyxpy0+wqx*dyxdyxpy1+     ydy1+     rdyy1
      dde0=qcz*dyxdyxpx0+wqz*dyxdyxpx1
      ddf0=qcz*dyxdyxpy0+wqz*dyxdyxpy1
      dea0=qcx*dyxdzxpx0+wqx*dyxdzxpx1+     yex1+     rdzx1+de0
      deb0=qcy*dyxdzxpy0+wqy*dyxdzxpy1+     xey1           +de0
      dec0=qcz*dyxdzxpz0+wqz*dyxdzxpz1          +     rdxz1+de0
      ded0=qcy*dyxdzxpx0+wqy*dyxdzxpx1+     xex1
      dee0=qcz*dyxdzxpx0+wqz*dyxdzxpx1          +     rdxx1
      def0=qcy*dyxdzxpz0+wqy*dyxdzxpz1+     xez1
      dfa0=qcx*dyxdzypx0+wqx*dyxdzypx1+     yfx1           +df0
      dfb0=qcy*dyxdzypy0+wqy*dyxdzypy1+     xfy1+     rdzy1+df0
      dfc0=qcz*dyxdzypz0+wqz*dyxdzypz1          +     rdyz1+df0
      dfd0=qcx*dyxdzypy0+wqx*dyxdzypy1+     yfy1
      dfe0=qcx*dyxdzypz0+wqx*dyxdzypz1+     yfz1
      dff0=qcz*dyxdzypy0+wqz*dyxdzypy1          +     rdyy1
      eaa0=qcx*dzxdxxpx0+wqx*dzxdxxpx1+     zax1+2.d0*rexx1+ea0
      eab0=qcy*dzxdxxpy0+wqy*dzxdxxpy1                     +ea0
      eac0=qcz*dzxdxxpz0+wqz*dzxdxxpz1+     xaz1           +ea0
      ead0=qcy*dzxdxxpx0+wqy*dzxdxxpx1
      eae0=qcz*dzxdxxpx0+wqz*dzxdxxpx1+     xax1
      eaf0=qcy*dzxdxxpz0+wqy*dzxdxxpz1
      eba0=qcx*dzxdyypx0+wqx*dzxdyypx1+     zbx1           +eb0
      ebb0=qcy*dzxdyypy0+wqy*dzxdyypy1          +2.d0*reyy1+eb0
      ebc0=qcz*dzxdyypz0+wqz*dzxdyypz1+     xbz1           +eb0
      ebd0=qcx*dzxdyypy0+wqx*dzxdyypy1+     zby1
      ebe0=qcx*dzxdyypz0+wqx*dzxdyypz1+     zbz1
      ebf0=qcz*dzxdyypy0+wqz*dzxdyypy1+     xby1
      eca0=qcx*dzxdzzpx0+wqx*dzxdzzpx1+     zcx1           +ec0
      ecb0=qcy*dzxdzzpy0+wqy*dzxdzzpy1                     +ec0
      ecc0=qcz*dzxdzzpz0+wqz*dzxdzzpz1+     xcz1+2.d0*rezz1+ec0
      ecd0=qcy*dzxdzzpx0+wqy*dzxdzzpx1
      ece0=qcx*dzxdzzpz0+wqx*dzxdzzpz1+     zcz1
      ecf0=qcy*dzxdzzpz0+wqy*dzxdzzpz1
      eda0=qcx*dzxdyxpx0+wqx*dzxdyxpx1+     zdx1+     reyx1+ed0
      edb0=qcy*dzxdyxpy0+wqy*dzxdyxpy1          +     rexy1+ed0
      edc0=qcz*dzxdyxpz0+wqz*dzxdyxpz1+     xdz1           +ed0
      edd0=qcy*dzxdyxpx0+wqy*dzxdyxpx1          +     rexx1
      ede0=qcz*dzxdyxpx0+wqz*dzxdyxpx1+     xdx1
      edf0=qcz*dzxdyxpy0+wqz*dzxdyxpy1+     xdy1
      eea0=qcx*dzxdzxpx0+wqx*dzxdzxpx1+     zex1+     rezx1+ee0
      eeb0=qcy*dzxdzxpy0+wqy*dzxdzxpy1                     +ee0
      eec0=qcz*dzxdzxpz0+wqz*dzxdzxpz1+     xez1+     rexz1+ee0
      eed0=qcy*dzxdzxpx0+wqy*dzxdzxpx1
      eee0=qcx*dzxdzxpz0+wqx*dzxdzxpz1+     zez1+     rezz1
      eef0=qcy*dzxdzxpz0+wqy*dzxdzxpz1
      efa0=qcx*dzxdzypx0+wqx*dzxdzypx1+     zfx1           +ef0
      efb0=qcy*dzxdzypy0+wqy*dzxdzypy1          +     rezy1+ef0
      efc0=qcz*dzxdzypz0+wqz*dzxdzypz1+     xfz1+     reyz1+ef0
      efd0=qcy*dzxdzypx0+wqy*dzxdzypx1          +     rezx1
      efe0=qcx*dzxdzypz0+wqx*dzxdzypz1+     zfz1
      eff0=qcy*dzxdzypz0+wqy*dzxdzypz1          +     rezz1
      faa0=qcx*dzydxxpx0+wqx*dzydxxpx1          +2.d0*rfxx1+fa0
      fab0=qcy*dzydxxpy0+wqy*dzydxxpy1+     zay1           +fa0
      fac0=qcz*dzydxxpz0+wqz*dzydxxpz1+     yaz1           +fa0
      fad0=qcy*dzydxxpx0+wqy*dzydxxpx1+     zax1
      fae0=qcz*dzydxxpx0+wqz*dzydxxpx1+     yax1
      faf0=qcy*dzydxxpz0+wqy*dzydxxpz1+     zaz1
      fba0=qcx*dzydyypx0+wqx*dzydyypx1                     +fb0
      fbb0=qcy*dzydyypy0+wqy*dzydyypy1+     zby1+2.d0*rfyy1+fb0
      fbc0=qcz*dzydyypz0+wqz*dzydyypz1+     ybz1           +fb0
      fbd0=qcx*dzydyypy0+wqx*dzydyypy1
      fbe0=qcx*dzydyypz0+wqx*dzydyypz1
      fbf0=qcz*dzydyypy0+wqz*dzydyypy1+     yby1
      fca0=qcx*dzydzzpx0+wqx*dzydzzpx1                     +fc0
      fcb0=qcy*dzydzzpy0+wqy*dzydzzpy1+     zcy1           +fc0
      fcc0=qcz*dzydzzpz0+wqz*dzydzzpz1+     ycz1+2.d0*rfzz1+fc0
      fcd0=qcx*dzydzzpy0+wqx*dzydzzpy1
      fce0=qcx*dzydzzpz0+wqx*dzydzzpz1
      fcf0=qcy*dzydzzpz0+wqy*dzydzzpz1+     zcz1
      fda0=qcx*dzydyxpx0+wqx*dzydyxpx1          +     rfyx1+fd0
      fdb0=qcy*dzydyxpy0+wqy*dzydyxpy1+     zdy1+     rfxy1+fd0
      fdc0=qcz*dzydyxpz0+wqz*dzydyxpz1+     ydz1           +fd0
      fdd0=qcx*dzydyxpy0+wqx*dzydyxpy1          +     rfyy1
      fde0=qcx*dzydyxpz0+wqx*dzydyxpz1          +     rfyz1
      fdf0=qcz*dzydyxpy0+wqz*dzydyxpy1+     ydy1
      fea0=qcx*dzydzxpx0+wqx*dzydzxpx1          +     rfzx1+fe0
      feb0=qcy*dzydzxpy0+wqy*dzydzxpy1+     zey1           +fe0
      fec0=qcz*dzydzxpz0+wqz*dzydzxpz1+     yez1+     rfxz1+fe0
      fed0=qcy*dzydzxpx0+wqy*dzydzxpx1+     zex1
      fee0=qcx*dzydzxpz0+wqx*dzydzxpz1          +     rfzz1
      fef0=qcy*dzydzxpz0+wqy*dzydzxpz1+     zez1
      ffa0=qcx*dzydzypx0+wqx*dzydzypx1                     +ff0
      ffb0=qcy*dzydzypy0+wqy*dzydzypy1+     zfy1+     rfzy1+ff0
      ffc0=qcz*dzydzypz0+wqz*dzydzypz1+     yfz1+     rfyz1+ff0
      ffd0=qcx*dzydzypy0+wqx*dzydzypy1
      ffe0=qcx*dzydzypz0+wqx*dzydzypz1
      fff0=qcy*dzydzypz0+wqy*dzydzypz1+     zfz1+     rfzz1

      aaa1=qcx*dxxdxxpx1+wqx*dxxdxxpx2+2.d0*xax2+2.d0*raxx2+aa1
      aab1=qcy*dxxdxxpy1+wqy*dxxdxxpy2                     +aa1
      aac1=qcz*dxxdxxpz1+wqz*dxxdxxpz2                     +aa1
      aad1=qcy*dxxdxxpx1+wqy*dxxdxxpx2
      aae1=qcz*dxxdxxpx1+wqz*dxxdxxpx2
      aaf1=qcy*dxxdxxpz1+wqy*dxxdxxpz2
      aba1=qcx*dxxdyypx1+wqx*dxxdyypx2+2.d0*xbx2           +ab1
      abb1=qcy*dxxdyypy1+wqy*dxxdyypy2          +2.d0*rayy2+ab1
      abc1=qcz*dxxdyypz1+wqz*dxxdyypz2                     +ab1
      abd1=qcx*dxxdyypy1+wqx*dxxdyypy2+2.d0*xby2
      abe1=qcz*dxxdyypx1+wqz*dxxdyypx2
      abf1=qcz*dxxdyypy1+wqz*dxxdyypy2
      aca1=qcx*dxxdzzpx1+wqx*dxxdzzpx2+2.d0*xcx2           +ac1
      acb1=qcy*dxxdzzpy1+wqy*dxxdzzpy2                     +ac1
      acc1=qcz*dxxdzzpz1+wqz*dxxdzzpz2          +2.d0*razz2+ac1
      acd1=qcy*dxxdzzpx1+wqy*dxxdzzpx2
      ace1=qcx*dxxdzzpz1+wqx*dxxdzzpz2+2.d0*xcz2
      acf1=qcy*dxxdzzpz1+wqy*dxxdzzpz2
      ada1=qcx*dxxdyxpx1+wqx*dxxdyxpx2+2.d0*xdx2+     rayx2+ad1
      adb1=qcy*dxxdyxpy1+wqy*dxxdyxpy2          +     raxy2+ad1
      adc1=qcz*dxxdyxpz1+wqz*dxxdyxpz2                     +ad1
      add1=qcy*dxxdyxpx1+wqy*dxxdyxpx2          +     raxx2
      ade1=qcz*dxxdyxpx1+wqz*dxxdyxpx2
      adf1=qcz*dxxdyxpy1+wqz*dxxdyxpy2
      aea1=qcx*dxxdzxpx1+wqx*dxxdzxpx2+2.d0*xex2+     razx2+ae1
      aeb1=qcy*dxxdzxpy1+wqy*dxxdzxpy2                     +ae1
      aec1=qcz*dxxdzxpz1+wqz*dxxdzxpz2          +     raxz2+ae1
      aed1=qcy*dxxdzxpx1+wqy*dxxdzxpx2
      aee1=qcz*dxxdzxpx1+wqz*dxxdzxpx2          +     raxx2
      aef1=qcy*dxxdzxpz1+wqy*dxxdzxpz2
      afa1=qcx*dxxdzypx1+wqx*dxxdzypx2+2.d0*xfx2           +af1
      afb1=qcy*dxxdzypy1+wqy*dxxdzypy2          +     razy2+af1
      afc1=qcz*dxxdzypz1+wqz*dxxdzypz2          +     rayz2+af1
      afd1=qcy*dxxdzypx1+wqy*dxxdzypx2          +     razx2
      afe1=qcz*dxxdzypx1+wqz*dxxdzypx2          +     rayx2
      aff1=qcy*dxxdzypz1+wqy*dxxdzypz2          +     razz2
      baa1=qcx*dyydxxpx1+wqx*dyydxxpx2          +2.d0*rbxx2+ba1
      bab1=qcy*dyydxxpy1+wqy*dyydxxpy2+2.d0*yay2           +ba1
      bac1=qcz*dyydxxpz1+wqz*dyydxxpz2                     +ba1
      bad1=qcx*dyydxxpy1+wqx*dyydxxpy2          +2.d0*rbxy2
      bae1=qcz*dyydxxpx1+wqz*dyydxxpx2
      baf1=qcz*dyydxxpy1+wqz*dyydxxpy2
      bba1=qcx*dyydyypx1+wqx*dyydyypx2                     +bb1
      bbb1=qcy*dyydyypy1+wqy*dyydyypy2+2.d0*yby2+2.d0*rbyy2+bb1
      bbc1=qcz*dyydyypz1+wqz*dyydyypz2                     +bb1
      bbd1=qcx*dyydyypy1+wqx*dyydyypy2
      bbe1=qcx*dyydyypz1+wqx*dyydyypz2
      bbf1=qcz*dyydyypy1+wqz*dyydyypy2
      bca1=qcx*dyydzzpx1+wqx*dyydzzpx2                     +bc1
      bcb1=qcy*dyydzzpy1+wqy*dyydzzpy2+2.d0*ycy2           +bc1
      bcc1=qcz*dyydzzpz1+wqz*dyydzzpz2          +2.d0*rbzz2+bc1
      bcd1=qcx*dyydzzpy1+wqx*dyydzzpy2
      bce1=qcx*dyydzzpz1+wqx*dyydzzpz2
      bcf1=qcy*dyydzzpz1+wqy*dyydzzpz2+2.d0*ycz2
      bda1=qcx*dyydyxpx1+wqx*dyydyxpx2          +     rbyx2+bd1
      bdb1=qcy*dyydyxpy1+wqy*dyydyxpy2+2.d0*ydy2+     rbxy2+bd1
      bdc1=qcz*dyydyxpz1+wqz*dyydyxpz2                     +bd1
      bdd1=qcx*dyydyxpy1+wqx*dyydyxpy2          +     rbyy2
      bde1=qcz*dyydyxpx1+wqz*dyydyxpx2
      bdf1=qcz*dyydyxpy1+wqz*dyydyxpy2
      bea1=qcx*dyydzxpx1+wqx*dyydzxpx2          +     rbzx2+be1
      beb1=qcy*dyydzxpy1+wqy*dyydzxpy2+2.d0*yey2           +be1
      bec1=qcz*dyydzxpz1+wqz*dyydzxpz2          +     rbxz2+be1
      bed1=qcx*dyydzxpy1+wqx*dyydzxpy2          +     rbzy2
      bee1=qcx*dyydzxpz1+wqx*dyydzxpz2          +     rbzz2
      bef1=qcz*dyydzxpy1+wqz*dyydzxpy2          +     rbxy2
      bfa1=qcx*dyydzypx1+wqx*dyydzypx2                     +bf1
      bfb1=qcy*dyydzypy1+wqy*dyydzypy2+2.d0*yfy2+     rbzy2+bf1
      bfc1=qcz*dyydzypz1+wqz*dyydzypz2          +     rbyz2+bf1
      bfd1=qcx*dyydzypy1+wqx*dyydzypy2
      bfe1=qcx*dyydzypz1+wqx*dyydzypz2
      bff1=qcz*dyydzypy1+wqz*dyydzypy2          +     rbyy2
      caa1=qcx*dzzdxxpx1+wqx*dzzdxxpx2          +2.d0*rcxx2+ca1
      cab1=qcy*dzzdxxpy1+wqy*dzzdxxpy2                     +ca1
      cac1=qcz*dzzdxxpz1+wqz*dzzdxxpz2+2.d0*zaz2           +ca1
      cad1=qcy*dzzdxxpx1+wqy*dzzdxxpx2
      cae1=qcx*dzzdxxpz1+wqx*dzzdxxpz2          +2.d0*rcxz2
      caf1=qcy*dzzdxxpz1+wqy*dzzdxxpz2
      cba1=qcx*dzzdyypx1+wqx*dzzdyypx2                     +cb1
      cbb1=qcy*dzzdyypy1+wqy*dzzdyypy2          +2.d0*rcyy2+cb1
      cbc1=qcz*dzzdyypz1+wqz*dzzdyypz2+2.d0*zbz2           +cb1
      cbd1=qcx*dzzdyypy1+wqx*dzzdyypy2
      cbe1=qcx*dzzdyypz1+wqx*dzzdyypz2
      cbf1=qcy*dzzdyypz1+wqy*dzzdyypz2          +2.d0*rcyz2
      cca1=qcx*dzzdzzpx1+wqx*dzzdzzpx2                     +cc1
      ccb1=qcy*dzzdzzpy1+wqy*dzzdzzpy2                     +cc1
      ccc1=qcz*dzzdzzpz1+wqz*dzzdzzpz2+2.d0*zcz2+2.d0*rczz2+cc1
      ccd1=qcx*dzzdzzpy1+wqx*dzzdzzpy2
      cce1=qcx*dzzdzzpz1+wqx*dzzdzzpz2
      ccf1=qcy*dzzdzzpz1+wqy*dzzdzzpz2
      cda1=qcx*dzzdyxpx1+wqx*dzzdyxpx2          +     rcyx2+cd1
      cdb1=qcy*dzzdyxpy1+wqy*dzzdyxpy2          +     rcxy2+cd1
      cdc1=qcz*dzzdyxpz1+wqz*dzzdyxpz2+2.d0*zdz2           +cd1
      cdd1=qcx*dzzdyxpy1+wqx*dzzdyxpy2          +     rcyy2
      cde1=qcx*dzzdyxpz1+wqx*dzzdyxpz2          +     rcyz2
      cdf1=qcy*dzzdyxpz1+wqy*dzzdyxpz2          +     rcxz2
      cea1=qcx*dzzdzxpx1+wqx*dzzdzxpx2          +     rczx2+ce1
      ceb1=qcy*dzzdzxpy1+wqy*dzzdzxpy2                     +ce1
      cec1=qcz*dzzdzxpz1+wqz*dzzdzxpz2+2.d0*zez2+     rcxz2+ce1
      ced1=qcy*dzzdzxpx1+wqy*dzzdzxpx2
      cee1=qcx*dzzdzxpz1+wqx*dzzdzxpz2          +     rczz2
      cef1=qcy*dzzdzxpz1+wqy*dzzdzxpz2
      cfa1=qcx*dzzdzypx1+wqx*dzzdzypx2                     +cf1
      cfb1=qcy*dzzdzypy1+wqy*dzzdzypy2          +     rczy2+cf1
      cfc1=qcz*dzzdzypz1+wqz*dzzdzypz2+2.d0*zfz2+     rcyz2+cf1
      cfd1=qcx*dzzdzypy1+wqx*dzzdzypy2
      cfe1=qcx*dzzdzypz1+wqx*dzzdzypz2
      cff1=qcy*dzzdzypz1+wqy*dzzdzypz2          +     rczz2
      daa1=qcx*dyxdxxpx1+wqx*dyxdxxpx2+     yax2+2.d0*rdxx2+da1
      dab1=qcy*dyxdxxpy1+wqy*dyxdxxpy2+     xay2           +da1
      dac1=qcz*dyxdxxpz1+wqz*dyxdxxpz2                     +da1
      dad1=qcy*dyxdxxpx1+wqy*dyxdxxpx2+     xax2
      dae1=qcz*dyxdxxpx1+wqz*dyxdxxpx2
      daf1=qcz*dyxdxxpy1+wqz*dyxdxxpy2
      dba1=qcx*dyxdyypx1+wqx*dyxdyypx2+     ybx2           +db1
      dbb1=qcy*dyxdyypy1+wqy*dyxdyypy2+     xby2+2.d0*rdyy2+db1
      dbc1=qcz*dyxdyypz1+wqz*dyxdyypz2                     +db1
      dbd1=qcx*dyxdyypy1+wqx*dyxdyypy2+     yby2
      dbe1=qcz*dyxdyypx1+wqz*dyxdyypx2
      dbf1=qcz*dyxdyypy1+wqz*dyxdyypy2
      dca1=qcx*dyxdzzpx1+wqx*dyxdzzpx2+     ycx2           +dc1
      dcb1=qcy*dyxdzzpy1+wqy*dyxdzzpy2+     xcy2           +dc1
      dcc1=qcz*dyxdzzpz1+wqz*dyxdzzpz2          +2.d0*rdzz2+dc1
      dcd1=qcx*dyxdzzpy1+wqx*dyxdzzpy2+     ycy2
      dce1=qcx*dyxdzzpz1+wqx*dyxdzzpz2+     ycz2
      dcf1=qcy*dyxdzzpz1+wqy*dyxdzzpz2+     xcz2
      dda1=qcx*dyxdyxpx1+wqx*dyxdyxpx2+     ydx2+     rdyx2+dd1
      ddb1=qcy*dyxdyxpy1+wqy*dyxdyxpy2+     xdy2+     rdxy2+dd1
      ddc1=qcz*dyxdyxpz1+wqz*dyxdyxpz2                     +dd1
      ddd1=qcx*dyxdyxpy1+wqx*dyxdyxpy2+     ydy2+     rdyy2
      dde1=qcz*dyxdyxpx1+wqz*dyxdyxpx2
      ddf1=qcz*dyxdyxpy1+wqz*dyxdyxpy2
      dea1=qcx*dyxdzxpx1+wqx*dyxdzxpx2+     yex2+     rdzx2+de1
      deb1=qcy*dyxdzxpy1+wqy*dyxdzxpy2+     xey2           +de1
      dec1=qcz*dyxdzxpz1+wqz*dyxdzxpz2          +     rdxz2+de1
      ded1=qcy*dyxdzxpx1+wqy*dyxdzxpx2+     xex2
      dee1=qcz*dyxdzxpx1+wqz*dyxdzxpx2          +     rdxx2
      def1=qcy*dyxdzxpz1+wqy*dyxdzxpz2+     xez2
      dfa1=qcx*dyxdzypx1+wqx*dyxdzypx2+     yfx2           +df1
      dfb1=qcy*dyxdzypy1+wqy*dyxdzypy2+     xfy2+     rdzy2+df1
      dfc1=qcz*dyxdzypz1+wqz*dyxdzypz2          +     rdyz2+df1
      dfd1=qcx*dyxdzypy1+wqx*dyxdzypy2+     yfy2
      dfe1=qcx*dyxdzypz1+wqx*dyxdzypz2+     yfz2
      dff1=qcz*dyxdzypy1+wqz*dyxdzypy2          +     rdyy2
      eaa1=qcx*dzxdxxpx1+wqx*dzxdxxpx2+     zax2+2.d0*rexx2+ea1
      eab1=qcy*dzxdxxpy1+wqy*dzxdxxpy2                     +ea1
      eac1=qcz*dzxdxxpz1+wqz*dzxdxxpz2+     xaz2           +ea1
      ead1=qcy*dzxdxxpx1+wqy*dzxdxxpx2
      eae1=qcz*dzxdxxpx1+wqz*dzxdxxpx2+     xax2
      eaf1=qcy*dzxdxxpz1+wqy*dzxdxxpz2
      eba1=qcx*dzxdyypx1+wqx*dzxdyypx2+     zbx2           +eb1
      ebb1=qcy*dzxdyypy1+wqy*dzxdyypy2          +2.d0*reyy2+eb1
      ebc1=qcz*dzxdyypz1+wqz*dzxdyypz2+     xbz2           +eb1
      ebd1=qcx*dzxdyypy1+wqx*dzxdyypy2+     zby2
      ebe1=qcx*dzxdyypz1+wqx*dzxdyypz2+     zbz2
      ebf1=qcz*dzxdyypy1+wqz*dzxdyypy2+     xby2
      eca1=qcx*dzxdzzpx1+wqx*dzxdzzpx2+     zcx2           +ec1
      ecb1=qcy*dzxdzzpy1+wqy*dzxdzzpy2                     +ec1
      ecc1=qcz*dzxdzzpz1+wqz*dzxdzzpz2+     xcz2+2.d0*rezz2+ec1
      ecd1=qcy*dzxdzzpx1+wqy*dzxdzzpx2
      ece1=qcx*dzxdzzpz1+wqx*dzxdzzpz2+     zcz2
      ecf1=qcy*dzxdzzpz1+wqy*dzxdzzpz2
      eda1=qcx*dzxdyxpx1+wqx*dzxdyxpx2+     zdx2+     reyx2+ed1
      edb1=qcy*dzxdyxpy1+wqy*dzxdyxpy2          +     rexy2+ed1
      edc1=qcz*dzxdyxpz1+wqz*dzxdyxpz2+     xdz2           +ed1
      edd1=qcy*dzxdyxpx1+wqy*dzxdyxpx2          +     rexx2
      ede1=qcz*dzxdyxpx1+wqz*dzxdyxpx2+     xdx2
      edf1=qcz*dzxdyxpy1+wqz*dzxdyxpy2+     xdy2
      eea1=qcx*dzxdzxpx1+wqx*dzxdzxpx2+     zex2+     rezx2+ee1
      eeb1=qcy*dzxdzxpy1+wqy*dzxdzxpy2                     +ee1
      eec1=qcz*dzxdzxpz1+wqz*dzxdzxpz2+     xez2+     rexz2+ee1
      eed1=qcy*dzxdzxpx1+wqy*dzxdzxpx2
      eee1=qcx*dzxdzxpz1+wqx*dzxdzxpz2+     zez2+     rezz2
      eef1=qcy*dzxdzxpz1+wqy*dzxdzxpz2
      efa1=qcx*dzxdzypx1+wqx*dzxdzypx2+     zfx2           +ef1
      efb1=qcy*dzxdzypy1+wqy*dzxdzypy2          +     rezy2+ef1
      efc1=qcz*dzxdzypz1+wqz*dzxdzypz2+     xfz2+     reyz2+ef1
      efd1=qcy*dzxdzypx1+wqy*dzxdzypx2          +     rezx2
      efe1=qcx*dzxdzypz1+wqx*dzxdzypz2+     zfz2
      eff1=qcy*dzxdzypz1+wqy*dzxdzypz2          +     rezz2
      faa1=qcx*dzydxxpx1+wqx*dzydxxpx2          +2.d0*rfxx2+fa1
      fab1=qcy*dzydxxpy1+wqy*dzydxxpy2+     zay2           +fa1
      fac1=qcz*dzydxxpz1+wqz*dzydxxpz2+     yaz2           +fa1
      fad1=qcy*dzydxxpx1+wqy*dzydxxpx2+     zax2
      fae1=qcz*dzydxxpx1+wqz*dzydxxpx2+     yax2
      faf1=qcy*dzydxxpz1+wqy*dzydxxpz2+     zaz2
      fba1=qcx*dzydyypx1+wqx*dzydyypx2                     +fb1
      fbb1=qcy*dzydyypy1+wqy*dzydyypy2+     zby2+2.d0*rfyy2+fb1
      fbc1=qcz*dzydyypz1+wqz*dzydyypz2+     ybz2           +fb1
      fbd1=qcx*dzydyypy1+wqx*dzydyypy2
      fbe1=qcx*dzydyypz1+wqx*dzydyypz2
      fbf1=qcz*dzydyypy1+wqz*dzydyypy2+     yby2
      fca1=qcx*dzydzzpx1+wqx*dzydzzpx2                     +fc1
      fcb1=qcy*dzydzzpy1+wqy*dzydzzpy2+     zcy2           +fc1
      fcc1=qcz*dzydzzpz1+wqz*dzydzzpz2+     ycz2+2.d0*rfzz2+fc1
      fcd1=qcx*dzydzzpy1+wqx*dzydzzpy2
      fce1=qcx*dzydzzpz1+wqx*dzydzzpz2
      fcf1=qcy*dzydzzpz1+wqy*dzydzzpz2+     zcz2
      fda1=qcx*dzydyxpx1+wqx*dzydyxpx2          +     rfyx2+fd1
      fdb1=qcy*dzydyxpy1+wqy*dzydyxpy2+     zdy2+     rfxy2+fd1
      fdc1=qcz*dzydyxpz1+wqz*dzydyxpz2+     ydz2           +fd1
      fdd1=qcx*dzydyxpy1+wqx*dzydyxpy2          +     rfyy2
      fde1=qcx*dzydyxpz1+wqx*dzydyxpz2          +     rfyz2
      fdf1=qcz*dzydyxpy1+wqz*dzydyxpy2+     ydy2
      fea1=qcx*dzydzxpx1+wqx*dzydzxpx2          +     rfzx2+fe1
      feb1=qcy*dzydzxpy1+wqy*dzydzxpy2+     zey2           +fe1
      fec1=qcz*dzydzxpz1+wqz*dzydzxpz2+     yez2+     rfxz2+fe1
      fed1=qcy*dzydzxpx1+wqy*dzydzxpx2+     zex2
      fee1=qcx*dzydzxpz1+wqx*dzydzxpz2          +     rfzz2
      fef1=qcy*dzydzxpz1+wqy*dzydzxpz2+     zez2
      ffa1=qcx*dzydzypx1+wqx*dzydzypx2                     +ff1
      ffb1=qcy*dzydzypy1+wqy*dzydzypy2+     zfy2+     rfzy2+ff1
      ffc1=qcz*dzydzypz1+wqz*dzydzypz2+     yfz2+     rfyz2+ff1
      ffd1=qcx*dzydzypy1+wqx*dzydzypy2
      ffe1=qcx*dzydzypz1+wqx*dzydzypz2
      fff1=qcy*dzydzypz1+wqy*dzydzypz2+     zfz2+     rfzz2

!rpdds(1) 
      rxaa=rkp*xdxxdxx1
      rxab=rkp*xdxxdyy1
      rxac=rkp*xdxxdzz1
      rxad=rkp*xdxxdyx1
      rxae=rkp*xdxxdzx1
      rxaf=rkp*xdxxdzy1
      rxba=rkp*xdyydxx1
      rxbb=rkp*xdyydyy1
      rxbc=rkp*xdyydzz1
      rxbd=rkp*xdyydyx1
      rxbe=rkp*xdyydzx1
      rxbf=rkp*xdyydzy1
      rxca=rkp*xdzzdxx1
      rxcb=rkp*xdzzdyy1
      rxcc=rkp*xdzzdzz1
      rxcd=rkp*xdzzdyx1
      rxce=rkp*xdzzdzx1
      rxcf=rkp*xdzzdzy1
      rxda=rkp*xdyxdxx1
      rxdb=rkp*xdyxdyy1
      rxdc=rkp*xdyxdzz1
      rxdd=rkp*xdyxdyx1
      rxde=rkp*xdyxdzx1
      rxdf=rkp*xdyxdzy1
      rxea=rkp*xdzxdxx1
      rxeb=rkp*xdzxdyy1
      rxec=rkp*xdzxdzz1
      rxed=rkp*xdzxdyx1
      rxee=rkp*xdzxdzx1
      rxef=rkp*xdzxdzy1
      rxfa=rkp*xdzydxx1
      rxfb=rkp*xdzydyy1
      rxfc=rkp*xdzydzz1
      rxfd=rkp*xdzydyx1
      rxfe=rkp*xdzydzx1
      rxff=rkp*xdzydzy1
      ryaa=rkp*ydxxdxx1
      ryab=rkp*ydxxdyy1
      ryac=rkp*ydxxdzz1
      ryad=rkp*ydxxdyx1
      ryae=rkp*ydxxdzx1
      ryaf=rkp*ydxxdzy1
      ryba=rkp*ydyydxx1
      rybb=rkp*ydyydyy1
      rybc=rkp*ydyydzz1
      rybd=rkp*ydyydyx1
      rybe=rkp*ydyydzx1
      rybf=rkp*ydyydzy1
      ryca=rkp*ydzzdxx1
      rycb=rkp*ydzzdyy1
      rycc=rkp*ydzzdzz1
      rycd=rkp*ydzzdyx1
      ryce=rkp*ydzzdzx1
      rycf=rkp*ydzzdzy1
      ryda=rkp*ydyxdxx1
      rydb=rkp*ydyxdyy1
      rydc=rkp*ydyxdzz1
      rydd=rkp*ydyxdyx1
      ryde=rkp*ydyxdzx1
      rydf=rkp*ydyxdzy1
      ryea=rkp*ydzxdxx1
      ryeb=rkp*ydzxdyy1
      ryec=rkp*ydzxdzz1
      ryed=rkp*ydzxdyx1
      ryee=rkp*ydzxdzx1
      ryef=rkp*ydzxdzy1
      ryfa=rkp*ydzydxx1
      ryfb=rkp*ydzydyy1
      ryfc=rkp*ydzydzz1
      ryfd=rkp*ydzydyx1
      ryfe=rkp*ydzydzx1
      ryff=rkp*ydzydzy1
      rzaa=rkp*zdxxdxx1
      rzab=rkp*zdxxdyy1
      rzac=rkp*zdxxdzz1
      rzad=rkp*zdxxdyx1
      rzae=rkp*zdxxdzx1
      rzaf=rkp*zdxxdzy1
      rzba=rkp*zdyydxx1
      rzbb=rkp*zdyydyy1
      rzbc=rkp*zdyydzz1
      rzbd=rkp*zdyydyx1
      rzbe=rkp*zdyydzx1
      rzbf=rkp*zdyydzy1
      rzca=rkp*zdzzdxx1
      rzcb=rkp*zdzzdyy1
      rzcc=rkp*zdzzdzz1
      rzcd=rkp*zdzzdyx1
      rzce=rkp*zdzzdzx1
      rzcf=rkp*zdzzdzy1
      rzda=rkp*zdyxdxx1
      rzdb=rkp*zdyxdyy1
      rzdc=rkp*zdyxdzz1
      rzdd=rkp*zdyxdyx1
      rzde=rkp*zdyxdzx1
      rzdf=rkp*zdyxdzy1
      rzea=rkp*zdzxdxx1
      rzeb=rkp*zdzxdyy1
      rzec=rkp*zdzxdzz1
      rzed=rkp*zdzxdyx1
      rzee=rkp*zdzxdzx1
      rzef=rkp*zdzxdzy1
      rzfa=rkp*zdzydxx1
      rzfb=rkp*zdzydyy1
      rzfc=rkp*zdzydzz1
      rzfd=rkp*zdzydyx1
      rzfe=rkp*zdzydzx1
      rzff=rkp*zdzydzy1
 
!rdpds(1)
      raxa=rkp* axa1
      raxb=rkp* axb1
      raxc=rkp* axc1
      raxd=rkp* axd1
      raxe=rkp* axe1
      raxf=rkp* axf1
      raya=rkp* aya1
      rayb=rkp* ayb1
      rayc=rkp* ayc1
      rayd=rkp* ayd1
      raye=rkp* aye1
      rayf=rkp* ayf1
      raza=rkp* aza1
      razb=rkp* azb1
      razc=rkp* azc1
      razd=rkp* azd1
      raze=rkp* aze1
      razf=rkp* azf1
      rbxa=rkp* bxa1
      rbxb=rkp* bxb1
      rbxc=rkp* bxc1
      rbxd=rkp* bxd1
      rbxe=rkp* bxe1
      rbxf=rkp* bxf1
      rbya=rkp* bya1
      rbyb=rkp* byb1
      rbyc=rkp* byc1
      rbyd=rkp* byd1
      rbye=rkp* bye1
      rbyf=rkp* byf1
      rbza=rkp* bza1
      rbzb=rkp* bzb1
      rbzc=rkp* bzc1
      rbzd=rkp* bzd1
      rbze=rkp* bze1
      rbzf=rkp* bzf1
      rcxa=rkp* cxa1
      rcxb=rkp* cxb1
      rcxc=rkp* cxc1
      rcxd=rkp* cxd1
      rcxe=rkp* cxe1
      rcxf=rkp* cxf1
      rcya=rkp* cya1
      rcyb=rkp* cyb1
      rcyc=rkp* cyc1
      rcyd=rkp* cyd1
      rcye=rkp* cye1
      rcyf=rkp* cyf1
      rcza=rkp* cza1
      rczb=rkp* czb1
      rczc=rkp* czc1
      rczd=rkp* czd1
      rcze=rkp* cze1
      rczf=rkp* czf1
      rdxa=rkp* dxa1
      rdxb=rkp* dxb1
      rdxc=rkp* dxc1
      rdxd=rkp* dxd1
      rdxe=rkp* dxe1
      rdxf=rkp* dxf1
      rdya=rkp* dya1
      rdyb=rkp* dyb1
      rdyc=rkp* dyc1
      rdyd=rkp* dyd1
      rdye=rkp* dye1
      rdyf=rkp* dyf1
      rdza=rkp* dza1
      rdzb=rkp* dzb1
      rdzc=rkp* dzc1
      rdzd=rkp* dzd1
      rdze=rkp* dze1
      rdzf=rkp* dzf1
      rexa=rkp* exa1
      rexb=rkp* exb1
      rexc=rkp* exc1
      rexd=rkp* exd1
      rexe=rkp* exe1
      rexf=rkp* exf1
      reya=rkp* eya1
      reyb=rkp* eyb1
      reyc=rkp* eyc1
      reyd=rkp* eyd1
      reye=rkp* eye1
      reyf=rkp* eyf1
      reza=rkp* eza1
      rezb=rkp* ezb1
      rezc=rkp* ezc1
      rezd=rkp* ezd1
      reze=rkp* eze1
      rezf=rkp* ezf1
      rfxa=rkp* fxa1
      rfxb=rkp* fxb1
      rfxc=rkp* fxc1
      rfxd=rkp* fxd1
      rfxe=rkp* fxe1
      rfxf=rkp* fxf1
      rfya=rkp* fya1
      rfyb=rkp* fyb1
      rfyc=rkp* fyc1
      rfyd=rkp* fyd1
      rfye=rkp* fye1
      rfyf=rkp* fyf1
      rfza=rkp* fza1
      rfzb=rkp* fzb1
      rfzc=rkp* fzc1
      rfzd=rkp* fzd1
      rfze=rkp* fze1
      rfzf=rkp* fzf1
 
!ddps01(01)
      aax01= eta*(dxxdxxpx0 -rooe*dxxdxxpx1)
      aay01= eta*(dxxdxxpy0 -rooe*dxxdxxpy1)
      aaz01= eta*(dxxdxxpz0 -rooe*dxxdxxpz1)
      abx01= eta*(dxxdyypx0 -rooe*dxxdyypx1)
      aby01= eta*(dxxdyypy0 -rooe*dxxdyypy1)
      abz01= eta*(dxxdyypz0 -rooe*dxxdyypz1)
      acx01= eta*(dxxdzzpx0 -rooe*dxxdzzpx1)
      acy01= eta*(dxxdzzpy0 -rooe*dxxdzzpy1)
      acz01= eta*(dxxdzzpz0 -rooe*dxxdzzpz1)
      adx01= eta*(dxxdyxpx0 -rooe*dxxdyxpx1)
      ady01= eta*(dxxdyxpy0 -rooe*dxxdyxpy1)
      adz01= eta*(dxxdyxpz0 -rooe*dxxdyxpz1)
      aex01= eta*(dxxdzxpx0 -rooe*dxxdzxpx1)
      aey01= eta*(dxxdzxpy0 -rooe*dxxdzxpy1)
      aez01= eta*(dxxdzxpz0 -rooe*dxxdzxpz1)
      afx01= eta*(dxxdzypx0 -rooe*dxxdzypx1)
      afy01= eta*(dxxdzypy0 -rooe*dxxdzypy1)
      afz01= eta*(dxxdzypz0 -rooe*dxxdzypz1)
      bax01= eta*(dyydxxpx0 -rooe*dyydxxpx1)
      bay01= eta*(dyydxxpy0 -rooe*dyydxxpy1)
      baz01= eta*(dyydxxpz0 -rooe*dyydxxpz1)
      bbx01= eta*(dyydyypx0 -rooe*dyydyypx1)
      bby01= eta*(dyydyypy0 -rooe*dyydyypy1)
      bbz01= eta*(dyydyypz0 -rooe*dyydyypz1)
      bcx01= eta*(dyydzzpx0 -rooe*dyydzzpx1)
      bcy01= eta*(dyydzzpy0 -rooe*dyydzzpy1)
      bcz01= eta*(dyydzzpz0 -rooe*dyydzzpz1)
      bdx01= eta*(dyydyxpx0 -rooe*dyydyxpx1)
      bdy01= eta*(dyydyxpy0 -rooe*dyydyxpy1)
      bdz01= eta*(dyydyxpz0 -rooe*dyydyxpz1)
      bex01= eta*(dyydzxpx0 -rooe*dyydzxpx1)
      bey01= eta*(dyydzxpy0 -rooe*dyydzxpy1)
      bez01= eta*(dyydzxpz0 -rooe*dyydzxpz1)
      bfx01= eta*(dyydzypx0 -rooe*dyydzypx1)
      bfy01= eta*(dyydzypy0 -rooe*dyydzypy1)
      bfz01= eta*(dyydzypz0 -rooe*dyydzypz1)
      cax01= eta*(dzzdxxpx0 -rooe*dzzdxxpx1)
      cay01= eta*(dzzdxxpy0 -rooe*dzzdxxpy1)
      caz01= eta*(dzzdxxpz0 -rooe*dzzdxxpz1)
      cbx01= eta*(dzzdyypx0 -rooe*dzzdyypx1)
      cby01= eta*(dzzdyypy0 -rooe*dzzdyypy1)
      cbz01= eta*(dzzdyypz0 -rooe*dzzdyypz1)
      ccx01= eta*(dzzdzzpx0 -rooe*dzzdzzpx1)
      ccy01= eta*(dzzdzzpy0 -rooe*dzzdzzpy1)
      ccz01= eta*(dzzdzzpz0 -rooe*dzzdzzpz1)
      cdx01= eta*(dzzdyxpx0 -rooe*dzzdyxpx1)
      cdy01= eta*(dzzdyxpy0 -rooe*dzzdyxpy1)
      cdz01= eta*(dzzdyxpz0 -rooe*dzzdyxpz1)
      cex01= eta*(dzzdzxpx0 -rooe*dzzdzxpx1)
      cey01= eta*(dzzdzxpy0 -rooe*dzzdzxpy1)
      cez01= eta*(dzzdzxpz0 -rooe*dzzdzxpz1)
      cfx01= eta*(dzzdzypx0 -rooe*dzzdzypx1)
      cfy01= eta*(dzzdzypy0 -rooe*dzzdzypy1)
      cfz01= eta*(dzzdzypz0 -rooe*dzzdzypz1)
      dax01= eta*(dyxdxxpx0 -rooe*dyxdxxpx1)
      day01= eta*(dyxdxxpy0 -rooe*dyxdxxpy1)
      daz01= eta*(dyxdxxpz0 -rooe*dyxdxxpz1)
      dbx01= eta*(dyxdyypx0 -rooe*dyxdyypx1)
      dby01= eta*(dyxdyypy0 -rooe*dyxdyypy1)
      dbz01= eta*(dyxdyypz0 -rooe*dyxdyypz1)
      dcx01= eta*(dyxdzzpx0 -rooe*dyxdzzpx1)
      dcy01= eta*(dyxdzzpy0 -rooe*dyxdzzpy1)
      dcz01= eta*(dyxdzzpz0 -rooe*dyxdzzpz1)
      ddx01= eta*(dyxdyxpx0 -rooe*dyxdyxpx1)
      ddy01= eta*(dyxdyxpy0 -rooe*dyxdyxpy1)
      ddz01= eta*(dyxdyxpz0 -rooe*dyxdyxpz1)
      dex01= eta*(dyxdzxpx0 -rooe*dyxdzxpx1)
      dey01= eta*(dyxdzxpy0 -rooe*dyxdzxpy1)
      dez01= eta*(dyxdzxpz0 -rooe*dyxdzxpz1)
      dfx01= eta*(dyxdzypx0 -rooe*dyxdzypx1)
      dfy01= eta*(dyxdzypy0 -rooe*dyxdzypy1)
      dfz01= eta*(dyxdzypz0 -rooe*dyxdzypz1)
      eax01= eta*(dzxdxxpx0 -rooe*dzxdxxpx1)
      eay01= eta*(dzxdxxpy0 -rooe*dzxdxxpy1)
      eaz01= eta*(dzxdxxpz0 -rooe*dzxdxxpz1)
      ebx01= eta*(dzxdyypx0 -rooe*dzxdyypx1)
      eby01= eta*(dzxdyypy0 -rooe*dzxdyypy1)
      ebz01= eta*(dzxdyypz0 -rooe*dzxdyypz1)
      ecx01= eta*(dzxdzzpx0 -rooe*dzxdzzpx1)
      ecy01= eta*(dzxdzzpy0 -rooe*dzxdzzpy1)
      ecz01= eta*(dzxdzzpz0 -rooe*dzxdzzpz1)
      edx01= eta*(dzxdyxpx0 -rooe*dzxdyxpx1)
      edy01= eta*(dzxdyxpy0 -rooe*dzxdyxpy1)
      edz01= eta*(dzxdyxpz0 -rooe*dzxdyxpz1)
      eex01= eta*(dzxdzxpx0 -rooe*dzxdzxpx1)
      eey01= eta*(dzxdzxpy0 -rooe*dzxdzxpy1)
      eez01= eta*(dzxdzxpz0 -rooe*dzxdzxpz1)
      efx01= eta*(dzxdzypx0 -rooe*dzxdzypx1)
      efy01= eta*(dzxdzypy0 -rooe*dzxdzypy1)
      efz01= eta*(dzxdzypz0 -rooe*dzxdzypz1)
      fax01= eta*(dzydxxpx0 -rooe*dzydxxpx1)
      fay01= eta*(dzydxxpy0 -rooe*dzydxxpy1)
      faz01= eta*(dzydxxpz0 -rooe*dzydxxpz1)
      fbx01= eta*(dzydyypx0 -rooe*dzydyypx1)
      fby01= eta*(dzydyypy0 -rooe*dzydyypy1)
      fbz01= eta*(dzydyypz0 -rooe*dzydyypz1)
      fcx01= eta*(dzydzzpx0 -rooe*dzydzzpx1)
      fcy01= eta*(dzydzzpy0 -rooe*dzydzzpy1)
      fcz01= eta*(dzydzzpz0 -rooe*dzydzzpz1)
      fdx01= eta*(dzydyxpx0 -rooe*dzydyxpx1)
      fdy01= eta*(dzydyxpy0 -rooe*dzydyxpy1)
      fdz01= eta*(dzydyxpz0 -rooe*dzydyxpz1)
      fex01= eta*(dzydzxpx0 -rooe*dzydzxpx1)
      fey01= eta*(dzydzxpy0 -rooe*dzydzxpy1)
      fez01= eta*(dzydzxpz0 -rooe*dzydzxpz1)
      ffx01= eta*(dzydzypx0 -rooe*dzydzypx1)
      ffy01= eta*(dzydzypy0 -rooe*dzydzypy1)
      ffz01= eta*(dzydzypz0 -rooe*dzydzypz1)
                           
!dddp(0)
      ec(  1)=ec(  1)+qdx*aaa0+wqx*aaa1+2.d0*rxaa+2.d0*raxa+2.d0*aax01
      ec(  2)=ec(  2)+qdy*aaa0+wqy*aaa1
      ec(  3)=ec(  3)+qdz*aaa0+wqz*aaa1
      ec(  4)=ec(  4)+qdx*aab0+wqx*aab1+2.d0*rxab+2.d0*raxb
      ec(  5)=ec(  5)+qdy*aab0+wqy*aab1                    +2.d0*aay01
      ec(  6)=ec(  6)+qdz*aab0+wqz*aab1
      ec(  7)=ec(  7)+qdx*aac0+wqx*aac1+2.d0*rxac+2.d0*raxc
      ec(  8)=ec(  8)+qdy*aac0+wqy*aac1
      ec(  9)=ec(  9)+qdz*aac0+wqz*aac1                    +2.d0*aaz01
      ec( 10)=ec( 10)+qdx*aad0+wqx*aad1+2.d0*rxad+2.d0*raxd+     aay01
      ec( 11)=ec( 11)+qdy*aad0+wqy*aad1                    +     aax01
      ec( 12)=ec( 12)+qdz*aad0+wqz*aad1                    
      ec( 13)=ec( 13)+qdx*aae0+wqx*aae1+2.d0*rxae+2.d0*raxe+     aaz01
      ec( 14)=ec( 14)+qdy*aae0+wqy*aae1
      ec( 15)=ec( 15)+qdz*aae0+wqz*aae1                    +     aax01
      ec( 16)=ec( 16)+qdx*aaf0+wqx*aaf1+2.d0*rxaf+2.d0*raxf
      ec( 17)=ec( 17)+qdy*aaf0+wqy*aaf1                    +     aaz01
      ec( 18)=ec( 18)+qdz*aaf0+wqz*aaf1                    +     aay01
      ec( 19)=ec( 19)+qdx*aba0+wqx*aba1+2.d0*rxba          +2.d0*abx01
      ec( 20)=ec( 20)+qdy*aba0+wqy*aba1          +2.d0*raya
      ec( 21)=ec( 21)+qdz*aba0+wqz*aba1
      ec( 22)=ec( 22)+qdx*abb0+wqx*abb1+2.d0*rxbb          
      ec( 23)=ec( 23)+qdy*abb0+wqy*abb1          +2.d0*rayb+2.d0*aby01
      ec( 24)=ec( 24)+qdz*abb0+wqz*abb1                    
      ec( 25)=ec( 25)+qdx*abc0+wqx*abc1+2.d0*rxbc          
      ec( 26)=ec( 26)+qdy*abc0+wqy*abc1          +2.d0*rayc
      ec( 27)=ec( 27)+qdz*abc0+wqz*abc1                    +2.d0*abz01
      ec( 28)=ec( 28)+qdx*abd0+wqx*abd1+2.d0*rxbd          +     aby01
      ec( 29)=ec( 29)+qdy*abd0+wqy*abd1          +2.d0*rayd+     abx01
      ec( 30)=ec( 30)+qdz*abd0+wqz*abd1                    
      ec( 31)=ec( 31)+qdx*abe0+wqx*abe1+2.d0*rxbe          +     abz01
      ec( 32)=ec( 32)+qdy*abe0+wqy*abe1          +2.d0*raye
      ec( 33)=ec( 33)+qdz*abe0+wqz*abe1                    +     abx01
      ec( 34)=ec( 34)+qdx*abf0+wqx*abf1+2.d0*rxbf          
      ec( 35)=ec( 35)+qdy*abf0+wqy*abf1          +2.d0*rayf+     abz01
      ec( 36)=ec( 36)+qdz*abf0+wqz*abf1                    +     aby01
      ec( 37)=ec( 37)+qdx*aca0+wqx*aca1+2.d0*rxca          +2.d0*acx01
      ec( 38)=ec( 38)+qdy*aca0+wqy*aca1                    
      ec( 39)=ec( 39)+qdz*aca0+wqz*aca1          +2.d0*raza
      ec( 40)=ec( 40)+qdx*acb0+wqx*acb1+2.d0*rxcb          
      ec( 41)=ec( 41)+qdy*acb0+wqy*acb1                    +2.d0*acy01
      ec( 42)=ec( 42)+qdz*acb0+wqz*acb1          +2.d0*razb
      ec( 43)=ec( 43)+qdx*acc0+wqx*acc1+2.d0*rxcc          
      ec( 44)=ec( 44)+qdy*acc0+wqy*acc1                    
      ec( 45)=ec( 45)+qdz*acc0+wqz*acc1          +2.d0*razc+2.d0*acz01
      ec( 46)=ec( 46)+qdx*acd0+wqx*acd1+2.d0*rxcd          +     acy01
      ec( 47)=ec( 47)+qdy*acd0+wqy*acd1                    +     acx01
      ec( 48)=ec( 48)+qdz*acd0+wqz*acd1          +2.d0*razd
      ec( 49)=ec( 49)+qdx*ace0+wqx*ace1+2.d0*rxce          +     acz01
      ec( 50)=ec( 50)+qdy*ace0+wqy*ace1                    
      ec( 51)=ec( 51)+qdz*ace0+wqz*ace1          +2.d0*raze+     acx01
      ec( 52)=ec( 52)+qdx*acf0+wqx*acf1+2.d0*rxcf          
      ec( 53)=ec( 53)+qdy*acf0+wqy*acf1                    +     acz01
      ec( 54)=ec( 54)+qdz*acf0+wqz*acf1          +2.d0*razf+     acy01
      ec( 55)=ec( 55)+qdx*ada0+wqx*ada1+2.d0*rxda+     raya+2.d0*adx01
      ec( 56)=ec( 56)+qdy*ada0+wqy*ada1          +     raxa
      ec( 57)=ec( 57)+qdz*ada0+wqz*ada1                    
      ec( 58)=ec( 58)+qdx*adb0+wqx*adb1+2.d0*rxdb+     rayb
      ec( 59)=ec( 59)+qdy*adb0+wqy*adb1          +     raxb+2.d0*ady01
      ec( 60)=ec( 60)+qdz*adb0+wqz*adb1                    
      ec( 61)=ec( 61)+qdx*adc0+wqx*adc1+2.d0*rxdc+     rayc
      ec( 62)=ec( 62)+qdy*adc0+wqy*adc1          +     raxc
      ec( 63)=ec( 63)+qdz*adc0+wqz*adc1                    +2.d0*adz01
      ec( 64)=ec( 64)+qdx*add0+wqx*add1+2.d0*rxdd+     rayd+     ady01
      ec( 65)=ec( 65)+qdy*add0+wqy*add1          +     raxd+     adx01
      ec( 66)=ec( 66)+qdz*add0+wqz*add1                    
      ec( 67)=ec( 67)+qdx*ade0+wqx*ade1+2.d0*rxde+     raye+     adz01
      ec( 68)=ec( 68)+qdy*ade0+wqy*ade1          +     raxe
      ec( 69)=ec( 69)+qdz*ade0+wqz*ade1                    +     adx01
      ec( 70)=ec( 70)+qdx*adf0+wqx*adf1+2.d0*rxdf+     rayf
      ec( 71)=ec( 71)+qdy*adf0+wqy*adf1          +     raxf+     adz01
      ec( 72)=ec( 72)+qdz*adf0+wqz*adf1                    +     ady01
      ec( 73)=ec( 73)+qdx*aea0+wqx*aea1+2.d0*rxea+     raza+2.d0*aex01
      ec( 74)=ec( 74)+qdy*aea0+wqy*aea1                    
      ec( 75)=ec( 75)+qdz*aea0+wqz*aea1          +     raxa
      ec( 76)=ec( 76)+qdx*aeb0+wqx*aeb1+2.d0*rxeb+     razb
      ec( 77)=ec( 77)+qdy*aeb0+wqy*aeb1                    +2.d0*aey01
      ec( 78)=ec( 78)+qdz*aeb0+wqz*aeb1          +     raxb
      ec( 79)=ec( 79)+qdx*aec0+wqx*aec1+2.d0*rxec+     razc
      ec( 80)=ec( 80)+qdy*aec0+wqy*aec1                    
      ec( 81)=ec( 81)+qdz*aec0+wqz*aec1          +     raxc+2.d0*aez01
      ec( 82)=ec( 82)+qdx*aed0+wqx*aed1+2.d0*rxed+     razd+     aey01
      ec( 83)=ec( 83)+qdy*aed0+wqy*aed1                    +     aex01
      ec( 84)=ec( 84)+qdz*aed0+wqz*aed1          +     raxd
      ec( 85)=ec( 85)+qdx*aee0+wqx*aee1+2.d0*rxee+     raze+     aez01
      ec( 86)=ec( 86)+qdy*aee0+wqy*aee1                    
      ec( 87)=ec( 87)+qdz*aee0+wqz*aee1          +     raxe+     aex01
      ec( 88)=ec( 88)+qdx*aef0+wqx*aef1+2.d0*rxef+     razf
      ec( 89)=ec( 89)+qdy*aef0+wqy*aef1                    +     aez01
      ec( 90)=ec( 90)+qdz*aef0+wqz*aef1          +     raxf+     aey01
      ec( 91)=ec( 91)+qdx*afa0+wqx*afa1+2.d0*rxfa          +2.d0*afx01
      ec( 92)=ec( 92)+qdy*afa0+wqy*afa1          +     raza
      ec( 93)=ec( 93)+qdz*afa0+wqz*afa1          +     raya
      ec( 94)=ec( 94)+qdx*afb0+wqx*afb1+2.d0*rxfb          
      ec( 95)=ec( 95)+qdy*afb0+wqy*afb1          +     razb+2.d0*afy01
      ec( 96)=ec( 96)+qdz*afb0+wqz*afb1          +     rayb
      ec( 97)=ec( 97)+qdx*afc0+wqx*afc1+2.d0*rxfc          
      ec( 98)=ec( 98)+qdy*afc0+wqy*afc1          +     razc
      ec( 99)=ec( 99)+qdz*afc0+wqz*afc1          +     rayc+2.d0*afz01
      ec(100)=ec(100)+qdx*afd0+wqx*afd1+2.d0*rxfd          +     afy01
      ec(101)=ec(101)+qdy*afd0+wqy*afd1          +     razd+     afx01
      ec(102)=ec(102)+qdz*afd0+wqz*afd1          +     rayd
      ec(103)=ec(103)+qdx*afe0+wqx*afe1+2.d0*rxfe          +     afz01
      ec(104)=ec(104)+qdy*afe0+wqy*afe1          +     raze
      ec(105)=ec(105)+qdz*afe0+wqz*afe1          +     raye+     afx01
      ec(106)=ec(106)+qdx*aff0+wqx*aff1+2.d0*rxff          
      ec(107)=ec(107)+qdy*aff0+wqy*aff1          +     razf+     afz01
      ec(108)=ec(108)+qdz*aff0+wqz*aff1          +     rayf+     afy01
      ec(109)=ec(109)+qdx*baa0+wqx*baa1          +2.d0*rbxa+2.d0*bax01
      ec(110)=ec(110)+qdy*baa0+wqy*baa1+2.d0*ryaa          
      ec(111)=ec(111)+qdz*baa0+wqz*baa1                    
      ec(112)=ec(112)+qdx*bab0+wqx*bab1          +2.d0*rbxb
      ec(113)=ec(113)+qdy*bab0+wqy*bab1+2.d0*ryab          +2.d0*bay01
      ec(114)=ec(114)+qdz*bab0+wqz*bab1                    
      ec(115)=ec(115)+qdx*bac0+wqx*bac1          +2.d0*rbxc
      ec(116)=ec(116)+qdy*bac0+wqy*bac1+2.d0*ryac          
      ec(117)=ec(117)+qdz*bac0+wqz*bac1                    +2.d0*baz01
      ec(118)=ec(118)+qdx*bad0+wqx*bad1          +2.d0*rbxd+     bay01
      ec(119)=ec(119)+qdy*bad0+wqy*bad1+2.d0*ryad          +     bax01
      ec(120)=ec(120)+qdz*bad0+wqz*bad1                    
      ec(121)=ec(121)+qdx*bae0+wqx*bae1          +2.d0*rbxe+     baz01
      ec(122)=ec(122)+qdy*bae0+wqy*bae1+2.d0*ryae          
      ec(123)=ec(123)+qdz*bae0+wqz*bae1                    +     bax01
      ec(124)=ec(124)+qdx*baf0+wqx*baf1          +2.d0*rbxf
      ec(125)=ec(125)+qdy*baf0+wqy*baf1+2.d0*ryaf          +     baz01
      ec(126)=ec(126)+qdz*baf0+wqz*baf1                    +     bay01
      ec(127)=ec(127)+qdx*bba0+wqx*bba1                    +2.d0*bbx01
      ec(128)=ec(128)+qdy*bba0+wqy*bba1+2.d0*ryba+2.d0*rbya
      ec(129)=ec(129)+qdz*bba0+wqz*bba1                    
      ec(130)=ec(130)+qdx*bbb0+wqx*bbb1                    
      ec(131)=ec(131)+qdy*bbb0+wqy*bbb1+2.d0*rybb+2.d0*rbyb+2.d0*bby01
      ec(132)=ec(132)+qdz*bbb0+wqz*bbb1                    
      ec(133)=ec(133)+qdx*bbc0+wqx*bbc1                    
      ec(134)=ec(134)+qdy*bbc0+wqy*bbc1+2.d0*rybc+2.d0*rbyc
      ec(135)=ec(135)+qdz*bbc0+wqz*bbc1                    +2.d0*bbz01
      ec(136)=ec(136)+qdx*bbd0+wqx*bbd1                    +     bby01
      ec(137)=ec(137)+qdy*bbd0+wqy*bbd1+2.d0*rybd+2.d0*rbyd+     bbx01
      ec(138)=ec(138)+qdz*bbd0+wqz*bbd1                    
      ec(139)=ec(139)+qdx*bbe0+wqx*bbe1                    +     bbz01
      ec(140)=ec(140)+qdy*bbe0+wqy*bbe1+2.d0*rybe+2.d0*rbye
      ec(141)=ec(141)+qdz*bbe0+wqz*bbe1                    +     bbx01
      ec(142)=ec(142)+qdx*bbf0+wqx*bbf1                    
      ec(143)=ec(143)+qdy*bbf0+wqy*bbf1+2.d0*rybf+2.d0*rbyf+     bbz01
      ec(144)=ec(144)+qdz*bbf0+wqz*bbf1                    +     bby01
      ec(145)=ec(145)+qdx*bca0+wqx*bca1                    +2.d0*bcx01
      ec(146)=ec(146)+qdy*bca0+wqy*bca1+2.d0*ryca          
      ec(147)=ec(147)+qdz*bca0+wqz*bca1          +2.d0*rbza
      ec(148)=ec(148)+qdx*bcb0+wqx*bcb1                    
      ec(149)=ec(149)+qdy*bcb0+wqy*bcb1+2.d0*rycb          +2.d0*bcy01
      ec(150)=ec(150)+qdz*bcb0+wqz*bcb1          +2.d0*rbzb
      ec(151)=ec(151)+qdx*bcc0+wqx*bcc1                    
      ec(152)=ec(152)+qdy*bcc0+wqy*bcc1+2.d0*rycc          
      ec(153)=ec(153)+qdz*bcc0+wqz*bcc1          +2.d0*rbzc+2.d0*bcz01
      ec(154)=ec(154)+qdx*bcd0+wqx*bcd1                    +     bcy01
      ec(155)=ec(155)+qdy*bcd0+wqy*bcd1+2.d0*rycd          +     bcx01
      ec(156)=ec(156)+qdz*bcd0+wqz*bcd1          +2.d0*rbzd
      ec(157)=ec(157)+qdx*bce0+wqx*bce1                    +     bcz01
      ec(158)=ec(158)+qdy*bce0+wqy*bce1+2.d0*ryce          
      ec(159)=ec(159)+qdz*bce0+wqz*bce1          +2.d0*rbze+     bcx01
      ec(160)=ec(160)+qdx*bcf0+wqx*bcf1                    
      ec(161)=ec(161)+qdy*bcf0+wqy*bcf1+2.d0*rycf          +     bcz01
      ec(162)=ec(162)+qdz*bcf0+wqz*bcf1          +2.d0*rbzf+     bcy01
      ec(163)=ec(163)+qdx*bda0+wqx*bda1          +     rbya+2.d0*bdx01
      ec(164)=ec(164)+qdy*bda0+wqy*bda1+2.d0*ryda+     rbxa
      ec(165)=ec(165)+qdz*bda0+wqz*bda1                    
      ec(166)=ec(166)+qdx*bdb0+wqx*bdb1          +     rbyb
      ec(167)=ec(167)+qdy*bdb0+wqy*bdb1+2.d0*rydb+     rbxb+2.d0*bdy01
      ec(168)=ec(168)+qdz*bdb0+wqz*bdb1                    
      ec(169)=ec(169)+qdx*bdc0+wqx*bdc1          +     rbyc
      ec(170)=ec(170)+qdy*bdc0+wqy*bdc1+2.d0*rydc+     rbxc
      ec(171)=ec(171)+qdz*bdc0+wqz*bdc1                    +2.d0*bdz01
      ec(172)=ec(172)+qdx*bdd0+wqx*bdd1          +     rbyd+     bdy01
      ec(173)=ec(173)+qdy*bdd0+wqy*bdd1+2.d0*rydd+     rbxd+     bdx01
      ec(174)=ec(174)+qdz*bdd0+wqz*bdd1                    
      ec(175)=ec(175)+qdx*bde0+wqx*bde1          +     rbye+     bdz01
      ec(176)=ec(176)+qdy*bde0+wqy*bde1+2.d0*ryde+     rbxe
      ec(177)=ec(177)+qdz*bde0+wqz*bde1                    +     bdx01
      ec(178)=ec(178)+qdx*bdf0+wqx*bdf1          +     rbyf
      ec(179)=ec(179)+qdy*bdf0+wqy*bdf1+2.d0*rydf+     rbxf+     bdz01
      ec(180)=ec(180)+qdz*bdf0+wqz*bdf1                    +     bdy01
      ec(181)=ec(181)+qdx*bea0+wqx*bea1          +     rbza+2.d0*bex01
      ec(182)=ec(182)+qdy*bea0+wqy*bea1+2.d0*ryea          
      ec(183)=ec(183)+qdz*bea0+wqz*bea1          +     rbxa
      ec(184)=ec(184)+qdx*beb0+wqx*beb1          +     rbzb
      ec(185)=ec(185)+qdy*beb0+wqy*beb1+2.d0*ryeb          +2.d0*bey01
      ec(186)=ec(186)+qdz*beb0+wqz*beb1          +     rbxb
      ec(187)=ec(187)+qdx*bec0+wqx*bec1          +     rbzc
      ec(188)=ec(188)+qdy*bec0+wqy*bec1+2.d0*ryec          
      ec(189)=ec(189)+qdz*bec0+wqz*bec1          +     rbxc+2.d0*bez01
      ec(190)=ec(190)+qdx*bed0+wqx*bed1          +     rbzd+     bey01
      ec(191)=ec(191)+qdy*bed0+wqy*bed1+2.d0*ryed          +     bex01
      ec(192)=ec(192)+qdz*bed0+wqz*bed1          +     rbxd
      ec(193)=ec(193)+qdx*bee0+wqx*bee1          +     rbze+     bez01
      ec(194)=ec(194)+qdy*bee0+wqy*bee1+2.d0*ryee          
      ec(195)=ec(195)+qdz*bee0+wqz*bee1          +     rbxe+     bex01
      ec(196)=ec(196)+qdx*bef0+wqx*bef1          +     rbzf
      ec(197)=ec(197)+qdy*bef0+wqy*bef1+2.d0*ryef          +     bez01
      ec(198)=ec(198)+qdz*bef0+wqz*bef1          +     rbxf+     bey01
      ec(199)=ec(199)+qdx*bfa0+wqx*bfa1                    +2.d0*bfx01
      ec(200)=ec(200)+qdy*bfa0+wqy*bfa1+2.d0*ryfa+     rbza
      ec(201)=ec(201)+qdz*bfa0+wqz*bfa1          +     rbya
      ec(202)=ec(202)+qdx*bfb0+wqx*bfb1                    
      ec(203)=ec(203)+qdy*bfb0+wqy*bfb1+2.d0*ryfb+     rbzb+2.d0*bfy01
      ec(204)=ec(204)+qdz*bfb0+wqz*bfb1          +     rbyb
      ec(205)=ec(205)+qdx*bfc0+wqx*bfc1                    
      ec(206)=ec(206)+qdy*bfc0+wqy*bfc1+2.d0*ryfc+     rbzc
      ec(207)=ec(207)+qdz*bfc0+wqz*bfc1          +     rbyc+2.d0*bfz01
      ec(208)=ec(208)+qdx*bfd0+wqx*bfd1                    +     bfy01
      ec(209)=ec(209)+qdy*bfd0+wqy*bfd1+2.d0*ryfd+     rbzd+     bfx01
      ec(210)=ec(210)+qdz*bfd0+wqz*bfd1          +     rbyd
      ec(211)=ec(211)+qdx*bfe0+wqx*bfe1                    +     bfz01
      ec(212)=ec(212)+qdy*bfe0+wqy*bfe1+2.d0*ryfe+     rbze
      ec(213)=ec(213)+qdz*bfe0+wqz*bfe1          +     rbye+     bfx01
      ec(214)=ec(214)+qdx*bff0+wqx*bff1                    
      ec(215)=ec(215)+qdy*bff0+wqy*bff1+2.d0*ryff+     rbzf+     bfz01
      ec(216)=ec(216)+qdz*bff0+wqz*bff1          +     rbyf+     bfy01
      ec(217)=ec(217)+qdx*caa0+wqx*caa1          +2.d0*rcxa+2.d0*cax01
      ec(218)=ec(218)+qdy*caa0+wqy*caa1                    
      ec(219)=ec(219)+qdz*caa0+wqz*caa1+2.d0*rzaa          
      ec(220)=ec(220)+qdx*cab0+wqx*cab1          +2.d0*rcxb
      ec(221)=ec(221)+qdy*cab0+wqy*cab1                    +2.d0*cay01
      ec(222)=ec(222)+qdz*cab0+wqz*cab1+2.d0*rzab          
      ec(223)=ec(223)+qdx*cac0+wqx*cac1          +2.d0*rcxc
      ec(224)=ec(224)+qdy*cac0+wqy*cac1                    
      ec(225)=ec(225)+qdz*cac0+wqz*cac1+2.d0*rzac          +2.d0*caz01
      ec(226)=ec(226)+qdx*cad0+wqx*cad1          +2.d0*rcxd+     cay01
      ec(227)=ec(227)+qdy*cad0+wqy*cad1                    +     cax01
      ec(228)=ec(228)+qdz*cad0+wqz*cad1+2.d0*rzad          
      ec(229)=ec(229)+qdx*cae0+wqx*cae1          +2.d0*rcxe+     caz01
      ec(230)=ec(230)+qdy*cae0+wqy*cae1                    
      ec(231)=ec(231)+qdz*cae0+wqz*cae1+2.d0*rzae          +     cax01
      ec(232)=ec(232)+qdx*caf0+wqx*caf1          +2.d0*rcxf
      ec(233)=ec(233)+qdy*caf0+wqy*caf1                    +     caz01
      ec(234)=ec(234)+qdz*caf0+wqz*caf1+2.d0*rzaf          +     cay01
      ec(235)=ec(235)+qdx*cba0+wqx*cba1                    +2.d0*cbx01
      ec(236)=ec(236)+qdy*cba0+wqy*cba1          +2.d0*rcya
      ec(237)=ec(237)+qdz*cba0+wqz*cba1+2.d0*rzba          
      ec(238)=ec(238)+qdx*cbb0+wqx*cbb1                    
      ec(239)=ec(239)+qdy*cbb0+wqy*cbb1          +2.d0*rcyb+2.d0*cby01
      ec(240)=ec(240)+qdz*cbb0+wqz*cbb1+2.d0*rzbb          
      ec(241)=ec(241)+qdx*cbc0+wqx*cbc1                    
      ec(242)=ec(242)+qdy*cbc0+wqy*cbc1          +2.d0*rcyc
      ec(243)=ec(243)+qdz*cbc0+wqz*cbc1+2.d0*rzbc          +2.d0*cbz01
      ec(244)=ec(244)+qdx*cbd0+wqx*cbd1                    +     cby01
      ec(245)=ec(245)+qdy*cbd0+wqy*cbd1          +2.d0*rcyd+     cbx01
      ec(246)=ec(246)+qdz*cbd0+wqz*cbd1+2.d0*rzbd          
      ec(247)=ec(247)+qdx*cbe0+wqx*cbe1                    +     cbz01
      ec(248)=ec(248)+qdy*cbe0+wqy*cbe1          +2.d0*rcye
      ec(249)=ec(249)+qdz*cbe0+wqz*cbe1+2.d0*rzbe          +     cbx01
      ec(250)=ec(250)+qdx*cbf0+wqx*cbf1                    
      ec(251)=ec(251)+qdy*cbf0+wqy*cbf1          +2.d0*rcyf+     cbz01
      ec(252)=ec(252)+qdz*cbf0+wqz*cbf1+2.d0*rzbf          +     cby01

      ec(253)=ec(253)+qdx*cca0+wqx*cca1                    +2.d0*ccx01
      ec(254)=ec(254)+qdy*cca0+wqy*cca1                    
      ec(255)=ec(255)+qdz*cca0+wqz*cca1+2.d0*rzca+2.d0*rcza
      ec(256)=ec(256)+qdx*ccb0+wqx*ccb1                    
      ec(257)=ec(257)+qdy*ccb0+wqy*ccb1                    +2.d0*ccy01
      ec(258)=ec(258)+qdz*ccb0+wqz*ccb1+2.d0*rzcb+2.d0*rczb
      ec(259)=ec(259)+qdx*ccc0+wqx*ccc1                    
      ec(260)=ec(260)+qdy*ccc0+wqy*ccc1                    
      ec(261)=ec(261)+qdz*ccc0+wqz*ccc1+2.d0*rzcc+2.d0*rczc+2.d0*ccz01
      ec(262)=ec(262)+qdx*ccd0+wqx*ccd1                    +     ccy01
      ec(263)=ec(263)+qdy*ccd0+wqy*ccd1                    +     ccx01
      ec(264)=ec(264)+qdz*ccd0+wqz*ccd1+2.d0*rzcd+2.d0*rczd
      ec(265)=ec(265)+qdx*cce0+wqx*cce1                    +     ccz01
      ec(266)=ec(266)+qdy*cce0+wqy*cce1                    
      ec(267)=ec(267)+qdz*cce0+wqz*cce1+2.d0*rzce+2.d0*rcze+     ccx01
      ec(268)=ec(268)+qdx*ccf0+wqx*ccf1                    
      ec(269)=ec(269)+qdy*ccf0+wqy*ccf1                    +     ccz01
      ec(270)=ec(270)+qdz*ccf0+wqz*ccf1+2.d0*rzcf+2.d0*rczf+     ccy01
      ec(271)=ec(271)+qdx*cda0+wqx*cda1          +     rcya+2.d0*cdx01
      ec(272)=ec(272)+qdy*cda0+wqy*cda1          +     rcxa
      ec(273)=ec(273)+qdz*cda0+wqz*cda1+2.d0*rzda          
      ec(274)=ec(274)+qdx*cdb0+wqx*cdb1          +     rcyb
      ec(275)=ec(275)+qdy*cdb0+wqy*cdb1          +     rcxb+2.d0*cdy01
      ec(276)=ec(276)+qdz*cdb0+wqz*cdb1+2.d0*rzdb          
      ec(277)=ec(277)+qdx*cdc0+wqx*cdc1          +     rcyc
      ec(278)=ec(278)+qdy*cdc0+wqy*cdc1          +     rcxc
      ec(279)=ec(279)+qdz*cdc0+wqz*cdc1+2.d0*rzdc          +2.d0*cdz01
      ec(280)=ec(280)+qdx*cdd0+wqx*cdd1          +     rcyd+     cdy01
      ec(281)=ec(281)+qdy*cdd0+wqy*cdd1          +     rcxd+     cdx01
      ec(282)=ec(282)+qdz*cdd0+wqz*cdd1+2.d0*rzdd          
      ec(283)=ec(283)+qdx*cde0+wqx*cde1          +     rcye+     cdz01
      ec(284)=ec(284)+qdy*cde0+wqy*cde1          +     rcxe
      ec(285)=ec(285)+qdz*cde0+wqz*cde1+2.d0*rzde          +     cdx01
      ec(286)=ec(286)+qdx*cdf0+wqx*cdf1          +     rcyf
      ec(287)=ec(287)+qdy*cdf0+wqy*cdf1          +     rcxf+     cdz01
      ec(288)=ec(288)+qdz*cdf0+wqz*cdf1+2.d0*rzdf          +     cdy01
      ec(289)=ec(289)+qdx*cea0+wqx*cea1          +     rcza+2.d0*cex01
      ec(290)=ec(290)+qdy*cea0+wqy*cea1                    
      ec(291)=ec(291)+qdz*cea0+wqz*cea1+2.d0*rzea+     rcxa
      ec(292)=ec(292)+qdx*ceb0+wqx*ceb1          +     rczb
      ec(293)=ec(293)+qdy*ceb0+wqy*ceb1                    +2.d0*cey01
      ec(294)=ec(294)+qdz*ceb0+wqz*ceb1+2.d0*rzeb+     rcxb
      ec(295)=ec(295)+qdx*cec0+wqx*cec1          +     rczc
      ec(296)=ec(296)+qdy*cec0+wqy*cec1                    
      ec(297)=ec(297)+qdz*cec0+wqz*cec1+2.d0*rzec+     rcxc+2.d0*cez01
      ec(298)=ec(298)+qdx*ced0+wqx*ced1          +     rczd+     cey01
      ec(299)=ec(299)+qdy*ced0+wqy*ced1                    +     cex01
      ec(300)=ec(300)+qdz*ced0+wqz*ced1+2.d0*rzed+     rcxd
      ec(301)=ec(301)+qdx*cee0+wqx*cee1          +     rcze+     cez01
      ec(302)=ec(302)+qdy*cee0+wqy*cee1                    
      ec(303)=ec(303)+qdz*cee0+wqz*cee1+2.d0*rzee+     rcxe+     cex01
      ec(304)=ec(304)+qdx*cef0+wqx*cef1          +     rczf
      ec(305)=ec(305)+qdy*cef0+wqy*cef1                    +     cez01
      ec(306)=ec(306)+qdz*cef0+wqz*cef1+2.d0*rzef+     rcxf+     cey01
      ec(307)=ec(307)+qdx*cfa0+wqx*cfa1                    +2.d0*cfx01
      ec(308)=ec(308)+qdy*cfa0+wqy*cfa1          +     rcza
      ec(309)=ec(309)+qdz*cfa0+wqz*cfa1+2.d0*rzfa+     rcya
      ec(310)=ec(310)+qdx*cfb0+wqx*cfb1                    
      ec(311)=ec(311)+qdy*cfb0+wqy*cfb1          +     rczb+2.d0*cfy01
      ec(312)=ec(312)+qdz*cfb0+wqz*cfb1+2.d0*rzfb+     rcyb
      ec(313)=ec(313)+qdx*cfc0+wqx*cfc1                    
      ec(314)=ec(314)+qdy*cfc0+wqy*cfc1          +     rczc
      ec(315)=ec(315)+qdz*cfc0+wqz*cfc1+2.d0*rzfc+     rcyc+2.d0*cfz01
      ec(316)=ec(316)+qdx*cfd0+wqx*cfd1                    +     cfy01
      ec(317)=ec(317)+qdy*cfd0+wqy*cfd1          +     rczd+     cfx01
      ec(318)=ec(318)+qdz*cfd0+wqz*cfd1+2.d0*rzfd+     rcyd
      ec(319)=ec(319)+qdx*cfe0+wqx*cfe1                    +     cfz01
      ec(320)=ec(320)+qdy*cfe0+wqy*cfe1          +     rcze
      ec(321)=ec(321)+qdz*cfe0+wqz*cfe1+2.d0*rzfe+     rcye+     cfx01
      ec(322)=ec(322)+qdx*cff0+wqx*cff1                    
      ec(323)=ec(323)+qdy*cff0+wqy*cff1          +     rczf+     cfz01
      ec(324)=ec(324)+qdz*cff0+wqz*cff1+2.d0*rzff+     rcyf+     cfy01
      ec(325)=ec(325)+qdx*daa0+wqx*daa1+     ryaa+2.d0*rdxa+2.d0*dax01
      ec(326)=ec(326)+qdy*daa0+wqy*daa1+     rxaa          
      ec(327)=ec(327)+qdz*daa0+wqz*daa1                    
      ec(328)=ec(328)+qdx*dab0+wqx*dab1+     ryab+2.d0*rdxb
      ec(329)=ec(329)+qdy*dab0+wqy*dab1+     rxab          +2.d0*day01
      ec(330)=ec(330)+qdz*dab0+wqz*dab1                    
      ec(331)=ec(331)+qdx*dac0+wqx*dac1+     ryac+2.d0*rdxc
      ec(332)=ec(332)+qdy*dac0+wqy*dac1+     rxac          
      ec(333)=ec(333)+qdz*dac0+wqz*dac1                    +2.d0*daz01
      ec(334)=ec(334)+qdx*dad0+wqx*dad1+     ryad+2.d0*rdxd+     day01
      ec(335)=ec(335)+qdy*dad0+wqy*dad1+     rxad          +     dax01
      ec(336)=ec(336)+qdz*dad0+wqz*dad1                    
      ec(337)=ec(337)+qdx*dae0+wqx*dae1+     ryae+2.d0*rdxe+     daz01
      ec(338)=ec(338)+qdy*dae0+wqy*dae1+     rxae          
      ec(339)=ec(339)+qdz*dae0+wqz*dae1                    +     dax01
      ec(340)=ec(340)+qdx*daf0+wqx*daf1+     ryaf+2.d0*rdxf
      ec(341)=ec(341)+qdy*daf0+wqy*daf1+     rxaf          +     daz01
      ec(342)=ec(342)+qdz*daf0+wqz*daf1                    +     day01
      ec(343)=ec(343)+qdx*dba0+wqx*dba1+     ryba          +2.d0*dbx01
      ec(344)=ec(344)+qdy*dba0+wqy*dba1+     rxba+2.d0*rdya
      ec(345)=ec(345)+qdz*dba0+wqz*dba1                    
      ec(346)=ec(346)+qdx*dbb0+wqx*dbb1+     rybb          
      ec(347)=ec(347)+qdy*dbb0+wqy*dbb1+     rxbb+2.d0*rdyb+2.d0*dby01
      ec(348)=ec(348)+qdz*dbb0+wqz*dbb1                    
      ec(349)=ec(349)+qdx*dbc0+wqx*dbc1+     rybc          
      ec(350)=ec(350)+qdy*dbc0+wqy*dbc1+     rxbc+2.d0*rdyc
      ec(351)=ec(351)+qdz*dbc0+wqz*dbc1                    +2.d0*dbz01
      ec(352)=ec(352)+qdx*dbd0+wqx*dbd1+     rybd          +     dby01
      ec(353)=ec(353)+qdy*dbd0+wqy*dbd1+     rxbd+2.d0*rdyd+     dbx01
      ec(354)=ec(354)+qdz*dbd0+wqz*dbd1                    
      ec(355)=ec(355)+qdx*dbe0+wqx*dbe1+     rybe          +     dbz01
      ec(356)=ec(356)+qdy*dbe0+wqy*dbe1+     rxbe+2.d0*rdye
      ec(357)=ec(357)+qdz*dbe0+wqz*dbe1                    +     dbx01
      ec(358)=ec(358)+qdx*dbf0+wqx*dbf1+     rybf          
      ec(359)=ec(359)+qdy*dbf0+wqy*dbf1+     rxbf+2.d0*rdyf+     dbz01
      ec(360)=ec(360)+qdz*dbf0+wqz*dbf1                    +     dby01
      ec(361)=ec(361)+qdx*dca0+wqx*dca1+     ryca          +2.d0*dcx01
      ec(362)=ec(362)+qdy*dca0+wqy*dca1+     rxca          
      ec(363)=ec(363)+qdz*dca0+wqz*dca1          +2.d0*rdza
      ec(364)=ec(364)+qdx*dcb0+wqx*dcb1+     rycb          
      ec(365)=ec(365)+qdy*dcb0+wqy*dcb1+     rxcb          +2.d0*dcy01
      ec(366)=ec(366)+qdz*dcb0+wqz*dcb1          +2.d0*rdzb
      ec(367)=ec(367)+qdx*dcc0+wqx*dcc1+     rycc          
      ec(368)=ec(368)+qdy*dcc0+wqy*dcc1+     rxcc          
      ec(369)=ec(369)+qdz*dcc0+wqz*dcc1          +2.d0*rdzc+2.d0*dcz01
      ec(370)=ec(370)+qdx*dcd0+wqx*dcd1+     rycd          +     dcy01
      ec(371)=ec(371)+qdy*dcd0+wqy*dcd1+     rxcd          +     dcx01
      ec(372)=ec(372)+qdz*dcd0+wqz*dcd1          +2.d0*rdzd
      ec(373)=ec(373)+qdx*dce0+wqx*dce1+     ryce          +     dcz01
      ec(374)=ec(374)+qdy*dce0+wqy*dce1+     rxce          
      ec(375)=ec(375)+qdz*dce0+wqz*dce1          +2.d0*rdze+     dcx01
      ec(376)=ec(376)+qdx*dcf0+wqx*dcf1+     rycf          
      ec(377)=ec(377)+qdy*dcf0+wqy*dcf1+     rxcf          +     dcz01
      ec(378)=ec(378)+qdz*dcf0+wqz*dcf1          +2.d0*rdzf+     dcy01
      ec(379)=ec(379)+qdx*dda0+wqx*dda1+     ryda+     rdya+2.d0*ddx01
      ec(380)=ec(380)+qdy*dda0+wqy*dda1+     rxda+     rdxa
      ec(381)=ec(381)+qdz*dda0+wqz*dda1                    
      ec(382)=ec(382)+qdx*ddb0+wqx*ddb1+     rydb+     rdyb
      ec(383)=ec(383)+qdy*ddb0+wqy*ddb1+     rxdb+     rdxb+2.d0*ddy01
      ec(384)=ec(384)+qdz*ddb0+wqz*ddb1                    
      ec(385)=ec(385)+qdx*ddc0+wqx*ddc1+     rydc+     rdyc
      ec(386)=ec(386)+qdy*ddc0+wqy*ddc1+     rxdc+     rdxc
      ec(387)=ec(387)+qdz*ddc0+wqz*ddc1                    +2.d0*ddz01
      ec(388)=ec(388)+qdx*ddd0+wqx*ddd1+     rydd+     rdyd+     ddy01
      ec(389)=ec(389)+qdy*ddd0+wqy*ddd1+     rxdd+     rdxd+     ddx01
      ec(390)=ec(390)+qdz*ddd0+wqz*ddd1                    
      ec(391)=ec(391)+qdx*dde0+wqx*dde1+     ryde+     rdye+     ddz01
      ec(392)=ec(392)+qdy*dde0+wqy*dde1+     rxde+     rdxe
      ec(393)=ec(393)+qdz*dde0+wqz*dde1                    +     ddx01
      ec(394)=ec(394)+qdx*ddf0+wqx*ddf1+     rydf+     rdyf
      ec(395)=ec(395)+qdy*ddf0+wqy*ddf1+     rxdf+     rdxf+     ddz01
      ec(396)=ec(396)+qdz*ddf0+wqz*ddf1                    +     ddy01
      ec(397)=ec(397)+qdx*dea0+wqx*dea1+     ryea+     rdza+2.d0*dex01
      ec(398)=ec(398)+qdy*dea0+wqy*dea1+     rxea
      ec(399)=ec(399)+qdz*dea0+wqz*dea1          +     rdxa
      ec(400)=ec(400)+qdx*deb0+wqx*deb1+     ryeb+     rdzb
      ec(401)=ec(401)+qdy*deb0+wqy*deb1+     rxeb          +2.d0*dey01
      ec(402)=ec(402)+qdz*deb0+wqz*deb1          +     rdxb
      ec(403)=ec(403)+qdx*dec0+wqx*dec1+     ryec+     rdzc
      ec(404)=ec(404)+qdy*dec0+wqy*dec1+     rxec
      ec(405)=ec(405)+qdz*dec0+wqz*dec1          +     rdxc+2.d0*dez01
      ec(406)=ec(406)+qdx*ded0+wqx*ded1+     ryed+     rdzd+     dey01
      ec(407)=ec(407)+qdy*ded0+wqy*ded1+     rxed          +     dex01
      ec(408)=ec(408)+qdz*ded0+wqz*ded1          +     rdxd
      ec(409)=ec(409)+qdx*dee0+wqx*dee1+     ryee+     rdze+     dez01
      ec(410)=ec(410)+qdy*dee0+wqy*dee1+     rxee 
      ec(411)=ec(411)+qdz*dee0+wqz*dee1          +     rdxe+     dex01
      ec(412)=ec(412)+qdx*def0+wqx*def1+     ryef+     rdzf
      ec(413)=ec(413)+qdy*def0+wqy*def1+     rxef          +     dez01
      ec(414)=ec(414)+qdz*def0+wqz*def1          +     rdxf+     dey01
      ec(415)=ec(415)+qdx*dfa0+wqx*dfa1+     ryfa          +2.d0*dfx01
      ec(416)=ec(416)+qdy*dfa0+wqy*dfa1+     rxfa+     rdza
      ec(417)=ec(417)+qdz*dfa0+wqz*dfa1          +     rdya
      ec(418)=ec(418)+qdx*dfb0+wqx*dfb1+     ryfb                    
      ec(419)=ec(419)+qdy*dfb0+wqy*dfb1+     rxfb+     rdzb+2.d0*dfy01
      ec(420)=ec(420)+qdz*dfb0+wqz*dfb1          +     rdyb
      ec(421)=ec(421)+qdx*dfc0+wqx*dfc1+     ryfc                    
      ec(422)=ec(422)+qdy*dfc0+wqy*dfc1+     rxfc+     rdzc
      ec(423)=ec(423)+qdz*dfc0+wqz*dfc1          +     rdyc+2.d0*dfz01
      ec(424)=ec(424)+qdx*dfd0+wqx*dfd1+     ryfd          +     dfy01
      ec(425)=ec(425)+qdy*dfd0+wqy*dfd1+     rxfd+     rdzd+     dfx01
      ec(426)=ec(426)+qdz*dfd0+wqz*dfd1          +     rdyd
      ec(427)=ec(427)+qdx*dfe0+wqx*dfe1+     ryfe          +     dfz01
      ec(428)=ec(428)+qdy*dfe0+wqy*dfe1+     rxfe+     rdze
      ec(429)=ec(429)+qdz*dfe0+wqz*dfe1          +     rdye+     dfx01
      ec(430)=ec(430)+qdx*dff0+wqx*dff1+     ryff                   
      ec(431)=ec(431)+qdy*dff0+wqy*dff1+     rxff+     rdzf+     dfz01
      ec(432)=ec(432)+qdz*dff0+wqz*dff1          +     rdyf+     dfy01
      ec(433)=ec(433)+qdx*eaa0+wqx*eaa1+     rzaa+2.d0*rexa+2.d0*eax01
      ec(434)=ec(434)+qdy*eaa0+wqy*eaa1                    
      ec(435)=ec(435)+qdz*eaa0+wqz*eaa1+     rxaa          
      ec(436)=ec(436)+qdx*eab0+wqx*eab1+     rzab+2.d0*rexb
      ec(437)=ec(437)+qdy*eab0+wqy*eab1                    +2.d0*eay01
      ec(438)=ec(438)+qdz*eab0+wqz*eab1+     rxab          
      ec(439)=ec(439)+qdx*eac0+wqx*eac1+     rzac+2.d0*rexc
      ec(440)=ec(440)+qdy*eac0+wqy*eac1                    
      ec(441)=ec(441)+qdz*eac0+wqz*eac1+     rxac          +2.d0*eaz01
      ec(442)=ec(442)+qdx*ead0+wqx*ead1+     rzad+2.d0*rexd+     eay01
      ec(443)=ec(443)+qdy*ead0+wqy*ead1                    +     eax01
      ec(444)=ec(444)+qdz*ead0+wqz*ead1+     rxad          
      ec(445)=ec(445)+qdx*eae0+wqx*eae1+     rzae+2.d0*rexe+     eaz01
      ec(446)=ec(446)+qdy*eae0+wqy*eae1                    
      ec(447)=ec(447)+qdz*eae0+wqz*eae1+     rxae          +     eax01
      ec(448)=ec(448)+qdx*eaf0+wqx*eaf1+     rzaf+2.d0*rexf
      ec(449)=ec(449)+qdy*eaf0+wqy*eaf1                    +     eaz01
      ec(450)=ec(450)+qdz*eaf0+wqz*eaf1+     rxaf          +     eay01
      ec(451)=ec(451)+qdx*eba0+wqx*eba1+     rzba          +2.d0*ebx01
      ec(452)=ec(452)+qdy*eba0+wqy*eba1          +2.d0*reya
      ec(453)=ec(453)+qdz*eba0+wqz*eba1+     rxba          
      ec(454)=ec(454)+qdx*ebb0+wqx*ebb1+     rzbb          
      ec(455)=ec(455)+qdy*ebb0+wqy*ebb1          +2.d0*reyb+2.d0*eby01
      ec(456)=ec(456)+qdz*ebb0+wqz*ebb1+     rxbb          
      ec(457)=ec(457)+qdx*ebc0+wqx*ebc1+     rzbc          
      ec(458)=ec(458)+qdy*ebc0+wqy*ebc1          +2.d0*reyc
      ec(459)=ec(459)+qdz*ebc0+wqz*ebc1+     rxbc          +2.d0*ebz01
      ec(460)=ec(460)+qdx*ebd0+wqx*ebd1+     rzbd          +     eby01
      ec(461)=ec(461)+qdy*ebd0+wqy*ebd1          +2.d0*reyd+     ebx01
      ec(462)=ec(462)+qdz*ebd0+wqz*ebd1+     rxbd          
      ec(463)=ec(463)+qdx*ebe0+wqx*ebe1+     rzbe          +     ebz01
      ec(464)=ec(464)+qdy*ebe0+wqy*ebe1          +2.d0*reye
      ec(465)=ec(465)+qdz*ebe0+wqz*ebe1+     rxbe          +     ebx01
      ec(466)=ec(466)+qdx*ebf0+wqx*ebf1+     rzbf          
      ec(467)=ec(467)+qdy*ebf0+wqy*ebf1          +2.d0*reyf+     ebz01
      ec(468)=ec(468)+qdz*ebf0+wqz*ebf1+     rxbf          +     eby01
      ec(469)=ec(469)+qdx*eca0+wqx*eca1+     rzca          +2.d0*ecx01
      ec(470)=ec(470)+qdy*eca0+wqy*eca1                    
      ec(471)=ec(471)+qdz*eca0+wqz*eca1+     rxca+2.d0*reza
      ec(472)=ec(472)+qdx*ecb0+wqx*ecb1+     rzcb          
      ec(473)=ec(473)+qdy*ecb0+wqy*ecb1                    +2.d0*ecy01
      ec(474)=ec(474)+qdz*ecb0+wqz*ecb1+     rxcb+2.d0*rezb
      ec(475)=ec(475)+qdx*ecc0+wqx*ecc1+     rzcc          
      ec(476)=ec(476)+qdy*ecc0+wqy*ecc1                    
      ec(477)=ec(477)+qdz*ecc0+wqz*ecc1+     rxcc+2.d0*rezc+2.d0*ecz01
      ec(478)=ec(478)+qdx*ecd0+wqx*ecd1+     rzcd          +     ecy01
      ec(479)=ec(479)+qdy*ecd0+wqy*ecd1                    +     ecx01
      ec(480)=ec(480)+qdz*ecd0+wqz*ecd1+     rxcd+2.d0*rezd
      ec(481)=ec(481)+qdx*ece0+wqx*ece1+     rzce          +     ecz01
      ec(482)=ec(482)+qdy*ece0+wqy*ece1                    
      ec(483)=ec(483)+qdz*ece0+wqz*ece1+     rxce+2.d0*reze+     ecx01
      ec(484)=ec(484)+qdx*ecf0+wqx*ecf1+     rzcf          
      ec(485)=ec(485)+qdy*ecf0+wqy*ecf1                    +     ecz01
      ec(486)=ec(486)+qdz*ecf0+wqz*ecf1+     rxcf+2.d0*rezf+     ecy01
      ec(487)=ec(487)+qdx*eda0+wqx*eda1+     rzda+     reya+2.d0*edx01
      ec(488)=ec(488)+qdy*eda0+wqy*eda1          +     rexa
      ec(489)=ec(489)+qdz*eda0+wqz*eda1+     rxda          
      ec(490)=ec(490)+qdx*edb0+wqx*edb1+     rzdb+     reyb
      ec(491)=ec(491)+qdy*edb0+wqy*edb1          +     rexb+2.d0*edy01
      ec(492)=ec(492)+qdz*edb0+wqz*edb1+     rxdb          
      ec(493)=ec(493)+qdx*edc0+wqx*edc1+     rzdc+     reyc
      ec(494)=ec(494)+qdy*edc0+wqy*edc1          +     rexc
      ec(495)=ec(495)+qdz*edc0+wqz*edc1+     rxdc          +2.d0*edz01
      ec(496)=ec(496)+qdx*edd0+wqx*edd1+     rzdd+     reyd+     edy01
      ec(497)=ec(497)+qdy*edd0+wqy*edd1          +     rexd+     edx01
      ec(498)=ec(498)+qdz*edd0+wqz*edd1+     rxdd          
      ec(499)=ec(499)+qdx*ede0+wqx*ede1+     rzde+     reye+     edz01
      ec(500)=ec(500)+qdy*ede0+wqy*ede1          +     rexe
      ec(501)=ec(501)+qdz*ede0+wqz*ede1+     rxde          +     edx01
      ec(502)=ec(502)+qdx*edf0+wqx*edf1+     rzdf+     reyf
      ec(503)=ec(503)+qdy*edf0+wqy*edf1          +     rexf+     edz01
      ec(504)=ec(504)+qdz*edf0+wqz*edf1+     rxdf          +     edy01
      ec(505)=ec(505)+qdx*eea0+wqx*eea1+     rzea+     reza+2.d0*eex01
      ec(506)=ec(506)+qdy*eea0+wqy*eea1                    
      ec(507)=ec(507)+qdz*eea0+wqz*eea1+     rxea+     rexa
      ec(508)=ec(508)+qdx*eeb0+wqx*eeb1+     rzeb+     rezb
      ec(509)=ec(509)+qdy*eeb0+wqy*eeb1                    +2.d0*eey01
      ec(510)=ec(510)+qdz*eeb0+wqz*eeb1+     rxeb+     rexb
      ec(511)=ec(511)+qdx*eec0+wqx*eec1+     rzec+     rezc
      ec(512)=ec(512)+qdy*eec0+wqy*eec1                    
      ec(513)=ec(513)+qdz*eec0+wqz*eec1+     rxec+     rexc+2.d0*eez01
      ec(514)=ec(514)+qdx*eed0+wqx*eed1+     rzed+     rezd+     eey01
      ec(515)=ec(515)+qdy*eed0+wqy*eed1                    +     eex01
      ec(516)=ec(516)+qdz*eed0+wqz*eed1+     rxed+     rexd
      ec(517)=ec(517)+qdx*eee0+wqx*eee1+     rzee+     reze+     eez01
      ec(518)=ec(518)+qdy*eee0+wqy*eee1                    
      ec(519)=ec(519)+qdz*eee0+wqz*eee1+     rxee+     rexe+     eex01
      ec(520)=ec(520)+qdx*eef0+wqx*eef1+     rzef+     rezf
      ec(521)=ec(521)+qdy*eef0+wqy*eef1                    +     eez01
      ec(522)=ec(522)+qdz*eef0+wqz*eef1+     rxef+     rexf+     eey01
      ec(523)=ec(523)+qdx*efa0+wqx*efa1+     rzfa          +2.d0*efx01
      ec(524)=ec(524)+qdy*efa0+wqy*efa1          +     reza
      ec(525)=ec(525)+qdz*efa0+wqz*efa1+     rxfa+     reya
      ec(526)=ec(526)+qdx*efb0+wqx*efb1+     rzfb          
      ec(527)=ec(527)+qdy*efb0+wqy*efb1          +     rezb+2.d0*efy01
      ec(528)=ec(528)+qdz*efb0+wqz*efb1+     rxfb+     reyb
      ec(529)=ec(529)+qdx*efc0+wqx*efc1+     rzfc          
      ec(530)=ec(530)+qdy*efc0+wqy*efc1          +     rezc
      ec(531)=ec(531)+qdz*efc0+wqz*efc1+     rxfc+     reyc+2.d0*efz01
      ec(532)=ec(532)+qdx*efd0+wqx*efd1+     rzfd          +     efy01
      ec(533)=ec(533)+qdy*efd0+wqy*efd1          +     rezd+     efx01
      ec(534)=ec(534)+qdz*efd0+wqz*efd1+     rxfd+     reyd
      ec(535)=ec(535)+qdx*efe0+wqx*efe1+     rzfe          +     efz01
      ec(536)=ec(536)+qdy*efe0+wqy*efe1          +     reze
      ec(537)=ec(537)+qdz*efe0+wqz*efe1+     rxfe+     reye+     efx01
      ec(538)=ec(538)+qdx*eff0+wqx*eff1+     rzff          
      ec(539)=ec(539)+qdy*eff0+wqy*eff1          +     rezf+     efz01
      ec(540)=ec(540)+qdz*eff0+wqz*eff1+     rxff+     reyf+     efy01
      ec(541)=ec(541)+qdx*faa0+wqx*faa1          +2.d0*rfxa+2.d0*fax01
      ec(542)=ec(542)+qdy*faa0+wqy*faa1+     rzaa          
      ec(543)=ec(543)+qdz*faa0+wqz*faa1+     ryaa          
      ec(544)=ec(544)+qdx*fab0+wqx*fab1          +2.d0*rfxb
      ec(545)=ec(545)+qdy*fab0+wqy*fab1+     rzab          +2.d0*fay01
      ec(546)=ec(546)+qdz*fab0+wqz*fab1+     ryab          
      ec(547)=ec(547)+qdx*fac0+wqx*fac1          +2.d0*rfxc
      ec(548)=ec(548)+qdy*fac0+wqy*fac1+     rzac          
      ec(549)=ec(549)+qdz*fac0+wqz*fac1+     ryac          +2.d0*faz01
      ec(550)=ec(550)+qdx*fad0+wqx*fad1          +2.d0*rfxd+     fay01
      ec(551)=ec(551)+qdy*fad0+wqy*fad1+     rzad          +     fax01
      ec(552)=ec(552)+qdz*fad0+wqz*fad1+     ryad          
      ec(553)=ec(553)+qdx*fae0+wqx*fae1          +2.d0*rfxe+     faz01
      ec(554)=ec(554)+qdy*fae0+wqy*fae1+     rzae          
      ec(555)=ec(555)+qdz*fae0+wqz*fae1+     ryae          +     fax01
      ec(556)=ec(556)+qdx*faf0+wqx*faf1          +2.d0*rfxf
      ec(557)=ec(557)+qdy*faf0+wqy*faf1+     rzaf          +     faz01
      ec(558)=ec(558)+qdz*faf0+wqz*faf1+     ryaf          +     fay01
      ec(559)=ec(559)+qdx*fba0+wqx*fba1                    +2.d0*fbx01
      ec(560)=ec(560)+qdy*fba0+wqy*fba1+     rzba+2.d0*rfya
      ec(561)=ec(561)+qdz*fba0+wqz*fba1+     ryba          
      ec(562)=ec(562)+qdx*fbb0+wqx*fbb1                    
      ec(563)=ec(563)+qdy*fbb0+wqy*fbb1+     rzbb+2.d0*rfyb+2.d0*fby01
      ec(564)=ec(564)+qdz*fbb0+wqz*fbb1+     rybb          
      ec(565)=ec(565)+qdx*fbc0+wqx*fbc1                    
      ec(566)=ec(566)+qdy*fbc0+wqy*fbc1+     rzbc+2.d0*rfyc
      ec(567)=ec(567)+qdz*fbc0+wqz*fbc1+     rybc          +2.d0*fbz01
      ec(568)=ec(568)+qdx*fbd0+wqx*fbd1                    +     fby01
      ec(569)=ec(569)+qdy*fbd0+wqy*fbd1+     rzbd+2.d0*rfyd+     fbx01
      ec(570)=ec(570)+qdz*fbd0+wqz*fbd1+     rybd          
      ec(571)=ec(571)+qdx*fbe0+wqx*fbe1                    +     fbz01
      ec(572)=ec(572)+qdy*fbe0+wqy*fbe1+     rzbe+2.d0*rfye
      ec(573)=ec(573)+qdz*fbe0+wqz*fbe1+     rybe          +     fbx01
      ec(574)=ec(574)+qdx*fbf0+wqx*fbf1                    
      ec(575)=ec(575)+qdy*fbf0+wqy*fbf1+     rzbf+2.d0*rfyf+     fbz01
      ec(576)=ec(576)+qdz*fbf0+wqz*fbf1+     rybf          +     fby01
      ec(577)=ec(577)+qdx*fca0+wqx*fca1                    +2.d0*fcx01
      ec(578)=ec(578)+qdy*fca0+wqy*fca1+     rzca          
      ec(579)=ec(579)+qdz*fca0+wqz*fca1+     ryca+2.d0*rfza
      ec(580)=ec(580)+qdx*fcb0+wqx*fcb1                    
      ec(581)=ec(581)+qdy*fcb0+wqy*fcb1+     rzcb          +2.d0*fcy01
      ec(582)=ec(582)+qdz*fcb0+wqz*fcb1+     rycb+2.d0*rfzb
      ec(583)=ec(583)+qdx*fcc0+wqx*fcc1                    
      ec(584)=ec(584)+qdy*fcc0+wqy*fcc1+     rzcc          
      ec(585)=ec(585)+qdz*fcc0+wqz*fcc1+     rycc+2.d0*rfzc+2.d0*fcz01
      ec(586)=ec(586)+qdx*fcd0+wqx*fcd1                    +     fcy01
      ec(587)=ec(587)+qdy*fcd0+wqy*fcd1+     rzcd          +     fcx01
      ec(588)=ec(588)+qdz*fcd0+wqz*fcd1+     rycd+2.d0*rfzd
      ec(589)=ec(589)+qdx*fce0+wqx*fce1                    +     fcz01
      ec(590)=ec(590)+qdy*fce0+wqy*fce1+     rzce          
      ec(591)=ec(591)+qdz*fce0+wqz*fce1+     ryce+2.d0*rfze+     fcx01
      ec(592)=ec(592)+qdx*fcf0+wqx*fcf1                    
      ec(593)=ec(593)+qdy*fcf0+wqy*fcf1+     rzcf          +     fcz01
      ec(594)=ec(594)+qdz*fcf0+wqz*fcf1+     rycf+2.d0*rfzf+     fcy01
      ec(595)=ec(595)+qdx*fda0+wqx*fda1          +     rfya+2.d0*fdx01
      ec(596)=ec(596)+qdy*fda0+wqy*fda1+     rzda+     rfxa
      ec(597)=ec(597)+qdz*fda0+wqz*fda1+     ryda          
      ec(598)=ec(598)+qdx*fdb0+wqx*fdb1          +     rfyb
      ec(599)=ec(599)+qdy*fdb0+wqy*fdb1+     rzdb+     rfxb+2.d0*fdy01
      ec(600)=ec(600)+qdz*fdb0+wqz*fdb1+     rydb          
      ec(601)=ec(601)+qdx*fdc0+wqx*fdc1          +     rfyc
      ec(602)=ec(602)+qdy*fdc0+wqy*fdc1+     rzdc+     rfxc
      ec(603)=ec(603)+qdz*fdc0+wqz*fdc1+     rydc          +2.d0*fdz01
      ec(604)=ec(604)+qdx*fdd0+wqx*fdd1          +     rfyd+     fdy01
      ec(605)=ec(605)+qdy*fdd0+wqy*fdd1+     rzdd+     rfxd+     fdx01
      ec(606)=ec(606)+qdz*fdd0+wqz*fdd1+     rydd          
      ec(607)=ec(607)+qdx*fde0+wqx*fde1          +     rfye+     fdz01
      ec(608)=ec(608)+qdy*fde0+wqy*fde1+     rzde+     rfxe
      ec(609)=ec(609)+qdz*fde0+wqz*fde1+     ryde          +     fdx01
      ec(610)=ec(610)+qdx*fdf0+wqx*fdf1          +     rfyf
      ec(611)=ec(611)+qdy*fdf0+wqy*fdf1+     rzdf+     rfxf+     fdz01
      ec(612)=ec(612)+qdz*fdf0+wqz*fdf1+     rydf          +     fdy01
      ec(613)=ec(613)+qdx*fea0+wqx*fea1          +     rfza+2.d0*fex01
      ec(614)=ec(614)+qdy*fea0+wqy*fea1+     rzea          
      ec(615)=ec(615)+qdz*fea0+wqz*fea1+     ryea+     rfxa
      ec(616)=ec(616)+qdx*feb0+wqx*feb1          +     rfzb
      ec(617)=ec(617)+qdy*feb0+wqy*feb1+     rzeb          +2.d0*fey01
      ec(618)=ec(618)+qdz*feb0+wqz*feb1+     ryeb+     rfxb
      ec(619)=ec(619)+qdx*fec0+wqx*fec1          +     rfzc
      ec(620)=ec(620)+qdy*fec0+wqy*fec1+     rzec          
      ec(621)=ec(621)+qdz*fec0+wqz*fec1+     ryec+     rfxc+2.d0*fez01
      ec(622)=ec(622)+qdx*fed0+wqx*fed1          +     rfzd+     fey01
      ec(623)=ec(623)+qdy*fed0+wqy*fed1+     rzed          +     fex01
      ec(624)=ec(624)+qdz*fed0+wqz*fed1+     ryed+     rfxd
      ec(625)=ec(625)+qdx*fee0+wqx*fee1          +     rfze+     fez01
      ec(626)=ec(626)+qdy*fee0+wqy*fee1+     rzee          
      ec(627)=ec(627)+qdz*fee0+wqz*fee1+     ryee+     rfxe+     fex01
      ec(628)=ec(628)+qdx*fef0+wqx*fef1          +     rfzf
      ec(629)=ec(629)+qdy*fef0+wqy*fef1+     rzef          +     fez01
      ec(630)=ec(630)+qdz*fef0+wqz*fef1+     ryef+     rfxf+     fey01
      ec(631)=ec(631)+qdx*ffa0+wqx*ffa1                    +2.d0*ffx01
      ec(632)=ec(632)+qdy*ffa0+wqy*ffa1+     rzfa+     rfza
      ec(633)=ec(633)+qdz*ffa0+wqz*ffa1+     ryfa+     rfya
      ec(634)=ec(634)+qdx*ffb0+wqx*ffb1                    
      ec(635)=ec(635)+qdy*ffb0+wqy*ffb1+     rzfb+     rfzb+2.d0*ffy01
      ec(636)=ec(636)+qdz*ffb0+wqz*ffb1+     ryfb+     rfyb
      ec(637)=ec(637)+qdx*ffc0+wqx*ffc1                    
      ec(638)=ec(638)+qdy*ffc0+wqy*ffc1+     rzfc+     rfzc
      ec(639)=ec(639)+qdz*ffc0+wqz*ffc1+     ryfc+     rfyc+2.d0*ffz01
      ec(640)=ec(640)+qdx*ffd0+wqx*ffd1                    +     ffy01
      ec(641)=ec(641)+qdy*ffd0+wqy*ffd1+     rzfd+     rfzd+     ffx01
      ec(642)=ec(642)+qdz*ffd0+wqz*ffd1+     ryfd+     rfyd
      ec(643)=ec(643)+qdx*ffe0+wqx*ffe1                    +     ffz01
      ec(644)=ec(644)+qdy*ffe0+wqy*ffe1+     rzfe+     rfze
      ec(645)=ec(645)+qdz*ffe0+wqz*ffe1+     ryfe+     rfye+     ffx01
      ec(646)=ec(646)+qdx*fff0+wqx*fff1                    
      ec(647)=ec(647)+qdy*fff0+wqy*fff1+     rzff+     rfzf+     ffz01
      ec(648)=ec(648)+qdz*fff0+wqz*fff1+     ryff+     rfyf+     ffy01

 9996           enddo
 9997       enddo
 9998    enddo
 9999 enddo
#ifdef PL_OMP_ERI
!$omp end do
!$omp end parallel
#endif


      if (ierisw.eq.0) then 

        do i=325,648
          ec(i)= ec(i)*root3
        enddo

         do i=1,36
         do ii=10,18

            iii = ii + 18*(i-1)
            ec(iii)=ec(iii)*root3

         enddo
        enddo

        do i=1,6
        do ii=55,108
           iii = ii + 108*(i-1)
           ec(iii) = ec(iii)*root3
        enddo
        enddo

      endif
      
      end
