! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!= ddds =============================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================
      subroutine ioddds(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(6)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)

      dimension ec(216)

      data      pi / 3.14159265358979323846d+00 /

      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,6 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 ,
     &   0.09090909090909090d+00          /

      data  root3 / 1.73205080756887729352d+00 /


      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,216
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(7)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f6   = (((((fdat(13,it)*dt6   + fdat(12,it))*dt5
     &                    + fdat(11,it))*dt4  + fdat(10,it))*dt3
     &                    + fdat(9,it))*dt2  + fdat(8,it))*dt
     &                    + fdat(7,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f5   = (t2*f6 + ee)*rminv(6)
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)

                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     dm6 = fpp*f6! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
                     dm5 =  4.5d0 *tinv *  dm4
                     dm6 =  5.5d0 *tinv *  dm5
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)
                  s6 = dm6      !/( roo2**3)

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
 
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
                  px5 = pax*s5 + wpx*s6
                  py5 = pay*s5 + wpy*s6
                  pz5 = paz*s5 + wpz*s6

                  xp1 = pbx*s1 + wpx*s2
                  yp1 = pby*s1 + wpy*s2
                  zp1 = pbz*s1 + wpz*s2
                  xp2 = pbx*s2 + wpx*s3
                  yp2 = pby*s2 + wpy*s3
                  zp2 = pbz*s2 + wpz*s3
                  xp3 = pbx*s3 + wpx*s4
                  yp3 = pby*s3 + wpy*s4
                  zp3 = pbz*s3 + wpz*s4

                  s01 = zet*(s0-rooz*s1)
                  s12 = zet*(s1-rooz*s2)
                  s23 = zet*(s2-rooz*s3)
                  s34 = zet*(s3-rooz*s4)
                  s45 = zet*(s4-rooz*s5)
! dsss 
                  dxx0 = pax*px0 + wpx*px1+s01
                  dyy0 = pay*py0 + wpy*py1+s01
                  dzz0 = paz*pz0 + wpz*pz1+s01
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+s12
                  dyy1 = pay*py1 + wpy*py2+s12
                  dzz1 = paz*pz1 + wpz*pz2+s12
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+s23
                  dyy2 = pay*py2 + wpy*py3+s23
                  dzz2 = paz*pz2 + wpz*pz3+s23
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
 
                  dxx3 = pax*px3 + wpx*px4+s34
                  dyy3 = pay*py3 + wpy*py4+s34
                  dzz3 = paz*pz3 + wpz*pz4+s34
                  dyx3 = pay*px3 + wpy*px4
                  dzx3 = paz*px3 + wpz*px4
                  dzy3 = paz*py3 + wpz*py4

                  dxx4 = pax*px4 + wpx*px5+s45
                  dyy4 = pay*py4 + wpy*py5+s45
                  dzz4 = paz*pz4 + wpz*pz5+s45
                  dyx4 = pay*px4 + wpy*px5
                  dzx4 = paz*px4 + wpz*px5
                  dzy4 = paz*py4 + wpz*py5

!sdss
                  sdxx2 = pbx*xp2 + wpx*xp3 + s23
                  sdyy2 = pby*yp2 + wpy*yp3 + s23
                  sdzz2 = pbz*zp2 + wpz*zp3 + s23
                  sdyx2 = pby*xp2 + wpy*xp3
                  sdzx2 = pbz*xp2 + wpz*xp3
                  sdzy2 = pbz*yp2 + wpz*yp3

!ppss
                  ppxx0 = pbx * px0 + wpx*px1 + s01
                  ppyx0 = pbx * py0 + wpx*py1
                  ppzx0 = pbx * pz0 + wpx*pz1
                  ppxy0 = pby * px0 + wpy*px1
                  ppyy0 = pby * py0 + wpy*py1 + s01
                  ppzy0 = pby * pz0 + wpy*pz1
                  ppxz0 = pbz * px0 + wpz*px1
                  ppyz0 = pbz * py0 + wpz*py1
                  ppzz0 = pbz * pz0 + wpz*pz1 + s01
                            
                  ppxx1 = pbx * px1 + wpx*px2 + s12
                  ppyx1 = pbx * py1 + wpx*py2
                  ppzx1 = pbx * pz1 + wpx*pz2
                  ppxy1 = pby * px1 + wpy*px2
                  ppyy1 = pby * py1 + wpy*py2 + s12
                  ppzy1 = pby * pz1 + wpy*pz2
                  ppxz1 = pbz * px1 + wpz*px2
                  ppyz1 = pbz * py1 + wpz*py2
                  ppzz1 = pbz * pz1 + wpz*pz2 + s12
                             
                  ppxx2 = pbx * px2 + wpx*px3 + s23
                  ppyx2 = pbx * py2 + wpx*py3
                  ppzx2 = pbx * pz2 + wpx*pz3
                  ppxy2 = pby * px2 + wpy*px3
                  ppyy2 = pby * py2 + wpy*py3 + s23
                  ppzy2 = pby * pz2 + wpy*pz3
                  ppxz2 = pbz * px2 + wpz*px3
                  ppyz2 = pbz * py2 + wpz*py3
                  ppzz2 = pbz * pz2 + wpz*pz3 + s23
           
                  ppxx3 = pbx * px3 + wpx*px4 + s34
                  ppyx3 = pbx * py3 + wpx*py4
                  ppzx3 = pbx * pz3 + wpx*pz4
                  ppxy3 = pby * px3 + wpy*px4
                  ppyy3 = pby * py3 + wpy*py4 + s34
                  ppzy3 = pby * pz3 + wpy*pz4
                  ppxz3 = pbz * px3 + wpz*px4
                  ppyz3 = pbz * py3 + wpz*py4
                  ppzz3 = pbz * pz3 + wpz*pz4 + s34

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  px34 = zet*(px3-rooz*px4)
                  py34 = zet*(py3-rooz*py4)
                  pz34 = zet*(pz3-rooz*pz4)

!dpss 
                  dpxxx0 =  pbx*dxx0 + wpx*dxx1 + 2.0d0*px01
                  dpxxy0 =  pby*dxx0 + wpy*dxx1             
                  dpxxz0 =  pbz*dxx0 + wpz*dxx1             
                  dpyyx0 =  pbx*dyy0 + wpx*dyy1             
                  dpyyy0 =  pby*dyy0 + wpy*dyy1 + 2.0d0*py01
                  dpyyz0 =  pbz*dyy0 + wpz*dyy1             
                  dpzzx0 =  pbx*dzz0 + wpx*dzz1             
                  dpzzy0 =  pby*dzz0 + wpy*dzz1             
                  dpzzz0 =  pbz*dzz0 + wpz*dzz1 + 2.0d0*pz01
                  dpyxx0 =  pbx*dyx0 + wpx*dyx1 +       py01
                  dpyxy0 =  pby*dyx0 + wpy*dyx1 +       px01
                  dpyxz0 =  pbz*dyx0 + wpz*dyx1             
                  dpzxx0 =  pbx*dzx0 + wpx*dzx1 +       pz01
                  dpzxy0 =  pby*dzx0 + wpy*dzx1             
                  dpzxz0 =  pbz*dzx0 + wpz*dzx1 +       px01
                  dpzyx0 =  pbx*dzy0 + wpx*dzy1             
                  dpzyy0 =  pby*dzy0 + wpy*dzy1 +       pz01
                  dpzyz0 =  pbz*dzy0 + wpz*dzy1 +       py01
           
                  dpxxx1 =  pbx*dxx1 + wpx*dxx2 + 2.0d0*px12
                  dpxxy1 =  pby*dxx1 + wpy*dxx2             
                  dpxxz1 =  pbz*dxx1 + wpz*dxx2             
                  dpyyx1 =  pbx*dyy1 + wpx*dyy2             
                  dpyyy1 =  pby*dyy1 + wpy*dyy2 + 2.0d0*py12
                  dpyyz1 =  pbz*dyy1 + wpz*dyy2             
                  dpzzx1 =  pbx*dzz1 + wpx*dzz2             
                  dpzzy1 =  pby*dzz1 + wpy*dzz2             
                  dpzzz1 =  pbz*dzz1 + wpz*dzz2 + 2.0d0*pz12
                  dpyxx1 =  pbx*dyx1 + wpx*dyx2 +       py12
                  dpyxy1 =  pby*dyx1 + wpy*dyx2 +       px12
                  dpyxz1 =  pbz*dyx1 + wpz*dyx2             
                  dpzxx1 =  pbx*dzx1 + wpx*dzx2 +       pz12
                  dpzxy1 =  pby*dzx1 + wpy*dzx2             
                  dpzxz1 =  pbz*dzx1 + wpz*dzx2 +       px12
                  dpzyx1 =  pbx*dzy1 + wpx*dzy2             
                  dpzyy1 =  pby*dzy1 + wpy*dzy2 +       pz12
                  dpzyz1 =  pbz*dzy1 + wpz*dzy2 +       py12
           
                  dpxxx2 =  pbx*dxx2 + wpx*dxx3 + 2.0d0*px23
                  dpxxy2 =  pby*dxx2 + wpy*dxx3
                  dpxxz2 =  pbz*dxx2 + wpz*dxx3
                  dpyyx2 =  pbx*dyy2 + wpx*dyy3
                  dpyyy2 =  pby*dyy2 + wpy*dyy3 + 2.0d0*py23
                  dpyyz2 =  pbz*dyy2 + wpz*dyy3             
                  dpzzx2 =  pbx*dzz2 + wpx*dzz3             
                  dpzzy2 =  pby*dzz2 + wpy*dzz3             
                  dpzzz2 =  pbz*dzz2 + wpz*dzz3 + 2.0d0*pz23
                  dpyxx2 =  pbx*dyx2 + wpx*dyx3 +       py23
                  dpyxy2 =  pby*dyx2 + wpy*dyx3 +       px23
                  dpyxz2 =  pbz*dyx2 + wpz*dyx3             
                  dpzxx2 =  pbx*dzx2 + wpx*dzx3 +       pz23
                  dpzxy2 =  pby*dzx2 + wpy*dzx3             
                  dpzxz2 =  pbz*dzx2 + wpz*dzx3 +       px23
                  dpzyx2 =  pbx*dzy2 + wpx*dzy3             
                  dpzyy2 =  pby*dzy2 + wpy*dzy3 +       pz23
                  dpzyz2 =  pbz*dzy2 + wpz*dzy3 +       py23
           
                  dpxxx3 =  pbx*dxx3 + wpx*dxx4 + 2.0d0*px34
                  dpxxy3 =  pby*dxx3 + wpy*dxx4             
                  dpxxz3 =  pbz*dxx3 + wpz*dxx4             
                  dpyyx3 =  pbx*dyy3 + wpx*dyy4             
                  dpyyy3 =  pby*dyy3 + wpy*dyy4 + 2.0d0*py34
                  dpyyz3 =  pbz*dyy3 + wpz*dyy4             
                  dpzzx3 =  pbx*dzz3 + wpx*dzz4             
                  dpzzy3 =  pby*dzz3 + wpy*dzz4             
                  dpzzz3 =  pbz*dzz3 + wpz*dzz4 + 2.0d0*pz34
                  dpyxx3 =  pbx*dyx3 + wpx*dyx4 +       py34
                  dpyxy3 =  pby*dyx3 + wpy*dyx4 +       px34
                  dpyxz3 =  pbz*dyx3 + wpz*dyx4             
                  dpzxx3 =  pbx*dzx3 + wpx*dzx4 +       pz34
                  dpzxy3 =  pby*dzx3 + wpy*dzx4             
                  dpzxz3 =  pbz*dzx3 + wpz*dzx4 +       px34
                  dpzyx3 =  pbx*dzy3 + wpx*dzy4             
                  dpzyy3 =  pby*dzy3 + wpy*dzy4 +       pz34
                  dpzyz3 =  pbz*dzy3 + wpz*dzy4 +       py34


         xp12 = zet*(xp1 - rooz*xp2)
         yp12 = zet*(yp1 - rooz*yp2)
         zp12 = zet*(zp1 - rooz*zp2)
         xp23 = zet*(xp2 - rooz*xp3)
         yp23 = zet*(yp2 - rooz*yp3)
         zp23 = zet*(zp2 - rooz*zp3)

!pdss
         pdxxx1 = pbx*ppxx1 + wpx*ppxx2 +px12 +xp12
         pdxyy1 = pby*ppxy1 + wpy*ppxy2 +px12 
         pdxzz1 = pbz*ppxz1 + wpz*ppxz2 +px12 
         pdxyx1 = pby*ppxx1 + wpy*ppxx2 
         pdxzx1 = pbz*ppxx1 + wpz*ppxx2 
         pdxzy1 = pby*ppxz1 + wpy*ppxz2
         pdyxx1 = pbx*ppyx1 + wpx*ppyx2 +py12
         pdyyy1 = pby*ppyy1 + wpy*ppyy2 +py12 +yp12 
         pdyzz1 = pbz*ppyz1 + wpz*ppyz2 +py12 
         pdyyx1 = pbx*ppyy1 + wpx*ppyy2 
         pdyzx1 = pbx*ppyz1 + wpx*ppyz2 
         pdyzy1 = pbz*ppyy1 + wpz*ppyy2 
         pdzxx1 = pbx*ppzx1 + wpx*ppzx2 +pz12
         pdzyy1 = pby*ppzy1 + wpy*ppzy2 +pz12
         pdzzz1 = pbz*ppzz1 + wpz*ppzz2 +pz12 +zp12
         pdzyx1 = pbx*ppzy1 + wpx*ppzy2
         pdzzx1 = pbx*ppzz1 + wpx*ppzz2
         pdzzy1 = pby*ppzz1 + wpy*ppzz2

         pdxxx2 = pbx*ppxx2 + wpx*ppxx3 +px23 +xp23
         pdxyy2 = pby*ppxy2 + wpy*ppxy3 +px23
         pdxzz2 = pbz*ppxz2 + wpz*ppxz3 +px23
         pdxyx2 = pby*ppxx2 + wpy*ppxx3
         pdxzx2 = pbz*ppxx2 + wpz*ppxx3
         pdxzy2 = pby*ppxz2 + wpy*ppxz3
         pdyxx2 = pbx*ppyx2 + wpx*ppyx3 +py23
         pdyyy2 = pby*ppyy2 + wpy*ppyy3 +py23 +yp23
         pdyzz2 = pbz*ppyz2 + wpz*ppyz3 +py23
         pdyyx2 = pbx*ppyy2 + wpx*ppyy3
         pdyzx2 = pbx*ppyz2 + wpx*ppyz3
         pdyzy2 = pbz*ppyy2 + wpz*ppyy3
         pdzxx2 = pbx*ppzx2 + wpx*ppzx3 +pz23
         pdzyy2 = pby*ppzy2 + wpy*ppzy3 +pz23
         pdzzz2 = pbz*ppzz2 + wpz*ppzz3 +pz23 +zp23
         pdzyx2 = pbx*ppzy2 + wpx*ppzy3
         pdzzx2 = pbx*ppzz2 + wpx*ppzz3
         pdzzy2 = pby*ppzz2 + wpy*ppzz3

!RANK = 4
       ppxx01 = zet*(ppxx0 - rooz*ppxx1)
       ppxy01 = zet*(ppxy0 - rooz*ppxy1)
       ppxz01 = zet*(ppxz0 - rooz*ppxz1)
       ppyx01 = zet*(ppyx0 - rooz*ppyx1)
       ppyy01 = zet*(ppyy0 - rooz*ppyy1)
       ppyz01 = zet*(ppyz0 - rooz*ppyz1)
       ppzx01 = zet*(ppzx0 - rooz*ppzx1)
       ppzy01 = zet*(ppzy0 - rooz*ppzy1)
       ppzz01 = zet*(ppzz0 - rooz*ppzz1)

       ppxx12 = zet*(ppxx1 - rooz*ppxx2)
       ppxy12 = zet*(ppxy1 - rooz*ppxy2)
       ppxz12 = zet*(ppxz1 - rooz*ppxz2)
       ppyx12 = zet*(ppyx1 - rooz*ppyx2)
       ppyy12 = zet*(ppyy1 - rooz*ppyy2)
       ppyz12 = zet*(ppyz1 - rooz*ppyz2)
       ppzx12 = zet*(ppzx1 - rooz*ppzx2)
       ppzy12 = zet*(ppzy1 - rooz*ppzy2)
       ppzz12 = zet*(ppzz1 - rooz*ppzz2)

       ppxx23 = zet*(ppxx2 - rooz*ppxx3)
       ppxy23 = zet*(ppxy2 - rooz*ppxy3)
       ppxz23 = zet*(ppxz2 - rooz*ppxz3)
       ppyx23 = zet*(ppyx2 - rooz*ppyx3)
       ppyy23 = zet*(ppyy2 - rooz*ppyy3)
       ppyz23 = zet*(ppyz2 - rooz*ppyz3)
       ppzx23 = zet*(ppzx2 - rooz*ppzx3)
       ppzy23 = zet*(ppzy2 - rooz*ppzy3)
       ppzz23 = zet*(ppzz2 - rooz*ppzz3)
                 
       dxx01 = zet*(dxx0 -rooz*dxx1)
       dyy01 = zet*(dyy0 -rooz*dyy1)
       dzz01 = zet*(dzz0 -rooz*dzz1)
       dyx01 = zet*(dyx0 -rooz*dyx1)
       dzx01 = zet*(dzx0 -rooz*dzx1)
       dzy01 = zet*(dzy0 -rooz*dzy1)

       dxx12 = zet*(dxx1 -rooz*dxx2)
       dyy12 = zet*(dyy1 -rooz*dyy2)
       dzz12 = zet*(dzz1 -rooz*dzz2)
       dyx12 = zet*(dyx1 -rooz*dyx2)
       dzx12 = zet*(dzx1 -rooz*dzx2)
       dzy12 = zet*(dzy1 -rooz*dzy2)

       dxx23 = zet*(dxx2 -rooz*dxx3)
       dyy23 = zet*(dyy2 -rooz*dyy3)
       dzz23 = zet*(dzz2 -rooz*dzz3)
       dyx23 = zet*(dyx2 -rooz*dyx3)
       dzx23 = zet*(dzx2 -rooz*dzx3)
       dzy23 = zet*(dzy2 -rooz*dzy3)

!ddss
       ddxxxx0 = pbx*dpxxx0 + wpx*dpxxx1 + 2.0d0*ppxx01 + dxx01
       ddxxyy0 = pby*dpxxy0 + wpy*dpxxy1                + dxx01
       ddxxzz0 = pbz*dpxxz0 + wpz*dpxxz1                + dxx01
       ddxxyx0 = pby*dpxxx0 + wpy*dpxxx1
       ddxxzx0 = pbz*dpxxx0 + wpz*dpxxx1
       ddxxzy0 = pby*dpxxz0 + wpy*dpxxz1
       ddyyxx0 = pbx*dpyyx0 + wpx*dpyyx1                + dyy01
       ddyyyy0 = pby*dpyyy0 + wpy*dpyyy1 + 2.0d0*ppyy01 + dyy01
       ddyyzz0 = pbz*dpyyz0 + wpz*dpyyz1                + dyy01
       ddyyyx0 = pbx*dpyyy0 + wpx*dpyyy1
       ddyyzx0 = pbx*dpyyz0 + wpx*dpyyz1
       ddyyzy0 = pbz*dpyyy0 + wpz*dpyyy1
       ddzzxx0 = pbx*dpzzx0 + wpx*dpzzx1                + dzz01
       ddzzyy0 = pby*dpzzy0 + wpy*dpzzy1                + dzz01
       ddzzzz0 = pbz*dpzzz0 + wpz*dpzzz1 + 2.0d0*ppzz01 + dzz01
       ddzzyx0 = pbx*dpzzy0 + wpx*dpzzy1
       ddzzzx0 = pbx*dpzzz0 + wpx*dpzzz1
       ddzzzy0 = pby*dpzzz0 + wpy*dpzzz1
       ddyxxx0 = pbx*dpyxx0 + wpx*dpyxx1 +       ppyx01 + dyx01
       ddyxyy0 = pby*dpyxy0 + wpy*dpyxy1 +       ppxy01 + dyx01
       ddyxzz0 = pbz*dpyxz0 + wpz*dpyxz1                + dyx01
       ddyxyx0 = pbx*dpyxy0 + wpx*dpyxy1 +       ppyy01
       ddyxzx0 = pbz*dpyxx0 + wpz*dpyxx1
       ddyxzy0 = pbz*dpyxy0 + wpz*dpyxy1
       ddzxxx0 = pbx*dpzxx0 + wpx*dpzxx1 +       ppzx01 + dzx01
       ddzxyy0 = pby*dpzxy0 + wpy*dpzxy1                + dzx01
       ddzxzz0 = pbz*dpzxz0 + wpz*dpzxz1 +       ppxz01 + dzx01
       ddzxyx0 = pby*dpzxx0 + wpy*dpzxx1
       ddzxzx0 = pbx*dpzxz0 + wpx*dpzxz1 +       ppzz01
       ddzxzy0 = pby*dpzxz0 + wpy*dpzxz1
       ddzyxx0 = pbx*dpzyx0 + wpx*dpzyx1                + dzy01
       ddzyyy0 = pby*dpzyy0 + wpy*dpzyy1 +       ppzy01 + dzy01
       ddzyzz0 = pbz*dpzyz0 + wpz*dpzyz1 +       ppyz01 + dzy01
       ddzyyx0 = pbx*dpzyy0 + wpx*dpzyy1
       ddzyzx0 = pbx*dpzyz0 + wpx*dpzyz1
       ddzyzy0 = pby*dpzyz0 + wpy*dpzyz1 +       ppzz01

       ddxxxx1 = pbx*dpxxx1 + wpx*dpxxx2 + 2.0d0*ppxx12 + dxx12
       ddxxyy1 = pby*dpxxy1 + wpy*dpxxy2                + dxx12
       ddxxzz1 = pbz*dpxxz1 + wpz*dpxxz2                + dxx12
       ddxxyx1 = pby*dpxxx1 + wpy*dpxxx2
       ddxxzx1 = pbz*dpxxx1 + wpz*dpxxx2
       ddxxzy1 = pby*dpxxz1 + wpy*dpxxz2
       ddyyxx1 = pbx*dpyyx1 + wpx*dpyyx2                + dyy12
       ddyyyy1 = pby*dpyyy1 + wpy*dpyyy2 + 2.0d0*ppyy12 + dyy12
       ddyyzz1 = pbz*dpyyz1 + wpz*dpyyz2                + dyy12
       ddyyyx1 = pbx*dpyyy1 + wpx*dpyyy2
       ddyyzx1 = pbx*dpyyz1 + wpx*dpyyz2
       ddyyzy1 = pbz*dpyyy1 + wpz*dpyyy2
       ddzzxx1 = pbx*dpzzx1 + wpx*dpzzx2                + dzz12
       ddzzyy1 = pby*dpzzy1 + wpy*dpzzy2                + dzz12
       ddzzzz1 = pbz*dpzzz1 + wpz*dpzzz2 + 2.0d0*ppzz12 + dzz12
       ddzzyx1 = pbx*dpzzy1 + wpx*dpzzy2
       ddzzzx1 = pbx*dpzzz1 + wpx*dpzzz2
       ddzzzy1 = pby*dpzzz1 + wpy*dpzzz2
       ddyxxx1 = pbx*dpyxx1 + wpx*dpyxx2 +       ppyx12 + dyx12
       ddyxyy1 = pby*dpyxy1 + wpy*dpyxy2 +       ppxy12 + dyx12
       ddyxzz1 = pbz*dpyxz1 + wpz*dpyxz2                + dyx12
       ddyxyx1 = pbx*dpyxy1 + wpx*dpyxy2 +       ppyy12
       ddyxzx1 = pbz*dpyxx1 + wpz*dpyxx2
       ddyxzy1 = pbz*dpyxy1 + wpz*dpyxy2
       ddzxxx1 = pbx*dpzxx1 + wpx*dpzxx2 +       ppzx12 + dzx12
       ddzxyy1 = pby*dpzxy1 + wpy*dpzxy2                + dzx12
       ddzxzz1 = pbz*dpzxz1 + wpz*dpzxz2 +       ppxz12 + dzx12
       ddzxyx1 = pby*dpzxx1 + wpy*dpzxx2
       ddzxzx1 = pbx*dpzxz1 + wpx*dpzxz2 +       ppzz12
       ddzxzy1 = pby*dpzxz1 + wpy*dpzxz2
       ddzyxx1 = pbx*dpzyx1 + wpx*dpzyx2                + dzy12
       ddzyyy1 = pby*dpzyy1 + wpy*dpzyy2 +       ppzy12 + dzy12
       ddzyzz1 = pbz*dpzyz1 + wpz*dpzyz2 +       ppyz12 + dzy12
       ddzyyx1 = pbx*dpzyy1 + wpx*dpzyy2
       ddzyzx1 = pbx*dpzyz1 + wpx*dpzyz2
       ddzyzy1 = pby*dpzyz1 + wpy*dpzyz2 +       ppzz12

       ddxxxx2 = pbx*dpxxx2 + wpx*dpxxx3 + 2.0d0*ppxx23 + dxx23
       ddxxyy2 = pby*dpxxy2 + wpy*dpxxy3                + dxx23
       ddxxzz2 = pbz*dpxxz2 + wpz*dpxxz3                + dxx23
       ddxxyx2 = pby*dpxxx2 + wpy*dpxxx3
       ddxxzx2 = pbz*dpxxx2 + wpz*dpxxx3
       ddxxzy2 = pby*dpxxz2 + wpy*dpxxz3
       ddyyxx2 = pbx*dpyyx2 + wpx*dpyyx3                + dyy23
       ddyyyy2 = pby*dpyyy2 + wpy*dpyyy3 + 2.0d0*ppyy23 + dyy23
       ddyyzz2 = pbz*dpyyz2 + wpz*dpyyz3                + dyy23
       ddyyyx2 = pbx*dpyyy2 + wpx*dpyyy3
       ddyyzx2 = pbx*dpyyz2 + wpx*dpyyz3
       ddyyzy2 = pbz*dpyyy2 + wpz*dpyyy3
       ddzzxx2 = pbx*dpzzx2 + wpx*dpzzx3                + dzz23
       ddzzyy2 = pby*dpzzy2 + wpy*dpzzy3                + dzz23
       ddzzzz2 = pbz*dpzzz2 + wpz*dpzzz3 + 2.0d0*ppzz23 + dzz23
       ddzzyx2 = pbx*dpzzy2 + wpx*dpzzy3
       ddzzzx2 = pbx*dpzzz2 + wpx*dpzzz3
       ddzzzy2 = pby*dpzzz2 + wpy*dpzzz3
       ddyxxx2 = pbx*dpyxx2 + wpx*dpyxx3 +       ppyx23 + dyx23
       ddyxyy2 = pby*dpyxy2 + wpy*dpyxy3 +       ppxy23 + dyx23
       ddyxzz2 = pbz*dpyxz2 + wpz*dpyxz3                + dyx23
       ddyxyx2 = pbx*dpyxy2 + wpx*dpyxy3 +       ppyy23
       ddyxzx2 = pbz*dpyxx2 + wpz*dpyxx3
       ddyxzy2 = pbz*dpyxy2 + wpz*dpyxy3
       ddzxxx2 = pbx*dpzxx2 + wpx*dpzxx3 +       ppzx23 + dzx23
       ddzxyy2 = pby*dpzxy2 + wpy*dpzxy3                + dzx23
       ddzxzz2 = pbz*dpzxz2 + wpz*dpzxz3 +       ppxz23 + dzx23
       ddzxyx2 = pby*dpzxx2 + wpy*dpzxx3
       ddzxzx2 = pbx*dpzxz2 + wpx*dpzxz3 +       ppzz23
       ddzxzy2 = pby*dpzxz2 + wpy*dpzxz3
       ddzyxx2 = pbx*dpzyx2 + wpx*dpzyx3                + dzy23
       ddzyyy2 = pby*dpzyy2 + wpy*dpzyy3 +       ppzy23 + dzy23
       ddzyzz2 = pbz*dpzyz2 + wpz*dpzyz3 +       ppyz23 + dzy23
       ddzyyx2 = pbx*dpzyy2 + wpx*dpzyy3
       ddzyzx2 = pbx*dpzyz2 + wpx*dpzyz3
       ddzyzy2 = pby*dpzyz2 + wpy*dpzyz3 +       ppzz23


      rppxx2 = rkp*ppxx2
      rppxy2 = rkp*ppxy2
      rppxz2 = rkp*ppxz2
      rppyx2 = rkp*ppyx2
      rppyy2 = rkp*ppyy2
      rppyz2 = rkp*ppyz2
      rppzx2 = rkp*ppzx2
      rppzy2 = rkp*ppzy2
      rppzz2 = rkp*ppzz2

      rdxx2 = rkp*dxx2
      rdyy2 = rkp*dyy2
      rdzz2 = rkp*dzz2
      rdyx2 = rkp*dyx2
      rdzx2 = rkp*dzx2
      rdzy2 = rkp*dzy2

!dpps
      axx = qcx*dpxxx1 + wqx*dpxxx2 + 2.0d0*rppxx2 + rdxx2
      axy = qcy*dpxxx1 + wqy*dpxxx2 
      axz = qcz*dpxxx1 + wqz*dpxxx2 
      ayx = qcx*dpxxy1 + wqx*dpxxy2 + 2.0d0*rppxy2        
      ayy = qcy*dpxxy1 + wqy*dpxxy2                + rdxx2
      ayz = qcz*dpxxy1 + wqz*dpxxy2                       
      azx = qcx*dpxxz1 + wqx*dpxxz2 + 2.0d0*rppxz2        
      azy = qcy*dpxxz1 + wqy*dpxxz2                       
      azz = qcz*dpxxz1 + wqz*dpxxz2                + rdxx2
      bxx = qcx*dpyyx1 + wqx*dpyyx2                + rdyy2
      bxy = qcy*dpyyx1 + wqy*dpyyx2 + 2.0d0*rppyx2        
      bxz = qcz*dpyyx1 + wqz*dpyyx2                       
      byx = qcx*dpyyy1 + wqx*dpyyy2                       
      byy = qcy*dpyyy1 + wqy*dpyyy2 + 2.0d0*rppyy2 + rdyy2
      byz = qcz*dpyyy1 + wqz*dpyyy2                       
      bzx = qcx*dpyyz1 + wqx*dpyyz2                       
      bzy = qcy*dpyyz1 + wqy*dpyyz2 + 2.0d0*rppyz2        
      bzz = qcz*dpyyz1 + wqz*dpyyz2                + rdyy2
      cxx = qcx*dpzzx1 + wqx*dpzzx2                + rdzz2
      cxy = qcy*dpzzx1 + wqy*dpzzx2                       
      cxz = qcz*dpzzx1 + wqz*dpzzx2 + 2.0d0*rppzx2        
      cyx = qcx*dpzzy1 + wqx*dpzzy2                       
      cyy = qcy*dpzzy1 + wqy*dpzzy2                + rdzz2
      cyz = qcz*dpzzy1 + wqz*dpzzy2 + 2.0d0*rppzy2        
      czx = qcx*dpzzz1 + wqx*dpzzz2                       
      czy = qcy*dpzzz1 + wqy*dpzzz2                       
      czz = qcz*dpzzz1 + wqz*dpzzz2 + 2.0d0*rppzz2 + rdzz2
      dxx = qcx*dpyxx1 + wqx*dpyxx2 +       rppyx2 + rdyx2
      dxy = qcy*dpyxx1 + wqy*dpyxx2 +       rppxx2        
      dxz = qcz*dpyxx1 + wqz*dpyxx2                       
      dyx = qcx*dpyxy1 + wqx*dpyxy2 +       rppyy2        
      dyy = qcy*dpyxy1 + wqy*dpyxy2 +       rppxy2 + rdyx2
      dyz = qcz*dpyxy1 + wqz*dpyxy2            !    + rdyx2
      dzx = qcx*dpyxz1 + wqx*dpyxz2 +       rppyz2        
      dzy = qcy*dpyxz1 + wqy*dpyxz2 +       rppxz2        
      dzz = qcz*dpyxz1 + wqz*dpyxz2                + rdyx2
      exx = qcx*dpzxx1 + wqx*dpzxx2 +       rppzx2 + rdzx2
      exy = qcy*dpzxx1 + wqy*dpzxx2                       
      exz = qcz*dpzxx1 + wqz*dpzxx2 +       rppxx2        
      eyx = qcx*dpzxy1 + wqx*dpzxy2 +       rppzy2        
      eyy = qcy*dpzxy1 + wqy*dpzxy2                + rdzx2
      eyz = qcz*dpzxy1 + wqz*dpzxy2 +       rppxy2        
      ezx = qcx*dpzxz1 + wqx*dpzxz2 +       rppzz2        
      ezy = qcy*dpzxz1 + wqy*dpzxz2                       
      ezz = qcz*dpzxz1 + wqz*dpzxz2 +       rppxz2 + rdzx2
      fxx = qcx*dpzyx1 + wqx*dpzyx2                + rdzy2
      fxy = qcy*dpzyx1 + wqy*dpzyx2 +       rppzx2        
      fxz = qcz*dpzyx1 + wqz*dpzyx2 +       rppyx2        
      fyx = qcx*dpzyy1 + wqx*dpzyy2                       
      fyy = qcy*dpzyy1 + wqy*dpzyy2 +       rppzy2 + rdzy2
      fyz = qcz*dpzyy1 + wqz*dpzyy2 +       rppyy2        
      fzx = qcx*dpzyz1 + wqx*dpzyz2                       
      fzy = qcy*dpzyz1 + wqy*dpzyz2 +       rppzz2        
      fzz = qcz*dpzyz1 + wqz*dpzyz2 +       rppyz2 + rdzy2


      rsdxx2 = rkp * sdxx2
      rsdyy2 = rkp * sdyy2
      rsdzz2 = rkp * sdzz2
      rsdyx2 = rkp * sdyx2
      rsdzx2 = rkp * sdzx2
      rsdzy2 = rkp * sdzy2

!pdps 
      pxdxxpx1 = qcx*pdxxx1+wqx*pdxxx2+rsdxx2+2.0d0*rppxx2
      pxdxxpy1 = qcy*pdxxx1+wqy*pdxxx2                   
      pxdxxpz1 = qcz*pdxxx1+wqz*pdxxx2                   
      pxdyypx1 = qcx*pdxyy1+wqx*pdxyy2+rsdyy2             
      pxdyypy1 = qcy*pdxyy1+wqy*pdxyy2       +2.0d0*rppxy2
      pxdyypz1 = qcz*pdxyy1+wqz*pdxyy2                   
      pxdzzpx1 = qcx*pdxzz1+wqx*pdxzz2+rsdzz2
      pxdzzpy1 = qcy*pdxzz1+wqy*pdxzz2                   
      pxdzzpz1 = qcz*pdxzz1+wqz*pdxzz2       +2.0d0*rppxz2
      pxdyxpx1 = qcx*pdxyx1+wqx*pdxyx2+rsdyx2+      rppxy2
      pxdyxpy1 = qcy*pdxyx1+wqy*pdxyx2       +      rppxx2
      pxdyxpz1 = qcz*pdxyx1+wqz*pdxyx2                   
      pxdzxpx1 = qcx*pdxzx1+wqx*pdxzx2+rsdzx2+      rppxz2
      pxdzxpy1 = qcy*pdxzx1+wqy*pdxzx2                   
      pxdzxpz1 = qcz*pdxzx1+wqz*pdxzx2       +      rppxx2
      pxdzypx1 = qcx*pdxzy1+wqx*pdxzy2+rsdzy2             
      pxdzypy1 = qcy*pdxzy1+wqy*pdxzy2       +      rppxz2
      pxdzypz1 = qcz*pdxzy1+wqz*pdxzy2       +      rppxy2
      pydxxpx1 = qcx*pdyxx1+wqx*pdyxx2       +2.0d0*rppyx2
      pydxxpy1 = qcy*pdyxx1+wqy*pdyxx2+rsdxx2             
      pydxxpz1 = qcz*pdyxx1+wqz*pdyxx2                   
      pydyypx1 = qcx*pdyyy1+wqx*pdyyy2                   
      pydyypy1 = qcy*pdyyy1+wqy*pdyyy2+rsdyy2+2.0d0*rppyy2
      pydyypz1 = qcz*pdyyy1+wqz*pdyyy2                   
      pydzzpx1 = qcx*pdyzz1+wqx*pdyzz2                   
      pydzzpy1 = qcy*pdyzz1+wqy*pdyzz2+rsdzz2             
      pydzzpz1 = qcz*pdyzz1+wqz*pdyzz2       +2.0d0*rppyz2
      pydyxpx1 = qcx*pdyyx1+wqx*pdyyx2       +      rppyy2
      pydyxpy1 = qcy*pdyyx1+wqy*pdyyx2+rsdyx2+      rppyx2
      pydyxpz1 = qcz*pdyyx1+wqz*pdyyx2                   
      pydzxpx1 = qcx*pdyzx1+wqx*pdyzx2       +      rppyz2
      pydzxpy1 = qcy*pdyzx1+wqy*pdyzx2+rsdzx2             
      pydzxpz1 = qcz*pdyzx1+wqz*pdyzx2       +      rppyx2
      pydzypx1 = qcx*pdyzy1+wqx*pdyzy2                   
      pydzypy1 = qcy*pdyzy1+wqy*pdyzy2+rsdzy2+      rppyz2
      pydzypz1 = qcz*pdyzy1+wqz*pdyzy2       +      rppyy2
      pzdxxpx1 = qcx*pdzxx1+wqx*pdzxx2       +2.0d0*rppzx2 
      pzdxxpy1 = qcy*pdzxx1+wqy*pdzxx2                    
      pzdxxpz1 = qcz*pdzxx1+wqz*pdzxx2+rsdxx2              
      pzdyypx1 = qcx*pdzyy1+wqx*pdzyy2                    
      pzdyypy1 = qcy*pdzyy1+wqy*pdzyy2       +2.0d0*rppzy2 
      pzdyypz1 = qcz*pdzyy1+wqz*pdzyy2+rsdyy2
      pzdzzpx1 = qcx*pdzzz1+wqx*pdzzz2                    
      pzdzzpy1 = qcy*pdzzz1+wqy*pdzzz2                    
      pzdzzpz1 = qcz*pdzzz1+wqz*pdzzz2+rsdzz2+2.0d0*rppzz2 
      pzdyxpx1 = qcx*pdzyx1+wqx*pdzyx2       +      rppzy2 
      pzdyxpy1 = qcy*pdzyx1+wqy*pdzyx2       +      rppzx2 
      pzdyxpz1 = qcz*pdzyx1+wqz*pdzyx2+rsdyx2              
      pzdzxpx1 = qcx*pdzzx1+wqx*pdzzx2       +      rppzz2 
      pzdzxpy1 = qcy*pdzzx1+wqy*pdzzx2                    
      pzdzxpz1 = qcz*pdzzx1+wqz*pdzzx2+rsdzx2+      rppzx2 
      pzdzypx1 = qcx*pdzzy1+wqx*pdzzy2                    
      pzdzypy1 = qcy*pdzzy1+wqy*pdzzy2       +      rppzz2 
      pzdzypz1 = qcz*pdzzy1+wqz*pdzzy2+rsdzy2+      rppzy2 

         rdpxxx1 = rkp * dpxxx1
         rdpxxy1 = rkp * dpxxy1
         rdpxxz1 = rkp * dpxxz1
         rdpyyx1 = rkp * dpyyx1
         rdpyyy1 = rkp * dpyyy1
         rdpyyz1 = rkp * dpyyz1
         rdpzzx1 = rkp * dpzzx1
         rdpzzy1 = rkp * dpzzy1
         rdpzzz1 = rkp * dpzzz1
         rdpyxx1 = rkp * dpyxx1
         rdpyxy1 = rkp * dpyxy1
         rdpyxz1 = rkp * dpyxz1
         rdpzxx1 = rkp * dpzxx1
         rdpzxy1 = rkp * dpzxy1
         rdpzxz1 = rkp * dpzxz1
         rdpzyx1 = rkp * dpzyx1
         rdpzyy1 = rkp * dpzyy1
         rdpzyz1 = rkp * dpzyz1
         rdpxxx2 = rkp * dpxxx2
         rdpxxy2 = rkp * dpxxy2
         rdpxxz2 = rkp * dpxxz2
         rdpyyx2 = rkp * dpyyx2
         rdpyyy2 = rkp * dpyyy2
         rdpyyz2 = rkp * dpyyz2
         rdpzzx2 = rkp * dpzzx2
         rdpzzy2 = rkp * dpzzy2
         rdpzzz2 = rkp * dpzzz2
         rdpyxx2 = rkp * dpyxx2
         rdpyxy2 = rkp * dpyxy2
         rdpyxz2 = rkp * dpyxz2
         rdpzxx2 = rkp * dpzxx2
         rdpzxy2 = rkp * dpzxy2
         rdpzxz2 = rkp * dpzxz2
         rdpzyx2 = rkp * dpzyx2
         rdpzyy2 = rkp * dpzyy2
         rdpzyz2 = rkp * dpzyz2

         rpdxxx1 = rkp * pdxxx1
         rpdxyy1 = rkp * pdxyy1
         rpdxzz1 = rkp * pdxzz1
         rpdxyx1 = rkp * pdxyx1
         rpdxzx1 = rkp * pdxzx1
         rpdxzy1 = rkp * pdxzy1
         rpdyxx1 = rkp * pdyxx1
         rpdyyy1 = rkp * pdyyy1
         rpdyzz1 = rkp * pdyzz1
         rpdyyx1 = rkp * pdyyx1
         rpdyzx1 = rkp * pdyzx1
         rpdyzy1 = rkp * pdyzy1
         rpdzxx1 = rkp * pdzxx1
         rpdzyy1 = rkp * pdzyy1
         rpdzzz1 = rkp * pdzzz1
         rpdzyx1 = rkp * pdzyx1
         rpdzzx1 = rkp * pdzzx1
         rpdzzy1 = rkp * pdzzy1

         rpdxxx2 = rkp * pdxxx2
         rpdxyy2 = rkp * pdxyy2
         rpdxzz2 = rkp * pdxzz2
         rpdxyx2 = rkp * pdxyx2
         rpdxzx2 = rkp * pdxzx2
         rpdxzy2 = rkp * pdxzy2
         rpdyxx2 = rkp * pdyxx2
         rpdyyy2 = rkp * pdyyy2
         rpdyzz2 = rkp * pdyzz2
         rpdyyx2 = rkp * pdyyx2
         rpdyzx2 = rkp * pdyzx2
         rpdyzy2 = rkp * pdyzy2
         rpdzxx2 = rkp * pdzxx2
         rpdzyy2 = rkp * pdzyy2
         rpdzzz2 = rkp * pdzzz2
         rpdzyx2 = rkp * pdzyx2
         rpdzzx2 = rkp * pdzzx2
         rpdzzy2 = rkp * pdzzy2


      dxxdxxpx0=qcx*ddxxxx0 + wqx*ddxxxx1 + 2.0d0*rpdxxx1+2.0d0*rdpxxx1
      dxxdxxpy0=qcy*ddxxxx0 + wqy*ddxxxx1
      dxxdxxpz0=qcz*ddxxxx0 + wqz*ddxxxx1
      dxxdyypx0=qcx*ddxxyy0 + wqx*ddxxyy1 + 2.0d0*rpdxyy1
      dxxdyypy0=qcy*ddxxyy0 + wqy*ddxxyy1                +2.0d0*rdpxxy1
      dxxdyypz0=qcz*ddxxyy0 + wqz*ddxxyy1
      dxxdzzpx0=qcx*ddxxzz0 + wqx*ddxxzz1 + 2.0d0*rpdxzz1
      dxxdzzpy0=qcy*ddxxzz0 + wqy*ddxxzz1
      dxxdzzpz0=qcz*ddxxzz0 + wqz*ddxxzz1                +2.0d0*rdpxxz1
      dxxdyxpx0=qcx*ddxxyx0 + wqx*ddxxyx1 + 2.0d0*rpdxyx1+      rdpxxy1
      dxxdyxpy0=qcy*ddxxyx0 + wqy*ddxxyx1                +      rdpxxx1
      dxxdyxpz0=qcz*ddxxyx0 + wqz*ddxxyx1 
      dxxdzxpx0=qcx*ddxxzx0 + wqx*ddxxzx1 + 2.0d0*rpdxzx1+      rdpxxz1
      dxxdzxpy0=qcy*ddxxzx0 + wqy*ddxxzx1
      dxxdzxpz0=qcz*ddxxzx0 + wqz*ddxxzx1                +      rdpxxx1
      dxxdzypx0=qcx*ddxxzy0 + wqx*ddxxzy1 + 2.0d0*rpdxzy1
      dxxdzypy0=qcy*ddxxzy0 + wqy*ddxxzy1                +      rdpxxz1
      dxxdzypz0=qcz*ddxxzy0 + wqz*ddxxzy1                +      rdpxxy1
      dyydxxpx0=qcx*ddyyxx0 + wqx*ddyyxx1                +2.0d0*rdpyyx1
      dyydxxpy0=qcy*ddyyxx0 + wqy*ddyyxx1 + 2.0d0*rpdyxx1
      dyydxxpz0=qcz*ddyyxx0 + wqz*ddyyxx1
      dyydyypx0=qcx*ddyyyy0 + wqx*ddyyyy1
      dyydyypy0=qcy*ddyyyy0 + wqy*ddyyyy1 + 2.0d0*rpdyyy1+2.0d0*rdpyyy1
      dyydyypz0=qcz*ddyyyy0 + wqz*ddyyyy1
      dyydzzpx0=qcx*ddyyzz0 + wqx*ddyyzz1
      dyydzzpy0=qcy*ddyyzz0 + wqy*ddyyzz1 + 2.0d0*rpdyzz1
      dyydzzpz0=qcz*ddyyzz0 + wqz*ddyyzz1                +2.0d0*rdpyyz1
      dyydyxpx0=qcx*ddyyyx0 + wqx*ddyyyx1                +      rdpyyy1
      dyydyxpy0=qcy*ddyyyx0 + wqy*ddyyyx1 + 2.0d0*rpdyyx1+      rdpyyx1
      dyydyxpz0=qcz*ddyyyx0 + wqz*ddyyyx1
      dyydzxpx0=qcx*ddyyzx0 + wqx*ddyyzx1                +      rdpyyz1
      dyydzxpy0=qcy*ddyyzx0 + wqy*ddyyzx1 + 2.0d0*rpdyzx1
      dyydzxpz0=qcz*ddyyzx0 + wqz*ddyyzx1                +      rdpyyx1
      dyydzypx0=qcx*ddyyzy0 + wqx*ddyyzy1
      dyydzypy0=qcy*ddyyzy0 + wqy*ddyyzy1 + 2.0d0*rpdyzy1+      rdpyyz1
      dyydzypz0=qcz*ddyyzy0 + wqz*ddyyzy1                +      rdpyyy1
      dzzdxxpx0=qcx*ddzzxx0 + wqx*ddzzxx1                +2.0d0*rdpzzx1
      dzzdxxpy0=qcy*ddzzxx0 + wqy*ddzzxx1 
      dzzdxxpz0=qcz*ddzzxx0 + wqz*ddzzxx1 + 2.0d0*rpdzxx1
      dzzdyypx0=qcx*ddzzyy0 + wqx*ddzzyy1
      dzzdyypy0=qcy*ddzzyy0 + wqy*ddzzyy1                +2.0d0*rdpzzy1
      dzzdyypz0=qcz*ddzzyy0 + wqz*ddzzyy1 + 2.0d0*rpdzyy1
      dzzdzzpx0=qcx*ddzzzz0 + wqx*ddzzzz1
      dzzdzzpy0=qcy*ddzzzz0 + wqy*ddzzzz1
      dzzdzzpz0=qcz*ddzzzz0 + wqz*ddzzzz1 + 2.0d0*rpdzzz1+2.0d0*rdpzzz1
      dzzdyxpx0=qcx*ddzzyx0 + wqx*ddzzyx1                +      rdpzzy1
      dzzdyxpy0=qcy*ddzzyx0 + wqy*ddzzyx1                +      rdpzzx1
      dzzdyxpz0=qcz*ddzzyx0 + wqz*ddzzyx1 + 2.0d0*rpdzyx1
      dzzdzxpx0=qcx*ddzzzx0 + wqx*ddzzzx1                +      rdpzzz1
      dzzdzxpy0=qcy*ddzzzx0 + wqy*ddzzzx1 
      dzzdzxpz0=qcz*ddzzzx0 + wqz*ddzzzx1 + 2.0d0*rpdzzx1+      rdpzzx1
      dzzdzypx0=qcx*ddzzzy0 + wqx*ddzzzy1
      dzzdzypy0=qcy*ddzzzy0 + wqy*ddzzzy1                +      rdpzzz1
      dzzdzypz0=qcz*ddzzzy0 + wqz*ddzzzy1 + 2.0d0*rpdzzy1+      rdpzzy1

      dyxdxxpx0=qcx*ddyxxx0 + wqx*ddyxxx1 +       rpdyxx1+2.0d0*rdpyxx1
      dyxdxxpy0=qcy*ddyxxx0 + wqy*ddyxxx1 +       rpdxxx1
      dyxdxxpz0=qcz*ddyxxx0 + wqz*ddyxxx1
      dyxdyypx0=qcx*ddyxyy0 + wqx*ddyxyy1 +       rpdyyy1
      dyxdyypy0=qcy*ddyxyy0 + wqy*ddyxyy1 +       rpdxyy1+2.0d0*rdpyxy1
      dyxdyypz0=qcz*ddyxyy0 + wqz*ddyxyy1
      dyxdzzpx0=qcx*ddyxzz0 + wqx*ddyxzz1 +       rpdyzz1
      dyxdzzpy0=qcy*ddyxzz0 + wqy*ddyxzz1 +       rpdxzz1
      dyxdzzpz0=qcz*ddyxzz0 + wqz*ddyxzz1                +2.0d0*rdpyxz1
      dyxdyxpx0=qcx*ddyxyx0 + wqx*ddyxyx1 +       rpdyyx1+      rdpyxy1
      dyxdyxpy0=qcy*ddyxyx0 + wqy*ddyxyx1 +       rpdxyx1+      rdpyxx1
      dyxdyxpz0=qcz*ddyxyx0 + wqz*ddyxyx1
      dyxdzxpx0=qcx*ddyxzx0 + wqx*ddyxzx1 +       rpdyzx1+      rdpyxz1
      dyxdzxpy0=qcy*ddyxzx0 + wqy*ddyxzx1 +       rpdxzx1
      dyxdzxpz0=qcz*ddyxzx0 + wqz*ddyxzx1                +      rdpyxx1
      dyxdzypx0=qcx*ddyxzy0 + wqx*ddyxzy1 +       rpdyzy1
      dyxdzypy0=qcy*ddyxzy0 + wqy*ddyxzy1 +       rpdxzy1+      rdpyxz1
      dyxdzypz0=qcz*ddyxzy0 + wqz*ddyxzy1                +      rdpyxy1
      dzxdxxpx0=qcx*ddzxxx0 + wqx*ddzxxx1 +       rpdzxx1+2.0d0*rdpzxx1
      dzxdxxpy0=qcy*ddzxxx0 + wqy*ddzxxx1
      dzxdxxpz0=qcz*ddzxxx0 + wqz*ddzxxx1 +       rpdxxx1
      dzxdyypx0=qcx*ddzxyy0 + wqx*ddzxyy1 +       rpdzyy1
      dzxdyypy0=qcy*ddzxyy0 + wqy*ddzxyy1                +2.0d0*rdpzxy1
      dzxdyypz0=qcz*ddzxyy0 + wqz*ddzxyy1 +       rpdxyy1
      dzxdzzpx0=qcx*ddzxzz0 + wqx*ddzxzz1 +       rpdzzz1
      dzxdzzpy0=qcy*ddzxzz0 + wqy*ddzxzz1
      dzxdzzpz0=qcz*ddzxzz0 + wqz*ddzxzz1 +       rpdxzz1+2.0d0*rdpzxz1
      dzxdyxpx0=qcx*ddzxyx0 + wqx*ddzxyx1 +       rpdzyx1+      rdpzxy1
      dzxdyxpy0=qcy*ddzxyx0 + wqy*ddzxyx1                +      rdpzxx1
      dzxdyxpz0=qcz*ddzxyx0 + wqz*ddzxyx1 +       rpdxyx1
      dzxdzxpx0=qcx*ddzxzx0 + wqx*ddzxzx1 +       rpdzzx1+      rdpzxz1
      dzxdzxpy0=qcy*ddzxzx0 + wqy*ddzxzx1
      dzxdzxpz0=qcz*ddzxzx0 + wqz*ddzxzx1 +       rpdxzx1+      rdpzxx1
      dzxdzypx0=qcx*ddzxzy0 + wqx*ddzxzy1 +       rpdzzy1
      dzxdzypy0=qcy*ddzxzy0 + wqy*ddzxzy1                +      rdpzxz1
      dzxdzypz0=qcz*ddzxzy0 + wqz*ddzxzy1 +       rpdxzy1+      rdpzxy1
      dzydxxpx0=qcx*ddzyxx0 + wqx*ddzyxx1                +2.0d0*rdpzyx1
      dzydxxpy0=qcy*ddzyxx0 + wqy*ddzyxx1 +       rpdzxx1
      dzydxxpz0=qcz*ddzyxx0 + wqz*ddzyxx1 +       rpdyxx1
      dzydyypx0=qcx*ddzyyy0 + wqx*ddzyyy1
      dzydyypy0=qcy*ddzyyy0 + wqy*ddzyyy1 +       rpdzyy1+2.0d0*rdpzyy1
      dzydyypz0=qcz*ddzyyy0 + wqz*ddzyyy1 +       rpdyyy1
      dzydzzpx0=qcx*ddzyzz0 + wqx*ddzyzz1
      dzydzzpy0=qcy*ddzyzz0 + wqy*ddzyzz1 +       rpdzzz1
      dzydzzpz0=qcz*ddzyzz0 + wqz*ddzyzz1 +       rpdyzz1+2.0d0*rdpzyz1
      dzydyxpx0=qcx*ddzyyx0 + wqx*ddzyyx1                +      rdpzyy1
      dzydyxpy0=qcy*ddzyyx0 + wqy*ddzyyx1 +       rpdzyx1+      rdpzyx1
      dzydyxpz0=qcz*ddzyyx0 + wqz*ddzyyx1 +       rpdyyx1
      dzydzxpx0=qcx*ddzyzx0 + wqx*ddzyzx1                +      rdpzyz1
      dzydzxpy0=qcy*ddzyzx0 + wqy*ddzyzx1 +       rpdzzx1
      dzydzxpz0=qcz*ddzyzx0 + wqz*ddzyzx1 +       rpdyzx1+      rdpzyx1
      dzydzypx0=qcx*ddzyzy0 + wqx*ddzyzy1
      dzydzypy0=qcy*ddzyzy0 + wqy*ddzyzy1 +       rpdzzy1+      rdpzyz1
      dzydzypz0=qcz*ddzyzy0 + wqz*ddzyzy1 +       rpdyzy1+      rdpzyy1

      dxxdxxpx1=qcx*ddxxxx1 + wqx*ddxxxx2 + 2.0d0*rpdxxx2+2.0d0*rdpxxx2
      dxxdxxpy1=qcy*ddxxxx1 + wqy*ddxxxx2
      dxxdxxpz1=qcz*ddxxxx1 + wqz*ddxxxx2
      dxxdyypx1=qcx*ddxxyy1 + wqx*ddxxyy2 + 2.0d0*rpdxyy2
      dxxdyypy1=qcy*ddxxyy1 + wqy*ddxxyy2                +2.0d0*rdpxxy2
      dxxdyypz1=qcz*ddxxyy1 + wqz*ddxxyy2
      dxxdzzpx1=qcx*ddxxzz1 + wqx*ddxxzz2 + 2.0d0*rpdxzz2
      dxxdzzpy1=qcy*ddxxzz1 + wqy*ddxxzz2
      dxxdzzpz1=qcz*ddxxzz1 + wqz*ddxxzz2                +2.0d0*rdpxxz2
      dxxdyxpx1=qcx*ddxxyx1 + wqx*ddxxyx2 + 2.0d0*rpdxyx2+      rdpxxy2
      dxxdyxpy1=qcy*ddxxyx1 + wqy*ddxxyx2                +      rdpxxx2
      dxxdyxpz1=qcz*ddxxyx1 + wqz*ddxxyx2 
      dxxdzxpx1=qcx*ddxxzx1 + wqx*ddxxzx2 + 2.0d0*rpdxzx2+      rdpxxz2
      dxxdzxpy1=qcy*ddxxzx1 + wqy*ddxxzx2
      dxxdzxpz1=qcz*ddxxzx1 + wqz*ddxxzx2                +      rdpxxx2
      dxxdzypx1=qcx*ddxxzy1 + wqx*ddxxzy2 + 2.0d0*rpdxzy2
      dxxdzypy1=qcy*ddxxzy1 + wqy*ddxxzy2                +      rdpxxz2
      dxxdzypz1=qcz*ddxxzy1 + wqz*ddxxzy2                +      rdpxxy2
      dyydxxpx1=qcx*ddyyxx1 + wqx*ddyyxx2                +2.0d0*rdpyyx2
      dyydxxpy1=qcy*ddyyxx1 + wqy*ddyyxx2 + 2.0d0*rpdyxx2
      dyydxxpz1=qcz*ddyyxx1 + wqz*ddyyxx2
      dyydyypx1=qcx*ddyyyy1 + wqx*ddyyyy2
      dyydyypy1=qcy*ddyyyy1 + wqy*ddyyyy2 + 2.0d0*rpdyyy2+2.0d0*rdpyyy2
      dyydyypz1=qcz*ddyyyy1 + wqz*ddyyyy2
      dyydzzpx1=qcx*ddyyzz1 + wqx*ddyyzz2
      dyydzzpy1=qcy*ddyyzz1 + wqy*ddyyzz2 + 2.0d0*rpdyzz2
      dyydzzpz1=qcz*ddyyzz1 + wqz*ddyyzz2                +2.0d0*rdpyyz2
      dyydyxpx1=qcx*ddyyyx1 + wqx*ddyyyx2                +      rdpyyy2
      dyydyxpy1=qcy*ddyyyx1 + wqy*ddyyyx2 + 2.0d0*rpdyyx2+      rdpyyx2
      dyydyxpz1=qcz*ddyyyx1 + wqz*ddyyyx2
      dyydzxpx1=qcx*ddyyzx1 + wqx*ddyyzx2                +      rdpyyz2
      dyydzxpy1=qcy*ddyyzx1 + wqy*ddyyzx2 + 2.0d0*rpdyzx2
      dyydzxpz1=qcz*ddyyzx1 + wqz*ddyyzx2                +      rdpyyx2
      dyydzypx1=qcx*ddyyzy1 + wqx*ddyyzy2
      dyydzypy1=qcy*ddyyzy1 + wqy*ddyyzy2 + 2.0d0*rpdyzy2+      rdpyyz2
      dyydzypz1=qcz*ddyyzy1 + wqz*ddyyzy2                +      rdpyyy2
      dzzdxxpx1=qcx*ddzzxx1 + wqx*ddzzxx2                +2.0d0*rdpzzx2
      dzzdxxpy1=qcy*ddzzxx1 + wqy*ddzzxx2 
      dzzdxxpz1=qcz*ddzzxx1 + wqz*ddzzxx2 + 2.0d0*rpdzxx2
      dzzdyypx1=qcx*ddzzyy1 + wqx*ddzzyy2
      dzzdyypy1=qcy*ddzzyy1 + wqy*ddzzyy2                +2.0d0*rdpzzy2
      dzzdyypz1=qcz*ddzzyy1 + wqz*ddzzyy2 + 2.0d0*rpdzyy2
      dzzdzzpx1=qcx*ddzzzz1 + wqx*ddzzzz2
      dzzdzzpy1=qcy*ddzzzz1 + wqy*ddzzzz2
      dzzdzzpz1=qcz*ddzzzz1 + wqz*ddzzzz2 + 2.0d0*rpdzzz2+2.0d0*rdpzzz2
      dzzdyxpx1=qcx*ddzzyx1 + wqx*ddzzyx2                +      rdpzzy2
      dzzdyxpy1=qcy*ddzzyx1 + wqy*ddzzyx2                +      rdpzzx2
      dzzdyxpz1=qcz*ddzzyx1 + wqz*ddzzyx2 + 2.0d0*rpdzyx2
      dzzdzxpx1=qcx*ddzzzx1 + wqx*ddzzzx2                +      rdpzzz2
      dzzdzxpy1=qcy*ddzzzx1 + wqy*ddzzzx2 
      dzzdzxpz1=qcz*ddzzzx1 + wqz*ddzzzx2 + 2.0d0*rpdzzx2+      rdpzzx2
      dzzdzypx1=qcx*ddzzzy1 + wqx*ddzzzy2
      dzzdzypy1=qcy*ddzzzy1 + wqy*ddzzzy2                +      rdpzzz2
      dzzdzypz1=qcz*ddzzzy1 + wqz*ddzzzy2 + 2.0d0*rpdzzy2+      rdpzzy2

      dyxdxxpx1=qcx*ddyxxx1 + wqx*ddyxxx2 +       rpdyxx2+2.0d0*rdpyxx2
      dyxdxxpy1=qcy*ddyxxx1 + wqy*ddyxxx2 +       rpdxxx2
      dyxdxxpz1=qcz*ddyxxx1 + wqz*ddyxxx2
      dyxdyypx1=qcx*ddyxyy1 + wqx*ddyxyy2 +       rpdyyy2
      dyxdyypy1=qcy*ddyxyy1 + wqy*ddyxyy2 +       rpdxyy2+2.0d0*rdpyxy2
      dyxdyypz1=qcz*ddyxyy1 + wqz*ddyxyy2
      dyxdzzpx1=qcx*ddyxzz1 + wqx*ddyxzz2 +       rpdyzz2
      dyxdzzpy1=qcy*ddyxzz1 + wqy*ddyxzz2 +       rpdxzz2
      dyxdzzpz1=qcz*ddyxzz1 + wqz*ddyxzz2                +2.0d0*rdpyxz2
      dyxdyxpx1=qcx*ddyxyx1 + wqx*ddyxyx2 +       rpdyyx2+      rdpyxy2
      dyxdyxpy1=qcy*ddyxyx1 + wqy*ddyxyx2 +       rpdxyx2+      rdpyxx2
      dyxdyxpz1=qcz*ddyxyx1 + wqz*ddyxyx2
      dyxdzxpx1=qcx*ddyxzx1 + wqx*ddyxzx2 +       rpdyzx2+      rdpyxz2
      dyxdzxpy1=qcy*ddyxzx1 + wqy*ddyxzx2 +       rpdxzx2
      dyxdzxpz1=qcz*ddyxzx1 + wqz*ddyxzx2                +      rdpyxx2
      dyxdzypx1=qcx*ddyxzy1 + wqx*ddyxzy2 +       rpdyzy2
      dyxdzypy1=qcy*ddyxzy1 + wqy*ddyxzy2 +       rpdxzy2+      rdpyxz2
      dyxdzypz1=qcz*ddyxzy1 + wqz*ddyxzy2                +      rdpyxy2
      dzxdxxpx1=qcx*ddzxxx1 + wqx*ddzxxx2 +       rpdzxx2+2.0d0*rdpzxx2
      dzxdxxpy1=qcy*ddzxxx1 + wqy*ddzxxx2
      dzxdxxpz1=qcz*ddzxxx1 + wqz*ddzxxx2 +       rpdxxx2
      dzxdyypx1=qcx*ddzxyy1 + wqx*ddzxyy2 +       rpdzyy2
      dzxdyypy1=qcy*ddzxyy1 + wqy*ddzxyy2                +2.0d0*rdpzxy2
      dzxdyypz1=qcz*ddzxyy1 + wqz*ddzxyy2 +       rpdxyy2
      dzxdzzpx1=qcx*ddzxzz1 + wqx*ddzxzz2 +       rpdzzz2
      dzxdzzpy1=qcy*ddzxzz1 + wqy*ddzxzz2
      dzxdzzpz1=qcz*ddzxzz1 + wqz*ddzxzz2 +       rpdxzz2+2.0d0*rdpzxz2
      dzxdyxpx1=qcx*ddzxyx1 + wqx*ddzxyx2 +       rpdzyx2+      rdpzxy2
      dzxdyxpy1=qcy*ddzxyx1 + wqy*ddzxyx2                +      rdpzxx2
      dzxdyxpz1=qcz*ddzxyx1 + wqz*ddzxyx2 +       rpdxyx2
      dzxdzxpx1=qcx*ddzxzx1 + wqx*ddzxzx2 +       rpdzzx2+      rdpzxz2
      dzxdzxpy1=qcy*ddzxzx1 + wqy*ddzxzx2
      dzxdzxpz1=qcz*ddzxzx1 + wqz*ddzxzx2 +       rpdxzx2+      rdpzxx2
      dzxdzypx1=qcx*ddzxzy1 + wqx*ddzxzy2 +       rpdzzy2
      dzxdzypy1=qcy*ddzxzy1 + wqy*ddzxzy2                +      rdpzxz2
      dzxdzypz1=qcz*ddzxzy1 + wqz*ddzxzy2 +       rpdxzy2+      rdpzxy2
      dzydxxpx1=qcx*ddzyxx1 + wqx*ddzyxx2                +2.0d0*rdpzyx2
      dzydxxpy1=qcy*ddzyxx1 + wqy*ddzyxx2 +       rpdzxx2
      dzydxxpz1=qcz*ddzyxx1 + wqz*ddzyxx2 +       rpdyxx2
      dzydyypx1=qcx*ddzyyy1 + wqx*ddzyyy2
      dzydyypy1=qcy*ddzyyy1 + wqy*ddzyyy2 +       rpdzyy2+2.0d0*rdpzyy2
      dzydyypz1=qcz*ddzyyy1 + wqz*ddzyyy2 +       rpdyyy2
      dzydzzpx1=qcx*ddzyzz1 + wqx*ddzyzz2
      dzydzzpy1=qcy*ddzyzz1 + wqy*ddzyzz2 +       rpdzzz2
      dzydzzpz1=qcz*ddzyzz1 + wqz*ddzyzz2 +       rpdyzz2+2.0d0*rdpzyz2
      dzydyxpx1=qcx*ddzyyx1 + wqx*ddzyyx2                +      rdpzyy2
      dzydyxpy1=qcy*ddzyyx1 + wqy*ddzyyx2 +       rpdzyx2+      rdpzyx2
      dzydyxpz1=qcz*ddzyyx1 + wqz*ddzyyx2 +       rpdyyx2
      dzydzxpx1=qcx*ddzyzx1 + wqx*ddzyzx2                +      rdpzyz2
      dzydzxpy1=qcy*ddzyzx1 + wqy*ddzyzx2 +       rpdzzx2
      dzydzxpz1=qcz*ddzyzx1 + wqz*ddzyzx2 +       rpdyzx2+      rdpzyx2
      dzydzypx1=qcx*ddzyzy1 + wqx*ddzyzy2
      dzydzypy1=qcy*ddzyzy1 + wqy*ddzyzy2 +       rpdzzy2+      rdpzyz2
      dzydzypz1=qcz*ddzyzy1 + wqz*ddzyzy2 +       rpdyzy2+      rdpzyy2

!RANK=6
      xax  = rkp * pxdxxpx1
      xay  = rkp * pxdxxpy1
      xaz  = rkp * pxdxxpz1
      xbx  = rkp * pxdyypx1
      xby  = rkp * pxdyypy1
      xbz  = rkp * pxdyypz1
      xcx  = rkp * pxdzzpx1
      xcy  = rkp * pxdzzpy1
      xcz  = rkp * pxdzzpz1
      xdx  = rkp * pxdyxpx1
      xdy  = rkp * pxdyxpy1
      xdz  = rkp * pxdyxpz1
      xex  = rkp * pxdzxpx1
      xey  = rkp * pxdzxpy1
      xez  = rkp * pxdzxpz1
      xfx  = rkp * pxdzypx1
      xfy  = rkp * pxdzypy1
      xfz  = rkp * pxdzypz1

      yax = rkp * pydxxpx1
      yay = rkp * pydxxpy1
      yaz = rkp * pydxxpz1
      ybx = rkp * pydyypx1
      yby = rkp * pydyypy1
      ybz = rkp * pydyypz1
      ycx = rkp * pydzzpx1
      ycy = rkp * pydzzpy1
      ycz = rkp * pydzzpz1
      ydx = rkp * pydyxpx1
      ydy = rkp * pydyxpy1
      ydz = rkp * pydyxpz1
      yex = rkp * pydzxpx1
      yey = rkp * pydzxpy1
      yez = rkp * pydzxpz1
      yfx = rkp * pydzypx1
      yfy = rkp * pydzypy1
      yfz = rkp * pydzypz1

      zax = rkp * pzdxxpx1
      zay = rkp * pzdxxpy1
      zaz = rkp * pzdxxpz1
      zbx = rkp * pzdyypx1
      zby = rkp * pzdyypy1
      zbz = rkp * pzdyypz1
      zcx = rkp * pzdzzpx1
      zcy = rkp * pzdzzpy1
      zcz = rkp * pzdzzpz1
      zdx = rkp * pzdyxpx1
      zdy = rkp * pzdyxpy1
      zdz = rkp * pzdyxpz1
      zex = rkp * pzdzxpx1
      zey = rkp * pzdzxpy1
      zez = rkp * pzdzxpz1
      zfx = rkp * pzdzypx1
      zfy = rkp * pzdzypy1
      zfz = rkp * pzdzypz1

      raxx= rkp *axx
      raxy= rkp *axy
      raxz= rkp *axz
      rayx= rkp *ayx
      rayy= rkp *ayy
      rayz= rkp *ayz
      razx= rkp *azx
      razy= rkp *azy
      razz= rkp *azz
      rbxx= rkp *bxx
      rbxy= rkp *bxy
      rbxz= rkp *bxz
      rbyx= rkp *byx
      rbyy= rkp *byy
      rbyz= rkp *byz
      rbzx= rkp *bzx
      rbzy= rkp *bzy
      rbzz= rkp *bzz
      rcxx= rkp *cxx
      rcxy= rkp *cxy
      rcxz= rkp *cxz
      rcyx= rkp *cyx
      rcyy= rkp *cyy
      rcyz= rkp *cyz
      rczx= rkp *czx
      rczy= rkp *czy
      rczz= rkp *czz
      rdxx= rkp *dxx
      rdxy= rkp *dxy
      rdxz= rkp *dxz
      rdyx= rkp *dyx
      rdyy= rkp *dyy
      rdyz= rkp *dyz
      rdzx= rkp *dzx
      rdzy= rkp *dzy
      rdzz= rkp *dzz
      rexx= rkp *exx
      rexy= rkp *exy
      rexz= rkp *exz
      reyx= rkp *eyx
      reyy= rkp *eyy
      reyz= rkp *eyz
      rezx= rkp *ezx
      rezy= rkp *ezy
      rezz= rkp *ezz
      rfxx= rkp *fxx
      rfxy= rkp *fxy
      rfxz= rkp *fxz
      rfyx= rkp *fyx
      rfyy= rkp *fyy
      rfyz= rkp *fyz
      rfzx= rkp *fzx
      rfzy= rkp *fzy
      rfzz= rkp *fzz

      aa0 = eta*(ddxxxx0 - rooe*ddxxxx1)
      ab0 = eta*(ddxxyy0 - rooe*ddxxyy1)
      ac0 = eta*(ddxxzz0 - rooe*ddxxzz1)
      ad0 = eta*(ddxxyx0 - rooe*ddxxyx1)
      ae0 = eta*(ddxxzx0 - rooe*ddxxzx1)
      af0 = eta*(ddxxzy0 - rooe*ddxxzy1)
      ba0 = eta*(ddyyxx0 - rooe*ddyyxx1)
      bb0 = eta*(ddyyyy0 - rooe*ddyyyy1)
      bc0 = eta*(ddyyzz0 - rooe*ddyyzz1)
      bd0 = eta*(ddyyyx0 - rooe*ddyyyx1)
      be0 = eta*(ddyyzx0 - rooe*ddyyzx1)
      bf0 = eta*(ddyyzy0 - rooe*ddyyzy1)
      ca0 = eta*(ddzzxx0 - rooe*ddzzxx1)
      cb0 = eta*(ddzzyy0 - rooe*ddzzyy1)
      cc0 = eta*(ddzzzz0 - rooe*ddzzzz1)
      cd0 = eta*(ddzzyx0 - rooe*ddzzyx1)
      ce0 = eta*(ddzzzx0 - rooe*ddzzzx1)
      cf0 = eta*(ddzzzy0 - rooe*ddzzzy1)
      da0 = eta*(ddyxxx0 - rooe*ddyxxx1)
      db0 = eta*(ddyxyy0 - rooe*ddyxyy1)
      dc0 = eta*(ddyxzz0 - rooe*ddyxzz1)
      dd0 = eta*(ddyxyx0 - rooe*ddyxyx1)
      de0 = eta*(ddyxzx0 - rooe*ddyxzx1)
      df0 = eta*(ddyxzy0 - rooe*ddyxzy1)
      ea0 = eta*(ddzxxx0 - rooe*ddzxxx1)
      eb0 = eta*(ddzxyy0 - rooe*ddzxyy1)
      ec0 = eta*(ddzxzz0 - rooe*ddzxzz1)
      ed0 = eta*(ddzxyx0 - rooe*ddzxyx1)
      ee0 = eta*(ddzxzx0 - rooe*ddzxzx1)
      ef0 = eta*(ddzxzy0 - rooe*ddzxzy1)
      fa0 = eta*(ddzyxx0 - rooe*ddzyxx1)
      fb0 = eta*(ddzyyy0 - rooe*ddzyyy1)
      fc0 = eta*(ddzyzz0 - rooe*ddzyzz1)
      fd0 = eta*(ddzyyx0 - rooe*ddzyyx1)
      fe0 = eta*(ddzyzx0 - rooe*ddzyzx1)
      ff0 = eta*(ddzyzy0 - rooe*ddzyzy1)

      ec(  1)=ec(  1)+qcx*dxxdxxpx0+wqx*dxxdxxpx1+2.d0*xax+2.d0*raxx+aa0
      ec(  2)=ec(  2)+qcy*dxxdxxpy0+wqy*dxxdxxpy1                   +aa0
      ec(  3)=ec(  3)+qcz*dxxdxxpz0+wqz*dxxdxxpz1                   +aa0
      ec(  4)=ec(  4)+qcy*dxxdxxpx0+wqy*dxxdxxpx1
      ec(  5)=ec(  5)+qcz*dxxdxxpx0+wqz*dxxdxxpx1
      ec(  6)=ec(  6)+qcy*dxxdxxpz0+wqy*dxxdxxpz1
      ec(  7)=ec(  7)+qcx*dxxdyypx0+wqx*dxxdyypx1+2.d0*xbx          +ab0
      ec(  8)=ec(  8)+qcy*dxxdyypy0+wqy*dxxdyypy1         +2.d0*rayy+ab0
      ec(  9)=ec(  9)+qcz*dxxdyypz0+wqz*dxxdyypz1                   +ab0
      ec( 10)=ec( 10)+qcx*dxxdyypy0+wqx*dxxdyypy1+2.d0*xby
      ec( 11)=ec( 11)+qcz*dxxdyypx0+wqz*dxxdyypx1
      ec( 12)=ec( 12)+qcz*dxxdyypy0+wqz*dxxdyypy1
      ec( 13)=ec( 13)+qcx*dxxdzzpx0+wqx*dxxdzzpx1+2.d0*xcx          +ac0
      ec( 14)=ec( 14)+qcy*dxxdzzpy0+wqy*dxxdzzpy1                   +ac0
      ec( 15)=ec( 15)+qcz*dxxdzzpz0+wqz*dxxdzzpz1         +2.d0*razz+ac0
      ec( 16)=ec( 16)+qcy*dxxdzzpx0+wqy*dxxdzzpx1
      ec( 17)=ec( 17)+qcx*dxxdzzpz0+wqx*dxxdzzpz1+2.d0*xcz
      ec( 18)=ec( 18)+qcy*dxxdzzpz0+wqy*dxxdzzpz1
      ec( 19)=ec( 19)+qcx*dxxdyxpx0+wqx*dxxdyxpx1+2.d0*xdx+     rayx+ad0
      ec( 20)=ec( 20)+qcy*dxxdyxpy0+wqy*dxxdyxpy1         +     raxy+ad0
      ec( 21)=ec( 21)+qcz*dxxdyxpz0+wqz*dxxdyxpz1                   +ad0
      ec( 22)=ec( 22)+qcy*dxxdyxpx0+wqy*dxxdyxpx1         +     raxx
      ec( 23)=ec( 23)+qcz*dxxdyxpx0+wqz*dxxdyxpx1
      ec( 24)=ec( 24)+qcz*dxxdyxpy0+wqz*dxxdyxpy1
      ec( 25)=ec( 25)+qcx*dxxdzxpx0+wqx*dxxdzxpx1+2.d0*xex+     razx+ae0
      ec( 26)=ec( 26)+qcy*dxxdzxpy0+wqy*dxxdzxpy1                   +ae0
      ec( 27)=ec( 27)+qcz*dxxdzxpz0+wqz*dxxdzxpz1         +     raxz+ae0
      ec( 28)=ec( 28)+qcy*dxxdzxpx0+wqy*dxxdzxpx1
      ec( 29)=ec( 29)+qcz*dxxdzxpx0+wqz*dxxdzxpx1         +     raxx
      ec( 30)=ec( 30)+qcy*dxxdzxpz0+wqy*dxxdzxpz1
      ec( 31)=ec( 31)+qcx*dxxdzypx0+wqx*dxxdzypx1+2.d0*xfx          +af0
      ec( 32)=ec( 32)+qcy*dxxdzypy0+wqy*dxxdzypy1         +     razy+af0
      ec( 33)=ec( 33)+qcz*dxxdzypz0+wqz*dxxdzypz1         +     rayz+af0
      ec( 34)=ec( 34)+qcy*dxxdzypx0+wqy*dxxdzypx1         +     razx
      ec( 35)=ec( 35)+qcz*dxxdzypx0+wqz*dxxdzypx1         +     rayx
      ec( 36)=ec( 36)+qcy*dxxdzypz0+wqy*dxxdzypz1         +     razz
      ec( 37)=ec( 37)+qcx*dyydxxpx0+wqx*dyydxxpx1         +2.d0*rbxx+ba0
      ec( 38)=ec( 38)+qcy*dyydxxpy0+wqy*dyydxxpy1+2.d0*yay          +ba0
      ec( 39)=ec( 39)+qcz*dyydxxpz0+wqz*dyydxxpz1                   +ba0
      ec( 40)=ec( 40)+qcx*dyydxxpy0+wqx*dyydxxpy1         +2.d0*rbxy
      ec( 41)=ec( 41)+qcz*dyydxxpx0+wqz*dyydxxpx1
      ec( 42)=ec( 42)+qcz*dyydxxpy0+wqz*dyydxxpy1
      ec( 43)=ec( 43)+qcx*dyydyypx0+wqx*dyydyypx1                   +bb0
      ec( 44)=ec( 44)+qcy*dyydyypy0+wqy*dyydyypy1+2.d0*yby+2.d0*rbyy+bb0
      ec( 45)=ec( 45)+qcz*dyydyypz0+wqz*dyydyypz1                   +bb0
      ec( 46)=ec( 46)+qcx*dyydyypy0+wqx*dyydyypy1               
      ec( 47)=ec( 47)+qcx*dyydyypz0+wqx*dyydyypz1               
      ec( 48)=ec( 48)+qcz*dyydyypy0+wqz*dyydyypy1               
      ec( 49)=ec( 49)+qcx*dyydzzpx0+wqx*dyydzzpx1                   +bc0
      ec( 50)=ec( 50)+qcy*dyydzzpy0+wqy*dyydzzpy1+2.d0*ycy          +bc0
      ec( 51)=ec( 51)+qcz*dyydzzpz0+wqz*dyydzzpz1         +2.d0*rbzz+bc0
      ec( 52)=ec( 52)+qcx*dyydzzpy0+wqx*dyydzzpy1                   
      ec( 53)=ec( 53)+qcx*dyydzzpz0+wqx*dyydzzpz1                   
      ec( 54)=ec( 54)+qcy*dyydzzpz0+wqy*dyydzzpz1+2.d0*ycz             
      ec( 55)=ec( 55)+qcx*dyydyxpx0+wqx*dyydyxpx1         +     rbyx+bd0
      ec( 56)=ec( 56)+qcy*dyydyxpy0+wqy*dyydyxpy1+2.d0*ydy+     rbxy+bd0
      ec( 57)=ec( 57)+qcz*dyydyxpz0+wqz*dyydyxpz1                   +bd0
      ec( 58)=ec( 58)+qcx*dyydyxpy0+wqx*dyydyxpy1         +     rbyy
      ec( 59)=ec( 59)+qcz*dyydyxpx0+wqz*dyydyxpx1                   
      ec( 60)=ec( 60)+qcz*dyydyxpy0+wqz*dyydyxpy1                   
      ec( 61)=ec( 61)+qcx*dyydzxpx0+wqx*dyydzxpx1         +     rbzx+be0
      ec( 62)=ec( 62)+qcy*dyydzxpy0+wqy*dyydzxpy1+2.d0*yey          +be0
      ec( 63)=ec( 63)+qcz*dyydzxpz0+wqz*dyydzxpz1         +     rbxz+be0
      ec( 64)=ec( 64)+qcx*dyydzxpy0+wqx*dyydzxpy1         +     rbzy
      ec( 65)=ec( 65)+qcx*dyydzxpz0+wqx*dyydzxpz1         +     rbzz
      ec( 66)=ec( 66)+qcz*dyydzxpy0+wqz*dyydzxpy1         +     rbxy
      ec( 67)=ec( 67)+qcx*dyydzypx0+wqx*dyydzypx1                   +bf0
      ec( 68)=ec( 68)+qcy*dyydzypy0+wqy*dyydzypy1+2.d0*yfy+     rbzy+bf0
      ec( 69)=ec( 69)+qcz*dyydzypz0+wqz*dyydzypz1         +     rbyz+bf0
      ec( 70)=ec( 70)+qcx*dyydzypy0+wqx*dyydzypy1                   
      ec( 71)=ec( 71)+qcx*dyydzypz0+wqx*dyydzypz1                   
      ec( 72)=ec( 72)+qcz*dyydzypy0+wqz*dyydzypy1         +     rbyy
      ec( 73)=ec( 73)+qcx*dzzdxxpx0+wqx*dzzdxxpx1         +2.d0*rcxx+ca0
      ec( 74)=ec( 74)+qcy*dzzdxxpy0+wqy*dzzdxxpy1                   +ca0
      ec( 75)=ec( 75)+qcz*dzzdxxpz0+wqz*dzzdxxpz1+2.d0*zaz          +ca0
      ec( 76)=ec( 76)+qcy*dzzdxxpx0+wqy*dzzdxxpx1                   
      ec( 77)=ec( 77)+qcx*dzzdxxpz0+wqx*dzzdxxpz1         +2.d0*rcxz
      ec( 78)=ec( 78)+qcy*dzzdxxpz0+wqy*dzzdxxpz1                   
      ec( 79)=ec( 79)+qcx*dzzdyypx0+wqx*dzzdyypx1                   +cb0
      ec( 80)=ec( 80)+qcy*dzzdyypy0+wqy*dzzdyypy1         +2.d0*rcyy+cb0
      ec( 81)=ec( 81)+qcz*dzzdyypz0+wqz*dzzdyypz1+2.d0*zbz          +cb0
      ec( 82)=ec( 82)+qcx*dzzdyypy0+wqx*dzzdyypy1                   
      ec( 83)=ec( 83)+qcx*dzzdyypz0+wqx*dzzdyypz1                   
      ec( 84)=ec( 84)+qcy*dzzdyypz0+wqy*dzzdyypz1         +2.d0*rcyz
      ec( 85)=ec( 85)+qcx*dzzdzzpx0+wqx*dzzdzzpx1                   +cc0
      ec( 86)=ec( 86)+qcy*dzzdzzpy0+wqy*dzzdzzpy1                   +cc0
      ec( 87)=ec( 87)+qcz*dzzdzzpz0+wqz*dzzdzzpz1+2.d0*zcz+2.d0*rczz+cc0
      ec( 88)=ec( 88)+qcx*dzzdzzpy0+wqx*dzzdzzpy1                
      ec( 89)=ec( 89)+qcx*dzzdzzpz0+wqx*dzzdzzpz1                   
      ec( 90)=ec( 90)+qcy*dzzdzzpz0+wqy*dzzdzzpz1                   
      ec( 91)=ec( 91)+qcx*dzzdyxpx0+wqx*dzzdyxpx1         +     rcyx+cd0
      ec( 92)=ec( 92)+qcy*dzzdyxpy0+wqy*dzzdyxpy1         +     rcxy+cd0
      ec( 93)=ec( 93)+qcz*dzzdyxpz0+wqz*dzzdyxpz1+2.d0*zdz          +cd0
      ec( 94)=ec( 94)+qcx*dzzdyxpy0+wqx*dzzdyxpy1         +     rcyy
      ec( 95)=ec( 95)+qcx*dzzdyxpz0+wqx*dzzdyxpz1         +     rcyz
      ec( 96)=ec( 96)+qcy*dzzdyxpz0+wqy*dzzdyxpz1         +     rcxz
      ec( 97)=ec( 97)+qcx*dzzdzxpx0+wqx*dzzdzxpx1         +     rczx+ce0
      ec( 98)=ec( 98)+qcy*dzzdzxpy0+wqy*dzzdzxpy1                   +ce0
      ec( 99)=ec( 99)+qcz*dzzdzxpz0+wqz*dzzdzxpz1+2.d0*zez+     rcxz+ce0
      ec(100)=ec(100)+qcy*dzzdzxpx0+wqy*dzzdzxpx1                
      ec(101)=ec(101)+qcx*dzzdzxpz0+wqx*dzzdzxpz1         +     rczz
      ec(102)=ec(102)+qcy*dzzdzxpz0+wqy*dzzdzxpz1               
      ec(103)=ec(103)+qcx*dzzdzypx0+wqx*dzzdzypx1                   +cf0
      ec(104)=ec(104)+qcy*dzzdzypy0+wqy*dzzdzypy1         +     rczy+cf0
      ec(105)=ec(105)+qcz*dzzdzypz0+wqz*dzzdzypz1+2.d0*zfz+     rcyz+cf0
      ec(106)=ec(106)+qcx*dzzdzypy0+wqx*dzzdzypy1                   
      ec(107)=ec(107)+qcx*dzzdzypz0+wqx*dzzdzypz1                   
      ec(108)=ec(108)+qcy*dzzdzypz0+wqy*dzzdzypz1         +     rczz
      ec(109)=ec(109)+qcx*dyxdxxpx0+wqx*dyxdxxpx1+     yax+2.d0*rdxx+da0
      ec(110)=ec(110)+qcy*dyxdxxpy0+wqy*dyxdxxpy1+     xay          +da0
      ec(111)=ec(111)+qcz*dyxdxxpz0+wqz*dyxdxxpz1                   +da0
      ec(112)=ec(112)+qcy*dyxdxxpx0+wqy*dyxdxxpx1+     xax
      ec(113)=ec(113)+qcz*dyxdxxpx0+wqz*dyxdxxpx1               
      ec(114)=ec(114)+qcz*dyxdxxpy0+wqz*dyxdxxpy1               
      ec(115)=ec(115)+qcx*dyxdyypx0+wqx*dyxdyypx1+     ybx          +db0
      ec(116)=ec(116)+qcy*dyxdyypy0+wqy*dyxdyypy1+     xby+2.d0*rdyy+db0
      ec(117)=ec(117)+qcz*dyxdyypz0+wqz*dyxdyypz1                   +db0
      ec(118)=ec(118)+qcx*dyxdyypy0+wqx*dyxdyypy1+     yby
      ec(119)=ec(119)+qcz*dyxdyypx0+wqz*dyxdyypx1               
      ec(120)=ec(120)+qcz*dyxdyypy0+wqz*dyxdyypy1               
      ec(121)=ec(121)+qcx*dyxdzzpx0+wqx*dyxdzzpx1+     ycx          +dc0
      ec(122)=ec(122)+qcy*dyxdzzpy0+wqy*dyxdzzpy1+     xcy          +dc0
      ec(123)=ec(123)+qcz*dyxdzzpz0+wqz*dyxdzzpz1         +2.d0*rdzz+dc0
      ec(124)=ec(124)+qcx*dyxdzzpy0+wqx*dyxdzzpy1+     ycy          
      ec(125)=ec(125)+qcx*dyxdzzpz0+wqx*dyxdzzpz1+     ycz          
      ec(126)=ec(126)+qcy*dyxdzzpz0+wqy*dyxdzzpz1+     xcz          
      ec(127)=ec(127)+qcx*dyxdyxpx0+wqx*dyxdyxpx1+     ydx+     rdyx+dd0
      ec(128)=ec(128)+qcy*dyxdyxpy0+wqy*dyxdyxpy1+     xdy+     rdxy+dd0
      ec(129)=ec(129)+qcz*dyxdyxpz0+wqz*dyxdyxpz1                   +dd0
      ec(130)=ec(130)+qcx*dyxdyxpy0+wqx*dyxdyxpy1+     ydy+     rdyy
      ec(131)=ec(131)+qcz*dyxdyxpx0+wqz*dyxdyxpx1
      ec(132)=ec(132)+qcz*dyxdyxpy0+wqz*dyxdyxpy1
      ec(133)=ec(133)+qcx*dyxdzxpx0+wqx*dyxdzxpx1+     yex+     rdzx+de0
      ec(134)=ec(134)+qcy*dyxdzxpy0+wqy*dyxdzxpy1+     xey          +de0
      ec(135)=ec(135)+qcz*dyxdzxpz0+wqz*dyxdzxpz1         +     rdxz+de0
      ec(136)=ec(136)+qcy*dyxdzxpx0+wqy*dyxdzxpx1+     xex            
      ec(137)=ec(137)+qcz*dyxdzxpx0+wqz*dyxdzxpx1         +     rdxx
      ec(138)=ec(138)+qcy*dyxdzxpz0+wqy*dyxdzxpz1+     xez          
      ec(139)=ec(139)+qcx*dyxdzypx0+wqx*dyxdzypx1+     yfx          +df0
      ec(140)=ec(140)+qcy*dyxdzypy0+wqy*dyxdzypy1+     xfy+     rdzy+df0
      ec(141)=ec(141)+qcz*dyxdzypz0+wqz*dyxdzypz1         +     rdyz+df0
      ec(142)=ec(142)+qcx*dyxdzypy0+wqx*dyxdzypy1+     yfy             
      ec(143)=ec(143)+qcx*dyxdzypz0+wqx*dyxdzypz1+     yfz             
      ec(144)=ec(144)+qcz*dyxdzypy0+wqz*dyxdzypy1         +     rdyy
      ec(145)=ec(145)+qcx*dzxdxxpx0+wqx*dzxdxxpx1+     zax+2.d0*rexx+ea0
      ec(146)=ec(146)+qcy*dzxdxxpy0+wqy*dzxdxxpy1                   +ea0
      ec(147)=ec(147)+qcz*dzxdxxpz0+wqz*dzxdxxpz1+     xaz          +ea0
      ec(148)=ec(148)+qcy*dzxdxxpx0+wqy*dzxdxxpx1               
      ec(149)=ec(149)+qcz*dzxdxxpx0+wqz*dzxdxxpx1+     xax         
      ec(150)=ec(150)+qcy*dzxdxxpz0+wqy*dzxdxxpz1               
      ec(151)=ec(151)+qcx*dzxdyypx0+wqx*dzxdyypx1+     zbx          +eb0
      ec(152)=ec(152)+qcy*dzxdyypy0+wqy*dzxdyypy1         +2.d0*reyy+eb0
      ec(153)=ec(153)+qcz*dzxdyypz0+wqz*dzxdyypz1+     xbz          +eb0
      ec(154)=ec(154)+qcx*dzxdyypy0+wqx*dzxdyypy1+     zby         
      ec(155)=ec(155)+qcx*dzxdyypz0+wqx*dzxdyypz1+     zbz 
      ec(156)=ec(156)+qcz*dzxdyypy0+wqz*dzxdyypy1+     xby         
      ec(157)=ec(157)+qcx*dzxdzzpx0+wqx*dzxdzzpx1+     zcx          +ec0
      ec(158)=ec(158)+qcy*dzxdzzpy0+wqy*dzxdzzpy1                   +ec0
      ec(159)=ec(159)+qcz*dzxdzzpz0+wqz*dzxdzzpz1+     xcz+2.d0*rezz+ec0
      ec(160)=ec(160)+qcy*dzxdzzpx0+wqy*dzxdzzpx1                
      ec(161)=ec(161)+qcx*dzxdzzpz0+wqx*dzxdzzpz1+     zcz          
      ec(162)=ec(162)+qcy*dzxdzzpz0+wqy*dzxdzzpz1                
      ec(163)=ec(163)+qcx*dzxdyxpx0+wqx*dzxdyxpx1+     zdx+     reyx+ed0
      ec(164)=ec(164)+qcy*dzxdyxpy0+wqy*dzxdyxpy1         +     rexy+ed0
      ec(165)=ec(165)+qcz*dzxdyxpz0+wqz*dzxdyxpz1+     xdz          +ed0
      ec(166)=ec(166)+qcy*dzxdyxpx0+wqy*dzxdyxpx1         +     rexx
      ec(167)=ec(167)+qcz*dzxdyxpx0+wqz*dzxdyxpx1+     xdx             
      ec(168)=ec(168)+qcz*dzxdyxpy0+wqz*dzxdyxpy1+     xdy             
      ec(169)=ec(169)+qcx*dzxdzxpx0+wqx*dzxdzxpx1+     zex+     rezx+ee0
      ec(170)=ec(170)+qcy*dzxdzxpy0+wqy*dzxdzxpy1                   +ee0
      ec(171)=ec(171)+qcz*dzxdzxpz0+wqz*dzxdzxpz1+     xez+     rexz+ee0
      ec(172)=ec(172)+qcy*dzxdzxpx0+wqy*dzxdzxpx1               
      ec(173)=ec(173)+qcx*dzxdzxpz0+wqx*dzxdzxpz1+     zez+     rezz
      ec(174)=ec(174)+qcy*dzxdzxpz0+wqy*dzxdzxpz1                   
      ec(175)=ec(175)+qcx*dzxdzypx0+wqx*dzxdzypx1+     zfx          +ef0
      ec(176)=ec(176)+qcy*dzxdzypy0+wqy*dzxdzypy1         +     rezy+ef0
      ec(177)=ec(177)+qcz*dzxdzypz0+wqz*dzxdzypz1+     xfz+     reyz+ef0
      ec(178)=ec(178)+qcy*dzxdzypx0+wqy*dzxdzypx1         +     rezx
      ec(179)=ec(179)+qcx*dzxdzypz0+wqx*dzxdzypz1+     zfz             
      ec(180)=ec(180)+qcy*dzxdzypz0+wqy*dzxdzypz1         +     rezz
      ec(181)=ec(181)+qcx*dzydxxpx0+wqx*dzydxxpx1         +2.d0*rfxx+fa0
      ec(182)=ec(182)+qcy*dzydxxpy0+wqy*dzydxxpy1+     zay          +fa0
      ec(183)=ec(183)+qcz*dzydxxpz0+wqz*dzydxxpz1+     yaz          +fa0
      ec(184)=ec(184)+qcy*dzydxxpx0+wqy*dzydxxpx1+     zax             
      ec(185)=ec(185)+qcz*dzydxxpx0+wqz*dzydxxpx1+     yax             
      ec(186)=ec(186)+qcy*dzydxxpz0+wqy*dzydxxpz1+     zaz             
      ec(187)=ec(187)+qcx*dzydyypx0+wqx*dzydyypx1                   +fb0
      ec(188)=ec(188)+qcy*dzydyypy0+wqy*dzydyypy1+     zby+2.d0*rfyy+fb0
      ec(189)=ec(189)+qcz*dzydyypz0+wqz*dzydyypz1+     ybz          +fb0
      ec(190)=ec(190)+qcx*dzydyypy0+wqx*dzydyypy1                   
      ec(191)=ec(191)+qcx*dzydyypz0+wqx*dzydyypz1                   
      ec(192)=ec(192)+qcz*dzydyypy0+wqz*dzydyypy1+     yby
      ec(193)=ec(193)+qcx*dzydzzpx0+wqx*dzydzzpx1                   +fc0
      ec(194)=ec(194)+qcy*dzydzzpy0+wqy*dzydzzpy1+     zcy          +fc0
      ec(195)=ec(195)+qcz*dzydzzpz0+wqz*dzydzzpz1+     ycz+2.d0*rfzz+fc0
      ec(196)=ec(196)+qcx*dzydzzpy0+wqx*dzydzzpy1                
      ec(197)=ec(197)+qcx*dzydzzpz0+wqx*dzydzzpz1                   
      ec(198)=ec(198)+qcy*dzydzzpz0+wqy*dzydzzpz1+     zcz
      ec(199)=ec(199)+qcx*dzydyxpx0+wqx*dzydyxpx1         +     rfyx+fd0
      ec(200)=ec(200)+qcy*dzydyxpy0+wqy*dzydyxpy1+     zdy+     rfxy+fd0
      ec(201)=ec(201)+qcz*dzydyxpz0+wqz*dzydyxpz1+     ydz          +fd0
      ec(202)=ec(202)+qcx*dzydyxpy0+wqx*dzydyxpy1         +     rfyy
      ec(203)=ec(203)+qcx*dzydyxpz0+wqx*dzydyxpz1         +     rfyz
      ec(204)=ec(204)+qcz*dzydyxpy0+wqz*dzydyxpy1+     ydy
      ec(205)=ec(205)+qcx*dzydzxpx0+wqx*dzydzxpx1         +     rfzx+fe0
      ec(206)=ec(206)+qcy*dzydzxpy0+wqy*dzydzxpy1+     zey          +fe0
      ec(207)=ec(207)+qcz*dzydzxpz0+wqz*dzydzxpz1+     yez+     rfxz+fe0
      ec(208)=ec(208)+qcy*dzydzxpx0+wqy*dzydzxpx1+     zex         
      ec(209)=ec(209)+qcx*dzydzxpz0+wqx*dzydzxpz1         +     rfzz
      ec(210)=ec(210)+qcy*dzydzxpz0+wqy*dzydzxpz1+     zez
      ec(211)=ec(211)+qcx*dzydzypx0+wqx*dzydzypx1                   +ff0
      ec(212)=ec(212)+qcy*dzydzypy0+wqy*dzydzypy1+     zfy+     rfzy+ff0
      ec(213)=ec(213)+qcz*dzydzypz0+wqz*dzydzypz1+     yfz+     rfyz+ff0
      ec(214)=ec(214)+qcx*dzydzypy0+wqx*dzydzypy1                   
      ec(215)=ec(215)+qcx*dzydzypz0+wqx*dzydzypz1                   
      ec(216)=ec(216)+qcy*dzydzypz0+wqy*dzydzypz1+     zfz+     rfzz

                enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 

        do i=109,216
          ec(i)= ec(i)*root3
        enddo

        do i=1,216
          if (mod(i-1,6).ge.3) then
          ec(i)= ec(i)*root3
          endif
        enddo


        do i0 = 1,6
           do ii=19,36

             i = ii + 36*(i0-1)
             ec(i) = ec(i)*root3

           enddo
        enddo

      endif
      

      end
!= ddpp =============================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================
      subroutine ioddpp(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(6)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)

      dimension ec(324)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,6 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 ,
     &   0.09090909090909090d+00          /

      data  root3 / 1.73205080756887729352d+00 /


      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,324
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)

                  qdx =  yq(1,l,k) - xyz(1,latom)
                  qdy =  yq(2,l,k) - xyz(2,latom)
                  qdz =  yq(3,l,k) - xyz(3,latom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(7)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f6   = (((((fdat(13,it)*dt6   + fdat(12,it))*dt5
     &                    + fdat(11,it))*dt4  + fdat(10,it))*dt3
     &                    + fdat(9,it))*dt2  + fdat(8,it))*dt
     &                    + fdat(7,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f5   = (t2*f6 + ee)*rminv(6)
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)

                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     dm6 = fpp*f6! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
                     dm5 =  4.5d0 *tinv *  dm4
                     dm6 =  5.5d0 *tinv *  dm5
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)
                  s6 = dm6      !/( roo2**3)

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
 
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
                  px5 = pax*s5 + wpx*s6
                  py5 = pay*s5 + wpy*s6
                  pz5 = paz*s5 + wpz*s6

                  xp1 = pbx*s1 + wpx*s2
                  yp1 = pby*s1 + wpy*s2
                  zp1 = pbz*s1 + wpz*s2
                  xp2 = pbx*s2 + wpx*s3
                  yp2 = pby*s2 + wpy*s3
                  zp2 = pbz*s2 + wpz*s3
                  xp3 = pbx*s3 + wpx*s4
                  yp3 = pby*s3 + wpy*s4
                  zp3 = pbz*s3 + wpz*s4

                  s01 = zet*(s0-rooz*s1)
                  s12 = zet*(s1-rooz*s2)
                  s23 = zet*(s2-rooz*s3)
                  s34 = zet*(s3-rooz*s4)
                  s45 = zet*(s4-rooz*s5)
! dsss 
                  dxx0 = pax*px0 + wpx*px1+s01
                  dyy0 = pay*py0 + wpy*py1+s01
                  dzz0 = paz*pz0 + wpz*pz1+s01
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+s12
                  dyy1 = pay*py1 + wpy*py2+s12
                  dzz1 = paz*pz1 + wpz*pz2+s12
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+s23
                  dyy2 = pay*py2 + wpy*py3+s23
                  dzz2 = paz*pz2 + wpz*pz3+s23
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
 
                  dxx3 = pax*px3 + wpx*px4+s34
                  dyy3 = pay*py3 + wpy*py4+s34
                  dzz3 = paz*pz3 + wpz*pz4+s34
                  dyx3 = pay*px3 + wpy*px4
                  dzx3 = paz*px3 + wpz*px4
                  dzy3 = paz*py3 + wpz*py4

                  dxx4 = pax*px4 + wpx*px5+s45
                  dyy4 = pay*py4 + wpy*py5+s45
                  dzz4 = paz*pz4 + wpz*pz5+s45
                  dyx4 = pay*px4 + wpy*px5
                  dzx4 = paz*px4 + wpz*px5
                  dzy4 = paz*py4 + wpz*py5

!sdss
                  sdxx2 = pbx*xp2 + wpx*xp3 + s23
                  sdyy2 = pby*yp2 + wpy*yp3 + s23
                  sdzz2 = pbz*zp2 + wpz*zp3 + s23
                  sdyx2 = pby*xp2 + wpy*xp3
                  sdzx2 = pbz*xp2 + wpz*xp3
                  sdzy2 = pbz*yp2 + wpz*yp3

!ppss
                  ppxx0 = pbx * px0 + wpx*px1 + s01
                  ppyx0 = pbx * py0 + wpx*py1
                  ppzx0 = pbx * pz0 + wpx*pz1
                  ppxy0 = pby * px0 + wpy*px1
                  ppyy0 = pby * py0 + wpy*py1 + s01
                  ppzy0 = pby * pz0 + wpy*pz1
                  ppxz0 = pbz * px0 + wpz*px1
                  ppyz0 = pbz * py0 + wpz*py1
                  ppzz0 = pbz * pz0 + wpz*pz1 + s01
                            
                  ppxx1 = pbx * px1 + wpx*px2 + s12
                  ppyx1 = pbx * py1 + wpx*py2
                  ppzx1 = pbx * pz1 + wpx*pz2
                  ppxy1 = pby * px1 + wpy*px2
                  ppyy1 = pby * py1 + wpy*py2 + s12
                  ppzy1 = pby * pz1 + wpy*pz2
                  ppxz1 = pbz * px1 + wpz*px2
                  ppyz1 = pbz * py1 + wpz*py2
                  ppzz1 = pbz * pz1 + wpz*pz2 + s12
                             
                  ppxx2 = pbx * px2 + wpx*px3 + s23
                  ppyx2 = pbx * py2 + wpx*py3
                  ppzx2 = pbx * pz2 + wpx*pz3
                  ppxy2 = pby * px2 + wpy*px3
                  ppyy2 = pby * py2 + wpy*py3 + s23
                  ppzy2 = pby * pz2 + wpy*pz3
                  ppxz2 = pbz * px2 + wpz*px3
                  ppyz2 = pbz * py2 + wpz*py3
                  ppzz2 = pbz * pz2 + wpz*pz3 + s23
           
                  ppxx3 = pbx * px3 + wpx*px4 + s34
                  ppyx3 = pbx * py3 + wpx*py4
                  ppzx3 = pbx * pz3 + wpx*pz4
                  ppxy3 = pby * px3 + wpy*px4
                  ppyy3 = pby * py3 + wpy*py4 + s34
                  ppzy3 = pby * pz3 + wpy*pz4
                  ppxz3 = pbz * px3 + wpz*px4
                  ppyz3 = pbz * py3 + wpz*py4
                  ppzz3 = pbz * pz3 + wpz*pz4 + s34

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  px34 = zet*(px3-rooz*px4)
                  py34 = zet*(py3-rooz*py4)
                  pz34 = zet*(pz3-rooz*pz4)

!dpss 
                  dpxxx0 =  pbx*dxx0 + wpx*dxx1 + 2.0d0*px01
                  dpxxy0 =  pby*dxx0 + wpy*dxx1             
                  dpxxz0 =  pbz*dxx0 + wpz*dxx1             
                  dpyyx0 =  pbx*dyy0 + wpx*dyy1             
                  dpyyy0 =  pby*dyy0 + wpy*dyy1 + 2.0d0*py01
                  dpyyz0 =  pbz*dyy0 + wpz*dyy1             
                  dpzzx0 =  pbx*dzz0 + wpx*dzz1             
                  dpzzy0 =  pby*dzz0 + wpy*dzz1             
                  dpzzz0 =  pbz*dzz0 + wpz*dzz1 + 2.0d0*pz01
                  dpyxx0 =  pbx*dyx0 + wpx*dyx1 +       py01
                  dpyxy0 =  pby*dyx0 + wpy*dyx1 +       px01
                  dpyxz0 =  pbz*dyx0 + wpz*dyx1             
                  dpzxx0 =  pbx*dzx0 + wpx*dzx1 +       pz01
                  dpzxy0 =  pby*dzx0 + wpy*dzx1             
                  dpzxz0 =  pbz*dzx0 + wpz*dzx1 +       px01
                  dpzyx0 =  pbx*dzy0 + wpx*dzy1             
                  dpzyy0 =  pby*dzy0 + wpy*dzy1 +       pz01
                  dpzyz0 =  pbz*dzy0 + wpz*dzy1 +       py01
           
                  dpxxx1 =  pbx*dxx1 + wpx*dxx2 + 2.0d0*px12
                  dpxxy1 =  pby*dxx1 + wpy*dxx2             
                  dpxxz1 =  pbz*dxx1 + wpz*dxx2             
                  dpyyx1 =  pbx*dyy1 + wpx*dyy2             
                  dpyyy1 =  pby*dyy1 + wpy*dyy2 + 2.0d0*py12
                  dpyyz1 =  pbz*dyy1 + wpz*dyy2             
                  dpzzx1 =  pbx*dzz1 + wpx*dzz2             
                  dpzzy1 =  pby*dzz1 + wpy*dzz2             
                  dpzzz1 =  pbz*dzz1 + wpz*dzz2 + 2.0d0*pz12
                  dpyxx1 =  pbx*dyx1 + wpx*dyx2 +       py12
                  dpyxy1 =  pby*dyx1 + wpy*dyx2 +       px12
                  dpyxz1 =  pbz*dyx1 + wpz*dyx2             
                  dpzxx1 =  pbx*dzx1 + wpx*dzx2 +       pz12
                  dpzxy1 =  pby*dzx1 + wpy*dzx2             
                  dpzxz1 =  pbz*dzx1 + wpz*dzx2 +       px12
                  dpzyx1 =  pbx*dzy1 + wpx*dzy2             
                  dpzyy1 =  pby*dzy1 + wpy*dzy2 +       pz12
                  dpzyz1 =  pbz*dzy1 + wpz*dzy2 +       py12
           
                  dpxxx2 =  pbx*dxx2 + wpx*dxx3 + 2.0d0*px23
                  dpxxy2 =  pby*dxx2 + wpy*dxx3
                  dpxxz2 =  pbz*dxx2 + wpz*dxx3
                  dpyyx2 =  pbx*dyy2 + wpx*dyy3
                  dpyyy2 =  pby*dyy2 + wpy*dyy3 + 2.0d0*py23
                  dpyyz2 =  pbz*dyy2 + wpz*dyy3             
                  dpzzx2 =  pbx*dzz2 + wpx*dzz3             
                  dpzzy2 =  pby*dzz2 + wpy*dzz3             
                  dpzzz2 =  pbz*dzz2 + wpz*dzz3 + 2.0d0*pz23
                  dpyxx2 =  pbx*dyx2 + wpx*dyx3 +       py23
                  dpyxy2 =  pby*dyx2 + wpy*dyx3 +       px23
                  dpyxz2 =  pbz*dyx2 + wpz*dyx3             
                  dpzxx2 =  pbx*dzx2 + wpx*dzx3 +       pz23
                  dpzxy2 =  pby*dzx2 + wpy*dzx3             
                  dpzxz2 =  pbz*dzx2 + wpz*dzx3 +       px23
                  dpzyx2 =  pbx*dzy2 + wpx*dzy3             
                  dpzyy2 =  pby*dzy2 + wpy*dzy3 +       pz23
                  dpzyz2 =  pbz*dzy2 + wpz*dzy3 +       py23
           
                  dpxxx3 =  pbx*dxx3 + wpx*dxx4 + 2.0d0*px34
                  dpxxy3 =  pby*dxx3 + wpy*dxx4             
                  dpxxz3 =  pbz*dxx3 + wpz*dxx4             
                  dpyyx3 =  pbx*dyy3 + wpx*dyy4             
                  dpyyy3 =  pby*dyy3 + wpy*dyy4 + 2.0d0*py34
                  dpyyz3 =  pbz*dyy3 + wpz*dyy4             
                  dpzzx3 =  pbx*dzz3 + wpx*dzz4             
                  dpzzy3 =  pby*dzz3 + wpy*dzz4             
                  dpzzz3 =  pbz*dzz3 + wpz*dzz4 + 2.0d0*pz34
                  dpyxx3 =  pbx*dyx3 + wpx*dyx4 +       py34
                  dpyxy3 =  pby*dyx3 + wpy*dyx4 +       px34
                  dpyxz3 =  pbz*dyx3 + wpz*dyx4             
                  dpzxx3 =  pbx*dzx3 + wpx*dzx4 +       pz34
                  dpzxy3 =  pby*dzx3 + wpy*dzx4             
                  dpzxz3 =  pbz*dzx3 + wpz*dzx4 +       px34
                  dpzyx3 =  pbx*dzy3 + wpx*dzy4             
                  dpzyy3 =  pby*dzy3 + wpy*dzy4 +       pz34
                  dpzyz3 =  pbz*dzy3 + wpz*dzy4 +       py34


         xp12 = zet*(xp1 - rooz*xp2)
         yp12 = zet*(yp1 - rooz*yp2)
         zp12 = zet*(zp1 - rooz*zp2)
         xp23 = zet*(xp2 - rooz*xp3)
         yp23 = zet*(yp2 - rooz*yp3)
         zp23 = zet*(zp2 - rooz*zp3)

!pdss
         pdxxx1 = pbx*ppxx1 + wpx*ppxx2 +px12 +xp12
         pdxyy1 = pby*ppxy1 + wpy*ppxy2 +px12 
         pdxzz1 = pbz*ppxz1 + wpz*ppxz2 +px12 
         pdxyx1 = pby*ppxx1 + wpy*ppxx2 
         pdxzx1 = pbz*ppxx1 + wpz*ppxx2 
         pdxzy1 = pby*ppxz1 + wpy*ppxz2
         pdyxx1 = pbx*ppyx1 + wpx*ppyx2 +py12
         pdyyy1 = pby*ppyy1 + wpy*ppyy2 +py12 +yp12 
         pdyzz1 = pbz*ppyz1 + wpz*ppyz2 +py12 
         pdyyx1 = pbx*ppyy1 + wpx*ppyy2 
         pdyzx1 = pbx*ppyz1 + wpx*ppyz2 
         pdyzy1 = pbz*ppyy1 + wpz*ppyy2 
         pdzxx1 = pbx*ppzx1 + wpx*ppzx2 +pz12
         pdzyy1 = pby*ppzy1 + wpy*ppzy2 +pz12
         pdzzz1 = pbz*ppzz1 + wpz*ppzz2 +pz12 +zp12
         pdzyx1 = pbx*ppzy1 + wpx*ppzy2
         pdzzx1 = pbx*ppzz1 + wpx*ppzz2
         pdzzy1 = pby*ppzz1 + wpy*ppzz2

         pdxxx2 = pbx*ppxx2 + wpx*ppxx3 +px23 +xp23
         pdxyy2 = pby*ppxy2 + wpy*ppxy3 +px23
         pdxzz2 = pbz*ppxz2 + wpz*ppxz3 +px23
         pdxyx2 = pby*ppxx2 + wpy*ppxx3
         pdxzx2 = pbz*ppxx2 + wpz*ppxx3
         pdxzy2 = pby*ppxz2 + wpy*ppxz3
         pdyxx2 = pbx*ppyx2 + wpx*ppyx3 +py23
         pdyyy2 = pby*ppyy2 + wpy*ppyy3 +py23 +yp23
         pdyzz2 = pbz*ppyz2 + wpz*ppyz3 +py23
         pdyyx2 = pbx*ppyy2 + wpx*ppyy3
         pdyzx2 = pbx*ppyz2 + wpx*ppyz3
         pdyzy2 = pbz*ppyy2 + wpz*ppyy3
         pdzxx2 = pbx*ppzx2 + wpx*ppzx3 +pz23
         pdzyy2 = pby*ppzy2 + wpy*ppzy3 +pz23
         pdzzz2 = pbz*ppzz2 + wpz*ppzz3 +pz23 +zp23
         pdzyx2 = pbx*ppzy2 + wpx*ppzy3
         pdzzx2 = pbx*ppzz2 + wpx*ppzz3
         pdzzy2 = pby*ppzz2 + wpy*ppzz3

!RANK = 4
       ppxx01 = zet*(ppxx0 - rooz*ppxx1)
       ppxy01 = zet*(ppxy0 - rooz*ppxy1)
       ppxz01 = zet*(ppxz0 - rooz*ppxz1)
       ppyx01 = zet*(ppyx0 - rooz*ppyx1)
       ppyy01 = zet*(ppyy0 - rooz*ppyy1)
       ppyz01 = zet*(ppyz0 - rooz*ppyz1)
       ppzx01 = zet*(ppzx0 - rooz*ppzx1)
       ppzy01 = zet*(ppzy0 - rooz*ppzy1)
       ppzz01 = zet*(ppzz0 - rooz*ppzz1)

       ppxx12 = zet*(ppxx1 - rooz*ppxx2)
       ppxy12 = zet*(ppxy1 - rooz*ppxy2)
       ppxz12 = zet*(ppxz1 - rooz*ppxz2)
       ppyx12 = zet*(ppyx1 - rooz*ppyx2)
       ppyy12 = zet*(ppyy1 - rooz*ppyy2)
       ppyz12 = zet*(ppyz1 - rooz*ppyz2)
       ppzx12 = zet*(ppzx1 - rooz*ppzx2)
       ppzy12 = zet*(ppzy1 - rooz*ppzy2)
       ppzz12 = zet*(ppzz1 - rooz*ppzz2)

       ppxx23 = zet*(ppxx2 - rooz*ppxx3)
       ppxy23 = zet*(ppxy2 - rooz*ppxy3)
       ppxz23 = zet*(ppxz2 - rooz*ppxz3)
       ppyx23 = zet*(ppyx2 - rooz*ppyx3)
       ppyy23 = zet*(ppyy2 - rooz*ppyy3)
       ppyz23 = zet*(ppyz2 - rooz*ppyz3)
       ppzx23 = zet*(ppzx2 - rooz*ppzx3)
       ppzy23 = zet*(ppzy2 - rooz*ppzy3)
       ppzz23 = zet*(ppzz2 - rooz*ppzz3)
                 
       dxx01 = zet*(dxx0 -rooz*dxx1)
       dyy01 = zet*(dyy0 -rooz*dyy1)
       dzz01 = zet*(dzz0 -rooz*dzz1)
       dyx01 = zet*(dyx0 -rooz*dyx1)
       dzx01 = zet*(dzx0 -rooz*dzx1)
       dzy01 = zet*(dzy0 -rooz*dzy1)

       dxx12 = zet*(dxx1 -rooz*dxx2)
       dyy12 = zet*(dyy1 -rooz*dyy2)
       dzz12 = zet*(dzz1 -rooz*dzz2)
       dyx12 = zet*(dyx1 -rooz*dyx2)
       dzx12 = zet*(dzx1 -rooz*dzx2)
       dzy12 = zet*(dzy1 -rooz*dzy2)

       dxx23 = zet*(dxx2 -rooz*dxx3)
       dyy23 = zet*(dyy2 -rooz*dyy3)
       dzz23 = zet*(dzz2 -rooz*dzz3)
       dyx23 = zet*(dyx2 -rooz*dyx3)
       dzx23 = zet*(dzx2 -rooz*dzx3)
       dzy23 = zet*(dzy2 -rooz*dzy3)

!ddss
       ddxxxx0 = pbx*dpxxx0 + wpx*dpxxx1 + 2.0d0*ppxx01 + dxx01
       ddxxyy0 = pby*dpxxy0 + wpy*dpxxy1                + dxx01
       ddxxzz0 = pbz*dpxxz0 + wpz*dpxxz1                + dxx01
       ddxxyx0 = pby*dpxxx0 + wpy*dpxxx1
       ddxxzx0 = pbz*dpxxx0 + wpz*dpxxx1
       ddxxzy0 = pby*dpxxz0 + wpy*dpxxz1
       ddyyxx0 = pbx*dpyyx0 + wpx*dpyyx1                + dyy01
       ddyyyy0 = pby*dpyyy0 + wpy*dpyyy1 + 2.0d0*ppyy01 + dyy01
       ddyyzz0 = pbz*dpyyz0 + wpz*dpyyz1                + dyy01
       ddyyyx0 = pbx*dpyyy0 + wpx*dpyyy1
       ddyyzx0 = pbx*dpyyz0 + wpx*dpyyz1
       ddyyzy0 = pbz*dpyyy0 + wpz*dpyyy1
       ddzzxx0 = pbx*dpzzx0 + wpx*dpzzx1                + dzz01
       ddzzyy0 = pby*dpzzy0 + wpy*dpzzy1                + dzz01
       ddzzzz0 = pbz*dpzzz0 + wpz*dpzzz1 + 2.0d0*ppzz01 + dzz01
       ddzzyx0 = pbx*dpzzy0 + wpx*dpzzy1
       ddzzzx0 = pbx*dpzzz0 + wpx*dpzzz1
       ddzzzy0 = pby*dpzzz0 + wpy*dpzzz1
       ddyxxx0 = pbx*dpyxx0 + wpx*dpyxx1 +       ppyx01 + dyx01
       ddyxyy0 = pby*dpyxy0 + wpy*dpyxy1 +       ppxy01 + dyx01
       ddyxzz0 = pbz*dpyxz0 + wpz*dpyxz1                + dyx01
       ddyxyx0 = pbx*dpyxy0 + wpx*dpyxy1 +       ppyy01
       ddyxzx0 = pbz*dpyxx0 + wpz*dpyxx1
       ddyxzy0 = pbz*dpyxy0 + wpz*dpyxy1
       ddzxxx0 = pbx*dpzxx0 + wpx*dpzxx1 +       ppzx01 + dzx01
       ddzxyy0 = pby*dpzxy0 + wpy*dpzxy1                + dzx01
       ddzxzz0 = pbz*dpzxz0 + wpz*dpzxz1 +       ppxz01 + dzx01
       ddzxyx0 = pby*dpzxx0 + wpy*dpzxx1
       ddzxzx0 = pbx*dpzxz0 + wpx*dpzxz1 +       ppzz01
       ddzxzy0 = pby*dpzxz0 + wpy*dpzxz1
       ddzyxx0 = pbx*dpzyx0 + wpx*dpzyx1                + dzy01
       ddzyyy0 = pby*dpzyy0 + wpy*dpzyy1 +       ppzy01 + dzy01
       ddzyzz0 = pbz*dpzyz0 + wpz*dpzyz1 +       ppyz01 + dzy01
       ddzyyx0 = pbx*dpzyy0 + wpx*dpzyy1
       ddzyzx0 = pbx*dpzyz0 + wpx*dpzyz1
       ddzyzy0 = pby*dpzyz0 + wpy*dpzyz1 +       ppzz01

       ddxxxx1 = pbx*dpxxx1 + wpx*dpxxx2 + 2.0d0*ppxx12 + dxx12
       ddxxyy1 = pby*dpxxy1 + wpy*dpxxy2                + dxx12
       ddxxzz1 = pbz*dpxxz1 + wpz*dpxxz2                + dxx12
       ddxxyx1 = pby*dpxxx1 + wpy*dpxxx2
       ddxxzx1 = pbz*dpxxx1 + wpz*dpxxx2
       ddxxzy1 = pby*dpxxz1 + wpy*dpxxz2
       ddyyxx1 = pbx*dpyyx1 + wpx*dpyyx2                + dyy12
       ddyyyy1 = pby*dpyyy1 + wpy*dpyyy2 + 2.0d0*ppyy12 + dyy12
       ddyyzz1 = pbz*dpyyz1 + wpz*dpyyz2                + dyy12
       ddyyyx1 = pbx*dpyyy1 + wpx*dpyyy2
       ddyyzx1 = pbx*dpyyz1 + wpx*dpyyz2
       ddyyzy1 = pbz*dpyyy1 + wpz*dpyyy2
       ddzzxx1 = pbx*dpzzx1 + wpx*dpzzx2                + dzz12
       ddzzyy1 = pby*dpzzy1 + wpy*dpzzy2                + dzz12
       ddzzzz1 = pbz*dpzzz1 + wpz*dpzzz2 + 2.0d0*ppzz12 + dzz12
       ddzzyx1 = pbx*dpzzy1 + wpx*dpzzy2
       ddzzzx1 = pbx*dpzzz1 + wpx*dpzzz2
       ddzzzy1 = pby*dpzzz1 + wpy*dpzzz2
       ddyxxx1 = pbx*dpyxx1 + wpx*dpyxx2 +       ppyx12 + dyx12
       ddyxyy1 = pby*dpyxy1 + wpy*dpyxy2 +       ppxy12 + dyx12
       ddyxzz1 = pbz*dpyxz1 + wpz*dpyxz2                + dyx12
       ddyxyx1 = pbx*dpyxy1 + wpx*dpyxy2 +       ppyy12
       ddyxzx1 = pbz*dpyxx1 + wpz*dpyxx2
       ddyxzy1 = pbz*dpyxy1 + wpz*dpyxy2
       ddzxxx1 = pbx*dpzxx1 + wpx*dpzxx2 +       ppzx12 + dzx12
       ddzxyy1 = pby*dpzxy1 + wpy*dpzxy2                + dzx12
       ddzxzz1 = pbz*dpzxz1 + wpz*dpzxz2 +       ppxz12 + dzx12
       ddzxyx1 = pby*dpzxx1 + wpy*dpzxx2
       ddzxzx1 = pbx*dpzxz1 + wpx*dpzxz2 +       ppzz12
       ddzxzy1 = pby*dpzxz1 + wpy*dpzxz2
       ddzyxx1 = pbx*dpzyx1 + wpx*dpzyx2                + dzy12
       ddzyyy1 = pby*dpzyy1 + wpy*dpzyy2 +       ppzy12 + dzy12
       ddzyzz1 = pbz*dpzyz1 + wpz*dpzyz2 +       ppyz12 + dzy12
       ddzyyx1 = pbx*dpzyy1 + wpx*dpzyy2
       ddzyzx1 = pbx*dpzyz1 + wpx*dpzyz2
       ddzyzy1 = pby*dpzyz1 + wpy*dpzyz2 +       ppzz12

       ddxxxx2 = pbx*dpxxx2 + wpx*dpxxx3 + 2.0d0*ppxx23 + dxx23
       ddxxyy2 = pby*dpxxy2 + wpy*dpxxy3                + dxx23
       ddxxzz2 = pbz*dpxxz2 + wpz*dpxxz3                + dxx23
       ddxxyx2 = pby*dpxxx2 + wpy*dpxxx3
       ddxxzx2 = pbz*dpxxx2 + wpz*dpxxx3
       ddxxzy2 = pby*dpxxz2 + wpy*dpxxz3
       ddyyxx2 = pbx*dpyyx2 + wpx*dpyyx3                + dyy23
       ddyyyy2 = pby*dpyyy2 + wpy*dpyyy3 + 2.0d0*ppyy23 + dyy23
       ddyyzz2 = pbz*dpyyz2 + wpz*dpyyz3                + dyy23
       ddyyyx2 = pbx*dpyyy2 + wpx*dpyyy3
       ddyyzx2 = pbx*dpyyz2 + wpx*dpyyz3
       ddyyzy2 = pbz*dpyyy2 + wpz*dpyyy3
       ddzzxx2 = pbx*dpzzx2 + wpx*dpzzx3                + dzz23
       ddzzyy2 = pby*dpzzy2 + wpy*dpzzy3                + dzz23
       ddzzzz2 = pbz*dpzzz2 + wpz*dpzzz3 + 2.0d0*ppzz23 + dzz23
       ddzzyx2 = pbx*dpzzy2 + wpx*dpzzy3
       ddzzzx2 = pbx*dpzzz2 + wpx*dpzzz3
       ddzzzy2 = pby*dpzzz2 + wpy*dpzzz3
       ddyxxx2 = pbx*dpyxx2 + wpx*dpyxx3 +       ppyx23 + dyx23
       ddyxyy2 = pby*dpyxy2 + wpy*dpyxy3 +       ppxy23 + dyx23
       ddyxzz2 = pbz*dpyxz2 + wpz*dpyxz3                + dyx23
       ddyxyx2 = pbx*dpyxy2 + wpx*dpyxy3 +       ppyy23
       ddyxzx2 = pbz*dpyxx2 + wpz*dpyxx3
       ddyxzy2 = pbz*dpyxy2 + wpz*dpyxy3
       ddzxxx2 = pbx*dpzxx2 + wpx*dpzxx3 +       ppzx23 + dzx23
       ddzxyy2 = pby*dpzxy2 + wpy*dpzxy3                + dzx23
       ddzxzz2 = pbz*dpzxz2 + wpz*dpzxz3 +       ppxz23 + dzx23
       ddzxyx2 = pby*dpzxx2 + wpy*dpzxx3
       ddzxzx2 = pbx*dpzxz2 + wpx*dpzxz3 +       ppzz23
       ddzxzy2 = pby*dpzxz2 + wpy*dpzxz3
       ddzyxx2 = pbx*dpzyx2 + wpx*dpzyx3                + dzy23
       ddzyyy2 = pby*dpzyy2 + wpy*dpzyy3 +       ppzy23 + dzy23
       ddzyzz2 = pbz*dpzyz2 + wpz*dpzyz3 +       ppyz23 + dzy23
       ddzyyx2 = pbx*dpzyy2 + wpx*dpzyy3
       ddzyzx2 = pbx*dpzyz2 + wpx*dpzyz3
       ddzyzy2 = pby*dpzyz2 + wpy*dpzyz3 +       ppzz23


      rppxx2 = rkp*ppxx2
      rppxy2 = rkp*ppxy2
      rppxz2 = rkp*ppxz2
      rppyx2 = rkp*ppyx2
      rppyy2 = rkp*ppyy2
      rppyz2 = rkp*ppyz2
      rppzx2 = rkp*ppzx2
      rppzy2 = rkp*ppzy2
      rppzz2 = rkp*ppzz2

      rdxx2 = rkp*dxx2
      rdyy2 = rkp*dyy2
      rdzz2 = rkp*dzz2
      rdyx2 = rkp*dyx2
      rdzx2 = rkp*dzx2
      rdzy2 = rkp*dzy2

!dpps
      axx = qcx*dpxxx1 + wqx*dpxxx2 + 2.0d0*rppxx2 + rdxx2
      axy = qcy*dpxxx1 + wqy*dpxxx2 
      axz = qcz*dpxxx1 + wqz*dpxxx2 
      ayx = qcx*dpxxy1 + wqx*dpxxy2 + 2.0d0*rppxy2        
      ayy = qcy*dpxxy1 + wqy*dpxxy2                + rdxx2
      ayz = qcz*dpxxy1 + wqz*dpxxy2                       
      azx = qcx*dpxxz1 + wqx*dpxxz2 + 2.0d0*rppxz2        
      azy = qcy*dpxxz1 + wqy*dpxxz2                       
      azz = qcz*dpxxz1 + wqz*dpxxz2                + rdxx2
      bxx = qcx*dpyyx1 + wqx*dpyyx2                + rdyy2
      bxy = qcy*dpyyx1 + wqy*dpyyx2 + 2.0d0*rppyx2        
      bxz = qcz*dpyyx1 + wqz*dpyyx2                       
      byx = qcx*dpyyy1 + wqx*dpyyy2                       
      byy = qcy*dpyyy1 + wqy*dpyyy2 + 2.0d0*rppyy2 + rdyy2
      byz = qcz*dpyyy1 + wqz*dpyyy2                       
      bzx = qcx*dpyyz1 + wqx*dpyyz2                       
      bzy = qcy*dpyyz1 + wqy*dpyyz2 + 2.0d0*rppyz2        
      bzz = qcz*dpyyz1 + wqz*dpyyz2                + rdyy2
      cxx = qcx*dpzzx1 + wqx*dpzzx2                + rdzz2
      cxy = qcy*dpzzx1 + wqy*dpzzx2                       
      cxz = qcz*dpzzx1 + wqz*dpzzx2 + 2.0d0*rppzx2        
      cyx = qcx*dpzzy1 + wqx*dpzzy2                       
      cyy = qcy*dpzzy1 + wqy*dpzzy2                + rdzz2
      cyz = qcz*dpzzy1 + wqz*dpzzy2 + 2.0d0*rppzy2        
      czx = qcx*dpzzz1 + wqx*dpzzz2                       
      czy = qcy*dpzzz1 + wqy*dpzzz2                       
      czz = qcz*dpzzz1 + wqz*dpzzz2 + 2.0d0*rppzz2 + rdzz2
      dxx = qcx*dpyxx1 + wqx*dpyxx2 +       rppyx2 + rdyx2
      dxy = qcy*dpyxx1 + wqy*dpyxx2 +       rppxx2        
      dxz = qcz*dpyxx1 + wqz*dpyxx2                       
      dyx = qcx*dpyxy1 + wqx*dpyxy2 +       rppyy2        
      dyy = qcy*dpyxy1 + wqy*dpyxy2 +       rppxy2 + rdyx2
      dyz = qcz*dpyxy1 + wqz*dpyxy2            !    + rdyx2
      dzx = qcx*dpyxz1 + wqx*dpyxz2 +       rppyz2        
      dzy = qcy*dpyxz1 + wqy*dpyxz2 +       rppxz2        
      dzz = qcz*dpyxz1 + wqz*dpyxz2                + rdyx2
      exx = qcx*dpzxx1 + wqx*dpzxx2 +       rppzx2 + rdzx2
      exy = qcy*dpzxx1 + wqy*dpzxx2                       
      exz = qcz*dpzxx1 + wqz*dpzxx2 +       rppxx2        
      eyx = qcx*dpzxy1 + wqx*dpzxy2 +       rppzy2        
      eyy = qcy*dpzxy1 + wqy*dpzxy2                + rdzx2
      eyz = qcz*dpzxy1 + wqz*dpzxy2 +       rppxy2        
      ezx = qcx*dpzxz1 + wqx*dpzxz2 +       rppzz2        
      ezy = qcy*dpzxz1 + wqy*dpzxz2                       
      ezz = qcz*dpzxz1 + wqz*dpzxz2 +       rppxz2 + rdzx2
      fxx = qcx*dpzyx1 + wqx*dpzyx2                + rdzy2
      fxy = qcy*dpzyx1 + wqy*dpzyx2 +       rppzx2        
      fxz = qcz*dpzyx1 + wqz*dpzyx2 +       rppyx2        
      fyx = qcx*dpzyy1 + wqx*dpzyy2                       
      fyy = qcy*dpzyy1 + wqy*dpzyy2 +       rppzy2 + rdzy2
      fyz = qcz*dpzyy1 + wqz*dpzyy2 +       rppyy2        
      fzx = qcx*dpzyz1 + wqx*dpzyz2                       
      fzy = qcy*dpzyz1 + wqy*dpzyz2 +       rppzz2        
      fzz = qcz*dpzyz1 + wqz*dpzyz2 +       rppyz2 + rdzy2


      rsdxx2 = rkp * sdxx2
      rsdyy2 = rkp * sdyy2
      rsdzz2 = rkp * sdzz2
      rsdyx2 = rkp * sdyx2
      rsdzx2 = rkp * sdzx2
      rsdzy2 = rkp * sdzy2

!pdps 
      pxdxxpx1 = qcx*pdxxx1+wqx*pdxxx2+rsdxx2+2.0d0*rppxx2
      pxdxxpy1 = qcy*pdxxx1+wqy*pdxxx2                   
      pxdxxpz1 = qcz*pdxxx1+wqz*pdxxx2                   
      pxdyypx1 = qcx*pdxyy1+wqx*pdxyy2+rsdyy2             
      pxdyypy1 = qcy*pdxyy1+wqy*pdxyy2       +2.0d0*rppxy2
      pxdyypz1 = qcz*pdxyy1+wqz*pdxyy2                   
      pxdzzpx1 = qcx*pdxzz1+wqx*pdxzz2+rsdzz2
      pxdzzpy1 = qcy*pdxzz1+wqy*pdxzz2                   
      pxdzzpz1 = qcz*pdxzz1+wqz*pdxzz2       +2.0d0*rppxz2
      pxdyxpx1 = qcx*pdxyx1+wqx*pdxyx2+rsdyx2+      rppxy2
      pxdyxpy1 = qcy*pdxyx1+wqy*pdxyx2       +      rppxx2
      pxdyxpz1 = qcz*pdxyx1+wqz*pdxyx2                   
      pxdzxpx1 = qcx*pdxzx1+wqx*pdxzx2+rsdzx2+      rppxz2
      pxdzxpy1 = qcy*pdxzx1+wqy*pdxzx2                   
      pxdzxpz1 = qcz*pdxzx1+wqz*pdxzx2       +      rppxx2
      pxdzypx1 = qcx*pdxzy1+wqx*pdxzy2+rsdzy2             
      pxdzypy1 = qcy*pdxzy1+wqy*pdxzy2       +      rppxz2
      pxdzypz1 = qcz*pdxzy1+wqz*pdxzy2       +      rppxy2
      pydxxpx1 = qcx*pdyxx1+wqx*pdyxx2       +2.0d0*rppyx2
      pydxxpy1 = qcy*pdyxx1+wqy*pdyxx2+rsdxx2             
      pydxxpz1 = qcz*pdyxx1+wqz*pdyxx2                   
      pydyypx1 = qcx*pdyyy1+wqx*pdyyy2                   
      pydyypy1 = qcy*pdyyy1+wqy*pdyyy2+rsdyy2+2.0d0*rppyy2
      pydyypz1 = qcz*pdyyy1+wqz*pdyyy2                   
      pydzzpx1 = qcx*pdyzz1+wqx*pdyzz2                   
      pydzzpy1 = qcy*pdyzz1+wqy*pdyzz2+rsdzz2             
      pydzzpz1 = qcz*pdyzz1+wqz*pdyzz2       +2.0d0*rppyz2
      pydyxpx1 = qcx*pdyyx1+wqx*pdyyx2       +      rppyy2
      pydyxpy1 = qcy*pdyyx1+wqy*pdyyx2+rsdyx2+      rppyx2
      pydyxpz1 = qcz*pdyyx1+wqz*pdyyx2                   
      pydzxpx1 = qcx*pdyzx1+wqx*pdyzx2       +      rppyz2
      pydzxpy1 = qcy*pdyzx1+wqy*pdyzx2+rsdzx2             
      pydzxpz1 = qcz*pdyzx1+wqz*pdyzx2       +      rppyx2
      pydzypx1 = qcx*pdyzy1+wqx*pdyzy2                   
      pydzypy1 = qcy*pdyzy1+wqy*pdyzy2+rsdzy2+      rppyz2
      pydzypz1 = qcz*pdyzy1+wqz*pdyzy2       +      rppyy2
      pzdxxpx1 = qcx*pdzxx1+wqx*pdzxx2       +2.0d0*rppzx2 
      pzdxxpy1 = qcy*pdzxx1+wqy*pdzxx2                    
      pzdxxpz1 = qcz*pdzxx1+wqz*pdzxx2+rsdxx2              
      pzdyypx1 = qcx*pdzyy1+wqx*pdzyy2                    
      pzdyypy1 = qcy*pdzyy1+wqy*pdzyy2       +2.0d0*rppzy2 
      pzdyypz1 = qcz*pdzyy1+wqz*pdzyy2+rsdyy2
      pzdzzpx1 = qcx*pdzzz1+wqx*pdzzz2                    
      pzdzzpy1 = qcy*pdzzz1+wqy*pdzzz2                    
      pzdzzpz1 = qcz*pdzzz1+wqz*pdzzz2+rsdzz2+2.0d0*rppzz2 
      pzdyxpx1 = qcx*pdzyx1+wqx*pdzyx2       +      rppzy2 
      pzdyxpy1 = qcy*pdzyx1+wqy*pdzyx2       +      rppzx2 
      pzdyxpz1 = qcz*pdzyx1+wqz*pdzyx2+rsdyx2              
      pzdzxpx1 = qcx*pdzzx1+wqx*pdzzx2       +      rppzz2 
      pzdzxpy1 = qcy*pdzzx1+wqy*pdzzx2                    
      pzdzxpz1 = qcz*pdzzx1+wqz*pdzzx2+rsdzx2+      rppzx2 
      pzdzypx1 = qcx*pdzzy1+wqx*pdzzy2                    
      pzdzypy1 = qcy*pdzzy1+wqy*pdzzy2       +      rppzz2 
      pzdzypz1 = qcz*pdzzy1+wqz*pdzzy2+rsdzy2+      rppzy2 

         rdpxxx1 = rkp * dpxxx1
         rdpxxy1 = rkp * dpxxy1
         rdpxxz1 = rkp * dpxxz1
         rdpyyx1 = rkp * dpyyx1
         rdpyyy1 = rkp * dpyyy1
         rdpyyz1 = rkp * dpyyz1
         rdpzzx1 = rkp * dpzzx1
         rdpzzy1 = rkp * dpzzy1
         rdpzzz1 = rkp * dpzzz1
         rdpyxx1 = rkp * dpyxx1
         rdpyxy1 = rkp * dpyxy1
         rdpyxz1 = rkp * dpyxz1
         rdpzxx1 = rkp * dpzxx1
         rdpzxy1 = rkp * dpzxy1
         rdpzxz1 = rkp * dpzxz1
         rdpzyx1 = rkp * dpzyx1
         rdpzyy1 = rkp * dpzyy1
         rdpzyz1 = rkp * dpzyz1
         rdpxxx2 = rkp * dpxxx2
         rdpxxy2 = rkp * dpxxy2
         rdpxxz2 = rkp * dpxxz2
         rdpyyx2 = rkp * dpyyx2
         rdpyyy2 = rkp * dpyyy2
         rdpyyz2 = rkp * dpyyz2
         rdpzzx2 = rkp * dpzzx2
         rdpzzy2 = rkp * dpzzy2
         rdpzzz2 = rkp * dpzzz2
         rdpyxx2 = rkp * dpyxx2
         rdpyxy2 = rkp * dpyxy2
         rdpyxz2 = rkp * dpyxz2
         rdpzxx2 = rkp * dpzxx2
         rdpzxy2 = rkp * dpzxy2
         rdpzxz2 = rkp * dpzxz2
         rdpzyx2 = rkp * dpzyx2
         rdpzyy2 = rkp * dpzyy2
         rdpzyz2 = rkp * dpzyz2

         rpdxxx1 = rkp * pdxxx1
         rpdxyy1 = rkp * pdxyy1
         rpdxzz1 = rkp * pdxzz1
         rpdxyx1 = rkp * pdxyx1
         rpdxzx1 = rkp * pdxzx1
         rpdxzy1 = rkp * pdxzy1
         rpdyxx1 = rkp * pdyxx1
         rpdyyy1 = rkp * pdyyy1
         rpdyzz1 = rkp * pdyzz1
         rpdyyx1 = rkp * pdyyx1
         rpdyzx1 = rkp * pdyzx1
         rpdyzy1 = rkp * pdyzy1
         rpdzxx1 = rkp * pdzxx1
         rpdzyy1 = rkp * pdzyy1
         rpdzzz1 = rkp * pdzzz1
         rpdzyx1 = rkp * pdzyx1
         rpdzzx1 = rkp * pdzzx1
         rpdzzy1 = rkp * pdzzy1

         rpdxxx2 = rkp * pdxxx2
         rpdxyy2 = rkp * pdxyy2
         rpdxzz2 = rkp * pdxzz2
         rpdxyx2 = rkp * pdxyx2
         rpdxzx2 = rkp * pdxzx2
         rpdxzy2 = rkp * pdxzy2
         rpdyxx2 = rkp * pdyxx2
         rpdyyy2 = rkp * pdyyy2
         rpdyzz2 = rkp * pdyzz2
         rpdyyx2 = rkp * pdyyx2
         rpdyzx2 = rkp * pdyzx2
         rpdyzy2 = rkp * pdyzy2
         rpdzxx2 = rkp * pdzxx2
         rpdzyy2 = rkp * pdzyy2
         rpdzzz2 = rkp * pdzzz2
         rpdzyx2 = rkp * pdzyx2
         rpdzzx2 = rkp * pdzzx2
         rpdzzy2 = rkp * pdzzy2

      dxxdxxpx0=qcx*ddxxxx0 + wqx*ddxxxx1 + 2.0d0*rpdxxx1+2.0d0*rdpxxx1
      dxxdxxpy0=qcy*ddxxxx0 + wqy*ddxxxx1
      dxxdxxpz0=qcz*ddxxxx0 + wqz*ddxxxx1
      dxxdyypx0=qcx*ddxxyy0 + wqx*ddxxyy1 + 2.0d0*rpdxyy1
      dxxdyypy0=qcy*ddxxyy0 + wqy*ddxxyy1                +2.0d0*rdpxxy1
      dxxdyypz0=qcz*ddxxyy0 + wqz*ddxxyy1
      dxxdzzpx0=qcx*ddxxzz0 + wqx*ddxxzz1 + 2.0d0*rpdxzz1
      dxxdzzpy0=qcy*ddxxzz0 + wqy*ddxxzz1
      dxxdzzpz0=qcz*ddxxzz0 + wqz*ddxxzz1                +2.0d0*rdpxxz1
      dxxdyxpx0=qcx*ddxxyx0 + wqx*ddxxyx1 + 2.0d0*rpdxyx1+      rdpxxy1
      dxxdyxpy0=qcy*ddxxyx0 + wqy*ddxxyx1                +      rdpxxx1
      dxxdyxpz0=qcz*ddxxyx0 + wqz*ddxxyx1 
      dxxdzxpx0=qcx*ddxxzx0 + wqx*ddxxzx1 + 2.0d0*rpdxzx1+      rdpxxz1
      dxxdzxpy0=qcy*ddxxzx0 + wqy*ddxxzx1
      dxxdzxpz0=qcz*ddxxzx0 + wqz*ddxxzx1                +      rdpxxx1
      dxxdzypx0=qcx*ddxxzy0 + wqx*ddxxzy1 + 2.0d0*rpdxzy1
      dxxdzypy0=qcy*ddxxzy0 + wqy*ddxxzy1                +      rdpxxz1
      dxxdzypz0=qcz*ddxxzy0 + wqz*ddxxzy1                +      rdpxxy1
      dyydxxpx0=qcx*ddyyxx0 + wqx*ddyyxx1                +2.0d0*rdpyyx1
      dyydxxpy0=qcy*ddyyxx0 + wqy*ddyyxx1 + 2.0d0*rpdyxx1
      dyydxxpz0=qcz*ddyyxx0 + wqz*ddyyxx1
      dyydyypx0=qcx*ddyyyy0 + wqx*ddyyyy1
      dyydyypy0=qcy*ddyyyy0 + wqy*ddyyyy1 + 2.0d0*rpdyyy1+2.0d0*rdpyyy1
      dyydyypz0=qcz*ddyyyy0 + wqz*ddyyyy1
      dyydzzpx0=qcx*ddyyzz0 + wqx*ddyyzz1
      dyydzzpy0=qcy*ddyyzz0 + wqy*ddyyzz1 + 2.0d0*rpdyzz1
      dyydzzpz0=qcz*ddyyzz0 + wqz*ddyyzz1                +2.0d0*rdpyyz1
      dyydyxpx0=qcx*ddyyyx0 + wqx*ddyyyx1                +      rdpyyy1
      dyydyxpy0=qcy*ddyyyx0 + wqy*ddyyyx1 + 2.0d0*rpdyyx1+      rdpyyx1
      dyydyxpz0=qcz*ddyyyx0 + wqz*ddyyyx1
      dyydzxpx0=qcx*ddyyzx0 + wqx*ddyyzx1                +      rdpyyz1
      dyydzxpy0=qcy*ddyyzx0 + wqy*ddyyzx1 + 2.0d0*rpdyzx1
      dyydzxpz0=qcz*ddyyzx0 + wqz*ddyyzx1                +      rdpyyx1
      dyydzypx0=qcx*ddyyzy0 + wqx*ddyyzy1
      dyydzypy0=qcy*ddyyzy0 + wqy*ddyyzy1 + 2.0d0*rpdyzy1+      rdpyyz1
      dyydzypz0=qcz*ddyyzy0 + wqz*ddyyzy1                +      rdpyyy1
      dzzdxxpx0=qcx*ddzzxx0 + wqx*ddzzxx1                +2.0d0*rdpzzx1
      dzzdxxpy0=qcy*ddzzxx0 + wqy*ddzzxx1 
      dzzdxxpz0=qcz*ddzzxx0 + wqz*ddzzxx1 + 2.0d0*rpdzxx1
      dzzdyypx0=qcx*ddzzyy0 + wqx*ddzzyy1
      dzzdyypy0=qcy*ddzzyy0 + wqy*ddzzyy1                +2.0d0*rdpzzy1
      dzzdyypz0=qcz*ddzzyy0 + wqz*ddzzyy1 + 2.0d0*rpdzyy1
      dzzdzzpx0=qcx*ddzzzz0 + wqx*ddzzzz1
      dzzdzzpy0=qcy*ddzzzz0 + wqy*ddzzzz1
      dzzdzzpz0=qcz*ddzzzz0 + wqz*ddzzzz1 + 2.0d0*rpdzzz1+2.0d0*rdpzzz1
      dzzdyxpx0=qcx*ddzzyx0 + wqx*ddzzyx1                +      rdpzzy1
      dzzdyxpy0=qcy*ddzzyx0 + wqy*ddzzyx1                +      rdpzzx1
      dzzdyxpz0=qcz*ddzzyx0 + wqz*ddzzyx1 + 2.0d0*rpdzyx1
      dzzdzxpx0=qcx*ddzzzx0 + wqx*ddzzzx1                +      rdpzzz1
      dzzdzxpy0=qcy*ddzzzx0 + wqy*ddzzzx1 
      dzzdzxpz0=qcz*ddzzzx0 + wqz*ddzzzx1 + 2.0d0*rpdzzx1+      rdpzzx1
      dzzdzypx0=qcx*ddzzzy0 + wqx*ddzzzy1
      dzzdzypy0=qcy*ddzzzy0 + wqy*ddzzzy1                +      rdpzzz1
      dzzdzypz0=qcz*ddzzzy0 + wqz*ddzzzy1 + 2.0d0*rpdzzy1+      rdpzzy1

      dyxdxxpx0=qcx*ddyxxx0 + wqx*ddyxxx1 +       rpdyxx1+2.0d0*rdpyxx1
      dyxdxxpy0=qcy*ddyxxx0 + wqy*ddyxxx1 +       rpdxxx1
      dyxdxxpz0=qcz*ddyxxx0 + wqz*ddyxxx1
      dyxdyypx0=qcx*ddyxyy0 + wqx*ddyxyy1 +       rpdyyy1
      dyxdyypy0=qcy*ddyxyy0 + wqy*ddyxyy1 +       rpdxyy1+2.0d0*rdpyxy1
      dyxdyypz0=qcz*ddyxyy0 + wqz*ddyxyy1
      dyxdzzpx0=qcx*ddyxzz0 + wqx*ddyxzz1 +       rpdyzz1
      dyxdzzpy0=qcy*ddyxzz0 + wqy*ddyxzz1 +       rpdxzz1
      dyxdzzpz0=qcz*ddyxzz0 + wqz*ddyxzz1                +2.0d0*rdpyxz1
      dyxdyxpx0=qcx*ddyxyx0 + wqx*ddyxyx1 +       rpdyyx1+      rdpyxy1
      dyxdyxpy0=qcy*ddyxyx0 + wqy*ddyxyx1 +       rpdxyx1+      rdpyxx1
      dyxdyxpz0=qcz*ddyxyx0 + wqz*ddyxyx1
      dyxdzxpx0=qcx*ddyxzx0 + wqx*ddyxzx1 +       rpdyzx1+      rdpyxz1
      dyxdzxpy0=qcy*ddyxzx0 + wqy*ddyxzx1 +       rpdxzx1
      dyxdzxpz0=qcz*ddyxzx0 + wqz*ddyxzx1                +      rdpyxx1
      dyxdzypx0=qcx*ddyxzy0 + wqx*ddyxzy1 +       rpdyzy1
      dyxdzypy0=qcy*ddyxzy0 + wqy*ddyxzy1 +       rpdxzy1+      rdpyxz1
      dyxdzypz0=qcz*ddyxzy0 + wqz*ddyxzy1                +      rdpyxy1
      dzxdxxpx0=qcx*ddzxxx0 + wqx*ddzxxx1 +       rpdzxx1+2.0d0*rdpzxx1
      dzxdxxpy0=qcy*ddzxxx0 + wqy*ddzxxx1
      dzxdxxpz0=qcz*ddzxxx0 + wqz*ddzxxx1 +       rpdxxx1
      dzxdyypx0=qcx*ddzxyy0 + wqx*ddzxyy1 +       rpdzyy1
      dzxdyypy0=qcy*ddzxyy0 + wqy*ddzxyy1                +2.0d0*rdpzxy1
      dzxdyypz0=qcz*ddzxyy0 + wqz*ddzxyy1 +       rpdxyy1
      dzxdzzpx0=qcx*ddzxzz0 + wqx*ddzxzz1 +       rpdzzz1
      dzxdzzpy0=qcy*ddzxzz0 + wqy*ddzxzz1
      dzxdzzpz0=qcz*ddzxzz0 + wqz*ddzxzz1 +       rpdxzz1+2.0d0*rdpzxz1
      dzxdyxpx0=qcx*ddzxyx0 + wqx*ddzxyx1 +       rpdzyx1+      rdpzxy1
      dzxdyxpy0=qcy*ddzxyx0 + wqy*ddzxyx1                +      rdpzxx1
      dzxdyxpz0=qcz*ddzxyx0 + wqz*ddzxyx1 +       rpdxyx1
      dzxdzxpx0=qcx*ddzxzx0 + wqx*ddzxzx1 +       rpdzzx1+      rdpzxz1
      dzxdzxpy0=qcy*ddzxzx0 + wqy*ddzxzx1
      dzxdzxpz0=qcz*ddzxzx0 + wqz*ddzxzx1 +       rpdxzx1+      rdpzxx1
      dzxdzypx0=qcx*ddzxzy0 + wqx*ddzxzy1 +       rpdzzy1
      dzxdzypy0=qcy*ddzxzy0 + wqy*ddzxzy1                +      rdpzxz1
      dzxdzypz0=qcz*ddzxzy0 + wqz*ddzxzy1 +       rpdxzy1+      rdpzxy1
      dzydxxpx0=qcx*ddzyxx0 + wqx*ddzyxx1                +2.0d0*rdpzyx1
      dzydxxpy0=qcy*ddzyxx0 + wqy*ddzyxx1 +       rpdzxx1
      dzydxxpz0=qcz*ddzyxx0 + wqz*ddzyxx1 +       rpdyxx1
      dzydyypx0=qcx*ddzyyy0 + wqx*ddzyyy1
      dzydyypy0=qcy*ddzyyy0 + wqy*ddzyyy1 +       rpdzyy1+2.0d0*rdpzyy1
      dzydyypz0=qcz*ddzyyy0 + wqz*ddzyyy1 +       rpdyyy1
      dzydzzpx0=qcx*ddzyzz0 + wqx*ddzyzz1
      dzydzzpy0=qcy*ddzyzz0 + wqy*ddzyzz1 +       rpdzzz1
      dzydzzpz0=qcz*ddzyzz0 + wqz*ddzyzz1 +       rpdyzz1+2.0d0*rdpzyz1
      dzydyxpx0=qcx*ddzyyx0 + wqx*ddzyyx1                +      rdpzyy1
      dzydyxpy0=qcy*ddzyyx0 + wqy*ddzyyx1 +       rpdzyx1+      rdpzyx1
      dzydyxpz0=qcz*ddzyyx0 + wqz*ddzyyx1 +       rpdyyx1
      dzydzxpx0=qcx*ddzyzx0 + wqx*ddzyzx1                +      rdpzyz1
      dzydzxpy0=qcy*ddzyzx0 + wqy*ddzyzx1 +       rpdzzx1
      dzydzxpz0=qcz*ddzyzx0 + wqz*ddzyzx1 +       rpdyzx1+      rdpzyx1
      dzydzypx0=qcx*ddzyzy0 + wqx*ddzyzy1
      dzydzypy0=qcy*ddzyzy0 + wqy*ddzyzy1 +       rpdzzy1+      rdpzyz1
      dzydzypz0=qcz*ddzyzy0 + wqz*ddzyzy1 +       rpdyzy1+      rdpzyy1

      dxxdxxpx1=qcx*ddxxxx1 + wqx*ddxxxx2 + 2.0d0*rpdxxx2+2.0d0*rdpxxx2
      dxxdxxpy1=qcy*ddxxxx1 + wqy*ddxxxx2
      dxxdxxpz1=qcz*ddxxxx1 + wqz*ddxxxx2
      dxxdyypx1=qcx*ddxxyy1 + wqx*ddxxyy2 + 2.0d0*rpdxyy2
      dxxdyypy1=qcy*ddxxyy1 + wqy*ddxxyy2                +2.0d0*rdpxxy2
      dxxdyypz1=qcz*ddxxyy1 + wqz*ddxxyy2
      dxxdzzpx1=qcx*ddxxzz1 + wqx*ddxxzz2 + 2.0d0*rpdxzz2
      dxxdzzpy1=qcy*ddxxzz1 + wqy*ddxxzz2
      dxxdzzpz1=qcz*ddxxzz1 + wqz*ddxxzz2                +2.0d0*rdpxxz2
      dxxdyxpx1=qcx*ddxxyx1 + wqx*ddxxyx2 + 2.0d0*rpdxyx2+      rdpxxy2
      dxxdyxpy1=qcy*ddxxyx1 + wqy*ddxxyx2                +      rdpxxx2
      dxxdyxpz1=qcz*ddxxyx1 + wqz*ddxxyx2 
      dxxdzxpx1=qcx*ddxxzx1 + wqx*ddxxzx2 + 2.0d0*rpdxzx2+      rdpxxz2
      dxxdzxpy1=qcy*ddxxzx1 + wqy*ddxxzx2
      dxxdzxpz1=qcz*ddxxzx1 + wqz*ddxxzx2                +      rdpxxx2
      dxxdzypx1=qcx*ddxxzy1 + wqx*ddxxzy2 + 2.0d0*rpdxzy2
      dxxdzypy1=qcy*ddxxzy1 + wqy*ddxxzy2                +      rdpxxz2
      dxxdzypz1=qcz*ddxxzy1 + wqz*ddxxzy2                +      rdpxxy2
      dyydxxpx1=qcx*ddyyxx1 + wqx*ddyyxx2                +2.0d0*rdpyyx2
      dyydxxpy1=qcy*ddyyxx1 + wqy*ddyyxx2 + 2.0d0*rpdyxx2
      dyydxxpz1=qcz*ddyyxx1 + wqz*ddyyxx2
      dyydyypx1=qcx*ddyyyy1 + wqx*ddyyyy2
      dyydyypy1=qcy*ddyyyy1 + wqy*ddyyyy2 + 2.0d0*rpdyyy2+2.0d0*rdpyyy2
      dyydyypz1=qcz*ddyyyy1 + wqz*ddyyyy2
      dyydzzpx1=qcx*ddyyzz1 + wqx*ddyyzz2
      dyydzzpy1=qcy*ddyyzz1 + wqy*ddyyzz2 + 2.0d0*rpdyzz2
      dyydzzpz1=qcz*ddyyzz1 + wqz*ddyyzz2                +2.0d0*rdpyyz2
      dyydyxpx1=qcx*ddyyyx1 + wqx*ddyyyx2                +      rdpyyy2
      dyydyxpy1=qcy*ddyyyx1 + wqy*ddyyyx2 + 2.0d0*rpdyyx2+      rdpyyx2
      dyydyxpz1=qcz*ddyyyx1 + wqz*ddyyyx2
      dyydzxpx1=qcx*ddyyzx1 + wqx*ddyyzx2                +      rdpyyz2
      dyydzxpy1=qcy*ddyyzx1 + wqy*ddyyzx2 + 2.0d0*rpdyzx2
      dyydzxpz1=qcz*ddyyzx1 + wqz*ddyyzx2                +      rdpyyx2
      dyydzypx1=qcx*ddyyzy1 + wqx*ddyyzy2
      dyydzypy1=qcy*ddyyzy1 + wqy*ddyyzy2 + 2.0d0*rpdyzy2+      rdpyyz2
      dyydzypz1=qcz*ddyyzy1 + wqz*ddyyzy2                +      rdpyyy2
      dzzdxxpx1=qcx*ddzzxx1 + wqx*ddzzxx2                +2.0d0*rdpzzx2
      dzzdxxpy1=qcy*ddzzxx1 + wqy*ddzzxx2 
      dzzdxxpz1=qcz*ddzzxx1 + wqz*ddzzxx2 + 2.0d0*rpdzxx2
      dzzdyypx1=qcx*ddzzyy1 + wqx*ddzzyy2
      dzzdyypy1=qcy*ddzzyy1 + wqy*ddzzyy2                +2.0d0*rdpzzy2
      dzzdyypz1=qcz*ddzzyy1 + wqz*ddzzyy2 + 2.0d0*rpdzyy2
      dzzdzzpx1=qcx*ddzzzz1 + wqx*ddzzzz2
      dzzdzzpy1=qcy*ddzzzz1 + wqy*ddzzzz2
      dzzdzzpz1=qcz*ddzzzz1 + wqz*ddzzzz2 + 2.0d0*rpdzzz2+2.0d0*rdpzzz2
      dzzdyxpx1=qcx*ddzzyx1 + wqx*ddzzyx2                +      rdpzzy2
      dzzdyxpy1=qcy*ddzzyx1 + wqy*ddzzyx2                +      rdpzzx2
      dzzdyxpz1=qcz*ddzzyx1 + wqz*ddzzyx2 + 2.0d0*rpdzyx2
      dzzdzxpx1=qcx*ddzzzx1 + wqx*ddzzzx2                +      rdpzzz2
      dzzdzxpy1=qcy*ddzzzx1 + wqy*ddzzzx2 
      dzzdzxpz1=qcz*ddzzzx1 + wqz*ddzzzx2 + 2.0d0*rpdzzx2+      rdpzzx2
      dzzdzypx1=qcx*ddzzzy1 + wqx*ddzzzy2
      dzzdzypy1=qcy*ddzzzy1 + wqy*ddzzzy2                +      rdpzzz2
      dzzdzypz1=qcz*ddzzzy1 + wqz*ddzzzy2 + 2.0d0*rpdzzy2+      rdpzzy2

      dyxdxxpx1=qcx*ddyxxx1 + wqx*ddyxxx2 +       rpdyxx2+2.0d0*rdpyxx2
      dyxdxxpy1=qcy*ddyxxx1 + wqy*ddyxxx2 +       rpdxxx2
      dyxdxxpz1=qcz*ddyxxx1 + wqz*ddyxxx2
      dyxdyypx1=qcx*ddyxyy1 + wqx*ddyxyy2 +       rpdyyy2
      dyxdyypy1=qcy*ddyxyy1 + wqy*ddyxyy2 +       rpdxyy2+2.0d0*rdpyxy2
      dyxdyypz1=qcz*ddyxyy1 + wqz*ddyxyy2
      dyxdzzpx1=qcx*ddyxzz1 + wqx*ddyxzz2 +       rpdyzz2
      dyxdzzpy1=qcy*ddyxzz1 + wqy*ddyxzz2 +       rpdxzz2
      dyxdzzpz1=qcz*ddyxzz1 + wqz*ddyxzz2                +2.0d0*rdpyxz2
      dyxdyxpx1=qcx*ddyxyx1 + wqx*ddyxyx2 +       rpdyyx2+      rdpyxy2
      dyxdyxpy1=qcy*ddyxyx1 + wqy*ddyxyx2 +       rpdxyx2+      rdpyxx2
      dyxdyxpz1=qcz*ddyxyx1 + wqz*ddyxyx2
      dyxdzxpx1=qcx*ddyxzx1 + wqx*ddyxzx2 +       rpdyzx2+      rdpyxz2
      dyxdzxpy1=qcy*ddyxzx1 + wqy*ddyxzx2 +       rpdxzx2
      dyxdzxpz1=qcz*ddyxzx1 + wqz*ddyxzx2                +      rdpyxx2
      dyxdzypx1=qcx*ddyxzy1 + wqx*ddyxzy2 +       rpdyzy2
      dyxdzypy1=qcy*ddyxzy1 + wqy*ddyxzy2 +       rpdxzy2+      rdpyxz2
      dyxdzypz1=qcz*ddyxzy1 + wqz*ddyxzy2                +      rdpyxy2
      dzxdxxpx1=qcx*ddzxxx1 + wqx*ddzxxx2 +       rpdzxx2+2.0d0*rdpzxx2
      dzxdxxpy1=qcy*ddzxxx1 + wqy*ddzxxx2
      dzxdxxpz1=qcz*ddzxxx1 + wqz*ddzxxx2 +       rpdxxx2
      dzxdyypx1=qcx*ddzxyy1 + wqx*ddzxyy2 +       rpdzyy2
      dzxdyypy1=qcy*ddzxyy1 + wqy*ddzxyy2                +2.0d0*rdpzxy2
      dzxdyypz1=qcz*ddzxyy1 + wqz*ddzxyy2 +       rpdxyy2
      dzxdzzpx1=qcx*ddzxzz1 + wqx*ddzxzz2 +       rpdzzz2
      dzxdzzpy1=qcy*ddzxzz1 + wqy*ddzxzz2
      dzxdzzpz1=qcz*ddzxzz1 + wqz*ddzxzz2 +       rpdxzz2+2.0d0*rdpzxz2
      dzxdyxpx1=qcx*ddzxyx1 + wqx*ddzxyx2 +       rpdzyx2+      rdpzxy2
      dzxdyxpy1=qcy*ddzxyx1 + wqy*ddzxyx2                +      rdpzxx2
      dzxdyxpz1=qcz*ddzxyx1 + wqz*ddzxyx2 +       rpdxyx2
      dzxdzxpx1=qcx*ddzxzx1 + wqx*ddzxzx2 +       rpdzzx2+      rdpzxz2
      dzxdzxpy1=qcy*ddzxzx1 + wqy*ddzxzx2
      dzxdzxpz1=qcz*ddzxzx1 + wqz*ddzxzx2 +       rpdxzx2+      rdpzxx2
      dzxdzypx1=qcx*ddzxzy1 + wqx*ddzxzy2 +       rpdzzy2
      dzxdzypy1=qcy*ddzxzy1 + wqy*ddzxzy2                +      rdpzxz2
      dzxdzypz1=qcz*ddzxzy1 + wqz*ddzxzy2 +       rpdxzy2+      rdpzxy2
      dzydxxpx1=qcx*ddzyxx1 + wqx*ddzyxx2                +2.0d0*rdpzyx2
      dzydxxpy1=qcy*ddzyxx1 + wqy*ddzyxx2 +       rpdzxx2
      dzydxxpz1=qcz*ddzyxx1 + wqz*ddzyxx2 +       rpdyxx2
      dzydyypx1=qcx*ddzyyy1 + wqx*ddzyyy2
      dzydyypy1=qcy*ddzyyy1 + wqy*ddzyyy2 +       rpdzyy2+2.0d0*rdpzyy2
      dzydyypz1=qcz*ddzyyy1 + wqz*ddzyyy2 +       rpdyyy2
      dzydzzpx1=qcx*ddzyzz1 + wqx*ddzyzz2
      dzydzzpy1=qcy*ddzyzz1 + wqy*ddzyzz2 +       rpdzzz2
      dzydzzpz1=qcz*ddzyzz1 + wqz*ddzyzz2 +       rpdyzz2+2.0d0*rdpzyz2
      dzydyxpx1=qcx*ddzyyx1 + wqx*ddzyyx2                +      rdpzyy2
      dzydyxpy1=qcy*ddzyyx1 + wqy*ddzyyx2 +       rpdzyx2+      rdpzyx2
      dzydyxpz1=qcz*ddzyyx1 + wqz*ddzyyx2 +       rpdyyx2
      dzydzxpx1=qcx*ddzyzx1 + wqx*ddzyzx2                +      rdpzyz2
      dzydzxpy1=qcy*ddzyzx1 + wqy*ddzyzx2 +       rpdzzx2
      dzydzxpz1=qcz*ddzyzx1 + wqz*ddzyzx2 +       rpdyzx2+      rdpzyx2
      dzydzypx1=qcx*ddzyzy1 + wqx*ddzyzy2
      dzydzypy1=qcy*ddzyzy1 + wqy*ddzyzy2 +       rpdzzy2+      rdpzyz2
      dzydzypz1=qcz*ddzyzy1 + wqz*ddzyzy2 +       rpdyzy2+      rdpzyy2


!RANK=6
    
      xax  = rkp * pxdxxpx1
      xay  = rkp * pxdxxpy1
      xaz  = rkp * pxdxxpz1
      xbx  = rkp * pxdyypx1
      xby  = rkp * pxdyypy1
      xbz  = rkp * pxdyypz1
      xcx  = rkp * pxdzzpx1
      xcy  = rkp * pxdzzpy1
      xcz  = rkp * pxdzzpz1
      xdx  = rkp * pxdyxpx1
      xdy  = rkp * pxdyxpy1
      xdz  = rkp * pxdyxpz1
      xex  = rkp * pxdzxpx1
      xey  = rkp * pxdzxpy1
      xez  = rkp * pxdzxpz1
      xfx  = rkp * pxdzypx1
      xfy  = rkp * pxdzypy1
      xfz  = rkp * pxdzypz1

      yax = rkp * pydxxpx1
      yay = rkp * pydxxpy1
      yaz = rkp * pydxxpz1
      ybx = rkp * pydyypx1
      yby = rkp * pydyypy1
      ybz = rkp * pydyypz1
      ycx = rkp * pydzzpx1
      ycy = rkp * pydzzpy1
      ycz = rkp * pydzzpz1
      ydx = rkp * pydyxpx1
      ydy = rkp * pydyxpy1
      ydz = rkp * pydyxpz1
      yex = rkp * pydzxpx1
      yey = rkp * pydzxpy1
      yez = rkp * pydzxpz1
      yfx = rkp * pydzypx1
      yfy = rkp * pydzypy1
      yfz = rkp * pydzypz1

      zax = rkp * pzdxxpx1
      zay = rkp * pzdxxpy1
      zaz = rkp * pzdxxpz1
      zbx = rkp * pzdyypx1
      zby = rkp * pzdyypy1
      zbz = rkp * pzdyypz1
      zcx = rkp * pzdzzpx1
      zcy = rkp * pzdzzpy1
      zcz = rkp * pzdzzpz1
      zdx = rkp * pzdyxpx1
      zdy = rkp * pzdyxpy1
      zdz = rkp * pzdyxpz1
      zex = rkp * pzdzxpx1
      zey = rkp * pzdzxpy1
      zez = rkp * pzdzxpz1
      zfx = rkp * pzdzypx1
      zfy = rkp * pzdzypy1
      zfz = rkp * pzdzypz1

      raxx= rkp *axx
      raxy= rkp *axy
      raxz= rkp *axz
      rayx= rkp *ayx
      rayy= rkp *ayy
      rayz= rkp *ayz
      razx= rkp *azx
      razy= rkp *azy
      razz= rkp *azz
      rbxx= rkp *bxx
      rbxy= rkp *bxy
      rbxz= rkp *bxz
      rbyx= rkp *byx
      rbyy= rkp *byy
      rbyz= rkp *byz
      rbzx= rkp *bzx
      rbzy= rkp *bzy
      rbzz= rkp *bzz
      rcxx= rkp *cxx
      rcxy= rkp *cxy
      rcxz= rkp *cxz
      rcyx= rkp *cyx
      rcyy= rkp *cyy
      rcyz= rkp *cyz
      rczx= rkp *czx
      rczy= rkp *czy
      rczz= rkp *czz
      rdxx= rkp *dxx
      rdxy= rkp *dxy
      rdxz= rkp *dxz
      rdyx= rkp *dyx
      rdyy= rkp *dyy
      rdyz= rkp *dyz
      rdzx= rkp *dzx
      rdzy= rkp *dzy
      rdzz= rkp *dzz
      rexx= rkp *exx
      rexy= rkp *exy
      rexz= rkp *exz
      reyx= rkp *eyx
      reyy= rkp *eyy
      reyz= rkp *eyz
      rezx= rkp *ezx
      rezy= rkp *ezy
      rezz= rkp *ezz
      rfxx= rkp *fxx
      rfxy= rkp *fxy
      rfxz= rkp *fxz
      rfyx= rkp *fyx
      rfyy= rkp *fyy
      rfyz= rkp *fyz
      rfzx= rkp *fzx
      rfzy= rkp *fzy
      rfzz= rkp *fzz


      aa0 = eta*(ddxxxx0 - rooe*ddxxxx1)
      ab0 = eta*(ddxxyy0 - rooe*ddxxyy1)
      ac0 = eta*(ddxxzz0 - rooe*ddxxzz1)
      ad0 = eta*(ddxxyx0 - rooe*ddxxyx1)
      ae0 = eta*(ddxxzx0 - rooe*ddxxzx1)
      af0 = eta*(ddxxzy0 - rooe*ddxxzy1)
      ba0 = eta*(ddyyxx0 - rooe*ddyyxx1)
      bb0 = eta*(ddyyyy0 - rooe*ddyyyy1)
      bc0 = eta*(ddyyzz0 - rooe*ddyyzz1)
      bd0 = eta*(ddyyyx0 - rooe*ddyyyx1)
      be0 = eta*(ddyyzx0 - rooe*ddyyzx1)
      bf0 = eta*(ddyyzy0 - rooe*ddyyzy1)
      ca0 = eta*(ddzzxx0 - rooe*ddzzxx1)
      cb0 = eta*(ddzzyy0 - rooe*ddzzyy1)
      cc0 = eta*(ddzzzz0 - rooe*ddzzzz1)
      cd0 = eta*(ddzzyx0 - rooe*ddzzyx1)
      ce0 = eta*(ddzzzx0 - rooe*ddzzzx1)
      cf0 = eta*(ddzzzy0 - rooe*ddzzzy1)
      da0 = eta*(ddyxxx0 - rooe*ddyxxx1)
      db0 = eta*(ddyxyy0 - rooe*ddyxyy1)
      dc0 = eta*(ddyxzz0 - rooe*ddyxzz1)
      dd0 = eta*(ddyxyx0 - rooe*ddyxyx1)
      de0 = eta*(ddyxzx0 - rooe*ddyxzx1)
      df0 = eta*(ddyxzy0 - rooe*ddyxzy1)
      ea0 = eta*(ddzxxx0 - rooe*ddzxxx1)
      eb0 = eta*(ddzxyy0 - rooe*ddzxyy1)
      ec0 = eta*(ddzxzz0 - rooe*ddzxzz1)
      ed0 = eta*(ddzxyx0 - rooe*ddzxyx1)
      ee0 = eta*(ddzxzx0 - rooe*ddzxzx1)
      ef0 = eta*(ddzxzy0 - rooe*ddzxzy1)
      fa0 = eta*(ddzyxx0 - rooe*ddzyxx1)
      fb0 = eta*(ddzyyy0 - rooe*ddzyyy1)
      fc0 = eta*(ddzyzz0 - rooe*ddzyzz1)
      fd0 = eta*(ddzyyx0 - rooe*ddzyyx1)
      fe0 = eta*(ddzyzx0 - rooe*ddzyzx1)
      ff0 = eta*(ddzyzy0 - rooe*ddzyzy1)

      ec(  1)=ec(  1)+qdx*dxxdxxpx0+wqx*dxxdxxpx1+2.d0*xax+2.d0*raxx+aa0
      ec(  2)=ec(  2)+qdy*dxxdxxpx0+wqy*dxxdxxpx1
      ec(  3)=ec(  3)+qdz*dxxdxxpx0+wqz*dxxdxxpx1
      ec(  4)=ec(  4)+qdx*dxxdxxpy0+wqx*dxxdxxpy1+2.d0*xay+2.d0*raxy
      ec(  5)=ec(  5)+qdy*dxxdxxpy0+wqy*dxxdxxpy1                   +aa0
      ec(  6)=ec(  6)+qdz*dxxdxxpy0+wqz*dxxdxxpy1
      ec(  7)=ec(  7)+qdx*dxxdxxpz0+wqx*dxxdxxpz1+2.d0*xaz+2.d0*raxz
      ec(  8)=ec(  8)+qdy*dxxdxxpz0+wqy*dxxdxxpz1
      ec(  9)=ec(  9)+qdz*dxxdxxpz0+wqz*dxxdxxpz1                   +aa0
      ec( 10)=ec( 10)+qdx*dxxdyypx0+wqx*dxxdyypx1+2.d0*xbx          +ab0
      ec( 11)=ec( 11)+qdy*dxxdyypx0+wqy*dxxdyypx1         +2.d0*rayx
      ec( 12)=ec( 12)+qdz*dxxdyypx0+wqz*dxxdyypx1                   
      ec( 13)=ec( 13)+qdx*dxxdyypy0+wqx*dxxdyypy1+2.d0*xby          
      ec( 14)=ec( 14)+qdy*dxxdyypy0+wqy*dxxdyypy1         +2.d0*rayy+ab0
      ec( 15)=ec( 15)+qdz*dxxdyypy0+wqz*dxxdyypy1                   
      ec( 16)=ec( 16)+qdx*dxxdyypz0+wqx*dxxdyypz1+2.d0*xbz          
      ec( 17)=ec( 17)+qdy*dxxdyypz0+wqy*dxxdyypz1         +2.d0*rayz
      ec( 18)=ec( 18)+qdz*dxxdyypz0+wqz*dxxdyypz1                   +ab0
      ec( 19)=ec( 19)+qdx*dxxdzzpx0+wqx*dxxdzzpx1+2.d0*xcx          +ac0
      ec( 20)=ec( 20)+qdy*dxxdzzpx0+wqy*dxxdzzpx1                   
      ec( 21)=ec( 21)+qdz*dxxdzzpx0+wqz*dxxdzzpx1         +2.d0*razx
      ec( 22)=ec( 22)+qdx*dxxdzzpy0+wqx*dxxdzzpy1+2.d0*xcy          
      ec( 23)=ec( 23)+qdy*dxxdzzpy0+wqy*dxxdzzpy1                   +ac0
      ec( 24)=ec( 24)+qdz*dxxdzzpy0+wqz*dxxdzzpy1         +2.d0*razy
      ec( 25)=ec( 25)+qdx*dxxdzzpz0+wqx*dxxdzzpz1+2.d0*xcz          
      ec( 26)=ec( 26)+qdy*dxxdzzpz0+wqy*dxxdzzpz1                   
      ec( 27)=ec( 27)+qdz*dxxdzzpz0+wqz*dxxdzzpz1         +2.d0*razz+ac0
      ec( 28)=ec( 28)+qdx*dxxdyxpx0+wqx*dxxdyxpx1+2.d0*xdx+     rayx+ad0
      ec( 29)=ec( 29)+qdy*dxxdyxpx0+wqy*dxxdyxpx1         +     raxx
      ec( 30)=ec( 30)+qdz*dxxdyxpx0+wqz*dxxdyxpx1                   
      ec( 31)=ec( 31)+qdx*dxxdyxpy0+wqx*dxxdyxpy1+2.d0*xdy+     rayy
      ec( 32)=ec( 32)+qdy*dxxdyxpy0+wqy*dxxdyxpy1         +     raxy+ad0
      ec( 33)=ec( 33)+qdz*dxxdyxpy0+wqz*dxxdyxpy1                   
      ec( 34)=ec( 34)+qdx*dxxdyxpz0+wqx*dxxdyxpz1+2.d0*xdz+     rayz
      ec( 35)=ec( 35)+qdy*dxxdyxpz0+wqy*dxxdyxpz1         +     raxz
      ec( 36)=ec( 36)+qdz*dxxdyxpz0+wqz*dxxdyxpz1                   +ad0
      ec( 37)=ec( 37)+qdx*dxxdzxpx0+wqx*dxxdzxpx1+2.d0*xex+     razx+ae0
      ec( 38)=ec( 38)+qdy*dxxdzxpx0+wqy*dxxdzxpx1                   
      ec( 39)=ec( 39)+qdz*dxxdzxpx0+wqz*dxxdzxpx1         +     raxx
      ec( 40)=ec( 40)+qdx*dxxdzxpy0+wqx*dxxdzxpy1+2.d0*xey+     razy
      ec( 41)=ec( 41)+qdy*dxxdzxpy0+wqy*dxxdzxpy1                   +ae0
      ec( 42)=ec( 42)+qdz*dxxdzxpy0+wqz*dxxdzxpy1         +     raxy
      ec( 43)=ec( 43)+qdx*dxxdzxpz0+wqx*dxxdzxpz1+2.d0*xez+     razz
      ec( 44)=ec( 44)+qdy*dxxdzxpz0+wqy*dxxdzxpz1                   
      ec( 45)=ec( 45)+qdz*dxxdzxpz0+wqz*dxxdzxpz1         +     raxz+ae0
      ec( 46)=ec( 46)+qdx*dxxdzypx0+wqx*dxxdzypx1+2.d0*xfx          +af0
      ec( 47)=ec( 47)+qdy*dxxdzypx0+wqy*dxxdzypx1         +     razx
      ec( 48)=ec( 48)+qdz*dxxdzypx0+wqz*dxxdzypx1         +     rayx
      ec( 49)=ec( 49)+qdx*dxxdzypy0+wqx*dxxdzypy1+2.d0*xfy          
      ec( 50)=ec( 50)+qdy*dxxdzypy0+wqy*dxxdzypy1         +     razy+af0
      ec( 51)=ec( 51)+qdz*dxxdzypy0+wqz*dxxdzypy1         +     rayy
      ec( 52)=ec( 52)+qdx*dxxdzypz0+wqx*dxxdzypz1+2.d0*xfz          
      ec( 53)=ec( 53)+qdy*dxxdzypz0+wqy*dxxdzypz1         +     razz
      ec( 54)=ec( 54)+qdz*dxxdzypz0+wqz*dxxdzypz1         +     rayz+af0
      ec( 55)=ec( 55)+qdx*dyydxxpx0+wqx*dyydxxpx1         +2.d0*rbxx+ba0
      ec( 56)=ec( 56)+qdy*dyydxxpx0+wqy*dyydxxpx1+2.d0*yax              
      ec( 57)=ec( 57)+qdz*dyydxxpx0+wqz*dyydxxpx1                       
      ec( 58)=ec( 58)+qdx*dyydxxpy0+wqx*dyydxxpy1         +2.d0*rbxy    
      ec( 59)=ec( 59)+qdy*dyydxxpy0+wqy*dyydxxpy1+2.d0*yay          +ba0
      ec( 60)=ec( 60)+qdz*dyydxxpy0+wqz*dyydxxpy1                       
      ec( 61)=ec( 61)+qdx*dyydxxpz0+wqx*dyydxxpz1         +2.d0*rbxz    
      ec( 62)=ec( 62)+qdy*dyydxxpz0+wqy*dyydxxpz1+2.d0*yaz              
      ec( 63)=ec( 63)+qdz*dyydxxpz0+wqz*dyydxxpz1                   +ba0
      ec( 64)=ec( 64)+qdx*dyydyypx0+wqx*dyydyypx1                   +bb0
      ec( 65)=ec( 65)+qdy*dyydyypx0+wqy*dyydyypx1+2.d0*ybx+2.d0*rbyx    
      ec( 66)=ec( 66)+qdz*dyydyypx0+wqz*dyydyypx1                       
      ec( 67)=ec( 67)+qdx*dyydyypy0+wqx*dyydyypy1                       
      ec( 68)=ec( 68)+qdy*dyydyypy0+wqy*dyydyypy1+2.d0*yby+2.d0*rbyy+bb0
      ec( 69)=ec( 69)+qdz*dyydyypy0+wqz*dyydyypy1                       
      ec( 70)=ec( 70)+qdx*dyydyypz0+wqx*dyydyypz1                       
      ec( 71)=ec( 71)+qdy*dyydyypz0+wqy*dyydyypz1+2.d0*ybz+2.d0*rbyz    
      ec( 72)=ec( 72)+qdz*dyydyypz0+wqz*dyydyypz1                   +bb0
      ec( 73)=ec( 73)+qdx*dyydzzpx0+wqx*dyydzzpx1                   +bc0
      ec( 74)=ec( 74)+qdy*dyydzzpx0+wqy*dyydzzpx1+2.d0*ycx              
      ec( 75)=ec( 75)+qdz*dyydzzpx0+wqz*dyydzzpx1         +2.d0*rbzx    
      ec( 76)=ec( 76)+qdx*dyydzzpy0+wqx*dyydzzpy1                       
      ec( 77)=ec( 77)+qdy*dyydzzpy0+wqy*dyydzzpy1+2.d0*ycy          +bc0
      ec( 78)=ec( 78)+qdz*dyydzzpy0+wqz*dyydzzpy1         +2.d0*rbzy    
      ec( 79)=ec( 79)+qdx*dyydzzpz0+wqx*dyydzzpz1                       
      ec( 80)=ec( 80)+qdy*dyydzzpz0+wqy*dyydzzpz1+2.d0*ycz              
      ec( 81)=ec( 81)+qdz*dyydzzpz0+wqz*dyydzzpz1         +2.d0*rbzz+bc0
      ec( 82)=ec( 82)+qdx*dyydyxpx0+wqx*dyydyxpx1         +     rbyx+bd0
      ec( 83)=ec( 83)+qdy*dyydyxpx0+wqy*dyydyxpx1+2.d0*ydx+     rbxx    
      ec( 84)=ec( 84)+qdz*dyydyxpx0+wqz*dyydyxpx1                       
      ec( 85)=ec( 85)+qdx*dyydyxpy0+wqx*dyydyxpy1         +     rbyy    
      ec( 86)=ec( 86)+qdy*dyydyxpy0+wqy*dyydyxpy1+2.d0*ydy+     rbxy+bd0
      ec( 87)=ec( 87)+qdz*dyydyxpy0+wqz*dyydyxpy1                       
      ec( 88)=ec( 88)+qdx*dyydyxpz0+wqx*dyydyxpz1         +     rbyz    
      ec( 89)=ec( 89)+qdy*dyydyxpz0+wqy*dyydyxpz1+2.d0*ydz+     rbxz    
      ec( 90)=ec( 90)+qdz*dyydyxpz0+wqz*dyydyxpz1                   +bd0
      ec( 91)=ec( 91)+qdx*dyydzxpx0+wqx*dyydzxpx1         +     rbzx+be0
      ec( 92)=ec( 92)+qdy*dyydzxpx0+wqy*dyydzxpx1+2.d0*yex              
      ec( 93)=ec( 93)+qdz*dyydzxpx0+wqz*dyydzxpx1         +     rbxx    
      ec( 94)=ec( 94)+qdx*dyydzxpy0+wqx*dyydzxpy1         +     rbzy    
      ec( 95)=ec( 95)+qdy*dyydzxpy0+wqy*dyydzxpy1+2.d0*yey          +be0
      ec( 96)=ec( 96)+qdz*dyydzxpy0+wqz*dyydzxpy1         +     rbxy    
      ec( 97)=ec( 97)+qdx*dyydzxpz0+wqx*dyydzxpz1         +     rbzz    
      ec( 98)=ec( 98)+qdy*dyydzxpz0+wqy*dyydzxpz1+2.d0*yez              
      ec( 99)=ec( 99)+qdz*dyydzxpz0+wqz*dyydzxpz1         +     rbxz+be0
      ec(100)=ec(100)+qdx*dyydzypx0+wqx*dyydzypx1                   +bf0
      ec(101)=ec(101)+qdy*dyydzypx0+wqy*dyydzypx1+2.d0*yfx+     rbzx    
      ec(102)=ec(102)+qdz*dyydzypx0+wqz*dyydzypx1         +     rbyx    
      ec(103)=ec(103)+qdx*dyydzypy0+wqx*dyydzypy1                       
      ec(104)=ec(104)+qdy*dyydzypy0+wqy*dyydzypy1+2.d0*yfy+     rbzy+bf0
      ec(105)=ec(105)+qdz*dyydzypy0+wqz*dyydzypy1         +     rbyy    
      ec(106)=ec(106)+qdx*dyydzypz0+wqx*dyydzypz1                       
      ec(107)=ec(107)+qdy*dyydzypz0+wqy*dyydzypz1+2.d0*yfz+     rbzz    
      ec(108)=ec(108)+qdz*dyydzypz0+wqz*dyydzypz1         +     rbyz+bf0
      ec(109)=ec(109)+qdx*dzzdxxpx0+wqx*dzzdxxpx1         +2.d0*rcxx+ca0
      ec(110)=ec(110)+qdy*dzzdxxpx0+wqy*dzzdxxpx1                       
      ec(111)=ec(111)+qdz*dzzdxxpx0+wqz*dzzdxxpx1+2.d0*zax              
      ec(112)=ec(112)+qdx*dzzdxxpy0+wqx*dzzdxxpy1         +2.d0*rcxy    
      ec(113)=ec(113)+qdy*dzzdxxpy0+wqy*dzzdxxpy1                   +ca0
      ec(114)=ec(114)+qdz*dzzdxxpy0+wqz*dzzdxxpy1+2.d0*zay              
      ec(115)=ec(115)+qdx*dzzdxxpz0+wqx*dzzdxxpz1         +2.d0*rcxz    
      ec(116)=ec(116)+qdy*dzzdxxpz0+wqy*dzzdxxpz1                       
      ec(117)=ec(117)+qdz*dzzdxxpz0+wqz*dzzdxxpz1+2.d0*zaz          +ca0
      ec(118)=ec(118)+qdx*dzzdyypx0+wqx*dzzdyypx1                   +cb0
      ec(119)=ec(119)+qdy*dzzdyypx0+wqy*dzzdyypx1         +2.d0*rcyx    
      ec(120)=ec(120)+qdz*dzzdyypx0+wqz*dzzdyypx1+2.d0*zbx              
      ec(121)=ec(121)+qdx*dzzdyypy0+wqx*dzzdyypy1                       
      ec(122)=ec(122)+qdy*dzzdyypy0+wqy*dzzdyypy1         +2.d0*rcyy+cb0
      ec(123)=ec(123)+qdz*dzzdyypy0+wqz*dzzdyypy1+2.d0*zby              
      ec(124)=ec(124)+qdx*dzzdyypz0+wqx*dzzdyypz1                       
      ec(125)=ec(125)+qdy*dzzdyypz0+wqy*dzzdyypz1         +2.d0*rcyz    
      ec(126)=ec(126)+qdz*dzzdyypz0+wqz*dzzdyypz1+2.d0*zbz          +cb0
      ec(127)=ec(127)+qdx*dzzdzzpx0+wqx*dzzdzzpx1                   +cc0
      ec(128)=ec(128)+qdy*dzzdzzpx0+wqy*dzzdzzpx1                       
      ec(129)=ec(129)+qdz*dzzdzzpx0+wqz*dzzdzzpx1+2.d0*zcx+2.d0*rczx    
      ec(130)=ec(130)+qdx*dzzdzzpy0+wqx*dzzdzzpy1                       
      ec(131)=ec(131)+qdy*dzzdzzpy0+wqy*dzzdzzpy1                   +cc0
      ec(132)=ec(132)+qdz*dzzdzzpy0+wqz*dzzdzzpy1+2.d0*zcy+2.d0*rczy    
      ec(133)=ec(133)+qdx*dzzdzzpz0+wqx*dzzdzzpz1                       
      ec(134)=ec(134)+qdy*dzzdzzpz0+wqy*dzzdzzpz1                       
      ec(135)=ec(135)+qdz*dzzdzzpz0+wqz*dzzdzzpz1+2.d0*zcz+2.d0*rczz+cc0
      ec(136)=ec(136)+qdx*dzzdyxpx0+wqx*dzzdyxpx1         +     rcyx+cd0
      ec(137)=ec(137)+qdy*dzzdyxpx0+wqy*dzzdyxpx1         +     rcxx    
      ec(138)=ec(138)+qdz*dzzdyxpx0+wqz*dzzdyxpx1+2.d0*zdx              
      ec(139)=ec(139)+qdx*dzzdyxpy0+wqx*dzzdyxpy1         +     rcyy    
      ec(140)=ec(140)+qdy*dzzdyxpy0+wqy*dzzdyxpy1         +     rcxy+cd0
      ec(141)=ec(141)+qdz*dzzdyxpy0+wqz*dzzdyxpy1+2.d0*zdy              
      ec(142)=ec(142)+qdx*dzzdyxpz0+wqx*dzzdyxpz1         +     rcyz    
      ec(143)=ec(143)+qdy*dzzdyxpz0+wqy*dzzdyxpz1         +     rcxz    
      ec(144)=ec(144)+qdz*dzzdyxpz0+wqz*dzzdyxpz1+2.d0*zdz          +cd0
      ec(145)=ec(145)+qdx*dzzdzxpx0+wqx*dzzdzxpx1         +     rczx+ce0
      ec(146)=ec(146)+qdy*dzzdzxpx0+wqy*dzzdzxpx1                       
      ec(147)=ec(147)+qdz*dzzdzxpx0+wqz*dzzdzxpx1+2.d0*zex+     rcxx    
      ec(148)=ec(148)+qdx*dzzdzxpy0+wqx*dzzdzxpy1         +     rczy    
      ec(149)=ec(149)+qdy*dzzdzxpy0+wqy*dzzdzxpy1                   +ce0
      ec(150)=ec(150)+qdz*dzzdzxpy0+wqz*dzzdzxpy1+2.d0*zey+     rcxy    
      ec(151)=ec(151)+qdx*dzzdzxpz0+wqx*dzzdzxpz1         +     rczz    
      ec(152)=ec(152)+qdy*dzzdzxpz0+wqy*dzzdzxpz1
      ec(153)=ec(153)+qdz*dzzdzxpz0+wqz*dzzdzxpz1+2.d0*zez+     rcxz+ce0
      ec(154)=ec(154)+qdx*dzzdzypx0+wqx*dzzdzypx1                   +cf0
      ec(155)=ec(155)+qdy*dzzdzypx0+wqy*dzzdzypx1         +     rczx    
      ec(156)=ec(156)+qdz*dzzdzypx0+wqz*dzzdzypx1+2.d0*zfx+     rcyx    
      ec(157)=ec(157)+qdx*dzzdzypy0+wqx*dzzdzypy1
      ec(158)=ec(158)+qdy*dzzdzypy0+wqy*dzzdzypy1         +     rczy+cf0
      ec(159)=ec(159)+qdz*dzzdzypy0+wqz*dzzdzypy1+2.d0*zfy+     rcyy    
      ec(160)=ec(160)+qdx*dzzdzypz0+wqx*dzzdzypz1                       
      ec(161)=ec(161)+qdy*dzzdzypz0+wqy*dzzdzypz1         +     rczz    
      ec(162)=ec(162)+qdz*dzzdzypz0+wqz*dzzdzypz1+2.d0*zfz+     rcyz+cf0
      ec(163)=ec(163)+qdx*dyxdxxpx0+wqx*dyxdxxpx1+     yax+2.d0*rdxx+da0
      ec(164)=ec(164)+qdy*dyxdxxpx0+wqy*dyxdxxpx1+     xax              
      ec(165)=ec(165)+qdz*dyxdxxpx0+wqz*dyxdxxpx1                       
      ec(166)=ec(166)+qdx*dyxdxxpy0+wqx*dyxdxxpy1+     yay+2.d0*rdxy    
      ec(167)=ec(167)+qdy*dyxdxxpy0+wqy*dyxdxxpy1+     xay          +da0
      ec(168)=ec(168)+qdz*dyxdxxpy0+wqz*dyxdxxpy1                       
      ec(169)=ec(169)+qdx*dyxdxxpz0+wqx*dyxdxxpz1+     yaz+2.d0*rdxz    
      ec(170)=ec(170)+qdy*dyxdxxpz0+wqy*dyxdxxpz1+     xaz              
      ec(171)=ec(171)+qdz*dyxdxxpz0+wqz*dyxdxxpz1                   +da0
      ec(172)=ec(172)+qdx*dyxdyypx0+wqx*dyxdyypx1+     ybx          +db0
      ec(173)=ec(173)+qdy*dyxdyypx0+wqy*dyxdyypx1+     xbx+2.d0*rdyx    
      ec(174)=ec(174)+qdz*dyxdyypx0+wqz*dyxdyypx1                       
      ec(175)=ec(175)+qdx*dyxdyypy0+wqx*dyxdyypy1+     yby
      ec(176)=ec(176)+qdy*dyxdyypy0+wqy*dyxdyypy1+     xby+2.d0*rdyy+db0
      ec(177)=ec(177)+qdz*dyxdyypy0+wqz*dyxdyypy1                       
      ec(178)=ec(178)+qdx*dyxdyypz0+wqx*dyxdyypz1+     ybz              
      ec(179)=ec(179)+qdy*dyxdyypz0+wqy*dyxdyypz1+     xbz+2.d0*rdyz    
      ec(180)=ec(180)+qdz*dyxdyypz0+wqz*dyxdyypz1                   +db0
      ec(181)=ec(181)+qdx*dyxdzzpx0+wqx*dyxdzzpx1+     ycx          +dc0
      ec(182)=ec(182)+qdy*dyxdzzpx0+wqy*dyxdzzpx1+     xcx              
      ec(183)=ec(183)+qdz*dyxdzzpx0+wqz*dyxdzzpx1         +2.d0*rdzx    
      ec(184)=ec(184)+qdx*dyxdzzpy0+wqx*dyxdzzpy1+     ycy              
      ec(185)=ec(185)+qdy*dyxdzzpy0+wqy*dyxdzzpy1+     xcy          +dc0
      ec(186)=ec(186)+qdz*dyxdzzpy0+wqz*dyxdzzpy1         +2.d0*rdzy    
      ec(187)=ec(187)+qdx*dyxdzzpz0+wqx*dyxdzzpz1+     ycz              
      ec(188)=ec(188)+qdy*dyxdzzpz0+wqy*dyxdzzpz1+     xcz              
      ec(189)=ec(189)+qdz*dyxdzzpz0+wqz*dyxdzzpz1         +2.d0*rdzz+dc0
      ec(190)=ec(190)+qdx*dyxdyxpx0+wqx*dyxdyxpx1+     ydx+     rdyx+dd0
      ec(191)=ec(191)+qdy*dyxdyxpx0+wqy*dyxdyxpx1+     xdx+     rdxx    
      ec(192)=ec(192)+qdz*dyxdyxpx0+wqz*dyxdyxpx1                       
      ec(193)=ec(193)+qdx*dyxdyxpy0+wqx*dyxdyxpy1+     ydy+     rdyy    
      ec(194)=ec(194)+qdy*dyxdyxpy0+wqy*dyxdyxpy1+     xdy+     rdxy+dd0
      ec(195)=ec(195)+qdz*dyxdyxpy0+wqz*dyxdyxpy1                       
      ec(196)=ec(196)+qdx*dyxdyxpz0+wqx*dyxdyxpz1+     ydz+     rdyz    
      ec(197)=ec(197)+qdy*dyxdyxpz0+wqy*dyxdyxpz1+     xdz+     rdxz    
      ec(198)=ec(198)+qdz*dyxdyxpz0+wqz*dyxdyxpz1                   +dd0
      ec(199)=ec(199)+qdx*dyxdzxpx0+wqx*dyxdzxpx1+     yex+     rdzx+de0
      ec(200)=ec(200)+qdy*dyxdzxpx0+wqy*dyxdzxpx1+     xex              
      ec(201)=ec(201)+qdz*dyxdzxpx0+wqz*dyxdzxpx1         +     rdxx    
      ec(202)=ec(202)+qdx*dyxdzxpy0+wqx*dyxdzxpy1+     yey+     rdzy    
      ec(203)=ec(203)+qdy*dyxdzxpy0+wqy*dyxdzxpy1+     xey          +de0
      ec(204)=ec(204)+qdz*dyxdzxpy0+wqz*dyxdzxpy1         +     rdxy    
      ec(205)=ec(205)+qdx*dyxdzxpz0+wqx*dyxdzxpz1+     yez+     rdzz    
      ec(206)=ec(206)+qdy*dyxdzxpz0+wqy*dyxdzxpz1+     xez              
      ec(207)=ec(207)+qdz*dyxdzxpz0+wqz*dyxdzxpz1         +     rdxz+de0
      ec(208)=ec(208)+qdx*dyxdzypx0+wqx*dyxdzypx1+     yfx          +df0
      ec(209)=ec(209)+qdy*dyxdzypx0+wqy*dyxdzypx1+     xfx+     rdzx    
      ec(210)=ec(210)+qdz*dyxdzypx0+wqz*dyxdzypx1         +     rdyx    
      ec(211)=ec(211)+qdx*dyxdzypy0+wqx*dyxdzypy1+     yfy              
      ec(212)=ec(212)+qdy*dyxdzypy0+wqy*dyxdzypy1+     xfy+     rdzy+df0
      ec(213)=ec(213)+qdz*dyxdzypy0+wqz*dyxdzypy1         +     rdyy    
      ec(214)=ec(214)+qdx*dyxdzypz0+wqx*dyxdzypz1+     yfz              
      ec(215)=ec(215)+qdy*dyxdzypz0+wqy*dyxdzypz1+     xfz+     rdzz    
      ec(216)=ec(216)+qdz*dyxdzypz0+wqz*dyxdzypz1         +     rdyz+df0
      ec(217)=ec(217)+qdx*dzxdxxpx0+wqx*dzxdxxpx1+     zax+2.d0*rexx+ea0
      ec(218)=ec(218)+qdy*dzxdxxpx0+wqy*dzxdxxpx1                       
      ec(219)=ec(219)+qdz*dzxdxxpx0+wqz*dzxdxxpx1+     xax              
      ec(220)=ec(220)+qdx*dzxdxxpy0+wqx*dzxdxxpy1+     zay+2.d0*rexy    
      ec(221)=ec(221)+qdy*dzxdxxpy0+wqy*dzxdxxpy1                   +ea0
      ec(222)=ec(222)+qdz*dzxdxxpy0+wqz*dzxdxxpy1+     xay              
      ec(223)=ec(223)+qdx*dzxdxxpz0+wqx*dzxdxxpz1+     zaz+2.d0*rexz    
      ec(224)=ec(224)+qdy*dzxdxxpz0+wqy*dzxdxxpz1                       
      ec(225)=ec(225)+qdz*dzxdxxpz0+wqz*dzxdxxpz1+     xaz          +ea0
      ec(226)=ec(226)+qdx*dzxdyypx0+wqx*dzxdyypx1+     zbx          +eb0
      ec(227)=ec(227)+qdy*dzxdyypx0+wqy*dzxdyypx1         +2.d0*reyx    
      ec(228)=ec(228)+qdz*dzxdyypx0+wqz*dzxdyypx1+     xbx              
      ec(229)=ec(229)+qdx*dzxdyypy0+wqx*dzxdyypy1+     zby              
      ec(230)=ec(230)+qdy*dzxdyypy0+wqy*dzxdyypy1         +2.d0*reyy+eb0
      ec(231)=ec(231)+qdz*dzxdyypy0+wqz*dzxdyypy1+     xby              
      ec(232)=ec(232)+qdx*dzxdyypz0+wqx*dzxdyypz1+     zbz              
      ec(233)=ec(233)+qdy*dzxdyypz0+wqy*dzxdyypz1         +2.d0*reyz    
      ec(234)=ec(234)+qdz*dzxdyypz0+wqz*dzxdyypz1+     xbz          +eb0
      ec(235)=ec(235)+qdx*dzxdzzpx0+wqx*dzxdzzpx1+     zcx          +ec0
      ec(236)=ec(236)+qdy*dzxdzzpx0+wqy*dzxdzzpx1                       
      ec(237)=ec(237)+qdz*dzxdzzpx0+wqz*dzxdzzpx1+     xcx+2.d0*rezx    
      ec(238)=ec(238)+qdx*dzxdzzpy0+wqx*dzxdzzpy1+     zcy              
      ec(239)=ec(239)+qdy*dzxdzzpy0+wqy*dzxdzzpy1                   +ec0
      ec(240)=ec(240)+qdz*dzxdzzpy0+wqz*dzxdzzpy1+     xcy+2.d0*rezy    
      ec(241)=ec(241)+qdx*dzxdzzpz0+wqx*dzxdzzpz1+     zcz              
      ec(242)=ec(242)+qdy*dzxdzzpz0+wqy*dzxdzzpz1                       
      ec(243)=ec(243)+qdz*dzxdzzpz0+wqz*dzxdzzpz1+     xcz+2.d0*rezz+ec0
      ec(244)=ec(244)+qdx*dzxdyxpx0+wqx*dzxdyxpx1+     zdx+     reyx+ed0
      ec(245)=ec(245)+qdy*dzxdyxpx0+wqy*dzxdyxpx1         +     rexx    
      ec(246)=ec(246)+qdz*dzxdyxpx0+wqz*dzxdyxpx1+     xdx              
      ec(247)=ec(247)+qdx*dzxdyxpy0+wqx*dzxdyxpy1+     zdy+     reyy    
      ec(248)=ec(248)+qdy*dzxdyxpy0+wqy*dzxdyxpy1         +     rexy+ed0
      ec(249)=ec(249)+qdz*dzxdyxpy0+wqz*dzxdyxpy1+     xdy              
      ec(250)=ec(250)+qdx*dzxdyxpz0+wqx*dzxdyxpz1+     zdz+     reyz    
      ec(251)=ec(251)+qdy*dzxdyxpz0+wqy*dzxdyxpz1         +     rexz    
      ec(252)=ec(252)+qdz*dzxdyxpz0+wqz*dzxdyxpz1+     xdz          +ed0
      ec(253)=ec(253)+qdx*dzxdzxpx0+wqx*dzxdzxpx1+     zex+     rezx+ee0
      ec(254)=ec(254)+qdy*dzxdzxpx0+wqy*dzxdzxpx1                       
      ec(255)=ec(255)+qdz*dzxdzxpx0+wqz*dzxdzxpx1+     xex+     rexx    
      ec(256)=ec(256)+qdx*dzxdzxpy0+wqx*dzxdzxpy1+     zey+     rezy    
      ec(257)=ec(257)+qdy*dzxdzxpy0+wqy*dzxdzxpy1                   +ee0
      ec(258)=ec(258)+qdz*dzxdzxpy0+wqz*dzxdzxpy1+     xey+     rexy    
      ec(259)=ec(259)+qdx*dzxdzxpz0+wqx*dzxdzxpz1+     zez+     rezz    
      ec(260)=ec(260)+qdy*dzxdzxpz0+wqy*dzxdzxpz1 
      ec(261)=ec(261)+qdz*dzxdzxpz0+wqz*dzxdzxpz1+     xez+     rexz+ee0
      ec(262)=ec(262)+qdx*dzxdzypx0+wqx*dzxdzypx1+     zfx          +ef0
      ec(263)=ec(263)+qdy*dzxdzypx0+wqy*dzxdzypx1         +     rezx    
      ec(264)=ec(264)+qdz*dzxdzypx0+wqz*dzxdzypx1+     xfx+     reyx    
      ec(265)=ec(265)+qdx*dzxdzypy0+wqx*dzxdzypy1+     zfy              
      ec(266)=ec(266)+qdy*dzxdzypy0+wqy*dzxdzypy1         +     rezy+ef0
      ec(267)=ec(267)+qdz*dzxdzypy0+wqz*dzxdzypy1+     xfy+     reyy    
      ec(268)=ec(268)+qdx*dzxdzypz0+wqx*dzxdzypz1+     zfz              
      ec(269)=ec(269)+qdy*dzxdzypz0+wqy*dzxdzypz1         +     rezz    
      ec(270)=ec(270)+qdz*dzxdzypz0+wqz*dzxdzypz1+1.d0*xfz+     reyz+ef0
      ec(271)=ec(271)+qdx*dzydxxpx0+wqx*dzydxxpx1         +2.d0*rfxx+fa0
      ec(272)=ec(272)+qdy*dzydxxpx0+wqy*dzydxxpx1+     zax              
      ec(273)=ec(273)+qdz*dzydxxpx0+wqz*dzydxxpx1+     yax              
      ec(274)=ec(274)+qdx*dzydxxpy0+wqx*dzydxxpy1         +2.d0*rfxy    
      ec(275)=ec(275)+qdy*dzydxxpy0+wqy*dzydxxpy1+     zay          +fa0
      ec(276)=ec(276)+qdz*dzydxxpy0+wqz*dzydxxpy1+     yay              
      ec(277)=ec(277)+qdx*dzydxxpz0+wqx*dzydxxpz1         +2.d0*rfxz    
      ec(278)=ec(278)+qdy*dzydxxpz0+wqy*dzydxxpz1+     zaz              
      ec(279)=ec(279)+qdz*dzydxxpz0+wqz*dzydxxpz1+     yaz          +fa0
      ec(280)=ec(280)+qdx*dzydyypx0+wqx*dzydyypx1                   +fb0
      ec(281)=ec(281)+qdy*dzydyypx0+wqy*dzydyypx1+     zbx+2.d0*rfyx    
      ec(282)=ec(282)+qdz*dzydyypx0+wqz*dzydyypx1+     ybx              
      ec(283)=ec(283)+qdx*dzydyypy0+wqx*dzydyypy1                       
      ec(284)=ec(284)+qdy*dzydyypy0+wqy*dzydyypy1+     zby+2.d0*rfyy+fb0
      ec(285)=ec(285)+qdz*dzydyypy0+wqz*dzydyypy1+     yby              
      ec(286)=ec(286)+qdx*dzydyypz0+wqx*dzydyypz1                       
      ec(287)=ec(287)+qdy*dzydyypz0+wqy*dzydyypz1+     zbz+2.d0*rfyz    
      ec(288)=ec(288)+qdz*dzydyypz0+wqz*dzydyypz1+     ybz          +fb0
      ec(289)=ec(289)+qdx*dzydzzpx0+wqx*dzydzzpx1                   +fc0
      ec(290)=ec(290)+qdy*dzydzzpx0+wqy*dzydzzpx1+     zcx              
      ec(291)=ec(291)+qdz*dzydzzpx0+wqz*dzydzzpx1+     ycx+2.d0*rfzx    
      ec(292)=ec(292)+qdx*dzydzzpy0+wqx*dzydzzpy1                       
      ec(293)=ec(293)+qdy*dzydzzpy0+wqy*dzydzzpy1+     zcy          +fc0
      ec(294)=ec(294)+qdz*dzydzzpy0+wqz*dzydzzpy1+     ycy+2.d0*rfzy    
      ec(295)=ec(295)+qdx*dzydzzpz0+wqx*dzydzzpz1                       
      ec(296)=ec(296)+qdy*dzydzzpz0+wqy*dzydzzpz1+     zcz              
      ec(297)=ec(297)+qdz*dzydzzpz0+wqz*dzydzzpz1+     ycz+2.d0*rfzz+fc0
      ec(298)=ec(298)+qdx*dzydyxpx0+wqx*dzydyxpx1         +     rfyx+fd0
      ec(299)=ec(299)+qdy*dzydyxpx0+wqy*dzydyxpx1+     zdx+     rfxx    
      ec(300)=ec(300)+qdz*dzydyxpx0+wqz*dzydyxpx1+     ydx              
      ec(301)=ec(301)+qdx*dzydyxpy0+wqx*dzydyxpy1         +     rfyy    
      ec(302)=ec(302)+qdy*dzydyxpy0+wqy*dzydyxpy1+     zdy+     rfxy+fd0
      ec(303)=ec(303)+qdz*dzydyxpy0+wqz*dzydyxpy1+     ydy              
      ec(304)=ec(304)+qdx*dzydyxpz0+wqx*dzydyxpz1         +     rfyz    
      ec(305)=ec(305)+qdy*dzydyxpz0+wqy*dzydyxpz1+     zdz+     rfxz    
      ec(306)=ec(306)+qdz*dzydyxpz0+wqz*dzydyxpz1+     ydz          +fd0
      ec(307)=ec(307)+qdx*dzydzxpx0+wqx*dzydzxpx1         +     rfzx+fe0
      ec(308)=ec(308)+qdy*dzydzxpx0+wqy*dzydzxpx1+     zex              
      ec(309)=ec(309)+qdz*dzydzxpx0+wqz*dzydzxpx1+     yex+     rfxx    
      ec(310)=ec(310)+qdx*dzydzxpy0+wqx*dzydzxpy1         +     rfzy    
      ec(311)=ec(311)+qdy*dzydzxpy0+wqy*dzydzxpy1+     zey          +fe0
      ec(312)=ec(312)+qdz*dzydzxpy0+wqz*dzydzxpy1+     yey+     rfxy    
      ec(313)=ec(313)+qdx*dzydzxpz0+wqx*dzydzxpz1         +     rfzz    
      ec(314)=ec(314)+qdy*dzydzxpz0+wqy*dzydzxpz1+     zez              
      ec(315)=ec(315)+qdz*dzydzxpz0+wqz*dzydzxpz1+     yez+     rfxz+fe0
      ec(316)=ec(316)+qdx*dzydzypx0+wqx*dzydzypx1                   +ff0
      ec(317)=ec(317)+qdy*dzydzypx0+wqy*dzydzypx1+     zfx+     rfzx    
      ec(318)=ec(318)+qdz*dzydzypx0+wqz*dzydzypx1+     yfx+     rfyx    
      ec(319)=ec(319)+qdx*dzydzypy0+wqx*dzydzypy1                       
      ec(320)=ec(320)+qdy*dzydzypy0+wqy*dzydzypy1+     zfy+     rfzy+ff0
      ec(321)=ec(321)+qdz*dzydzypy0+wqz*dzydzypy1+     yfy+     rfyy    
      ec(322)=ec(322)+qdx*dzydzypz0+wqx*dzydzypz1                       
      ec(323)=ec(323)+qdy*dzydzypz0+wqy*dzydzypz1+     zfz+     rfzz    
      ec(324)=ec(324)+qdz*dzydzypz0+wqz*dzydzypz1+     yfz+     rfyz+ff0

                enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 

        do i=163,324
          ec(i)= ec(i)*root3
        enddo

        do i0 = 1,6
           do ii=28,54

             i = ii + 54*(i0-1)
             ec(i) = ec(i)*root3

           enddo
        enddo

      endif
      

      end

!= dpdp =============================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================
      subroutine iodpdp(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(6)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)

      dimension ec(324)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,6 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 ,
     &   0.09090909090909090d+00          /

      data  root3 / 1.73205080756887729352d+00 /



      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,324
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)

                  qdx =  yq(1,l,k) - xyz(1,latom)
                  qdy =  yq(2,l,k) - xyz(2,latom)
                  qdz =  yq(3,l,k) - xyz(3,latom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(7)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f6   = (((((fdat(13,it)*dt6   + fdat(12,it))*dt5
     &                    + fdat(11,it))*dt4  + fdat(10,it))*dt3
     &                    + fdat(9,it))*dt2  + fdat(8,it))*dt
     &                    + fdat(7,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f5   = (t2*f6 + ee)*rminv(6)
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)

                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     dm6 = fpp*f6! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
                     dm5 =  4.5d0 *tinv *  dm4
                     dm6 =  5.5d0 *tinv *  dm5
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)
                  s6 = dm6      !/( roo2**3)

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
!psss
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
                  px5 = pax*s5 + wpx*s6
                  py5 = pay*s5 + wpy*s6
                  pz5 = paz*s5 + wpz*s6
!spss
!                 xp1 = pbx*s1 + wpx*s2
!                 yp1 = pby*s1 + wpy*s2
!                 zp1 = pbz*s1 + wpz*s2
                  xp2 = pbx*s2 + wpx*s3
                  yp2 = pby*s2 + wpy*s3
                  zp2 = pbz*s2 + wpz*s3
                  xp3 = pbx*s3 + wpx*s4
                  yp3 = pby*s3 + wpy*s4
                  zp3 = pbz*s3 + wpz*s4

                  s01 = zet*(s0-rooz*s1)
                  s12 = zet*(s1-rooz*s2)
                  s23 = zet*(s2-rooz*s3)
                  s34 = zet*(s3-rooz*s4)
                  s45 = zet*(s4-rooz*s5)
! dsss 
                  dxx0 = pax*px0 + wpx*px1+s01
                  dyy0 = pay*py0 + wpy*py1+s01
                  dzz0 = paz*pz0 + wpz*pz1+s01
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+s12
                  dyy1 = pay*py1 + wpy*py2+s12
                  dzz1 = paz*pz1 + wpz*pz2+s12
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+s23
                  dyy2 = pay*py2 + wpy*py3+s23
                  dzz2 = paz*pz2 + wpz*pz3+s23
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
 
                  dxx3 = pax*px3 + wpx*px4+s34
                  dyy3 = pay*py3 + wpy*py4+s34
                  dzz3 = paz*pz3 + wpz*pz4+s34
                  dyx3 = pay*px3 + wpy*px4
                  dzx3 = paz*px3 + wpz*px4
                  dzy3 = paz*py3 + wpz*py4

                  dxx4 = pax*px4 + wpx*px5+s45
                  dyy4 = pay*py4 + wpy*py5+s45
                  dzz4 = paz*pz4 + wpz*pz5+s45
                  dyx4 = pay*px4 + wpy*px5
                  dzx4 = paz*px4 + wpz*px5
                  dzy4 = paz*py4 + wpz*py5

                  ppxx1 = pbx * px1 + wpx*px2 + s12
                  ppyx1 = pbx * py1 + wpx*py2
                  ppzx1 = pbx * pz1 + wpx*pz2
                  ppxy1 = pby * px1 + wpy*px2
                  ppyy1 = pby * py1 + wpy*py2 + s12
                  ppzy1 = pby * pz1 + wpy*pz2
                  ppxz1 = pbz * px1 + wpz*px2
                  ppyz1 = pbz * py1 + wpz*py2
                  ppzz1 = pbz * pz1 + wpz*pz2 + s12
                             
                  ppxx2 = pbx * px2 + wpx*px3 + s23
                  ppyx2 = pbx * py2 + wpx*py3
                  ppzx2 = pbx * pz2 + wpx*pz3
                  ppxy2 = pby * px2 + wpy*px3
                  ppyy2 = pby * py2 + wpy*py3 + s23
                  ppzy2 = pby * pz2 + wpy*pz3
                  ppxz2 = pbz * px2 + wpz*px3
                  ppyz2 = pbz * py2 + wpz*py3
                  ppzz2 = pbz * pz2 + wpz*pz3 + s23
           
                  ppxx3 = pbx * px3 + wpx*px4 + s34
                  ppyx3 = pbx * py3 + wpx*py4
                  ppzx3 = pbx * pz3 + wpx*pz4
                  ppxy3 = pby * px3 + wpy*px4
                  ppyy3 = pby * py3 + wpy*py4 + s34
                  ppzy3 = pby * pz3 + wpy*pz4
                  ppxz3 = pbz * px3 + wpz*px4
                  ppyz3 = pbz * py3 + wpz*py4
                  ppzz3 = pbz * pz3 + wpz*pz4 + s34
!spps
                  spxpx2 = qcx * xp2 + wqx*xp3 + rkp*s3
                  spypx2 = qcx * yp2 + wqx*yp3
                  spzpx2 = qcx * zp2 + wqx*zp3
                  spxpy2 = qcy * xp2 + wqy*xp3
                  spypy2 = qcy * yp2 + wqy*yp3 + rkp*s3
                  spzpy2 = qcy * zp2 + wqy*zp3
                  spxpz2 = qcz * xp2 + wqz*xp3
                  spypz2 = qcz * yp2 + wqz*yp3
                  spzpz2 = qcz * zp2 + wqz*zp3 + rkp*s3
!psps
                  pxpx2 = qcx * px2 + wqx*px3 + rkp*s3
                  pypx2 = qcx * py2 + wqx*py3
                  pzpx2 = qcx * pz2 + wqx*pz3
                  pxpy2 = qcy * px2 + wqy*px3
                  pypy2 = qcy * py2 + wqy*py3 + rkp*s3
                  pzpy2 = qcy * pz2 + wqy*pz3
                  pxpz2 = qcz * px2 + wqz*px3
                  pypz2 = qcz * py2 + wqz*py3
                  pzpz2 = qcz * pz2 + wqz*pz3 + rkp*s3
                     
                  pxpx3 = qcx * px3 + wqx*px4 + rkp*s4
                  pypx3 = qcx * py3 + wqx*py4
                  pzpx3 = qcx * pz3 + wqx*pz4
                  pxpy3 = qcy * px3 + wqy*px4
                  pypy3 = qcy * py3 + wqy*py4 + rkp*s4
                  pzpy3 = qcy * pz3 + wqy*pz4
                  pxpz3 = qcz * px3 + wqz*px4
                  pypz3 = qcz * py3 + wqz*py4
                  pzpz3 = qcz * pz3 + wqz*pz4 + rkp*s4

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  px34 = zet*(px3-rooz*px4)
                  py34 = zet*(py3-rooz*py4)
                  pz34 = zet*(pz3-rooz*pz4)

!dpss 
                  dpxxx0 =  pbx*dxx0 + wpx*dxx1 + 2.0d0*px01
                  dpxxy0 =  pby*dxx0 + wpy*dxx1             
                  dpxxz0 =  pbz*dxx0 + wpz*dxx1             
                  dpyyx0 =  pbx*dyy0 + wpx*dyy1             
                  dpyyy0 =  pby*dyy0 + wpy*dyy1 + 2.0d0*py01
                  dpyyz0 =  pbz*dyy0 + wpz*dyy1             
                  dpzzx0 =  pbx*dzz0 + wpx*dzz1             
                  dpzzy0 =  pby*dzz0 + wpy*dzz1             
                  dpzzz0 =  pbz*dzz0 + wpz*dzz1 + 2.0d0*pz01
                  dpyxx0 =  pbx*dyx0 + wpx*dyx1 +       py01
                  dpyxy0 =  pby*dyx0 + wpy*dyx1 +       px01
                  dpyxz0 =  pbz*dyx0 + wpz*dyx1             
                  dpzxx0 =  pbx*dzx0 + wpx*dzx1 +       pz01
                  dpzxy0 =  pby*dzx0 + wpy*dzx1             
                  dpzxz0 =  pbz*dzx0 + wpz*dzx1 +       px01
                  dpzyx0 =  pbx*dzy0 + wpx*dzy1             
                  dpzyy0 =  pby*dzy0 + wpy*dzy1 +       pz01
                  dpzyz0 =  pbz*dzy0 + wpz*dzy1 +       py01
           
                  dpxxx1 =  pbx*dxx1 + wpx*dxx2 + 2.0d0*px12
                  dpxxy1 =  pby*dxx1 + wpy*dxx2             
                  dpxxz1 =  pbz*dxx1 + wpz*dxx2             
                  dpyyx1 =  pbx*dyy1 + wpx*dyy2             
                  dpyyy1 =  pby*dyy1 + wpy*dyy2 + 2.0d0*py12
                  dpyyz1 =  pbz*dyy1 + wpz*dyy2             
                  dpzzx1 =  pbx*dzz1 + wpx*dzz2             
                  dpzzy1 =  pby*dzz1 + wpy*dzz2             
                  dpzzz1 =  pbz*dzz1 + wpz*dzz2 + 2.0d0*pz12
                  dpyxx1 =  pbx*dyx1 + wpx*dyx2 +       py12
                  dpyxy1 =  pby*dyx1 + wpy*dyx2 +       px12
                  dpyxz1 =  pbz*dyx1 + wpz*dyx2             
                  dpzxx1 =  pbx*dzx1 + wpx*dzx2 +       pz12
                  dpzxy1 =  pby*dzx1 + wpy*dzx2             
                  dpzxz1 =  pbz*dzx1 + wpz*dzx2 +       px12
                  dpzyx1 =  pbx*dzy1 + wpx*dzy2             
                  dpzyy1 =  pby*dzy1 + wpy*dzy2 +       pz12
                  dpzyz1 =  pbz*dzy1 + wpz*dzy2 +       py12
           
                  dpxxx2 =  pbx*dxx2 + wpx*dxx3 + 2.0d0*px23
                  dpxxy2 =  pby*dxx2 + wpy*dxx3
                  dpxxz2 =  pbz*dxx2 + wpz*dxx3
                  dpyyx2 =  pbx*dyy2 + wpx*dyy3
                  dpyyy2 =  pby*dyy2 + wpy*dyy3 + 2.0d0*py23
                  dpyyz2 =  pbz*dyy2 + wpz*dyy3             
                  dpzzx2 =  pbx*dzz2 + wpx*dzz3             
                  dpzzy2 =  pby*dzz2 + wpy*dzz3             
                  dpzzz2 =  pbz*dzz2 + wpz*dzz3 + 2.0d0*pz23
                  dpyxx2 =  pbx*dyx2 + wpx*dyx3 +       py23
                  dpyxy2 =  pby*dyx2 + wpy*dyx3 +       px23
                  dpyxz2 =  pbz*dyx2 + wpz*dyx3             
                  dpzxx2 =  pbx*dzx2 + wpx*dzx3 +       pz23
                  dpzxy2 =  pby*dzx2 + wpy*dzx3             
                  dpzxz2 =  pbz*dzx2 + wpz*dzx3 +       px23
                  dpzyx2 =  pbx*dzy2 + wpx*dzy3             
                  dpzyy2 =  pby*dzy2 + wpy*dzy3 +       pz23
                  dpzyz2 =  pbz*dzy2 + wpz*dzy3 +       py23
           
                  dpxxx3 =  pbx*dxx3 + wpx*dxx4 + 2.0d0*px34
                  dpxxy3 =  pby*dxx3 + wpy*dxx4             
                  dpxxz3 =  pbz*dxx3 + wpz*dxx4             
                  dpyyx3 =  pbx*dyy3 + wpx*dyy4             
                  dpyyy3 =  pby*dyy3 + wpy*dyy4 + 2.0d0*py34
                  dpyyz3 =  pbz*dyy3 + wpz*dyy4             
                  dpzzx3 =  pbx*dzz3 + wpx*dzz4             
                  dpzzy3 =  pby*dzz3 + wpy*dzz4             
                  dpzzz3 =  pbz*dzz3 + wpz*dzz4 + 2.0d0*pz34
                  dpyxx3 =  pbx*dyx3 + wpx*dyx4 +       py34
                  dpyxy3 =  pby*dyx3 + wpy*dyx4 +       px34
                  dpyxz3 =  pbz*dyx3 + wpz*dyx4             
                  dpzxx3 =  pbx*dzx3 + wpx*dzx4 +       pz34
                  dpzxy3 =  pby*dzx3 + wpy*dzx4             
                  dpzxz3 =  pbz*dzx3 + wpz*dzx4 +       px34
                  dpzyx3 =  pbx*dzy3 + wpx*dzy4             
                  dpzyy3 =  pby*dzy3 + wpy*dzy4 +       pz34
                  dpzyz3 =  pbz*dzy3 + wpz*dzy4 +       py34

                  rpx2 = rkp * px2
                  rpy2 = rkp * py2
                  rpz2 = rkp * pz2
                  rpx3 = rkp * px3
                  rpy3 = rkp * py3
                  rpz3 = rkp * pz3

                  rxp2 = rkp * xp2
                  ryp2 = rkp * yp2
                  rzp2 = rkp * zp2
                  rxp3 = rkp * xp3
                  ryp3 = rkp * yp3
                  rzp3 = rkp * zp3

!dsps
                  dxxpx1 =  qcx*dxx1 + wqx*dxx2 + 2.0d0*rpx2
                  dxxpy1 =  qcy*dxx1 + wqy*dxx2            
                  dxxpz1 =  qcz*dxx1 + wqz*dxx2            
                  dyypx1 =  qcx*dyy1 + wqx*dyy2            
                  dyypy1 =  qcy*dyy1 + wqy*dyy2 + 2.0d0*rpy2
                  dyypz1 =  qcz*dyy1 + wqz*dyy2            
                  dzzpx1 =  qcx*dzz1 + wqx*dzz2            
                  dzzpy1 =  qcy*dzz1 + wqy*dzz2            
                  dzzpz1 =  qcz*dzz1 + wqz*dzz2 + 2.0d0*rpz2
                  dyxpx1 =  qcx*dyx1 + wqx*dyx2 +       rpy2
                  dyxpy1 =  qcy*dyx1 + wqy*dyx2 +       rpx2
                  dyxpz1 =  qcz*dyx1 + wqz*dyx2            
                  dzxpx1 =  qcx*dzx1 + wqx*dzx2 +       rpz2
                  dzxpy1 =  qcy*dzx1 + wqy*dzx2            
                  dzxpz1 =  qcz*dzx1 + wqz*dzx2 +       rpx2
                  dzypx1 =  qcx*dzy1 + wqx*dzy2            
                  dzypy1 =  qcy*dzy1 + wqy*dzy2 +       rpz2
                  dzypz1 =  qcz*dzy1 + wqz*dzy2 +       rpy2
                     
                  dxxpx2 =  qcx*dxx2 + wqx*dxx3 + 2.0d0*rpx3
                  dxxpy2 =  qcy*dxx2 + wqy*dxx3
                  dxxpz2 =  qcz*dxx2 + wqz*dxx3
                  dyypx2 =  qcx*dyy2 + wqx*dyy3
                  dyypy2 =  qcy*dyy2 + wqy*dyy3 + 2.0d0*rpy3
                  dyypz2 =  qcz*dyy2 + wqz*dyy3            
                  dzzpx2 =  qcx*dzz2 + wqx*dzz3            
                  dzzpy2 =  qcy*dzz2 + wqy*dzz3            
                  dzzpz2 =  qcz*dzz2 + wqz*dzz3 + 2.0d0*rpz3
                  dyxpx2 =  qcx*dyx2 + wqx*dyx3 +       rpy3
                  dyxpy2 =  qcy*dyx2 + wqy*dyx3 +       rpx3
                  dyxpz2 =  qcz*dyx2 + wqz*dyx3            
                  dzxpx2 =  qcx*dzx2 + wqx*dzx3 +       rpz3
                  dzxpy2 =  qcy*dzx2 + wqy*dzx3            
                  dzxpz2 =  qcz*dzx2 + wqz*dzx3 +       rpx3
                  dzypx2 =  qcx*dzy2 + wqx*dzy3            
                  dzypy2 =  qcy*dzy2 + wqy*dzy3 +       rpz3
                  dzypz2 =  qcz*dzy2 + wqz*dzy3 +       rpy3

                  pppxxx1 = qcx*ppxx1 + wqx*ppxx2 + rxp2 + rpx2
                  pppxxy1 = qcy*ppxx1 + wqy*ppxx2        
                  pppxxz1 = qcz*ppxx1 + wqz*ppxx2        
                  pppxyx1 = qcx*ppxy1 + wqx*ppxy2 + ryp2
                  pppxyy1 = qcy*ppxy1 + wqy*ppxy2        + rpx2
                  pppxyz1 = qcz*ppxy1 + wqz*ppxy2              
                  pppxzx1 = qcx*ppxz1 + wqx*ppxz2 + rzp2       
                  pppxzy1 = qcy*ppxz1 + wqy*ppxz2              
                  pppxzz1 = qcz*ppxz1 + wqz*ppxz2        + rpx2
                  pppyxx1 = qcx*ppyx1 + wqx*ppyx2        + rpy2
                  pppyxy1 = qcy*ppyx1 + wqy*ppyx2 + rxp2       
                  pppyxz1 = qcz*ppyx1 + wqz*ppyx2              
                  pppyyx1 = qcx*ppyy1 + wqx*ppyy2              
                  pppyyy1 = qcy*ppyy1 + wqy*ppyy2 + ryp2 + rpy2
                  pppyyz1 = qcz*ppyy1 + wqz*ppyy2              
                  pppyzx1 = qcx*ppyz1 + wqx*ppyz2              
                  pppyzy1 = qcy*ppyz1 + wqy*ppyz2 + rzp2       
                  pppyzz1 = qcz*ppyz1 + wqz*ppyz2        + rpy2
                  pppzxx1 = qcx*ppzx1 + wqx*ppzx2        + rpz2
                  pppzxy1 = qcy*ppzx1 + wqy*ppzx2              
                  pppzxz1 = qcz*ppzx1 + wqz*ppzx2 + rxp2       
                  pppzyx1 = qcx*ppzy1 + wqx*ppzy2              
                  pppzyy1 = qcy*ppzy1 + wqy*ppzy2        + rpz2
                  pppzyz1 = qcz*ppzy1 + wqz*ppzy2 + ryp2       
                  pppzzx1 = qcx*ppzz1 + wqx*ppzz2
                  pppzzy1 = qcy*ppzz1 + wqy*ppzz2
                  pppzzz1 = qcz*ppzz1 + wqz*ppzz2 + rzp2 + rpz2

                  pppxxx2 = qcx*ppxx2 + wqx*ppxx3 + rxp3 + rpx3
                  pppxxy2 = qcy*ppxx2 + wqy*ppxx3        
                  pppxxz2 = qcz*ppxx2 + wqz*ppxx3        
                  pppxyx2 = qcx*ppxy2 + wqx*ppxy3 + ryp3
                  pppxyy2 = qcy*ppxy2 + wqy*ppxy3        + rpx3
                  pppxyz2 = qcz*ppxy2 + wqz*ppxy3              
                  pppxzx2 = qcx*ppxz2 + wqx*ppxz3 + rzp3       
                  pppxzy2 = qcy*ppxz2 + wqy*ppxz3              
                  pppxzz2 = qcz*ppxz2 + wqz*ppxz3        + rpx3
                  pppyxx2 = qcx*ppyx2 + wqx*ppyx3        + rpy3
                  pppyxy2 = qcy*ppyx2 + wqy*ppyx3 + rxp3       
                  pppyxz2 = qcz*ppyx2 + wqz*ppyx3              
                  pppyyx2 = qcx*ppyy2 + wqx*ppyy3              
                  pppyyy2 = qcy*ppyy2 + wqy*ppyy3 + ryp3 + rpy3
                  pppyyz2 = qcz*ppyy2 + wqz*ppyy3              
                  pppyzx2 = qcx*ppyz2 + wqx*ppyz3              
                  pppyzy2 = qcy*ppyz2 + wqy*ppyz3 + rzp3       
                  pppyzz2 = qcz*ppyz2 + wqz*ppyz3        + rpy3
                  pppzxx2 = qcx*ppzx2 + wqx*ppzx3        + rpz3
                  pppzxy2 = qcy*ppzx2 + wqy*ppzx3              
                  pppzxz2 = qcz*ppzx2 + wqz*ppzx3 + rxp3       
                  pppzyx2 = qcx*ppzy2 + wqx*ppzy3              
                  pppzyy2 = qcy*ppzy2 + wqy*ppzy3        + rpz3
                  pppzyz2 = qcz*ppzy2 + wqz*ppzy3 + ryp3       
                  pppzzx2 = qcx*ppzz2 + wqx*ppzz3
                  pppzzy2 = qcy*ppzz2 + wqy*ppzz3              
                  pppzzz2 = qcz*ppzz2 + wqz*ppzz3 + rzp3 + rpz3
!RANK = 4
       ppxx12 = eta*(ppxx1 - rooe*ppxx2)
       ppxy12 = eta*(ppxy1 - rooe*ppxy2)
       ppxz12 = eta*(ppxz1 - rooe*ppxz2)
       ppyx12 = eta*(ppyx1 - rooe*ppyx2)
       ppyy12 = eta*(ppyy1 - rooe*ppyy2)
       ppyz12 = eta*(ppyz1 - rooe*ppyz2)
       ppzx12 = eta*(ppzx1 - rooe*ppzx2)
       ppzy12 = eta*(ppzy1 - rooe*ppzy2)
       ppzz12 = eta*(ppzz1 - rooe*ppzz2)
       
      rpxpx2 = rkp*pxpx2
      rpxpy2 = rkp*pxpy2
      rpxpz2 = rkp*pxpz2
      rpypx2 = rkp*pypx2
      rpypy2 = rkp*pypy2
      rpypz2 = rkp*pypz2
      rpzpx2 = rkp*pzpx2
      rpzpy2 = rkp*pzpy2
      rpzpz2 = rkp*pzpz2
      rspxpx2 = rkp*spxpx2
      rspypx2 = rkp*spypx2
      rspzpx2 = rkp*spzpx2
      rspxpy2 = rkp*spxpy2
      rspypy2 = rkp*spypy2
      rspzpy2 = rkp*spzpy2
      rspxpz2 = rkp*spxpz2
      rspypz2 = rkp*spypz2
      rspzpz2 = rkp*spzpz2

!ppds
      xxdxx1 = qcx*pppxxx1 + wqx*pppxxx2 +rspxpx2 + rpxpx2 +ppxx12
      xxdyy1 = qcy*pppxxy1 + wqy*pppxxy2                   +ppxx12
      xxdzz1 = qcz*pppxxz1 + wqz*pppxxz2                   +ppxx12
      xxdyx1 = qcy*pppxxx1 + wqy*pppxxx2
      xxdzx1 = qcz*pppxxx1 + wqz*pppxxx2
      xxdzy1 = qcy*pppxxz1 + wqy*pppxxz2
      xydxx1 = qcx*pppxyx1 + wqx*pppxyx2 +rspypx2          +ppxy12
      xydyy1 = qcy*pppxyy1 + wqy*pppxyy2          +rpxpy2  +ppxy12
      xydzz1 = qcz*pppxyz1 + wqz*pppxyz2                   +ppxy12
      xydyx1 = qcy*pppxyx1 + wqy*pppxyx2          +rpxpx2
      xydzx1 = qcz*pppxyx1 + wqz*pppxyx2
      xydzy1 = qcz*pppxyy1 + wqz*pppxyy2
      xzdxx1 = qcx*pppxzx1 + wqx*pppxzx2 +rspzpx2          +ppxz12
      xzdyy1 = qcy*pppxzy1 + wqy*pppxzy2                   +ppxz12
      xzdzz1 = qcz*pppxzz1 + wqz*pppxzz2          +rpxpz2  +ppxz12
      xzdyx1 = qcy*pppxzx1 + wqy*pppxzx2
      xzdzx1 = qcx*pppxzz1 + wqx*pppxzz2 +rspzpz2
      xzdzy1 = qcy*pppxzz1 + wqy*pppxzz2
      yxdxx1 = qcx*pppyxx1 + wqx*pppyxx2          + rpypx2 +ppyx12
      yxdyy1 = qcy*pppyxy1 + wqy*pppyxy2 +rspxpy2          +ppyx12
      yxdzz1 = qcz*pppyxz1 + wqz*pppyxz2                   +ppyx12
      yxdyx1 = qcx*pppyxy1 + wqx*pppyxy2          + rpypy2
      yxdzx1 = qcz*pppyxx1 + wqz*pppyxx2
      yxdzy1 = qcz*pppyxy1 + wqz*pppyxy2
      yydxx1 = qcx*pppyyx1 + wqx*pppyyx2                   +ppyy12
      yydyy1 = qcy*pppyyy1 + wqy*pppyyy2 +rspypy2 +rpypy2  +ppyy12
      yydzz1 = qcz*pppyyz1 + wqz*pppyyz2                   +ppyy12
      yydyx1 = qcx*pppyyy1 + wqx*pppyyy2
      yydzx1 = qcz*pppyyx1 + wqz*pppyyx2 
      yydzy1 = qcz*pppyyy1 + wqz*pppyyy2 
      yzdxx1 = qcx*pppyzx1 + wqx*pppyzx2                   +ppyz12
      yzdyy1 = qcy*pppyzy1 + wqy*pppyzy2 +rspzpy2          +ppyz12
      yzdzz1 = qcz*pppyzz1 + wqz*pppyzz2          +rpypz2  +ppyz12
      yzdyx1 = qcx*pppyzy1 + wqx*pppyzy2
      yzdzx1 = qcx*pppyzz1 + wqx*pppyzz2
      yzdzy1 = qcy*pppyzz1 + wqy*pppyzz2 +rspzpz2
      zxdxx1 = qcx*pppzxx1 + wqx*pppzxx2          + rpzpx2 +ppzx12
      zxdyy1 = qcy*pppzxy1 + wqy*pppzxy2                   +ppzx12
      zxdzz1 = qcz*pppzxz1 + wqz*pppzxz2 +rspxpz2          +ppzx12
      zxdyx1 = qcy*pppzxx1 + wqy*pppzxx2
      zxdzx1 = qcz*pppzxx1 + wqz*pppzxx2 +rspxpx2
      zxdzy1 = qcy*pppzxz1 + wqy*pppzxz2 
      zydxx1 = qcx*pppzyx1 + wqx*pppzyx2                   +ppzy12
      zydyy1 = qcy*pppzyy1 + wqy*pppzyy2          +rpzpy2  +ppzy12
      zydzz1 = qcz*pppzyz1 + wqz*pppzyz2 +rspypz2          +ppzy12
      zydyx1 = qcx*pppzyy1 + wqx*pppzyy2
      zydzx1 = qcx*pppzyz1 + wqx*pppzyz2
      zydzy1 = qcz*pppzyy1 + wqz*pppzyy2 +rspypy2 
      zzdxx1 = qcx*pppzzx1 + wqx*pppzzx2                   +ppzz12
      zzdyy1 = qcy*pppzzy1 + wqy*pppzzy2                   +ppzz12
      zzdzz1 = qcz*pppzzz1 + wqz*pppzzz2 +rspzpz2 +rpzpz2  +ppzz12
      zzdyx1 = qcx*pppzzy1 + wqx*pppzzy2
      zzdzx1 = qcx*pppzzz1 + wqx*pppzzz2
      zzdzy1 = qcy*pppzzz1 + wqy*pppzzz2

      rdxx1 = rkp*dxx1
      rdyy1 = rkp*dyy1
      rdzz1 = rkp*dzz1
      rdyx1 = rkp*dyx1
      rdzx1 = rkp*dzx1
      rdzy1 = rkp*dzy1
      rdxx2 = rkp*dxx2
      rdyy2 = rkp*dyy2
      rdzz2 = rkp*dzz2
      rdyx2 = rkp*dyx2
      rdzx2 = rkp*dzx2
      rdzy2 = rkp*dzy2
      rdxx3 = rkp*dxx3
      rdyy3 = rkp*dyy3
      rdzz3 = rkp*dzz3
      rdyx3 = rkp*dyx3
      rdzx3 = rkp*dzx3
      rdzy3 = rkp*dzy3


      dxx12 = eta*(dxx1 -rooe*dxx2)
      dyy12 = eta*(dyy1 -rooe*dyy2)
      dzz12 = eta*(dzz1 -rooe*dzz2)
      dyx12 = eta*(dyx1 -rooe*dyx2)
      dzx12 = eta*(dzx1 -rooe*dzx2)
      dzy12 = eta*(dzy1 -rooe*dzy2)

      rppxx1 = rkp*ppxx1
      rppxy1 = rkp*ppxy1
      rppxz1 = rkp*ppxz1
      rppyx1 = rkp*ppyx1
      rppyy1 = rkp*ppyy1
      rppyz1 = rkp*ppyz1
      rppzx1 = rkp*ppzx1
      rppzy1 = rkp*ppzy1
      rppzz1 = rkp*ppzz1
      rppxx2 = rkp*ppxx2
      rppxy2 = rkp*ppxy2
      rppxz2 = rkp*ppxz2
      rppyx2 = rkp*ppyx2
      rppyy2 = rkp*ppyy2
      rppyz2 = rkp*ppyz2
      rppzx2 = rkp*ppzx2
      rppzy2 = rkp*ppzy2
      rppzz2 = rkp*ppzz2
      rppxx3 = rkp*ppxx3
      rppxy3 = rkp*ppxy3
      rppxz3 = rkp*ppxz3
      rppyx3 = rkp*ppyx3
      rppyy3 = rkp*ppyy3
      rppyz3 = rkp*ppyz3
      rppzx3 = rkp*ppzx3
      rppzy3 = rkp*ppzy3
      rppzz3 = rkp*ppzz3

!dsds
      dxxdxx1 = qcx*dxxpx1 + wqx*dxxpx2 +2.0d0*rpxpx2 + dxx12
      dxxdyy1 = qcy*dxxpy1 + wqy*dxxpy2               + dxx12
      dxxdzz1 = qcz*dxxpz1 + wqz*dxxpz2               + dxx12
      dxxdyx1 = qcy*dxxpx1 + wqy*dxxpx2            
      dxxdzx1 = qcz*dxxpx1 + wqz*dxxpx2            
      dxxdzy1 = qcy*dxxpz1 + wqy*dxxpz2            
      dyydxx1 = qcx*dyypx1 + wqx*dyypx2               + dyy12
      dyydyy1 = qcy*dyypy1 + wqy*dyypy2 +2.0d0*rpypy2 + dyy12
      dyydzz1 = qcz*dyypz1 + wqz*dyypz2               + dyy12
      dyydyx1 = qcy*dyypx1 + wqy*dyypx2 +2.0d0*rpypx2
      dyydzx1 = qcz*dyypx1 + wqz*dyypx2            
      dyydzy1 = qcz*dyypy1 + wqz*dyypy2            
      dzzdxx1 = qcx*dzzpx1 + wqx*dzzpx2               + dzz12
      dzzdyy1 = qcy*dzzpy1 + wqy*dzzpy2               + dzz12
      dzzdzz1 = qcz*dzzpz1 + wqz*dzzpz2 +2.0d0*rpzpz2 + dzz12
      dzzdyx1 = qcy*dzzpx1 + wqy*dzzpx2            
      dzzdzx1 = qcz*dzzpx1 + wqz*dzzpx2 +2.0d0*rpzpx2
      dzzdzy1 = qcy*dzzpz1 + wqy*dzzpz2            
      dyxdxx1 = qcx*dyxpx1 + wqx*dyxpx2 +      rpypx2 + dyx12
      dyxdyy1 = qcy*dyxpy1 + wqy*dyxpy2 +      rpxpy2 + dyx12
      dyxdzz1 = qcz*dyxpz1 + wqz*dyxpz2               + dyx12
      dyxdyx1 = qcy*dyxpx1 + wqy*dyxpx2 +      rpxpx2
      dyxdzx1 = qcz*dyxpx1 + wqz*dyxpx2            
      dyxdzy1 = qcz*dyxpy1 + wqz*dyxpy2            
      dzxdxx1 = qcx*dzxpx1 + wqx*dzxpx2 +      rpzpx2 + dzx12
      dzxdyy1 = qcy*dzxpy1 + wqy*dzxpy2               + dzx12
      dzxdzz1 = qcz*dzxpz1 + wqz*dzxpz2 +      rpxpz2 + dzx12
      dzxdyx1 = qcy*dzxpx1 + wqy*dzxpx2            
      dzxdzx1 = qcz*dzxpx1 + wqz*dzxpx2 +      rpxpx2
      dzxdzy1 = qcy*dzxpz1 + wqy*dzxpz2            
      dzydxx1 = qcx*dzypx1 + wqx*dzypx2               + dzy12
      dzydyy1 = qcy*dzypy1 + wqy*dzypy2 +      rpzpy2 + dzy12
      dzydzz1 = qcz*dzypz1 + wqz*dzypz2 +      rpypz2 + dzy12
      dzydyx1 = qcx*dzypy1 + wqx*dzypy2
      dzydzx1 = qcx*dzypz1 + wqx*dzypz2
      dzydzy1 = qcy*dzypz1 + wqy*dzypz2 +      rpzpz2

!dpps
      dxxpxpx0= qcx*dpxxx0 + wqx*dpxxx1 + 2.0d0*rppxx1 + rdxx1
      dxxpxpy0= qcy*dpxxx0 + wqy*dpxxx1 
      dxxpxpz0= qcz*dpxxx0 + wqz*dpxxx1 
      dxxpypx0= qcx*dpxxy0 + wqx*dpxxy1 + 2.0d0*rppxy1       
      dxxpypy0= qcy*dpxxy0 + wqy*dpxxy1                + rdxx1
      dxxpypz0= qcz*dpxxy0 + wqz*dpxxy1                      
      dxxpzpx0= qcx*dpxxz0 + wqx*dpxxz1 + 2.0d0*rppxz1       
      dxxpzpy0= qcy*dpxxz0 + wqy*dpxxz1                      
      dxxpzpz0= qcz*dpxxz0 + wqz*dpxxz1                + rdxx1
      dyypxpx0= qcx*dpyyx0 + wqx*dpyyx1                + rdyy1
      dyypxpy0= qcy*dpyyx0 + wqy*dpyyx1 + 2.0d0*rppyx1       
      dyypxpz0= qcz*dpyyx0 + wqz*dpyyx1                      
      dyypypx0= qcx*dpyyy0 + wqx*dpyyy1                      
      dyypypy0= qcy*dpyyy0 + wqy*dpyyy1 + 2.0d0*rppyy1 + rdyy1
      dyypypz0= qcz*dpyyy0 + wqz*dpyyy1                      
      dyypzpx0= qcx*dpyyz0 + wqx*dpyyz1                      
      dyypzpy0= qcy*dpyyz0 + wqy*dpyyz1 + 2.0d0*rppyz1       
      dyypzpz0= qcz*dpyyz0 + wqz*dpyyz1                + rdyy1
      dzzpxpx0= qcx*dpzzx0 + wqx*dpzzx1                + rdzz1
      dzzpxpy0= qcy*dpzzx0 + wqy*dpzzx1                      
      dzzpxpz0= qcz*dpzzx0 + wqz*dpzzx1 + 2.0d0*rppzx1       
      dzzpypx0= qcx*dpzzy0 + wqx*dpzzy1                      
      dzzpypy0= qcy*dpzzy0 + wqy*dpzzy1                + rdzz1
      dzzpypz0= qcz*dpzzy0 + wqz*dpzzy1 + 2.0d0*rppzy1       
      dzzpzpx0= qcx*dpzzz0 + wqx*dpzzz1                      
      dzzpzpy0= qcy*dpzzz0 + wqy*dpzzz1                      
      dzzpzpz0= qcz*dpzzz0 + wqz*dpzzz1 + 2.0d0*rppzz1 + rdzz1
      dyxpxpx0= qcx*dpyxx0 + wqx*dpyxx1 +       rppyx1 + rdyx1
      dyxpxpy0= qcy*dpyxx0 + wqy*dpyxx1 +       rppxx1       
      dyxpxpz0= qcz*dpyxx0 + wqz*dpyxx1                      
      dyxpypx0= qcx*dpyxy0 + wqx*dpyxy1 +       rppyy1       
      dyxpypy0= qcy*dpyxy0 + wqy*dpyxy1 +       rppxy1 + rdyx1
      dyxpypz0= qcz*dpyxy0 + wqz*dpyxy1      
      dyxpzpx0= qcx*dpyxz0 + wqx*dpyxz1 +       rppyz1       
      dyxpzpy0= qcy*dpyxz0 + wqy*dpyxz1 +       rppxz1       
      dyxpzpz0= qcz*dpyxz0 + wqz*dpyxz1                + rdyx1
      dzxpxpx0= qcx*dpzxx0 + wqx*dpzxx1 +       rppzx1 + rdzx1
      dzxpxpy0= qcy*dpzxx0 + wqy*dpzxx1                      
      dzxpxpz0= qcz*dpzxx0 + wqz*dpzxx1 +       rppxx1       
      dzxpypx0= qcx*dpzxy0 + wqx*dpzxy1 +       rppzy1       
      dzxpypy0= qcy*dpzxy0 + wqy*dpzxy1                + rdzx1
      dzxpypz0= qcz*dpzxy0 + wqz*dpzxy1 +       rppxy1       
      dzxpzpx0= qcx*dpzxz0 + wqx*dpzxz1 +       rppzz1       
      dzxpzpy0= qcy*dpzxz0 + wqy*dpzxz1                      
      dzxpzpz0= qcz*dpzxz0 + wqz*dpzxz1 +       rppxz1 + rdzx1
      dzypxpx0= qcx*dpzyx0 + wqx*dpzyx1                + rdzy1
      dzypxpy0= qcy*dpzyx0 + wqy*dpzyx1 +       rppzx1       
      dzypxpz0= qcz*dpzyx0 + wqz*dpzyx1 +       rppyx1       
      dzypypx0= qcx*dpzyy0 + wqx*dpzyy1                      
      dzypypy0= qcy*dpzyy0 + wqy*dpzyy1 +       rppzy1 + rdzy1
      dzypypz0= qcz*dpzyy0 + wqz*dpzyy1 +       rppyy1       
      dzypzpx0= qcx*dpzyz0 + wqx*dpzyz1                      
      dzypzpy0= qcy*dpzyz0 + wqy*dpzyz1 +       rppzz1       
      dzypzpz0= qcz*dpzyz0 + wqz*dpzyz1 +       rppyz1 + rdzy1

      dxxpxpx1= qcx*dpxxx1 + wqx*dpxxx2 + 2.0d0*rppxx2 + rdxx2
      dxxpxpy1= qcy*dpxxx1 + wqy*dpxxx2                       
      dxxpxpz1= qcz*dpxxx1 + wqz*dpxxx2                       
      dxxpypx1= qcx*dpxxy1 + wqx*dpxxy2 + 2.0d0*rppxy2        
      dxxpypy1= qcy*dpxxy1 + wqy*dpxxy2                + rdxx2
      dxxpypz1= qcz*dpxxy1 + wqz*dpxxy2                       
      dxxpzpx1= qcx*dpxxz1 + wqx*dpxxz2 + 2.0d0*rppxz2        
      dxxpzpy1= qcy*dpxxz1 + wqy*dpxxz2                       
      dxxpzpz1= qcz*dpxxz1 + wqz*dpxxz2                + rdxx2
      dyypxpx1= qcx*dpyyx1 + wqx*dpyyx2                + rdyy2
      dyypxpy1= qcy*dpyyx1 + wqy*dpyyx2 + 2.0d0*rppyx2        
      dyypxpz1= qcz*dpyyx1 + wqz*dpyyx2                       
      dyypypx1= qcx*dpyyy1 + wqx*dpyyy2                       
      dyypypy1= qcy*dpyyy1 + wqy*dpyyy2 + 2.0d0*rppyy2 + rdyy2
      dyypypz1= qcz*dpyyy1 + wqz*dpyyy2                       
      dyypzpx1= qcx*dpyyz1 + wqx*dpyyz2                       
      dyypzpy1= qcy*dpyyz1 + wqy*dpyyz2 + 2.0d0*rppyz2        
      dyypzpz1= qcz*dpyyz1 + wqz*dpyyz2                + rdyy2
      dzzpxpx1= qcx*dpzzx1 + wqx*dpzzx2                + rdzz2
      dzzpxpy1= qcy*dpzzx1 + wqy*dpzzx2                       
      dzzpxpz1= qcz*dpzzx1 + wqz*dpzzx2 + 2.0d0*rppzx2        
      dzzpypx1= qcx*dpzzy1 + wqx*dpzzy2                       
      dzzpypy1= qcy*dpzzy1 + wqy*dpzzy2                + rdzz2
      dzzpypz1= qcz*dpzzy1 + wqz*dpzzy2 + 2.0d0*rppzy2        
      dzzpzpx1= qcx*dpzzz1 + wqx*dpzzz2                       
      dzzpzpy1= qcy*dpzzz1 + wqy*dpzzz2                       
      dzzpzpz1= qcz*dpzzz1 + wqz*dpzzz2 + 2.0d0*rppzz2 + rdzz2
      dyxpxpx1= qcx*dpyxx1 + wqx*dpyxx2 +       rppyx2 + rdyx2
      dyxpxpy1= qcy*dpyxx1 + wqy*dpyxx2 +       rppxx2        
      dyxpxpz1= qcz*dpyxx1 + wqz*dpyxx2                       
      dyxpypx1= qcx*dpyxy1 + wqx*dpyxy2 +       rppyy2        
      dyxpypy1= qcy*dpyxy1 + wqy*dpyxy2 +       rppxy2 + rdyx2
      dyxpypz1= qcz*dpyxy1 + wqz*dpyxy2                       
      dyxpzpx1= qcx*dpyxz1 + wqx*dpyxz2 +       rppyz2        
      dyxpzpy1= qcy*dpyxz1 + wqy*dpyxz2 +       rppxz2        
      dyxpzpz1= qcz*dpyxz1 + wqz*dpyxz2                + rdyx2
      dzxpxpx1= qcx*dpzxx1 + wqx*dpzxx2 +       rppzx2 + rdzx2
      dzxpxpy1= qcy*dpzxx1 + wqy*dpzxx2                       
      dzxpxpz1= qcz*dpzxx1 + wqz*dpzxx2 +       rppxx2        
      dzxpypx1= qcx*dpzxy1 + wqx*dpzxy2 +       rppzy2        
      dzxpypy1= qcy*dpzxy1 + wqy*dpzxy2                + rdzx2
      dzxpypz1= qcz*dpzxy1 + wqz*dpzxy2 +       rppxy2        
      dzxpzpx1= qcx*dpzxz1 + wqx*dpzxz2 +       rppzz2        
      dzxpzpy1= qcy*dpzxz1 + wqy*dpzxz2                       
      dzxpzpz1= qcz*dpzxz1 + wqz*dpzxz2 +       rppxz2 + rdzx2
      dzypxpx1= qcx*dpzyx1 + wqx*dpzyx2                + rdzy2
      dzypxpy1= qcy*dpzyx1 + wqy*dpzyx2 +       rppzx2        
      dzypxpz1= qcz*dpzyx1 + wqz*dpzyx2 +       rppyx2        
      dzypypx1= qcx*dpzyy1 + wqx*dpzyy2                       
      dzypypy1= qcy*dpzyy1 + wqy*dpzyy2 +       rppzy2 + rdzy2
      dzypypz1= qcz*dpzyy1 + wqz*dpzyy2 +       rppyy2        
      dzypzpx1= qcx*dpzyz1 + wqx*dpzyz2                       
      dzypzpy1= qcy*dpzyz1 + wqy*dpzyz2 +       rppzz2        
      dzypzpz1= qcz*dpzyz1 + wqz*dpzyz2 +       rppyz2 + rdzy2

      dxxpxpx2= qcx*dpxxx2 + wqx*dpxxx3 + 2.0d0*rppxx3 + rdxx3
      dxxpxpy2= qcy*dpxxx2 + wqy*dpxxx3                       
      dxxpxpz2= qcz*dpxxx2 + wqz*dpxxx3                       
      dxxpypx2= qcx*dpxxy2 + wqx*dpxxy3 + 2.0d0*rppxy3        
      dxxpypy2= qcy*dpxxy2 + wqy*dpxxy3                + rdxx3
      dxxpypz2= qcz*dpxxy2 + wqz*dpxxy3                       
      dxxpzpx2= qcx*dpxxz2 + wqx*dpxxz3 + 2.0d0*rppxz3        
      dxxpzpy2= qcy*dpxxz2 + wqy*dpxxz3                       
      dxxpzpz2= qcz*dpxxz2 + wqz*dpxxz3                + rdxx3
      dyypxpx2= qcx*dpyyx2 + wqx*dpyyx3                + rdyy3
      dyypxpy2= qcy*dpyyx2 + wqy*dpyyx3 + 2.0d0*rppyx3        
      dyypxpz2= qcz*dpyyx2 + wqz*dpyyx3                       
      dyypypx2= qcx*dpyyy2 + wqx*dpyyy3                       
      dyypypy2= qcy*dpyyy2 + wqy*dpyyy3 + 2.0d0*rppyy3 + rdyy3
      dyypypz2= qcz*dpyyy2 + wqz*dpyyy3                       
      dyypzpx2= qcx*dpyyz2 + wqx*dpyyz3                       
      dyypzpy2= qcy*dpyyz2 + wqy*dpyyz3 + 2.0d0*rppyz3        
      dyypzpz2= qcz*dpyyz2 + wqz*dpyyz3                + rdyy3
      dzzpxpx2= qcx*dpzzx2 + wqx*dpzzx3                + rdzz3
      dzzpxpy2= qcy*dpzzx2 + wqy*dpzzx3                       
      dzzpxpz2= qcz*dpzzx2 + wqz*dpzzx3 + 2.0d0*rppzx3        
      dzzpypx2= qcx*dpzzy2 + wqx*dpzzy3                       
      dzzpypy2= qcy*dpzzy2 + wqy*dpzzy3                + rdzz3
      dzzpypz2= qcz*dpzzy2 + wqz*dpzzy3 + 2.0d0*rppzy3        
      dzzpzpx2= qcx*dpzzz2 + wqx*dpzzz3                       
      dzzpzpy2= qcy*dpzzz2 + wqy*dpzzz3                       
      dzzpzpz2= qcz*dpzzz2 + wqz*dpzzz3 + 2.0d0*rppzz3 + rdzz3
      dyxpxpx2= qcx*dpyxx2 + wqx*dpyxx3 +       rppyx3 + rdyx3
      dyxpxpy2= qcy*dpyxx2 + wqy*dpyxx3 +       rppxx3        
      dyxpxpz2= qcz*dpyxx2 + wqz*dpyxx3                       
      dyxpypx2= qcx*dpyxy2 + wqx*dpyxy3 +       rppyy3        
      dyxpypy2= qcy*dpyxy2 + wqy*dpyxy3 +       rppxy3 + rdyx3
      dyxpypz2= qcz*dpyxy2 + wqz*dpyxy3                       
      dyxpzpx2= qcx*dpyxz2 + wqx*dpyxz3 +       rppyz3        
      dyxpzpy2= qcy*dpyxz2 + wqy*dpyxz3 +       rppxz3        
      dyxpzpz2= qcz*dpyxz2 + wqz*dpyxz3                + rdyx3
      dzxpxpx2= qcx*dpzxx2 + wqx*dpzxx3 +       rppzx3 + rdzx3
      dzxpxpy2= qcy*dpzxx2 + wqy*dpzxx3                       
      dzxpxpz2= qcz*dpzxx2 + wqz*dpzxx3 +       rppxx3        
      dzxpypx2= qcx*dpzxy2 + wqx*dpzxy3 +       rppzy3        
      dzxpypy2= qcy*dpzxy2 + wqy*dpzxy3                + rdzx3
      dzxpypz2= qcz*dpzxy2 + wqz*dpzxy3 +       rppxy3        
      dzxpzpx2= qcx*dpzxz2 + wqx*dpzxz3 +       rppzz3 
      dzxpzpy2= qcy*dpzxz2 + wqy*dpzxz3                       
      dzxpzpz2= qcz*dpzxz2 + wqz*dpzxz3 +       rppxz3 + rdzx3
      dzypxpx2= qcx*dpzyx2 + wqx*dpzyx3                + rdzy3
      dzypxpy2= qcy*dpzyx2 + wqy*dpzyx3 +       rppzx3        
      dzypxpz2= qcz*dpzyx2 + wqz*dpzyx3 +       rppyx3        
      dzypypx2= qcx*dpzyy2 + wqx*dpzyy3                       
      dzypypy2= qcy*dpzyy2 + wqy*dpzyy3 +       rppzy3 + rdzy3
      dzypypz2= qcz*dpzyy2 + wqz*dpzyy3 +       rppyy3        
      dzypzpx2= qcx*dpzyz2 + wqx*dpzyz3                       
      dzypzpy2= qcy*dpzyz2 + wqy*dpzyz3 +       rppzz3        
      dzypzpz2= qcz*dpzyz2 + wqz*dpzyz3 +       rppyz3 + rdzy3

      rpppxxx1 = rkp*pppxxx1
      rpppxxy1 = rkp*pppxxy1
      rpppxxz1 = rkp*pppxxz1
      rpppxyx1 = rkp*pppxyx1
      rpppxyy1 = rkp*pppxyy1
      rpppxyz1 = rkp*pppxyz1
      rpppxzx1 = rkp*pppxzx1
      rpppxzy1 = rkp*pppxzy1
      rpppxzz1 = rkp*pppxzz1
      rpppyxx1 = rkp*pppyxx1
      rpppyxy1 = rkp*pppyxy1
      rpppyxz1 = rkp*pppyxz1
      rpppyyx1 = rkp*pppyyx1
      rpppyyy1 = rkp*pppyyy1
      rpppyyz1 = rkp*pppyyz1
      rpppyzx1 = rkp*pppyzx1
      rpppyzy1 = rkp*pppyzy1
      rpppyzz1 = rkp*pppyzz1
      rpppzxx1 = rkp*pppzxx1
      rpppzxy1 = rkp*pppzxy1
      rpppzxz1 = rkp*pppzxz1
      rpppzyx1 = rkp*pppzyx1
      rpppzyy1 = rkp*pppzyy1
      rpppzyz1 = rkp*pppzyz1
      rpppzzx1 = rkp*pppzzx1
      rpppzzy1 = rkp*pppzzy1
      rpppzzz1 = rkp*pppzzz1

      rpppxxx2 = rkp*pppxxx2
      rpppxxy2 = rkp*pppxxy2
      rpppxxz2 = rkp*pppxxz2
      rpppxyx2 = rkp*pppxyx2
      rpppxyy2 = rkp*pppxyy2
      rpppxyz2 = rkp*pppxyz2
      rpppxzx2 = rkp*pppxzx2
      rpppxzy2 = rkp*pppxzy2
      rpppxzz2 = rkp*pppxzz2
      rpppyxx2 = rkp*pppyxx2
      rpppyxy2 = rkp*pppyxy2
      rpppyxz2 = rkp*pppyxz2
      rpppyyx2 = rkp*pppyyx2
      rpppyyy2 = rkp*pppyyy2
      rpppyyz2 = rkp*pppyyz2
      rpppyzx2 = rkp*pppyzx2
      rpppyzy2 = rkp*pppyzy2
      rpppyzz2 = rkp*pppyzz2
      rpppzxx2 = rkp*pppzxx2
      rpppzxy2 = rkp*pppzxy2
      rpppzxz2 = rkp*pppzxz2
      rpppzyx2 = rkp*pppzyx2
      rpppzyy2 = rkp*pppzyy2
      rpppzyz2 = rkp*pppzyz2
      rpppzzx2 = rkp*pppzzx2
      rpppzzy2 = rkp*pppzzy2
      rpppzzz2 = rkp*pppzzz2
 
      rdxxpx1 =  rkp*dxxpx1
      rdxxpy1 =  rkp*dxxpy1
      rdxxpz1 =  rkp*dxxpz1
      rdyypx1 =  rkp*dyypx1
      rdyypy1 =  rkp*dyypy1
      rdyypz1 =  rkp*dyypz1
      rdzzpx1 =  rkp*dzzpx1
      rdzzpy1 =  rkp*dzzpy1
      rdzzpz1 =  rkp*dzzpz1
      rdyxpx1 =  rkp*dyxpx1
      rdyxpy1 =  rkp*dyxpy1
      rdyxpz1 =  rkp*dyxpz1
      rdzxpx1 =  rkp*dzxpx1
      rdzxpy1 =  rkp*dzxpy1
      rdzxpz1 =  rkp*dzxpz1
      rdzypx1 =  rkp*dzypx1
      rdzypy1 =  rkp*dzypy1
      rdzypz1 =  rkp*dzypz1
                        
      rdxxpx2 =  rkp*dxxpx2
      rdxxpy2 =  rkp*dxxpy2
      rdxxpz2 =  rkp*dxxpz2
      rdyypx2 =  rkp*dyypx2
      rdyypy2 =  rkp*dyypy2
      rdyypz2 =  rkp*dyypz2
      rdzzpx2 =  rkp*dzzpx2
      rdzzpy2 =  rkp*dzzpy2
      rdzzpz2 =  rkp*dzzpz2
      rdyxpx2 =  rkp*dyxpx2
      rdyxpy2 =  rkp*dyxpy2
      rdyxpz2 =  rkp*dyxpz2
      rdzxpx2 =  rkp*dzxpx2
      rdzxpy2 =  rkp*dzxpy2
      rdzxpz2 =  rkp*dzxpz2
      rdzypx2 =  rkp*dzypx2
      rdzypy2 =  rkp*dzypy2
      rdzypz2 =  rkp*dzypz2

      dpxxx01=  eta*(dpxxx0 -rooe*dpxxx1)
      dpxxy01=  eta*(dpxxy0 -rooe*dpxxy1)
      dpxxz01=  eta*(dpxxz0 -rooe*dpxxz1)
      dpyyx01=  eta*(dpyyx0 -rooe*dpyyx1)
      dpyyy01=  eta*(dpyyy0 -rooe*dpyyy1)
      dpyyz01=  eta*(dpyyz0 -rooe*dpyyz1)
      dpzzx01=  eta*(dpzzx0 -rooe*dpzzx1)
      dpzzy01=  eta*(dpzzy0 -rooe*dpzzy1)
      dpzzz01=  eta*(dpzzz0 -rooe*dpzzz1)
      dpyxx01=  eta*(dpyxx0 -rooe*dpyxx1)
      dpyxy01=  eta*(dpyxy0 -rooe*dpyxy1)
      dpyxz01=  eta*(dpyxz0 -rooe*dpyxz1)
      dpzxx01=  eta*(dpzxx0 -rooe*dpzxx1)
      dpzxy01=  eta*(dpzxy0 -rooe*dpzxy1)
      dpzxz01=  eta*(dpzxz0 -rooe*dpzxz1)
      dpzyx01=  eta*(dpzyx0 -rooe*dpzyx1)
      dpzyy01=  eta*(dpzyy0 -rooe*dpzyy1)
      dpzyz01=  eta*(dpzyz0 -rooe*dpzyz1)

      dpxxx12=  eta*(dpxxx1 -rooe*dpxxx2)
      dpxxy12=  eta*(dpxxy1 -rooe*dpxxy2)
      dpxxz12=  eta*(dpxxz1 -rooe*dpxxz2)
      dpyyx12=  eta*(dpyyx1 -rooe*dpyyx2)
      dpyyy12=  eta*(dpyyy1 -rooe*dpyyy2)
      dpyyz12=  eta*(dpyyz1 -rooe*dpyyz2)
      dpzzx12=  eta*(dpzzx1 -rooe*dpzzx2)
      dpzzy12=  eta*(dpzzy1 -rooe*dpzzy2)
      dpzzz12=  eta*(dpzzz1 -rooe*dpzzz2)
      dpyxx12=  eta*(dpyxx1 -rooe*dpyxx2)
      dpyxy12=  eta*(dpyxy1 -rooe*dpyxy2)
      dpyxz12=  eta*(dpyxz1 -rooe*dpyxz2)
      dpzxx12=  eta*(dpzxx1 -rooe*dpzxx2)
      dpzxy12=  eta*(dpzxy1 -rooe*dpzxy2)
      dpzxz12=  eta*(dpzxz1 -rooe*dpzxz2)
      dpzyx12=  eta*(dpzyx1 -rooe*dpzyx2)
      dpzyy12=  eta*(dpzyy1 -rooe*dpzyy2)
      dpzyz12=  eta*(dpzyz1 -rooe*dpzyz2)
  
!dpds 
 
      axa0= qcx*dxxpxpx0+wqx*dxxpxpx1+2.d0*rpppxxx1+rdxxpx1+dpxxx01
      axb0= qcy*dxxpxpy0+wqy*dxxpxpy1                      +dpxxx01
      axc0= qcz*dxxpxpz0+wqz*dxxpxpz1                      +dpxxx01
      axd0= qcy*dxxpxpx0+wqy*dxxpxpx1
      axe0= qcz*dxxpxpx0+wqz*dxxpxpx1
      axf0= qcy*dxxpxpz0+wqy*dxxpxpz1
      aya0= qcx*dxxpypx0+wqx*dxxpypx1+2.d0*rpppxyx1        +dpxxy01
      ayb0= qcy*dxxpypy0+wqy*dxxpypy1              +rdxxpy1+dpxxy01
      ayc0= qcz*dxxpypz0+wqz*dxxpypz1                      +dpxxy01
      ayd0= qcy*dxxpypx0+wqy*dxxpypx1              +rdxxpx1
      aye0= qcz*dxxpypx0+wqz*dxxpypx1
      ayf0= qcz*dxxpypy0+wqz*dxxpypy1
      aza0= qcx*dxxpzpx0+wqx*dxxpzpx1+2.d0*rpppxzx1        +dpxxz01
      azb0= qcy*dxxpzpy0+wqy*dxxpzpy1                      +dpxxz01
      azc0= qcz*dxxpzpz0+wqz*dxxpzpz1              +rdxxpz1+dpxxz01
      azd0= qcy*dxxpzpx0+wqy*dxxpzpx1                      
      aze0= qcz*dxxpzpx0+wqz*dxxpzpx1              +rdxxpx1
      azf0= qcy*dxxpzpz0+wqy*dxxpzpz1      
      bxa0= qcx*dyypxpx0+wqx*dyypxpx1              +rdyypx1+dpyyx01
      bxb0= qcy*dyypxpy0+wqy*dyypxpy1+2.d0*rpppyxy1        +dpyyx01
      bxc0= qcz*dyypxpz0+wqz*dyypxpz1                      +dpyyx01
      bxd0= qcx*dyypxpy0+wqx*dyypxpy1              +rdyypy1
      bxe0= qcx*dyypxpz0+wqx*dyypxpz1              +rdyypz1
      bxf0= qcz*dyypxpy0+wqz*dyypxpy1                      
      bya0= qcx*dyypypx0+wqx*dyypypx1                      +dpyyy01
      byb0= qcy*dyypypy0+wqy*dyypypy1+2.d0*rpppyyy1+rdyypy1+dpyyy01
      byc0= qcz*dyypypz0+wqz*dyypypz1                      +dpyyy01
      byd0= qcx*dyypypy0+wqx*dyypypy1
      bye0= qcx*dyypypz0+wqx*dyypypz1
      byf0= qcz*dyypypy0+wqz*dyypypy1
      bza0= qcx*dyypzpx0+wqx*dyypzpx1                      +dpyyz01
      bzb0= qcy*dyypzpy0+wqy*dyypzpy1+2.d0*rpppyzy1        +dpyyz01
      bzc0= qcz*dyypzpz0+wqz*dyypzpz1              +rdyypz1+dpyyz01
      bzd0= qcx*dyypzpy0+wqx*dyypzpy1
      bze0= qcx*dyypzpz0+wqx*dyypzpz1
      bzf0= qcz*dyypzpy0+wqz*dyypzpy1              +rdyypy1
      cxa0= qcx*dzzpxpx0+wqx*dzzpxpx1              +rdzzpx1+dpzzx01
      cxb0= qcy*dzzpxpy0+wqy*dzzpxpy1                      +dpzzx01
      cxc0= qcz*dzzpxpz0+wqz*dzzpxpz1+2.d0*rpppzxz1        +dpzzx01
      cxd0= qcy*dzzpxpx0+wqy*dzzpxpx1                            
      cxe0= qcx*dzzpxpz0+wqx*dzzpxpz1              +rdzzpz1      
      cxf0= qcy*dzzpxpz0+wqy*dzzpxpz1                            
      cya0= qcx*dzzpypx0+wqx*dzzpypx1                      +dpzzy01
      cyb0= qcy*dzzpypy0+wqy*dzzpypy1              +rdzzpy1+dpzzy01
      cyc0= qcz*dzzpypz0+wqz*dzzpypz1+2.d0*rpppzyz1        +dpzzy01
      cyd0= qcx*dzzpypy0+wqx*dzzpypy1                            
      cye0= qcx*dzzpypz0+wqx*dzzpypz1                            
      cyf0= qcy*dzzpypz0+wqy*dzzpypz1              +rdzzpz1      
      cza0= qcx*dzzpzpx0+wqx*dzzpzpx1                      +dpzzz01
      czb0= qcy*dzzpzpy0+wqy*dzzpzpy1                      +dpzzz01
      czc0= qcz*dzzpzpz0+wqz*dzzpzpz1+2.d0*rpppzzz1+rdzzpz1+dpzzz01
      czd0= qcx*dzzpzpy0+wqx*dzzpzpy1                      
      cze0= qcx*dzzpzpz0+wqx*dzzpzpz1                      
      czf0= qcy*dzzpzpz0+wqy*dzzpzpz1                      
      dxa0= qcx*dyxpxpx0+wqx*dyxpxpx1+1.d0*rpppyxx1+rdyxpx1+dpyxx01
      dxb0= qcy*dyxpxpy0+wqy*dyxpxpy1+1.d0*rpppxxy1        +dpyxx01
      dxc0= qcz*dyxpxpz0+wqz*dyxpxpz1                      +dpyxx01
      dxd0= qcx*dyxpxpy0+wqx*dyxpxpy1+1.d0*rpppyxy1+rdyxpy1
      dxe0= qcx*dyxpxpz0+wqx*dyxpxpz1+1.d0*rpppyxz1+rdyxpz1
      dxf0= qcz*dyxpxpy0+wqz*dyxpxpy1                      
      dya0= qcx*dyxpypx0+wqx*dyxpypx1+1.d0*rpppyyx1        +dpyxy01
      dyb0= qcy*dyxpypy0+wqy*dyxpypy1+1.d0*rpppxyy1+rdyxpy1+dpyxy01
      dyc0= qcz*dyxpypz0+wqz*dyxpypz1                      +dpyxy01
      dyd0= qcx*dyxpypy0+wqx*dyxpypy1+1.d0*rpppyyy1
      dye0= qcz*dyxpypx0+wqz*dyxpypx1              
      dyf0= qcz*dyxpypy0+wqz*dyxpypy1              
      dza0= qcx*dyxpzpx0+wqx*dyxpzpx1+1.d0*rpppyzx1        +dpyxz01
      dzb0= qcy*dyxpzpy0+wqy*dyxpzpy1+1.d0*rpppxzy1        +dpyxz01
      dzc0= qcz*dyxpzpz0+wqz*dyxpzpz1              +rdyxpz1+dpyxz01
      dzd0= qcx*dyxpzpy0+wqx*dyxpzpy1+1.d0*rpppyzy1        
      dze0= qcx*dyxpzpz0+wqx*dyxpzpz1+1.d0*rpppyzz1        
      dzf0= qcy*dyxpzpz0+wqy*dyxpzpz1+1.d0*rpppxzz1        
      exa0= qcx*dzxpxpx0+wqx*dzxpxpx1+1.d0*rpppzxx1+rdzxpx1+dpzxx01
      exb0= qcy*dzxpxpy0+wqy*dzxpxpy1                      +dpzxx01
      exc0= qcz*dzxpxpz0+wqz*dzxpxpz1+1.d0*rpppxxz1        +dpzxx01
      exd0= qcy*dzxpxpx0+wqy*dzxpxpx1              
      exe0= qcz*dzxpxpx0+wqz*dzxpxpx1+1.d0*rpppxxx1
      exf0= qcy*dzxpxpz0+wqy*dzxpxpz1              
      eya0= qcx*dzxpypx0+wqx*dzxpypx1+1.d0*rpppzyx1        +dpzxy01
      eyb0= qcy*dzxpypy0+wqy*dzxpypy1              +rdzxpy1+dpzxy01
      eyc0= qcz*dzxpypz0+wqz*dzxpypz1+1.d0*rpppxyz1        +dpzxy01
      eyd0= qcx*dzxpypy0+wqx*dzxpypy1+1.d0*rpppzyy1        
      eye0= qcz*dzxpypx0+wqz*dzxpypx1+1.d0*rpppxyx1        
      eyf0= qcz*dzxpypy0+wqz*dzxpypy1+1.d0*rpppxyy1        
      eza0= qcx*dzxpzpx0+wqx*dzxpzpx1+1.d0*rpppzzx1        +dpzxz01
      ezb0= qcy*dzxpzpy0+wqy*dzxpzpy1                      +dpzxz01
      ezc0= qcz*dzxpzpz0+wqz*dzxpzpz1+1.d0*rpppxzz1+rdzxpz1+dpzxz01
      ezd0= qcy*dzxpzpx0+wqy*dzxpzpx1                      
      eze0= qcx*dzxpzpz0+wqx*dzxpzpz1+1.d0*rpppzzz1        
      ezf0= qcy*dzxpzpz0+wqy*dzxpzpz1                      
      fxa0= qcx*dzypxpx0+wqx*dzypxpx1              +rdzypx1+dpzyx01
      fxb0= qcy*dzypxpy0+wqy*dzypxpy1+1.d0*rpppzxy1        +dpzyx01
      fxc0= qcz*dzypxpz0+wqz*dzypxpz1+1.d0*rpppyxz1        +dpzyx01
      fxd0= qcy*dzypxpx0+wqy*dzypxpx1+1.d0*rpppzxx1        
      fxe0= qcz*dzypxpx0+wqz*dzypxpx1+1.d0*rpppyxx1        
      fxf0= qcz*dzypxpy0+wqz*dzypxpy1+1.d0*rpppyxy1        
      fya0= qcx*dzypypx0+wqx*dzypypx1                      +dpzyy01
      fyb0= qcy*dzypypy0+wqy*dzypypy1+1.d0*rpppzyy1+rdzypy1+dpzyy01
      fyc0= qcz*dzypypz0+wqz*dzypypz1+1.d0*rpppyyz1        +dpzyy01
      fyd0= qcx*dzypypy0+wqx*dzypypy1                      
      fye0= qcx*dzypypz0+wqx*dzypypz1                      
      fyf0= qcz*dzypypy0+wqz*dzypypy1+1.d0*rpppyyy1        
      fza0= qcx*dzypzpx0+wqx*dzypzpx1                      +dpzyz01
      fzb0= qcy*dzypzpy0+wqy*dzypzpy1+1.d0*rpppzzy1        +dpzyz01
      fzc0= qcz*dzypzpz0+wqz*dzypzpz1+1.d0*rpppyzz1+rdzypz1+dpzyz01
      fzd0= qcx*dzypzpy0+wqx*dzypzpy1                      
      fze0= qcx*dzypzpz0+wqx*dzypzpz1                      
      fzf0= qcy*dzypzpz0+wqy*dzypzpz1+1.d0*rpppzzz1    
    
      axa1= qcx*dxxpxpx1+wqx*dxxpxpx2+2.d0*rpppxxx2+rdxxpx2+dpxxx12
      axb1= qcy*dxxpxpy1+wqy*dxxpxpy2                      +dpxxx12
      axc1= qcz*dxxpxpz1+wqz*dxxpxpz2                      +dpxxx12
      axd1= qcy*dxxpxpx1+wqy*dxxpxpx2                              
      axe1= qcz*dxxpxpx1+wqz*dxxpxpx2                              
      axf1= qcy*dxxpxpz1+wqy*dxxpxpz2                              
      aya1= qcx*dxxpypx1+wqx*dxxpypx2+2.d0*rpppxyx2        +dpxxy12
      ayb1= qcy*dxxpypy1+wqy*dxxpypy2              +rdxxpy2+dpxxy12
      ayc1= qcz*dxxpypz1+wqz*dxxpypz2                      +dpxxy12
      ayd1= qcy*dxxpypx1+wqy*dxxpypx2              +rdxxpx2        
      aye1= qcz*dxxpypx1+wqz*dxxpypx2                              
      ayf1= qcz*dxxpypy1+wqz*dxxpypy2                              
      aza1= qcx*dxxpzpx1+wqx*dxxpzpx2+2.d0*rpppxzx2        +dpxxz12
      azb1= qcy*dxxpzpy1+wqy*dxxpzpy2                      +dpxxz12
      azc1= qcz*dxxpzpz1+wqz*dxxpzpz2              +rdxxpz2+dpxxz12
      azd1= qcy*dxxpzpx1+wqy*dxxpzpx2                              
      aze1= qcz*dxxpzpx1+wqz*dxxpzpx2              +rdxxpx2        
      azf1= qcy*dxxpzpz1+wqy*dxxpzpz2
      bxa1= qcx*dyypxpx1+wqx*dyypxpx2              +rdyypx2+dpyyx12
      bxb1= qcy*dyypxpy1+wqy*dyypxpy2+2.d0*rpppyxy2        +dpyyx12
      bxc1= qcz*dyypxpz1+wqz*dyypxpz2                      +dpyyx12
      bxd1= qcx*dyypxpy1+wqx*dyypxpy2              +rdyypy2        
      bxe1= qcx*dyypxpz1+wqx*dyypxpz2              +rdyypz2        
      bxf1= qcz*dyypxpy1+wqz*dyypxpy2                              
      bya1= qcx*dyypypx1+wqx*dyypypx2                      +dpyyy12
      byb1= qcy*dyypypy1+wqy*dyypypy2+2.d0*rpppyyy2+rdyypy2+dpyyy12
      byc1= qcz*dyypypz1+wqz*dyypypz2                      +dpyyy12
      byd1= qcx*dyypypy1+wqx*dyypypy2                              
      bye1= qcx*dyypypz1+wqx*dyypypz2                              
      byf1= qcz*dyypypy1+wqz*dyypypy2                              
      bza1= qcx*dyypzpx1+wqx*dyypzpx2                      +dpyyz12
      bzb1= qcy*dyypzpy1+wqy*dyypzpy2+2.d0*rpppyzy2        +dpyyz12
      bzc1= qcz*dyypzpz1+wqz*dyypzpz2              +rdyypz2+dpyyz12
      bzd1= qcx*dyypzpy1+wqx*dyypzpy2                              
      bze1= qcx*dyypzpz1+wqx*dyypzpz2                              
      bzf1= qcz*dyypzpy1+wqz*dyypzpy2              +rdyypy2        
      cxa1= qcx*dzzpxpx1+wqx*dzzpxpx2              +rdzzpx2+dpzzx12
      cxb1= qcy*dzzpxpy1+wqy*dzzpxpy2                      +dpzzx12
      cxc1= qcz*dzzpxpz1+wqz*dzzpxpz2+2.d0*rpppzxz2        +dpzzx12
      cxd1= qcy*dzzpxpx1+wqy*dzzpxpx2                              
      cxe1= qcx*dzzpxpz1+wqx*dzzpxpz2              +rdzzpz2        
      cxf1= qcy*dzzpxpz1+wqy*dzzpxpz2                              
      cya1= qcx*dzzpypx1+wqx*dzzpypx2                      +dpzzy12
      cyb1= qcy*dzzpypy1+wqy*dzzpypy2              +rdzzpy2+dpzzy12
      cyc1= qcz*dzzpypz1+wqz*dzzpypz2+2.d0*rpppzyz2        +dpzzy12
      cyd1= qcx*dzzpypy1+wqx*dzzpypy2                              
      cye1= qcx*dzzpypz1+wqx*dzzpypz2                              
      cyf1= qcy*dzzpypz1+wqy*dzzpypz2              +rdzzpz2        
      cza1= qcx*dzzpzpx1+wqx*dzzpzpx2                      +dpzzz12
      czb1= qcy*dzzpzpy1+wqy*dzzpzpy2                      +dpzzz12
      czc1= qcz*dzzpzpz1+wqz*dzzpzpz2+2.d0*rpppzzz2+rdzzpz2+dpzzz12
      czd1= qcx*dzzpzpy1+wqx*dzzpzpy2                              
      cze1= qcx*dzzpzpz1+wqx*dzzpzpz2                              
      czf1= qcy*dzzpzpz1+wqy*dzzpzpz2                              
      dxa1= qcx*dyxpxpx1+wqx*dyxpxpx2+1.d0*rpppyxx2+rdyxpx2+dpyxx12
      dxb1= qcy*dyxpxpy1+wqy*dyxpxpy2+1.d0*rpppxxy2        +dpyxx12
      dxc1= qcz*dyxpxpz1+wqz*dyxpxpz2                      +dpyxx12
      dxd1= qcx*dyxpxpy1+wqx*dyxpxpy2+1.d0*rpppyxy2+rdyxpy2        
      dxe1= qcx*dyxpxpz1+wqx*dyxpxpz2+1.d0*rpppyxz2+rdyxpz2        
      dxf1= qcz*dyxpxpy1+wqz*dyxpxpy2                              
      dya1= qcx*dyxpypx1+wqx*dyxpypx2+1.d0*rpppyyx2        +dpyxy12
      dyb1= qcy*dyxpypy1+wqy*dyxpypy2+1.d0*rpppxyy2+rdyxpy2+dpyxy12
      dyc1= qcz*dyxpypz1+wqz*dyxpypz2                      +dpyxy12
      dyd1= qcx*dyxpypy1+wqx*dyxpypy2+1.d0*rpppyyy2                
      dye1= qcz*dyxpypx1+wqz*dyxpypx2                              
      dyf1= qcz*dyxpypy1+wqz*dyxpypy2                              
      dza1= qcx*dyxpzpx1+wqx*dyxpzpx2+1.d0*rpppyzx2        +dpyxz12
      dzb1= qcy*dyxpzpy1+wqy*dyxpzpy2+1.d0*rpppxzy2        +dpyxz12
      dzc1= qcz*dyxpzpz1+wqz*dyxpzpz2              +rdyxpz2+dpyxz12
      dzd1= qcx*dyxpzpy1+wqx*dyxpzpy2+1.d0*rpppyzy2               
      dze1= qcx*dyxpzpz1+wqx*dyxpzpz2+1.d0*rpppyzz2                
      dzf1= qcy*dyxpzpz1+wqy*dyxpzpz2+1.d0*rpppxzz2                
      exa1= qcx*dzxpxpx1+wqx*dzxpxpx2+1.d0*rpppzxx2+rdzxpx2+dpzxx12
      exb1= qcy*dzxpxpy1+wqy*dzxpxpy2                      +dpzxx12
      exc1= qcz*dzxpxpz1+wqz*dzxpxpz2+1.d0*rpppxxz2        +dpzxx12
      exd1= qcy*dzxpxpx1+wqy*dzxpxpx2                              
      exe1= qcz*dzxpxpx1+wqz*dzxpxpx2+1.d0*rpppxxx2                
      exf1= qcy*dzxpxpz1+wqy*dzxpxpz2                              
      eya1= qcx*dzxpypx1+wqx*dzxpypx2+1.d0*rpppzyx2        +dpzxy12
      eyb1= qcy*dzxpypy1+wqy*dzxpypy2              +rdzxpy2+dpzxy12
      eyc1= qcz*dzxpypz1+wqz*dzxpypz2+1.d0*rpppxyz2        +dpzxy12
      eyd1= qcx*dzxpypy1+wqx*dzxpypy2+1.d0*rpppzyy2                
      eye1= qcz*dzxpypx1+wqz*dzxpypx2+1.d0*rpppxyx2                
      eyf1= qcz*dzxpypy1+wqz*dzxpypy2+1.d0*rpppxyy2                
      eza1= qcx*dzxpzpx1+wqx*dzxpzpx2+1.d0*rpppzzx2        +dpzxz12
      ezb1= qcy*dzxpzpy1+wqy*dzxpzpy2                      +dpzxz12
      ezc1= qcz*dzxpzpz1+wqz*dzxpzpz2+1.d0*rpppxzz2+rdzxpz2+dpzxz12
      ezd1= qcy*dzxpzpx1+wqy*dzxpzpx2
      eze1= qcx*dzxpzpz1+wqx*dzxpzpz2+1.d0*rpppzzz2                
      ezf1= qcy*dzxpzpz1+wqy*dzxpzpz2                              
      fxa1= qcx*dzypxpx1+wqx*dzypxpx2              +rdzypx2+dpzyx12
      fxb1= qcy*dzypxpy1+wqy*dzypxpy2+1.d0*rpppzxy2        +dpzyx12
      fxc1= qcz*dzypxpz1+wqz*dzypxpz2+1.d0*rpppyxz2        +dpzyx12
      fxd1= qcy*dzypxpx1+wqy*dzypxpx2+1.d0*rpppzxx2                
      fxe1= qcz*dzypxpx1+wqz*dzypxpx2+1.d0*rpppyxx2                
      fxf1= qcz*dzypxpy1+wqz*dzypxpy2+1.d0*rpppyxy2                
      fya1= qcx*dzypypx1+wqx*dzypypx2                      +dpzyy12
      fyb1= qcy*dzypypy1+wqy*dzypypy2+1.d0*rpppzyy2+rdzypy2+dpzyy12
      fyc1= qcz*dzypypz1+wqz*dzypypz2+1.d0*rpppyyz2        +dpzyy12
      fyd1= qcx*dzypypy1+wqx*dzypypy2                              
      fye1= qcx*dzypypz1+wqx*dzypypz2                              
      fyf1= qcz*dzypypy1+wqz*dzypypy2+1.d0*rpppyyy2                
      fza1= qcx*dzypzpx1+wqx*dzypzpx2                      +dpzyz12
      fzb1= qcy*dzypzpy1+wqy*dzypzpy2+1.d0*rpppzzy2        +dpzyz12
      fzc1= qcz*dzypzpz1+wqz*dzypzpz2+1.d0*rpppyzz2+rdzypz2+dpzyz12
      fzd1= qcx*dzypzpy1+wqx*dzypzpy2                      
      fze1= qcx*dzypzpz1+wqx*dzypzpz2                      
      fzf1= qcy*dzypzpz1+wqy*dzypzpz2+1.d0*rpppzzz2        
  

!RANK=6
      pxpxdxx1 = rkp * xxdxx1
      pxpxdyy1 = rkp * xxdyy1
      pxpxdzz1 = rkp * xxdzz1
      pxpxdyx1 = rkp * xxdyx1
      pxpxdzx1 = rkp * xxdzx1
      pxpxdzy1 = rkp * xxdzy1
      pxpydxx1 = rkp * xydxx1
      pxpydyy1 = rkp * xydyy1
      pxpydzz1 = rkp * xydzz1 
      pxpydyx1 = rkp * xydyx1 
      pxpydzx1 = rkp * xydzx1 
      pxpydzy1 = rkp * xydzy1 
      pxpzdxx1 = rkp * xzdxx1 
      pxpzdyy1 = rkp * xzdyy1 
      pxpzdzz1 = rkp * xzdzz1 
      pxpzdyx1 = rkp * xzdyx1 
      pxpzdzx1 = rkp * xzdzx1
      pxpzdzy1 = rkp * xzdzy1 
      pypxdxx1 = rkp * yxdxx1 
      pypxdyy1 = rkp * yxdyy1 
      pypxdzz1 = rkp * yxdzz1 
      pypxdyx1 = rkp * yxdyx1 
      pypxdzx1 = rkp * yxdzx1 
      pypxdzy1 = rkp * yxdzy1 
      pypydxx1 = rkp * yydxx1 
      pypydyy1 = rkp * yydyy1 
      pypydzz1 = rkp * yydzz1 
      pypydyx1 = rkp * yydyx1 
      pypydzx1 = rkp * yydzx1 
      pypydzy1 = rkp * yydzy1 
      pypzdxx1 = rkp * yzdxx1 
      pypzdyy1 = rkp * yzdyy1 
      pypzdzz1 = rkp * yzdzz1 
      pypzdyx1 = rkp * yzdyx1 
      pypzdzx1 = rkp * yzdzx1 
      pypzdzy1 = rkp * yzdzy1 
      pzpxdxx1 = rkp * zxdxx1 
      pzpxdyy1 = rkp * zxdyy1 
      pzpxdzz1 = rkp * zxdzz1 
      pzpxdyx1 = rkp * zxdyx1 
      pzpxdzx1 = rkp * zxdzx1 
      pzpxdzy1 = rkp * zxdzy1 
      pzpydxx1 = rkp * zydxx1 
      pzpydyy1 = rkp * zydyy1 
      pzpydzz1 = rkp * zydzz1
      pzpydyx1 = rkp * zydyx1 
      pzpydzx1 = rkp * zydzx1
      pzpydzy1 = rkp * zydzy1 
      pzpzdxx1 = rkp * zzdxx1
      pzpzdyy1 = rkp * zzdyy1
      pzpzdzz1 = rkp * zzdzz1
      pzpzdyx1 = rkp * zzdyx1
      pzpzdzx1 = rkp * zzdzx1
      pzpzdzy1 = rkp * zzdzy1

      aa1 = rkp * dxxdxx1
      ab1 = rkp * dxxdyy1
      ac1 = rkp * dxxdzz1
      ad1 = rkp * dxxdyx1
      ae1 = rkp * dxxdzx1
      af1 = rkp * dxxdzy1
      ba1 = rkp * dyydxx1
      bb1 = rkp * dyydyy1
      bc1 = rkp * dyydzz1
      bd1 = rkp * dyydyx1
      be1 = rkp * dyydzx1
      bf1 = rkp * dyydzy1
      ca1 = rkp * dzzdxx1
      cb1 = rkp * dzzdyy1
      cc1 = rkp * dzzdzz1
      cd1 = rkp * dzzdyx1
      ce1 = rkp * dzzdzx1
      cf1 = rkp * dzzdzy1
      da1 = rkp * dyxdxx1
      db1 = rkp * dyxdyy1
      dc1 = rkp * dyxdzz1
      dd1 = rkp * dyxdyx1
      de1 = rkp * dyxdzx1
      df1 = rkp * dyxdzy1
      ea1 = rkp * dzxdxx1
      eb1 = rkp * dzxdyy1
      ec1 = rkp * dzxdzz1
      ed1 = rkp * dzxdyx1
      ee1 = rkp * dzxdzx1
      ef1 = rkp * dzxdzy1
      fa1 = rkp * dzydxx1
      fb1 = rkp * dzydyy1
      fc1 = rkp * dzydzz1
      fd1 = rkp * dzydyx1
      fe1 = rkp * dzydzx1
      ff1 = rkp * dzydzy1

      dxxpxpx01=  eta*( dxxpxpx0 -rooe*   dxxpxpx1)
      dxxpxpy01=  eta*( dxxpxpy0 -rooe*   dxxpxpy1)
      dxxpxpz01=  eta*( dxxpxpz0 -rooe*   dxxpxpz1)
      dxxpypx01=  eta*( dxxpypx0 -rooe*   dxxpypx1)
      dxxpypy01=  eta*( dxxpypy0 -rooe*   dxxpypy1)
      dxxpypz01=  eta*( dxxpypz0 -rooe*   dxxpypz1)
      dxxpzpx01=  eta*( dxxpzpx0 -rooe*   dxxpzpx1)
      dxxpzpy01=  eta*( dxxpzpy0 -rooe*   dxxpzpy1)
      dxxpzpz01=  eta*( dxxpzpz0 -rooe*   dxxpzpz1)
      dyypxpx01=  eta*( dyypxpx0 -rooe*   dyypxpx1)
      dyypxpy01=  eta*( dyypxpy0 -rooe*   dyypxpy1)
      dyypxpz01=  eta*( dyypxpz0 -rooe*   dyypxpz1)
      dyypypx01=  eta*( dyypypx0 -rooe*   dyypypx1)
      dyypypy01=  eta*( dyypypy0 -rooe*   dyypypy1)
      dyypypz01=  eta*( dyypypz0 -rooe*   dyypypz1)
      dyypzpx01=  eta*( dyypzpx0 -rooe*   dyypzpx1)
      dyypzpy01=  eta*( dyypzpy0 -rooe*   dyypzpy1)
      dyypzpz01=  eta*( dyypzpz0 -rooe*   dyypzpz1)
      dzzpxpx01=  eta*( dzzpxpx0 -rooe*   dzzpxpx1)
      dzzpxpy01=  eta*( dzzpxpy0 -rooe*   dzzpxpy1)
      dzzpxpz01=  eta*( dzzpxpz0 -rooe*   dzzpxpz1)
      dzzpypx01=  eta*( dzzpypx0 -rooe*   dzzpypx1)
      dzzpypy01=  eta*( dzzpypy0 -rooe*   dzzpypy1)
      dzzpypz01=  eta*( dzzpypz0 -rooe*   dzzpypz1)
      dzzpzpx01=  eta*( dzzpzpx0 -rooe*   dzzpzpx1)
      dzzpzpy01=  eta*( dzzpzpy0 -rooe*   dzzpzpy1)
      dzzpzpz01=  eta*( dzzpzpz0 -rooe*   dzzpzpz1)
      dyxpxpx01=  eta*( dyxpxpx0 -rooe*   dyxpxpx1)
      dyxpxpy01=  eta*( dyxpxpy0 -rooe*   dyxpxpy1)
      dyxpxpz01=  eta*( dyxpxpz0 -rooe*   dyxpxpz1)
      dyxpypx01=  eta*( dyxpypx0 -rooe*   dyxpypx1)
      dyxpypy01=  eta*( dyxpypy0 -rooe*   dyxpypy1)
      dyxpypz01=  eta*( dyxpypz0 -rooe*   dyxpypz1)
      dyxpzpx01=  eta*( dyxpzpx0 -rooe*   dyxpzpx1)
      dyxpzpy01=  eta*( dyxpzpy0 -rooe*   dyxpzpy1)
      dyxpzpz01=  eta*( dyxpzpz0 -rooe*   dyxpzpz1)
      dzxpxpx01=  eta*( dzxpxpx0 -rooe*   dzxpxpx1)
      dzxpxpy01=  eta*( dzxpxpy0 -rooe*   dzxpxpy1)
      dzxpxpz01=  eta*( dzxpxpz0 -rooe*   dzxpxpz1)
      dzxpypx01=  eta*( dzxpypx0 -rooe*   dzxpypx1)
      dzxpypy01=  eta*( dzxpypy0 -rooe*   dzxpypy1)
      dzxpypz01=  eta*( dzxpypz0 -rooe*   dzxpypz1)
      dzxpzpx01=  eta*( dzxpzpx0 -rooe*   dzxpzpx1)
      dzxpzpy01=  eta*( dzxpzpy0 -rooe*   dzxpzpy1)
      dzxpzpz01=  eta*( dzxpzpz0 -rooe*   dzxpzpz1)
      dzypxpx01=  eta*( dzypxpx0 -rooe*   dzypxpx1)
      dzypxpy01=  eta*( dzypxpy0 -rooe*   dzypxpy1)
      dzypxpz01=  eta*( dzypxpz0 -rooe*   dzypxpz1)
      dzypypx01=  eta*( dzypypx0 -rooe*   dzypypx1)
      dzypypy01=  eta*( dzypypy0 -rooe*   dzypypy1)
      dzypypz01=  eta*( dzypypz0 -rooe*   dzypypz1)
      dzypzpx01=  eta*( dzypzpx0 -rooe*   dzypzpx1)
      dzypzpy01=  eta*( dzypzpy0 -rooe*   dzypzpy1)
      dzypzpz01=  eta*( dzypzpz0 -rooe*   dzypzpz1)

!
      ec(  1)=ec(  1)+qdx*axa0+wqx*axa1+2.d0*pxpxdxx1+aa1+2.d0*dxxpxpx01
      ec(  2)=ec(  2)+qdy*axa0+wqy*axa1
      ec(  3)=ec(  3)+qdz*axa0+wqz*axa1
      ec(  4)=ec(  4)+qdx*axb0+wqx*axb1+2.d0*pxpxdyy1+ab1
      ec(  5)=ec(  5)+qdy*axb0+wqy*axb1                  +2.d0*dxxpxpy01
      ec(  6)=ec(  6)+qdz*axb0+wqz*axb1                      
      ec(  7)=ec(  7)+qdx*axc0+wqx*axc1+2.d0*pxpxdzz1+ac1
      ec(  8)=ec(  8)+qdy*axc0+wqy*axc1                      
      ec(  9)=ec(  9)+qdz*axc0+wqz*axc1                  +2.d0*dxxpxpz01
      ec( 10)=ec( 10)+qdx*axd0+wqx*axd1+2.d0*pxpxdyx1+ad1+     dxxpxpy01
      ec( 11)=ec( 11)+qdy*axd0+wqy*axd1                  +     dxxpxpx01
      ec( 12)=ec( 12)+qdz*axd0+wqz*axd1                      
      ec( 13)=ec( 13)+qdx*axe0+wqx*axe1+2.d0*pxpxdzx1+ae1+     dxxpxpz01
      ec( 14)=ec( 14)+qdy*axe0+wqy*axe1                      
      ec( 15)=ec( 15)+qdz*axe0+wqz*axe1                  +     dxxpxpx01
      ec( 16)=ec( 16)+qdx*axf0+wqx*axf1+2.d0*pxpxdzy1+af1
      ec( 17)=ec( 17)+qdy*axf0+wqy*axf1                  +     dxxpxpz01
      ec( 18)=ec( 18)+qdz*axf0+wqz*axf1                  +     dxxpxpy01
      ec( 19)=ec( 19)+qdx*aya0+wqx*aya1+2.d0*pxpydxx1    +2.d0*dxxpypx01
      ec( 20)=ec( 20)+qdy*aya0+wqy*aya1              +aa1
      ec( 21)=ec( 21)+qdz*aya0+wqz*aya1
      ec( 22)=ec( 22)+qdx*ayb0+wqx*ayb1+2.d0*pxpydyy1
      ec( 23)=ec( 23)+qdy*ayb0+wqy*ayb1              +ab1+2.d0*dxxpypy01
      ec( 24)=ec( 24)+qdz*ayb0+wqz*ayb1                      
      ec( 25)=ec( 25)+qdx*ayc0+wqx*ayc1+2.d0*pxpydzz1        
      ec( 26)=ec( 26)+qdy*ayc0+wqy*ayc1              +ac1
      ec( 27)=ec( 27)+qdz*ayc0+wqz*ayc1                  +2.d0*dxxpypz01
      ec( 28)=ec( 28)+qdx*ayd0+wqx*ayd1+2.d0*pxpydyx1    +     dxxpypy01
      ec( 29)=ec( 29)+qdy*ayd0+wqy*ayd1              +ad1+     dxxpypx01
      ec( 30)=ec( 30)+qdz*ayd0+wqz*ayd1                      
      ec( 31)=ec( 31)+qdx*aye0+wqx*aye1+2.d0*pxpydzx1    +     dxxpypz01
      ec( 32)=ec( 32)+qdy*aye0+wqy*aye1              +ae1
      ec( 33)=ec( 33)+qdz*aye0+wqz*aye1                  +     dxxpypx01
      ec( 34)=ec( 34)+qdx*ayf0+wqx*ayf1+2.d0*pxpydzy1        
      ec( 35)=ec( 35)+qdy*ayf0+wqy*ayf1              +af1+     dxxpypz01
      ec( 36)=ec( 36)+qdz*ayf0+wqz*ayf1                  +     dxxpypy01
      ec( 37)=ec( 37)+qdx*aza0+wqx*aza1+2.d0*pxpzdxx1    +2.d0*dxxpzpx01
      ec( 38)=ec( 38)+qdy*aza0+wqy*aza1                      
      ec( 39)=ec( 39)+qdz*aza0+wqz*aza1              +aa1
      ec( 40)=ec( 40)+qdx*azb0+wqx*azb1+2.d0*pxpzdyy1        
      ec( 41)=ec( 41)+qdy*azb0+wqy*azb1                  +2.d0*dxxpzpy01
      ec( 42)=ec( 42)+qdz*azb0+wqz*azb1              +ab1
      ec( 43)=ec( 43)+qdx*azc0+wqx*azc1+2.d0*pxpzdzz1        
      ec( 44)=ec( 44)+qdy*azc0+wqy*azc1                      
      ec( 45)=ec( 45)+qdz*azc0+wqz*azc1              +ac1+2.d0*dxxpzpz01
      ec( 46)=ec( 46)+qdx*azd0+wqx*azd1+2.d0*pxpzdyx1    +     dxxpzpy01
      ec( 47)=ec( 47)+qdy*azd0+wqy*azd1                  +     dxxpzpx01
      ec( 48)=ec( 48)+qdz*azd0+wqz*azd1              +ad1
      ec( 49)=ec( 49)+qdx*aze0+wqx*aze1+2.d0*pxpzdzx1    +     dxxpzpz01
      ec( 50)=ec( 50)+qdy*aze0+wqy*aze1                  
      ec( 51)=ec( 51)+qdz*aze0+wqz*aze1              +ae1+     dxxpzpx01
      ec( 52)=ec( 52)+qdx*azf0+wqx*azf1+2.d0*pxpzdzy1        
      ec( 53)=ec( 53)+qdy*azf0+wqy*azf1                  +     dxxpzpz01
      ec( 54)=ec( 54)+qdz*azf0+wqz*azf1              +af1+     dxxpzpy01
      ec( 55)=ec( 55)+qdx*bxa0+wqx*bxa1              +ba1+2.d0*dyypxpx01
      ec( 56)=ec( 56)+qdy*bxa0+wqy*bxa1+2.d0*pypxdxx1        
      ec( 57)=ec( 57)+qdz*bxa0+wqz*bxa1                      
      ec( 58)=ec( 58)+qdx*bxb0+wqx*bxb1              +bb1
      ec( 59)=ec( 59)+qdy*bxb0+wqy*bxb1+2.d0*pypxdyy1    +2.d0*dyypxpy01
      ec( 60)=ec( 60)+qdz*bxb0+wqz*bxb1                      
      ec( 61)=ec( 61)+qdx*bxc0+wqx*bxc1              +bc1
      ec( 62)=ec( 62)+qdy*bxc0+wqy*bxc1+2.d0*pypxdzz1        
      ec( 63)=ec( 63)+qdz*bxc0+wqz*bxc1                  +2.d0*dyypxpz01
      ec( 64)=ec( 64)+qdx*bxd0+wqx*bxd1              +bd1+     dyypxpy01
      ec( 65)=ec( 65)+qdy*bxd0+wqy*bxd1+2.d0*pypxdyx1    +     dyypxpx01
      ec( 66)=ec( 66)+qdz*bxd0+wqz*bxd1                      
      ec( 67)=ec( 67)+qdx*bxe0+wqx*bxe1              +be1+     dyypxpz01
      ec( 68)=ec( 68)+qdy*bxe0+wqy*bxe1+2.d0*pypxdzx1        
      ec( 69)=ec( 69)+qdz*bxe0+wqz*bxe1                  +     dyypxpx01
      ec( 70)=ec( 70)+qdx*bxf0+wqx*bxf1              +bf1
      ec( 71)=ec( 71)+qdy*bxf0+wqy*bxf1+2.d0*pypxdzy1    +     dyypxpz01
      ec( 72)=ec( 72)+qdz*bxf0+wqz*bxf1                  +     dyypxpy01
      ec( 73)=ec( 73)+qdx*bya0+wqx*bya1                  +2.d0*dyypypx01
      ec( 74)=ec( 74)+qdy*bya0+wqy*bya1+2.d0*pypydxx1+ba1
      ec( 75)=ec( 75)+qdz*bya0+wqz*bya1                      
      ec( 76)=ec( 76)+qdx*byb0+wqx*byb1                      
      ec( 77)=ec( 77)+qdy*byb0+wqy*byb1+2.d0*pypydyy1+bb1+2.d0*dyypypy01
      ec( 78)=ec( 78)+qdz*byb0+wqz*byb1
      ec( 79)=ec( 79)+qdx*byc0+wqx*byc1                      
      ec( 80)=ec( 80)+qdy*byc0+wqy*byc1+2.d0*pypydzz1+bc1
      ec( 81)=ec( 81)+qdz*byc0+wqz*byc1                  +2.d0*dyypypz01
      ec( 82)=ec( 82)+qdx*byd0+wqx*byd1                  +     dyypypy01
      ec( 83)=ec( 83)+qdy*byd0+wqy*byd1+2.d0*pypydyx1+bd1+     dyypypx01
      ec( 84)=ec( 84)+qdz*byd0+wqz*byd1                  
      ec( 85)=ec( 85)+qdx*bye0+wqx*bye1                  +     dyypypz01
      ec( 86)=ec( 86)+qdy*bye0+wqy*bye1+2.d0*pypydzx1+be1
      ec( 87)=ec( 87)+qdz*bye0+wqz*bye1                  +     dyypypx01
      ec( 88)=ec( 88)+qdx*byf0+wqx*byf1                  
      ec( 89)=ec( 89)+qdy*byf0+wqy*byf1+2.d0*pypydzy1+bf1+     dyypypz01
      ec( 90)=ec( 90)+qdz*byf0+wqz*byf1                  +     dyypypy01
      ec( 91)=ec( 91)+qdx*bza0+wqx*bza1                  +2.d0*dyypzpx01
      ec( 92)=ec( 92)+qdy*bza0+wqy*bza1+2.d0*pypzdxx1        
      ec( 93)=ec( 93)+qdz*bza0+wqz*bza1              +ba1
      ec( 94)=ec( 94)+qdx*bzb0+wqx*bzb1                      
      ec( 95)=ec( 95)+qdy*bzb0+wqy*bzb1+2.d0*pypzdyy1    +2.d0*dyypzpy01
      ec( 96)=ec( 96)+qdz*bzb0+wqz*bzb1              +bb1
      ec( 97)=ec( 97)+qdx*bzc0+wqx*bzc1                      
      ec( 98)=ec( 98)+qdy*bzc0+wqy*bzc1+2.d0*pypzdzz1        
      ec( 99)=ec( 99)+qdz*bzc0+wqz*bzc1              +bc1+2.d0*dyypzpz01
      ec(100)=ec(100)+qdx*bzd0+wqx*bzd1                  +     dyypzpy01
      ec(101)=ec(101)+qdy*bzd0+wqy*bzd1+2.d0*pypzdyx1    +     dyypzpx01
      ec(102)=ec(102)+qdz*bzd0+wqz*bzd1              +bd1
      ec(103)=ec(103)+qdx*bze0+wqx*bze1                  +     dyypzpz01
      ec(104)=ec(104)+qdy*bze0+wqy*bze1+2.d0*pypzdzx1    
      ec(105)=ec(105)+qdz*bze0+wqz*bze1              +be1+     dyypzpx01
      ec(106)=ec(106)+qdx*bzf0+wqx*bzf1                      
      ec(107)=ec(107)+qdy*bzf0+wqy*bzf1+2.d0*pypzdzy1    +     dyypzpz01
      ec(108)=ec(108)+qdz*bzf0+wqz*bzf1              +bf1+     dyypzpy01
      ec(109)=ec(109)+qdx*cxa0+wqx*cxa1              +ca1+2.d0*dzzpxpx01
      ec(110)=ec(110)+qdy*cxa0+wqy*cxa1                      
      ec(111)=ec(111)+qdz*cxa0+wqz*cxa1+2.d0*pzpxdxx1        
      ec(112)=ec(112)+qdx*cxb0+wqx*cxb1              +cb1
      ec(113)=ec(113)+qdy*cxb0+wqy*cxb1                  +2.d0*dzzpxpy01
      ec(114)=ec(114)+qdz*cxb0+wqz*cxb1+2.d0*pzpxdyy1        
      ec(115)=ec(115)+qdx*cxc0+wqx*cxc1              +cc1
      ec(116)=ec(116)+qdy*cxc0+wqy*cxc1                      
      ec(117)=ec(117)+qdz*cxc0+wqz*cxc1+2.d0*pzpxdzz1    +2.d0*dzzpxpz01
      ec(118)=ec(118)+qdx*cxd0+wqx*cxd1              +cd1+     dzzpxpy01
      ec(119)=ec(119)+qdy*cxd0+wqy*cxd1                  +     dzzpxpx01
      ec(120)=ec(120)+qdz*cxd0+wqz*cxd1+2.d0*pzpxdyx1        
      ec(121)=ec(121)+qdx*cxe0+wqx*cxe1              +ce1+     dzzpxpz01
      ec(122)=ec(122)+qdy*cxe0+wqy*cxe1                     
      ec(123)=ec(123)+qdz*cxe0+wqz*cxe1+2.d0*pzpxdzx1    +     dzzpxpx01
      ec(124)=ec(124)+qdx*cxf0+wqx*cxf1              +cf1
      ec(125)=ec(125)+qdy*cxf0+wqy*cxf1                  +     dzzpxpz01
      ec(126)=ec(126)+qdz*cxf0+wqz*cxf1+2.d0*pzpxdzy1    +     dzzpxpy01
      ec(127)=ec(127)+qdx*cya0+wqx*cya1                  +2.d0*dzzpypx01
      ec(128)=ec(128)+qdy*cya0+wqy*cya1              +ca1
      ec(129)=ec(129)+qdz*cya0+wqz*cya1+2.d0*pzpydxx1        
      ec(130)=ec(130)+qdx*cyb0+wqx*cyb1                      
      ec(131)=ec(131)+qdy*cyb0+wqy*cyb1              +cb1+2.d0*dzzpypy01
      ec(132)=ec(132)+qdz*cyb0+wqz*cyb1+2.d0*pzpydyy1        
      ec(133)=ec(133)+qdx*cyc0+wqx*cyc1                      
      ec(134)=ec(134)+qdy*cyc0+wqy*cyc1              +cc1
      ec(135)=ec(135)+qdz*cyc0+wqz*cyc1+2.d0*pzpydzz1    +2.d0*dzzpypz01
      ec(136)=ec(136)+qdx*cyd0+wqx*cyd1                  +     dzzpypy01
      ec(137)=ec(137)+qdy*cyd0+wqy*cyd1              +cd1+     dzzpypx01
      ec(138)=ec(138)+qdz*cyd0+wqz*cyd1+2.d0*pzpydyx1        
      ec(139)=ec(139)+qdx*cye0+wqx*cye1                  +     dzzpypz01
      ec(140)=ec(140)+qdy*cye0+wqy*cye1              +ce1 
      ec(141)=ec(141)+qdz*cye0+wqz*cye1+2.d0*pzpydzx1    +     dzzpypx01
      ec(142)=ec(142)+qdx*cyf0+wqx*cyf1                      
      ec(143)=ec(143)+qdy*cyf0+wqy*cyf1              +cf1+     dzzpypz01
      ec(144)=ec(144)+qdz*cyf0+wqz*cyf1+2.d0*pzpydzy1    +     dzzpypy01
      ec(145)=ec(145)+qdx*cza0+wqx*cza1                  +2.d0*dzzpzpx01
      ec(146)=ec(146)+qdy*cza0+wqy*cza1                      
      ec(147)=ec(147)+qdz*cza0+wqz*cza1+2.d0*pzpzdxx1+ca1
      ec(148)=ec(148)+qdx*czb0+wqx*czb1                      
      ec(149)=ec(149)+qdy*czb0+wqy*czb1                  +2.d0*dzzpzpy01
      ec(150)=ec(150)+qdz*czb0+wqz*czb1+2.d0*pzpzdyy1+cb1
      ec(151)=ec(151)+qdx*czc0+wqx*czc1                      
      ec(152)=ec(152)+qdy*czc0+wqy*czc1                      
      ec(153)=ec(153)+qdz*czc0+wqz*czc1+2.d0*pzpzdzz1+cc1+2.d0*dzzpzpz01
      ec(154)=ec(154)+qdx*czd0+wqx*czd1                  +     dzzpzpy01
      ec(155)=ec(155)+qdy*czd0+wqy*czd1                  +     dzzpzpx01
      ec(156)=ec(156)+qdz*czd0+wqz*czd1+2.d0*pzpzdyx1+cd1
      ec(157)=ec(157)+qdx*cze0+wqx*cze1                  +     dzzpzpz01
      ec(158)=ec(158)+qdy*cze0+wqy*cze1                   
      ec(159)=ec(159)+qdz*cze0+wqz*cze1+2.d0*pzpzdzx1+ce1+     dzzpzpx01
      ec(160)=ec(160)+qdx*czf0+wqx*czf1                  
      ec(161)=ec(161)+qdy*czf0+wqy*czf1                  +     dzzpzpz01
      ec(162)=ec(162)+qdz*czf0+wqz*czf1+2.d0*pzpzdzy1+cf1+     dzzpzpy01
      ec(163)=ec(163)+qdx*dxa0+wqx*dxa1+     pypxdxx1+da1+2.d0*dyxpxpx01
      ec(164)=ec(164)+qdy*dxa0+wqy*dxa1+     pxpxdxx1
      ec(165)=ec(165)+qdz*dxa0+wqz*dxa1              
      ec(166)=ec(166)+qdx*dxb0+wqx*dxb1+     pypxdyy1+db1
      ec(167)=ec(167)+qdy*dxb0+wqy*dxb1+     pxpxdyy1    +2.d0*dyxpxpy01
      ec(168)=ec(168)+qdz*dxb0+wqz*dxb1                      
      ec(169)=ec(169)+qdx*dxc0+wqx*dxc1+     pypxdzz1+dc1
      ec(170)=ec(170)+qdy*dxc0+wqy*dxc1+     pxpxdzz1        
      ec(171)=ec(171)+qdz*dxc0+wqz*dxc1                  +2.d0*dyxpxpz01
      ec(172)=ec(172)+qdx*dxd0+wqx*dxd1+     pypxdyx1+dd1+     dyxpxpy01
      ec(173)=ec(173)+qdy*dxd0+wqy*dxd1+     pxpxdyx1    +     dyxpxpx01
      ec(174)=ec(174)+qdz*dxd0+wqz*dxd1                      
      ec(175)=ec(175)+qdx*dxe0+wqx*dxe1+     pypxdzx1+de1+     dyxpxpz01
      ec(176)=ec(176)+qdy*dxe0+wqy*dxe1+     pxpxdzx1           
      ec(177)=ec(177)+qdz*dxe0+wqz*dxe1                  +     dyxpxpx01
      ec(178)=ec(178)+qdx*dxf0+wqx*dxf1+     pypxdzy1+df1
      ec(179)=ec(179)+qdy*dxf0+wqy*dxf1+     pxpxdzy1    +     dyxpxpz01
      ec(180)=ec(180)+qdz*dxf0+wqz*dxf1                  +     dyxpxpy01
      ec(181)=ec(181)+qdx*dya0+wqx*dya1+     pypydxx1    +2.d0*dyxpypx01
      ec(182)=ec(182)+qdy*dya0+wqy*dya1+     pxpydxx1+da1
      ec(183)=ec(183)+qdz*dya0+wqz*dya1                      
      ec(184)=ec(184)+qdx*dyb0+wqx*dyb1+     pypydyy1        
      ec(185)=ec(185)+qdy*dyb0+wqy*dyb1+     pxpydyy1+db1+2.d0*dyxpypy01
      ec(186)=ec(186)+qdz*dyb0+wqz*dyb1                      
      ec(187)=ec(187)+qdx*dyc0+wqx*dyc1+     pypydzz1        
      ec(188)=ec(188)+qdy*dyc0+wqy*dyc1+     pxpydzz1+dc1
      ec(189)=ec(189)+qdz*dyc0+wqz*dyc1                  +2.d0*dyxpypz01
      ec(190)=ec(190)+qdx*dyd0+wqx*dyd1+     pypydyx1    +     dyxpypy01
      ec(191)=ec(191)+qdy*dyd0+wqy*dyd1+     pxpydyx1+dd1+     dyxpypx01
      ec(192)=ec(192)+qdz*dyd0+wqz*dyd1                      
      ec(193)=ec(193)+qdx*dye0+wqx*dye1+     pypydzx1    +     dyxpypz01
      ec(194)=ec(194)+qdy*dye0+wqy*dye1+     pxpydzx1+de1
      ec(195)=ec(195)+qdz*dye0+wqz*dye1                  +     dyxpypx01
      ec(196)=ec(196)+qdx*dyf0+wqx*dyf1+     pypydzy1        
      ec(197)=ec(197)+qdy*dyf0+wqy*dyf1+     pxpydzy1+df1+     dyxpypz01
      ec(198)=ec(198)+qdz*dyf0+wqz*dyf1                  +     dyxpypy01
      ec(199)=ec(199)+qdx*dza0+wqx*dza1+     pypzdxx1    +2.d0*dyxpzpx01
      ec(200)=ec(200)+qdy*dza0+wqy*dza1+     pxpzdxx1        
      ec(201)=ec(201)+qdz*dza0+wqz*dza1              +da1
      ec(202)=ec(202)+qdx*dzb0+wqx*dzb1+     pypzdyy1        
      ec(203)=ec(203)+qdy*dzb0+wqy*dzb1+     pxpzdyy1    +2.d0*dyxpzpy01
      ec(204)=ec(204)+qdz*dzb0+wqz*dzb1              +db1
      ec(205)=ec(205)+qdx*dzc0+wqx*dzc1+     pypzdzz1        
      ec(206)=ec(206)+qdy*dzc0+wqy*dzc1+     pxpzdzz1        
      ec(207)=ec(207)+qdz*dzc0+wqz*dzc1              +dc1+2.d0*dyxpzpz01
      ec(208)=ec(208)+qdx*dzd0+wqx*dzd1+     pypzdyx1    +     dyxpzpy01
      ec(209)=ec(209)+qdy*dzd0+wqy*dzd1+     pxpzdyx1    +     dyxpzpx01
      ec(210)=ec(210)+qdz*dzd0+wqz*dzd1              +dd1
      ec(211)=ec(211)+qdx*dze0+wqx*dze1+     pypzdzx1    +     dyxpzpz01
      ec(212)=ec(212)+qdy*dze0+wqy*dze1+     pxpzdzx1
      ec(213)=ec(213)+qdz*dze0+wqz*dze1              +de1+     dyxpzpx01
      ec(214)=ec(214)+qdx*dzf0+wqx*dzf1+     pypzdzy1
      ec(215)=ec(215)+qdy*dzf0+wqy*dzf1+     pxpzdzy1    +     dyxpzpz01
      ec(216)=ec(216)+qdz*dzf0+wqz*dzf1              +df1+     dyxpzpy01
      ec(217)=ec(217)+qdx*exa0+wqx*exa1+     pzpxdxx1+ea1+2.d0*dzxpxpx01
      ec(218)=ec(218)+qdy*exa0+wqy*exa1                      
      ec(219)=ec(219)+qdz*exa0+wqz*exa1+     pxpxdxx1        
      ec(220)=ec(220)+qdx*exb0+wqx*exb1+     pzpxdyy1+eb1
      ec(221)=ec(221)+qdy*exb0+wqy*exb1                  +2.d0*dzxpxpy01
      ec(222)=ec(222)+qdz*exb0+wqz*exb1+     pxpxdyy1        
      ec(223)=ec(223)+qdx*exc0+wqx*exc1+     pzpxdzz1+ec1
      ec(224)=ec(224)+qdy*exc0+wqy*exc1                      
      ec(225)=ec(225)+qdz*exc0+wqz*exc1+     pxpxdzz1    +2.d0*dzxpxpz01
      ec(226)=ec(226)+qdx*exd0+wqx*exd1+     pzpxdyx1+ed1+     dzxpxpy01
      ec(227)=ec(227)+qdy*exd0+wqy*exd1                  +     dzxpxpx01
      ec(228)=ec(228)+qdz*exd0+wqz*exd1+     pxpxdyx1        
      ec(229)=ec(229)+qdx*exe0+wqx*exe1+     pzpxdzx1+ee1+     dzxpxpz01
      ec(230)=ec(230)+qdy*exe0+wqy*exe1                       
      ec(231)=ec(231)+qdz*exe0+wqz*exe1+     pxpxdzx1    +     dzxpxpx01
      ec(232)=ec(232)+qdx*exf0+wqx*exf1+     pzpxdzy1+ef1
      ec(233)=ec(233)+qdy*exf0+wqy*exf1                  +     dzxpxpz01
      ec(234)=ec(234)+qdz*exf0+wqz*exf1+     pxpxdzy1    +     dzxpxpy01
      ec(235)=ec(235)+qdx*eya0+wqx*eya1+     pzpydxx1    +2.d0*dzxpypx01
      ec(236)=ec(236)+qdy*eya0+wqy*eya1              +ea1
      ec(237)=ec(237)+qdz*eya0+wqz*eya1+     pxpydxx1        
      ec(238)=ec(238)+qdx*eyb0+wqx*eyb1+     pzpydyy1        
      ec(239)=ec(239)+qdy*eyb0+wqy*eyb1              +eb1+2.d0*dzxpypy01
      ec(240)=ec(240)+qdz*eyb0+wqz*eyb1+     pxpydyy1        
      ec(241)=ec(241)+qdx*eyc0+wqx*eyc1+     pzpydzz1        
      ec(242)=ec(242)+qdy*eyc0+wqy*eyc1              +ec1
      ec(243)=ec(243)+qdz*eyc0+wqz*eyc1+     pxpydzz1    +2.d0*dzxpypz01
      ec(244)=ec(244)+qdx*eyd0+wqx*eyd1+     pzpydyx1    +     dzxpypy01
      ec(245)=ec(245)+qdy*eyd0+wqy*eyd1              +ed1+     dzxpypx01
      ec(246)=ec(246)+qdz*eyd0+wqz*eyd1+     pxpydyx1    
      ec(247)=ec(247)+qdx*eye0+wqx*eye1+     pzpydzx1    +     dzxpypz01
      ec(248)=ec(248)+qdy*eye0+wqy*eye1              +ee1 
      ec(249)=ec(249)+qdz*eye0+wqz*eye1+     pxpydzx1    +     dzxpypx01
      ec(250)=ec(250)+qdx*eyf0+wqx*eyf1+     pzpydzy1        
      ec(251)=ec(251)+qdy*eyf0+wqy*eyf1              +ef1+     dzxpypz01
      ec(252)=ec(252)+qdz*eyf0+wqz*eyf1+     pxpydzy1    +     dzxpypy01
      ec(253)=ec(253)+qdx*eza0+wqx*eza1+     pzpzdxx1    +2.d0*dzxpzpx01
      ec(254)=ec(254)+qdy*eza0+wqy*eza1                      
      ec(255)=ec(255)+qdz*eza0+wqz*eza1+     pxpzdxx1+ea1
      ec(256)=ec(256)+qdx*ezb0+wqx*ezb1+     pzpzdyy1        
      ec(257)=ec(257)+qdy*ezb0+wqy*ezb1                  +2.d0*dzxpzpy01
      ec(258)=ec(258)+qdz*ezb0+wqz*ezb1+     pxpzdyy1+eb1
      ec(259)=ec(259)+qdx*ezc0+wqx*ezc1+     pzpzdzz1        
      ec(260)=ec(260)+qdy*ezc0+wqy*ezc1                      
      ec(261)=ec(261)+qdz*ezc0+wqz*ezc1+     pxpzdzz1+ec1+2.d0*dzxpzpz01
      ec(262)=ec(262)+qdx*ezd0+wqx*ezd1+     pzpzdyx1    +     dzxpzpy01
      ec(263)=ec(263)+qdy*ezd0+wqy*ezd1                  +     dzxpzpx01
      ec(264)=ec(264)+qdz*ezd0+wqz*ezd1+     pxpzdyx1+ed1
      ec(265)=ec(265)+qdx*eze0+wqx*eze1+     pzpzdzx1    +     dzxpzpz01
      ec(266)=ec(266)+qdy*eze0+wqy*eze1                       
      ec(267)=ec(267)+qdz*eze0+wqz*eze1+     pxpzdzx1+ee1+     dzxpzpx01
      ec(268)=ec(268)+qdx*ezf0+wqx*ezf1+     pzpzdzy1     
      ec(269)=ec(269)+qdy*ezf0+wqy*ezf1                  +     dzxpzpz01
      ec(270)=ec(270)+qdz*ezf0+wqz*ezf1+     pxpzdzy1+ef1+     dzxpzpy01
      ec(271)=ec(271)+qdx*fxa0+wqx*fxa1              +fa1+2.d0*dzypxpx01
      ec(272)=ec(272)+qdy*fxa0+wqy*fxa1+     pzpxdxx1        
      ec(273)=ec(273)+qdz*fxa0+wqz*fxa1+     pypxdxx1        
      ec(274)=ec(274)+qdx*fxb0+wqx*fxb1              +fb1
      ec(275)=ec(275)+qdy*fxb0+wqy*fxb1+     pzpxdyy1    +2.d0*dzypxpy01
      ec(276)=ec(276)+qdz*fxb0+wqz*fxb1+     pypxdyy1        
      ec(277)=ec(277)+qdx*fxc0+wqx*fxc1              +fc1
      ec(278)=ec(278)+qdy*fxc0+wqy*fxc1+     pzpxdzz1        
      ec(279)=ec(279)+qdz*fxc0+wqz*fxc1+     pypxdzz1    +2.d0*dzypxpz01
      ec(280)=ec(280)+qdx*fxd0+wqx*fxd1              +fd1+     dzypxpy01
      ec(281)=ec(281)+qdy*fxd0+wqy*fxd1+     pzpxdyx1    +     dzypxpx01
      ec(282)=ec(282)+qdz*fxd0+wqz*fxd1+     pypxdyx1        
      ec(283)=ec(283)+qdx*fxe0+wqx*fxe1              +fe1+     dzypxpz01
      ec(284)=ec(284)+qdy*fxe0+wqy*fxe1+     pzpxdzx1          
      ec(285)=ec(285)+qdz*fxe0+wqz*fxe1+     pypxdzx1    +     dzypxpx01
      ec(286)=ec(286)+qdx*fxf0+wqx*fxf1              +ff1
      ec(287)=ec(287)+qdy*fxf0+wqy*fxf1+     pzpxdzy1    +     dzypxpz01
      ec(288)=ec(288)+qdz*fxf0+wqz*fxf1+     pypxdzy1    +     dzypxpy01
      ec(289)=ec(289)+qdx*fya0+wqx*fya1                  +2.d0*dzypypx01
      ec(290)=ec(290)+qdy*fya0+wqy*fya1+     pzpydxx1+fa1
      ec(291)=ec(291)+qdz*fya0+wqz*fya1+     pypydxx1        
      ec(292)=ec(292)+qdx*fyb0+wqx*fyb1
      ec(293)=ec(293)+qdy*fyb0+wqy*fyb1+     pzpydyy1+fb1+2.d0*dzypypy01
      ec(294)=ec(294)+qdz*fyb0+wqz*fyb1+     pypydyy1        
      ec(295)=ec(295)+qdx*fyc0+wqx*fyc1                      
      ec(296)=ec(296)+qdy*fyc0+wqy*fyc1+     pzpydzz1+fc1
      ec(297)=ec(297)+qdz*fyc0+wqz*fyc1+     pypydzz1    +2.d0*dzypypz01
      ec(298)=ec(298)+qdx*fyd0+wqx*fyd1                  +     dzypypy01
      ec(299)=ec(299)+qdy*fyd0+wqy*fyd1+     pzpydyx1+fd1+     dzypypx01
      ec(300)=ec(300)+qdz*fyd0+wqz*fyd1+     pypydyx1    
      ec(301)=ec(301)+qdx*fye0+wqx*fye1                  +     dzypypz01
      ec(302)=ec(302)+qdy*fye0+wqy*fye1+     pzpydzx1+fe1 
      ec(303)=ec(303)+qdz*fye0+wqz*fye1+     pypydzx1    +     dzypypx01
      ec(304)=ec(304)+qdx*fyf0+wqx*fyf1                      
      ec(305)=ec(305)+qdy*fyf0+wqy*fyf1+     pzpydzy1+ff1+     dzypypz01
      ec(306)=ec(306)+qdz*fyf0+wqz*fyf1+     pypydzy1    +     dzypypy01
      ec(307)=ec(307)+qdx*fza0+wqx*fza1                  +2.d0*dzypzpx01
      ec(308)=ec(308)+qdy*fza0+wqy*fza1+     pzpzdxx1        
      ec(309)=ec(309)+qdz*fza0+wqz*fza1+     pypzdxx1+fa1
      ec(310)=ec(310)+qdx*fzb0+wqx*fzb1                      
      ec(311)=ec(311)+qdy*fzb0+wqy*fzb1+     pzpzdyy1    +2.d0*dzypzpy01
      ec(312)=ec(312)+qdz*fzb0+wqz*fzb1+     pypzdyy1+fb1
      ec(313)=ec(313)+qdx*fzc0+wqx*fzc1
      ec(314)=ec(314)+qdy*fzc0+wqy*fzc1+     pzpzdzz1        
      ec(315)=ec(315)+qdz*fzc0+wqz*fzc1+     pypzdzz1+fc1+2.d0*dzypzpz01
      ec(316)=ec(316)+qdx*fzd0+wqx*fzd1                  +     dzypzpy01
      ec(317)=ec(317)+qdy*fzd0+wqy*fzd1+     pzpzdyx1    +     dzypzpx01
      ec(318)=ec(318)+qdz*fzd0+wqz*fzd1+     pypzdyx1+fd1
      ec(319)=ec(319)+qdx*fze0+wqx*fze1                  +     dzypzpz01
      ec(320)=ec(320)+qdy*fze0+wqy*fze1+     pzpzdzx1         
      ec(321)=ec(321)+qdz*fze0+wqz*fze1+     pypzdzx1+fe1+     dzypzpx01
      ec(322)=ec(322)+qdx*fzf0+wqx*fzf1                      
      ec(323)=ec(323)+qdy*fzf0+wqy*fzf1+     pzpzdzy1    +     dzypzpz01
      ec(324)=ec(324)+qdz*fzf0+wqz*fzf1+     pypzdzy1+ff1+     dzypzpy01

                enddo
            enddo
         enddo
      enddo


      if (ierisw.eq.0) then 

        do i=163,324
          ec(i)= ec(i)*root3
        enddo

        do i0 = 1,18
           do ii=10,18

             i = ii + 18*(i0-1)
             ec(i) = ec(i)*root3

           enddo
        enddo

      endif

      end
