! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
!= iofsss ===========================================================
c  caluvate primitive gto fsss type  obara-method
c ===================================================================

      subroutine iofsss(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)

      dimension ec(10)

      data      pi / 3.14159265358979323846d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root5 / 2.23606797749978980505d+00 /
      data  root15/ 3.87298334620741688517d+00 /



!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,10
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(4)) then
                     
                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f3   = (((((fdat(10,it)*dt6   + fdat(9,it))*dt5
     &                    + fdat(8,it))*dt4  + fdat(7,it))*dt3
     &                    + fdat(6,it))*dt2  + fdat(5,it))*dt
     &                    + fdat(4,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)


                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)
                  
                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  
                  ec( 1)=ec( 1) + pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  ec( 2)=ec( 2) + pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  ec( 3)=ec( 3) + paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  ec( 4)=ec( 4) + pay*dxx0+wpy*dxx1
                  ec( 5)=ec( 5) + paz*dxx0+wpz*dxx1
                  ec( 6)=ec( 6) + pax*dyy0+wpx*dyy1
                  ec( 7)=ec( 7) + paz*dyy0+wpz*dyy1            
                  ec( 8)=ec( 8) + pax*dzz0+wpx*dzz1
                  ec( 9)=ec( 9) + pay*dzz0+wpy*dzz1
                  ec(10)=ec(10) + paz*dyx0+wpz*dyx1
                  
               enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 
         ec( 4) = ec( 4) *  root5
         ec( 5) = ec( 5) *  root5
         ec( 6) = ec( 6) *  root5
         ec( 7) = ec( 7) *  root5
         ec( 8) = ec( 8) *  root5
         ec( 9) = ec( 9) *  root5
         ec(10) = ec(10) *  root15
      endif
      
      end
!= fpss =============================================================
c  caluvate primitive gto fpss type  obara-method
c ===================================================================
      subroutine iofpss(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(30)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root5 / 2.23606797749978969640d+00 /
      data  root15/ 3.87298334620741688517d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,30
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(5)) then
                     
                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f4   = (((((fdat(11,it)*dt6   + fdat(10,it))*dt5
     &                    + fdat(9,it))*dt4  + fdat(8,it))*dt3
     &                    + fdat(7,it))*dt2  + fdat(6,it))*dt
     &                    + fdat(5,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     dm4 =  3.5d0 *tinv *  dm3 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)


                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
                  dyx2 = pay*px2 + wpy*px3
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1
                  fzxx0 = paz*dxx0+wpz*dxx1
                  fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
                  fzzy0 = pay*dzz0+wpy*dzz1
                  fzyx0 = paz*dyx0+wpz*dyx1
                  
                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
                  fzxx1 = paz*dxx1+wpz*dxx2
                  fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
                  fzzy1 = pay*dzz1+wpy*dzz2
                  fzyx1 = paz*dyx1+wpz*dyx2

                  dxx01 = zet*(dxx0 - rooz*dxx1)
                  dyy01 = zet*(dyy0 - rooz*dyy1)
                  dzz01 = zet*(dzz0 - rooz*dzz1)
                  dyx01 = zet*(dyx0 - rooz*dyx1)
                  dzx01 = zet*(dzx0 - rooz*dzx1)
                  dzy01 = zet*(dzy0 - rooz*dzy1)

                  ec( 1) =ec( 1)+pbx*fxxx0 + wpx*fxxx1 + 3.0d0*dxx01
                  ec( 2) =ec( 2)+pby*fxxx0 + wpy*fxxx1
                  ec( 3) =ec( 3)+pbz*fxxx0 + wpz*fxxx1
                  ec( 4) =ec( 4)+pbx*fyyy0 + wpx*fyyy1
                  ec( 5) =ec( 5)+pby*fyyy0 + wpy*fyyy1 + 3.0d0*dyy01
                  ec( 6) =ec( 6)+pbz*fyyy0 + wpz*fyyy1
                  ec( 7) =ec( 7)+pbx*fzzz0 + wpx*fzzz1
                  ec( 8) =ec( 8)+pby*fzzz0 + wpy*fzzz1
                  ec( 9) =ec( 9)+pbz*fzzz0 + wpz*fzzz1 + 3.0d0*dzz01
                  ec(10) =ec(10)+pbx*fyxx0 + wpx*fyxx1 + 2.0d0*dyx01
                  ec(11) =ec(11)+pby*fyxx0 + wpy*fyxx1 +       dxx01
                  ec(12) =ec(12)+pbz*fyxx0 + wpz*fyxx1
                  ec(13) =ec(13)+pbx*fzxx0 + wpx*fzxx1 + 2.0d0*dzx01
                  ec(14) =ec(14)+pby*fzxx0 + wpy*fzxx1
                  ec(15) =ec(15)+pbz*fzxx0 + wpz*fzxx1 +       dxx01
                  ec(16) =ec(16)+pbx*fyyx0 + wpx*fyyx1 +       dyy01
                  ec(17) =ec(17)+pby*fyyx0 + wpy*fyyx1 + 2.0d0*dyx01
                  ec(18) =ec(18)+pbz*fyyx0 + wpz*fyyx1
                  ec(19) =ec(19)+pbx*fzyy0 + wpx*fzyy1
                  ec(20) =ec(20)+pby*fzyy0 + wpy*fzyy1 + 2.0d0*dzy01
                  ec(21) =ec(21)+pbz*fzyy0 + wpz*fzyy1 +       dyy01
                  ec(22) =ec(22)+pbx*fzzx0 + wpx*fzzx1 +       dzz01
                  ec(23) =ec(23)+pby*fzzx0 + wpy*fzzx1
                  ec(24) =ec(24)+pbz*fzzx0 + wpz*fzzx1 + 2.0d0*dzx01
                  ec(25) =ec(25)+pbx*fzzy0 + wpx*fzzy1
                  ec(26) =ec(26)+pby*fzzy0 + wpy*fzzy1 +       dzz01
                  ec(27) =ec(27)+pbz*fzzy0 + wpz*fzzy1 + 2.0d0*dzy01
                  ec(28) =ec(28)+pbx*fzyx0 + wpx*fzyx1 +       dzy01
                  ec(29) =ec(29)+pby*fzyx0 + wpy*fzyx1 +       dzx01
                  ec(30) =ec(30)+pbz*fzyx0 + wpz*fzyx1 +       dyx01

                enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 

        do i=10,27
          ec(i)= ec(i)*root5
        enddo

        do i=28,30
          ec(i)= ec(i)*root15
        enddo

      endif
      
      end
!= fsps =============================================================
c  caluvate primitive gto fsps type  obara-method
c ===================================================================
      subroutine iofsps(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(30)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root5 / 2.23606797749978969640d+00 /
      data  root15/ 3.87298334620741688517d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,30
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
                  qcx = yq(1,l,k) - xyz(1,katom)
                  qcy = yq(2,l,k) - xyz(2,katom)
                  qcz = yq(3,l,k) - xyz(3,katom)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(5)) then
                     
                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f4   = (((((fdat(11,it)*dt6   + fdat(10,it))*dt5
     &                    + fdat(9,it))*dt4  + fdat(8,it))*dt3
     &                    + fdat(7,it))*dt2  + fdat(6,it))*dt
     &                    + fdat(5,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     dm4 =  3.5d0 *tinv *  dm3 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
!                 dzx0 = paz*px0 + wpz*px1
!                 dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
                  dyx2 = pay*px2 + wpy*px3
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1
                  fzxx0 = paz*dxx0+wpz*dxx1
                  fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
                  fzzy0 = pay*dzz0+wpy*dzz1
                  fzyx0 = paz*dyx0+wpz*dyx1
                  
                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
                  fzxx1 = paz*dxx1+wpz*dxx2
                  fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
                  fzzy1 = pay*dzz1+wpy*dzz2
                  fzyx1 = paz*dyx1+wpz*dyx2

!                 dxx01 = zet*(dxx0 - rooz*dxx1)
!                 dyy01 = zet*(dyy0 - rooz*dyy1)
!                 dzz01 = zet*(dzz0 - rooz*dzz1)
!                 dyx01 = zet*(dyx0 - rooz*dyx1)
!                 dzx01 = zet*(dzx0 - rooz*dzx1)
!                 dzy01 = zet*(dzy0 - rooz*dzy1)

                  rkp = rooz * eta

                  rdxx1 = rkp * dxx1
                  rdyy1 = rkp * dyy1
                  rdzz1 = rkp * dzz1
                  rdyx1 = rkp * dyx1
                  rdzx1 = rkp * dzx1
                  rdzy1 = rkp * dzy1

                  ec( 1) = ec( 1)+qcx*fxxx0 + wqx*fxxx1 + 3.0d0 * rdxx1
                  ec( 2) = ec( 2)+qcy*fxxx0 + wqy*fxxx1
                  ec( 3) = ec( 3)+qcz*fxxx0 + wqz*fxxx1
                  ec( 4) = ec( 4)+qcx*fyyy0 + wqx*fyyy1
                  ec( 5) = ec( 5)+qcy*fyyy0 + wqy*fyyy1 + 3.0d0 * rdyy1
                  ec( 6) = ec( 6)+qcz*fyyy0 + wqz*fyyy1
                  ec( 7) = ec( 7)+qcx*fzzz0 + wqx*fzzz1
                  ec( 8) = ec( 8)+qcy*fzzz0 + wqy*fzzz1
                  ec( 9) = ec( 9)+qcz*fzzz0 + wqz*fzzz1 + 3.0d0 * rdzz1
                  ec(10) = ec(10)+qcx*fyxx0 + wqx*fyxx1 + 2.0d0 * rdyx1
                  ec(11) = ec(11)+qcy*fyxx0 + wqy*fyxx1 +         rdxx1
                  ec(12) = ec(12)+qcz*fyxx0 + wqz*fyxx1
                  ec(13) = ec(13)+qcx*fzxx0 + wqx*fzxx1 + 2.0d0 * rdzx1
                  ec(14) = ec(14)+qcy*fzxx0 + wqy*fzxx1
                  ec(15) = ec(15)+qcz*fzxx0 + wqz*fzxx1 +         rdxx1
                  ec(16) = ec(16)+qcx*fyyx0 + wqx*fyyx1 +         rdyy1
                  ec(17) = ec(17)+qcy*fyyx0 + wqy*fyyx1 + 2.0d0 * rdyx1
                  ec(18) = ec(18)+qcz*fyyx0 + wqz*fyyx1
                  ec(19) = ec(19)+qcx*fzyy0 + wqx*fzyy1
                  ec(20) = ec(20)+qcy*fzyy0 + wqy*fzyy1 + 2.0d0 * rdzy1
                  ec(21) = ec(21)+qcz*fzyy0 + wqz*fzyy1 +         rdyy1
                  ec(22) = ec(22)+qcx*fzzx0 + wqx*fzzx1 +         rdzz1
                  ec(23) = ec(23)+qcy*fzzx0 + wqy*fzzx1
                  ec(24) = ec(24)+qcz*fzzx0 + wqz*fzzx1 + 2.0d0 * rdzx1
                  ec(25) = ec(25)+qcx*fzzy0 + wqx*fzzy1
                  ec(26) = ec(26)+qcy*fzzy0 + wqy*fzzy1 +         rdzz1
                  ec(27) = ec(27)+qcz*fzzy0 + wqz*fzzy1 + 2.0d0 * rdzy1
                  ec(28) = ec(28)+qcx*fzyx0 + wqx*fzyx1 +         rdzy1
                  ec(29) = ec(29)+qcy*fzyx0 + wqy*fzyx1 +         rdzx1
                  ec(30) = ec(30)+qcz*fzyx0 + wqz*fzyx1 +         rdyx1

                enddo
            enddo
         enddo
      enddo

 
      if (ierisw.eq.0) then 

        do i=10,27
          ec(i)= ec(i)*root5
        enddo

        do i=28,30
          ec(i)= ec(i)*root15
        enddo

      endif
      
      end
!= iogsss ===========================================================
c  caluvate primitive gto gsss type  obara-method
c ===================================================================

      subroutine iogsss(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(15)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root3 / 1.73205080756887729352d+00 /
      data  root5 / 2.23606797749978969640d+00 /
      data  root7 / 2.64575131106459059050d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,15
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2
                  
                  if (t. le .tf(5)) then
                     
                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f4   = (((((fdat(11,it)*dt6   + fdat(10,it))*dt5
     &                    + fdat(9,it))*dt4  + fdat(8,it))*dt3
     &                    + fdat(7,it))*dt2  + fdat(6,it))*dt
     &                    + fdat(5,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee

                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0
                     dm2 =  1.5d0 *tinv *  dm1
                     dm3 =  2.5d0 *tinv *  dm2
                     dm4 =  3.5d0 *tinv *  dm3
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
c                 dyx0 = pay*px0 + wpy*px1
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
c                 dyx1 = pay*px1 + wpy*px2
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)
                  
                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
c                 dyx2 = pay*px2 + wpy*px3
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1

c                 fzxx0 = paz*dxx0+wpz*dxx1
c                 fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
c                 fzzy0 = pay*dzz0+wpy*dzz1
c                 fzyx0 = paz*dyx0+wpz*dyx1

                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
c                 fzxx1 = paz*dxx1+wpz*dxx2
c                 fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
c                 fzzy1 = pay*dzz1+wpy*dzz2
c                 fzyx1 = paz*dyx1+wpz*dyx2
                  
                  dxx01 = zet*(dxx0 - rooz*dxx1)
                  dyy01 = zet*(dyy0 - rooz*dyy1)
                  dzz01 = zet*(dzz0 - rooz*dzz1)
                  
                  ec( 1) = ec( 1) +  pax*fxxx0 + wpx*fxxx1 + 3.0d0*dxx01
                  ec( 2) = ec( 2) +  pay*fyyy0 + wpy*fyyy1 + 3.0d0*dyy01
                  ec( 3) = ec( 3) +  paz*fzzz0 + wpz*fzzz1 + 3.0d0*dzz01
                  ec( 4) = ec( 4) +  pay*fxxx0 + wpy*fxxx1
                  ec( 5) = ec( 5) +  paz*fxxx0 + wpz*fxxx1
                  ec( 6) = ec( 6) +  pax*fyyy0 + wpx*fyyy1
                  ec( 7) = ec( 7) +  paz*fyyy0 + wpz*fyyy1
                  ec( 8) = ec( 8) +  pax*fzzz0 + wpx*fzzz1
                  ec( 9) = ec( 9) +  pay*fzzz0 + wpy*fzzz1
                  ec(10) = ec(10) +  pay*fyxx0 + wpy*fyxx1 +       dxx01
                  ec(11) = ec(11) +  pax*fzzx0 + wpx*fzzx1 +       dzz01
                  ec(12) = ec(12) +  paz*fzyy0 + wpz*fzyy1 +       dyy01
                  ec(13) = ec(13) +  paz*fyxx0 + wpz*fyxx1
                  ec(14) = ec(14) +  pax*fzyy0 + wpx*fzyy1
                  ec(15) = ec(15) +  pay*fzzx0 + wpy*fzzx1
               enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 

         ec( 4) = ec( 4)               * root7
         ec( 5) = ec( 5)               * root7
         ec( 6) = ec( 6)               * root7
         ec( 7) = ec( 7)               * root7
         ec( 8) = ec( 8)               * root7
         ec( 9) = ec( 9)               * root7
         ec(10) = ec(10) * root3* root5* root7 / 3.0d0
         ec(11) = ec(11) * root3* root5* root7 / 3.0d0
         ec(12) = ec(12) * root3* root5* root7 / 3.0d0
         ec(13) = ec(13)        * root5* root7
         ec(14) = ec(14)        * root5* root7
         ec(15) = ec(15)        * root5* root7

      endif
      
      end
!= iogpss ===========================================================
c  caluvate primitive gto gpss type  obara-method
c ===================================================================

      subroutine iogpss(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(45)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root3 / 1.73205080756887729352d+00 /
      data  root5 / 2.23606797749978969640d+00 /
      data  root7 / 2.64575131106459059050d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,45
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(6)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f5   = (((((fdat(12,it)*dt6   + fdat(11,it))*dt5
     &                    + fdat(10,it))*dt4  + fdat(9,it))*dt3
     &                    + fdat(8,it))*dt2  + fdat(7,it))*dt
     &                    + fdat(6,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     dm4 =  3.5d0 *tinv *  dm3 
                     dm5 =  4.5d0 *tinv *  dm4 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
                   
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)

                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
                  dyx2 = pay*px2 + wpy*px3
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)

                  dxx3 = pax*px3 + wpx*px4+zet*(s3-rooz*s4)
                  dyx3 = pay*px3 + wpy*px4
                  dyy3 = pay*py3 + wpy*py4+zet*(s3-rooz*s4)
                  dzz3 = paz*pz3 + wpz*pz4+zet*(s3-rooz*s4)
                  
                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1
                  fzxx0 = paz*dxx0+wpz*dxx1
                  fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
                  fzzy0 = pay*dzz0+wpy*dzz1
                  fzyx0 = paz*dyx0+wpz*dyx1

                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
                  fzxx1 = paz*dxx1+wpz*dxx2
                  fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
                  fzzy1 = pay*dzz1+wpy*dzz2
                  fzyx1 = paz*dyx1+wpz*dyx2
                  
                  fxxx2 = pax*dxx2+wpx*dxx3 + 2.0d0*px23
                  fyyy2 = pay*dyy2+wpy*dyy3 + 2.0d0*py23
                  fzzz2 = paz*dzz2+wpz*dzz3 + 2.0d0*pz23
                  fyxx2 = pay*dxx2+wpy*dxx3
!                 fzxx2 = paz*dxx2+wpz*dxx3
!                 fyyx2 = pax*dyy2+wpx*dyy3
                  fzyy2 = paz*dyy2+wpz*dyy3
                  fzzx2 = pax*dzz2+wpx*dzz3
!                 fzzy2 = pay*dzz2+wpy*dzz3
!                 fzyx2 = paz*dyx2+wpz*dyx3

                  dxx01 = zet*(dxx0 - rooz*dxx1)
                  dyy01 = zet*(dyy0 - rooz*dyy1)
                  dzz01 = zet*(dzz0 - rooz*dzz1)

                  dxx12 = zet*(dxx1 - rooz*dxx2)
                  dyy12 = zet*(dyy1 - rooz*dyy2)
                  dzz12 = zet*(dzz1 - rooz*dzz2)
                   
                  gxxxx0 = pax*fxxx0 + wpx*fxxx1 + 3.0d0*dxx01
                  gyyyy0 = pay*fyyy0 + wpy*fyyy1 + 3.0d0*dyy01
                  gzzzz0 = paz*fzzz0 + wpz*fzzz1 + 3.0d0*dzz01
                  gyxxx0 = pay*fxxx0 + wpy*fxxx1
                  gzxxx0 = paz*fxxx0 + wpz*fxxx1
                  gyyyx0 = pax*fyyy0 + wpx*fyyy1
                  gzyyy0 = paz*fyyy0 + wpz*fyyy1
                  gzzzx0 = pax*fzzz0 + wpx*fzzz1
                  gzzzy0 = pay*fzzz0 + wpy*fzzz1
                  gyyxx0 = pay*fyxx0 + wpy*fyxx1 +       dxx01
                  gzzxx0 = pax*fzzx0 + wpx*fzzx1 +       dzz01
                  gzzyy0 = paz*fzyy0 + wpz*fzyy1 +       dyy01
                  gzyxx0 = paz*fyxx0 + wpz*fyxx1
                  gzyyx0 = pax*fzyy0 + wpx*fzyy1
                  gzzyx0 = pay*fzzx0 + wpy*fzzx1

                  gxxxx1 = pax*fxxx1 + wpx*fxxx2 + 3.0d0*dxx12
                  gyyyy1 = pay*fyyy1 + wpy*fyyy2 + 3.0d0*dyy12
                  gzzzz1 = paz*fzzz1 + wpz*fzzz2 + 3.0d0*dzz12
                  gyxxx1 = pay*fxxx1 + wpy*fxxx2
                  gzxxx1 = paz*fxxx1 + wpz*fxxx2
                  gyyyx1 = pax*fyyy1 + wpx*fyyy2
                  gzyyy1 = paz*fyyy1 + wpz*fyyy2
                  gzzzx1 = pax*fzzz1 + wpx*fzzz2
                  gzzzy1 = pay*fzzz1 + wpy*fzzz2
                  gyyxx1 = pay*fyxx1 + wpy*fyxx2 +       dxx12
                  gzzxx1 = pax*fzzx1 + wpx*fzzx2 +       dzz12
                  gzzyy1 = paz*fzyy1 + wpz*fzyy2 +       dyy12
                  gzyxx1 = paz*fyxx1 + wpz*fyxx2
                  gzyyx1 = pax*fzyy1 + wpx*fzyy2
                  gzzyx1 = pay*fzzx1 + wpy*fzzx2

                  fxxx01 = zet*(fxxx0 - rooz*fxxx1)
                  fyyy01 = zet*(fyyy0 - rooz*fyyy1)
                  fzzz01 = zet*(fzzz0 - rooz*fzzz1)
                  fyxx01 = zet*(fyxx0 - rooz*fyxx1)
                  fzxx01 = zet*(fzxx0 - rooz*fzxx1)
                  fyyx01 = zet*(fyyx0 - rooz*fyyx1)
                  fzyy01 = zet*(fzyy0 - rooz*fzyy1)
                  fzzx01 = zet*(fzzx0 - rooz*fzzx1)
                  fzzy01 = zet*(fzzy0 - rooz*fzzy1)
                  fzyx01 = zet*(fzyx0 - rooz*fzyx1)

                  ec( 1)=ec( 1)+pbx*gxxxx0 + wpx*gxxxx1 + 4.0d0 * fxxx01
                  ec( 2)=ec( 2)+pby*gxxxx0 + wpy*gxxxx1
                  ec( 3)=ec( 3)+pbz*gxxxx0 + wpz*gxxxx1
                  ec( 4)=ec( 4)+pbx*gyyyy0 + wpx*gyyyy1
                  ec( 5)=ec( 5)+pby*gyyyy0 + wpy*gyyyy1 + 4.0d0 * fyyy01
                  ec( 6)=ec( 6)+pbz*gyyyy0 + wpz*gyyyy1
                  ec( 7)=ec( 7)+pbx*gzzzz0 + wpx*gzzzz1
                  ec( 8)=ec( 8)+pby*gzzzz0 + wpy*gzzzz1
                  ec( 9)=ec( 9)+pbz*gzzzz0 + wpz*gzzzz1 + 4.0d0 * fzzz01
                  ec(10)=ec(10)+pbx*gyxxx0 + wpx*gyxxx1 + 3.0d0 * fyxx01
                  ec(11)=ec(11)+pby*gyxxx0 + wpy*gyxxx1 +         fxxx01
                  ec(12)=ec(12)+pbz*gyxxx0 + wpz*gyxxx1
                  ec(13)=ec(13)+pbx*gzxxx0 + wpx*gzxxx1 + 3.0d0 * fzxx01
                  ec(14)=ec(14)+pby*gzxxx0 + wpy*gzxxx1
                  ec(15)=ec(15)+pbz*gzxxx0 + wpz*gzxxx1 +         fxxx01
                  ec(16)=ec(16)+pbx*gyyyx0 + wpx*gyyyx1 +         fyyy01
                  ec(17)=ec(17)+pby*gyyyx0 + wpy*gyyyx1 + 3.0d0 * fyyx01
                  ec(18)=ec(18)+pbz*gyyyx0 + wpz*gyyyx1
                  ec(19)=ec(19)+pbx*gzyyy0 + wpx*gzyyy1
                  ec(20)=ec(20)+pby*gzyyy0 + wpy*gzyyy1 + 3.0d0 * fzyy01
                  ec(21)=ec(21)+pbz*gzyyy0 + wpz*gzyyy1 +         fyyy01
                  ec(22)=ec(22)+pbx*gzzzx0 + wpx*gzzzx1 +         fzzz01
                  ec(23)=ec(23)+pby*gzzzx0 + wpy*gzzzx1
                  ec(24)=ec(24)+pbz*gzzzx0 + wpz*gzzzx1 + 3.0d0 * fzzx01
                  ec(25)=ec(25)+pbx*gzzzy0 + wpx*gzzzy1
                  ec(26)=ec(26)+pby*gzzzy0 + wpy*gzzzy1 +         fzzz01
                  ec(27)=ec(27)+pbz*gzzzy0 + wpz*gzzzy1 + 3.0d0 * fzzy01
                  ec(28)=ec(28)+pbx*gyyxx0 + wpx*gyyxx1 + 2.0d0 * fyyx01
                  ec(29)=ec(29)+pby*gyyxx0 + wpy*gyyxx1 + 2.0d0 * fyxx01
                  ec(30)=ec(30)+pbz*gyyxx0 + wpz*gyyxx1
                  ec(31)=ec(31)+pbx*gzzxx0 + wpx*gzzxx1 + 2.0d0 * fzzx01
                  ec(32)=ec(32)+pby*gzzxx0 + wpy*gzzxx1
                  ec(33)=ec(33)+pbz*gzzxx0 + wpz*gzzxx1 + 2.0d0 * fzxx01
                  ec(34)=ec(34)+pbx*gzzyy0 + wpx*gzzyy1
                  ec(35)=ec(35)+pby*gzzyy0 + wpy*gzzyy1 + 2.0d0 * fzzy01
                  ec(36)=ec(36)+pbz*gzzyy0 + wpz*gzzyy1 + 2.0d0 * fzyy01
                  ec(37)=ec(37)+pbx*gzyxx0 + wpx*gzyxx1 + 2.0d0 * fzyx01
                  ec(38)=ec(38)+pby*gzyxx0 + wpy*gzyxx1 +         fzxx01
                  ec(39)=ec(39)+pbz*gzyxx0 + wpz*gzyxx1 +         fyxx01
                  ec(40)=ec(40)+pbx*gzyyx0 + wpx*gzyyx1 +         fzyy01
                  ec(41)=ec(41)+pby*gzyyx0 + wpy*gzyyx1 + 2.0d0 * fzyx01
                  ec(42)=ec(42)+pbz*gzyyx0 + wpz*gzyyx1 +         fyyx01
                  ec(43)=ec(43)+pbx*gzzyx0 + wpx*gzzyx1 +         fzzy01
                  ec(44)=ec(44)+pby*gzzyx0 + wpy*gzzyx1 +         fzzx01
                  ec(45)=ec(45)+pbz*gzzyx0 + wpz*gzzyx1 + 2.0d0 * fzyx01

               enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 
         do i=10,27
            ec(i) = ec(i) * root7
         enddo

         do i=28,36
            ec(i) = ec(i) * root3 * root5 * root7 / 3.0d0
         enddo

         do i=37,45
            ec(i) = ec(i) * root5 * root7 
         enddo

      endif
      

      end
!= iogsps ===========================================================
c  caluvate primitive gto gsps type  obara-method
c ===================================================================

      subroutine iogsps(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(45)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root3 / 1.73205080756887729352d+00 /
      data  root5 / 2.23606797749978969640d+00 /
      data  root7 / 2.64575131106459059050d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,45
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)

                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(6)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f5   = (((((fdat(12,it)*dt6   + fdat(11,it))*dt5
     &                    + fdat(10,it))*dt4  + fdat(9,it))*dt3
     &                    + fdat(8,it))*dt2  + fdat(7,it))*dt
     &                    + fdat(6,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     dm4 =  3.5d0 *tinv *  dm3 
                     dm5 =  4.5d0 *tinv *  dm4 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
                   
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)

                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
                  dyx2 = pay*px2 + wpy*px3
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)

                  dxx3 = pax*px3 + wpx*px4+zet*(s3-rooz*s4)
                  dyx3 = pay*px3 + wpy*px4
                  dyy3 = pay*py3 + wpy*py4+zet*(s3-rooz*s4)
                  dzz3 = paz*pz3 + wpz*pz4+zet*(s3-rooz*s4)
                  
                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1
!                 fzxx0 = paz*dxx0+wpz*dxx1
!                 fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
!                 fzzy0 = pay*dzz0+wpy*dzz1
!                 fzyx0 = paz*dyx0+wpz*dyx1

                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
                  fzxx1 = paz*dxx1+wpz*dxx2
                  fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
                  fzzy1 = pay*dzz1+wpy*dzz2
                  fzyx1 = paz*dyx1+wpz*dyx2
                  
                  fxxx2 = pax*dxx2+wpx*dxx3 + 2.0d0*px23
                  fyyy2 = pay*dyy2+wpy*dyy3 + 2.0d0*py23
                  fzzz2 = paz*dzz2+wpz*dzz3 + 2.0d0*pz23
                  fyxx2 = pay*dxx2+wpy*dxx3
!                 fzxx2 = paz*dxx2+wpz*dxx3
!                 fyyx2 = pax*dyy2+wpx*dyy3
                  fzyy2 = paz*dyy2+wpz*dyy3
                  fzzx2 = pax*dzz2+wpx*dzz3
!                 fzzy2 = pay*dzz2+wpy*dzz3
!                 fzyx2 = paz*dyx2+wpz*dyx3

                  dxx01 = zet*(dxx0 - rooz*dxx1)
                  dyy01 = zet*(dyy0 - rooz*dyy1)
                  dzz01 = zet*(dzz0 - rooz*dzz1)

                  dxx12 = zet*(dxx1 - rooz*dxx2)
                  dyy12 = zet*(dyy1 - rooz*dyy2)
                  dzz12 = zet*(dzz1 - rooz*dzz2)
                   
                  gxxxx0 = pax*fxxx0 + wpx*fxxx1 + 3.0d0*dxx01
                  gyyyy0 = pay*fyyy0 + wpy*fyyy1 + 3.0d0*dyy01
                  gzzzz0 = paz*fzzz0 + wpz*fzzz1 + 3.0d0*dzz01
                  gyxxx0 = pay*fxxx0 + wpy*fxxx1
                  gzxxx0 = paz*fxxx0 + wpz*fxxx1
                  gyyyx0 = pax*fyyy0 + wpx*fyyy1
                  gzyyy0 = paz*fyyy0 + wpz*fyyy1
                  gzzzx0 = pax*fzzz0 + wpx*fzzz1
                  gzzzy0 = pay*fzzz0 + wpy*fzzz1
                  gyyxx0 = pay*fyxx0 + wpy*fyxx1 +       dxx01
                  gzzxx0 = pax*fzzx0 + wpx*fzzx1 +       dzz01
                  gzzyy0 = paz*fzyy0 + wpz*fzyy1 +       dyy01
                  gzyxx0 = paz*fyxx0 + wpz*fyxx1
                  gzyyx0 = pax*fzyy0 + wpx*fzyy1
                  gzzyx0 = pay*fzzx0 + wpy*fzzx1

                  gxxxx1 = pax*fxxx1 + wpx*fxxx2 + 3.0d0*dxx12
                  gyyyy1 = pay*fyyy1 + wpy*fyyy2 + 3.0d0*dyy12
                  gzzzz1 = paz*fzzz1 + wpz*fzzz2 + 3.0d0*dzz12
                  gyxxx1 = pay*fxxx1 + wpy*fxxx2
                  gzxxx1 = paz*fxxx1 + wpz*fxxx2
                  gyyyx1 = pax*fyyy1 + wpx*fyyy2
                  gzyyy1 = paz*fyyy1 + wpz*fyyy2
                  gzzzx1 = pax*fzzz1 + wpx*fzzz2
                  gzzzy1 = pay*fzzz1 + wpy*fzzz2
                  gyyxx1 = pay*fyxx1 + wpy*fyxx2 +       dxx12
                  gzzxx1 = pax*fzzx1 + wpx*fzzx2 +       dzz12
                  gzzyy1 = paz*fzyy1 + wpz*fzyy2 +       dyy12
                  gzyxx1 = paz*fyxx1 + wpz*fyxx2
                  gzyyx1 = pax*fzyy1 + wpx*fzyy2
                  gzzyx1 = pay*fzzx1 + wpy*fzzx2

                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz

                  rfxxx1 = rkp *fxxx1
                  rfyyy1 = rkp *fyyy1
                  rfzzz1 = rkp *fzzz1
                  rfyxx1 = rkp *fyxx1
                  rfzxx1 = rkp *fzxx1
                  rfyyx1 = rkp *fyyx1
                  rfzyy1 = rkp *fzyy1
                  rfzzx1 = rkp *fzzx1
                  rfzzy1 = rkp *fzzy1
                  rfzyx1 = rkp *fzyx1

                  ec( 1)=ec( 1)+qcx*gxxxx0 + wqx*gxxxx1 + 4.0d0 *rfxxx1
                  ec( 2)=ec( 2)+qcy*gxxxx0 + wqy*gxxxx1
                  ec( 3)=ec( 3)+qcz*gxxxx0 + wqz*gxxxx1
                  ec( 4)=ec( 4)+qcx*gyyyy0 + wqx*gyyyy1
                  ec( 5)=ec( 5)+qcy*gyyyy0 + wqy*gyyyy1 + 4.0d0 *rfyyy1
                  ec( 6)=ec( 6)+qcz*gyyyy0 + wqz*gyyyy1
                  ec( 7)=ec( 7)+qcx*gzzzz0 + wqx*gzzzz1
                  ec( 8)=ec( 8)+qcy*gzzzz0 + wqy*gzzzz1
                  ec( 9)=ec( 9)+qcz*gzzzz0 + wqz*gzzzz1 + 4.0d0 *rfzzz1
                  ec(10)=ec(10)+qcx*gyxxx0 + wqx*gyxxx1 + 3.0d0 *rfyxx1
                  ec(11)=ec(11)+qcy*gyxxx0 + wqy*gyxxx1 +        rfxxx1
                  ec(12)=ec(12)+qcz*gyxxx0 + wqz*gyxxx1
                  ec(13)=ec(13)+qcx*gzxxx0 + wqx*gzxxx1 + 3.0d0 *rfzxx1
                  ec(14)=ec(14)+qcy*gzxxx0 + wqy*gzxxx1
                  ec(15)=ec(15)+qcz*gzxxx0 + wqz*gzxxx1 +        rfxxx1
                  ec(16)=ec(16)+qcx*gyyyx0 + wqx*gyyyx1 +        rfyyy1
                  ec(17)=ec(17)+qcy*gyyyx0 + wqy*gyyyx1 + 3.0d0 *rfyyx1
                  ec(18)=ec(18)+qcz*gyyyx0 + wqz*gyyyx1
                  ec(19)=ec(19)+qcx*gzyyy0 + wqx*gzyyy1
                  ec(20)=ec(20)+qcy*gzyyy0 + wqy*gzyyy1 + 3.0d0 *rfzyy1
                  ec(21)=ec(21)+qcz*gzyyy0 + wqz*gzyyy1 +        rfyyy1
                  ec(22)=ec(22)+qcx*gzzzx0 + wqx*gzzzx1 +        rfzzz1
                  ec(23)=ec(23)+qcy*gzzzx0 + wqy*gzzzx1
                  ec(24)=ec(24)+qcz*gzzzx0 + wqz*gzzzx1 + 3.0d0 *rfzzx1
                  ec(25)=ec(25)+qcx*gzzzy0 + wqx*gzzzy1
                  ec(26)=ec(26)+qcy*gzzzy0 + wqy*gzzzy1 +        rfzzz1
                  ec(27)=ec(27)+qcz*gzzzy0 + wqz*gzzzy1 + 3.0d0 *rfzzy1
                  ec(28)=ec(28)+qcx*gyyxx0 + wqx*gyyxx1 + 2.0d0 *rfyyx1
                  ec(29)=ec(29)+qcy*gyyxx0 + wqy*gyyxx1 + 2.0d0 *rfyxx1
                  ec(30)=ec(30)+qcz*gyyxx0 + wqz*gyyxx1
                  ec(31)=ec(31)+qcx*gzzxx0 + wqx*gzzxx1 + 2.0d0 *rfzzx1
                  ec(32)=ec(32)+qcy*gzzxx0 + wqy*gzzxx1
                  ec(33)=ec(33)+qcz*gzzxx0 + wqz*gzzxx1 + 2.0d0 *rfzxx1
                  ec(34)=ec(34)+qcx*gzzyy0 + wqx*gzzyy1
                  ec(35)=ec(35)+qcy*gzzyy0 + wqy*gzzyy1 + 2.0d0 *rfzzy1
                  ec(36)=ec(36)+qcz*gzzyy0 + wqz*gzzyy1 + 2.0d0 *rfzyy1
                  ec(37)=ec(37)+qcx*gzyxx0 + wqx*gzyxx1 + 2.0d0 *rfzyx1
                  ec(38)=ec(38)+qcy*gzyxx0 + wqy*gzyxx1 +        rfzxx1
                  ec(39)=ec(39)+qcz*gzyxx0 + wqz*gzyxx1 +        rfyxx1
                  ec(40)=ec(40)+qcx*gzyyx0 + wqx*gzyyx1 +        rfzyy1
                  ec(41)=ec(41)+qcy*gzyyx0 + wqy*gzyyx1 + 2.0d0 *rfzyx1
                  ec(42)=ec(42)+qcz*gzyyx0 + wqz*gzyyx1 +        rfyyx1
                  ec(43)=ec(43)+qcx*gzzyx0 + wqx*gzzyx1 +        rfzzy1
                  ec(44)=ec(44)+qcy*gzzyx0 + wqy*gzzyx1 +        rfzzx1
                  ec(45)=ec(45)+qcz*gzzyx0 + wqz*gzzyx1 + 2.0d0 *rfzyx1

               enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 
         do i=10,27
            ec(i) = ec(i) * root7
         enddo

         do i=28,36
            ec(i) = ec(i) * root3 * root5 * root7 / 3.0d0
         enddo

         do i=37,45
            ec(i) = ec(i) * root5 * root7 
         enddo

      endif
      

      end
!= fpps =============================================================
c  caluvate primitive gto fpps type  obara-method
c ===================================================================
      subroutine iofpps(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )

      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(90)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root5 / 2.23606797749978969640d+00 /
      data  root15/ 3.87298334620741688517d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,90
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)


                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(6)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f5   = (((((fdat(12,it)*dt6   + fdat(11,it))*dt5
     &                    + fdat(10,it))*dt4  + fdat(9,it))*dt3
     &                    + fdat(8,it))*dt2  + fdat(7,it))*dt
     &                    + fdat(6,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     dm4 =  3.5d0 *tinv *  dm3 
                     dm5 =  4.5d0 *tinv *  dm4 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
 
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
 
                  dxx3 = pax*px3 + wpx*px4+zet*(s3-rooz*s4)
                  dyy3 = pay*py3 + wpy*py4+zet*(s3-rooz*s4)
                  dzz3 = paz*pz3 + wpz*pz4+zet*(s3-rooz*s4)
                  dyx3 = pay*px3 + wpy*px4
!                 dzx3 = paz*px3 + wpz*px4
!                 dzy3 = paz*py3 + wpz*py4

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1
                  fzxx0 = paz*dxx0+wpz*dxx1
                  fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
                  fzzy0 = pay*dzz0+wpy*dzz1
                  fzyx0 = paz*dyx0+wpz*dyx1
                  
                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
                  fzxx1 = paz*dxx1+wpz*dxx2
                  fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
                  fzzy1 = pay*dzz1+wpy*dzz2
                  fzyx1 = paz*dyx1+wpz*dyx2

                  fxxx2 = pax*dxx2+wpx*dxx3 + 2.0d0*px23
                  fyyy2 = pay*dyy2+wpy*dyy3 + 2.0d0*py23
                  fzzz2 = paz*dzz2+wpz*dzz3 + 2.0d0*pz23
                  fyxx2 = pay*dxx2+wpy*dxx3
                  fzxx2 = paz*dxx2+wpz*dxx3
                  fyyx2 = pax*dyy2+wpx*dyy3
                  fzyy2 = paz*dyy2+wpz*dyy3
                  fzzx2 = pax*dzz2+wpx*dzz3
                  fzzy2 = pay*dzz2+wpy*dzz3
                  fzyx2 = paz*dyx2+wpz*dyx3

                  dxx01 = zet*(dxx0 - rooz*dxx1)
                  dyy01 = zet*(dyy0 - rooz*dyy1)
                  dzz01 = zet*(dzz0 - rooz*dzz1)
                  dyx01 = zet*(dyx0 - rooz*dyx1)
                  dzx01 = zet*(dzx0 - rooz*dzx1)
                  dzy01 = zet*(dzy0 - rooz*dzy1)
                  dxx12 = zet*(dxx1 - rooz*dxx2)
                  dyy12 = zet*(dyy1 - rooz*dyy2)
                  dzz12 = zet*(dzz1 - rooz*dzz2)
                  dyx12 = zet*(dyx1 - rooz*dyx2)
                  dzx12 = zet*(dzx1 - rooz*dzx2)
                  dzy12 = zet*(dzy1 - rooz*dzy2)

                  fpxxxx0 =pbx*fxxx0 + wpx*fxxx1 + 3.0d0*dxx01
                  fpxxxy0 =pby*fxxx0 + wpy*fxxx1
                  fpxxxz0 =pbz*fxxx0 + wpz*fxxx1
                  fpyyyx0 =pbx*fyyy0 + wpx*fyyy1
                  fpyyyy0 =pby*fyyy0 + wpy*fyyy1 + 3.0d0*dyy01
                  fpyyyz0 =pbz*fyyy0 + wpz*fyyy1
                  fpzzzx0 =pbx*fzzz0 + wpx*fzzz1
                  fpzzzy0 =pby*fzzz0 + wpy*fzzz1
                  fpzzzz0 =pbz*fzzz0 + wpz*fzzz1 + 3.0d0*dzz01
                  fpyxxx0 =pbx*fyxx0 + wpx*fyxx1 + 2.0d0*dyx01
                  fpyxxy0 =pby*fyxx0 + wpy*fyxx1 +       dxx01
                  fpyxxz0 =pbz*fyxx0 + wpz*fyxx1
                  fpzxxx0 =pbx*fzxx0 + wpx*fzxx1 + 2.0d0*dzx01
                  fpzxxy0 =pby*fzxx0 + wpy*fzxx1
                  fpzxxz0 =pbz*fzxx0 + wpz*fzxx1 +       dxx01
                  fpyyxx0 =pbx*fyyx0 + wpx*fyyx1 +       dyy01
                  fpyyxy0 =pby*fyyx0 + wpy*fyyx1 + 2.0d0*dyx01
                  fpyyxz0 =pbz*fyyx0 + wpz*fyyx1
                  fpzyyx0 =pbx*fzyy0 + wpx*fzyy1
                  fpzyyy0 =pby*fzyy0 + wpy*fzyy1 + 2.0d0*dzy01
                  fpzyyz0 =pbz*fzyy0 + wpz*fzyy1 +       dyy01
                  fpzzxx0 =pbx*fzzx0 + wpx*fzzx1 +       dzz01
                  fpzzxy0 =pby*fzzx0 + wpy*fzzx1
                  fpzzxz0 =pbz*fzzx0 + wpz*fzzx1 + 2.0d0*dzx01
                  fpzzyx0 =pbx*fzzy0 + wpx*fzzy1
                  fpzzyy0 =pby*fzzy0 + wpy*fzzy1 +       dzz01
                  fpzzyz0 =pbz*fzzy0 + wpz*fzzy1 + 2.0d0*dzy01
                  fpzyxx0 =pbx*fzyx0 + wpx*fzyx1 +       dzy01
                  fpzyxy0 =pby*fzyx0 + wpy*fzyx1 +       dzx01
                  fpzyxz0 =pbz*fzyx0 + wpz*fzyx1 +       dyx01

                  fpxxxx1 =pbx*fxxx1 + wpx*fxxx2 + 3.0d0*dxx12
                  fpxxxy1 =pby*fxxx1 + wpy*fxxx2
                  fpxxxz1 =pbz*fxxx1 + wpz*fxxx2
                  fpyyyx1 =pbx*fyyy1 + wpx*fyyy2
                  fpyyyy1 =pby*fyyy1 + wpy*fyyy2 + 3.0d0*dyy12
                  fpyyyz1 =pbz*fyyy1 + wpz*fyyy2
                  fpzzzx1 =pbx*fzzz1 + wpx*fzzz2
                  fpzzzy1 =pby*fzzz1 + wpy*fzzz2
                  fpzzzz1 =pbz*fzzz1 + wpz*fzzz2 + 3.0d0*dzz12
                  fpyxxx1 =pbx*fyxx1 + wpx*fyxx2 + 2.0d0*dyx12
                  fpyxxy1 =pby*fyxx1 + wpy*fyxx2 +       dxx12
                  fpyxxz1 =pbz*fyxx1 + wpz*fyxx2
                  fpzxxx1 =pbx*fzxx1 + wpx*fzxx2 + 2.0d0*dzx12
                  fpzxxy1 =pby*fzxx1 + wpy*fzxx2
                  fpzxxz1 =pbz*fzxx1 + wpz*fzxx2 +       dxx12
                  fpyyxx1 =pbx*fyyx1 + wpx*fyyx2 +       dyy12
                  fpyyxy1 =pby*fyyx1 + wpy*fyyx2 + 2.0d0*dyx12
                  fpyyxz1 =pbz*fyyx1 + wpz*fyyx2
                  fpzyyx1 =pbx*fzyy1 + wpx*fzyy2
                  fpzyyy1 =pby*fzyy1 + wpy*fzyy2 + 2.0d0*dzy12
                  fpzyyz1 =pbz*fzyy1 + wpz*fzyy2 +       dyy12
                  fpzzxx1 =pbx*fzzx1 + wpx*fzzx2 +       dzz12
                  fpzzxy1 =pby*fzzx1 + wpy*fzzx2
                  fpzzxz1 =pbz*fzzx1 + wpz*fzzx2 + 2.0d0*dzx12
                  fpzzyx1 =pbx*fzzy1 + wpx*fzzy2
                  fpzzyy1 =pby*fzzy1 + wpy*fzzy2 +       dzz12
                  fpzzyz1 =pbz*fzzy1 + wpz*fzzy2 + 2.0d0*dzy12
                  fpzyxx1 =pbx*fzyx1 + wpx*fzyx2 +       dzy12
                  fpzyxy1 =pby*fzyx1 + wpy*fzyx2 +       dzx12
                  fpzyxz1 =pbz*fzyx1 + wpz*fzyx2 +       dyx12

                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz

                  rfxxx1 = rkp * fxxx1
                  rfyyy1 = rkp * fyyy1
                  rfzzz1 = rkp * fzzz1
                  rfyxx1 = rkp * fyxx1
                  rfzxx1 = rkp * fzxx1
                  rfyyx1 = rkp * fyyx1
                  rfzyy1 = rkp * fzyy1
                  rfzzx1 = rkp * fzzx1
                  rfzzy1 = rkp * fzzy1
                  rfzyx1 = rkp * fzyx1
      
       rdpxxx1 = rkp * ( pbx*dxx1 + wpx*dxx2 + 2.0d0*px12 )
       rdpxxy1 = rkp * ( pby*dxx1 + wpy*dxx2              )
       rdpxxz1 = rkp * ( pbz*dxx1 + wpz*dxx2              )
       rdpyyx1 = rkp * ( pbx*dyy1 + wpx*dyy2              )
       rdpyyy1 = rkp * ( pby*dyy1 + wpy*dyy2 + 2.0d0*py12 )
       rdpyyz1 = rkp * ( pbz*dyy1 + wpz*dyy2              )
       rdpzzx1 = rkp * ( pbx*dzz1 + wpx*dzz2              )
       rdpzzy1 = rkp * ( pby*dzz1 + wpy*dzz2              )
       rdpzzz1 = rkp * ( pbz*dzz1 + wpz*dzz2 + 2.0d0*pz12 )
       rdpyxx1 = rkp * ( pbx*dyx1 + wpx*dyx2 +       py12 )
       rdpyxy1 = rkp * ( pby*dyx1 + wpy*dyx2 +       px12 )
       rdpyxz1 = rkp * ( pbz*dyx1 + wpz*dyx2              )
       rdpzxx1 = rkp * ( pbx*dzx1 + wpx*dzx2 +       pz12 )
       rdpzxy1 = rkp * ( pby*dzx1 + wpy*dzx2              )
       rdpzxz1 = rkp * ( pbz*dzx1 + wpz*dzx2 +       px12 )
       rdpzyx1 = rkp * ( pbx*dzy1 + wpx*dzy2              )
       rdpzyy1 = rkp * ( pby*dzy1 + wpy*dzy2 +       pz12 )
       rdpzyz1 = rkp * ( pbz*dzy1 + wpz*dzy2 +       py12 )
      
       ec( 1) =ec( 1)+qcx*fpxxxx0 + wqx*fpxxxx1 + 3.0d0*rdpxxx1 + rfxxx1
       ec( 2) =ec( 2)+qcy*fpxxxx0 + wqy*fpxxxx1
       ec( 3) =ec( 3)+qcz*fpxxxx0 + wqz*fpxxxx1
       ec( 4) =ec( 4)+qcx*fpxxxy0 + wqx*fpxxxy1 + 3.0d0*rdpxxy1
       ec( 5) =ec( 5)+qcy*fpxxxy0 + wqy*fpxxxy1                 + rfxxx1
       ec( 6) =ec( 6)+qcz*fpxxxy0 + wqz*fpxxxy1
       ec( 7) =ec( 7)+qcx*fpxxxz0 + wqx*fpxxxz1 + 3.0d0*rdpxxz1
       ec( 8) =ec( 8)+qcy*fpxxxz0 + wqy*fpxxxz1
       ec( 9) =ec( 9)+qcz*fpxxxz0 + wqz*fpxxxz1                 + rfxxx1
       ec(10) =ec(10)+qcx*fpyyyx0 + wqx*fpyyyx1                 + rfyyy1
       ec(11) =ec(11)+qcy*fpyyyx0 + wqy*fpyyyx1 + 3.0d0*rdpyyx1
       ec(12) =ec(12)+qcz*fpyyyx0 + wqz*fpyyyx1
       ec(13) =ec(13)+qcx*fpyyyy0 + wqx*fpyyyy1
       ec(14) =ec(14)+qcy*fpyyyy0 + wqy*fpyyyy1 + 3.0d0*rdpyyy1 + rfyyy1
       ec(15) =ec(15)+qcz*fpyyyy0 + wqz*fpyyyy1
       ec(16) =ec(16)+qcx*fpyyyz0 + wqx*fpyyyz1
       ec(17) =ec(17)+qcy*fpyyyz0 + wqy*fpyyyz1 + 3.0d0*rdpyyz1
       ec(18) =ec(18)+qcz*fpyyyz0 + wqz*fpyyyz1                 + rfyyy1
       ec(19) =ec(19)+qcx*fpzzzx0 + wqx*fpzzzx1                 + rfzzz1
       ec(20) =ec(20)+qcy*fpzzzx0 + wqy*fpzzzx1
       ec(21) =ec(21)+qcz*fpzzzx0 + wqz*fpzzzx1 + 3.0d0*rdpzzx1   
       ec(22) =ec(22)+qcx*fpzzzy0 + wqx*fpzzzy1
       ec(23) =ec(23)+qcy*fpzzzy0 + wqy*fpzzzy1                 + rfzzz1
       ec(24) =ec(24)+qcz*fpzzzy0 + wqz*fpzzzy1 + 3.0d0*rdpzzy1
       ec(25) =ec(25)+qcx*fpzzzz0 + wqx*fpzzzz1
       ec(26) =ec(26)+qcy*fpzzzz0 + wqy*fpzzzz1
       ec(27) =ec(27)+qcz*fpzzzz0 + wqz*fpzzzz1 + 3.0d0*rdpzzz1 + rfzzz1
       ec(28) =ec(28)+qcx*fpyxxx0 + wqx*fpyxxx1 + 2.0d0*rdpyxx1 + rfyxx1
       ec(29) =ec(29)+qcy*fpyxxx0 + wqy*fpyxxx1 +       rdpxxx1
       ec(30) =ec(30)+qcz*fpyxxx0 + wqz*fpyxxx1
       ec(31) =ec(31)+qcx*fpyxxy0 + wqx*fpyxxy1 + 2.0d0*rdpyxy1
       ec(32) =ec(32)+qcy*fpyxxy0 + wqy*fpyxxy1 +       rdpxxy1 + rfyxx1
       ec(33) =ec(33)+qcz*fpyxxy0 + wqz*fpyxxy1
       ec(34) =ec(34)+qcx*fpyxxz0 + wqx*fpyxxz1 + 2.0d0*rdpyxz1
       ec(35) =ec(35)+qcy*fpyxxz0 + wqy*fpyxxz1 +       rdpxxz1
       ec(36) =ec(36)+qcz*fpyxxz0 + wqz*fpyxxz1                 + rfyxx1
       ec(37) =ec(37)+qcx*fpzxxx0 + wqx*fpzxxx1 + 2.0d0*rdpzxx1 + rfzxx1
       ec(38) =ec(38)+qcy*fpzxxx0 + wqy*fpzxxx1
       ec(39) =ec(39)+qcz*fpzxxx0 + wqz*fpzxxx1 +       rdpxxx1   
       ec(40) =ec(40)+qcx*fpzxxy0 + wqx*fpzxxy1 + 2.0d0*rdpzxy1
       ec(41) =ec(41)+qcy*fpzxxy0 + wqy*fpzxxy1                 + rfzxx1
       ec(42) =ec(42)+qcz*fpzxxy0 + wqz*fpzxxy1 +       rdpxxy1   
       ec(43) =ec(43)+qcx*fpzxxz0 + wqx*fpzxxz1 + 2.0d0*rdpzxz1
       ec(44) =ec(44)+qcy*fpzxxz0 + wqy*fpzxxz1
       ec(45) =ec(45)+qcz*fpzxxz0 + wqz*fpzxxz1 +       rdpxxz1 + rfzxx1
       ec(46) =ec(46)+qcx*fpyyxx0 + wqx*fpyyxx1 +       rdpyyx1 + rfyyx1
       ec(47) =ec(47)+qcy*fpyyxx0 + wqy*fpyyxx1 + 2.0d0*rdpyxx1
       ec(48) =ec(48)+qcz*fpyyxx0 + wqz*fpyyxx1
       ec(49) =ec(49)+qcx*fpyyxy0 + wqx*fpyyxy1 +       rdpyyy1
       ec(50) =ec(50)+qcy*fpyyxy0 + wqy*fpyyxy1 + 2.0d0*rdpyxy1 + rfyyx1
       ec(51) =ec(51)+qcz*fpyyxy0 + wqz*fpyyxy1
       ec(52) =ec(52)+qcx*fpyyxz0 + wqx*fpyyxz1 +       rdpyyz1
       ec(53) =ec(53)+qcy*fpyyxz0 + wqy*fpyyxz1 + 2.0d0*rdpyxz1
       ec(54) =ec(54)+qcz*fpyyxz0 + wqz*fpyyxz1                 + rfyyx1
       ec(55) =ec(55)+qcx*fpzyyx0 + wqx*fpzyyx1                 + rfzyy1
       ec(56) =ec(56)+qcy*fpzyyx0 + wqy*fpzyyx1 + 2.0d0*rdpzyx1
       ec(57) =ec(57)+qcz*fpzyyx0 + wqz*fpzyyx1 +       rdpyyx1
       ec(58) =ec(58)+qcx*fpzyyy0 + wqx*fpzyyy1
       ec(59) =ec(59)+qcy*fpzyyy0 + wqy*fpzyyy1 + 2.0d0*rdpzyy1 + rfzyy1
       ec(60) =ec(60)+qcz*fpzyyy0 + wqz*fpzyyy1 +       rdpyyy1
       ec(61) =ec(61)+qcx*fpzyyz0 + wqx*fpzyyz1
       ec(62) =ec(62)+qcy*fpzyyz0 + wqy*fpzyyz1 + 2.0d0*rdpzyz1
       ec(63) =ec(63)+qcz*fpzyyz0 + wqz*fpzyyz1 +       rdpyyz1 + rfzyy1
       ec(64) =ec(64)+qcx*fpzzxx0 + wqx*fpzzxx1 +       rdpzzx1 + rfzzx1
       ec(65) =ec(65)+qcy*fpzzxx0 + wqy*fpzzxx1
       ec(66) =ec(66)+qcz*fpzzxx0 + wqz*fpzzxx1 + 2.0d0*rdpzxx1
       ec(67) =ec(67)+qcx*fpzzxy0 + wqx*fpzzxy1 +       rdpzzy1
       ec(68) =ec(68)+qcy*fpzzxy0 + wqy*fpzzxy1                 + rfzzx1
       ec(69) =ec(69)+qcz*fpzzxy0 + wqz*fpzzxy1 + 2.0d0*rdpzxy1
       ec(70) =ec(70)+qcx*fpzzxz0 + wqx*fpzzxz1 +       rdpzzz1
       ec(71) =ec(71)+qcy*fpzzxz0 + wqy*fpzzxz1
       ec(72) =ec(72)+qcz*fpzzxz0 + wqz*fpzzxz1 + 2.0d0*rdpzxz1 + rfzzx1
       ec(73) =ec(73)+qcx*fpzzyx0 + wqx*fpzzyx1                 + rfzzy1
       ec(74) =ec(74)+qcy*fpzzyx0 + wqy*fpzzyx1 +       rdpzzx1
       ec(75) =ec(75)+qcz*fpzzyx0 + wqz*fpzzyx1 + 2.0d0*rdpzyx1
       ec(76) =ec(76)+qcx*fpzzyy0 + wqx*fpzzyy1
       ec(77) =ec(77)+qcy*fpzzyy0 + wqy*fpzzyy1 +       rdpzzy1 + rfzzy1
       ec(78) =ec(78)+qcz*fpzzyy0 + wqz*fpzzyy1 + 2.0d0*rdpzyy1
       ec(79) =ec(79)+qcx*fpzzyz0 + wqx*fpzzyz1
       ec(80) =ec(80)+qcy*fpzzyz0 + wqy*fpzzyz1 +       rdpzzz1
       ec(81) =ec(81)+qcz*fpzzyz0 + wqz*fpzzyz1 + 2.0d0*rdpzyz1 + rfzzy1
       ec(82) =ec(82)+qcx*fpzyxx0 + wqx*fpzyxx1 +       rdpzyx1 + rfzyx1
       ec(83) =ec(83)+qcy*fpzyxx0 + wqy*fpzyxx1 +       rdpzxx1
       ec(84) =ec(84)+qcz*fpzyxx0 + wqz*fpzyxx1 +       rdpyxx1
       ec(85) =ec(85)+qcx*fpzyxy0 + wqx*fpzyxy1 +       rdpzyy1
       ec(86) =ec(86)+qcy*fpzyxy0 + wqy*fpzyxy1 +       rdpzxy1 + rfzyx1
       ec(87) =ec(87)+qcz*fpzyxy0 + wqz*fpzyxy1 +       rdpyxy1
       ec(88) =ec(88)+qcx*fpzyxz0 + wqx*fpzyxz1 +       rdpzyz1
       ec(89) =ec(89)+qcy*fpzyxz0 + wqy*fpzyxz1 +       rdpzxz1
       ec(90) =ec(90)+qcz*fpzyxz0 + wqz*fpzyxz1 +       rdpyxz1 + rfzyx1

                enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 

        do i=28,81
          ec(i)= ec(i)*root5
        enddo

        do i=82,90
          ec(i)= ec(i)*root15
        enddo

      endif
      
      end

!= fdss =============================================================
c  caluvate primitive gto fdss type  obara-method
c ===================================================================
      subroutine iofdss(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )


      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(60)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root3 / 1.73205080756887729352d+00 /
      data  root5 / 2.23606797749978969640d+00 /
      data  root15/ 3.87298334620741688517d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,60
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
            pbx = px - xyz(1,jatom)
            pby = py - xyz(2,jatom)
            pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(6)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f5   = (((((fdat(12,it)*dt6   + fdat(11,it))*dt5
     &                    + fdat(10,it))*dt4  + fdat(9,it))*dt3
     &                    + fdat(8,it))*dt2  + fdat(7,it))*dt
     &                    + fdat(6,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     dm4 =  3.5d0 *tinv *  dm3 
                     dm5 =  4.5d0 *tinv *  dm4 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)

                  rooz = zet*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
 
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
 
                  dxx3 = pax*px3 + wpx*px4+zet*(s3-rooz*s4)
                  dyy3 = pay*py3 + wpy*py4+zet*(s3-rooz*s4)
                  dzz3 = paz*pz3 + wpz*pz4+zet*(s3-rooz*s4)
                  dyx3 = pay*px3 + wpy*px4
!                 dzx3 = paz*px3 + wpz*px4
!                 dzy3 = paz*py3 + wpz*py4

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1
                  fzxx0 = paz*dxx0+wpz*dxx1
                  fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
                  fzzy0 = pay*dzz0+wpy*dzz1
                  fzyx0 = paz*dyx0+wpz*dyx1
                  
                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
                  fzxx1 = paz*dxx1+wpz*dxx2
                  fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
                  fzzy1 = pay*dzz1+wpy*dzz2
                  fzyx1 = paz*dyx1+wpz*dyx2

                  fxxx2 = pax*dxx2+wpx*dxx3 + 2.0d0*px23
                  fyyy2 = pay*dyy2+wpy*dyy3 + 2.0d0*py23
                  fzzz2 = paz*dzz2+wpz*dzz3 + 2.0d0*pz23
                  fyxx2 = pay*dxx2+wpy*dxx3
                  fzxx2 = paz*dxx2+wpz*dxx3
                  fyyx2 = pax*dyy2+wpx*dyy3
                  fzyy2 = paz*dyy2+wpz*dyy3
                  fzzx2 = pax*dzz2+wpx*dzz3
                  fzzy2 = pay*dzz2+wpy*dzz3
                  fzyx2 = paz*dyx2+wpz*dyx3

                  dxx01 = zet*(dxx0 - rooz*dxx1)
                  dyy01 = zet*(dyy0 - rooz*dyy1)
                  dzz01 = zet*(dzz0 - rooz*dzz1)
                  dyx01 = zet*(dyx0 - rooz*dyx1)
                  dzx01 = zet*(dzx0 - rooz*dzx1)
                  dzy01 = zet*(dzy0 - rooz*dzy1)
                  dxx12 = zet*(dxx1 - rooz*dxx2)
                  dyy12 = zet*(dyy1 - rooz*dyy2)
                  dzz12 = zet*(dzz1 - rooz*dzz2)
                  dyx12 = zet*(dyx1 - rooz*dyx2)
                  dzx12 = zet*(dzx1 - rooz*dzx2)
                  dzy12 = zet*(dzy1 - rooz*dzy2)

                  fpxxxx0 =pbx*fxxx0 + wpx*fxxx1 + 3.0d0*dxx01
                  fpxxxy0 =pby*fxxx0 + wpy*fxxx1
                  fpxxxz0 =pbz*fxxx0 + wpz*fxxx1
                  fpyyyx0 =pbx*fyyy0 + wpx*fyyy1
                  fpyyyy0 =pby*fyyy0 + wpy*fyyy1 + 3.0d0*dyy01
                  fpyyyz0 =pbz*fyyy0 + wpz*fyyy1
                  fpzzzx0 =pbx*fzzz0 + wpx*fzzz1
                  fpzzzy0 =pby*fzzz0 + wpy*fzzz1
                  fpzzzz0 =pbz*fzzz0 + wpz*fzzz1 + 3.0d0*dzz01
                  fpyxxx0 =pbx*fyxx0 + wpx*fyxx1 + 2.0d0*dyx01
                  fpyxxy0 =pby*fyxx0 + wpy*fyxx1 +       dxx01
                  fpyxxz0 =pbz*fyxx0 + wpz*fyxx1
                  fpzxxx0 =pbx*fzxx0 + wpx*fzxx1 + 2.0d0*dzx01
                  fpzxxy0 =pby*fzxx0 + wpy*fzxx1
                  fpzxxz0 =pbz*fzxx0 + wpz*fzxx1 +       dxx01
                  fpyyxx0 =pbx*fyyx0 + wpx*fyyx1 +       dyy01
                  fpyyxy0 =pby*fyyx0 + wpy*fyyx1 + 2.0d0*dyx01
                  fpyyxz0 =pbz*fyyx0 + wpz*fyyx1
                  fpzyyx0 =pbx*fzyy0 + wpx*fzyy1
                  fpzyyy0 =pby*fzyy0 + wpy*fzyy1 + 2.0d0*dzy01
                  fpzyyz0 =pbz*fzyy0 + wpz*fzyy1 +       dyy01
                  fpzzxx0 =pbx*fzzx0 + wpx*fzzx1 +       dzz01
                  fpzzxy0 =pby*fzzx0 + wpy*fzzx1
                  fpzzxz0 =pbz*fzzx0 + wpz*fzzx1 + 2.0d0*dzx01
                  fpzzyx0 =pbx*fzzy0 + wpx*fzzy1
                  fpzzyy0 =pby*fzzy0 + wpy*fzzy1 +       dzz01
                  fpzzyz0 =pbz*fzzy0 + wpz*fzzy1 + 2.0d0*dzy01
                  fpzyxx0 =pbx*fzyx0 + wpx*fzyx1 +       dzy01
                  fpzyxy0 =pby*fzyx0 + wpy*fzyx1 +       dzx01
                  fpzyxz0 =pbz*fzyx0 + wpz*fzyx1 +       dyx01

                  fpxxxx1 =pbx*fxxx1 + wpx*fxxx2 + 3.0d0*dxx12
                  fpxxxy1 =pby*fxxx1 + wpy*fxxx2
                  fpxxxz1 =pbz*fxxx1 + wpz*fxxx2
                  fpyyyx1 =pbx*fyyy1 + wpx*fyyy2
                  fpyyyy1 =pby*fyyy1 + wpy*fyyy2 + 3.0d0*dyy12
                  fpyyyz1 =pbz*fyyy1 + wpz*fyyy2
                  fpzzzx1 =pbx*fzzz1 + wpx*fzzz2
                  fpzzzy1 =pby*fzzz1 + wpy*fzzz2
                  fpzzzz1 =pbz*fzzz1 + wpz*fzzz2 + 3.0d0*dzz12
                  fpyxxx1 =pbx*fyxx1 + wpx*fyxx2 + 2.0d0*dyx12
                  fpyxxy1 =pby*fyxx1 + wpy*fyxx2 +       dxx12
                  fpyxxz1 =pbz*fyxx1 + wpz*fyxx2
                  fpzxxx1 =pbx*fzxx1 + wpx*fzxx2 + 2.0d0*dzx12
                  fpzxxy1 =pby*fzxx1 + wpy*fzxx2
                  fpzxxz1 =pbz*fzxx1 + wpz*fzxx2 +       dxx12
                  fpyyxx1 =pbx*fyyx1 + wpx*fyyx2 +       dyy12
                  fpyyxy1 =pby*fyyx1 + wpy*fyyx2 + 2.0d0*dyx12
                  fpyyxz1 =pbz*fyyx1 + wpz*fyyx2
                  fpzyyx1 =pbx*fzyy1 + wpx*fzyy2
                  fpzyyy1 =pby*fzyy1 + wpy*fzyy2 + 2.0d0*dzy12
                  fpzyyz1 =pbz*fzyy1 + wpz*fzyy2 +       dyy12
                  fpzzxx1 =pbx*fzzx1 + wpx*fzzx2 +       dzz12
                  fpzzxy1 =pby*fzzx1 + wpy*fzzx2
                  fpzzxz1 =pbz*fzzx1 + wpz*fzzx2 + 2.0d0*dzx12
                  fpzzyx1 =pbx*fzzy1 + wpx*fzzy2
                  fpzzyy1 =pby*fzzy1 + wpy*fzzy2 +       dzz12
                  fpzzyz1 =pbz*fzzy1 + wpz*fzzy2 + 2.0d0*dzy12
                  fpzyxx1 =pbx*fzyx1 + wpx*fzyx2 +       dzy12
                  fpzyxy1 =pby*fzyx1 + wpy*fzyx2 +       dzx12
                  fpzyxz1 =pbz*fzyx1 + wpz*fzyx2 +       dyx12

!                 rkp = rooz * eta
!                 wqx = wpx - qpx
!                 wqy = wpy - qpy
!                 wqz = wpz - qpz

                  fxxx01 = zet*(fxxx0 - rooz*fxxx1)
                  fyyy01 = zet*(fyyy0 - rooz*fyyy1)
                  fzzz01 = zet*(fzzz0 - rooz*fzzz1)
                  fyxx01 = zet*(fyxx0 - rooz*fyxx1)
                  fzxx01 = zet*(fzxx0 - rooz*fzxx1)
                  fyyx01 = zet*(fyyx0 - rooz*fyyx1)
                  fzyy01 = zet*(fzyy0 - rooz*fzyy1)
                  fzzx01 = zet*(fzzx0 - rooz*fzzx1)
                  fzzy01 = zet*(fzzy0 - rooz*fzzy1)
                  fzyx01 = zet*(fzyx0 - rooz*fzyx1)

       dpxxx0 =  pbx*dxx0 + wpx*dxx1 + 2.0d0*px01
       dpxxy0 =  pby*dxx0 + wpy*dxx1
       dpxxz0 =  pbz*dxx0 + wpz*dxx1
       dpyyx0 =  pbx*dyy0 + wpx*dyy1
       dpyyy0 =  pby*dyy0 + wpy*dyy1 + 2.0d0*py01
       dpyyz0 =  pbz*dyy0 + wpz*dyy1
       dpzzx0 =  pbx*dzz0 + wpx*dzz1
       dpzzy0 =  pby*dzz0 + wpy*dzz1
       dpzzz0 =  pbz*dzz0 + wpz*dzz1 + 2.0d0*pz01
       dpyxx0 =  pbx*dyx0 + wpx*dyx1 +       py01
       dpyxy0 =  pby*dyx0 + wpy*dyx1 +       px01
       dpyxz0 =  pbz*dyx0 + wpz*dyx1
       dpzxx0 =  pbx*dzx0 + wpx*dzx1 +       pz01
       dpzxy0 =  pby*dzx0 + wpy*dzx1
       dpzxz0 =  pbz*dzx0 + wpz*dzx1 +       px01
       dpzyx0 =  pbx*dzy0 + wpx*dzy1
       dpzyy0 =  pby*dzy0 + wpy*dzy1 +       pz01
       dpzyz0 =  pbz*dzy0 + wpz*dzy1 +       py01
       
       dpxxx1 =  pbx*dxx1 + wpx*dxx2 + 2.0d0*px12
       dpxxy1 =  pby*dxx1 + wpy*dxx2             
       dpxxz1 =  pbz*dxx1 + wpz*dxx2             
       dpyyx1 =  pbx*dyy1 + wpx*dyy2             
       dpyyy1 =  pby*dyy1 + wpy*dyy2 + 2.0d0*py12
       dpyyz1 =  pbz*dyy1 + wpz*dyy2             
       dpzzx1 =  pbx*dzz1 + wpx*dzz2             
       dpzzy1 =  pby*dzz1 + wpy*dzz2             
       dpzzz1 =  pbz*dzz1 + wpz*dzz2 + 2.0d0*pz12
       dpyxx1 =  pbx*dyx1 + wpx*dyx2 +       py12
       dpyxy1 =  pby*dyx1 + wpy*dyx2 +       px12
       dpyxz1 =  pbz*dyx1 + wpz*dyx2             
       dpzxx1 =  pbx*dzx1 + wpx*dzx2 +       pz12
       dpzxy1 =  pby*dzx1 + wpy*dzx2             
       dpzxz1 =  pbz*dzx1 + wpz*dzx2 +       px12
       dpzyx1 =  pbx*dzy1 + wpx*dzy2             
       dpzyy1 =  pby*dzy1 + wpy*dzy2 +       pz12
       dpzyz1 =  pbz*dzy1 + wpz*dzy2 +       py12
      
       dpxxx01 = zet * (dpxxx0 - rooz*dpxxx1)
       dpxxy01 = zet * (dpxxy0 - rooz*dpxxy1)
       dpxxz01 = zet * (dpxxz0 - rooz*dpxxz1)
       dpyyx01 = zet * (dpyyx0 - rooz*dpyyx1)
       dpyyy01 = zet * (dpyyy0 - rooz*dpyyy1)
       dpyyz01 = zet * (dpyyz0 - rooz*dpyyz1)
       dpzzx01 = zet * (dpzzx0 - rooz*dpzzx1)
       dpzzy01 = zet * (dpzzy0 - rooz*dpzzy1)
       dpzzz01 = zet * (dpzzz0 - rooz*dpzzz1)
       dpyxx01 = zet * (dpyxx0 - rooz*dpyxx1)
       dpyxy01 = zet * (dpyxy0 - rooz*dpyxy1)
       dpyxz01 = zet * (dpyxz0 - rooz*dpyxz1)
       dpzxx01 = zet * (dpzxx0 - rooz*dpzxx1)
       dpzxy01 = zet * (dpzxy0 - rooz*dpzxy1)
       dpzxz01 = zet * (dpzxz0 - rooz*dpzxz1)
       dpzyx01 = zet * (dpzyx0 - rooz*dpzyx1)
       dpzyy01 = zet * (dpzyy0 - rooz*dpzyy1)
       dpzyz01 = zet * (dpzyz0 - rooz*dpzyz1)

       ec( 1) =ec( 1)+pbx*fpxxxx0 + wpx*fpxxxx1 + 3.0d0*dpxxx01 + fxxx01
       ec( 2) =ec( 2)+pby*fpxxxy0 + wpy*fpxxxy1                 + fxxx01
       ec( 3) =ec( 3)+pbz*fpxxxz0 + wpz*fpxxxz1                 + fxxx01
       ec( 4) =ec( 4)+pby*fpxxxx0 + wpy*fpxxxx1
       ec( 5) =ec( 5)+pbz*fpxxxx0 + wpz*fpxxxx1
       ec( 6) =ec( 6)+pbz*fpxxxy0 + wpz*fpxxxy1
       ec( 7) =ec( 7)+pbx*fpyyyx0 + wpx*fpyyyx1                 + fyyy01
       ec( 8) =ec( 8)+pby*fpyyyy0 + wpy*fpyyyy1 + 3.0d0*dpyyy01 + fyyy01
       ec( 9) =ec( 9)+pbz*fpyyyz0 + wpz*fpyyyz1                 + fyyy01
       ec(10) =ec(10)+pbx*fpyyyy0 + wpx*fpyyyy1
       ec(11) =ec(11)+pbx*fpyyyz0 + wpx*fpyyyz1
       ec(12) =ec(12)+pbz*fpyyyy0 + wpz*fpyyyy1
       ec(13) =ec(13)+pbx*fpzzzx0 + wpx*fpzzzx1                 + fzzz01
       ec(14) =ec(14)+pby*fpzzzy0 + wpy*fpzzzy1                 + fzzz01
       ec(15) =ec(15)+pbz*fpzzzz0 + wpz*fpzzzz1 + 3.0d0*dpzzz01 + fzzz01
       ec(16) =ec(16)+pbx*fpzzzy0 + wpx*fpzzzy1                
       ec(17) =ec(17)+pbx*fpzzzz0 + wpx*fpzzzz1                
       ec(18) =ec(18)+pby*fpzzzz0 + wpy*fpzzzz1                
       ec(19) =ec(19)+pbx*fpyxxx0 + wpx*fpyxxx1 + 2.0d0*dpyxx01 + fyxx01
       ec(20) =ec(20)+pby*fpyxxy0 + wpy*fpyxxy1 +       dpxxy01 + fyxx01
       ec(21) =ec(21)+pbz*fpyxxz0 + wpz*fpyxxz1                 + fyxx01
       ec(22) =ec(22)+pby*fpyxxx0 + wpy*fpyxxx1 +       dpxxx01
       ec(23) =ec(23)+pbz*fpyxxx0 + wpz*fpyxxx1
       ec(24) =ec(24)+pbz*fpyxxy0 + wpz*fpyxxy1
       ec(25) =ec(25)+pbx*fpzxxx0 + wpx*fpzxxx1 + 2.0d0*dpzxx01 + fzxx01
       ec(26) =ec(26)+pby*fpzxxy0 + wpy*fpzxxy1                 + fzxx01
       ec(27) =ec(27)+pbz*fpzxxz0 + wpz*fpzxxz1 +       dpxxz01 + fzxx01
       ec(28) =ec(28)+pby*fpzxxx0 + wpy*fpzxxx1                         
       ec(29) =ec(29)+pbz*fpzxxx0 + wpz*fpzxxx1 +       dpxxx01
       ec(30) =ec(30)+pby*fpzxxz0 + wpy*fpzxxz1
       ec(31) =ec(31)+pbx*fpyyxx0 + wpx*fpyyxx1 +       dpyyx01 + fyyx01
       ec(32) =ec(32)+pby*fpyyxy0 + wpy*fpyyxy1 + 2.0d0*dpyxy01 + fyyx01
       ec(33) =ec(33)+pbz*fpyyxz0 + wpz*fpyyxz1                 + fyyx01
       ec(34) =ec(34)+pbx*fpyyxy0 + wpx*fpyyxy1 +       dpyyy01
       ec(35) =ec(35)+pbz*fpyyxx0 + wpz*fpyyxx1
       ec(36) =ec(36)+pbz*fpyyxy0 + wpz*fpyyxy1
       ec(37) =ec(37)+pbx*fpzyyx0 + wpx*fpzyyx1                 + fzyy01
       ec(38) =ec(38)+pby*fpzyyy0 + wpy*fpzyyy1 + 2.0d0*dpzyy01 + fzyy01
       ec(39) =ec(39)+pbz*fpzyyz0 + wpz*fpzyyz1 +       dpyyz01 + fzyy01
       ec(40) =ec(40)+pbx*fpzyyy0 + wpx*fpzyyy1
       ec(41) =ec(41)+pbx*fpzyyz0 + wpx*fpzyyz1
       ec(42) =ec(42)+pbz*fpzyyy0 + wpz*fpzyyy1 +       dpyyy01
       ec(43) =ec(43)+pbx*fpzzxx0 + wpx*fpzzxx1 +       dpzzx01 + fzzx01
       ec(44) =ec(44)+pby*fpzzxy0 + wpy*fpzzxy1                 + fzzx01
       ec(45) =ec(45)+pbz*fpzzxz0 + wpz*fpzzxz1 + 2.0d0*dpzxz01 + fzzx01
       ec(46) =ec(46)+pby*fpzzxx0 + wpy*fpzzxx1
       ec(47) =ec(47)+pbx*fpzzxz0 + wpx*fpzzxz1 +       dpzzz01
       ec(48) =ec(48)+pby*fpzzxz0 + wpy*fpzzxz1
       ec(49) =ec(49)+pbx*fpzzyx0 + wpx*fpzzyx1                 + fzzy01
       ec(50) =ec(50)+pby*fpzzyy0 + wpy*fpzzyy1 +       dpzzy01 + fzzy01
       ec(51) =ec(51)+pbz*fpzzyz0 + wpz*fpzzyz1 + 2.0d0*dpzyz01 + fzzy01
       ec(52) =ec(52)+pbx*fpzzyy0 + wpx*fpzzyy1
       ec(53) =ec(53)+pbx*fpzzyz0 + wpx*fpzzyz1
       ec(54) =ec(54)+pby*fpzzyz0 + wpy*fpzzyz1 +       dpzzz01
       ec(55) =ec(55)+pbx*fpzyxx0 + wpx*fpzyxx1 +       dpzyx01 + fzyx01
       ec(56) =ec(56)+pby*fpzyxy0 + wpy*fpzyxy1 +       dpzxy01 + fzyx01
       ec(57) =ec(57)+pbz*fpzyxz0 + wpz*fpzyxz1 +       dpyxz01 + fzyx01
       ec(58) =ec(58)+pbx*fpzyxy0 + wpx*fpzyxy1 +       dpzyy01         
       ec(59) =ec(59)+pbx*fpzyxz0 + wpx*fpzyxz1 +       dpzyz01         
       ec(60) =ec(60)+pby*fpzyxz0 + wpy*fpzyxz1 +       dpzxz01         

                enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 

        do i=19,54
          ec(i)= ec(i)*root5
        enddo

        do i=55,60
          ec(i)= ec(i)*root15
        enddo

        do i=1,60
           if (mod(i-1,6).ge.3) then
              ec(i) = ec(i) * root3
           endif
        enddo

      endif
      
      end

!= fspp =============================================================
c  caluvate primitive gto fspp type  obara-method
c ===================================================================
      subroutine iofspp(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )


      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(90)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root5 / 2.23606797749978969640d+00 /
      data  root15/ 3.87298334620741688517d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,90
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
c           pbx = px - xyz(1,jatom)
c           pby = py - xyz(2,jatom)
c           pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)

                  qdx =  yq(1,l,k) - xyz(1,latom)
                  qdy =  yq(2,l,k) - xyz(2,latom)
                  qdz =  yq(3,l,k) - xyz(3,latom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(6)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f5   = (((((fdat(12,it)*dt6   + fdat(11,it))*dt5
     &                    + fdat(10,it))*dt4  + fdat(9,it))*dt3
     &                    + fdat(8,it))*dt2  + fdat(7,it))*dt
     &                    + fdat(6,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     dm4 =  3.5d0 *tinv *  dm3 
                     dm5 =  4.5d0 *tinv *  dm4 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
 
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
 
                  dxx3 = pax*px3 + wpx*px4+zet*(s3-rooz*s4)
                  dyy3 = pay*py3 + wpy*py4+zet*(s3-rooz*s4)
                  dzz3 = paz*pz3 + wpz*pz4+zet*(s3-rooz*s4)
                  dyx3 = pay*px3 + wpy*px4
!                 dzx3 = paz*px3 + wpz*px4
!                 dzy3 = paz*py3 + wpz*py4

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1
                  fzxx0 = paz*dxx0+wpz*dxx1
                  fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
                  fzzy0 = pay*dzz0+wpy*dzz1
                  fzyx0 = paz*dyx0+wpz*dyx1
                  
                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
                  fzxx1 = paz*dxx1+wpz*dxx2
                  fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
                  fzzy1 = pay*dzz1+wpy*dzz2
                  fzyx1 = paz*dyx1+wpz*dyx2

                  fxxx2 = pax*dxx2+wpx*dxx3 + 2.0d0*px23
                  fyyy2 = pay*dyy2+wpy*dyy3 + 2.0d0*py23
                  fzzz2 = paz*dzz2+wpz*dzz3 + 2.0d0*pz23
                  fyxx2 = pay*dxx2+wpy*dxx3
                  fzxx2 = paz*dxx2+wpz*dxx3
                  fyyx2 = pax*dyy2+wpx*dyy3
                  fzyy2 = paz*dyy2+wpz*dyy3
                  fzzx2 = pax*dzz2+wpx*dzz3
                  fzzy2 = pay*dzz2+wpy*dzz3
                  fzyx2 = paz*dyx2+wpz*dyx3

!                 dxx01 = zet*(dxx0 - rooz*dxx1)
!                 dyy01 = zet*(dyy0 - rooz*dyy1)
!                 dzz01 = zet*(dzz0 - rooz*dzz1)
!                 dyx01 = zet*(dyx0 - rooz*dyx1)
!                 dzx01 = zet*(dzx0 - rooz*dzx1)
!                 dzy01 = zet*(dzy0 - rooz*dzy1)
!                 dxx12 = zet*(dxx1 - rooz*dxx2)
!                 dyy12 = zet*(dyy1 - rooz*dyy2)
!                 dzz12 = zet*(dzz1 - rooz*dzz2)
!                 dyx12 = zet*(dyx1 - rooz*dyx2)
!                 dzx12 = zet*(dzx1 - rooz*dzx2)
!                 dzy12 = zet*(dzy1 - rooz*dzy2)

                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz

                  rdxx1 = rkp * dxx1
                  rdyy1 = rkp * dyy1
                  rdzz1 = rkp * dzz1
                  rdyx1 = rkp * dyx1
                  rdzx1 = rkp * dzx1
                  rdzy1 = rkp * dzy1
                  rdxx2 = rkp * dxx2
                  rdyy2 = rkp * dyy2
                  rdzz2 = rkp * dzz2
                  rdyx2 = rkp * dyx2
                  rdzx2 = rkp * dzx2
                  rdzy2 = rkp * dzy2

                  fxxxpx0 =qcx*fxxx0 + wqx*fxxx1 + 3.0d0*rdxx1
                  fxxxpy0 =qcy*fxxx0 + wqy*fxxx1
                  fxxxpz0 =qcz*fxxx0 + wqz*fxxx1
                  fyyypx0 =qcx*fyyy0 + wqx*fyyy1
                  fyyypy0 =qcy*fyyy0 + wqy*fyyy1 + 3.0d0*rdyy1
                  fyyypz0 =qcz*fyyy0 + wqz*fyyy1
                  fzzzpx0 =qcx*fzzz0 + wqx*fzzz1
                  fzzzpy0 =qcy*fzzz0 + wqy*fzzz1
                  fzzzpz0 =qcz*fzzz0 + wqz*fzzz1 + 3.0d0*rdzz1
                  fyxxpx0 =qcx*fyxx0 + wqx*fyxx1 + 2.0d0*rdyx1
                  fyxxpy0 =qcy*fyxx0 + wqy*fyxx1 +       rdxx1
                  fyxxpz0 =qcz*fyxx0 + wqz*fyxx1
                  fzxxpx0 =qcx*fzxx0 + wqx*fzxx1 + 2.0d0*rdzx1
                  fzxxpy0 =qcy*fzxx0 + wqy*fzxx1
                  fzxxpz0 =qcz*fzxx0 + wqz*fzxx1 +       rdxx1
                  fyyxpx0 =qcx*fyyx0 + wqx*fyyx1 +       rdyy1
                  fyyxpy0 =qcy*fyyx0 + wqy*fyyx1 + 2.0d0*rdyx1
                  fyyxpz0 =qcz*fyyx0 + wqz*fyyx1
                  fzyypx0 =qcx*fzyy0 + wqx*fzyy1
                  fzyypy0 =qcy*fzyy0 + wqy*fzyy1 + 2.0d0*rdzy1
                  fzyypz0 =qcz*fzyy0 + wqz*fzyy1 +       rdyy1
                  fzzxpx0 =qcx*fzzx0 + wqx*fzzx1 +       rdzz1
                  fzzxpy0 =qcy*fzzx0 + wqy*fzzx1
                  fzzxpz0 =qcz*fzzx0 + wqz*fzzx1 + 2.0d0*rdzx1
                  fzzypx0 =qcx*fzzy0 + wqx*fzzy1
                  fzzypy0 =qcy*fzzy0 + wqy*fzzy1 +       rdzz1
                  fzzypz0 =qcz*fzzy0 + wqz*fzzy1 + 2.0d0*rdzy1
                  fzyxpx0 =qcx*fzyx0 + wqx*fzyx1 +       rdzy1
                  fzyxpy0 =qcy*fzyx0 + wqy*fzyx1 +       rdzx1
                  fzyxpz0 =qcz*fzyx0 + wqz*fzyx1 +       rdyx1

                  fxxxpx1 =qcx*fxxx1 + wqx*fxxx2 + 3.0d0*rdxx2
                  fxxxpy1 =qcy*fxxx1 + wqy*fxxx2
                  fxxxpz1 =qcz*fxxx1 + wqz*fxxx2
                  fyyypx1 =qcx*fyyy1 + wqx*fyyy2
                  fyyypy1 =qcy*fyyy1 + wqy*fyyy2 + 3.0d0*rdyy2
                  fyyypz1 =qcz*fyyy1 + wqz*fyyy2
                  fzzzpx1 =qcx*fzzz1 + wqx*fzzz2
                  fzzzpy1 =qcy*fzzz1 + wqy*fzzz2
                  fzzzpz1 =qcz*fzzz1 + wqz*fzzz2 + 3.0d0*rdzz2
                  fyxxpx1 =qcx*fyxx1 + wqx*fyxx2 + 2.0d0*rdyx2
                  fyxxpy1 =qcy*fyxx1 + wqy*fyxx2 +       rdxx2
                  fyxxpz1 =qcz*fyxx1 + wqz*fyxx2
                  fzxxpx1 =qcx*fzxx1 + wqx*fzxx2 + 2.0d0*rdzx2
                  fzxxpy1 =qcy*fzxx1 + wqy*fzxx2
                  fzxxpz1 =qcz*fzxx1 + wqz*fzxx2 +       rdxx2
                  fyyxpx1 =qcx*fyyx1 + wqx*fyyx2 +       rdyy2
                  fyyxpy1 =qcy*fyyx1 + wqy*fyyx2 + 2.0d0*rdyx2
                  fyyxpz1 =qcz*fyyx1 + wqz*fyyx2
                  fzyypx1 =qcx*fzyy1 + wqx*fzyy2
                  fzyypy1 =qcy*fzyy1 + wqy*fzyy2 + 2.0d0*rdzy2
                  fzyypz1 =qcz*fzyy1 + wqz*fzyy2 +       rdyy2
                  fzzxpx1 =qcx*fzzx1 + wqx*fzzx2 +       rdzz2
                  fzzxpy1 =qcy*fzzx1 + wqy*fzzx2
                  fzzxpz1 =qcz*fzzx1 + wqz*fzzx2 + 2.0d0*rdzx2
                  fzzypx1 =qcx*fzzy1 + wqx*fzzy2
                  fzzypy1 =qcy*fzzy1 + wqy*fzzy2 +       rdzz2
                  fzzypz1 =qcz*fzzy1 + wqz*fzzy2 + 2.0d0*rdzy2
                  fzyxpx1 =qcx*fzyx1 + wqx*fzyx2 +       rdzy2
                  fzyxpy1 =qcy*fzyx1 + wqy*fzyx2 +       rdzx2
                  fzyxpz1 =qcz*fzyx1 + wqz*fzyx2 +       rdyx2

                  fxxx01 =  eta*(fxxx0 - rooe*fxxx1)
                  fyyy01 =  eta*(fyyy0 - rooe*fyyy1)
                  fzzz01 =  eta*(fzzz0 - rooe*fzzz1)
                  fyxx01 =  eta*(fyxx0 - rooe*fyxx1)
                  fzxx01 =  eta*(fzxx0 - rooe*fzxx1)
                  fyyx01 =  eta*(fyyx0 - rooe*fyyx1)
                  fzyy01 =  eta*(fzyy0 - rooe*fzyy1)
                  fzzx01 =  eta*(fzzx0 - rooe*fzzx1)
                  fzzy01 =  eta*(fzzy0 - rooe*fzzy1)
                  fzyx01 =  eta*(fzyx0 - rooe*fzyx1)
      
      rpx2 = rkp * px2
      rpy2 = rkp * py2
      rpz2 = rkp * pz2
      
       rdpxxx1 = rkp * ( qcx*dxx1 + wqx*dxx2 + 2.0d0*rpx2 )
       rdpxxy1 = rkp * ( qcy*dxx1 + wqy*dxx2              )
       rdpxxz1 = rkp * ( qcz*dxx1 + wqz*dxx2              )
       rdpyyx1 = rkp * ( qcx*dyy1 + wqx*dyy2              )
       rdpyyy1 = rkp * ( qcy*dyy1 + wqy*dyy2 + 2.0d0*rpy2 )
       rdpyyz1 = rkp * ( qcz*dyy1 + wqz*dyy2              )
       rdpzzx1 = rkp * ( qcx*dzz1 + wqx*dzz2              )
       rdpzzy1 = rkp * ( qcy*dzz1 + wqy*dzz2              )
       rdpzzz1 = rkp * ( qcz*dzz1 + wqz*dzz2 + 2.0d0*rpz2 )
       rdpyxx1 = rkp * ( qcx*dyx1 + wqx*dyx2 +       rpy2 )
       rdpyxy1 = rkp * ( qcy*dyx1 + wqy*dyx2 +       rpx2 )
       rdpyxz1 = rkp * ( qcz*dyx1 + wqz*dyx2              )
       rdpzxx1 = rkp * ( qcx*dzx1 + wqx*dzx2 +       rpz2 )
       rdpzxy1 = rkp * ( qcy*dzx1 + wqy*dzx2              )
       rdpzxz1 = rkp * ( qcz*dzx1 + wqz*dzx2 +       rpx2 )
       rdpzyx1 = rkp * ( qcx*dzy1 + wqx*dzy2              )
       rdpzyy1 = rkp * ( qcy*dzy1 + wqy*dzy2 +       rpz2 )
       rdpzyz1 = rkp * ( qcz*dzy1 + wqz*dzy2 +       rpy2 )
      
       ec( 1) =ec( 1)+qdx*fxxxpx0 + wqx*fxxxpx1 + 3.0d0*rdpxxx1 + fxxx01
       ec( 2) =ec( 2)+qdy*fxxxpx0 + wqy*fxxxpx1                         
       ec( 3) =ec( 3)+qdz*fxxxpx0 + wqz*fxxxpx1                         
       ec( 4) =ec( 4)+qdx*fxxxpy0 + wqx*fxxxpy1 + 3.0d0*rdpxxy1         
       ec( 5) =ec( 5)+qdy*fxxxpy0 + wqy*fxxxpy1                 + fxxx01
       ec( 6) =ec( 6)+qdz*fxxxpy0 + wqz*fxxxpy1                         
       ec( 7) =ec( 7)+qdx*fxxxpz0 + wqx*fxxxpz1 + 3.0d0*rdpxxz1         
       ec( 8) =ec( 8)+qdy*fxxxpz0 + wqy*fxxxpz1                         
       ec( 9) =ec( 9)+qdz*fxxxpz0 + wqz*fxxxpz1                 + fxxx01
       ec(10) =ec(10)+qdx*fyyypx0 + wqx*fyyypx1                 + fyyy01
       ec(11) =ec(11)+qdy*fyyypx0 + wqy*fyyypx1 + 3.0d0*rdpyyx1         
       ec(12) =ec(12)+qdz*fyyypx0 + wqz*fyyypx1                         
       ec(13) =ec(13)+qdx*fyyypy0 + wqx*fyyypy1                         
       ec(14) =ec(14)+qdy*fyyypy0 + wqy*fyyypy1 + 3.0d0*rdpyyy1 + fyyy01
       ec(15) =ec(15)+qdz*fyyypy0 + wqz*fyyypy1                         
       ec(16) =ec(16)+qdx*fyyypz0 + wqx*fyyypz1                         
       ec(17) =ec(17)+qdy*fyyypz0 + wqy*fyyypz1 + 3.0d0*rdpyyz1         
       ec(18) =ec(18)+qdz*fyyypz0 + wqz*fyyypz1                 + fyyy01
       ec(19) =ec(19)+qdx*fzzzpx0 + wqx*fzzzpx1                 + fzzz01
       ec(20) =ec(20)+qdy*fzzzpx0 + wqy*fzzzpx1                         
       ec(21) =ec(21)+qdz*fzzzpx0 + wqz*fzzzpx1 + 3.0d0*rdpzzx1         
       ec(22) =ec(22)+qdx*fzzzpy0 + wqx*fzzzpy1                         
       ec(23) =ec(23)+qdy*fzzzpy0 + wqy*fzzzpy1                 + fzzz01
       ec(24) =ec(24)+qdz*fzzzpy0 + wqz*fzzzpy1 + 3.0d0*rdpzzy1         
       ec(25) =ec(25)+qdx*fzzzpz0 + wqx*fzzzpz1                         
       ec(26) =ec(26)+qdy*fzzzpz0 + wqy*fzzzpz1                         
       ec(27) =ec(27)+qdz*fzzzpz0 + wqz*fzzzpz1 + 3.0d0*rdpzzz1 + fzzz01
       ec(28) =ec(28)+qdx*fyxxpx0 + wqx*fyxxpx1 + 2.0d0*rdpyxx1 + fyxx01
       ec(29) =ec(29)+qdy*fyxxpx0 + wqy*fyxxpx1 +       rdpxxx1         
       ec(30) =ec(30)+qdz*fyxxpx0 + wqz*fyxxpx1                         
       ec(31) =ec(31)+qdx*fyxxpy0 + wqx*fyxxpy1 + 2.0d0*rdpyxy1         
       ec(32) =ec(32)+qdy*fyxxpy0 + wqy*fyxxpy1 +       rdpxxy1 + fyxx01
       ec(33) =ec(33)+qdz*fyxxpy0 + wqz*fyxxpy1                         
       ec(34) =ec(34)+qdx*fyxxpz0 + wqx*fyxxpz1 + 2.0d0*rdpyxz1         
       ec(35) =ec(35)+qdy*fyxxpz0 + wqy*fyxxpz1 +       rdpxxz1         
       ec(36) =ec(36)+qdz*fyxxpz0 + wqz*fyxxpz1                 + fyxx01
       ec(37) =ec(37)+qdx*fzxxpx0 + wqx*fzxxpx1 + 2.0d0*rdpzxx1 + fzxx01
       ec(38) =ec(38)+qdy*fzxxpx0 + wqy*fzxxpx1                         
       ec(39) =ec(39)+qdz*fzxxpx0 + wqz*fzxxpx1 +       rdpxxx1         
       ec(40) =ec(40)+qdx*fzxxpy0 + wqx*fzxxpy1 + 2.0d0*rdpzxy1         
       ec(41) =ec(41)+qdy*fzxxpy0 + wqy*fzxxpy1                 + fzxx01
       ec(42) =ec(42)+qdz*fzxxpy0 + wqz*fzxxpy1 +       rdpxxy1         
       ec(43) =ec(43)+qdx*fzxxpz0 + wqx*fzxxpz1 + 2.0d0*rdpzxz1         
       ec(44) =ec(44)+qdy*fzxxpz0 + wqy*fzxxpz1                         
       ec(45) =ec(45)+qdz*fzxxpz0 + wqz*fzxxpz1 +       rdpxxz1 + fzxx01
       ec(46) =ec(46)+qdx*fyyxpx0 + wqx*fyyxpx1 +       rdpyyx1 + fyyx01
       ec(47) =ec(47)+qdy*fyyxpx0 + wqy*fyyxpx1 + 2.0d0*rdpyxx1         
       ec(48) =ec(48)+qdz*fyyxpx0 + wqz*fyyxpx1                         
       ec(49) =ec(49)+qdx*fyyxpy0 + wqx*fyyxpy1 +       rdpyyy1         
       ec(50) =ec(50)+qdy*fyyxpy0 + wqy*fyyxpy1 + 2.0d0*rdpyxy1 + fyyx01
       ec(51) =ec(51)+qdz*fyyxpy0 + wqz*fyyxpy1                         
       ec(52) =ec(52)+qdx*fyyxpz0 + wqx*fyyxpz1 +       rdpyyz1         
       ec(53) =ec(53)+qdy*fyyxpz0 + wqy*fyyxpz1 + 2.0d0*rdpyxz1         
       ec(54) =ec(54)+qdz*fyyxpz0 + wqz*fyyxpz1                 + fyyx01
       ec(55) =ec(55)+qdx*fzyypx0 + wqx*fzyypx1                 + fzyy01
       ec(56) =ec(56)+qdy*fzyypx0 + wqy*fzyypx1 + 2.0d0*rdpzyx1         
       ec(57) =ec(57)+qdz*fzyypx0 + wqz*fzyypx1 +       rdpyyx1         
       ec(58) =ec(58)+qdx*fzyypy0 + wqx*fzyypy1                         
       ec(59) =ec(59)+qdy*fzyypy0 + wqy*fzyypy1 + 2.0d0*rdpzyy1 + fzyy01
       ec(60) =ec(60)+qdz*fzyypy0 + wqz*fzyypy1 +       rdpyyy1         
       ec(61) =ec(61)+qdx*fzyypz0 + wqx*fzyypz1                         
       ec(62) =ec(62)+qdy*fzyypz0 + wqy*fzyypz1 + 2.0d0*rdpzyz1         
       ec(63) =ec(63)+qdz*fzyypz0 + wqz*fzyypz1 +       rdpyyz1 + fzyy01
       ec(64) =ec(64)+qdx*fzzxpx0 + wqx*fzzxpx1 +       rdpzzx1 + fzzx01
       ec(65) =ec(65)+qdy*fzzxpx0 + wqy*fzzxpx1                         
       ec(66) =ec(66)+qdz*fzzxpx0 + wqz*fzzxpx1 + 2.0d0*rdpzxx1         
       ec(67) =ec(67)+qdx*fzzxpy0 + wqx*fzzxpy1 +       rdpzzy1         
       ec(68) =ec(68)+qdy*fzzxpy0 + wqy*fzzxpy1                 + fzzx01
       ec(69) =ec(69)+qdz*fzzxpy0 + wqz*fzzxpy1 + 2.0d0*rdpzxy1         
       ec(70) =ec(70)+qdx*fzzxpz0 + wqx*fzzxpz1 +       rdpzzz1         
       ec(71) =ec(71)+qdy*fzzxpz0 + wqy*fzzxpz1                         
       ec(72) =ec(72)+qdz*fzzxpz0 + wqz*fzzxpz1 + 2.0d0*rdpzxz1 + fzzx01
       ec(73) =ec(73)+qdx*fzzypx0 + wqx*fzzypx1                 + fzzy01
       ec(74) =ec(74)+qdy*fzzypx0 + wqy*fzzypx1 +       rdpzzx1         
       ec(75) =ec(75)+qdz*fzzypx0 + wqz*fzzypx1 + 2.0d0*rdpzyx1         
       ec(76) =ec(76)+qdx*fzzypy0 + wqx*fzzypy1                         
       ec(77) =ec(77)+qdy*fzzypy0 + wqy*fzzypy1 +       rdpzzy1 + fzzy01
       ec(78) =ec(78)+qdz*fzzypy0 + wqz*fzzypy1 + 2.0d0*rdpzyy1         
       ec(79) =ec(79)+qdx*fzzypz0 + wqx*fzzypz1                         
       ec(80) =ec(80)+qdy*fzzypz0 + wqy*fzzypz1 +       rdpzzz1         
       ec(81) =ec(81)+qdz*fzzypz0 + wqz*fzzypz1 + 2.0d0*rdpzyz1 + fzzy01
       ec(82) =ec(82)+qdx*fzyxpx0 + wqx*fzyxpx1 +       rdpzyx1 + fzyx01
       ec(83) =ec(83)+qdy*fzyxpx0 + wqy*fzyxpx1 +       rdpzxx1         
       ec(84) =ec(84)+qdz*fzyxpx0 + wqz*fzyxpx1 +       rdpyxx1         
       ec(85) =ec(85)+qdx*fzyxpy0 + wqx*fzyxpy1 +       rdpzyy1         
       ec(86) =ec(86)+qdy*fzyxpy0 + wqy*fzyxpy1 +       rdpzxy1 + fzyx01
       ec(87) =ec(87)+qdz*fzyxpy0 + wqz*fzyxpy1 +       rdpyxy1         
       ec(88) =ec(88)+qdx*fzyxpz0 + wqx*fzyxpz1 +       rdpzyz1         
       ec(89) =ec(89)+qdy*fzyxpz0 + wqy*fzyxpz1 +       rdpzxz1         
       ec(90) =ec(90)+qdz*fzyxpz0 + wqz*fzyxpz1 +       rdpyxz1 + fzyx01

                enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 

        do i=28,81
          ec(i)= ec(i)*root5
        enddo

        do i=82,90
          ec(i)= ec(i)*root15
        enddo

      endif
      
      end

!= fsds =============================================================
c  caluvate primitive gto fsds type  obara-method
c ===================================================================
      subroutine iofsds(
     &           ec   ,
     &           fdat ,  edat  ,
     &           yp   ,  yq    ,     
     &           uu   ,  uv    ,
     &           z    ,  zetpq ,  xyz   ,  
     &           nasp ,  mxsa  ,  mxprm ,  ntprm,  natom,
     &           iasp ,  jasp  ,  kasp  ,  lasp ,
     &           ishel,  jshel ,  kshel ,  lshel,
     &           iatom,  jatom ,  katom ,  latom,
     &           ierisw                           )


      implicit real(8) (a-h,o-z)           
      dimension fdat(31,2001)
      dimension tf(25),rminv(5)
      dimension edat(2001)
      dimension z(mxprm,mxsa,nasp)

      dimension xyz(3,natom)
      dimension zetpq(mxprm,mxprm,mxsa,nasp,mxsa,nasp)
      dimension yp(3,mxprm,mxprm)
      dimension yq(3,mxprm,mxprm)
      dimension uu(mxprm,mxprm)
      dimension uv(mxprm,mxprm)
      dimension ntprm(mxsa,nasp)
!     dimension kyssap(mxsa,nasp)

      dimension ec(60)

      data      pi / 3.14159265358979323846d+00 /
c      data      sqrt_pi5 / 1.2533141373155001208d+00 /
      data      (tf(i),i=1,25) /
     &                33.0,37.0,41.0,43.0,46.0,49.0,
     &                51.0,54.0,56.0,58.0,61.0,63.0,
     &                66.0,68.0,70.0,72.0,74.0,80.0,
     &                85.0,90.0,95.0,95.0,98.0,99.0,
     &                99.0                           /

      data  ga0   / 1.0d+00 /
      data  ga1   / 1.000 000 000 000 005 298d+00 /
      data  ga2   / 0.5d+00 /
      data  ga3   / 0.166 666 666 598 849 826d+00 /
      data  ga4   / 0.416 666 666 666 666 667d-01 /
      data  ga5   / 0.833 355 034 722 222 222d-02 /
      data  ga6   / 0.138 888 888 888 888 889d-02 /

      data      (rminv(i),i=1,5 ) /
     &   1.0d+00,  0.333333333333333333d+00,  0.20d+00,
     &   0.14285714285714286d+00,  0.11111111111111111d+00 /

      data  root3 / 1.73205080756887729352d+00 /
      data  root5 / 2.23606797749978969640d+00 /
      data  root15/ 3.87298334620741688517d+00 /


!     iysp = kyssap(ishel,iasp)
!     jysp = kyssap(jshel,jasp)
!     kysp = kyssap(kshel,kasp)
!     lysp = kyssap(lshel,lasp)

      igp = ntprm(ishel,iasp)
      jgp = ntprm(jshel,jasp)
      kgp = ntprm(kshel,kasp)
      lgp = ntprm(lshel,lasp)

      pi2 = 2.0d0*pi

      do i = 1,60
        ec(i) = 0.0d0
      enddo

      do i = 1, igp
         do j = 1, jgp
            zet = zetpq(j,i,jshel,jasp,ishel,iasp)
            px  = yp (1,j,i)
            py  = yp (2,j,i) 
            pz  = yp (3,j,i)
            up  = uu  (j,i)
            
c     up_rpi = up * sqrt_pi5
            
            pax = px - xyz(1,iatom)
            pay = py - xyz(2,iatom)
            paz = pz - xyz(3,iatom)
c           pbx = px - xyz(1,jatom)
c           pby = py - xyz(2,jatom)
c           pbz = pz - xyz(3,jatom)
            
            do k = 1, kgp
               do l = 1, lgp
                  eta = zetpq(l,k,lshel,lasp,kshel,kasp)
                  qpx =  yq(1,l,k) - px
                  qpy =  yq(2,l,k) - py
                  qpz =  yq(3,l,k) - pz
                  vq  = uv  (l,k)
                  roo2 = 1.0d0 / (zet + eta)
 
                  qcx =  yq(1,l,k) - xyz(1,katom)
                  qcy =  yq(2,l,k) - xyz(2,katom)
                  qcz =  yq(3,l,k) - xyz(3,katom)

!                 qdx =  yq(1,l,k) - xyz(1,latom)
!                 qdy =  yq(2,l,k) - xyz(2,latom)
!                 qdz =  yq(3,l,k) - xyz(3,latom)

                  qp2  = qpx*qpx + qpy*qpy + qpz*qpz
                  t    = 0.5d0 * roo2 * qp2

                  if (t. le .tf(6)) then

                     it = idint((t+0.025d+00)*20.0d+00)
                     dt = 0.05d+00*it - t
                     it = it + 1
                     dt4 = dt*0.25d+00
                     dt5 = dt*0.2d+00
                     dt6 = dt*0.166666666666666667d+00
                     dt2 = dt4 + dt4
                     dt3 = dt6 + dt6
                     f5   = (((((fdat(12,it)*dt6   + fdat(11,it))*dt5
     &                    + fdat(10,it))*dt4  + fdat(9,it))*dt3
     &                    + fdat(8,it))*dt2  + fdat(7,it))*dt
     &                    + fdat(6,it)
                     
                     eed  = (((((ga6*dt + ga5)*dt + ga4)*dt
     &                    + ga3)*dt + ga2)*dt + ga1)*dt + ga0
                     ee   = edat(it)*eed
                     
                     t2   = t*2.0d0
                     
                     f4   = (t2*f5 + ee)*rminv(5)
                     f3   = (t2*f4 + ee)*rminv(4)
                     f2   = (t2*f3 + ee)*rminv(3)
                     f1   = (t2*f2 + ee)*rminv(2)
                     f0   =  t2*f1 + ee
                     fpp =  up * vq * dsqrt(roo2)
                     dm0 = fpp*f0
                     dm1 = fpp*f1! *  roo2
                     dm2 = fpp*f2! *( roo2)**2
                     dm3 = fpp*f3! *( roo2)**3
                     dm4 = fpp*f4! *( roo2)**3
                     dm5 = fpp*f5! *( roo2)**3
                     
                  else
                     qinv = 1.0d0/qp2
                     tinv = 1.0d0/ t
                     dm0=  up*vq*dsqrt( pi2*qinv)*0.5d0
c     dm0=  vq * dsqrt(qinv) * up_rpi
                     dm1 =  0.5d0 *tinv *  dm0 
                     dm2 =  1.5d0 *tinv *  dm1 
                     dm3 =  2.5d0 *tinv *  dm2 
                     dm4 =  3.5d0 *tinv *  dm3 
                     dm5 =  4.5d0 *tinv *  dm4 
                     
                  end if
                  
                  s0 = dm0
                  s1 = dm1      !/  roo2
                  s2 = dm2      !/( roo2**2)
                  s3 = dm3      !/( roo2**3)
                  s4 = dm4      !/( roo2**3)
                  s5 = dm5      !/( roo2**3)

                  rooz = zet*roo2
                  rooe = eta*roo2
                  wpx = rooz * qpx
                  wpy = rooz * qpy
                  wpz = rooz * qpz
                  
                  px0 = pax*s0 + wpx*s1
                  py0 = pay*s0 + wpy*s1
                  pz0 = paz*s0 + wpz*s1
                  px1 = pax*s1 + wpx*s2
                  py1 = pay*s1 + wpy*s2
                  pz1 = paz*s1 + wpz*s2
                  px2 = pax*s2 + wpx*s3
                  py2 = pay*s2 + wpy*s3
                  pz2 = paz*s2 + wpz*s3
                  px3 = pax*s3 + wpx*s4
                  py3 = pay*s3 + wpy*s4
                  pz3 = paz*s3 + wpz*s4
                  px4 = pax*s4 + wpx*s5
                  py4 = pay*s4 + wpy*s5
                  pz4 = paz*s4 + wpz*s5
 
                  dxx0 = pax*px0 + wpx*px1+zet*(s0-rooz*s1)
                  dyy0 = pay*py0 + wpy*py1+zet*(s0-rooz*s1)
                  dzz0 = paz*pz0 + wpz*pz1+zet*(s0-rooz*s1)
                  dyx0 = pay*px0 + wpy*px1
                  dzx0 = paz*px0 + wpz*px1
                  dzy0 = paz*py0 + wpz*py1

                  dxx1 = pax*px1 + wpx*px2+zet*(s1-rooz*s2)
                  dyy1 = pay*py1 + wpy*py2+zet*(s1-rooz*s2)
                  dzz1 = paz*pz1 + wpz*pz2+zet*(s1-rooz*s2)
                  dyx1 = pay*px1 + wpy*px2
                  dzx1 = paz*px1 + wpz*px2
                  dzy1 = paz*py1 + wpz*py2
                  
                  dxx2 = pax*px2 + wpx*px3+zet*(s2-rooz*s3)
                  dyy2 = pay*py2 + wpy*py3+zet*(s2-rooz*s3)
                  dzz2 = paz*pz2 + wpz*pz3+zet*(s2-rooz*s3)
                  dyx2 = pay*px2 + wpy*px3
                  dzx2 = paz*px2 + wpz*px3
                  dzy2 = paz*py2 + wpz*py3
 
                  dxx3 = pax*px3 + wpx*px4+zet*(s3-rooz*s4)
                  dyy3 = pay*py3 + wpy*py4+zet*(s3-rooz*s4)
                  dzz3 = paz*pz3 + wpz*pz4+zet*(s3-rooz*s4)
                  dyx3 = pay*px3 + wpy*px4
!                 dzx3 = paz*px3 + wpz*px4
!                 dzy3 = paz*py3 + wpz*py4

                  px01 = zet*(px0-rooz*px1)
                  py01 = zet*(py0-rooz*py1)
                  pz01 = zet*(pz0-rooz*pz1)
                  px12 = zet*(px1-rooz*px2)
                  py12 = zet*(py1-rooz*py2)
                  pz12 = zet*(pz1-rooz*pz2)
                  px23 = zet*(px2-rooz*px3)
                  py23 = zet*(py2-rooz*py3)
                  pz23 = zet*(pz2-rooz*pz3)
                  
                  fxxx0 = pax*dxx0+wpx*dxx1 + 2.0d0*px01
                  fyyy0 = pay*dyy0+wpy*dyy1 + 2.0d0*py01
                  fzzz0 = paz*dzz0+wpz*dzz1 + 2.0d0*pz01
                  fyxx0 = pay*dxx0+wpy*dxx1
                  fzxx0 = paz*dxx0+wpz*dxx1
                  fyyx0 = pax*dyy0+wpx*dyy1
                  fzyy0 = paz*dyy0+wpz*dyy1
                  fzzx0 = pax*dzz0+wpx*dzz1
                  fzzy0 = pay*dzz0+wpy*dzz1
                  fzyx0 = paz*dyx0+wpz*dyx1
                  
                  fxxx1 = pax*dxx1+wpx*dxx2 + 2.0d0*px12
                  fyyy1 = pay*dyy1+wpy*dyy2 + 2.0d0*py12
                  fzzz1 = paz*dzz1+wpz*dzz2 + 2.0d0*pz12
                  fyxx1 = pay*dxx1+wpy*dxx2
                  fzxx1 = paz*dxx1+wpz*dxx2
                  fyyx1 = pax*dyy1+wpx*dyy2
                  fzyy1 = paz*dyy1+wpz*dyy2
                  fzzx1 = pax*dzz1+wpx*dzz2
                  fzzy1 = pay*dzz1+wpy*dzz2
                  fzyx1 = paz*dyx1+wpz*dyx2

                  fxxx2 = pax*dxx2+wpx*dxx3 + 2.0d0*px23
                  fyyy2 = pay*dyy2+wpy*dyy3 + 2.0d0*py23
                  fzzz2 = paz*dzz2+wpz*dzz3 + 2.0d0*pz23
                  fyxx2 = pay*dxx2+wpy*dxx3
                  fzxx2 = paz*dxx2+wpz*dxx3
                  fyyx2 = pax*dyy2+wpx*dyy3
                  fzyy2 = paz*dyy2+wpz*dyy3
                  fzzx2 = pax*dzz2+wpx*dzz3
                  fzzy2 = pay*dzz2+wpy*dzz3
                  fzyx2 = paz*dyx2+wpz*dyx3

                  rkp = rooz * eta
                  wqx = wpx - qpx
                  wqy = wpy - qpy
                  wqz = wpz - qpz

                  rdxx1 = rkp * dxx1
                  rdyy1 = rkp * dyy1
                  rdzz1 = rkp * dzz1
                  rdyx1 = rkp * dyx1
                  rdzx1 = rkp * dzx1
                  rdzy1 = rkp * dzy1
                  rdxx2 = rkp * dxx2
                  rdyy2 = rkp * dyy2
                  rdzz2 = rkp * dzz2
                  rdyx2 = rkp * dyx2
                  rdzx2 = rkp * dzx2
                  rdzy2 = rkp * dzy2

                  fxxxpx0 =qcx*fxxx0 + wqx*fxxx1 + 3.0d0*rdxx1
                  fxxxpy0 =qcy*fxxx0 + wqy*fxxx1
                  fxxxpz0 =qcz*fxxx0 + wqz*fxxx1
                  fyyypx0 =qcx*fyyy0 + wqx*fyyy1
                  fyyypy0 =qcy*fyyy0 + wqy*fyyy1 + 3.0d0*rdyy1
                  fyyypz0 =qcz*fyyy0 + wqz*fyyy1
                  fzzzpx0 =qcx*fzzz0 + wqx*fzzz1
                  fzzzpy0 =qcy*fzzz0 + wqy*fzzz1
                  fzzzpz0 =qcz*fzzz0 + wqz*fzzz1 + 3.0d0*rdzz1
                  fyxxpx0 =qcx*fyxx0 + wqx*fyxx1 + 2.0d0*rdyx1
                  fyxxpy0 =qcy*fyxx0 + wqy*fyxx1 +       rdxx1
                  fyxxpz0 =qcz*fyxx0 + wqz*fyxx1
                  fzxxpx0 =qcx*fzxx0 + wqx*fzxx1 + 2.0d0*rdzx1
                  fzxxpy0 =qcy*fzxx0 + wqy*fzxx1
                  fzxxpz0 =qcz*fzxx0 + wqz*fzxx1 +       rdxx1
                  fyyxpx0 =qcx*fyyx0 + wqx*fyyx1 +       rdyy1
                  fyyxpy0 =qcy*fyyx0 + wqy*fyyx1 + 2.0d0*rdyx1
                  fyyxpz0 =qcz*fyyx0 + wqz*fyyx1
                  fzyypx0 =qcx*fzyy0 + wqx*fzyy1
                  fzyypy0 =qcy*fzyy0 + wqy*fzyy1 + 2.0d0*rdzy1
                  fzyypz0 =qcz*fzyy0 + wqz*fzyy1 +       rdyy1
                  fzzxpx0 =qcx*fzzx0 + wqx*fzzx1 +       rdzz1
                  fzzxpy0 =qcy*fzzx0 + wqy*fzzx1
                  fzzxpz0 =qcz*fzzx0 + wqz*fzzx1 + 2.0d0*rdzx1
                  fzzypx0 =qcx*fzzy0 + wqx*fzzy1
                  fzzypy0 =qcy*fzzy0 + wqy*fzzy1 +       rdzz1
                  fzzypz0 =qcz*fzzy0 + wqz*fzzy1 + 2.0d0*rdzy1
                  fzyxpx0 =qcx*fzyx0 + wqx*fzyx1 +       rdzy1
                  fzyxpy0 =qcy*fzyx0 + wqy*fzyx1 +       rdzx1
                  fzyxpz0 =qcz*fzyx0 + wqz*fzyx1 +       rdyx1

                  fxxxpx1 =qcx*fxxx1 + wqx*fxxx2 + 3.0d0*rdxx2
                  fxxxpy1 =qcy*fxxx1 + wqy*fxxx2
                  fxxxpz1 =qcz*fxxx1 + wqz*fxxx2
                  fyyypx1 =qcx*fyyy1 + wqx*fyyy2
                  fyyypy1 =qcy*fyyy1 + wqy*fyyy2 + 3.0d0*rdyy2
                  fyyypz1 =qcz*fyyy1 + wqz*fyyy2
                  fzzzpx1 =qcx*fzzz1 + wqx*fzzz2
                  fzzzpy1 =qcy*fzzz1 + wqy*fzzz2
                  fzzzpz1 =qcz*fzzz1 + wqz*fzzz2 + 3.0d0*rdzz2
                  fyxxpx1 =qcx*fyxx1 + wqx*fyxx2 + 2.0d0*rdyx2
                  fyxxpy1 =qcy*fyxx1 + wqy*fyxx2 +       rdxx2
                  fyxxpz1 =qcz*fyxx1 + wqz*fyxx2
                  fzxxpx1 =qcx*fzxx1 + wqx*fzxx2 + 2.0d0*rdzx2
                  fzxxpy1 =qcy*fzxx1 + wqy*fzxx2
                  fzxxpz1 =qcz*fzxx1 + wqz*fzxx2 +       rdxx2
                  fyyxpx1 =qcx*fyyx1 + wqx*fyyx2 +       rdyy2
                  fyyxpy1 =qcy*fyyx1 + wqy*fyyx2 + 2.0d0*rdyx2
                  fyyxpz1 =qcz*fyyx1 + wqz*fyyx2
                  fzyypx1 =qcx*fzyy1 + wqx*fzyy2
                  fzyypy1 =qcy*fzyy1 + wqy*fzyy2 + 2.0d0*rdzy2
                  fzyypz1 =qcz*fzyy1 + wqz*fzyy2 +       rdyy2
                  fzzxpx1 =qcx*fzzx1 + wqx*fzzx2 +       rdzz2
                  fzzxpy1 =qcy*fzzx1 + wqy*fzzx2
                  fzzxpz1 =qcz*fzzx1 + wqz*fzzx2 + 2.0d0*rdzx2
                  fzzypx1 =qcx*fzzy1 + wqx*fzzy2
                  fzzypy1 =qcy*fzzy1 + wqy*fzzy2 +       rdzz2
                  fzzypz1 =qcz*fzzy1 + wqz*fzzy2 + 2.0d0*rdzy2
                  fzyxpx1 =qcx*fzyx1 + wqx*fzyx2 +       rdzy2
                  fzyxpy1 =qcy*fzyx1 + wqy*fzyx2 +       rdzx2
                  fzyxpz1 =qcz*fzyx1 + wqz*fzyx2 +       rdyx2

                  fxxx01 =  eta*(fxxx0 - rooe*fxxx1)
                  fyyy01 =  eta*(fyyy0 - rooe*fyyy1)
                  fzzz01 =  eta*(fzzz0 - rooe*fzzz1)
                  fyxx01 =  eta*(fyxx0 - rooe*fyxx1)
                  fzxx01 =  eta*(fzxx0 - rooe*fzxx1)
                  fyyx01 =  eta*(fyyx0 - rooe*fyyx1)
                  fzyy01 =  eta*(fzyy0 - rooe*fzyy1)
                  fzzx01 =  eta*(fzzx0 - rooe*fzzx1)
                  fzzy01 =  eta*(fzzy0 - rooe*fzzy1)
                  fzyx01 =  eta*(fzyx0 - rooe*fzyx1)
      
       rpx2 = rkp * px2
       rpy2 = rkp * py2
       rpz2 = rkp * pz2
      
       rdpxxx1 = rkp * ( qcx*dxx1 + wqx*dxx2 + 2.0d0*rpx2 )
       rdpxxy1 = rkp * ( qcy*dxx1 + wqy*dxx2              )
       rdpxxz1 = rkp * ( qcz*dxx1 + wqz*dxx2              )
       rdpyyx1 = rkp * ( qcx*dyy1 + wqx*dyy2              )
       rdpyyy1 = rkp * ( qcy*dyy1 + wqy*dyy2 + 2.0d0*rpy2 )
       rdpyyz1 = rkp * ( qcz*dyy1 + wqz*dyy2              )
       rdpzzx1 = rkp * ( qcx*dzz1 + wqx*dzz2              )
       rdpzzy1 = rkp * ( qcy*dzz1 + wqy*dzz2              )
       rdpzzz1 = rkp * ( qcz*dzz1 + wqz*dzz2 + 2.0d0*rpz2 )
       rdpyxx1 = rkp * ( qcx*dyx1 + wqx*dyx2 +       rpy2 )
       rdpyxy1 = rkp * ( qcy*dyx1 + wqy*dyx2 +       rpx2 )
       rdpyxz1 = rkp * ( qcz*dyx1 + wqz*dyx2              )
       rdpzxx1 = rkp * ( qcx*dzx1 + wqx*dzx2 +       rpz2 )
       rdpzxy1 = rkp * ( qcy*dzx1 + wqy*dzx2              )
       rdpzxz1 = rkp * ( qcz*dzx1 + wqz*dzx2 +       rpx2 )
       rdpzyx1 = rkp * ( qcx*dzy1 + wqx*dzy2              )
       rdpzyy1 = rkp * ( qcy*dzy1 + wqy*dzy2 +       rpz2 )
       rdpzyz1 = rkp * ( qcz*dzy1 + wqz*dzy2 +       rpy2 )
      
       ec( 1) =ec( 1)+qcx*fxxxpx0 + wqx*fxxxpx1 + 3.0d0*rdpxxx1 + fxxx01
       ec( 2) =ec( 2)+qcy*fxxxpy0 + wqy*fxxxpy1                 + fxxx01
       ec( 3) =ec( 3)+qcz*fxxxpz0 + wqz*fxxxpz1                 + fxxx01
       ec( 4) =ec( 4)+qcy*fxxxpx0 + wqy*fxxxpx1
       ec( 5) =ec( 5)+qcz*fxxxpx0 + wqz*fxxxpx1
       ec( 6) =ec( 6)+qcz*fxxxpy0 + wqz*fxxxpy1
       ec( 7) =ec( 7)+qcx*fyyypx0 + wqx*fyyypx1                 + fyyy01
       ec( 8) =ec( 8)+qcy*fyyypy0 + wqy*fyyypy1 + 3.0d0*rdpyyy1 + fyyy01
       ec( 9) =ec( 9)+qcz*fyyypz0 + wqz*fyyypz1                 + fyyy01
       ec(10) =ec(10)+qcx*fyyypy0 + wqx*fyyypy1
       ec(11) =ec(11)+qcx*fyyypz0 + wqx*fyyypz1
       ec(12) =ec(12)+qcz*fyyypy0 + wqz*fyyypy1
       ec(13) =ec(13)+qcx*fzzzpx0 + wqx*fzzzpx1                 + fzzz01
       ec(14) =ec(14)+qcy*fzzzpy0 + wqy*fzzzpy1                 + fzzz01
       ec(15) =ec(15)+qcz*fzzzpz0 + wqz*fzzzpz1 + 3.0d0*rdpzzz1 + fzzz01
       ec(16) =ec(16)+qcx*fzzzpy0 + wqx*fzzzpy1               
       ec(17) =ec(17)+qcx*fzzzpz0 + wqx*fzzzpz1               
       ec(18) =ec(18)+qcy*fzzzpz0 + wqy*fzzzpz1               
       ec(19) =ec(19)+qcx*fyxxpx0 + wqx*fyxxpx1 + 2.0d0*rdpyxx1 + fyxx01
       ec(20) =ec(20)+qcy*fyxxpy0 + wqy*fyxxpy1 +       rdpxxy1 + fyxx01
       ec(21) =ec(21)+qcz*fyxxpz0 + wqz*fyxxpz1                 + fyxx01
       ec(22) =ec(22)+qcy*fyxxpx0 + wqy*fyxxpx1 +       rdpxxx1
       ec(23) =ec(23)+qcz*fyxxpx0 + wqz*fyxxpx1
       ec(24) =ec(24)+qcz*fyxxpy0 + wqz*fyxxpy1
       ec(25) =ec(25)+qcx*fzxxpx0 + wqx*fzxxpx1 + 2.0d0*rdpzxx1 + fzxx01
       ec(26) =ec(26)+qcy*fzxxpy0 + wqy*fzxxpy1                 + fzxx01
       ec(27) =ec(27)+qcz*fzxxpz0 + wqz*fzxxpz1 +       rdpxxz1 + fzxx01
       ec(28) =ec(28)+qcy*fzxxpx0 + wqy*fzxxpx1                        
       ec(29) =ec(29)+qcz*fzxxpx0 + wqz*fzxxpx1 +       rdpxxx1
       ec(30) =ec(30)+qcy*fzxxpz0 + wqy*fzxxpz1
       ec(31) =ec(31)+qcx*fyyxpx0 + wqx*fyyxpx1 +       rdpyyx1 + fyyx01
       ec(32) =ec(32)+qcy*fyyxpy0 + wqy*fyyxpy1 + 2.0d0*rdpyxy1 + fyyx01
       ec(33) =ec(33)+qcz*fyyxpz0 + wqz*fyyxpz1                 + fyyx01
       ec(34) =ec(34)+qcx*fyyxpy0 + wqx*fyyxpy1 +       rdpyyy1
       ec(35) =ec(35)+qcz*fyyxpx0 + wqz*fyyxpx1
       ec(36) =ec(36)+qcz*fyyxpy0 + wqz*fyyxpy1
       ec(37) =ec(37)+qcx*fzyypx0 + wqx*fzyypx1                 + fzyy01
       ec(38) =ec(38)+qcy*fzyypy0 + wqy*fzyypy1 + 2.0d0*rdpzyy1 + fzyy01
       ec(39) =ec(39)+qcz*fzyypz0 + wqz*fzyypz1 +       rdpyyz1 + fzyy01
       ec(40) =ec(40)+qcx*fzyypy0 + wqx*fzyypy1
       ec(41) =ec(41)+qcx*fzyypz0 + wqx*fzyypz1
       ec(42) =ec(42)+qcz*fzyypy0 + wqz*fzyypy1 +       rdpyyy1
       ec(43) =ec(43)+qcx*fzzxpx0 + wqx*fzzxpx1 +       rdpzzx1 + fzzx01
       ec(44) =ec(44)+qcy*fzzxpy0 + wqy*fzzxpy1                 + fzzx01
       ec(45) =ec(45)+qcz*fzzxpz0 + wqz*fzzxpz1 + 2.0d0*rdpzxz1 + fzzx01
       ec(46) =ec(46)+qcy*fzzxpx0 + wqy*fzzxpx1
       ec(47) =ec(47)+qcx*fzzxpz0 + wqx*fzzxpz1 +       rdpzzz1
       ec(48) =ec(48)+qcy*fzzxpz0 + wqy*fzzxpz1
       ec(49) =ec(49)+qcx*fzzypx0 + wqx*fzzypx1                 + fzzy01
       ec(50) =ec(50)+qcy*fzzypy0 + wqy*fzzypy1 +       rdpzzy1 + fzzy01
       ec(51) =ec(51)+qcz*fzzypz0 + wqz*fzzypz1 + 2.0d0*rdpzyz1 + fzzy01
       ec(52) =ec(52)+qcx*fzzypy0 + wqx*fzzypy1
       ec(53) =ec(53)+qcx*fzzypz0 + wqx*fzzypz1
       ec(54) =ec(54)+qcy*fzzypz0 + wqy*fzzypz1 +       rdpzzz1
       ec(55) =ec(55)+qcx*fzyxpx0 + wqx*fzyxpx1 +       rdpzyx1 + fzyx01
       ec(56) =ec(56)+qcy*fzyxpy0 + wqy*fzyxpy1 +       rdpzxy1 + fzyx01
       ec(57) =ec(57)+qcz*fzyxpz0 + wqz*fzyxpz1 +       rdpyxz1 + fzyx01
       ec(58) =ec(58)+qcx*fzyxpy0 + wqx*fzyxpy1 +       rdpzyy1         
       ec(59) =ec(59)+qcx*fzyxpz0 + wqx*fzyxpz1 +       rdpzyz1         
       ec(60) =ec(60)+qcy*fzyxpz0 + wqy*fzyxpz1 +       rdpzxz1         


                enddo
            enddo
         enddo
      enddo

      if (ierisw.eq.0) then 

        do i=19,54
          ec(i)= ec(i)*root5
        enddo

        do i=55,60
          ec(i)= ec(i)*root15
        enddo

        do i=1,60
           if (mod(i-1,6).ge.3) then
              ec(i) = ec(i) * root3
           endif
        enddo
      endif
 
      end
