! -*- coding: utf-8 -*-
!
! Dual licensed under the MIT or GPL Version 3 license.
! See 'LICENSE.MIT' for the definition of the MIT license,
! and 'COPYING' for the definition of the GPL license.
!
CC IMDSSS ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DSSS
C ===================================================================

      subroutine imdsss(
     &           ec   ,
     &           xyz  ,  dsss ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )

      implicit real(8)(a-h,o-z)

      dimension dsss(12)
      dimension xyz(3,natom)
      dimension tiu(9)
      dimension o1(9), p1(9)
      dimension ec(mvhgp)

      data      root3 / 1.73205080756887729353d+00 /
      
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)

      Z001000  =  dsss( 1)
      Z022000  =  dsss( 2)
      U002000  =  dsss( 3)
      U012000  =  dsss( 4)
      U012101  =  dsss( 5)
      U113000  =  dsss( 6)
      D002000  =  dsss( 7)
      D002101  =  dsss( 8)
      D002202  =  dsss( 9)
      D103000  =  dsss(10)
      D103101  =  dsss(11)
      D204000  =  dsss(12)

      o1(1) = +D204000+U113000+U113000+Z022000
      o1(4) = +D103101+U012101
      o1(7) = +D103000+U012000
      o1(2) = +D103101+U012101
      o1(5) = +D002202
      o1(8) = +D002101
      o1(3) = +D103000+U012000
      o1(6) = +D002101
      o1(9) = +D002000

      do2   = Z001000 - U002000

      do ij=1,9
         p1(ij) = 0.0d0
      enddo

      do i=1,3
         kyo1 = i
         kyo2 = i + 3
         kyo3 = i + 6

         do j=1,3
            ky = i + (j-1) * 3
            p1(ky) = 0
!           do l = 1,3

            kyt1 = 3*j - 2
            kyt2 = 3*j - 1
            kyt3 = 3*j

            p1(ky) = p1(ky) + o1(kyo1) * tiu(kyt1)
            p1(ky) = p1(ky) + o1(kyo2) * tiu(kyt2)
            p1(ky) = p1(ky) + o1(kyo3) * tiu(kyt3)
!           enddo
         enddo
      enddo

      do i=1,3
         kyo1 = 3*i - 2
         kyo2 = 3*i - 1
         kyo3 = 3*i

         do j=1,3
            ky = i + (j-1) * 3
            o1(ky) = 0
!           do l = 1,3

             kyt1 = 3*j - 2
             kyt2 = 3*j - 1
             kyt3 = 3*j

             o1(ky) = o1(ky) + p1(kyo1) * tiu(kyt1)
             o1(ky) = o1(ky) + p1(kyo2) * tiu(kyt2)
             o1(ky) = o1(ky) + p1(kyo3) * tiu(kyt3)
!            enddo
         enddo
      enddo

      ec(1) = o1(1) + do2
      ec(2) = o1(5) + do2
      ec(3) = o1(9) + do2
      
      if (ierisw.eq.0) then
         ec(4) = o1(4) * root3
         ec(5) = o1(7) * root3
         ec(6) = o1(8) * root3
      else
         ec(4) = o1(4)
         ec(5) = o1(7)
         ec(6) = o1(8)
      endif
      end
      
CC IMDSPS ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DSPS
C ===================================================================

      subroutine imdsps(
     &           ec   ,
     &           xyz  ,  dsps ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )
      
      implicit real(8)(a-h,o-z)
      
      dimension dsps(39)
      dimension xyz(3,natom)
      dimension tiu(9),tkw(9)
      dimension o1(9),o2(9),o3(9),o4(3),o5(3),o6(3)
      dimension p1(9),b2(3),b3(3),pps(27),qqq(27)
      dimension p2(9),p3(9)
      dimension ec(mvhgp)
      
      data      root3 / 1.73205080756887729353d+00 /
 
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)
      tkw(1)=-tiu(1)
      tkw(4)=-tiu(4)
      tkw(7)=-tiu(7)
      tkw(2)=-tiu(2)
      tkw(5)=-tiu(5)
      tkw(8)=-tiu(8)
      tkw(3)=-tiu(3)
      tkw(6)=-tiu(6)
      tkw(9)=-tiu(9)

C**   KERNEL DSPS =====================================================
C     CALCULATE & CONTRACT KERNELS FOR DSPS TYPE
C     1:T002001  8:T204001 15:D002112 22:D103112 29:U002011 36:U113011
C     2:T002102  9:T204102 16:D002213 23:D113001 30:U012001 37:U123001
C     3:T002203 10:T305001 17:D012001 24:D113102 31:U012011 38:Z001011
C     4:T002304 11:D002000 18:D012102 25:D204011 32:U012112 39:Z022011
C     5:T103001 12:D002001 19:D012203 26:D214001 33:U022001
C     6:T103102 13:D002011 20:D103001 27:U001001 34:U022102
C     7:T103203 14:D002102 21:D103011 28:U001102 35:U102001
      
      T002001 =dsps( 1)
      T002102 =dsps( 2)
      T002203 =dsps( 3)
      T002304 =dsps( 4)
      T103001 =dsps( 5)
      T103102 =dsps( 6)
      T103203 =dsps( 7)
      T204001 =dsps( 8)
      T204102 =dsps( 9)
      T305001 =dsps(10)
      
      D002000 =dsps(11)
      D002001 =dsps(12)
      D002011 =dsps(13)
      D002102 =dsps(14)
      D002112 =dsps(15)
      D002213 =dsps(16)
      D012001 =dsps(17)
      D012102 =dsps(18)
      D012203 =dsps(19)
      D103001 =dsps(20)
      D103011 =dsps(21)
      D103112 =dsps(22)
      D113001 =dsps(23)
      D113102 =dsps(24)
      D204011 =dsps(25)
      D214001 =dsps(26)

      U001001 =dsps(27)
      U001102 =dsps(28)
      U002011 =dsps(29)
      U012001 =dsps(30)
      U012011 =dsps(31)
      U012112 =dsps(32)
      U022001 =dsps(33)
      U022102 =dsps(34)
      U102001 =dsps(35)
      U113011 =dsps(36)
      U123001 =dsps(37)

      Z001011 =dsps(38)
      Z022011 =dsps(39)
      
      O1(1)= +D214001+D214001+T305001+U123001
      O1(4)= +D113102+D113102+D204011+T204102
     &       +U022102+U113011+U113011+Z022011
      O1(7)= +D113001+D113001+T204001+U022001
      O1(2)= +D113102+T204102
      O1(5)= +D012203+D103112+T103203+U012112
      O1(8)= +D012102+T103102
      O1(3)= +D113001+T204001
      O1(6)= +D012102+D103011+T103102+U012011
      O1(9)= +D012001+T103001
      
      O2(1)= +D113102+T204102
      O2(4)= +D012203+D103112+T103203+U012112
      O2(7)= +D012102+T103102
      O2(2)= +T103203
      O2(5)= +D002213+T002304
      O2(8)= +T002203
      O2(3)= +T103102
      O2(6)= +D002112+T002203
      O2(9)= +T002102
     
      O3(1)= +D113001+T204001
      O3(4)= +D012102+D103011+T103102+U012011
      O3(7)= +D012001+T103001
      O3(2)= +T103102
      O3(5)= +D002112+T002203
      O3(8)= +T002102
      O3(3)= +T103001
      O3(6)= +D002011+T002102
      O3(9)= +T002001

      O4(1)= +U012001+D103001
      O4(2)= +D002102
      O4(3)= +D002001
     
      O5(1)= U012001+D103001
      O5(2)= D002102
      O5(3)= D002001

      O6(1)= U102001-D103001
      O6(2)= Z001011+U001102-U002011-D002102
      O6(3)= U001001-D002001

      do i=1,3
         b2(i) = 0
         b3(i) = 0
         kyt1 = 3*i - 2
         kyt2 = 3*i - 1
         kyt3 = 3*i

!        do l = 1,3 
            b2(i) = b2(i) + tiu(kyt1) * o5(1)
            b2(i) = b2(i) + tiu(kyt2) * o5(2)
            b2(i) = b2(i) + tiu(kyt3) * o5(3)

            b3(i) = b3(i) + tkw(kyt1) * o6(1)
            b3(i) = b3(i) + tkw(kyt2) * o6(2)
            b3(i) = b3(i) + tkw(kyt3) * o6(3)
!        enddo
      enddo

      do i= 1,3
         kyo1 = i 
         kyo2 = i + 3
         kyo3 = i + 6
         do j=1,3
            ky = i + (j-1)*3
            p1(ky) = 0
            p2(ky) = 0
            p3(ky) = 0
!           do l = 1,3

               kyt1 = 3*j - 2
               kyt2 = 3*j - 1
               kyt3 = 3*j


               p1(ky) = p1(ky) + o1(kyo1) * tkw(kyt1)
               p1(ky) = p1(ky) + o1(kyo2) * tkw(kyt2)
               p1(ky) = p1(ky) + o1(kyo3) * tkw(kyt3)

               p2(ky) = p2(ky) + o2(kyo1) * tkw(kyt1)
               p2(ky) = p2(ky) + o2(kyo2) * tkw(kyt2)
               p2(ky) = p2(ky) + o2(kyo3) * tkw(kyt3)

               p3(ky) = p3(ky) + o3(kyo1) * tkw(kyt1)
               p3(ky) = p3(ky) + o3(kyo2) * tkw(kyt2)
               p3(ky) = p3(ky) + o3(kyo3) * tkw(kyt3)
!           enddo
         enddo
      enddo

      do i= 1,3
         kyo1 = 3*i - 2
         kyo2 = 3*i - 1
         kyo3 = 3*i

         do j=1,3
            ky = i + (j-1)*3
            o1(ky) = 0
            o2(ky) = 0
            o3(ky) = 0
!           do l = 1,3
               kyt1 = 3*j - 2
               kyt2 = 3*j - 1
               kyt3 = 3*j

 
               o1(ky) = o1(ky) + p1(kyo1) * tiu(kyt1)
               o1(ky) = o1(ky) + p1(kyo2) * tiu(kyt2)
               o1(ky) = o1(ky) + p1(kyo3) * tiu(kyt3)

               o2(ky) = o2(ky) + p2(kyo1) * tiu(kyt1)
               o2(ky) = o2(ky) + p2(kyo2) * tiu(kyt2)
               o2(ky) = o2(ky) + p2(kyo3) * tiu(kyt3)

               o3(ky) = o3(ky) + p3(kyo1) * tiu(kyt1)
               o3(ky) = o3(ky) + p3(kyo2) * tiu(kyt2)
               o3(ky) = o3(ky) + p3(kyo3) * tiu(kyt3)
!           enddo
         enddo
      enddo
      
      qqq( 1) = O1(1)+O4(1)
      qqq( 2) = O1(2)
      qqq( 3) = O1(3)
      qqq(10) = O2(1)+O4(2)
      qqq(11) = O2(2)
      qqq(12) = O2(3)
      qqq(19) = O3(1)+O4(3)
      qqq(20) = O3(2)
      qqq(21) = O3(3)
       
      qqq( 4) = O1(4)
      qqq( 5) = O1(5)+O4(1)
      qqq( 6) = O1(6)
      qqq(13) = O2(4)
      qqq(14) = O2(5)+O4(2)
      qqq(15) = O2(6)
      qqq(22) = O3(4)
      qqq(23) = O3(5)+O4(3)
      qqq(24) = O3(6)
       
      qqq( 7) = O1(7)
      qqq( 8) = O1(8)
      qqq( 9) = O1(9)+O4(1)
      qqq(16) = O2(7)
      qqq(17) = O2(8)
      qqq(18) = O2(9)+O4(2)
      qqq(25) = O3(7)
      qqq(26) = O3(8)
      qqq(27) = O3(9)+O4(3)
      
      call ipgemm(9,pps,qqq,tiu)
      
      ec( 1) = PPS( 1)+B2(1)+B3(1)
      ec( 2) = PPS( 2)      +B3(2)
      ec( 3) = PPS( 3)      +B3(3)
      
      ec( 4) = PPS(13)      +B3(1)
      ec( 5) = PPS(14)+B2(2)+B3(2)
      ec( 6) = PPS(15)      +B3(3)
      
      ec( 7) = PPS(25)      +B3(1)
      ec( 8) = PPS(26)      +B3(2)
      ec( 9) = PPS(27)+B2(3)+B3(3)
      
      ec(10) = PPS(10)
      ec(11) = PPS(11)+B2(1)
      ec(12) = PPS(12)
      
      ec(13) = PPS(19)
      ec(14) = PPS(20)
      ec(15) = PPS(21)+B2(1)
      
      ec(16) = PPS(22)
      ec(17) = PPS(23)
      ec(18) = PPS(24)+B2(2)
      
      if (ierisw.eq.0) then 
         do ir = 10,18
            ec(ir) = ec(ir) * root3
         enddo
      endif
      
      end
CC IMDPSS ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DPSS
C ===================================================================
      
      subroutine imdpss(
     &           ec   ,
     &           xyz  ,  dpss ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )

      
      implicit real(8)(a-h,o-z)
      
      dimension dpss(38)
      dimension xyz(3,natom)
      dimension tiu(9)
      dimension o1(9),o2(9),o3(9),o4(3),o5(3),o6(3)
      dimension pps(27),qqq(27),p1(9),p2(9),p3(9),b2(3),b3(3)
      dimension ec(mvhgp)
      
      data      root3 / 1.73205080756887729353d+00 /
      
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)

      T003000 =dpss( 1)
      T003101 =dpss( 2)
      T003202 =dpss( 3)
      T003303 =dpss( 4)
      T104000 =dpss( 5)
      T104101 =dpss( 6)
      T104202 =dpss( 7)
      T205000 =dpss( 8)
      T205101 =dpss( 9)
      T306000 =dpss(10)
      D013000 =dpss(11)
      D013101 =dpss(12)
      D013202 =dpss(13)
      D103000 =dpss(14)
      D103101 =dpss(15)
      D103202 =dpss(16)
      D114000 =dpss(17)
      D114101 =dpss(18)
      D204000 =dpss(19)
      D204101 =dpss(20)
      D215000 =dpss(21)
      D305000 =dpss(22)
      U002000 =dpss(23)
      U002101 =dpss(24)
      D003000 =dpss(25)
      D003101 =dpss(26)
      U013000 =dpss(27)
      U023000 =dpss(28)
      U023101 =dpss(29)
      U103000 =dpss(30)
      D104000 =dpss(31)
      U113000 =dpss(32)
      U113101 =dpss(33)
      U124000 =dpss(34)
      U214000 =dpss(35)
      Z012000 =dpss(36)
      Z102000 =dpss(37)
      Z123000 =dpss(38)
 
      O1(1)= +D215000+D215000+T306000+U124000
     &       -D305000-U214000-U214000-Z123000
      O1(4)= +D114101+D114101+T205101+U023101
      O1(7)= +D114000+D114000+T205000+U023000
      O1(2)= +D114101+T205101-D204101-U113101
      O1(5)= +D013202+T104202
      O1(8)= +D013101+T104101
      O1(3)= +D114000+T205000-D204000-U113000
      O1(6)= +D013101+T104101
      O1(9)= +D013000+T104000
      
      O2(1)= +D114101+T205101-D204101-U113101
      O2(4)= +D013202+T104202
      O2(7)= +D013101+T104101
      O2(2)= +T104202-D103202
      O2(5)= +T003303
      O2(8)= +T003202
      O2(3)= +T104101-D103101
      O2(6)= +T003202
      O2(9)= +T003101
      
      O3(1)= +D114000+T205000-D204000-U113000
      O3(4)= +D013101+T104101
      O3(7)= +D013000+T104000
      O3(2)= +T104101-D103101
      O3(5)= +T003202
      O3(8)= +T003101
      O3(3)= +T104000-D103000
      O3(6)= +T003101
      O3(9)= +T003000
      
      O4(1)= +Z012000+U103000-U013000-D104000
      O4(2)= +U002101-D003101
      O4(3)= +U002000-D003000
      
      O5(1)= +Z012000+U103000-U013000-D104000
      O5(2)= +U002101-D003101
      O5(3)= +U002000-D003000
      
      O6(1)= -Z102000+U103000+U103000-D104000
      O6(2)= +U002101-D003101
      O6(3)= +U002000-D003000
      do i=1,3
         b2(i) = 0
         b3(i) = 0
         kyt1 = 3*i - 2
         kyt2 = 3*i - 1
         kyt3 = 3*i

!        do l = 1,3 
            b2(i) = b2(i) + tiu(kyt1) * o5(1)
            b2(i) = b2(i) + tiu(kyt2) * o5(2)
            b2(i) = b2(i) + tiu(kyt3) * o5(3)

            b3(i) = b3(i) + tiu(kyt1) * o6(1)
            b3(i) = b3(i) + tiu(kyt2) * o6(2)
            b3(i) = b3(i) + tiu(kyt3) * o6(3)
!        enddo
      enddo

      do i= 1,3
         kyo1 = i 
         kyo2 = i + 3
         kyo3 = i + 6
         do j=1,3
            ky = i + (j-1)*3
            p1(ky) = 0
            p2(ky) = 0
            p3(ky) = 0
!           do l = 1,3

               kyt1 = 3*j - 2
               kyt2 = 3*j - 1
               kyt3 = 3*j


               p1(ky) = p1(ky) + o1(kyo1) * tiu(kyt1)
               p1(ky) = p1(ky) + o1(kyo2) * tiu(kyt2)
               p1(ky) = p1(ky) + o1(kyo3) * tiu(kyt3)

               p2(ky) = p2(ky) + o2(kyo1) * tiu(kyt1)
               p2(ky) = p2(ky) + o2(kyo2) * tiu(kyt2)
               p2(ky) = p2(ky) + o2(kyo3) * tiu(kyt3)

               p3(ky) = p3(ky) + o3(kyo1) * tiu(kyt1)
               p3(ky) = p3(ky) + o3(kyo2) * tiu(kyt2)
               p3(ky) = p3(ky) + o3(kyo3) * tiu(kyt3)
!           enddo
         enddo
      enddo

      do i= 1,3
         kyo1 = 3*i - 2
         kyo2 = 3*i - 1
         kyo3 = 3*i

         do j=1,3
            ky = i + (j-1)*3
            o1(ky) = 0
            o2(ky) = 0
            o3(ky) = 0
!           do l = 1,3
               kyt1 = 3*j - 2
               kyt2 = 3*j - 1
               kyt3 = 3*j

 
               o1(ky) = o1(ky) + p1(kyo1) * tiu(kyt1)
               o1(ky) = o1(ky) + p1(kyo2) * tiu(kyt2)
               o1(ky) = o1(ky) + p1(kyo3) * tiu(kyt3)

               o2(ky) = o2(ky) + p2(kyo1) * tiu(kyt1)
               o2(ky) = o2(ky) + p2(kyo2) * tiu(kyt2)
               o2(ky) = o2(ky) + p2(kyo3) * tiu(kyt3)

               o3(ky) = o3(ky) + p3(kyo1) * tiu(kyt1)
               o3(ky) = o3(ky) + p3(kyo2) * tiu(kyt2)
               o3(ky) = o3(ky) + p3(kyo3) * tiu(kyt3)
!           enddo
         enddo
      enddo
       
      qqq( 1) = O1(1)+O4(1)
      qqq( 2) = O1(2)
      qqq( 3) = O1(3)
      qqq(10) = O2(1)+O4(2)
      qqq(11) = O2(2)
      qqq(12) = O2(3)
      qqq(19) = O3(1)+O4(3)
      qqq(20) = O3(2)
      qqq(21) = O3(3)
       
      qqq( 4) = O1(4)
      qqq( 5) = O1(5)+O4(1)
      qqq( 6) = O1(6)
      qqq(13) = O2(4)
      qqq(14) = O2(5)+O4(2)
      qqq(15) = O2(6)
      qqq(22) = O3(4)
      qqq(23) = O3(5)+O4(3)
      qqq(24) = O3(6)
       
      qqq( 7) = O1(7)
      qqq( 8) = O1(8)
      qqq( 9) = O1(9)+O4(1)
      qqq(16) = O2(7)
      qqq(17) = O2(8)
      qqq(18) = O2(9)+O4(2)
      qqq(25) = O3(7)
      qqq(26) = O3(8)
      qqq(27) = O3(9)+O4(3)
      
      call ipgemm (9,pps,qqq,tiu)

      ec( 1) = PPS( 1)+B2(1)+B3(1)
      ec( 2) = PPS( 2)      +B3(2)
      ec( 3) = PPS( 3)      +B3(3)
      ec( 4) = PPS(13)      +B3(1)
      ec( 5) = PPS(14)+B2(2)+B3(2)
      ec( 6) = PPS(15)      +B3(3)
      ec( 7) = PPS(25)      +B3(1)
      ec( 8) = PPS(26)      +B3(2)
      ec( 9) = PPS(27)+B2(3)+B3(3)
      ec(10) = PPS(10)
      ec(11) = PPS(11)+B2(1)
      ec(12) = PPS(12)
      ec(13) = PPS(19)
      ec(14) = PPS(20)
      ec(15) = PPS(21)+B2(1)
      ec(16) = PPS(22)
      ec(17) = PPS(23)
      ec(18) = PPS(24)+B2(2)
      
      if (ierisw.eq.0) then 
         do ir =10,18
            ec(ir) = ec(ir)*root3
         enddo
      endif
      
      end
CC IMDSPP ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DSPP
C ===================================================================

      SUBROUTINE imdspp(
     &           ec   ,
     &           xyz  ,  dspp ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )


      IMPLICIT REAL(8)(a-h,o-z)

      DIMENSION dspp(121)
      DIMENSION xyz(3,natom)
      DIMENSION tiu(9),tkw(9)
      DIMENSION o1(9),o2(9),o3(9),o4(9),o5(9),o6(9)
      DIMENSION o7(9),o8(9),o9(9)
      DIMENSION d1(9),d2(9),d3(9),d4(9),d5(9),d6(9)
      DIMENSION p1(9),b2(9),b3(9),ppp(81),qqq(81)
      DIMENSION ec(mvhgp)

      DATA      root3 / 1.73205080756887729353d+00 /
 
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)
      tkw(1)=-tiu(1)
      tkw(4)=-tiu(4)
      tkw(7)=-tiu(7)
      tkw(2)=-tiu(2)
      tkw(5)=-tiu(5)
      tkw(8)=-tiu(8)
      tkw(3)=-tiu(3)
      tkw(6)=-tiu(6)
      tkw(9)=-tiu(9)
C** BEGIN PRISM DSPP L2 STEP =========================================
C                    DSPP WITH BLAS
C ====================================================================
      F002002=dspp( 1)
      F002103=dspp( 2)
      F002204=dspp( 3)
      F002305=dspp( 4)
      F002406=dspp( 5)
      F103002=dspp( 6)
      F103103=dspp( 7)
      F103204=dspp( 8)
      F103305=dspp( 9)
      F204002=dspp(10)
      F204103=dspp(11)
      F204204=dspp(12)
      F305002=dspp(13)
      F305103=dspp(14)
      F406002=dspp(15)
      
      T002002=dspp(16)
      T002012=dspp(17)
      T002102=dspp(18)
      T002103=dspp(19)
      T002113=dspp(20)
      T002203=dspp(21)
      T002204=dspp(22)
      T002214=dspp(23)
      T002304=dspp(24)
      T002315=dspp(25)
      T002405=dspp(26)
      T012002=dspp(27)
      T012103=dspp(28)
      T012204=dspp(29)
      T012305=dspp(30)
      T103002=dspp(31)
      T103012=dspp(32)
      T103102=dspp(33)
      T103103=dspp(34)
      T103113=dspp(35)
      T103203=dspp(36)
      T103214=dspp(37)
      T103304=dspp(38)
      T113002=dspp(39)
      T113103=dspp(40)
      T113204=dspp(41)
      T204002=dspp(42)
      T204012=dspp(43)
      T204102=dspp(44)
      T204113=dspp(45)
      T204203=dspp(46)
      T214002=dspp(47)
      T214103=dspp(48)
      T305012=dspp(49)
      T305102=dspp(50)
      T315002=dspp(51)
      
      D001002=dspp(52)
      D001103=dspp(53)
      D001204=dspp(54)
      D002001=dspp(55)
      D002002=dspp(56)
      D002012=dspp(57)
      D002102=dspp(58)
      D002112=dspp(59)
      D002113=dspp(60)
      D002203=dspp(61)
      D002213=dspp(62)
      D002314=dspp(63)
      D012002=dspp(64)
      D012012=dspp(65)
      D012102=dspp(66)
      D012103=dspp(67)
      D012113=dspp(68)
      D012203=dspp(69)
      D012214=dspp(70)
      D012304=dspp(71)
      D022002=dspp(72)
      D022103=dspp(73)
      D022204=dspp(74)
      D102002=dspp(75)
      D102103=dspp(76)
      D103001=dspp(77)
      D103012=dspp(78)
      D103102=dspp(79)
      D103112=dspp(80)
      D103213=dspp(81)
      D113002=dspp(82)
      D113012=dspp(83)
      D113102=dspp(84)
      D113113=dspp(85)
      D113203=dspp(86)
      D123002=dspp(87)
      D123103=dspp(88)
      D203002=dspp(89)
      D204001=dspp(90)
      D204112=dspp(91)
      D214012=dspp(92)
      D214102=dspp(93)
      D224002=dspp(94)
      
      U001002=dspp(95)
      U001012=dspp(96)
      U001102=dspp(97)
      U001113=dspp(98)
      U001203=dspp(99)
      U002001=dspp(100)
      U002112=dspp(101)
      U012001=dspp(102)
      U012012=dspp(103)
      U012102=dspp(104)
      U012112=dspp(105)
      U012213=dspp(106)
      U022002=dspp(107)
      U022012=dspp(108)
      U022102=dspp(109)
      U022113=dspp(110)
      U022203=dspp(111)
      U102012=dspp(112)
      U102102=dspp(113)
      U113001=dspp(114)
      U113112=dspp(115)
      U123012=dspp(116)
      U123102=dspp(117)
      
      Z001001=dspp(118)
      Z001112=dspp(119)
      Z022001=dspp(120)
      Z022112=dspp(121)
      
      O1(1)= +D224002+F406002+T315002+T315002
      O1(4)= +D123103+F305103+T214103+T214103
     &       -D214102-D214102-T305102-U123102
      O1(7)= +D123002+F305002+T214002+T214002
      O1(2)= +D123103+D214012+D214012+F305103
     &       +T214103+T214103+T305012+U123012
      O1(5)= +D022204+D113113+D113113+F204204
     &       +T113204+T113204+T204113+U022113
     &       -D113203-D113203-D204112-T204203
     &       -U022203-U113112-U113112-Z022112
      O1(8)= +D022103+D113012+D113012+F204103
     &       +T113103+T113103+T204012+U022012
      O1(3)= +D123002+F305002+T214002+T214002
      O1(6)= +D022103+F204103+T113103+T113103
     &       -D113102-D113102-T204102-U022102
      O1(9)= +D022002+F204002+T113002+T113002
      
      O2(1)= +F305103+T214103
      O2(4)= +F204204+T113204-D113203-T204203
      O2(7)= +F204103+T113103
      O2(2)= +D113113+F204204+T113204+T204113
      O2(5)= +D012214+F103305+T012305+T103214
     &       -D012304-D103213-T103304-U012213
      O2(8)= +D012113+F103204+T012204+T103113
      O2(3)= +F204103+T113103
      O2(6)= +F103204+T012204-D012203-T103203
      O2(9)= +F103103+T012103
      
      O3(1)= +F305002+T214002
      O3(4)= +F204103+T113103-D113102-T204102
      O3(7)= +F204002+T113002
      O3(2)= +D113012+F204103+T113103+T204012
      O3(5)= +D012113+F103204+T012204+T103113
     &       -D012203-D103112-T103203-U012112
      O3(8)= +D012012+F103103+T012103+T103012
      O3(3)= +F204002+T113002
      O3(6)= +F103103+T012103-D012102-T103102
      O3(9)= +F103002+T012002
      
      O4(1)= +F305103+T214103
      O4(4)= +F204204+T113204-D113203-T204203
      O4(7)= +F204103+T113103
      O4(2)= +D113113+F204204+T113204+T204113
      O4(5)= +D012214+F103305+T012305+T103214
     &       -D012304-D103213-T103304-U012213
      O4(8)= +D012113+F103204+T012204+T103113
      O4(3)= +F204103+T113103
      O4(6)= +F103204+T012204-D012203-T103203
      O4(9)= +F103103+T012103
      
      O5(1)= +F204204
      O5(4)= +F103305-T103304
      O5(7)= +F103204
      O5(2)= +F103305+T103214
      O5(5)= +F002406+T002315-D002314-T002405
      O5(8)= +F002305+T002214
      O5(3)= +F103204
      O5(6)= +F002305-T002304
      O5(9)= +F002204
      
      O6(1)= +F204103
      O6(4)= +F103204-T103203
      O6(7)= +F103103
      O6(2)= +F103204+T103113
      O6(5)= +F002305+T002214-D002213-T002304
      O6(8)= +F002204+T002113
      O6(3)= +F103103
      O6(6)= +F002204-T002203
      O6(9)= +F002103
                                                 
      O7(1)= +F305002+T214002
      O7(4)= +F204103+T113103-D113102-T204102
      O7(7)= +F204002+T113002
      O7(2)= +D113012+F204103+T113103+T204012
      O7(5)= +D012113+F103204+T012204+T103113
     &       -D012203-D103112-T103203-U012112
      O7(8)= +D012012+F103103+T012103+T103012
      O7(3)= +F204002+T113002
      O7(6)= +F103103+T012103-D012102-T103102
      O7(9)= +F103002+T012002
      
      O8(1)= +F204103
      O8(4)= +F103204-T103203
      O8(7)= +F103103
      O8(2)= +F103204+T103113
      O8(5)= +F002305+T002214-D002213-T002304
      O8(8)= +F002204+T002113
      O8(3)= +F103103
      O8(6)= +F002204-T002203
      O8(9)= +F002103
      
      O9(1)= +F204002
      O9(4)= +F103103-T103102
      O9(7)= +F103002
      O9(2)= +F103103+T103012
      O9(5)= +F002204+T002113-D002112-T002203
      O9(8)= +F002103+T002012
      O9(3)= +F103002
      O9(6)= +F002103-T002102
      O9(9)= +F002002
c     Delta1 d_kl          
      D1(1)=+Z022001-U022002+U113001-D113002
     &      +U113001-D113002+D204001-T204002
      D1(2)=+U012102-D012103+D103102-T103103
      D1(3)=+U012001-D012002+D103001-T103002
      D1(4)=+U012102-D012103+D103102-T103103
      D1(5)=+D002203-T002204
      D1(6)=+D002102-T002103
      D1(7)=+U012001-D012002+D103001-T103002
      D1(8)=+D002102-T002103
      D1(9)=+D002001-T002002
c  Delta2 d_jl          
      D2(1)=+D113002+T204002
      D2(2)=+T103103
      D2(3)=+T103002
      D2(4)=+U012012+D012103+D103012+T103103
      D2(5)=+D002113+T002204
      D2(6)=+D002012+T002103
      D2(7)=+D012002+T103002
      D2(8)=+T002103
      D2(9)=+T002002          
c  Delta3 d_jk          
      D3(1)=+D113002+T204002
      D3(2)=+T103103
      D3(3)=+T103002
      D3(4)=-U012102+D012103-D103102+T103103
      D3(5)=-D002203+T002204
      D3(6)=-D002102+T002103
      D3(7)=+D012002+T103002
      D3(8)=+T002103
      D3(9)=+T002002          
c  Delta4 d_il          
      D4(1)=+D113002+T204002
      D4(4)=+D012103+D103012+T103103+U012012
      D4(7)=+D012002+T103002
      D4(2)=+T103103
      D4(5)=+D002113+T002204
      D4(8)=+T002103
      D4(3)=+T103002
      D4(6)=+D002012+T002103
      D4(9)=+T002002
c  Delta5 d_ik          
      D5(1)=+D113002+T204002
      D5(4)=+D012103+T103103-D103102-U012102
      D5(7)=+D012002+T103002
      D5(2)=+T103103
      D5(5)=+T002204-D002203
      D5(8)=+T002103
      D5(3)=+T103002
      D5(6)=+T002103-D002102
      D5(9)=+T002002
c  Delta6 d_ij          
      D6(1)=+D203002-T204002
      D6(4)=+D102103-U102102-T103103+D103102
      D6(7)=+D102002-T103002
      D6(2)=+D102103+U102012-D103012-T103103
      D6(5)=+D001204+U001113-U001203-Z001112
     &      -D002113-T002204+D002203+U002112
      D6(8)=+D001103+U001012-D002012-T002103
      D6(3)=+D102002-T103002
      D6(6)=+D001103-U001102-T002103+D002102
      D6(9)=+D001002-T002002

c  Delta7 d_il and d_jk
      D7 = D002002
c  Delta8 d_ik and d_jl
      D8 = D002002
c  Delta9 d_ij and d_kl
      D9 = Z001001-U001002-U002001+D002002
               
c Delta ssss-->ppss in blas 
               
      call ipgemm  (3, p1, d4, tkw)         
      call ipgemmt (3, d4, p1, tiu)         
      call ipgemm  (3, p1, d5, tkw)         
      call ipgemmt (3, d5, p1, tiu)         
      call ipgemm  (3, p1, d6, tkw)         
      call ipgemmt (3, d6, p1, tkw)         
               
c ssss-->ppss in blas 

      call ipgemm (3,p1,o1,tkw)         
      call ipgemmt(3,o1,p1,tkw)         

      call ipgemm (3,p1,o2,tkw)         
      call ipgemmt(3,o2,p1,tkw)         

      call ipgemm (3,p1,o3,tkw)         
      call ipgemmt(3,o3,p1,tkw)         

      call ipgemm (3,p1,o4,tkw)         
      call ipgemmt(3,o4,p1,tkw)         

      call ipgemm (3,p1,o5,tkw)         
      call ipgemmt(3,o5,p1,tkw)         

      call ipgemm (3,p1,o6,tkw)         
      call ipgemmt(3,o6,p1,tkw)         

      call ipgemm (3,p1,o7,tkw)         
      call ipgemmt(3,o7,p1,tkw)         

      call ipgemm (3,p1,o8,tkw)         
      call ipgemmt(3,o8,p1,tkw)         

      call ipgemm (3,p1,o9,tkw)         
      call ipgemmt(3,o9,p1,tkw)         

c   blased O1 change suitable form for ppss-->ppps
      qqq( 1) = O1(1)+D1(1)
      qqq( 2) = O1(2)
      qqq( 3) = O1(3)
      qqq(28) = O2(1)+D1(4)
      qqq(29) = O2(2)
      qqq(30) = O2(3)
      qqq(55) = O3(1)+D1(7)
      qqq(56) = O3(2)
      qqq(57) = O3(3)
        
      qqq( 4) = O1(4)
      qqq( 5) = O1(5)+D1(1)
      qqq( 6) = O1(6)     
      qqq(31) = O2(4)     
      qqq(32) = O2(5)+D1(4)
      qqq(33) = O2(6)     
      qqq(58) = O3(4)     
      qqq(59) = O3(5)+D1(7)
      qqq(60) = O3(6)
        
      qqq( 7) = O1(7)
      qqq( 8) = O1(8)
      qqq( 9) = O1(9)+D1(1)
      qqq(34) = O2(7)     
      qqq(35) = O2(8)     
      qqq(36) = O2(9)+D1(4)
      qqq(61) = O3(7)     
      qqq(62) = O3(8)     
      qqq(63) = O3(9)+D1(7)
        
      qqq(10) = O4(1)+D1(2)
      qqq(11) = O4(2)
      qqq(12) = O4(3)
      qqq(37) = O5(1)+D1(5)
      qqq(38) = O5(2)
      qqq(39) = O5(3)
      qqq(64) = O6(1)+D1(8)
      qqq(65) = O6(2)
      qqq(66) = O6(3)
        
      qqq(13) = O4(4)
      qqq(14) = O4(5)+D1(2)
      qqq(15) = O4(6)
      qqq(40) = O5(4)
      qqq(41) = O5(5)+D1(5)
      qqq(42) = O5(6)
      qqq(67) = O6(4)
      qqq(68) = O6(5)+D1(8)
      qqq(69) = O6(6)
        
      qqq(16) = O4(7)
      qqq(17) = O4(8)
      qqq(18) = O4(9)+D1(2)
      qqq(43) = O5(7)
      qqq(44) = O5(8)
      qqq(45) = O5(9)+D1(5)
      qqq(70) = O6(7)
      qqq(71) = O6(8)
      qqq(72) = O6(9)+D1(8)               
        
      qqq(19) = O7(1)+D1(3)
      qqq(20) = O7(2)
      qqq(21) = O7(3)
      qqq(46) = O8(1)+D1(6)
      qqq(47) = O8(2)
      qqq(48) = O8(3)
      qqq(73) = O9(1)+D1(9)
      qqq(74) = O9(2)
      qqq(75) = O9(3)
        
      qqq(22) = O7(4)
      qqq(23) = O7(5)+D1(3)
      qqq(24) = O7(6)
      qqq(49) = O8(4)
      qqq(50) = O8(5)+D1(6)
      qqq(51) = O8(6)
      qqq(76) = O9(4)
      qqq(77) = O9(5)+D1(9)
      qqq(78) = O9(6)
        
      qqq(25) = O7(7)
      qqq(26) = O7(8)
      qqq(27) = O7(9)+D1(3)
      qqq(52) = O8(7)
      qqq(53) = O8(8)
      qqq(54) = O8(9)+D1(6)
      qqq(79) = O9(7)
      qqq(80) = O9(8)
      qqq(81) = O9(9)+D1(9)                

c ppss-->ppps in blas 
      call ipgemm (27,ppp,qqq,tiu)

c  blased O1 change suitable form for ppps-->pppp
      call ipgemm (3,b2,d2,tkw)
      call ipgemm (3,b3,d3,tkw)

      qqq( 1) = PPP( 1)+B2(1)+B3(1)
      qqq( 2) = PPP( 2)      +B3(4)
      qqq( 3) = PPP( 3)      +B3(7)
      qqq(28) = PPP(10)+B2(2)+B3(2)
      qqq(29) = PPP(11)      +B3(5)
      qqq(30) = PPP(12)      +B3(8)
      qqq(55) = PPP(19)+B2(3)+B3(3)
      qqq(56) = PPP(20)      +B3(6)
      qqq(57) = PPP(21)      +B3(9)
      qqq( 4) = PPP(28)
      qqq( 5) = PPP(29)+B2(1)
      qqq( 6) = PPP(30)
      qqq(31) = PPP(37)
      qqq(32) = PPP(38)+B2(2)
      qqq(33) = PPP(39)
      qqq(58) = PPP(46)
      qqq(59) = PPP(47)+B2(3)
      qqq(60) = PPP(48)
         
      qqq( 7) = PPP(55)
      qqq( 8) = PPP(56)
      qqq( 9) = PPP(57)+B2(1)
      qqq(34) = PPP(64)
      qqq(35) = PPP(65)
      qqq(36) = PPP(66)+B2(2)
      qqq(61) = PPP(73)
      qqq(62) = PPP(74)
      qqq(63) = PPP(75)+B2(3)
           
      qqq(10) = PPP( 4)+B2(4)
      qqq(11) = PPP( 5)
      qqq(12) = PPP( 6)
      qqq(37) = PPP(13)+B2(5)
      qqq(38) = PPP(14)
      qqq(39) = PPP(15)
      qqq(64) = PPP(22)+B2(6)
      qqq(65) = PPP(23)
      qqq(66) = PPP(24)
         
      qqq(13) = PPP(31)      +B3(1)
      qqq(14) = PPP(32)+B2(4)+B3(4)
      qqq(15) = PPP(33)      +B3(7)
      qqq(40) = PPP(40)      +B3(2)
      qqq(41) = PPP(41)+B2(5)+B3(5)
      qqq(42) = PPP(42)      +B3(8)
      qqq(67) = PPP(49)      +B3(3)
      qqq(68) = PPP(50)+B2(6)+B3(6)
      qqq(69) = PPP(51)      +B3(9)
          
      qqq(16) = PPP(58)
      qqq(17) = PPP(59)
      qqq(18) = PPP(60)+B2(4)
      qqq(43) = PPP(67)
      qqq(44) = PPP(68)
      qqq(45) = PPP(69)+B2(5)
      qqq(70) = PPP(76)
      qqq(71) = PPP(77)
      qqq(72) = PPP(78)+B2(6)               
         
      qqq(19) = PPP( 7)+B2(7)
      qqq(20) = PPP( 8)
      qqq(21) = PPP( 9)
      qqq(46) = PPP(16)+B2(8)
      qqq(47) = PPP(17)
      qqq(48) = PPP(18)
      qqq(73) = PPP(25)+B2(9)
      qqq(74) = PPP(26)
      qqq(75) = PPP(27)
         
      qqq(22) = PPP(34)
      qqq(23) = PPP(35)+B2(7)
      qqq(24) = PPP(36)
      qqq(49) = PPP(43)
      qqq(50) = PPP(44)+B2(8)
      qqq(51) = PPP(45)
      qqq(76) = PPP(52)
      qqq(77) = PPP(53)+B2(9)
      qqq(78) = PPP(54)
         
      qqq(25) = PPP(61)      +B3(1)
      qqq(26) = PPP(62)      +B3(4)
      qqq(27) = PPP(63)+B2(7)+B3(7)
      qqq(52) = PPP(70)      +B3(2)
      qqq(53) = PPP(71)      +B3(5)
      qqq(54) = PPP(72)+B2(8)+B3(8)
      qqq(79) = PPP(79)      +B3(3)
      qqq(80) = PPP(80)      +B3(6)
      qqq(81) = PPP(81)+B2(9)+B3(9)

c ppps-->pppp in blas 
      call ipgemm (27,ppp,qqq,tiu)
 
      ec( 1) =PPP( 1)+D4(1)+D5(1)+D6(1)+D7+D8+D9
      ec( 2) =PPP( 2)      +D5(2)+D6(2)
      ec( 3) =PPP( 3)      +D5(3)+D6(3)
      ec( 4) =PPP(10)+D4(2)      +D6(4)
      ec( 5) =PPP(11)            +D6(5)      +D9
      ec( 6) =PPP(12)            +D6(6)
      ec( 7) =PPP(19)+D4(3)      +D6(7)
      ec( 8) =PPP(20)            +D6(8)
      ec( 9) =PPP(21)            +D6(9)      +D9
      ec(10) =PPP(31)            +D6(1)      +D9
      ec(11) =PPP(32)+D4(4)      +D6(2)         
      ec(12) =PPP(33)            +D6(3)         
      ec(13) =PPP(40)      +D5(4)+D6(4)         
      ec(14) =PPP(41)+D4(5)+D5(5)+D6(5)+D7+D8+D9
      ec(15) =PPP(42)      +D5(6)+D6(6)         
      ec(16) =PPP(49)            +D6(7)         
      ec(17) =PPP(50)+D4(6)      +D6(8)         
      ec(18) =PPP(51)            +D6(9)      +D9
      ec(19) =PPP(61)            +D6(1)      +D9
      ec(20) =PPP(62)            +D6(2)         
      ec(21) =PPP(63)+D4(7)      +D6(3)         
      ec(22) =PPP(70)            +D6(4)         
      ec(23) =PPP(71)            +D6(5)      +D9
      ec(24) =PPP(72)+D4(8)      +D6(6)         
      ec(25) =PPP(79)      +D5(7)+D6(7)         
      ec(26) =PPP(80)      +D5(8)+D6(8)         
      ec(27) =PPP(81)+D4(9)+D5(9)+D6(9)+D7+D8+D9

      ec(28) =PPP(28)
      ec(29) =PPP(29)+D4(1)            +D7
      ec(30) =PPP(30)
      ec(31) =PPP(37)      +D5(1)         +D8
      ec(32) =PPP(38)+D4(2)+D5(2)
      ec(33) =PPP(39)      +D5(3)
      ec(34) =PPP(46)      
      ec(35) =PPP(47)+D4(3)      
      ec(36) =PPP(48)            
      ec(37) =PPP(55)
      ec(38) =PPP(56)
      ec(39) =PPP(57)+D4(1)            +D7
      ec(40) =PPP(64)
      ec(41) =PPP(65)
      ec(42) =PPP(66)+D4(2)
      ec(43) =PPP(73)      +D5(1)         +D8
      ec(44) =PPP(74)      +D5(2)
      ec(45) =PPP(75)+D4(3)+D5(3)
      ec(46) =PPP(58)      
      ec(47) =PPP(59)            
      ec(48) =PPP(60)+D4(4)      
      ec(49) =PPP(67)      
      ec(50) =PPP(68)            
      ec(51) =PPP(69)+D4(5)            +D7
      ec(52) =PPP(76)      +D5(4)
      ec(53) =PPP(77)      +D5(5)         +D8
      ec(54) =PPP(78)+D4(6)+D5(6)
      
      if (ierisw.eq.0) then 
         do ir = 28,54
            ec(ir) = ec(ir) * root3
         enddo
      endif
      
      end
CC IMDSDS ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DSDS
C ===================================================================

      subroutine imdsds(
     &           ec   ,
     &           xyz  ,  dsds ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )


      implicit real(8)(a-h,o-z)

      dimension dsds(99)
      dimension xyz(3,natom)
      dimension tiu(9),tkw(9)
      dimension o1(9),o2(9),o3(9),o4(9),o5(9),o6(9)
      dimension o7(9),o8(9),o9(9)
      dimension d1(9),d2(9),d3(9),d4(9),d5(9),d6(9)
      dimension p1(9),b2(9),b3(9),ppp(81),qqq(81)
      dimension ec(mvhgp)

      data      root3 / 1.73205080756887729353d+00 /
 
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)
      tkw(1)=-tiu(1)
      tkw(4)=-tiu(4)
      tkw(7)=-tiu(7)
      tkw(2)=-tiu(2)
      tkw(5)=-tiu(5)
      tkw(8)=-tiu(8)
      tkw(3)=-tiu(3)
      tkw(6)=-tiu(6)
      tkw(9)=-tiu(9)
C** BEGIN PRISM DSDS L2 STEP =========================================
C                    DSDS WITH BLAS
C ====================================================================
      F002002  =DSDS(  1)   
      F002103  =DSDS(  2)   
      F002204  =DSDS(  3)   
      F002305  =DSDS(  4)   
      F002406  =DSDS(  5)   
      F103002  =DSDS(  6)   
      F103103  =DSDS(  7)   
      F103204  =DSDS(  8)   
      F103305  =DSDS(  9)   
      F204002  =DSDS( 10)   
      F204103  =DSDS( 11)   
      F204204  =DSDS( 12)   
      F305002  =DSDS( 13)   
      F305103  =DSDS( 14)   
      F406002  =DSDS( 15)   
      T002002  =DSDS( 16)   
      T002012  =DSDS( 17)   
      T002103  =DSDS( 18)   
      T002113  =DSDS( 19)   
      T002204  =DSDS( 20)   
      T002214  =DSDS( 21)   
      T002315  =DSDS( 22)   
      T012002  =DSDS( 23)   
      T012103  =DSDS( 24)   
      T012204  =DSDS( 25)   
      T012305  =DSDS( 26)   
      T103002  =DSDS( 27)   
      T103012  =DSDS( 28)   
      T103103  =DSDS( 29)   
      T103113  =DSDS( 30)   
      T103214  =DSDS( 31)   
      T113002  =DSDS( 32)   
      T113103  =DSDS( 33)   
      T113204  =DSDS( 34)   
      T204002  =DSDS( 35)   
      T204012  =DSDS( 36)   
      T204113  =DSDS( 37)   
      T214002  =DSDS( 38)   
      T214103  =DSDS( 39)   
      T305012  =DSDS( 40)   
      T315002  =DSDS( 41)   
      D001002  =DSDS( 42)   
      D001103  =DSDS( 43)   
      D001204  =DSDS( 44)   
      D002001  =DSDS( 45)   
      D002002  =DSDS( 46)   
      D002012  =DSDS( 47)   
      D002022  =DSDS( 48)   
      D002102  =DSDS( 49)   
      D002113  =DSDS( 50)   
      D002123  =DSDS( 51)   
      D002203  =DSDS( 52)   
      D002224  =DSDS( 53)   
      D012002  =DSDS( 54)   
      D012012  =DSDS( 55)   
      D012103  =DSDS( 56)   
      D012113  =DSDS( 57)   
      D012214  =DSDS( 58)   
      D022002  =DSDS( 59)   
      D022103  =DSDS( 60)   
      D022204  =DSDS( 61)   
      D102002  =DSDS( 62)   
      D102103  =DSDS( 63)   
      D103001  =DSDS( 64)   
      D103012  =DSDS( 65)   
      D103022  =DSDS( 66)   
      D103102  =DSDS( 67)   
      D103123  =DSDS( 68)   
      D113002  =DSDS( 69)   
      D113012  =DSDS( 70)   
      D113113  =DSDS( 71)   
      D123002  =DSDS( 72)   
      D123103  =DSDS( 73)   
      D203002  =DSDS( 74)   
      D204001  =DSDS( 75)   
      D204022  =DSDS( 76)   
      D214012  =DSDS( 77)   
      D224002  =DSDS( 78)   
      U001002  =DSDS( 79)   
      U001012  =DSDS( 80)   
      U001113  =DSDS( 81)   
      U002001  =DSDS( 82)   
      U002022  =DSDS( 83)   
      U012001  =DSDS( 84)   
      U012012  =DSDS( 85)   
      U012022  =DSDS( 86)   
      U012102  =DSDS( 87)   
      U012123  =DSDS( 88)   
      U022002  =DSDS( 89)   
      U022012  =DSDS( 90)   
      U022113  =DSDS( 91)   
      U102012  =DSDS( 92)   
      U113001  =DSDS( 93)   
      U113022  =DSDS( 94)   
      U123012  =DSDS( 95)   
      Z001001  =DSDS( 96)   
      Z001022  =DSDS( 97)   
      Z022001  =DSDS( 98)   
      Z022022  =DSDS( 99)

      O1(1)=  +D224002+F406002+T315002+T315002
      O1(4)=  +D123103+D214012+D214012+F305103
     &        +T214103+T214103+T305012+U123012
      O1(7)=  +D123002+F305002+T214002+T214002
      O1(2)=  +D123103+D214012+D214012+F305103
     &        +T214103+T214103+T305012+U123012
      O1(5)=  +D022204+D113113+D113113+D113113
     &        +D113113+D204022+F204204+T113204
     &        +T113204+T204113+T204113+U022113
     &        +U022113+U113022+U113022+Z022022
      O1(8)=  +D022103+D113012+D113012+F204103
     &        +T113103+T113103+T204012+U022012
      O1(3)=  +D123002+F305002+T214002+T214002
      O1(6)=  +D022103+D113012+D113012+F204103
     &        +T113103+T113103+T204012+U022012
      O1(9)=  +D022002+F204002+T113002+T113002

      O2(1)=  +F305103+T214103
      O2(4)=  +D113113+F204204+T113204+T204113
      O2(7)=  +F204103+T113103
      O2(2)=  +D113113+F204204+T113204+T204113
      O2(5)=  +D012214+D012214+D103123+F103305
     &        +T012305+T103214+T103214+U012123
      O2(8)=  +D012113+F103204+T012204+T103113
      O2(3)=  +F204103+T113103
      O2(6)=  +D012113+F103204+T012204+T103113
      O2(9)=  +F103103+T012103
  
      O3(1)=  +F305002+T214002
      O3(4)=  +D113012+F204103+T113103+T204012
      O3(7)=  +F204002+T113002
      O3(2)=  +D113012+F204103+T113103+T204012
      O3(5)=  +D012113+D012113+D103022+F103204
     &        +T012204+T103113+T103113+U012022
      O3(8)=  +D012012+F103103+T012103+T103012
      O3(3)=  +F204002+T113002
      O3(6)=  +D012012+F103103+T012103+T103012
      O3(9)=  +F103002+T012002
  
      O4(1)=  +F305103+T214103
      O4(4)=  +D113113+F204204+T113204+T204113
      O4(7)=  +F204103+T113103
      O4(2)=  +D113113+F204204+T113204+T204113
      O4(5)=  +D012214+D012214+D103123+F103305
     &        +T012305+T103214+T103214+U012123
      O4(8)=  +D012113+F103204+T012204+T103113
      O4(3)=  +F204103+T113103
      O4(6)=  +D012113+F103204+T012204+T103113
      O4(9)=  +F103103+T012103
  
      O5(1)=  +F204204
      O5(4)=  +F103305+T103214
      O5(7)=  +F103204
      O5(2)=  +F103305+T103214
      O5(5)=  +D002224+F002406+T002315+T002315
      O5(8)=  +F002305+T002214
      O5(3)=  +F103204
      O5(6)=  +F002305+T002214
      O5(9)=  +F002204
  
      O6(1)=  +F204103
      O6(4)=  +F103204+T103113
      O6(7)=  +F103103
      O6(2)=  +F103204+T103113
      O6(5)=  +D002123+F002305+T002214+T002214
      O6(8)=  +F002204+T002113
      O6(3)=  +F103103
      O6(6)=  +F002204+T002113
      O6(9)=  +F002103
 
      O7(1)=  +F305002+T214002
      O7(4)=  +D113012+F204103+T113103+T204012
      O7(7)=  +F204002+T113002
      O7(2)=  +D113012+F204103+T113103+T204012
      O7(5)=  +D012113+D012113+D103022+F103204
     &        +T012204+T103113+T103113+U012022
      O7(8)=  +D012012+F103103+T012103+T103012
      O7(3)=  +F204002+T113002
      O7(6)=  +D012012+F103103+T012103+T103012
      O7(9)=  +F103002+T012002
 
      O8(1)=  +F204103
      O8(4)=  +F103204+T103113
      O8(7)=  +F103103
      O8(2)=  +F103204+T103113
      O8(5)=  +D002123+F002305+T002214+T002214
      O8(8)=  +F002204+T002113
      O8(3)=  +F103103
      O8(6)=  +F002204+T002113
      O8(9)=  +F002103

      O9(1)=  +F204002
      O9(4)=  +F103103+T103012
      O9(7)=  +F103002
      O9(2)=  +F103103+T103012
      O9(5)=  +D002022+F002204+T002113+T002113
      O9(8)=  +F002103+T002012
      O9(3)=  +F103002
      O9(6)=  +F002103+T002012
      O9(9)=  +F002002         

c  Delta1 d_kl          
      D1(1)=+Z022001-U022002+U113001-D113002
     &      +U113001-D113002+D204001-T204002
      D1(2)=+U012102-D012103+D103102-T103103
      D1(3)=+U012001-D012002+D103001-T103002
      D1(4)=+U012102-D012103+D103102-T103103
      D1(5)=+D002203-T002204
      D1(6)=+D002102-T002103
      D1(7)=+U012001-D012002+D103001-T103002
      D1(8)=+D002102-T002103
      D1(9)=+D002001-T002002
c  Delta2 d_jl
      D2(1)=+D113002+T204002
      D2(2)=+T103103
      D2(3)=+T103002
      D2(4)=+U012012+D012103+D103012+T103103
      D2(5)=+D002113+T002204
      D2(6)=+D002012+T002103
      D2(7)=+D012002+T103002
      D2(8)=+T002103
      D2(9)=+T002002          
c  Delta3 d_jk          
      D3(1)=+D113002+T204002
      D3(2)=+T103103
      D3(3)=+T103002
      D3(4)=+U012012+D012103+D103012+T103103
      D3(5)=+D002113+T002204
      D3(6)=+D002012+T002103
      D3(7)=+D012002+T103002
      D3(8)=+T002103
      D3(9)=+T002002
c  Delta4 d_il          
      D4(1)=+D113002+T204002
      D4(4)=+D012103+D103012+T103103+U012012
      D4(7)=+D012002+T103002
      D4(2)=+T103103
      D4(5)=+D002113+T002204
      D4(8)=+T002103
      D4(3)=+T103002
      D4(6)=+D002012+T002103
      D4(9)=+T002002
c  Delta5 d_ik          
      D5(1)=+D113002+T204002
      D5(4)=+D012103+D103012+T103103+U012012
      D5(7)=+D012002+T103002
      D5(2)=+T103103
      D5(5)=+D002113+T002204
      D5(8)=+T002103
      D5(3)=+T103002
      D5(6)=+D002012+T002103
      D5(9)=+T002002
c  Delta6 d_ij          
               
      D6(1)=+D203002-T204002
      D6(4)=+D102103+U102012-D103012-T103103
      D6(7)=+D102002-T103002
      D6(2)=+D102103+U102012-D103012-T103103
      D6(5)=+D001204+U001113+U001113+Z001022
     &      -D002113-D002113-T002204-U002022
      D6(8)=+D001103+U001012-D002012-T002103
      D6(3)=+D102002-T103002
      D6(6)=+D001103+U001012-D002012-T002103
      D6(9)=+D001002-T002002

c  Delta7 d_il and d_jk
      D7 = D002002
c  Delta8 d_ik and d_jl
      D8 = D002002
c  Delta9 d_ij and d_kl
      D9 = Z001001-U001002-U002001+D002002

c Delta ssss-->ppss in blas 
               
      call ipgemm (3, p1, d4, tkw)
      call ipgemmt(3, d4, p1, tiu)
      call ipgemm (3, p1, d5, tkw)
      call ipgemmt(3, d5, p1, tiu)
      call ipgemm (3, p1, d6, tkw)
      call ipgemmt(3, d6, p1, tkw)
               
c ssss-->ppss in blas 

      call ipgemm (3, p1, o1, tkw)
      call ipgemmt(3, o1, p1, tkw)
                              
      call ipgemm (3, p1, o2, tkw)
      call ipgemmt(3, o2, p1, tkw)
                              
      call ipgemm (3, p1, o3, tkw)
      call ipgemmt(3, o3, p1, tkw)
                              
      call ipgemm (3, p1, o4, tkw)
      call ipgemmt(3, o4, p1, tkw)
                              
      call ipgemm (3, p1, o5, tkw)
      call ipgemmt(3, o5, p1, tkw)
                              
      call ipgemm (3, p1, o6, tkw)
      call ipgemmt(3, o6, p1, tkw)
                              
      call ipgemm (3, p1, o7, tkw)
      call ipgemmt(3, o7, p1, tkw)
                              
      call ipgemm (3, p1, o8, tkw)
      call ipgemmt(3, o8, p1, tkw)
                              
      call ipgemm (3, p1, o9, tkw)
      call ipgemmt(3, o9, p1, tkw)

c   blased O1 change suitable form for ppss-->ppps
      qqq( 1) = O1(1)+D1(1)
      qqq( 2) = O1(2)
      qqq( 3) = O1(3)
      qqq(28) = O2(1)+D1(4)
      qqq(29) = O2(2)
      qqq(30) = O2(3)
      qqq(55) = O3(1)+D1(7)
      qqq(56) = O3(2)
      qqq(57) = O3(3)
            
      qqq( 4) = O1(4)
      qqq( 5) = O1(5)+D1(1)
      qqq( 6) = O1(6)     
      qqq(31) = O2(4)     
      qqq(32) = O2(5)+D1(4)
      qqq(33) = O2(6)     
      qqq(58) = O3(4)     
      qqq(59) = O3(5)+D1(7)
      qqq(60) = O3(6)
          
      qqq( 7) = O1(7)
      qqq( 8) = O1(8)
      qqq( 9) = O1(9)+D1(1)
      qqq(34) = O2(7)     
      qqq(35) = O2(8)     
      qqq(36) = O2(9)+D1(4)
      qqq(61) = O3(7)     
      qqq(62) = O3(8)     
      qqq(63) = O3(9)+D1(7)
          
      qqq(10) = O4(1)+D1(2)
      qqq(11) = O4(2)
      qqq(12) = O4(3)
      qqq(37) = O5(1)+D1(5)
      qqq(38) = O5(2)
      qqq(39) = O5(3)
      qqq(64) = O6(1)+D1(8)
      qqq(65) = O6(2)
      qqq(66) = O6(3)
          
      qqq(13) = O4(4)
      qqq(14) = O4(5)+D1(2)
      qqq(15) = O4(6)
      qqq(40) = O5(4)
      qqq(41) = O5(5)+D1(5)
      qqq(42) = O5(6)
      qqq(67) = O6(4)
      qqq(68) = O6(5)+D1(8)
      qqq(69) = O6(6)
        
      qqq(16) = O4(7)
      qqq(17) = O4(8)
      qqq(18) = O4(9)+D1(2)
      qqq(43) = O5(7)
      qqq(44) = O5(8)
      qqq(45) = O5(9)+D1(5)
      qqq(70) = O6(7)
      qqq(71) = O6(8)
      qqq(72) = O6(9)+D1(8)
        
      qqq(19) = O7(1)+D1(3)
      qqq(20) = O7(2)
      qqq(21) = O7(3)
      qqq(46) = O8(1)+D1(6)
      qqq(47) = O8(2)
      qqq(48) = O8(3)
      qqq(73) = O9(1)+D1(9)
      qqq(74) = O9(2)
      qqq(75) = O9(3)
     
      qqq(22) = O7(4)
      qqq(23) = O7(5)+D1(3)
      qqq(24) = O7(6)
      qqq(49) = O8(4)
      qqq(50) = O8(5)+D1(6)
      qqq(51) = O8(6)
      qqq(76) = O9(4)
      qqq(77) = O9(5)+D1(9)
      qqq(78) = O9(6)

      qqq(25) = O7(7)
      qqq(26) = O7(8)
      qqq(27) = O7(9)+D1(3)
      qqq(52) = O8(7)
      qqq(53) = O8(8)
      qqq(54) = O8(9)+D1(6)
      qqq(79) = O9(7)
      qqq(80) = O9(8)
      qqq(81) = O9(9)+D1(9)                

c ppss-->ppps in blas 

      call ipgemm (27, ppp, qqq, tiu)

c  blased O1 change suitable form for ppps-->pppp
      call ipgemm (3, b2, d2, tkw)
      call ipgemm (3, b3, d3, tkw)

      qqq( 1) = PPP( 1)+B2(1)+B3(1)
      qqq( 2) = PPP( 2)      +B3(4)
      qqq( 3) = PPP( 3)      +B3(7)
      qqq(28) = PPP(10)+B2(2)+B3(2)
      qqq(29) = PPP(11)      +B3(5)
      qqq(30) = PPP(12)      +B3(8)
      qqq(55) = PPP(19)+B2(3)+B3(3)
      qqq(56) = PPP(20)      +B3(6)
      qqq(57) = PPP(21)      +B3(9)
      qqq( 4) = PPP(28)
      qqq( 5) = PPP(29)+B2(1)
      qqq( 6) = PPP(30)
      qqq(31) = PPP(37)
      qqq(32) = PPP(38)+B2(2)
      qqq(33) = PPP(39)
      qqq(58) = PPP(46)
      qqq(59) = PPP(47)+B2(3)
      qqq(60) = PPP(48)
           
      qqq( 7) = PPP(55)
      qqq( 8) = PPP(56)
      qqq( 9) = PPP(57)+B2(1)
      qqq(34) = PPP(64)
      qqq(35) = PPP(65)
      qqq(36) = PPP(66)+B2(2)
      qqq(61) = PPP(73)
      qqq(62) = PPP(74)
      qqq(63) = PPP(75)+B2(3)
                   
      qqq(10) = PPP( 4)+B2(4)
      qqq(11) = PPP( 5)
      qqq(12) = PPP( 6)
      qqq(37) = PPP(13)+B2(5)
      qqq(38) = PPP(14)
      qqq(39) = PPP(15)
      qqq(64) = PPP(22)+B2(6)
      qqq(65) = PPP(23)
      qqq(66) = PPP(24)
                   
      qqq(13) = PPP(31)      +B3(1)
      qqq(14) = PPP(32)+B2(4)+B3(4)
      qqq(15) = PPP(33)      +B3(7)
      qqq(40) = PPP(40)      +B3(2)
      qqq(41) = PPP(41)+B2(5)+B3(5)
      qqq(42) = PPP(42)      +B3(8)
      qqq(67) = PPP(49)      +B3(3)
      qqq(68) = PPP(50)+B2(6)+B3(6)
      qqq(69) = PPP(51)      +B3(9)
                   
      qqq(16) = PPP(58)
      qqq(17) = PPP(59)
      qqq(18) = PPP(60)+B2(4)
      qqq(43) = PPP(67)
      qqq(44) = PPP(68)
      qqq(45) = PPP(69)+B2(5)
      qqq(70) = PPP(76)
      qqq(71) = PPP(77)
      qqq(72) = PPP(78)+B2(6)
                   
      qqq(19) = PPP( 7)+B2(7)
      qqq(20) = PPP( 8)
      qqq(21) = PPP( 9)
      qqq(46) = PPP(16)+B2(8)
      qqq(47) = PPP(17)
      qqq(48) = PPP(18)
      qqq(73) = PPP(25)+B2(9)
      qqq(74) = PPP(26)
      qqq(75) = PPP(27)
         
      qqq(22) = PPP(34)
      qqq(23) = PPP(35)+B2(7)
      qqq(24) = PPP(36)
      qqq(49) = PPP(43)
      qqq(50) = PPP(44)+B2(8)
      qqq(51) = PPP(45)
      qqq(76) = PPP(52)
      qqq(77) = PPP(53)+B2(9)
      qqq(78) = PPP(54)
                   
      qqq(25) = PPP(61)      +B3(1)
      qqq(26) = PPP(62)      +B3(4)
      qqq(27) = PPP(63)+B2(7)+B3(7)
      qqq(52) = PPP(70)      +B3(2)
      qqq(53) = PPP(71)      +B3(5)
      qqq(54) = PPP(72)+B2(8)+B3(8)
      qqq(79) = PPP(79)      +B3(3)
      qqq(80) = PPP(80)      +B3(6)
      qqq(81) = PPP(81)+B2(9)+B3(9)

c ppps-->pppp in blas 
      call ipgemm (27,ppp,qqq,tiu)
!      ierisw = 1
      if (ierisw.eq.0) then
         
         ec( 1) =(PPP( 1)+D4(1)+D5(1)+D6(1)+D7+D8+D9)
         ec( 2) =(PPP(11)            +D6(5)      +D9)
         ec( 3) =(PPP(21)            +D6(9)      +D9)
         ec( 4) =(PPP(10)+D4(2)      +D6(4)         )*root3
         ec( 5) =(PPP(19)+D4(3)      +D6(7)         )*root3
         ec( 6) =(PPP(20)            +D6(8)         )*root3
         ec( 7) =(PPP(31)            +D6(1)      +D9)
         ec( 8) =(PPP(41)+D4(5)+D5(5)+D6(5)+D7+D8+D9)
         ec( 9) =(PPP(51)            +D6(9)      +D9)
         ec(10) =(PPP(40)      +D5(4)+D6(4)         )*root3
         ec(11) =(PPP(49)            +D6(7)         )*root3
         ec(12) =(PPP(50)+D4(6)      +D6(8)         )*root3
         ec(13) =(PPP(61)            +D6(1)      +D9)
         ec(14) =(PPP(71)            +D6(5)      +D9)
         ec(15) =(PPP(81)+D4(9)+D5(9)+D6(9)+D7+D8+D9)
         ec(16) =(PPP(70)            +D6(4)         )*root3
         ec(17) =(PPP(79)      +D5(7)+D6(7)         )*root3
         ec(18) =(PPP(80)      +D5(8)+D6(8)         )*root3
         ec(19) =(PPP(28)                           )
         ec(20) =(PPP(38)+D4(2)+D5(2)               )
         ec(21) =(PPP(48)                           )
         ec(22) =(PPP(37)      +D5(1)         +D8   )*root3
         ec(23) =(PPP(46)                           )*root3
         ec(24) =(PPP(47)+D4(3)                     )*root3
         ec(25) =(PPP(55)                           )
         ec(26) =(PPP(65)                           )
         ec(27) =(PPP(75)+D4(3)+D5(3)               )
         ec(28) =(PPP(64)                           )*root3
         ec(29) =(PPP(73)      +D5(1)         +D8   )*root3
         ec(30) =(PPP(74)      +D5(2)               )*root3
         ec(31) =(PPP(58)                           )
         ec(32) =(PPP(68)                           )
         ec(33) =(PPP(78)+D4(6)+D5(6)               )
         ec(34) =(PPP(67)                           )*root3
         ec(35) =(PPP(76)      +D5(4)               )*root3
         ec(36) =(PPP(77)      +D5(5)         +D8   )*root3

         do ir = 19,36
            ec(ir) = ec(ir) * root3
         enddo
          
      else                                                      
         ec( 1) = PPP( 1)+D4(1)+D5(1)+D6(1)+D7+D8+D9
         ec( 2) = PPP(11)            +D6(5)      +D9
         ec( 3) = PPP(21)            +D6(9)      +D9
         ec( 4) = PPP(10)+D4(2)      +D6(4)         
         ec( 5) = PPP(19)+D4(3)      +D6(7)         
         ec( 6) = PPP(20)            +D6(8)         
         ec( 7) = PPP(31)            +D6(1)      +D9
         ec( 8) = PPP(41)+D4(5)+D5(5)+D6(5)+D7+D8+D9
         ec( 9) = PPP(51)            +D6(9)      +D9
         ec(10) = PPP(40)      +D5(4)+D6(4)         
         ec(11) = PPP(49)            +D6(7)         
         ec(12) = PPP(50)+D4(6)      +D6(8)         
         ec(13) = PPP(61)            +D6(1)      +D9
         ec(14) = PPP(71)            +D6(5)      +D9
         ec(15) = PPP(81)+D4(9)+D5(9)+D6(9)+D7+D8+D9
         ec(16) = PPP(70)            +D6(4)         
         ec(17) = PPP(79)      +D5(7)+D6(7)         
         ec(18) = PPP(80)      +D5(8)+D6(8)         
         ec(19) = PPP(28)                           
         ec(20) = PPP(38)+D4(2)+D5(2)               
         ec(21) = PPP(48)                           
         ec(22) = PPP(37)      +D5(1)         +D8   
         ec(23) = PPP(46)                           
         ec(24) = PPP(47)+D4(3)                     
         ec(25) = PPP(55)                           
         ec(26) = PPP(65)                           
         ec(27) = PPP(75)+D4(3)+D5(3)               
         ec(28) = PPP(64)                           
         ec(29) = PPP(73)      +D5(1)         +D8   
         ec(30) = PPP(74)      +D5(2)               
         ec(31) = PPP(58)                           
         ec(32) = PPP(68)                           
         ec(33) = PPP(78)+D4(6)+D5(6)               
         ec(34) = PPP(67)                           
         ec(35) = PPP(76)      +D5(4)               
         ec(36) = PPP(77)      +D5(5)         +D8   
      endif

      end
CC IMDPPS ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DPPS
C ===================================================================

      subroutine imdpps(
     &           ec   ,
     &           xyz  ,  dpps ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )


      implicit real(8)(a-h,o-z)

      dimension dpps(112)
      dimension xyz(3,natom)
      dimension tiu(9),tkw(9)
      dimension o1(9),o2(9),o3(9),o4(9),o5(9),o6(9)
      dimension o7(9),o8(9),o9(9)
      dimension d1(9),d2(9),d3(9),d4(9),d5(9),d6(9)
      dimension p1(9),b2(9),b3(9),ppp(81),qqq(81)
      dimension ec(mvhgp)

      data      root3 / 1.73205080756887729353d+00 /
 
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)

      tkw(1)=-tiu(1)
      tkw(4)=-tiu(4)
      tkw(7)=-tiu(7)
      tkw(2)=-tiu(2)
      tkw(5)=-tiu(5)
      tkw(8)=-tiu(8)
      tkw(3)=-tiu(3)
      tkw(6)=-tiu(6)
      tkw(9)=-tiu(9)
C** BEGIN PRISM DPPS L2 STEP =========================================
C                    DPPS WITH BLAS
C ====================================================================
      D002001 =DPPS(  1)
      D002102 =DPPS(  2)
      D002203 =DPPS(  3)
      D003001 =DPPS(  4)
      D003011 =DPPS(  5)
      D003112 =DPPS(  6)
      D013001 =DPPS(  7)
      D013011 =DPPS(  8)
      D013102 =DPPS(  9)
      D013112 =DPPS( 10)
      D013213 =DPPS( 11)
      D023001 =DPPS( 12)
      D023102 =DPPS( 13)
      D023203 =DPPS( 14)
      D103001 =DPPS( 15)
      D103011 =DPPS( 16)
      D103102 =DPPS( 17)
      D103112 =DPPS( 18)
      D103213 =DPPS( 19)
      D104011 =DPPS( 20)
      D113001 =DPPS( 21)
      D113102 =DPPS( 22)
      D113203 =DPPS( 23)
      D114001 =DPPS( 24)
      D114011 =DPPS( 25)
      D114112 =DPPS( 26)
      D124001 =DPPS( 27)
      D124102 =DPPS( 28)
      D204001 =DPPS( 29)
      D204011 =DPPS( 30)
      D204112 =DPPS( 31)
      D214001 =DPPS( 32)
      D214102 =DPPS( 33)
      D215011 =DPPS( 34)
      D225001 =DPPS( 35)
      D305011 =DPPS( 36)
      D315001 =DPPS( 37)
      F003001 =DPPS( 38)
      F003102 =DPPS( 39)
      F003203 =DPPS( 40)
      F003304 =DPPS( 41)
      F003405 =DPPS( 42)
      F104001 =DPPS( 43)
      F104102 =DPPS( 44)
      F104203 =DPPS( 45)
      F104304 =DPPS( 46)
      F205001 =DPPS( 47)
      F205102 =DPPS( 48)
      F205203 =DPPS( 49)
      F306001 =DPPS( 50)
      F306102 =DPPS( 51)
      F407001 =DPPS( 52)
      T003001 =DPPS( 53)
      T003011 =DPPS( 54)
      T003102 =DPPS( 55)
      T003112 =DPPS( 56)
      T003203 =DPPS( 57)
      T003213 =DPPS( 58)
      T003314 =DPPS( 59)
      T013001 =DPPS( 60)
      T013102 =DPPS( 61)
      T013203 =DPPS( 62)
      T013304 =DPPS( 63)
      T103001 =DPPS( 64)
      T103102 =DPPS( 65)
      T103203 =DPPS( 66)
      T103304 =DPPS( 67)
      T104001 =DPPS( 68)
      T104011 =DPPS( 69)
      T104102 =DPPS( 70)
      T104112 =DPPS( 71)
      T104213 =DPPS( 72)
      T114001 =DPPS( 73)
      T114102 =DPPS( 74)
      T114203 =DPPS( 75)
      T204001 =DPPS( 76)
      T204102 =DPPS( 77)
      T204203 =DPPS( 78)
      T205001 =DPPS( 79)
      T205011 =DPPS( 80)
      T205112 =DPPS( 81)
      T215001 =DPPS( 82)
      T215102 =DPPS( 83)
      T305001 =DPPS( 84)
      T305102 =DPPS( 85)
      T306011 =DPPS( 86)
      T316001 =DPPS( 87)
      T406001 =DPPS( 88)
      U002001 =DPPS( 89)
      U002011 =DPPS( 90)
      U002112 =DPPS( 91)
      U012001 =DPPS( 92)
      U012102 =DPPS( 93)
      U013011 =DPPS( 94)
      U023001 =DPPS( 95)
      U023011 =DPPS( 96)
      U023112 =DPPS( 97)
      U102001 =DPPS( 98)
      U102102 =DPPS( 99)
      U103011 =DPPS(100)
      U113001 =DPPS(101)
      U113011 =DPPS(102)
      U113112 =DPPS(103)
      U123001 =DPPS(104)
      U123102 =DPPS(105)
      U124011 =DPPS(106)
      U203001 =DPPS(107)
      U214011 =DPPS(108)
      U224001 =DPPS(109)
      Z012011 =DPPS(110)
      Z102011 =DPPS(111)
      Z123011 =DPPS(112)

      O1(1)=  +D225001+F407001+T316001+T316001
     &        -D315001-D315001-T406001-U224001
      O1(4)=  +D124102+D215011+D215011+F306102
     &        +T215102+T215102+T306011+U124011
     &        -D214102-D214102-D305011-T305102
     &        -U123102-U214011-U214011-Z123011
      O1(7)=  +D124001+F306001+T215001+T215001
     &        -D214001-D214001-T305001-U123001
      O1(2)=  +D124102+F306102+T215102+T215102
      O1(5)=  +D023203+D114112+D114112+F205203
     &        +T114203+T114203+T205112+U023112
      O1(8)=  +D023102+F205102+T114102+T114102
      O1(3)=  +D124001+F306001+T215001+T215001
      O1(6)=  +D023102+D114011+D114011+F205102
     &        +T114102+T114102+T205011+U023011
      O1(9)=  +D023001+F205001+T114001+T114001

      O2(1)=  +F306102+T215102-D214102-T305102
      O2(4)=  +D114112+F205203+T114203+T205112
     &        -D113203-D204112-T204203-U113112
      O2(7)=  +F205102+T114102-D113102-T204102
      O2(2)=  +F205203+T114203
      O2(5)=  +D013213+F104304+T013304+T104213
      O2(8)=  +F104203+T013203
      O2(3)=  +F205102+T114102
      O2(6)=  +D013112+F104203+T013203+T104112
      O2(9)=  +F104102+T013102
 
      O3(1)=  +F306001+T215001-D214001-T305001
      O3(4)=  +D114011+F205102+T114102+T205011
     &        -D113102-D204011-T204102-U113011
      O3(7)=  +F205001+T114001-D113001-T204001
      O3(2)=  +F205102+T114102
      O3(5)=  +D013112+F104203+T013203+T104112
      O3(8)=  +F104102+T013102
      O3(3)=  +F205001+T114001
      O3(6)=  +D013011+F104102+T013102+T104011
      O3(9)=  +F104001+T013001
     
      O4(1)=  +F306102+T215102-D214102-T305102
      O4(4)=  +D114112+F205203+T114203+T205112
     &        -D113203-D204112-T204203-U113112
      O4(7)=  +F205102+T114102-D113102-T204102
      O4(2)=  +F205203+T114203
      O4(5)=  +D013213+F104304+T013304+T104213
      O4(8)=  +F104203+T013203
      O4(3)=  +F205102+T114102
      O4(6)=  +D013112+F104203+T013203+T104112
      O4(9)=  +F104102+T013102
     
      O5(1)=  +F205203-T204203
      O5(4)=  +F104304+T104213-D103213-T103304
      O5(7)=  +F104203-T103203
      O5(2)=  +F104304
      O5(5)=  +F003405+T003314
      O5(8)=  +F003304
      O5(3)=  +F104203
      O5(6)=  +F003304+T003213
      O5(9)=  +F003203
     
      O6(1)=  +F205102-T204102
      O6(4)=  +F104203+T104112-D103112-T103203
      O6(7)=  +F104102-T103102
      O6(2)=  +F104203
      O6(5)=  +F003304+T003213
      O6(8)=  +F003203
      O6(3)=  +F104102
      O6(6)=  +F003203+T003112
      O6(9)=  +F003102
     
      O7(1)=  +F306001+T215001-D214001-T305001
      O7(4)=  +D114011+F205102+T114102+T205011
     &        -D113102-D204011-T204102-U113011
      O7(7)=  +F205001+T114001-D113001-T204001
      O7(2)=  +F205102+T114102
      O7(5)=  +D013112+F104203+T013203+T104112
      O7(8)=  +F104102+T013102
      O7(3)=  +F205001+T114001
      O7(6)=  +D013011+F104102+T013102+T104011
      O7(9)=  +F104001+T013001
     
      O8(1)=  +F205102-T204102
      O8(4)=  +F104203+T104112-D103112-T103203
      O8(7)=  +F104102-T103102
      O8(2)=  +F104203
      O8(5)=  +F003304+T003213
      O8(8)=  +F003203
      O8(3)=  +F104102
      O8(6)=  +F003203+T003112
      O8(9)=  +F003102
     
      O9(1)=  +F205001-T204001
      O9(4)=  +F104102+T104011-D103011-T103102
      O9(7)=  +F104001-T103001
      O9(2)=  +F104102
      O9(5)=  +F003203+T003112
      O9(8)=  +F003102
      O9(3)=  +F104001
      O9(6)=  +F003102+T003011
      O9(9)=  +F003001

c  Delta1 d_kl          
      D1(1)=+U023001+D114001+D114001+T205001
      D1(4)=+D013102+T104102
      D1(7)=+D013001+T104001
      D1(2)=+D013102+T104102
      D1(5)=+T003203
      D1(8)=+T003102
      D1(3)=+D013001+T104001
      D1(6)=+T003102
      D1(9)=+T003001
c  Delta2 d_jl          
      D2(1)=-U113001+D114001-D204001+T205001
      D2(4)=+D013102+T104102
      D2(7)=+D013001+T104001!
      D2(2)=-D103102+T104102
      D2(5)=+T003203
      D2(8)=+T003102
      D2(3)=-D103001+T104001
      D2(6)=+T003102
      D2(9)=+T003001          
c  Delta3 d_jk          
      D3(1)=+U113001-D114001+D204001-T205001
      D3(4)=+Z012011+U012102+U103011+D103102
     &      -U013011-D013102-D104011-T104102
      D3(7)=+U012001-D013001+D103001-T104001
      D3(2)=+D103102-T104102
      D3(5)=+U002112+D002203-D003112-T003203
      D3(8)=+D002102-T003102
      D3(3)=+D103001-T104001
      D3(6)=+U002011+D002102-D003011-T003102
      D3(9)=+D002001-T003001
c  Delta4 d_il
      D4(1)=+D114001+T205001-D204001-U113001
      D4(4)=+D013102+T104102
      D4(7)=+D013001+T104001
      D4(2)=+T104102-D103102
      D4(5)=+T003203
      D4(8)=+T003102
      D4(3)=+T104001-D103001
      D4(6)=+T003102
      D4(9)=+T003001
c  Delta5 d_ik
      D5(1)=+D204001+U113001-D114001-T205001
      D5(4)=+D103102+U012102+U103011+Z012011
     &      -D013102-D104011-T104102-U013011
      D5(7)=+D103001+U012001-D013001-T104001
      D5(2)=+D103102-T104102
      D5(5)=+D002203+U002112-D003112-T003203
      D5(8)=+D002102-T003102
      D5(3)=+D103001-T104001
      D5(6)=+D002102+U002011-D003011-T003102
      D5(9)=+D002001-T003001
c  Delta6 d_ij          
      D6(1)=+D204001-U203001-T205001+D204001
      D6(4)=+D103102+U103011-U102102-Z102011
     &      -D104011-T104102+D103102+U103011
      D6(7)=+D103001-U102001-T104001+D103001
      D6(2)=+D103102-T104102
      D6(5)=+D002203+U002112-D003112-T003203
      D6(8)=+D002102-T003102
      D6(3)=+D103001-T104001
      D6(6)=+D002102+U002011-D003011-T003102
      D6(9)=+D002001-T003001
 
c  Delta7 d_il and d_jk
      D7 = U002001-D003001
c  Delta8 d_ik and d_jl
      D8 = U002001-D003001
c  Delta9 d_ij and d_kl
      D9 = U002001-D003001
      
      do mmm=1,9
         p1(mmm) = 0.0d0
      enddo

c     Delta ssss-->ppss in blas 
      call ipgemm (3,p1,d4,tiu)
      call ipgemmt(3,d4,p1,tiu)

      call ipgemm (3,p1,d5,tkw)
      call ipgemmt(3,d5,p1,tiu)

      call ipgemm (3,p1,d6,tkw)
      call ipgemmt(3,d6,p1,tiu)

c ssss-->ppss in blas 
      call ipgemm (3,p1,o1,tkw)
      call ipgemmt(3,o1,p1,tiu)

      call ipgemm (3,p1,o2,tkw)
      call ipgemmt(3,o2,p1,tiu)

      call ipgemm (3,p1,o3,tkw)
      call ipgemmt(3,o3,p1,tiu)

      call ipgemm (3,p1,o4,tkw)
      call ipgemmt(3,o4,p1,tiu)

      call ipgemm (3,p1,o5,tkw)
      call ipgemmt(3,o5,p1,tiu)

      call ipgemm (3,p1,o6,tkw)
      call ipgemmt(3,o6,p1,tiu)

      call ipgemm (3,p1,o7,tkw)
      call ipgemmt(3,o7,p1,tiu)

      call ipgemm (3,p1,o8,tkw)
      call ipgemmt(3,o8,p1,tiu)

      call ipgemm (3,p1,o9,tkw)
      call ipgemmt(3,o9,p1,tiu)

c  blased O1 change suitable form for ppss-->ppps
      qqq( 1) = O1(1)+D1(1)
      qqq( 2) = O1(2)
      qqq( 3) = O1(3)
      qqq(28) = O2(1)+D1(4)
      qqq(29) = O2(2)
      qqq(30) = O2(3)
      qqq(55) = O3(1)+D1(7)
      qqq(56) = O3(2)
      qqq(57) = O3(3)
        
      qqq( 4) = O1(4)
      qqq( 5) = O1(5)+D1(1)
      qqq( 6) = O1(6)     
      qqq(31) = O2(4)     
      qqq(32) = O2(5)+D1(4)
      qqq(33) = O2(6)     
      qqq(58) = O3(4)     
      qqq(59) = O3(5)+D1(7)
      qqq(60) = O3(6)
        
      qqq( 7) = O1(7)
      qqq( 8) = O1(8)
      qqq( 9) = O1(9)+D1(1)
      qqq(34) = O2(7)
      qqq(35) = O2(8)
      qqq(36) = O2(9)+D1(4)
      qqq(61) = O3(7)
      qqq(62) = O3(8)
      qqq(63) = O3(9)+D1(7)
        
      qqq(10) = O4(1)+D1(2)
      qqq(11) = O4(2)
      qqq(12) = O4(3)
      qqq(37) = O5(1)+D1(5)
      qqq(38) = O5(2)
      qqq(39) = O5(3)
      qqq(64) = O6(1)+D1(8)
      qqq(65) = O6(2)
      qqq(66) = O6(3)
        
      qqq(13) = O4(4)
      qqq(14) = O4(5)+D1(2)
      qqq(15) = O4(6)
      qqq(40) = O5(4)
      qqq(41) = O5(5)+D1(5)
      qqq(42) = O5(6)
      qqq(67) = O6(4)
      qqq(68) = O6(5)+D1(8)
      qqq(69) = O6(6)
        
      qqq(16) = O4(7)
      qqq(17) = O4(8)
      qqq(18) = O4(9)+D1(2)
      qqq(43) = O5(7)
      qqq(44) = O5(8)
      qqq(45) = O5(9)+D1(5)
      qqq(70) = O6(7)
      qqq(71) = O6(8)
      qqq(72) = O6(9)+D1(8)
        
      qqq(19) = O7(1)+D1(3)
      qqq(20) = O7(2)
      qqq(21) = O7(3)
      qqq(46) = O8(1)+D1(6)
      qqq(47) = O8(2)
      qqq(48) = O8(3)
      qqq(73) = O9(1)+D1(9)
      qqq(74) = O9(2)
      qqq(75) = O9(3)
        
      qqq(22) = O7(4)
      qqq(23) = O7(5)+D1(3)
      qqq(24) = O7(6)
      qqq(49) = O8(4)
      qqq(50) = O8(5)+D1(6)
      qqq(51) = O8(6)
      qqq(76) = O9(4)
      qqq(77) = O9(5)+D1(9)
      qqq(78) = O9(6)
        
      qqq(25) = O7(7)
      qqq(26) = O7(8)
      qqq(27) = O7(9)+D1(3)
      qqq(52) = O8(7)
      qqq(53) = O8(8)
      qqq(54) = O8(9)+D1(6)
      qqq(79) = O9(7)
      qqq(80) = O9(8)
      qqq(81) = O9(9)+D1(9)

c ppss-->ppps in blas 
      call ipgemm (27,ppp,qqq,tiu)

c  blased O1 change suitable form for ppps-->pppp
      call ipgemm (3,b2,d2,tiu)
      call ipgemm (3,b3,d3,tkw)
               
      qqq( 1) = PPP( 1)+B2(1)+B3(1)
      qqq( 2) = PPP( 2)      +B3(4)
      qqq( 3) = PPP( 3)      +B3(7)
      qqq(28) = PPP(10)+B2(2)+B3(2)
      qqq(29) = PPP(11)      +B3(5)
      qqq(30) = PPP(12)      +B3(8)
      qqq(55) = PPP(19)+B2(3)+B3(3)
      qqq(56) = PPP(20)      +B3(6)
      qqq(57) = PPP(21)      +B3(9)
      qqq( 4) = PPP(28)
      qqq( 5) = PPP(29)+B2(1)
      qqq( 6) = PPP(30)
      qqq(31) = PPP(37)
      qqq(32) = PPP(38)+B2(2)
      qqq(33) = PPP(39)
      qqq(58) = PPP(46)
      qqq(59) = PPP(47)+B2(3)
      qqq(60) = PPP(48)
          
      qqq( 7) = PPP(55)
      qqq( 8) = PPP(56)
      qqq( 9) = PPP(57)+B2(1)
      qqq(34) = PPP(64)
      qqq(35) = PPP(65)
      qqq(36) = PPP(66)+B2(2)
      qqq(61) = PPP(73)
      qqq(62) = PPP(74)
      qqq(63) = PPP(75)+B2(3)
                  
      qqq(10) = PPP( 4)+B2(4)
      qqq(11) = PPP( 5)
      qqq(12) = PPP( 6)
      qqq(37) = PPP(13)+B2(5)
      qqq(38) = PPP(14)
      qqq(39) = PPP(15)
      qqq(64) = PPP(22)+B2(6)
      qqq(65) = PPP(23)
      qqq(66) = PPP(24)
    
      qqq(13) = PPP(31)      +B3(1)
      qqq(14) = PPP(32)+B2(4)+B3(4)
      qqq(15) = PPP(33)      +B3(7)
      qqq(40) = PPP(40)      +B3(2)
      qqq(41) = PPP(41)+B2(5)+B3(5)
      qqq(42) = PPP(42)      +B3(8)
      qqq(67) = PPP(49)      +B3(3)
      qqq(68) = PPP(50)+B2(6)+B3(6)
      qqq(69) = PPP(51)      +B3(9)
         
      qqq(16) = PPP(58)
      qqq(17) = PPP(59)
      qqq(18) = PPP(60)+B2(4)
      qqq(43) = PPP(67)
      qqq(44) = PPP(68)
      qqq(45) = PPP(69)+B2(5)
      qqq(70) = PPP(76)
      qqq(71) = PPP(77)
      qqq(72) = PPP(78)+B2(6)
         
      qqq(19) = PPP( 7)+B2(7)
      qqq(20) = PPP( 8)
      qqq(21) = PPP( 9)
      qqq(46) = PPP(16)+B2(8)
      qqq(47) = PPP(17)
      qqq(48) = PPP(18)
      qqq(73) = PPP(25)+B2(9)
      qqq(74) = PPP(26)
      qqq(75) = PPP(27)
         
      qqq(22) = PPP(34)
      qqq(23) = PPP(35)+B2(7)
      qqq(24) = PPP(36)
      qqq(49) = PPP(43)
      qqq(50) = PPP(44)+B2(8)
      qqq(51) = PPP(45)
      qqq(76) = PPP(52)
      qqq(77) = PPP(53)+B2(9)
      qqq(78) = PPP(54)
         
      qqq(25) = PPP(61)      +B3(1)
      qqq(26) = PPP(62)      +B3(4)
      qqq(27) = PPP(63)+B2(7)+B3(7)
      qqq(52) = PPP(70)      +B3(2)
      qqq(53) = PPP(71)      +B3(5)
      qqq(54) = PPP(72)+B2(8)+B3(8)
      qqq(79) = PPP(79)      +B3(3)
      qqq(80) = PPP(80)      +B3(6)
      qqq(81) = PPP(81)+B2(9)+B3(9)

c ppps-->pppp in blas 
      call ipgemm (27,ppp,qqq,tiu)
!XX
      ec( 1) =PPP( 1)+D4(1)+D5(1)+D6(1)+D7+D8+D9
      ec( 2) =PPP( 2)      +D5(2)+D6(2)
      ec( 3) =PPP( 3)      +D5(3)+D6(3)
      ec( 4) =PPP(10)+D4(2)      +D6(4)
      ec( 5) =PPP(11)            +D6(5)      +D9
      ec( 6) =PPP(12)            +D6(6)
      ec( 7) =PPP(19)+D4(3)      +D6(7)
      ec( 8) =PPP(20)            +D6(8)
      ec( 9) =PPP(21)            +D6(9)      +D9
!YY
      ec(10) =PPP(31)            +D6(1)      +D9
      ec(11) =PPP(32)+D4(4)      +D6(2)
      ec(12) =PPP(33)            +D6(3)
      ec(13) =PPP(40)      +D5(4)+D6(4)
      ec(14) =PPP(41)+D4(5)+D5(5)+D6(5)+D7+D8+D9
      ec(15) =PPP(42)      +D5(6)+D6(6)         
      ec(16) =PPP(49)            +D6(7)         
      ec(17) =PPP(50)+D4(6)      +D6(8)         
      ec(18) =PPP(51)            +D6(9)      +D9
!ZZ
      ec(19) =PPP(61)            +D6(1)      +D9
      ec(20) =PPP(62)            +D6(2)         
      ec(21) =PPP(63)+D4(7)      +D6(3)         
      ec(22) =PPP(70)            +D6(4)         
      ec(23) =PPP(71)            +D6(5)      +D9
      ec(24) =PPP(72)+D4(8)      +D6(6)         
      ec(25) =PPP(79)      +D5(7)+D6(7)         
      ec(26) =PPP(80)      +D5(8)+D6(8)         
      ec(27) =PPP(81)+D4(9)+D5(9)+D6(9)+D7+D8+D9
!XY
      ec(28) =PPP( 4)+D4(4)+D5(4)
      ec(29) =PPP( 5)      +D5(5)         +D8
      ec(30) =PPP( 6)      +D5(6)
      ec(31) =PPP(13)+D4(5)            +D7
      ec(32) =PPP(14)      
      ec(33) =PPP(15)      
      ec(34) =PPP(22)+D4(6)
      ec(35) =PPP(23)
      ec(36) =PPP(24)
!XZ
      ec(37) =PPP( 7)+D4(7)+D5(7) 
      ec(38) =PPP( 8)      +D5(8)
      ec(39) =PPP( 9)      +D5(9)         +D8
      ec(40) =PPP(16)+D4(8)      
      ec(41) =PPP(17)      
      ec(42) =PPP(18)      
      ec(43) =PPP(25)+D4(9)            +D7
      ec(44) =PPP(26)
      ec(45) =PPP(27)
!YZ
      ec(46) =PPP(34)      
      ec(47) =PPP(35)+D4(7)      
      ec(48) =PPP(36)            
      ec(49) =PPP(43)      +D5(7)
      ec(50) =PPP(44)+D4(8)+D5(8)
      ec(51) =PPP(45)      +D5(9)         +D8
      ec(52) =PPP(52)      
      ec(53) =PPP(53)+D4(9)            +D7
      ec(54) =PPP(54)
      
      
      if (ierisw.eq.0) then
         do ir = 28,54
            ec(ir) = ec(ir) * root3
         enddo
      endif

      end
CC IMDDSS ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DDSS
C ===================================================================

      subroutine imddss(
     &           ec   ,
     &           xyz  ,  ddss ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )

      implicit real(8)(a-h,o-z)

      dimension ddss(88)
      dimension xyz(3,natom)
      dimension tiu(9)
      dimension o1(9),o2(9),o3(9),o4(9),o5(9),o6(9)
      dimension o7(9),o8(9),o9(9)
      dimension d1(9),d2(9),d3(9),d4(9),d5(9),d6(9)
      dimension p1(9),b2(9),b3(9),ppp(81),qqq(81)
      dimension ec(mvhgp)

      data      root3 / 1.73205080756887729353d+00 /
 
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)
C** BEGIN PRISM DDSS L2 STEP =========================================
C                    DDSS WITH BLAS
C ====================================================================
      F004000=DDSS( 1)
      F004101=DDSS( 2)
      F004202=DDSS( 3)
      F004303=DDSS( 4)
      F004404=DDSS( 5)
      F105000=DDSS( 6)
      F105101=DDSS( 7)
      F105202=DDSS( 8)
      F105303=DDSS( 9)
      F206000=DDSS(10)
      F206101=DDSS(11)
      F206202=DDSS(12)
      F307000=DDSS(13)
      F307101=DDSS(14)
      F408000=DDSS(15)
      T004000=DDSS(16)
      T004101=DDSS(17)
      T004202=DDSS(18)
      T014000=DDSS(19)
      T014101=DDSS(20)
      T014202=DDSS(21)
      T014303=DDSS(22)
      T104000=DDSS(23)
      T104101=DDSS(24)
      T104202=DDSS(25)
      T104303=DDSS(26)
      T105000=DDSS(27)
      T105101=DDSS(28)
      T115000=DDSS(29)
      T115101=DDSS(30)
      T115202=DDSS(31)
      T205000=DDSS(32)
      T205101=DDSS(33)
      T205202=DDSS(34)
      T206000=DDSS(35)
      T216000=DDSS(36)
      T216101=DDSS(37)
      T306000=DDSS(38)
      T306101=DDSS(39)
      T317000=DDSS(40)
      T407000=DDSS(41)
      D003000=DDSS(42)
      D003101=DDSS(43)
      D003202=DDSS(44)
      D004000=DDSS(45)
      D014000=DDSS(46)
      D014101=DDSS(47)
      D024000=DDSS(48)
      D024101=DDSS(49)
      D024202=DDSS(50)
      D104000=DDSS(51)
      D104101=DDSS(52)
      D114000=DDSS(53)
      D114101=DDSS(54)
      D114202=DDSS(55)
      D115000=DDSS(56)
      D125000=DDSS(57)
      D125101=DDSS(58)
      D204000=DDSS(59)
      D204101=DDSS(60)
      D204202=DDSS(61)
      D205000=DDSS(62)
      D215000=DDSS(63)
      D215101=DDSS(64)
      D226000=DDSS(65)
      D305000=DDSS(66)
      D305101=DDSS(67)
      D316000=DDSS(68)
      D406000=DDSS(69)
      U003000=DDSS(70)
      U013000=DDSS(71)
      U013101=DDSS(72)
      U024000=DDSS(73)
      U103000=DDSS(74)
      U103101=DDSS(75)
      U114000=DDSS(76)
      U124000=DDSS(77)
      U124101=DDSS(78)
      U204000=DDSS(79)
      U214000=DDSS(80)
      U214101=DDSS(81)
      U225000=DDSS(82)
      U315000=DDSS(83)
      Z002000=DDSS(84)
      Z023000=DDSS(85)
      Z113000=DDSS(86)
      Z203000=DDSS(87)
      Z224000=DDSS(88)

      O1(1)= +D226000+D406000+F408000+T317000
     &       +T317000+U315000+U315000+Z224000
     &       -D316000-D316000-D316000-D316000
     &       -T407000-T407000-U225000-U225000
      O1(4)= +D125101+F307101+T216101+T216101
     &       -D215101-D215101-T306101-U124101
      O1(7)= +D125000+F307000+T216000+T216000
     &       -D215000-D215000-T306000-U124000
      O1(2)= +D125101+F307101+T216101+T216101
     &       -D215101-D215101-T306101-U124101
      O1(5)= +D024202+F206202+T115202+T115202
      O1(8)= +D024101+F206101+T115101+T115101
      O1(3)= +D125000+F307000+T216000+T216000
     &       -D215000-D215000-T306000-U124000
      O1(6)= +D024101+F206101+T115101+T115101
      O1(9)= +D024000+F206000+T115000+T115000
 
      O2(1)= +D305101+F307101+T216101+U214101
     &       -D215101-D215101-T306101-T306101
      O2(4)= +F206202+T115202-D114202-T205202
      O2(7)= +F206101+T115101-D114101-T205101
      O2(2)= +F206202+T115202-D114202-T205202
      O2(5)= +F105303+T014303
      O2(8)= +F105202+T014202
      O2(3)= +F206101+T115101-D114101-T205101
      O2(6)= +F105202+T014202
      O2(9)= +F105101+T014101
 
      O3(1)= +D305000+F307000+T216000+U214000
     &       -D215000-D215000-T306000-T306000
      O3(4)= +F206101+T115101-D114101-T205101
      O3(7)= +F206000+T115000-D114000-T205000
      O3(2)= +F206101+T115101-D114101-T205101
      O3(5)= +F105202+T014202
      O3(8)= +F105101+T014101
      O3(3)= +F206000+T115000-D114000-T205000
      O3(6)= +F105101+T014101
      O3(9)= +F105000+T014000
            
      O4(1)= +D305101+F307101+T216101+U214101
     &       -D215101-D215101-T306101-T306101
      O4(4)= +F206202+T115202-D114202-T205202
      O4(7)= +F206101+T115101-D114101-T205101
      O4(2)= +F206202+T115202-D114202-T205202
      O4(5)= +F105303+T014303
      O4(8)= +F105202+T014202
      O4(3)= +F206101+T115101-D114101-T205101
      O4(6)= +F105202+T014202
      O4(9)= +F105101+T014101
                                              
      O5(1)= +D204202+F206202-T205202-T205202
      O5(4)= +F105303-T104303
      O5(7)= +F105202-T104202
      O5(2)= +F105303-T104303
      O5(5)= +F004404
      O5(8)= +F004303
      O5(3)= +F105202-T104202
      O5(6)= +F004303
      O5(9)= +F004202
            
      O6(1)= +D204101+F206101-T205101-T205101
      O6(4)= +F105202-T104202
      O6(7)= +F105101-T104101
      O6(2)= +F105202-T104202
      O6(5)= +F004303
      O6(8)= +F004202
      O6(3)= +F105101-T104101
      O6(6)= +F004202
      O6(9)= +F004101
            
      O7(1)= +D305000+F307000+T216000+U214000
     &       -D215000-D215000-T306000-T306000
      O7(4)= +F206101+T115101-D114101-T205101
      O7(7)= +F206000+T115000-D114000-T205000
      O7(2)= +F206101+T115101-D114101-T205101
      O7(5)= +F105202+T014202
      O7(8)= +F105101+T014101
      O7(3)= +F206000+T115000-D114000-T205000
      O7(6)= +F105101+T014101
      O7(9)= +F105000+T014000
            
      O8(1)= +D204101+F206101-T205101-T205101
      O8(4)= +F105202-T104202
      O8(7)= +F105101-T104101
      O8(2)= +F105202-T104202
      O8(5)= +F004303
      O8(8)= +F004202
      O8(3)= +F105101-T104101
      O8(6)= +F004202
      O8(9)= +F004101
            
      O9(1)= +D204000+F206000-T205000-T205000
      O9(4)= +F105101-T104101
      O9(7)= +F105000-T104000
      O9(2)= +F105101-T104101
      O9(5)= +F004202
      O9(8)= +F004101
      O9(3)= +F105000-T104000
      O9(6)= +F004101
      O9(9)= +F004000
c  Delta1 d_kl          
      D1(1)=+Z023000-U024000+U114000-D115000
     &      +U114000-D115000+D205000-T206000
      D1(4)=+U013101-D014101+D104101-T105101
      D1(7)=+U013000-D014000+D104000-T105000
      D1(2)=+U013101-D014101+D104101-T105101
      D1(5)=+D003202-T004202
      D1(8)=+D003101-T004101
      D1(3)=+U013000-D014000+D104000-T105000
      D1(6)=+D003101-T004101
      D1(9)=+D003000-T004000
c  Delta2 d_jl          
      D2(1)=-Z113000+U114000+U114000-D115000
     &      -U204000+D205000+D205000-T206000
      D2(4)=+U013101-D014101+D104101-T105101
      D2(7)=+U013000-D014000+D104000-T105000
      D2(2)=-U103101+D104101+D104101-T105101
      D2(5)=+D003202-T004202
      D2(8)=+D003101-T004101
      D2(3)=-U103000+D104000+D104000-T105000
      D2(6)=+D003101-T004101
      D2(9)=+D003000-T004000
c  Delta3 d_jk
      D3(1)=D2(1)
      D3(2)=D2(2)
      D3(3)=D2(3)
      D3(4)=D2(4)
      D3(5)=D2(5)
      D3(6)=D2(6)
      D3(7)=D2(7)
      D3(8)=D2(8)
      D3(9)=D2(9)
c  Delta4 d_il
      D4(1)=+D205000+U114000-U204000-Z113000
     &      -D115000-T206000+D205000+U114000
      D4(4)=+D104101+U013101-D014101-T105101
      D4(7)=+D104000+U013000-D014000-T105000
      D4(2)=+D104101-U103101-T105101+D104101
      D4(5)=+D003202-T004202
      D4(8)=+D003101-T004101
      D4(3)=+D104000-U103000-T105000+D104000
      D4(6)=+D003101-T004101
      D4(9)=+D003000-T004000
c  Delta5 d_ik
      D5(1)=D4(1)
      D5(4)=D4(4)
      D5(7)=D4(7)
      D5(2)=D4(2)
      D5(5)=D4(5)
      D5(8)=D4(8)
      D5(3)=D4(3)
      D5(6)=D4(6)
      D5(9)=D4(9)
c  Del d_ij
      D6(1)=+D205000+Z203000-U204000-U204000
     &      -T206000-U204000+D205000+D205000
      D6(4)=+D104101-U103101-T105101+D104101
      D6(7)=+D104000-U103000-T105000+D104000
      D6(2)=+D104101-U103101-T105101+D104101
      D6(5)=+D003202-T004202
      D6(8)=+D003101-T004101
      D6(3)=+D104000-U103000-T105000+D104000
      D6(6)=+D003101-T004101
      D6(9)=+D003000-T004000 
c  Delta7 d_il and d_jk
      D7 = Z002000-U003000-U003000+D004000
c  Delta8 d_ik and d_jl
      D8 = D7
c  Delta9 d_ij and d_kl
      D9 = D7
c Delta ssss-->ppss in blas 
      call ipgemm (3,p1,d4,tiu)         
      call ipgemmt(3,d4,p1,tiu)    

      call ipgemm (3,p1,d5,tiu)         
      call ipgemmt(3,d5,p1,tiu)    

      call ipgemm (3,p1,d6,tiu)         
      call ipgemmt(3,d6,p1,tiu)    
               
c ssss-->ppss in blas 

      call ipgemm (3,p1,o1,tiu)         
      call ipgemmt(3,o1,p1,tiu)    

      call ipgemm (3,p1,o2,tiu)         
      call ipgemmt(3,o2,p1,tiu)    

      call ipgemm (3,p1,o3,tiu)         
      call ipgemmt(3,o3,p1,tiu)    

      call ipgemm (3,p1,o4,tiu)         
      call ipgemmt(3,o4,p1,tiu)    

      call ipgemm (3,p1,o5,tiu)         
      call ipgemmt(3,o5,p1,tiu)    

      call ipgemm (3,p1,o6,tiu)         
      call ipgemmt(3,o6,p1,tiu)    

      call ipgemm (3,p1,o7,tiu)         
      call ipgemmt(3,o7,p1,tiu)    

      call ipgemm (3,p1,o8,tiu)         
      call ipgemmt(3,o8,p1,tiu)    

      call ipgemm (3,p1,o9,tiu)         
      call ipgemmt(3,o9,p1,tiu)    

c  blased O1 change suitable form for ppss-->ppps
      qqq( 1) = O1(1)+D1(1)
      qqq( 2) = O1(2)
      qqq( 3) = O1(3)
      qqq(28) = O2(1)+D1(4)
      qqq(29) = O2(2)
      qqq(30) = O2(3)
      qqq(55) = O3(1)+D1(7)
      qqq(56) = O3(2)
      qqq(57) = O3(3)
         
      qqq( 4) = O1(4)
      qqq( 5) = O1(5)+D1(1)
      qqq( 6) = O1(6)     
      qqq(31) = O2(4)     
      qqq(32) = O2(5)+D1(4)
      qqq(33) = O2(6)     
      qqq(58) = O3(4)     
      qqq(59) = O3(5)+D1(7)
      qqq(60) = O3(6)
         
      qqq( 7) = O1(7)
      qqq( 8) = O1(8)
      qqq( 9) = O1(9)+D1(1)
      qqq(34) = O2(7)     
      qqq(35) = O2(8)     
      qqq(36) = O2(9)+D1(4)
      qqq(61) = O3(7)     
      qqq(62) = O3(8)     
      qqq(63) = O3(9)+D1(7)
         
      qqq(10) = O4(1)+D1(2)
      qqq(11) = O4(2)
      qqq(12) = O4(3)
      qqq(37) = O5(1)+D1(5)
      qqq(38) = O5(2)
      qqq(39) = O5(3)
      qqq(64) = O6(1)+D1(8)
      qqq(65) = O6(2)
      qqq(66) = O6(3)
         
      qqq(13) = O4(4)
      qqq(14) = O4(5)+D1(2)
      qqq(15) = O4(6)
      qqq(40) = O5(4)
      qqq(41) = O5(5)+D1(5)
      qqq(42) = O5(6)
      qqq(67) = O6(4)
      qqq(68) = O6(5)+D1(8)
      qqq(69) = O6(6)
         
      qqq(16) = O4(7)
      qqq(17) = O4(8)
      qqq(18) = O4(9)+D1(2)
      qqq(43) = O5(7)
      qqq(44) = O5(8)
      qqq(45) = O5(9)+D1(5)
      qqq(70) = O6(7)
      qqq(71) = O6(8)
      qqq(72) = O6(9)+D1(8)               
         
      qqq(19) = O7(1)+D1(3)
      qqq(20) = O7(2)
      qqq(21) = O7(3)
      qqq(46) = O8(1)+D1(6)
      qqq(47) = O8(2)
      qqq(48) = O8(3)
      qqq(73) = O9(1)+D1(9)
      qqq(74) = O9(2)
      qqq(75) = O9(3)
         
      qqq(22) = O7(4)
      qqq(23) = O7(5)+D1(3)
      qqq(24) = O7(6)
      qqq(49) = O8(4)
      qqq(50) = O8(5)+D1(6)
      qqq(51) = O8(6)
      qqq(76) = O9(4)
      qqq(77) = O9(5)+D1(9)
      qqq(78) = O9(6)
         
      qqq(25) = O7(7)
      qqq(26) = O7(8)
      qqq(27) = O7(9)+D1(3)
      qqq(52) = O8(7)
      qqq(53) = O8(8)
      qqq(54) = O8(9)+D1(6)
      qqq(79) = O9(7)
      qqq(80) = O9(8)
      qqq(81) = O9(9)+D1(9)                

c ppss-->ppps in blas
      call ipgemm (27,ppp,qqq,tiu)

c  blased O1 change suitable form for ppps-->pppp

      call ipgemm (3,b2,d2,tiu)
      call ipgemm (3,b3,d3,tiu)

      qqq( 1) = PPP( 1)+B2(1)+B3(1)
      qqq( 2) = PPP( 2)      +B3(4)
      qqq( 3) = PPP( 3)      +B3(7)
      qqq(28) = PPP(10)+B2(2)+B3(2)
      qqq(29) = PPP(11)      +B3(5)
      qqq(30) = PPP(12)      +B3(8)
      qqq(55) = PPP(19)+B2(3)+B3(3)
      qqq(56) = PPP(20)      +B3(6)
      qqq(57) = PPP(21)      +B3(9)
      qqq( 4) = PPP(28)
      qqq( 5) = PPP(29)+B2(1)
      qqq( 6) = PPP(30)
      qqq(31) = PPP(37)
      qqq(32) = PPP(38)+B2(2)
      qqq(33) = PPP(39)
      qqq(58) = PPP(46)
      qqq(59) = PPP(47)+B2(3)
      qqq(60) = PPP(48)
        
      qqq( 7) = PPP(55)
      qqq( 8) = PPP(56)
      qqq( 9) = PPP(57)+B2(1)
      qqq(34) = PPP(64)
      qqq(35) = PPP(65)
      qqq(36) = PPP(66)+B2(2)
      qqq(61) = PPP(73)
      qqq(62) = PPP(74)
      qqq(63) = PPP(75)+B2(3)
        
      qqq(10) = PPP( 4)+B2(4)
      qqq(11) = PPP( 5)
      qqq(12) = PPP( 6)
      qqq(37) = PPP(13)+B2(5)
      qqq(38) = PPP(14)
      qqq(39) = PPP(15)
      qqq(64) = PPP(22)+B2(6)
      qqq(65) = PPP(23)
      qqq(66) = PPP(24)
        
      qqq(13) = PPP(31)      +B3(1)
      qqq(14) = PPP(32)+B2(4)+B3(4)
      qqq(15) = PPP(33)      +B3(7)
      qqq(40) = PPP(40)      +B3(2)
      qqq(41) = PPP(41)+B2(5)+B3(5)
      qqq(42) = PPP(42)      +B3(8)
      qqq(67) = PPP(49)      +B3(3)
      qqq(68) = PPP(50)+B2(6)+B3(6)
      qqq(69) = PPP(51)      +B3(9)
        
      qqq(16) = PPP(58)
      qqq(17) = PPP(59)
      qqq(18) = PPP(60)+B2(4)
      qqq(43) = PPP(67)
      qqq(44) = PPP(68)
      qqq(45) = PPP(69)+B2(5)
      qqq(70) = PPP(76)
      qqq(71) = PPP(77)
      qqq(72) = PPP(78)+B2(6)               
        
      qqq(19) = PPP( 7)+B2(7)
      qqq(20) = PPP( 8)
      qqq(21) = PPP( 9)
      qqq(46) = PPP(16)+B2(8)
      qqq(47) = PPP(17)
      qqq(48) = PPP(18)
      qqq(73) = PPP(25)+B2(9)
      qqq(74) = PPP(26)
      qqq(75) = PPP(27)
        
      qqq(22) = PPP(34)
      qqq(23) = PPP(35)+B2(7)
      qqq(24) = PPP(36)
      qqq(49) = PPP(43)
      qqq(50) = PPP(44)+B2(8)
      qqq(51) = PPP(45)
      qqq(76) = PPP(52)
      qqq(77) = PPP(53)+B2(9)
      qqq(78) = PPP(54)
        
      qqq(25) = PPP(61)      +B3(1)
      qqq(26) = PPP(62)      +B3(4)
      qqq(27) = PPP(63)+B2(7)+B3(7)
      qqq(52) = PPP(70)      +B3(2)
      qqq(53) = PPP(71)      +B3(5)
      qqq(54) = PPP(72)+B2(8)+B3(8)
      qqq(79) = PPP(79)      +B3(3)
      qqq(80) = PPP(80)      +B3(6)
      qqq(81) = PPP(81)+B2(9)+B3(9)

c ppps-->pppp in blas 
      call ipgemm (27,ppp,qqq,tiu)
      
      if (ierisw.eq.0) then
         ec( 1) =(PPP( 1)+D4(1)+D5(1)+D6(1)+D7+D8+D9)
         ec( 2) =(PPP(11)            +D6(5)      +D9)
         ec( 3) =(PPP(21)            +D6(9)      +D9)
         ec( 4) =(PPP(10)+D4(2)      +D6(4)         )*root3
         ec( 5) =(PPP(19)+D4(3)      +D6(7)         )*root3
         ec( 6) =(PPP(20)            +D6(8)         )*root3
         
         ec( 7) =(PPP(31)            +D6(1)      +D9)    
         ec( 8) =(PPP(41)+D4(5)+D5(5)+D6(5)+D7+D8+D9)
         ec( 9) =(PPP(51)            +D6(9)      +D9)
         ec(10) =(PPP(40)      +D5(4)+D6(4)         )*root3
         ec(11) =(PPP(49)            +D6(7)         )*root3
         ec(12) =(PPP(50)+D4(6)      +D6(8)         )*root3
         
         ec(13) =(PPP(61)            +D6(1)      +D9)
         ec(14) =(PPP(71)            +D6(5)      +D9)
         ec(15) =(PPP(81)+D4(9)+D5(9)+D6(9)+D7+D8+D9)
         ec(16) =(PPP(70)            +D6(4)         )*root3
         ec(17) =(PPP(79)      +D5(7)+D6(7)         )*root3 !ZZXZ
         ec(18) =(PPP(80)      +D5(8)+D6(8)         )*root3
         
         ec(19) =(PPP(28)                           )
         ec(20) =(PPP(38)+D4(2)+D5(2)               )
         ec(21) =(PPP(48)                           )
         ec(22) =(PPP(37)      +D5(1)         +D8   )*root3
         ec(23) =(PPP(46)                           )*root3
         ec(24) =(PPP(47)+D4(3)                     )*root3
         
         ec(25) =(PPP(55)                           )
         ec(26) =(PPP(65)                           )
         ec(27) =(PPP(75)+D4(3)+D5(3)               ) !XZZZ
         ec(28) =(PPP(64)                           )*root3
         ec(29) =(PPP(73)      +D5(1)         +D8   )*root3
         ec(30) =(PPP(74)      +D5(2)               )*root3
         
         ec(31) =(PPP(58)                           )
         ec(32) =(PPP(68)                           )
         ec(33) =(PPP(78)+D4(6)+D5(6)               )
         ec(34) =(PPP(67)                           )*root3
         ec(35) =(PPP(76)      +D5(4)               )*root3
         ec(36) =(PPP(77)      +D5(5)         +D8   )*root3
         
         do ir = 19,36
            ec(ir) = ec(ir) * root3
         enddo
      else
         ec( 1) = PPP( 1)+D4(1)+D5(1)+D6(1)+D7+D8+D9 
         ec( 2) = PPP(11)            +D6(5)      +D9 
         ec( 3) = PPP(21)            +D6(9)      +D9 
         ec( 4) = PPP(10)+D4(2)      +D6(4)          
         ec( 5) = PPP(19)+D4(3)      +D6(7)          
         ec( 6) = PPP(20)            +D6(8)          
         
         ec( 7) = PPP(31)            +D6(1)      +D9 
         ec( 8) = PPP(41)+D4(5)+D5(5)+D6(5)+D7+D8+D9 
         ec( 9) = PPP(51)            +D6(9)      +D9 
         ec(10) = PPP(40)      +D5(4)+D6(4)          
         ec(11) = PPP(49)            +D6(7)          
         ec(12) = PPP(50)+D4(6)      +D6(8)          
         
         ec(13) = PPP(61)            +D6(1)      +D9 
         ec(14) = PPP(71)            +D6(5)      +D9 
         ec(15) = PPP(81)+D4(9)+D5(9)+D6(9)+D7+D8+D9 
         ec(16) = PPP(70)            +D6(4)          
         ec(17) = PPP(79)      +D5(7)+D6(7) !ZZXZ
         ec(18) = PPP(80)      +D5(8)+D6(8)          
         
         ec(19) = PPP(28)                            
         ec(20) = PPP(38)+D4(2)+D5(2)                
         ec(21) = PPP(48)                            
         ec(22) = PPP(37)      +D5(1)         +D8    
         ec(23) = PPP(46)                            
         ec(24) = PPP(47)+D4(3)                      
         
         ec(25) = PPP(55)                            
         ec(26) = PPP(65)                            
         ec(27) = PPP(75)+D4(3)+D5(3)                
         ec(28) = PPP(64)                            
         ec(29) = PPP(73)      +D5(1)         +D8    
         ec(30) = PPP(74)      +D5(2)                
         
         ec(31) = PPP(58)                            
         ec(32) = PPP(68)                            
         ec(33) = PPP(78)+D4(6)+D5(6)                
         ec(34) = PPP(67)                            
         ec(35) = PPP(76)      +D5(4)                
         ec(36) = PPP(77)      +D5(5)         +D8    
         
      endif
      
      end
CC IMDPPP ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DPPP
C ===================================================================
       subroutine imdppp(
     &           ec   ,
     &           xyz  ,  dppp ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )


      implicit real(8)(a-h,o-z)

      dimension dppp(336)
      dimension xyz(3,natom)
      dimension tiu(9),tkw(9)

      dimension o01(9),o02(9),o03(9),o04(9),o05(9),o06(9)
      dimension o07(9),o08(9),o09(9),o10(9),o11(9),o12(9)
      dimension o13(9),o14(9),o15(9),o16(9),o17(9),o18(9)
      dimension o19(9),o20(9),o21(9),o22(9),o23(9),o24(9)
      dimension o25(9),o26(9),o27(9)

      dimension dlm1(9),dlm2(9),dlm3(9),dkm1(9),dkm2(9),dkm3(9)
      dimension dkl1(9),dkl2(9),dkl3(9),djm1(9),djm2(9),djm3(9)
      dimension djl1(9),djl2(9),djl3(9),djk1(9),djk2(9),djk3(9)
      dimension dim1(9),dim2(9),dim3(9),dil1(9),dil2(9),dil3(9)
      dimension dik1(9),dik2(9),dik3(9),dij1(9),dij2(9),dij3(9)

      dimension plm1(9),plm2(9),plm3(9),pkm1(9),pkm2(9),pkm3(9)
      dimension pkl1(9),pkl2(9),pkl3(9),pjm1(9),pjm2(9),pjm3(9)
      dimension pjl1(9),pjl2(9),pjl3(9),pjk1(9),pjk2(9),pjk3(9)
      dimension pim1(9),pim2(9),pim3(9),pil1(9),pil2(9),pil3(9) 
      dimension pik1(9),pik2(9),pik3(9),pij1(9),pij2(9),pij3(9) 

      dimension p1(9),ppp(243),qqq(243),ddd(45),eee(45)

      dimension ec(mvhgp)

      data      root3 / 1.73205080756887729353d+00 /
 
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)

      tkw(1) = -tiu(1)
      tkw(4) = -tiu(4)
      tkw(7) = -tiu(7)
      tkw(2) = -tiu(2)
      tkw(5) = -tiu(5)
      tkw(8) = -tiu(8)
      tkw(3) = -tiu(3)
      tkw(6) = -tiu(6)
      tkw(9) = -tiu(9)

      include 'ints_iset_dppp.inc'

      O01(1) = +F417002+F417002+T326002+V508002
     &         -D325002-F507002-T416002-T416002
      O01(4) = +D315102+D315102+F316103+F316103
     &         +T225103+T406102+U224102+V407103
     &         -D224103-D225102-F406103-F407102
     &         -T315103-T315103-T316102-T316102
      O01(7) = +F316002+F316002+T225002+V407002
     &         -D224002-F406002-T315002-T315002
      O01(2) = +D225012+F316103+F316103+F407012
     &         +T225103+T316012+T316012+V407103
     &         -D224103-D315012-D315012-F406103
     &         -T315103-T315103-T406012-U224012
      O01(5) = +D124113+D214203+D214203+D305112
     &         +F215204+F215204+F306113+T124204
     &         +T215113+T215113+T305203+U123203
     &         +U214112+U214112+V306204+Z123112
     &         -D123204-D124203-D214113-D214113
     &         -D215112-D215112-F305204-F306203
     &         -T214204-T214204-T215203-T215203
     &         -T305113-T306112-U123113-U124112
      O01(8) = +D124012+F215103+F215103+F306012
     &         +T124103+T215012+T215012+V306103
     &         -D123103-D214012-D214012-F305103
     &         -T214103-T214103-T305012-U123012
      O01(3) = +F316002+F316002+T225002+V407002
     &         -D224002-F406002-T315002-T315002
      O01(6) = +D214102+D214102+F215103+F215103
     &         +T124103+T305102+U123102+V306103
     &         -D123103-D124102-F305103-F306102
     &         -T214103-T214103-T215102-T215102
      O01(9) = +F215002+F215002+T124002+V306002
     &         -D123002-F305002-T214002-T214002

      O02(1) = +F316103+F316103+T225103+V407103
      O02(4) = +F215204+F215204+T124204+V306204
     &         -D124203-F306203-T215203-T215203
      O02(7) = +F215103+F215103+T124103+V306103
      O02(2) = +D124113+F215204+F215204+F306113
     &         +T124204+T215113+T215113+V306204
      O02(5) = +D023214+F114305+F114305+F205214
     &         +T023305+T114214+T114214+V205305
     &         -D023304-D114213-D114213-F205304
     &         -T114304-T114304-T205213-U023213
      O02(8) = +D023113+F114204+F114204+F205113
     &         +T023204+T114113+T114113+V205204
      O02(3) = +F215103+F215103+T124103+V306103
      O02(6) = +F114204+F114204+T023204+V205204
     &         -D023203-F205203-T114203-T114203
      O02(9) = +F114103+F114103+T023103+V205103

      O03(1) = +F316002+F316002+T225002+V407002
      O03(4) = +F215103+F215103+T124103+V306103
     &         -D124102-F306102-T215102-T215102
      O03(7) = +F215002+F215002+T124002+V306002
      O03(2) = +D124012+F215103+F215103+F306012
     &         +T124103+T215012+T215012+V306103
      O03(5) = +D023113+F114204+F114204+F205113
     &         +T023204+T114113+T114113+V205204
     &         -D023203-D114112-D114112-F205203
     &         -T114203-T114203-T205112-U023112
      O03(8) = +D023012+F114103+F114103+F205012
     &         +T023103+T114012+T114012+V205103
      O03(3) = +F215002+F215002+T124002+V306002
      O03(6) = +F114103+F114103+T023103+V205103
     &         -D023102-F205102-T114102-T114102
      O03(9) = +F114002+F114002+T023002+V205002

      O04(1) = +F316103+V407103-F406103-T315103
      O04(4) = +D214203+F215204+T305203+V306204
     &         -F305204-F306203-T214204-T215203
      O04(7) = +F215103+V306103-F305103-T214103
      O04(2) = +F215204+F306113+T215113+V306204
     &         -D214113-F305204-T214204-T305113
      O04(5) = +D113304+D204213+F114305+F205214
     &         +T114214+T204304+U113213+V205305
     &         -D113214-D114213-F204305-F205304
     &         -T113305-T114304-T204214-T205213
      O04(8) = +F114204+F205113+T114113+V205204
     &         -D113113-F204204-T113204-T204113
      O04(3) = +F215103+V306103-F305103-T214103
      O04(6) = +D113203+F114204+T204203+V205204
     &         -F204204-F205203-T113204-T114203
      O04(9) = +F114103+V205103-F204103-T113103

      O05(1) = +F215204+V306204
      O05(4) = +F114305+V205305-F205304-T114304
      O05(7) = +F114204+V205204
      O05(2) = +F114305+F205214+T114214+V205305
      O05(5) = +F013406+F104315+T013315+V104406
     &         -D013314-F104405-T013405-T104314
      O05(8) = +F013305+F104214+T013214+V104305
      O05(3) = +F114204+V205204
      O05(6) = +F013305+V104305-F104304-T013304
      O05(9) = +F013204+V104204

      O06(1) = +F215103+V306103
      O06(4) = +F114204+V205204-F205203-T114203
      O06(7) = +F114103+V205103
      O06(2) = +F114204+F205113+T114113+V205204
      O06(5) = +F013305+F104214+T013214+V104305
     &         -D013213-F104304-T013304-T104213
      O06(8) = +F013204+F104113+T013113+V104204
      O06(3) = +F114103+V205103
      O06(6) = +F013204+V104204-F104203-T013203
      O06(9) = +F013103+V104103

      O07(1) = +F316002+V407002-F406002-T315002
      O07(4) = +D214102+F215103+T305102+V306103
     &         -F305103-F306102-T214103-T215102
      O07(7) = +F215002+V306002-F305002-T214002
      O07(2) = +F215103+F306012+T215012+V306103
     &         -D214012-F305103-T214103-T305012
      O07(5) = +D113203+D204112+F114204+F205113
     &         +T114113+T204203+U113112+V205204
     &         -D113113-D114112-F204204-F205203
     &         -T113204-T114203-T204113-T205112
      O07(8) = +F114103+F205012+T114012+V205103
     &         -D113012-F204103-T113103-T204012
      O07(3) = +F215002+V306002-F305002-T214002
      O07(6) = +D113102+F114103+T204102+V205103
     &         -F204103-F205102-T113103-T114102
      O07(9) = +F114002+V205002-F204002-T113002

      O08(1) = +F215103+V306103
      O08(4) = +F114204+V205204-F205203-T114203
      O08(7) = +F114103+V205103
      O08(2) = +F114204+F205113+T114113+V205204
      O08(5) = +F013305+F104214+T013214+V104305
     &         -D013213-F104304-T013304-T104213
      O08(8) = +F013204+F104113+T013113+V104204
      O08(3) = +F114103+V205103
      O08(6) = +F013204+V104204-F104203-T013203
      O08(9) = +F013103+V104103

      O09(1) = +F215002+V306002
      O09(4) = +F114103+V205103-F205102-T114102
      O09(7) = +F114002+V205002
      O09(2) = +F114103+F205012+T114012+V205103
      O09(5) = +F013204+F104113+T013113+V104204
     &         -D013112-F104203-T013203-T104112
      O09(8) = +F013103+F104012+T013012+V104103
      O09(3) = +F114002+V205002
      O09(6) = +F013103+V104103-F104102-T013102
      O09(9) = +F013002+V104002

      O10(1)= +F316103+V407103-F406103-T315103
      O10(4)= +D214203+F215204+T305203+V306204
     &        -F305204-F306203-T214204-T215203
      O10(7)= +F215103+V306103-F305103-T214103
      O10(2)= +F215204+F306113+T215113+V306204
     &        -D214113-F305204-T214204-T305113
      O10(5)= +D113304+D204213+F114305+F205214
     &        +T114214+T204304+U113213+V205305
     &        -D113214-D114213-F204305-F205304
     &        -T113305-T114304-T204214-T205213
      O10(8)= +F114204+F205113+T114113+V205204
     &        -D113113-F204204-T113204-T204113
      O10(3)= +F215103+V306103-F305103-T214103
      O10(6)= +D113203+F114204+T204203+V205204
     &        -F204204-F205203-T113204-T114203
      O10(9)= +F114103+V205103-F204103-T113103

      O11(1)= +F215204+V306204
      O11(4)= +F114305+V205305-F205304-T114304
      O11(7)= +F114204+V205204
      O11(2)= +F114305+F205214+T114214+V205305
      O11(5)= +F013406+F104315+T013315+V104406
     &         -D013314-F104405-T013405-T104314
      O11(8)= +F013305+F104214+T013214+V104305
      O11(3)= +F114204+V205204
      O11(6)= +F013305+V104305-F104304-T013304
      O11(9)= +F013204+V104204

      O12(1)= +F215103+V306103
      O12(4)= +F114204+V205204-F205203-T114203
      O12(7)= +F114103+V205103
      O12(2)= +F114204+F205113+T114113+V205204
      O12(5)= +F013305+F104214+T013214+V104305
     &         -D013213-F104304-T013304-T104213
      O12(8)= +F013204+F104113+T013113+V104204
      O12(3)= +F114103+V205103
      O12(6)= +F013204+V104204-F104203-T013203
      O12(9)= +F013103+V104103

      O13(1)= +V306204-F305204
      O13(4)= +T204304+V205305-F204305-F205304
      O13(7)= +V205204-F204204
      O13(2)= +F205214+V205305-F204305-T204214
      O13(5)= +D103314+F104315+T103405+V104406
     &         -F103406-F104405-T103315-T104314
      O13(8)= +F104214+V104305-F103305-T103214
      O13(3)= +V205204-F204204
      O13(6)= +T103304+V104305-F103305-F104304
      O13(9)= +V104204-F103204

      O14(1)= +V205305
      O14(4)= +V104406-F104405
      O14(7)= +V104305
      O14(2)= +F104315+V104406
      O14(5)= +F003416+V003507-F003506-T003415
      O14(8)= +F003315+V003406
      O14(3)= +V104305
      O14(6)= +V003406-F003405
      O14(9)= +V003305

      O15(1)= +V205204
      O15(4)= +V104305-F104304
      O15(7)= +V104204
      O15(2)= +F104214+V104305
      O15(5)= +F003315+V003406-F003405-T003314
      O15(8)= +F003214+V003305
      O15(3)= +V104204
      O15(6)= +V003305-F003304
      O15(9)= +V003204

      O16(1)= +V306103-F305103
      O16(4)= +T204203+V205204-F204204-F205203
      O16(7)= +V205103-F204103
      O16(2)= +F205113+V205204-F204204-T204113
      O16(5)= +D103213+F104214+T103304+V104305
     &         -F103305-F104304-T103214-T104213
      O16(8)= +F104113+V104204-F103204-T103113
      O16(3)= +V205103-F204103
      O16(6)= +T103203+V104204-F103204-F104203
      O16(9)= +V104103-F103103

      O17(1)= +V205204
      O17(4)= +V104305-F104304
      O17(7)= +V104204
      O17(2)= +F104214+V104305
      O17(5)= +F003315+V003406-F003405-T003314
      O17(8)= +F003214+V003305
      O17(3)= +V104204
      O17(6)= +V003305-F003304
      O17(9)= +V003204

      O18(1)= +V205103
      O18(4)= +V104204-F104203
      O18(7)= +V104103
      O18(2)= +F104113+V104204
      O18(5)= +F003214+V003305-F003304-T003213
      O18(8)= +F003113+V003204
      O18(3)= +V104103
      O18(6)= +V003204-F003203
      O18(9)= +V003103

      O19(1)= +F316002+V407002-F406002-T315002
      O19(4)= +D214102+F215103+T305102+V306103
     &        -F305103-F306102-T214103-T215102
      O19(7)= +F215002+V306002-F305002-T214002
      O19(2)= +F215103+F306012+T215012+V306103
     &        -D214012-F305103-T214103-T305012
      O19(5)= +D113203+D204112+F114204+F205113
     &        +T114113+T204203+U113112+V205204
     &        -D113113-D114112-F204204-F205203
     &        -T113204-T114203-T204113-T205112
      O19(8)= +F114103+F205012+T114012+V205103
     &        -D113012-F204103-T113103-T204012
      O19(3)= +F215002+V306002-F305002-T214002
      O19(6)= +D113102+F114103+T204102+V205103
     &        -F204103-F205102-T113103-T114102
      O19(9)= +F114002+V205002-F204002-T113002

      O20(1)= +F215103+V306103
      O20(4)= +F114204+V205204-F205203-T114203
      O20(7)= +F114103+V205103
      O20(2)= +F114204+F205113+T114113+V205204
      O20(5)= +F013305+F104214+T013214+V104305
     &        -D013213-F104304-T013304-T104213
      O20(8)= +F013204+F104113+T013113+V104204
      O20(3)= +F114103+V205103
      O20(6)= +F013204+V104204-F104203-T013203
      O20(9)= +F013103+V104103

      O21(1)= +F215002+V306002
      O21(4)= +F114103+V205103-F205102-T114102
      O21(7)= +F114002+V205002
      O21(2)= +F114103+F205012+T114012+V205103
      O21(5)= +F013204+F104113+T013113+V104204
     &        -D013112-F104203-T013203-T104112
      O21(8)= +F013103+F104012+T013012+V104103
      O21(3)= +F114002+V205002
      O21(6)= +F013103+V104103-F104102-T013102
      O21(9)= +F013002+V104002

      O22(1)= +V306103-F305103
      O22(4)= +T204203+V205204-F204204-F205203
      O22(7)= +V205103-F204103
      O22(2)= +F205113+V205204-F204204-T204113
      O22(5)= +D103213+F104214+T103304+V104305
     &        -F103305-F104304-T103214-T104213
      O22(8)= +F104113+V104204-F103204-T103113
      O22(3)= +V205103-F204103
      O22(6)= +T103203+V104204-F103204-F104203
      O22(9)= +V104103-F103103

      O23(1)= +V205204
      O23(4)= +V104305-F104304
      O23(7)= +V104204
      O23(2)= +F104214+V104305
      O23(5)= +F003315+V003406-F003405-T003314
      O23(8)= +F003214+V003305
      O23(3)= +V104204
      O23(6)= +V003305-F003304
      O23(9)= +V003204

      O24(1)= +V205103
      O24(4)= +V104204-F104203
      O24(7)= +V104103
      O24(2)= +F104113+V104204
      O24(5)= +F003214+V003305-F003304-T003213
      O24(8)= +F003113+V003204
      O24(3)= +V104103
      O24(6)= +V003204-F003203
      O24(9)= +V003103

      O25(1)= +V306002-F305002
      O25(4)= +T204102+V205103-F204103-F205102
      O25(7)= +V205002-F204002
      O25(2)= +F205012+V205103-F204103-T204012
      O25(5)= +D103112+F104113+T103203+V104204
     &        -F103204-F104203-T103113-T104112
      O25(8)= +F104012+V104103-F103103-T103012
      O25(3)= +V205002-F204002
      O25(6)= +T103102+V104103-F103103-F104102
      O25(9)= +V104002-F103002

      O26(1)= +V205103
      O26(4)= +V104204-F104203
      O26(7)= +V104103
      O26(2)= +F104113+V104204
      O26(5)= +F003214+V003305-F003304-T003213
      O26(8)= +F003113+V003204
      O26(3)= +V104103
      O26(6)= +V003204-F003203
      O26(9)= +V003103

      O27(1)= +V205002
      O27(4)= +V104103-F104102
      O27(7)= +V104002
      O27(2)= +F104012+V104103
      O27(5)= +F003113+V003204-F003203-T003112
      O27(8)= +F003012+V003103
      O27(3)= +V104002
      O27(6)= +V003103-F003102
      O27(9)= +V003002

! delta d_lm
      DLM1(1)= -Z123001+U123002+U124001-D124002
     &         -U214001+D214002+D215001-T215002
     &         -U214001+D214002+D215001-T215002
     &         -D305001+T305002+T306001-F306002
      DLM1(4)= +U023102-D023103+D114102-T114103
     &         +D114102-T114103+T205102-F205103
      DLM1(7)= +U023001-D023002+D114001-T114002
     &         +D114001-T114002+T205001-F205002
      DLM1(2)= -U113102+D113103+D114102-T114103
     &         -D204102+T204103+T205102-F205103
      DLM1(5)= +D013203-T013204+T104203-F104204
      DLM1(8)= +D013102-T013103+T104102-F104103
      DLM1(3)= -D204001+T204002+T205001-F205002
     &         -U113001+D113002+D114001-T114002
      DLM1(6)= +D013102-T013103+T104102-F104103
      DLM1(9)= +D013001-T013002+T104001-F104002

      DLM2(1)= -U113102+D113103+D114102-T114103
     &         -D204102+T204103+T205102-F205103
      DLM2(4)= +D013203-T013204+T104203-F104204
      DLM2(7)= +D013102-T013103+T104102-F104103
      DLM2(2)= -D103203+T103204+T104203-F104204
      DLM2(5)= +T003304-F003305
      DLM2(8)= +T003203-F003204
      DLM2(3)= -D103102+T103103+T104102-F104103
      DLM2(6)= +T003203-F003204
      DLM2(9)= +T003102-F003103

      DLM3(1)= -U113001+D113002+D114001-T114002
     &         -D204001+T204002+T205001-F205002
      DLM3(4)= +D013102-T013103+T104102-F104103
      DLM3(7)= +D013001-T013002+T104001-F104002
      DLM3(2)= -D103102+T103103+T104102-F104103
      DLM3(5)= +T003203-F003204
      DLM3(8)= +T003102-F003103
      DLM3(3)= -D103001+T103002+T104001-F104002
      DLM3(6)= +T003102-F003103
      DLM3(9)= +T003001-F003002
! delta d_km
      DKM1(1)= +D124002+T215002+T215002+F306002
      DKM1(4)= +U023012+D023103+D114012+T114103
     &         +D114012+T114103+T205012+F205103
      DKM1(7)= +D023002+T114002+T114002+F205002
      DKM1(2)= +T114103+F205103
      DKM1(5)= +D013113+T013204+T104113+F104204
      DKM1(8)= +T013103+F104103
      DKM1(3)= +T114002+F205002
      DKM1(6)= +D013012+T013103+T104012+F104103
      DKM1(9)= +T013002+F104002
      
      DKM2(1)= +T114103+F205103
      DKM2(4)= +D013113+T013204+T104113+F104204
      DKM2(7)= +T013103+F104103
      DKM2(2)= +F104204
      DKM2(5)= +T003214+F003305
      DKM2(8)= +F003204
      DKM2(3)= +F104103
      DKM2(6)= +T003113+F003204
      DKM2(9)= +F003103

      DKM3(1)= +T114002+F205002
      DKM3(4)= +D013012+T013103+T104012+F104103
      DKM3(7)= +T013002+F104002
      DKM3(2)= +F104103
      DKM3(5)= +T003113+F003204
      DKM3(8)= +F003103
      DKM3(3)= +F104002
      DKM3(6)= +T003012+F003103
      DKM3(9)= +F003002
! delta d_kl 
      DKL1(1)= +D124002+T215002+T215002+F306002
      DKL1(4)= -U023102+D023103-D114102+T114103
     &         -D114102+T114103-T205102+F205103
      DKL1(7)= +D023002+T114002+T114002+F205002
      DKL1(2)= +T114103+F205103
      DKL1(5)= -D013203+T013204-T104203+F104204
      DKL1(8)= +T013103+F104103
      DKL1(3)= +T114002+F205002
      DKL1(6)= -D013102+T013103-T104102+F104103
      DKL1(9)= +T013002+F104002

      DKL2(1)= +T114103+F205103
      DKL2(4)= -D013203+T013204-T104203+F104204
      DKL2(7)= +T013103+F104103
      DKL2(2)= +F104204
      DKL2(5)= -T003304+F003305
      DKL2(8)= +F003204
      DKL2(3)= +F104103
      DKL2(6)= -T003203+F003204
      DKL2(9)= +F003103

      DKL3(1)= +T114002+F205002
      DKL3(4)= -D013102+T013103-T104102+F104103
      DKL3(7)= +T013002+F104002
      DKL3(2)= +F104103
      DKL3(5)= -T003203+F003204
      DKL3(8)= +F003103
      DKL3(3)= +F104002
      DKL3(6)= -T003102+F003103
      DKL3(9)= +F003002
! delta d_jm
      DJM1(1)= +T215002-D214002+F306002-T305002
      DJM1(4)= +D114012+T114103-D113103-U113012
     &         +F205103+T205012-D204012-T204103
      DJM1(7)= +T114002-D113002+F205002-T204002
      DJM1(2)= +T114103+F205103
      DJM1(5)= +D013113+T013204+F104204+T104113
      DJM1(8)= +T013103+F104103
      DJM1(3)= +T114002+F205002
      DJM1(6)= +D013012+T013103+F104103+T104012
      DJM1(9)= +T013002+F104002

      DJM2(1)= +F205103-T204103
      DJM2(4)= +F104204+T104113-D103113-T103204
      DJM2(7)= +F104103-T103103
      DJM2(2)= +F104204
      DJM2(5)= +F003305+T003214
      DJM2(8)= +F003204
      DJM2(3)= +F104103
      DJM2(6)= +F003204+T003113
      DJM2(9)= +F003103

      DJM3(1)= +F205002-T204002
      DJM3(4)= +F104103+T104012-D103012-T103103
      DJM3(7)= +F104002-T103002
      DJM3(2)= +F104103
      DJM3(5)= +F003204+T003113
      DJM3(8)= +F003103
      DJM3(3)= +F104002
      DJM3(6)= +F003103+T003012
      DJM3(9)= +F003002 
! delta d_jl
      DJL1(1)= +T215002-D214002+F306002-T305002
      DJL1(4)= +T114103+U113102-D113103-D114102
     &         +D204102+F205103-T204103-T205102
      DJL1(7)= +T114002-D113002+F205002-T204002
      DJL1(2)= +T114103+F205103
      DJL1(5)= +T013204-D013203+F104204-T104203
      DJL1(8)= +T013103+F104103
      DJL1(3)= +T114002+F205002
      DJL1(6)= +T013103-D013102+F104103-T104102
      DJL1(9)= +T013002+F104002
      DJL2(1)= +F205103-T204103
      DJL2(4)= +D103203+F104204-T103204-T104203
      DJL2(7)= +F104103-T103103
      DJL2(2)= +F104204
      DJL2(5)= +F003305-T003304
      DJL2(8)= +F003204
      DJL2(3)= +F104103
      DJL2(6)= +F003204-T003203
      DJL2(9)= +F003103
      DJL3(1)= +F205002-T204002
      DJL3(4)= +D103102+F104103-T103103-T104102
      DJL3(7)= +F104002-T103002
      DJL3(2)= +F104103
      DJL3(5)= +F003204-T003203
      DJL3(8)= +F003103
      DJL3(3)= +F104002
      DJL3(6)= +F003103-T003102
      DJL3(9)= +F003002
! delta d_jk       
      DJK1(1)= +D214002-T215002+T305002-F306002
      DJK1(4)= +D113103-U113102-T114103+D114102
     &         +T204103-D204102-F205103+T205102
      DJK1(7)= +D113002-T114002+T204002-F205002
      DJK1(2)= +D113103+U113012-D114012-T114103
     &         +D204012+T204103-F205103-T205012
      DJK1(5)= +D012204+U012113-U012203-Z012112
     &         -D013113-T013204+D013203+U013112
     &         +D103113+T103204-D103203-U103112
     &         -F104204-T104113+D104112+T104203
      DJK1(8)= +D012103+U012012-D013012-T013103
     &         +D103012+T103103-F104103-T104012
      DJK1(3)= +D113002-T114002+T204002-F205002
      DJK1(6)= +D012103-U012102-T013103+D013102
     &         +T103103-D103102-F104103+T104102
      DJK1(9)= +D012002-T013002+T103002-F104002
      DJK2(1)= +T204103-F205103
      DJK2(4)= +T103204-D103203-F104204+T104203
      DJK2(7)= +T103103-F104103
      DJK2(2)= +D103113+T103204-F104204-T104113
      DJK2(5)= +D002214+T002305-D002304-U002213
     &         -F003305-T003214+D003213+T003304
      DJK2(8)= +D002113+T002204-F003204-T003113
      DJK2(3)= +T103103-F104103
      DJK2(6)= +T002204-D002203-F003204+T003203
      DJK2(9)= +T002103-F003103
      DJK3(1)= +T204002-F205002
      DJK3(4)= +T103103-D103102-F104103+T104102
      DJK3(7)= +T103002-F104002
      DJK3(2)= +D103012+T103103-F104103-T104012
      DJK3(5)= +D002113+T002204-D002203-U002112
     &         -F003204-T003113+D003112+T003203
      DJK3(8)= +D002012+T002103-F003103-T003012
      DJK3(3)= +T103002-F104002
      DJK3(6)= +T002103-D002102-F003103+T003102
      DJK3(9)= +T002002-F003002 
 
      DIM1(1)= +F306002+T215002-D214002-T305002
      DIM1(4)= +D114012+F205103+T114103+T205012
     &         -D113103-D204012-T204103-U113012
      DIM1(7)= +F205002+T114002-D113002-T204002
      DIM1(2)= +F205103+T114103
      DIM1(5)= +D013113+F104204+T013204+T104113
      DIM1(8)= +F104103+T013103
      DIM1(3)= +F205002+T114002
      DIM1(6)= +D013012+F104103+T013103+T104012
      DIM1(9)= +F104002+T013002
      DIM2(1)= +F205103-T204103
      DIM2(4)= +F104204+T104113-D103113-T103204
      DIM2(7)= +F104103-T103103
      DIM2(2)= +F104204
      DIM2(5)= +F003305+T003214
      DIM2(8)= +F003204
      DIM2(3)= +F104103
      DIM2(6)= +F003204+T003113
      DIM2(9)= +F003103
      DIM3(1)= +F205002-T204002
      DIM3(4)= +F104103+T104012-D103012-T103103
      DIM3(7)= +F104002-T103002
      DIM3(2)= +F104103
      DIM3(5)= +F003204+T003113
      DIM3(8)= +F003103
      DIM3(3)= +F104002
      DIM3(6)= +F003103+T003012
      DIM3(9)= +F003002 
! delta d_il
      DIL1(1)= +F306002+T215002-D214002-T305002
      DIL1(4)= +D204102+F205103+T114103+U113102
     &         -D113103-D114102-T204103-T205102
      DIL1(7)= +F205002+T114002-D113002-T204002
      DIL1(2)= +F205103+T114103
      DIL1(5)= +F104204+T013204-D013203-T104203
      DIL1(8)= +F104103+T013103
      DIL1(3)= +F205002+T114002
      DIL1(6)= +F104103+T013103-D013102-T104102
      DIL1(9)= +F104002+T013002

      DIL2(1)= +F205103-T204103
      DIL2(4)= +D103203+F104204-T103204-T104203
      DIL2(7)= +F104103-T103103
      DIL2(2)= +F104204
      DIL2(5)= +F003305-T003304
      DIL2(8)= +F003204
      DIL2(3)= +F104103
      DIL2(6)= +F003204-T003203
      DIL2(9)= +F003103

      DIL3(1)= +F205002-T204002
      DIL3(4)= +D103102+F104103-T103103-T104102
      DIL3(7)= +F104002-T103002
      DIL3(2)= +F104103
      DIL3(5)= +F003204-T003203
      DIL3(8)= +F003103
      DIL3(3)= +F104002
      DIL3(6)= +F003103-T003102
      DIL3(9)= +F003002
! delta d_ik
      DIK1(1)= +D214002+T305002-F306002-T215002
      DIK1(4)= +D113103+T204103-D204102-U113102
     &         -F205103-T114103+D114102+T205102
      DIK1(7)= +D113002+T204002-F205002-T114002
      DIK1(2)= +D113103+D204012+T204103+U113012
     &         -D114012-F205103-T114103-T205012
      DIK1(5)= +D012204+D103113+T103204+U012113
     &         -D103203-U012203-U103112-Z012112
     &         -D013113-F104204-T013204-T104113
     &         +D013203+D104112+T104203+U013112
      DIK1(8)= +D012103+D103012+T103103+U012012
     &         -D013012-F104103-T013103-T104012
      DIK1(3)= +D113002+T204002-F205002-T114002
      DIK1(6)= +D012103+T103103-D103102-U012102
     &         -F104103-T013103+D013102+T104102
      DIK1(9)= +D012002+T103002-F104002-T013002
      DIK2(1)= +T204103-F205103
      DIK2(4)= +T103204-D103203-F104204+T104203
      DIK2(7)= +T103103-F104103
      DIK2(2)= +D103113+T103204-F104204-T104113
      DIK2(5)= +D002214+T002305-D002304-U002213
     &         -F003305-T003214+D003213+T003304
      DIK2(8)= +D002113+T002204-F003204-T003113
      DIK2(3)= +T103103-F104103
      DIK2(6)= +T002204-D002203-F003204+T003203
      DIK2(9)= +T002103-F003103

      DIK3(1)= +T204002-F205002
      DIK3(4)= +T103103-D103102-F104103+T104102
      DIK3(7)= +T103002-F104002
      DIK3(2)= +D103012+T103103-F104103-T104012
      DIK3(5)= +D002113+T002204-D002203-U002112
     &         -F003204-T003113+D003112+T003203
      DIK3(8)= +D002012+T002103-F003103-T003012
      DIK3(3)= +T103002-F104002
      DIK3(6)= +T002103-D002102-F003103+T003102
      DIK3(9)= +T002002-F003002
! delta d_dij
      DIJ1(1)= +T305002-D304002-F306002+T305002
      DIJ1(4)= +T204103+U203102-D203103-D204102
     &         -D204102-F205103+T204103+T205102
      DIJ1(7)= +T204002-D203002-F205002+T204002
      DIJ1(2)= +D204012+T204103-D203103-U203012
     &         -F205103-T205012+D204012+T204103
      DIJ1(5)= +D103113+T103204+U102203+Z102112
     &         -D102204-D103203-U102113-U103112
     &         -D103203-F104204-T104113-U103112
     &         +D103113+D104112+T103204+T104203
      DIJ1(8)= +D103012+T103103-D102103-U102012
     &         -F104103-T104012+D103012+T103103
      DIJ1(3)= +T204002-D203002-F205002+T204002
      DIJ1(6)= +T103103+U102102-D102103-D103102
     &         -D103102-F104103+T103103+T104102
      DIJ1(9)= +T103002-D102002-F104002+T103002
      DIJ2(1)= +T204103-F205103
      DIJ2(4)= +T103204-D103203-F104204+T104203
      DIJ2(7)= +T103103-F104103
      DIJ2(2)= +D103113+T103204-F104204-T104113
      DIJ2(5)= +D002214+T002305-D002304-U002213
     &         -F003305-T003214+D003213+T003304
      DIJ2(8)= +D002113+T002204-F003204-T003113
      DIJ2(3)= +T103103-F104103
      DIJ2(6)= +T002204-D002203-F003204+T003203
      DIJ2(9)= +T002103-F003103
      DIJ3(1)= +T204002-F205002
      DIJ3(4)= +T103103-D103102-F104103+T104102
      DIJ3(7)= +T103002-F104002
      DIJ3(2)= +D103012+T103103-F104103-T104012
      DIJ3(5)= +D002113+T002204-D002203-U002112
     &         -F003204-T003113+D003112+T003203
      DIJ3(8)= +D002012+T002103-F003103-T003012
      DIJ3(3)= +T103002-F104002
      DIJ3(6)= +T002103-D002102-F003103+T003102
      DIJ3(9)= +T002002-F003002

! delta d_jm and d_kl
      DDD( 1)= +D013002+T104002
      DDD(16)= +T003103
      DDD(31)= +T003002

! delta d_jl and d_km
      DDD( 2)= +D013002+T104002
      DDD(17)= +T003103
      DDD(32)= +T003002

! delta d_jk and d_lm
      DDD( 3)= +Z012001-U012002-U013001+D013002
     &         +U103001-D103002-D104001+T104002
      DDD(18)= +U002102-D002103-D003102+T003103
      DDD(33)= +U002001-D002002-D003001+T003002

! delta d_im and d_jk
      DDD( 4)= +D103002-T104002
      DDD(19)= +U002012+D002103-D003012-T003103
      DDD(34)= +D002002-T003002

      DDD( 4)= -DDD( 4)
      DDD(19)= -DDD(19)
      DDD(34)= -DDD(34)

! delta d_im and d_jl
      DDD( 5)= -D103002+T104002
      DDD(20)= +T003103
      DDD(35)= +T003002

! delta d_im and d_kl
      DDD( 6)= +D013002+T104002
      DDD(21)= +T003103
      DDD(36)= +T003002

! delta d_il and d_jk
      DDD( 7)= +D103002-T104002
      DDD(22)= -U002102+D002103+D003102-T003103
      DDD(37)= +D002002-T003002
      DDD( 7)= -DDD( 7)
      DDD(22)= -DDD(22)
      DDD(37)= -DDD(37)

! delta d_il and d_jm
      DDD( 8)= -D103002+T104002
      DDD(23)= +T003103
      DDD(38)= +T003002

! delta d_il and d_km
      DDD( 9)= +D013002+T104002
      DDD(24)= +T003103
      DDD(39)= +T003002

! delta d_ik and d_jl
      DDD(10)= +D103002-T104002
      DDD(25)= -U002102+D002103+D003102-T003103
      DDD(40)= +D002002-T003002

      DDD(10)= -DDD(10)
      DDD(25)= -DDD(25)
      DDD(40)= -DDD(40)

! delta d_ik and d_jm
      DDD(11)= +D103002-T104002
      DDD(26)= +U002012+D002103-D003012-T003103
      DDD(41)= +D002002-T003002
      DDD(11)= -DDD(11)
      DDD(26)= -DDD(26)
      DDD(41)= -DDD(41)

! delta d_ik and d_lm
      DDD(12)= +Z012001-U012002+U103001-D103002
     &         -U013001+D013002-D104001+T104002
      DDD(27)= +U002102-D002103-D003102+T003103
      DDD(42)= +U002001-D002002-D003001+T003002

! delta d_ij and d_kl
      DDD(13)= +D103002-T104002
      DDD(28)= -U002102+D002103+D003102-T003103
      DDD(43)= +D002002-T003002

      DDD(13)= -DDD(13)
      DDD(28)= -DDD(28)
      DDD(43)= -DDD(43)

! delta d_ij and d_km
      DDD(14)= +D103002-T104002
      DDD(29)= +U002012+D002103-D003012-T003103
      DDD(44)= +D002002-T003002
      DDD(14)= -DDD(14)
      DDD(29)= -DDD(29)
      DDD(44)= -DDD(44)

! delta d_ij and d_lm
      DDD(15)= -Z102001+U102002+U103001-D103002
     &         +U103001-D103002-D104001+T104002
      DDD(30)= +U002102-D002103-D003102+T003103
      DDD(45)= +U002001-D002002-D003001+T003002

      call ipgemm (15,eee,ddd,tiu)

      CALL IDIJK (TIU, TIU, TIU, DLM1, DLM2, DLM3, PLM1, PLM2, PLM3)
      CALL IDIJK (TKW, TIU, TIU, DKM1, DKM2, DKM3, PKM1, PKM2, PKM3)
      CALL IDIJK (TKW, TIU, TIU, DKL1, DKL2, DKL3, PKL1, PKL2, PKL3)
      CALL IDIJK (TKW, TIU, TIU, DJM1, DJM2, DJM3, PJM1, PJM2, PJM3)
      CALL IDIJK (TKW, TIU, TIU, DJL1, DJL2, DJL3, PJL1, PJL2, PJL3)
      CALL IDIJK (TKW, TKW, TIU, DJK1, DJK2, DJK3, PJK1, PJK2, PJK3)
      CALL IDIJK (TKW, TIU, TIU, DIM1, DIM2, DIM3, PIM1, PIM2, PIM3)
      CALL IDIJK (TKW, TIU, TIU, DIL1, DIL2, DIL3, PIL1, PIL2, PIL3)
      CALL IDIJK (TKW, TKW, TIU, DIK1, DIK2, DIK3, PIK1, PIK2, PIK3)
      CALL IDIJK (TKW, TKW, TIU, DIJ1, DIJ2, DIJ3, PIJ1, PIJ2, PIJ3)

      include 'ints_isetd.inc'
                
      call ipgemm (3,p1 ,o01,tkw)
      call ipgemmt(3,o01, p1,tkw)
      call ipgemm (3,p1 ,o02,tkw)
      call ipgemmt(3,o02, p1,tkw)
      call ipgemm (3,p1 ,o03,tkw)
      call ipgemmt(3,o03, p1,tkw)
      call ipgemm (3,p1 ,o04,tkw)
      call ipgemmt(3,o04, p1,tkw)
      call ipgemm (3,p1 ,o05,tkw)
      call ipgemmt(3,o05, p1,tkw)
      call ipgemm (3,p1 ,o06,tkw)
      call ipgemmt(3,o06, p1,tkw)
      call ipgemm (3,p1 ,o07,tkw)
      call ipgemmt(3,o07, p1,tkw)
      call ipgemm (3,p1 ,o08,tkw)
      call ipgemmt(3,o08, p1,tkw)
      call ipgemm (3,p1 ,o09,tkw)
      call ipgemmt(3,o09, p1,tkw)
      call ipgemm (3,p1 ,o10,tkw)
      call ipgemmt(3,o10, p1,tkw)
      call ipgemm (3,p1 ,o11,tkw)
      call ipgemmt(3,o11, p1,tkw)
      call ipgemm (3,p1 ,o12,tkw)
      call ipgemmt(3,o12, p1,tkw)
      call ipgemm (3,p1 ,o13,tkw)
      call ipgemmt(3,o13, p1,tkw)
      call ipgemm (3,p1 ,o14,tkw)
      call ipgemmt(3,o14, p1,tkw)
      call ipgemm (3,p1 ,o15,tkw)
      call ipgemmt(3,o15, p1,tkw)
      call ipgemm (3,p1 ,o16,tkw)
      call ipgemmt(3,o16, p1,tkw)
      call ipgemm (3,p1 ,o17,tkw)
      call ipgemmt(3,o17, p1,tkw)
      call ipgemm (3,p1 ,o18,tkw)
      call ipgemmt(3,o18, p1,tkw)
      call ipgemm (3,p1 ,o19,tkw)
      call ipgemmt(3,o19, p1,tkw)
      call ipgemm (3,p1 ,o20,tkw)
      call ipgemmt(3,o20, p1,tkw)
      call ipgemm (3,p1 ,o21,tkw)
      call ipgemmt(3,o21, p1,tkw)
      call ipgemm (3,p1 ,o22,tkw)
      call ipgemmt(3,o22, p1,tkw)
      call ipgemm (3,p1 ,o23,tkw)
      call ipgemmt(3,o23, p1,tkw)
      call ipgemm (3,p1 ,o24,tkw)
      call ipgemmt(3,o24, p1,tkw)
      call ipgemm (3,p1 ,o25,tkw)
      call ipgemmt(3,o25, p1,tkw)
      call ipgemm (3,p1 ,o26,tkw)
      call ipgemmt(3,o26, p1,tkw)
      call ipgemm (3,p1 ,o27,tkw)
      call ipgemmt(3,o27, p1,tkw)

      include 'ints_iset1.inc'
      call ipgemm(81,ppp,qqq,tiu)

      include 'ints_iset2.inc'
      call ipgemm(81,ppp,qqq,tiu)

      include 'ints_iset3.inc'
      call ipgemm(81,ppp,qqq,tiu)

      include 'ints_output_dppp.inc'

      end
CC IMDPDS ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DPDS
C ===================================================================

      subroutine imdpds(
     &           ec   ,
     &           xyz  ,  dpds ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )


      implicit real(8)(a-h,o-z)

      dimension dpds(284),ddd(45),eee(45)
      dimension xyz(3,natom)
      dimension tiu(9),tkw(9)

      dimension o01(9),o02(9),o03(9),o04(9),o05(9),o06(9)
      dimension o07(9),o08(9),o09(9),o10(9),o11(9),o12(9)
      dimension o13(9),o14(9),o15(9),o16(9),o17(9),o18(9)
      dimension o19(9),o20(9),o21(9),o22(9),o23(9),o24(9)
      dimension o25(9),o26(9),o27(9)

      dimension dlm1(9),dlm2(9),dlm3(9),dkm1(9),dkm2(9),dkm3(9)
      dimension dkl1(9),dkl2(9),dkl3(9),djm1(9),djm2(9),djm3(9)
      dimension djl1(9),djl2(9),djl3(9),djk1(9),djk2(9),djk3(9)
      dimension dim1(9),dim2(9),dim3(9),dil1(9),dil2(9),dil3(9)
      dimension dik1(9),dik2(9),dik3(9),dij1(9),dij2(9),dij3(9)
      dimension plm1(9),plm2(9),plm3(9),pkm1(9),pkm2(9),pkm3(9)
      dimension pkl1(9),pkl2(9),pkl3(9),pjm1(9),pjm2(9),pjm3(9)
      dimension pjl1(9),pjl2(9),pjl3(9),pjk1(9),pjk2(9),pjk3(9)
      dimension pim1(9),pim2(9),pim3(9),pil1(9),pil2(9),pil3(9)
      dimension pik1(9),pik2(9),pik3(9),pij1(9),pij2(9),pij3(9)

      dimension p1(9),ppp(243),qqq(243)

      dimension ec(mvhgp)
      data      root3 / 1.73205080756887729353d+00 /
 
 
      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)

      tkw(1) = -tiu(1)
      tkw(4) = -tiu(4)
      tkw(7) = -tiu(7)
      tkw(2) = -tiu(2)
      tkw(5) = -tiu(5)
      tkw(8) = -tiu(8)
      tkw(3) = -tiu(3)
      tkw(6) = -tiu(6)
      tkw(9) = -tiu(9)

      include 'ints_iset_dpds.inc'

      O01(1) =+F417002+F417002+T326002+V508002
     &        -D325002-F507002-T416002-T416002
      O01(4) =+D225012+F316103+F316103+F407012
     &        +T225103+T316012+T316012+V407103
     &        -D224103-D315012-D315012-F406103
     &        -T315103-T315103-T406012-U224012
      O01(7) =+F316002+F316002+T225002+V407002
     &        -D224002-F406002-T315002-T315002
      O01(2) =+D225012+F316103+F316103+F407012
     &        +T225103+T316012+T316012+V407103
     &        -D224103-D315012-D315012-F406103
     &        -T315103-T315103-T406012-U224012
      O01(5) =+D124113+D124113+D215022+D215022
     &        +F215204+F215204+F306113+F306113
     &        +T124204+T215113+T215113+T215113
     &        +T215113+T306022+U124022+V306204
     &        -D123204-D214113-D214113-D214113
     &        -D214113-D305022-F305204-T214204
     &        -T214204-T305113-T305113-U123113
     &        -U123113-U214022-U214022-Z123022
      O01(8) =+D124012+F215103+F215103+F306012
     &        +T124103+T215012+T215012+V306103
     &        -D123103-D214012-D214012-F305103
     &        -T214103-T214103-T305012-U123012
      O01(3) =+F316002+F316002+T225002+V407002
     &        -D224002-F406002-T315002-T315002
      O01(6) =+D124012+F215103+F215103+F306012
     &        +T124103+T215012+T215012+V306103
     &        -D123103-D214012-D214012-F305103
     &        -T214103-T214103-T305012-U123012
      O01(9) =+F215002+F215002+T124002+V306002
     &        -D123002-F305002-T214002-T214002

      O02(1) =+F316103+F316103+T225103+V407103
      O02(4) =+D124113+F215204+F215204+F306113
     &        +T124204+T215113+T215113+V306204
      O02(7) =+F215103+F215103+T124103+V306103
      O02(2) =+D124113+F215204+F215204+F306113
     &        +T124204+T215113+T215113+V306204
      O02(5) =+D023214+D023214+D114123+D114123
     &        +F114305+F114305+F205214+F205214
     &        +T023305+T114214+T114214+T114214
     &        +T114214+T205123+U023123+V205305
      O02(8) =+D023113+F114204+F114204+F205113
     &        +T023204+T114113+T114113+V205204
      O02(3) =+F215103+F215103+T124103+V306103
      O02(6) =+D023113+F114204+F114204+F205113
     &        +T023204+T114113+T114113+V205204
      O02(9) =+F114103+F114103+T023103+V205103
                                              
      O03(1) =+F316002+F316002+T225002+V407002
      O03(4) =+D124012+F215103+F215103+F306012
     &        +T124103+T215012+T215012+V306103
      O03(7) =+F215002+F215002+T124002+V306002
      O03(2) =+D124012+F215103+F215103+F306012
     &        +T124103+T215012+T215012+V306103
      O03(5) =+D023113+D023113+D114022+D114022
     &        +F114204+F114204+F205113+F205113
     &        +T023204+T114113+T114113+T114113
     &        +T114113+T205022+U023022+V205204
      O03(8) =+D023012+F114103+F114103+F205012
     &        +T023103+T114012+T114012+V205103
      O03(3) =+F215002+F215002+T124002+V306002
      O03(6) =+D023012+F114103+F114103+F205012
     &        +T023103+T114012+T114012+V205103
      O03(9) =+F114002+F114002+T023002+V205002

      O04(1) =+F316103+V407103-F406103-T315103
      O04(4) =+F215204+F306113+T215113+V306204
     &        -D214113-F305204-T214204-T305113
      O04(7) =+F215103+V306103-F305103-T214103
      O04(2) =+F215204+F306113+T215113+V306204
     &        -D214113-F305204-T214204-T305113
      O04(5) =+D114123+F114305+F205214+F205214
     &        +T114214+T114214+T205123+V205305
     &        -D113214-D113214-D204123-F204305
     &        -T113305-T204214-T204214-U113123
      O04(8) =+F114204+F205113+T114113+V205204
     &        -D113113-F204204-T113204-T204113
      O04(3) =+F215103+V306103-F305103-T214103
      O04(6) =+F114204+F205113+T114113+V205204
     &        -D113113-F204204-T113204-T204113
      O04(9) =+F114103+V205103-F204103-T113103

      O05(1) =+F215204+V306204 
      O05(4) =+F114305+F205214+T114214+V205305 
      O05(7) =+F114204+V205204 
      O05(2) =+F114305+F205214+T114214+V205305 
      O05(5) =+D013224+F013406+F104315+F104315 
     &        +T013315+T013315+T104224+V104406 
      O05(8) =+F013305+F104214+T013214+V104305 
      O05(3) =+F114204+V205204 
      O05(6) =+F013305+F104214+T013214+V104305 
      O05(9) =+F013204+V104204 

      O06(1) =+F215103+V306103 
      O06(4) =+F114204+F205113+T114113+V205204 
      O06(7) =+F114103+V205103 
      O06(2) =+F114204+F205113+T114113+V205204 
      O06(5) =+D013123+F013305+F104214+F104214  
     &        +T013214+T013214+T104123+V104305 
      O06(8) =+F013204+F104113+T013113+V104204 
      O06(3) =+F114103+V205103 
      O06(6) =+F013204+F104113+T013113+V104204 
      O06(9) =+F013103+V104103 
                                   
      O07(1) =+F316002+V407002-F406002-T315002 
      O07(4) =+F215103+F306012+T215012+V306103 
     &        -D214012-F305103-T214103-T305012 
      O07(7) =+F215002+V306002-F305002-T214002 
      O07(2) =+F215103+F306012+T215012+V306103 
     &        -D214012-F305103-T214103-T305012 
      O07(5) =+D114022+F114204+F205113+F205113 
     &        +T114113+T114113+T205022+V205204 
     &        -D113113-D113113-D204022-F204204 
     &        -T113204-T204113-T204113-U113022 
      O07(8) =+F114103+F205012+T114012+V205103 
     &        -D113012-F204103-T113103-T204012 
      O07(3) =+F215002+V306002-F305002-T214002 
      O07(6) =+F114103+F205012+T114012+V205103 
     &        -D113012-F204103-T113103-T204012 
      O07(9) =+F114002+V205002-F204002-T113002 
                                                
      O08(1) =+F215103+V306103 
      O08(4) =+F114204+F205113+T114113+V205204 
      O08(7) =+F114103+V205103 
      O08(2) =+F114204+F205113+T114113+V205204 
      O08(5) =+D013123+F013305+F104214+F104214 
     &        +T013214+T013214+T104123+V104305 
      O08(8) =+F013204+F104113+T013113+V104204 
      O08(3) =+F114103+V205103 
      O08(6) =+F013204+F104113+T013113+V104204 
      O08(9) =+F013103+V104103 
                                                
      O09(1) =+F215002+V306002 
      O09(4) =+F114103+F205012+T114012+V205103 
      O09(7) =+F114002+V205002 
      O09(2) =+F114103+F205012+T114012+V205103 
      O09(5) =+D013022+F013204+F104113+F104113 
     &        +T013113+T013113+T104022+V104204 
      O09(8) =+F013103+F104012+T013012+V104103 
      O09(3) =+F114002+V205002 
      O09(6) =+F013103+F104012+T013012+V104103 
      O09(9) =+F013002+V104002 
                                                
      O10(1)= +F316103+V407103-F406103-T315103
      O10(4)= +F215204+F306113+T215113+V306204
     &        -D214113-F305204-T214204-T305113
      O10(7)= +F215103+V306103-F305103-T214103
      O10(2)= +F215204+F306113+T215113+V306204
     &        -D214113-F305204-T214204-T305113
      O10(5)= +D114123+F114305+F205214+F205214
     &        +T114214+T114214+T205123+V205305
     &        -D113214-D113214-D204123-F204305
     &        -T113305-T204214-T204214-U113123
      O10(8)= +F114204+F205113+T114113+V205204
     &        -D113113-F204204-T113204-T204113
      O10(3)= +F215103+V306103-F305103-T214103
      O10(6)= +F114204+F205113+T114113+V205204
     &        -D113113-F204204-T113204-T204113
      O10(9)= +F114103+V205103-F204103-T113103
              
      O11(1)= +F215204+V306204
      O11(4)= +F114305+F205214+T114214+V205305
      O11(7)= +F114204+V205204
      O11(2)= +F114305+F205214+T114214+V205305
      O11(5)= +D013224+F013406+F104315+F104315
     &        +T013315+T013315+T104224+V104406
      O11(8)= +F013305+F104214+T013214+V104305
      O11(3)= +F114204+V205204
      O11(6)= +F013305+F104214+T013214+V104305
      O11(9)= +F013204+V104204
              
      O12(1)= +F215103+V306103
      O12(4)= +F114204+F205113+T114113+V205204
      O12(7)= +F114103+V205103
      O12(2)= +F114204+F205113+T114113+V205204
      O12(5)= +D013123+F013305+F104214+F104214
     &        +T013214+T013214+T104123+V104305
      O12(8)= +F013204+F104113+T013113+V104204
      O12(3)= +F114103+V205103
      O12(6)= +F013204+F104113+T013113+V104204
      O12(9)= +F013103+V104103
              
      O13(1)= +V306204-F305204
      O13(4)= +F205214+V205305-F204305-T204214
      O13(7)= +V205204-F204204
      O13(2)= +F205214+V205305-F204305-T204214
      O13(5)= +F104315+F104315+T104224+V104406
     &        -D103224-F103406-T103315-T103315
      O13(8)= +F104214+V104305-F103305-T103214
      O13(3)= +V205204-F204204
      O13(6)= +F104214+V104305-F103305-T103214
      O13(9)= +V104204-F103204
              
      O14(1)= +V205305
      O14(4)= +F104315+V104406
      O14(7)= +V104305
      O14(2)= +F104315+V104406
      O14(5)= +F003416+F003416+T003325+V003507
      O14(8)= +F003315+V003406
      O14(3)= +V104305
      O14(6)= +F003315+V003406
      O14(9)= +V003305
              
      O15(1)= +V205204
      O15(4)= +F104214+V104305
      O15(7)= +V104204
      O15(2)= +F104214+V104305
      O15(5)= +F003315+F003315+T003224+V003406
      O15(8)= +F003214+V003305
      O15(3)= +V104204
      O15(6)= +F003214+V003305
      O15(9)= +V003204
              
      O16(1)= +V306103-F305103
      O16(4)= +F205113+V205204-F204204-T204113
      O16(7)= +V205103-F204103
      O16(2)= +F205113+V205204-F204204-T204113
      O16(5)= +F104214+F104214+T104123+V104305
     &        -D103123-F103305-T103214-T103214
      O16(8)= +F104113+V104204-F103204-T103113
      O16(3)= +V205103-F204103
      O16(6)= +F104113+V104204-F103204-T103113
      O16(9)= +V104103-F103103
              
      O17(1)= +V205204
      O17(4)= +F104214+V104305
      O17(7)= +V104204
      O17(2)= +F104214+V104305
      O17(5)= +F003315+F003315+T003224+V003406
      O17(8)= +F003214+V003305
      O17(3)= +V104204
      O17(6)= +F003214+V003305
      O17(9)= +V003204
              
      O18(1)= +V205103
      O18(4)= +F104113+V104204
      O18(7)= +V104103
      O18(2)= +F104113+V104204
      O18(5)= +F003214+F003214+T003123+V003305
      O18(8)= +F003113+V003204
      O18(3)= +V104103
      O18(6)= +F003113+V003204
      O18(9)= +V003103
              
      O19(1)= +F316002+V407002-F406002-T315002
      O19(4)= +F215103+F306012+T215012+V306103
     &        -D214012-F305103-T214103-T305012
      O19(7)= +F215002+V306002-F305002-T214002
      O19(2)= +F215103+F306012+T215012+V306103
     &        -D214012-F305103-T214103-T305012
      O19(5)= +D114022+F114204+F205113+F205113
     &        +T114113+T114113+T205022+V205204
     &        -D113113-D113113-D204022-F204204
     &        -T113204-T204113-T204113-U113022
      O19(8)= +F114103+F205012+T114012+V205103
     &        -D113012-F204103-T113103-T204012
      O19(3)= +F215002+V306002-F305002-T214002
      O19(6)= +F114103+F205012+T114012+V205103
     &        -D113012-F204103-T113103-T204012
      O19(9)= +F114002+V205002-F204002-T113002
              
      O20(1)= +F215103+V306103
      O20(4)= +F114204+F205113+T114113+V205204
      O20(7)= +F114103+V205103
      O20(2)= +F114204+F205113+T114113+V205204
      O20(5)= +D013123+F013305+F104214+F104214
     &        +T013214+T013214+T104123+V104305
      O20(8)= +F013204+F104113+T013113+V104204
      O20(3)= +F114103+V205103
      O20(6)= +F013204+F104113+T013113+V104204
      O20(9)= +F013103+V104103
              
      O21(1)= +F215002+V306002
      O21(4)= +F114103+F205012+T114012+V205103
      O21(7)= +F114002+V205002
      O21(2)= +F114103+F205012+T114012+V205103
      O21(5)= +D013022+F013204+F104113+F104113
     &        +T013113+T013113+T104022+V104204
      O21(8)= +F013103+F104012+T013012+V104103
      O21(3)= +F114002+V205002
      O21(6)= +F013103+F104012+T013012+V104103
      O21(9)= +F013002+V104002
              
      O22(1)= +V306103-F305103
      O22(4)= +F205113+V205204-F204204-T204113
      O22(7)= +V205103-F204103
      O22(2)= +F205113+V205204-F204204-T204113
      O22(5)= +F104214+F104214+T104123+V104305
     &        -D103123-F103305-T103214-T103214
      O22(8)= +F104113+V104204-F103204-T103113
      O22(3)= +V205103-F204103
      O22(6)= +F104113+V104204-F103204-T103113
      O22(9)= +V104103-F103103
              
      O23(1)= +V205204
      O23(4)= +F104214+V104305
      O23(7)= +V104204
      O23(2)= +F104214+V104305
      O23(5)= +F003315+F003315+T003224+V003406
      O23(8)= +F003214+V003305
      O23(3)= +V104204
      O23(6)= +F003214+V003305
      O23(9)= +V003204
              
      O24(1)= +V205103
      O24(4)= +F104113+V104204
      O24(7)= +V104103
      O24(2)= +F104113+V104204
      O24(5)= +F003214+F003214+T003123+V003305
      O24(8)= +F003113+V003204
      O24(3)= +V104103
      O24(6)= +F003113+V003204
      O24(9)= +V003103
              
      O25(1)= +V306002-F305002
      O25(4)= +F205012+V205103-F204103-T204012
      O25(7)= +V205002-F204002
      O25(2)= +F205012+V205103-F204103-T204012
      O25(5)= +F104113+F104113+T104022+V104204
     &        -D103022-F103204-T103113-T103113
      O25(8)= +F104012+V104103-F103103-T103012
      O25(3)= +V205002-F204002
      O25(6)= +F104012+V104103-F103103-T103012
      O25(9)= +V104002-F103002
              
      O26(1)= +V205103
      O26(4)= +F104113+V104204
      O26(7)= +V104103
      O26(2)= +F104113+V104204
      O26(5)= +F003214+F003214+T003123+V003305
      O26(8)= +F003113+V003204
      O26(3)= +V104103
      O26(6)= +F003113+V003204
      O26(9)= +V003103
              
      O27(1)= +V205002
      O27(4)= +F104012+V104103
      O27(7)= +V104002
      O27(2)= +F104012+V104103
      O27(5)= +F003113+F003113+T003022+V003204
      O27(8)= +F003012+V003103
      O27(3)= +V104002
      O27(6)= +F003012+V003103
      O27(9)= +V003002

! delta d_lm
      dlm1(1)= -Z123001+U123002+U124001-D124002
     &         -U214001+D214002+D215001-T215002
     &         -U214001+D214002+D215001-T215002
     &         -D305001+T305002+T306001-F306002
      dlm1(4)= +U023102-D023103+D114102-T114103
     &         +D114102-T114103+T205102-F205103
      dlm1(7)= +U023001-D023002+D114001-T114002
     &         +D114001-T114002+T205001-F205002
      dlm1(2)= -U113102+D113103+D114102-T114103!BU
     &         -D204102+T204103+T205102-F205103
      dlm1(5)= +D013203-T013204+T104203-F104204
      dlm1(8)= +D013102-T013103+T104102-F104103
      dlm1(3)= -U113001+D113002+D114001-T114002
     &         -D204001+T204002+T205001-F205002
      dlm1(6)= +D013102-T013103+T104102-F104103
      dlm1(9)= +D013001-T013002+T104001-F104002

      dlm2(1)= -U113102+D113103+D114102-T114103
     &         -D204102+T204103+T205102-F205103
      dlm2(4)= +D013203-T013204+T104203-F104204
      dlm2(7)= +D013102-T013103+T104102-F104103
      dlm2(2)= -D103203+T103204+T104203-F104204
      dlm2(5)= +T003304-F003305
      dlm2(8)= +T003203-F003204
      dlm2(3)= -D103102+T103103+T104102-F104103
      dlm2(6)= +T003203-F003204
      dlm2(9)= +T003102-F003103

      dlm3(1)= -U113001+D113002+D114001-T114002
     &         -D204001+T204002+T205001-F205002
      dlm3(4)= +D013102-T013103+T104102-F104103
      dlm3(7)= +D013001-T013002+T104001-F104002
      dlm3(2)= -D103102+T103103+T104102-F104103
      dlm3(5)= +T003203-F003204
      dlm3(8)= +T003102-F003103
      dlm3(3)= -D103001+T103002+T104001-F104002
      dlm3(6)= +T003102-F003103
      dlm3(9)= +T003001-F003002
! delta d_km 
      DKM1(1)= +D124002+T215002+T215002+F306002
      DKM1(4)= +U023012+D023103+D114012+T114103
     &         +D114012+T114103+T205012+F205103
      DKM1(7)= +D023002+T114002+T114002+F205002
      DKM1(2)= +T114103+F205103
      DKM1(5)= +D013113+T013204+T104113+F104204
      DKM1(8)= +T013103+F104103
      DKM1(3)= +T114002+F205002
      DKM1(6)= +D013012+T013103+T104012+F104103
      DKM1(9)= +T013002+F104002
      DKM2(1)= +T114103+F205103
      DKM2(4)= +D013113+T013204+T104113+F104204
      DKM2(7)= +T013103+F104103
      DKM2(2)= +F104204
      DKM2(5)= +T003214+F003305
      DKM2(8)= +F003204
      DKM2(3)= +F104103
      DKM2(6)= +T003113+F003204
      DKM2(9)= +F003103

      DKM3(1)= +T114002+F205002
      DKM3(4)= +D013012+T013103+T104012+F104103
      DKM3(7)= +T013002+F104002
      DKM3(2)= +F104103
      DKM3(5)= +T003113+F003204
      DKM3(8)= +F003103
      DKM3(3)= +F104002
      DKM3(6)= +T003012+F003103
      DKM3(9)= +F003002
! delta d_kl 
      DKL1(1)= +D124002+T215002+T215002+F306002
      DKL1(4)= +U023012+D023103+D114012+T114103
     &         +D114012+T114103+T205012+F205103
      DKL1(7)= +D023002+T114002+T114002+F205002
      DKL1(2)= +T114103+F205103
      DKL1(5)= +D013113+T013204+T104113+F104204
      DKL1(8)= +T013103+F104103
      DKL1(3)= +T114002+F205002
      DKL1(6)= +D013012+T013103+T104012+F104103
      DKL1(9)= +T013002+F104002
      DKL2(1)= +T114103+F205103
      DKL2(4)= +D013113+T013204+T104113+F104204
      DKL2(7)= +T013103+F104103
      DKL2(2)= +F104204
      DKL2(5)= +T003214+F003305
      DKL2(8)= +F003204
      DKL2(3)= +F104103
      DKL2(6)= +T003113+F003204
      DKL2(9)= +F003103

      DKL3(1)= +T114002+F205002
      DKL3(4)= +D013012+T013103+T104012+F104103
      DKL3(7)= +T013002+F104002
      DKL3(2)= +F104103
      DKL3(5)= +T003113+F003204
      DKL3(8)= +F003103
      DKL3(3)= +F104002
      DKL3(6)= +T003012+F003103
      DKL3(9)= +F003002

! delta d_jm
      DJM1(1)= +T215002-D214002+F306002-T305002
      DJM1(4)= +D114012+T114103-D113103-U113012
     &         +F205103+T205012-D204012-T204103
      DJM1(7)= +T114002-D113002+F205002-T204002
      DJM1(2)= +T114103+F205103
      DJM1(5)= +D013113+T013204+F104204+T104113
      DJM1(8)= +T013103+F104103
      DJM1(3)= +T114002+F205002
      DJM1(6)= +D013012+T013103+F104103+T104012
      DJM1(9)= +T013002+F104002
      DJM2(1)= +F205103-T204103
      DJM2(4)= +F104204+T104113-D103113-T103204
      DJM2(7)= +F104103-T103103
      DJM2(2)= +F104204
      DJM2(5)= +F003305+T003214
      DJM2(8)= +F003204
      DJM2(3)= +F104103
      DJM2(6)= +F003204+T003113
      DJM2(9)= +F003103
      DJM3(1)= +F205002-T204002
      DJM3(4)= +F104103+T104012-D103012-T103103
      DJM3(7)= +F104002-T103002
      DJM3(2)= +F104103
      DJM3(5)= +F003204+T003113
      DJM3(8)= +F003103
      DJM3(3)= +F104002
      DJM3(6)= +F003103+T003012
      DJM3(9)= +F003002
! delta d_jl
      DJL1(1)= +T215002-D214002+F306002-T305002
      DJL1(4)= +D114012+T114103-D113103-U113012
     &         +F205103+T205012-D204012-T204103
      DJL1(7)= +T114002-D113002+F205002-T204002
      DJL1(2)= +T114103+F205103
      DJL1(5)= +D013113+T013204+F104204+T104113
      DJL1(8)= +T013103+F104103
      DJL1(3)= +T114002+F205002
      DJL1(6)= +D013012+T013103+F104103+T104012
      DJL1(9)= +T013002+F104002
      DJL2(1)= +F205103-T204103
      DJL2(4)= +F104204+T104113-D103113-T103204
      DJL2(7)= +F104103-T103103
      DJL2(2)= +F104204
      DJL2(5)= +F003305+T003214
      DJL2(8)= +F003204
      DJL2(3)= +F104103
      DJL2(6)= +F003204+T003113
      DJL2(9)= +F003103
      DJL3(1)= +F205002-T204002
      DJL3(4)= +F104103+T104012-D103012-T103103
      DJL3(7)= +F104002-T103002
      DJL3(2)= +F104103
      DJL3(5)= +F003204+T003113
      DJL3(8)= +F003103
      DJL3(3)= +F104002
      DJL3(6)= +F003103+T003012
      DJL3(9)= +F003002
! delta d_jk       
      DJK1(1)= +D214002-T215002+T305002-F306002
      DJK1(4)= +D113103+U113012-D114012-T114103
     &         +D204012+T204103-F205103-T205012
      DJK1(7)= +D113002-T114002+T204002-F205002
      DJK1(2)= +D113103+U113012-D114012-T114103
     &         +D204012+T204103-F205103-T205012
      DJK1(5)= +D012204+U012113+U012113+Z012022
     &         -D013113-D013113-T013204-U013022
     &         +D103113+D103113+T103204+U103022
     &         -D104022-F104204-T104113-T104113
      DJK1(8)= +D012103+U012012-D013012-T013103
     &         +D103012+T103103-F104103-T104012
      DJK1(3)= +D113002-T114002+T204002-F205002
      DJK1(6)= +D012103+U012012-D013012-T013103
     &         +D103012+T103103-F104103-T104012
      DJK1(9)= +D012002-T013002+T103002-F104002
      DJK2(1)= +T204103-F205103
      DJK2(4)= +D103113+T103204-F104204-T104113
      DJK2(7)= +T103103-F104103
      DJK2(2)= +D103113+T103204-F104204-T104113
      DJK2(5)= +D002214+D002214+T002305+U002123
     &         -D003123-F003305-T003214-T003214
      DJK2(8)= +D002113+T002204-F003204-T003113
      DJK2(3)= +T103103-F104103
      DJK2(6)= +D002113+T002204-F003204-T003113
      DJK2(9)= +T002103-F003103
      DJK3(1)= +T204002-F205002
      DJK3(4)= +D103012+T103103-F104103-T104012
      DJK3(7)= +T103002-F104002
      DJK3(2)= +D103012+T103103-F104103-T104012
      DJK3(5)= +D002113+D002113+T002204+U002022
     &         -D003022-F003204-T003113-T003113
      DJK3(8)= +D002012+T002103-F003103-T003012
      DJK3(3)= +T103002-F104002
      DJK3(6)= +D002012+T002103-F003103-T003012
      DJK3(9)= +T002002-F003002
 
! delta d_im
      DIM1(1)= +F306002+T215002-D214002-T305002
      DIM1(4)= +D114012+F205103+T114103+T205012
     &         -D113103-D204012-T204103-U113012
      DIM1(7)= +F205002+T114002-D113002-T204002
      DIM1(2)= +F205103+T114103
      DIM1(5)= +D013113+F104204+T013204+T104113
      DIM1(8)= +F104103+T013103
      DIM1(3)= +F205002+T114002
      DIM1(6)= +D013012+F104103+T013103+T104012
      DIM1(9)= +F104002+T013002
      DIM2(1)= +F205103-T204103
      DIM2(4)= +F104204+T104113-D103113-T103204
      DIM2(7)= +F104103-T103103
      DIM2(2)= +F104204
      DIM2(5)= +F003305+T003214
      DIM2(8)= +F003204
      DIM2(3)= +F104103
      DIM2(6)= +F003204+T003113
      DIM2(9)= +F003103
      DIM3(1)= +F205002-T204002
      DIM3(4)= +F104103+T104012-D103012-T103103
      DIM3(7)= +F104002-T103002
      DIM3(2)= +F104103
      DIM3(5)= +F003204+T003113
      DIM3(8)= +F003103
      DIM3(3)= +F104002
      DIM3(6)= +F003103+T003012
      DIM3(9)= +F003002
! delta d_il
      DIL1(1)= +F306002+T215002-D214002-T305002
      DIL1(4)= +D114012+F205103+T114103+T205012
     &         -D113103-D204012-T204103-U113012
      DIL1(7)= +F205002+T114002-D113002-T204002
      DIL1(2)= +F205103+T114103
      DIL1(5)= +D013113+F104204+T013204+T104113
      DIL1(8)= +F104103+T013103
      DIL1(3)= +F205002+T114002
      DIL1(6)= +D013012+F104103+T013103+T104012
      DIL1(9)= +F104002+T013002
      DIL2(1)= +F205103-T204103
      DIL2(4)= +F104204+T104113-D103113-T103204
      DIL2(7)= +F104103-T103103
      DIL2(2)= +F104204
      DIL2(5)= +F003305+T003214
      DIL2(8)= +F003204
      DIL2(3)= +F104103
      DIL2(6)= +F003204+T003113
      DIL2(9)= +F003103
      DIL3(1)= +F205002-T204002
      DIL3(4)= +F104103+T104012-D103012-T103103
      DIL3(7)= +F104002-T103002
      DIL3(2)= +F104103
      DIL3(5)= +F003204+T003113
      DIL3(8)= +F003103
      DIL3(3)= +F104002
      DIL3(6)= +F003103+T003012
      DIL3(9)= +F003002

! delta d_ik
      DIK1(1)= +D214002+T305002-F306002-T215002
      DIK1(4)= +D113103+D204012+T204103+U113012
     &         -D114012-F205103-T114103-T205012
      DIK1(7)= +D113002+T204002-F205002-T114002
      DIK1(2)= +D113103+D204012+T204103+U113012
     &         -D114012-F205103-T114103-T205012
      DIK1(5)= +D012204+D103113+D103113+T103204
     &         +U012113+U012113+U103022+Z012022
     &         -D013113-D013113-D104022-F104204
     &         -T013204-T104113-T104113-U013022
      DIK1(8)= +D012103+D103012+T103103+U012012
     &         -D013012-F104103-T013103-T104012
      DIK1(3)= +D113002+T204002-F205002-T114002
      DIK1(6)= +D012103+D103012+T103103+U012012
     &         -D013012-F104103-T013103-T104012
      DIK1(9)= +D012002+T103002-F104002-T013002
      DIK2(1)= +T204103-F205103
      DIK2(4)= +D103113+T103204-F104204-T104113
      DIK2(7)= +T103103-F104103
      DIK2(2)= +D103113+T103204-F104204-T104113
      DIK2(5)= +D002214+D002214+T002305+U002123
     &         -D003123-F003305-T003214-T003214
      DIK2(8)= +D002113+T002204-F003204-T003113
      DIK2(3)= +T103103-F104103
      DIK2(6)= +D002113+T002204-F003204-T003113
      DIK2(9)= +T002103-F003103

      DIK3(1)= +T204002-F205002
      DIK3(4)= +D103012+T103103-F104103-T104012
      DIK3(7)= +T103002-F104002
      DIK3(2)= +D103012+T103103-F104103-T104012
      DIK3(5)= +D002113+D002113+T002204+U002022
     &         -D003022-F003204-T003113-T003113
      DIK3(8)= +D002012+T002103-F003103-T003012
      DIK3(3)= +T103002-F104002
      DIK3(6)= +D002012+T002103-F003103-T003012
      DIK3(9)= +T002002-F003002

! delta d_dij
      DIJ1(1)=+T305002-D304002-F306002+T305002 
      DIJ1(4)=+D204012+T204103-D203103-U203012 
     &        -F205103-T205012+D204012+T204103 
      DIJ1(7)=+T204002-D203002-F205002+T204002 
      DIJ1(2)=+D204012+T204103-D203103-U203012 
     &        -F205103-T205012+D204012+T204103 
      DIJ1(5)=+D103113+D103113+T103204+U103022 
     &        -D102204-U102113-U102113-Z102022 
     &        -D104022-F104204-T104113-T104113 
     &        +D103113+D103113+T103204+U103022 
      DIJ1(8)=+D103012+T103103-D102103-U102012 
     &        -F104103-T104012+D103012+T103103 
      DIJ1(3)=+T204002-D203002-F205002+T204002 
      DIJ1(6)=+D103012+T103103-D102103-U102012 
     &        -F104103-T104012+D103012+T103103 
      DIJ1(9)=+T103002-D102002-F104002+T103002 

      DIJ2(1)=+T204103-F205103 
      DIJ2(4)=+D103113+T103204-F104204-T104113 
      DIJ2(7)=+T103103-F104103 
      DIJ2(2)=+D103113+T103204-F104204-T104113 
      DIJ2(5)=+D002214+D002214+T002305+U002123 
     &        -D003123-F003305-T003214-T003214 
      DIJ2(8)=+D002113+T002204-F003204-T003113 
      DIJ2(3)=+T103103-F104103 
      DIJ2(6)=+D002113+T002204-F003204-T003113 
      DIJ2(9)=+T002103-F003103 
      DIJ3(1)=+T204002-F205002 
      DIJ3(4)=+D103012+T103103-F104103-T104012 
      DIJ3(7)=+T103002-F104002 
      DIJ3(2)=+D103012+T103103-F104103-T104012 
      DIJ3(5)=+D002113+D002113+T002204+U002022 
     &        -D003022-F003204-T003113-T003113 
      DIJ3(8)=+D002012+T002103-F003103-T003012 
      DIJ3(3)=+T103002-F104002 
      DIJ3(6)=+D002012+T002103-F003103-T003012 
      DIJ3(9)=+T002002-F003002 

! delta d_jm and d_kl
      DDD( 1)= +D013002+T104002
      DDD(16)= +T003103
      DDD(31)= +T003002

! delta d_jl and   d_km
      DDD( 2)= +D013002+T104002
      DDD(17)= +T003103
      DDD(32)= +T003002

! delta d_jk and d_lm
      DDD( 3)= +Z012001-U012002-U013001+D013002
     &         +U103001-D103002-D104001+T104002
      DDD(18)= +U002102-D002103-D003102+T003103
      DDD(33)= +U002001-D002002-D003001+T003002
 
! delta d_im and d_jk
      DDD( 4)= +D103002-T104002
      DDD(19)= +U002012+D002103-D003012-T003103
      DDD(34)= +D002002-T003002

! delta d_im and d_jl
      DDD( 5)= -D103002+T104002
      DDD(20)= +T003103
      DDD(35)= +T003002

! delta d_im and d_kl
      DDD( 6)= +D013002+T104002
      DDD(21)= +T003103
      DDD(36)= +T003002

! delta d_il and d_jk
      DDD( 7)=+D103002-T104002
      DDD(22)=+U002012+D002103-D003012-T003103
      DDD(37)=+D002002-T003002

! delta d_il and d_jm
      DDD( 8)= -D103002+T104002
      DDD(23)= +T003103
      DDD(38)= +T003002

! delta d_il and d_km
      DDD( 9)= +D013002+T104002
      DDD(24)= +T003103
      DDD(39)= +T003002

! delta d_ik and d_jl
      DDD(10)= D103002-T104002
      DDD(25)= U002012+D002103-D003012-T003103
      DDD(40)= D002002-T003002

! delta d_ik and d_jm
      DDD(11)= D103002-T104002
      DDD(26)= U002012+D002103-D003012-T003103
      DDD(41)= D002002-T003002

! delta d_ik and d_lm
      DDD(12)= +Z012001-U012002+U103001-D103002
     &         -U013001+D013002-D104001+T104002
      DDD(27)= +U002102-D002103-D003102+T003103
      DDD(42)= +U002001-D002002-D003001+T003002

! delta d_ij and d_kl
      DDD(13)= +D103002-T104002
      DDD(28)= +U002012+D002103-D003012-T003103
      DDD(43)= +D002002-T003002

! delta d_ij and d_km
      DDD(14)= +D103002-T104002
      DDD(29)= +U002012+D002103-D003012-T003103
      DDD(44)= +D002002-T003002

! delta d_ij and d_lm
      DDD(15)=-Z102001+U102002+U103001-D103002
     &        +U103001-D103002-D104001+T104002
      DDD(30)=+U002102-D002103-D003102+T003103
      DDD(45)=+U002001-D002002-D003001+T003002
 
      ddd( 4) = -ddd( 4)
      ddd(19) = -ddd(19)
      ddd(34) = -ddd(34)
      ddd( 7) = -ddd( 7)
      ddd(22) = -ddd(22)
      ddd(37) = -ddd(37)
      ddd(10) = -ddd(10)
      ddd(25) = -ddd(25)
      ddd(40) = -ddd(40)
      ddd(11) = -ddd(11)
      ddd(26) = -ddd(26)
      ddd(41) = -ddd(41)
      ddd(13) = -ddd(13)
      ddd(28) = -ddd(28)
      ddd(43) = -ddd(43)
      ddd(14) = -ddd(14)
      ddd(29) = -ddd(29)
      ddd(44) = -ddd(44)
    
      call ipgemm (15,eee,ddd,tiu)
 
      CALL IDIJK (TIU, TIU, TIU, DLM1, DLM2, DLM3, PLM1, PLM2, PLM3)
      CALL IDIJK (TKW, TIU, TIU, DKM1, DKM2, DKM3, PKM1, PKM2, PKM3)
      CALL IDIJK (TKW, TIU, TIU, DKL1, DKL2, DKL3, PKL1, PKL2, PKL3)
      CALL IDIJK (TKW, TIU, TIU, DJM1, DJM2, DJM3, PJM1, PJM2, PJM3)
      CALL IDIJK (TKW, TIU, TIU, DJL1, DJL2, DJL3, PJL1, PJL2, PJL3)
      CALL IDIJK (TKW, TKW, TIU, DJK1, DJK2, DJK3, PJK1, PJK2, PJK3)
      CALL IDIJK (TKW, TIU, TIU, DIM1, DIM2, DIM3, PIM1, PIM2, PIM3)
      CALL IDIJK (TKW, TIU, TIU, DIL1, DIL2, DIL3, PIL1, PIL2, PIL3)
      CALL IDIJK (TKW, TKW, TIU, DIK1, DIK2, DIK3, PIK1, PIK2, PIK3)
      CALL IDIJK (TKW, TKW, TIU, DIJ1, DIJ2, DIJ3, PIJ1, PIJ2, PIJ3)

      include 'ints_isetd_dpds.inc'

      call ipgemm (3,p1 ,o01,TKW)
      call ipgemmt(3,o01, p1,TKW)
      call ipgemm (3,p1 ,o02,TKW)
      call ipgemmt(3,o02, p1,TKW)
      call ipgemm (3,p1 ,o03,TKW)
      call ipgemmt(3,o03, p1,TKW)
      call ipgemm (3,p1 ,o04,TKW)
      call ipgemmt(3,o04, p1,TKW)
      call ipgemm (3,p1 ,o05,TKW)
      call ipgemmt(3,o05, p1,TKW)
      call ipgemm (3,p1 ,o06,TKW)
      call ipgemmt(3,o06, p1,TKW)
      call ipgemm (3,p1 ,o07,TKW)
      call ipgemmt(3,o07, p1,TKW)
      call ipgemm (3,p1 ,o08,TKW)
      call ipgemmt(3,o08, p1,TKW)
      call ipgemm (3,p1 ,o09,TKW)
      call ipgemmt(3,o09, p1,TKW)
      call ipgemm (3,p1 ,o10,TKW)
      call ipgemmt(3,o10, p1,TKW)
      call ipgemm (3,p1 ,o11,TKW)
      call ipgemmt(3,o11, p1,TKW)
      call ipgemm (3,p1 ,o12,TKW)
      call ipgemmt(3,o12, p1,TKW)
      call ipgemm (3,p1 ,o13,TKW)
      call ipgemmt(3,o13, p1,TKW)
      call ipgemm (3,p1 ,o14,TKW)
      call ipgemmt(3,o14, p1,TKW)
      call ipgemm (3,p1 ,o15,TKW)
      call ipgemmt(3,o15, p1,TKW)
      call ipgemm (3,p1 ,o16,TKW)
      call ipgemmt(3,o16, p1,TKW)
      call ipgemm (3,p1 ,o17,TKW)
      call ipgemmt(3,o17, p1,TKW)
      call ipgemm (3,p1 ,o18,TKW)
      call ipgemmt(3,o18, p1,TKW)
      call ipgemm (3,p1 ,o19,TKW)
      call ipgemmt(3,o19, p1,TKW)
      call ipgemm (3,p1 ,o20,TKW)
      call ipgemmt(3,o20, p1,TKW)
      call ipgemm (3,p1 ,o21,TKW)
      call ipgemmt(3,o21, p1,TKW)
      call ipgemm (3,p1 ,o22,TKW)
      call ipgemmt(3,o22, p1,TKW)
      call ipgemm (3,p1 ,o23,TKW)
      call ipgemmt(3,o23, p1,TKW)
      call ipgemm (3,p1 ,o24,TKW)
      call ipgemmt(3,o24, p1,TKW)
      call ipgemm (3,p1 ,o25,TKW)
      call ipgemmt(3,o25, p1,TKW)
      call ipgemm (3,p1 ,o26,TKW)
      call ipgemmt(3,o26, p1,TKW)
      call ipgemm (3,p1 ,o27,TKW)
      call ipgemmt(3,o27, p1,TKW)

      include 'ints_iset1.inc'
      call ipgemm(81,ppp,qqq,tiu)

      include 'ints_iset2.inc'
      call ipgemm(81,ppp,qqq,tiu)

      include 'ints_iset3.inc'
      call ipgemm (81,ppp,qqq,tiu)

      include 'ints_output_dpds.inc'

      end
CC IMDDPS ===========================================================
C        CALCLATE PRISM METHOD WITH BLAS FOR DDPS
C ===================================================================

      subroutine imddps(
     &           ec   ,
     &           xyz  ,  ddps ,
     &           mvhgp,  natom,  ierisw,
     &           iatom,  jatom,  katom ,  latom )


      implicit real(8)(a-h,o-z)

      dimension ddps(245)
      dimension xyz(3,natom)
      dimension tiu(9),tkw(9)

      dimension o01(9),o02(9),o03(9),o04(9),o05(9),o06(9)
      dimension o07(9),o08(9),o09(9),o10(9),o11(9),o12(9)
      dimension o13(9),o14(9),o15(9),o16(9),o17(9),o18(9)
      dimension o19(9),o20(9),o21(9),o22(9),o23(9),o24(9)
      dimension o25(9),o26(9),o27(9)

      dimension dlm1(9),dlm2(9),dlm3(9),dkm1(9),dkm2(9),dkm3(9)
      dimension dkl1(9),dkl2(9),dkl3(9),djm1(9),djm2(9),djm3(9)
      dimension djl1(9),djl2(9),djl3(9),djk1(9),djk2(9),djk3(9)
      dimension dim1(9),dim2(9),dim3(9),dil1(9),dil2(9),dil3(9)
      dimension dik1(9),dik2(9),dik3(9),dij1(9),dij2(9),dij3(9)
      dimension plm1(9),plm2(9),plm3(9),pkm1(9),pkm2(9),pkm3(9)
      dimension pkl1(9),pkl2(9),pkl3(9),pjm1(9),pjm2(9),pjm3(9)
      dimension pjl1(9),pjl2(9),pjl3(9),pjk1(9),pjk2(9),pjk3(9)
      dimension pim1(9),pim2(9),pim3(9),pil1(9),pil2(9),pil3(9)
      dimension pik1(9),pik2(9),pik3(9),pij1(9),pij2(9),pij3(9)

      dimension p1(9),ddd(45),eee(45),ppp(243),qqq(243)

      dimension ec(mvhgp)

      data      root3 / 1.73205080756887729353d+00 /

      tiu(1)= xyz(1,jatom) - xyz(1,iatom)
      tiu(4)= xyz(2,jatom) - xyz(2,iatom)
      tiu(7)= xyz(3,jatom) - xyz(3,iatom)
      tiu(2)= xyz(1,katom) - xyz(1,latom)
      tiu(5)= xyz(2,katom) - xyz(2,latom)
      tiu(8)= xyz(3,katom) - xyz(3,latom)
      tiu(3)= xyz(1,latom) - xyz(1,jatom)
      tiu(6)= xyz(2,latom) - xyz(2,jatom)
      tiu(9)= xyz(3,latom) - xyz(3,jatom)

      tkw(1) = -tiu(1)
      tkw(4) = -tiu(4)
      tkw(7) = -tiu(7)
      tkw(2) = -tiu(2)
      tkw(5) = -tiu(5)
      tkw(8) = -tiu(8)
      tkw(3) = -tiu(3)
      tkw(6) = -tiu(6)
      tkw(9) = -tiu(9)

      include 'ints_iset_ddps.inc'

      O01(1)=   +D416001+D416001+F418001+F418001
     &          +T327001+T507001+U325001+V509001
     &          -D326001-D326001-F508001-F508001
     &          -T417001-T417001-T417001-T417001
      O01(4)=   +D226011+D315102+D315102+D406011
     &          +F317102+F317102+F408011+T226102
     &          +T317011+T317011+T406102+U224102
     &          +U315011+U315011+V408102+Z224011
     &          -D225102-D225102-D316011-D316011
     &          -D316011-D316011-F407102-F407102
     &          -T316102-T316102-T316102-T316102
     &          -T407011-T407011-U225011-U225011
      O01(7)=   +D315001+D315001+F317001+F317001
     &          +T226001+T406001+U224001+V408001
     &          -D225001-D225001-F407001-F407001
     &          -T316001-T316001-T316001-T316001
      O01(2)=   +F317102+F317102+T226102+V408102
     &          -D225102-F407102-T316102-T316102
      O01(5)=   +D125112+F216203+F216203+F307112
     &          +T125203+T216112+T216112+V307203
     &          -D124203-D215112-D215112-F306203
     &          -T215203-T215203-T306112-U124112
      O01(8)=   +F216102+F216102+T125102+V307102
     &          -D124102-F306102-T215102-T215102
      O01(3)=   +F317001+F317001+T226001+V408001
     &          -D225001-F407001-T316001-T316001
      O01(6)=   +D125011+F216102+F216102+F307011
     &          +T125102+T216011+T216011+V307102
     &          -D124102-D215011-D215011-F306102
     &          -T215102-T215102-T306011-U124011
      O01(9)=   +F216001+F216001+T125001+V307001
     &          -D124001-F306001-T215001-T215001
      
      O02(1)=   +F317102+F317102+T226102+V408102
     &          -D225102-F407102-T316102-T316102
      O02(4)=   +D125112+F216203+F216203+F307112
     &          +T125203+T216112+T216112+V307203
     &          -D124203-D215112-D215112-F306203
     &          -T215203-T215203-T306112-U124112
      O02(7)=   +F216102+F216102+T125102+V307102
     &          -D124102-F306102-T215102-T215102
      O02(2)=   +F216203+F216203+T125203+V307203
      O02(5)=   +D024213+F115304+F115304+F206213
     &          +T024304+T115213+T115213+V206304
      O02(8)=   +F115203+F115203+T024203+V206203
      O02(3)=   +F216102+F216102+T125102+V307102
      O02(6)=   +D024112+F115203+F115203+F206112
     &          +T024203+T115112+T115112+V206203
      O02(9)=   +F115102+F115102+T024102+V206102
      
      O03(1)=   +F317001+F317001+T226001+V408001
     &          -D225001-F407001-T316001-T316001
      O03(4)=   +D125011+F216102+F216102+F307011
     &          +T125102+T216011+T216011+V307102
     &          -D124102-D215011-D215011-F306102
     &          -T215102-T215102-T306011-U124011
      O03(7)=   +F216001+F216001+T125001+V307001
     &          -D124001-F306001-T215001-T215001
      O03(2)=   +F216102+F216102+T125102+V307102
      O03(5)=   +D024112+F115203+F115203+F206112
     &          +T024203+T115112+T115112+V206203
      O03(8)=   +F115102+F115102+T024102+V206102
      O03(3)=   +F216001+F216001+T125001+V307001
      O03(6)=   +D024011+F115102+F115102+F206011
     &          +T024102+T115011+T115011+V206102
      O03(9)=   +F115001+F115001+T024001+V206001
      
      O04(1)=   +D315102+F317102+T406102+V408102
     &          -F407102-F407102-T316102-T316102
      O04(4)=   +D214203+D305112+F216203+F307112
     &          +T216112+T305203+U214112+V307203
     &          -D215112-D215112-F306203-F306203
     &          -T215203-T215203-T306112-T306112
      O04(7)=   +D214102+F216102+T305102+V307102
     &          -F306102-F306102-T215102-T215102
      O04(2)=   +F216203+V307203-F306203-T215203
      O04(5)=   +F115304+F206213+T115213+V206304
     &          -D114213-F205304-T114304-T205213
      O04(8)=   +F115203+V206203-F205203-T114203
      O04(3)=   +F216102+V307102-F306102-T215102
      O04(6)=   +F115203+F206112+T115112+V206203
     &          -D114112-F205203-T114203-T205112
      O04(9)=   +F115102+V206102-F205102-T114102
      
      O05(1)=   +F216203+V307203-F306203-T215203
      O05(4)=   +F115304+F206213+T115213+V206304
     &          -D114213-F205304-T114304-T205213
      O05(7)=   +F115203+V206203-F205203-T114203
      O05(2)=   +F115304+V206304
      O05(5)=   +F014405+F105314+T014314+V105405
      O05(8)=   +F014304+V105304
      O05(3)=   +F115203+V206203
      O05(6)=   +F014304+F105213+T014213+V105304
      O05(9)=   +F014203+V105203
      
      O06(1)=   +F216102+V307102-F306102-T215102
      O06(4)=   +F115203+F206112+T115112+V206203
     &          -D114112-F205203-T114203-T205112
      O06(7)=   +F115102+V206102-F205102-T114102
      O06(2)=   +F115203+V206203
      O06(5)=   +F014304+F105213+T014213+V105304
      O06(8)=   +F014203+V105203
      O06(3)=   +F115102+V206102
      O06(6)=   +F014203+F105112+T014112+V105203
      O06(9)=   +F014102+V105102
      
      O07(1)=   +D315001+F317001+T406001+V408001
     &          -F407001-F407001-T316001-T316001
      O07(4)=   +D214102+D305011+F216102+F307011
     &          +T216011+T305102+U214011+V307102
     &          -D215011-D215011-F306102-F306102
     &          -T215102-T215102-T306011-T306011
      O07(7)=   +D214001+F216001+T305001+V307001
     &          -F306001-F306001-T215001-T215001
      O07(2)=   +F216102+V307102-F306102-T215102
      O07(5)=   +F115203+F206112+T115112+V206203
     &          -D114112-F205203-T114203-T205112
      O07(8)=   +F115102+V206102-F205102-T114102
      O07(3)=   +F216001+V307001-F306001-T215001
      O07(6)=   +F115102+F206011+T115011+V206102
     &          -D114011-F205102-T114102-T205011
      O07(9)=   +F115001+V206001-F205001-T114001
      
      O08(1)=   +F216102+V307102-F306102-T215102
      O08(4)=   +F115203+F206112+T115112+V206203
     &          -D114112-F205203-T114203-T205112
      O08(7)=   +F115102+V206102-F205102-T114102
      O08(2)=   +F115203+V206203
      O08(5)=   +F014304+F105213+T014213+V105304
      O08(8)=   +F014203+V105203
      O08(3)=   +F115102+V206102
      O08(6)=   +F014203+F105112+T014112+V105203
      O08(9)=   +F014102+V105102
                
      O09(1)=   +F216001+V307001-F306001-T215001
      O09(4)=   +F115102+F206011+T115011+V206102
     &          -D114011-F205102-T114102-T205011
      O09(7)=   +F115001+V206001-F205001-T114001
      O09(2)=   +F115102+V206102
      O09(5)=   +F014203+F105112+T014112+V105203
      O09(8)=   +F014102+V105102
      O09(3)=   +F115001+V206001
      O09(6)=   +F014102+F105011+T014011+V105102
      O09(9)=   +F014001+V105001
      
      O10(1)=   +D315102+F317102+T406102+V408102
     &          -F407102-F407102-T316102-T316102
      O10(4)=   +D214203+D305112+F216203+F307112
     &          +T216112+T305203+U214112+V307203
     &          -D215112-D215112-F306203-F306203
     &          -T215203-T215203-T306112-T306112
      O10(7)=   +D214102+F216102+T305102+V307102
     &          -F306102-F306102-T215102-T215102
      O10(2)=   +F216203+V307203-F306203-T215203
      O10(5)=   +F115304+F206213+T115213+V206304
     &          -D114213-F205304-T114304-T205213
      O10(8)=   +F115203+V206203-F205203-T114203
      O10(3)=   +F216102+V307102-F306102-T215102
      O10(6)=   +F115203+F206112+T115112+V206203
     &          -D114112-F205203-T114203-T205112
      O10(9)=   +F115102+V206102-F205102-T114102
      
      O11(1)=   +F216203+V307203-F306203-T215203
      O11(4)=   +F115304+F206213+T115213+V206304
     &          -D114213-F205304-T114304-T205213
      O11(7)=   +F115203+V206203-F205203-T114203
      O11(2)=   +F115304+V206304
      O11(5)=   +F014405+F105314+T014314+V105405
      O11(8)=   +F014304+V105304
      O11(3)=   +F115203+V206203
      O11(6)=   +F014304+F105213+T014213+V105304
      O11(9)=   +F014203+V105203
      
      O12(1)=   +F216102+V307102-F306102-T215102
      O12(4)=   +F115203+F206112+T115112+V206203
     &          -D114112-F205203-T114203-T205112
      O12(7)=   +F115102+V206102-F205102-T114102
      O12(2)=   +F115203+V206203
      O12(5)=   +F014304+F105213+T014213+V105304
      O12(8)=   +F014203+V105203
      O12(3)=   +F115102+V206102
      O12(6)=   +F014203+F105112+T014112+V105203
      O12(9)=   +F014102+V105102
      
      O13(1)=   +T305203+V307203-F306203-F306203
      O13(4)=   +D204213+F206213+T204304+V206304
     &          -F205304-F205304-T205213-T205213
      O13(7)=   +T204203+V206203-F205203-F205203
      O13(2)=   +V206304-F205304
      O13(5)=   +F105314+V105405-F104405-T104314
      O13(8)=   +V105304-F104304
      O13(3)=   +V206203-F205203
      O13(6)=   +F105213+V105304-F104304-T104213
      O13(9)=   +V105203-F104203
      
      O14(1)=   +V206304-F205304
      O14(4)=   +F105314+V105405-F104405-T104314
      O14(7)=   +V105304-F104304
      O14(2)=   +V105405
      O14(5)=   +F004415+V004506
      O14(8)=   +V004405
      O14(3)=   +V105304
      O14(6)=   +F004314+V004405
      O14(9)=   +V004304
      
      O15(1)=   +V206203-F205203
      O15(4)=   +F105213+V105304-F104304-T104213
      O15(7)=   +V105203-F104203
      O15(2)=   +V105304
      O15(5)=   +F004314+V004405
      O15(8)=   +V004304
      O15(3)=   +V105203
      O15(6)=   +F004213+V004304
      O15(9)=   +V004203
      
      O16(1)=   +T305102+V307102-F306102-F306102
      O16(4)=   +D204112+F206112+T204203+V206203
     &          -F205203-F205203-T205112-T205112
      O16(7)=   +T204102+V206102-F205102-F205102
      O16(2)=   +V206203-F205203
      O16(5)=   +F105213+V105304-F104304-T104213
      O16(8)=   +V105203-F104203
      O16(3)=   +V206102-F205102
      O16(6)=   +F105112+V105203-F104203-T104112
      O16(9)=   +V105102-F104102
      
      O17(1)=   +V206203-F205203
      O17(4)=   +F105213+V105304-F104304-T104213
      O17(7)=   +V105203-F104203
      O17(2)=   +V105304
      O17(5)=   +F004314+V004405
      O17(8)=   +V004304
      O17(3)=   +V105203
      O17(6)=   +F004213+V004304
      O17(9)=   +V004203
      
      O18(1)=   +V206102-F205102
      O18(4)=   +F105112+V105203-F104203-T104112
      O18(7)=   +V105102-F104102
      O18(2)=   +V105203
      O18(5)=   +F004213+V004304
      O18(8)=   +V004203
      O18(3)=   +V105102
      O18(6)=   +F004112+V004203
      O18(9)=   +V004102
      
      O19(1)=   +D315001+F317001+T406001+V408001
     &          -F407001-F407001-T316001-T316001
      O19(4)=   +D214102+D305011+F216102+F307011
     &          +T216011+T305102+U214011+V307102
     &          -D215011-D215011-F306102-F306102
     &          -T215102-T215102-T306011-T306011
      O19(7)=   +D214001+F216001+T305001+V307001
     &          -F306001-F306001-T215001-T215001
      O19(2)=   +F216102+V307102-F306102-T215102
      O19(5)=   +F115203+F206112+T115112+V206203
     &          -D114112-F205203-T114203-T205112
      O19(8)=   +F115102+V206102-F205102-T114102
      O19(3)=   +F216001+V307001-F306001-T215001
      O19(6)=   +F115102+F206011+T115011+V206102
     &          -D114011-F205102-T114102-T205011
      O19(9)=   +F115001+V206001-F205001-T114001
      
      O20(1)=   +F216102+V307102-F306102-T215102
      O20(4)=   +F115203+F206112+T115112+V206203
     &          -D114112-F205203-T114203-T205112
      O20(7)=   +F115102+V206102-F205102-T114102
      O20(2)=   +F115203+V206203
      O20(5)=   +F014304+F105213+T014213+V105304
      O20(8)=   +F014203+V105203
      O20(3)=   +F115102+V206102
      O20(6)=   +F014203+F105112+T014112+V105203
      O20(9)=   +F014102+V105102
                
      O21(1)=   +F216001+V307001-F306001-T215001
      O21(4)=   +F115102+F206011+T115011+V206102
     &          -D114011-F205102-T114102-T205011
      O21(7)=   +F115001+V206001-F205001-T114001
      O21(2)=   +F115102+V206102
      O21(5)=   +F014203+F105112+T014112+V105203
      O21(8)=   +F014102+V105102
      O21(3)=   +F115001+V206001
      O21(6)=   +F014102+F105011+T014011+V105102
      O21(9)=   +F014001+V105001
                
      O22(1)=   +T305102+V307102-F306102-F306102
      O22(4)=   +D204112+F206112+T204203+V206203
     &          -F205203-F205203-T205112-T205112
      O22(7)=   +T204102+V206102-F205102-F205102
      O22(2)=   +V206203-F205203
      O22(5)=   +F105213+V105304-F104304-T104213
      O22(8)=   +V105203-F104203
      O22(3)=   +V206102-F205102
      O22(6)=   +F105112+V105203-F104203-T104112
      O22(9)=   +V105102-F104102
      
      O23(1)=   +V206203-F205203
      O23(4)=   +F105213+V105304-F104304-T104213
      O23(7)=   +V105203-F104203
      O23(2)=   +V105304
      O23(5)=   +F004314+V004405
      O23(8)=   +V004304
      O23(3)=   +V105203
      O23(6)=   +F004213+V004304
      O23(9)=   +V004203
                
      O24(1)=   +V206102-F205102
      O24(4)=   +F105112+V105203-F104203-T104112
      O24(7)=   +V105102-F104102
      O24(2)=   +V105203
      O24(5)=   +F004213+V004304
      O24(8)=   +V004203
      O24(3)=   +V105102
      O24(6)=   +F004112+V004203
      O24(9)=   +V004102
      
      O25(1)=   +T305001+V307001-F306001-F306001
      O25(4)=   +D204011+F206011+T204102+V206102
     &          -F205102-F205102-T205011-T205011
      O25(7)=   +T204001+V206001-F205001-F205001
      O25(2)=   +V206102-F205102
      O25(5)=   +F105112+V105203-F104203-T104112
      O25(8)=   +V105102-F104102
      O25(3)=   +V206001-F205001
      O25(6)=   +F105011+V105102-F104102-T104011
      O25(9)=   +V105001-F104001
      
      O26(1)=   +V206102-F205102
      O26(4)=   +F105112+V105203-F104203-T104112
      O26(7)=   +V105102-F104102
      O26(2)=   +V105203
      O26(5)=   +F004213+V004304
      O26(8)=   +V004203
      O26(3)=   +V105102
      O26(6)=   +F004112+V004203
      O26(9)=   +V004102
                 
      O27(1)=   +V206001-F205001
      O27(4)=   +F105011+V105102-F104102-T104011
      O27(7)=   +V105001-F104001
      O27(2)=   +V105102
      O27(5)=   +F004112+V004203
      O27(8)=   +V004102
      O27(3)=   +V105001
      O27(6)=   +F004011+V004102
      O27(9)=   +V004001
! delta d_lm
      dlm1(1)= -U124001+D125001-D215001+T216001
     &         -D215001+T216001-T306001+F307001
      dlm1(4)= +D024102+T115102+T115102+F206102
      dlm1(7)= +D024001+T115001+T115001+F206001
      dlm1(2)= -D114102+T115102-T205102+F206102
      dlm1(5)= +F105203+T014203
      dlm1(8)= +F105102+T014102
      dlm1(3)= +F206001+T115001-D114001-T205001
      dlm1(6)= +F105102+T014102
      dlm1(9)= +F105001+T014001
                                                 
      dlm2(1)= -D114102+T115102-T205102+F206102
      dlm2(4)= +F105203+T014203
      dlm2(7)= +F105102+T014102
      dlm2(2)= +F105203-T104203
      dlm2(5)= +F004304
      dlm2(8)= +F004203
      dlm2(3)= +F105102-T104102
      dlm2(6)= +F004203
      dlm2(9)= +F004102
                                                
      dlm3(1)= -D114001+T115001-T205001+F206001
      dlm3(4)= +T014102+F105102
      dlm3(7)= +T014001+F105001
      dlm3(2)= +F105102-T104102
      dlm3(5)= +F004203
      dlm3(8)= +F004102
      dlm3(3)= +F105001-T104001
      dlm3(6)= +F004102
      dlm3(9)= +F004001      
! delta d_km 
      DKM1(1)=DLM1(1)
      DKM1(4)=DLM1(4)
      DKM1(7)=DLM1(7)
      DKM1(2)=DLM1(2)
      DKM1(5)=DLM1(5)
      DKM1(8)=DLM1(8)
      DKM1(3)=DLM1(3)
      DKM1(6)=DLM1(6)
      DKM1(9)=DLM1(9)
                     
      DKM2(1)=DLM2(1)
      DKM2(4)=DLM2(4)
      DKM2(7)=DLM2(7)
      DKM2(2)=DLM2(2)
      DKM2(5)=DLM2(5)
      DKM2(8)=DLM2(8)
      DKM2(3)=DLM2(3)
      DKM2(6)=DLM2(6)
      DKM2(9)=DLM2(9)
                     
      DKM3(1)=DLM3(1)
      DKM3(4)=DLM3(4)
      DKM3(7)=DLM3(7)
      DKM3(2)=DLM3(2)
      DKM3(5)=DLM3(5)
      DKM3(8)=DLM3(8)
      DKM3(3)=DLM3(3)
      DKM3(6)=DLM3(6)
      DKM3(9)=DLM3(9)
! delta d_kl 
      DKL1(1)= +U124001-D125001+D215001-T216001
     &         +D215001-T216001+T306001-F307001
      DKL1(4)= +Z023011+U023102-U024011-D024102
     &         +U114011+D114102-D115011-T115102
     &         +U114011+D114102-D115011-T115102
     &         +D205011+T205102-T206011-F206102
      DKL1(7)= +U023001-D024001+D114001-T115001
     &         +D114001-T115001+T205001-F206001
      DKL1(2)= +D114102-T115102+T205102-F206102
      DKL1(5)= +U013112+D013203-D014112-T014203
     &         +D104112+T104203-T105112-F105203
      DKL1(8)= +D013102-T014102+T104102-F105102
      DKL1(3)= +D114001-T115001+T205001-F206001
      DKL1(6)= +U013011+D013102-D014011-T014102
     &         +D104011+T104102-T105011-F105102
      DKL1(9)= +D013001-T014001+T104001-F105001
                                                
      DKL2(1)= +D114102-T115102+T205102-F206102
      DKL2(4)= +U013112+D013203-D014112-T014203
     &         +D104112+T104203-T105112-F105203
      DKL2(7)= +D013102-T014102+T104102-F105102
      DKL2(2)= +T104203-F105203
      DKL2(5)= +D003213+T003304-T004213-F004304
      DKL2(8)= +T003203-F004203
      DKL2(3)= +T104102-F105102
      DKL2(6)= +D003112+T003203-T004112-F004203
      DKL2(9)= +T003102-F004102
                           
      DKL3(1)= +D114001-T115001+T205001-F206001
      DKL3(4)= +U013011+D013102-D014011-T014102
     &         +D104011+T104102-T105011-F105102
      DKL3(7)= +D013001-T014001+T104001-F105001
      DKL3(2)= +T104102-F105102
      DKL3(5)= +D003112+T003203-T004112-F004203
      DKL3(8)= +T003102-F004102
      DKL3(3)= +T104001-F105001
      DKL3(6)= +D003011+T003102-T004011-F004102
      DKL3(9)= +T003001-F004001

! delta d_jm
      DJM1(1)= +D305001+F307001+T216001+U214001
     &         -D215001-D215001-T306001-T306001
      DJM1(4)= +F206102+T115102-D114102-T205102
      DJM1(7)= +F206001+T115001-D114001-T205001
      DJM1(2)= +F206102+T115102-D114102-T205102
      DJM1(5)= +F105203+T014203
      DJM1(8)= +F105102+T014102
      DJM1(3)= +F206001+T115001-D114001-T205001
      DJM1(6)= +F105102+T014102
      DJM1(9)= +F105001+T014001
                
      DJM2(1)= +D204102+F206102-T205102-T205102
      DJM2(4)= +F105203-T104203
      DJM2(7)= +F105102-T104102
      DJM2(2)= +F105203-T104203
      DJM2(5)= +F004304
      DJM2(8)= +F004203
      DJM2(3)= +F105102-T104102
      DJM2(6)= +F004203
      DJM2(9)= +F004102
                                                
      DJM3(1)= +D204001+F206001-T205001-T205001
      DJM3(4)= +F105102-T104102
      DJM3(7)= +F105001-T104001
      DJM3(2)= +F105102-T104102
      DJM3(5)= +F004203
      DJM3(8)= +F004102
      DJM3(3)= +F105001-T104001
      DJM3(6)= +F004102
      DJM3(9)= +F004001
! delta d_jl
      DJL1(1)= +D215001+T306001-D305001-U214001
     &         -F307001-T216001+D215001+T306001
      DJL1(4)= +D114102+D205011+T205102+U114011
     &         -D115011-F206102-T115102-T206011
     &         -D204102-U113102-U204011-Z113011
     &         +D114102+D205011+T205102+U114011
      DJL1(7)= +D114001+T205001-D204001-U113001
     &         -F206001-T115001+D114001+T205001
      DJL1(2)= +D114102+T205102-F206102-T115102
      DJL1(5)= +D013203+D104112+T104203+U013112
     &         -D014112-F105203-T014203-T105112
      DJL1(8)= +D013102+T104102-F105102-T014102
      DJL1(3)= +D114001+T205001-F206001-T115001
      DJL1(6)= +D013102+D104011+T104102+U013011
     &         -D014011-F105102-T014102-T105011
      DJL1(9)= +D013001+T104001-F105001-T014001
                                                
      DJL2(1)= +T205102-D204102-F206102+T205102
      DJL2(4)= +D104112+T104203-D103203-U103112
     &         -F105203-T105112+D104112+T104203
      DJL2(7)= +T104102-D103102-F105102+T104102
      DJL2(2)= +T104203-F105203
      DJL2(5)= +D003213+T003304-F004304-T004213
      DJL2(8)= +T003203-F004203
      DJL2(3)= +T104102-F105102
      DJL2(6)= +D003112+T003203-F004203-T004112
      DJL2(9)= +T003102-F004102
                                                
      DJL3(1)= +T205001-D204001-F206001+T205001
      DJL3(4)= +D104011+T104102-D103102-U103011
     &         -F105102-T105011+D104011+T104102
      DJL3(7)= +T104001-D103001-F105001+T104001
      DJL3(2)= +T104102-F105102
      DJL3(5)= +D003112+T003203-F004203-T004112
      DJL3(8)= +T003102-F004102
      DJL3(3)= +T104001-F105001
      DJL3(6)= +D003011+T003102-F004102-T004011
      DJL3(9)= +T003001-F004001

! delta d_jk       
      DJK1(1)= DJL1(1)
      DJK1(4)= DJL1(4)
      DJK1(7)= DJL1(7)
      DJK1(2)= DJL1(2)
      DJK1(5)= DJL1(5)
      DJK1(8)= DJL1(8)
      DJK1(3)= DJL1(3)
      DJK1(6)= DJL1(6)
      DJK1(9)= DJL1(9)
                      
      DJK2(1)= DJL2(1)
      DJK2(4)= DJL2(4)
      DJK2(7)= DJL2(7)
      DJK2(2)= DJL2(2)
      DJK2(5)= DJL2(5)
      DJK2(8)= DJL2(8)
      DJK2(3)= DJL2(3)
      DJK2(6)= DJL2(6)
      DJK2(9)= DJL2(9)
                      
      DJK3(1)= DJL3(1)
      DJK3(4)= DJL3(4)
      DJK3(7)= DJL3(7)
      DJK3(2)= DJL3(2)
      DJK3(5)= DJL3(5)
      DJK3(8)= DJL3(8)
      DJK3(3)= DJL3(3)
      DJK3(6)= DJL3(6)
      DJK3(9)= DJL3(9)
 
! delta d_im
      DIM1(1)=DJM1(1)
      DIM1(4)=DJM1(4)
      DIM1(7)=DJM1(7)
      DIM1(2)=DJM1(2)
      DIM1(5)=DJM1(5)
      DIM1(8)=DJM1(8)
      DIM1(3)=DJM1(3)
      DIM1(6)=DJM1(6)
      DIM1(9)=DJM1(9)
                     
      DIM2(1)=DJM2(1)
      DIM2(4)=DJM2(4)
      DIM2(7)=DJM2(7)
      DIM2(2)=DJM2(2)
      DIM2(5)=DJM2(5)
      DIM2(8)=DJM2(8)
      DIM2(3)=DJM2(3)
      DIM2(6)=DJM2(6)
      DIM2(9)=DJM2(9)
                     
      DIM3(1)=DJM3(1)
      DIM3(4)=DJM3(4)
      DIM3(7)=DJM3(7)
      DIM3(2)=DJM3(2)
      DIM3(5)=DJM3(5)
      DIM3(8)=DJM3(8)
      DIM3(3)=DJM3(3)
      DIM3(6)=DJM3(6)
      DIM3(9)=DJM3(9)

! delta d_il
      DIL1(1)=+D215001+T306001-D305001-U214001
     &        -F307001-T216001+D215001+T306001
      DIL1(4)=+D114102+D205011+T205102+U114011
     &        -D115011-F206102-T115102-T206011
     &        -D204102-U113102-U204011-Z113011
     &        +D114102+D205011+T205102+U114011
      DIL1(7)=+D114001+T205001-D204001-U113001
     &        -F206001-T115001+D114001+T205001
      DIL1(2)=+D114102+T205102-F206102-T115102
      DIL1(5)=+D013203+D104112+T104203+U013112
     &        -D014112-F105203-T014203-T105112
      DIL1(8)=+D013102+T104102-F105102-T014102
      DIL1(3)=+D114001+T205001-F206001-T115001
      DIL1(6)=+D013102+D104011+T104102+U013011
     &        -D014011-F105102-T014102-T105011
      DIL1(9)=+D013001+T104001-F105001-T014001
                                               
      DIL2(1)=+T205102-D204102-F206102+T205102
      DIL2(4)=+D104112+T104203-D103203-U103112
     &        -F105203-T105112+D104112+T104203
      DIL2(7)=+T104102-D103102-F105102+T104102
      DIL2(2)=+T104203-F105203
      DIL2(5)=+D003213+T003304-F004304-T004213
      DIL2(8)=+T003203-F004203
      DIL2(3)=+T104102-F105102
      DIL2(6)=+D003112+T003203-F004203-T004112
      DIL2(9)=+T003102-F004102
                                               
      DIL3(1)=+T205001-D204001-F206001+T205001
      DIL3(4)=+D104011+T104102-D103102-U103011
     &        -F105102-T105011+D104011+T104102
      DIL3(7)=+T104001-D103001-F105001+T104001
      DIL3(2)=+T104102-F105102
      DIL3(5)=+D003112+T003203-F004203-T004112
      DIL3(8)=+T003102-F004102
      DIL3(3)=+T104001-F105001
      DIL3(6)=+D003011+T003102-F004102-T004011
      DIL3(9)=+T003001-F004001

! delta d_ik
      DIK1(1)= DIL1(1)
      DIK1(4)= DIL1(4)
      DIK1(7)= DIL1(7)
      DIK1(2)= DIL1(2)
      DIK1(5)= DIL1(5)
      DIK1(8)= DIL1(8)
      DIK1(3)= DIL1(3)
      DIK1(6)= DIL1(6)
      DIK1(9)= DIL1(9)
                      
      DIK2(1)= DIL2(1)
      DIK2(4)= DIL2(4)
      DIK2(7)= DIL2(7)
      DIK2(2)= DIL2(2)
      DIK2(5)= DIL2(5)
      DIK2(8)= DIL2(8)
      DIK2(3)= DIL2(3)
      DIK2(6)= DIL2(6)
      DIK2(9)= DIL2(9)
 
      DIK3(1)= DIL3(1)
      DIK3(4)= DIL3(4)
      DIK3(7)= DIL3(7)
      DIK3(2)= DIL3(2)
      DIK3(5)= DIL3(5)
      DIK3(8)= DIL3(8)
      DIK3(3)= DIL3(3)
      DIK3(6)= DIL3(6)
      DIK3(9)= DIL3(9)

! delta d_dij
      DIJ1(1)=+T306001+U304001-D305001-D305001
     &        -D305001-F307001+T306001+T306001
      DIJ1(4)=+D205011+T205102+U203102+Z203011
     &        -D204102-F206102-T206011-U204011
     &        -D204102-D204102-U204011-U204011
     &        +D205011+D205011+T205102+T205102
      DIJ1(7)=+T205001+U203001-D204001-D204001
     &        -D204001-F206001+T205001+T205001
      DIJ1(2)=+T205102-D204102-F206102+T205102
      DIJ1(5)=+D104112+T104203-D103203-U103112
     &        -F105203-T105112+D104112+T104203
      DIJ1(8)=+T104102-D103102-F105102+T104102
      DIJ1(3)=+T205001-D204001-F206001+T205001
      DIJ1(6)=+D104011+T104102-D103102-U103011
     &        -F105102-T105011+D104011+T104102
      DIJ1(9)=+T104001-D103001-F105001+T104001
                                               
      DIJ2(1)=+T205102-D204102-F206102+T205102
      DIJ2(4)=+D104112+T104203-D103203-U103112
     &        -F105203-T105112+D104112+T104203
      DIJ2(7)=+T104102-D103102-F105102+T104102
      DIJ2(2)=+T104203-F105203
      DIJ2(5)=+D003213+T003304-F004304-T004213
      DIJ2(8)=+T003203-F004203
      DIJ2(3)=+T104102-F105102
      DIJ2(6)=+D003112+T003203-F004203-T004112
      DIJ2(9)=+T003102-F004102
                                               
      DIJ3(1)=+T205001-D204001-F206001+T205001
      DIJ3(4)=+D104011+T104102-D103102-U103011
     &        -F105102-T105011+D104011+T104102
      DIJ3(7)=+T104001-D103001-F105001+T104001
      DIJ3(2)=+T104102-F105102
      DIJ3(5)=+D003112+T003203-F004203-T004112
      DIJ3(8)=+T003102-F004102
      DIJ3(3)=+T104001-F105001
      DIJ3(6)=+D003011+T003102-F004102-T004011
      DIJ3(9)=+T003001-F004001

! delta d_jm and d_kl
      DDD( 1)=+U013001-D014001+D104001-T105001
      DDD(16)=+D003102-T004102
      DDD(31)=+D003001-T004001

! delta d_jl and   d_km
      DDD( 2)= +U013001-D014001+D104001-T105001
      DDD(17)= +D003102-T004102
      DDD(32)= +D003001-T004001

! delta d_jk and d_lm
      DDD( 3)=DDD( 2)
      DDD(18)=DDD(17)
      DDD(33)=DDD(32)
 
! delta d_im and d_jk
      DDD( 4)= -U103001+D104001+D104001-T105001
      DDD(19)= +D003102-T004102
      DDD(34)= +D003001-T004001
 
! delta d_im and d_jl
      DDD( 5)= DDD( 4)
      DDD(20)= DDD(19)
      DDD(35)= DDD(34)

! delta d_im and d_kl
      DDD( 6)= DDD( 1)
      DDD(21)= DDD(16)
      DDD(36)= DDD(31)

! delta d_il and d_jk
      DDD( 7)= +U103001-D104001-D104001+T105001
      DDD(22)= +Z002011+U002102-U003011-D003102
     &         -U003011-D003102+D004011+T004102
      DDD(37)= +U002001-D003001-D003001+T004001

! delta d_il and d_jm
      DDD( 8)= -U103001+D104001+D104001-T105001
      DDD(23)= +D003102-T004102
      DDD(38)= +D003001-T004001

! delta d_il and d_km
      DDD( 9)= DDD( 2)
      DDD(24)= DDD(17)
      DDD(39)= DDD(32)

! delta d_ik and d_jl
      DDD(10)= U103001-D104001-D104001+T105001
      DDD(25)= Z002011+U002102-U003011-D003102
     &        -U003011-D003102+D004011+T004102
      DDD(40)= U002001-D003001-D003001+T004001

! delta d_ik and d_jm
      DDD(11)= DDD( 8)
      DDD(26)= DDD(23)
      DDD(41)= DDD(38)

! delta d_ik and d_lm
      DDD(12)= DDD( 2)
      DDD(27)= DDD(17)
      DDD(42)= DDD(32)

! delt d_ij and d_kl
      DDD(13)= +U103001-D104001-D104001+T105001
      DDD(28)= +Z002011+U002102-U003011-D003102
     &         -U003011-D003102+D004011+T004102
      DDD(43)= +U002001-D003001-D003001+T004001

! delta d_ij and d_km
      DDD(14)= -U103001+D104001+D104001-T105001
      DDD(29)= +D003102-T004102
      DDD(44)= +D003001-T004001

! delta d_ij and d_lm
      DDD(15)=DDD(14)
      DDD(30)=DDD(29)
      DDD(45)=DDD(44)

!==========================
      ddd( 7) = -ddd( 7)
      ddd(22) = -ddd(22)
      ddd(37) = -ddd(37)
      ddd(10) = -ddd(10)
      ddd(25) = -ddd(25)
      ddd(40) = -ddd(40)
      ddd(13) = -ddd(13)
      ddd(28) = -ddd(28)
      ddd(43) = -ddd(43)

      call ipgemm(15,eee,ddd,tiu)
 
      CALL IDIJK (TIU, TIU, TIU, DLM1, DLM2, DLM3, PLM1, PLM2, PLM3)
      CALL IDIJK (TIU, TIU, TIU, DKM1, DKM2, DKM3, PKM1, PKM2, PKM3)
      CALL IDIJK (TKW, TIU, TIU, DKL1, DKL2, DKL3, PKL1, PKL2, PKL3)
      CALL IDIJK (TIU, TIU, TIU, DJM1, DJM2, DJM3, PJM1, PJM2, PJM3)
      CALL IDIJK (TKW, TIU, TIU, DJL1, DJL2, DJL3, PJL1, PJL2, PJL3)
      CALL IDIJK (TKW, TIU, TIU, DJK1, DJK2, DJK3, PJK1, PJK2, PJK3)
      CALL IDIJK (TIU, TIU, TIU, DIM1, DIM2, DIM3, PIM1, PIM2, PIM3)
      CALL IDIJK (TKW, TIU, TIU, DIL1, DIL2, DIL3, PIL1, PIL2, PIL3)
      CALL IDIJK (TKW, TIU, TIU, DIK1, DIK2, DIK3, PIK1, PIK2, PIK3)
      CALL IDIJK (TKW, TIU, TIU, DIJ1, DIJ2, DIJ3, PIJ1, PIJ2, PIJ3)

      include 'ints_isetd_ddps.inc'
               
      call ipgemm (3,p1 ,o01,TKW)
      call ipgemmt(3,o01, p1,TIU)
      call ipgemm (3,p1 ,o02,TKW)
      call ipgemmt(3,o02, p1,TIU)
      call ipgemm (3,p1 ,o03,TKW)
      call ipgemmt(3,o03, p1,TIU)
      call ipgemm (3,p1 ,o04,TKW)
      call ipgemmt(3,o04, p1,TIU)
      call ipgemm (3,p1 ,o05,TKW)
      call ipgemmt(3,o05, p1,TIU)
      call ipgemm (3,p1 ,o06,TKW)
      call ipgemmt(3,o06, p1,TIU)
      call ipgemm (3,p1 ,o07,TKW)
      call ipgemmt(3,o07, p1,TIU)
      call ipgemm (3,p1 ,o08,TKW)
      call ipgemmt(3,o08, p1,TIU)
      call ipgemm (3,p1 ,o09,TKW)
      call ipgemmt(3,o09, p1,TIU)
      call ipgemm (3,p1 ,o10,TKW)
      call ipgemmt(3,o10, p1,TIU)
      call ipgemm (3,p1 ,o11,TKW)
      call ipgemmt(3,o11, p1,TIU)
      call ipgemm (3,p1 ,o12,TKW)
      call ipgemmt(3,o12, p1,TIU)
      call ipgemm (3,p1 ,o13,TKW)
      call ipgemmt(3,o13, p1,TIU)
      call ipgemm (3,p1 ,o14,TKW)
      call ipgemmt(3,o14, p1,TIU)
      call ipgemm (3,p1 ,o15,TKW)
      call ipgemmt(3,o15, p1,TIU)
      call ipgemm (3,p1 ,o16,TKW)
      call ipgemmt(3,o16, p1,TIU)
      call ipgemm (3,p1 ,o17,TKW)
      call ipgemmt(3,o17, p1,TIU)
      call ipgemm (3,p1 ,o18,TKW)
      call ipgemmt(3,o18, p1,TIU)
      call ipgemm (3,p1 ,o19,TKW)
      call ipgemmt(3,o19, p1,TIU)
      call ipgemm (3,p1 ,o20,TKW)
      call ipgemmt(3,o20, p1,TIU)
      call ipgemm (3,p1 ,o21,TKW)
      call ipgemmt(3,o21, p1,TIU)
      call ipgemm (3,p1 ,o22,TKW)
      call ipgemmt(3,o22, p1,TIU)
      call ipgemm (3,p1 ,o23,TKW)
      call ipgemmt(3,o23, p1,TIU)
      call ipgemm (3,p1 ,o24,TKW)
      call ipgemmt(3,o24, p1,TIU)
      call ipgemm (3,p1 ,o25,TKW)
      call ipgemmt(3,o25, p1,TIU)
      call ipgemm (3,p1 ,o26,TKW)
      call ipgemmt(3,o26, p1,TIU)
      call ipgemm (3,p1 ,o27,TKW)
      call ipgemmt(3,o27, p1,TIU)

      include 'ints_iset1.inc'
      call ipgemm(81,ppp,qqq,tiu)

      include 'ints_iset2.inc'
      call ipgemm(81,ppp,qqq,tiu)

      include 'ints_iset3.inc'
      call ipgemm(81,ppp,qqq,tiu)

      include 'ints_output_ddps.inc'

      end
